/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 97;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 68,
  Feature_HasRCPC_IMMOBit = 88,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 67,
  Feature_HasSHA3Bit = 66,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 96,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 85,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 79,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 45,
  Feature_HasSVEAESBit = 37,
  Feature_HasSVE2SM4Bit = 42,
  Feature_HasSVE2SHA3Bit = 95,
  Feature_HasSVEBitPermBit = 39,
  Feature_HasSMEandIsNonStreamingSafeBit = 58,
  Feature_HasSMEBit = 51,
  Feature_HasSMEF64F64Bit = 53,
  Feature_HasSMEF16F16Bit = 61,
  Feature_HasSMEI16I64Bit = 56,
  Feature_HasSME2andIsNonStreamingSafeBit = 63,
  Feature_HasSME2Bit = 60,
  Feature_HasSME2p1Bit = 65,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 48,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 43,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 49,
  Feature_HasLUTBit = 50,
  Feature_HasSME_LUTv2Bit = 64,
  Feature_HasSMEF8F16Bit = 54,
  Feature_HasSMEF8F32Bit = 52,
  Feature_HasSME_MOP4Bit = 57,
  Feature_HasSME_TMOPBit = 62,
  Feature_HasCMPBRBit = 86,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 31,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 40,
  Feature_HasSVE2_or_SMEBit = 33,
  Feature_HasSVE2_or_SME2Bit = 47,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 36,
  Feature_HasSVE2p1_or_SMEBit = 59,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 46,
  Feature_HasSVE2p2_or_SME2p2Bit = 32,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 55,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 38,
  Feature_HasNonStreamingSVE_or_SSVE_FEXPABit = 41,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 76,
  Feature_HasRCPCBit = 87,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 94,
  Feature_HasMatMulFP64Bit = 44,
  Feature_HasLS64Bit = 83,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 84,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 80,
  Feature_UseExperimentalZeroingPseudosBit = 35,
  Feature_UseAlternateSExtLoadCVTF32Bit = 78,
  Feature_UseScalarIncVLBit = 34,
  Feature_NoUseScalarIncVLBit = 91,
  Feature_HasFastIncVLBit = 92,
  Feature_UseSVEFPLD1RBit = 90,
  Feature_UseLDAPURBit = 89,
  Feature_AllowMisalignedMemAccessesBit = 93,
  Feature_NotForCodeSizeBit = 77,
  Feature_UseSTRQroBit = 75,
  Feature_TailCallX16X17Bit = 70,
  Feature_TailCallX17Bit = 81,
  Feature_TailCallNotX16Bit = 82,
  Feature_TailCallAnyBit = 69,
  Feature_SLSBLRMitigationBit = 73,
  Feature_NoSLSBLRMitigationBit = 72,
  Feature_OptimizedGISelOrOtherSelectorBit = 71,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_TMOP()))
    Features.set(Feature_HasSME_TMOPBit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_FEXPA()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_FEXPABit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->hasDisableFastIncVL())
    Features.set(Feature_HasFastIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEF8F16_HasSME_MOP4,
  GIFBS_HasSMEF8F32_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_IsLE,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_FEXPABit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F32Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(903), /*)*//*default:*//*Label 154*/ GIMT_Encode4(439408),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3410),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(36405),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(50633),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(53154),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(53236), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(53318),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(61064),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(86179), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(97147), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(104671), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(114753),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(115244),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(115735),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(116003),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(116153),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(116644), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(116677),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(125615),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(126665), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(129714), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(143240),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(144591),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(145583),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(146575),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(148067), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(149559),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(150551),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(151543),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(152535),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(153527),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(154519),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(155511), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(156216),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(156921),
     /*    270 */ /*TargetOpcode::G_ATOMICRMW_FMAXIMUM*//*Label 34*/ GIMT_Encode4(157626),
     /*    274 */ /*TargetOpcode::G_ATOMICRMW_FMINIMUM*//*Label 35*/ GIMT_Encode4(158331), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(159036), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(159087),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(267831), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(279347),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 40*/ GIMT_Encode4(279637),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 41*/ GIMT_Encode4(281074),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 42*/ GIMT_Encode4(281194), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 43*/ GIMT_Encode4(281435),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 44*/ GIMT_Encode4(283333),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 45*/ GIMT_Encode4(284987),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 46*/ GIMT_Encode4(287766),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 47*/ GIMT_Encode4(288591),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 48*/ GIMT_Encode4(289029), GIMT_Encode4(0),
     /*    382 */ /*TargetOpcode::G_FSHR*//*Label 49*/ GIMT_Encode4(289854),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 50*/ GIMT_Encode4(289984), GIMT_Encode4(0),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 51*/ GIMT_Encode4(290526), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 52*/ GIMT_Encode4(298303), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 53*/ GIMT_Encode4(299348),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 54*/ GIMT_Encode4(299832),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 55*/ GIMT_Encode4(300316),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 56*/ GIMT_Encode4(300746),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 57*/ GIMT_Encode4(301176),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 58*/ GIMT_Encode4(301606), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(302036),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(303834),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(304572),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(308668), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(324941), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(325557),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(329064),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(329312),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(329500),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(330477),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(331454),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(336082),
     /*    614 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 71*/ GIMT_Encode4(340088),
     /*    618 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 72*/ GIMT_Encode4(340408),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 73*/ GIMT_Encode4(340728), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 74*/ GIMT_Encode4(341585),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 75*/ GIMT_Encode4(341867),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 76*/ GIMT_Encode4(342245),
     /*    646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 77*/ GIMT_Encode4(342623),
     /*    650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 78*/ GIMT_Encode4(342973),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 79*/ GIMT_Encode4(343323),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 80*/ GIMT_Encode4(344026), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 81*/ GIMT_Encode4(344729),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 82*/ GIMT_Encode4(345133),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 83*/ GIMT_Encode4(345537),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 84*/ GIMT_Encode4(345941),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 85*/ GIMT_Encode4(346345),
     /*    722 */ /*TargetOpcode::G_LROUND*//*Label 86*/ GIMT_Encode4(347160),
     /*    726 */ /*TargetOpcode::G_LLROUND*//*Label 87*/ GIMT_Encode4(347326),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 88*/ GIMT_Encode4(347425), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 89*/ GIMT_Encode4(347441),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 90*/ GIMT_Encode4(352813),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(385735), GIMT_Encode4(0),
     /*    762 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 92*/ GIMT_Encode4(388653), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTTZ*//*Label 93*/ GIMT_Encode4(390973), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 94*/ GIMT_Encode4(391125), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 95*/ GIMT_Encode4(391799),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 96*/ GIMT_Encode4(391959),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 97*/ GIMT_Encode4(392273),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 98*/ GIMT_Encode4(392427), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 99*/ GIMT_Encode4(392918),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 100*/ GIMT_Encode4(393218),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 101*/ GIMT_Encode4(393709),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 102*/ GIMT_Encode4(394200), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 103*/ GIMT_Encode4(394691),
     /*    894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 104*/ GIMT_Encode4(395817),
     /*    898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 105*/ GIMT_Encode4(396433),
     /*    902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 106*/ GIMT_Encode4(400155), GIMT_Encode4(0),
     /*    910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 107*/ GIMT_Encode4(400771),
     /*    914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 108*/ GIMT_Encode4(416378), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 109*/ GIMT_Encode4(416678),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 110*/ GIMT_Encode4(416692),
     /*    958 */ /*TargetOpcode::G_UBSANTRAP*//*Label 111*/ GIMT_Encode4(416713), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 112*/ GIMT_Encode4(416738), GIMT_Encode4(0),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 113*/ GIMT_Encode4(417048),
     /*    982 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 114*/ GIMT_Encode4(417219),
     /*    986 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 115*/ GIMT_Encode4(417390),
     /*    990 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 116*/ GIMT_Encode4(417561),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 117*/ GIMT_Encode4(417732), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 118*/ GIMT_Encode4(418861),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 119*/ GIMT_Encode4(419064),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 120*/ GIMT_Encode4(419267),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 121*/ GIMT_Encode4(419470), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3278 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 122*/ GIMT_Encode4(419673), GIMT_Encode4(0),
     /*   3286 */ /*AArch64::G_BSP*//*Label 123*/ GIMT_Encode4(419813),
     /*   3290 */ /*AArch64::G_DUP*//*Label 124*/ GIMT_Encode4(420801),
     /*   3294 */ /*AArch64::G_DUPLANE16*//*Label 125*/ GIMT_Encode4(422624),
     /*   3298 */ /*AArch64::G_DUPLANE32*//*Label 126*/ GIMT_Encode4(422879),
     /*   3302 */ /*AArch64::G_DUPLANE64*//*Label 127*/ GIMT_Encode4(423134),
     /*   3306 */ /*AArch64::G_DUPLANE8*//*Label 128*/ GIMT_Encode4(423280),
     /*   3310 */ /*AArch64::G_EXT*//*Label 129*/ GIMT_Encode4(423459),
     /*   3314 */ /*AArch64::G_FCMEQ*//*Label 130*/ GIMT_Encode4(425109),
     /*   3318 */ /*AArch64::G_FCMGE*//*Label 131*/ GIMT_Encode4(425668),
     /*   3322 */ /*AArch64::G_FCMGT*//*Label 132*/ GIMT_Encode4(426760),
     /*   3326 */ /*AArch64::G_REV16*//*Label 133*/ GIMT_Encode4(427852),
     /*   3330 */ /*AArch64::G_REV32*//*Label 134*/ GIMT_Encode4(428006),
     /*   3334 */ /*AArch64::G_REV64*//*Label 135*/ GIMT_Encode4(428182),
     /*   3338 */ /*AArch64::G_SADDLP*//*Label 136*/ GIMT_Encode4(428456),
     /*   3342 */ /*AArch64::G_SADDLV*//*Label 137*/ GIMT_Encode4(428662),
     /*   3346 */ /*AArch64::G_SDOT*//*Label 138*/ GIMT_Encode4(429061),
     /*   3350 */ /*AArch64::G_SITOF*//*Label 139*/ GIMT_Encode4(429431),
     /*   3354 */ /*AArch64::G_SMULL*//*Label 140*/ GIMT_Encode4(429548),
     /*   3358 */ /*AArch64::G_TRN1*//*Label 141*/ GIMT_Encode4(430781),
     /*   3362 */ /*AArch64::G_TRN2*//*Label 142*/ GIMT_Encode4(431561),
     /*   3366 */ /*AArch64::G_UADDLP*//*Label 143*/ GIMT_Encode4(432341),
     /*   3370 */ /*AArch64::G_UADDLV*//*Label 144*/ GIMT_Encode4(432547),
     /*   3374 */ /*AArch64::G_UDOT*//*Label 145*/ GIMT_Encode4(433414),
     /*   3378 */ /*AArch64::G_UITOF*//*Label 146*/ GIMT_Encode4(433784),
     /*   3382 */ /*AArch64::G_UMULL*//*Label 147*/ GIMT_Encode4(433901),
     /*   3386 */ /*AArch64::G_UZP1*//*Label 148*/ GIMT_Encode4(435134),
     /*   3390 */ /*AArch64::G_UZP2*//*Label 149*/ GIMT_Encode4(435914),
     /*   3394 */ /*AArch64::G_VASHR*//*Label 150*/ GIMT_Encode4(436694),
     /*   3398 */ /*AArch64::G_VLSHR*//*Label 151*/ GIMT_Encode4(437392),
     /*   3402 */ /*AArch64::G_ZIP1*//*Label 152*/ GIMT_Encode4(437848),
     /*   3406 */ /*AArch64::G_ZIP2*//*Label 153*/ GIMT_Encode4(438628),
     /*   3410 */ // Label 0: @3410
     /*   3410 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 168*/ GIMT_Encode4(36404),
     /*   3421 */ /*GILLT_s32*//*Label 155*/ GIMT_Encode4(3509),
     /*   3425 */ /*GILLT_s64*//*Label 156*/ GIMT_Encode4(6288), GIMT_Encode4(0),
     /*   3433 */ /*GILLT_v2s32*//*Label 157*/ GIMT_Encode4(11616),
     /*   3437 */ /*GILLT_v2s64*//*Label 158*/ GIMT_Encode4(15224),
     /*   3441 */ /*GILLT_v4s16*//*Label 159*/ GIMT_Encode4(21126),
     /*   3445 */ /*GILLT_v4s32*//*Label 160*/ GIMT_Encode4(24624),
     /*   3449 */ /*GILLT_v8s8*//*Label 161*/ GIMT_Encode4(30802),
     /*   3453 */ /*GILLT_v8s16*//*Label 162*/ GIMT_Encode4(31652),
     /*   3457 */ /*GILLT_v16s8*//*Label 163*/ GIMT_Encode4(35230), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3477 */ /*GILLT_nxv2s64*//*Label 164*/ GIMT_Encode4(35954), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3489 */ /*GILLT_nxv4s32*//*Label 165*/ GIMT_Encode4(36326), GIMT_Encode4(0),
     /*   3497 */ /*GILLT_nxv8s16*//*Label 166*/ GIMT_Encode4(36352), GIMT_Encode4(0),
     /*   3505 */ /*GILLT_nxv16s8*//*Label 167*/ GIMT_Encode4(36378),
     /*   3509 */ // Label 155: @3509
     /*   3509 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(6287),
     /*   3514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3520 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3553), // Rule ID 13289 //
     /*   3525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3540 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3551 */     GIR_RootConstrainSelectedInstOperands,
     /*   3552 */     // GIR_Coverage, 13289,
     /*   3552 */     GIR_EraseRootFromParent_Done,
     /*   3553 */   // Label 170: @3553
     /*   3553 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3705), // Rule ID 13716 //
     /*   3558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3585 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3588 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3593 */     // MIs[2] pattern
     /*   3593 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3596 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3607 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3607 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3610 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3614 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3633 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3636 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3640 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3687 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3704 */     // GIR_Coverage, 13716,
     /*   3704 */     GIR_EraseRootFromParent_Done,
     /*   3705 */   // Label 171: @3705
     /*   3705 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3857), // Rule ID 15570 //
     /*   3710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3745 */     // MIs[2] pattern
     /*   3745 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3748 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3759 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3759 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3762 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3766 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3785 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3792 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3839 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3856 */     // GIR_Coverage, 15570,
     /*   3856 */     GIR_EraseRootFromParent_Done,
     /*   3857 */   // Label 172: @3857
     /*   3857 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4009), // Rule ID 15582 //
     /*   3862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3889 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3892 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3897 */     // MIs[2] pattern
     /*   3897 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3900 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3911 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3937 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3940 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3944 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3947 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3952 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3957 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3981 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4008 */     // GIR_Coverage, 15582,
     /*   4008 */     GIR_EraseRootFromParent_Done,
     /*   4009 */   // Label 173: @4009
     /*   4009 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4161), // Rule ID 15594 //
     /*   4014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4041 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4044 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4049 */     // MIs[2] pattern
     /*   4049 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4052 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4063 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4063 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4066 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4070 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4089 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4092 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4096 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4126 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4133 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4143 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4160 */     // GIR_Coverage, 15594,
     /*   4160 */     GIR_EraseRootFromParent_Done,
     /*   4161 */   // Label 174: @4161
     /*   4161 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4194), // Rule ID 91 //
     /*   4166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4181 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4192 */     GIR_RootConstrainSelectedInstOperands,
     /*   4193 */     // GIR_Coverage, 91,
     /*   4193 */     GIR_EraseRootFromParent_Done,
     /*   4194 */   // Label 175: @4194
     /*   4194 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4346), // Rule ID 2656 //
     /*   4199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4230 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4233 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4238 */     // MIs[2] pattern
     /*   4238 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4241 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4248 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4248 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4251 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4255 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4262 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4265 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4269 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4274 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4277 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4281 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4284 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4289 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4294 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4318 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4328 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4345 */     // GIR_Coverage, 2656,
     /*   4345 */     GIR_EraseRootFromParent_Done,
     /*   4346 */   // Label 176: @4346
     /*   4346 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4498), // Rule ID 10015 //
     /*   4351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4382 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4385 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4390 */     // MIs[2] pattern
     /*   4390 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4393 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4400 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4426 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4433 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4441 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4446 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4470 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4480 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4497 */     // GIR_Coverage, 10015,
     /*   4497 */     GIR_EraseRootFromParent_Done,
     /*   4498 */   // Label 177: @4498
     /*   4498 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4650), // Rule ID 10027 //
     /*   4503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4534 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4537 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4542 */     // MIs[2] pattern
     /*   4542 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4545 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4552 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4552 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4555 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4559 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4578 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4585 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4598 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4615 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4632 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4649 */     // GIR_Coverage, 10027,
     /*   4649 */     GIR_EraseRootFromParent_Done,
     /*   4650 */   // Label 178: @4650
     /*   4650 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4802), // Rule ID 10039 //
     /*   4655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4686 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4689 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4694 */     // MIs[2] pattern
     /*   4694 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4697 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4704 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4704 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4707 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4711 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4730 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4737 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4774 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4784 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4801 */     // GIR_Coverage, 10039,
     /*   4801 */     GIR_EraseRootFromParent_Done,
     /*   4802 */   // Label 179: @4802
     /*   4802 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4959), // Rule ID 15613 //
     /*   4807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4834 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4837 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4853 */     // MIs[2] pred
     /*   4853 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4864 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4864 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4867 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4871 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4890 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4897 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4910 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4941 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4958 */     // GIR_Coverage, 15613,
     /*   4958 */     GIR_EraseRootFromParent_Done,
     /*   4959 */   // Label 180: @4959
     /*   4959 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(5116), // Rule ID 15614 //
     /*   4964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4991 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4994 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5010 */     // MIs[2] pred
     /*   5010 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5021 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5021 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5024 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5028 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5047 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5054 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5067 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5098 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5115 */     // GIR_Coverage, 15614,
     /*   5115 */     GIR_EraseRootFromParent_Done,
     /*   5116 */   // Label 181: @5116
     /*   5116 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(5273), // Rule ID 15615 //
     /*   5121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5148 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5151 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5160 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5167 */     // MIs[2] pred
     /*   5167 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5178 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5178 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5181 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5185 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5192 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5195 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5199 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5204 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5207 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5211 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5245 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5272 */     // GIR_Coverage, 15615,
     /*   5272 */     GIR_EraseRootFromParent_Done,
     /*   5273 */   // Label 182: @5273
     /*   5273 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(5430), // Rule ID 15616 //
     /*   5278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5305 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5308 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5317 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5324 */     // MIs[2] pred
     /*   5324 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5335 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5335 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5338 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5342 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5349 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5352 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5356 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5361 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5364 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5368 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5402 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5412 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5429 */     // GIR_Coverage, 15616,
     /*   5429 */     GIR_EraseRootFromParent_Done,
     /*   5430 */   // Label 183: @5430
     /*   5430 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5587), // Rule ID 10131 //
     /*   5435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5466 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5469 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5478 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5485 */     // MIs[2] pred
     /*   5485 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5492 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5492 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5518 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5521 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5525 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5528 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5533 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5569 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5586 */     // GIR_Coverage, 10131,
     /*   5586 */     GIR_EraseRootFromParent_Done,
     /*   5587 */   // Label 184: @5587
     /*   5587 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5744), // Rule ID 10132 //
     /*   5592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5623 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5626 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5635 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5642 */     // MIs[2] pred
     /*   5642 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5649 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5649 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5652 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5656 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5675 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5678 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5682 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5690 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5726 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5743 */     // GIR_Coverage, 10132,
     /*   5743 */     GIR_EraseRootFromParent_Done,
     /*   5744 */   // Label 185: @5744
     /*   5744 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5901), // Rule ID 10133 //
     /*   5749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5780 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5783 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5792 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5799 */     // MIs[2] pred
     /*   5799 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5806 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5806 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5809 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5813 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5820 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5823 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5827 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5832 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5839 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5847 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5883 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5900 */     // GIR_Coverage, 10133,
     /*   5900 */     GIR_EraseRootFromParent_Done,
     /*   5901 */   // Label 186: @5901
     /*   5901 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(6058), // Rule ID 10134 //
     /*   5906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5937 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5940 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5949 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5956 */     // MIs[2] pred
     /*   5956 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5963 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5963 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5966 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5970 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5977 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5980 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5984 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5989 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5992 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5996 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5999 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   6017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   6021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   6030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   6033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6040 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   6047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6057 */     // GIR_Coverage, 10134,
     /*   6057 */     GIR_EraseRootFromParent_Done,
     /*   6058 */   // Label 187: @6058
     /*   6058 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(6091), // Rule ID 13293 //
     /*   6063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6078 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6089 */     GIR_RootConstrainSelectedInstOperands,
     /*   6090 */     // GIR_Coverage, 13293,
     /*   6090 */     GIR_EraseRootFromParent_Done,
     /*   6091 */   // Label 188: @6091
     /*   6091 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(6127), // Rule ID 13856 //
     /*   6096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6111 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6125 */     GIR_RootConstrainSelectedInstOperands,
     /*   6126 */     // GIR_Coverage, 13856,
     /*   6126 */     GIR_EraseRootFromParent_Done,
     /*   6127 */   // Label 189: @6127
     /*   6127 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6160), // Rule ID 97 //
     /*   6132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6147 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6158 */     GIR_RootConstrainSelectedInstOperands,
     /*   6159 */     // GIR_Coverage, 97,
     /*   6159 */     GIR_EraseRootFromParent_Done,
     /*   6160 */   // Label 190: @6160
     /*   6160 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6196), // Rule ID 3921 //
     /*   6165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6180 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6194 */     GIR_RootConstrainSelectedInstOperands,
     /*   6195 */     // GIR_Coverage, 3921,
     /*   6195 */     GIR_EraseRootFromParent_Done,
     /*   6196 */   // Label 191: @6196
     /*   6196 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6229), // Rule ID 13291 //
     /*   6201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6216 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6227 */     GIR_RootConstrainSelectedInstOperands,
     /*   6228 */     // GIR_Coverage, 13291,
     /*   6228 */     GIR_EraseRootFromParent_Done,
     /*   6229 */   // Label 192: @6229
     /*   6229 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(6262), // Rule ID 95 //
     /*   6234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6249 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6260 */     GIR_RootConstrainSelectedInstOperands,
     /*   6261 */     // GIR_Coverage, 95,
     /*   6261 */     GIR_EraseRootFromParent_Done,
     /*   6262 */   // Label 193: @6262
     /*   6262 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6286), // Rule ID 93 //
     /*   6267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6279 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6284 */     GIR_RootConstrainSelectedInstOperands,
     /*   6285 */     // GIR_Coverage, 93,
     /*   6285 */     GIR_Done,
     /*   6286 */   // Label 194: @6286
     /*   6286 */   GIM_Reject,
     /*   6287 */ // Label 169: @6287
     /*   6287 */ GIM_Reject,
     /*   6288 */ // Label 156: @6288
     /*   6288 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(11615),
     /*   6293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6299 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(6435), // Rule ID 5413 //
     /*   6304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6337 */     // MIs[1] Operand 2
     /*   6337 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6360 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6364 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6368 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6372 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6377 */     // MIs[3] Operand 2
     /*   6377 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6390 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6417 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6434 */     // GIR_Coverage, 5413,
     /*   6434 */     GIR_EraseRootFromParent_Done,
     /*   6435 */   // Label 196: @6435
     /*   6435 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6571), // Rule ID 5412 //
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6473 */     // MIs[1] Operand 2
     /*   6473 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6492 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6500 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6504 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6508 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6513 */     // MIs[3] Operand 2
     /*   6513 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6524 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6526 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6553 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6570 */     // GIR_Coverage, 5412,
     /*   6570 */     GIR_EraseRootFromParent_Done,
     /*   6571 */   // Label 197: @6571
     /*   6571 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(6707), // Rule ID 5422 //
     /*   6576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6609 */     // MIs[1] Operand 2
     /*   6609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6632 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6636 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6640 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6644 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6649 */     // MIs[3] Operand 2
     /*   6649 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6660 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6662 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6706 */     // GIR_Coverage, 5422,
     /*   6706 */     GIR_EraseRootFromParent_Done,
     /*   6707 */   // Label 198: @6707
     /*   6707 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6843), // Rule ID 5411 //
     /*   6712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6745 */     // MIs[1] Operand 2
     /*   6745 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6772 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6776 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6780 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6785 */     // MIs[3] Operand 2
     /*   6785 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6796 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6798 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6825 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6842 */     // GIR_Coverage, 5411,
     /*   6842 */     GIR_EraseRootFromParent_Done,
     /*   6843 */   // Label 199: @6843
     /*   6843 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6979), // Rule ID 5410 //
     /*   6848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6881 */     // MIs[1] Operand 2
     /*   6881 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6908 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6912 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6916 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6921 */     // MIs[3] Operand 2
     /*   6921 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6932 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6934 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6961 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6978 */     // GIR_Coverage, 5410,
     /*   6978 */     GIR_EraseRootFromParent_Done,
     /*   6979 */   // Label 200: @6979
     /*   6979 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(7047), // Rule ID 6967 //
     /*   6984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   7013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7025 */     // MIs[2] Rn
     /*   7025 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7030 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   7034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7036 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7045 */     GIR_RootConstrainSelectedInstOperands,
     /*   7046 */     // GIR_Coverage, 6967,
     /*   7046 */     GIR_EraseRootFromParent_Done,
     /*   7047 */   // Label 201: @7047
     /*   7047 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(7115), // Rule ID 14014 //
     /*   7052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7077 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7093 */     // MIs[2] Rn
     /*   7093 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7098 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7104 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7113 */     GIR_RootConstrainSelectedInstOperands,
     /*   7114 */     // GIR_Coverage, 14014,
     /*   7114 */     GIR_EraseRootFromParent_Done,
     /*   7115 */   // Label 202: @7115
     /*   7115 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(7148), // Rule ID 13290 //
     /*   7120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7135 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7146 */     GIR_RootConstrainSelectedInstOperands,
     /*   7147 */     // GIR_Coverage, 13290,
     /*   7147 */     GIR_EraseRootFromParent_Done,
     /*   7148 */   // Label 203: @7148
     /*   7148 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(7281), // Rule ID 3973 //
     /*   7153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7190 */     // MIs[2] Operand 2
     /*   7190 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7209 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7213 */     // MIs[3] Operand 1
     /*   7213 */     // No operand predicates
     /*   7213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7219 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7231 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7250 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7279 */     GIR_RootConstrainSelectedInstOperands,
     /*   7280 */     // GIR_Coverage, 3973,
     /*   7280 */     GIR_EraseRootFromParent_Done,
     /*   7281 */   // Label 204: @7281
     /*   7281 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7376), // Rule ID 3971 //
     /*   7286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7331 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7335 */     // MIs[3] Operand 1
     /*   7335 */     // No operand predicates
     /*   7335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7341 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7353 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7374 */     GIR_RootConstrainSelectedInstOperands,
     /*   7375 */     // GIR_Coverage, 3971,
     /*   7375 */     GIR_EraseRootFromParent_Done,
     /*   7376 */   // Label 205: @7376
     /*   7376 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7471), // Rule ID 3972 //
     /*   7381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7426 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7430 */     // MIs[3] Operand 1
     /*   7430 */     // No operand predicates
     /*   7430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7436 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7448 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7469 */     GIR_RootConstrainSelectedInstOperands,
     /*   7470 */     // GIR_Coverage, 3972,
     /*   7470 */     GIR_EraseRootFromParent_Done,
     /*   7471 */   // Label 206: @7471
     /*   7471 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7504), // Rule ID 92 //
     /*   7476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7491 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7502 */     GIR_RootConstrainSelectedInstOperands,
     /*   7503 */     // GIR_Coverage, 92,
     /*   7503 */     GIR_EraseRootFromParent_Done,
     /*   7504 */   // Label 207: @7504
     /*   7504 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7637), // Rule ID 13866 //
     /*   7509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7550 */     // MIs[2] Operand 2
     /*   7550 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7573 */     // MIs[3] Operand 1
     /*   7573 */     // No operand predicates
     /*   7573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7575 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7587 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7606 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7635 */     GIR_RootConstrainSelectedInstOperands,
     /*   7636 */     // GIR_Coverage, 13866,
     /*   7636 */     GIR_EraseRootFromParent_Done,
     /*   7637 */   // Label 208: @7637
     /*   7637 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7732), // Rule ID 13864 //
     /*   7642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7691 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7695 */     // MIs[3] Operand 1
     /*   7695 */     // No operand predicates
     /*   7695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7697 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7709 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7730 */     GIR_RootConstrainSelectedInstOperands,
     /*   7731 */     // GIR_Coverage, 13864,
     /*   7731 */     GIR_EraseRootFromParent_Done,
     /*   7732 */   // Label 209: @7732
     /*   7732 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7827), // Rule ID 13865 //
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7786 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7790 */     // MIs[3] Operand 1
     /*   7790 */     // No operand predicates
     /*   7790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7792 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7804 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7825 */     GIR_RootConstrainSelectedInstOperands,
     /*   7826 */     // GIR_Coverage, 13865,
     /*   7826 */     GIR_EraseRootFromParent_Done,
     /*   7827 */   // Label 210: @7827
     /*   7827 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(7909), // Rule ID 13301 //
     /*   7832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7892 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7907 */     GIR_RootConstrainSelectedInstOperands,
     /*   7908 */     // GIR_Coverage, 13301,
     /*   7908 */     GIR_EraseRootFromParent_Done,
     /*   7909 */   // Label 211: @7909
     /*   7909 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(7991), // Rule ID 13302 //
     /*   7914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7974 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7989 */     GIR_RootConstrainSelectedInstOperands,
     /*   7990 */     // GIR_Coverage, 13302,
     /*   7990 */     GIR_EraseRootFromParent_Done,
     /*   7991 */   // Label 212: @7991
     /*   7991 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(8073), // Rule ID 123 //
     /*   7996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8045 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8049 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8056 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8071 */     GIR_RootConstrainSelectedInstOperands,
     /*   8072 */     // GIR_Coverage, 123,
     /*   8072 */     GIR_EraseRootFromParent_Done,
     /*   8073 */   // Label 213: @8073
     /*   8073 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(8155), // Rule ID 125 //
     /*   8078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8138 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8153 */     GIR_RootConstrainSelectedInstOperands,
     /*   8154 */     // GIR_Coverage, 125,
     /*   8154 */     GIR_EraseRootFromParent_Done,
     /*   8155 */   // Label 214: @8155
     /*   8155 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(8213), // Rule ID 13711 //
     /*   8160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8175 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8178 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8183 */     // MIs[1] pattern
     /*   8183 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8186 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8197 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8211 */     GIR_RootConstrainSelectedInstOperands,
     /*   8212 */     // GIR_Coverage, 13711,
     /*   8212 */     GIR_EraseRootFromParent_Done,
     /*   8213 */   // Label 215: @8213
     /*   8213 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8271), // Rule ID 15565 //
     /*   8218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8233 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8236 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8241 */     // MIs[1] pattern
     /*   8241 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8244 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8255 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8269 */     GIR_RootConstrainSelectedInstOperands,
     /*   8270 */     // GIR_Coverage, 15565,
     /*   8270 */     GIR_EraseRootFromParent_Done,
     /*   8271 */   // Label 216: @8271
     /*   8271 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8329), // Rule ID 15577 //
     /*   8276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8291 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8294 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8299 */     // MIs[1] pattern
     /*   8299 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8302 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8313 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8327 */     GIR_RootConstrainSelectedInstOperands,
     /*   8328 */     // GIR_Coverage, 15577,
     /*   8328 */     GIR_EraseRootFromParent_Done,
     /*   8329 */   // Label 217: @8329
     /*   8329 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8387), // Rule ID 15589 //
     /*   8334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8349 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8352 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8357 */     // MIs[1] pattern
     /*   8357 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8360 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8371 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8385 */     GIR_RootConstrainSelectedInstOperands,
     /*   8386 */     // GIR_Coverage, 15589,
     /*   8386 */     GIR_EraseRootFromParent_Done,
     /*   8387 */   // Label 218: @8387
     /*   8387 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8445), // Rule ID 2653 //
     /*   8392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8411 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8414 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8419 */     // MIs[1] pattern
     /*   8419 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8422 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8429 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8443 */     GIR_RootConstrainSelectedInstOperands,
     /*   8444 */     // GIR_Coverage, 2653,
     /*   8444 */     GIR_EraseRootFromParent_Done,
     /*   8445 */   // Label 219: @8445
     /*   8445 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8503), // Rule ID 10012 //
     /*   8450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8469 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8472 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8477 */     // MIs[1] pattern
     /*   8477 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8480 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8487 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8501 */     GIR_RootConstrainSelectedInstOperands,
     /*   8502 */     // GIR_Coverage, 10012,
     /*   8502 */     GIR_EraseRootFromParent_Done,
     /*   8503 */   // Label 220: @8503
     /*   8503 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8561), // Rule ID 10024 //
     /*   8508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8527 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8530 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8535 */     // MIs[1] pattern
     /*   8535 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8538 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8545 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8559 */     GIR_RootConstrainSelectedInstOperands,
     /*   8560 */     // GIR_Coverage, 10024,
     /*   8560 */     GIR_EraseRootFromParent_Done,
     /*   8561 */   // Label 221: @8561
     /*   8561 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8619), // Rule ID 10036 //
     /*   8566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8585 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8588 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8593 */     // MIs[1] pattern
     /*   8593 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8596 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8603 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8617 */     GIR_RootConstrainSelectedInstOperands,
     /*   8618 */     // GIR_Coverage, 10036,
     /*   8618 */     GIR_EraseRootFromParent_Done,
     /*   8619 */   // Label 222: @8619
     /*   8619 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8782), // Rule ID 13986 //
     /*   8624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   8648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8666 */     // MIs[1] Operand 2
     /*   8666 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8683 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8683 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8686 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8690 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8709 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8712 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8716 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8719 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8724 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8746 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8749 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8753 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8764 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8781 */     // GIR_Coverage, 13986,
     /*   8781 */     GIR_EraseRootFromParent_Done,
     /*   8782 */   // Label 223: @8782
     /*   8782 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8945), // Rule ID 13983 //
     /*   8787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8829 */     // MIs[1] Operand 2
     /*   8829 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8846 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8846 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8849 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8853 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8860 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8863 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8867 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8872 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8879 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8882 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8887 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8892 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8909 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8927 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8944 */     // GIR_Coverage, 13983,
     /*   8944 */     GIR_EraseRootFromParent_Done,
     /*   8945 */   // Label 224: @8945
     /*   8945 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(9095), // Rule ID 13992 //
     /*   8950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8983 */     // MIs[1] Operand 2
     /*   8983 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9000 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9000 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9003 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9007 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9026 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9029 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9033 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9077 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9094 */     // GIR_Coverage, 13992,
     /*   9094 */     GIR_EraseRootFromParent_Done,
     /*   9095 */   // Label 225: @9095
     /*   9095 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(9245), // Rule ID 13995 //
     /*   9100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9133 */     // MIs[1] Operand 2
     /*   9133 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9150 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9150 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9153 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9157 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9164 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9167 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9171 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9176 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9179 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9183 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9213 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9227 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9244 */     // GIR_Coverage, 13995,
     /*   9244 */     GIR_EraseRootFromParent_Done,
     /*   9245 */   // Label 226: @9245
     /*   9245 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(9395), // Rule ID 13991 //
     /*   9250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9283 */     // MIs[1] Operand 2
     /*   9283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9300 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9300 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9303 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9307 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9326 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9329 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9333 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9336 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9341 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9363 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9377 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9394 */     // GIR_Coverage, 13991,
     /*   9394 */     GIR_EraseRootFromParent_Done,
     /*   9395 */   // Label 227: @9395
     /*   9395 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9558), // Rule ID 5395 //
     /*   9400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9446 */     // MIs[1] Operand 2
     /*   9446 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9459 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9459 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9462 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9466 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9473 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9476 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9480 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9485 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9488 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9492 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9495 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9540 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9557 */     // GIR_Coverage, 5395,
     /*   9557 */     GIR_EraseRootFromParent_Done,
     /*   9558 */   // Label 228: @9558
     /*   9558 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(9721), // Rule ID 5392 //
     /*   9563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9609 */     // MIs[1] Operand 2
     /*   9609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9622 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9622 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9625 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9629 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9636 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9639 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9643 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9648 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9651 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9655 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9658 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9663 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9692 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9703 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9720 */     // GIR_Coverage, 5392,
     /*   9720 */     GIR_EraseRootFromParent_Done,
     /*   9721 */   // Label 229: @9721
     /*   9721 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(9871), // Rule ID 5419 //
     /*   9726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9763 */     // MIs[1] Operand 2
     /*   9763 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9776 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9776 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9779 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9783 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9802 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9805 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9809 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9812 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9817 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9822 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9839 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9853 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9870 */     // GIR_Coverage, 5419,
     /*   9870 */     GIR_EraseRootFromParent_Done,
     /*   9871 */   // Label 230: @9871
     /*   9871 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(10021), // Rule ID 5425 //
     /*   9876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9913 */     // MIs[1] Operand 2
     /*   9913 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9926 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9926 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9929 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9933 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9940 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9943 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9947 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9952 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9959 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9972 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9989 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10020 */     // GIR_Coverage, 5425,
     /*  10020 */     GIR_EraseRootFromParent_Done,
     /*  10021 */   // Label 231: @10021
     /*  10021 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(10171), // Rule ID 5418 //
     /*  10026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10063 */     // MIs[1] Operand 2
     /*  10063 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10076 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10076 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10079 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10083 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10090 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10093 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10097 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10102 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10105 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10109 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10112 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10153 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10170 */     // GIR_Coverage, 5418,
     /*  10170 */     GIR_EraseRootFromParent_Done,
     /*  10171 */   // Label 232: @10171
     /*  10171 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(10204), // Rule ID 13294 //
     /*  10176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10191 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10198 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10202 */     GIR_RootConstrainSelectedInstOperands,
     /*  10203 */     // GIR_Coverage, 13294,
     /*  10203 */     GIR_EraseRootFromParent_Done,
     /*  10204 */   // Label 233: @10204
     /*  10204 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10240), // Rule ID 13857 //
     /*  10209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10224 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10238 */     GIR_RootConstrainSelectedInstOperands,
     /*  10239 */     // GIR_Coverage, 13857,
     /*  10239 */     GIR_EraseRootFromParent_Done,
     /*  10240 */   // Label 234: @10240
     /*  10240 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10273), // Rule ID 98 //
     /*  10245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10260 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10267 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10271 */     GIR_RootConstrainSelectedInstOperands,
     /*  10272 */     // GIR_Coverage, 98,
     /*  10272 */     GIR_EraseRootFromParent_Done,
     /*  10273 */   // Label 235: @10273
     /*  10273 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10309), // Rule ID 3922 //
     /*  10278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10293 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10300 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10307 */     GIR_RootConstrainSelectedInstOperands,
     /*  10308 */     // GIR_Coverage, 3922,
     /*  10308 */     GIR_EraseRootFromParent_Done,
     /*  10309 */   // Label 236: @10309
     /*  10309 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10342), // Rule ID 13292 //
     /*  10314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10329 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10340 */     GIR_RootConstrainSelectedInstOperands,
     /*  10341 */     // GIR_Coverage, 13292,
     /*  10341 */     GIR_EraseRootFromParent_Done,
     /*  10342 */   // Label 237: @10342
     /*  10342 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10405), // Rule ID 15605 //
     /*  10347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10362 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10365 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10374 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10381 */     // MIs[1] pred
     /*  10381 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10392 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10403 */     GIR_RootConstrainSelectedInstOperands,
     /*  10404 */     // GIR_Coverage, 15605,
     /*  10404 */     GIR_EraseRootFromParent_Done,
     /*  10405 */   // Label 238: @10405
     /*  10405 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10468), // Rule ID 15606 //
     /*  10410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10425 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10428 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10444 */     // MIs[1] pred
     /*  10444 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10455 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10466 */     GIR_RootConstrainSelectedInstOperands,
     /*  10467 */     // GIR_Coverage, 15606,
     /*  10467 */     GIR_EraseRootFromParent_Done,
     /*  10468 */   // Label 239: @10468
     /*  10468 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10531), // Rule ID 15607 //
     /*  10473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10488 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10491 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10507 */     // MIs[1] pred
     /*  10507 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10518 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10529 */     GIR_RootConstrainSelectedInstOperands,
     /*  10530 */     // GIR_Coverage, 15607,
     /*  10530 */     GIR_EraseRootFromParent_Done,
     /*  10531 */   // Label 240: @10531
     /*  10531 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10594), // Rule ID 15608 //
     /*  10536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10551 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10554 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10563 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10570 */     // MIs[1] pred
     /*  10570 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10581 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10592 */     GIR_RootConstrainSelectedInstOperands,
     /*  10593 */     // GIR_Coverage, 15608,
     /*  10593 */     GIR_EraseRootFromParent_Done,
     /*  10594 */   // Label 241: @10594
     /*  10594 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10627), // Rule ID 96 //
     /*  10599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10614 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10621 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10625 */     GIR_RootConstrainSelectedInstOperands,
     /*  10626 */     // GIR_Coverage, 96,
     /*  10626 */     GIR_EraseRootFromParent_Done,
     /*  10627 */   // Label 242: @10627
     /*  10627 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10690), // Rule ID 10123 //
     /*  10632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10651 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10654 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10663 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10670 */     // MIs[1] pred
     /*  10670 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10677 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10688 */     GIR_RootConstrainSelectedInstOperands,
     /*  10689 */     // GIR_Coverage, 10123,
     /*  10689 */     GIR_EraseRootFromParent_Done,
     /*  10690 */   // Label 243: @10690
     /*  10690 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(10753), // Rule ID 10124 //
     /*  10695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10714 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10717 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10733 */     // MIs[1] pred
     /*  10733 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10740 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10751 */     GIR_RootConstrainSelectedInstOperands,
     /*  10752 */     // GIR_Coverage, 10124,
     /*  10752 */     GIR_EraseRootFromParent_Done,
     /*  10753 */   // Label 244: @10753
     /*  10753 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(10816), // Rule ID 10125 //
     /*  10758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10777 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10780 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10789 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10796 */     // MIs[1] pred
     /*  10796 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10803 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10814 */     GIR_RootConstrainSelectedInstOperands,
     /*  10815 */     // GIR_Coverage, 10125,
     /*  10815 */     GIR_EraseRootFromParent_Done,
     /*  10816 */   // Label 245: @10816
     /*  10816 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(10879), // Rule ID 10126 //
     /*  10821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10840 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10843 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10852 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10859 */     // MIs[1] pred
     /*  10859 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10866 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10877 */     GIR_RootConstrainSelectedInstOperands,
     /*  10878 */     // GIR_Coverage, 10126,
     /*  10878 */     GIR_EraseRootFromParent_Done,
     /*  10879 */   // Label 246: @10879
     /*  10879 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(10935), // Rule ID 13400 //
     /*  10884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10899 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10902 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  10907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10922 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 661:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10933 */     GIR_RootConstrainSelectedInstOperands,
     /*  10934 */     // GIR_Coverage, 13400,
     /*  10934 */     GIR_EraseRootFromParent_Done,
     /*  10935 */   // Label 247: @10935
     /*  10935 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(10991), // Rule ID 13412 //
     /*  10940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10955 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10958 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  10963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10978 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 726:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  10981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10989 */     GIR_RootConstrainSelectedInstOperands,
     /*  10990 */     // GIR_Coverage, 13412,
     /*  10990 */     GIR_EraseRootFromParent_Done,
     /*  10991 */   // Label 248: @10991
     /*  10991 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11058), // Rule ID 13618 //
     /*  10996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11020 */     // MIs[1] imm
     /*  11020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11028 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11032 */     // MIs[2] Operand 1
     /*  11032 */     // No operand predicates
     /*  11032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11042 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11056 */     GIR_RootConstrainSelectedInstOperands,
     /*  11057 */     // GIR_Coverage, 13618,
     /*  11057 */     GIR_EraseRootFromParent_Done,
     /*  11058 */   // Label 249: @11058
     /*  11058 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11125), // Rule ID 13621 //
     /*  11063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11087 */     // MIs[1] imm
     /*  11087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11099 */     // MIs[2] Operand 1
     /*  11099 */     // No operand predicates
     /*  11099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11109 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11123 */     GIR_RootConstrainSelectedInstOperands,
     /*  11124 */     // GIR_Coverage, 13621,
     /*  11124 */     GIR_EraseRootFromParent_Done,
     /*  11125 */   // Label 250: @11125
     /*  11125 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11181), // Rule ID 997 //
     /*  11130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11149 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11152 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11168 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 661:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11179 */     GIR_RootConstrainSelectedInstOperands,
     /*  11180 */     // GIR_Coverage, 997,
     /*  11180 */     GIR_EraseRootFromParent_Done,
     /*  11181 */   // Label 251: @11181
     /*  11181 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11237), // Rule ID 1058 //
     /*  11186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11205 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11208 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11224 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 726:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11235 */     GIR_RootConstrainSelectedInstOperands,
     /*  11236 */     // GIR_Coverage, 1058,
     /*  11236 */     GIR_EraseRootFromParent_Done,
     /*  11237 */   // Label 252: @11237
     /*  11237 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11304), // Rule ID 2121 //
     /*  11242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11270 */     // MIs[1] imm
     /*  11270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11282 */     // MIs[2] Operand 1
     /*  11282 */     // No operand predicates
     /*  11282 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11288 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11302 */     GIR_RootConstrainSelectedInstOperands,
     /*  11303 */     // GIR_Coverage, 2121,
     /*  11303 */     GIR_EraseRootFromParent_Done,
     /*  11304 */   // Label 253: @11304
     /*  11304 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11371), // Rule ID 2130 //
     /*  11309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11337 */     // MIs[1] imm
     /*  11337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11345 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11349 */     // MIs[2] Operand 1
     /*  11349 */     // No operand predicates
     /*  11349 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11355 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11369 */     GIR_RootConstrainSelectedInstOperands,
     /*  11370 */     // GIR_Coverage, 2130,
     /*  11370 */     GIR_EraseRootFromParent_Done,
     /*  11371 */   // Label 254: @11371
     /*  11371 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11419), // Rule ID 13399 //
     /*  11376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11406 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11417 */     GIR_RootConstrainSelectedInstOperands,
     /*  11418 */     // GIR_Coverage, 13399,
     /*  11418 */     GIR_EraseRootFromParent_Done,
     /*  11419 */   // Label 255: @11419
     /*  11419 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11467), // Rule ID 13411 //
     /*  11424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11454 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11465 */     GIR_RootConstrainSelectedInstOperands,
     /*  11466 */     // GIR_Coverage, 13411,
     /*  11466 */     GIR_EraseRootFromParent_Done,
     /*  11467 */   // Label 256: @11467
     /*  11467 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11515), // Rule ID 996 //
     /*  11472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11502 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11513 */     GIR_RootConstrainSelectedInstOperands,
     /*  11514 */     // GIR_Coverage, 996,
     /*  11514 */     GIR_EraseRootFromParent_Done,
     /*  11515 */   // Label 257: @11515
     /*  11515 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11563), // Rule ID 1057 //
     /*  11520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11550 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11561 */     GIR_RootConstrainSelectedInstOperands,
     /*  11562 */     // GIR_Coverage, 1057,
     /*  11562 */     GIR_EraseRootFromParent_Done,
     /*  11563 */   // Label 258: @11563
     /*  11563 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11587), // Rule ID 94 //
     /*  11568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11580 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  11580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  11585 */     GIR_RootConstrainSelectedInstOperands,
     /*  11586 */     // GIR_Coverage, 94,
     /*  11586 */     GIR_Done,
     /*  11587 */   // Label 259: @11587
     /*  11587 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11614), // Rule ID 1607 //
     /*  11592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11607 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  11607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  11612 */     GIR_RootConstrainSelectedInstOperands,
     /*  11613 */     // GIR_Coverage, 1607,
     /*  11613 */     GIR_Done,
     /*  11614 */   // Label 260: @11614
     /*  11614 */   GIM_Reject,
     /*  11615 */ // Label 195: @11615
     /*  11615 */ GIM_Reject,
     /*  11616 */ // Label 157: @11616
     /*  11616 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(15223),
     /*  11621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11627 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11815), // Rule ID 6988 //
     /*  11632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11669 */     // MIs[2] Operand 2
     /*  11669 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11688 */     // MIs[3] Rn
     /*  11688 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11693 */     // MIs[3] Operand 2
     /*  11693 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11712 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11716 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11720 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11724 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11728 */     // MIs[5] Rn
     /*  11728 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11733 */     // MIs[5] Operand 2
     /*  11733 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11744 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11748 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11752 */     // MIs[6] Rn
     /*  11752 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11757 */     // MIs[6] Operand 2
     /*  11757 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11768 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11770 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11797 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11814 */     // GIR_Coverage, 6988,
     /*  11814 */     GIR_EraseRootFromParent_Done,
     /*  11815 */   // Label 262: @11815
     /*  11815 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12003), // Rule ID 14025 //
     /*  11820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11857 */     // MIs[2] Operand 2
     /*  11857 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11876 */     // MIs[3] Rn
     /*  11876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11881 */     // MIs[3] Operand 2
     /*  11881 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11896 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11900 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11904 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11908 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11912 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11916 */     // MIs[5] Rn
     /*  11916 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11921 */     // MIs[5] Operand 2
     /*  11921 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11932 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11936 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11940 */     // MIs[6] Rn
     /*  11940 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11945 */     // MIs[6] Operand 2
     /*  11945 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11956 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11958 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11985 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12002 */     // GIR_Coverage, 14025,
     /*  12002 */     GIR_EraseRootFromParent_Done,
     /*  12003 */   // Label 263: @12003
     /*  12003 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12139), // Rule ID 5409 //
     /*  12008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12041 */     // MIs[1] Operand 2
     /*  12041 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12060 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12064 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12068 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12072 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12076 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12081 */     // MIs[3] Operand 2
     /*  12081 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12092 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12094 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12121 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12138 */     // GIR_Coverage, 5409,
     /*  12138 */     GIR_EraseRootFromParent_Done,
     /*  12139 */   // Label 264: @12139
     /*  12139 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12275), // Rule ID 5408 //
     /*  12144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12177 */     // MIs[1] Operand 2
     /*  12177 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12196 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12208 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12212 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12217 */     // MIs[3] Operand 2
     /*  12217 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12228 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12230 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12257 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12274 */     // GIR_Coverage, 5408,
     /*  12274 */     GIR_EraseRootFromParent_Done,
     /*  12275 */   // Label 265: @12275
     /*  12275 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12411), // Rule ID 5421 //
     /*  12280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12313 */     // MIs[1] Operand 2
     /*  12313 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12332 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12336 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12340 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12344 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12348 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12353 */     // MIs[3] Operand 2
     /*  12353 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12364 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12366 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12393 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12410 */     // GIR_Coverage, 5421,
     /*  12410 */     GIR_EraseRootFromParent_Done,
     /*  12411 */   // Label 266: @12411
     /*  12411 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12547), // Rule ID 5407 //
     /*  12416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12449 */     // MIs[1] Operand 2
     /*  12449 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12484 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12489 */     // MIs[3] Operand 2
     /*  12489 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12502 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12546 */     // GIR_Coverage, 5407,
     /*  12546 */     GIR_EraseRootFromParent_Done,
     /*  12547 */   // Label 267: @12547
     /*  12547 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12683), // Rule ID 5406 //
     /*  12552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12585 */     // MIs[1] Operand 2
     /*  12585 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12616 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12620 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12625 */     // MIs[3] Operand 2
     /*  12625 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12638 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12665 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12682 */     // GIR_Coverage, 5406,
     /*  12682 */     GIR_EraseRootFromParent_Done,
     /*  12683 */   // Label 268: @12683
     /*  12683 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12846), // Rule ID 13985 //
     /*  12688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  12712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12730 */     // MIs[1] Operand 2
     /*  12730 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12747 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12747 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12750 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12754 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12761 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12764 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12768 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12773 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12776 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12780 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12783 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12788 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12793 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  12805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12810 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12828 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12845 */     // GIR_Coverage, 13985,
     /*  12845 */     GIR_EraseRootFromParent_Done,
     /*  12846 */   // Label 269: @12846
     /*  12846 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(13009), // Rule ID 13982 //
     /*  12851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  12875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12893 */     // MIs[1] Operand 2
     /*  12893 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12910 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12910 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12913 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12917 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12924 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12927 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12931 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12936 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12943 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12946 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12951 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12956 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  12968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12973 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13008 */     // GIR_Coverage, 13982,
     /*  13008 */     GIR_EraseRootFromParent_Done,
     /*  13009 */   // Label 270: @13009
     /*  13009 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(13159), // Rule ID 13990 //
     /*  13014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13047 */     // MIs[1] Operand 2
     /*  13047 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13064 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13064 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13067 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13071 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13078 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13081 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13085 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13090 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13093 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13097 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13100 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13105 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13110 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13141 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13158 */     // GIR_Coverage, 13990,
     /*  13158 */     GIR_EraseRootFromParent_Done,
     /*  13159 */   // Label 271: @13159
     /*  13159 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(13309), // Rule ID 13994 //
     /*  13164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13197 */     // MIs[1] Operand 2
     /*  13197 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13214 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13214 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13217 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13221 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13228 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13231 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13235 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13240 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13243 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13247 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13250 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13255 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13260 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13277 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13291 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13308 */     // GIR_Coverage, 13994,
     /*  13308 */     GIR_EraseRootFromParent_Done,
     /*  13309 */   // Label 272: @13309
     /*  13309 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(13459), // Rule ID 13989 //
     /*  13314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13347 */     // MIs[1] Operand 2
     /*  13347 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13364 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13364 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13367 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13371 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13378 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13381 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13385 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13390 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13393 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13397 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13427 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13441 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13458 */     // GIR_Coverage, 13989,
     /*  13458 */     GIR_EraseRootFromParent_Done,
     /*  13459 */   // Label 273: @13459
     /*  13459 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13622), // Rule ID 5394 //
     /*  13464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13510 */     // MIs[1] Operand 2
     /*  13510 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13523 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13523 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13526 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13530 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13537 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13540 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13544 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13549 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13552 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13556 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13559 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13569 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13586 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13604 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13621 */     // GIR_Coverage, 5394,
     /*  13621 */     GIR_EraseRootFromParent_Done,
     /*  13622 */   // Label 274: @13622
     /*  13622 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13785), // Rule ID 5391 //
     /*  13627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13673 */     // MIs[1] Operand 2
     /*  13673 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13686 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13686 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13689 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13693 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13700 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13703 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13707 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13712 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13715 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13719 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13727 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13732 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13749 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13752 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13784 */     // GIR_Coverage, 5391,
     /*  13784 */     GIR_EraseRootFromParent_Done,
     /*  13785 */   // Label 275: @13785
     /*  13785 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13935), // Rule ID 5417 //
     /*  13790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13827 */     // MIs[1] Operand 2
     /*  13827 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13840 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13840 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13843 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13847 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13866 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13869 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  13873 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13886 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13903 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13917 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13934 */     // GIR_Coverage, 5417,
     /*  13934 */     GIR_EraseRootFromParent_Done,
     /*  13935 */   // Label 276: @13935
     /*  13935 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(14085), // Rule ID 5424 //
     /*  13940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13977 */     // MIs[1] Operand 2
     /*  13977 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13990 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13990 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13993 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13997 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14004 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14007 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14011 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14016 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14019 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14023 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14026 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14031 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14053 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14067 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14084 */     // GIR_Coverage, 5424,
     /*  14084 */     GIR_EraseRootFromParent_Done,
     /*  14085 */   // Label 277: @14085
     /*  14085 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(14235), // Rule ID 5416 //
     /*  14090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14127 */     // MIs[1] Operand 2
     /*  14127 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14140 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14140 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14143 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14147 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14166 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14169 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14173 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14203 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14217 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14234 */     // GIR_Coverage, 5416,
     /*  14234 */     GIR_EraseRootFromParent_Done,
     /*  14235 */   // Label 278: @14235
     /*  14235 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(14304), // Rule ID 13434 //
     /*  14240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14287 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14302 */     GIR_RootConstrainSelectedInstOperands,
     /*  14303 */     // GIR_Coverage, 13434,
     /*  14303 */     GIR_EraseRootFromParent_Done,
     /*  14304 */   // Label 279: @14304
     /*  14304 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(14373), // Rule ID 13446 //
     /*  14309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14324 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14327 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14356 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14371 */     GIR_RootConstrainSelectedInstOperands,
     /*  14372 */     // GIR_Coverage, 13446,
     /*  14372 */     GIR_EraseRootFromParent_Done,
     /*  14373 */   // Label 280: @14373
     /*  14373 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(14429), // Rule ID 13396 //
     /*  14378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14393 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14396 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14416 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 661:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14427 */     GIR_RootConstrainSelectedInstOperands,
     /*  14428 */     // GIR_Coverage, 13396,
     /*  14428 */     GIR_EraseRootFromParent_Done,
     /*  14429 */   // Label 281: @14429
     /*  14429 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(14485), // Rule ID 13408 //
     /*  14434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14449 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14452 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14472 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 726:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14483 */     GIR_RootConstrainSelectedInstOperands,
     /*  14484 */     // GIR_Coverage, 13408,
     /*  14484 */     GIR_EraseRootFromParent_Done,
     /*  14485 */   // Label 282: @14485
     /*  14485 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14552), // Rule ID 13638 //
     /*  14490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14514 */     // MIs[1] imm
     /*  14514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14526 */     // MIs[2] Operand 1
     /*  14526 */     // No operand predicates
     /*  14526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14530 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14536 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14550 */     GIR_RootConstrainSelectedInstOperands,
     /*  14551 */     // GIR_Coverage, 13638,
     /*  14551 */     GIR_EraseRootFromParent_Done,
     /*  14552 */   // Label 283: @14552
     /*  14552 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14619), // Rule ID 13659 //
     /*  14557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14581 */     // MIs[1] imm
     /*  14581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14593 */     // MIs[2] Operand 1
     /*  14593 */     // No operand predicates
     /*  14593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14603 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14617 */     GIR_RootConstrainSelectedInstOperands,
     /*  14618 */     // GIR_Coverage, 13659,
     /*  14618 */     GIR_EraseRootFromParent_Done,
     /*  14619 */   // Label 284: @14619
     /*  14619 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14688), // Rule ID 1365 //
     /*  14624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14643 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14646 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14655 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14671 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14686 */     GIR_RootConstrainSelectedInstOperands,
     /*  14687 */     // GIR_Coverage, 1365,
     /*  14687 */     GIR_EraseRootFromParent_Done,
     /*  14688 */   // Label 285: @14688
     /*  14688 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14757), // Rule ID 1488 //
     /*  14693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14712 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14715 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14724 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14740 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14755 */     GIR_RootConstrainSelectedInstOperands,
     /*  14756 */     // GIR_Coverage, 1488,
     /*  14756 */     GIR_EraseRootFromParent_Done,
     /*  14757 */   // Label 286: @14757
     /*  14757 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(14813), // Rule ID 993 //
     /*  14762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14781 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14784 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14800 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 661:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14811 */     GIR_RootConstrainSelectedInstOperands,
     /*  14812 */     // GIR_Coverage, 993,
     /*  14812 */     GIR_EraseRootFromParent_Done,
     /*  14813 */   // Label 287: @14813
     /*  14813 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(14869), // Rule ID 1054 //
     /*  14818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14837 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14840 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14856 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 726:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14867 */     GIR_RootConstrainSelectedInstOperands,
     /*  14868 */     // GIR_Coverage, 1054,
     /*  14868 */     GIR_EraseRootFromParent_Done,
     /*  14869 */   // Label 288: @14869
     /*  14869 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(14936), // Rule ID 2238 //
     /*  14874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14902 */     // MIs[1] imm
     /*  14902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14910 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14914 */     // MIs[2] Operand 1
     /*  14914 */     // No operand predicates
     /*  14914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14920 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14934 */     GIR_RootConstrainSelectedInstOperands,
     /*  14935 */     // GIR_Coverage, 2238,
     /*  14935 */     GIR_EraseRootFromParent_Done,
     /*  14936 */   // Label 289: @14936
     /*  14936 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(15003), // Rule ID 2297 //
     /*  14941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14969 */     // MIs[1] imm
     /*  14969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14977 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14981 */     // MIs[2] Operand 1
     /*  14981 */     // No operand predicates
     /*  14981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14987 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15001 */     GIR_RootConstrainSelectedInstOperands,
     /*  15002 */     // GIR_Coverage, 2297,
     /*  15002 */     GIR_EraseRootFromParent_Done,
     /*  15003 */   // Label 290: @15003
     /*  15003 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(15051), // Rule ID 13395 //
     /*  15008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15038 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15049 */     GIR_RootConstrainSelectedInstOperands,
     /*  15050 */     // GIR_Coverage, 13395,
     /*  15050 */     GIR_EraseRootFromParent_Done,
     /*  15051 */   // Label 291: @15051
     /*  15051 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(15099), // Rule ID 13407 //
     /*  15056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15086 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15097 */     GIR_RootConstrainSelectedInstOperands,
     /*  15098 */     // GIR_Coverage, 13407,
     /*  15098 */     GIR_EraseRootFromParent_Done,
     /*  15099 */   // Label 292: @15099
     /*  15099 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(15147), // Rule ID 992 //
     /*  15104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15134 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15145 */     GIR_RootConstrainSelectedInstOperands,
     /*  15146 */     // GIR_Coverage, 992,
     /*  15146 */     GIR_EraseRootFromParent_Done,
     /*  15147 */   // Label 293: @15147
     /*  15147 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(15195), // Rule ID 1053 //
     /*  15152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15182 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15193 */     GIR_RootConstrainSelectedInstOperands,
     /*  15194 */     // GIR_Coverage, 1053,
     /*  15194 */     GIR_EraseRootFromParent_Done,
     /*  15195 */   // Label 294: @15195
     /*  15195 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15222), // Rule ID 1104 //
     /*  15200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15215 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15220 */     GIR_RootConstrainSelectedInstOperands,
     /*  15221 */     // GIR_Coverage, 1104,
     /*  15221 */     GIR_Done,
     /*  15222 */   // Label 295: @15222
     /*  15222 */   GIM_Reject,
     /*  15223 */ // Label 261: @15223
     /*  15223 */ GIM_Reject,
     /*  15224 */ // Label 158: @15224
     /*  15224 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(21125),
     /*  15229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15235 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15353), // Rule ID 13573 //
     /*  15240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15283 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15287 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15291 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15296 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15300 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15304 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15308 */     // MIs[4] Operand 1
     /*  15308 */     // No operand predicates
     /*  15308 */     // MIs[2] Operand 2
     /*  15308 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15323 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15332 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15351 */     GIR_RootConstrainSelectedInstOperands,
     /*  15352 */     // GIR_Coverage, 13573,
     /*  15352 */     GIR_EraseRootFromParent_Done,
     /*  15353 */   // Label 297: @15353
     /*  15353 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15471), // Rule ID 13574 //
     /*  15358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15401 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15405 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15409 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15414 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15418 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15422 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15426 */     // MIs[4] Operand 1
     /*  15426 */     // No operand predicates
     /*  15426 */     // MIs[2] Operand 2
     /*  15426 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15441 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15450 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15469 */     GIR_RootConstrainSelectedInstOperands,
     /*  15470 */     // GIR_Coverage, 13574,
     /*  15470 */     GIR_EraseRootFromParent_Done,
     /*  15471 */   // Label 298: @15471
     /*  15471 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15589), // Rule ID 13603 //
     /*  15476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15519 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15523 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15527 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15540 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15544 */     // MIs[4] Operand 1
     /*  15544 */     // No operand predicates
     /*  15544 */     // MIs[2] Operand 2
     /*  15544 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15559 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15568 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15587 */     GIR_RootConstrainSelectedInstOperands,
     /*  15588 */     // GIR_Coverage, 13603,
     /*  15588 */     GIR_EraseRootFromParent_Done,
     /*  15589 */   // Label 299: @15589
     /*  15589 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15707), // Rule ID 13604 //
     /*  15594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15637 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15641 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15645 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15650 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15654 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15658 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15662 */     // MIs[4] Operand 1
     /*  15662 */     // No operand predicates
     /*  15662 */     // MIs[2] Operand 2
     /*  15662 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15677 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15686 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15705 */     GIR_RootConstrainSelectedInstOperands,
     /*  15706 */     // GIR_Coverage, 13604,
     /*  15706 */     GIR_EraseRootFromParent_Done,
     /*  15707 */   // Label 300: @15707
     /*  15707 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15825), // Rule ID 2042 //
     /*  15712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15763 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15767 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15772 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15776 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15780 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15784 */     // MIs[4] Operand 1
     /*  15784 */     // No operand predicates
     /*  15784 */     // MIs[2] Operand 2
     /*  15784 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15795 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15804 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15823 */     GIR_RootConstrainSelectedInstOperands,
     /*  15824 */     // GIR_Coverage, 2042,
     /*  15824 */     GIR_EraseRootFromParent_Done,
     /*  15825 */   // Label 301: @15825
     /*  15825 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15943), // Rule ID 13572 //
     /*  15830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15881 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15885 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15890 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15894 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15898 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15902 */     // MIs[4] Operand 1
     /*  15902 */     // No operand predicates
     /*  15902 */     // MIs[2] Operand 2
     /*  15902 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15913 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15922 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15941 */     GIR_RootConstrainSelectedInstOperands,
     /*  15942 */     // GIR_Coverage, 13572,
     /*  15942 */     GIR_EraseRootFromParent_Done,
     /*  15943 */   // Label 302: @15943
     /*  15943 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(16061), // Rule ID 2094 //
     /*  15948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15995 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15999 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16003 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16008 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16012 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16016 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16020 */     // MIs[4] Operand 1
     /*  16020 */     // No operand predicates
     /*  16020 */     // MIs[2] Operand 2
     /*  16020 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16031 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16040 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16045 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16059 */     GIR_RootConstrainSelectedInstOperands,
     /*  16060 */     // GIR_Coverage, 2094,
     /*  16060 */     GIR_EraseRootFromParent_Done,
     /*  16061 */   // Label 303: @16061
     /*  16061 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(16179), // Rule ID 13602 //
     /*  16066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16113 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16117 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16121 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16126 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16130 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16134 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16138 */     // MIs[4] Operand 1
     /*  16138 */     // No operand predicates
     /*  16138 */     // MIs[2] Operand 2
     /*  16138 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16149 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16158 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16177 */     GIR_RootConstrainSelectedInstOperands,
     /*  16178 */     // GIR_Coverage, 13602,
     /*  16178 */     GIR_EraseRootFromParent_Done,
     /*  16179 */   // Label 304: @16179
     /*  16179 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(16266), // Rule ID 13478 //
     /*  16184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16211 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16214 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16223 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16247 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16264 */     GIR_RootConstrainSelectedInstOperands,
     /*  16265 */     // GIR_Coverage, 13478,
     /*  16265 */     GIR_EraseRootFromParent_Done,
     /*  16266 */   // Label 305: @16266
     /*  16266 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(16353), // Rule ID 13502 //
     /*  16271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16298 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16301 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16310 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16327 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16334 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16351 */     GIR_RootConstrainSelectedInstOperands,
     /*  16352 */     // GIR_Coverage, 13502,
     /*  16352 */     GIR_EraseRootFromParent_Done,
     /*  16353 */   // Label 306: @16353
     /*  16353 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(16440), // Rule ID 1699 //
     /*  16358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16389 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16392 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16401 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16421 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16438 */     GIR_RootConstrainSelectedInstOperands,
     /*  16439 */     // GIR_Coverage, 1699,
     /*  16439 */     GIR_EraseRootFromParent_Done,
     /*  16440 */   // Label 307: @16440
     /*  16440 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16527), // Rule ID 1777 //
     /*  16445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16476 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16479 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16488 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16508 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16525 */     GIR_RootConstrainSelectedInstOperands,
     /*  16526 */     // GIR_Coverage, 1777,
     /*  16526 */     GIR_EraseRootFromParent_Done,
     /*  16527 */   // Label 308: @16527
     /*  16527 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16642), // Rule ID 13568 //
     /*  16532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16575 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16579 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16583 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16592 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16596 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16600 */     // MIs[4] Operand 1
     /*  16600 */     // No operand predicates
     /*  16600 */     // MIs[2] Operand 2
     /*  16600 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16620 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16622 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16640 */     GIR_RootConstrainSelectedInstOperands,
     /*  16641 */     // GIR_Coverage, 13568,
     /*  16641 */     GIR_EraseRootFromParent_Done,
     /*  16642 */   // Label 309: @16642
     /*  16642 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16757), // Rule ID 13567 //
     /*  16647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16695 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16699 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16703 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16712 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16716 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16720 */     // MIs[4] Operand 1
     /*  16720 */     // No operand predicates
     /*  16720 */     // MIs[2] Operand 2
     /*  16720 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16735 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16737 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16755 */     GIR_RootConstrainSelectedInstOperands,
     /*  16756 */     // GIR_Coverage, 13567,
     /*  16756 */     GIR_EraseRootFromParent_Done,
     /*  16757 */   // Label 310: @16757
     /*  16757 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16872), // Rule ID 13598 //
     /*  16762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16805 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16809 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16813 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16818 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16822 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16826 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16830 */     // MIs[4] Operand 1
     /*  16830 */     // No operand predicates
     /*  16830 */     // MIs[2] Operand 2
     /*  16830 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16850 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16852 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16870 */     GIR_RootConstrainSelectedInstOperands,
     /*  16871 */     // GIR_Coverage, 13598,
     /*  16871 */     GIR_EraseRootFromParent_Done,
     /*  16872 */   // Label 311: @16872
     /*  16872 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16987), // Rule ID 13597 //
     /*  16877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16925 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16929 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16933 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16942 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16946 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16950 */     // MIs[4] Operand 1
     /*  16950 */     // No operand predicates
     /*  16950 */     // MIs[2] Operand 2
     /*  16950 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16965 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16967 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16985 */     GIR_RootConstrainSelectedInstOperands,
     /*  16986 */     // GIR_Coverage, 13597,
     /*  16986 */     GIR_EraseRootFromParent_Done,
     /*  16987 */   // Label 312: @16987
     /*  16987 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(17056), // Rule ID 1801 //
     /*  16992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17039 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17054 */     GIR_RootConstrainSelectedInstOperands,
     /*  17055 */     // GIR_Coverage, 1801,
     /*  17055 */     GIR_EraseRootFromParent_Done,
     /*  17056 */   // Label 313: @17056
     /*  17056 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(17125), // Rule ID 1800 //
     /*  17061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17108 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17123 */     GIR_RootConstrainSelectedInstOperands,
     /*  17124 */     // GIR_Coverage, 1800,
     /*  17124 */     GIR_EraseRootFromParent_Done,
     /*  17125 */   // Label 314: @17125
     /*  17125 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(17194), // Rule ID 1717 //
     /*  17130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17170 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17177 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17192 */     GIR_RootConstrainSelectedInstOperands,
     /*  17193 */     // GIR_Coverage, 1717,
     /*  17193 */     GIR_EraseRootFromParent_Done,
     /*  17194 */   // Label 315: @17194
     /*  17194 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(17263), // Rule ID 1799 //
     /*  17199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17246 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17261 */     GIR_RootConstrainSelectedInstOperands,
     /*  17262 */     // GIR_Coverage, 1799,
     /*  17262 */     GIR_EraseRootFromParent_Done,
     /*  17263 */   // Label 316: @17263
     /*  17263 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(17332), // Rule ID 1798 //
     /*  17268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17315 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17330 */     GIR_RootConstrainSelectedInstOperands,
     /*  17331 */     // GIR_Coverage, 1798,
     /*  17331 */     GIR_EraseRootFromParent_Done,
     /*  17332 */   // Label 317: @17332
     /*  17332 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17447), // Rule ID 13566 //
     /*  17337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17384 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17388 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17392 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17397 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17401 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17405 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17409 */     // MIs[4] Operand 1
     /*  17409 */     // No operand predicates
     /*  17409 */     // MIs[2] Operand 2
     /*  17409 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17425 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17427 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17445 */     GIR_RootConstrainSelectedInstOperands,
     /*  17446 */     // GIR_Coverage, 13566,
     /*  17446 */     GIR_EraseRootFromParent_Done,
     /*  17447 */   // Label 318: @17447
     /*  17447 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17562), // Rule ID 2040 //
     /*  17452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17504 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17508 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17512 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17517 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17521 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17525 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17529 */     // MIs[4] Operand 1
     /*  17529 */     // No operand predicates
     /*  17529 */     // MIs[2] Operand 2
     /*  17529 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17540 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17542 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17560 */     GIR_RootConstrainSelectedInstOperands,
     /*  17561 */     // GIR_Coverage, 2040,
     /*  17561 */     GIR_EraseRootFromParent_Done,
     /*  17562 */   // Label 319: @17562
     /*  17562 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17677), // Rule ID 13596 //
     /*  17567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17614 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17618 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17622 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17627 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17631 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17635 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17639 */     // MIs[4] Operand 1
     /*  17639 */     // No operand predicates
     /*  17639 */     // MIs[2] Operand 2
     /*  17639 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17655 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17657 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17675 */     GIR_RootConstrainSelectedInstOperands,
     /*  17676 */     // GIR_Coverage, 13596,
     /*  17676 */     GIR_EraseRootFromParent_Done,
     /*  17677 */   // Label 320: @17677
     /*  17677 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17792), // Rule ID 2092 //
     /*  17682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17734 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17738 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17742 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17747 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17751 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17755 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17759 */     // MIs[4] Operand 1
     /*  17759 */     // No operand predicates
     /*  17759 */     // MIs[2] Operand 2
     /*  17759 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17772 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17790 */     GIR_RootConstrainSelectedInstOperands,
     /*  17791 */     // GIR_Coverage, 2092,
     /*  17791 */     GIR_EraseRootFromParent_Done,
     /*  17792 */   // Label 321: @17792
     /*  17792 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17859), // Rule ID 13490 //
     /*  17797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17840 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17857 */     GIR_RootConstrainSelectedInstOperands,
     /*  17858 */     // GIR_Coverage, 13490,
     /*  17858 */     GIR_EraseRootFromParent_Done,
     /*  17859 */   // Label 322: @17859
     /*  17859 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17926), // Rule ID 13520 //
     /*  17864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17907 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  17910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17924 */     GIR_RootConstrainSelectedInstOperands,
     /*  17925 */     // GIR_Coverage, 13520,
     /*  17925 */     GIR_EraseRootFromParent_Done,
     /*  17926 */   // Label 323: @17926
     /*  17926 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17993), // Rule ID 1729 //
     /*  17931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17974 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17991 */     GIR_RootConstrainSelectedInstOperands,
     /*  17992 */     // GIR_Coverage, 1729,
     /*  17992 */     GIR_EraseRootFromParent_Done,
     /*  17993 */   // Label 324: @17993
     /*  17993 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(18060), // Rule ID 1819 //
     /*  17998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18041 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18058 */     GIR_RootConstrainSelectedInstOperands,
     /*  18059 */     // GIR_Coverage, 1819,
     /*  18059 */     GIR_EraseRootFromParent_Done,
     /*  18060 */   // Label 325: @18060
     /*  18060 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(18141), // Rule ID 13476 //
     /*  18065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18092 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18095 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18104 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18124 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18139 */     GIR_RootConstrainSelectedInstOperands,
     /*  18140 */     // GIR_Coverage, 13476,
     /*  18140 */     GIR_EraseRootFromParent_Done,
     /*  18141 */   // Label 326: @18141
     /*  18141 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(18222), // Rule ID 13500 //
     /*  18146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18173 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18176 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18185 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18205 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18220 */     GIR_RootConstrainSelectedInstOperands,
     /*  18221 */     // GIR_Coverage, 13500,
     /*  18221 */     GIR_EraseRootFromParent_Done,
     /*  18222 */   // Label 327: @18222
     /*  18222 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18303), // Rule ID 1697 //
     /*  18227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18258 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18261 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18270 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18286 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18301 */     GIR_RootConstrainSelectedInstOperands,
     /*  18302 */     // GIR_Coverage, 1697,
     /*  18302 */     GIR_EraseRootFromParent_Done,
     /*  18303 */   // Label 328: @18303
     /*  18303 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18384), // Rule ID 1775 //
     /*  18308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18339 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18342 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18351 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18367 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18382 */     GIR_RootConstrainSelectedInstOperands,
     /*  18383 */     // GIR_Coverage, 1775,
     /*  18383 */     GIR_EraseRootFromParent_Done,
     /*  18384 */   // Label 329: @18384
     /*  18384 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18476), // Rule ID 13571 //
     /*  18389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18441 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18445 */     // MIs[3] Operand 1
     /*  18445 */     // No operand predicates
     /*  18445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18456 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18474 */     GIR_RootConstrainSelectedInstOperands,
     /*  18475 */     // GIR_Coverage, 13571,
     /*  18475 */     GIR_EraseRootFromParent_Done,
     /*  18476 */   // Label 330: @18476
     /*  18476 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18568), // Rule ID 13570 //
     /*  18481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18538 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18542 */     // MIs[3] Operand 1
     /*  18542 */     // No operand predicates
     /*  18542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18548 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18566 */     GIR_RootConstrainSelectedInstOperands,
     /*  18567 */     // GIR_Coverage, 13570,
     /*  18567 */     GIR_EraseRootFromParent_Done,
     /*  18568 */   // Label 331: @18568
     /*  18568 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18660), // Rule ID 13601 //
     /*  18573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18625 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18629 */     // MIs[3] Operand 1
     /*  18629 */     // No operand predicates
     /*  18629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18640 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18658 */     GIR_RootConstrainSelectedInstOperands,
     /*  18659 */     // GIR_Coverage, 13601,
     /*  18659 */     GIR_EraseRootFromParent_Done,
     /*  18660 */   // Label 332: @18660
     /*  18660 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18752), // Rule ID 13600 //
     /*  18665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18722 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18726 */     // MIs[3] Operand 1
     /*  18726 */     // No operand predicates
     /*  18726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18732 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18750 */     GIR_RootConstrainSelectedInstOperands,
     /*  18751 */     // GIR_Coverage, 13600,
     /*  18751 */     GIR_EraseRootFromParent_Done,
     /*  18752 */   // Label 333: @18752
     /*  18752 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18844), // Rule ID 13569 //
     /*  18757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18813 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18817 */     // MIs[3] Operand 1
     /*  18817 */     // No operand predicates
     /*  18817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18824 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18842 */     GIR_RootConstrainSelectedInstOperands,
     /*  18843 */     // GIR_Coverage, 13569,
     /*  18843 */     GIR_EraseRootFromParent_Done,
     /*  18844 */   // Label 334: @18844
     /*  18844 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18936), // Rule ID 2041 //
     /*  18849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18910 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18914 */     // MIs[3] Operand 1
     /*  18914 */     // No operand predicates
     /*  18914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18916 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18934 */     GIR_RootConstrainSelectedInstOperands,
     /*  18935 */     // GIR_Coverage, 2041,
     /*  18935 */     GIR_EraseRootFromParent_Done,
     /*  18936 */   // Label 335: @18936
     /*  18936 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(19028), // Rule ID 13599 //
     /*  18941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18997 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19001 */     // MIs[3] Operand 1
     /*  19001 */     // No operand predicates
     /*  19001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19008 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19026 */     GIR_RootConstrainSelectedInstOperands,
     /*  19027 */     // GIR_Coverage, 13599,
     /*  19027 */     GIR_EraseRootFromParent_Done,
     /*  19028 */   // Label 336: @19028
     /*  19028 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(19120), // Rule ID 2093 //
     /*  19033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19094 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19098 */     // MIs[3] Operand 1
     /*  19098 */     // No operand predicates
     /*  19098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19100 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19118 */     GIR_RootConstrainSelectedInstOperands,
     /*  19119 */     // GIR_Coverage, 2093,
     /*  19119 */     GIR_EraseRootFromParent_Done,
     /*  19120 */   // Label 337: @19120
     /*  19120 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(19171), // Rule ID 13514 //
     /*  19125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19157 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19169 */     GIR_RootConstrainSelectedInstOperands,
     /*  19170 */     // GIR_Coverage, 13514,
     /*  19170 */     GIR_EraseRootFromParent_Done,
     /*  19171 */   // Label 338: @19171
     /*  19171 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(19222), // Rule ID 13484 //
     /*  19176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19208 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19220 */     GIR_RootConstrainSelectedInstOperands,
     /*  19221 */     // GIR_Coverage, 13484,
     /*  19221 */     GIR_EraseRootFromParent_Done,
     /*  19222 */   // Label 339: @19222
     /*  19222 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19273), // Rule ID 13513 //
     /*  19227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19259 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19271 */     GIR_RootConstrainSelectedInstOperands,
     /*  19272 */     // GIR_Coverage, 13513,
     /*  19272 */     GIR_EraseRootFromParent_Done,
     /*  19273 */   // Label 340: @19273
     /*  19273 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19324), // Rule ID 1813 //
     /*  19278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19310 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19322 */     GIR_RootConstrainSelectedInstOperands,
     /*  19323 */     // GIR_Coverage, 1813,
     /*  19323 */     GIR_EraseRootFromParent_Done,
     /*  19324 */   // Label 341: @19324
     /*  19324 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19375), // Rule ID 1723 //
     /*  19329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19361 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19373 */     GIR_RootConstrainSelectedInstOperands,
     /*  19374 */     // GIR_Coverage, 1723,
     /*  19374 */     GIR_EraseRootFromParent_Done,
     /*  19375 */   // Label 342: @19375
     /*  19375 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19426), // Rule ID 1812 //
     /*  19380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19412 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19424 */     GIR_RootConstrainSelectedInstOperands,
     /*  19425 */     // GIR_Coverage, 1812,
     /*  19425 */     GIR_EraseRootFromParent_Done,
     /*  19426 */   // Label 343: @19426
     /*  19426 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19482), // Rule ID 13402 //
     /*  19431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19446 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19449 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19469 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 661:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19480 */     GIR_RootConstrainSelectedInstOperands,
     /*  19481 */     // GIR_Coverage, 13402,
     /*  19481 */     GIR_EraseRootFromParent_Done,
     /*  19482 */   // Label 344: @19482
     /*  19482 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19538), // Rule ID 13414 //
     /*  19487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19502 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19505 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19525 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 726:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19536 */     GIR_RootConstrainSelectedInstOperands,
     /*  19537 */     // GIR_Coverage, 13414,
     /*  19537 */     GIR_EraseRootFromParent_Done,
     /*  19538 */   // Label 345: @19538
     /*  19538 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19605), // Rule ID 13642 //
     /*  19543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19567 */     // MIs[1] imm
     /*  19567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19575 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19579 */     // MIs[2] Operand 1
     /*  19579 */     // No operand predicates
     /*  19579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19589 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19603 */     GIR_RootConstrainSelectedInstOperands,
     /*  19604 */     // GIR_Coverage, 13642,
     /*  19604 */     GIR_EraseRootFromParent_Done,
     /*  19605 */   // Label 346: @19605
     /*  19605 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19672), // Rule ID 13663 //
     /*  19610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19634 */     // MIs[1] imm
     /*  19634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19642 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19646 */     // MIs[2] Operand 1
     /*  19646 */     // No operand predicates
     /*  19646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19656 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19670 */     GIR_RootConstrainSelectedInstOperands,
     /*  19671 */     // GIR_Coverage, 13663,
     /*  19671 */     GIR_EraseRootFromParent_Done,
     /*  19672 */   // Label 347: @19672
     /*  19672 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19728), // Rule ID 999 //
     /*  19677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19696 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19699 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19715 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 661:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19726 */     GIR_RootConstrainSelectedInstOperands,
     /*  19727 */     // GIR_Coverage, 999,
     /*  19727 */     GIR_EraseRootFromParent_Done,
     /*  19728 */   // Label 348: @19728
     /*  19728 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(19784), // Rule ID 1060 //
     /*  19733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19752 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19755 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19771 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 726:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19782 */     GIR_RootConstrainSelectedInstOperands,
     /*  19783 */     // GIR_Coverage, 1060,
     /*  19783 */     GIR_EraseRootFromParent_Done,
     /*  19784 */   // Label 349: @19784
     /*  19784 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(19851), // Rule ID 2242 //
     /*  19789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19817 */     // MIs[1] imm
     /*  19817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19825 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19829 */     // MIs[2] Operand 1
     /*  19829 */     // No operand predicates
     /*  19829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19835 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19849 */     GIR_RootConstrainSelectedInstOperands,
     /*  19850 */     // GIR_Coverage, 2242,
     /*  19850 */     GIR_EraseRootFromParent_Done,
     /*  19851 */   // Label 350: @19851
     /*  19851 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(19918), // Rule ID 2301 //
     /*  19856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19884 */     // MIs[1] imm
     /*  19884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19892 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19896 */     // MIs[2] Operand 1
     /*  19896 */     // No operand predicates
     /*  19896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19902 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19916 */     GIR_RootConstrainSelectedInstOperands,
     /*  19917 */     // GIR_Coverage, 2301,
     /*  19917 */     GIR_EraseRootFromParent_Done,
     /*  19918 */   // Label 351: @19918
     /*  19918 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(19988), // Rule ID 6984 //
     /*  19923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  19935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  19957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19961 */     // MIs[2] Rn
     /*  19961 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19966 */     // MIs[2] Rm
     /*  19966 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  19971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19973 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  19973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  19976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19986 */     GIR_RootConstrainSelectedInstOperands,
     /*  19987 */     // GIR_Coverage, 6984,
     /*  19987 */     GIR_EraseRootFromParent_Done,
     /*  19988 */   // Label 352: @19988
     /*  19988 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(20058), // Rule ID 14021 //
     /*  19993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20031 */     // MIs[2] Rn
     /*  20031 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20036 */     // MIs[2] Rm
     /*  20036 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20043 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20056 */     GIR_RootConstrainSelectedInstOperands,
     /*  20057 */     // GIR_Coverage, 14021,
     /*  20057 */     GIR_EraseRootFromParent_Done,
     /*  20058 */   // Label 353: @20058
     /*  20058 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(20121), // Rule ID 1797 //
     /*  20063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20106 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20119 */     GIR_RootConstrainSelectedInstOperands,
     /*  20120 */     // GIR_Coverage, 1797,
     /*  20120 */     GIR_EraseRootFromParent_Done,
     /*  20121 */   // Label 354: @20121
     /*  20121 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(20184), // Rule ID 1796 //
     /*  20126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20169 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20182 */     GIR_RootConstrainSelectedInstOperands,
     /*  20183 */     // GIR_Coverage, 1796,
     /*  20183 */     GIR_EraseRootFromParent_Done,
     /*  20184 */   // Label 355: @20184
     /*  20184 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(20247), // Rule ID 1716 //
     /*  20189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20232 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20245 */     GIR_RootConstrainSelectedInstOperands,
     /*  20246 */     // GIR_Coverage, 1716,
     /*  20246 */     GIR_EraseRootFromParent_Done,
     /*  20247 */   // Label 356: @20247
     /*  20247 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20310), // Rule ID 1795 //
     /*  20252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20295 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20308 */     GIR_RootConstrainSelectedInstOperands,
     /*  20309 */     // GIR_Coverage, 1795,
     /*  20309 */     GIR_EraseRootFromParent_Done,
     /*  20310 */   // Label 357: @20310
     /*  20310 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20373), // Rule ID 1794 //
     /*  20315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20358 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20371 */     GIR_RootConstrainSelectedInstOperands,
     /*  20372 */     // GIR_Coverage, 1794,
     /*  20372 */     GIR_EraseRootFromParent_Done,
     /*  20373 */   // Label 358: @20373
     /*  20373 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20434), // Rule ID 13489 //
     /*  20378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20417 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20432 */     GIR_RootConstrainSelectedInstOperands,
     /*  20433 */     // GIR_Coverage, 13489,
     /*  20433 */     GIR_EraseRootFromParent_Done,
     /*  20434 */   // Label 359: @20434
     /*  20434 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20495), // Rule ID 13519 //
     /*  20439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20478 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20493 */     GIR_RootConstrainSelectedInstOperands,
     /*  20494 */     // GIR_Coverage, 13519,
     /*  20494 */     GIR_EraseRootFromParent_Done,
     /*  20495 */   // Label 360: @20495
     /*  20495 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20543), // Rule ID 13512 //
     /*  20500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20530 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20541 */     GIR_RootConstrainSelectedInstOperands,
     /*  20542 */     // GIR_Coverage, 13512,
     /*  20542 */     GIR_EraseRootFromParent_Done,
     /*  20543 */   // Label 361: @20543
     /*  20543 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20591), // Rule ID 13401 //
     /*  20548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20578 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20589 */     GIR_RootConstrainSelectedInstOperands,
     /*  20590 */     // GIR_Coverage, 13401,
     /*  20590 */     GIR_EraseRootFromParent_Done,
     /*  20591 */   // Label 362: @20591
     /*  20591 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20639), // Rule ID 13483 //
     /*  20596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20626 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20637 */     GIR_RootConstrainSelectedInstOperands,
     /*  20638 */     // GIR_Coverage, 13483,
     /*  20638 */     GIR_EraseRootFromParent_Done,
     /*  20639 */   // Label 363: @20639
     /*  20639 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20687), // Rule ID 13413 //
     /*  20644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  20659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20674 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20685 */     GIR_RootConstrainSelectedInstOperands,
     /*  20686 */     // GIR_Coverage, 13413,
     /*  20686 */     GIR_EraseRootFromParent_Done,
     /*  20687 */   // Label 364: @20687
     /*  20687 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(20735), // Rule ID 13511 //
     /*  20692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20722 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20733 */     GIR_RootConstrainSelectedInstOperands,
     /*  20734 */     // GIR_Coverage, 13511,
     /*  20734 */     GIR_EraseRootFromParent_Done,
     /*  20735 */   // Label 365: @20735
     /*  20735 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(20796), // Rule ID 1728 //
     /*  20740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20779 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20794 */     GIR_RootConstrainSelectedInstOperands,
     /*  20795 */     // GIR_Coverage, 1728,
     /*  20795 */     GIR_EraseRootFromParent_Done,
     /*  20796 */   // Label 366: @20796
     /*  20796 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20857), // Rule ID 1818 //
     /*  20801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20840 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20855 */     GIR_RootConstrainSelectedInstOperands,
     /*  20856 */     // GIR_Coverage, 1818,
     /*  20856 */     GIR_EraseRootFromParent_Done,
     /*  20857 */   // Label 367: @20857
     /*  20857 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20905), // Rule ID 1811 //
     /*  20862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20892 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20903 */     GIR_RootConstrainSelectedInstOperands,
     /*  20904 */     // GIR_Coverage, 1811,
     /*  20904 */     GIR_EraseRootFromParent_Done,
     /*  20905 */   // Label 368: @20905
     /*  20905 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20953), // Rule ID 998 //
     /*  20910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20940 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20951 */     GIR_RootConstrainSelectedInstOperands,
     /*  20952 */     // GIR_Coverage, 998,
     /*  20952 */     GIR_EraseRootFromParent_Done,
     /*  20953 */   // Label 369: @20953
     /*  20953 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(21001), // Rule ID 1722 //
     /*  20958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20988 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20999 */     GIR_RootConstrainSelectedInstOperands,
     /*  21000 */     // GIR_Coverage, 1722,
     /*  21000 */     GIR_EraseRootFromParent_Done,
     /*  21001 */   // Label 370: @21001
     /*  21001 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(21049), // Rule ID 1059 //
     /*  21006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21036 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21047 */     GIR_RootConstrainSelectedInstOperands,
     /*  21048 */     // GIR_Coverage, 1059,
     /*  21048 */     GIR_EraseRootFromParent_Done,
     /*  21049 */   // Label 371: @21049
     /*  21049 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(21097), // Rule ID 1810 //
     /*  21054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21084 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21095 */     GIR_RootConstrainSelectedInstOperands,
     /*  21096 */     // GIR_Coverage, 1810,
     /*  21096 */     GIR_EraseRootFromParent_Done,
     /*  21097 */   // Label 372: @21097
     /*  21097 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21124), // Rule ID 1106 //
     /*  21102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21117 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21122 */     GIR_RootConstrainSelectedInstOperands,
     /*  21123 */     // GIR_Coverage, 1106,
     /*  21123 */     GIR_Done,
     /*  21124 */   // Label 373: @21124
     /*  21124 */   GIM_Reject,
     /*  21125 */ // Label 296: @21125
     /*  21125 */ GIM_Reject,
     /*  21126 */ // Label 159: @21126
     /*  21126 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(24623),
     /*  21131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21137 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21273), // Rule ID 5405 //
     /*  21142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21175 */     // MIs[1] Operand 2
     /*  21175 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21198 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21202 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21206 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21210 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21215 */     // MIs[3] Operand 2
     /*  21215 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21226 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21228 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21244 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21272 */     // GIR_Coverage, 5405,
     /*  21272 */     GIR_EraseRootFromParent_Done,
     /*  21273 */   // Label 375: @21273
     /*  21273 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21409), // Rule ID 5404 //
     /*  21278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21311 */     // MIs[1] Operand 2
     /*  21311 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21334 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21338 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21342 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21346 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21351 */     // MIs[3] Operand 2
     /*  21351 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21362 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21364 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21408 */     // GIR_Coverage, 5404,
     /*  21408 */     GIR_EraseRootFromParent_Done,
     /*  21409 */   // Label 376: @21409
     /*  21409 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21545), // Rule ID 5420 //
     /*  21414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21447 */     // MIs[1] Operand 2
     /*  21447 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21466 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21470 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21474 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21478 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21482 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21487 */     // MIs[3] Operand 2
     /*  21487 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21498 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21500 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  21507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21527 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21544 */     // GIR_Coverage, 5420,
     /*  21544 */     GIR_EraseRootFromParent_Done,
     /*  21545 */   // Label 377: @21545
     /*  21545 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21681), // Rule ID 5403 //
     /*  21550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21583 */     // MIs[1] Operand 2
     /*  21583 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21606 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21610 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21614 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21618 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21623 */     // MIs[3] Operand 2
     /*  21623 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21634 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21636 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21663 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21675 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21680 */     // GIR_Coverage, 5403,
     /*  21680 */     GIR_EraseRootFromParent_Done,
     /*  21681 */   // Label 378: @21681
     /*  21681 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21817), // Rule ID 5402 //
     /*  21686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21719 */     // MIs[1] Operand 2
     /*  21719 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21738 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21742 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21746 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21750 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21754 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21759 */     // MIs[3] Operand 2
     /*  21759 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21772 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21784 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21788 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21799 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21816 */     // GIR_Coverage, 5402,
     /*  21816 */     GIR_EraseRootFromParent_Done,
     /*  21817 */   // Label 379: @21817
     /*  21817 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21950), // Rule ID 14026 //
     /*  21822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  21846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  21867 */     // MIs[1] Operand 2
     /*  21867 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21878 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  21882 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21886 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21890 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  21894 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21898 */     // MIs[5] Rn
     /*  21898 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21903 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  21905 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  21905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  21908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  21912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21932 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21949 */     // GIR_Coverage, 14026,
     /*  21949 */     GIR_EraseRootFromParent_Done,
     /*  21950 */   // Label 380: @21950
     /*  21950 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(22083), // Rule ID 6989 //
     /*  21955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22000 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22004 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  22008 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22012 */     // MIs[4] Rn
     /*  22012 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22017 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22021 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22025 */     // MIs[3] Operand 2
     /*  22025 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22036 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22038 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22065 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22082 */     // GIR_Coverage, 6989,
     /*  22082 */     GIR_EraseRootFromParent_Done,
     /*  22083 */   // Label 381: @22083
     /*  22083 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(22246), // Rule ID 13984 //
     /*  22088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22130 */     // MIs[1] Operand 2
     /*  22130 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22147 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22147 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22150 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22154 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22161 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22164 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22168 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22173 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22176 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22180 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22183 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22210 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22228 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22245 */     // GIR_Coverage, 13984,
     /*  22245 */     GIR_EraseRootFromParent_Done,
     /*  22246 */   // Label 382: @22246
     /*  22246 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22409), // Rule ID 13981 //
     /*  22251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22293 */     // MIs[1] Operand 2
     /*  22293 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22310 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22310 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22313 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22317 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22324 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22327 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22331 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22336 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22339 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22343 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22408 */     // GIR_Coverage, 13981,
     /*  22408 */     GIR_EraseRootFromParent_Done,
     /*  22409 */   // Label 383: @22409
     /*  22409 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22559), // Rule ID 13988 //
     /*  22414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22447 */     // MIs[1] Operand 2
     /*  22447 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22464 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22464 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22467 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22471 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22490 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22493 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22497 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22558 */     // GIR_Coverage, 13988,
     /*  22558 */     GIR_EraseRootFromParent_Done,
     /*  22559 */   // Label 384: @22559
     /*  22559 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22709), // Rule ID 13993 //
     /*  22564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22597 */     // MIs[1] Operand 2
     /*  22597 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22614 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22614 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22617 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22621 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22628 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22631 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22635 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22640 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22647 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22655 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  22672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22677 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22691 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22708 */     // GIR_Coverage, 13993,
     /*  22708 */     GIR_EraseRootFromParent_Done,
     /*  22709 */   // Label 385: @22709
     /*  22709 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22859), // Rule ID 13987 //
     /*  22714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22747 */     // MIs[1] Operand 2
     /*  22747 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22764 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22764 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22767 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22771 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22778 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22781 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22785 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22790 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22793 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22797 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22810 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22827 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22841 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22858 */     // GIR_Coverage, 13987,
     /*  22858 */     GIR_EraseRootFromParent_Done,
     /*  22859 */   // Label 386: @22859
     /*  22859 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(23022), // Rule ID 5393 //
     /*  22864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22910 */     // MIs[1] Operand 2
     /*  22910 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22923 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22923 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22926 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22930 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22937 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22940 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22944 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22949 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22952 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  22956 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22964 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22969 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22986 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23004 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23021 */     // GIR_Coverage, 5393,
     /*  23021 */     GIR_EraseRootFromParent_Done,
     /*  23022 */   // Label 387: @23022
     /*  23022 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(23185), // Rule ID 5390 //
     /*  23027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23073 */     // MIs[1] Operand 2
     /*  23073 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23086 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23086 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23089 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23093 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23100 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23103 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23107 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23112 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23119 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23127 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23132 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23149 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23152 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23167 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23184 */     // GIR_Coverage, 5390,
     /*  23184 */     GIR_EraseRootFromParent_Done,
     /*  23185 */   // Label 388: @23185
     /*  23185 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(23335), // Rule ID 5415 //
     /*  23190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23227 */     // MIs[1] Operand 2
     /*  23227 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23240 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23240 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23243 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23247 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23254 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23257 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23261 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23266 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23269 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23273 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23276 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23281 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23303 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23317 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23334 */     // GIR_Coverage, 5415,
     /*  23334 */     GIR_EraseRootFromParent_Done,
     /*  23335 */   // Label 389: @23335
     /*  23335 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23485), // Rule ID 5423 //
     /*  23340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23377 */     // MIs[1] Operand 2
     /*  23377 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23390 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23390 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23393 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23397 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23404 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23407 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23411 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23416 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23419 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23423 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23426 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23431 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23453 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23467 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23484 */     // GIR_Coverage, 5423,
     /*  23484 */     GIR_EraseRootFromParent_Done,
     /*  23485 */   // Label 390: @23485
     /*  23485 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23635), // Rule ID 5414 //
     /*  23490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23527 */     // MIs[1] Operand 2
     /*  23527 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23540 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23540 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23543 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23547 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23566 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23569 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23573 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23576 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23586 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23603 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23617 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23634 */     // GIR_Coverage, 5414,
     /*  23634 */     GIR_EraseRootFromParent_Done,
     /*  23635 */   // Label 391: @23635
     /*  23635 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23704), // Rule ID 13430 //
     /*  23640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23655 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23658 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23687 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  23690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23702 */     GIR_RootConstrainSelectedInstOperands,
     /*  23703 */     // GIR_Coverage, 13430,
     /*  23703 */     GIR_EraseRootFromParent_Done,
     /*  23704 */   // Label 392: @23704
     /*  23704 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23773), // Rule ID 13442 //
     /*  23709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23724 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23727 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23736 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23756 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  23759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23771 */     GIR_RootConstrainSelectedInstOperands,
     /*  23772 */     // GIR_Coverage, 13442,
     /*  23772 */     GIR_EraseRootFromParent_Done,
     /*  23773 */   // Label 393: @23773
     /*  23773 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23829), // Rule ID 13392 //
     /*  23778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23793 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23796 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  23801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23816 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 661:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  23819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23827 */     GIR_RootConstrainSelectedInstOperands,
     /*  23828 */     // GIR_Coverage, 13392,
     /*  23828 */     GIR_EraseRootFromParent_Done,
     /*  23829 */   // Label 394: @23829
     /*  23829 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23885), // Rule ID 13404 //
     /*  23834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23849 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23852 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  23857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23872 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 726:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  23875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23883 */     GIR_RootConstrainSelectedInstOperands,
     /*  23884 */     // GIR_Coverage, 13404,
     /*  23884 */     GIR_EraseRootFromParent_Done,
     /*  23885 */   // Label 395: @23885
     /*  23885 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23952), // Rule ID 13634 //
     /*  23890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  23905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23914 */     // MIs[1] imm
     /*  23914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23922 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23926 */     // MIs[2] Operand 1
     /*  23926 */     // No operand predicates
     /*  23926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23936 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  23939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  23947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  23950 */     GIR_RootConstrainSelectedInstOperands,
     /*  23951 */     // GIR_Coverage, 13634,
     /*  23951 */     GIR_EraseRootFromParent_Done,
     /*  23952 */   // Label 396: @23952
     /*  23952 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24019), // Rule ID 13655 //
     /*  23957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  23972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23981 */     // MIs[1] imm
     /*  23981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23993 */     // MIs[2] Operand 1
     /*  23993 */     // No operand predicates
     /*  23993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24003 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24017 */     GIR_RootConstrainSelectedInstOperands,
     /*  24018 */     // GIR_Coverage, 13655,
     /*  24018 */     GIR_EraseRootFromParent_Done,
     /*  24019 */   // Label 397: @24019
     /*  24019 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24088), // Rule ID 1361 //
     /*  24024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24043 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24046 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24055 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24071 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24086 */     GIR_RootConstrainSelectedInstOperands,
     /*  24087 */     // GIR_Coverage, 1361,
     /*  24087 */     GIR_EraseRootFromParent_Done,
     /*  24088 */   // Label 398: @24088
     /*  24088 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24157), // Rule ID 1484 //
     /*  24093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24112 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24115 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24140 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24155 */     GIR_RootConstrainSelectedInstOperands,
     /*  24156 */     // GIR_Coverage, 1484,
     /*  24156 */     GIR_EraseRootFromParent_Done,
     /*  24157 */   // Label 399: @24157
     /*  24157 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24213), // Rule ID 989 //
     /*  24162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24181 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24184 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24200 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 661:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24211 */     GIR_RootConstrainSelectedInstOperands,
     /*  24212 */     // GIR_Coverage, 989,
     /*  24212 */     GIR_EraseRootFromParent_Done,
     /*  24213 */   // Label 400: @24213
     /*  24213 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24269), // Rule ID 1050 //
     /*  24218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24237 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24240 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24256 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 726:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24267 */     GIR_RootConstrainSelectedInstOperands,
     /*  24268 */     // GIR_Coverage, 1050,
     /*  24268 */     GIR_EraseRootFromParent_Done,
     /*  24269 */   // Label 401: @24269
     /*  24269 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24336), // Rule ID 2234 //
     /*  24274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24302 */     // MIs[1] imm
     /*  24302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24310 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24314 */     // MIs[2] Operand 1
     /*  24314 */     // No operand predicates
     /*  24314 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24320 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24334 */     GIR_RootConstrainSelectedInstOperands,
     /*  24335 */     // GIR_Coverage, 2234,
     /*  24335 */     GIR_EraseRootFromParent_Done,
     /*  24336 */   // Label 402: @24336
     /*  24336 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24403), // Rule ID 2293 //
     /*  24341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24369 */     // MIs[1] imm
     /*  24369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24377 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24381 */     // MIs[2] Operand 1
     /*  24381 */     // No operand predicates
     /*  24381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24387 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24401 */     GIR_RootConstrainSelectedInstOperands,
     /*  24402 */     // GIR_Coverage, 2293,
     /*  24402 */     GIR_EraseRootFromParent_Done,
     /*  24403 */   // Label 403: @24403
     /*  24403 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24451), // Rule ID 13391 //
     /*  24408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24438 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24449 */     GIR_RootConstrainSelectedInstOperands,
     /*  24450 */     // GIR_Coverage, 13391,
     /*  24450 */     GIR_EraseRootFromParent_Done,
     /*  24451 */   // Label 404: @24451
     /*  24451 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24499), // Rule ID 13403 //
     /*  24456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24486 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24497 */     GIR_RootConstrainSelectedInstOperands,
     /*  24498 */     // GIR_Coverage, 13403,
     /*  24498 */     GIR_EraseRootFromParent_Done,
     /*  24499 */   // Label 405: @24499
     /*  24499 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24547), // Rule ID 988 //
     /*  24504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24534 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24545 */     GIR_RootConstrainSelectedInstOperands,
     /*  24546 */     // GIR_Coverage, 988,
     /*  24546 */     GIR_EraseRootFromParent_Done,
     /*  24547 */   // Label 406: @24547
     /*  24547 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24595), // Rule ID 1049 //
     /*  24552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24582 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24593 */     GIR_RootConstrainSelectedInstOperands,
     /*  24594 */     // GIR_Coverage, 1049,
     /*  24594 */     GIR_EraseRootFromParent_Done,
     /*  24595 */   // Label 407: @24595
     /*  24595 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24622), // Rule ID 1102 //
     /*  24600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24615 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  24620 */     GIR_RootConstrainSelectedInstOperands,
     /*  24621 */     // GIR_Coverage, 1102,
     /*  24621 */     GIR_Done,
     /*  24622 */   // Label 408: @24622
     /*  24622 */   GIM_Reject,
     /*  24623 */ // Label 374: @24623
     /*  24623 */ GIM_Reject,
     /*  24624 */ // Label 160: @24624
     /*  24624 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(30801),
     /*  24629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24635 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24753), // Rule ID 13564 //
     /*  24640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24687 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24691 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24696 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24700 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24704 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24708 */     // MIs[4] Operand 1
     /*  24708 */     // No operand predicates
     /*  24708 */     // MIs[2] Operand 2
     /*  24708 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24723 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24732 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24751 */     GIR_RootConstrainSelectedInstOperands,
     /*  24752 */     // GIR_Coverage, 13564,
     /*  24752 */     GIR_EraseRootFromParent_Done,
     /*  24753 */   // Label 410: @24753
     /*  24753 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24871), // Rule ID 13565 //
     /*  24758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24801 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24805 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24809 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24814 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24818 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24822 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24826 */     // MIs[4] Operand 1
     /*  24826 */     // No operand predicates
     /*  24826 */     // MIs[2] Operand 2
     /*  24826 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24841 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24850 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24869 */     GIR_RootConstrainSelectedInstOperands,
     /*  24870 */     // GIR_Coverage, 13565,
     /*  24870 */     GIR_EraseRootFromParent_Done,
     /*  24871 */   // Label 411: @24871
     /*  24871 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(24989), // Rule ID 13594 //
     /*  24876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24919 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24923 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24927 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24932 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24936 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24940 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24944 */     // MIs[4] Operand 1
     /*  24944 */     // No operand predicates
     /*  24944 */     // MIs[2] Operand 2
     /*  24944 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24959 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24968 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  24971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24987 */     GIR_RootConstrainSelectedInstOperands,
     /*  24988 */     // GIR_Coverage, 13594,
     /*  24988 */     GIR_EraseRootFromParent_Done,
     /*  24989 */   // Label 412: @24989
     /*  24989 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(25107), // Rule ID 13595 //
     /*  24994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25037 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25041 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25045 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25050 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25054 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25058 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25062 */     // MIs[4] Operand 1
     /*  25062 */     // No operand predicates
     /*  25062 */     // MIs[2] Operand 2
     /*  25062 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25077 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25086 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25105 */     GIR_RootConstrainSelectedInstOperands,
     /*  25106 */     // GIR_Coverage, 13595,
     /*  25106 */     GIR_EraseRootFromParent_Done,
     /*  25107 */   // Label 413: @25107
     /*  25107 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(25225), // Rule ID 2039 //
     /*  25112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25159 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25163 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25167 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25180 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25184 */     // MIs[4] Operand 1
     /*  25184 */     // No operand predicates
     /*  25184 */     // MIs[2] Operand 2
     /*  25184 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25195 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25204 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25223 */     GIR_RootConstrainSelectedInstOperands,
     /*  25224 */     // GIR_Coverage, 2039,
     /*  25224 */     GIR_EraseRootFromParent_Done,
     /*  25225 */   // Label 414: @25225
     /*  25225 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(25343), // Rule ID 13563 //
     /*  25230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25281 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25285 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25290 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25294 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25298 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25302 */     // MIs[4] Operand 1
     /*  25302 */     // No operand predicates
     /*  25302 */     // MIs[2] Operand 2
     /*  25302 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25313 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25322 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25341 */     GIR_RootConstrainSelectedInstOperands,
     /*  25342 */     // GIR_Coverage, 13563,
     /*  25342 */     GIR_EraseRootFromParent_Done,
     /*  25343 */   // Label 415: @25343
     /*  25343 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(25461), // Rule ID 2091 //
     /*  25348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25412 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25416 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25420 */     // MIs[4] Operand 1
     /*  25420 */     // No operand predicates
     /*  25420 */     // MIs[2] Operand 2
     /*  25420 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25431 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25440 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25459 */     GIR_RootConstrainSelectedInstOperands,
     /*  25460 */     // GIR_Coverage, 2091,
     /*  25460 */     GIR_EraseRootFromParent_Done,
     /*  25461 */   // Label 416: @25461
     /*  25461 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(25579), // Rule ID 13593 //
     /*  25466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25513 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25517 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25521 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25526 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25530 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25534 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25538 */     // MIs[4] Operand 1
     /*  25538 */     // No operand predicates
     /*  25538 */     // MIs[2] Operand 2
     /*  25538 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25549 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25558 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25577 */     GIR_RootConstrainSelectedInstOperands,
     /*  25578 */     // GIR_Coverage, 13593,
     /*  25578 */     GIR_EraseRootFromParent_Done,
     /*  25579 */   // Label 417: @25579
     /*  25579 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25666), // Rule ID 13474 //
     /*  25584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25611 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25614 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25623 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25647 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25664 */     GIR_RootConstrainSelectedInstOperands,
     /*  25665 */     // GIR_Coverage, 13474,
     /*  25665 */     GIR_EraseRootFromParent_Done,
     /*  25666 */   // Label 418: @25666
     /*  25666 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25753), // Rule ID 13498 //
     /*  25671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25698 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25701 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25710 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25734 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25751 */     GIR_RootConstrainSelectedInstOperands,
     /*  25752 */     // GIR_Coverage, 13498,
     /*  25752 */     GIR_EraseRootFromParent_Done,
     /*  25753 */   // Label 419: @25753
     /*  25753 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25840), // Rule ID 1695 //
     /*  25758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25789 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25792 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25801 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25821 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25838 */     GIR_RootConstrainSelectedInstOperands,
     /*  25839 */     // GIR_Coverage, 1695,
     /*  25839 */     GIR_EraseRootFromParent_Done,
     /*  25840 */   // Label 420: @25840
     /*  25840 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25927), // Rule ID 1773 //
     /*  25845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25876 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25879 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25888 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25908 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25925 */     GIR_RootConstrainSelectedInstOperands,
     /*  25926 */     // GIR_Coverage, 1773,
     /*  25926 */     GIR_EraseRootFromParent_Done,
     /*  25927 */   // Label 421: @25927
     /*  25927 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(26042), // Rule ID 13559 //
     /*  25932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25979 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25983 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25992 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25996 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26000 */     // MIs[4] Operand 1
     /*  26000 */     // No operand predicates
     /*  26000 */     // MIs[2] Operand 2
     /*  26000 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26022 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26040 */     GIR_RootConstrainSelectedInstOperands,
     /*  26041 */     // GIR_Coverage, 13559,
     /*  26041 */     GIR_EraseRootFromParent_Done,
     /*  26042 */   // Label 422: @26042
     /*  26042 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(26157), // Rule ID 13558 //
     /*  26047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26095 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26099 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26103 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26108 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26112 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26116 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26120 */     // MIs[4] Operand 1
     /*  26120 */     // No operand predicates
     /*  26120 */     // MIs[2] Operand 2
     /*  26120 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26135 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26137 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26155 */     GIR_RootConstrainSelectedInstOperands,
     /*  26156 */     // GIR_Coverage, 13558,
     /*  26156 */     GIR_EraseRootFromParent_Done,
     /*  26157 */   // Label 423: @26157
     /*  26157 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(26272), // Rule ID 13589 //
     /*  26162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26213 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26226 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26230 */     // MIs[4] Operand 1
     /*  26230 */     // No operand predicates
     /*  26230 */     // MIs[2] Operand 2
     /*  26230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26250 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26252 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26270 */     GIR_RootConstrainSelectedInstOperands,
     /*  26271 */     // GIR_Coverage, 13589,
     /*  26271 */     GIR_EraseRootFromParent_Done,
     /*  26272 */   // Label 424: @26272
     /*  26272 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(26387), // Rule ID 13588 //
     /*  26277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26325 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26329 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26333 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26338 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26342 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26346 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26350 */     // MIs[4] Operand 1
     /*  26350 */     // No operand predicates
     /*  26350 */     // MIs[2] Operand 2
     /*  26350 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26365 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26367 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26385 */     GIR_RootConstrainSelectedInstOperands,
     /*  26386 */     // GIR_Coverage, 13588,
     /*  26386 */     GIR_EraseRootFromParent_Done,
     /*  26387 */   // Label 425: @26387
     /*  26387 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(26456), // Rule ID 1793 //
     /*  26392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26439 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26454 */     GIR_RootConstrainSelectedInstOperands,
     /*  26455 */     // GIR_Coverage, 1793,
     /*  26455 */     GIR_EraseRootFromParent_Done,
     /*  26456 */   // Label 426: @26456
     /*  26456 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26525), // Rule ID 1792 //
     /*  26461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26508 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26523 */     GIR_RootConstrainSelectedInstOperands,
     /*  26524 */     // GIR_Coverage, 1792,
     /*  26524 */     GIR_EraseRootFromParent_Done,
     /*  26525 */   // Label 427: @26525
     /*  26525 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26594), // Rule ID 1715 //
     /*  26530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26577 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  26580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26592 */     GIR_RootConstrainSelectedInstOperands,
     /*  26593 */     // GIR_Coverage, 1715,
     /*  26593 */     GIR_EraseRootFromParent_Done,
     /*  26594 */   // Label 428: @26594
     /*  26594 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26663), // Rule ID 1791 //
     /*  26599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26646 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26661 */     GIR_RootConstrainSelectedInstOperands,
     /*  26662 */     // GIR_Coverage, 1791,
     /*  26662 */     GIR_EraseRootFromParent_Done,
     /*  26663 */   // Label 429: @26663
     /*  26663 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26732), // Rule ID 1790 //
     /*  26668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26715 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26730 */     GIR_RootConstrainSelectedInstOperands,
     /*  26731 */     // GIR_Coverage, 1790,
     /*  26731 */     GIR_EraseRootFromParent_Done,
     /*  26732 */   // Label 430: @26732
     /*  26732 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26847), // Rule ID 13557 //
     /*  26737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26788 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26792 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26797 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26801 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26805 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26809 */     // MIs[4] Operand 1
     /*  26809 */     // No operand predicates
     /*  26809 */     // MIs[2] Operand 2
     /*  26809 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26825 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26827 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26845 */     GIR_RootConstrainSelectedInstOperands,
     /*  26846 */     // GIR_Coverage, 13557,
     /*  26846 */     GIR_EraseRootFromParent_Done,
     /*  26847 */   // Label 431: @26847
     /*  26847 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26962), // Rule ID 2037 //
     /*  26852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26904 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26908 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26912 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26917 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26921 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26925 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26929 */     // MIs[4] Operand 1
     /*  26929 */     // No operand predicates
     /*  26929 */     // MIs[2] Operand 2
     /*  26929 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26940 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26942 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26960 */     GIR_RootConstrainSelectedInstOperands,
     /*  26961 */     // GIR_Coverage, 2037,
     /*  26961 */     GIR_EraseRootFromParent_Done,
     /*  26962 */   // Label 432: @26962
     /*  26962 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(27077), // Rule ID 13587 //
     /*  26967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27014 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27018 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27022 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27027 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27031 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27035 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27039 */     // MIs[4] Operand 1
     /*  27039 */     // No operand predicates
     /*  27039 */     // MIs[2] Operand 2
     /*  27039 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27055 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27057 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27075 */     GIR_RootConstrainSelectedInstOperands,
     /*  27076 */     // GIR_Coverage, 13587,
     /*  27076 */     GIR_EraseRootFromParent_Done,
     /*  27077 */   // Label 433: @27077
     /*  27077 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(27192), // Rule ID 2089 //
     /*  27082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27134 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27138 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27142 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27147 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27151 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27155 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27159 */     // MIs[4] Operand 1
     /*  27159 */     // No operand predicates
     /*  27159 */     // MIs[2] Operand 2
     /*  27159 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27170 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27172 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27190 */     GIR_RootConstrainSelectedInstOperands,
     /*  27191 */     // GIR_Coverage, 2089,
     /*  27191 */     GIR_EraseRootFromParent_Done,
     /*  27192 */   // Label 434: @27192
     /*  27192 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(27259), // Rule ID 13488 //
     /*  27197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27240 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27257 */     GIR_RootConstrainSelectedInstOperands,
     /*  27258 */     // GIR_Coverage, 13488,
     /*  27258 */     GIR_EraseRootFromParent_Done,
     /*  27259 */   // Label 435: @27259
     /*  27259 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(27326), // Rule ID 13518 //
     /*  27264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27307 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27324 */     GIR_RootConstrainSelectedInstOperands,
     /*  27325 */     // GIR_Coverage, 13518,
     /*  27325 */     GIR_EraseRootFromParent_Done,
     /*  27326 */   // Label 436: @27326
     /*  27326 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(27393), // Rule ID 1727 //
     /*  27331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27374 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27391 */     GIR_RootConstrainSelectedInstOperands,
     /*  27392 */     // GIR_Coverage, 1727,
     /*  27392 */     GIR_EraseRootFromParent_Done,
     /*  27393 */   // Label 437: @27393
     /*  27393 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27460), // Rule ID 1817 //
     /*  27398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27441 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27458 */     GIR_RootConstrainSelectedInstOperands,
     /*  27459 */     // GIR_Coverage, 1817,
     /*  27459 */     GIR_EraseRootFromParent_Done,
     /*  27460 */   // Label 438: @27460
     /*  27460 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27541), // Rule ID 13472 //
     /*  27465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27492 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27495 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27504 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27524 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27539 */     GIR_RootConstrainSelectedInstOperands,
     /*  27540 */     // GIR_Coverage, 13472,
     /*  27540 */     GIR_EraseRootFromParent_Done,
     /*  27541 */   // Label 439: @27541
     /*  27541 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27622), // Rule ID 13496 //
     /*  27546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27573 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27576 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27585 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27605 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27620 */     GIR_RootConstrainSelectedInstOperands,
     /*  27621 */     // GIR_Coverage, 13496,
     /*  27621 */     GIR_EraseRootFromParent_Done,
     /*  27622 */   // Label 440: @27622
     /*  27622 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27703), // Rule ID 1693 //
     /*  27627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27658 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27661 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27670 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27686 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27701 */     GIR_RootConstrainSelectedInstOperands,
     /*  27702 */     // GIR_Coverage, 1693,
     /*  27702 */     GIR_EraseRootFromParent_Done,
     /*  27703 */   // Label 441: @27703
     /*  27703 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27784), // Rule ID 1771 //
     /*  27708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27739 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27742 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27751 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27767 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27782 */     GIR_RootConstrainSelectedInstOperands,
     /*  27783 */     // GIR_Coverage, 1771,
     /*  27783 */     GIR_EraseRootFromParent_Done,
     /*  27784 */   // Label 442: @27784
     /*  27784 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27876), // Rule ID 13562 //
     /*  27789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27841 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27845 */     // MIs[3] Operand 1
     /*  27845 */     // No operand predicates
     /*  27845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27856 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27874 */     GIR_RootConstrainSelectedInstOperands,
     /*  27875 */     // GIR_Coverage, 13562,
     /*  27875 */     GIR_EraseRootFromParent_Done,
     /*  27876 */   // Label 443: @27876
     /*  27876 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(27968), // Rule ID 13561 //
     /*  27881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27938 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27942 */     // MIs[3] Operand 1
     /*  27942 */     // No operand predicates
     /*  27942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27948 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27966 */     GIR_RootConstrainSelectedInstOperands,
     /*  27967 */     // GIR_Coverage, 13561,
     /*  27967 */     GIR_EraseRootFromParent_Done,
     /*  27968 */   // Label 444: @27968
     /*  27968 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(28060), // Rule ID 13592 //
     /*  27973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28025 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28029 */     // MIs[3] Operand 1
     /*  28029 */     // No operand predicates
     /*  28029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28040 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28058 */     GIR_RootConstrainSelectedInstOperands,
     /*  28059 */     // GIR_Coverage, 13592,
     /*  28059 */     GIR_EraseRootFromParent_Done,
     /*  28060 */   // Label 445: @28060
     /*  28060 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(28152), // Rule ID 13591 //
     /*  28065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28122 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28126 */     // MIs[3] Operand 1
     /*  28126 */     // No operand predicates
     /*  28126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28132 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28150 */     GIR_RootConstrainSelectedInstOperands,
     /*  28151 */     // GIR_Coverage, 13591,
     /*  28151 */     GIR_EraseRootFromParent_Done,
     /*  28152 */   // Label 446: @28152
     /*  28152 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(28244), // Rule ID 13560 //
     /*  28157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28213 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28217 */     // MIs[3] Operand 1
     /*  28217 */     // No operand predicates
     /*  28217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28224 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28242 */     GIR_RootConstrainSelectedInstOperands,
     /*  28243 */     // GIR_Coverage, 13560,
     /*  28243 */     GIR_EraseRootFromParent_Done,
     /*  28244 */   // Label 447: @28244
     /*  28244 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(28336), // Rule ID 2038 //
     /*  28249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28310 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28314 */     // MIs[3] Operand 1
     /*  28314 */     // No operand predicates
     /*  28314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28316 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28334 */     GIR_RootConstrainSelectedInstOperands,
     /*  28335 */     // GIR_Coverage, 2038,
     /*  28335 */     GIR_EraseRootFromParent_Done,
     /*  28336 */   // Label 448: @28336
     /*  28336 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(28428), // Rule ID 13590 //
     /*  28341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28397 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28401 */     // MIs[3] Operand 1
     /*  28401 */     // No operand predicates
     /*  28401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28408 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28426 */     GIR_RootConstrainSelectedInstOperands,
     /*  28427 */     // GIR_Coverage, 13590,
     /*  28427 */     GIR_EraseRootFromParent_Done,
     /*  28428 */   // Label 449: @28428
     /*  28428 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28520), // Rule ID 2090 //
     /*  28433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28494 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28498 */     // MIs[3] Operand 1
     /*  28498 */     // No operand predicates
     /*  28498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28500 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28518 */     GIR_RootConstrainSelectedInstOperands,
     /*  28519 */     // GIR_Coverage, 2090,
     /*  28519 */     GIR_EraseRootFromParent_Done,
     /*  28520 */   // Label 450: @28520
     /*  28520 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28571), // Rule ID 13510 //
     /*  28525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28557 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28569 */     GIR_RootConstrainSelectedInstOperands,
     /*  28570 */     // GIR_Coverage, 13510,
     /*  28570 */     GIR_EraseRootFromParent_Done,
     /*  28571 */   // Label 451: @28571
     /*  28571 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28622), // Rule ID 13482 //
     /*  28576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28608 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28620 */     GIR_RootConstrainSelectedInstOperands,
     /*  28621 */     // GIR_Coverage, 13482,
     /*  28621 */     GIR_EraseRootFromParent_Done,
     /*  28622 */   // Label 452: @28622
     /*  28622 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28673), // Rule ID 13509 //
     /*  28627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28659 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28671 */     GIR_RootConstrainSelectedInstOperands,
     /*  28672 */     // GIR_Coverage, 13509,
     /*  28672 */     GIR_EraseRootFromParent_Done,
     /*  28673 */   // Label 453: @28673
     /*  28673 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28724), // Rule ID 1809 //
     /*  28678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28710 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28722 */     GIR_RootConstrainSelectedInstOperands,
     /*  28723 */     // GIR_Coverage, 1809,
     /*  28723 */     GIR_EraseRootFromParent_Done,
     /*  28724 */   // Label 454: @28724
     /*  28724 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(28775), // Rule ID 1721 //
     /*  28729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28761 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28773 */     GIR_RootConstrainSelectedInstOperands,
     /*  28774 */     // GIR_Coverage, 1721,
     /*  28774 */     GIR_EraseRootFromParent_Done,
     /*  28775 */   // Label 455: @28775
     /*  28775 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(28826), // Rule ID 1808 //
     /*  28780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28812 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28824 */     GIR_RootConstrainSelectedInstOperands,
     /*  28825 */     // GIR_Coverage, 1808,
     /*  28825 */     GIR_EraseRootFromParent_Done,
     /*  28826 */   // Label 456: @28826
     /*  28826 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(28895), // Rule ID 13436 //
     /*  28831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28846 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28849 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28858 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28878 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  28881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28893 */     GIR_RootConstrainSelectedInstOperands,
     /*  28894 */     // GIR_Coverage, 13436,
     /*  28894 */     GIR_EraseRootFromParent_Done,
     /*  28895 */   // Label 457: @28895
     /*  28895 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(28964), // Rule ID 13448 //
     /*  28900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28915 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28918 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28927 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28947 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  28950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28962 */     GIR_RootConstrainSelectedInstOperands,
     /*  28963 */     // GIR_Coverage, 13448,
     /*  28963 */     GIR_EraseRootFromParent_Done,
     /*  28964 */   // Label 458: @28964
     /*  28964 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(29020), // Rule ID 13398 //
     /*  28969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28984 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  28987 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  28992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  28996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29007 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 661:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29018 */     GIR_RootConstrainSelectedInstOperands,
     /*  29019 */     // GIR_Coverage, 13398,
     /*  29019 */     GIR_EraseRootFromParent_Done,
     /*  29020 */   // Label 459: @29020
     /*  29020 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(29076), // Rule ID 13410 //
     /*  29025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29040 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29043 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29063 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 726:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29074 */     GIR_RootConstrainSelectedInstOperands,
     /*  29075 */     // GIR_Coverage, 13410,
     /*  29075 */     GIR_EraseRootFromParent_Done,
     /*  29076 */   // Label 460: @29076
     /*  29076 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(29143), // Rule ID 13640 //
     /*  29081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29105 */     // MIs[1] imm
     /*  29105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29113 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29117 */     // MIs[2] Operand 1
     /*  29117 */     // No operand predicates
     /*  29117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29127 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29141 */     GIR_RootConstrainSelectedInstOperands,
     /*  29142 */     // GIR_Coverage, 13640,
     /*  29142 */     GIR_EraseRootFromParent_Done,
     /*  29143 */   // Label 461: @29143
     /*  29143 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(29210), // Rule ID 13661 //
     /*  29148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29172 */     // MIs[1] imm
     /*  29172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29180 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29184 */     // MIs[2] Operand 1
     /*  29184 */     // No operand predicates
     /*  29184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29194 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29208 */     GIR_RootConstrainSelectedInstOperands,
     /*  29209 */     // GIR_Coverage, 13661,
     /*  29209 */     GIR_EraseRootFromParent_Done,
     /*  29210 */   // Label 462: @29210
     /*  29210 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29279), // Rule ID 1367 //
     /*  29215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29234 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29237 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29246 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29262 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29277 */     GIR_RootConstrainSelectedInstOperands,
     /*  29278 */     // GIR_Coverage, 1367,
     /*  29278 */     GIR_EraseRootFromParent_Done,
     /*  29279 */   // Label 463: @29279
     /*  29279 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29348), // Rule ID 1490 //
     /*  29284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29303 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29306 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29315 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29331 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29346 */     GIR_RootConstrainSelectedInstOperands,
     /*  29347 */     // GIR_Coverage, 1490,
     /*  29347 */     GIR_EraseRootFromParent_Done,
     /*  29348 */   // Label 464: @29348
     /*  29348 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29404), // Rule ID 995 //
     /*  29353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29372 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29375 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29391 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 661:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29402 */     GIR_RootConstrainSelectedInstOperands,
     /*  29403 */     // GIR_Coverage, 995,
     /*  29403 */     GIR_EraseRootFromParent_Done,
     /*  29404 */   // Label 465: @29404
     /*  29404 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29460), // Rule ID 1056 //
     /*  29409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29428 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29431 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29447 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 726:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29458 */     GIR_RootConstrainSelectedInstOperands,
     /*  29459 */     // GIR_Coverage, 1056,
     /*  29459 */     GIR_EraseRootFromParent_Done,
     /*  29460 */   // Label 466: @29460
     /*  29460 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29527), // Rule ID 2240 //
     /*  29465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29493 */     // MIs[1] imm
     /*  29493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29501 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29505 */     // MIs[2] Operand 1
     /*  29505 */     // No operand predicates
     /*  29505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29511 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29525 */     GIR_RootConstrainSelectedInstOperands,
     /*  29526 */     // GIR_Coverage, 2240,
     /*  29526 */     GIR_EraseRootFromParent_Done,
     /*  29527 */   // Label 467: @29527
     /*  29527 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29594), // Rule ID 2299 //
     /*  29532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29560 */     // MIs[1] imm
     /*  29560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29568 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29572 */     // MIs[2] Operand 1
     /*  29572 */     // No operand predicates
     /*  29572 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29578 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29592 */     GIR_RootConstrainSelectedInstOperands,
     /*  29593 */     // GIR_Coverage, 2299,
     /*  29593 */     GIR_EraseRootFromParent_Done,
     /*  29594 */   // Label 468: @29594
     /*  29594 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29664), // Rule ID 6985 //
     /*  29599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  29611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29637 */     // MIs[2] Rn
     /*  29637 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29642 */     // MIs[2] Rm
     /*  29642 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29649 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29662 */     GIR_RootConstrainSelectedInstOperands,
     /*  29663 */     // GIR_Coverage, 6985,
     /*  29663 */     GIR_EraseRootFromParent_Done,
     /*  29664 */   // Label 469: @29664
     /*  29664 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29734), // Rule ID 14022 //
     /*  29669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  29681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  29707 */     // MIs[2] Rn
     /*  29707 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29712 */     // MIs[2] Rm
     /*  29712 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29719 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29732 */     GIR_RootConstrainSelectedInstOperands,
     /*  29733 */     // GIR_Coverage, 14022,
     /*  29733 */     GIR_EraseRootFromParent_Done,
     /*  29734 */   // Label 470: @29734
     /*  29734 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(29797), // Rule ID 1789 //
     /*  29739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29782 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29795 */     GIR_RootConstrainSelectedInstOperands,
     /*  29796 */     // GIR_Coverage, 1789,
     /*  29796 */     GIR_EraseRootFromParent_Done,
     /*  29797 */   // Label 471: @29797
     /*  29797 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(29860), // Rule ID 1788 //
     /*  29802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29845 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29858 */     GIR_RootConstrainSelectedInstOperands,
     /*  29859 */     // GIR_Coverage, 1788,
     /*  29859 */     GIR_EraseRootFromParent_Done,
     /*  29860 */   // Label 472: @29860
     /*  29860 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(29923), // Rule ID 1714 //
     /*  29865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29908 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  29911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29921 */     GIR_RootConstrainSelectedInstOperands,
     /*  29922 */     // GIR_Coverage, 1714,
     /*  29922 */     GIR_EraseRootFromParent_Done,
     /*  29923 */   // Label 473: @29923
     /*  29923 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(29986), // Rule ID 1787 //
     /*  29928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29971 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29984 */     GIR_RootConstrainSelectedInstOperands,
     /*  29985 */     // GIR_Coverage, 1787,
     /*  29985 */     GIR_EraseRootFromParent_Done,
     /*  29986 */   // Label 474: @29986
     /*  29986 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(30049), // Rule ID 1786 //
     /*  29991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30034 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30047 */     GIR_RootConstrainSelectedInstOperands,
     /*  30048 */     // GIR_Coverage, 1786,
     /*  30048 */     GIR_EraseRootFromParent_Done,
     /*  30049 */   // Label 475: @30049
     /*  30049 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(30110), // Rule ID 13487 //
     /*  30054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30093 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30108 */     GIR_RootConstrainSelectedInstOperands,
     /*  30109 */     // GIR_Coverage, 13487,
     /*  30109 */     GIR_EraseRootFromParent_Done,
     /*  30110 */   // Label 476: @30110
     /*  30110 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(30171), // Rule ID 13517 //
     /*  30115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30154 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30169 */     GIR_RootConstrainSelectedInstOperands,
     /*  30170 */     // GIR_Coverage, 13517,
     /*  30170 */     GIR_EraseRootFromParent_Done,
     /*  30171 */   // Label 477: @30171
     /*  30171 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30219), // Rule ID 13508 //
     /*  30176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30206 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30217 */     GIR_RootConstrainSelectedInstOperands,
     /*  30218 */     // GIR_Coverage, 13508,
     /*  30218 */     GIR_EraseRootFromParent_Done,
     /*  30219 */   // Label 478: @30219
     /*  30219 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30267), // Rule ID 13397 //
     /*  30224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30254 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30265 */     GIR_RootConstrainSelectedInstOperands,
     /*  30266 */     // GIR_Coverage, 13397,
     /*  30266 */     GIR_EraseRootFromParent_Done,
     /*  30267 */   // Label 479: @30267
     /*  30267 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30315), // Rule ID 13481 //
     /*  30272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30302 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30313 */     GIR_RootConstrainSelectedInstOperands,
     /*  30314 */     // GIR_Coverage, 13481,
     /*  30314 */     GIR_EraseRootFromParent_Done,
     /*  30315 */   // Label 480: @30315
     /*  30315 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30363), // Rule ID 13409 //
     /*  30320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30350 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30361 */     GIR_RootConstrainSelectedInstOperands,
     /*  30362 */     // GIR_Coverage, 13409,
     /*  30362 */     GIR_EraseRootFromParent_Done,
     /*  30363 */   // Label 481: @30363
     /*  30363 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30411), // Rule ID 13507 //
     /*  30368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30398 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30409 */     GIR_RootConstrainSelectedInstOperands,
     /*  30410 */     // GIR_Coverage, 13507,
     /*  30410 */     GIR_EraseRootFromParent_Done,
     /*  30411 */   // Label 482: @30411
     /*  30411 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30472), // Rule ID 1726 //
     /*  30416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30455 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30470 */     GIR_RootConstrainSelectedInstOperands,
     /*  30471 */     // GIR_Coverage, 1726,
     /*  30471 */     GIR_EraseRootFromParent_Done,
     /*  30472 */   // Label 483: @30472
     /*  30472 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30533), // Rule ID 1816 //
     /*  30477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30516 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30531 */     GIR_RootConstrainSelectedInstOperands,
     /*  30532 */     // GIR_Coverage, 1816,
     /*  30532 */     GIR_EraseRootFromParent_Done,
     /*  30533 */   // Label 484: @30533
     /*  30533 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30581), // Rule ID 1807 //
     /*  30538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30568 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30579 */     GIR_RootConstrainSelectedInstOperands,
     /*  30580 */     // GIR_Coverage, 1807,
     /*  30580 */     GIR_EraseRootFromParent_Done,
     /*  30581 */   // Label 485: @30581
     /*  30581 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30629), // Rule ID 994 //
     /*  30586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30616 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30627 */     GIR_RootConstrainSelectedInstOperands,
     /*  30628 */     // GIR_Coverage, 994,
     /*  30628 */     GIR_EraseRootFromParent_Done,
     /*  30629 */   // Label 486: @30629
     /*  30629 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30677), // Rule ID 1720 //
     /*  30634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30664 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30675 */     GIR_RootConstrainSelectedInstOperands,
     /*  30676 */     // GIR_Coverage, 1720,
     /*  30676 */     GIR_EraseRootFromParent_Done,
     /*  30677 */   // Label 487: @30677
     /*  30677 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(30725), // Rule ID 1055 //
     /*  30682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30712 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30723 */     GIR_RootConstrainSelectedInstOperands,
     /*  30724 */     // GIR_Coverage, 1055,
     /*  30724 */     GIR_EraseRootFromParent_Done,
     /*  30725 */   // Label 488: @30725
     /*  30725 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(30773), // Rule ID 1806 //
     /*  30730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30760 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30771 */     GIR_RootConstrainSelectedInstOperands,
     /*  30772 */     // GIR_Coverage, 1806,
     /*  30772 */     GIR_EraseRootFromParent_Done,
     /*  30773 */   // Label 489: @30773
     /*  30773 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(30800), // Rule ID 1105 //
     /*  30778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30793 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  30793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  30798 */     GIR_RootConstrainSelectedInstOperands,
     /*  30799 */     // GIR_Coverage, 1105,
     /*  30799 */     GIR_Done,
     /*  30800 */   // Label 490: @30800
     /*  30800 */   GIM_Reject,
     /*  30801 */ // Label 409: @30801
     /*  30801 */ GIM_Reject,
     /*  30802 */ // Label 161: @30802
     /*  30802 */ GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(31651),
     /*  30807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30813 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(30946), // Rule ID 14027 //
     /*  30818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  30842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  30850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  30859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  30863 */     // MIs[1] Operand 2
     /*  30863 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  30874 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  30878 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30882 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30886 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  30890 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30894 */     // MIs[5] Rn
     /*  30894 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  30899 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  30901 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  30901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  30904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  30908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30928 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  30935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30945 */     // GIR_Coverage, 14027,
     /*  30945 */     GIR_EraseRootFromParent_Done,
     /*  30946 */   // Label 492: @30946
     /*  30946 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(31079), // Rule ID 6990 //
     /*  30951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  30988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30992 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30996 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  31000 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  31004 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31008 */     // MIs[4] Rn
     /*  31008 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31013 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31017 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31021 */     // MIs[3] Operand 2
     /*  31021 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31032 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31034 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31078 */     // GIR_Coverage, 6990,
     /*  31078 */     GIR_EraseRootFromParent_Done,
     /*  31079 */   // Label 493: @31079
     /*  31079 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(31148), // Rule ID 13426 //
     /*  31084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31099 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31102 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31111 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31131 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31146 */     GIR_RootConstrainSelectedInstOperands,
     /*  31147 */     // GIR_Coverage, 13426,
     /*  31147 */     GIR_EraseRootFromParent_Done,
     /*  31148 */   // Label 494: @31148
     /*  31148 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(31217), // Rule ID 13438 //
     /*  31153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31168 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31171 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31180 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31200 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31215 */     GIR_RootConstrainSelectedInstOperands,
     /*  31216 */     // GIR_Coverage, 13438,
     /*  31216 */     GIR_EraseRootFromParent_Done,
     /*  31217 */   // Label 495: @31217
     /*  31217 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(31284), // Rule ID 13630 //
     /*  31222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31246 */     // MIs[1] imm
     /*  31246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31254 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31258 */     // MIs[2] Operand 1
     /*  31258 */     // No operand predicates
     /*  31258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31268 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31282 */     GIR_RootConstrainSelectedInstOperands,
     /*  31283 */     // GIR_Coverage, 13630,
     /*  31283 */     GIR_EraseRootFromParent_Done,
     /*  31284 */   // Label 496: @31284
     /*  31284 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(31351), // Rule ID 13651 //
     /*  31289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31313 */     // MIs[1] imm
     /*  31313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31321 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31325 */     // MIs[2] Operand 1
     /*  31325 */     // No operand predicates
     /*  31325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31335 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31349 */     GIR_RootConstrainSelectedInstOperands,
     /*  31350 */     // GIR_Coverage, 13651,
     /*  31350 */     GIR_EraseRootFromParent_Done,
     /*  31351 */   // Label 497: @31351
     /*  31351 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(31420), // Rule ID 1357 //
     /*  31356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31375 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31378 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31387 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31403 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31418 */     GIR_RootConstrainSelectedInstOperands,
     /*  31419 */     // GIR_Coverage, 1357,
     /*  31419 */     GIR_EraseRootFromParent_Done,
     /*  31420 */   // Label 498: @31420
     /*  31420 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31489), // Rule ID 1480 //
     /*  31425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31444 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31447 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31456 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31472 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31487 */     GIR_RootConstrainSelectedInstOperands,
     /*  31488 */     // GIR_Coverage, 1480,
     /*  31488 */     GIR_EraseRootFromParent_Done,
     /*  31489 */   // Label 499: @31489
     /*  31489 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31556), // Rule ID 2230 //
     /*  31494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31522 */     // MIs[1] imm
     /*  31522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31530 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31534 */     // MIs[2] Operand 1
     /*  31534 */     // No operand predicates
     /*  31534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31540 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31554 */     GIR_RootConstrainSelectedInstOperands,
     /*  31555 */     // GIR_Coverage, 2230,
     /*  31555 */     GIR_EraseRootFromParent_Done,
     /*  31556 */   // Label 500: @31556
     /*  31556 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(31623), // Rule ID 2289 //
     /*  31561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31589 */     // MIs[1] imm
     /*  31589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31601 */     // MIs[2] Operand 1
     /*  31601 */     // No operand predicates
     /*  31601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31607 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31621 */     GIR_RootConstrainSelectedInstOperands,
     /*  31622 */     // GIR_Coverage, 2289,
     /*  31622 */     GIR_EraseRootFromParent_Done,
     /*  31623 */   // Label 501: @31623
     /*  31623 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31650), // Rule ID 1100 //
     /*  31628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31643 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  31648 */     GIR_RootConstrainSelectedInstOperands,
     /*  31649 */     // GIR_Coverage, 1100,
     /*  31649 */     GIR_Done,
     /*  31650 */   // Label 502: @31650
     /*  31650 */   GIM_Reject,
     /*  31651 */ // Label 491: @31651
     /*  31651 */ GIM_Reject,
     /*  31652 */ // Label 162: @31652
     /*  31652 */ GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(35229),
     /*  31657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31663 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(31750), // Rule ID 13470 //
     /*  31668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31695 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31698 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31707 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31731 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 660:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31748 */     GIR_RootConstrainSelectedInstOperands,
     /*  31749 */     // GIR_Coverage, 13470,
     /*  31749 */     GIR_EraseRootFromParent_Done,
     /*  31750 */   // Label 504: @31750
     /*  31750 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(31837), // Rule ID 13494 //
     /*  31755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31782 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31785 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31794 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31818 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 725:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31835 */     GIR_RootConstrainSelectedInstOperands,
     /*  31836 */     // GIR_Coverage, 13494,
     /*  31836 */     GIR_EraseRootFromParent_Done,
     /*  31837 */   // Label 505: @31837
     /*  31837 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(31924), // Rule ID 1691 //
     /*  31842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31873 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31876 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31885 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31905 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 660:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31922 */     GIR_RootConstrainSelectedInstOperands,
     /*  31923 */     // GIR_Coverage, 1691,
     /*  31923 */     GIR_EraseRootFromParent_Done,
     /*  31924 */   // Label 506: @31924
     /*  31924 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(32011), // Rule ID 1769 //
     /*  31929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31960 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31963 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31972 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31992 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 725:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32009 */     GIR_RootConstrainSelectedInstOperands,
     /*  32010 */     // GIR_Coverage, 1769,
     /*  32010 */     GIR_EraseRootFromParent_Done,
     /*  32011 */   // Label 507: @32011
     /*  32011 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(32080), // Rule ID 1785 //
     /*  32016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32063 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32078 */     GIR_RootConstrainSelectedInstOperands,
     /*  32079 */     // GIR_Coverage, 1785,
     /*  32079 */     GIR_EraseRootFromParent_Done,
     /*  32080 */   // Label 508: @32080
     /*  32080 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(32149), // Rule ID 1784 //
     /*  32085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32132 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32147 */     GIR_RootConstrainSelectedInstOperands,
     /*  32148 */     // GIR_Coverage, 1784,
     /*  32148 */     GIR_EraseRootFromParent_Done,
     /*  32149 */   // Label 509: @32149
     /*  32149 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(32218), // Rule ID 1713 //
     /*  32154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32201 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32216 */     GIR_RootConstrainSelectedInstOperands,
     /*  32217 */     // GIR_Coverage, 1713,
     /*  32217 */     GIR_EraseRootFromParent_Done,
     /*  32218 */   // Label 510: @32218
     /*  32218 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(32287), // Rule ID 1783 //
     /*  32223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32270 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32285 */     GIR_RootConstrainSelectedInstOperands,
     /*  32286 */     // GIR_Coverage, 1783,
     /*  32286 */     GIR_EraseRootFromParent_Done,
     /*  32287 */   // Label 511: @32287
     /*  32287 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32356), // Rule ID 1782 //
     /*  32292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32339 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32354 */     GIR_RootConstrainSelectedInstOperands,
     /*  32355 */     // GIR_Coverage, 1782,
     /*  32355 */     GIR_EraseRootFromParent_Done,
     /*  32356 */   // Label 512: @32356
     /*  32356 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32423), // Rule ID 13486 //
     /*  32361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32404 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32421 */     GIR_RootConstrainSelectedInstOperands,
     /*  32422 */     // GIR_Coverage, 13486,
     /*  32422 */     GIR_EraseRootFromParent_Done,
     /*  32423 */   // Label 513: @32423
     /*  32423 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32490), // Rule ID 13516 //
     /*  32428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32471 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32488 */     GIR_RootConstrainSelectedInstOperands,
     /*  32489 */     // GIR_Coverage, 13516,
     /*  32489 */     GIR_EraseRootFromParent_Done,
     /*  32490 */   // Label 514: @32490
     /*  32490 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32557), // Rule ID 1725 //
     /*  32495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32538 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32555 */     GIR_RootConstrainSelectedInstOperands,
     /*  32556 */     // GIR_Coverage, 1725,
     /*  32556 */     GIR_EraseRootFromParent_Done,
     /*  32557 */   // Label 515: @32557
     /*  32557 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32624), // Rule ID 1815 //
     /*  32562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32605 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32622 */     GIR_RootConstrainSelectedInstOperands,
     /*  32623 */     // GIR_Coverage, 1815,
     /*  32623 */     GIR_EraseRootFromParent_Done,
     /*  32624 */   // Label 516: @32624
     /*  32624 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32705), // Rule ID 13468 //
     /*  32629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32656 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32659 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32668 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32688 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32703 */     GIR_RootConstrainSelectedInstOperands,
     /*  32704 */     // GIR_Coverage, 13468,
     /*  32704 */     GIR_EraseRootFromParent_Done,
     /*  32705 */   // Label 517: @32705
     /*  32705 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32786), // Rule ID 13492 //
     /*  32710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32749 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32769 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32784 */     GIR_RootConstrainSelectedInstOperands,
     /*  32785 */     // GIR_Coverage, 13492,
     /*  32785 */     GIR_EraseRootFromParent_Done,
     /*  32786 */   // Label 518: @32786
     /*  32786 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(32867), // Rule ID 1689 //
     /*  32791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32822 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32825 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32834 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32850 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32865 */     GIR_RootConstrainSelectedInstOperands,
     /*  32866 */     // GIR_Coverage, 1689,
     /*  32866 */     GIR_EraseRootFromParent_Done,
     /*  32867 */   // Label 519: @32867
     /*  32867 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(32948), // Rule ID 1767 //
     /*  32872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32903 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32906 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32915 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32919 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32931 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32946 */     GIR_RootConstrainSelectedInstOperands,
     /*  32947 */     // GIR_Coverage, 1767,
     /*  32947 */     GIR_EraseRootFromParent_Done,
     /*  32948 */   // Label 520: @32948
     /*  32948 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(32999), // Rule ID 13506 //
     /*  32953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32985 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  32988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  32997 */     GIR_RootConstrainSelectedInstOperands,
     /*  32998 */     // GIR_Coverage, 13506,
     /*  32998 */     GIR_EraseRootFromParent_Done,
     /*  32999 */   // Label 521: @32999
     /*  32999 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(33050), // Rule ID 13480 //
     /*  33004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33036 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33048 */     GIR_RootConstrainSelectedInstOperands,
     /*  33049 */     // GIR_Coverage, 13480,
     /*  33049 */     GIR_EraseRootFromParent_Done,
     /*  33050 */   // Label 522: @33050
     /*  33050 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(33101), // Rule ID 13505 //
     /*  33055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33087 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33099 */     GIR_RootConstrainSelectedInstOperands,
     /*  33100 */     // GIR_Coverage, 13505,
     /*  33100 */     GIR_EraseRootFromParent_Done,
     /*  33101 */   // Label 523: @33101
     /*  33101 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(33152), // Rule ID 1805 //
     /*  33106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33138 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33150 */     GIR_RootConstrainSelectedInstOperands,
     /*  33151 */     // GIR_Coverage, 1805,
     /*  33151 */     GIR_EraseRootFromParent_Done,
     /*  33152 */   // Label 524: @33152
     /*  33152 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(33203), // Rule ID 1719 //
     /*  33157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33189 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33201 */     GIR_RootConstrainSelectedInstOperands,
     /*  33202 */     // GIR_Coverage, 1719,
     /*  33202 */     GIR_EraseRootFromParent_Done,
     /*  33203 */   // Label 525: @33203
     /*  33203 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33254), // Rule ID 1804 //
     /*  33208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33240 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33252 */     GIR_RootConstrainSelectedInstOperands,
     /*  33253 */     // GIR_Coverage, 1804,
     /*  33253 */     GIR_EraseRootFromParent_Done,
     /*  33254 */   // Label 526: @33254
     /*  33254 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33323), // Rule ID 13432 //
     /*  33259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33274 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33277 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33306 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33321 */     GIR_RootConstrainSelectedInstOperands,
     /*  33322 */     // GIR_Coverage, 13432,
     /*  33322 */     GIR_EraseRootFromParent_Done,
     /*  33323 */   // Label 527: @33323
     /*  33323 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33392), // Rule ID 13444 //
     /*  33328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33343 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33346 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33355 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33375 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33390 */     GIR_RootConstrainSelectedInstOperands,
     /*  33391 */     // GIR_Coverage, 13444,
     /*  33391 */     GIR_EraseRootFromParent_Done,
     /*  33392 */   // Label 528: @33392
     /*  33392 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33448), // Rule ID 13394 //
     /*  33397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33412 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33415 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33435 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 661:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33446 */     GIR_RootConstrainSelectedInstOperands,
     /*  33447 */     // GIR_Coverage, 13394,
     /*  33447 */     GIR_EraseRootFromParent_Done,
     /*  33448 */   // Label 529: @33448
     /*  33448 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33504), // Rule ID 13406 //
     /*  33453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33468 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33471 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33491 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 726:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33502 */     GIR_RootConstrainSelectedInstOperands,
     /*  33503 */     // GIR_Coverage, 13406,
     /*  33503 */     GIR_EraseRootFromParent_Done,
     /*  33504 */   // Label 530: @33504
     /*  33504 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33571), // Rule ID 13636 //
     /*  33509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33533 */     // MIs[1] imm
     /*  33533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33541 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33545 */     // MIs[2] Operand 1
     /*  33545 */     // No operand predicates
     /*  33545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33549 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33555 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33569 */     GIR_RootConstrainSelectedInstOperands,
     /*  33570 */     // GIR_Coverage, 13636,
     /*  33570 */     GIR_EraseRootFromParent_Done,
     /*  33571 */   // Label 531: @33571
     /*  33571 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33638), // Rule ID 13657 //
     /*  33576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33600 */     // MIs[1] imm
     /*  33600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33608 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33612 */     // MIs[2] Operand 1
     /*  33612 */     // No operand predicates
     /*  33612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33622 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33636 */     GIR_RootConstrainSelectedInstOperands,
     /*  33637 */     // GIR_Coverage, 13657,
     /*  33637 */     GIR_EraseRootFromParent_Done,
     /*  33638 */   // Label 532: @33638
     /*  33638 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33707), // Rule ID 1363 //
     /*  33643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33662 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33665 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33674 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33690 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33705 */     GIR_RootConstrainSelectedInstOperands,
     /*  33706 */     // GIR_Coverage, 1363,
     /*  33706 */     GIR_EraseRootFromParent_Done,
     /*  33707 */   // Label 533: @33707
     /*  33707 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(33776), // Rule ID 1486 //
     /*  33712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33731 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33734 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33743 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33759 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33774 */     GIR_RootConstrainSelectedInstOperands,
     /*  33775 */     // GIR_Coverage, 1486,
     /*  33775 */     GIR_EraseRootFromParent_Done,
     /*  33776 */   // Label 534: @33776
     /*  33776 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(33832), // Rule ID 991 //
     /*  33781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33800 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33803 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33819 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 661:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33830 */     GIR_RootConstrainSelectedInstOperands,
     /*  33831 */     // GIR_Coverage, 991,
     /*  33831 */     GIR_EraseRootFromParent_Done,
     /*  33832 */   // Label 535: @33832
     /*  33832 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(33888), // Rule ID 1052 //
     /*  33837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33856 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33859 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33875 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 726:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33886 */     GIR_RootConstrainSelectedInstOperands,
     /*  33887 */     // GIR_Coverage, 1052,
     /*  33887 */     GIR_EraseRootFromParent_Done,
     /*  33888 */   // Label 536: @33888
     /*  33888 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(33955), // Rule ID 2236 //
     /*  33893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33921 */     // MIs[1] imm
     /*  33921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33929 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33933 */     // MIs[2] Operand 1
     /*  33933 */     // No operand predicates
     /*  33933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33939 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33953 */     GIR_RootConstrainSelectedInstOperands,
     /*  33954 */     // GIR_Coverage, 2236,
     /*  33954 */     GIR_EraseRootFromParent_Done,
     /*  33955 */   // Label 537: @33955
     /*  33955 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(34022), // Rule ID 2295 //
     /*  33960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33988 */     // MIs[1] imm
     /*  33988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33996 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34000 */     // MIs[2] Operand 1
     /*  34000 */     // No operand predicates
     /*  34000 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34006 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34020 */     GIR_RootConstrainSelectedInstOperands,
     /*  34021 */     // GIR_Coverage, 2295,
     /*  34021 */     GIR_EraseRootFromParent_Done,
     /*  34022 */   // Label 538: @34022
     /*  34022 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(34092), // Rule ID 6986 //
     /*  34027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34065 */     // MIs[2] Rn
     /*  34065 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34070 */     // MIs[2] Rm
     /*  34070 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34077 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34090 */     GIR_RootConstrainSelectedInstOperands,
     /*  34091 */     // GIR_Coverage, 6986,
     /*  34091 */     GIR_EraseRootFromParent_Done,
     /*  34092 */   // Label 539: @34092
     /*  34092 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(34162), // Rule ID 14023 //
     /*  34097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34135 */     // MIs[2] Rn
     /*  34135 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34140 */     // MIs[2] Rm
     /*  34140 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34147 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34160 */     GIR_RootConstrainSelectedInstOperands,
     /*  34161 */     // GIR_Coverage, 14023,
     /*  34161 */     GIR_EraseRootFromParent_Done,
     /*  34162 */   // Label 540: @34162
     /*  34162 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(34225), // Rule ID 1781 //
     /*  34167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34210 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34223 */     GIR_RootConstrainSelectedInstOperands,
     /*  34224 */     // GIR_Coverage, 1781,
     /*  34224 */     GIR_EraseRootFromParent_Done,
     /*  34225 */   // Label 541: @34225
     /*  34225 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34288), // Rule ID 1780 //
     /*  34230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34273 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34286 */     GIR_RootConstrainSelectedInstOperands,
     /*  34287 */     // GIR_Coverage, 1780,
     /*  34287 */     GIR_EraseRootFromParent_Done,
     /*  34288 */   // Label 542: @34288
     /*  34288 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34351), // Rule ID 1712 //
     /*  34293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34336 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34349 */     GIR_RootConstrainSelectedInstOperands,
     /*  34350 */     // GIR_Coverage, 1712,
     /*  34350 */     GIR_EraseRootFromParent_Done,
     /*  34351 */   // Label 543: @34351
     /*  34351 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34414), // Rule ID 1779 //
     /*  34356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34399 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34412 */     GIR_RootConstrainSelectedInstOperands,
     /*  34413 */     // GIR_Coverage, 1779,
     /*  34413 */     GIR_EraseRootFromParent_Done,
     /*  34414 */   // Label 544: @34414
     /*  34414 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34477), // Rule ID 1778 //
     /*  34419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34462 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34475 */     GIR_RootConstrainSelectedInstOperands,
     /*  34476 */     // GIR_Coverage, 1778,
     /*  34476 */     GIR_EraseRootFromParent_Done,
     /*  34477 */   // Label 545: @34477
     /*  34477 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34538), // Rule ID 13485 //
     /*  34482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34521 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34536 */     GIR_RootConstrainSelectedInstOperands,
     /*  34537 */     // GIR_Coverage, 13485,
     /*  34537 */     GIR_EraseRootFromParent_Done,
     /*  34538 */   // Label 546: @34538
     /*  34538 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34599), // Rule ID 13515 //
     /*  34543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34582 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34597 */     GIR_RootConstrainSelectedInstOperands,
     /*  34598 */     // GIR_Coverage, 13515,
     /*  34598 */     GIR_EraseRootFromParent_Done,
     /*  34599 */   // Label 547: @34599
     /*  34599 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34647), // Rule ID 13504 //
     /*  34604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34634 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34645 */     GIR_RootConstrainSelectedInstOperands,
     /*  34646 */     // GIR_Coverage, 13504,
     /*  34646 */     GIR_EraseRootFromParent_Done,
     /*  34647 */   // Label 548: @34647
     /*  34647 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34695), // Rule ID 13393 //
     /*  34652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  34667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34682 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34693 */     GIR_RootConstrainSelectedInstOperands,
     /*  34694 */     // GIR_Coverage, 13393,
     /*  34694 */     GIR_EraseRootFromParent_Done,
     /*  34695 */   // Label 549: @34695
     /*  34695 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(34743), // Rule ID 13479 //
     /*  34700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34730 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  34733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34741 */     GIR_RootConstrainSelectedInstOperands,
     /*  34742 */     // GIR_Coverage, 13479,
     /*  34742 */     GIR_EraseRootFromParent_Done,
     /*  34743 */   // Label 550: @34743
     /*  34743 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(34791), // Rule ID 13405 //
     /*  34748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  34763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34778 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34789 */     GIR_RootConstrainSelectedInstOperands,
     /*  34790 */     // GIR_Coverage, 13405,
     /*  34790 */     GIR_EraseRootFromParent_Done,
     /*  34791 */   // Label 551: @34791
     /*  34791 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(34839), // Rule ID 13503 //
     /*  34796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34826 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34837 */     GIR_RootConstrainSelectedInstOperands,
     /*  34838 */     // GIR_Coverage, 13503,
     /*  34838 */     GIR_EraseRootFromParent_Done,
     /*  34839 */   // Label 552: @34839
     /*  34839 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(34900), // Rule ID 1724 //
     /*  34844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34883 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34898 */     GIR_RootConstrainSelectedInstOperands,
     /*  34899 */     // GIR_Coverage, 1724,
     /*  34899 */     GIR_EraseRootFromParent_Done,
     /*  34900 */   // Label 553: @34900
     /*  34900 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(34961), // Rule ID 1814 //
     /*  34905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34944 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34959 */     GIR_RootConstrainSelectedInstOperands,
     /*  34960 */     // GIR_Coverage, 1814,
     /*  34960 */     GIR_EraseRootFromParent_Done,
     /*  34961 */   // Label 554: @34961
     /*  34961 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(35009), // Rule ID 1803 //
     /*  34966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34996 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35007 */     GIR_RootConstrainSelectedInstOperands,
     /*  35008 */     // GIR_Coverage, 1803,
     /*  35008 */     GIR_EraseRootFromParent_Done,
     /*  35009 */   // Label 555: @35009
     /*  35009 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(35057), // Rule ID 990 //
     /*  35014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35044 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35055 */     GIR_RootConstrainSelectedInstOperands,
     /*  35056 */     // GIR_Coverage, 990,
     /*  35056 */     GIR_EraseRootFromParent_Done,
     /*  35057 */   // Label 556: @35057
     /*  35057 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(35105), // Rule ID 1718 //
     /*  35062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35092 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35103 */     GIR_RootConstrainSelectedInstOperands,
     /*  35104 */     // GIR_Coverage, 1718,
     /*  35104 */     GIR_EraseRootFromParent_Done,
     /*  35105 */   // Label 557: @35105
     /*  35105 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(35153), // Rule ID 1051 //
     /*  35110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35140 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35151 */     GIR_RootConstrainSelectedInstOperands,
     /*  35152 */     // GIR_Coverage, 1051,
     /*  35152 */     GIR_EraseRootFromParent_Done,
     /*  35153 */   // Label 558: @35153
     /*  35153 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35201), // Rule ID 1802 //
     /*  35158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35188 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35199 */     GIR_RootConstrainSelectedInstOperands,
     /*  35200 */     // GIR_Coverage, 1802,
     /*  35200 */     GIR_EraseRootFromParent_Done,
     /*  35201 */   // Label 559: @35201
     /*  35201 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35228), // Rule ID 1103 //
     /*  35206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35221 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35226 */     GIR_RootConstrainSelectedInstOperands,
     /*  35227 */     // GIR_Coverage, 1103,
     /*  35227 */     GIR_Done,
     /*  35228 */   // Label 560: @35228
     /*  35228 */   GIM_Reject,
     /*  35229 */ // Label 503: @35229
     /*  35229 */ GIM_Reject,
     /*  35230 */ // Label 163: @35230
     /*  35230 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35953),
     /*  35235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35241 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35310), // Rule ID 13428 //
     /*  35246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35261 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35264 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35273 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35293 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35308 */     GIR_RootConstrainSelectedInstOperands,
     /*  35309 */     // GIR_Coverage, 13428,
     /*  35309 */     GIR_EraseRootFromParent_Done,
     /*  35310 */   // Label 562: @35310
     /*  35310 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35379), // Rule ID 13440 //
     /*  35315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35330 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35333 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35342 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35362 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35377 */     GIR_RootConstrainSelectedInstOperands,
     /*  35378 */     // GIR_Coverage, 13440,
     /*  35378 */     GIR_EraseRootFromParent_Done,
     /*  35379 */   // Label 563: @35379
     /*  35379 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35446), // Rule ID 13632 //
     /*  35384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35408 */     // MIs[1] imm
     /*  35408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35416 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35420 */     // MIs[2] Operand 1
     /*  35420 */     // No operand predicates
     /*  35420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35430 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35444 */     GIR_RootConstrainSelectedInstOperands,
     /*  35445 */     // GIR_Coverage, 13632,
     /*  35445 */     GIR_EraseRootFromParent_Done,
     /*  35446 */   // Label 564: @35446
     /*  35446 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35513), // Rule ID 13653 //
     /*  35451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35475 */     // MIs[1] imm
     /*  35475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35483 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35487 */     // MIs[2] Operand 1
     /*  35487 */     // No operand predicates
     /*  35487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35497 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35511 */     GIR_RootConstrainSelectedInstOperands,
     /*  35512 */     // GIR_Coverage, 13653,
     /*  35512 */     GIR_EraseRootFromParent_Done,
     /*  35513 */   // Label 565: @35513
     /*  35513 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35582), // Rule ID 1359 //
     /*  35518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35537 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35540 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35549 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35565 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35580 */     GIR_RootConstrainSelectedInstOperands,
     /*  35581 */     // GIR_Coverage, 1359,
     /*  35581 */     GIR_EraseRootFromParent_Done,
     /*  35582 */   // Label 566: @35582
     /*  35582 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(35651), // Rule ID 1482 //
     /*  35587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35606 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35609 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35618 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35634 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35649 */     GIR_RootConstrainSelectedInstOperands,
     /*  35650 */     // GIR_Coverage, 1482,
     /*  35650 */     GIR_EraseRootFromParent_Done,
     /*  35651 */   // Label 567: @35651
     /*  35651 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(35718), // Rule ID 2232 //
     /*  35656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35684 */     // MIs[1] imm
     /*  35684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35692 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35696 */     // MIs[2] Operand 1
     /*  35696 */     // No operand predicates
     /*  35696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35702 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35716 */     GIR_RootConstrainSelectedInstOperands,
     /*  35717 */     // GIR_Coverage, 2232,
     /*  35717 */     GIR_EraseRootFromParent_Done,
     /*  35718 */   // Label 568: @35718
     /*  35718 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35785), // Rule ID 2291 //
     /*  35723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35751 */     // MIs[1] imm
     /*  35751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35759 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35763 */     // MIs[2] Operand 1
     /*  35763 */     // No operand predicates
     /*  35763 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35769 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35783 */     GIR_RootConstrainSelectedInstOperands,
     /*  35784 */     // GIR_Coverage, 2291,
     /*  35784 */     GIR_EraseRootFromParent_Done,
     /*  35785 */   // Label 569: @35785
     /*  35785 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(35855), // Rule ID 6987 //
     /*  35790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  35802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  35828 */     // MIs[2] Rn
     /*  35828 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35833 */     // MIs[2] Rm
     /*  35833 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35840 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35853 */     GIR_RootConstrainSelectedInstOperands,
     /*  35854 */     // GIR_Coverage, 6987,
     /*  35854 */     GIR_EraseRootFromParent_Done,
     /*  35855 */   // Label 570: @35855
     /*  35855 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(35925), // Rule ID 14024 //
     /*  35860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  35872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  35898 */     // MIs[2] Rn
     /*  35898 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35903 */     // MIs[2] Rm
     /*  35903 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35910 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35923 */     GIR_RootConstrainSelectedInstOperands,
     /*  35924 */     // GIR_Coverage, 14024,
     /*  35924 */     GIR_EraseRootFromParent_Done,
     /*  35925 */   // Label 571: @35925
     /*  35925 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(35952), // Rule ID 1101 //
     /*  35930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35945 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  35950 */     GIR_RootConstrainSelectedInstOperands,
     /*  35951 */     // GIR_Coverage, 1101,
     /*  35951 */     GIR_Done,
     /*  35952 */   // Label 572: @35952
     /*  35952 */   GIM_Reject,
     /*  35953 */ // Label 561: @35953
     /*  35953 */ GIM_Reject,
     /*  35954 */ // Label 164: @35954
     /*  35954 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(36325),
     /*  35959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  35969 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(36031), // Rule ID 15208 //
     /*  35974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  35977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36005 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36018 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36029 */     GIR_RootConstrainSelectedInstOperands,
     /*  36030 */     // GIR_Coverage, 15208,
     /*  36030 */     GIR_EraseRootFromParent_Done,
     /*  36031 */   // Label 574: @36031
     /*  36031 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(36093), // Rule ID 15207 //
     /*  36036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36067 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36080 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36091 */     GIR_RootConstrainSelectedInstOperands,
     /*  36092 */     // GIR_Coverage, 15207,
     /*  36092 */     GIR_EraseRootFromParent_Done,
     /*  36093 */   // Label 575: @36093
     /*  36093 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36155), // Rule ID 15206 //
     /*  36098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36129 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36142 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36153 */     GIR_RootConstrainSelectedInstOperands,
     /*  36154 */     // GIR_Coverage, 15206,
     /*  36154 */     GIR_EraseRootFromParent_Done,
     /*  36155 */   // Label 576: @36155
     /*  36155 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36217), // Rule ID 8962 //
     /*  36160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36191 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36204 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36215 */     GIR_RootConstrainSelectedInstOperands,
     /*  36216 */     // GIR_Coverage, 8962,
     /*  36216 */     GIR_EraseRootFromParent_Done,
     /*  36217 */   // Label 577: @36217
     /*  36217 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36263), // Rule ID 15209 //
     /*  36222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36237 */     // MIs[1] Operand 2
     /*  36237 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36250 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36261 */     GIR_RootConstrainSelectedInstOperands,
     /*  36262 */     // GIR_Coverage, 15209,
     /*  36262 */     GIR_EraseRootFromParent_Done,
     /*  36263 */   // Label 578: @36263
     /*  36263 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36309), // Rule ID 8963 //
     /*  36268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36283 */     // MIs[1] Operand 2
     /*  36283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36296 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36307 */     GIR_RootConstrainSelectedInstOperands,
     /*  36308 */     // GIR_Coverage, 8963,
     /*  36308 */     GIR_EraseRootFromParent_Done,
     /*  36309 */   // Label 579: @36309
     /*  36309 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36324), // Rule ID 2780 //
     /*  36314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36317 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36322 */     GIR_RootConstrainSelectedInstOperands,
     /*  36323 */     // GIR_Coverage, 2780,
     /*  36323 */     GIR_Done,
     /*  36324 */   // Label 580: @36324
     /*  36324 */   GIM_Reject,
     /*  36325 */ // Label 573: @36325
     /*  36325 */ GIM_Reject,
     /*  36326 */ // Label 165: @36326
     /*  36326 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36351), // Rule ID 2779 //
     /*  36331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36344 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36349 */   GIR_RootConstrainSelectedInstOperands,
     /*  36350 */   // GIR_Coverage, 2779,
     /*  36350 */   GIR_Done,
     /*  36351 */ // Label 581: @36351
     /*  36351 */ GIM_Reject,
     /*  36352 */ // Label 166: @36352
     /*  36352 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(36377), // Rule ID 2778 //
     /*  36357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36370 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36375 */   GIR_RootConstrainSelectedInstOperands,
     /*  36376 */   // GIR_Coverage, 2778,
     /*  36376 */   GIR_Done,
     /*  36377 */ // Label 582: @36377
     /*  36377 */ GIM_Reject,
     /*  36378 */ // Label 167: @36378
     /*  36378 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(36403), // Rule ID 2777 //
     /*  36383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  36389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  36392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36396 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  36396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  36401 */   GIR_RootConstrainSelectedInstOperands,
     /*  36402 */   // GIR_Coverage, 2777,
     /*  36402 */   GIR_Done,
     /*  36403 */ // Label 583: @36403
     /*  36403 */ GIM_Reject,
     /*  36404 */ // Label 168: @36404
     /*  36404 */ GIM_Reject,
     /*  36405 */ // Label 1: @36405
     /*  36405 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 597*/ GIMT_Encode4(50632),
     /*  36416 */ /*GILLT_s32*//*Label 584*/ GIMT_Encode4(36504),
     /*  36420 */ /*GILLT_s64*//*Label 585*/ GIMT_Encode4(37986), GIMT_Encode4(0),
     /*  36428 */ /*GILLT_v2s32*//*Label 586*/ GIMT_Encode4(41268),
     /*  36432 */ /*GILLT_v2s64*//*Label 587*/ GIMT_Encode4(42759),
     /*  36436 */ /*GILLT_v4s16*//*Label 588*/ GIMT_Encode4(45219),
     /*  36440 */ /*GILLT_v4s32*//*Label 589*/ GIMT_Encode4(46710),
     /*  36444 */ /*GILLT_v8s8*//*Label 590*/ GIMT_Encode4(49170),
     /*  36448 */ /*GILLT_v8s16*//*Label 591*/ GIMT_Encode4(49245),
     /*  36452 */ /*GILLT_v16s8*//*Label 592*/ GIMT_Encode4(50453), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36472 */ /*GILLT_nxv2s64*//*Label 593*/ GIMT_Encode4(50528), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36484 */ /*GILLT_nxv4s32*//*Label 594*/ GIMT_Encode4(50554), GIMT_Encode4(0),
     /*  36492 */ /*GILLT_nxv8s16*//*Label 595*/ GIMT_Encode4(50580), GIMT_Encode4(0),
     /*  36500 */ /*GILLT_nxv16s8*//*Label 596*/ GIMT_Encode4(50606),
     /*  36504 */ // Label 584: @36504
     /*  36504 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(37985),
     /*  36509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36515 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(36667), // Rule ID 10009 //
     /*  36520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36551 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36554 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  36559 */     // MIs[2] pattern
     /*  36559 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36562 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36569 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36569 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36572 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36576 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36583 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36586 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36590 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36595 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36598 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36602 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36605 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36610 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36615 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  36627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36632 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36639 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36649 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36666 */     // GIR_Coverage, 10009,
     /*  36666 */     GIR_EraseRootFromParent_Done,
     /*  36667 */   // Label 599: @36667
     /*  36667 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(36819), // Rule ID 10021 //
     /*  36672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36703 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36706 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  36711 */     // MIs[2] pattern
     /*  36711 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36714 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36721 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36721 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36724 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36728 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36735 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36738 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36742 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36747 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36750 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36754 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36757 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36762 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36767 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  36779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36784 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36791 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36801 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36818 */     // GIR_Coverage, 10021,
     /*  36818 */     GIR_EraseRootFromParent_Done,
     /*  36819 */   // Label 600: @36819
     /*  36819 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(36971), // Rule ID 10033 //
     /*  36824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36855 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36858 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  36863 */     // MIs[2] pattern
     /*  36863 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36866 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36873 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36873 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36876 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36880 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36899 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36902 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36906 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36914 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36919 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  36931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36936 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36953 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36970 */     // GIR_Coverage, 10033,
     /*  36970 */     GIR_EraseRootFromParent_Done,
     /*  36971 */   // Label 601: @36971
     /*  36971 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(37123), // Rule ID 10045 //
     /*  36976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37007 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37010 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37015 */     // MIs[2] pattern
     /*  37015 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37018 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37025 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37025 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37028 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37032 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37051 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37054 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37058 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37071 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37095 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37105 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37122 */     // GIR_Coverage, 10045,
     /*  37122 */     GIR_EraseRootFromParent_Done,
     /*  37123 */   // Label 602: @37123
     /*  37123 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(37185), // Rule ID 3953 //
     /*  37128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37164 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37183 */     GIR_RootConstrainSelectedInstOperands,
     /*  37184 */     // GIR_Coverage, 3953,
     /*  37184 */     GIR_EraseRootFromParent_Done,
     /*  37185 */   // Label 603: @37185
     /*  37185 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(37342), // Rule ID 10147 //
     /*  37190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37221 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37224 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37233 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37240 */     // MIs[2] pred
     /*  37240 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37247 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37247 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37250 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37254 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37273 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37276 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37280 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37288 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37293 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37314 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37324 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37341 */     // GIR_Coverage, 10147,
     /*  37341 */     GIR_EraseRootFromParent_Done,
     /*  37342 */   // Label 604: @37342
     /*  37342 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(37499), // Rule ID 10148 //
     /*  37347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37378 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37381 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  37390 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37397 */     // MIs[2] pred
     /*  37397 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37404 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37404 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37407 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37411 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37418 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37421 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37425 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37430 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37433 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37437 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37440 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  37462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37471 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37481 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37498 */     // GIR_Coverage, 10148,
     /*  37498 */     GIR_EraseRootFromParent_Done,
     /*  37499 */   // Label 605: @37499
     /*  37499 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(37656), // Rule ID 10149 //
     /*  37504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37535 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37538 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  37547 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37554 */     // MIs[2] pred
     /*  37554 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37561 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37587 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37590 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37594 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  37619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37628 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37638 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37655 */     // GIR_Coverage, 10149,
     /*  37655 */     GIR_EraseRootFromParent_Done,
     /*  37656 */   // Label 606: @37656
     /*  37656 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37813), // Rule ID 10150 //
     /*  37661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37692 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37695 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  37704 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37711 */     // MIs[2] pred
     /*  37711 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37718 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37718 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37721 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37725 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37732 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37735 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37739 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37744 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37751 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37759 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37764 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  37776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37781 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37785 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37795 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37812 */     // GIR_Coverage, 10150,
     /*  37812 */     GIR_EraseRootFromParent_Done,
     /*  37813 */   // Label 607: @37813
     /*  37813 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37849), // Rule ID 3918 //
     /*  37818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  37833 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  37833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  37836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37838 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  37840 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  37844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37847 */     GIR_RootConstrainSelectedInstOperands,
     /*  37848 */     // GIR_Coverage, 3918,
     /*  37848 */     GIR_EraseRootFromParent_Done,
     /*  37849 */   // Label 608: @37849
     /*  37849 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37882), // Rule ID 3923 //
     /*  37854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  37869 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  37872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37880 */     GIR_RootConstrainSelectedInstOperands,
     /*  37881 */     // GIR_Coverage, 3923,
     /*  37881 */     GIR_EraseRootFromParent_Done,
     /*  37882 */   // Label 609: @37882
     /*  37882 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37918), // Rule ID 3912 //
     /*  37887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  37902 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  37905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37909 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37916 */     GIR_RootConstrainSelectedInstOperands,
     /*  37917 */     // GIR_Coverage, 3912,
     /*  37917 */     GIR_EraseRootFromParent_Done,
     /*  37918 */   // Label 610: @37918
     /*  37918 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37954), // Rule ID 3916 //
     /*  37923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  37938 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  37938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  37941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  37949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37952 */     GIR_RootConstrainSelectedInstOperands,
     /*  37953 */     // GIR_Coverage, 3916,
     /*  37953 */     GIR_EraseRootFromParent_Done,
     /*  37954 */   // Label 611: @37954
     /*  37954 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37984), // Rule ID 3914 //
     /*  37959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37971 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  37971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  37976 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  37982 */     GIR_RootConstrainSelectedInstOperands,
     /*  37983 */     // GIR_Coverage, 3914,
     /*  37983 */     GIR_Done,
     /*  37984 */   // Label 612: @37984
     /*  37984 */   GIM_Reject,
     /*  37985 */ // Label 598: @37985
     /*  37985 */ GIM_Reject,
     /*  37986 */ // Label 585: @37986
     /*  37986 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(41267),
     /*  37991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  37994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37997 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38133), // Rule ID 5437 //
     /*  38002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38035 */     // MIs[1] Operand 2
     /*  38035 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38054 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38058 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38062 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38066 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38070 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38075 */     // MIs[3] Operand 2
     /*  38075 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38088 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38115 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38132 */     // GIR_Coverage, 5437,
     /*  38132 */     GIR_EraseRootFromParent_Done,
     /*  38133 */   // Label 614: @38133
     /*  38133 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(38269), // Rule ID 5436 //
     /*  38138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38171 */     // MIs[1] Operand 2
     /*  38171 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38190 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38194 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38198 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38202 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38206 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38211 */     // MIs[3] Operand 2
     /*  38211 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38222 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38224 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38251 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38268 */     // GIR_Coverage, 5436,
     /*  38268 */     GIR_EraseRootFromParent_Done,
     /*  38269 */   // Label 615: @38269
     /*  38269 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(38405), // Rule ID 5446 //
     /*  38274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38307 */     // MIs[1] Operand 2
     /*  38307 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38326 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38330 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38334 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38338 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38342 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38347 */     // MIs[3] Operand 2
     /*  38347 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38358 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38360 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38387 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38404 */     // GIR_Coverage, 5446,
     /*  38404 */     GIR_EraseRootFromParent_Done,
     /*  38405 */   // Label 616: @38405
     /*  38405 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38541), // Rule ID 5435 //
     /*  38410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38443 */     // MIs[1] Operand 2
     /*  38443 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38462 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38466 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38470 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38474 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38478 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38483 */     // MIs[3] Operand 2
     /*  38483 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38494 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38496 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38523 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38540 */     // GIR_Coverage, 5435,
     /*  38540 */     GIR_EraseRootFromParent_Done,
     /*  38541 */   // Label 617: @38541
     /*  38541 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38677), // Rule ID 5434 //
     /*  38546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38579 */     // MIs[1] Operand 2
     /*  38579 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38598 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38602 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38606 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38610 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38614 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38619 */     // MIs[3] Operand 2
     /*  38619 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38632 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38659 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38676 */     // GIR_Coverage, 5434,
     /*  38676 */     GIR_EraseRootFromParent_Done,
     /*  38677 */   // Label 618: @38677
     /*  38677 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38814), // Rule ID 3970 //
     /*  38682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  38714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  38718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38723 */     // MIs[2] Operand 2
     /*  38723 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  38734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38742 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38746 */     // MIs[3] Operand 1
     /*  38746 */     // No operand predicates
     /*  38746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38748 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38748 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  38751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38755 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38760 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  38767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38779 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  38785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  38806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38812 */     GIR_RootConstrainSelectedInstOperands,
     /*  38813 */     // GIR_Coverage, 3970,
     /*  38813 */     GIR_EraseRootFromParent_Done,
     /*  38814 */   // Label 619: @38814
     /*  38814 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38913), // Rule ID 3968 //
     /*  38819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38868 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38872 */     // MIs[3] Operand 1
     /*  38872 */     // No operand predicates
     /*  38872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38874 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38886 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38911 */     GIR_RootConstrainSelectedInstOperands,
     /*  38912 */     // GIR_Coverage, 3968,
     /*  38912 */     GIR_EraseRootFromParent_Done,
     /*  38913 */   // Label 620: @38913
     /*  38913 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(39012), // Rule ID 3969 //
     /*  38918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38967 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  38971 */     // MIs[3] Operand 1
     /*  38971 */     // No operand predicates
     /*  38971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38973 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38985 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  38995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39010 */     GIR_RootConstrainSelectedInstOperands,
     /*  39011 */     // GIR_Coverage, 3969,
     /*  39011 */     GIR_EraseRootFromParent_Done,
     /*  39012 */   // Label 621: @39012
     /*  39012 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(39098), // Rule ID 3963 //
     /*  39017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39066 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39070 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39077 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39096 */     GIR_RootConstrainSelectedInstOperands,
     /*  39097 */     // GIR_Coverage, 3963,
     /*  39097 */     GIR_EraseRootFromParent_Done,
     /*  39098 */   // Label 622: @39098
     /*  39098 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(39184), // Rule ID 3964 //
     /*  39103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39152 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39163 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39182 */     GIR_RootConstrainSelectedInstOperands,
     /*  39183 */     // GIR_Coverage, 3964,
     /*  39183 */     GIR_EraseRootFromParent_Done,
     /*  39184 */   // Label 623: @39184
     /*  39184 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(39317), // Rule ID 3976 //
     /*  39189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39230 */     // MIs[2] Operand 2
     /*  39230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39249 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39253 */     // MIs[3] Operand 1
     /*  39253 */     // No operand predicates
     /*  39253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39255 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39267 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39286 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39315 */     GIR_RootConstrainSelectedInstOperands,
     /*  39316 */     // GIR_Coverage, 3976,
     /*  39316 */     GIR_EraseRootFromParent_Done,
     /*  39317 */   // Label 624: @39317
     /*  39317 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(39412), // Rule ID 3974 //
     /*  39322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39371 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39375 */     // MIs[3] Operand 1
     /*  39375 */     // No operand predicates
     /*  39375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39377 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39389 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39410 */     GIR_RootConstrainSelectedInstOperands,
     /*  39411 */     // GIR_Coverage, 3974,
     /*  39411 */     GIR_EraseRootFromParent_Done,
     /*  39412 */   // Label 625: @39412
     /*  39412 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39507), // Rule ID 3975 //
     /*  39417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39466 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39470 */     // MIs[3] Operand 1
     /*  39470 */     // No operand predicates
     /*  39470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39472 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39484 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39505 */     GIR_RootConstrainSelectedInstOperands,
     /*  39506 */     // GIR_Coverage, 3975,
     /*  39506 */     GIR_EraseRootFromParent_Done,
     /*  39507 */   // Label 626: @39507
     /*  39507 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39589), // Rule ID 124 //
     /*  39512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39561 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39565 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39572 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39587 */     GIR_RootConstrainSelectedInstOperands,
     /*  39588 */     // GIR_Coverage, 124,
     /*  39588 */     GIR_EraseRootFromParent_Done,
     /*  39589 */   // Label 627: @39589
     /*  39589 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39671), // Rule ID 126 //
     /*  39594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39643 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39647 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39654 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39669 */     GIR_RootConstrainSelectedInstOperands,
     /*  39670 */     // GIR_Coverage, 126,
     /*  39670 */     GIR_EraseRootFromParent_Done,
     /*  39671 */   // Label 628: @39671
     /*  39671 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39733), // Rule ID 3954 //
     /*  39676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39712 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  39712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  39715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  39721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  39725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39731 */     GIR_RootConstrainSelectedInstOperands,
     /*  39732 */     // GIR_Coverage, 3954,
     /*  39732 */     GIR_EraseRootFromParent_Done,
     /*  39733 */   // Label 629: @39733
     /*  39733 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39791), // Rule ID 10006 //
     /*  39738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39757 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39760 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  39765 */     // MIs[1] pattern
     /*  39765 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39768 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39775 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  39778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39789 */     GIR_RootConstrainSelectedInstOperands,
     /*  39790 */     // GIR_Coverage, 10006,
     /*  39790 */     GIR_EraseRootFromParent_Done,
     /*  39791 */   // Label 630: @39791
     /*  39791 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39849), // Rule ID 10018 //
     /*  39796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39815 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39818 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  39823 */     // MIs[1] pattern
     /*  39823 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39826 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39833 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  39836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39847 */     GIR_RootConstrainSelectedInstOperands,
     /*  39848 */     // GIR_Coverage, 10018,
     /*  39848 */     GIR_EraseRootFromParent_Done,
     /*  39849 */   // Label 631: @39849
     /*  39849 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(39907), // Rule ID 10030 //
     /*  39854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39873 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39876 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  39881 */     // MIs[1] pattern
     /*  39881 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39884 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39891 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  39894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39905 */     GIR_RootConstrainSelectedInstOperands,
     /*  39906 */     // GIR_Coverage, 10030,
     /*  39906 */     GIR_EraseRootFromParent_Done,
     /*  39907 */   // Label 632: @39907
     /*  39907 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(39965), // Rule ID 10042 //
     /*  39912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39931 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39934 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  39939 */     // MIs[1] pattern
     /*  39939 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39942 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39949 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  39952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39963 */     GIR_RootConstrainSelectedInstOperands,
     /*  39964 */     // GIR_Coverage, 10042,
     /*  39964 */     GIR_EraseRootFromParent_Done,
     /*  39965 */   // Label 633: @39965
     /*  39965 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(40128), // Rule ID 5401 //
     /*  39970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  39998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40016 */     // MIs[1] Operand 2
     /*  40016 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40029 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40029 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40032 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40036 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40055 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40058 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40062 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40065 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40070 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40075 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  40087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40092 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40099 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40110 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40127 */     // GIR_Coverage, 5401,
     /*  40127 */     GIR_EraseRootFromParent_Done,
     /*  40128 */   // Label 634: @40128
     /*  40128 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(40291), // Rule ID 5398 //
     /*  40133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  40161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40179 */     // MIs[1] Operand 2
     /*  40179 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40192 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40192 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40195 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40199 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40218 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40221 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40225 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40228 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  40250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40273 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40290 */     // GIR_Coverage, 5398,
     /*  40290 */     GIR_EraseRootFromParent_Done,
     /*  40291 */   // Label 635: @40291
     /*  40291 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(40441), // Rule ID 5443 //
     /*  40296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40333 */     // MIs[1] Operand 2
     /*  40333 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40346 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40346 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40349 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40353 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40372 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40379 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40409 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40423 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40440 */     // GIR_Coverage, 5443,
     /*  40440 */     GIR_EraseRootFromParent_Done,
     /*  40441 */   // Label 636: @40441
     /*  40441 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40591), // Rule ID 5449 //
     /*  40446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40483 */     // MIs[1] Operand 2
     /*  40483 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40496 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40522 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40525 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40529 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40532 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40542 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  40554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40573 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40590 */     // GIR_Coverage, 5449,
     /*  40590 */     GIR_EraseRootFromParent_Done,
     /*  40591 */   // Label 637: @40591
     /*  40591 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40741), // Rule ID 5442 //
     /*  40596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40633 */     // MIs[1] Operand 2
     /*  40633 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40646 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40646 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40649 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40653 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40660 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40663 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40667 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40672 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40679 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40723 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40740 */     // GIR_Coverage, 5442,
     /*  40740 */     GIR_EraseRootFromParent_Done,
     /*  40741 */   // Label 638: @40741
     /*  40741 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40777), // Rule ID 3919 //
     /*  40746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  40761 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  40761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  40764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40766 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  40768 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  40772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40775 */     GIR_RootConstrainSelectedInstOperands,
     /*  40776 */     // GIR_Coverage, 3919,
     /*  40776 */     GIR_EraseRootFromParent_Done,
     /*  40777 */   // Label 639: @40777
     /*  40777 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40810), // Rule ID 3924 //
     /*  40782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  40797 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  40800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40808 */     GIR_RootConstrainSelectedInstOperands,
     /*  40809 */     // GIR_Coverage, 3924,
     /*  40809 */     GIR_EraseRootFromParent_Done,
     /*  40810 */   // Label 640: @40810
     /*  40810 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40846), // Rule ID 3913 //
     /*  40815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  40830 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  40833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40844 */     GIR_RootConstrainSelectedInstOperands,
     /*  40845 */     // GIR_Coverage, 3913,
     /*  40845 */     GIR_EraseRootFromParent_Done,
     /*  40846 */   // Label 641: @40846
     /*  40846 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40882), // Rule ID 3917 //
     /*  40851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  40866 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  40866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  40869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  40877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40880 */     GIR_RootConstrainSelectedInstOperands,
     /*  40881 */     // GIR_Coverage, 3917,
     /*  40881 */     GIR_EraseRootFromParent_Done,
     /*  40882 */   // Label 642: @40882
     /*  40882 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40945), // Rule ID 10139 //
     /*  40887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40906 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40909 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  40918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40925 */     // MIs[1] pred
     /*  40925 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40932 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  40935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40943 */     GIR_RootConstrainSelectedInstOperands,
     /*  40944 */     // GIR_Coverage, 10139,
     /*  40944 */     GIR_EraseRootFromParent_Done,
     /*  40945 */   // Label 643: @40945
     /*  40945 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(41008), // Rule ID 10140 //
     /*  40950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40969 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40972 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  40981 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40988 */     // MIs[1] pred
     /*  40988 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40995 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  40998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41006 */     GIR_RootConstrainSelectedInstOperands,
     /*  41007 */     // GIR_Coverage, 10140,
     /*  41007 */     GIR_EraseRootFromParent_Done,
     /*  41008 */   // Label 644: @41008
     /*  41008 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(41071), // Rule ID 10141 //
     /*  41013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41032 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41035 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  41044 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41051 */     // MIs[1] pred
     /*  41051 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41058 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  41061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41069 */     GIR_RootConstrainSelectedInstOperands,
     /*  41070 */     // GIR_Coverage, 10141,
     /*  41070 */     GIR_EraseRootFromParent_Done,
     /*  41071 */   // Label 645: @41071
     /*  41071 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(41134), // Rule ID 10142 //
     /*  41076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41095 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41098 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  41107 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41114 */     // MIs[1] pred
     /*  41114 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41121 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  41124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41132 */     GIR_RootConstrainSelectedInstOperands,
     /*  41133 */     // GIR_Coverage, 10142,
     /*  41133 */     GIR_EraseRootFromParent_Done,
     /*  41134 */   // Label 646: @41134
     /*  41134 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(41173), // Rule ID 1655 //
     /*  41139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41150 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41156 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41164 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  41164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41171 */     GIR_RootConstrainSelectedInstOperands,
     /*  41172 */     // GIR_Coverage, 1655,
     /*  41172 */     GIR_EraseRootFromParent_Done,
     /*  41173 */   // Label 647: @41173
     /*  41173 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41209), // Rule ID 5284 //
     /*  41178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41186 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41192 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41200 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  41200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41207 */     GIR_RootConstrainSelectedInstOperands,
     /*  41208 */     // GIR_Coverage, 5284,
     /*  41208 */     GIR_EraseRootFromParent_Done,
     /*  41209 */   // Label 648: @41209
     /*  41209 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(41236), // Rule ID 1644 //
     /*  41214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41229 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  41229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  41234 */     GIR_RootConstrainSelectedInstOperands,
     /*  41235 */     // GIR_Coverage, 1644,
     /*  41235 */     GIR_Done,
     /*  41236 */   // Label 649: @41236
     /*  41236 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41266), // Rule ID 3915 //
     /*  41241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41253 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  41253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  41258 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  41264 */     GIR_RootConstrainSelectedInstOperands,
     /*  41265 */     // GIR_Coverage, 3915,
     /*  41265 */     GIR_Done,
     /*  41266 */   // Label 650: @41266
     /*  41266 */   GIM_Reject,
     /*  41267 */ // Label 613: @41267
     /*  41267 */ GIM_Reject,
     /*  41268 */ // Label 586: @41268
     /*  41268 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(42758),
     /*  41273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41283 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(41415), // Rule ID 5433 //
     /*  41288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41317 */     // MIs[1] Operand 2
     /*  41317 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41336 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41340 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41344 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41348 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41352 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41357 */     // MIs[3] Operand 2
     /*  41357 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41368 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41370 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41397 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41414 */     // GIR_Coverage, 5433,
     /*  41414 */     GIR_EraseRootFromParent_Done,
     /*  41415 */   // Label 652: @41415
     /*  41415 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(41547), // Rule ID 5432 //
     /*  41420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41449 */     // MIs[1] Operand 2
     /*  41449 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41484 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41489 */     // MIs[3] Operand 2
     /*  41489 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41502 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41546 */     // GIR_Coverage, 5432,
     /*  41546 */     GIR_EraseRootFromParent_Done,
     /*  41547 */   // Label 653: @41547
     /*  41547 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(41679), // Rule ID 5445 //
     /*  41552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41581 */     // MIs[1] Operand 2
     /*  41581 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41600 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41604 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41608 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41612 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41616 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41621 */     // MIs[3] Operand 2
     /*  41621 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41632 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41634 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  41641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41661 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41678 */     // GIR_Coverage, 5445,
     /*  41678 */     GIR_EraseRootFromParent_Done,
     /*  41679 */   // Label 654: @41679
     /*  41679 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41811), // Rule ID 5431 //
     /*  41684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41713 */     // MIs[1] Operand 2
     /*  41713 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41732 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41736 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41740 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41744 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41748 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41753 */     // MIs[3] Operand 2
     /*  41753 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41764 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41766 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41793 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41810 */     // GIR_Coverage, 5431,
     /*  41810 */     GIR_EraseRootFromParent_Done,
     /*  41811 */   // Label 655: @41811
     /*  41811 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(41943), // Rule ID 5430 //
     /*  41816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41845 */     // MIs[1] Operand 2
     /*  41845 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41868 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41872 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41876 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41880 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41885 */     // MIs[3] Operand 2
     /*  41885 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41896 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41898 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41942 */     // GIR_Coverage, 5430,
     /*  41942 */     GIR_EraseRootFromParent_Done,
     /*  41943 */   // Label 656: @41943
     /*  41943 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(42102), // Rule ID 5400 //
     /*  41948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  41972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41990 */     // MIs[1] Operand 2
     /*  41990 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42003 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42003 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42006 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42010 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42017 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42020 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42024 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42029 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42032 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42036 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42039 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  42061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42066 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42069 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42084 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42101 */     // GIR_Coverage, 5400,
     /*  42101 */     GIR_EraseRootFromParent_Done,
     /*  42102 */   // Label 657: @42102
     /*  42102 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42261), // Rule ID 5397 //
     /*  42107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  42131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42149 */     // MIs[1] Operand 2
     /*  42149 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42162 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42162 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42165 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42169 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42176 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42179 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42183 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42188 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42191 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42195 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  42220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42225 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42243 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42260 */     // GIR_Coverage, 5397,
     /*  42260 */     GIR_EraseRootFromParent_Done,
     /*  42261 */   // Label 658: @42261
     /*  42261 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(42407), // Rule ID 5441 //
     /*  42266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42294 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42299 */     // MIs[1] Operand 2
     /*  42299 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42312 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42312 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42315 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42319 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42326 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42329 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42333 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42338 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42341 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42345 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42353 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42358 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42375 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42406 */     // GIR_Coverage, 5441,
     /*  42406 */     GIR_EraseRootFromParent_Done,
     /*  42407 */   // Label 659: @42407
     /*  42407 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(42553), // Rule ID 5448 //
     /*  42412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42445 */     // MIs[1] Operand 2
     /*  42445 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42458 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42458 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42461 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42465 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42472 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42475 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42479 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42484 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42491 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42499 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42504 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  42516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42521 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42524 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42535 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42552 */     // GIR_Coverage, 5448,
     /*  42552 */     GIR_EraseRootFromParent_Done,
     /*  42553 */   // Label 660: @42553
     /*  42553 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(42699), // Rule ID 5440 //
     /*  42558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42591 */     // MIs[1] Operand 2
     /*  42591 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42604 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42604 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42607 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42611 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42618 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42621 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42625 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42630 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42633 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42637 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42640 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42645 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42667 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42681 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42698 */     // GIR_Coverage, 5440,
     /*  42698 */     GIR_EraseRootFromParent_Done,
     /*  42699 */   // Label 661: @42699
     /*  42699 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(42734), // Rule ID 969 //
     /*  42704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42711 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42717 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42725 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  42725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  42728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42732 */     GIR_RootConstrainSelectedInstOperands,
     /*  42733 */     // GIR_Coverage, 969,
     /*  42733 */     GIR_EraseRootFromParent_Done,
     /*  42734 */   // Label 662: @42734
     /*  42734 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(42757), // Rule ID 1476 //
     /*  42739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42750 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  42755 */     GIR_RootConstrainSelectedInstOperands,
     /*  42756 */     // GIR_Coverage, 1476,
     /*  42756 */     GIR_Done,
     /*  42757 */   // Label 663: @42757
     /*  42757 */   GIM_Reject,
     /*  42758 */ // Label 651: @42758
     /*  42758 */ GIM_Reject,
     /*  42759 */ // Label 587: @42759
     /*  42759 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(45218),
     /*  42764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  42767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  42770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42774 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(42888), // Rule ID 2048 //
     /*  42779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42826 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42830 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42835 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42839 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42843 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42847 */     // MIs[4] Operand 1
     /*  42847 */     // No operand predicates
     /*  42847 */     // MIs[2] Operand 2
     /*  42847 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42858 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42867 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42886 */     GIR_RootConstrainSelectedInstOperands,
     /*  42887 */     // GIR_Coverage, 2048,
     /*  42887 */     GIR_EraseRootFromParent_Done,
     /*  42888 */   // Label 665: @42888
     /*  42888 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(43002), // Rule ID 13580 //
     /*  42893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42936 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42940 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42944 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42949 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42953 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42957 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42961 */     // MIs[4] Operand 1
     /*  42961 */     // No operand predicates
     /*  42961 */     // MIs[2] Operand 2
     /*  42961 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42972 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42981 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43000 */     GIR_RootConstrainSelectedInstOperands,
     /*  43001 */     // GIR_Coverage, 13580,
     /*  43001 */     GIR_EraseRootFromParent_Done,
     /*  43002 */   // Label 666: @43002
     /*  43002 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(43116), // Rule ID 2100 //
     /*  43007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43054 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43058 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43071 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43075 */     // MIs[4] Operand 1
     /*  43075 */     // No operand predicates
     /*  43075 */     // MIs[2] Operand 2
     /*  43075 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43095 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43114 */     GIR_RootConstrainSelectedInstOperands,
     /*  43115 */     // GIR_Coverage, 2100,
     /*  43115 */     GIR_EraseRootFromParent_Done,
     /*  43116 */   // Label 667: @43116
     /*  43116 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(43230), // Rule ID 13610 //
     /*  43121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43164 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43168 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43172 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43177 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43181 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43185 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43189 */     // MIs[4] Operand 1
     /*  43189 */     // No operand predicates
     /*  43189 */     // MIs[2] Operand 2
     /*  43189 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43200 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43209 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43228 */     GIR_RootConstrainSelectedInstOperands,
     /*  43229 */     // GIR_Coverage, 13610,
     /*  43229 */     GIR_EraseRootFromParent_Done,
     /*  43230 */   // Label 668: @43230
     /*  43230 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(43295), // Rule ID 1855 //
     /*  43235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43278 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43293 */     GIR_RootConstrainSelectedInstOperands,
     /*  43294 */     // GIR_Coverage, 1855,
     /*  43294 */     GIR_EraseRootFromParent_Done,
     /*  43295 */   // Label 669: @43295
     /*  43295 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(43360), // Rule ID 1854 //
     /*  43300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43343 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43358 */     GIR_RootConstrainSelectedInstOperands,
     /*  43359 */     // GIR_Coverage, 1854,
     /*  43359 */     GIR_EraseRootFromParent_Done,
     /*  43360 */   // Label 670: @43360
     /*  43360 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(43425), // Rule ID 1759 //
     /*  43365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43408 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  43411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43423 */     GIR_RootConstrainSelectedInstOperands,
     /*  43424 */     // GIR_Coverage, 1759,
     /*  43424 */     GIR_EraseRootFromParent_Done,
     /*  43425 */   // Label 671: @43425
     /*  43425 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43490), // Rule ID 1853 //
     /*  43430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43473 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43488 */     GIR_RootConstrainSelectedInstOperands,
     /*  43489 */     // GIR_Coverage, 1853,
     /*  43489 */     GIR_EraseRootFromParent_Done,
     /*  43490 */   // Label 672: @43490
     /*  43490 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43555), // Rule ID 1852 //
     /*  43495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43538 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43553 */     GIR_RootConstrainSelectedInstOperands,
     /*  43554 */     // GIR_Coverage, 1852,
     /*  43554 */     GIR_EraseRootFromParent_Done,
     /*  43555 */   // Label 673: @43555
     /*  43555 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43666), // Rule ID 13578 //
     /*  43560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43603 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43607 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43611 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43620 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43624 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43628 */     // MIs[4] Operand 1
     /*  43628 */     // No operand predicates
     /*  43628 */     // MIs[2] Operand 2
     /*  43628 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43644 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43646 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43664 */     GIR_RootConstrainSelectedInstOperands,
     /*  43665 */     // GIR_Coverage, 13578,
     /*  43665 */     GIR_EraseRootFromParent_Done,
     /*  43666 */   // Label 674: @43666
     /*  43666 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43777), // Rule ID 2046 //
     /*  43671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43719 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43723 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43727 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43736 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43740 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43744 */     // MIs[4] Operand 1
     /*  43744 */     // No operand predicates
     /*  43744 */     // MIs[2] Operand 2
     /*  43744 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43755 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43757 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43775 */     GIR_RootConstrainSelectedInstOperands,
     /*  43776 */     // GIR_Coverage, 2046,
     /*  43776 */     GIR_EraseRootFromParent_Done,
     /*  43777 */   // Label 675: @43777
     /*  43777 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(43888), // Rule ID 13608 //
     /*  43782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43825 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43829 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43833 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43838 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43842 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43846 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43850 */     // MIs[4] Operand 1
     /*  43850 */     // No operand predicates
     /*  43850 */     // MIs[2] Operand 2
     /*  43850 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43866 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43868 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43886 */     GIR_RootConstrainSelectedInstOperands,
     /*  43887 */     // GIR_Coverage, 13608,
     /*  43887 */     GIR_EraseRootFromParent_Done,
     /*  43888 */   // Label 676: @43888
     /*  43888 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(43999), // Rule ID 2098 //
     /*  43893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43941 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43945 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43949 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43962 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43966 */     // MIs[4] Operand 1
     /*  43966 */     // No operand predicates
     /*  43966 */     // MIs[2] Operand 2
     /*  43966 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43977 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43979 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43997 */     GIR_RootConstrainSelectedInstOperands,
     /*  43998 */     // GIR_Coverage, 2098,
     /*  43998 */     GIR_EraseRootFromParent_Done,
     /*  43999 */   // Label 677: @43999
     /*  43999 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(44062), // Rule ID 1735 //
     /*  44004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44043 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  44046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44060 */     GIR_RootConstrainSelectedInstOperands,
     /*  44061 */     // GIR_Coverage, 1735,
     /*  44061 */     GIR_EraseRootFromParent_Done,
     /*  44062 */   // Label 678: @44062
     /*  44062 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44125), // Rule ID 1825 //
     /*  44067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44106 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  44109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44123 */     GIR_RootConstrainSelectedInstOperands,
     /*  44124 */     // GIR_Coverage, 1825,
     /*  44124 */     GIR_EraseRootFromParent_Done,
     /*  44125 */   // Label 679: @44125
     /*  44125 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(44213), // Rule ID 13579 //
     /*  44130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44182 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44186 */     // MIs[3] Operand 1
     /*  44186 */     // No operand predicates
     /*  44186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44193 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44211 */     GIR_RootConstrainSelectedInstOperands,
     /*  44212 */     // GIR_Coverage, 13579,
     /*  44212 */     GIR_EraseRootFromParent_Done,
     /*  44213 */   // Label 680: @44213
     /*  44213 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(44301), // Rule ID 2047 //
     /*  44218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44275 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44279 */     // MIs[3] Operand 1
     /*  44279 */     // No operand predicates
     /*  44279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44281 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44299 */     GIR_RootConstrainSelectedInstOperands,
     /*  44300 */     // GIR_Coverage, 2047,
     /*  44300 */     GIR_EraseRootFromParent_Done,
     /*  44301 */   // Label 681: @44301
     /*  44301 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44389), // Rule ID 13609 //
     /*  44306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44358 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44362 */     // MIs[3] Operand 1
     /*  44362 */     // No operand predicates
     /*  44362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44369 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44387 */     GIR_RootConstrainSelectedInstOperands,
     /*  44388 */     // GIR_Coverage, 13609,
     /*  44388 */     GIR_EraseRootFromParent_Done,
     /*  44389 */   // Label 682: @44389
     /*  44389 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44477), // Rule ID 2099 //
     /*  44394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44451 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44455 */     // MIs[3] Operand 1
     /*  44455 */     // No operand predicates
     /*  44455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44457 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44475 */     GIR_RootConstrainSelectedInstOperands,
     /*  44476 */     // GIR_Coverage, 2099,
     /*  44476 */     GIR_EraseRootFromParent_Done,
     /*  44477 */   // Label 683: @44477
     /*  44477 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44524), // Rule ID 1867 //
     /*  44482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44510 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44522 */     GIR_RootConstrainSelectedInstOperands,
     /*  44523 */     // GIR_Coverage, 1867,
     /*  44523 */     GIR_EraseRootFromParent_Done,
     /*  44524 */   // Label 684: @44524
     /*  44524 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44571), // Rule ID 1765 //
     /*  44529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44557 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  44560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44569 */     GIR_RootConstrainSelectedInstOperands,
     /*  44570 */     // GIR_Coverage, 1765,
     /*  44570 */     GIR_EraseRootFromParent_Done,
     /*  44571 */   // Label 685: @44571
     /*  44571 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44618), // Rule ID 1866 //
     /*  44576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44604 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44616 */     GIR_RootConstrainSelectedInstOperands,
     /*  44617 */     // GIR_Coverage, 1866,
     /*  44617 */     GIR_EraseRootFromParent_Done,
     /*  44618 */   // Label 686: @44618
     /*  44618 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(44677), // Rule ID 1851 //
     /*  44623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44662 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44675 */     GIR_RootConstrainSelectedInstOperands,
     /*  44676 */     // GIR_Coverage, 1851,
     /*  44676 */     GIR_EraseRootFromParent_Done,
     /*  44677 */   // Label 687: @44677
     /*  44677 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(44736), // Rule ID 1850 //
     /*  44682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44721 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44734 */     GIR_RootConstrainSelectedInstOperands,
     /*  44735 */     // GIR_Coverage, 1850,
     /*  44735 */     GIR_EraseRootFromParent_Done,
     /*  44736 */   // Label 688: @44736
     /*  44736 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44795), // Rule ID 1758 //
     /*  44741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44780 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  44783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44793 */     GIR_RootConstrainSelectedInstOperands,
     /*  44794 */     // GIR_Coverage, 1758,
     /*  44794 */     GIR_EraseRootFromParent_Done,
     /*  44795 */   // Label 689: @44795
     /*  44795 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44854), // Rule ID 1849 //
     /*  44800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44839 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44852 */     GIR_RootConstrainSelectedInstOperands,
     /*  44853 */     // GIR_Coverage, 1849,
     /*  44853 */     GIR_EraseRootFromParent_Done,
     /*  44854 */   // Label 690: @44854
     /*  44854 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44913), // Rule ID 1848 //
     /*  44859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44898 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44911 */     GIR_RootConstrainSelectedInstOperands,
     /*  44912 */     // GIR_Coverage, 1848,
     /*  44912 */     GIR_EraseRootFromParent_Done,
     /*  44913 */   // Label 691: @44913
     /*  44913 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(44948), // Rule ID 971 //
     /*  44918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44925 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44931 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  44933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44939 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  44939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  44942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  44946 */     GIR_RootConstrainSelectedInstOperands,
     /*  44947 */     // GIR_Coverage, 971,
     /*  44947 */     GIR_EraseRootFromParent_Done,
     /*  44948 */   // Label 692: @44948
     /*  44948 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(45005), // Rule ID 1734 //
     /*  44953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44988 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  44991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45003 */     GIR_RootConstrainSelectedInstOperands,
     /*  45004 */     // GIR_Coverage, 1734,
     /*  45004 */     GIR_EraseRootFromParent_Done,
     /*  45005 */   // Label 693: @45005
     /*  45005 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(45062), // Rule ID 1824 //
     /*  45010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45045 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  45048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45060 */     GIR_RootConstrainSelectedInstOperands,
     /*  45061 */     // GIR_Coverage, 1824,
     /*  45061 */     GIR_EraseRootFromParent_Done,
     /*  45062 */   // Label 694: @45062
     /*  45062 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(45106), // Rule ID 1865 //
     /*  45067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45093 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45104 */     GIR_RootConstrainSelectedInstOperands,
     /*  45105 */     // GIR_Coverage, 1865,
     /*  45105 */     GIR_EraseRootFromParent_Done,
     /*  45106 */   // Label 695: @45106
     /*  45106 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(45150), // Rule ID 1764 //
     /*  45111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45137 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  45140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45148 */     GIR_RootConstrainSelectedInstOperands,
     /*  45149 */     // GIR_Coverage, 1764,
     /*  45149 */     GIR_EraseRootFromParent_Done,
     /*  45150 */   // Label 696: @45150
     /*  45150 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(45194), // Rule ID 1864 //
     /*  45155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45181 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45192 */     GIR_RootConstrainSelectedInstOperands,
     /*  45193 */     // GIR_Coverage, 1864,
     /*  45193 */     GIR_EraseRootFromParent_Done,
     /*  45194 */   // Label 697: @45194
     /*  45194 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45217), // Rule ID 1478 //
     /*  45199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45210 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  45210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  45215 */     GIR_RootConstrainSelectedInstOperands,
     /*  45216 */     // GIR_Coverage, 1478,
     /*  45216 */     GIR_Done,
     /*  45217 */   // Label 698: @45217
     /*  45217 */   GIM_Reject,
     /*  45218 */ // Label 664: @45218
     /*  45218 */ GIM_Reject,
     /*  45219 */ // Label 588: @45219
     /*  45219 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(46709),
     /*  45224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45234 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45366), // Rule ID 5429 //
     /*  45239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45268 */     // MIs[1] Operand 2
     /*  45268 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45287 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45291 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45295 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45299 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45303 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45308 */     // MIs[3] Operand 2
     /*  45308 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45319 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45321 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45337 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45348 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45365 */     // GIR_Coverage, 5429,
     /*  45365 */     GIR_EraseRootFromParent_Done,
     /*  45366 */   // Label 700: @45366
     /*  45366 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(45498), // Rule ID 5428 //
     /*  45371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45400 */     // MIs[1] Operand 2
     /*  45400 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45419 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45431 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45435 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45440 */     // MIs[3] Operand 2
     /*  45440 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45451 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45453 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45465 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45480 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45497 */     // GIR_Coverage, 5428,
     /*  45497 */     GIR_EraseRootFromParent_Done,
     /*  45498 */   // Label 701: @45498
     /*  45498 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(45630), // Rule ID 5444 //
     /*  45503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45532 */     // MIs[1] Operand 2
     /*  45532 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45551 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45555 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45559 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45563 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45567 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45572 */     // MIs[3] Operand 2
     /*  45572 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45583 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45585 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  45592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45597 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45612 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45629 */     // GIR_Coverage, 5444,
     /*  45629 */     GIR_EraseRootFromParent_Done,
     /*  45630 */   // Label 702: @45630
     /*  45630 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(45762), // Rule ID 5427 //
     /*  45635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45664 */     // MIs[1] Operand 2
     /*  45664 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45691 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45695 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45699 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45704 */     // MIs[3] Operand 2
     /*  45704 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45715 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45717 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45733 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45744 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45761 */     // GIR_Coverage, 5427,
     /*  45761 */     GIR_EraseRootFromParent_Done,
     /*  45762 */   // Label 703: @45762
     /*  45762 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(45894), // Rule ID 5426 //
     /*  45767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45796 */     // MIs[1] Operand 2
     /*  45796 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45815 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45819 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45823 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45827 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45831 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45836 */     // MIs[3] Operand 2
     /*  45836 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45847 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45849 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45876 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45893 */     // GIR_Coverage, 5426,
     /*  45893 */     GIR_EraseRootFromParent_Done,
     /*  45894 */   // Label 704: @45894
     /*  45894 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(46053), // Rule ID 5399 //
     /*  45899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  45923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  45931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45941 */     // MIs[1] Operand 2
     /*  45941 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45954 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45954 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  45957 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45961 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45968 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  45971 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45975 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45980 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  45987 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  45990 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45995 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46000 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  46012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46017 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46020 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46024 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46035 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46052 */     // GIR_Coverage, 5399,
     /*  46052 */     GIR_EraseRootFromParent_Done,
     /*  46053 */   // Label 705: @46053
     /*  46053 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(46212), // Rule ID 5396 //
     /*  46058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  46082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46100 */     // MIs[1] Operand 2
     /*  46100 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46113 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46113 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46116 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46120 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46127 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46130 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46134 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46139 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46142 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  46146 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46149 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46154 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  46171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46179 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46183 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46194 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46211 */     // GIR_Coverage, 5396,
     /*  46211 */     GIR_EraseRootFromParent_Done,
     /*  46212 */   // Label 706: @46212
     /*  46212 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(46358), // Rule ID 5439 //
     /*  46217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46250 */     // MIs[1] Operand 2
     /*  46250 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46263 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46263 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46266 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46270 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46277 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46280 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46284 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46289 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46292 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46296 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46299 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46304 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46309 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46326 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46340 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46357 */     // GIR_Coverage, 5439,
     /*  46357 */     GIR_EraseRootFromParent_Done,
     /*  46358 */   // Label 707: @46358
     /*  46358 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(46504), // Rule ID 5447 //
     /*  46363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46396 */     // MIs[1] Operand 2
     /*  46396 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46409 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46409 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46412 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46416 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46423 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46426 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46430 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46435 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46438 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46442 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46455 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  46467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46472 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46475 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46486 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46503 */     // GIR_Coverage, 5447,
     /*  46503 */     GIR_EraseRootFromParent_Done,
     /*  46504 */   // Label 708: @46504
     /*  46504 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46650), // Rule ID 5438 //
     /*  46509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46542 */     // MIs[1] Operand 2
     /*  46542 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46555 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46555 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46558 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46562 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46581 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46584 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46588 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46591 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46596 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46601 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46618 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46621 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46632 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46649 */     // GIR_Coverage, 5438,
     /*  46649 */     GIR_EraseRootFromParent_Done,
     /*  46650 */   // Label 709: @46650
     /*  46650 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(46685), // Rule ID 967 //
     /*  46655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46662 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46668 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46676 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  46676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  46679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46683 */     GIR_RootConstrainSelectedInstOperands,
     /*  46684 */     // GIR_Coverage, 967,
     /*  46684 */     GIR_EraseRootFromParent_Done,
     /*  46685 */   // Label 710: @46685
     /*  46685 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(46708), // Rule ID 1474 //
     /*  46690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46701 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  46706 */     GIR_RootConstrainSelectedInstOperands,
     /*  46707 */     // GIR_Coverage, 1474,
     /*  46707 */     GIR_Done,
     /*  46708 */   // Label 711: @46708
     /*  46708 */   GIM_Reject,
     /*  46709 */ // Label 699: @46709
     /*  46709 */ GIM_Reject,
     /*  46710 */ // Label 589: @46710
     /*  46710 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(49169),
     /*  46715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46725 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(46839), // Rule ID 2045 //
     /*  46730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46781 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46794 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46798 */     // MIs[4] Operand 1
     /*  46798 */     // No operand predicates
     /*  46798 */     // MIs[2] Operand 2
     /*  46798 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46809 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46818 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46837 */     GIR_RootConstrainSelectedInstOperands,
     /*  46838 */     // GIR_Coverage, 2045,
     /*  46838 */     GIR_EraseRootFromParent_Done,
     /*  46839 */   // Label 713: @46839
     /*  46839 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(46953), // Rule ID 13577 //
     /*  46844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46887 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46891 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46895 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46900 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46904 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46908 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46912 */     // MIs[4] Operand 1
     /*  46912 */     // No operand predicates
     /*  46912 */     // MIs[2] Operand 2
     /*  46912 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46923 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46932 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46951 */     GIR_RootConstrainSelectedInstOperands,
     /*  46952 */     // GIR_Coverage, 13577,
     /*  46952 */     GIR_EraseRootFromParent_Done,
     /*  46953 */   // Label 714: @46953
     /*  46953 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(47067), // Rule ID 2097 //
     /*  46958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47001 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47005 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47009 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47018 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47022 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47026 */     // MIs[4] Operand 1
     /*  47026 */     // No operand predicates
     /*  47026 */     // MIs[2] Operand 2
     /*  47026 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47037 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47046 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47065 */     GIR_RootConstrainSelectedInstOperands,
     /*  47066 */     // GIR_Coverage, 2097,
     /*  47066 */     GIR_EraseRootFromParent_Done,
     /*  47067 */   // Label 715: @47067
     /*  47067 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(47181), // Rule ID 13607 //
     /*  47072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47115 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47119 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47123 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47128 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47132 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47136 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47140 */     // MIs[4] Operand 1
     /*  47140 */     // No operand predicates
     /*  47140 */     // MIs[2] Operand 2
     /*  47140 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47151 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47160 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47179 */     GIR_RootConstrainSelectedInstOperands,
     /*  47180 */     // GIR_Coverage, 13607,
     /*  47180 */     GIR_EraseRootFromParent_Done,
     /*  47181 */   // Label 716: @47181
     /*  47181 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(47246), // Rule ID 1847 //
     /*  47186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47229 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47244 */     GIR_RootConstrainSelectedInstOperands,
     /*  47245 */     // GIR_Coverage, 1847,
     /*  47245 */     GIR_EraseRootFromParent_Done,
     /*  47246 */   // Label 717: @47246
     /*  47246 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(47311), // Rule ID 1846 //
     /*  47251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47294 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47309 */     GIR_RootConstrainSelectedInstOperands,
     /*  47310 */     // GIR_Coverage, 1846,
     /*  47310 */     GIR_EraseRootFromParent_Done,
     /*  47311 */   // Label 718: @47311
     /*  47311 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(47376), // Rule ID 1757 //
     /*  47316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47359 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  47362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47374 */     GIR_RootConstrainSelectedInstOperands,
     /*  47375 */     // GIR_Coverage, 1757,
     /*  47375 */     GIR_EraseRootFromParent_Done,
     /*  47376 */   // Label 719: @47376
     /*  47376 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47441), // Rule ID 1845 //
     /*  47381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47424 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47439 */     GIR_RootConstrainSelectedInstOperands,
     /*  47440 */     // GIR_Coverage, 1845,
     /*  47440 */     GIR_EraseRootFromParent_Done,
     /*  47441 */   // Label 720: @47441
     /*  47441 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47506), // Rule ID 1844 //
     /*  47446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47489 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47504 */     GIR_RootConstrainSelectedInstOperands,
     /*  47505 */     // GIR_Coverage, 1844,
     /*  47505 */     GIR_EraseRootFromParent_Done,
     /*  47506 */   // Label 721: @47506
     /*  47506 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47617), // Rule ID 13575 //
     /*  47511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47554 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47558 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47562 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47567 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47571 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47575 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47579 */     // MIs[4] Operand 1
     /*  47579 */     // No operand predicates
     /*  47579 */     // MIs[2] Operand 2
     /*  47579 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47595 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47597 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47615 */     GIR_RootConstrainSelectedInstOperands,
     /*  47616 */     // GIR_Coverage, 13575,
     /*  47616 */     GIR_EraseRootFromParent_Done,
     /*  47617 */   // Label 722: @47617
     /*  47617 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47728), // Rule ID 2043 //
     /*  47622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47674 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47678 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47683 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47687 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47691 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47695 */     // MIs[4] Operand 1
     /*  47695 */     // No operand predicates
     /*  47695 */     // MIs[2] Operand 2
     /*  47695 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47706 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47708 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47726 */     GIR_RootConstrainSelectedInstOperands,
     /*  47727 */     // GIR_Coverage, 2043,
     /*  47727 */     GIR_EraseRootFromParent_Done,
     /*  47728 */   // Label 723: @47728
     /*  47728 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(47839), // Rule ID 13605 //
     /*  47733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47776 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47780 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47784 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47789 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47793 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47797 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47801 */     // MIs[4] Operand 1
     /*  47801 */     // No operand predicates
     /*  47801 */     // MIs[2] Operand 2
     /*  47801 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47817 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47819 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47837 */     GIR_RootConstrainSelectedInstOperands,
     /*  47838 */     // GIR_Coverage, 13605,
     /*  47838 */     GIR_EraseRootFromParent_Done,
     /*  47839 */   // Label 724: @47839
     /*  47839 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(47950), // Rule ID 2095 //
     /*  47844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47892 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47896 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47900 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47913 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47917 */     // MIs[4] Operand 1
     /*  47917 */     // No operand predicates
     /*  47917 */     // MIs[2] Operand 2
     /*  47917 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47928 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47930 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47948 */     GIR_RootConstrainSelectedInstOperands,
     /*  47949 */     // GIR_Coverage, 2095,
     /*  47949 */     GIR_EraseRootFromParent_Done,
     /*  47950 */   // Label 725: @47950
     /*  47950 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(48013), // Rule ID 1733 //
     /*  47955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47994 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  47997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48011 */     GIR_RootConstrainSelectedInstOperands,
     /*  48012 */     // GIR_Coverage, 1733,
     /*  48012 */     GIR_EraseRootFromParent_Done,
     /*  48013 */   // Label 726: @48013
     /*  48013 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(48076), // Rule ID 1823 //
     /*  48018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48057 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  48060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48074 */     GIR_RootConstrainSelectedInstOperands,
     /*  48075 */     // GIR_Coverage, 1823,
     /*  48075 */     GIR_EraseRootFromParent_Done,
     /*  48076 */   // Label 727: @48076
     /*  48076 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(48164), // Rule ID 13576 //
     /*  48081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48133 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48137 */     // MIs[3] Operand 1
     /*  48137 */     // No operand predicates
     /*  48137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48144 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48162 */     GIR_RootConstrainSelectedInstOperands,
     /*  48163 */     // GIR_Coverage, 13576,
     /*  48163 */     GIR_EraseRootFromParent_Done,
     /*  48164 */   // Label 728: @48164
     /*  48164 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(48252), // Rule ID 2044 //
     /*  48169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48226 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48230 */     // MIs[3] Operand 1
     /*  48230 */     // No operand predicates
     /*  48230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48232 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48250 */     GIR_RootConstrainSelectedInstOperands,
     /*  48251 */     // GIR_Coverage, 2044,
     /*  48251 */     GIR_EraseRootFromParent_Done,
     /*  48252 */   // Label 729: @48252
     /*  48252 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(48340), // Rule ID 13606 //
     /*  48257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48309 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48313 */     // MIs[3] Operand 1
     /*  48313 */     // No operand predicates
     /*  48313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48320 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48338 */     GIR_RootConstrainSelectedInstOperands,
     /*  48339 */     // GIR_Coverage, 13606,
     /*  48339 */     GIR_EraseRootFromParent_Done,
     /*  48340 */   // Label 730: @48340
     /*  48340 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48428), // Rule ID 2096 //
     /*  48345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48402 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48406 */     // MIs[3] Operand 1
     /*  48406 */     // No operand predicates
     /*  48406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48408 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48426 */     GIR_RootConstrainSelectedInstOperands,
     /*  48427 */     // GIR_Coverage, 2096,
     /*  48427 */     GIR_EraseRootFromParent_Done,
     /*  48428 */   // Label 731: @48428
     /*  48428 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48475), // Rule ID 1863 //
     /*  48433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48461 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48473 */     GIR_RootConstrainSelectedInstOperands,
     /*  48474 */     // GIR_Coverage, 1863,
     /*  48474 */     GIR_EraseRootFromParent_Done,
     /*  48475 */   // Label 732: @48475
     /*  48475 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48522), // Rule ID 1763 //
     /*  48480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48508 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  48511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48520 */     GIR_RootConstrainSelectedInstOperands,
     /*  48521 */     // GIR_Coverage, 1763,
     /*  48521 */     GIR_EraseRootFromParent_Done,
     /*  48522 */   // Label 733: @48522
     /*  48522 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48569), // Rule ID 1862 //
     /*  48527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48555 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48567 */     GIR_RootConstrainSelectedInstOperands,
     /*  48568 */     // GIR_Coverage, 1862,
     /*  48568 */     GIR_EraseRootFromParent_Done,
     /*  48569 */   // Label 734: @48569
     /*  48569 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48628), // Rule ID 1843 //
     /*  48574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48613 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48626 */     GIR_RootConstrainSelectedInstOperands,
     /*  48627 */     // GIR_Coverage, 1843,
     /*  48627 */     GIR_EraseRootFromParent_Done,
     /*  48628 */   // Label 735: @48628
     /*  48628 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(48687), // Rule ID 1842 //
     /*  48633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48672 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48685 */     GIR_RootConstrainSelectedInstOperands,
     /*  48686 */     // GIR_Coverage, 1842,
     /*  48686 */     GIR_EraseRootFromParent_Done,
     /*  48687 */   // Label 736: @48687
     /*  48687 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(48746), // Rule ID 1756 //
     /*  48692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48731 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  48734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48744 */     GIR_RootConstrainSelectedInstOperands,
     /*  48745 */     // GIR_Coverage, 1756,
     /*  48745 */     GIR_EraseRootFromParent_Done,
     /*  48746 */   // Label 737: @48746
     /*  48746 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(48805), // Rule ID 1841 //
     /*  48751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48790 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48803 */     GIR_RootConstrainSelectedInstOperands,
     /*  48804 */     // GIR_Coverage, 1841,
     /*  48804 */     GIR_EraseRootFromParent_Done,
     /*  48805 */   // Label 738: @48805
     /*  48805 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(48864), // Rule ID 1840 //
     /*  48810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48849 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48862 */     GIR_RootConstrainSelectedInstOperands,
     /*  48863 */     // GIR_Coverage, 1840,
     /*  48863 */     GIR_EraseRootFromParent_Done,
     /*  48864 */   // Label 739: @48864
     /*  48864 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(48899), // Rule ID 970 //
     /*  48869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48876 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48882 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  48884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48890 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  48890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  48893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48897 */     GIR_RootConstrainSelectedInstOperands,
     /*  48898 */     // GIR_Coverage, 970,
     /*  48898 */     GIR_EraseRootFromParent_Done,
     /*  48899 */   // Label 740: @48899
     /*  48899 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(48956), // Rule ID 1732 //
     /*  48904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48939 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  48942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  48954 */     GIR_RootConstrainSelectedInstOperands,
     /*  48955 */     // GIR_Coverage, 1732,
     /*  48955 */     GIR_EraseRootFromParent_Done,
     /*  48956 */   // Label 741: @48956
     /*  48956 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(49013), // Rule ID 1822 //
     /*  48961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48996 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  48999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  49011 */     GIR_RootConstrainSelectedInstOperands,
     /*  49012 */     // GIR_Coverage, 1822,
     /*  49012 */     GIR_EraseRootFromParent_Done,
     /*  49013 */   // Label 742: @49013
     /*  49013 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(49057), // Rule ID 1861 //
     /*  49018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49044 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49055 */     GIR_RootConstrainSelectedInstOperands,
     /*  49056 */     // GIR_Coverage, 1861,
     /*  49056 */     GIR_EraseRootFromParent_Done,
     /*  49057 */   // Label 743: @49057
     /*  49057 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(49101), // Rule ID 1762 //
     /*  49062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49088 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  49091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49099 */     GIR_RootConstrainSelectedInstOperands,
     /*  49100 */     // GIR_Coverage, 1762,
     /*  49100 */     GIR_EraseRootFromParent_Done,
     /*  49101 */   // Label 744: @49101
     /*  49101 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(49145), // Rule ID 1860 //
     /*  49106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49132 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49143 */     GIR_RootConstrainSelectedInstOperands,
     /*  49144 */     // GIR_Coverage, 1860,
     /*  49144 */     GIR_EraseRootFromParent_Done,
     /*  49145 */   // Label 745: @49145
     /*  49145 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49168), // Rule ID 1477 //
     /*  49150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49161 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  49166 */     GIR_RootConstrainSelectedInstOperands,
     /*  49167 */     // GIR_Coverage, 1477,
     /*  49167 */     GIR_Done,
     /*  49168 */   // Label 746: @49168
     /*  49168 */   GIM_Reject,
     /*  49169 */ // Label 712: @49169
     /*  49169 */ GIM_Reject,
     /*  49170 */ // Label 590: @49170
     /*  49170 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49244),
     /*  49175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49185 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(49220), // Rule ID 965 //
     /*  49190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49197 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  49203 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  49205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49211 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  49211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  49214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49218 */     GIR_RootConstrainSelectedInstOperands,
     /*  49219 */     // GIR_Coverage, 965,
     /*  49219 */     GIR_EraseRootFromParent_Done,
     /*  49220 */   // Label 748: @49220
     /*  49220 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49243), // Rule ID 1472 //
     /*  49225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49236 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  49241 */     GIR_RootConstrainSelectedInstOperands,
     /*  49242 */     // GIR_Coverage, 1472,
     /*  49242 */     GIR_Done,
     /*  49243 */   // Label 749: @49243
     /*  49243 */   GIM_Reject,
     /*  49244 */ // Label 747: @49244
     /*  49244 */ GIM_Reject,
     /*  49245 */ // Label 591: @49245
     /*  49245 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(50452),
     /*  49250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49260 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(49325), // Rule ID 1839 //
     /*  49265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49308 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49323 */     GIR_RootConstrainSelectedInstOperands,
     /*  49324 */     // GIR_Coverage, 1839,
     /*  49324 */     GIR_EraseRootFromParent_Done,
     /*  49325 */   // Label 751: @49325
     /*  49325 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(49390), // Rule ID 1838 //
     /*  49330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49373 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49388 */     GIR_RootConstrainSelectedInstOperands,
     /*  49389 */     // GIR_Coverage, 1838,
     /*  49389 */     GIR_EraseRootFromParent_Done,
     /*  49390 */   // Label 752: @49390
     /*  49390 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(49455), // Rule ID 1755 //
     /*  49395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49438 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  49441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49453 */     GIR_RootConstrainSelectedInstOperands,
     /*  49454 */     // GIR_Coverage, 1755,
     /*  49454 */     GIR_EraseRootFromParent_Done,
     /*  49455 */   // Label 753: @49455
     /*  49455 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(49520), // Rule ID 1837 //
     /*  49460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49503 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49518 */     GIR_RootConstrainSelectedInstOperands,
     /*  49519 */     // GIR_Coverage, 1837,
     /*  49519 */     GIR_EraseRootFromParent_Done,
     /*  49520 */   // Label 754: @49520
     /*  49520 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(49585), // Rule ID 1836 //
     /*  49525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49568 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49583 */     GIR_RootConstrainSelectedInstOperands,
     /*  49584 */     // GIR_Coverage, 1836,
     /*  49584 */     GIR_EraseRootFromParent_Done,
     /*  49585 */   // Label 755: @49585
     /*  49585 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(49648), // Rule ID 1731 //
     /*  49590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49629 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  49632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49646 */     GIR_RootConstrainSelectedInstOperands,
     /*  49647 */     // GIR_Coverage, 1731,
     /*  49647 */     GIR_EraseRootFromParent_Done,
     /*  49648 */   // Label 756: @49648
     /*  49648 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(49711), // Rule ID 1821 //
     /*  49653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49692 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  49695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49709 */     GIR_RootConstrainSelectedInstOperands,
     /*  49710 */     // GIR_Coverage, 1821,
     /*  49710 */     GIR_EraseRootFromParent_Done,
     /*  49711 */   // Label 757: @49711
     /*  49711 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(49758), // Rule ID 1859 //
     /*  49716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49744 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49756 */     GIR_RootConstrainSelectedInstOperands,
     /*  49757 */     // GIR_Coverage, 1859,
     /*  49757 */     GIR_EraseRootFromParent_Done,
     /*  49758 */   // Label 758: @49758
     /*  49758 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(49805), // Rule ID 1761 //
     /*  49763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49791 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  49794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49803 */     GIR_RootConstrainSelectedInstOperands,
     /*  49804 */     // GIR_Coverage, 1761,
     /*  49804 */     GIR_EraseRootFromParent_Done,
     /*  49805 */   // Label 759: @49805
     /*  49805 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(49852), // Rule ID 1858 //
     /*  49810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49838 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49850 */     GIR_RootConstrainSelectedInstOperands,
     /*  49851 */     // GIR_Coverage, 1858,
     /*  49851 */     GIR_EraseRootFromParent_Done,
     /*  49852 */   // Label 760: @49852
     /*  49852 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(49911), // Rule ID 1835 //
     /*  49857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49896 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49909 */     GIR_RootConstrainSelectedInstOperands,
     /*  49910 */     // GIR_Coverage, 1835,
     /*  49910 */     GIR_EraseRootFromParent_Done,
     /*  49911 */   // Label 761: @49911
     /*  49911 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(49970), // Rule ID 1834 //
     /*  49916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49955 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49968 */     GIR_RootConstrainSelectedInstOperands,
     /*  49969 */     // GIR_Coverage, 1834,
     /*  49969 */     GIR_EraseRootFromParent_Done,
     /*  49970 */   // Label 762: @49970
     /*  49970 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(50029), // Rule ID 1754 //
     /*  49975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50014 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  50017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50027 */     GIR_RootConstrainSelectedInstOperands,
     /*  50028 */     // GIR_Coverage, 1754,
     /*  50028 */     GIR_EraseRootFromParent_Done,
     /*  50029 */   // Label 763: @50029
     /*  50029 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(50088), // Rule ID 1833 //
     /*  50034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50073 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50086 */     GIR_RootConstrainSelectedInstOperands,
     /*  50087 */     // GIR_Coverage, 1833,
     /*  50087 */     GIR_EraseRootFromParent_Done,
     /*  50088 */   // Label 764: @50088
     /*  50088 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(50147), // Rule ID 1832 //
     /*  50093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50132 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50145 */     GIR_RootConstrainSelectedInstOperands,
     /*  50146 */     // GIR_Coverage, 1832,
     /*  50146 */     GIR_EraseRootFromParent_Done,
     /*  50147 */   // Label 765: @50147
     /*  50147 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50182), // Rule ID 968 //
     /*  50152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50159 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50165 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50173 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  50173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  50176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50180 */     GIR_RootConstrainSelectedInstOperands,
     /*  50181 */     // GIR_Coverage, 968,
     /*  50181 */     GIR_EraseRootFromParent_Done,
     /*  50182 */   // Label 766: @50182
     /*  50182 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50239), // Rule ID 1730 //
     /*  50187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50222 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  50225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50237 */     GIR_RootConstrainSelectedInstOperands,
     /*  50238 */     // GIR_Coverage, 1730,
     /*  50238 */     GIR_EraseRootFromParent_Done,
     /*  50239 */   // Label 767: @50239
     /*  50239 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50296), // Rule ID 1820 //
     /*  50244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50279 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  50282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50294 */     GIR_RootConstrainSelectedInstOperands,
     /*  50295 */     // GIR_Coverage, 1820,
     /*  50295 */     GIR_EraseRootFromParent_Done,
     /*  50296 */   // Label 768: @50296
     /*  50296 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50340), // Rule ID 1857 //
     /*  50301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50327 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50338 */     GIR_RootConstrainSelectedInstOperands,
     /*  50339 */     // GIR_Coverage, 1857,
     /*  50339 */     GIR_EraseRootFromParent_Done,
     /*  50340 */   // Label 769: @50340
     /*  50340 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50384), // Rule ID 1760 //
     /*  50345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50371 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  50374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50382 */     GIR_RootConstrainSelectedInstOperands,
     /*  50383 */     // GIR_Coverage, 1760,
     /*  50383 */     GIR_EraseRootFromParent_Done,
     /*  50384 */   // Label 770: @50384
     /*  50384 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(50428), // Rule ID 1856 //
     /*  50389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50415 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50426 */     GIR_RootConstrainSelectedInstOperands,
     /*  50427 */     // GIR_Coverage, 1856,
     /*  50427 */     GIR_EraseRootFromParent_Done,
     /*  50428 */   // Label 771: @50428
     /*  50428 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(50451), // Rule ID 1475 //
     /*  50433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50444 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  50444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  50449 */     GIR_RootConstrainSelectedInstOperands,
     /*  50450 */     // GIR_Coverage, 1475,
     /*  50450 */     GIR_Done,
     /*  50451 */   // Label 772: @50451
     /*  50451 */   GIM_Reject,
     /*  50452 */ // Label 750: @50452
     /*  50452 */ GIM_Reject,
     /*  50453 */ // Label 592: @50453
     /*  50453 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(50527),
     /*  50458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50468 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(50503), // Rule ID 966 //
     /*  50473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50480 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50486 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50494 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  50494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  50497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50501 */     GIR_RootConstrainSelectedInstOperands,
     /*  50502 */     // GIR_Coverage, 966,
     /*  50502 */     GIR_EraseRootFromParent_Done,
     /*  50503 */   // Label 774: @50503
     /*  50503 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(50526), // Rule ID 1473 //
     /*  50508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50519 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  50524 */     GIR_RootConstrainSelectedInstOperands,
     /*  50525 */     // GIR_Coverage, 1473,
     /*  50525 */     GIR_Done,
     /*  50526 */   // Label 775: @50526
     /*  50526 */   GIM_Reject,
     /*  50527 */ // Label 773: @50527
     /*  50527 */ GIM_Reject,
     /*  50528 */ // Label 593: @50528
     /*  50528 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(50553), // Rule ID 7509 //
     /*  50533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  50539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  50542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50546 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  50546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  50551 */   GIR_RootConstrainSelectedInstOperands,
     /*  50552 */   // GIR_Coverage, 7509,
     /*  50552 */   GIR_Done,
     /*  50553 */ // Label 776: @50553
     /*  50553 */ GIM_Reject,
     /*  50554 */ // Label 594: @50554
     /*  50554 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(50579), // Rule ID 7508 //
     /*  50559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  50565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  50568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50572 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  50572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  50577 */   GIR_RootConstrainSelectedInstOperands,
     /*  50578 */   // GIR_Coverage, 7508,
     /*  50578 */   GIR_Done,
     /*  50579 */ // Label 777: @50579
     /*  50579 */ GIM_Reject,
     /*  50580 */ // Label 595: @50580
     /*  50580 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(50605), // Rule ID 7507 //
     /*  50585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  50591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  50594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50598 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  50598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  50603 */   GIR_RootConstrainSelectedInstOperands,
     /*  50604 */   // GIR_Coverage, 7507,
     /*  50604 */   GIR_Done,
     /*  50605 */ // Label 778: @50605
     /*  50605 */ GIM_Reject,
     /*  50606 */ // Label 596: @50606
     /*  50606 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(50631), // Rule ID 7506 //
     /*  50611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  50617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  50620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50624 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  50624 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  50629 */   GIR_RootConstrainSelectedInstOperands,
     /*  50630 */   // GIR_Coverage, 7506,
     /*  50630 */   GIR_Done,
     /*  50631 */ // Label 779: @50631
     /*  50631 */ GIM_Reject,
     /*  50632 */ // Label 597: @50632
     /*  50632 */ GIM_Reject,
     /*  50633 */ // Label 2: @50633
     /*  50633 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 788*/ GIMT_Encode4(53153),
     /*  50644 */ /*GILLT_s32*//*Label 780*/ GIMT_Encode4(50684),
     /*  50648 */ /*GILLT_s64*//*Label 781*/ GIMT_Encode4(50841), GIMT_Encode4(0),
     /*  50656 */ /*GILLT_v2s32*//*Label 782*/ GIMT_Encode4(52077), GIMT_Encode4(0),
     /*  50664 */ /*GILLT_v4s16*//*Label 783*/ GIMT_Encode4(52415),
     /*  50668 */ /*GILLT_v4s32*//*Label 784*/ GIMT_Encode4(52753),
     /*  50672 */ /*GILLT_v8s8*//*Label 785*/ GIMT_Encode4(52919),
     /*  50676 */ /*GILLT_v8s16*//*Label 786*/ GIMT_Encode4(52953),
     /*  50680 */ /*GILLT_v16s8*//*Label 787*/ GIMT_Encode4(53119),
     /*  50684 */ // Label 780: @50684
     /*  50684 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(50840),
     /*  50689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50699 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(50754), // Rule ID 3955 //
     /*  50704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50720 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50735 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50752 */     GIR_RootConstrainSelectedInstOperands,
     /*  50753 */     // GIR_Coverage, 3955,
     /*  50753 */     GIR_EraseRootFromParent_Done,
     /*  50754 */   // Label 790: @50754
     /*  50754 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(50809), // Rule ID 13860 //
     /*  50759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50779 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50790 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  50801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50807 */     GIR_RootConstrainSelectedInstOperands,
     /*  50808 */     // GIR_Coverage, 13860,
     /*  50808 */     GIR_EraseRootFromParent_Done,
     /*  50809 */   // Label 791: @50809
     /*  50809 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(50839), // Rule ID 3951 //
     /*  50814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50822 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  50825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50837 */     GIR_RootConstrainSelectedInstOperands,
     /*  50838 */     // GIR_Coverage, 3951,
     /*  50838 */     GIR_EraseRootFromParent_Done,
     /*  50839 */   // Label 792: @50839
     /*  50839 */   GIM_Reject,
     /*  50840 */ // Label 789: @50840
     /*  50840 */ GIM_Reject,
     /*  50841 */ // Label 781: @50841
     /*  50841 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(52076),
     /*  50846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  50852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50856 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(51002), // Rule ID 3960 //
     /*  50861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50882 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  50893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50914 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  50925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50927 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  50927 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  50930 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50934 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50939 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  50945 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50950 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50967 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  50973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  50986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  50994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51000 */     GIR_RootConstrainSelectedInstOperands,
     /*  51001 */     // GIR_Coverage, 3960,
     /*  51001 */     GIR_EraseRootFromParent_Done,
     /*  51002 */   // Label 794: @51002
     /*  51002 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(51106), // Rule ID 3961 //
     /*  51007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51028 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51058 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51070 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51104 */     GIR_RootConstrainSelectedInstOperands,
     /*  51105 */     // GIR_Coverage, 3961,
     /*  51105 */     GIR_EraseRootFromParent_Done,
     /*  51106 */   // Label 795: @51106
     /*  51106 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(51210), // Rule ID 13863 //
     /*  51111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51149 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51162 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51174 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51208 */     GIR_RootConstrainSelectedInstOperands,
     /*  51209 */     // GIR_Coverage, 13863,
     /*  51209 */     GIR_EraseRootFromParent_Done,
     /*  51210 */   // Label 796: @51210
     /*  51210 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(51265), // Rule ID 3956 //
     /*  51215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51231 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51246 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51263 */     GIR_RootConstrainSelectedInstOperands,
     /*  51264 */     // GIR_Coverage, 3956,
     /*  51264 */     GIR_EraseRootFromParent_Done,
     /*  51265 */   // Label 797: @51265
     /*  51265 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(51320), // Rule ID 13861 //
     /*  51270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51290 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51301 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  51312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51318 */     GIR_RootConstrainSelectedInstOperands,
     /*  51319 */     // GIR_Coverage, 13861,
     /*  51319 */     GIR_EraseRootFromParent_Done,
     /*  51320 */   // Label 798: @51320
     /*  51320 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(51433), // Rule ID 3967 //
     /*  51325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51342 */     // MIs[1] Operand 2
     /*  51342 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51361 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51365 */     // MIs[2] Operand 1
     /*  51365 */     // No operand predicates
     /*  51365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51367 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51379 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51398 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51431 */     GIR_RootConstrainSelectedInstOperands,
     /*  51432 */     // GIR_Coverage, 3967,
     /*  51432 */     GIR_EraseRootFromParent_Done,
     /*  51433 */   // Label 799: @51433
     /*  51433 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(51508), // Rule ID 3965 //
     /*  51438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51463 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51467 */     // MIs[2] Operand 1
     /*  51467 */     // No operand predicates
     /*  51467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51469 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51481 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51506 */     GIR_RootConstrainSelectedInstOperands,
     /*  51507 */     // GIR_Coverage, 3965,
     /*  51507 */     GIR_EraseRootFromParent_Done,
     /*  51508 */   // Label 800: @51508
     /*  51508 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(51583), // Rule ID 3966 //
     /*  51513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51538 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  51542 */     // MIs[2] Operand 1
     /*  51542 */     // No operand predicates
     /*  51542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51544 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51556 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51581 */     GIR_RootConstrainSelectedInstOperands,
     /*  51582 */     // GIR_Coverage, 3966,
     /*  51582 */     GIR_EraseRootFromParent_Done,
     /*  51583 */   // Label 801: @51583
     /*  51583 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(51721), // Rule ID 3957 //
     /*  51588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51605 */     // MIs[1] Operand 2
     /*  51605 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51633 */     // MIs[2] Operand 2
     /*  51633 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  51644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51646 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  51646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51658 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  51664 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51669 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51686 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51719 */     GIR_RootConstrainSelectedInstOperands,
     /*  51720 */     // GIR_Coverage, 3957,
     /*  51720 */     GIR_EraseRootFromParent_Done,
     /*  51721 */   // Label 802: @51721
     /*  51721 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(51821), // Rule ID 3958 //
     /*  51726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51743 */     // MIs[1] Operand 2
     /*  51743 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51773 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51785 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51819 */     GIR_RootConstrainSelectedInstOperands,
     /*  51820 */     // GIR_Coverage, 3958,
     /*  51820 */     GIR_EraseRootFromParent_Done,
     /*  51821 */   // Label 803: @51821
     /*  51821 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(51921), // Rule ID 13862 //
     /*  51826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51860 */     // MIs[2] Operand 2
     /*  51860 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  51871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51873 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51885 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51919 */     GIR_RootConstrainSelectedInstOperands,
     /*  51920 */     // GIR_Coverage, 13862,
     /*  51920 */     GIR_EraseRootFromParent_Done,
     /*  51921 */   // Label 804: @51921
     /*  51921 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(51983), // Rule ID 3959 //
     /*  51926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51962 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51981 */     GIR_RootConstrainSelectedInstOperands,
     /*  51982 */     // GIR_Coverage, 3959,
     /*  51982 */     GIR_EraseRootFromParent_Done,
     /*  51983 */   // Label 805: @51983
     /*  51983 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(52045), // Rule ID 3962 //
     /*  51988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  52017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52024 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52043 */     GIR_RootConstrainSelectedInstOperands,
     /*  52044 */     // GIR_Coverage, 3962,
     /*  52044 */     GIR_EraseRootFromParent_Done,
     /*  52045 */   // Label 806: @52045
     /*  52045 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(52075), // Rule ID 3952 //
     /*  52050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52058 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  52061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52073 */     GIR_RootConstrainSelectedInstOperands,
     /*  52074 */     // GIR_Coverage, 3952,
     /*  52074 */     GIR_EraseRootFromParent_Done,
     /*  52075 */   // Label 807: @52075
     /*  52075 */   GIM_Reject,
     /*  52076 */ // Label 793: @52076
     /*  52076 */ GIM_Reject,
     /*  52077 */ // Label 782: @52077
     /*  52077 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(52414),
     /*  52082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52092 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(52178), // Rule ID 13554 //
     /*  52097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52141 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52145 */     // MIs[3] Operand 1
     /*  52145 */     // No operand predicates
     /*  52145 */     // MIs[1] Operand 2
     /*  52145 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52162 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52176 */     GIR_RootConstrainSelectedInstOperands,
     /*  52177 */     // GIR_Coverage, 13554,
     /*  52177 */     GIR_EraseRootFromParent_Done,
     /*  52178 */   // Label 809: @52178
     /*  52178 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(52264), // Rule ID 2034 //
     /*  52183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52231 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52235 */     // MIs[3] Operand 1
     /*  52235 */     // No operand predicates
     /*  52235 */     // MIs[1] Operand 2
     /*  52235 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52248 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52262 */     GIR_RootConstrainSelectedInstOperands,
     /*  52263 */     // GIR_Coverage, 2034,
     /*  52263 */     GIR_EraseRootFromParent_Done,
     /*  52264 */   // Label 810: @52264
     /*  52264 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(52327), // Rule ID 13555 //
     /*  52269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52301 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52305 */     // MIs[2] Operand 1
     /*  52305 */     // No operand predicates
     /*  52305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52311 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52325 */     GIR_RootConstrainSelectedInstOperands,
     /*  52326 */     // GIR_Coverage, 13555,
     /*  52326 */     GIR_EraseRootFromParent_Done,
     /*  52327 */   // Label 811: @52327
     /*  52327 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(52390), // Rule ID 2035 //
     /*  52332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52368 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52372 */     // MIs[2] Operand 1
     /*  52372 */     // No operand predicates
     /*  52372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52374 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52388 */     GIR_RootConstrainSelectedInstOperands,
     /*  52389 */     // GIR_Coverage, 2035,
     /*  52389 */     GIR_EraseRootFromParent_Done,
     /*  52390 */   // Label 812: @52390
     /*  52390 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(52413), // Rule ID 1352 //
     /*  52395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52406 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  52406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  52411 */     GIR_RootConstrainSelectedInstOperands,
     /*  52412 */     // GIR_Coverage, 1352,
     /*  52412 */     GIR_Done,
     /*  52413 */   // Label 813: @52413
     /*  52413 */   GIM_Reject,
     /*  52414 */ // Label 808: @52414
     /*  52414 */ GIM_Reject,
     /*  52415 */ // Label 783: @52415
     /*  52415 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(52752),
     /*  52420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52430 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(52516), // Rule ID 13551 //
     /*  52435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52479 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52483 */     // MIs[3] Operand 1
     /*  52483 */     // No operand predicates
     /*  52483 */     // MIs[1] Operand 2
     /*  52483 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52500 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52514 */     GIR_RootConstrainSelectedInstOperands,
     /*  52515 */     // GIR_Coverage, 13551,
     /*  52515 */     GIR_EraseRootFromParent_Done,
     /*  52516 */   // Label 815: @52516
     /*  52516 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(52602), // Rule ID 2031 //
     /*  52521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52573 */     // MIs[3] Operand 1
     /*  52573 */     // No operand predicates
     /*  52573 */     // MIs[1] Operand 2
     /*  52573 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52586 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52600 */     GIR_RootConstrainSelectedInstOperands,
     /*  52601 */     // GIR_Coverage, 2031,
     /*  52601 */     GIR_EraseRootFromParent_Done,
     /*  52602 */   // Label 816: @52602
     /*  52602 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(52665), // Rule ID 13552 //
     /*  52607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52639 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52643 */     // MIs[2] Operand 1
     /*  52643 */     // No operand predicates
     /*  52643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52649 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52663 */     GIR_RootConstrainSelectedInstOperands,
     /*  52664 */     // GIR_Coverage, 13552,
     /*  52664 */     GIR_EraseRootFromParent_Done,
     /*  52665 */   // Label 817: @52665
     /*  52665 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(52728), // Rule ID 2032 //
     /*  52670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52706 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52710 */     // MIs[2] Operand 1
     /*  52710 */     // No operand predicates
     /*  52710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52712 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52726 */     GIR_RootConstrainSelectedInstOperands,
     /*  52727 */     // GIR_Coverage, 2032,
     /*  52727 */     GIR_EraseRootFromParent_Done,
     /*  52728 */   // Label 818: @52728
     /*  52728 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(52751), // Rule ID 1350 //
     /*  52733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52744 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  52744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  52749 */     GIR_RootConstrainSelectedInstOperands,
     /*  52750 */     // GIR_Coverage, 1350,
     /*  52750 */     GIR_Done,
     /*  52751 */   // Label 819: @52751
     /*  52751 */   GIM_Reject,
     /*  52752 */ // Label 814: @52752
     /*  52752 */ GIM_Reject,
     /*  52753 */ // Label 784: @52753
     /*  52753 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(52918),
     /*  52758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52768 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(52831), // Rule ID 13556 //
     /*  52773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52805 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52809 */     // MIs[2] Operand 1
     /*  52809 */     // No operand predicates
     /*  52809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52815 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52829 */     GIR_RootConstrainSelectedInstOperands,
     /*  52830 */     // GIR_Coverage, 13556,
     /*  52830 */     GIR_EraseRootFromParent_Done,
     /*  52831 */   // Label 821: @52831
     /*  52831 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(52894), // Rule ID 2036 //
     /*  52836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52872 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52876 */     // MIs[2] Operand 1
     /*  52876 */     // No operand predicates
     /*  52876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52878 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52892 */     GIR_RootConstrainSelectedInstOperands,
     /*  52893 */     // GIR_Coverage, 2036,
     /*  52893 */     GIR_EraseRootFromParent_Done,
     /*  52894 */   // Label 822: @52894
     /*  52894 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(52917), // Rule ID 1353 //
     /*  52899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52910 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  52910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  52915 */     GIR_RootConstrainSelectedInstOperands,
     /*  52916 */     // GIR_Coverage, 1353,
     /*  52916 */     GIR_Done,
     /*  52917 */   // Label 823: @52917
     /*  52917 */   GIM_Reject,
     /*  52918 */ // Label 820: @52918
     /*  52918 */ GIM_Reject,
     /*  52919 */ // Label 785: @52919
     /*  52919 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(52952), // Rule ID 1348 //
     /*  52924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52945 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  52950 */   GIR_RootConstrainSelectedInstOperands,
     /*  52951 */   // GIR_Coverage, 1348,
     /*  52951 */   GIR_Done,
     /*  52952 */ // Label 824: @52952
     /*  52952 */ GIM_Reject,
     /*  52953 */ // Label 786: @52953
     /*  52953 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(53118),
     /*  52958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52968 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(53031), // Rule ID 13553 //
     /*  52973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53005 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53009 */     // MIs[2] Operand 1
     /*  53009 */     // No operand predicates
     /*  53009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53015 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  53018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53029 */     GIR_RootConstrainSelectedInstOperands,
     /*  53030 */     // GIR_Coverage, 13553,
     /*  53030 */     GIR_EraseRootFromParent_Done,
     /*  53031 */   // Label 826: @53031
     /*  53031 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(53094), // Rule ID 2033 //
     /*  53036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  53051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  53064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53072 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53076 */     // MIs[2] Operand 1
     /*  53076 */     // No operand predicates
     /*  53076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53078 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  53081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53092 */     GIR_RootConstrainSelectedInstOperands,
     /*  53093 */     // GIR_Coverage, 2033,
     /*  53093 */     GIR_EraseRootFromParent_Done,
     /*  53094 */   // Label 827: @53094
     /*  53094 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(53117), // Rule ID 1351 //
     /*  53099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53110 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  53110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  53115 */     GIR_RootConstrainSelectedInstOperands,
     /*  53116 */     // GIR_Coverage, 1351,
     /*  53116 */     GIR_Done,
     /*  53117 */   // Label 828: @53117
     /*  53117 */   GIM_Reject,
     /*  53118 */ // Label 825: @53118
     /*  53118 */ GIM_Reject,
     /*  53119 */ // Label 787: @53119
     /*  53119 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(53152), // Rule ID 1349 //
     /*  53124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53145 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  53150 */   GIR_RootConstrainSelectedInstOperands,
     /*  53151 */   // GIR_Coverage, 1349,
     /*  53151 */   GIR_Done,
     /*  53152 */ // Label 829: @53152
     /*  53152 */ GIM_Reject,
     /*  53153 */ // Label 788: @53153
     /*  53153 */ GIM_Reject,
     /*  53154 */ // Label 3: @53154
     /*  53154 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 832*/ GIMT_Encode4(53235),
     /*  53165 */ /*GILLT_s32*//*Label 830*/ GIMT_Encode4(53173),
     /*  53169 */ /*GILLT_s64*//*Label 831*/ GIMT_Encode4(53204),
     /*  53173 */ // Label 830: @53173
     /*  53173 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(53203), // Rule ID 117 //
     /*  53178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53196 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  53201 */   GIR_RootConstrainSelectedInstOperands,
     /*  53202 */   // GIR_Coverage, 117,
     /*  53202 */   GIR_Done,
     /*  53203 */ // Label 833: @53203
     /*  53203 */ GIM_Reject,
     /*  53204 */ // Label 831: @53204
     /*  53204 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(53234), // Rule ID 118 //
     /*  53209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53227 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  53227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  53232 */   GIR_RootConstrainSelectedInstOperands,
     /*  53233 */   // GIR_Coverage, 118,
     /*  53233 */   GIR_Done,
     /*  53234 */ // Label 834: @53234
     /*  53234 */ GIM_Reject,
     /*  53235 */ // Label 832: @53235
     /*  53235 */ GIM_Reject,
     /*  53236 */ // Label 4: @53236
     /*  53236 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 837*/ GIMT_Encode4(53317),
     /*  53247 */ /*GILLT_s32*//*Label 835*/ GIMT_Encode4(53255),
     /*  53251 */ /*GILLT_s64*//*Label 836*/ GIMT_Encode4(53286),
     /*  53255 */ // Label 835: @53255
     /*  53255 */ GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(53285), // Rule ID 115 //
     /*  53260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53278 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  53283 */   GIR_RootConstrainSelectedInstOperands,
     /*  53284 */   // GIR_Coverage, 115,
     /*  53284 */   GIR_Done,
     /*  53285 */ // Label 838: @53285
     /*  53285 */ GIM_Reject,
     /*  53286 */ // Label 836: @53286
     /*  53286 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(53316), // Rule ID 116 //
     /*  53291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53309 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  53309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  53314 */   GIR_RootConstrainSelectedInstOperands,
     /*  53315 */   // GIR_Coverage, 116,
     /*  53315 */   GIR_Done,
     /*  53316 */ // Label 839: @53316
     /*  53316 */ GIM_Reject,
     /*  53317 */ // Label 837: @53317
     /*  53317 */ GIM_Reject,
     /*  53318 */ // Label 5: @53318
     /*  53318 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 858*/ GIMT_Encode4(61063),
     /*  53329 */ /*GILLT_s32*//*Label 840*/ GIMT_Encode4(53417),
     /*  53333 */ /*GILLT_s64*//*Label 841*/ GIMT_Encode4(53915), GIMT_Encode4(0),
     /*  53341 */ /*GILLT_v2s32*//*Label 842*/ GIMT_Encode4(55350),
     /*  53345 */ /*GILLT_v2s64*//*Label 843*/ GIMT_Encode4(55510),
     /*  53349 */ /*GILLT_v4s16*//*Label 844*/ GIMT_Encode4(55670),
     /*  53353 */ /*GILLT_v4s32*//*Label 845*/ GIMT_Encode4(55830),
     /*  53357 */ /*GILLT_v8s8*//*Label 846*/ GIMT_Encode4(55990),
     /*  53361 */ /*GILLT_v8s16*//*Label 847*/ GIMT_Encode4(56150),
     /*  53365 */ /*GILLT_v16s8*//*Label 848*/ GIMT_Encode4(56310),
     /*  53369 */ /*GILLT_nxv1s1*//*Label 849*/ GIMT_Encode4(56470),
     /*  53373 */ /*GILLT_nxv2s1*//*Label 850*/ GIMT_Encode4(57011), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  53385 */ /*GILLT_nxv2s64*//*Label 851*/ GIMT_Encode4(57552),
     /*  53389 */ /*GILLT_nxv4s1*//*Label 852*/ GIMT_Encode4(58024), GIMT_Encode4(0),
     /*  53397 */ /*GILLT_nxv4s32*//*Label 853*/ GIMT_Encode4(58565),
     /*  53401 */ /*GILLT_nxv8s1*//*Label 854*/ GIMT_Encode4(59037),
     /*  53405 */ /*GILLT_nxv8s16*//*Label 855*/ GIMT_Encode4(59578),
     /*  53409 */ /*GILLT_nxv16s1*//*Label 856*/ GIMT_Encode4(60050),
     /*  53413 */ /*GILLT_nxv16s8*//*Label 857*/ GIMT_Encode4(60591),
     /*  53417 */ // Label 840: @53417
     /*  53417 */ GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53914),
     /*  53422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53428 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53483), // Rule ID 13313 //
     /*  53433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53453 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53470 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53481 */     GIR_RootConstrainSelectedInstOperands,
     /*  53482 */     // GIR_Coverage, 13313,
     /*  53482 */     GIR_EraseRootFromParent_Done,
     /*  53483 */   // Label 860: @53483
     /*  53483 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53538), // Rule ID 162 //
     /*  53488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53512 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53525 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53532 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53536 */     GIR_RootConstrainSelectedInstOperands,
     /*  53537 */     // GIR_Coverage, 162,
     /*  53537 */     GIR_EraseRootFromParent_Done,
     /*  53538 */   // Label 861: @53538
     /*  53538 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53607), // Rule ID 5696 //
     /*  53543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  53580 */     // MIs[2] Operand 1
     /*  53580 */     // No operand predicates
     /*  53580 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53593 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  53593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  53596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53605 */     GIR_RootConstrainSelectedInstOperands,
     /*  53606 */     // GIR_Coverage, 5696,
     /*  53606 */     GIR_EraseRootFromParent_Done,
     /*  53607 */   // Label 862: @53607
     /*  53607 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53676), // Rule ID 5697 //
     /*  53612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53645 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53649 */     // MIs[2] Operand 1
     /*  53649 */     // No operand predicates
     /*  53649 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53662 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  53662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  53665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53674 */     GIR_RootConstrainSelectedInstOperands,
     /*  53675 */     // GIR_Coverage, 5697,
     /*  53675 */     GIR_EraseRootFromParent_Done,
     /*  53676 */   // Label 863: @53676
     /*  53676 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53729), // Rule ID 13311 //
     /*  53681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53706 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53716 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53727 */     GIR_RootConstrainSelectedInstOperands,
     /*  53728 */     // GIR_Coverage, 13311,
     /*  53728 */     GIR_EraseRootFromParent_Done,
     /*  53729 */   // Label 864: @53729
     /*  53729 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53782), // Rule ID 160 //
     /*  53734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53763 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53769 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53780 */     GIR_RootConstrainSelectedInstOperands,
     /*  53781 */     // GIR_Coverage, 160,
     /*  53781 */     GIR_EraseRootFromParent_Done,
     /*  53782 */   // Label 865: @53782
     /*  53782 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53823), // Rule ID 142 //
     /*  53787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  53791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53803 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  53807 */     // MIs[1] Operand 1
     /*  53807 */     // No operand predicates
     /*  53807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53809 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  53809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  53812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53816 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  53821 */     GIR_RootConstrainSelectedInstOperands,
     /*  53822 */     // GIR_Coverage, 142,
     /*  53822 */     GIR_EraseRootFromParent_Done,
     /*  53823 */   // Label 866: @53823
     /*  53823 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(53856), // Rule ID 13309 //
     /*  53828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53843 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53850 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53854 */     GIR_RootConstrainSelectedInstOperands,
     /*  53855 */     // GIR_Coverage, 13309,
     /*  53855 */     GIR_EraseRootFromParent_Done,
     /*  53856 */   // Label 867: @53856
     /*  53856 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(53889), // Rule ID 158 //
     /*  53861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53876 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53883 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53887 */     GIR_RootConstrainSelectedInstOperands,
     /*  53888 */     // GIR_Coverage, 158,
     /*  53888 */     GIR_EraseRootFromParent_Done,
     /*  53889 */   // Label 868: @53889
     /*  53889 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(53913), // Rule ID 156 //
     /*  53894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53906 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  53911 */     GIR_RootConstrainSelectedInstOperands,
     /*  53912 */     // GIR_Coverage, 156,
     /*  53912 */     GIR_Done,
     /*  53913 */   // Label 869: @53913
     /*  53913 */   GIM_Reject,
     /*  53914 */ // Label 859: @53914
     /*  53914 */ GIM_Reject,
     /*  53915 */ // Label 841: @53915
     /*  53915 */ GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(55349),
     /*  53920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53926 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(53981), // Rule ID 13314 //
     /*  53931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53951 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53968 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53979 */     GIR_RootConstrainSelectedInstOperands,
     /*  53980 */     // GIR_Coverage, 13314,
     /*  53980 */     GIR_EraseRootFromParent_Done,
     /*  53981 */   // Label 871: @53981
     /*  53981 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54036), // Rule ID 163 //
     /*  53986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54010 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54023 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  54026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54034 */     GIR_RootConstrainSelectedInstOperands,
     /*  54035 */     // GIR_Coverage, 163,
     /*  54035 */     GIR_EraseRootFromParent_Done,
     /*  54036 */   // Label 872: @54036
     /*  54036 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54149), // Rule ID 5698 //
     /*  54041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  54053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  54065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  54069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54086 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  54090 */     // MIs[3] Operand 1
     /*  54090 */     // No operand predicates
     /*  54090 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54103 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  54103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  54110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  54119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  54122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54148 */     // GIR_Coverage, 5698,
     /*  54148 */     GIR_EraseRootFromParent_Done,
     /*  54149 */   // Label 873: @54149
     /*  54149 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(54262), // Rule ID 5699 //
     /*  54154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  54166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  54178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54199 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54203 */     // MIs[3] Operand 1
     /*  54203 */     // No operand predicates
     /*  54203 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54216 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  54216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  54223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  54232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  54235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54261 */     // GIR_Coverage, 5699,
     /*  54261 */     GIR_EraseRootFromParent_Done,
     /*  54262 */   // Label 874: @54262
     /*  54262 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54361), // Rule ID 7158 //
     /*  54267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54279 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54282 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54287 */     // MIs[1] addr
     /*  54287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54296 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  54300 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54313 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 567:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  54320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54329 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54360 */     // GIR_Coverage, 7158,
     /*  54360 */     GIR_EraseRootFromParent_Done,
     /*  54361 */   // Label 875: @54361
     /*  54361 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54460), // Rule ID 7159 //
     /*  54366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54378 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54381 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54386 */     // MIs[1] addr
     /*  54386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54395 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  54399 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54412 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 567:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  54419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54424 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54428 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54459 */     // GIR_Coverage, 7159,
     /*  54459 */     GIR_EraseRootFromParent_Done,
     /*  54460 */   // Label 876: @54460
     /*  54460 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54559), // Rule ID 7160 //
     /*  54465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54477 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54480 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54485 */     // MIs[1] addr
     /*  54485 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54494 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  54498 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54511 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 567:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  54518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54527 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54558 */     // GIR_Coverage, 7160,
     /*  54558 */     GIR_EraseRootFromParent_Done,
     /*  54559 */   // Label 877: @54559
     /*  54559 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(54658), // Rule ID 7165 //
     /*  54564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54576 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54579 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54584 */     // MIs[1] addr
     /*  54584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54593 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  54597 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54610 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 564:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  54617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54626 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54657 */     // GIR_Coverage, 7165,
     /*  54657 */     GIR_EraseRootFromParent_Done,
     /*  54658 */   // Label 878: @54658
     /*  54658 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(54757), // Rule ID 7166 //
     /*  54663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54675 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54678 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54683 */     // MIs[1] addr
     /*  54683 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54692 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  54696 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54709 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 564:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  54716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54725 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54756 */     // GIR_Coverage, 7166,
     /*  54756 */     GIR_EraseRootFromParent_Done,
     /*  54757 */   // Label 879: @54757
     /*  54757 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(54856), // Rule ID 7167 //
     /*  54762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54774 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54777 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54782 */     // MIs[1] addr
     /*  54782 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54791 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  54795 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54808 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 564:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  54815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54820 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54824 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54855 */     // GIR_Coverage, 7167,
     /*  54855 */     GIR_EraseRootFromParent_Done,
     /*  54856 */   // Label 880: @54856
     /*  54856 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(54909), // Rule ID 13312 //
     /*  54861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54886 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54896 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54907 */     GIR_RootConstrainSelectedInstOperands,
     /*  54908 */     // GIR_Coverage, 13312,
     /*  54908 */     GIR_EraseRootFromParent_Done,
     /*  54909 */   // Label 881: @54909
     /*  54909 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(54962), // Rule ID 161 //
     /*  54914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54949 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54960 */     GIR_RootConstrainSelectedInstOperands,
     /*  54961 */     // GIR_Coverage, 161,
     /*  54961 */     GIR_EraseRootFromParent_Done,
     /*  54962 */   // Label 882: @54962
     /*  54962 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55062), // Rule ID 4004 //
     /*  54967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54975 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54986 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  54986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  54989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54998 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  55004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  55021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55026 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  55035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55061 */     // GIR_Coverage, 4004,
     /*  55061 */     GIR_EraseRootFromParent_Done,
     /*  55062 */   // Label 883: @55062
     /*  55062 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55103), // Rule ID 143 //
     /*  55067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55083 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  55087 */     // MIs[1] Operand 1
     /*  55087 */     // No operand predicates
     /*  55087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55089 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  55089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  55092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55096 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  55101 */     GIR_RootConstrainSelectedInstOperands,
     /*  55102 */     // GIR_Coverage, 143,
     /*  55102 */     GIR_EraseRootFromParent_Done,
     /*  55103 */   // Label 884: @55103
     /*  55103 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55136), // Rule ID 13310 //
     /*  55108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55123 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  55126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55134 */     GIR_RootConstrainSelectedInstOperands,
     /*  55135 */     // GIR_Coverage, 13310,
     /*  55135 */     GIR_EraseRootFromParent_Done,
     /*  55136 */   // Label 885: @55136
     /*  55136 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55169), // Rule ID 159 //
     /*  55141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55156 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  55159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55167 */     GIR_RootConstrainSelectedInstOperands,
     /*  55168 */     // GIR_Coverage, 159,
     /*  55168 */     GIR_EraseRootFromParent_Done,
     /*  55169 */   // Label 886: @55169
     /*  55169 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55233), // Rule ID 13968 //
     /*  55174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55206 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55212 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55220 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55225 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55231 */     GIR_RootConstrainSelectedInstOperands,
     /*  55232 */     // GIR_Coverage, 13968,
     /*  55232 */     GIR_EraseRootFromParent_Done,
     /*  55233 */   // Label 887: @55233
     /*  55233 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55297), // Rule ID 5080 //
     /*  55238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55274 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55284 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55289 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55295 */     GIR_RootConstrainSelectedInstOperands,
     /*  55296 */     // GIR_Coverage, 5080,
     /*  55296 */     GIR_EraseRootFromParent_Done,
     /*  55297 */   // Label 888: @55297
     /*  55297 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(55321), // Rule ID 157 //
     /*  55302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55314 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  55314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  55319 */     GIR_RootConstrainSelectedInstOperands,
     /*  55320 */     // GIR_Coverage, 157,
     /*  55320 */     GIR_Done,
     /*  55321 */   // Label 889: @55321
     /*  55321 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(55348), // Rule ID 2484 //
     /*  55326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55341 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55346 */     GIR_RootConstrainSelectedInstOperands,
     /*  55347 */     // GIR_Coverage, 2484,
     /*  55347 */     GIR_Done,
     /*  55348 */   // Label 890: @55348
     /*  55348 */   GIM_Reject,
     /*  55349 */ // Label 870: @55349
     /*  55349 */ GIM_Reject,
     /*  55350 */ // Label 842: @55350
     /*  55350 */ GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(55509),
     /*  55355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55365 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(55425), // Rule ID 13967 //
     /*  55370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55398 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55412 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55417 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55423 */     GIR_RootConstrainSelectedInstOperands,
     /*  55424 */     // GIR_Coverage, 13967,
     /*  55424 */     GIR_EraseRootFromParent_Done,
     /*  55425 */   // Label 892: @55425
     /*  55425 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(55485), // Rule ID 5079 //
     /*  55430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55462 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55468 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55472 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55477 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55483 */     GIR_RootConstrainSelectedInstOperands,
     /*  55484 */     // GIR_Coverage, 5079,
     /*  55484 */     GIR_EraseRootFromParent_Done,
     /*  55485 */   // Label 893: @55485
     /*  55485 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(55508), // Rule ID 2483 //
     /*  55490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55501 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55506 */     GIR_RootConstrainSelectedInstOperands,
     /*  55507 */     // GIR_Coverage, 2483,
     /*  55507 */     GIR_Done,
     /*  55508 */   // Label 894: @55508
     /*  55508 */   GIM_Reject,
     /*  55509 */ // Label 891: @55509
     /*  55509 */ GIM_Reject,
     /*  55510 */ // Label 843: @55510
     /*  55510 */ GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(55669),
     /*  55515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55525 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(55585), // Rule ID 13971 //
     /*  55530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55558 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55564 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55572 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55577 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55583 */     GIR_RootConstrainSelectedInstOperands,
     /*  55584 */     // GIR_Coverage, 13971,
     /*  55584 */     GIR_EraseRootFromParent_Done,
     /*  55585 */   // Label 896: @55585
     /*  55585 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(55645), // Rule ID 5083 //
     /*  55590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55622 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55632 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55637 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55643 */     GIR_RootConstrainSelectedInstOperands,
     /*  55644 */     // GIR_Coverage, 5083,
     /*  55644 */     GIR_EraseRootFromParent_Done,
     /*  55645 */   // Label 897: @55645
     /*  55645 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(55668), // Rule ID 2487 //
     /*  55650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55661 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55666 */     GIR_RootConstrainSelectedInstOperands,
     /*  55667 */     // GIR_Coverage, 2487,
     /*  55667 */     GIR_Done,
     /*  55668 */   // Label 898: @55668
     /*  55668 */   GIM_Reject,
     /*  55669 */ // Label 895: @55669
     /*  55669 */ GIM_Reject,
     /*  55670 */ // Label 844: @55670
     /*  55670 */ GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(55829),
     /*  55675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55685 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(55745), // Rule ID 13966 //
     /*  55690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55718 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55732 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55737 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55743 */     GIR_RootConstrainSelectedInstOperands,
     /*  55744 */     // GIR_Coverage, 13966,
     /*  55744 */     GIR_EraseRootFromParent_Done,
     /*  55745 */   // Label 900: @55745
     /*  55745 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(55805), // Rule ID 5078 //
     /*  55750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55782 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55788 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55792 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55797 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55803 */     GIR_RootConstrainSelectedInstOperands,
     /*  55804 */     // GIR_Coverage, 5078,
     /*  55804 */     GIR_EraseRootFromParent_Done,
     /*  55805 */   // Label 901: @55805
     /*  55805 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(55828), // Rule ID 2482 //
     /*  55810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55821 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55826 */     GIR_RootConstrainSelectedInstOperands,
     /*  55827 */     // GIR_Coverage, 2482,
     /*  55827 */     GIR_Done,
     /*  55828 */   // Label 902: @55828
     /*  55828 */   GIM_Reject,
     /*  55829 */ // Label 899: @55829
     /*  55829 */ GIM_Reject,
     /*  55830 */ // Label 845: @55830
     /*  55830 */ GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(55989),
     /*  55835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55845 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(55905), // Rule ID 13970 //
     /*  55850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55878 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55892 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55897 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55903 */     GIR_RootConstrainSelectedInstOperands,
     /*  55904 */     // GIR_Coverage, 13970,
     /*  55904 */     GIR_EraseRootFromParent_Done,
     /*  55905 */   // Label 904: @55905
     /*  55905 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(55965), // Rule ID 5082 //
     /*  55910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55952 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55957 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55963 */     GIR_RootConstrainSelectedInstOperands,
     /*  55964 */     // GIR_Coverage, 5082,
     /*  55964 */     GIR_EraseRootFromParent_Done,
     /*  55965 */   // Label 905: @55965
     /*  55965 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(55988), // Rule ID 2486 //
     /*  55970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55981 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55986 */     GIR_RootConstrainSelectedInstOperands,
     /*  55987 */     // GIR_Coverage, 2486,
     /*  55987 */     GIR_Done,
     /*  55988 */   // Label 906: @55988
     /*  55988 */   GIM_Reject,
     /*  55989 */ // Label 903: @55989
     /*  55989 */ GIM_Reject,
     /*  55990 */ // Label 846: @55990
     /*  55990 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(56149),
     /*  55995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56005 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(56065), // Rule ID 13449 //
     /*  56010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  56025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56038 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56044 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56052 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56063 */     GIR_RootConstrainSelectedInstOperands,
     /*  56064 */     // GIR_Coverage, 13449,
     /*  56064 */     GIR_EraseRootFromParent_Done,
     /*  56065 */   // Label 908: @56065
     /*  56065 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(56125), // Rule ID 1597 //
     /*  56070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  56089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56102 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56112 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56123 */     GIR_RootConstrainSelectedInstOperands,
     /*  56124 */     // GIR_Coverage, 1597,
     /*  56124 */     GIR_EraseRootFromParent_Done,
     /*  56125 */   // Label 909: @56125
     /*  56125 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(56148), // Rule ID 1595 //
     /*  56130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56141 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  56146 */     GIR_RootConstrainSelectedInstOperands,
     /*  56147 */     // GIR_Coverage, 1595,
     /*  56147 */     GIR_Done,
     /*  56148 */   // Label 910: @56148
     /*  56148 */   GIM_Reject,
     /*  56149 */ // Label 907: @56149
     /*  56149 */ GIM_Reject,
     /*  56150 */ // Label 847: @56150
     /*  56150 */ GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(56309),
     /*  56155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56165 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(56225), // Rule ID 13969 //
     /*  56170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56198 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56212 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56217 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56223 */     GIR_RootConstrainSelectedInstOperands,
     /*  56224 */     // GIR_Coverage, 13969,
     /*  56224 */     GIR_EraseRootFromParent_Done,
     /*  56225 */   // Label 912: @56225
     /*  56225 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(56285), // Rule ID 5081 //
     /*  56230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56262 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56268 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56272 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56277 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56283 */     GIR_RootConstrainSelectedInstOperands,
     /*  56284 */     // GIR_Coverage, 5081,
     /*  56284 */     GIR_EraseRootFromParent_Done,
     /*  56285 */   // Label 913: @56285
     /*  56285 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(56308), // Rule ID 2485 //
     /*  56290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56301 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  56306 */     GIR_RootConstrainSelectedInstOperands,
     /*  56307 */     // GIR_Coverage, 2485,
     /*  56307 */     GIR_Done,
     /*  56308 */   // Label 914: @56308
     /*  56308 */   GIM_Reject,
     /*  56309 */ // Label 911: @56309
     /*  56309 */ GIM_Reject,
     /*  56310 */ // Label 848: @56310
     /*  56310 */ GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(56469),
     /*  56315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56325 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(56385), // Rule ID 13450 //
     /*  56330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56358 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56372 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56383 */     GIR_RootConstrainSelectedInstOperands,
     /*  56384 */     // GIR_Coverage, 13450,
     /*  56384 */     GIR_EraseRootFromParent_Done,
     /*  56385 */   // Label 916: @56385
     /*  56385 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(56445), // Rule ID 1598 //
     /*  56390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56422 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56428 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56432 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56443 */     GIR_RootConstrainSelectedInstOperands,
     /*  56444 */     // GIR_Coverage, 1598,
     /*  56444 */     GIR_EraseRootFromParent_Done,
     /*  56445 */   // Label 917: @56445
     /*  56445 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(56468), // Rule ID 1596 //
     /*  56450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56461 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  56466 */     GIR_RootConstrainSelectedInstOperands,
     /*  56467 */     // GIR_Coverage, 1596,
     /*  56467 */     GIR_Done,
     /*  56468 */   // Label 918: @56468
     /*  56468 */   GIM_Reject,
     /*  56469 */ // Label 915: @56469
     /*  56469 */ GIM_Reject,
     /*  56470 */ // Label 849: @56470
     /*  56470 */ GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57010),
     /*  56475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56485 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(56542), // Rule ID 15163 //
     /*  56490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56521 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56527 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56540 */     GIR_RootConstrainSelectedInstOperands,
     /*  56541 */     // GIR_Coverage, 15163,
     /*  56541 */     GIR_EraseRootFromParent_Done,
     /*  56542 */   // Label 920: @56542
     /*  56542 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(56599), // Rule ID 15166 //
     /*  56547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56578 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56584 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56597 */     GIR_RootConstrainSelectedInstOperands,
     /*  56598 */     // GIR_Coverage, 15166,
     /*  56598 */     GIR_EraseRootFromParent_Done,
     /*  56599 */   // Label 921: @56599
     /*  56599 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(56656), // Rule ID 15162 //
     /*  56604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56635 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56641 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56654 */     GIR_RootConstrainSelectedInstOperands,
     /*  56655 */     // GIR_Coverage, 15162,
     /*  56655 */     GIR_EraseRootFromParent_Done,
     /*  56656 */   // Label 922: @56656
     /*  56656 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(56713), // Rule ID 15165 //
     /*  56661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56692 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56698 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56711 */     GIR_RootConstrainSelectedInstOperands,
     /*  56712 */     // GIR_Coverage, 15165,
     /*  56712 */     GIR_EraseRootFromParent_Done,
     /*  56713 */   // Label 923: @56713
     /*  56713 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(56770), // Rule ID 15161 //
     /*  56718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56749 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56755 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56768 */     GIR_RootConstrainSelectedInstOperands,
     /*  56769 */     // GIR_Coverage, 15161,
     /*  56769 */     GIR_EraseRootFromParent_Done,
     /*  56770 */   // Label 924: @56770
     /*  56770 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(56827), // Rule ID 15164 //
     /*  56775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56806 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56812 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56825 */     GIR_RootConstrainSelectedInstOperands,
     /*  56826 */     // GIR_Coverage, 15164,
     /*  56826 */     GIR_EraseRootFromParent_Done,
     /*  56827 */   // Label 925: @56827
     /*  56827 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(56884), // Rule ID 8501 //
     /*  56832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56863 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56869 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56882 */     GIR_RootConstrainSelectedInstOperands,
     /*  56883 */     // GIR_Coverage, 8501,
     /*  56883 */     GIR_EraseRootFromParent_Done,
     /*  56884 */   // Label 926: @56884
     /*  56884 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(56941), // Rule ID 8502 //
     /*  56889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56920 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56926 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56939 */     GIR_RootConstrainSelectedInstOperands,
     /*  56940 */     // GIR_Coverage, 8502,
     /*  56940 */     GIR_EraseRootFromParent_Done,
     /*  56941 */   // Label 927: @56941
     /*  56941 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(56988), // Rule ID 10765 //
     /*  56946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56957 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  56957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56969 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56986 */     GIR_RootConstrainSelectedInstOperands,
     /*  56987 */     // GIR_Coverage, 10765,
     /*  56987 */     GIR_EraseRootFromParent_Done,
     /*  56988 */   // Label 928: @56988
     /*  56988 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(57009), // Rule ID 2753 //
     /*  56993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56996 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57007 */     GIR_RootConstrainSelectedInstOperands,
     /*  57008 */     // GIR_Coverage, 2753,
     /*  57008 */     GIR_EraseRootFromParent_Done,
     /*  57009 */   // Label 929: @57009
     /*  57009 */   GIM_Reject,
     /*  57010 */ // Label 919: @57010
     /*  57010 */ GIM_Reject,
     /*  57011 */ // Label 850: @57011
     /*  57011 */ GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(57551),
     /*  57016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57026 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(57083), // Rule ID 15154 //
     /*  57031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57062 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57068 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57081 */     GIR_RootConstrainSelectedInstOperands,
     /*  57082 */     // GIR_Coverage, 15154,
     /*  57082 */     GIR_EraseRootFromParent_Done,
     /*  57083 */   // Label 931: @57083
     /*  57083 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(57140), // Rule ID 15157 //
     /*  57088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57119 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57125 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57138 */     GIR_RootConstrainSelectedInstOperands,
     /*  57139 */     // GIR_Coverage, 15157,
     /*  57139 */     GIR_EraseRootFromParent_Done,
     /*  57140 */   // Label 932: @57140
     /*  57140 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(57197), // Rule ID 15153 //
     /*  57145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57176 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57182 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57195 */     GIR_RootConstrainSelectedInstOperands,
     /*  57196 */     // GIR_Coverage, 15153,
     /*  57196 */     GIR_EraseRootFromParent_Done,
     /*  57197 */   // Label 933: @57197
     /*  57197 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(57254), // Rule ID 15156 //
     /*  57202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57233 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57239 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57252 */     GIR_RootConstrainSelectedInstOperands,
     /*  57253 */     // GIR_Coverage, 15156,
     /*  57253 */     GIR_EraseRootFromParent_Done,
     /*  57254 */   // Label 934: @57254
     /*  57254 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(57311), // Rule ID 15152 //
     /*  57259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57290 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57296 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57309 */     GIR_RootConstrainSelectedInstOperands,
     /*  57310 */     // GIR_Coverage, 15152,
     /*  57310 */     GIR_EraseRootFromParent_Done,
     /*  57311 */   // Label 935: @57311
     /*  57311 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(57368), // Rule ID 15155 //
     /*  57316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57347 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57353 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57366 */     GIR_RootConstrainSelectedInstOperands,
     /*  57367 */     // GIR_Coverage, 15155,
     /*  57367 */     GIR_EraseRootFromParent_Done,
     /*  57368 */   // Label 936: @57368
     /*  57368 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(57425), // Rule ID 8497 //
     /*  57373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57404 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57410 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57415 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57423 */     GIR_RootConstrainSelectedInstOperands,
     /*  57424 */     // GIR_Coverage, 8497,
     /*  57424 */     GIR_EraseRootFromParent_Done,
     /*  57425 */   // Label 937: @57425
     /*  57425 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(57482), // Rule ID 8498 //
     /*  57430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57461 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57467 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57480 */     GIR_RootConstrainSelectedInstOperands,
     /*  57481 */     // GIR_Coverage, 8498,
     /*  57481 */     GIR_EraseRootFromParent_Done,
     /*  57482 */   // Label 938: @57482
     /*  57482 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(57529), // Rule ID 10764 //
     /*  57487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57498 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  57498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  57505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57527 */     GIR_RootConstrainSelectedInstOperands,
     /*  57528 */     // GIR_Coverage, 10764,
     /*  57528 */     GIR_EraseRootFromParent_Done,
     /*  57529 */   // Label 939: @57529
     /*  57529 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(57550), // Rule ID 2752 //
     /*  57534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57537 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57548 */     GIR_RootConstrainSelectedInstOperands,
     /*  57549 */     // GIR_Coverage, 2752,
     /*  57549 */     GIR_EraseRootFromParent_Done,
     /*  57550 */   // Label 940: @57550
     /*  57550 */   GIM_Reject,
     /*  57551 */ // Label 930: @57551
     /*  57551 */ GIM_Reject,
     /*  57552 */ // Label 851: @57552
     /*  57552 */ GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(58023),
     /*  57557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57567 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(57622), // Rule ID 15094 //
     /*  57572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57603 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57609 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57620 */     GIR_RootConstrainSelectedInstOperands,
     /*  57621 */     // GIR_Coverage, 15094,
     /*  57621 */     GIR_EraseRootFromParent_Done,
     /*  57622 */   // Label 942: @57622
     /*  57622 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(57677), // Rule ID 15097 //
     /*  57627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57658 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57664 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57675 */     GIR_RootConstrainSelectedInstOperands,
     /*  57676 */     // GIR_Coverage, 15097,
     /*  57676 */     GIR_EraseRootFromParent_Done,
     /*  57677 */   // Label 943: @57677
     /*  57677 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(57732), // Rule ID 15093 //
     /*  57682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57719 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57730 */     GIR_RootConstrainSelectedInstOperands,
     /*  57731 */     // GIR_Coverage, 15093,
     /*  57731 */     GIR_EraseRootFromParent_Done,
     /*  57732 */   // Label 944: @57732
     /*  57732 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(57787), // Rule ID 15096 //
     /*  57737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57768 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57774 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57785 */     GIR_RootConstrainSelectedInstOperands,
     /*  57786 */     // GIR_Coverage, 15096,
     /*  57786 */     GIR_EraseRootFromParent_Done,
     /*  57787 */   // Label 945: @57787
     /*  57787 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(57842), // Rule ID 15092 //
     /*  57792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57823 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57829 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57840 */     GIR_RootConstrainSelectedInstOperands,
     /*  57841 */     // GIR_Coverage, 15092,
     /*  57841 */     GIR_EraseRootFromParent_Done,
     /*  57842 */   // Label 946: @57842
     /*  57842 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(57897), // Rule ID 15095 //
     /*  57847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57878 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57884 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57895 */     GIR_RootConstrainSelectedInstOperands,
     /*  57896 */     // GIR_Coverage, 15095,
     /*  57896 */     GIR_EraseRootFromParent_Done,
     /*  57897 */   // Label 947: @57897
     /*  57897 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(57952), // Rule ID 7546 //
     /*  57902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57933 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57939 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57950 */     GIR_RootConstrainSelectedInstOperands,
     /*  57951 */     // GIR_Coverage, 7546,
     /*  57951 */     GIR_EraseRootFromParent_Done,
     /*  57952 */   // Label 948: @57952
     /*  57952 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(58007), // Rule ID 7547 //
     /*  57957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57988 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57994 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58005 */     GIR_RootConstrainSelectedInstOperands,
     /*  58006 */     // GIR_Coverage, 7547,
     /*  58006 */     GIR_EraseRootFromParent_Done,
     /*  58007 */   // Label 949: @58007
     /*  58007 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(58022), // Rule ID 3146 //
     /*  58012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58015 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  58015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  58020 */     GIR_RootConstrainSelectedInstOperands,
     /*  58021 */     // GIR_Coverage, 3146,
     /*  58021 */     GIR_Done,
     /*  58022 */   // Label 950: @58022
     /*  58022 */   GIM_Reject,
     /*  58023 */ // Label 941: @58023
     /*  58023 */ GIM_Reject,
     /*  58024 */ // Label 852: @58024
     /*  58024 */ GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(58564),
     /*  58029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58039 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(58096), // Rule ID 15145 //
     /*  58044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58075 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58081 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58094 */     GIR_RootConstrainSelectedInstOperands,
     /*  58095 */     // GIR_Coverage, 15145,
     /*  58095 */     GIR_EraseRootFromParent_Done,
     /*  58096 */   // Label 952: @58096
     /*  58096 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(58153), // Rule ID 15148 //
     /*  58101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58132 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58138 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58151 */     GIR_RootConstrainSelectedInstOperands,
     /*  58152 */     // GIR_Coverage, 15148,
     /*  58152 */     GIR_EraseRootFromParent_Done,
     /*  58153 */   // Label 953: @58153
     /*  58153 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(58210), // Rule ID 15144 //
     /*  58158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58189 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58195 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58208 */     GIR_RootConstrainSelectedInstOperands,
     /*  58209 */     // GIR_Coverage, 15144,
     /*  58209 */     GIR_EraseRootFromParent_Done,
     /*  58210 */   // Label 954: @58210
     /*  58210 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(58267), // Rule ID 15147 //
     /*  58215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58246 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58252 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58265 */     GIR_RootConstrainSelectedInstOperands,
     /*  58266 */     // GIR_Coverage, 15147,
     /*  58266 */     GIR_EraseRootFromParent_Done,
     /*  58267 */   // Label 955: @58267
     /*  58267 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(58324), // Rule ID 15143 //
     /*  58272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58303 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58309 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58322 */     GIR_RootConstrainSelectedInstOperands,
     /*  58323 */     // GIR_Coverage, 15143,
     /*  58323 */     GIR_EraseRootFromParent_Done,
     /*  58324 */   // Label 956: @58324
     /*  58324 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(58381), // Rule ID 15146 //
     /*  58329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58360 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58366 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58379 */     GIR_RootConstrainSelectedInstOperands,
     /*  58380 */     // GIR_Coverage, 15146,
     /*  58380 */     GIR_EraseRootFromParent_Done,
     /*  58381 */   // Label 957: @58381
     /*  58381 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(58438), // Rule ID 8493 //
     /*  58386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58417 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58423 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58436 */     GIR_RootConstrainSelectedInstOperands,
     /*  58437 */     // GIR_Coverage, 8493,
     /*  58437 */     GIR_EraseRootFromParent_Done,
     /*  58438 */   // Label 958: @58438
     /*  58438 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(58495), // Rule ID 8494 //
     /*  58443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58474 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58480 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58493 */     GIR_RootConstrainSelectedInstOperands,
     /*  58494 */     // GIR_Coverage, 8494,
     /*  58494 */     GIR_EraseRootFromParent_Done,
     /*  58495 */   // Label 959: @58495
     /*  58495 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(58542), // Rule ID 10763 //
     /*  58500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58511 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  58511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  58518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58540 */     GIR_RootConstrainSelectedInstOperands,
     /*  58541 */     // GIR_Coverage, 10763,
     /*  58541 */     GIR_EraseRootFromParent_Done,
     /*  58542 */   // Label 960: @58542
     /*  58542 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(58563), // Rule ID 2751 //
     /*  58547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58550 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58561 */     GIR_RootConstrainSelectedInstOperands,
     /*  58562 */     // GIR_Coverage, 2751,
     /*  58562 */     GIR_EraseRootFromParent_Done,
     /*  58563 */   // Label 961: @58563
     /*  58563 */   GIM_Reject,
     /*  58564 */ // Label 951: @58564
     /*  58564 */ GIM_Reject,
     /*  58565 */ // Label 853: @58565
     /*  58565 */ GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(59036),
     /*  58570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  58580 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(58635), // Rule ID 15085 //
     /*  58585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58616 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58622 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58633 */     GIR_RootConstrainSelectedInstOperands,
     /*  58634 */     // GIR_Coverage, 15085,
     /*  58634 */     GIR_EraseRootFromParent_Done,
     /*  58635 */   // Label 963: @58635
     /*  58635 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(58690), // Rule ID 15088 //
     /*  58640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58671 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58677 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58688 */     GIR_RootConstrainSelectedInstOperands,
     /*  58689 */     // GIR_Coverage, 15088,
     /*  58689 */     GIR_EraseRootFromParent_Done,
     /*  58690 */   // Label 964: @58690
     /*  58690 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(58745), // Rule ID 15084 //
     /*  58695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58726 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58732 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58743 */     GIR_RootConstrainSelectedInstOperands,
     /*  58744 */     // GIR_Coverage, 15084,
     /*  58744 */     GIR_EraseRootFromParent_Done,
     /*  58745 */   // Label 965: @58745
     /*  58745 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(58800), // Rule ID 15087 //
     /*  58750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58781 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58787 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58798 */     GIR_RootConstrainSelectedInstOperands,
     /*  58799 */     // GIR_Coverage, 15087,
     /*  58799 */     GIR_EraseRootFromParent_Done,
     /*  58800 */   // Label 966: @58800
     /*  58800 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(58855), // Rule ID 15083 //
     /*  58805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58836 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58842 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58853 */     GIR_RootConstrainSelectedInstOperands,
     /*  58854 */     // GIR_Coverage, 15083,
     /*  58854 */     GIR_EraseRootFromParent_Done,
     /*  58855 */   // Label 967: @58855
     /*  58855 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(58910), // Rule ID 15086 //
     /*  58860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58891 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58897 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58908 */     GIR_RootConstrainSelectedInstOperands,
     /*  58909 */     // GIR_Coverage, 15086,
     /*  58909 */     GIR_EraseRootFromParent_Done,
     /*  58910 */   // Label 968: @58910
     /*  58910 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(58965), // Rule ID 7542 //
     /*  58915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58946 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58952 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58963 */     GIR_RootConstrainSelectedInstOperands,
     /*  58964 */     // GIR_Coverage, 7542,
     /*  58964 */     GIR_EraseRootFromParent_Done,
     /*  58965 */   // Label 969: @58965
     /*  58965 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(59020), // Rule ID 7543 //
     /*  58970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59007 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  59007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59012 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59018 */     GIR_RootConstrainSelectedInstOperands,
     /*  59019 */     // GIR_Coverage, 7543,
     /*  59019 */     GIR_EraseRootFromParent_Done,
     /*  59020 */   // Label 970: @59020
     /*  59020 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(59035), // Rule ID 3145 //
     /*  59025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59028 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  59028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59033 */     GIR_RootConstrainSelectedInstOperands,
     /*  59034 */     // GIR_Coverage, 3145,
     /*  59034 */     GIR_Done,
     /*  59035 */   // Label 971: @59035
     /*  59035 */   GIM_Reject,
     /*  59036 */ // Label 962: @59036
     /*  59036 */ GIM_Reject,
     /*  59037 */ // Label 854: @59037
     /*  59037 */ GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(59577),
     /*  59042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59052 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(59109), // Rule ID 15136 //
     /*  59057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59088 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59094 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59107 */     GIR_RootConstrainSelectedInstOperands,
     /*  59108 */     // GIR_Coverage, 15136,
     /*  59108 */     GIR_EraseRootFromParent_Done,
     /*  59109 */   // Label 973: @59109
     /*  59109 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(59166), // Rule ID 15139 //
     /*  59114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59145 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59151 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59164 */     GIR_RootConstrainSelectedInstOperands,
     /*  59165 */     // GIR_Coverage, 15139,
     /*  59165 */     GIR_EraseRootFromParent_Done,
     /*  59166 */   // Label 974: @59166
     /*  59166 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(59223), // Rule ID 15135 //
     /*  59171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59202 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59208 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59221 */     GIR_RootConstrainSelectedInstOperands,
     /*  59222 */     // GIR_Coverage, 15135,
     /*  59222 */     GIR_EraseRootFromParent_Done,
     /*  59223 */   // Label 975: @59223
     /*  59223 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(59280), // Rule ID 15138 //
     /*  59228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59259 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59265 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59278 */     GIR_RootConstrainSelectedInstOperands,
     /*  59279 */     // GIR_Coverage, 15138,
     /*  59279 */     GIR_EraseRootFromParent_Done,
     /*  59280 */   // Label 976: @59280
     /*  59280 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(59337), // Rule ID 15134 //
     /*  59285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59316 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59322 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59335 */     GIR_RootConstrainSelectedInstOperands,
     /*  59336 */     // GIR_Coverage, 15134,
     /*  59336 */     GIR_EraseRootFromParent_Done,
     /*  59337 */   // Label 977: @59337
     /*  59337 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(59394), // Rule ID 15137 //
     /*  59342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59373 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59379 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59392 */     GIR_RootConstrainSelectedInstOperands,
     /*  59393 */     // GIR_Coverage, 15137,
     /*  59393 */     GIR_EraseRootFromParent_Done,
     /*  59394 */   // Label 978: @59394
     /*  59394 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(59451), // Rule ID 8489 //
     /*  59399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59430 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59436 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59449 */     GIR_RootConstrainSelectedInstOperands,
     /*  59450 */     // GIR_Coverage, 8489,
     /*  59450 */     GIR_EraseRootFromParent_Done,
     /*  59451 */   // Label 979: @59451
     /*  59451 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(59508), // Rule ID 8490 //
     /*  59456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59487 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59493 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59506 */     GIR_RootConstrainSelectedInstOperands,
     /*  59507 */     // GIR_Coverage, 8490,
     /*  59507 */     GIR_EraseRootFromParent_Done,
     /*  59508 */   // Label 980: @59508
     /*  59508 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(59555), // Rule ID 10762 //
     /*  59513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59524 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  59524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  59531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59536 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  59539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59553 */     GIR_RootConstrainSelectedInstOperands,
     /*  59554 */     // GIR_Coverage, 10762,
     /*  59554 */     GIR_EraseRootFromParent_Done,
     /*  59555 */   // Label 981: @59555
     /*  59555 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(59576), // Rule ID 2750 //
     /*  59560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59563 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59574 */     GIR_RootConstrainSelectedInstOperands,
     /*  59575 */     // GIR_Coverage, 2750,
     /*  59575 */     GIR_EraseRootFromParent_Done,
     /*  59576 */   // Label 982: @59576
     /*  59576 */   GIM_Reject,
     /*  59577 */ // Label 972: @59577
     /*  59577 */ GIM_Reject,
     /*  59578 */ // Label 855: @59578
     /*  59578 */ GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(60049),
     /*  59583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59593 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(59648), // Rule ID 15076 //
     /*  59598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59629 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59635 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59646 */     GIR_RootConstrainSelectedInstOperands,
     /*  59647 */     // GIR_Coverage, 15076,
     /*  59647 */     GIR_EraseRootFromParent_Done,
     /*  59648 */   // Label 984: @59648
     /*  59648 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(59703), // Rule ID 15079 //
     /*  59653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59684 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59690 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59701 */     GIR_RootConstrainSelectedInstOperands,
     /*  59702 */     // GIR_Coverage, 15079,
     /*  59702 */     GIR_EraseRootFromParent_Done,
     /*  59703 */   // Label 985: @59703
     /*  59703 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(59758), // Rule ID 15075 //
     /*  59708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59739 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59745 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59756 */     GIR_RootConstrainSelectedInstOperands,
     /*  59757 */     // GIR_Coverage, 15075,
     /*  59757 */     GIR_EraseRootFromParent_Done,
     /*  59758 */   // Label 986: @59758
     /*  59758 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(59813), // Rule ID 15078 //
     /*  59763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59794 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59800 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59811 */     GIR_RootConstrainSelectedInstOperands,
     /*  59812 */     // GIR_Coverage, 15078,
     /*  59812 */     GIR_EraseRootFromParent_Done,
     /*  59813 */   // Label 987: @59813
     /*  59813 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(59868), // Rule ID 15074 //
     /*  59818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59849 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59855 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59866 */     GIR_RootConstrainSelectedInstOperands,
     /*  59867 */     // GIR_Coverage, 15074,
     /*  59867 */     GIR_EraseRootFromParent_Done,
     /*  59868 */   // Label 988: @59868
     /*  59868 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(59923), // Rule ID 15077 //
     /*  59873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59904 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59910 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59921 */     GIR_RootConstrainSelectedInstOperands,
     /*  59922 */     // GIR_Coverage, 15077,
     /*  59922 */     GIR_EraseRootFromParent_Done,
     /*  59923 */   // Label 989: @59923
     /*  59923 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(59978), // Rule ID 7538 //
     /*  59928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59959 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59965 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59976 */     GIR_RootConstrainSelectedInstOperands,
     /*  59977 */     // GIR_Coverage, 7538,
     /*  59977 */     GIR_EraseRootFromParent_Done,
     /*  59978 */   // Label 990: @59978
     /*  59978 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(60033), // Rule ID 7539 //
     /*  59983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  60002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60014 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60020 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  60020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60031 */     GIR_RootConstrainSelectedInstOperands,
     /*  60032 */     // GIR_Coverage, 7539,
     /*  60032 */     GIR_EraseRootFromParent_Done,
     /*  60033 */   // Label 991: @60033
     /*  60033 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(60048), // Rule ID 3144 //
     /*  60038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60041 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  60041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60046 */     GIR_RootConstrainSelectedInstOperands,
     /*  60047 */     // GIR_Coverage, 3144,
     /*  60047 */     GIR_Done,
     /*  60048 */   // Label 992: @60048
     /*  60048 */   GIM_Reject,
     /*  60049 */ // Label 983: @60049
     /*  60049 */ GIM_Reject,
     /*  60050 */ // Label 856: @60050
     /*  60050 */ GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(60590),
     /*  60055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  60065 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(60122), // Rule ID 15127 //
     /*  60070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60101 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60107 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60120 */     GIR_RootConstrainSelectedInstOperands,
     /*  60121 */     // GIR_Coverage, 15127,
     /*  60121 */     GIR_EraseRootFromParent_Done,
     /*  60122 */   // Label 994: @60122
     /*  60122 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(60179), // Rule ID 15130 //
     /*  60127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60158 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60164 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60177 */     GIR_RootConstrainSelectedInstOperands,
     /*  60178 */     // GIR_Coverage, 15130,
     /*  60178 */     GIR_EraseRootFromParent_Done,
     /*  60179 */   // Label 995: @60179
     /*  60179 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(60236), // Rule ID 15126 //
     /*  60184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60215 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60221 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60234 */     GIR_RootConstrainSelectedInstOperands,
     /*  60235 */     // GIR_Coverage, 15126,
     /*  60235 */     GIR_EraseRootFromParent_Done,
     /*  60236 */   // Label 996: @60236
     /*  60236 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(60293), // Rule ID 15129 //
     /*  60241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60272 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60278 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60291 */     GIR_RootConstrainSelectedInstOperands,
     /*  60292 */     // GIR_Coverage, 15129,
     /*  60292 */     GIR_EraseRootFromParent_Done,
     /*  60293 */   // Label 997: @60293
     /*  60293 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(60350), // Rule ID 15125 //
     /*  60298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60329 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60335 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60348 */     GIR_RootConstrainSelectedInstOperands,
     /*  60349 */     // GIR_Coverage, 15125,
     /*  60349 */     GIR_EraseRootFromParent_Done,
     /*  60350 */   // Label 998: @60350
     /*  60350 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(60407), // Rule ID 15128 //
     /*  60355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60386 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60392 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60405 */     GIR_RootConstrainSelectedInstOperands,
     /*  60406 */     // GIR_Coverage, 15128,
     /*  60406 */     GIR_EraseRootFromParent_Done,
     /*  60407 */   // Label 999: @60407
     /*  60407 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(60464), // Rule ID 8485 //
     /*  60412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60443 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60449 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60462 */     GIR_RootConstrainSelectedInstOperands,
     /*  60463 */     // GIR_Coverage, 8485,
     /*  60463 */     GIR_EraseRootFromParent_Done,
     /*  60464 */   // Label 1000: @60464
     /*  60464 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(60521), // Rule ID 8486 //
     /*  60469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60500 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60506 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60519 */     GIR_RootConstrainSelectedInstOperands,
     /*  60520 */     // GIR_Coverage, 8486,
     /*  60520 */     GIR_EraseRootFromParent_Done,
     /*  60521 */   // Label 1001: @60521
     /*  60521 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(60568), // Rule ID 10761 //
     /*  60526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60537 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  60537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  60540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  60544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60549 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  60552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  60564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  60566 */     GIR_RootConstrainSelectedInstOperands,
     /*  60567 */     // GIR_Coverage, 10761,
     /*  60567 */     GIR_EraseRootFromParent_Done,
     /*  60568 */   // Label 1002: @60568
     /*  60568 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(60589), // Rule ID 2749 //
     /*  60573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60576 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  60587 */     GIR_RootConstrainSelectedInstOperands,
     /*  60588 */     // GIR_Coverage, 2749,
     /*  60588 */     GIR_EraseRootFromParent_Done,
     /*  60589 */   // Label 1003: @60589
     /*  60589 */   GIM_Reject,
     /*  60590 */ // Label 993: @60590
     /*  60590 */ GIM_Reject,
     /*  60591 */ // Label 857: @60591
     /*  60591 */ GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61062),
     /*  60596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  60606 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(60661), // Rule ID 15067 //
     /*  60611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60642 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60648 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60659 */     GIR_RootConstrainSelectedInstOperands,
     /*  60660 */     // GIR_Coverage, 15067,
     /*  60660 */     GIR_EraseRootFromParent_Done,
     /*  60661 */   // Label 1005: @60661
     /*  60661 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(60716), // Rule ID 15070 //
     /*  60666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60697 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60703 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60714 */     GIR_RootConstrainSelectedInstOperands,
     /*  60715 */     // GIR_Coverage, 15070,
     /*  60715 */     GIR_EraseRootFromParent_Done,
     /*  60716 */   // Label 1006: @60716
     /*  60716 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(60771), // Rule ID 15066 //
     /*  60721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60752 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60758 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60769 */     GIR_RootConstrainSelectedInstOperands,
     /*  60770 */     // GIR_Coverage, 15066,
     /*  60770 */     GIR_EraseRootFromParent_Done,
     /*  60771 */   // Label 1007: @60771
     /*  60771 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(60826), // Rule ID 15069 //
     /*  60776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60807 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60813 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60824 */     GIR_RootConstrainSelectedInstOperands,
     /*  60825 */     // GIR_Coverage, 15069,
     /*  60825 */     GIR_EraseRootFromParent_Done,
     /*  60826 */   // Label 1008: @60826
     /*  60826 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(60881), // Rule ID 15065 //
     /*  60831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60862 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60868 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60879 */     GIR_RootConstrainSelectedInstOperands,
     /*  60880 */     // GIR_Coverage, 15065,
     /*  60880 */     GIR_EraseRootFromParent_Done,
     /*  60881 */   // Label 1009: @60881
     /*  60881 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(60936), // Rule ID 15068 //
     /*  60886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60917 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60923 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60934 */     GIR_RootConstrainSelectedInstOperands,
     /*  60935 */     // GIR_Coverage, 15068,
     /*  60935 */     GIR_EraseRootFromParent_Done,
     /*  60936 */   // Label 1010: @60936
     /*  60936 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(60991), // Rule ID 7534 //
     /*  60941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60972 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60978 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60989 */     GIR_RootConstrainSelectedInstOperands,
     /*  60990 */     // GIR_Coverage, 7534,
     /*  60990 */     GIR_EraseRootFromParent_Done,
     /*  60991 */   // Label 1011: @60991
     /*  60991 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(61046), // Rule ID 7535 //
     /*  60996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  61011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  61015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61027 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61033 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  61033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61044 */     GIR_RootConstrainSelectedInstOperands,
     /*  61045 */     // GIR_Coverage, 7535,
     /*  61045 */     GIR_EraseRootFromParent_Done,
     /*  61046 */   // Label 1012: @61046
     /*  61046 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(61061), // Rule ID 3143 //
     /*  61051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61054 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  61054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  61059 */     GIR_RootConstrainSelectedInstOperands,
     /*  61060 */     // GIR_Coverage, 3143,
     /*  61060 */     GIR_Done,
     /*  61061 */   // Label 1013: @61061
     /*  61061 */   GIM_Reject,
     /*  61062 */ // Label 1004: @61062
     /*  61062 */ GIM_Reject,
     /*  61063 */ // Label 858: @61063
     /*  61063 */ GIM_Reject,
     /*  61064 */ // Label 6: @61064
     /*  61064 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1032*/ GIMT_Encode4(86178),
     /*  61075 */ /*GILLT_s32*//*Label 1014*/ GIMT_Encode4(61163),
     /*  61079 */ /*GILLT_s64*//*Label 1015*/ GIMT_Encode4(61523), GIMT_Encode4(0),
     /*  61087 */ /*GILLT_v2s32*//*Label 1016*/ GIMT_Encode4(63422),
     /*  61091 */ /*GILLT_v2s64*//*Label 1017*/ GIMT_Encode4(64730),
     /*  61095 */ /*GILLT_v4s16*//*Label 1018*/ GIMT_Encode4(66038),
     /*  61099 */ /*GILLT_v4s32*//*Label 1019*/ GIMT_Encode4(67346),
     /*  61103 */ /*GILLT_v8s8*//*Label 1020*/ GIMT_Encode4(68654),
     /*  61107 */ /*GILLT_v8s16*//*Label 1021*/ GIMT_Encode4(69962),
     /*  61111 */ /*GILLT_v16s8*//*Label 1022*/ GIMT_Encode4(71270),
     /*  61115 */ /*GILLT_nxv1s1*//*Label 1023*/ GIMT_Encode4(72578),
     /*  61119 */ /*GILLT_nxv2s1*//*Label 1024*/ GIMT_Encode4(72610), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  61131 */ /*GILLT_nxv2s64*//*Label 1025*/ GIMT_Encode4(72642),
     /*  61135 */ /*GILLT_nxv4s1*//*Label 1026*/ GIMT_Encode4(76002), GIMT_Encode4(0),
     /*  61143 */ /*GILLT_nxv4s32*//*Label 1027*/ GIMT_Encode4(76034),
     /*  61147 */ /*GILLT_nxv8s1*//*Label 1028*/ GIMT_Encode4(79394),
     /*  61151 */ /*GILLT_nxv8s16*//*Label 1029*/ GIMT_Encode4(79426),
     /*  61155 */ /*GILLT_nxv16s1*//*Label 1030*/ GIMT_Encode4(82786),
     /*  61159 */ /*GILLT_nxv16s8*//*Label 1031*/ GIMT_Encode4(82818),
     /*  61163 */ // Label 1014: @61163
     /*  61163 */ GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(61522),
     /*  61168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  61171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61174 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(61229), // Rule ID 13333 //
     /*  61179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61199 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61216 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  61219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61227 */     GIR_RootConstrainSelectedInstOperands,
     /*  61228 */     // GIR_Coverage, 13333,
     /*  61228 */     GIR_EraseRootFromParent_Done,
     /*  61229 */   // Label 1034: @61229
     /*  61229 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(61284), // Rule ID 174 //
     /*  61234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61258 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61271 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  61274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61282 */     GIR_RootConstrainSelectedInstOperands,
     /*  61283 */     // GIR_Coverage, 174,
     /*  61283 */     GIR_EraseRootFromParent_Done,
     /*  61284 */   // Label 1035: @61284
     /*  61284 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(61325), // Rule ID 146 //
     /*  61289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  61293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61305 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  61309 */     // MIs[1] Operand 1
     /*  61309 */     // No operand predicates
     /*  61309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61311 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  61311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  61314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61318 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  61323 */     GIR_RootConstrainSelectedInstOperands,
     /*  61324 */     // GIR_Coverage, 146,
     /*  61324 */     GIR_EraseRootFromParent_Done,
     /*  61325 */   // Label 1036: @61325
     /*  61325 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(61358), // Rule ID 13335 //
     /*  61330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61345 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  61348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61356 */     GIR_RootConstrainSelectedInstOperands,
     /*  61357 */     // GIR_Coverage, 13335,
     /*  61357 */     GIR_EraseRootFromParent_Done,
     /*  61358 */   // Label 1037: @61358
     /*  61358 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(61391), // Rule ID 178 //
     /*  61363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61378 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  61381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61389 */     GIR_RootConstrainSelectedInstOperands,
     /*  61390 */     // GIR_Coverage, 178,
     /*  61390 */     GIR_EraseRootFromParent_Done,
     /*  61391 */   // Label 1038: @61391
     /*  61391 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(61444), // Rule ID 13331 //
     /*  61396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61421 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61431 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61442 */     GIR_RootConstrainSelectedInstOperands,
     /*  61443 */     // GIR_Coverage, 13331,
     /*  61443 */     GIR_EraseRootFromParent_Done,
     /*  61444 */   // Label 1039: @61444
     /*  61444 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(61497), // Rule ID 172 //
     /*  61449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61478 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61484 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61495 */     GIR_RootConstrainSelectedInstOperands,
     /*  61496 */     // GIR_Coverage, 172,
     /*  61496 */     GIR_EraseRootFromParent_Done,
     /*  61497 */   // Label 1040: @61497
     /*  61497 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(61521), // Rule ID 176 //
     /*  61502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61514 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  61519 */     GIR_RootConstrainSelectedInstOperands,
     /*  61520 */     // GIR_Coverage, 176,
     /*  61520 */     GIR_Done,
     /*  61521 */   // Label 1041: @61521
     /*  61521 */   GIM_Reject,
     /*  61522 */ // Label 1033: @61522
     /*  61522 */ GIM_Reject,
     /*  61523 */ // Label 1015: @61523
     /*  61523 */ GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(63421),
     /*  61528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  61531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  61534 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(61656), // Rule ID 4017 //
     /*  61539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61580 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61584 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61603 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61607 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61611 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61615 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61619 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61623 */     // MIs[4] Rn
     /*  61623 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61628 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61632 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61643 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61645 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61654 */     GIR_RootConstrainSelectedInstOperands,
     /*  61655 */     // GIR_Coverage, 4017,
     /*  61655 */     GIR_EraseRootFromParent_Done,
     /*  61656 */   // Label 1043: @61656
     /*  61656 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(61778), // Rule ID 13883 //
     /*  61661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61702 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61706 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61729 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61733 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61737 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61741 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61745 */     // MIs[4] Rn
     /*  61745 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61750 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61754 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61765 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61767 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61776 */     GIR_RootConstrainSelectedInstOperands,
     /*  61777 */     // GIR_Coverage, 13883,
     /*  61777 */     GIR_EraseRootFromParent_Done,
     /*  61778 */   // Label 1044: @61778
     /*  61778 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(61833), // Rule ID 13334 //
     /*  61783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61803 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61820 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61831 */     GIR_RootConstrainSelectedInstOperands,
     /*  61832 */     // GIR_Coverage, 13334,
     /*  61832 */     GIR_EraseRootFromParent_Done,
     /*  61833 */   // Label 1045: @61833
     /*  61833 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(61888), // Rule ID 175 //
     /*  61838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61862 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61875 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61886 */     GIR_RootConstrainSelectedInstOperands,
     /*  61887 */     // GIR_Coverage, 175,
     /*  61887 */     GIR_EraseRootFromParent_Done,
     /*  61888 */   // Label 1046: @61888
     /*  61888 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(61997), // Rule ID 13683 //
     /*  61893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61941 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61962 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61966 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61971 */     // MIs[4] LHS
     /*  61971 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61976 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61978 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61995 */     GIR_RootConstrainSelectedInstOperands,
     /*  61996 */     // GIR_Coverage, 13683,
     /*  61996 */     GIR_EraseRootFromParent_Done,
     /*  61997 */   // Label 1047: @61997
     /*  61997 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(62106), // Rule ID 13682 //
     /*  62002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62050 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62071 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  62075 */     // MIs[4] LHS
     /*  62075 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62080 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62085 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62087 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  62104 */     GIR_RootConstrainSelectedInstOperands,
     /*  62105 */     // GIR_Coverage, 13682,
     /*  62105 */     GIR_EraseRootFromParent_Done,
     /*  62106 */   // Label 1048: @62106
     /*  62106 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(62215), // Rule ID 13685 //
     /*  62111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62164 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62170 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62180 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  62184 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62189 */     // MIs[4] LHS
     /*  62189 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62194 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62196 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  62209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62213 */     GIR_RootConstrainSelectedInstOperands,
     /*  62214 */     // GIR_Coverage, 13685,
     /*  62214 */     GIR_EraseRootFromParent_Done,
     /*  62215 */   // Label 1049: @62215
     /*  62215 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(62324), // Rule ID 13684 //
     /*  62220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62273 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62285 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62289 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  62293 */     // MIs[4] LHS
     /*  62293 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62298 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62303 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62305 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62322 */     GIR_RootConstrainSelectedInstOperands,
     /*  62323 */     // GIR_Coverage, 13684,
     /*  62323 */     GIR_EraseRootFromParent_Done,
     /*  62324 */   // Label 1050: @62324
     /*  62324 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(62433), // Rule ID 2471 //
     /*  62329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62390 */     // MIs[3] LHS
     /*  62390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62395 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62399 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62412 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62414 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62431 */     GIR_RootConstrainSelectedInstOperands,
     /*  62432 */     // GIR_Coverage, 2471,
     /*  62432 */     GIR_EraseRootFromParent_Done,
     /*  62433 */   // Label 1051: @62433
     /*  62433 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(62542), // Rule ID 13680 //
     /*  62438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62495 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62499 */     // MIs[3] LHS
     /*  62499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62508 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62514 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62521 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62523 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62540 */     GIR_RootConstrainSelectedInstOperands,
     /*  62541 */     // GIR_Coverage, 13680,
     /*  62541 */     GIR_EraseRootFromParent_Done,
     /*  62542 */   // Label 1052: @62542
     /*  62542 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62651), // Rule ID 13679 //
     /*  62547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62609 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62613 */     // MIs[3] LHS
     /*  62613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62622 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62632 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62649 */     GIR_RootConstrainSelectedInstOperands,
     /*  62650 */     // GIR_Coverage, 13679,
     /*  62650 */     GIR_EraseRootFromParent_Done,
     /*  62651 */   // Label 1053: @62651
     /*  62651 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62760), // Rule ID 13681 //
     /*  62656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62701 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62722 */     // MIs[3] LHS
     /*  62722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62727 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62731 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62737 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62741 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62758 */     GIR_RootConstrainSelectedInstOperands,
     /*  62759 */     // GIR_Coverage, 13681,
     /*  62759 */     GIR_EraseRootFromParent_Done,
     /*  62760 */   // Label 1054: @62760
     /*  62760 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62801), // Rule ID 147 //
     /*  62765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  62769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62781 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  62785 */     // MIs[1] Operand 1
     /*  62785 */     // No operand predicates
     /*  62785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62787 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  62787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  62790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62794 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  62799 */     GIR_RootConstrainSelectedInstOperands,
     /*  62800 */     // GIR_Coverage, 147,
     /*  62800 */     GIR_EraseRootFromParent_Done,
     /*  62801 */   // Label 1055: @62801
     /*  62801 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(62834), // Rule ID 13336 //
     /*  62806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62821 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62828 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62832 */     GIR_RootConstrainSelectedInstOperands,
     /*  62833 */     // GIR_Coverage, 13336,
     /*  62833 */     GIR_EraseRootFromParent_Done,
     /*  62834 */   // Label 1056: @62834
     /*  62834 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(62867), // Rule ID 179 //
     /*  62839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62854 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62861 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62865 */     GIR_RootConstrainSelectedInstOperands,
     /*  62866 */     // GIR_Coverage, 179,
     /*  62866 */     GIR_EraseRootFromParent_Done,
     /*  62867 */   // Label 1057: @62867
     /*  62867 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(62934), // Rule ID 13619 //
     /*  62872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62896 */     // MIs[1] imm
     /*  62896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62908 */     // MIs[2] Operand 1
     /*  62908 */     // No operand predicates
     /*  62908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62912 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62918 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62932 */     GIR_RootConstrainSelectedInstOperands,
     /*  62933 */     // GIR_Coverage, 13619,
     /*  62933 */     GIR_EraseRootFromParent_Done,
     /*  62934 */   // Label 1058: @62934
     /*  62934 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(63001), // Rule ID 13622 //
     /*  62939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62963 */     // MIs[1] imm
     /*  62963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62971 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62975 */     // MIs[2] Operand 1
     /*  62975 */     // No operand predicates
     /*  62975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62985 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62999 */     GIR_RootConstrainSelectedInstOperands,
     /*  63000 */     // GIR_Coverage, 13622,
     /*  63000 */     GIR_EraseRootFromParent_Done,
     /*  63001 */   // Label 1059: @63001
     /*  63001 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(63054), // Rule ID 13332 //
     /*  63006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63031 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63041 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  63048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63052 */     GIR_RootConstrainSelectedInstOperands,
     /*  63053 */     // GIR_Coverage, 13332,
     /*  63053 */     GIR_EraseRootFromParent_Done,
     /*  63054 */   // Label 1060: @63054
     /*  63054 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(63121), // Rule ID 2122 //
     /*  63059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63087 */     // MIs[1] imm
     /*  63087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  63099 */     // MIs[2] Operand 1
     /*  63099 */     // No operand predicates
     /*  63099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63105 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  63108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63119 */     GIR_RootConstrainSelectedInstOperands,
     /*  63120 */     // GIR_Coverage, 2122,
     /*  63120 */     GIR_EraseRootFromParent_Done,
     /*  63121 */   // Label 1061: @63121
     /*  63121 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(63188), // Rule ID 2131 //
     /*  63126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63154 */     // MIs[1] imm
     /*  63154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63162 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  63166 */     // MIs[2] Operand 1
     /*  63166 */     // No operand predicates
     /*  63166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63172 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  63175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63186 */     GIR_RootConstrainSelectedInstOperands,
     /*  63187 */     // GIR_Coverage, 2131,
     /*  63187 */     GIR_EraseRootFromParent_Done,
     /*  63188 */   // Label 1062: @63188
     /*  63188 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(63241), // Rule ID 173 //
     /*  63193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63222 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63228 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  63235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63239 */     GIR_RootConstrainSelectedInstOperands,
     /*  63240 */     // GIR_Coverage, 173,
     /*  63240 */     GIR_EraseRootFromParent_Done,
     /*  63241 */   // Label 1063: @63241
     /*  63241 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(63305), // Rule ID 13974 //
     /*  63246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63278 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63284 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63292 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63297 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  63299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63303 */     GIR_RootConstrainSelectedInstOperands,
     /*  63304 */     // GIR_Coverage, 13974,
     /*  63304 */     GIR_EraseRootFromParent_Done,
     /*  63305 */   // Label 1064: @63305
     /*  63305 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(63369), // Rule ID 5092 //
     /*  63310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63346 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63352 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63356 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63361 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  63363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63367 */     GIR_RootConstrainSelectedInstOperands,
     /*  63368 */     // GIR_Coverage, 5092,
     /*  63368 */     GIR_EraseRootFromParent_Done,
     /*  63369 */   // Label 1065: @63369
     /*  63369 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(63393), // Rule ID 177 //
     /*  63374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63386 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  63391 */     GIR_RootConstrainSelectedInstOperands,
     /*  63392 */     // GIR_Coverage, 177,
     /*  63392 */     GIR_Done,
     /*  63393 */   // Label 1066: @63393
     /*  63393 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(63420), // Rule ID 5098 //
     /*  63398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63413 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  63418 */     GIR_RootConstrainSelectedInstOperands,
     /*  63419 */     // GIR_Coverage, 5098,
     /*  63419 */     GIR_Done,
     /*  63420 */   // Label 1067: @63420
     /*  63420 */   GIM_Reject,
     /*  63421 */ // Label 1042: @63421
     /*  63421 */ GIM_Reject,
     /*  63422 */ // Label 1016: @63422
     /*  63422 */ GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(64729),
     /*  63427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63433 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(63542), // Rule ID 13676 //
     /*  63438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63486 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63492 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63499 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63503 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63507 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63511 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63516 */     // MIs[4] LHS
     /*  63516 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63521 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63523 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63540 */     GIR_RootConstrainSelectedInstOperands,
     /*  63541 */     // GIR_Coverage, 13676,
     /*  63541 */     GIR_EraseRootFromParent_Done,
     /*  63542 */   // Label 1069: @63542
     /*  63542 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(63651), // Rule ID 13675 //
     /*  63547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63595 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63601 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63616 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63620 */     // MIs[4] LHS
     /*  63620 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63625 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63632 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63649 */     GIR_RootConstrainSelectedInstOperands,
     /*  63650 */     // GIR_Coverage, 13675,
     /*  63650 */     GIR_EraseRootFromParent_Done,
     /*  63651 */   // Label 1070: @63651
     /*  63651 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(63760), // Rule ID 13678 //
     /*  63656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63700 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63705 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63709 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63715 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63717 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63721 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63725 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63729 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63734 */     // MIs[4] LHS
     /*  63734 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63741 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63758 */     GIR_RootConstrainSelectedInstOperands,
     /*  63759 */     // GIR_Coverage, 13678,
     /*  63759 */     GIR_EraseRootFromParent_Done,
     /*  63760 */   // Label 1071: @63760
     /*  63760 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(63869), // Rule ID 13677 //
     /*  63765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63818 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63826 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63830 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63834 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63838 */     // MIs[4] LHS
     /*  63838 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63843 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63848 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63850 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63867 */     GIR_RootConstrainSelectedInstOperands,
     /*  63868 */     // GIR_Coverage, 13677,
     /*  63868 */     GIR_EraseRootFromParent_Done,
     /*  63869 */   // Label 1072: @63869
     /*  63869 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(63978), // Rule ID 2470 //
     /*  63874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63931 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63935 */     // MIs[3] LHS
     /*  63935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63940 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63944 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63950 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63957 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63959 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63976 */     GIR_RootConstrainSelectedInstOperands,
     /*  63977 */     // GIR_Coverage, 2470,
     /*  63977 */     GIR_EraseRootFromParent_Done,
     /*  63978 */   // Label 1073: @63978
     /*  63978 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(64087), // Rule ID 13673 //
     /*  63983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64040 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64044 */     // MIs[3] LHS
     /*  64044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64049 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64053 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64059 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64066 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64068 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64085 */     GIR_RootConstrainSelectedInstOperands,
     /*  64086 */     // GIR_Coverage, 13673,
     /*  64086 */     GIR_EraseRootFromParent_Done,
     /*  64087 */   // Label 1074: @64087
     /*  64087 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(64196), // Rule ID 13672 //
     /*  64092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64154 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64158 */     // MIs[3] LHS
     /*  64158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64163 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64167 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64175 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64177 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64194 */     GIR_RootConstrainSelectedInstOperands,
     /*  64195 */     // GIR_Coverage, 13672,
     /*  64195 */     GIR_EraseRootFromParent_Done,
     /*  64196 */   // Label 1075: @64196
     /*  64196 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(64305), // Rule ID 13674 //
     /*  64201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64263 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64267 */     // MIs[3] LHS
     /*  64267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64272 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64276 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64282 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64284 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64286 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64303 */     GIR_RootConstrainSelectedInstOperands,
     /*  64304 */     // GIR_Coverage, 13674,
     /*  64304 */     GIR_EraseRootFromParent_Done,
     /*  64305 */   // Label 1076: @64305
     /*  64305 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(64372), // Rule ID 13639 //
     /*  64310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64334 */     // MIs[1] imm
     /*  64334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64342 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64346 */     // MIs[2] Operand 1
     /*  64346 */     // No operand predicates
     /*  64346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64356 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64370 */     GIR_RootConstrainSelectedInstOperands,
     /*  64371 */     // GIR_Coverage, 13639,
     /*  64371 */     GIR_EraseRootFromParent_Done,
     /*  64372 */   // Label 1077: @64372
     /*  64372 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64439), // Rule ID 13660 //
     /*  64377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64401 */     // MIs[1] imm
     /*  64401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64409 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64413 */     // MIs[2] Operand 1
     /*  64413 */     // No operand predicates
     /*  64413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64423 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64437 */     GIR_RootConstrainSelectedInstOperands,
     /*  64438 */     // GIR_Coverage, 13660,
     /*  64438 */     GIR_EraseRootFromParent_Done,
     /*  64439 */   // Label 1078: @64439
     /*  64439 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(64506), // Rule ID 2239 //
     /*  64444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64472 */     // MIs[1] imm
     /*  64472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64480 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64484 */     // MIs[2] Operand 1
     /*  64484 */     // No operand predicates
     /*  64484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64490 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64504 */     GIR_RootConstrainSelectedInstOperands,
     /*  64505 */     // GIR_Coverage, 2239,
     /*  64505 */     GIR_EraseRootFromParent_Done,
     /*  64506 */   // Label 1079: @64506
     /*  64506 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(64573), // Rule ID 2298 //
     /*  64511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64539 */     // MIs[1] imm
     /*  64539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64547 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64551 */     // MIs[2] Operand 1
     /*  64551 */     // No operand predicates
     /*  64551 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64557 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64571 */     GIR_RootConstrainSelectedInstOperands,
     /*  64572 */     // GIR_Coverage, 2298,
     /*  64572 */     GIR_EraseRootFromParent_Done,
     /*  64573 */   // Label 1080: @64573
     /*  64573 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64637), // Rule ID 13973 //
     /*  64578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64610 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64624 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64629 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64635 */     GIR_RootConstrainSelectedInstOperands,
     /*  64636 */     // GIR_Coverage, 13973,
     /*  64636 */     GIR_EraseRootFromParent_Done,
     /*  64637 */   // Label 1081: @64637
     /*  64637 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64701), // Rule ID 5091 //
     /*  64642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64678 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64684 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64688 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64693 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64699 */     GIR_RootConstrainSelectedInstOperands,
     /*  64700 */     // GIR_Coverage, 5091,
     /*  64700 */     GIR_EraseRootFromParent_Done,
     /*  64701 */   // Label 1082: @64701
     /*  64701 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(64728), // Rule ID 5097 //
     /*  64706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64721 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64726 */     GIR_RootConstrainSelectedInstOperands,
     /*  64727 */     // GIR_Coverage, 5097,
     /*  64727 */     GIR_Done,
     /*  64728 */   // Label 1083: @64728
     /*  64728 */   GIM_Reject,
     /*  64729 */ // Label 1068: @64729
     /*  64729 */ GIM_Reject,
     /*  64730 */ // Label 1017: @64730
     /*  64730 */ GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(66037),
     /*  64735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64741 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(64850), // Rule ID 13704 //
     /*  64746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64794 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64807 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64811 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64815 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64819 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64824 */     // MIs[4] LHS
     /*  64824 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64829 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64831 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64848 */     GIR_RootConstrainSelectedInstOperands,
     /*  64849 */     // GIR_Coverage, 13704,
     /*  64849 */     GIR_EraseRootFromParent_Done,
     /*  64850 */   // Label 1085: @64850
     /*  64850 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(64959), // Rule ID 13703 //
     /*  64855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64903 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64909 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64916 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64920 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64924 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64928 */     // MIs[4] LHS
     /*  64928 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64933 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64938 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64940 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64957 */     GIR_RootConstrainSelectedInstOperands,
     /*  64958 */     // GIR_Coverage, 13703,
     /*  64958 */     GIR_EraseRootFromParent_Done,
     /*  64959 */   // Label 1086: @64959
     /*  64959 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(65068), // Rule ID 13706 //
     /*  64964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65017 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65023 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65025 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65029 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65033 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65037 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65042 */     // MIs[4] LHS
     /*  65042 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65047 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65049 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65066 */     GIR_RootConstrainSelectedInstOperands,
     /*  65067 */     // GIR_Coverage, 13706,
     /*  65067 */     GIR_EraseRootFromParent_Done,
     /*  65068 */   // Label 1087: @65068
     /*  65068 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(65177), // Rule ID 13705 //
     /*  65073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65126 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65132 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65134 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65138 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65142 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65146 */     // MIs[4] LHS
     /*  65146 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65151 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65156 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65158 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65175 */     GIR_RootConstrainSelectedInstOperands,
     /*  65176 */     // GIR_Coverage, 13705,
     /*  65176 */     GIR_EraseRootFromParent_Done,
     /*  65177 */   // Label 1088: @65177
     /*  65177 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(65286), // Rule ID 2474 //
     /*  65182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65243 */     // MIs[3] LHS
     /*  65243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65252 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65258 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65265 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65267 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65284 */     GIR_RootConstrainSelectedInstOperands,
     /*  65285 */     // GIR_Coverage, 2474,
     /*  65285 */     GIR_EraseRootFromParent_Done,
     /*  65286 */   // Label 1089: @65286
     /*  65286 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(65395), // Rule ID 13701 //
     /*  65291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65348 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65352 */     // MIs[3] LHS
     /*  65352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65357 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65361 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65374 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65376 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65393 */     GIR_RootConstrainSelectedInstOperands,
     /*  65394 */     // GIR_Coverage, 13701,
     /*  65394 */     GIR_EraseRootFromParent_Done,
     /*  65395 */   // Label 1090: @65395
     /*  65395 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(65504), // Rule ID 13700 //
     /*  65400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65462 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65466 */     // MIs[3] LHS
     /*  65466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65471 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65475 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65483 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65485 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65502 */     GIR_RootConstrainSelectedInstOperands,
     /*  65503 */     // GIR_Coverage, 13700,
     /*  65503 */     GIR_EraseRootFromParent_Done,
     /*  65504 */   // Label 1091: @65504
     /*  65504 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(65613), // Rule ID 13702 //
     /*  65509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65571 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65575 */     // MIs[3] LHS
     /*  65575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65580 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65584 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65590 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65592 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65594 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65611 */     GIR_RootConstrainSelectedInstOperands,
     /*  65612 */     // GIR_Coverage, 13702,
     /*  65612 */     GIR_EraseRootFromParent_Done,
     /*  65613 */   // Label 1092: @65613
     /*  65613 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(65680), // Rule ID 13643 //
     /*  65618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65642 */     // MIs[1] imm
     /*  65642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65650 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65654 */     // MIs[2] Operand 1
     /*  65654 */     // No operand predicates
     /*  65654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65664 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65678 */     GIR_RootConstrainSelectedInstOperands,
     /*  65679 */     // GIR_Coverage, 13643,
     /*  65679 */     GIR_EraseRootFromParent_Done,
     /*  65680 */   // Label 1093: @65680
     /*  65680 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65747), // Rule ID 13664 //
     /*  65685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65709 */     // MIs[1] imm
     /*  65709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65717 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65721 */     // MIs[2] Operand 1
     /*  65721 */     // No operand predicates
     /*  65721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65731 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65745 */     GIR_RootConstrainSelectedInstOperands,
     /*  65746 */     // GIR_Coverage, 13664,
     /*  65746 */     GIR_EraseRootFromParent_Done,
     /*  65747 */   // Label 1094: @65747
     /*  65747 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(65814), // Rule ID 2243 //
     /*  65752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65780 */     // MIs[1] imm
     /*  65780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65788 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65792 */     // MIs[2] Operand 1
     /*  65792 */     // No operand predicates
     /*  65792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65798 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65812 */     GIR_RootConstrainSelectedInstOperands,
     /*  65813 */     // GIR_Coverage, 2243,
     /*  65813 */     GIR_EraseRootFromParent_Done,
     /*  65814 */   // Label 1095: @65814
     /*  65814 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(65881), // Rule ID 2302 //
     /*  65819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65847 */     // MIs[1] imm
     /*  65847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65855 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65859 */     // MIs[2] Operand 1
     /*  65859 */     // No operand predicates
     /*  65859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65865 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65879 */     GIR_RootConstrainSelectedInstOperands,
     /*  65880 */     // GIR_Coverage, 2302,
     /*  65880 */     GIR_EraseRootFromParent_Done,
     /*  65881 */   // Label 1096: @65881
     /*  65881 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(65945), // Rule ID 13977 //
     /*  65886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65918 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65924 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65932 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65937 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65943 */     GIR_RootConstrainSelectedInstOperands,
     /*  65944 */     // GIR_Coverage, 13977,
     /*  65944 */     GIR_EraseRootFromParent_Done,
     /*  65945 */   // Label 1097: @65945
     /*  65945 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(66009), // Rule ID 5095 //
     /*  65950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65986 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65992 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65996 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66001 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  66003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66007 */     GIR_RootConstrainSelectedInstOperands,
     /*  66008 */     // GIR_Coverage, 5095,
     /*  66008 */     GIR_EraseRootFromParent_Done,
     /*  66009 */   // Label 1098: @66009
     /*  66009 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(66036), // Rule ID 5101 //
     /*  66014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66029 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  66029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  66034 */     GIR_RootConstrainSelectedInstOperands,
     /*  66035 */     // GIR_Coverage, 5101,
     /*  66035 */     GIR_Done,
     /*  66036 */   // Label 1099: @66036
     /*  66036 */   GIM_Reject,
     /*  66037 */ // Label 1084: @66037
     /*  66037 */ GIM_Reject,
     /*  66038 */ // Label 1018: @66038
     /*  66038 */ GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(67345),
     /*  66043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66049 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(66158), // Rule ID 13669 //
     /*  66054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66102 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66115 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66119 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66123 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66127 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66132 */     // MIs[4] LHS
     /*  66132 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66137 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66139 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66156 */     GIR_RootConstrainSelectedInstOperands,
     /*  66157 */     // GIR_Coverage, 13669,
     /*  66157 */     GIR_EraseRootFromParent_Done,
     /*  66158 */   // Label 1101: @66158
     /*  66158 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(66267), // Rule ID 13668 //
     /*  66163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66211 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66217 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66224 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66228 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66232 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66236 */     // MIs[4] LHS
     /*  66236 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66241 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66246 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66248 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66265 */     GIR_RootConstrainSelectedInstOperands,
     /*  66266 */     // GIR_Coverage, 13668,
     /*  66266 */     GIR_EraseRootFromParent_Done,
     /*  66267 */   // Label 1102: @66267
     /*  66267 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(66376), // Rule ID 13671 //
     /*  66272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66325 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66331 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66333 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66337 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66341 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66345 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66350 */     // MIs[4] LHS
     /*  66350 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66355 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66357 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66374 */     GIR_RootConstrainSelectedInstOperands,
     /*  66375 */     // GIR_Coverage, 13671,
     /*  66375 */     GIR_EraseRootFromParent_Done,
     /*  66376 */   // Label 1103: @66376
     /*  66376 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(66485), // Rule ID 13670 //
     /*  66381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66434 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66440 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66446 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66450 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66454 */     // MIs[4] LHS
     /*  66454 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66459 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66464 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66466 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66483 */     GIR_RootConstrainSelectedInstOperands,
     /*  66484 */     // GIR_Coverage, 13670,
     /*  66484 */     GIR_EraseRootFromParent_Done,
     /*  66485 */   // Label 1104: @66485
     /*  66485 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(66594), // Rule ID 2469 //
     /*  66490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66547 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66551 */     // MIs[3] LHS
     /*  66551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66556 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66560 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66566 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66573 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66575 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66592 */     GIR_RootConstrainSelectedInstOperands,
     /*  66593 */     // GIR_Coverage, 2469,
     /*  66593 */     GIR_EraseRootFromParent_Done,
     /*  66594 */   // Label 1105: @66594
     /*  66594 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(66703), // Rule ID 13666 //
     /*  66599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66656 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66660 */     // MIs[3] LHS
     /*  66660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66665 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66669 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66682 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66684 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66701 */     GIR_RootConstrainSelectedInstOperands,
     /*  66702 */     // GIR_Coverage, 13666,
     /*  66702 */     GIR_EraseRootFromParent_Done,
     /*  66703 */   // Label 1106: @66703
     /*  66703 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(66812), // Rule ID 13665 //
     /*  66708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66770 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66774 */     // MIs[3] LHS
     /*  66774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66783 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66791 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66793 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66810 */     GIR_RootConstrainSelectedInstOperands,
     /*  66811 */     // GIR_Coverage, 13665,
     /*  66811 */     GIR_EraseRootFromParent_Done,
     /*  66812 */   // Label 1107: @66812
     /*  66812 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(66921), // Rule ID 13667 //
     /*  66817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66879 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66883 */     // MIs[3] LHS
     /*  66883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66892 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66898 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66900 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66902 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66919 */     GIR_RootConstrainSelectedInstOperands,
     /*  66920 */     // GIR_Coverage, 13667,
     /*  66920 */     GIR_EraseRootFromParent_Done,
     /*  66921 */   // Label 1108: @66921
     /*  66921 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(66988), // Rule ID 13635 //
     /*  66926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66950 */     // MIs[1] imm
     /*  66950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66962 */     // MIs[2] Operand 1
     /*  66962 */     // No operand predicates
     /*  66962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66972 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66986 */     GIR_RootConstrainSelectedInstOperands,
     /*  66987 */     // GIR_Coverage, 13635,
     /*  66987 */     GIR_EraseRootFromParent_Done,
     /*  66988 */   // Label 1109: @66988
     /*  66988 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(67055), // Rule ID 13656 //
     /*  66993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67017 */     // MIs[1] imm
     /*  67017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67025 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67029 */     // MIs[2] Operand 1
     /*  67029 */     // No operand predicates
     /*  67029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67039 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  67042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67053 */     GIR_RootConstrainSelectedInstOperands,
     /*  67054 */     // GIR_Coverage, 13656,
     /*  67054 */     GIR_EraseRootFromParent_Done,
     /*  67055 */   // Label 1110: @67055
     /*  67055 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(67122), // Rule ID 2235 //
     /*  67060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67088 */     // MIs[1] imm
     /*  67088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67096 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67100 */     // MIs[2] Operand 1
     /*  67100 */     // No operand predicates
     /*  67100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67106 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  67109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67120 */     GIR_RootConstrainSelectedInstOperands,
     /*  67121 */     // GIR_Coverage, 2235,
     /*  67121 */     GIR_EraseRootFromParent_Done,
     /*  67122 */   // Label 1111: @67122
     /*  67122 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(67189), // Rule ID 2294 //
     /*  67127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67155 */     // MIs[1] imm
     /*  67155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67163 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67167 */     // MIs[2] Operand 1
     /*  67167 */     // No operand predicates
     /*  67167 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67173 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  67176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67187 */     GIR_RootConstrainSelectedInstOperands,
     /*  67188 */     // GIR_Coverage, 2294,
     /*  67188 */     GIR_EraseRootFromParent_Done,
     /*  67189 */   // Label 1112: @67189
     /*  67189 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(67253), // Rule ID 13972 //
     /*  67194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67226 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67232 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67240 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67245 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67251 */     GIR_RootConstrainSelectedInstOperands,
     /*  67252 */     // GIR_Coverage, 13972,
     /*  67252 */     GIR_EraseRootFromParent_Done,
     /*  67253 */   // Label 1113: @67253
     /*  67253 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(67317), // Rule ID 5090 //
     /*  67258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67294 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67300 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67304 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67309 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67315 */     GIR_RootConstrainSelectedInstOperands,
     /*  67316 */     // GIR_Coverage, 5090,
     /*  67316 */     GIR_EraseRootFromParent_Done,
     /*  67317 */   // Label 1114: @67317
     /*  67317 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(67344), // Rule ID 5096 //
     /*  67322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67337 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  67342 */     GIR_RootConstrainSelectedInstOperands,
     /*  67343 */     // GIR_Coverage, 5096,
     /*  67343 */     GIR_Done,
     /*  67344 */   // Label 1115: @67344
     /*  67344 */   GIM_Reject,
     /*  67345 */ // Label 1100: @67345
     /*  67345 */ GIM_Reject,
     /*  67346 */ // Label 1019: @67346
     /*  67346 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(68653),
     /*  67351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67357 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(67466), // Rule ID 13697 //
     /*  67362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67410 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67416 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67431 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67435 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67440 */     // MIs[4] LHS
     /*  67440 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67445 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67447 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67464 */     GIR_RootConstrainSelectedInstOperands,
     /*  67465 */     // GIR_Coverage, 13697,
     /*  67465 */     GIR_EraseRootFromParent_Done,
     /*  67466 */   // Label 1117: @67466
     /*  67466 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67575), // Rule ID 13696 //
     /*  67471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67519 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67540 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67544 */     // MIs[4] LHS
     /*  67544 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67549 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67554 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67556 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67573 */     GIR_RootConstrainSelectedInstOperands,
     /*  67574 */     // GIR_Coverage, 13696,
     /*  67574 */     GIR_EraseRootFromParent_Done,
     /*  67575 */   // Label 1118: @67575
     /*  67575 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67684), // Rule ID 13699 //
     /*  67580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67633 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67641 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67645 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67649 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67653 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67658 */     // MIs[4] LHS
     /*  67658 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67663 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67665 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67682 */     GIR_RootConstrainSelectedInstOperands,
     /*  67683 */     // GIR_Coverage, 13699,
     /*  67683 */     GIR_EraseRootFromParent_Done,
     /*  67684 */   // Label 1119: @67684
     /*  67684 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(67793), // Rule ID 13698 //
     /*  67689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67742 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67750 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67754 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67758 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67762 */     // MIs[4] LHS
     /*  67762 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67767 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67772 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67774 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67791 */     GIR_RootConstrainSelectedInstOperands,
     /*  67792 */     // GIR_Coverage, 13698,
     /*  67792 */     GIR_EraseRootFromParent_Done,
     /*  67793 */   // Label 1120: @67793
     /*  67793 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(67902), // Rule ID 2473 //
     /*  67798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67855 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67859 */     // MIs[3] LHS
     /*  67859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67864 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67868 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67874 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67881 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67883 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67900 */     GIR_RootConstrainSelectedInstOperands,
     /*  67901 */     // GIR_Coverage, 2473,
     /*  67901 */     GIR_EraseRootFromParent_Done,
     /*  67902 */   // Label 1121: @67902
     /*  67902 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(68011), // Rule ID 13694 //
     /*  67907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67964 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67968 */     // MIs[3] LHS
     /*  67968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67973 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67977 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67983 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67990 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67992 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  68009 */     GIR_RootConstrainSelectedInstOperands,
     /*  68010 */     // GIR_Coverage, 13694,
     /*  68010 */     GIR_EraseRootFromParent_Done,
     /*  68011 */   // Label 1122: @68011
     /*  68011 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(68120), // Rule ID 13693 //
     /*  68016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68078 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68082 */     // MIs[3] LHS
     /*  68082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68087 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68091 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68097 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68099 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68101 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68118 */     GIR_RootConstrainSelectedInstOperands,
     /*  68119 */     // GIR_Coverage, 13693,
     /*  68119 */     GIR_EraseRootFromParent_Done,
     /*  68120 */   // Label 1123: @68120
     /*  68120 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(68229), // Rule ID 13695 //
     /*  68125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68187 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68191 */     // MIs[3] LHS
     /*  68191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68196 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68200 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68208 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68210 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68227 */     GIR_RootConstrainSelectedInstOperands,
     /*  68228 */     // GIR_Coverage, 13695,
     /*  68228 */     GIR_EraseRootFromParent_Done,
     /*  68229 */   // Label 1124: @68229
     /*  68229 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(68296), // Rule ID 13641 //
     /*  68234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68258 */     // MIs[1] imm
     /*  68258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68266 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68270 */     // MIs[2] Operand 1
     /*  68270 */     // No operand predicates
     /*  68270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68280 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68294 */     GIR_RootConstrainSelectedInstOperands,
     /*  68295 */     // GIR_Coverage, 13641,
     /*  68295 */     GIR_EraseRootFromParent_Done,
     /*  68296 */   // Label 1125: @68296
     /*  68296 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68363), // Rule ID 13662 //
     /*  68301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68325 */     // MIs[1] imm
     /*  68325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68333 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68337 */     // MIs[2] Operand 1
     /*  68337 */     // No operand predicates
     /*  68337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68347 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68361 */     GIR_RootConstrainSelectedInstOperands,
     /*  68362 */     // GIR_Coverage, 13662,
     /*  68362 */     GIR_EraseRootFromParent_Done,
     /*  68363 */   // Label 1126: @68363
     /*  68363 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(68430), // Rule ID 2241 //
     /*  68368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68396 */     // MIs[1] imm
     /*  68396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68404 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68408 */     // MIs[2] Operand 1
     /*  68408 */     // No operand predicates
     /*  68408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68414 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68428 */     GIR_RootConstrainSelectedInstOperands,
     /*  68429 */     // GIR_Coverage, 2241,
     /*  68429 */     GIR_EraseRootFromParent_Done,
     /*  68430 */   // Label 1127: @68430
     /*  68430 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(68497), // Rule ID 2300 //
     /*  68435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68463 */     // MIs[1] imm
     /*  68463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68471 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68475 */     // MIs[2] Operand 1
     /*  68475 */     // No operand predicates
     /*  68475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68481 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68495 */     GIR_RootConstrainSelectedInstOperands,
     /*  68496 */     // GIR_Coverage, 2300,
     /*  68496 */     GIR_EraseRootFromParent_Done,
     /*  68497 */   // Label 1128: @68497
     /*  68497 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68561), // Rule ID 13976 //
     /*  68502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68534 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68540 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68548 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68553 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68559 */     GIR_RootConstrainSelectedInstOperands,
     /*  68560 */     // GIR_Coverage, 13976,
     /*  68560 */     GIR_EraseRootFromParent_Done,
     /*  68561 */   // Label 1129: @68561
     /*  68561 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68625), // Rule ID 5094 //
     /*  68566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68602 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68608 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68612 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68617 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68623 */     GIR_RootConstrainSelectedInstOperands,
     /*  68624 */     // GIR_Coverage, 5094,
     /*  68624 */     GIR_EraseRootFromParent_Done,
     /*  68625 */   // Label 1130: @68625
     /*  68625 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(68652), // Rule ID 5100 //
     /*  68630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68645 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  68650 */     GIR_RootConstrainSelectedInstOperands,
     /*  68651 */     // GIR_Coverage, 5100,
     /*  68651 */     GIR_Done,
     /*  68652 */   // Label 1131: @68652
     /*  68652 */   GIM_Reject,
     /*  68653 */ // Label 1116: @68653
     /*  68653 */ GIM_Reject,
     /*  68654 */ // Label 1020: @68654
     /*  68654 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(69961),
     /*  68659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68665 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(68774), // Rule ID 13457 //
     /*  68670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68718 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68735 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68739 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68743 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68748 */     // MIs[4] Rd
     /*  68748 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68753 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68755 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68772 */     GIR_RootConstrainSelectedInstOperands,
     /*  68773 */     // GIR_Coverage, 13457,
     /*  68773 */     GIR_EraseRootFromParent_Done,
     /*  68774 */   // Label 1133: @68774
     /*  68774 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(68883), // Rule ID 13456 //
     /*  68779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68827 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68833 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68840 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68844 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68848 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68852 */     // MIs[4] Rd
     /*  68852 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68857 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68862 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68864 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68881 */     GIR_RootConstrainSelectedInstOperands,
     /*  68882 */     // GIR_Coverage, 13456,
     /*  68882 */     GIR_EraseRootFromParent_Done,
     /*  68883 */   // Label 1134: @68883
     /*  68883 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(68992), // Rule ID 13459 //
     /*  68888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68941 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68949 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68953 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68957 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68961 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68966 */     // MIs[4] Rd
     /*  68966 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68971 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68973 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68990 */     GIR_RootConstrainSelectedInstOperands,
     /*  68991 */     // GIR_Coverage, 13459,
     /*  68991 */     GIR_EraseRootFromParent_Done,
     /*  68992 */   // Label 1135: @68992
     /*  68992 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(69101), // Rule ID 13458 //
     /*  68997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69050 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69058 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69062 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69066 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69070 */     // MIs[4] Rd
     /*  69070 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69075 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69080 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69082 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  69091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  69095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69099 */     GIR_RootConstrainSelectedInstOperands,
     /*  69100 */     // GIR_Coverage, 13458,
     /*  69100 */     GIR_EraseRootFromParent_Done,
     /*  69101 */   // Label 1136: @69101
     /*  69101 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(69210), // Rule ID 1605 //
     /*  69106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69163 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69167 */     // MIs[3] Rd
     /*  69167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69176 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69182 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69189 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69191 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69208 */     GIR_RootConstrainSelectedInstOperands,
     /*  69209 */     // GIR_Coverage, 1605,
     /*  69209 */     GIR_EraseRootFromParent_Done,
     /*  69210 */   // Label 1137: @69210
     /*  69210 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(69319), // Rule ID 13454 //
     /*  69215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69272 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69276 */     // MIs[3] Rd
     /*  69276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69285 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69291 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69298 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69300 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69317 */     GIR_RootConstrainSelectedInstOperands,
     /*  69318 */     // GIR_Coverage, 13454,
     /*  69318 */     GIR_EraseRootFromParent_Done,
     /*  69319 */   // Label 1138: @69319
     /*  69319 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(69428), // Rule ID 13453 //
     /*  69324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69390 */     // MIs[3] Rd
     /*  69390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69395 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69399 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69407 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69409 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69426 */     GIR_RootConstrainSelectedInstOperands,
     /*  69427 */     // GIR_Coverage, 13453,
     /*  69427 */     GIR_EraseRootFromParent_Done,
     /*  69428 */   // Label 1139: @69428
     /*  69428 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(69537), // Rule ID 13455 //
     /*  69433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69495 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69499 */     // MIs[3] Rd
     /*  69499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69508 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69514 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69516 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69518 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69535 */     GIR_RootConstrainSelectedInstOperands,
     /*  69536 */     // GIR_Coverage, 13455,
     /*  69536 */     GIR_EraseRootFromParent_Done,
     /*  69537 */   // Label 1140: @69537
     /*  69537 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(69604), // Rule ID 13631 //
     /*  69542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69566 */     // MIs[1] imm
     /*  69566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69574 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69578 */     // MIs[2] Operand 1
     /*  69578 */     // No operand predicates
     /*  69578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69588 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69602 */     GIR_RootConstrainSelectedInstOperands,
     /*  69603 */     // GIR_Coverage, 13631,
     /*  69603 */     GIR_EraseRootFromParent_Done,
     /*  69604 */   // Label 1141: @69604
     /*  69604 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69671), // Rule ID 13652 //
     /*  69609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69633 */     // MIs[1] imm
     /*  69633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69641 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69645 */     // MIs[2] Operand 1
     /*  69645 */     // No operand predicates
     /*  69645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69655 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69669 */     GIR_RootConstrainSelectedInstOperands,
     /*  69670 */     // GIR_Coverage, 13652,
     /*  69670 */     GIR_EraseRootFromParent_Done,
     /*  69671 */   // Label 1142: @69671
     /*  69671 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69738), // Rule ID 2231 //
     /*  69676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69704 */     // MIs[1] imm
     /*  69704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69712 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69716 */     // MIs[2] Operand 1
     /*  69716 */     // No operand predicates
     /*  69716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69722 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69736 */     GIR_RootConstrainSelectedInstOperands,
     /*  69737 */     // GIR_Coverage, 2231,
     /*  69737 */     GIR_EraseRootFromParent_Done,
     /*  69738 */   // Label 1143: @69738
     /*  69738 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(69805), // Rule ID 2290 //
     /*  69743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69771 */     // MIs[1] imm
     /*  69771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69779 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69783 */     // MIs[2] Operand 1
     /*  69783 */     // No operand predicates
     /*  69783 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69789 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69803 */     GIR_RootConstrainSelectedInstOperands,
     /*  69804 */     // GIR_Coverage, 2290,
     /*  69804 */     GIR_EraseRootFromParent_Done,
     /*  69805 */   // Label 1144: @69805
     /*  69805 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(69869), // Rule ID 13451 //
     /*  69810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69842 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69848 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69856 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69867 */     GIR_RootConstrainSelectedInstOperands,
     /*  69868 */     // GIR_Coverage, 13451,
     /*  69868 */     GIR_EraseRootFromParent_Done,
     /*  69869 */   // Label 1145: @69869
     /*  69869 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(69933), // Rule ID 1601 //
     /*  69874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69910 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69916 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69920 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69931 */     GIR_RootConstrainSelectedInstOperands,
     /*  69932 */     // GIR_Coverage, 1601,
     /*  69932 */     GIR_EraseRootFromParent_Done,
     /*  69933 */   // Label 1146: @69933
     /*  69933 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(69960), // Rule ID 1603 //
     /*  69938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69953 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  69958 */     GIR_RootConstrainSelectedInstOperands,
     /*  69959 */     // GIR_Coverage, 1603,
     /*  69959 */     GIR_Done,
     /*  69960 */   // Label 1147: @69960
     /*  69960 */   GIM_Reject,
     /*  69961 */ // Label 1132: @69961
     /*  69961 */ GIM_Reject,
     /*  69962 */ // Label 1021: @69962
     /*  69962 */ GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71269),
     /*  69967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69973 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(70082), // Rule ID 13690 //
     /*  69978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70026 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70032 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70039 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70043 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70047 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70051 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70056 */     // MIs[4] LHS
     /*  70056 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70061 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70063 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  70080 */     GIR_RootConstrainSelectedInstOperands,
     /*  70081 */     // GIR_Coverage, 13690,
     /*  70081 */     GIR_EraseRootFromParent_Done,
     /*  70082 */   // Label 1149: @70082
     /*  70082 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(70191), // Rule ID 13689 //
     /*  70087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70122 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70135 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70141 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70148 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70152 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70156 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70160 */     // MIs[4] LHS
     /*  70160 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70165 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70170 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70172 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  70189 */     GIR_RootConstrainSelectedInstOperands,
     /*  70190 */     // GIR_Coverage, 13689,
     /*  70190 */     GIR_EraseRootFromParent_Done,
     /*  70191 */   // Label 1150: @70191
     /*  70191 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(70300), // Rule ID 13692 //
     /*  70196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70249 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70255 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70257 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70261 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70265 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70269 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70274 */     // MIs[4] LHS
     /*  70274 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70279 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70281 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70298 */     GIR_RootConstrainSelectedInstOperands,
     /*  70299 */     // GIR_Coverage, 13692,
     /*  70299 */     GIR_EraseRootFromParent_Done,
     /*  70300 */   // Label 1151: @70300
     /*  70300 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(70409), // Rule ID 13691 //
     /*  70305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70358 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70366 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70370 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70374 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70378 */     // MIs[4] LHS
     /*  70378 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70383 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70390 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70407 */     GIR_RootConstrainSelectedInstOperands,
     /*  70408 */     // GIR_Coverage, 13691,
     /*  70408 */     GIR_EraseRootFromParent_Done,
     /*  70409 */   // Label 1152: @70409
     /*  70409 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(70518), // Rule ID 2472 //
     /*  70414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70471 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70475 */     // MIs[3] LHS
     /*  70475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70480 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70484 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70490 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70497 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70499 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70516 */     GIR_RootConstrainSelectedInstOperands,
     /*  70517 */     // GIR_Coverage, 2472,
     /*  70517 */     GIR_EraseRootFromParent_Done,
     /*  70518 */   // Label 1153: @70518
     /*  70518 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(70627), // Rule ID 13687 //
     /*  70523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70580 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70584 */     // MIs[3] LHS
     /*  70584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70589 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70593 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70606 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70608 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70625 */     GIR_RootConstrainSelectedInstOperands,
     /*  70626 */     // GIR_Coverage, 13687,
     /*  70626 */     GIR_EraseRootFromParent_Done,
     /*  70627 */   // Label 1154: @70627
     /*  70627 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(70736), // Rule ID 13686 //
     /*  70632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70694 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70698 */     // MIs[3] LHS
     /*  70698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70703 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70707 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70713 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70715 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70717 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70734 */     GIR_RootConstrainSelectedInstOperands,
     /*  70735 */     // GIR_Coverage, 13686,
     /*  70735 */     GIR_EraseRootFromParent_Done,
     /*  70736 */   // Label 1155: @70736
     /*  70736 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(70845), // Rule ID 13688 //
     /*  70741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70803 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70807 */     // MIs[3] LHS
     /*  70807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70812 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70816 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70822 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70824 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70826 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70843 */     GIR_RootConstrainSelectedInstOperands,
     /*  70844 */     // GIR_Coverage, 13688,
     /*  70844 */     GIR_EraseRootFromParent_Done,
     /*  70845 */   // Label 1156: @70845
     /*  70845 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(70912), // Rule ID 13637 //
     /*  70850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70874 */     // MIs[1] imm
     /*  70874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70882 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70886 */     // MIs[2] Operand 1
     /*  70886 */     // No operand predicates
     /*  70886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70896 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70910 */     GIR_RootConstrainSelectedInstOperands,
     /*  70911 */     // GIR_Coverage, 13637,
     /*  70911 */     GIR_EraseRootFromParent_Done,
     /*  70912 */   // Label 1157: @70912
     /*  70912 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(70979), // Rule ID 13658 //
     /*  70917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70941 */     // MIs[1] imm
     /*  70941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70949 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70953 */     // MIs[2] Operand 1
     /*  70953 */     // No operand predicates
     /*  70953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70963 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70977 */     GIR_RootConstrainSelectedInstOperands,
     /*  70978 */     // GIR_Coverage, 13658,
     /*  70978 */     GIR_EraseRootFromParent_Done,
     /*  70979 */   // Label 1158: @70979
     /*  70979 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(71046), // Rule ID 2237 //
     /*  70984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71012 */     // MIs[1] imm
     /*  71012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71020 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  71024 */     // MIs[2] Operand 1
     /*  71024 */     // No operand predicates
     /*  71024 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71030 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  71033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71044 */     GIR_RootConstrainSelectedInstOperands,
     /*  71045 */     // GIR_Coverage, 2237,
     /*  71045 */     GIR_EraseRootFromParent_Done,
     /*  71046 */   // Label 1159: @71046
     /*  71046 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(71113), // Rule ID 2296 //
     /*  71051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71079 */     // MIs[1] imm
     /*  71079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71087 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  71091 */     // MIs[2] Operand 1
     /*  71091 */     // No operand predicates
     /*  71091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71097 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  71100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71111 */     GIR_RootConstrainSelectedInstOperands,
     /*  71112 */     // GIR_Coverage, 2296,
     /*  71112 */     GIR_EraseRootFromParent_Done,
     /*  71113 */   // Label 1160: @71113
     /*  71113 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71177), // Rule ID 13975 //
     /*  71118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71150 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71156 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71164 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71169 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  71171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71175 */     GIR_RootConstrainSelectedInstOperands,
     /*  71176 */     // GIR_Coverage, 13975,
     /*  71176 */     GIR_EraseRootFromParent_Done,
     /*  71177 */   // Label 1161: @71177
     /*  71177 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(71241), // Rule ID 5093 //
     /*  71182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71218 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71228 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71233 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  71235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71239 */     GIR_RootConstrainSelectedInstOperands,
     /*  71240 */     // GIR_Coverage, 5093,
     /*  71240 */     GIR_EraseRootFromParent_Done,
     /*  71241 */   // Label 1162: @71241
     /*  71241 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(71268), // Rule ID 5099 //
     /*  71246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71261 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  71266 */     GIR_RootConstrainSelectedInstOperands,
     /*  71267 */     // GIR_Coverage, 5099,
     /*  71267 */     GIR_Done,
     /*  71268 */   // Label 1163: @71268
     /*  71268 */   GIM_Reject,
     /*  71269 */ // Label 1148: @71269
     /*  71269 */ GIM_Reject,
     /*  71270 */ // Label 1022: @71270
     /*  71270 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72577),
     /*  71275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71281 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(71390), // Rule ID 13464 //
     /*  71286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71334 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71340 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71347 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71351 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71355 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71359 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71364 */     // MIs[4] Rd
     /*  71364 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71369 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71371 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71388 */     GIR_RootConstrainSelectedInstOperands,
     /*  71389 */     // GIR_Coverage, 13464,
     /*  71389 */     GIR_EraseRootFromParent_Done,
     /*  71390 */   // Label 1165: @71390
     /*  71390 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(71499), // Rule ID 13463 //
     /*  71395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71443 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71449 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71464 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71468 */     // MIs[4] Rd
     /*  71468 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71473 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71478 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71480 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71497 */     GIR_RootConstrainSelectedInstOperands,
     /*  71498 */     // GIR_Coverage, 13463,
     /*  71498 */     GIR_EraseRootFromParent_Done,
     /*  71499 */   // Label 1166: @71499
     /*  71499 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71608), // Rule ID 13466 //
     /*  71504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71557 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71563 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71565 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71569 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71573 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71577 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71582 */     // MIs[4] Rd
     /*  71582 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71587 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71589 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71606 */     GIR_RootConstrainSelectedInstOperands,
     /*  71607 */     // GIR_Coverage, 13466,
     /*  71607 */     GIR_EraseRootFromParent_Done,
     /*  71608 */   // Label 1167: @71608
     /*  71608 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71717), // Rule ID 13465 //
     /*  71613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71666 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71672 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71674 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71678 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71682 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71686 */     // MIs[4] Rd
     /*  71686 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71691 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71696 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71698 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71715 */     GIR_RootConstrainSelectedInstOperands,
     /*  71716 */     // GIR_Coverage, 13465,
     /*  71716 */     GIR_EraseRootFromParent_Done,
     /*  71717 */   // Label 1168: @71717
     /*  71717 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(71826), // Rule ID 1606 //
     /*  71722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71779 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71783 */     // MIs[3] Rd
     /*  71783 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71788 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71792 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71798 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71805 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71807 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71824 */     GIR_RootConstrainSelectedInstOperands,
     /*  71825 */     // GIR_Coverage, 1606,
     /*  71825 */     GIR_EraseRootFromParent_Done,
     /*  71826 */   // Label 1169: @71826
     /*  71826 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(71935), // Rule ID 13461 //
     /*  71831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71888 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71892 */     // MIs[3] Rd
     /*  71892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71897 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71901 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71907 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71914 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71916 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71933 */     GIR_RootConstrainSelectedInstOperands,
     /*  71934 */     // GIR_Coverage, 13461,
     /*  71934 */     GIR_EraseRootFromParent_Done,
     /*  71935 */   // Label 1170: @71935
     /*  71935 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72044), // Rule ID 13460 //
     /*  71940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72002 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72006 */     // MIs[3] Rd
     /*  72006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  72011 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72015 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72021 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72023 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72025 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  72034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  72038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  72042 */     GIR_RootConstrainSelectedInstOperands,
     /*  72043 */     // GIR_Coverage, 13460,
     /*  72043 */     GIR_EraseRootFromParent_Done,
     /*  72044 */   // Label 1171: @72044
     /*  72044 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72153), // Rule ID 13462 //
     /*  72049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72111 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72115 */     // MIs[3] Rd
     /*  72115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72124 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72130 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72132 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72134 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  72143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  72151 */     GIR_RootConstrainSelectedInstOperands,
     /*  72152 */     // GIR_Coverage, 13462,
     /*  72152 */     GIR_EraseRootFromParent_Done,
     /*  72153 */   // Label 1172: @72153
     /*  72153 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72220), // Rule ID 13633 //
     /*  72158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72182 */     // MIs[1] imm
     /*  72182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72190 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72194 */     // MIs[2] Operand 1
     /*  72194 */     // No operand predicates
     /*  72194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72204 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72218 */     GIR_RootConstrainSelectedInstOperands,
     /*  72219 */     // GIR_Coverage, 13633,
     /*  72219 */     GIR_EraseRootFromParent_Done,
     /*  72220 */   // Label 1173: @72220
     /*  72220 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72287), // Rule ID 13654 //
     /*  72225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72249 */     // MIs[1] imm
     /*  72249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72257 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72261 */     // MIs[2] Operand 1
     /*  72261 */     // No operand predicates
     /*  72261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72271 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72285 */     GIR_RootConstrainSelectedInstOperands,
     /*  72286 */     // GIR_Coverage, 13654,
     /*  72286 */     GIR_EraseRootFromParent_Done,
     /*  72287 */   // Label 1174: @72287
     /*  72287 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72354), // Rule ID 2233 //
     /*  72292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72320 */     // MIs[1] imm
     /*  72320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72328 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72332 */     // MIs[2] Operand 1
     /*  72332 */     // No operand predicates
     /*  72332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72338 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72352 */     GIR_RootConstrainSelectedInstOperands,
     /*  72353 */     // GIR_Coverage, 2233,
     /*  72353 */     GIR_EraseRootFromParent_Done,
     /*  72354 */   // Label 1175: @72354
     /*  72354 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72421), // Rule ID 2292 //
     /*  72359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72387 */     // MIs[1] imm
     /*  72387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72395 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72399 */     // MIs[2] Operand 1
     /*  72399 */     // No operand predicates
     /*  72399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72405 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72419 */     GIR_RootConstrainSelectedInstOperands,
     /*  72420 */     // GIR_Coverage, 2292,
     /*  72420 */     GIR_EraseRootFromParent_Done,
     /*  72421 */   // Label 1176: @72421
     /*  72421 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72485), // Rule ID 13452 //
     /*  72426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72458 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72464 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72472 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72483 */     GIR_RootConstrainSelectedInstOperands,
     /*  72484 */     // GIR_Coverage, 13452,
     /*  72484 */     GIR_EraseRootFromParent_Done,
     /*  72485 */   // Label 1177: @72485
     /*  72485 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72549), // Rule ID 1602 //
     /*  72490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72526 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72536 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72547 */     GIR_RootConstrainSelectedInstOperands,
     /*  72548 */     // GIR_Coverage, 1602,
     /*  72548 */     GIR_EraseRootFromParent_Done,
     /*  72549 */   // Label 1178: @72549
     /*  72549 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72576), // Rule ID 1604 //
     /*  72554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72569 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  72574 */     GIR_RootConstrainSelectedInstOperands,
     /*  72575 */     // GIR_Coverage, 1604,
     /*  72575 */     GIR_Done,
     /*  72576 */   // Label 1179: @72576
     /*  72576 */   GIM_Reject,
     /*  72577 */ // Label 1164: @72577
     /*  72577 */ GIM_Reject,
     /*  72578 */ // Label 1023: @72578
     /*  72578 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(72609), // Rule ID 8524 //
     /*  72583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  72589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  72592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72596 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  72596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72601 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72603 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72605 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72607 */   GIR_RootConstrainSelectedInstOperands,
     /*  72608 */   // GIR_Coverage, 8524,
     /*  72608 */   GIR_EraseRootFromParent_Done,
     /*  72609 */ // Label 1180: @72609
     /*  72609 */ GIM_Reject,
     /*  72610 */ // Label 1024: @72610
     /*  72610 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(72641), // Rule ID 8523 //
     /*  72615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  72621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  72624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72628 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  72628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72633 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72635 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72637 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72639 */   GIR_RootConstrainSelectedInstOperands,
     /*  72640 */   // GIR_Coverage, 8523,
     /*  72640 */   GIR_EraseRootFromParent_Done,
     /*  72641 */ // Label 1181: @72641
     /*  72641 */ GIM_Reject,
     /*  72642 */ // Label 1025: @72642
     /*  72642 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(76001),
     /*  72647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72657 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(72775), // Rule ID 15807 //
     /*  72662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  72665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72701 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72707 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72709 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  72713 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72717 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72721 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72725 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  72729 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  72737 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  72741 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72745 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72749 */     // MIs[6] Op3
     /*  72749 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  72754 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  72756 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  72756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  72759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  72761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  72765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  72769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  72773 */     GIR_RootConstrainSelectedInstOperands,
     /*  72774 */     // GIR_Coverage, 15807,
     /*  72774 */     GIR_EraseRootFromParent_Done,
     /*  72775 */   // Label 1183: @72775
     /*  72775 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(72893), // Rule ID 15809 //
     /*  72780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  72783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72819 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72825 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72827 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  72831 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72835 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72839 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72843 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  72847 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72853 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  72855 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  72859 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72863 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72867 */     // MIs[6] Op3
     /*  72867 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72872 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  72874 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  72874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  72877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  72879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  72883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  72887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  72891 */     GIR_RootConstrainSelectedInstOperands,
     /*  72892 */     // GIR_Coverage, 15809,
     /*  72892 */     GIR_EraseRootFromParent_Done,
     /*  72893 */   // Label 1184: @72893
     /*  72893 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73011), // Rule ID 15806 //
     /*  72898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  72901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72937 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72943 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72945 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  72949 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72953 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72957 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72961 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  72965 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72971 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  72973 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  72977 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72981 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72985 */     // MIs[6] Op3
     /*  72985 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  72990 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  72992 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  72992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  72995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  72997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  73001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  73005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  73009 */     GIR_RootConstrainSelectedInstOperands,
     /*  73010 */     // GIR_Coverage, 15806,
     /*  73010 */     GIR_EraseRootFromParent_Done,
     /*  73011 */   // Label 1185: @73011
     /*  73011 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73129), // Rule ID 15808 //
     /*  73016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73055 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73061 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  73067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73071 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73075 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73079 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73083 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73089 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  73091 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  73095 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73099 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73103 */     // MIs[6] Op3
     /*  73103 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73108 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73110 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  73113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  73119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  73123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73127 */     GIR_RootConstrainSelectedInstOperands,
     /*  73128 */     // GIR_Coverage, 15808,
     /*  73128 */     GIR_EraseRootFromParent_Done,
     /*  73129 */   // Label 1186: @73129
     /*  73129 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73247), // Rule ID 15754 //
     /*  73134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73173 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73179 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73181 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73185 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73189 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73193 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73197 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73201 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73205 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73209 */     // MIs[5] Op3
     /*  73209 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73214 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73218 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73226 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73228 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  73237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  73241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  73245 */     GIR_RootConstrainSelectedInstOperands,
     /*  73246 */     // GIR_Coverage, 15754,
     /*  73246 */     GIR_EraseRootFromParent_Done,
     /*  73247 */   // Label 1187: @73247
     /*  73247 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73365), // Rule ID 15759 //
     /*  73252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73291 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73297 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73299 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73303 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73307 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73311 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73315 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73319 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73323 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73327 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73331 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73337 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73339 */     // MIs[4] Op3
     /*  73339 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73344 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73346 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73363 */     GIR_RootConstrainSelectedInstOperands,
     /*  73364 */     // GIR_Coverage, 15759,
     /*  73364 */     GIR_EraseRootFromParent_Done,
     /*  73365 */   // Label 1188: @73365
     /*  73365 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73483), // Rule ID 15760 //
     /*  73370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73409 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73415 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73417 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73421 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73425 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73429 */     // MIs[4] Op3
     /*  73429 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73434 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73438 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73442 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73446 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73450 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73454 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73460 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73462 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73464 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73481 */     GIR_RootConstrainSelectedInstOperands,
     /*  73482 */     // GIR_Coverage, 15760,
     /*  73482 */     GIR_EraseRootFromParent_Done,
     /*  73483 */   // Label 1189: @73483
     /*  73483 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(73601), // Rule ID 11960 //
     /*  73488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73527 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73533 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73535 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73539 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73543 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73547 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73551 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73555 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73559 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73563 */     // MIs[5] Op3
     /*  73563 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73568 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73572 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73578 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73580 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73582 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  73591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  73595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  73599 */     GIR_RootConstrainSelectedInstOperands,
     /*  73600 */     // GIR_Coverage, 11960,
     /*  73600 */     GIR_EraseRootFromParent_Done,
     /*  73601 */   // Label 1190: @73601
     /*  73601 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(73719), // Rule ID 15756 //
     /*  73606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73645 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73651 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73653 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73657 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73661 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73665 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73669 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73673 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73677 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73681 */     // MIs[5] Op3
     /*  73681 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  73686 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73690 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73696 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73698 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73700 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  73709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  73713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  73717 */     GIR_RootConstrainSelectedInstOperands,
     /*  73718 */     // GIR_Coverage, 15756,
     /*  73718 */     GIR_EraseRootFromParent_Done,
     /*  73719 */   // Label 1191: @73719
     /*  73719 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(73837), // Rule ID 15757 //
     /*  73724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73763 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73769 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73771 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73775 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73779 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73783 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73787 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73791 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73795 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73799 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73803 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73809 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73811 */     // MIs[4] Op3
     /*  73811 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73816 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73818 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  73831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73835 */     GIR_RootConstrainSelectedInstOperands,
     /*  73836 */     // GIR_Coverage, 15757,
     /*  73836 */     GIR_EraseRootFromParent_Done,
     /*  73837 */   // Label 1192: @73837
     /*  73837 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(73955), // Rule ID 15758 //
     /*  73842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73881 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73887 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73889 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73893 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73897 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73901 */     // MIs[4] Op3
     /*  73901 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73906 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73910 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73914 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73918 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73922 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73926 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73932 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73934 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73936 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  73949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73953 */     GIR_RootConstrainSelectedInstOperands,
     /*  73954 */     // GIR_Coverage, 15758,
     /*  73954 */     GIR_EraseRootFromParent_Done,
     /*  73955 */   // Label 1193: @73955
     /*  73955 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74073), // Rule ID 15755 //
     /*  73960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73999 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74007 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74011 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74015 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74019 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74023 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74027 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74031 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74035 */     // MIs[5] Op3
     /*  74035 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  74040 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74044 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74050 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74052 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74054 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  74063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  74067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74071 */     GIR_RootConstrainSelectedInstOperands,
     /*  74072 */     // GIR_Coverage, 15755,
     /*  74072 */     GIR_EraseRootFromParent_Done,
     /*  74073 */   // Label 1194: @74073
     /*  74073 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74191), // Rule ID 15803 //
     /*  74078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74121 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74125 */     // MIs[3] Op3
     /*  74125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74130 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74134 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74140 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74142 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74146 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74150 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74154 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74158 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74162 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74170 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74172 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  74185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74189 */     GIR_RootConstrainSelectedInstOperands,
     /*  74190 */     // GIR_Coverage, 15803,
     /*  74190 */     GIR_EraseRootFromParent_Done,
     /*  74191 */   // Label 1195: @74191
     /*  74191 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74309), // Rule ID 15805 //
     /*  74196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74243 */     // MIs[3] Op3
     /*  74243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  74248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74252 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74258 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74260 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74264 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74268 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74272 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74276 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74280 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74286 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74288 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74290 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  74303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74307 */     GIR_RootConstrainSelectedInstOperands,
     /*  74308 */     // GIR_Coverage, 15805,
     /*  74308 */     GIR_EraseRootFromParent_Done,
     /*  74309 */   // Label 1196: @74309
     /*  74309 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74427), // Rule ID 11971 //
     /*  74314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74357 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74361 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74365 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74369 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74375 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74377 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74381 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74385 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74389 */     // MIs[5] Op3
     /*  74389 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74394 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74398 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74406 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74408 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  74421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74425 */     GIR_RootConstrainSelectedInstOperands,
     /*  74426 */     // GIR_Coverage, 11971,
     /*  74426 */     GIR_EraseRootFromParent_Done,
     /*  74427 */   // Label 1197: @74427
     /*  74427 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74545), // Rule ID 15804 //
     /*  74432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74475 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74479 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74483 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74487 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74493 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74495 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74499 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74503 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74507 */     // MIs[5] Op3
     /*  74507 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  74512 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74516 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74522 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74524 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74526 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  74539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74543 */     GIR_RootConstrainSelectedInstOperands,
     /*  74544 */     // GIR_Coverage, 15804,
     /*  74544 */     GIR_EraseRootFromParent_Done,
     /*  74545 */   // Label 1198: @74545
     /*  74545 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74635), // Rule ID 15732 //
     /*  74550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74589 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74595 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74597 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74601 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74605 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74609 */     // MIs[4] Op3
     /*  74609 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74614 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74616 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  74625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74633 */     GIR_RootConstrainSelectedInstOperands,
     /*  74634 */     // GIR_Coverage, 15732,
     /*  74634 */     GIR_EraseRootFromParent_Done,
     /*  74635 */   // Label 1199: @74635
     /*  74635 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74725), // Rule ID 15731 //
     /*  74640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74679 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74691 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74695 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74699 */     // MIs[4] Op3
     /*  74699 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74704 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74706 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  74715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74723 */     GIR_RootConstrainSelectedInstOperands,
     /*  74724 */     // GIR_Coverage, 15731,
     /*  74724 */     GIR_EraseRootFromParent_Done,
     /*  74725 */   // Label 1200: @74725
     /*  74725 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74815), // Rule ID 15730 //
     /*  74730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74769 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74775 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74785 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74789 */     // MIs[4] Op3
     /*  74789 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74794 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74796 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  74805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74813 */     GIR_RootConstrainSelectedInstOperands,
     /*  74814 */     // GIR_Coverage, 15730,
     /*  74814 */     GIR_EraseRootFromParent_Done,
     /*  74815 */   // Label 1201: @74815
     /*  74815 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74905), // Rule ID 15729 //
     /*  74820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74859 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74865 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74867 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74871 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74875 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74879 */     // MIs[4] Op3
     /*  74879 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74884 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74886 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  74895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74903 */     GIR_RootConstrainSelectedInstOperands,
     /*  74904 */     // GIR_Coverage, 15729,
     /*  74904 */     GIR_EraseRootFromParent_Done,
     /*  74905 */   // Label 1202: @74905
     /*  74905 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74995), // Rule ID 15726 //
     /*  74910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74953 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74957 */     // MIs[3] Op3
     /*  74957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74962 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74966 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74972 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74974 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74976 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  74989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74993 */     GIR_RootConstrainSelectedInstOperands,
     /*  74994 */     // GIR_Coverage, 15726,
     /*  74994 */     GIR_EraseRootFromParent_Done,
     /*  74995 */   // Label 1203: @74995
     /*  74995 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(75085), // Rule ID 15728 //
     /*  75000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75043 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75047 */     // MIs[3] Op3
     /*  75047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75052 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75056 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75062 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75064 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75066 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  75069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  75079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75083 */     GIR_RootConstrainSelectedInstOperands,
     /*  75084 */     // GIR_Coverage, 15728,
     /*  75084 */     GIR_EraseRootFromParent_Done,
     /*  75085 */   // Label 1204: @75085
     /*  75085 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(75175), // Rule ID 11952 //
     /*  75090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75133 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75137 */     // MIs[3] Op3
     /*  75137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75142 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75146 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75152 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75154 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75156 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  75159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75173 */     GIR_RootConstrainSelectedInstOperands,
     /*  75174 */     // GIR_Coverage, 11952,
     /*  75174 */     GIR_EraseRootFromParent_Done,
     /*  75175 */   // Label 1205: @75175
     /*  75175 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(75265), // Rule ID 15727 //
     /*  75180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75223 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75227 */     // MIs[3] Op3
     /*  75227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75232 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75236 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75242 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75244 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75246 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  75249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75263 */     GIR_RootConstrainSelectedInstOperands,
     /*  75264 */     // GIR_Coverage, 15727,
     /*  75264 */     GIR_EraseRootFromParent_Done,
     /*  75265 */   // Label 1206: @75265
     /*  75265 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(75355), // Rule ID 15810 //
     /*  75270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75313 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75317 */     // MIs[3] Op3
     /*  75317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75326 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75332 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75334 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75336 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  75349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75353 */     GIR_RootConstrainSelectedInstOperands,
     /*  75354 */     // GIR_Coverage, 15810,
     /*  75354 */     GIR_EraseRootFromParent_Done,
     /*  75355 */   // Label 1207: @75355
     /*  75355 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(75445), // Rule ID 15812 //
     /*  75360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75403 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75407 */     // MIs[3] Op3
     /*  75407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75416 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75422 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75424 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75426 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  75439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75443 */     GIR_RootConstrainSelectedInstOperands,
     /*  75444 */     // GIR_Coverage, 15812,
     /*  75444 */     GIR_EraseRootFromParent_Done,
     /*  75445 */   // Label 1208: @75445
     /*  75445 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(75535), // Rule ID 11972 //
     /*  75450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75493 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75497 */     // MIs[3] Op3
     /*  75497 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75502 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75506 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75512 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75514 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75516 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  75529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75533 */     GIR_RootConstrainSelectedInstOperands,
     /*  75534 */     // GIR_Coverage, 11972,
     /*  75534 */     GIR_EraseRootFromParent_Done,
     /*  75535 */   // Label 1209: @75535
     /*  75535 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(75625), // Rule ID 15811 //
     /*  75540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75575 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75579 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75583 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75587 */     // MIs[3] Op3
     /*  75587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75592 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75596 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75602 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75604 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75606 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  75619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75623 */     GIR_RootConstrainSelectedInstOperands,
     /*  75624 */     // GIR_Coverage, 15811,
     /*  75624 */     GIR_EraseRootFromParent_Done,
     /*  75625 */   // Label 1210: @75625
     /*  75625 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(75715), // Rule ID 15814 //
     /*  75630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75669 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75677 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75681 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75685 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75689 */     // MIs[4] Op3
     /*  75689 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  75694 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75696 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  75705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  75713 */     GIR_RootConstrainSelectedInstOperands,
     /*  75714 */     // GIR_Coverage, 15814,
     /*  75714 */     GIR_EraseRootFromParent_Done,
     /*  75715 */   // Label 1211: @75715
     /*  75715 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75805), // Rule ID 15816 //
     /*  75720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75759 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75765 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75767 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75771 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75775 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75779 */     // MIs[4] Op3
     /*  75779 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75784 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75786 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  75795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  75799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75803 */     GIR_RootConstrainSelectedInstOperands,
     /*  75804 */     // GIR_Coverage, 15816,
     /*  75804 */     GIR_EraseRootFromParent_Done,
     /*  75805 */   // Label 1212: @75805
     /*  75805 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(75895), // Rule ID 15813 //
     /*  75810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75849 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75855 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75857 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75861 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75865 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75869 */     // MIs[4] Op3
     /*  75869 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  75874 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75876 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  75885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  75893 */     GIR_RootConstrainSelectedInstOperands,
     /*  75894 */     // GIR_Coverage, 15813,
     /*  75894 */     GIR_EraseRootFromParent_Done,
     /*  75895 */   // Label 1213: @75895
     /*  75895 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75985), // Rule ID 15815 //
     /*  75900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75939 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75945 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75947 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75951 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75955 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75959 */     // MIs[4] Op3
     /*  75959 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75964 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75966 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  75975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  75979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75983 */     GIR_RootConstrainSelectedInstOperands,
     /*  75984 */     // GIR_Coverage, 15815,
     /*  75984 */     GIR_EraseRootFromParent_Done,
     /*  75985 */   // Label 1214: @75985
     /*  75985 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(76000), // Rule ID 7529 //
     /*  75990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75993 */     // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  75993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  75998 */     GIR_RootConstrainSelectedInstOperands,
     /*  75999 */     // GIR_Coverage, 7529,
     /*  75999 */     GIR_Done,
     /*  76000 */   // Label 1215: @76000
     /*  76000 */   GIM_Reject,
     /*  76001 */ // Label 1182: @76001
     /*  76001 */ GIM_Reject,
     /*  76002 */ // Label 1026: @76002
     /*  76002 */ GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(76033), // Rule ID 8522 //
     /*  76007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  76010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  76013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  76016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  76020 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  76020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  76023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  76025 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  76027 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  76029 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  76031 */   GIR_RootConstrainSelectedInstOperands,
     /*  76032 */   // GIR_Coverage, 8522,
     /*  76032 */   GIR_EraseRootFromParent_Done,
     /*  76033 */ // Label 1216: @76033
     /*  76033 */ GIM_Reject,
     /*  76034 */ // Label 1027: @76034
     /*  76034 */ GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(79393),
     /*  76039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  76049 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(76167), // Rule ID 15793 //
     /*  76054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76093 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76099 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76101 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76105 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76109 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76113 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76117 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76121 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76127 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76129 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76133 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76137 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76141 */     // MIs[6] Op3
     /*  76141 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  76146 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76148 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  76157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  76165 */     GIR_RootConstrainSelectedInstOperands,
     /*  76166 */     // GIR_Coverage, 15793,
     /*  76166 */     GIR_EraseRootFromParent_Done,
     /*  76167 */   // Label 1218: @76167
     /*  76167 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(76285), // Rule ID 15795 //
     /*  76172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76211 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76217 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76219 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76223 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76227 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76231 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76235 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76239 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76245 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76247 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76251 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76255 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76259 */     // MIs[6] Op3
     /*  76259 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76264 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76266 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  76275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  76279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76283 */     GIR_RootConstrainSelectedInstOperands,
     /*  76284 */     // GIR_Coverage, 15795,
     /*  76284 */     GIR_EraseRootFromParent_Done,
     /*  76285 */   // Label 1219: @76285
     /*  76285 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(76403), // Rule ID 15792 //
     /*  76290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76329 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76335 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76337 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76341 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76345 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76349 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76353 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76357 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76363 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76365 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76369 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76373 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76377 */     // MIs[6] Op3
     /*  76377 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  76382 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76384 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  76393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  76401 */     GIR_RootConstrainSelectedInstOperands,
     /*  76402 */     // GIR_Coverage, 15792,
     /*  76402 */     GIR_EraseRootFromParent_Done,
     /*  76403 */   // Label 1220: @76403
     /*  76403 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(76521), // Rule ID 15794 //
     /*  76408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76447 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76453 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76455 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76459 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76463 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76467 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76471 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76475 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76483 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76487 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76491 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76495 */     // MIs[6] Op3
     /*  76495 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76500 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76502 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  76511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  76515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76519 */     GIR_RootConstrainSelectedInstOperands,
     /*  76520 */     // GIR_Coverage, 15794,
     /*  76520 */     GIR_EraseRootFromParent_Done,
     /*  76521 */   // Label 1221: @76521
     /*  76521 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(76639), // Rule ID 15747 //
     /*  76526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76565 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76571 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76573 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76577 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76581 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76585 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76589 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  76593 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76597 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76601 */     // MIs[5] Op3
     /*  76601 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76606 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76610 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76618 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76620 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  76629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  76633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76637 */     GIR_RootConstrainSelectedInstOperands,
     /*  76638 */     // GIR_Coverage, 15747,
     /*  76638 */     GIR_EraseRootFromParent_Done,
     /*  76639 */   // Label 1222: @76639
     /*  76639 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(76757), // Rule ID 15752 //
     /*  76644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76683 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76689 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76691 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76695 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76699 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76703 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  76707 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76711 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76715 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76719 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76723 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76731 */     // MIs[4] Op3
     /*  76731 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76736 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76738 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  76747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76755 */     GIR_RootConstrainSelectedInstOperands,
     /*  76756 */     // GIR_Coverage, 15752,
     /*  76756 */     GIR_EraseRootFromParent_Done,
     /*  76757 */   // Label 1223: @76757
     /*  76757 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(76875), // Rule ID 15753 //
     /*  76762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76801 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76807 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76809 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76813 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76817 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76821 */     // MIs[4] Op3
     /*  76821 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76826 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76830 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76834 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76838 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76842 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76846 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76852 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76854 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76856 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  76865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76873 */     GIR_RootConstrainSelectedInstOperands,
     /*  76874 */     // GIR_Coverage, 15753,
     /*  76874 */     GIR_EraseRootFromParent_Done,
     /*  76875 */   // Label 1224: @76875
     /*  76875 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(76993), // Rule ID 11958 //
     /*  76880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76919 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76925 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76927 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76931 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76935 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76939 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76943 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76947 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76951 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76955 */     // MIs[5] Op3
     /*  76955 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76960 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76964 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76972 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76974 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  76983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  76987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76991 */     GIR_RootConstrainSelectedInstOperands,
     /*  76992 */     // GIR_Coverage, 11958,
     /*  76992 */     GIR_EraseRootFromParent_Done,
     /*  76993 */   // Label 1225: @76993
     /*  76993 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(77111), // Rule ID 15749 //
     /*  76998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77037 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77045 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77049 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77053 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77057 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77061 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  77065 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77069 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77073 */     // MIs[5] Op3
     /*  77073 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77078 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77082 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77090 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77092 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  77101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  77105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77109 */     GIR_RootConstrainSelectedInstOperands,
     /*  77110 */     // GIR_Coverage, 15749,
     /*  77110 */     GIR_EraseRootFromParent_Done,
     /*  77111 */   // Label 1226: @77111
     /*  77111 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(77229), // Rule ID 15750 //
     /*  77116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77155 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77161 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77163 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77167 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77171 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77175 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  77179 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77183 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77187 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77191 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77195 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77201 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77203 */     // MIs[4] Op3
     /*  77203 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77208 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77210 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  77219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77227 */     GIR_RootConstrainSelectedInstOperands,
     /*  77228 */     // GIR_Coverage, 15750,
     /*  77228 */     GIR_EraseRootFromParent_Done,
     /*  77229 */   // Label 1227: @77229
     /*  77229 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(77347), // Rule ID 15751 //
     /*  77234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77273 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77285 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77289 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77293 */     // MIs[4] Op3
     /*  77293 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77298 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77302 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77306 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77310 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77314 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77318 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77324 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77326 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77328 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  77337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77345 */     GIR_RootConstrainSelectedInstOperands,
     /*  77346 */     // GIR_Coverage, 15751,
     /*  77346 */     GIR_EraseRootFromParent_Done,
     /*  77347 */   // Label 1228: @77347
     /*  77347 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(77465), // Rule ID 15748 //
     /*  77352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77391 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77397 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77399 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77403 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77407 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77411 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77415 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77419 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77423 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77427 */     // MIs[5] Op3
     /*  77427 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77432 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77436 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77442 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77444 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77446 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  77455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  77459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77463 */     GIR_RootConstrainSelectedInstOperands,
     /*  77464 */     // GIR_Coverage, 15748,
     /*  77464 */     GIR_EraseRootFromParent_Done,
     /*  77465 */   // Label 1229: @77465
     /*  77465 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(77583), // Rule ID 15789 //
     /*  77470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77513 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77517 */     // MIs[3] Op3
     /*  77517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  77522 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77526 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77534 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77538 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77542 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77546 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77550 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77554 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77560 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77562 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77564 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  77577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77581 */     GIR_RootConstrainSelectedInstOperands,
     /*  77582 */     // GIR_Coverage, 15789,
     /*  77582 */     GIR_EraseRootFromParent_Done,
     /*  77583 */   // Label 1230: @77583
     /*  77583 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(77701), // Rule ID 15791 //
     /*  77588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77631 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77635 */     // MIs[3] Op3
     /*  77635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77640 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77644 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77652 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77656 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77660 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77664 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77668 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77672 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77678 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77680 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77682 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  77695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77699 */     GIR_RootConstrainSelectedInstOperands,
     /*  77700 */     // GIR_Coverage, 15791,
     /*  77700 */     GIR_EraseRootFromParent_Done,
     /*  77701 */   // Label 1231: @77701
     /*  77701 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(77819), // Rule ID 11968 //
     /*  77706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77749 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77753 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77757 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77761 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77767 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77769 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77773 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77777 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77781 */     // MIs[5] Op3
     /*  77781 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  77786 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77790 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77796 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77798 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77800 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77817 */     GIR_RootConstrainSelectedInstOperands,
     /*  77818 */     // GIR_Coverage, 11968,
     /*  77818 */     GIR_EraseRootFromParent_Done,
     /*  77819 */   // Label 1232: @77819
     /*  77819 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(77937), // Rule ID 15790 //
     /*  77824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77867 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77871 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77875 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77879 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77887 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77891 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77895 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77899 */     // MIs[5] Op3
     /*  77899 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77904 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77908 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77916 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77918 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77935 */     GIR_RootConstrainSelectedInstOperands,
     /*  77936 */     // GIR_Coverage, 15790,
     /*  77936 */     GIR_EraseRootFromParent_Done,
     /*  77937 */   // Label 1233: @77937
     /*  77937 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(78027), // Rule ID 15725 //
     /*  77942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77981 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77987 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77989 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77993 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77997 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78001 */     // MIs[4] Op3
     /*  78001 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78006 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78008 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  78017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78025 */     GIR_RootConstrainSelectedInstOperands,
     /*  78026 */     // GIR_Coverage, 15725,
     /*  78026 */     GIR_EraseRootFromParent_Done,
     /*  78027 */   // Label 1234: @78027
     /*  78027 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(78117), // Rule ID 15724 //
     /*  78032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78071 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78077 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78079 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78083 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78087 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78091 */     // MIs[4] Op3
     /*  78091 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78096 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78098 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  78107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78115 */     GIR_RootConstrainSelectedInstOperands,
     /*  78116 */     // GIR_Coverage, 15724,
     /*  78116 */     GIR_EraseRootFromParent_Done,
     /*  78117 */   // Label 1235: @78117
     /*  78117 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(78207), // Rule ID 15723 //
     /*  78122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78161 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78167 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78169 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78173 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78177 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78181 */     // MIs[4] Op3
     /*  78181 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78186 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78188 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  78197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78205 */     GIR_RootConstrainSelectedInstOperands,
     /*  78206 */     // GIR_Coverage, 15723,
     /*  78206 */     GIR_EraseRootFromParent_Done,
     /*  78207 */   // Label 1236: @78207
     /*  78207 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(78297), // Rule ID 15722 //
     /*  78212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78251 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78257 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78259 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78263 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78267 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78271 */     // MIs[4] Op3
     /*  78271 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78276 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78278 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  78287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78295 */     GIR_RootConstrainSelectedInstOperands,
     /*  78296 */     // GIR_Coverage, 15722,
     /*  78296 */     GIR_EraseRootFromParent_Done,
     /*  78297 */   // Label 1237: @78297
     /*  78297 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(78387), // Rule ID 15719 //
     /*  78302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78345 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78349 */     // MIs[3] Op3
     /*  78349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78354 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78358 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78366 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78368 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  78381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78385 */     GIR_RootConstrainSelectedInstOperands,
     /*  78386 */     // GIR_Coverage, 15719,
     /*  78386 */     GIR_EraseRootFromParent_Done,
     /*  78387 */   // Label 1238: @78387
     /*  78387 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(78477), // Rule ID 15721 //
     /*  78392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78435 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78439 */     // MIs[3] Op3
     /*  78439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78444 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78448 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78454 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78456 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78458 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  78471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78475 */     GIR_RootConstrainSelectedInstOperands,
     /*  78476 */     // GIR_Coverage, 15721,
     /*  78476 */     GIR_EraseRootFromParent_Done,
     /*  78477 */   // Label 1239: @78477
     /*  78477 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(78567), // Rule ID 11950 //
     /*  78482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78525 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78529 */     // MIs[3] Op3
     /*  78529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78534 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78538 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78544 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78546 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78548 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  78561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78565 */     GIR_RootConstrainSelectedInstOperands,
     /*  78566 */     // GIR_Coverage, 11950,
     /*  78566 */     GIR_EraseRootFromParent_Done,
     /*  78567 */   // Label 1240: @78567
     /*  78567 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(78657), // Rule ID 15720 //
     /*  78572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78615 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78619 */     // MIs[3] Op3
     /*  78619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78624 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78628 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78634 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78638 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  78651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78655 */     GIR_RootConstrainSelectedInstOperands,
     /*  78656 */     // GIR_Coverage, 15720,
     /*  78656 */     GIR_EraseRootFromParent_Done,
     /*  78657 */   // Label 1241: @78657
     /*  78657 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(78747), // Rule ID 15796 //
     /*  78662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78705 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78709 */     // MIs[3] Op3
     /*  78709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78714 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78718 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78726 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78728 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  78731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  78741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78745 */     GIR_RootConstrainSelectedInstOperands,
     /*  78746 */     // GIR_Coverage, 15796,
     /*  78746 */     GIR_EraseRootFromParent_Done,
     /*  78747 */   // Label 1242: @78747
     /*  78747 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(78837), // Rule ID 15798 //
     /*  78752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78795 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78799 */     // MIs[3] Op3
     /*  78799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78804 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78808 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78814 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78816 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78818 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  78821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  78831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78835 */     GIR_RootConstrainSelectedInstOperands,
     /*  78836 */     // GIR_Coverage, 15798,
     /*  78836 */     GIR_EraseRootFromParent_Done,
     /*  78837 */   // Label 1243: @78837
     /*  78837 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(78927), // Rule ID 11969 //
     /*  78842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78885 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78889 */     // MIs[3] Op3
     /*  78889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78894 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78898 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78904 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78906 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78908 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  78911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  78921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78925 */     GIR_RootConstrainSelectedInstOperands,
     /*  78926 */     // GIR_Coverage, 11969,
     /*  78926 */     GIR_EraseRootFromParent_Done,
     /*  78927 */   // Label 1244: @78927
     /*  78927 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(79017), // Rule ID 15797 //
     /*  78932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78979 */     // MIs[3] Op3
     /*  78979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78988 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78996 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78998 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  79011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79015 */     GIR_RootConstrainSelectedInstOperands,
     /*  79016 */     // GIR_Coverage, 15797,
     /*  79016 */     GIR_EraseRootFromParent_Done,
     /*  79017 */   // Label 1245: @79017
     /*  79017 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(79107), // Rule ID 15800 //
     /*  79022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79061 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79067 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79069 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79073 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79077 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79081 */     // MIs[4] Op3
     /*  79081 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  79086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79088 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  79105 */     GIR_RootConstrainSelectedInstOperands,
     /*  79106 */     // GIR_Coverage, 15800,
     /*  79106 */     GIR_EraseRootFromParent_Done,
     /*  79107 */   // Label 1246: @79107
     /*  79107 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(79197), // Rule ID 15802 //
     /*  79112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79151 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79157 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79159 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79163 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79167 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79171 */     // MIs[4] Op3
     /*  79171 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79176 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79178 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79195 */     GIR_RootConstrainSelectedInstOperands,
     /*  79196 */     // GIR_Coverage, 15802,
     /*  79196 */     GIR_EraseRootFromParent_Done,
     /*  79197 */   // Label 1247: @79197
     /*  79197 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(79287), // Rule ID 15799 //
     /*  79202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79241 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79247 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79249 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79253 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79257 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79261 */     // MIs[4] Op3
     /*  79261 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  79266 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79268 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  79285 */     GIR_RootConstrainSelectedInstOperands,
     /*  79286 */     // GIR_Coverage, 15799,
     /*  79286 */     GIR_EraseRootFromParent_Done,
     /*  79287 */   // Label 1248: @79287
     /*  79287 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(79377), // Rule ID 15801 //
     /*  79292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79331 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79337 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79347 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79351 */     // MIs[4] Op3
     /*  79351 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79356 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79358 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79375 */     GIR_RootConstrainSelectedInstOperands,
     /*  79376 */     // GIR_Coverage, 15801,
     /*  79376 */     GIR_EraseRootFromParent_Done,
     /*  79377 */   // Label 1249: @79377
     /*  79377 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(79392), // Rule ID 7528 //
     /*  79382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79385 */     // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  79385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  79390 */     GIR_RootConstrainSelectedInstOperands,
     /*  79391 */     // GIR_Coverage, 7528,
     /*  79391 */     GIR_Done,
     /*  79392 */   // Label 1250: @79392
     /*  79392 */   GIM_Reject,
     /*  79393 */ // Label 1217: @79393
     /*  79393 */ GIM_Reject,
     /*  79394 */ // Label 1028: @79394
     /*  79394 */ GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(79425), // Rule ID 8521 //
     /*  79399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  79405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  79408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  79412 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  79412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  79415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  79417 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79419 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79421 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  79423 */   GIR_RootConstrainSelectedInstOperands,
     /*  79424 */   // GIR_Coverage, 8521,
     /*  79424 */   GIR_EraseRootFromParent_Done,
     /*  79425 */ // Label 1251: @79425
     /*  79425 */ GIM_Reject,
     /*  79426 */ // Label 1029: @79426
     /*  79426 */ GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(82785),
     /*  79431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  79441 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(79559), // Rule ID 15779 //
     /*  79446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79485 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79491 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79493 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79497 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79501 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79505 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79509 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79513 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79521 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79525 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79529 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79533 */     // MIs[6] Op3
     /*  79533 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  79538 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79540 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  79549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  79557 */     GIR_RootConstrainSelectedInstOperands,
     /*  79558 */     // GIR_Coverage, 15779,
     /*  79558 */     GIR_EraseRootFromParent_Done,
     /*  79559 */   // Label 1253: @79559
     /*  79559 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(79677), // Rule ID 15781 //
     /*  79564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79603 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79609 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79611 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79615 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79619 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79623 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79627 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79631 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79637 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79639 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79643 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79647 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79651 */     // MIs[6] Op3
     /*  79651 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79656 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79658 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  79667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  79671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79675 */     GIR_RootConstrainSelectedInstOperands,
     /*  79676 */     // GIR_Coverage, 15781,
     /*  79676 */     GIR_EraseRootFromParent_Done,
     /*  79677 */   // Label 1254: @79677
     /*  79677 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(79795), // Rule ID 15778 //
     /*  79682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79721 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79727 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79729 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79733 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79737 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79741 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79745 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79749 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79755 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79757 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79761 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79765 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79769 */     // MIs[6] Op3
     /*  79769 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  79774 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79776 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  79785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  79793 */     GIR_RootConstrainSelectedInstOperands,
     /*  79794 */     // GIR_Coverage, 15778,
     /*  79794 */     GIR_EraseRootFromParent_Done,
     /*  79795 */   // Label 1255: @79795
     /*  79795 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(79913), // Rule ID 15780 //
     /*  79800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79839 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79845 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79847 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79851 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79855 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79859 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79863 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79867 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79873 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79875 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79879 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79883 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79887 */     // MIs[6] Op3
     /*  79887 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79892 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79894 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  79903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  79907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79911 */     GIR_RootConstrainSelectedInstOperands,
     /*  79912 */     // GIR_Coverage, 15780,
     /*  79912 */     GIR_EraseRootFromParent_Done,
     /*  79913 */   // Label 1256: @79913
     /*  79913 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(80031), // Rule ID 15740 //
     /*  79918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79957 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79963 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79965 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79969 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79973 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79977 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79981 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  79985 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79989 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79993 */     // MIs[5] Op3
     /*  79993 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79998 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80002 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80008 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80010 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80012 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  80025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80029 */     GIR_RootConstrainSelectedInstOperands,
     /*  80030 */     // GIR_Coverage, 15740,
     /*  80030 */     GIR_EraseRootFromParent_Done,
     /*  80031 */   // Label 1257: @80031
     /*  80031 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(80149), // Rule ID 15745 //
     /*  80036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80075 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80083 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80087 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80091 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80095 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  80099 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80103 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80107 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80111 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80115 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80123 */     // MIs[4] Op3
     /*  80123 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80128 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80130 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  80143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80147 */     GIR_RootConstrainSelectedInstOperands,
     /*  80148 */     // GIR_Coverage, 15745,
     /*  80148 */     GIR_EraseRootFromParent_Done,
     /*  80149 */   // Label 1258: @80149
     /*  80149 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(80267), // Rule ID 15746 //
     /*  80154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80193 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80199 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80201 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80205 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80209 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80213 */     // MIs[4] Op3
     /*  80213 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80218 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80222 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80226 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80230 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80234 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80238 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80244 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80246 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80248 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  80261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80265 */     GIR_RootConstrainSelectedInstOperands,
     /*  80266 */     // GIR_Coverage, 15746,
     /*  80266 */     GIR_EraseRootFromParent_Done,
     /*  80267 */   // Label 1259: @80267
     /*  80267 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(80385), // Rule ID 11956 //
     /*  80272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80311 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80317 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80319 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80323 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80327 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80331 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80335 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80339 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80343 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80347 */     // MIs[5] Op3
     /*  80347 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80352 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80356 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80362 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80364 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80366 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  80379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80383 */     GIR_RootConstrainSelectedInstOperands,
     /*  80384 */     // GIR_Coverage, 11956,
     /*  80384 */     GIR_EraseRootFromParent_Done,
     /*  80385 */   // Label 1260: @80385
     /*  80385 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(80503), // Rule ID 15742 //
     /*  80390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80429 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80435 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80437 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80441 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80445 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80449 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80453 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  80457 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80461 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80465 */     // MIs[5] Op3
     /*  80465 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80470 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80474 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80480 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80482 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80484 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  80497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80501 */     GIR_RootConstrainSelectedInstOperands,
     /*  80502 */     // GIR_Coverage, 15742,
     /*  80502 */     GIR_EraseRootFromParent_Done,
     /*  80503 */   // Label 1261: @80503
     /*  80503 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(80621), // Rule ID 15743 //
     /*  80508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80547 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80553 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80555 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80559 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80563 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80567 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  80571 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80575 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80579 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80583 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80587 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80593 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80595 */     // MIs[4] Op3
     /*  80595 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80600 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80602 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  80615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80619 */     GIR_RootConstrainSelectedInstOperands,
     /*  80620 */     // GIR_Coverage, 15743,
     /*  80620 */     GIR_EraseRootFromParent_Done,
     /*  80621 */   // Label 1262: @80621
     /*  80621 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(80739), // Rule ID 15744 //
     /*  80626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80665 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80671 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80673 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80677 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80681 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80685 */     // MIs[4] Op3
     /*  80685 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80690 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80694 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80698 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80702 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80706 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80710 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80716 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80718 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80720 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  80733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80737 */     GIR_RootConstrainSelectedInstOperands,
     /*  80738 */     // GIR_Coverage, 15744,
     /*  80738 */     GIR_EraseRootFromParent_Done,
     /*  80739 */   // Label 1263: @80739
     /*  80739 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(80857), // Rule ID 15741 //
     /*  80744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80783 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80791 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80795 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80799 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80803 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80807 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80811 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80815 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80819 */     // MIs[5] Op3
     /*  80819 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80824 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80828 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80834 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80836 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80838 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  80851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80855 */     GIR_RootConstrainSelectedInstOperands,
     /*  80856 */     // GIR_Coverage, 15741,
     /*  80856 */     GIR_EraseRootFromParent_Done,
     /*  80857 */   // Label 1264: @80857
     /*  80857 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(80975), // Rule ID 15775 //
     /*  80862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80905 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80909 */     // MIs[3] Op3
     /*  80909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80914 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80918 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80924 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80926 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  80930 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80934 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80938 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80942 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80946 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80952 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80954 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80956 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  80969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80973 */     GIR_RootConstrainSelectedInstOperands,
     /*  80974 */     // GIR_Coverage, 15775,
     /*  80974 */     GIR_EraseRootFromParent_Done,
     /*  80975 */   // Label 1265: @80975
     /*  80975 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(81093), // Rule ID 15777 //
     /*  80980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81011 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81023 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81027 */     // MIs[3] Op3
     /*  81027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81032 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81036 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81042 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81044 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  81048 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81052 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81056 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81060 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81064 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81072 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81074 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  81083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  81087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81091 */     GIR_RootConstrainSelectedInstOperands,
     /*  81092 */     // GIR_Coverage, 15777,
     /*  81092 */     GIR_EraseRootFromParent_Done,
     /*  81093 */   // Label 1266: @81093
     /*  81093 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(81211), // Rule ID 11965 //
     /*  81098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81141 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81145 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81149 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81153 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81159 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81161 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  81165 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81169 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81173 */     // MIs[5] Op3
     /*  81173 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81178 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81182 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81188 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81190 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81192 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  81201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  81205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81209 */     GIR_RootConstrainSelectedInstOperands,
     /*  81210 */     // GIR_Coverage, 11965,
     /*  81210 */     GIR_EraseRootFromParent_Done,
     /*  81211 */   // Label 1267: @81211
     /*  81211 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(81329), // Rule ID 15776 //
     /*  81216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81259 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81263 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81267 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81271 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81277 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81279 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  81283 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81287 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81291 */     // MIs[5] Op3
     /*  81291 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81296 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81300 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81306 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81308 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81310 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  81319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  81323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81327 */     GIR_RootConstrainSelectedInstOperands,
     /*  81328 */     // GIR_Coverage, 15776,
     /*  81328 */     GIR_EraseRootFromParent_Done,
     /*  81329 */   // Label 1268: @81329
     /*  81329 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(81419), // Rule ID 15718 //
     /*  81334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81373 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81379 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81381 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81385 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81389 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81393 */     // MIs[4] Op3
     /*  81393 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81398 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81400 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  81409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81417 */     GIR_RootConstrainSelectedInstOperands,
     /*  81418 */     // GIR_Coverage, 15718,
     /*  81418 */     GIR_EraseRootFromParent_Done,
     /*  81419 */   // Label 1269: @81419
     /*  81419 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(81509), // Rule ID 15717 //
     /*  81424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81463 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81469 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81471 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81475 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81479 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81483 */     // MIs[4] Op3
     /*  81483 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81488 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81490 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  81499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81507 */     GIR_RootConstrainSelectedInstOperands,
     /*  81508 */     // GIR_Coverage, 15717,
     /*  81508 */     GIR_EraseRootFromParent_Done,
     /*  81509 */   // Label 1270: @81509
     /*  81509 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(81599), // Rule ID 15716 //
     /*  81514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  81537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81553 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81559 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81561 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81565 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81569 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81573 */     // MIs[4] Op3
     /*  81573 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81578 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81580 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  81589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  81593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81597 */     GIR_RootConstrainSelectedInstOperands,
     /*  81598 */     // GIR_Coverage, 15716,
     /*  81598 */     GIR_EraseRootFromParent_Done,
     /*  81599 */   // Label 1271: @81599
     /*  81599 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(81689), // Rule ID 15715 //
     /*  81604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  81627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81643 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81649 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81651 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81655 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81659 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81663 */     // MIs[4] Op3
     /*  81663 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81668 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81670 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  81679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  81683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81687 */     GIR_RootConstrainSelectedInstOperands,
     /*  81688 */     // GIR_Coverage, 15715,
     /*  81688 */     GIR_EraseRootFromParent_Done,
     /*  81689 */   // Label 1272: @81689
     /*  81689 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(81779), // Rule ID 15712 //
     /*  81694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81737 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81741 */     // MIs[3] Op3
     /*  81741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81746 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81750 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81756 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81758 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81760 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  81769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  81773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81777 */     GIR_RootConstrainSelectedInstOperands,
     /*  81778 */     // GIR_Coverage, 15712,
     /*  81778 */     GIR_EraseRootFromParent_Done,
     /*  81779 */   // Label 1273: @81779
     /*  81779 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(81869), // Rule ID 15714 //
     /*  81784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81827 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81831 */     // MIs[3] Op3
     /*  81831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81836 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81840 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81846 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81848 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81850 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  81859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  81863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81867 */     GIR_RootConstrainSelectedInstOperands,
     /*  81868 */     // GIR_Coverage, 15714,
     /*  81868 */     GIR_EraseRootFromParent_Done,
     /*  81869 */   // Label 1274: @81869
     /*  81869 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(81959), // Rule ID 11948 //
     /*  81874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81917 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81921 */     // MIs[3] Op3
     /*  81921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81926 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81930 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81936 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81938 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81940 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  81949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  81953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81957 */     GIR_RootConstrainSelectedInstOperands,
     /*  81958 */     // GIR_Coverage, 11948,
     /*  81958 */     GIR_EraseRootFromParent_Done,
     /*  81959 */   // Label 1275: @81959
     /*  81959 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(82049), // Rule ID 15713 //
     /*  81964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81995 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82007 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82011 */     // MIs[3] Op3
     /*  82011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82016 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82020 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82026 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82028 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82030 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  82033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82047 */     GIR_RootConstrainSelectedInstOperands,
     /*  82048 */     // GIR_Coverage, 15713,
     /*  82048 */     GIR_EraseRootFromParent_Done,
     /*  82049 */   // Label 1276: @82049
     /*  82049 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(82139), // Rule ID 15782 //
     /*  82054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82097 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82101 */     // MIs[3] Op3
     /*  82101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82106 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82110 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82120 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  82133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82137 */     GIR_RootConstrainSelectedInstOperands,
     /*  82138 */     // GIR_Coverage, 15782,
     /*  82138 */     GIR_EraseRootFromParent_Done,
     /*  82139 */   // Label 1277: @82139
     /*  82139 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(82229), // Rule ID 15784 //
     /*  82144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82187 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82191 */     // MIs[3] Op3
     /*  82191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82196 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82200 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82208 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82210 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  82223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82227 */     GIR_RootConstrainSelectedInstOperands,
     /*  82228 */     // GIR_Coverage, 15784,
     /*  82228 */     GIR_EraseRootFromParent_Done,
     /*  82229 */   // Label 1278: @82229
     /*  82229 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(82319), // Rule ID 11966 //
     /*  82234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82281 */     // MIs[3] Op3
     /*  82281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82286 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82290 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82296 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82298 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82300 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82317 */     GIR_RootConstrainSelectedInstOperands,
     /*  82318 */     // GIR_Coverage, 11966,
     /*  82318 */     GIR_EraseRootFromParent_Done,
     /*  82319 */   // Label 1279: @82319
     /*  82319 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(82409), // Rule ID 15783 //
     /*  82324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82355 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82367 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82371 */     // MIs[3] Op3
     /*  82371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82376 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82380 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82386 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82390 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82407 */     GIR_RootConstrainSelectedInstOperands,
     /*  82408 */     // GIR_Coverage, 15783,
     /*  82408 */     GIR_EraseRootFromParent_Done,
     /*  82409 */   // Label 1280: @82409
     /*  82409 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(82499), // Rule ID 15786 //
     /*  82414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82453 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82461 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82465 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82469 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82473 */     // MIs[4] Op3
     /*  82473 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  82478 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82480 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  82489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  82497 */     GIR_RootConstrainSelectedInstOperands,
     /*  82498 */     // GIR_Coverage, 15786,
     /*  82498 */     GIR_EraseRootFromParent_Done,
     /*  82499 */   // Label 1281: @82499
     /*  82499 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(82589), // Rule ID 15788 //
     /*  82504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82543 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82549 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82551 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82555 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82559 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82563 */     // MIs[4] Op3
     /*  82563 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82568 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82570 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  82579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  82583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82587 */     GIR_RootConstrainSelectedInstOperands,
     /*  82588 */     // GIR_Coverage, 15788,
     /*  82588 */     GIR_EraseRootFromParent_Done,
     /*  82589 */   // Label 1282: @82589
     /*  82589 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(82679), // Rule ID 15785 //
     /*  82594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82633 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82641 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82645 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82649 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82653 */     // MIs[4] Op3
     /*  82653 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  82658 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82660 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  82669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  82677 */     GIR_RootConstrainSelectedInstOperands,
     /*  82678 */     // GIR_Coverage, 15785,
     /*  82678 */     GIR_EraseRootFromParent_Done,
     /*  82679 */   // Label 1283: @82679
     /*  82679 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(82769), // Rule ID 15787 //
     /*  82684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82723 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82735 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82739 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82743 */     // MIs[4] Op3
     /*  82743 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82748 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82750 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  82759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  82763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82767 */     GIR_RootConstrainSelectedInstOperands,
     /*  82768 */     // GIR_Coverage, 15787,
     /*  82768 */     GIR_EraseRootFromParent_Done,
     /*  82769 */   // Label 1284: @82769
     /*  82769 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(82784), // Rule ID 7527 //
     /*  82774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  82777 */     // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  82777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  82782 */     GIR_RootConstrainSelectedInstOperands,
     /*  82783 */     // GIR_Coverage, 7527,
     /*  82783 */     GIR_Done,
     /*  82784 */   // Label 1285: @82784
     /*  82784 */   GIM_Reject,
     /*  82785 */ // Label 1252: @82785
     /*  82785 */ GIM_Reject,
     /*  82786 */ // Label 1030: @82786
     /*  82786 */ GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(82817), // Rule ID 8520 //
     /*  82791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  82794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  82797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  82800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  82804 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  82804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  82807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  82809 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  82811 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  82813 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  82815 */   GIR_RootConstrainSelectedInstOperands,
     /*  82816 */   // GIR_Coverage, 8520,
     /*  82816 */   GIR_EraseRootFromParent_Done,
     /*  82817 */ // Label 1286: @82817
     /*  82817 */ GIM_Reject,
     /*  82818 */ // Label 1031: @82818
     /*  82818 */ GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(86177),
     /*  82823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  82833 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(82951), // Rule ID 15765 //
     /*  82838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82877 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82883 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82885 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  82889 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82893 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82897 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82901 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  82905 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82911 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  82913 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  82917 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82921 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82925 */     // MIs[6] Op3
     /*  82925 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  82930 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82932 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  82932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  82941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  82949 */     GIR_RootConstrainSelectedInstOperands,
     /*  82950 */     // GIR_Coverage, 15765,
     /*  82950 */     GIR_EraseRootFromParent_Done,
     /*  82951 */   // Label 1288: @82951
     /*  82951 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(83069), // Rule ID 15767 //
     /*  82956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82995 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83001 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83003 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  83007 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83011 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83015 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83019 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83023 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83029 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  83031 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  83035 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83039 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83043 */     // MIs[6] Op3
     /*  83043 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83048 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83050 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  83059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  83063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83067 */     GIR_RootConstrainSelectedInstOperands,
     /*  83068 */     // GIR_Coverage, 15767,
     /*  83068 */     GIR_EraseRootFromParent_Done,
     /*  83069 */   // Label 1289: @83069
     /*  83069 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(83187), // Rule ID 15764 //
     /*  83074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  83125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83129 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83133 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83137 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83141 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83147 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  83149 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  83153 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83157 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83161 */     // MIs[6] Op3
     /*  83161 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  83166 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83168 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  83177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  83185 */     GIR_RootConstrainSelectedInstOperands,
     /*  83186 */     // GIR_Coverage, 15764,
     /*  83186 */     GIR_EraseRootFromParent_Done,
     /*  83187 */   // Label 1290: @83187
     /*  83187 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(83305), // Rule ID 15766 //
     /*  83192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83223 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83231 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83237 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83239 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  83243 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83247 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83251 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83255 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83259 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83265 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  83267 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  83271 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83275 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83279 */     // MIs[6] Op3
     /*  83279 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83284 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83286 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  83295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  83299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83303 */     GIR_RootConstrainSelectedInstOperands,
     /*  83304 */     // GIR_Coverage, 15766,
     /*  83304 */     GIR_EraseRootFromParent_Done,
     /*  83305 */   // Label 1291: @83305
     /*  83305 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(83423), // Rule ID 15733 //
     /*  83310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83349 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83355 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83357 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83361 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83365 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83369 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83373 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83377 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83381 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83385 */     // MIs[5] Op3
     /*  83385 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83390 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83394 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83400 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83402 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83404 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  83413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  83417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83421 */     GIR_RootConstrainSelectedInstOperands,
     /*  83422 */     // GIR_Coverage, 15733,
     /*  83422 */     GIR_EraseRootFromParent_Done,
     /*  83423 */   // Label 1292: @83423
     /*  83423 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(83541), // Rule ID 15738 //
     /*  83428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83467 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83473 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83475 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83479 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83483 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83487 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83491 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83495 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83499 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83503 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83507 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83513 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83515 */     // MIs[4] Op3
     /*  83515 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83520 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83522 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  83531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  83535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83539 */     GIR_RootConstrainSelectedInstOperands,
     /*  83540 */     // GIR_Coverage, 15738,
     /*  83540 */     GIR_EraseRootFromParent_Done,
     /*  83541 */   // Label 1293: @83541
     /*  83541 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(83659), // Rule ID 15739 //
     /*  83546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83585 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83591 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83593 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83597 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83601 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83605 */     // MIs[4] Op3
     /*  83605 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83610 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83614 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83618 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83622 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83626 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83630 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83638 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83640 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  83649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  83653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83657 */     GIR_RootConstrainSelectedInstOperands,
     /*  83658 */     // GIR_Coverage, 15739,
     /*  83658 */     GIR_EraseRootFromParent_Done,
     /*  83659 */   // Label 1294: @83659
     /*  83659 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(83777), // Rule ID 11954 //
     /*  83664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83695 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83703 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83709 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83711 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83715 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83719 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83723 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83727 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83731 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83735 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83739 */     // MIs[5] Op3
     /*  83739 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83744 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83748 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83754 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83756 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83758 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  83767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  83771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83775 */     GIR_RootConstrainSelectedInstOperands,
     /*  83776 */     // GIR_Coverage, 11954,
     /*  83776 */     GIR_EraseRootFromParent_Done,
     /*  83777 */   // Label 1295: @83777
     /*  83777 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(83895), // Rule ID 15735 //
     /*  83782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83821 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83827 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83829 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83833 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83837 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83841 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83845 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83849 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83853 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83857 */     // MIs[5] Op3
     /*  83857 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83862 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83866 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83874 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83876 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  83885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  83889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83893 */     GIR_RootConstrainSelectedInstOperands,
     /*  83894 */     // GIR_Coverage, 15735,
     /*  83894 */     GIR_EraseRootFromParent_Done,
     /*  83895 */   // Label 1296: @83895
     /*  83895 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(84013), // Rule ID 15736 //
     /*  83900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83939 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83945 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83947 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83951 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83955 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83959 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83963 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83967 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83971 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83975 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83979 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83985 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83987 */     // MIs[4] Op3
     /*  83987 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83992 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83994 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  84003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  84007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84011 */     GIR_RootConstrainSelectedInstOperands,
     /*  84012 */     // GIR_Coverage, 15736,
     /*  84012 */     GIR_EraseRootFromParent_Done,
     /*  84013 */   // Label 1297: @84013
     /*  84013 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(84131), // Rule ID 15737 //
     /*  84018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  84041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84057 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84063 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84065 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84069 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84073 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84077 */     // MIs[4] Op3
     /*  84077 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84082 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84086 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84090 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84094 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84098 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84102 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84110 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84112 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  84115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  84121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  84125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84129 */     GIR_RootConstrainSelectedInstOperands,
     /*  84130 */     // GIR_Coverage, 15737,
     /*  84130 */     GIR_EraseRootFromParent_Done,
     /*  84131 */   // Label 1298: @84131
     /*  84131 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(84249), // Rule ID 15734 //
     /*  84136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  84159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84175 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84181 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84183 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84187 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84191 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84195 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84199 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84203 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84207 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84211 */     // MIs[5] Op3
     /*  84211 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  84216 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84220 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84226 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84228 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84230 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  84233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  84239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  84243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  84247 */     GIR_RootConstrainSelectedInstOperands,
     /*  84248 */     // GIR_Coverage, 15734,
     /*  84248 */     GIR_EraseRootFromParent_Done,
     /*  84249 */   // Label 1299: @84249
     /*  84249 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(84367), // Rule ID 15761 //
     /*  84254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84297 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84301 */     // MIs[3] Op3
     /*  84301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  84306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84310 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84316 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84318 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84322 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84326 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84330 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84334 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84338 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84344 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84346 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84348 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  84357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  84361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  84365 */     GIR_RootConstrainSelectedInstOperands,
     /*  84366 */     // GIR_Coverage, 15761,
     /*  84366 */     GIR_EraseRootFromParent_Done,
     /*  84367 */   // Label 1300: @84367
     /*  84367 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(84485), // Rule ID 15763 //
     /*  84372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84415 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84419 */     // MIs[3] Op3
     /*  84419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  84424 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84428 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84434 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84436 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84440 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84444 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84448 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84452 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84456 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84462 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84464 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84466 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  84475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  84479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  84483 */     GIR_RootConstrainSelectedInstOperands,
     /*  84484 */     // GIR_Coverage, 15763,
     /*  84484 */     GIR_EraseRootFromParent_Done,
     /*  84485 */   // Label 1301: @84485
     /*  84485 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(84603), // Rule ID 11962 //
     /*  84490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84537 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84541 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84545 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84551 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84553 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84557 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84561 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84565 */     // MIs[5] Op3
     /*  84565 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  84570 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84574 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84580 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84582 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84584 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  84593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  84597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  84601 */     GIR_RootConstrainSelectedInstOperands,
     /*  84602 */     // GIR_Coverage, 11962,
     /*  84602 */     GIR_EraseRootFromParent_Done,
     /*  84603 */   // Label 1302: @84603
     /*  84603 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(84721), // Rule ID 15762 //
     /*  84608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84651 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84655 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84663 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84669 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84671 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84675 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84679 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84683 */     // MIs[5] Op3
     /*  84683 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  84688 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84692 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84698 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84700 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84702 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  84711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  84715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  84719 */     GIR_RootConstrainSelectedInstOperands,
     /*  84720 */     // GIR_Coverage, 15762,
     /*  84720 */     GIR_EraseRootFromParent_Done,
     /*  84721 */   // Label 1303: @84721
     /*  84721 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(84811), // Rule ID 15711 //
     /*  84726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84765 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84771 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84773 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84777 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84781 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84785 */     // MIs[4] Op3
     /*  84785 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84790 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84792 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  84795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  84801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  84805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84809 */     GIR_RootConstrainSelectedInstOperands,
     /*  84810 */     // GIR_Coverage, 15711,
     /*  84810 */     GIR_EraseRootFromParent_Done,
     /*  84811 */   // Label 1304: @84811
     /*  84811 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(84901), // Rule ID 15710 //
     /*  84816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84855 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84861 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84863 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84867 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84871 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84875 */     // MIs[4] Op3
     /*  84875 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84882 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  84885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  84891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  84895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84899 */     GIR_RootConstrainSelectedInstOperands,
     /*  84900 */     // GIR_Coverage, 15710,
     /*  84900 */     GIR_EraseRootFromParent_Done,
     /*  84901 */   // Label 1305: @84901
     /*  84901 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(84991), // Rule ID 15709 //
     /*  84906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  84929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84945 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84951 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84953 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84957 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84961 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84965 */     // MIs[4] Op3
     /*  84965 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84970 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84972 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  84975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  84981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  84985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84989 */     GIR_RootConstrainSelectedInstOperands,
     /*  84990 */     // GIR_Coverage, 15709,
     /*  84990 */     GIR_EraseRootFromParent_Done,
     /*  84991 */   // Label 1306: @84991
     /*  84991 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(85081), // Rule ID 15708 //
     /*  84996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85035 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85041 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85043 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85047 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85051 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85055 */     // MIs[4] Op3
     /*  85055 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85060 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85062 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  85071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  85075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85079 */     GIR_RootConstrainSelectedInstOperands,
     /*  85080 */     // GIR_Coverage, 15708,
     /*  85080 */     GIR_EraseRootFromParent_Done,
     /*  85081 */   // Label 1307: @85081
     /*  85081 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(85171), // Rule ID 15705 //
     /*  85086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85129 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85133 */     // MIs[3] Op3
     /*  85133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85142 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85148 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85150 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85152 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  85165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85169 */     GIR_RootConstrainSelectedInstOperands,
     /*  85170 */     // GIR_Coverage, 15705,
     /*  85170 */     GIR_EraseRootFromParent_Done,
     /*  85171 */   // Label 1308: @85171
     /*  85171 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(85261), // Rule ID 15707 //
     /*  85176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85219 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85223 */     // MIs[3] Op3
     /*  85223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85228 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85232 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85238 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85240 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85242 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  85255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85259 */     GIR_RootConstrainSelectedInstOperands,
     /*  85260 */     // GIR_Coverage, 15707,
     /*  85260 */     GIR_EraseRootFromParent_Done,
     /*  85261 */   // Label 1309: @85261
     /*  85261 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(85351), // Rule ID 11946 //
     /*  85266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85309 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85313 */     // MIs[3] Op3
     /*  85313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85318 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85322 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85328 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85330 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85332 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  85345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85349 */     GIR_RootConstrainSelectedInstOperands,
     /*  85350 */     // GIR_Coverage, 11946,
     /*  85350 */     GIR_EraseRootFromParent_Done,
     /*  85351 */   // Label 1310: @85351
     /*  85351 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(85441), // Rule ID 15706 //
     /*  85356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85403 */     // MIs[3] Op3
     /*  85403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85412 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85418 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85420 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85422 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  85435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85439 */     GIR_RootConstrainSelectedInstOperands,
     /*  85440 */     // GIR_Coverage, 15706,
     /*  85440 */     GIR_EraseRootFromParent_Done,
     /*  85441 */   // Label 1311: @85441
     /*  85441 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(85531), // Rule ID 15768 //
     /*  85446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85489 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85493 */     // MIs[3] Op3
     /*  85493 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85498 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85502 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85508 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85510 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85512 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  85525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85529 */     GIR_RootConstrainSelectedInstOperands,
     /*  85530 */     // GIR_Coverage, 15768,
     /*  85530 */     GIR_EraseRootFromParent_Done,
     /*  85531 */   // Label 1312: @85531
     /*  85531 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(85621), // Rule ID 15770 //
     /*  85536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85579 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85583 */     // MIs[3] Op3
     /*  85583 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85592 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85598 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85600 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85602 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  85615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85619 */     GIR_RootConstrainSelectedInstOperands,
     /*  85620 */     // GIR_Coverage, 15770,
     /*  85620 */     GIR_EraseRootFromParent_Done,
     /*  85621 */   // Label 1313: @85621
     /*  85621 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(85711), // Rule ID 11963 //
     /*  85626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85669 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85673 */     // MIs[3] Op3
     /*  85673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85682 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85688 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85690 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85692 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  85705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85709 */     GIR_RootConstrainSelectedInstOperands,
     /*  85710 */     // GIR_Coverage, 11963,
     /*  85710 */     GIR_EraseRootFromParent_Done,
     /*  85711 */   // Label 1314: @85711
     /*  85711 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(85801), // Rule ID 15769 //
     /*  85716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85763 */     // MIs[3] Op3
     /*  85763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85772 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85778 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85780 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85782 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  85795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85799 */     GIR_RootConstrainSelectedInstOperands,
     /*  85800 */     // GIR_Coverage, 15769,
     /*  85800 */     GIR_EraseRootFromParent_Done,
     /*  85801 */   // Label 1315: @85801
     /*  85801 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(85891), // Rule ID 15772 //
     /*  85806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  85845 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85851 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85853 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85857 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85861 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85865 */     // MIs[4] Op3
     /*  85865 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  85870 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85872 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  85881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  85885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  85889 */     GIR_RootConstrainSelectedInstOperands,
     /*  85890 */     // GIR_Coverage, 15772,
     /*  85890 */     GIR_EraseRootFromParent_Done,
     /*  85891 */   // Label 1316: @85891
     /*  85891 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(85981), // Rule ID 15774 //
     /*  85896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  85935 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85941 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85943 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85947 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85951 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85955 */     // MIs[4] Op3
     /*  85955 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85960 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85962 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  85971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  85975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85979 */     GIR_RootConstrainSelectedInstOperands,
     /*  85980 */     // GIR_Coverage, 15774,
     /*  85980 */     GIR_EraseRootFromParent_Done,
     /*  85981 */   // Label 1317: @85981
     /*  85981 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(86071), // Rule ID 15771 //
     /*  85986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  86013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  86025 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86031 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86033 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86037 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86041 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86045 */     // MIs[4] Op3
     /*  86045 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  86050 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86052 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  86065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  86069 */     GIR_RootConstrainSelectedInstOperands,
     /*  86070 */     // GIR_Coverage, 15771,
     /*  86070 */     GIR_EraseRootFromParent_Done,
     /*  86071 */   // Label 1318: @86071
     /*  86071 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(86161), // Rule ID 15773 //
     /*  86076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  86103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  86115 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86123 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86127 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86131 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86135 */     // MIs[4] Op3
     /*  86135 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86140 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86142 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  86155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86159 */     GIR_RootConstrainSelectedInstOperands,
     /*  86160 */     // GIR_Coverage, 15773,
     /*  86160 */     GIR_EraseRootFromParent_Done,
     /*  86161 */   // Label 1319: @86161
     /*  86161 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(86176), // Rule ID 7526 //
     /*  86166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86169 */     // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  86169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  86174 */     GIR_RootConstrainSelectedInstOperands,
     /*  86175 */     // GIR_Coverage, 7526,
     /*  86175 */     GIR_Done,
     /*  86176 */   // Label 1320: @86176
     /*  86176 */   GIM_Reject,
     /*  86177 */ // Label 1287: @86177
     /*  86177 */ GIM_Reject,
     /*  86178 */ // Label 1032: @86178
     /*  86178 */ GIM_Reject,
     /*  86179 */ // Label 7: @86179
     /*  86179 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1339*/ GIMT_Encode4(97146),
     /*  86190 */ /*GILLT_s32*//*Label 1321*/ GIMT_Encode4(86278),
     /*  86194 */ /*GILLT_s64*//*Label 1322*/ GIMT_Encode4(86958), GIMT_Encode4(0),
     /*  86202 */ /*GILLT_v2s32*//*Label 1323*/ GIMT_Encode4(87801),
     /*  86206 */ /*GILLT_v2s64*//*Label 1324*/ GIMT_Encode4(88036),
     /*  86210 */ /*GILLT_v4s16*//*Label 1325*/ GIMT_Encode4(88725),
     /*  86214 */ /*GILLT_v4s32*//*Label 1326*/ GIMT_Encode4(88960),
     /*  86218 */ /*GILLT_v8s8*//*Label 1327*/ GIMT_Encode4(89649),
     /*  86222 */ /*GILLT_v8s16*//*Label 1328*/ GIMT_Encode4(89887),
     /*  86226 */ /*GILLT_v16s8*//*Label 1329*/ GIMT_Encode4(90576),
     /*  86230 */ /*GILLT_nxv1s1*//*Label 1330*/ GIMT_Encode4(91268),
     /*  86234 */ /*GILLT_nxv2s1*//*Label 1331*/ GIMT_Encode4(91318), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  86246 */ /*GILLT_nxv2s64*//*Label 1332*/ GIMT_Encode4(91368),
     /*  86250 */ /*GILLT_nxv4s1*//*Label 1333*/ GIMT_Encode4(92775), GIMT_Encode4(0),
     /*  86258 */ /*GILLT_nxv4s32*//*Label 1334*/ GIMT_Encode4(92825),
     /*  86262 */ /*GILLT_nxv8s1*//*Label 1335*/ GIMT_Encode4(94232),
     /*  86266 */ /*GILLT_nxv8s16*//*Label 1336*/ GIMT_Encode4(94282),
     /*  86270 */ /*GILLT_nxv16s1*//*Label 1337*/ GIMT_Encode4(95689),
     /*  86274 */ /*GILLT_nxv16s8*//*Label 1338*/ GIMT_Encode4(95739),
     /*  86278 */ // Label 1321: @86278
     /*  86278 */ GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(86957),
     /*  86283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  86286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86289 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(86347), // Rule ID 13322 //
     /*  86294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86319 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86332 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86345 */     GIR_RootConstrainSelectedInstOperands,
     /*  86346 */     // GIR_Coverage, 13322,
     /*  86346 */     GIR_EraseRootFromParent_Done,
     /*  86347 */   // Label 1341: @86347
     /*  86347 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(86402), // Rule ID 13321 //
     /*  86352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86372 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86389 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  86396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86400 */     GIR_RootConstrainSelectedInstOperands,
     /*  86401 */     // GIR_Coverage, 13321,
     /*  86401 */     GIR_EraseRootFromParent_Done,
     /*  86402 */   // Label 1342: @86402
     /*  86402 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(86460), // Rule ID 13319 //
     /*  86407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86445 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86454 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86458 */     GIR_RootConstrainSelectedInstOperands,
     /*  86459 */     // GIR_Coverage, 13319,
     /*  86459 */     GIR_EraseRootFromParent_Done,
     /*  86460 */   // Label 1343: @86460
     /*  86460 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(86518), // Rule ID 166 //
     /*  86465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86503 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86516 */     GIR_RootConstrainSelectedInstOperands,
     /*  86517 */     // GIR_Coverage, 166,
     /*  86517 */     GIR_EraseRootFromParent_Done,
     /*  86518 */   // Label 1344: @86518
     /*  86518 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(86576), // Rule ID 13320 //
     /*  86523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86548 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86561 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86574 */     GIR_RootConstrainSelectedInstOperands,
     /*  86575 */     // GIR_Coverage, 13320,
     /*  86575 */     GIR_EraseRootFromParent_Done,
     /*  86576 */   // Label 1345: @86576
     /*  86576 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(86631), // Rule ID 13323 //
     /*  86581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86605 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86618 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86629 */     GIR_RootConstrainSelectedInstOperands,
     /*  86630 */     // GIR_Coverage, 13323,
     /*  86630 */     GIR_EraseRootFromParent_Done,
     /*  86631 */   // Label 1346: @86631
     /*  86631 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(86672), // Rule ID 144 //
     /*  86636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  86640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86652 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  86656 */     // MIs[1] Operand 1
     /*  86656 */     // No operand predicates
     /*  86656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86658 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  86658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  86661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86665 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  86670 */     GIR_RootConstrainSelectedInstOperands,
     /*  86671 */     // GIR_Coverage, 144,
     /*  86671 */     GIR_EraseRootFromParent_Done,
     /*  86672 */   // Label 1347: @86672
     /*  86672 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(86705), // Rule ID 13329 //
     /*  86677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86692 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  86695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  86699 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86703 */     GIR_RootConstrainSelectedInstOperands,
     /*  86704 */     // GIR_Coverage, 13329,
     /*  86704 */     GIR_EraseRootFromParent_Done,
     /*  86705 */   // Label 1348: @86705
     /*  86705 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(86738), // Rule ID 170 //
     /*  86710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86725 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  86728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86732 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86736 */     GIR_RootConstrainSelectedInstOperands,
     /*  86737 */     // GIR_Coverage, 170,
     /*  86737 */     GIR_EraseRootFromParent_Done,
     /*  86738 */   // Label 1349: @86738
     /*  86738 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(86791), // Rule ID 13315 //
     /*  86743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86768 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86778 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  86781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  86789 */     GIR_RootConstrainSelectedInstOperands,
     /*  86790 */     // GIR_Coverage, 13315,
     /*  86790 */     GIR_EraseRootFromParent_Done,
     /*  86791 */   // Label 1350: @86791
     /*  86791 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(86847), // Rule ID 164 //
     /*  86796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86832 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  86835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  86845 */     GIR_RootConstrainSelectedInstOperands,
     /*  86846 */     // GIR_Coverage, 164,
     /*  86846 */     GIR_EraseRootFromParent_Done,
     /*  86847 */   // Label 1351: @86847
     /*  86847 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(86900), // Rule ID 13316 //
     /*  86852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86881 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86887 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  86890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  86898 */     GIR_RootConstrainSelectedInstOperands,
     /*  86899 */     // GIR_Coverage, 13316,
     /*  86899 */     GIR_EraseRootFromParent_Done,
     /*  86900 */   // Label 1352: @86900
     /*  86900 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(86932), // Rule ID 4002 //
     /*  86905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86917 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  86917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  86920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  86930 */     GIR_RootConstrainSelectedInstOperands,
     /*  86931 */     // GIR_Coverage, 4002,
     /*  86931 */     GIR_EraseRootFromParent_Done,
     /*  86932 */   // Label 1353: @86932
     /*  86932 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(86956), // Rule ID 168 //
     /*  86937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86949 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  86954 */     GIR_RootConstrainSelectedInstOperands,
     /*  86955 */     // GIR_Coverage, 168,
     /*  86955 */     GIR_Done,
     /*  86956 */   // Label 1354: @86956
     /*  86956 */   GIM_Reject,
     /*  86957 */ // Label 1340: @86957
     /*  86957 */ GIM_Reject,
     /*  86958 */ // Label 1322: @86958
     /*  86958 */ GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(87800),
     /*  86963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  86969 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(87027), // Rule ID 13327 //
     /*  86974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  86990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  86994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86999 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87012 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87025 */     GIR_RootConstrainSelectedInstOperands,
     /*  87026 */     // GIR_Coverage, 13327,
     /*  87026 */     GIR_EraseRootFromParent_Done,
     /*  87027 */   // Label 1356: @87027
     /*  87027 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(87082), // Rule ID 13326 //
     /*  87032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87052 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87069 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  87076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87080 */     GIR_RootConstrainSelectedInstOperands,
     /*  87081 */     // GIR_Coverage, 13326,
     /*  87081 */     GIR_EraseRootFromParent_Done,
     /*  87082 */   // Label 1357: @87082
     /*  87082 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(87140), // Rule ID 13324 //
     /*  87087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87125 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87138 */     GIR_RootConstrainSelectedInstOperands,
     /*  87139 */     // GIR_Coverage, 13324,
     /*  87139 */     GIR_EraseRootFromParent_Done,
     /*  87140 */   // Label 1358: @87140
     /*  87140 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(87198), // Rule ID 167 //
     /*  87145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87183 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87196 */     GIR_RootConstrainSelectedInstOperands,
     /*  87197 */     // GIR_Coverage, 167,
     /*  87197 */     GIR_EraseRootFromParent_Done,
     /*  87198 */   // Label 1359: @87198
     /*  87198 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(87256), // Rule ID 13325 //
     /*  87203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87228 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87241 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87254 */     GIR_RootConstrainSelectedInstOperands,
     /*  87255 */     // GIR_Coverage, 13325,
     /*  87255 */     GIR_EraseRootFromParent_Done,
     /*  87256 */   // Label 1360: @87256
     /*  87256 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(87311), // Rule ID 13328 //
     /*  87261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87285 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87298 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87309 */     GIR_RootConstrainSelectedInstOperands,
     /*  87310 */     // GIR_Coverage, 13328,
     /*  87310 */     GIR_EraseRootFromParent_Done,
     /*  87311 */   // Label 1361: @87311
     /*  87311 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(87411), // Rule ID 1613 //
     /*  87316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  87331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87335 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  87339 */     // MIs[1] Operand 1
     /*  87339 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  87344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  87348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  87356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  87360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  87374 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87380 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  87382 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87386 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87392 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87394 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87396 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  87396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  87399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  87405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  87409 */     GIR_RootConstrainSelectedInstOperands,
     /*  87410 */     // GIR_Coverage, 1613,
     /*  87410 */     GIR_EraseRootFromParent_Done,
     /*  87411 */   // Label 1362: @87411
     /*  87411 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(87452), // Rule ID 145 //
     /*  87416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  87420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87432 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  87436 */     // MIs[1] Operand 1
     /*  87436 */     // No operand predicates
     /*  87436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87438 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  87438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  87441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87445 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  87450 */     GIR_RootConstrainSelectedInstOperands,
     /*  87451 */     // GIR_Coverage, 145,
     /*  87451 */     GIR_EraseRootFromParent_Done,
     /*  87452 */   // Label 1363: @87452
     /*  87452 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(87485), // Rule ID 13330 //
     /*  87457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87472 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  87475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  87479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87483 */     GIR_RootConstrainSelectedInstOperands,
     /*  87484 */     // GIR_Coverage, 13330,
     /*  87484 */     GIR_EraseRootFromParent_Done,
     /*  87485 */   // Label 1364: @87485
     /*  87485 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(87518), // Rule ID 171 //
     /*  87490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87505 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  87508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87516 */     GIR_RootConstrainSelectedInstOperands,
     /*  87517 */     // GIR_Coverage, 171,
     /*  87517 */     GIR_EraseRootFromParent_Done,
     /*  87518 */   // Label 1365: @87518
     /*  87518 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(87571), // Rule ID 13317 //
     /*  87523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87548 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87558 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  87561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  87569 */     GIR_RootConstrainSelectedInstOperands,
     /*  87570 */     // GIR_Coverage, 13317,
     /*  87570 */     GIR_EraseRootFromParent_Done,
     /*  87571 */   // Label 1366: @87571
     /*  87571 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(87627), // Rule ID 165 //
     /*  87576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87612 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  87615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  87625 */     GIR_RootConstrainSelectedInstOperands,
     /*  87626 */     // GIR_Coverage, 165,
     /*  87626 */     GIR_EraseRootFromParent_Done,
     /*  87627 */   // Label 1367: @87627
     /*  87627 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(87680), // Rule ID 13318 //
     /*  87632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87661 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87667 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  87670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  87678 */     GIR_RootConstrainSelectedInstOperands,
     /*  87679 */     // GIR_Coverage, 13318,
     /*  87679 */     GIR_EraseRootFromParent_Done,
     /*  87680 */   // Label 1368: @87680
     /*  87680 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(87712), // Rule ID 4003 //
     /*  87685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87697 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  87697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  87700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  87710 */     GIR_RootConstrainSelectedInstOperands,
     /*  87711 */     // GIR_Coverage, 4003,
     /*  87711 */     GIR_EraseRootFromParent_Done,
     /*  87712 */   // Label 1369: @87712
     /*  87712 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(87748), // Rule ID 4987 //
     /*  87717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87729 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  87737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87739 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  87739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  87742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87746 */     GIR_RootConstrainSelectedInstOperands,
     /*  87747 */     // GIR_Coverage, 4987,
     /*  87747 */     GIR_EraseRootFromParent_Done,
     /*  87748 */   // Label 1370: @87748
     /*  87748 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(87772), // Rule ID 169 //
     /*  87753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87765 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  87770 */     GIR_RootConstrainSelectedInstOperands,
     /*  87771 */     // GIR_Coverage, 169,
     /*  87771 */     GIR_Done,
     /*  87772 */   // Label 1371: @87772
     /*  87772 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(87799), // Rule ID 5086 //
     /*  87777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87792 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  87792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  87797 */     GIR_RootConstrainSelectedInstOperands,
     /*  87798 */     // GIR_Coverage, 5086,
     /*  87798 */     GIR_Done,
     /*  87799 */   // Label 1372: @87799
     /*  87799 */   GIM_Reject,
     /*  87800 */ // Label 1355: @87800
     /*  87800 */ GIM_Reject,
     /*  87801 */ // Label 1323: @87801
     /*  87801 */ GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(88035),
     /*  87806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87816 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(87912), // Rule ID 1160 //
     /*  87821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  87832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87836 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  87840 */     // MIs[1] Operand 1
     /*  87840 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  87845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  87849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  87875 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87881 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  87883 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87887 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87893 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87895 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87897 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  87897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  87900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  87906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  87910 */     GIR_RootConstrainSelectedInstOperands,
     /*  87911 */     // GIR_Coverage, 1160,
     /*  87911 */     GIR_EraseRootFromParent_Done,
     /*  87912 */   // Label 1374: @87912
     /*  87912 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(87979), // Rule ID 5034 //
     /*  87917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  87925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87929 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  87933 */     // MIs[1] Operand 1
     /*  87933 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  87938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  87942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87948 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  87950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  87954 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87960 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87964 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  87964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  87967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87977 */     GIR_RootConstrainSelectedInstOperands,
     /*  87978 */     // GIR_Coverage, 5034,
     /*  87978 */     GIR_EraseRootFromParent_Done,
     /*  87979 */   // Label 1375: @87979
     /*  87979 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(88011), // Rule ID 4985 //
     /*  87984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87992 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87998 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  88000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88002 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  88002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  88005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88009 */     GIR_RootConstrainSelectedInstOperands,
     /*  88010 */     // GIR_Coverage, 4985,
     /*  88010 */     GIR_EraseRootFromParent_Done,
     /*  88011 */   // Label 1376: @88011
     /*  88011 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(88034), // Rule ID 5085 //
     /*  88016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88027 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  88027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  88032 */     GIR_RootConstrainSelectedInstOperands,
     /*  88033 */     // GIR_Coverage, 5085,
     /*  88033 */     GIR_Done,
     /*  88034 */   // Label 1377: @88034
     /*  88034 */   GIM_Reject,
     /*  88035 */ // Label 1373: @88035
     /*  88035 */ GIM_Reject,
     /*  88036 */ // Label 1324: @88036
     /*  88036 */ GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(88724),
     /*  88041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88051 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(88147), // Rule ID 1162 //
     /*  88056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88071 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  88075 */     // MIs[1] Operand 1
     /*  88075 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  88110 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88116 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  88118 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  88122 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88128 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  88130 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  88132 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  88132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  88135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  88141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  88145 */     GIR_RootConstrainSelectedInstOperands,
     /*  88146 */     // GIR_Coverage, 1162,
     /*  88146 */     GIR_EraseRootFromParent_Done,
     /*  88147 */   // Label 1379: @88147
     /*  88147 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(88214), // Rule ID 5036 //
     /*  88152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88164 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  88168 */     // MIs[1] Operand 1
     /*  88168 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  88177 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88183 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  88185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  88189 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88195 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88199 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  88199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  88202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88212 */     GIR_RootConstrainSelectedInstOperands,
     /*  88213 */     // GIR_Coverage, 5036,
     /*  88213 */     GIR_EraseRootFromParent_Done,
     /*  88214 */   // Label 1380: @88214
     /*  88214 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(88299), // Rule ID 13852 //
     /*  88219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  88242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88263 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88282 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  88289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88297 */     GIR_RootConstrainSelectedInstOperands,
     /*  88298 */     // GIR_Coverage, 13852,
     /*  88298 */     GIR_EraseRootFromParent_Done,
     /*  88299 */   // Label 1381: @88299
     /*  88299 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(88384), // Rule ID 13851 //
     /*  88304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88353 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88359 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88367 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  88374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  88378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88382 */     GIR_RootConstrainSelectedInstOperands,
     /*  88383 */     // GIR_Coverage, 13851,
     /*  88383 */     GIR_EraseRootFromParent_Done,
     /*  88384 */   // Label 1382: @88384
     /*  88384 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(88469), // Rule ID 13850 //
     /*  88389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  88416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88437 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88443 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88452 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  88459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88467 */     GIR_RootConstrainSelectedInstOperands,
     /*  88468 */     // GIR_Coverage, 13850,
     /*  88468 */     GIR_EraseRootFromParent_Done,
     /*  88469 */   // Label 1383: @88469
     /*  88469 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(88554), // Rule ID 3830 //
     /*  88474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88527 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88533 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88537 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  88544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  88548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88552 */     GIR_RootConstrainSelectedInstOperands,
     /*  88553 */     // GIR_Coverage, 3830,
     /*  88553 */     GIR_EraseRootFromParent_Done,
     /*  88554 */   // Label 1384: @88554
     /*  88554 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(88586), // Rule ID 4988 //
     /*  88559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88567 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88573 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  88575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88577 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  88577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  88580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88584 */     GIR_RootConstrainSelectedInstOperands,
     /*  88585 */     // GIR_Coverage, 4988,
     /*  88585 */     GIR_EraseRootFromParent_Done,
     /*  88586 */   // Label 1385: @88586
     /*  88586 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(88643), // Rule ID 3826 //
     /*  88591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88626 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  88629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  88635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  88641 */     GIR_RootConstrainSelectedInstOperands,
     /*  88642 */     // GIR_Coverage, 3826,
     /*  88642 */     GIR_EraseRootFromParent_Done,
     /*  88643 */   // Label 1386: @88643
     /*  88643 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(88700), // Rule ID 13840 //
     /*  88648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88683 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  88686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  88692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  88698 */     GIR_RootConstrainSelectedInstOperands,
     /*  88699 */     // GIR_Coverage, 13840,
     /*  88699 */     GIR_EraseRootFromParent_Done,
     /*  88700 */   // Label 1387: @88700
     /*  88700 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(88723), // Rule ID 5089 //
     /*  88705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88716 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  88716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  88721 */     GIR_RootConstrainSelectedInstOperands,
     /*  88722 */     // GIR_Coverage, 5089,
     /*  88722 */     GIR_Done,
     /*  88723 */   // Label 1388: @88723
     /*  88723 */   GIM_Reject,
     /*  88724 */ // Label 1378: @88724
     /*  88724 */ GIM_Reject,
     /*  88725 */ // Label 1325: @88725
     /*  88725 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(88959),
     /*  88730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88740 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(88836), // Rule ID 1158 //
     /*  88745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88760 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  88764 */     // MIs[1] Operand 1
     /*  88764 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  88799 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88805 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  88807 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  88811 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  88819 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  88821 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  88821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  88824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  88830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  88834 */     GIR_RootConstrainSelectedInstOperands,
     /*  88835 */     // GIR_Coverage, 1158,
     /*  88835 */     GIR_EraseRootFromParent_Done,
     /*  88836 */   // Label 1390: @88836
     /*  88836 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(88903), // Rule ID 5032 //
     /*  88841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88853 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  88857 */     // MIs[1] Operand 1
     /*  88857 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  88866 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88872 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  88874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  88878 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88888 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  88888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  88891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88901 */     GIR_RootConstrainSelectedInstOperands,
     /*  88902 */     // GIR_Coverage, 5032,
     /*  88902 */     GIR_EraseRootFromParent_Done,
     /*  88903 */   // Label 1391: @88903
     /*  88903 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(88935), // Rule ID 4983 //
     /*  88908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88916 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88922 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  88924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88926 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  88926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  88929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88933 */     GIR_RootConstrainSelectedInstOperands,
     /*  88934 */     // GIR_Coverage, 4983,
     /*  88934 */     GIR_EraseRootFromParent_Done,
     /*  88935 */   // Label 1392: @88935
     /*  88935 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(88958), // Rule ID 5084 //
     /*  88940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88951 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  88951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  88956 */     GIR_RootConstrainSelectedInstOperands,
     /*  88957 */     // GIR_Coverage, 5084,
     /*  88957 */     GIR_Done,
     /*  88958 */   // Label 1393: @88958
     /*  88958 */   GIM_Reject,
     /*  88959 */ // Label 1389: @88959
     /*  88959 */ GIM_Reject,
     /*  88960 */ // Label 1326: @88960
     /*  88960 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(89648),
     /*  88965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  88968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88975 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(89071), // Rule ID 1161 //
     /*  88980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88995 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88999 */     // MIs[1] Operand 1
     /*  88999 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89034 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89040 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89042 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89046 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89052 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89054 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89056 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  89056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  89059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89069 */     GIR_RootConstrainSelectedInstOperands,
     /*  89070 */     // GIR_Coverage, 1161,
     /*  89070 */     GIR_EraseRootFromParent_Done,
     /*  89071 */   // Label 1395: @89071
     /*  89071 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(89138), // Rule ID 5035 //
     /*  89076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89088 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89092 */     // MIs[1] Operand 1
     /*  89092 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89101 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89107 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89121 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89123 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  89123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  89126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89136 */     GIR_RootConstrainSelectedInstOperands,
     /*  89137 */     // GIR_Coverage, 5035,
     /*  89137 */     GIR_EraseRootFromParent_Done,
     /*  89138 */   // Label 1396: @89138
     /*  89138 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(89223), // Rule ID 13849 //
     /*  89143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  89166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89187 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89193 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89206 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  89213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89221 */     GIR_RootConstrainSelectedInstOperands,
     /*  89222 */     // GIR_Coverage, 13849,
     /*  89222 */     GIR_EraseRootFromParent_Done,
     /*  89223 */   // Label 1397: @89223
     /*  89223 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(89308), // Rule ID 13848 //
     /*  89228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89277 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89283 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89291 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  89298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  89302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89306 */     GIR_RootConstrainSelectedInstOperands,
     /*  89307 */     // GIR_Coverage, 13848,
     /*  89307 */     GIR_EraseRootFromParent_Done,
     /*  89308 */   // Label 1398: @89308
     /*  89308 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(89393), // Rule ID 13847 //
     /*  89313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  89340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89352 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89361 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89376 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  89383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89391 */     GIR_RootConstrainSelectedInstOperands,
     /*  89392 */     // GIR_Coverage, 13847,
     /*  89392 */     GIR_EraseRootFromParent_Done,
     /*  89393 */   // Label 1399: @89393
     /*  89393 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(89478), // Rule ID 3829 //
     /*  89398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89451 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89457 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89461 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  89468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  89472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89476 */     GIR_RootConstrainSelectedInstOperands,
     /*  89477 */     // GIR_Coverage, 3829,
     /*  89477 */     GIR_EraseRootFromParent_Done,
     /*  89478 */   // Label 1400: @89478
     /*  89478 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(89510), // Rule ID 4986 //
     /*  89483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89491 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89497 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89501 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  89501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  89504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89508 */     GIR_RootConstrainSelectedInstOperands,
     /*  89509 */     // GIR_Coverage, 4986,
     /*  89509 */     GIR_EraseRootFromParent_Done,
     /*  89510 */   // Label 1401: @89510
     /*  89510 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(89567), // Rule ID 3825 //
     /*  89515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89550 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  89553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  89559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  89565 */     GIR_RootConstrainSelectedInstOperands,
     /*  89566 */     // GIR_Coverage, 3825,
     /*  89566 */     GIR_EraseRootFromParent_Done,
     /*  89567 */   // Label 1402: @89567
     /*  89567 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(89624), // Rule ID 13839 //
     /*  89572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89607 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  89610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  89616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  89622 */     GIR_RootConstrainSelectedInstOperands,
     /*  89623 */     // GIR_Coverage, 13839,
     /*  89623 */     GIR_EraseRootFromParent_Done,
     /*  89624 */   // Label 1403: @89624
     /*  89624 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(89647), // Rule ID 5088 //
     /*  89629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89640 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  89640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  89645 */     GIR_RootConstrainSelectedInstOperands,
     /*  89646 */     // GIR_Coverage, 5088,
     /*  89646 */     GIR_Done,
     /*  89647 */   // Label 1404: @89647
     /*  89647 */   GIM_Reject,
     /*  89648 */ // Label 1394: @89648
     /*  89648 */ GIM_Reject,
     /*  89649 */ // Label 1327: @89649
     /*  89649 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(89886),
     /*  89654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89664 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(89760), // Rule ID 1156 //
     /*  89669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89684 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  89688 */     // MIs[1] Operand 1
     /*  89688 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89723 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89729 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89735 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89741 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89743 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89745 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  89745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  89748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89758 */     GIR_RootConstrainSelectedInstOperands,
     /*  89759 */     // GIR_Coverage, 1156,
     /*  89759 */     GIR_EraseRootFromParent_Done,
     /*  89760 */   // Label 1406: @89760
     /*  89760 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(89827), // Rule ID 5030 //
     /*  89765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89777 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  89781 */     // MIs[1] Operand 1
     /*  89781 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89790 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89796 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89802 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89812 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  89812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  89815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89825 */     GIR_RootConstrainSelectedInstOperands,
     /*  89826 */     // GIR_Coverage, 5030,
     /*  89826 */     GIR_EraseRootFromParent_Done,
     /*  89827 */   // Label 1407: @89827
     /*  89827 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(89862), // Rule ID 972 //
     /*  89832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89843 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89849 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89853 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  89853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  89856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89860 */     GIR_RootConstrainSelectedInstOperands,
     /*  89861 */     // GIR_Coverage, 972,
     /*  89861 */     GIR_EraseRootFromParent_Done,
     /*  89862 */   // Label 1408: @89862
     /*  89862 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(89885), // Rule ID 1599 //
     /*  89867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89878 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  89878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  89883 */     GIR_RootConstrainSelectedInstOperands,
     /*  89884 */     // GIR_Coverage, 1599,
     /*  89884 */     GIR_Done,
     /*  89885 */   // Label 1409: @89885
     /*  89885 */   GIM_Reject,
     /*  89886 */ // Label 1405: @89886
     /*  89886 */ GIM_Reject,
     /*  89887 */ // Label 1328: @89887
     /*  89887 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(90575),
     /*  89892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89902 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(89998), // Rule ID 1159 //
     /*  89907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89922 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89926 */     // MIs[1] Operand 1
     /*  89926 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89947 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89961 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89967 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89969 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89973 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89979 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89981 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89983 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  89983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  89986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89996 */     GIR_RootConstrainSelectedInstOperands,
     /*  89997 */     // GIR_Coverage, 1159,
     /*  89997 */     GIR_EraseRootFromParent_Done,
     /*  89998 */   // Label 1411: @89998
     /*  89998 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(90065), // Rule ID 5033 //
     /*  90003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90015 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90019 */     // MIs[1] Operand 1
     /*  90019 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90028 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90034 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90040 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90046 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90050 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  90050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  90053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90063 */     GIR_RootConstrainSelectedInstOperands,
     /*  90064 */     // GIR_Coverage, 5033,
     /*  90064 */     GIR_EraseRootFromParent_Done,
     /*  90065 */   // Label 1412: @90065
     /*  90065 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(90150), // Rule ID 13846 //
     /*  90070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90114 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90120 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90133 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90148 */     GIR_RootConstrainSelectedInstOperands,
     /*  90149 */     // GIR_Coverage, 13846,
     /*  90149 */     GIR_EraseRootFromParent_Done,
     /*  90150 */   // Label 1413: @90150
     /*  90150 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(90235), // Rule ID 13845 //
     /*  90155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90191 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90204 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90210 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90218 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90233 */     GIR_RootConstrainSelectedInstOperands,
     /*  90234 */     // GIR_Coverage, 13845,
     /*  90234 */     GIR_EraseRootFromParent_Done,
     /*  90235 */   // Label 1414: @90235
     /*  90235 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(90320), // Rule ID 13844 //
     /*  90240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90288 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90294 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90303 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90318 */     GIR_RootConstrainSelectedInstOperands,
     /*  90319 */     // GIR_Coverage, 13844,
     /*  90319 */     GIR_EraseRootFromParent_Done,
     /*  90320 */   // Label 1415: @90320
     /*  90320 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(90405), // Rule ID 3828 //
     /*  90325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90378 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90384 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90388 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90403 */     GIR_RootConstrainSelectedInstOperands,
     /*  90404 */     // GIR_Coverage, 3828,
     /*  90404 */     GIR_EraseRootFromParent_Done,
     /*  90405 */   // Label 1416: @90405
     /*  90405 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(90437), // Rule ID 4984 //
     /*  90410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90418 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90424 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90428 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  90428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  90431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90435 */     GIR_RootConstrainSelectedInstOperands,
     /*  90436 */     // GIR_Coverage, 4984,
     /*  90436 */     GIR_EraseRootFromParent_Done,
     /*  90437 */   // Label 1417: @90437
     /*  90437 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(90494), // Rule ID 3824 //
     /*  90442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90477 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  90492 */     GIR_RootConstrainSelectedInstOperands,
     /*  90493 */     // GIR_Coverage, 3824,
     /*  90493 */     GIR_EraseRootFromParent_Done,
     /*  90494 */   // Label 1418: @90494
     /*  90494 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(90551), // Rule ID 13838 //
     /*  90499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90534 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  90549 */     GIR_RootConstrainSelectedInstOperands,
     /*  90550 */     // GIR_Coverage, 13838,
     /*  90550 */     GIR_EraseRootFromParent_Done,
     /*  90551 */   // Label 1419: @90551
     /*  90551 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(90574), // Rule ID 5087 //
     /*  90556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90567 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  90567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  90572 */     GIR_RootConstrainSelectedInstOperands,
     /*  90573 */     // GIR_Coverage, 5087,
     /*  90573 */     GIR_Done,
     /*  90574 */   // Label 1420: @90574
     /*  90574 */   GIM_Reject,
     /*  90575 */ // Label 1410: @90575
     /*  90575 */ GIM_Reject,
     /*  90576 */ // Label 1329: @90576
     /*  90576 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(91267),
     /*  90581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90591 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(90687), // Rule ID 1157 //
     /*  90596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90611 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90615 */     // MIs[1] Operand 1
     /*  90615 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  90650 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90656 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  90658 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  90662 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90668 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  90670 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  90672 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  90672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  90675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  90681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  90685 */     GIR_RootConstrainSelectedInstOperands,
     /*  90686 */     // GIR_Coverage, 1157,
     /*  90686 */     GIR_EraseRootFromParent_Done,
     /*  90687 */   // Label 1422: @90687
     /*  90687 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(90754), // Rule ID 5031 //
     /*  90692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90704 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90708 */     // MIs[1] Operand 1
     /*  90708 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90717 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90723 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90729 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90737 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90739 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  90739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  90742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90752 */     GIR_RootConstrainSelectedInstOperands,
     /*  90753 */     // GIR_Coverage, 5031,
     /*  90753 */     GIR_EraseRootFromParent_Done,
     /*  90754 */   // Label 1423: @90754
     /*  90754 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(90839), // Rule ID 13843 //
     /*  90759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90803 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90809 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90820 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90822 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  90822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90837 */     GIR_RootConstrainSelectedInstOperands,
     /*  90838 */     // GIR_Coverage, 13843,
     /*  90838 */     GIR_EraseRootFromParent_Done,
     /*  90839 */   // Label 1424: @90839
     /*  90839 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(90924), // Rule ID 13842 //
     /*  90844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90893 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90899 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90907 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  90907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90922 */     GIR_RootConstrainSelectedInstOperands,
     /*  90923 */     // GIR_Coverage, 13842,
     /*  90923 */     GIR_EraseRootFromParent_Done,
     /*  90924 */   // Label 1425: @90924
     /*  90924 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(91009), // Rule ID 13841 //
     /*  90929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90977 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90983 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90992 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  90992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91007 */     GIR_RootConstrainSelectedInstOperands,
     /*  91008 */     // GIR_Coverage, 13841,
     /*  91008 */     GIR_EraseRootFromParent_Done,
     /*  91009 */   // Label 1426: @91009
     /*  91009 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(91094), // Rule ID 3827 //
     /*  91014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91067 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91073 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91077 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  91077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  91084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  91088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91092 */     GIR_RootConstrainSelectedInstOperands,
     /*  91093 */     // GIR_Coverage, 3827,
     /*  91093 */     GIR_EraseRootFromParent_Done,
     /*  91094 */   // Label 1427: @91094
     /*  91094 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(91129), // Rule ID 973 //
     /*  91099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91110 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  91118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91120 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  91120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  91123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  91127 */     GIR_RootConstrainSelectedInstOperands,
     /*  91128 */     // GIR_Coverage, 973,
     /*  91128 */     GIR_EraseRootFromParent_Done,
     /*  91129 */   // Label 1428: @91129
     /*  91129 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(91186), // Rule ID 3823 //
     /*  91134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91169 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  91169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  91184 */     GIR_RootConstrainSelectedInstOperands,
     /*  91185 */     // GIR_Coverage, 3823,
     /*  91185 */     GIR_EraseRootFromParent_Done,
     /*  91186 */   // Label 1429: @91186
     /*  91186 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(91243), // Rule ID 13837 //
     /*  91191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91226 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  91226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  91241 */     GIR_RootConstrainSelectedInstOperands,
     /*  91242 */     // GIR_Coverage, 13837,
     /*  91242 */     GIR_EraseRootFromParent_Done,
     /*  91243 */   // Label 1430: @91243
     /*  91243 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(91266), // Rule ID 1600 //
     /*  91248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91259 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  91259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  91264 */     GIR_RootConstrainSelectedInstOperands,
     /*  91265 */     // GIR_Coverage, 1600,
     /*  91265 */     GIR_Done,
     /*  91266 */   // Label 1431: @91266
     /*  91266 */   GIM_Reject,
     /*  91267 */ // Label 1421: @91267
     /*  91267 */ GIM_Reject,
     /*  91268 */ // Label 1330: @91268
     /*  91268 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(91317), // Rule ID 8514 //
     /*  91273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  91276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  91279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  91282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  91286 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  91286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  91289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  91293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91298 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  91301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  91306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  91308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91311 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  91313 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  91315 */   GIR_RootConstrainSelectedInstOperands,
     /*  91316 */   // GIR_Coverage, 8514,
     /*  91316 */   GIR_EraseRootFromParent_Done,
     /*  91317 */ // Label 1432: @91317
     /*  91317 */ GIM_Reject,
     /*  91318 */ // Label 1331: @91318
     /*  91318 */ GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(91367), // Rule ID 8513 //
     /*  91323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  91326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  91329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  91332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  91336 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  91336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  91339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  91343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91348 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  91351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  91356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  91358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91361 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  91363 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  91365 */   GIR_RootConstrainSelectedInstOperands,
     /*  91366 */   // GIR_Coverage, 8513,
     /*  91366 */   GIR_EraseRootFromParent_Done,
     /*  91367 */ // Label 1433: @91367
     /*  91367 */ GIM_Reject,
     /*  91368 */ // Label 1332: @91368
     /*  91368 */ GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(92774),
     /*  91373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91383 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(91501), // Rule ID 15844 //
     /*  91388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  91427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91431 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91435 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91439 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91443 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91449 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91451 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91455 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91459 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91463 */     // MIs[5] Op3
     /*  91463 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91468 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91472 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91478 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91480 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91482 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  91491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  91495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91499 */     GIR_RootConstrainSelectedInstOperands,
     /*  91500 */     // GIR_Coverage, 15844,
     /*  91500 */     GIR_EraseRootFromParent_Done,
     /*  91501 */   // Label 1435: @91501
     /*  91501 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(91619), // Rule ID 15843 //
     /*  91506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  91545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91553 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91557 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91561 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91567 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91569 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91573 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91577 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91581 */     // MIs[5] Op3
     /*  91581 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91586 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91590 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91596 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91598 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91600 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  91609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  91613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91617 */     GIR_RootConstrainSelectedInstOperands,
     /*  91618 */     // GIR_Coverage, 15843,
     /*  91618 */     GIR_EraseRootFromParent_Done,
     /*  91619 */   // Label 1436: @91619
     /*  91619 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(91737), // Rule ID 15842 //
     /*  91624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91671 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91675 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91679 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91687 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91691 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91695 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91699 */     // MIs[5] Op3
     /*  91699 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91704 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91708 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91714 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91716 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91718 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  91727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  91731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91735 */     GIR_RootConstrainSelectedInstOperands,
     /*  91736 */     // GIR_Coverage, 15842,
     /*  91736 */     GIR_EraseRootFromParent_Done,
     /*  91737 */   // Label 1437: @91737
     /*  91737 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(91855), // Rule ID 15841 //
     /*  91742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91785 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91789 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91793 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91797 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91803 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91805 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91809 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91813 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91817 */     // MIs[5] Op3
     /*  91817 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91822 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91826 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91832 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91834 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91836 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  91845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  91849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91853 */     GIR_RootConstrainSelectedInstOperands,
     /*  91854 */     // GIR_Coverage, 15841,
     /*  91854 */     GIR_EraseRootFromParent_Done,
     /*  91855 */   // Label 1438: @91855
     /*  91855 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(91973), // Rule ID 15838 //
     /*  91860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  91899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91903 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91907 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91911 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  91915 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91919 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91923 */     // MIs[4] Op3
     /*  91923 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  91928 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  91932 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91938 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  91940 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91944 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91950 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91952 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91954 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  91963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  91967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  91971 */     GIR_RootConstrainSelectedInstOperands,
     /*  91972 */     // GIR_Coverage, 15838,
     /*  91972 */     GIR_EraseRootFromParent_Done,
     /*  91973 */   // Label 1439: @91973
     /*  91973 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(92091), // Rule ID 15840 //
     /*  91978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  92017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92021 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92025 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92029 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  92033 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92037 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92041 */     // MIs[4] Op3
     /*  92041 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  92046 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  92050 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  92058 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92062 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92068 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92070 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92072 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  92081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  92085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92089 */     GIR_RootConstrainSelectedInstOperands,
     /*  92090 */     // GIR_Coverage, 15840,
     /*  92090 */     GIR_EraseRootFromParent_Done,
     /*  92091 */   // Label 1440: @92091
     /*  92091 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(92209), // Rule ID 11980 //
     /*  92096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  92135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92139 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92143 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92147 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92151 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92155 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92159 */     // MIs[4] Op3
     /*  92159 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  92164 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  92168 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  92176 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92180 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92186 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92188 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92190 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  92199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  92203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  92207 */     GIR_RootConstrainSelectedInstOperands,
     /*  92208 */     // GIR_Coverage, 11980,
     /*  92208 */     GIR_EraseRootFromParent_Done,
     /*  92209 */   // Label 1441: @92209
     /*  92209 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(92327), // Rule ID 15839 //
     /*  92214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  92253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92257 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92261 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92265 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92269 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92273 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92277 */     // MIs[4] Op3
     /*  92277 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  92282 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  92286 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92292 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  92294 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92298 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92304 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92306 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92308 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  92317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  92321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92325 */     GIR_RootConstrainSelectedInstOperands,
     /*  92326 */     // GIR_Coverage, 15839,
     /*  92326 */     GIR_EraseRootFromParent_Done,
     /*  92327 */   // Label 1442: @92327
     /*  92327 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(92398), // Rule ID 15704 //
     /*  92332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92371 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92377 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92381 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  92388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  92392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92396 */     GIR_RootConstrainSelectedInstOperands,
     /*  92397 */     // GIR_Coverage, 15704,
     /*  92397 */     GIR_EraseRootFromParent_Done,
     /*  92398 */   // Label 1443: @92398
     /*  92398 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(92469), // Rule ID 15703 //
     /*  92403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92442 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92448 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92452 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  92459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  92463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92467 */     GIR_RootConstrainSelectedInstOperands,
     /*  92468 */     // GIR_Coverage, 15703,
     /*  92468 */     GIR_EraseRootFromParent_Done,
     /*  92469 */   // Label 1444: @92469
     /*  92469 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(92540), // Rule ID 15702 //
     /*  92474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92513 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92523 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  92534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92538 */     GIR_RootConstrainSelectedInstOperands,
     /*  92539 */     // GIR_Coverage, 15702,
     /*  92539 */     GIR_EraseRootFromParent_Done,
     /*  92540 */   // Label 1445: @92540
     /*  92540 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(92611), // Rule ID 11944 //
     /*  92545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92584 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92590 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92594 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  92605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92609 */     GIR_RootConstrainSelectedInstOperands,
     /*  92610 */     // GIR_Coverage, 11944,
     /*  92610 */     GIR_EraseRootFromParent_Done,
     /*  92611 */   // Label 1446: @92611
     /*  92611 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(92672), // Rule ID 11979 //
     /*  92616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  92627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92635 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  92639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  92643 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92649 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  92651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  92653 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  92662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  92666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  92670 */     GIR_RootConstrainSelectedInstOperands,
     /*  92671 */     // GIR_Coverage, 11979,
     /*  92671 */     GIR_EraseRootFromParent_Done,
     /*  92672 */   // Label 1447: @92672
     /*  92672 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(92715), // Rule ID 13804 //
     /*  92677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92698 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  92701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  92707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  92711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  92713 */     GIR_RootConstrainSelectedInstOperands,
     /*  92714 */     // GIR_Coverage, 13804,
     /*  92714 */     GIR_EraseRootFromParent_Done,
     /*  92715 */   // Label 1448: @92715
     /*  92715 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(92758), // Rule ID 3154 //
     /*  92720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92741 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  92744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  92752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  92756 */     GIR_RootConstrainSelectedInstOperands,
     /*  92757 */     // GIR_Coverage, 3154,
     /*  92757 */     GIR_EraseRootFromParent_Done,
     /*  92758 */   // Label 1449: @92758
     /*  92758 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(92773), // Rule ID 7533 //
     /*  92763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92766 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  92766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  92771 */     GIR_RootConstrainSelectedInstOperands,
     /*  92772 */     // GIR_Coverage, 7533,
     /*  92772 */     GIR_Done,
     /*  92773 */   // Label 1450: @92773
     /*  92773 */   GIM_Reject,
     /*  92774 */ // Label 1434: @92774
     /*  92774 */ GIM_Reject,
     /*  92775 */ // Label 1333: @92775
     /*  92775 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(92824), // Rule ID 8512 //
     /*  92780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  92786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  92789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  92793 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  92793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  92796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  92800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92805 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  92808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  92813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  92815 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92818 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92820 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  92822 */   GIR_RootConstrainSelectedInstOperands,
     /*  92823 */   // GIR_Coverage, 8512,
     /*  92823 */   GIR_EraseRootFromParent_Done,
     /*  92824 */ // Label 1451: @92824
     /*  92824 */ GIM_Reject,
     /*  92825 */ // Label 1334: @92825
     /*  92825 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(94231),
     /*  92830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92840 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(92958), // Rule ID 15837 //
     /*  92845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  92884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92896 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92900 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92906 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  92908 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  92912 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92916 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92920 */     // MIs[5] Op3
     /*  92920 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  92925 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92929 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92935 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92937 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92939 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  92939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  92948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  92952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  92956 */     GIR_RootConstrainSelectedInstOperands,
     /*  92957 */     // GIR_Coverage, 15837,
     /*  92957 */     GIR_EraseRootFromParent_Done,
     /*  92958 */   // Label 1453: @92958
     /*  92958 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(93076), // Rule ID 15836 //
     /*  92963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  93002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93006 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93010 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93018 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93024 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93026 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93030 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93034 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93038 */     // MIs[5] Op3
     /*  93038 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93043 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93047 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93055 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93057 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  93070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93074 */     GIR_RootConstrainSelectedInstOperands,
     /*  93075 */     // GIR_Coverage, 15836,
     /*  93075 */     GIR_EraseRootFromParent_Done,
     /*  93076 */   // Label 1454: @93076
     /*  93076 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(93194), // Rule ID 15835 //
     /*  93081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93128 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93132 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93136 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93142 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93144 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93148 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93152 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93156 */     // MIs[5] Op3
     /*  93156 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93161 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93165 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93171 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93173 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93175 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  93184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93192 */     GIR_RootConstrainSelectedInstOperands,
     /*  93193 */     // GIR_Coverage, 15835,
     /*  93193 */     GIR_EraseRootFromParent_Done,
     /*  93194 */   // Label 1455: @93194
     /*  93194 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(93312), // Rule ID 15834 //
     /*  93199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93242 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93246 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93250 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93254 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93260 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93262 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93266 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93270 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93274 */     // MIs[5] Op3
     /*  93274 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93279 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93283 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93289 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93291 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93293 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93310 */     GIR_RootConstrainSelectedInstOperands,
     /*  93311 */     // GIR_Coverage, 15834,
     /*  93311 */     GIR_EraseRootFromParent_Done,
     /*  93312 */   // Label 1456: @93312
     /*  93312 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(93430), // Rule ID 15831 //
     /*  93317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93360 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93364 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93372 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93376 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93380 */     // MIs[4] Op3
     /*  93380 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93385 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93389 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93395 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93397 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93401 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93407 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93409 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93411 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93428 */     GIR_RootConstrainSelectedInstOperands,
     /*  93429 */     // GIR_Coverage, 15831,
     /*  93429 */     GIR_EraseRootFromParent_Done,
     /*  93430 */   // Label 1457: @93430
     /*  93430 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(93548), // Rule ID 15833 //
     /*  93435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93478 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93482 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93486 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93490 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93494 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93498 */     // MIs[4] Op3
     /*  93498 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93503 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93507 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93513 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93515 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93519 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93527 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93529 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93546 */     GIR_RootConstrainSelectedInstOperands,
     /*  93547 */     // GIR_Coverage, 15833,
     /*  93547 */     GIR_EraseRootFromParent_Done,
     /*  93548 */   // Label 1458: @93548
     /*  93548 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(93666), // Rule ID 11978 //
     /*  93553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93596 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93600 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93604 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93608 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93612 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93616 */     // MIs[4] Op3
     /*  93616 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93621 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93625 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93631 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93633 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93637 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93643 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93645 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93647 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  93660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93664 */     GIR_RootConstrainSelectedInstOperands,
     /*  93665 */     // GIR_Coverage, 11978,
     /*  93665 */     GIR_EraseRootFromParent_Done,
     /*  93666 */   // Label 1459: @93666
     /*  93666 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(93784), // Rule ID 15832 //
     /*  93671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93722 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93726 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93730 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93734 */     // MIs[4] Op3
     /*  93734 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93739 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93743 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93749 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93751 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93755 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93761 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93763 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93765 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  93778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93782 */     GIR_RootConstrainSelectedInstOperands,
     /*  93783 */     // GIR_Coverage, 15832,
     /*  93783 */     GIR_EraseRootFromParent_Done,
     /*  93784 */   // Label 1460: @93784
     /*  93784 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(93855), // Rule ID 15701 //
     /*  93789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93828 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93834 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93838 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  93845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  93849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93853 */     GIR_RootConstrainSelectedInstOperands,
     /*  93854 */     // GIR_Coverage, 15701,
     /*  93854 */     GIR_EraseRootFromParent_Done,
     /*  93855 */   // Label 1461: @93855
     /*  93855 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(93926), // Rule ID 15700 //
     /*  93860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  93883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93899 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93905 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93909 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  93916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  93920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93924 */     GIR_RootConstrainSelectedInstOperands,
     /*  93925 */     // GIR_Coverage, 15700,
     /*  93925 */     GIR_EraseRootFromParent_Done,
     /*  93926 */   // Label 1462: @93926
     /*  93926 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(93997), // Rule ID 15699 //
     /*  93931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  93938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93970 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93976 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93980 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  93987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  93991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93995 */     GIR_RootConstrainSelectedInstOperands,
     /*  93996 */     // GIR_Coverage, 15699,
     /*  93996 */     GIR_EraseRootFromParent_Done,
     /*  93997 */   // Label 1463: @93997
     /*  93997 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(94068), // Rule ID 11942 //
     /*  94002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94041 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94047 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  94049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94051 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  94054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94066 */     GIR_RootConstrainSelectedInstOperands,
     /*  94067 */     // GIR_Coverage, 11942,
     /*  94067 */     GIR_EraseRootFromParent_Done,
     /*  94068 */   // Label 1464: @94068
     /*  94068 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(94129), // Rule ID 11977 //
     /*  94073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  94084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94092 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  94096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  94100 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94106 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  94108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94110 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  94119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  94123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  94127 */     GIR_RootConstrainSelectedInstOperands,
     /*  94128 */     // GIR_Coverage, 11977,
     /*  94128 */     GIR_EraseRootFromParent_Done,
     /*  94129 */   // Label 1465: @94129
     /*  94129 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(94172), // Rule ID 13803 //
     /*  94134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94155 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  94164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  94168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  94170 */     GIR_RootConstrainSelectedInstOperands,
     /*  94171 */     // GIR_Coverage, 13803,
     /*  94171 */     GIR_EraseRootFromParent_Done,
     /*  94172 */   // Label 1466: @94172
     /*  94172 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(94215), // Rule ID 3152 //
     /*  94177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94198 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94203 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  94213 */     GIR_RootConstrainSelectedInstOperands,
     /*  94214 */     // GIR_Coverage, 3152,
     /*  94214 */     GIR_EraseRootFromParent_Done,
     /*  94215 */   // Label 1467: @94215
     /*  94215 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(94230), // Rule ID 7532 //
     /*  94220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94223 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  94223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  94228 */     GIR_RootConstrainSelectedInstOperands,
     /*  94229 */     // GIR_Coverage, 7532,
     /*  94229 */     GIR_Done,
     /*  94230 */   // Label 1468: @94230
     /*  94230 */   GIM_Reject,
     /*  94231 */ // Label 1452: @94231
     /*  94231 */ GIM_Reject,
     /*  94232 */ // Label 1335: @94232
     /*  94232 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(94281), // Rule ID 8511 //
     /*  94237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  94243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  94246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  94250 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  94250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  94253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  94257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94262 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  94265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  94270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  94272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94275 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94277 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  94279 */   GIR_RootConstrainSelectedInstOperands,
     /*  94280 */   // GIR_Coverage, 8511,
     /*  94280 */   GIR_EraseRootFromParent_Done,
     /*  94281 */ // Label 1469: @94281
     /*  94281 */ GIM_Reject,
     /*  94282 */ // Label 1336: @94282
     /*  94282 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(95688),
     /*  94287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94297 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(94415), // Rule ID 15830 //
     /*  94302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94345 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94349 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94353 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94357 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94363 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94365 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94369 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94373 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94377 */     // MIs[5] Op3
     /*  94377 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94382 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94386 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94392 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94394 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94396 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94413 */     GIR_RootConstrainSelectedInstOperands,
     /*  94414 */     // GIR_Coverage, 15830,
     /*  94414 */     GIR_EraseRootFromParent_Done,
     /*  94415 */   // Label 1471: @94415
     /*  94415 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(94533), // Rule ID 15829 //
     /*  94420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94451 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94463 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94467 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94471 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94475 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94483 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94487 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94491 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94495 */     // MIs[5] Op3
     /*  94495 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94500 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94504 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94510 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94512 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94514 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94531 */     GIR_RootConstrainSelectedInstOperands,
     /*  94532 */     // GIR_Coverage, 15829,
     /*  94532 */     GIR_EraseRootFromParent_Done,
     /*  94533 */   // Label 1472: @94533
     /*  94533 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(94651), // Rule ID 15828 //
     /*  94538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94581 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94585 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94589 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94593 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94601 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94605 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94609 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94613 */     // MIs[5] Op3
     /*  94613 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94618 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94622 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94630 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94632 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  94645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94649 */     GIR_RootConstrainSelectedInstOperands,
     /*  94650 */     // GIR_Coverage, 15828,
     /*  94650 */     GIR_EraseRootFromParent_Done,
     /*  94651 */   // Label 1473: @94651
     /*  94651 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(94769), // Rule ID 15827 //
     /*  94656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94699 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94703 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94707 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94711 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94717 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94719 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94723 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94727 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94731 */     // MIs[5] Op3
     /*  94731 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94736 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94740 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94746 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94748 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94750 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  94763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94767 */     GIR_RootConstrainSelectedInstOperands,
     /*  94768 */     // GIR_Coverage, 15827,
     /*  94768 */     GIR_EraseRootFromParent_Done,
     /*  94769 */   // Label 1474: @94769
     /*  94769 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(94887), // Rule ID 15824 //
     /*  94774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94821 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94825 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  94829 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94833 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94837 */     // MIs[4] Op3
     /*  94837 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  94842 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94846 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94852 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94854 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94858 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94864 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94866 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94868 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  94877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  94881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  94885 */     GIR_RootConstrainSelectedInstOperands,
     /*  94886 */     // GIR_Coverage, 15824,
     /*  94886 */     GIR_EraseRootFromParent_Done,
     /*  94887 */   // Label 1475: @94887
     /*  94887 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(95005), // Rule ID 15826 //
     /*  94892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94935 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94939 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94943 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  94947 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94951 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94955 */     // MIs[4] Op3
     /*  94955 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  94960 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94964 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94972 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94976 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94982 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94984 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94986 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  94995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  94999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95003 */     GIR_RootConstrainSelectedInstOperands,
     /*  95004 */     // GIR_Coverage, 15826,
     /*  95004 */     GIR_EraseRootFromParent_Done,
     /*  95005 */   // Label 1476: @95005
     /*  95005 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(95123), // Rule ID 11976 //
     /*  95010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95053 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95057 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95061 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95065 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95069 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95073 */     // MIs[4] Op3
     /*  95073 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  95078 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95082 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95090 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95094 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95100 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95102 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95104 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  95113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  95121 */     GIR_RootConstrainSelectedInstOperands,
     /*  95122 */     // GIR_Coverage, 11976,
     /*  95122 */     GIR_EraseRootFromParent_Done,
     /*  95123 */   // Label 1477: @95123
     /*  95123 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(95241), // Rule ID 15825 //
     /*  95128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95159 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95171 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95175 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95179 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95183 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95187 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95191 */     // MIs[4] Op3
     /*  95191 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  95196 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95200 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95208 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95212 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95218 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95220 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95222 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  95231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95239 */     GIR_RootConstrainSelectedInstOperands,
     /*  95240 */     // GIR_Coverage, 15825,
     /*  95240 */     GIR_EraseRootFromParent_Done,
     /*  95241 */   // Label 1478: @95241
     /*  95241 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(95312), // Rule ID 15698 //
     /*  95246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95285 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95291 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95295 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95310 */     GIR_RootConstrainSelectedInstOperands,
     /*  95311 */     // GIR_Coverage, 15698,
     /*  95311 */     GIR_EraseRootFromParent_Done,
     /*  95312 */   // Label 1479: @95312
     /*  95312 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(95383), // Rule ID 15697 //
     /*  95317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95356 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95362 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95366 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95381 */     GIR_RootConstrainSelectedInstOperands,
     /*  95382 */     // GIR_Coverage, 15697,
     /*  95382 */     GIR_EraseRootFromParent_Done,
     /*  95383 */   // Label 1480: @95383
     /*  95383 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(95454), // Rule ID 15696 //
     /*  95388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95427 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95433 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95437 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95452 */     GIR_RootConstrainSelectedInstOperands,
     /*  95453 */     // GIR_Coverage, 15696,
     /*  95453 */     GIR_EraseRootFromParent_Done,
     /*  95454 */   // Label 1481: @95454
     /*  95454 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(95525), // Rule ID 11940 //
     /*  95459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95498 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95504 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95508 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95523 */     GIR_RootConstrainSelectedInstOperands,
     /*  95524 */     // GIR_Coverage, 11940,
     /*  95524 */     GIR_EraseRootFromParent_Done,
     /*  95525 */   // Label 1482: @95525
     /*  95525 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(95586), // Rule ID 11975 //
     /*  95530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  95541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95549 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  95553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  95557 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95563 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  95565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  95567 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  95576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  95580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  95584 */     GIR_RootConstrainSelectedInstOperands,
     /*  95585 */     // GIR_Coverage, 11975,
     /*  95585 */     GIR_EraseRootFromParent_Done,
     /*  95586 */   // Label 1483: @95586
     /*  95586 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(95629), // Rule ID 13802 //
     /*  95591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95612 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  95615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  95621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  95627 */     GIR_RootConstrainSelectedInstOperands,
     /*  95628 */     // GIR_Coverage, 13802,
     /*  95628 */     GIR_EraseRootFromParent_Done,
     /*  95629 */   // Label 1484: @95629
     /*  95629 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(95672), // Rule ID 3150 //
     /*  95634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95655 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  95658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  95670 */     GIR_RootConstrainSelectedInstOperands,
     /*  95671 */     // GIR_Coverage, 3150,
     /*  95671 */     GIR_EraseRootFromParent_Done,
     /*  95672 */   // Label 1485: @95672
     /*  95672 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(95687), // Rule ID 7531 //
     /*  95677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95680 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  95680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  95685 */     GIR_RootConstrainSelectedInstOperands,
     /*  95686 */     // GIR_Coverage, 7531,
     /*  95686 */     GIR_Done,
     /*  95687 */   // Label 1486: @95687
     /*  95687 */   GIM_Reject,
     /*  95688 */ // Label 1470: @95688
     /*  95688 */ GIM_Reject,
     /*  95689 */ // Label 1337: @95689
     /*  95689 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(95738), // Rule ID 8510 //
     /*  95694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  95700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  95703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  95707 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  95707 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  95710 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  95714 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95719 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  95722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  95727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  95729 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95732 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95734 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  95736 */   GIR_RootConstrainSelectedInstOperands,
     /*  95737 */   // GIR_Coverage, 8510,
     /*  95737 */   GIR_EraseRootFromParent_Done,
     /*  95738 */ // Label 1487: @95738
     /*  95738 */ GIM_Reject,
     /*  95739 */ // Label 1338: @95739
     /*  95739 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(97145),
     /*  95744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95754 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(95872), // Rule ID 15823 //
     /*  95759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  95798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95802 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95806 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95814 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95822 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95826 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95830 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95834 */     // MIs[5] Op3
     /*  95834 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95839 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95843 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95849 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95851 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95853 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  95853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  95862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  95866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  95870 */     GIR_RootConstrainSelectedInstOperands,
     /*  95871 */     // GIR_Coverage, 15823,
     /*  95871 */     GIR_EraseRootFromParent_Done,
     /*  95872 */   // Label 1489: @95872
     /*  95872 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(95990), // Rule ID 15822 //
     /*  95877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  95916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95920 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95924 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95928 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95932 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95938 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95940 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95944 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95948 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95952 */     // MIs[5] Op3
     /*  95952 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95957 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95961 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95967 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95969 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95971 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  95971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  95980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  95984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  95988 */     GIR_RootConstrainSelectedInstOperands,
     /*  95989 */     // GIR_Coverage, 15822,
     /*  95989 */     GIR_EraseRootFromParent_Done,
     /*  95990 */   // Label 1490: @95990
     /*  95990 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(96108), // Rule ID 15821 //
     /*  95995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96042 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96046 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96050 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96058 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96062 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96066 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96070 */     // MIs[5] Op3
     /*  96070 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96075 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96079 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96085 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96087 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96089 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  96098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96106 */     GIR_RootConstrainSelectedInstOperands,
     /*  96107 */     // GIR_Coverage, 15821,
     /*  96107 */     GIR_EraseRootFromParent_Done,
     /*  96108 */   // Label 1491: @96108
     /*  96108 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(96226), // Rule ID 15820 //
     /*  96113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96156 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96160 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96164 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96168 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96176 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96180 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96184 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96188 */     // MIs[5] Op3
     /*  96188 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96193 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96197 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96203 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96205 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96207 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  96216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96224 */     GIR_RootConstrainSelectedInstOperands,
     /*  96225 */     // GIR_Coverage, 15820,
     /*  96225 */     GIR_EraseRootFromParent_Done,
     /*  96226 */   // Label 1492: @96226
     /*  96226 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(96344), // Rule ID 15817 //
     /*  96231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96278 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96282 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96286 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96290 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96294 */     // MIs[4] Op3
     /*  96294 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96299 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96303 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96309 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96311 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96315 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96321 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96323 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96325 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96342 */     GIR_RootConstrainSelectedInstOperands,
     /*  96343 */     // GIR_Coverage, 15817,
     /*  96343 */     GIR_EraseRootFromParent_Done,
     /*  96344 */   // Label 1493: @96344
     /*  96344 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(96462), // Rule ID 15819 //
     /*  96349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96392 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96396 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96404 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96408 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96412 */     // MIs[4] Op3
     /*  96412 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96417 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96421 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96427 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96429 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96433 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96439 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96441 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96443 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96460 */     GIR_RootConstrainSelectedInstOperands,
     /*  96461 */     // GIR_Coverage, 15819,
     /*  96461 */     GIR_EraseRootFromParent_Done,
     /*  96462 */   // Label 1494: @96462
     /*  96462 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(96580), // Rule ID 11974 //
     /*  96467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96510 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96514 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96518 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96522 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96526 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96530 */     // MIs[4] Op3
     /*  96530 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96535 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96539 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96545 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96547 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96551 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96559 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96561 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96578 */     GIR_RootConstrainSelectedInstOperands,
     /*  96579 */     // GIR_Coverage, 11974,
     /*  96579 */     GIR_EraseRootFromParent_Done,
     /*  96580 */   // Label 1495: @96580
     /*  96580 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(96698), // Rule ID 15818 //
     /*  96585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96632 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96636 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96640 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96644 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96648 */     // MIs[4] Op3
     /*  96648 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96653 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96657 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96663 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96665 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96669 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96677 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96679 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96696 */     GIR_RootConstrainSelectedInstOperands,
     /*  96697 */     // GIR_Coverage, 15818,
     /*  96697 */     GIR_EraseRootFromParent_Done,
     /*  96698 */   // Label 1496: @96698
     /*  96698 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(96769), // Rule ID 15695 //
     /*  96703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96742 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96752 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  96759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96767 */     GIR_RootConstrainSelectedInstOperands,
     /*  96768 */     // GIR_Coverage, 15695,
     /*  96768 */     GIR_EraseRootFromParent_Done,
     /*  96769 */   // Label 1497: @96769
     /*  96769 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(96840), // Rule ID 15694 //
     /*  96774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  96797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96813 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96819 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96823 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  96830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96838 */     GIR_RootConstrainSelectedInstOperands,
     /*  96839 */     // GIR_Coverage, 15694,
     /*  96839 */     GIR_EraseRootFromParent_Done,
     /*  96840 */   // Label 1498: @96840
     /*  96840 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(96911), // Rule ID 15693 //
     /*  96845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96884 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96890 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96894 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96909 */     GIR_RootConstrainSelectedInstOperands,
     /*  96910 */     // GIR_Coverage, 15693,
     /*  96910 */     GIR_EraseRootFromParent_Done,
     /*  96911 */   // Label 1499: @96911
     /*  96911 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(96982), // Rule ID 11938 //
     /*  96916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  96939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96955 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96965 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96980 */     GIR_RootConstrainSelectedInstOperands,
     /*  96981 */     // GIR_Coverage, 11938,
     /*  96981 */     GIR_EraseRootFromParent_Done,
     /*  96982 */   // Label 1500: @96982
     /*  96982 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(97043), // Rule ID 11973 //
     /*  96987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  96998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97006 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  97010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  97014 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97020 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  97022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97024 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  97033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  97037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  97041 */     GIR_RootConstrainSelectedInstOperands,
     /*  97042 */     // GIR_Coverage, 11973,
     /*  97042 */     GIR_EraseRootFromParent_Done,
     /*  97043 */   // Label 1501: @97043
     /*  97043 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(97086), // Rule ID 13801 //
     /*  97048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97069 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  97078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  97082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  97084 */     GIR_RootConstrainSelectedInstOperands,
     /*  97085 */     // GIR_Coverage, 13801,
     /*  97085 */     GIR_EraseRootFromParent_Done,
     /*  97086 */   // Label 1502: @97086
     /*  97086 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(97129), // Rule ID 3148 //
     /*  97091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97112 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  97119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  97123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  97127 */     GIR_RootConstrainSelectedInstOperands,
     /*  97128 */     // GIR_Coverage, 3148,
     /*  97128 */     GIR_EraseRootFromParent_Done,
     /*  97129 */   // Label 1503: @97129
     /*  97129 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(97144), // Rule ID 7530 //
     /*  97134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97137 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  97137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  97142 */     GIR_RootConstrainSelectedInstOperands,
     /*  97143 */     // GIR_Coverage, 7530,
     /*  97143 */     GIR_Done,
     /*  97144 */   // Label 1504: @97144
     /*  97144 */   GIM_Reject,
     /*  97145 */ // Label 1488: @97145
     /*  97145 */ GIM_Reject,
     /*  97146 */ // Label 1339: @97146
     /*  97146 */ GIM_Reject,
     /*  97147 */ // Label 8: @97147
     /*  97147 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(104670),
     /*  97152 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  97155 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1517*/ GIMT_Encode4(104669),
     /*  97166 */   /*GILLT_v2s64*//*Label 1506*/ GIMT_Encode4(97234), GIMT_Encode4(0),
     /*  97174 */   /*GILLT_v4s32*//*Label 1507*/ GIMT_Encode4(97755), GIMT_Encode4(0),
     /*  97182 */   /*GILLT_v8s16*//*Label 1508*/ GIMT_Encode4(100167),
     /*  97186 */   /*GILLT_v16s8*//*Label 1509*/ GIMT_Encode4(102576), GIMT_Encode4(0),
     /*  97194 */   /*GILLT_nxv2s1*//*Label 1510*/ GIMT_Encode4(104487), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  97210 */   /*GILLT_nxv4s1*//*Label 1511*/ GIMT_Encode4(104513),
     /*  97214 */   /*GILLT_nxv4s16*//*Label 1512*/ GIMT_Encode4(104539),
     /*  97218 */   /*GILLT_nxv4s32*//*Label 1513*/ GIMT_Encode4(104565),
     /*  97222 */   /*GILLT_nxv8s1*//*Label 1514*/ GIMT_Encode4(104591),
     /*  97226 */   /*GILLT_nxv8s16*//*Label 1515*/ GIMT_Encode4(104617),
     /*  97230 */   /*GILLT_nxv16s1*//*Label 1516*/ GIMT_Encode4(104643),
     /*  97234 */   // Label 1506: @97234
     /*  97234 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(97754),
     /*  97239 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  97245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97253 */     GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(97315), // Rule ID 5842 //
     /*  97258 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97262 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97268 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  97270 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97272 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  97272 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97275 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  97279 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97284 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97288 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97290 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97293 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97295 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97301 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97304 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97309 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97314 */       // GIR_Coverage, 5842,
     /*  97314 */       GIR_EraseRootFromParent_Done,
     /*  97315 */     // Label 1519: @97315
     /*  97315 */     GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(97377), // Rule ID 5846 //
     /*  97320 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97324 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97330 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  97332 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97334 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  97334 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97337 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  97341 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97346 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97350 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97352 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97355 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97357 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97360 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97363 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97366 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97371 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97376 */       // GIR_Coverage, 5846,
     /*  97376 */       GIR_EraseRootFromParent_Done,
     /*  97377 */     // Label 1520: @97377
     /*  97377 */     GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(97435), // Rule ID 5843 //
     /*  97382 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97386 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  97390 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97392 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  97392 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  97395 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97399 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97404 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97406 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97409 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97411 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97414 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  97416 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97419 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97424 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97429 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97434 */       // GIR_Coverage, 5843,
     /*  97434 */       GIR_EraseRootFromParent_Done,
     /*  97435 */     // Label 1521: @97435
     /*  97435 */     GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(97493), // Rule ID 5847 //
     /*  97440 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97444 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  97448 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97450 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  97450 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  97453 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97457 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97462 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97464 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97467 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97469 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97472 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  97474 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97477 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97482 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97487 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97492 */       // GIR_Coverage, 5847,
     /*  97492 */       GIR_EraseRootFromParent_Done,
     /*  97493 */     // Label 1522: @97493
     /*  97493 */     GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(97623), // Rule ID 5841 //
     /*  97498 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97502 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  97502 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  97505 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97509 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97514 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97516 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  97519 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97523 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97528 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97531 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  97535 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  97538 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97543 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97548 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97553 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97556 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97560 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97565 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97567 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97570 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97574 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97579 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97582 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97586 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97589 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97594 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97599 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97604 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  97607 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97609 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97612 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  97615 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97618 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97621 */       GIR_RootConstrainSelectedInstOperands,
     /*  97622 */       // GIR_Coverage, 5841,
     /*  97622 */       GIR_EraseRootFromParent_Done,
     /*  97623 */     // Label 1523: @97623
     /*  97623 */     GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(97753), // Rule ID 5845 //
     /*  97628 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97632 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  97632 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  97635 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97639 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97644 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97646 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  97649 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97653 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97658 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97661 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  97665 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  97668 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97673 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97678 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97683 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97686 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97690 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97695 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97697 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97700 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97704 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97709 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97712 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97716 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97719 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97724 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97729 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97734 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  97737 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97739 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97742 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  97745 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97748 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97751 */       GIR_RootConstrainSelectedInstOperands,
     /*  97752 */       // GIR_Coverage, 5845,
     /*  97752 */       GIR_EraseRootFromParent_Done,
     /*  97753 */     // Label 1524: @97753
     /*  97753 */     GIM_Reject,
     /*  97754 */   // Label 1518: @97754
     /*  97754 */   GIM_Reject,
     /*  97755 */   // Label 1507: @97755
     /*  97755 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(100166),
     /*  97760 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  97763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  97766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97770 */     GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(97899), // Rule ID 5467 //
     /*  97775 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97779 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97783 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  97787 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97791 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97795 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  97799 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97803 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97807 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97811 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97815 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  97819 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97824 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97828 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97834 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97836 */       // MIs[2] Operand 2
     /*  97836 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  97847 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  97849 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  97849 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97852 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97856 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97861 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  97864 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97868 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97871 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97876 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97881 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  97884 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97886 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97889 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  97893 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  97897 */       GIR_RootConstrainSelectedInstOperands,
     /*  97898 */       // GIR_Coverage, 5467,
     /*  97898 */       GIR_EraseRootFromParent_Done,
     /*  97899 */     // Label 1526: @97899
     /*  97899 */     GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(98021), // Rule ID 5463 //
     /*  97904 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97908 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97912 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  97916 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97920 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97924 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  97928 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97932 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97936 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  97940 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97944 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  97948 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97953 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97958 */       // MIs[2] Operand 2
     /*  97958 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  97969 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  97971 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  97971 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97974 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97978 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97983 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  97986 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97990 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97993 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97998 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98003 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  98006 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98008 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98011 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  98015 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  98019 */       GIR_RootConstrainSelectedInstOperands,
     /*  98020 */       // GIR_Coverage, 5463,
     /*  98020 */       GIR_EraseRootFromParent_Done,
     /*  98021 */     // Label 1527: @98021
     /*  98021 */     GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(98143), // Rule ID 5465 //
     /*  98026 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98030 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98034 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98038 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98042 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98046 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98050 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98054 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  98058 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  98062 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98066 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98070 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98075 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98080 */       // MIs[2] Operand 2
     /*  98080 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  98091 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98093 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  98093 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98096 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98100 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98105 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  98108 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98112 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98115 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98120 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98125 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  98128 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98130 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98133 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  98137 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  98141 */       GIR_RootConstrainSelectedInstOperands,
     /*  98142 */       // GIR_Coverage, 5465,
     /*  98142 */       GIR_EraseRootFromParent_Done,
     /*  98143 */     // Label 1528: @98143
     /*  98143 */     GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(98245), // Rule ID 5613 //
     /*  98148 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98152 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98156 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98160 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98164 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98168 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98172 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98177 */       // MIs[2] Operand 2
     /*  98177 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  98188 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  98192 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98196 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98200 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  98204 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98208 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98212 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98217 */       // MIs[4] Operand 2
     /*  98217 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  98228 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  98230 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  98230 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  98233 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98235 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  98239 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  98243 */       GIR_RootConstrainSelectedInstOperands,
     /*  98244 */       // GIR_Coverage, 5613,
     /*  98244 */       GIR_EraseRootFromParent_Done,
     /*  98245 */     // Label 1529: @98245
     /*  98245 */     GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(98374), // Rule ID 6397 //
     /*  98250 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98254 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98258 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98262 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98265 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  98270 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98274 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98278 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98283 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  98287 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98289 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  98289 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  98292 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  98296 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98301 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98304 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98306 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98309 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98313 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98318 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98320 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98323 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98327 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98332 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98335 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  98339 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98342 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98347 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98352 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98357 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  98360 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98362 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98365 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  98369 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98372 */       GIR_RootConstrainSelectedInstOperands,
     /*  98373 */       // GIR_Coverage, 6397,
     /*  98373 */       GIR_EraseRootFromParent_Done,
     /*  98374 */     // Label 1530: @98374
     /*  98374 */     GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(98416), // Rule ID 5852 //
     /*  98379 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  98386 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  98393 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  98393 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  98396 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98398 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  98403 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98406 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98411 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  98414 */       GIR_RootConstrainSelectedInstOperands,
     /*  98415 */       // GIR_Coverage, 5852,
     /*  98415 */       GIR_EraseRootFromParent_Done,
     /*  98416 */     // Label 1531: @98416
     /*  98416 */     GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(98458), // Rule ID 5856 //
     /*  98421 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  98428 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  98435 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  98435 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  98438 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98440 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  98445 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98448 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98453 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  98456 */       GIR_RootConstrainSelectedInstOperands,
     /*  98457 */       // GIR_Coverage, 5856,
     /*  98457 */       GIR_EraseRootFromParent_Done,
     /*  98458 */     // Label 1532: @98458
     /*  98458 */     GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(98581), // Rule ID 2578 //
     /*  98463 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98466 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98470 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98474 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98478 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98481 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  98486 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98490 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98494 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98499 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  98503 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98507 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  98511 */       // MIs[2] Operand 1
     /*  98511 */       // No operand predicates
     /*  98511 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98513 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  98513 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98516 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98520 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98525 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98527 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98530 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98534 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98539 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98542 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98546 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98549 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98554 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98559 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98564 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  98567 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98569 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98572 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  98576 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  98579 */       GIR_RootConstrainSelectedInstOperands,
     /*  98580 */       // GIR_Coverage, 2578,
     /*  98580 */       GIR_EraseRootFromParent_Done,
     /*  98581 */     // Label 1533: @98581
     /*  98581 */     GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(98704), // Rule ID 6367 //
     /*  98586 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98589 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98593 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98597 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98601 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98605 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98609 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  98613 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98617 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98622 */       // MIs[2] imm
     /*  98622 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98626 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98630 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  98634 */       // MIs[3] Operand 1
     /*  98634 */       // No operand predicates
     /*  98634 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98636 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  98636 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98639 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98643 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98648 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98650 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98653 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98657 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98662 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98665 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98669 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98672 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98677 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98682 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98687 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  98690 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98692 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98695 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  98699 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  98702 */       GIR_RootConstrainSelectedInstOperands,
     /*  98703 */       // GIR_Coverage, 6367,
     /*  98703 */       GIR_EraseRootFromParent_Done,
     /*  98704 */     // Label 1534: @98704
     /*  98704 */     GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(98824), // Rule ID 6403 //
     /*  98709 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98713 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98717 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98721 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98725 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98729 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98733 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98737 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98742 */       // MIs[2] imm
     /*  98742 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98746 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98750 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  98754 */       // MIs[3] Operand 1
     /*  98754 */       // No operand predicates
     /*  98754 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98756 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  98756 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98759 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98763 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98768 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98770 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98773 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98777 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98782 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98785 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98789 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98792 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98797 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98802 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98807 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  98810 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98812 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98815 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  98819 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  98822 */       GIR_RootConstrainSelectedInstOperands,
     /*  98823 */       // GIR_Coverage, 6403,
     /*  98823 */       GIR_EraseRootFromParent_Done,
     /*  98824 */     // Label 1535: @98824
     /*  98824 */     GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(98941), // Rule ID 2501 //
     /*  98829 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98832 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98836 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98840 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98844 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98847 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  98852 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98856 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98860 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98865 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98870 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98872 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  98872 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98875 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98879 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98884 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98886 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98889 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98893 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98898 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98901 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98905 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98908 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98913 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98918 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98923 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  98926 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98928 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98931 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  98935 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  98939 */       GIR_RootConstrainSelectedInstOperands,
     /*  98940 */       // GIR_Coverage, 2501,
     /*  98940 */       GIR_EraseRootFromParent_Done,
     /*  98941 */     // Label 1536: @98941
     /*  98941 */     GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(99058), // Rule ID 5383 //
     /*  98946 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98949 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98953 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98957 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98961 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98964 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  98969 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98973 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98977 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98982 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98987 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98989 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  98989 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98992 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98996 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99001 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99003 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99006 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99010 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99015 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99018 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99022 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99025 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99030 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99035 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99040 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  99043 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99045 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99048 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99052 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  99056 */       GIR_RootConstrainSelectedInstOperands,
     /*  99057 */       // GIR_Coverage, 5383,
     /*  99057 */       GIR_EraseRootFromParent_Done,
     /*  99058 */     // Label 1537: @99058
     /*  99058 */     GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(99175), // Rule ID 5386 //
     /*  99063 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99066 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99070 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99074 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99078 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  99081 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  99086 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99090 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99094 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99099 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99104 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99106 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99106 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99109 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99113 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99118 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99120 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99123 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99127 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99132 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99135 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99139 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99142 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99147 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99152 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99157 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  99160 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99162 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99165 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99169 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  99173 */       GIR_RootConstrainSelectedInstOperands,
     /*  99174 */       // GIR_Coverage, 5386,
     /*  99174 */       GIR_EraseRootFromParent_Done,
     /*  99175 */     // Label 1538: @99175
     /*  99175 */     GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(99292), // Rule ID 5389 //
     /*  99180 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99183 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99187 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99191 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99195 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  99198 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  99203 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99207 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99211 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99216 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99221 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99223 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99223 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99226 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99230 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99235 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99237 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99240 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99244 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99249 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99252 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99256 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99259 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99264 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99269 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99274 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  99277 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99279 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99282 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99286 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  99290 */       GIR_RootConstrainSelectedInstOperands,
     /*  99291 */       // GIR_Coverage, 5389,
     /*  99291 */       GIR_EraseRootFromParent_Done,
     /*  99292 */     // Label 1539: @99292
     /*  99292 */     GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(99396), // Rule ID 2497 //
     /*  99297 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99300 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99304 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99308 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99312 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  99315 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  99320 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99324 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99329 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99331 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 592:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  99331 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99334 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99338 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99343 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99345 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99348 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99352 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99357 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99360 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99364 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99367 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99372 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99377 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99382 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  99385 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99387 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99390 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99394 */       GIR_RootConstrainSelectedInstOperands,
     /*  99395 */       // GIR_Coverage, 2497,
     /*  99395 */       GIR_EraseRootFromParent_Done,
     /*  99396 */     // Label 1540: @99396
     /*  99396 */     GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(99452), // Rule ID 5546 //
     /*  99401 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99405 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99409 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99413 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99418 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  99422 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99426 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99430 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99435 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  99437 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  99437 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  99440 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99442 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  99446 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  99450 */       GIR_RootConstrainSelectedInstOperands,
     /*  99451 */       // GIR_Coverage, 5546,
     /*  99451 */       GIR_EraseRootFromParent_Done,
     /*  99452 */     // Label 1541: @99452
     /*  99452 */     GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(99518), // Rule ID 5850 //
     /*  99457 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99461 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99465 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  99471 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  99473 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99475 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  99475 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  99478 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  99482 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99487 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  99491 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99493 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99496 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99498 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99501 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99504 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99507 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99512 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99517 */       // GIR_Coverage, 5850,
     /*  99517 */       GIR_EraseRootFromParent_Done,
     /*  99518 */     // Label 1542: @99518
     /*  99518 */     GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(99584), // Rule ID 5854 //
     /*  99523 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99527 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99531 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  99537 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  99539 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99541 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  99541 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  99544 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  99548 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99553 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  99557 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99559 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99562 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99564 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99567 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99570 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99573 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99578 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99583 */       // GIR_Coverage, 5854,
     /*  99583 */       GIR_EraseRootFromParent_Done,
     /*  99584 */     // Label 1543: @99584
     /*  99584 */     GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(99677), // Rule ID 4950 //
     /*  99589 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99593 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99597 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  99601 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99605 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99610 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99612 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  99612 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99615 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99619 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99624 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99626 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99629 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99633 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99638 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99641 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99645 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99648 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99653 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99658 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99663 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  99666 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99668 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99671 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  99675 */       GIR_RootConstrainSelectedInstOperands,
     /*  99676 */       // GIR_Coverage, 4950,
     /*  99676 */       GIR_EraseRootFromParent_Done,
     /*  99677 */     // Label 1544: @99677
     /*  99677 */     GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(99773), // Rule ID 4997 //
     /*  99682 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99685 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99689 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99693 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99697 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99701 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99706 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99708 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  99708 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99711 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99715 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99720 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99722 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99725 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99729 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99734 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99737 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99741 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99744 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99749 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99754 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99759 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  99762 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99764 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99767 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  99771 */       GIR_RootConstrainSelectedInstOperands,
     /*  99772 */       // GIR_Coverage, 4997,
     /*  99772 */       GIR_EraseRootFromParent_Done,
     /*  99773 */     // Label 1545: @99773
     /*  99773 */     GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(99835), // Rule ID 5851 //
     /*  99778 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99782 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99786 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  99790 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99792 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  99792 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  99795 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99799 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99804 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99806 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99809 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99811 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99814 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  99816 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99819 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99824 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99829 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99834 */       // GIR_Coverage, 5851,
     /*  99834 */       GIR_EraseRootFromParent_Done,
     /*  99835 */     // Label 1546: @99835
     /*  99835 */     GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(99897), // Rule ID 5855 //
     /*  99840 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99844 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99848 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  99852 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99854 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  99854 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  99857 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99861 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99866 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99868 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99871 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99873 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99876 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  99878 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99881 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99886 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99891 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99896 */       // GIR_Coverage, 5855,
     /*  99896 */       GIR_EraseRootFromParent_Done,
     /*  99897 */     // Label 1547: @99897
     /*  99897 */     GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(100031), // Rule ID 5849 //
     /*  99902 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99906 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99910 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  99910 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  99913 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99917 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99922 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99924 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  99927 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99931 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99936 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99939 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  99943 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  99946 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99951 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99956 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99961 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99964 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99968 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99973 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99975 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99978 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99982 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99987 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99990 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99994 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99997 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100002 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100007 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100012 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100015 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100017 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100020 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100023 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100026 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100029 */       GIR_RootConstrainSelectedInstOperands,
     /* 100030 */       // GIR_Coverage, 5849,
     /* 100030 */       GIR_EraseRootFromParent_Done,
     /* 100031 */     // Label 1548: @100031
     /* 100031 */     GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(100165), // Rule ID 5853 //
     /* 100036 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100040 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100044 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 100044 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 100047 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100051 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100056 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100058 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 100061 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100065 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100070 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 100073 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 100077 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 100080 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100085 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100090 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100095 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100098 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100102 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100107 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100109 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100112 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100116 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100121 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100124 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100128 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100131 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100136 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100141 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100146 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100149 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100151 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100154 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100157 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100160 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100163 */       GIR_RootConstrainSelectedInstOperands,
     /* 100164 */       // GIR_Coverage, 5853,
     /* 100164 */       GIR_EraseRootFromParent_Done,
     /* 100165 */     // Label 1549: @100165
     /* 100165 */     GIM_Reject,
     /* 100166 */   // Label 1525: @100166
     /* 100166 */   GIM_Reject,
     /* 100167 */   // Label 1508: @100167
     /* 100167 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(102575),
     /* 100172 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 100178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100182 */     GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(100311), // Rule ID 5461 //
     /* 100187 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100191 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100195 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100199 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100203 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100207 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100211 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100215 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 100219 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 100223 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100227 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100231 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100236 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 100240 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 100246 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 100248 */       // MIs[2] Operand 2
     /* 100248 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100259 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 100261 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 100261 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100264 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100268 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100273 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100276 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100280 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100283 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100288 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100293 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 100296 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100301 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 100305 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 100309 */       GIR_RootConstrainSelectedInstOperands,
     /* 100310 */       // GIR_Coverage, 5461,
     /* 100310 */       GIR_EraseRootFromParent_Done,
     /* 100311 */     // Label 1551: @100311
     /* 100311 */     GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(100433), // Rule ID 5457 //
     /* 100316 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100320 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100324 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100328 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100332 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100336 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100340 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100344 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 100348 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 100352 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100356 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100360 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100365 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100370 */       // MIs[2] Operand 2
     /* 100370 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100381 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100383 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 100383 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100386 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100390 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100395 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100398 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100402 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100405 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100410 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100415 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 100418 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100420 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100423 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 100427 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 100431 */       GIR_RootConstrainSelectedInstOperands,
     /* 100432 */       // GIR_Coverage, 5457,
     /* 100432 */       GIR_EraseRootFromParent_Done,
     /* 100433 */     // Label 1552: @100433
     /* 100433 */     GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(100555), // Rule ID 5459 //
     /* 100438 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100442 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100446 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100450 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100454 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100458 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100462 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100466 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 100470 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 100474 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100478 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100482 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100487 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100492 */       // MIs[2] Operand 2
     /* 100492 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100503 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100505 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 100505 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100508 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100512 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100517 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100520 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100524 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100527 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100532 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100537 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 100540 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100542 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100545 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 100549 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 100553 */       GIR_RootConstrainSelectedInstOperands,
     /* 100554 */       // GIR_Coverage, 5459,
     /* 100554 */       GIR_EraseRootFromParent_Done,
     /* 100555 */     // Label 1553: @100555
     /* 100555 */     GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(100657), // Rule ID 5612 //
     /* 100560 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100564 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100568 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100572 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100576 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100580 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100584 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100589 */       // MIs[2] Operand 2
     /* 100589 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100600 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 100604 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100608 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100612 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 100616 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100620 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100624 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100629 */       // MIs[4] Operand 2
     /* 100629 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /* 100640 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 100642 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 100642 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 100645 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100647 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 100651 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 100655 */       GIR_RootConstrainSelectedInstOperands,
     /* 100656 */       // GIR_Coverage, 5612,
     /* 100656 */       GIR_EraseRootFromParent_Done,
     /* 100657 */     // Label 1554: @100657
     /* 100657 */     GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(100786), // Rule ID 6396 //
     /* 100662 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100666 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100670 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100674 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100677 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 100682 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100686 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100690 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100695 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /* 100699 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100701 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 100701 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100704 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 100708 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100713 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100716 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100718 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100721 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100725 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100730 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100732 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100735 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100739 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100744 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100747 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 100751 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100754 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100759 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100764 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100769 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 100772 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100774 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100777 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 100781 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100784 */       GIR_RootConstrainSelectedInstOperands,
     /* 100785 */       // GIR_Coverage, 6396,
     /* 100785 */       GIR_EraseRootFromParent_Done,
     /* 100786 */     // Label 1555: @100786
     /* 100786 */     GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(100828), // Rule ID 5860 //
     /* 100791 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 100798 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 100805 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /* 100805 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100808 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100810 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 100815 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100818 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100823 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100826 */       GIR_RootConstrainSelectedInstOperands,
     /* 100827 */       // GIR_Coverage, 5860,
     /* 100827 */       GIR_EraseRootFromParent_Done,
     /* 100828 */     // Label 1556: @100828
     /* 100828 */     GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(100870), // Rule ID 5864 //
     /* 100833 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 100840 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 100847 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /* 100847 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100850 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100852 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 100857 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100860 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100865 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100868 */       GIR_RootConstrainSelectedInstOperands,
     /* 100869 */       // GIR_Coverage, 5864,
     /* 100869 */       GIR_EraseRootFromParent_Done,
     /* 100870 */     // Label 1557: @100870
     /* 100870 */     GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(100993), // Rule ID 2576 //
     /* 100875 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100878 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100882 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100886 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100890 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100893 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 100898 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100902 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100906 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100911 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 100915 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100919 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 100923 */       // MIs[2] Operand 1
     /* 100923 */       // No operand predicates
     /* 100923 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 100925 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 100925 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100928 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100932 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100937 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100939 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100942 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100946 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100951 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100954 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100958 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100961 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100966 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100971 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100976 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /* 100979 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100981 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100984 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100988 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 100991 */       GIR_RootConstrainSelectedInstOperands,
     /* 100992 */       // GIR_Coverage, 2576,
     /* 100992 */       GIR_EraseRootFromParent_Done,
     /* 100993 */     // Label 1558: @100993
     /* 100993 */     GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(101116), // Rule ID 6366 //
     /* 100998 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101001 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101005 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101009 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101013 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101017 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101021 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 101025 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101029 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101034 */       // MIs[2] imm
     /* 101034 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 101038 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101042 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 101046 */       // MIs[3] Operand 1
     /* 101046 */       // No operand predicates
     /* 101046 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101048 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 101048 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101051 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101055 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101060 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101062 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101065 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101069 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101074 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101077 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101081 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101084 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101089 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101094 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101099 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 101102 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101104 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101107 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 101111 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 101114 */       GIR_RootConstrainSelectedInstOperands,
     /* 101115 */       // GIR_Coverage, 6366,
     /* 101115 */       GIR_EraseRootFromParent_Done,
     /* 101116 */     // Label 1559: @101116
     /* 101116 */     GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(101236), // Rule ID 6402 //
     /* 101121 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101125 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101129 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101133 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101137 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101141 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 101145 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101149 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101154 */       // MIs[2] imm
     /* 101154 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 101158 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101162 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 101166 */       // MIs[3] Operand 1
     /* 101166 */       // No operand predicates
     /* 101166 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101168 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 101168 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101171 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101175 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101180 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101182 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101185 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101189 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101194 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101197 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101201 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101204 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101209 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101214 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101219 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 101222 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101224 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101227 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 101231 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 101234 */       GIR_RootConstrainSelectedInstOperands,
     /* 101235 */       // GIR_Coverage, 6402,
     /* 101235 */       GIR_EraseRootFromParent_Done,
     /* 101236 */     // Label 1560: @101236
     /* 101236 */     GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(101353), // Rule ID 2500 //
     /* 101241 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101244 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101248 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101252 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101256 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101259 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 101264 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101268 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101272 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101277 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101282 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101284 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101284 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101287 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101291 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101296 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101298 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101301 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101305 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101310 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101313 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101317 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101320 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101325 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101330 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101335 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 101338 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101340 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101343 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101347 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101351 */       GIR_RootConstrainSelectedInstOperands,
     /* 101352 */       // GIR_Coverage, 2500,
     /* 101352 */       GIR_EraseRootFromParent_Done,
     /* 101353 */     // Label 1561: @101353
     /* 101353 */     GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(101470), // Rule ID 5382 //
     /* 101358 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101361 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101365 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101369 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101373 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101376 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 101381 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101385 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101389 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101394 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101399 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101401 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101401 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101404 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101408 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101413 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101415 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101418 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101422 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101427 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101430 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101434 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101437 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101442 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101447 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101452 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 101455 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101457 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101460 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101464 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101468 */       GIR_RootConstrainSelectedInstOperands,
     /* 101469 */       // GIR_Coverage, 5382,
     /* 101469 */       GIR_EraseRootFromParent_Done,
     /* 101470 */     // Label 1562: @101470
     /* 101470 */     GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(101587), // Rule ID 5385 //
     /* 101475 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101478 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101482 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101486 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101490 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101493 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 101498 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101502 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101506 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101511 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101516 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101518 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101518 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101521 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101525 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101530 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101532 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101535 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101539 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101544 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101547 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101551 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101554 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101559 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101564 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101569 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 101572 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101574 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101577 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101581 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101585 */       GIR_RootConstrainSelectedInstOperands,
     /* 101586 */       // GIR_Coverage, 5385,
     /* 101586 */       GIR_EraseRootFromParent_Done,
     /* 101587 */     // Label 1563: @101587
     /* 101587 */     GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(101704), // Rule ID 5388 //
     /* 101592 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101595 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101599 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101603 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101607 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101610 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 101615 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101619 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101623 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101628 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101633 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101635 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101635 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101638 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101642 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101647 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101649 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101652 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101656 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101661 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101664 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101668 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101671 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101676 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101681 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101686 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /* 101689 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101691 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101694 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101698 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101702 */       GIR_RootConstrainSelectedInstOperands,
     /* 101703 */       // GIR_Coverage, 5388,
     /* 101703 */       GIR_EraseRootFromParent_Done,
     /* 101704 */     // Label 1564: @101704
     /* 101704 */     GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(101805), // Rule ID 4944 //
     /* 101709 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101713 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101717 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101721 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 101724 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 101729 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101733 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101738 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101740 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 765:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 101740 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101743 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101747 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101752 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101754 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101757 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101761 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101766 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101769 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101773 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101776 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101781 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101786 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101791 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 101794 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101796 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101799 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101803 */       GIR_RootConstrainSelectedInstOperands,
     /* 101804 */       // GIR_Coverage, 4944,
     /* 101804 */       GIR_EraseRootFromParent_Done,
     /* 101805 */     // Label 1565: @101805
     /* 101805 */     GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(101861), // Rule ID 5537 //
     /* 101810 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101814 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101818 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101822 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101827 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 101831 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101835 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101839 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101844 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 101846 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 101846 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 101849 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101851 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 101855 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 101859 */       GIR_RootConstrainSelectedInstOperands,
     /* 101860 */       // GIR_Coverage, 5537,
     /* 101860 */       GIR_EraseRootFromParent_Done,
     /* 101861 */     // Label 1566: @101861
     /* 101861 */     GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(101927), // Rule ID 5858 //
     /* 101866 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101870 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101874 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101880 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 101882 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101884 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /* 101884 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101887 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 101891 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101896 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 101900 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101902 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101905 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101907 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101910 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101913 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101916 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101921 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101926 */       // GIR_Coverage, 5858,
     /* 101926 */       GIR_EraseRootFromParent_Done,
     /* 101927 */     // Label 1567: @101927
     /* 101927 */     GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(101993), // Rule ID 5862 //
     /* 101932 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101936 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101940 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101946 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 101948 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101950 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /* 101950 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101953 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 101957 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101962 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 101966 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101968 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101971 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101973 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101976 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101979 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101982 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101987 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101992 */       // GIR_Coverage, 5862,
     /* 101992 */       GIR_EraseRootFromParent_Done,
     /* 101993 */     // Label 1568: @101993
     /* 101993 */     GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(102086), // Rule ID 4952 //
     /* 101998 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102002 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102006 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 102010 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102014 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102019 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102021 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 102021 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102024 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102028 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102033 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102035 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102038 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102042 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102047 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102050 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102054 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102057 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102062 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102067 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102072 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 102075 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102077 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102080 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102084 */       GIR_RootConstrainSelectedInstOperands,
     /* 102085 */       // GIR_Coverage, 4952,
     /* 102085 */       GIR_EraseRootFromParent_Done,
     /* 102086 */     // Label 1569: @102086
     /* 102086 */     GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(102182), // Rule ID 4996 //
     /* 102091 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102094 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102098 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102102 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102106 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102110 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102115 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102117 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /* 102117 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102120 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102124 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102129 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102131 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102134 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102138 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102143 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102146 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102150 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102153 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102158 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102163 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102168 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /* 102171 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102173 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102176 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102180 */       GIR_RootConstrainSelectedInstOperands,
     /* 102181 */       // GIR_Coverage, 4996,
     /* 102181 */       GIR_EraseRootFromParent_Done,
     /* 102182 */     // Label 1570: @102182
     /* 102182 */     GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(102244), // Rule ID 5859 //
     /* 102187 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102191 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102195 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 102199 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102201 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /* 102201 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 102204 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102208 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102213 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102215 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102218 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102220 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102223 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102225 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 102228 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102233 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102238 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102243 */       // GIR_Coverage, 5859,
     /* 102243 */       GIR_EraseRootFromParent_Done,
     /* 102244 */     // Label 1571: @102244
     /* 102244 */     GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(102306), // Rule ID 5863 //
     /* 102249 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102253 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102257 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 102261 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102263 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /* 102263 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 102266 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102270 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102275 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102277 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102280 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102282 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102285 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102287 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 102290 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102295 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102300 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102305 */       // GIR_Coverage, 5863,
     /* 102305 */       GIR_EraseRootFromParent_Done,
     /* 102306 */     // Label 1572: @102306
     /* 102306 */     GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(102440), // Rule ID 5857 //
     /* 102311 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102315 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102319 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 102319 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 102322 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102326 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102331 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102333 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 102336 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102340 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102345 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 102348 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 102352 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 102355 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102360 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102365 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102370 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102373 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102377 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102382 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102384 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102387 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102391 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102396 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102399 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102403 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102406 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102411 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102416 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102421 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102424 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102426 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102429 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102432 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102435 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102438 */       GIR_RootConstrainSelectedInstOperands,
     /* 102439 */       // GIR_Coverage, 5857,
     /* 102439 */       GIR_EraseRootFromParent_Done,
     /* 102440 */     // Label 1573: @102440
     /* 102440 */     GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(102574), // Rule ID 5861 //
     /* 102445 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102449 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102453 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 102453 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 102456 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102460 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102465 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102467 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 102470 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102474 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102479 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 102482 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 102486 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 102489 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102494 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102499 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102504 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102507 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102511 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102516 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102518 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102521 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102525 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102530 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102533 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102537 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102540 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102545 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102550 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102555 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102558 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102560 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102563 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102566 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102569 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102572 */       GIR_RootConstrainSelectedInstOperands,
     /* 102573 */       // GIR_Coverage, 5861,
     /* 102573 */       GIR_EraseRootFromParent_Done,
     /* 102574 */     // Label 1574: @102574
     /* 102574 */     GIM_Reject,
     /* 102575 */   // Label 1550: @102575
     /* 102575 */   GIM_Reject,
     /* 102576 */   // Label 1509: @102576
     /* 102576 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(104486),
     /* 102581 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102591 */     GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(102720), // Rule ID 5455 //
     /* 102596 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102600 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102604 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102608 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102612 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102616 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102620 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102624 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102628 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 102632 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102636 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102640 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102645 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 102649 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 102655 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 102657 */       // MIs[2] Operand 2
     /* 102657 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 102668 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 102670 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 102670 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102673 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102677 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102682 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102685 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102689 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102692 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102697 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102702 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 102705 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102707 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102710 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102714 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102718 */       GIR_RootConstrainSelectedInstOperands,
     /* 102719 */       // GIR_Coverage, 5455,
     /* 102719 */       GIR_EraseRootFromParent_Done,
     /* 102720 */     // Label 1576: @102720
     /* 102720 */     GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(102842), // Rule ID 5451 //
     /* 102725 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102729 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102733 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102737 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102741 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102745 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102749 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102753 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102757 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 102761 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102765 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102769 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102774 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102779 */       // MIs[2] Operand 2
     /* 102779 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 102790 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102792 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 102792 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102795 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102799 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102804 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102807 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102811 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102814 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102819 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102824 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 102827 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102829 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102832 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102836 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102840 */       GIR_RootConstrainSelectedInstOperands,
     /* 102841 */       // GIR_Coverage, 5451,
     /* 102841 */       GIR_EraseRootFromParent_Done,
     /* 102842 */     // Label 1577: @102842
     /* 102842 */     GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(102964), // Rule ID 5453 //
     /* 102847 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102851 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102855 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102859 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102863 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102867 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102871 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102875 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102879 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 102883 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102887 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102891 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102896 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102901 */       // MIs[2] Operand 2
     /* 102901 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 102912 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102914 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 102914 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102917 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102921 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102926 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102929 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102933 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102936 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102941 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102946 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 102949 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102954 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102958 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102962 */       GIR_RootConstrainSelectedInstOperands,
     /* 102963 */       // GIR_Coverage, 5453,
     /* 102963 */       GIR_EraseRootFromParent_Done,
     /* 102964 */     // Label 1578: @102964
     /* 102964 */     GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(103066), // Rule ID 5611 //
     /* 102969 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102973 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102977 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102981 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102985 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102989 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102993 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102998 */       // MIs[2] Operand 2
     /* 102998 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 103009 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 103013 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103017 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103021 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 103025 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 103029 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103033 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103038 */       // MIs[4] Operand 2
     /* 103038 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /* 103049 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 103051 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 103051 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 103054 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103056 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 103060 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 103064 */       GIR_RootConstrainSelectedInstOperands,
     /* 103065 */       // GIR_Coverage, 5611,
     /* 103065 */       GIR_EraseRootFromParent_Done,
     /* 103066 */     // Label 1579: @103066
     /* 103066 */     GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(103195), // Rule ID 6395 //
     /* 103071 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103075 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103079 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103083 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103086 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 103091 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103095 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103099 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103104 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /* 103108 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103110 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 103110 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 103113 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 103117 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103122 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103125 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103127 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103130 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103134 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103139 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103141 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103144 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103148 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103153 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103156 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 103160 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103163 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103168 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103173 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103178 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 103181 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103183 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103186 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103190 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103193 */       GIR_RootConstrainSelectedInstOperands,
     /* 103194 */       // GIR_Coverage, 6395,
     /* 103194 */       GIR_EraseRootFromParent_Done,
     /* 103195 */     // Label 1580: @103195
     /* 103195 */     GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(103237), // Rule ID 5868 //
     /* 103200 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 103207 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 103214 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /* 103214 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 103217 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103219 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 103224 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103227 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103232 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103235 */       GIR_RootConstrainSelectedInstOperands,
     /* 103236 */       // GIR_Coverage, 5868,
     /* 103236 */       GIR_EraseRootFromParent_Done,
     /* 103237 */     // Label 1581: @103237
     /* 103237 */     GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(103360), // Rule ID 2574 //
     /* 103242 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103245 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103249 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103253 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103257 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103260 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 103265 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103269 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103273 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103278 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 103282 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 103286 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 103290 */       // MIs[2] Operand 1
     /* 103290 */       // No operand predicates
     /* 103290 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 103292 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 103292 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103295 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103299 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103304 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103306 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103309 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103313 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103318 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103321 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103325 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103328 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103333 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103338 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103343 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /* 103346 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103348 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103351 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103355 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 103358 */       GIR_RootConstrainSelectedInstOperands,
     /* 103359 */       // GIR_Coverage, 2574,
     /* 103359 */       GIR_EraseRootFromParent_Done,
     /* 103360 */     // Label 1582: @103360
     /* 103360 */     GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(103483), // Rule ID 6365 //
     /* 103365 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103368 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103372 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103376 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103380 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103384 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 103388 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 103392 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103396 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103401 */       // MIs[2] imm
     /* 103401 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 103405 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 103409 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 103413 */       // MIs[3] Operand 1
     /* 103413 */       // No operand predicates
     /* 103413 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 103415 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 103415 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103418 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103422 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103427 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103429 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103432 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103436 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103441 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103444 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103448 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103451 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103456 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103461 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103466 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 103469 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103471 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103474 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 103478 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 103481 */       GIR_RootConstrainSelectedInstOperands,
     /* 103482 */       // GIR_Coverage, 6365,
     /* 103482 */       GIR_EraseRootFromParent_Done,
     /* 103483 */     // Label 1583: @103483
     /* 103483 */     GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(103603), // Rule ID 6401 //
     /* 103488 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103492 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103496 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103500 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103504 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 103508 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 103512 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103516 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103521 */       // MIs[2] imm
     /* 103521 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 103525 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 103529 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 103533 */       // MIs[3] Operand 1
     /* 103533 */       // No operand predicates
     /* 103533 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 103535 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 103535 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103538 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103542 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103547 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103549 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103552 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103556 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103561 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103564 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103568 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103571 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103576 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103581 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103586 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 103589 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103591 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103594 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 103598 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 103601 */       GIR_RootConstrainSelectedInstOperands,
     /* 103602 */       // GIR_Coverage, 6401,
     /* 103602 */       GIR_EraseRootFromParent_Done,
     /* 103603 */     // Label 1584: @103603
     /* 103603 */     GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(103720), // Rule ID 2499 //
     /* 103608 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103611 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103615 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103619 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103623 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103626 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 103631 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103635 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103639 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103644 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103649 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103651 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 103651 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103654 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103658 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103663 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103665 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103668 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103672 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103677 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103680 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103684 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103687 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103692 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103697 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103702 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 103705 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103707 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103710 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103714 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103718 */       GIR_RootConstrainSelectedInstOperands,
     /* 103719 */       // GIR_Coverage, 2499,
     /* 103719 */       GIR_EraseRootFromParent_Done,
     /* 103720 */     // Label 1585: @103720
     /* 103720 */     GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(103837), // Rule ID 5381 //
     /* 103725 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103728 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103732 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103736 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103740 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103743 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 103748 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103752 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103756 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103761 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103766 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103768 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 103768 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103771 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103775 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103780 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103782 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103785 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103789 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103794 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103797 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103801 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103804 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103809 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103814 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103819 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 103822 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103824 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103827 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103831 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103835 */       GIR_RootConstrainSelectedInstOperands,
     /* 103836 */       // GIR_Coverage, 5381,
     /* 103836 */       GIR_EraseRootFromParent_Done,
     /* 103837 */     // Label 1586: @103837
     /* 103837 */     GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(103954), // Rule ID 5384 //
     /* 103842 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103845 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103849 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103853 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103857 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103860 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 103865 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103869 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103873 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103878 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103883 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103885 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 103885 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103888 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103892 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103897 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103899 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103902 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103906 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103911 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103914 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103918 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103921 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103926 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103931 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103936 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 103939 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103941 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103944 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103948 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103952 */       GIR_RootConstrainSelectedInstOperands,
     /* 103953 */       // GIR_Coverage, 5384,
     /* 103953 */       GIR_EraseRootFromParent_Done,
     /* 103954 */     // Label 1587: @103954
     /* 103954 */     GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(104071), // Rule ID 5387 //
     /* 103959 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103962 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103966 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103970 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103974 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103977 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 103982 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103986 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103990 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103995 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104000 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104002 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 104002 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104005 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104009 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104014 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104016 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104019 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104023 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104028 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104031 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104035 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104038 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104043 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104048 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104053 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /* 104056 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104058 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104061 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 104065 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 104069 */       GIR_RootConstrainSelectedInstOperands,
     /* 104070 */       // GIR_Coverage, 5387,
     /* 104070 */       GIR_EraseRootFromParent_Done,
     /* 104071 */     // Label 1588: @104071
     /* 104071 */     GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(104127), // Rule ID 5528 //
     /* 104076 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104080 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104084 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104088 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104093 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 104097 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104101 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104105 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104110 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 104112 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 104112 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 104115 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104117 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 104121 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 104125 */       GIR_RootConstrainSelectedInstOperands,
     /* 104126 */       // GIR_Coverage, 5528,
     /* 104126 */       GIR_EraseRootFromParent_Done,
     /* 104127 */     // Label 1589: @104127
     /* 104127 */     GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(104193), // Rule ID 5866 //
     /* 104132 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104136 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104140 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 104146 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 104148 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104150 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /* 104150 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104153 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 104157 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104162 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 104166 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104168 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104171 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104173 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104176 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104179 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 104182 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104187 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104192 */       // GIR_Coverage, 5866,
     /* 104192 */       GIR_EraseRootFromParent_Done,
     /* 104193 */     // Label 1590: @104193
     /* 104193 */     GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(104289), // Rule ID 4995 //
     /* 104198 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104201 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104205 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104209 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104213 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104217 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104222 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104224 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /* 104224 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104227 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104231 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104236 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104238 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104241 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104245 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104250 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104253 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104257 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104260 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104265 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104270 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104275 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /* 104278 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104280 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104283 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 104287 */       GIR_RootConstrainSelectedInstOperands,
     /* 104288 */       // GIR_Coverage, 4995,
     /* 104288 */       GIR_EraseRootFromParent_Done,
     /* 104289 */     // Label 1591: @104289
     /* 104289 */     GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(104351), // Rule ID 5867 //
     /* 104294 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104298 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104302 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 104306 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104308 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /* 104308 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 104311 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104315 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104320 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104322 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104325 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104327 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104330 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 104332 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 104335 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104340 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104345 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104350 */       // GIR_Coverage, 5867,
     /* 104350 */       GIR_EraseRootFromParent_Done,
     /* 104351 */     // Label 1592: @104351
     /* 104351 */     GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(104485), // Rule ID 5865 //
     /* 104356 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104360 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104364 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 104364 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 104367 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104371 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104376 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104378 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 104381 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104385 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104390 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 104393 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 104397 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 104400 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104405 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104410 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104415 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104418 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104422 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104427 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104429 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104432 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104436 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104441 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104444 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104448 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104451 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104456 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104461 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104466 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 104469 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104471 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104474 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104477 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104480 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104483 */       GIR_RootConstrainSelectedInstOperands,
     /* 104484 */       // GIR_Coverage, 5865,
     /* 104484 */       GIR_EraseRootFromParent_Done,
     /* 104485 */     // Label 1593: @104485
     /* 104485 */     GIM_Reject,
     /* 104486 */   // Label 1575: @104486
     /* 104486 */   GIM_Reject,
     /* 104487 */   // Label 1510: @104487
     /* 104487 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(104512), // Rule ID 9141 //
     /* 104492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104495 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 104498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 104501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104505 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /* 104505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 104510 */     GIR_RootConstrainSelectedInstOperands,
     /* 104511 */     // GIR_Coverage, 9141,
     /* 104511 */     GIR_Done,
     /* 104512 */   // Label 1594: @104512
     /* 104512 */   GIM_Reject,
     /* 104513 */   // Label 1511: @104513
     /* 104513 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(104538), // Rule ID 9142 //
     /* 104518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104521 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 104524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 104527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104531 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /* 104531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 104536 */     GIR_RootConstrainSelectedInstOperands,
     /* 104537 */     // GIR_Coverage, 9142,
     /* 104537 */     GIR_Done,
     /* 104538 */   // Label 1595: @104538
     /* 104538 */   GIM_Reject,
     /* 104539 */   // Label 1512: @104539
     /* 104539 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(104564), // Rule ID 9145 //
     /* 104544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104547 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 104550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 104553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 104557 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /* 104557 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 104562 */     GIR_RootConstrainSelectedInstOperands,
     /* 104563 */     // GIR_Coverage, 9145,
     /* 104563 */     GIR_Done,
     /* 104564 */   // Label 1596: @104564
     /* 104564 */   GIM_Reject,
     /* 104565 */   // Label 1513: @104565
     /* 104565 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(104590), // Rule ID 9147 //
     /* 104570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104573 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 104576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 104579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 104583 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /* 104583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 104588 */     GIR_RootConstrainSelectedInstOperands,
     /* 104589 */     // GIR_Coverage, 9147,
     /* 104589 */     GIR_Done,
     /* 104590 */   // Label 1597: @104590
     /* 104590 */   GIM_Reject,
     /* 104591 */   // Label 1514: @104591
     /* 104591 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(104616), // Rule ID 9143 //
     /* 104596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104599 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 104602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 104605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104609 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /* 104609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 104614 */     GIR_RootConstrainSelectedInstOperands,
     /* 104615 */     // GIR_Coverage, 9143,
     /* 104615 */     GIR_Done,
     /* 104616 */   // Label 1598: @104616
     /* 104616 */   GIM_Reject,
     /* 104617 */   // Label 1515: @104617
     /* 104617 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(104642), // Rule ID 9146 //
     /* 104622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104625 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 104628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 104631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 104635 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /* 104635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 104640 */     GIR_RootConstrainSelectedInstOperands,
     /* 104641 */     // GIR_Coverage, 9146,
     /* 104641 */     GIR_Done,
     /* 104642 */   // Label 1599: @104642
     /* 104642 */   GIM_Reject,
     /* 104643 */   // Label 1516: @104643
     /* 104643 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(104668), // Rule ID 9144 //
     /* 104648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104651 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 104654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 104657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104661 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /* 104661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 104666 */     GIR_RootConstrainSelectedInstOperands,
     /* 104667 */     // GIR_Coverage, 9144,
     /* 104667 */     GIR_Done,
     /* 104668 */   // Label 1600: @104668
     /* 104668 */   GIM_Reject,
     /* 104669 */   // Label 1517: @104669
     /* 104669 */   GIM_Reject,
     /* 104670 */ // Label 1505: @104670
     /* 104670 */ GIM_Reject,
     /* 104671 */ // Label 9: @104671
     /* 104671 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1615*/ GIMT_Encode4(114752),
     /* 104682 */ /*GILLT_s32*//*Label 1601*/ GIMT_Encode4(104770),
     /* 104686 */ /*GILLT_s64*//*Label 1602*/ GIMT_Encode4(105273),
     /* 104690 */ /*GILLT_s128*//*Label 1603*/ GIMT_Encode4(107264),
     /* 104694 */ /*GILLT_v2s32*//*Label 1604*/ GIMT_Encode4(107910),
     /* 104698 */ /*GILLT_v2s64*//*Label 1605*/ GIMT_Encode4(108825),
     /* 104702 */ /*GILLT_v4s16*//*Label 1606*/ GIMT_Encode4(109594),
     /* 104706 */ /*GILLT_v4s32*//*Label 1607*/ GIMT_Encode4(110509),
     /* 104710 */ /*GILLT_v8s8*//*Label 1608*/ GIMT_Encode4(111354),
     /* 104714 */ /*GILLT_v8s16*//*Label 1609*/ GIMT_Encode4(111915),
     /* 104718 */ /*GILLT_v16s8*//*Label 1610*/ GIMT_Encode4(112760), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104738 */ /*GILLT_nxv2s64*//*Label 1611*/ GIMT_Encode4(113212), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104750 */ /*GILLT_nxv4s32*//*Label 1612*/ GIMT_Encode4(113661), GIMT_Encode4(0),
     /* 104758 */ /*GILLT_nxv8s16*//*Label 1613*/ GIMT_Encode4(114110), GIMT_Encode4(0),
     /* 104766 */ /*GILLT_nxv16s8*//*Label 1614*/ GIMT_Encode4(114559),
     /* 104770 */ // Label 1601: @104770
     /* 104770 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(105272),
     /* 104775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104778 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(104852), // Rule ID 7118 //
     /* 104783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 104787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 104795 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 104802 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104809 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104812 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 104816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 104825 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15781>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 104825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 104828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 104850 */     GIR_RootConstrainSelectedInstOperands,
     /* 104851 */     // GIR_Coverage, 7118,
     /* 104851 */     GIR_EraseRootFromParent_Done,
     /* 104852 */   // Label 1617: @104852
     /* 104852 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(104926), // Rule ID 7119 //
     /* 104857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 104861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 104869 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 104876 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104883 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104886 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 104890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 104899 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15781>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 104899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 104902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 104924 */     GIR_RootConstrainSelectedInstOperands,
     /* 104925 */     // GIR_Coverage, 7119,
     /* 104925 */     GIR_EraseRootFromParent_Done,
     /* 104926 */   // Label 1618: @104926
     /* 104926 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(104995), // Rule ID 7120 //
     /* 104931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 104935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 104943 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104946 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 104950 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104957 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104960 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 104964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 104973 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15781>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 104973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 104976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 104993 */     GIR_RootConstrainSelectedInstOperands,
     /* 104994 */     // GIR_Coverage, 7120,
     /* 104994 */     GIR_EraseRootFromParent_Done,
     /* 104995 */   // Label 1619: @104995
     /* 104995 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(105064), // Rule ID 7121 //
     /* 105000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105012 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105015 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105019 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 105026 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105029 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 105042 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15781>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 105045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105062 */     GIR_RootConstrainSelectedInstOperands,
     /* 105063 */     // GIR_Coverage, 7121,
     /* 105063 */     GIR_EraseRootFromParent_Done,
     /* 105064 */   // Label 1620: @105064
     /* 105064 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(105117), // Rule ID 5827 //
     /* 105069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 105073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 105081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 105085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105089 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 105093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105095 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v16i8:{ *:[v16i8] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v16i8] }:$src, bsub:{ *:[i32] })
     /* 105095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105100 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 105106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 105111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105116 */     // GIR_Coverage, 5827,
     /* 105116 */     GIR_EraseRootFromParent_Done,
     /* 105117 */   // Label 1621: @105117
     /* 105117 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(105170), // Rule ID 5828 //
     /* 105122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 105126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 105134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105142 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 105146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105148 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v8i16:{ *:[v8i16] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v8i16] }:$src, hsub:{ *:[i32] })
     /* 105148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105153 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // src
     /* 105159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 105164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105169 */     // GIR_Coverage, 5828,
     /* 105169 */     GIR_EraseRootFromParent_Done,
     /* 105170 */   // Label 1622: @105170
     /* 105170 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(105223), // Rule ID 5829 //
     /* 105175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 105187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105195 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 105199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105201 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /* 105201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105206 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /* 105212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105222 */     // GIR_Coverage, 5829,
     /* 105222 */     GIR_EraseRootFromParent_Done,
     /* 105223 */   // Label 1623: @105223
     /* 105223 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(105247), // Rule ID 6729 //
     /* 105228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105236 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /* 105236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105246 */     // GIR_Coverage, 6729,
     /* 105246 */     GIR_Done,
     /* 105247 */   // Label 1624: @105247
     /* 105247 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(105271), // Rule ID 6730 //
     /* 105252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105260 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /* 105260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105270 */     // GIR_Coverage, 6730,
     /* 105270 */     GIR_Done,
     /* 105271 */   // Label 1625: @105271
     /* 105271 */   GIM_Reject,
     /* 105272 */ // Label 1616: @105272
     /* 105272 */ GIM_Reject,
     /* 105273 */ // Label 1602: @105273
     /* 105273 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(105350), // Rule ID 7122 //
     /* 105278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105293 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105296 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105300 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105307 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105310 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105316 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105323 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15789>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105343 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105348 */   GIR_RootConstrainSelectedInstOperands,
     /* 105349 */   // GIR_Coverage, 7122,
     /* 105349 */   GIR_EraseRootFromParent_Done,
     /* 105350 */ // Label 1626: @105350
     /* 105350 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(105427), // Rule ID 7123 //
     /* 105355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105362 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105370 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105373 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105377 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105384 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105387 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105393 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105400 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15789>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105420 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105425 */   GIR_RootConstrainSelectedInstOperands,
     /* 105426 */   // GIR_Coverage, 7123,
     /* 105426 */   GIR_EraseRootFromParent_Done,
     /* 105427 */ // Label 1627: @105427
     /* 105427 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(105499), // Rule ID 7124 //
     /* 105432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105439 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105443 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105447 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105450 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105454 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105461 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105464 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105468 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105470 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105477 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15789>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105497 */   GIR_RootConstrainSelectedInstOperands,
     /* 105498 */   // GIR_Coverage, 7124,
     /* 105498 */   GIR_EraseRootFromParent_Done,
     /* 105499 */ // Label 1628: @105499
     /* 105499 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(105571), // Rule ID 7125 //
     /* 105504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105511 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105515 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105519 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105522 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105526 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105533 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105536 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105540 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105542 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105549 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15789>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105564 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105569 */   GIR_RootConstrainSelectedInstOperands,
     /* 105570 */   // GIR_Coverage, 7125,
     /* 105570 */   GIR_EraseRootFromParent_Done,
     /* 105571 */ // Label 1629: @105571
     /* 105571 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(105627), // Rule ID 5830 //
     /* 105576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105583 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105587 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 105591 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 105595 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105599 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 105603 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105605 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /* 105605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105610 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 105616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105621 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105626 */   // GIR_Coverage, 5830,
     /* 105626 */   GIR_EraseRootFromParent_Done,
     /* 105627 */ // Label 1630: @105627
     /* 105627 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(105657), // Rule ID 6704 //
     /* 105632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105646 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /* 105646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105651 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105656 */   // GIR_Coverage, 6704,
     /* 105656 */   GIR_Done,
     /* 105657 */ // Label 1631: @105657
     /* 105657 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(105687), // Rule ID 6705 //
     /* 105662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105676 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /* 105676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105686 */   // GIR_Coverage, 6705,
     /* 105686 */   GIR_Done,
     /* 105687 */ // Label 1632: @105687
     /* 105687 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(105717), // Rule ID 6706 //
     /* 105692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105706 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /* 105706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105716 */   // GIR_Coverage, 6706,
     /* 105716 */   GIR_Done,
     /* 105717 */ // Label 1633: @105717
     /* 105717 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(105747), // Rule ID 6707 //
     /* 105722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105736 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /* 105736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105746 */   // GIR_Coverage, 6707,
     /* 105746 */   GIR_Done,
     /* 105747 */ // Label 1634: @105747
     /* 105747 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(105777), // Rule ID 6708 //
     /* 105752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105766 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /* 105766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105776 */   // GIR_Coverage, 6708,
     /* 105776 */   GIR_Done,
     /* 105777 */ // Label 1635: @105777
     /* 105777 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(105807), // Rule ID 6709 //
     /* 105782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105796 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 105796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105801 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105806 */   // GIR_Coverage, 6709,
     /* 105806 */   GIR_Done,
     /* 105807 */ // Label 1636: @105807
     /* 105807 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(105857), // Rule ID 6715 //
     /* 105812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105826 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /* 105826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105838 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105842 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 105850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105855 */   GIR_RootConstrainSelectedInstOperands,
     /* 105856 */   // GIR_Coverage, 6715,
     /* 105856 */   GIR_EraseRootFromParent_Done,
     /* 105857 */ // Label 1637: @105857
     /* 105857 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(105907), // Rule ID 6716 //
     /* 105862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105876 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /* 105876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105888 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105892 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 105900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105905 */   GIR_RootConstrainSelectedInstOperands,
     /* 105906 */   // GIR_Coverage, 6716,
     /* 105906 */   GIR_EraseRootFromParent_Done,
     /* 105907 */ // Label 1638: @105907
     /* 105907 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(105957), // Rule ID 6717 //
     /* 105912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105926 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /* 105926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105938 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105942 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 105950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105955 */   GIR_RootConstrainSelectedInstOperands,
     /* 105956 */   // GIR_Coverage, 6717,
     /* 105956 */   GIR_EraseRootFromParent_Done,
     /* 105957 */ // Label 1639: @105957
     /* 105957 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(106007), // Rule ID 6718 //
     /* 105962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105976 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /* 105976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105988 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105992 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 106002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106005 */   GIR_RootConstrainSelectedInstOperands,
     /* 106006 */   // GIR_Coverage, 6718,
     /* 106006 */   GIR_EraseRootFromParent_Done,
     /* 106007 */ // Label 1640: @106007
     /* 106007 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(106057), // Rule ID 6719 //
     /* 106012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106026 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /* 106026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106038 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 106042 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 106052 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106055 */   GIR_RootConstrainSelectedInstOperands,
     /* 106056 */   // GIR_Coverage, 6719,
     /* 106056 */   GIR_EraseRootFromParent_Done,
     /* 106057 */ // Label 1641: @106057
     /* 106057 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(106084), // Rule ID 6720 //
     /* 106062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106073 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 106073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106078 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106083 */   // GIR_Coverage, 6720,
     /* 106083 */   GIR_Done,
     /* 106084 */ // Label 1642: @106084
     /* 106084 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(106111), // Rule ID 6721 //
     /* 106089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106100 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 106100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106110 */   // GIR_Coverage, 6721,
     /* 106110 */   GIR_Done,
     /* 106111 */ // Label 1643: @106111
     /* 106111 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(106138), // Rule ID 6722 //
     /* 106116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106127 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /* 106127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106132 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106137 */   // GIR_Coverage, 6722,
     /* 106137 */   GIR_Done,
     /* 106138 */ // Label 1644: @106138
     /* 106138 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(106165), // Rule ID 6731 //
     /* 106143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106154 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 106154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106159 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106164 */   // GIR_Coverage, 6731,
     /* 106164 */   GIR_Done,
     /* 106165 */ // Label 1645: @106165
     /* 106165 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(106192), // Rule ID 6732 //
     /* 106170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106181 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /* 106181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106191 */   // GIR_Coverage, 6732,
     /* 106191 */   GIR_Done,
     /* 106192 */ // Label 1646: @106192
     /* 106192 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(106219), // Rule ID 6733 //
     /* 106197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106208 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 106208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106213 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106218 */   // GIR_Coverage, 6733,
     /* 106218 */   GIR_Done,
     /* 106219 */ // Label 1647: @106219
     /* 106219 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(106251), // Rule ID 6734 //
     /* 106224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106238 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106241 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106243 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106250 */   // GIR_Coverage, 6734,
     /* 106250 */   GIR_EraseRootFromParent_Done,
     /* 106251 */ // Label 1648: @106251
     /* 106251 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(106283), // Rule ID 6735 //
     /* 106256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106270 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106273 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106275 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106277 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106282 */   // GIR_Coverage, 6735,
     /* 106282 */   GIR_EraseRootFromParent_Done,
     /* 106283 */ // Label 1649: @106283
     /* 106283 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(106315), // Rule ID 6736 //
     /* 106288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106302 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106305 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106307 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106309 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106314 */   // GIR_Coverage, 6736,
     /* 106314 */   GIR_EraseRootFromParent_Done,
     /* 106315 */ // Label 1650: @106315
     /* 106315 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(106347), // Rule ID 6737 //
     /* 106320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106334 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106337 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106339 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106341 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106346 */   // GIR_Coverage, 6737,
     /* 106346 */   GIR_EraseRootFromParent_Done,
     /* 106347 */ // Label 1651: @106347
     /* 106347 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(106379), // Rule ID 6738 //
     /* 106352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106366 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106369 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106371 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106373 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106378 */   // GIR_Coverage, 6738,
     /* 106378 */   GIR_EraseRootFromParent_Done,
     /* 106379 */ // Label 1652: @106379
     /* 106379 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(106405), // Rule ID 6739 //
     /* 106384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106398 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /* 106398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106403 */   GIR_RootConstrainSelectedInstOperands,
     /* 106404 */   // GIR_Coverage, 6739,
     /* 106404 */   GIR_Done,
     /* 106405 */ // Label 1653: @106405
     /* 106405 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(106431), // Rule ID 6740 //
     /* 106410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106424 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /* 106424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106429 */   GIR_RootConstrainSelectedInstOperands,
     /* 106430 */   // GIR_Coverage, 6740,
     /* 106430 */   GIR_Done,
     /* 106431 */ // Label 1654: @106431
     /* 106431 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(106457), // Rule ID 6741 //
     /* 106436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106450 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /* 106450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 106455 */   GIR_RootConstrainSelectedInstOperands,
     /* 106456 */   // GIR_Coverage, 6741,
     /* 106456 */   GIR_Done,
     /* 106457 */ // Label 1655: @106457
     /* 106457 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(106483), // Rule ID 6742 //
     /* 106462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106476 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /* 106476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106481 */   GIR_RootConstrainSelectedInstOperands,
     /* 106482 */   // GIR_Coverage, 6742,
     /* 106482 */   GIR_Done,
     /* 106483 */ // Label 1656: @106483
     /* 106483 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(106509), // Rule ID 6743 //
     /* 106488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106502 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /* 106502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106507 */   GIR_RootConstrainSelectedInstOperands,
     /* 106508 */   // GIR_Coverage, 6743,
     /* 106508 */   GIR_Done,
     /* 106509 */ // Label 1657: @106509
     /* 106509 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(106538), // Rule ID 6744 //
     /* 106514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106525 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106528 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106530 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106532 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106537 */   // GIR_Coverage, 6744,
     /* 106537 */   GIR_EraseRootFromParent_Done,
     /* 106538 */ // Label 1658: @106538
     /* 106538 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(106567), // Rule ID 6745 //
     /* 106543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106554 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106557 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106559 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106561 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106566 */   // GIR_Coverage, 6745,
     /* 106566 */   GIR_EraseRootFromParent_Done,
     /* 106567 */ // Label 1659: @106567
     /* 106567 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(106599), // Rule ID 6799 //
     /* 106572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106586 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106589 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106591 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106593 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106598 */   // GIR_Coverage, 6799,
     /* 106598 */   GIR_EraseRootFromParent_Done,
     /* 106599 */ // Label 1660: @106599
     /* 106599 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(106631), // Rule ID 6800 //
     /* 106604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106618 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106621 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106623 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106625 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106630 */   // GIR_Coverage, 6800,
     /* 106630 */   GIR_EraseRootFromParent_Done,
     /* 106631 */ // Label 1661: @106631
     /* 106631 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(106663), // Rule ID 6801 //
     /* 106636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106650 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106653 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106655 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106657 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106662 */   // GIR_Coverage, 6801,
     /* 106662 */   GIR_EraseRootFromParent_Done,
     /* 106663 */ // Label 1662: @106663
     /* 106663 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(106695), // Rule ID 6802 //
     /* 106668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106682 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106685 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106687 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106689 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106694 */   // GIR_Coverage, 6802,
     /* 106694 */   GIR_EraseRootFromParent_Done,
     /* 106695 */ // Label 1663: @106695
     /* 106695 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(106727), // Rule ID 6803 //
     /* 106700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106714 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106717 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106719 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106721 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106726 */   // GIR_Coverage, 6803,
     /* 106726 */   GIR_EraseRootFromParent_Done,
     /* 106727 */ // Label 1664: @106727
     /* 106727 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(106753), // Rule ID 6804 //
     /* 106732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106746 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /* 106746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106751 */   GIR_RootConstrainSelectedInstOperands,
     /* 106752 */   // GIR_Coverage, 6804,
     /* 106752 */   GIR_Done,
     /* 106753 */ // Label 1665: @106753
     /* 106753 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(106779), // Rule ID 6805 //
     /* 106758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106772 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /* 106772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106777 */   GIR_RootConstrainSelectedInstOperands,
     /* 106778 */   // GIR_Coverage, 6805,
     /* 106778 */   GIR_Done,
     /* 106779 */ // Label 1666: @106779
     /* 106779 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(106805), // Rule ID 6806 //
     /* 106784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106798 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /* 106798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106803 */   GIR_RootConstrainSelectedInstOperands,
     /* 106804 */   // GIR_Coverage, 6806,
     /* 106804 */   GIR_Done,
     /* 106805 */ // Label 1667: @106805
     /* 106805 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(106831), // Rule ID 6807 //
     /* 106810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106824 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /* 106824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 106829 */   GIR_RootConstrainSelectedInstOperands,
     /* 106830 */   // GIR_Coverage, 6807,
     /* 106830 */   GIR_Done,
     /* 106831 */ // Label 1668: @106831
     /* 106831 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(106857), // Rule ID 6808 //
     /* 106836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106850 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /* 106850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106855 */   GIR_RootConstrainSelectedInstOperands,
     /* 106856 */   // GIR_Coverage, 6808,
     /* 106856 */   GIR_Done,
     /* 106857 */ // Label 1669: @106857
     /* 106857 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(106886), // Rule ID 6809 //
     /* 106862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106873 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106876 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106878 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106885 */   // GIR_Coverage, 6809,
     /* 106885 */   GIR_EraseRootFromParent_Done,
     /* 106886 */ // Label 1670: @106886
     /* 106886 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(106915), // Rule ID 6810 //
     /* 106891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106902 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106914 */   // GIR_Coverage, 6810,
     /* 106914 */   GIR_EraseRootFromParent_Done,
     /* 106915 */ // Label 1671: @106915
     /* 106915 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(106947), // Rule ID 6811 //
     /* 106920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106934 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 106934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106946 */   // GIR_Coverage, 6811,
     /* 106946 */   GIR_EraseRootFromParent_Done,
     /* 106947 */ // Label 1672: @106947
     /* 106947 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(106979), // Rule ID 6812 //
     /* 106952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106966 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 106966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106978 */   // GIR_Coverage, 6812,
     /* 106978 */   GIR_EraseRootFromParent_Done,
     /* 106979 */ // Label 1673: @106979
     /* 106979 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(107011), // Rule ID 6813 //
     /* 106984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106998 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 106998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107010 */   // GIR_Coverage, 6813,
     /* 107010 */   GIR_EraseRootFromParent_Done,
     /* 107011 */ // Label 1674: @107011
     /* 107011 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(107043), // Rule ID 6814 //
     /* 107016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107030 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 107030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107042 */   // GIR_Coverage, 6814,
     /* 107042 */   GIR_EraseRootFromParent_Done,
     /* 107043 */ // Label 1675: @107043
     /* 107043 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(107075), // Rule ID 6815 //
     /* 107048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107062 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 107062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107074 */   // GIR_Coverage, 6815,
     /* 107074 */   GIR_EraseRootFromParent_Done,
     /* 107075 */ // Label 1676: @107075
     /* 107075 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(107101), // Rule ID 6816 //
     /* 107080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107094 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /* 107094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107099 */   GIR_RootConstrainSelectedInstOperands,
     /* 107100 */   // GIR_Coverage, 6816,
     /* 107100 */   GIR_Done,
     /* 107101 */ // Label 1677: @107101
     /* 107101 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(107127), // Rule ID 6817 //
     /* 107106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107120 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /* 107120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107125 */   GIR_RootConstrainSelectedInstOperands,
     /* 107126 */   // GIR_Coverage, 6817,
     /* 107126 */   GIR_Done,
     /* 107127 */ // Label 1678: @107127
     /* 107127 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(107153), // Rule ID 6818 //
     /* 107132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107146 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /* 107146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 107151 */   GIR_RootConstrainSelectedInstOperands,
     /* 107152 */   // GIR_Coverage, 6818,
     /* 107152 */   GIR_Done,
     /* 107153 */ // Label 1679: @107153
     /* 107153 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(107179), // Rule ID 6819 //
     /* 107158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107172 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /* 107172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107177 */   GIR_RootConstrainSelectedInstOperands,
     /* 107178 */   // GIR_Coverage, 6819,
     /* 107178 */   GIR_Done,
     /* 107179 */ // Label 1680: @107179
     /* 107179 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(107205), // Rule ID 6820 //
     /* 107184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107198 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /* 107198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107203 */   GIR_RootConstrainSelectedInstOperands,
     /* 107204 */   // GIR_Coverage, 6820,
     /* 107204 */   GIR_Done,
     /* 107205 */ // Label 1681: @107205
     /* 107205 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(107234), // Rule ID 6821 //
     /* 107210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107221 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 107221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107224 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107226 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107233 */   // GIR_Coverage, 6821,
     /* 107233 */   GIR_EraseRootFromParent_Done,
     /* 107234 */ // Label 1682: @107234
     /* 107234 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(107263), // Rule ID 6822 //
     /* 107239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107250 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 107250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107253 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107255 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107262 */   // GIR_Coverage, 6822,
     /* 107262 */   GIR_EraseRootFromParent_Done,
     /* 107263 */ // Label 1683: @107263
     /* 107263 */ GIM_Reject,
     /* 107264 */ // Label 1603: @107264
     /* 107264 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(107296), // Rule ID 6836 //
     /* 107269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107283 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107286 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107288 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107290 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107295 */   // GIR_Coverage, 6836,
     /* 107295 */   GIR_EraseRootFromParent_Done,
     /* 107296 */ // Label 1684: @107296
     /* 107296 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(107328), // Rule ID 6837 //
     /* 107301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107315 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107318 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107320 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107327 */   // GIR_Coverage, 6837,
     /* 107327 */   GIR_EraseRootFromParent_Done,
     /* 107328 */ // Label 1685: @107328
     /* 107328 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(107360), // Rule ID 6838 //
     /* 107333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107347 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107350 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107352 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107354 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107359 */   // GIR_Coverage, 6838,
     /* 107359 */   GIR_EraseRootFromParent_Done,
     /* 107360 */ // Label 1686: @107360
     /* 107360 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(107392), // Rule ID 6839 //
     /* 107365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107379 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107382 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107384 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107386 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107391 */   // GIR_Coverage, 6839,
     /* 107391 */   GIR_EraseRootFromParent_Done,
     /* 107392 */ // Label 1687: @107392
     /* 107392 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(107424), // Rule ID 6840 //
     /* 107397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107411 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107414 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107416 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107418 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107423 */   // GIR_Coverage, 6840,
     /* 107423 */   GIR_EraseRootFromParent_Done,
     /* 107424 */ // Label 1688: @107424
     /* 107424 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(107456), // Rule ID 6841 //
     /* 107429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107443 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107446 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107448 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107450 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107455 */   // GIR_Coverage, 6841,
     /* 107455 */   GIR_EraseRootFromParent_Done,
     /* 107456 */ // Label 1689: @107456
     /* 107456 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(107488), // Rule ID 6842 //
     /* 107461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 107467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107475 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107478 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107480 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107482 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107487 */   // GIR_Coverage, 6842,
     /* 107487 */   GIR_EraseRootFromParent_Done,
     /* 107488 */ // Label 1690: @107488
     /* 107488 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(107521), // Rule ID 6843 //
     /* 107493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107507 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /* 107507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107519 */   GIR_RootConstrainSelectedInstOperands,
     /* 107520 */   // GIR_Coverage, 6843,
     /* 107520 */   GIR_EraseRootFromParent_Done,
     /* 107521 */ // Label 1691: @107521
     /* 107521 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(107592), // Rule ID 6844 //
     /* 107526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107540 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /* 107540 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107543 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107547 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107552 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107570 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107584 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107590 */   GIR_RootConstrainSelectedInstOperands,
     /* 107591 */   // GIR_Coverage, 6844,
     /* 107591 */   GIR_EraseRootFromParent_Done,
     /* 107592 */ // Label 1692: @107592
     /* 107592 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(107663), // Rule ID 6845 //
     /* 107597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107611 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /* 107611 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107614 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107618 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107623 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107641 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107655 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107661 */   GIR_RootConstrainSelectedInstOperands,
     /* 107662 */   // GIR_Coverage, 6845,
     /* 107662 */   GIR_EraseRootFromParent_Done,
     /* 107663 */ // Label 1693: @107663
     /* 107663 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(107734), // Rule ID 6846 //
     /* 107668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107682 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /* 107682 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107685 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107689 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107694 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107712 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107723 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107726 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107732 */   GIR_RootConstrainSelectedInstOperands,
     /* 107733 */   // GIR_Coverage, 6846,
     /* 107733 */   GIR_EraseRootFromParent_Done,
     /* 107734 */ // Label 1694: @107734
     /* 107734 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(107767), // Rule ID 6847 //
     /* 107739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107753 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /* 107753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107760 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107765 */   GIR_RootConstrainSelectedInstOperands,
     /* 107766 */   // GIR_Coverage, 6847,
     /* 107766 */   GIR_EraseRootFromParent_Done,
     /* 107767 */ // Label 1695: @107767
     /* 107767 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(107838), // Rule ID 6848 //
     /* 107772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107786 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /* 107786 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107789 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107793 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107798 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107816 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107836 */   GIR_RootConstrainSelectedInstOperands,
     /* 107837 */   // GIR_Coverage, 6848,
     /* 107837 */   GIR_EraseRootFromParent_Done,
     /* 107838 */ // Label 1696: @107838
     /* 107838 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(107909), // Rule ID 6849 //
     /* 107843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 107849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107857 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /* 107857 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107860 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 107864 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107869 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107875 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107878 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 107882 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107887 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107907 */   GIR_RootConstrainSelectedInstOperands,
     /* 107908 */   // GIR_Coverage, 6849,
     /* 107908 */   GIR_EraseRootFromParent_Done,
     /* 107909 */ // Label 1697: @107909
     /* 107909 */ GIM_Reject,
     /* 107910 */ // Label 1604: @107910
     /* 107910 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(107940), // Rule ID 6701 //
     /* 107915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107929 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107934 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107939 */   // GIR_Coverage, 6701,
     /* 107939 */   GIR_Done,
     /* 107940 */ // Label 1698: @107940
     /* 107940 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(107970), // Rule ID 6703 //
     /* 107945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107959 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107964 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107969 */   // GIR_Coverage, 6703,
     /* 107969 */   GIR_Done,
     /* 107970 */ // Label 1699: @107970
     /* 107970 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(108020), // Rule ID 6712 //
     /* 107975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107989 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 107989 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107992 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107996 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108001 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 108005 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 108015 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108018 */   GIR_RootConstrainSelectedInstOperands,
     /* 108019 */   // GIR_Coverage, 6712,
     /* 108019 */   GIR_EraseRootFromParent_Done,
     /* 108020 */ // Label 1700: @108020
     /* 108020 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(108070), // Rule ID 6714 //
     /* 108025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108039 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 108039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 108042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108051 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 108055 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 108065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108068 */   GIR_RootConstrainSelectedInstOperands,
     /* 108069 */   // GIR_Coverage, 6714,
     /* 108069 */   GIR_EraseRootFromParent_Done,
     /* 108070 */ // Label 1701: @108070
     /* 108070 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(108102), // Rule ID 6746 //
     /* 108075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108089 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108101 */   // GIR_Coverage, 6746,
     /* 108101 */   GIR_EraseRootFromParent_Done,
     /* 108102 */ // Label 1702: @108102
     /* 108102 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(108134), // Rule ID 6747 //
     /* 108107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108121 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108133 */   // GIR_Coverage, 6747,
     /* 108133 */   GIR_EraseRootFromParent_Done,
     /* 108134 */ // Label 1703: @108134
     /* 108134 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(108166), // Rule ID 6748 //
     /* 108139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108153 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108165 */   // GIR_Coverage, 6748,
     /* 108165 */   GIR_EraseRootFromParent_Done,
     /* 108166 */ // Label 1704: @108166
     /* 108166 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(108198), // Rule ID 6749 //
     /* 108171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108185 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108188 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108197 */   // GIR_Coverage, 6749,
     /* 108197 */   GIR_EraseRootFromParent_Done,
     /* 108198 */ // Label 1705: @108198
     /* 108198 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(108230), // Rule ID 6750 //
     /* 108203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108217 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108220 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108222 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108229 */   // GIR_Coverage, 6750,
     /* 108229 */   GIR_EraseRootFromParent_Done,
     /* 108230 */ // Label 1706: @108230
     /* 108230 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(108262), // Rule ID 6751 //
     /* 108235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108249 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108252 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108254 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108261 */   // GIR_Coverage, 6751,
     /* 108261 */   GIR_EraseRootFromParent_Done,
     /* 108262 */ // Label 1707: @108262
     /* 108262 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(108288), // Rule ID 6752 //
     /* 108267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108281 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /* 108281 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108286 */   GIR_RootConstrainSelectedInstOperands,
     /* 108287 */   // GIR_Coverage, 6752,
     /* 108287 */   GIR_Done,
     /* 108288 */ // Label 1708: @108288
     /* 108288 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(108314), // Rule ID 6753 //
     /* 108293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108307 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /* 108307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108312 */   GIR_RootConstrainSelectedInstOperands,
     /* 108313 */   // GIR_Coverage, 6753,
     /* 108313 */   GIR_Done,
     /* 108314 */ // Label 1709: @108314
     /* 108314 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(108340), // Rule ID 6754 //
     /* 108319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108333 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /* 108333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 108338 */   GIR_RootConstrainSelectedInstOperands,
     /* 108339 */   // GIR_Coverage, 6754,
     /* 108339 */   GIR_Done,
     /* 108340 */ // Label 1710: @108340
     /* 108340 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(108366), // Rule ID 6755 //
     /* 108345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108359 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /* 108359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108364 */   GIR_RootConstrainSelectedInstOperands,
     /* 108365 */   // GIR_Coverage, 6755,
     /* 108365 */   GIR_Done,
     /* 108366 */ // Label 1711: @108366
     /* 108366 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(108392), // Rule ID 6756 //
     /* 108371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108385 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /* 108385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108390 */   GIR_RootConstrainSelectedInstOperands,
     /* 108391 */   // GIR_Coverage, 6756,
     /* 108391 */   GIR_Done,
     /* 108392 */ // Label 1712: @108392
     /* 108392 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(108418), // Rule ID 6757 //
     /* 108397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108411 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /* 108411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108416 */   GIR_RootConstrainSelectedInstOperands,
     /* 108417 */   // GIR_Coverage, 6757,
     /* 108417 */   GIR_Done,
     /* 108418 */ // Label 1713: @108418
     /* 108418 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(108447), // Rule ID 6758 //
     /* 108423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108434 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108437 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108439 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108441 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108446 */   // GIR_Coverage, 6758,
     /* 108446 */   GIR_EraseRootFromParent_Done,
     /* 108447 */ // Label 1714: @108447
     /* 108447 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(108479), // Rule ID 6823 //
     /* 108452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108466 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108469 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108471 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108473 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108478 */   // GIR_Coverage, 6823,
     /* 108478 */   GIR_EraseRootFromParent_Done,
     /* 108479 */ // Label 1715: @108479
     /* 108479 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(108511), // Rule ID 6824 //
     /* 108484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108498 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108501 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108503 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108510 */   // GIR_Coverage, 6824,
     /* 108510 */   GIR_EraseRootFromParent_Done,
     /* 108511 */ // Label 1716: @108511
     /* 108511 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(108543), // Rule ID 6825 //
     /* 108516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108530 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108533 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108537 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108542 */   // GIR_Coverage, 6825,
     /* 108542 */   GIR_EraseRootFromParent_Done,
     /* 108543 */ // Label 1717: @108543
     /* 108543 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(108575), // Rule ID 6826 //
     /* 108548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108562 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108565 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108567 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108569 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108574 */   // GIR_Coverage, 6826,
     /* 108574 */   GIR_EraseRootFromParent_Done,
     /* 108575 */ // Label 1718: @108575
     /* 108575 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(108607), // Rule ID 6827 //
     /* 108580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108594 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108597 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108599 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108601 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108606 */   // GIR_Coverage, 6827,
     /* 108606 */   GIR_EraseRootFromParent_Done,
     /* 108607 */ // Label 1719: @108607
     /* 108607 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(108639), // Rule ID 6828 //
     /* 108612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108626 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108629 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108631 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108633 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108638 */   // GIR_Coverage, 6828,
     /* 108638 */   GIR_EraseRootFromParent_Done,
     /* 108639 */ // Label 1720: @108639
     /* 108639 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(108665), // Rule ID 6829 //
     /* 108644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108658 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /* 108658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108663 */   GIR_RootConstrainSelectedInstOperands,
     /* 108664 */   // GIR_Coverage, 6829,
     /* 108664 */   GIR_Done,
     /* 108665 */ // Label 1721: @108665
     /* 108665 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(108691), // Rule ID 6830 //
     /* 108670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108684 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /* 108684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108689 */   GIR_RootConstrainSelectedInstOperands,
     /* 108690 */   // GIR_Coverage, 6830,
     /* 108690 */   GIR_Done,
     /* 108691 */ // Label 1722: @108691
     /* 108691 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(108717), // Rule ID 6831 //
     /* 108696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108710 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /* 108710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 108715 */   GIR_RootConstrainSelectedInstOperands,
     /* 108716 */   // GIR_Coverage, 6831,
     /* 108716 */   GIR_Done,
     /* 108717 */ // Label 1723: @108717
     /* 108717 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(108743), // Rule ID 6832 //
     /* 108722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108736 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /* 108736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108741 */   GIR_RootConstrainSelectedInstOperands,
     /* 108742 */   // GIR_Coverage, 6832,
     /* 108742 */   GIR_Done,
     /* 108743 */ // Label 1724: @108743
     /* 108743 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(108769), // Rule ID 6833 //
     /* 108748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108762 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /* 108762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108767 */   GIR_RootConstrainSelectedInstOperands,
     /* 108768 */   // GIR_Coverage, 6833,
     /* 108768 */   GIR_Done,
     /* 108769 */ // Label 1725: @108769
     /* 108769 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(108795), // Rule ID 6834 //
     /* 108774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108788 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /* 108788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108793 */   GIR_RootConstrainSelectedInstOperands,
     /* 108794 */   // GIR_Coverage, 6834,
     /* 108794 */   GIR_Done,
     /* 108795 */ // Label 1726: @108795
     /* 108795 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(108824), // Rule ID 6835 //
     /* 108800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108811 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108814 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108818 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108823 */   // GIR_Coverage, 6835,
     /* 108823 */   GIR_EraseRootFromParent_Done,
     /* 108824 */ // Label 1727: @108824
     /* 108824 */ GIM_Reject,
     /* 108825 */ // Label 1605: @108825
     /* 108825 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(108857), // Rule ID 6850 //
     /* 108830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 108836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108844 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108847 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108849 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108856 */   // GIR_Coverage, 6850,
     /* 108856 */   GIR_EraseRootFromParent_Done,
     /* 108857 */ // Label 1728: @108857
     /* 108857 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(108889), // Rule ID 6851 //
     /* 108862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108876 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108879 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108881 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108888 */   // GIR_Coverage, 6851,
     /* 108888 */   GIR_EraseRootFromParent_Done,
     /* 108889 */ // Label 1729: @108889
     /* 108889 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(108921), // Rule ID 6852 //
     /* 108894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108908 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108911 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108913 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108920 */   // GIR_Coverage, 6852,
     /* 108920 */   GIR_EraseRootFromParent_Done,
     /* 108921 */ // Label 1730: @108921
     /* 108921 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(108953), // Rule ID 6853 //
     /* 108926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108940 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108943 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108952 */   // GIR_Coverage, 6853,
     /* 108952 */   GIR_EraseRootFromParent_Done,
     /* 108953 */ // Label 1731: @108953
     /* 108953 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(108985), // Rule ID 6854 //
     /* 108958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 108964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108972 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108975 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108977 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108984 */   // GIR_Coverage, 6854,
     /* 108984 */   GIR_EraseRootFromParent_Done,
     /* 108985 */ // Label 1732: @108985
     /* 108985 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(109017), // Rule ID 6855 //
     /* 108990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109004 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 109004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109007 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109016 */   // GIR_Coverage, 6855,
     /* 109016 */   GIR_EraseRootFromParent_Done,
     /* 109017 */ // Label 1733: @109017
     /* 109017 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(109050), // Rule ID 6856 //
     /* 109022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 109028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109036 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 109036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109041 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109043 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109048 */   GIR_RootConstrainSelectedInstOperands,
     /* 109049 */   // GIR_Coverage, 6856,
     /* 109049 */   GIR_EraseRootFromParent_Done,
     /* 109050 */ // Label 1734: @109050
     /* 109050 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(109076), // Rule ID 6857 //
     /* 109055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109069 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /* 109069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109074 */   GIR_RootConstrainSelectedInstOperands,
     /* 109075 */   // GIR_Coverage, 6857,
     /* 109075 */   GIR_Done,
     /* 109076 */ // Label 1735: @109076
     /* 109076 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(109102), // Rule ID 6858 //
     /* 109081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109095 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /* 109095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109100 */   GIR_RootConstrainSelectedInstOperands,
     /* 109101 */   // GIR_Coverage, 6858,
     /* 109101 */   GIR_Done,
     /* 109102 */ // Label 1736: @109102
     /* 109102 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(109128), // Rule ID 6859 //
     /* 109107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109121 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /* 109121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109126 */   GIR_RootConstrainSelectedInstOperands,
     /* 109127 */   // GIR_Coverage, 6859,
     /* 109127 */   GIR_Done,
     /* 109128 */ // Label 1737: @109128
     /* 109128 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(109154), // Rule ID 6860 //
     /* 109133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109147 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /* 109147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109152 */   GIR_RootConstrainSelectedInstOperands,
     /* 109153 */   // GIR_Coverage, 6860,
     /* 109153 */   GIR_Done,
     /* 109154 */ // Label 1738: @109154
     /* 109154 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(109180), // Rule ID 6861 //
     /* 109159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109173 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /* 109173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109178 */   GIR_RootConstrainSelectedInstOperands,
     /* 109179 */   // GIR_Coverage, 6861,
     /* 109179 */   GIR_Done,
     /* 109180 */ // Label 1739: @109180
     /* 109180 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(109209), // Rule ID 6862 //
     /* 109185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109196 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 109196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109199 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109201 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109208 */   // GIR_Coverage, 6862,
     /* 109208 */   GIR_EraseRootFromParent_Done,
     /* 109209 */ // Label 1740: @109209
     /* 109209 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(109241), // Rule ID 6876 //
     /* 109214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 109220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109228 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109231 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109233 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109235 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109240 */   // GIR_Coverage, 6876,
     /* 109240 */   GIR_EraseRootFromParent_Done,
     /* 109241 */ // Label 1741: @109241
     /* 109241 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(109273), // Rule ID 6877 //
     /* 109246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109260 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109263 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109265 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109267 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109272 */   // GIR_Coverage, 6877,
     /* 109272 */   GIR_EraseRootFromParent_Done,
     /* 109273 */ // Label 1742: @109273
     /* 109273 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(109305), // Rule ID 6878 //
     /* 109278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109292 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109295 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109297 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109299 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109304 */   // GIR_Coverage, 6878,
     /* 109304 */   GIR_EraseRootFromParent_Done,
     /* 109305 */ // Label 1743: @109305
     /* 109305 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(109337), // Rule ID 6879 //
     /* 109310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109324 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109327 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109329 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109336 */   // GIR_Coverage, 6879,
     /* 109336 */   GIR_EraseRootFromParent_Done,
     /* 109337 */ // Label 1744: @109337
     /* 109337 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(109369), // Rule ID 6880 //
     /* 109342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109356 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109359 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109361 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109363 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109368 */   // GIR_Coverage, 6880,
     /* 109368 */   GIR_EraseRootFromParent_Done,
     /* 109369 */ // Label 1745: @109369
     /* 109369 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(109401), // Rule ID 6881 //
     /* 109374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109388 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109391 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109393 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109400 */   // GIR_Coverage, 6881,
     /* 109400 */   GIR_EraseRootFromParent_Done,
     /* 109401 */ // Label 1746: @109401
     /* 109401 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(109434), // Rule ID 6882 //
     /* 109406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 109412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109420 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 109420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109425 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109432 */   GIR_RootConstrainSelectedInstOperands,
     /* 109433 */   // GIR_Coverage, 6882,
     /* 109433 */   GIR_EraseRootFromParent_Done,
     /* 109434 */ // Label 1747: @109434
     /* 109434 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(109460), // Rule ID 6883 //
     /* 109439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109453 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /* 109453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109458 */   GIR_RootConstrainSelectedInstOperands,
     /* 109459 */   // GIR_Coverage, 6883,
     /* 109459 */   GIR_Done,
     /* 109460 */ // Label 1748: @109460
     /* 109460 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(109486), // Rule ID 6884 //
     /* 109465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109479 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /* 109479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109484 */   GIR_RootConstrainSelectedInstOperands,
     /* 109485 */   // GIR_Coverage, 6884,
     /* 109485 */   GIR_Done,
     /* 109486 */ // Label 1749: @109486
     /* 109486 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(109512), // Rule ID 6885 //
     /* 109491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109505 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /* 109505 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109510 */   GIR_RootConstrainSelectedInstOperands,
     /* 109511 */   // GIR_Coverage, 6885,
     /* 109511 */   GIR_Done,
     /* 109512 */ // Label 1750: @109512
     /* 109512 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(109538), // Rule ID 6886 //
     /* 109517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109531 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /* 109531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109536 */   GIR_RootConstrainSelectedInstOperands,
     /* 109537 */   // GIR_Coverage, 6886,
     /* 109537 */   GIR_Done,
     /* 109538 */ // Label 1751: @109538
     /* 109538 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(109564), // Rule ID 6887 //
     /* 109543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109557 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /* 109557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109562 */   GIR_RootConstrainSelectedInstOperands,
     /* 109563 */   // GIR_Coverage, 6887,
     /* 109563 */   GIR_Done,
     /* 109564 */ // Label 1752: @109564
     /* 109564 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(109593), // Rule ID 6888 //
     /* 109569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109580 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109583 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109585 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109587 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109592 */   // GIR_Coverage, 6888,
     /* 109592 */   GIR_EraseRootFromParent_Done,
     /* 109593 */ // Label 1753: @109593
     /* 109593 */ GIM_Reject,
     /* 109594 */ // Label 1606: @109594
     /* 109594 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(109624), // Rule ID 6700 //
     /* 109599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109613 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109618 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109623 */   // GIR_Coverage, 6700,
     /* 109623 */   GIR_Done,
     /* 109624 */ // Label 1754: @109624
     /* 109624 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(109654), // Rule ID 6702 //
     /* 109629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109643 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109653 */   // GIR_Coverage, 6702,
     /* 109653 */   GIR_Done,
     /* 109654 */ // Label 1755: @109654
     /* 109654 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(109704), // Rule ID 6711 //
     /* 109659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109673 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109685 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109689 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109702 */   GIR_RootConstrainSelectedInstOperands,
     /* 109703 */   // GIR_Coverage, 6711,
     /* 109703 */   GIR_EraseRootFromParent_Done,
     /* 109704 */ // Label 1756: @109704
     /* 109704 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(109754), // Rule ID 6713 //
     /* 109709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109723 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109735 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109749 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109752 */   GIR_RootConstrainSelectedInstOperands,
     /* 109753 */   // GIR_Coverage, 6713,
     /* 109753 */   GIR_EraseRootFromParent_Done,
     /* 109754 */ // Label 1757: @109754
     /* 109754 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(109786), // Rule ID 6759 //
     /* 109759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109773 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109776 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109778 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109785 */   // GIR_Coverage, 6759,
     /* 109785 */   GIR_EraseRootFromParent_Done,
     /* 109786 */ // Label 1758: @109786
     /* 109786 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(109818), // Rule ID 6760 //
     /* 109791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109805 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109808 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109810 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109812 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109817 */   // GIR_Coverage, 6760,
     /* 109817 */   GIR_EraseRootFromParent_Done,
     /* 109818 */ // Label 1759: @109818
     /* 109818 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(109850), // Rule ID 6761 //
     /* 109823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 109829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109837 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109840 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109842 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109844 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109849 */   // GIR_Coverage, 6761,
     /* 109849 */   GIR_EraseRootFromParent_Done,
     /* 109850 */ // Label 1760: @109850
     /* 109850 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(109882), // Rule ID 6762 //
     /* 109855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109869 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109872 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109874 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109876 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109881 */   // GIR_Coverage, 6762,
     /* 109881 */   GIR_EraseRootFromParent_Done,
     /* 109882 */ // Label 1761: @109882
     /* 109882 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(109914), // Rule ID 6763 //
     /* 109887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109901 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109904 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109906 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109908 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109913 */   // GIR_Coverage, 6763,
     /* 109913 */   GIR_EraseRootFromParent_Done,
     /* 109914 */ // Label 1762: @109914
     /* 109914 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(109946), // Rule ID 6764 //
     /* 109919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109933 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109936 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109938 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109940 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109945 */   // GIR_Coverage, 6764,
     /* 109945 */   GIR_EraseRootFromParent_Done,
     /* 109946 */ // Label 1763: @109946
     /* 109946 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(109972), // Rule ID 6765 //
     /* 109951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109965 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /* 109965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109970 */   GIR_RootConstrainSelectedInstOperands,
     /* 109971 */   // GIR_Coverage, 6765,
     /* 109971 */   GIR_Done,
     /* 109972 */ // Label 1764: @109972
     /* 109972 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(109998), // Rule ID 6766 //
     /* 109977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109991 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /* 109991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 109996 */   GIR_RootConstrainSelectedInstOperands,
     /* 109997 */   // GIR_Coverage, 6766,
     /* 109997 */   GIR_Done,
     /* 109998 */ // Label 1765: @109998
     /* 109998 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(110024), // Rule ID 6767 //
     /* 110003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110017 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /* 110017 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 110022 */   GIR_RootConstrainSelectedInstOperands,
     /* 110023 */   // GIR_Coverage, 6767,
     /* 110023 */   GIR_Done,
     /* 110024 */ // Label 1766: @110024
     /* 110024 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(110050), // Rule ID 6768 //
     /* 110029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110043 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /* 110043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110048 */   GIR_RootConstrainSelectedInstOperands,
     /* 110049 */   // GIR_Coverage, 6768,
     /* 110049 */   GIR_Done,
     /* 110050 */ // Label 1767: @110050
     /* 110050 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(110076), // Rule ID 6769 //
     /* 110055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110069 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /* 110069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110074 */   GIR_RootConstrainSelectedInstOperands,
     /* 110075 */   // GIR_Coverage, 6769,
     /* 110075 */   GIR_Done,
     /* 110076 */ // Label 1768: @110076
     /* 110076 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(110102), // Rule ID 6770 //
     /* 110081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110095 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /* 110095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110100 */   GIR_RootConstrainSelectedInstOperands,
     /* 110101 */   // GIR_Coverage, 6770,
     /* 110101 */   GIR_Done,
     /* 110102 */ // Label 1769: @110102
     /* 110102 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(110131), // Rule ID 6771 //
     /* 110107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110118 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 110118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110121 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110123 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110125 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110130 */   // GIR_Coverage, 6771,
     /* 110130 */   GIR_EraseRootFromParent_Done,
     /* 110131 */ // Label 1770: @110131
     /* 110131 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(110163), // Rule ID 6772 //
     /* 110136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110150 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110153 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110155 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110157 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110162 */   // GIR_Coverage, 6772,
     /* 110162 */   GIR_EraseRootFromParent_Done,
     /* 110163 */ // Label 1771: @110163
     /* 110163 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(110195), // Rule ID 6773 //
     /* 110168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110182 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110185 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110187 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110189 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110194 */   // GIR_Coverage, 6773,
     /* 110194 */   GIR_EraseRootFromParent_Done,
     /* 110195 */ // Label 1772: @110195
     /* 110195 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(110227), // Rule ID 6774 //
     /* 110200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110214 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110217 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110219 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110221 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110226 */   // GIR_Coverage, 6774,
     /* 110226 */   GIR_EraseRootFromParent_Done,
     /* 110227 */ // Label 1773: @110227
     /* 110227 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(110259), // Rule ID 6775 //
     /* 110232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110246 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110249 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110251 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110253 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110258 */   // GIR_Coverage, 6775,
     /* 110258 */   GIR_EraseRootFromParent_Done,
     /* 110259 */ // Label 1774: @110259
     /* 110259 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(110291), // Rule ID 6776 //
     /* 110264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110278 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110281 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110285 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110290 */   // GIR_Coverage, 6776,
     /* 110290 */   GIR_EraseRootFromParent_Done,
     /* 110291 */ // Label 1775: @110291
     /* 110291 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(110323), // Rule ID 6777 //
     /* 110296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110310 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110313 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110315 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110322 */   // GIR_Coverage, 6777,
     /* 110322 */   GIR_EraseRootFromParent_Done,
     /* 110323 */ // Label 1776: @110323
     /* 110323 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(110349), // Rule ID 6778 //
     /* 110328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110342 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /* 110342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110347 */   GIR_RootConstrainSelectedInstOperands,
     /* 110348 */   // GIR_Coverage, 6778,
     /* 110348 */   GIR_Done,
     /* 110349 */ // Label 1777: @110349
     /* 110349 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(110375), // Rule ID 6779 //
     /* 110354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110368 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /* 110368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110373 */   GIR_RootConstrainSelectedInstOperands,
     /* 110374 */   // GIR_Coverage, 6779,
     /* 110374 */   GIR_Done,
     /* 110375 */ // Label 1778: @110375
     /* 110375 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(110401), // Rule ID 6780 //
     /* 110380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110394 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /* 110394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 110399 */   GIR_RootConstrainSelectedInstOperands,
     /* 110400 */   // GIR_Coverage, 6780,
     /* 110400 */   GIR_Done,
     /* 110401 */ // Label 1779: @110401
     /* 110401 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(110427), // Rule ID 6781 //
     /* 110406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110420 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /* 110420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110425 */   GIR_RootConstrainSelectedInstOperands,
     /* 110426 */   // GIR_Coverage, 6781,
     /* 110426 */   GIR_Done,
     /* 110427 */ // Label 1780: @110427
     /* 110427 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(110453), // Rule ID 6782 //
     /* 110432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110446 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /* 110446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110451 */   GIR_RootConstrainSelectedInstOperands,
     /* 110452 */   // GIR_Coverage, 6782,
     /* 110452 */   GIR_Done,
     /* 110453 */ // Label 1781: @110453
     /* 110453 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(110479), // Rule ID 6783 //
     /* 110458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110472 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /* 110472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110477 */   GIR_RootConstrainSelectedInstOperands,
     /* 110478 */   // GIR_Coverage, 6783,
     /* 110478 */   GIR_Done,
     /* 110479 */ // Label 1782: @110479
     /* 110479 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(110508), // Rule ID 6784 //
     /* 110484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110495 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110498 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110500 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110502 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110507 */   // GIR_Coverage, 6784,
     /* 110507 */   GIR_EraseRootFromParent_Done,
     /* 110508 */ // Label 1783: @110508
     /* 110508 */ GIM_Reject,
     /* 110509 */ // Label 1607: @110509
     /* 110509 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(110541), // Rule ID 6863 //
     /* 110514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110528 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110531 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110533 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110540 */   // GIR_Coverage, 6863,
     /* 110540 */   GIR_EraseRootFromParent_Done,
     /* 110541 */ // Label 1784: @110541
     /* 110541 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(110573), // Rule ID 6864 //
     /* 110546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110560 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110563 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110565 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110567 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110572 */   // GIR_Coverage, 6864,
     /* 110572 */   GIR_EraseRootFromParent_Done,
     /* 110573 */ // Label 1785: @110573
     /* 110573 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(110605), // Rule ID 6865 //
     /* 110578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110592 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110595 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110597 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110599 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110604 */   // GIR_Coverage, 6865,
     /* 110604 */   GIR_EraseRootFromParent_Done,
     /* 110605 */ // Label 1786: @110605
     /* 110605 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(110637), // Rule ID 6866 //
     /* 110610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110624 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110627 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110629 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110631 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110636 */   // GIR_Coverage, 6866,
     /* 110636 */   GIR_EraseRootFromParent_Done,
     /* 110637 */ // Label 1787: @110637
     /* 110637 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(110669), // Rule ID 6867 //
     /* 110642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110656 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110659 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110661 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110663 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110668 */   // GIR_Coverage, 6867,
     /* 110668 */   GIR_EraseRootFromParent_Done,
     /* 110669 */ // Label 1788: @110669
     /* 110669 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(110701), // Rule ID 6868 //
     /* 110674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110688 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110691 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110693 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110700 */   // GIR_Coverage, 6868,
     /* 110700 */   GIR_EraseRootFromParent_Done,
     /* 110701 */ // Label 1789: @110701
     /* 110701 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(110772), // Rule ID 6869 //
     /* 110706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110720 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 110720 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 110723 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110727 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110732 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110738 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 110741 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110745 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110750 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110754 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 110759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 110761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110764 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 110767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 110770 */   GIR_RootConstrainSelectedInstOperands,
     /* 110771 */   // GIR_Coverage, 6869,
     /* 110771 */   GIR_EraseRootFromParent_Done,
     /* 110772 */ // Label 1790: @110772
     /* 110772 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(110798), // Rule ID 6870 //
     /* 110777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110791 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /* 110791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 110796 */   GIR_RootConstrainSelectedInstOperands,
     /* 110797 */   // GIR_Coverage, 6870,
     /* 110797 */   GIR_Done,
     /* 110798 */ // Label 1791: @110798
     /* 110798 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(110824), // Rule ID 6871 //
     /* 110803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110817 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /* 110817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 110822 */   GIR_RootConstrainSelectedInstOperands,
     /* 110823 */   // GIR_Coverage, 6871,
     /* 110823 */   GIR_Done,
     /* 110824 */ // Label 1792: @110824
     /* 110824 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(110850), // Rule ID 6872 //
     /* 110829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110843 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /* 110843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 110848 */   GIR_RootConstrainSelectedInstOperands,
     /* 110849 */   // GIR_Coverage, 6872,
     /* 110849 */   GIR_Done,
     /* 110850 */ // Label 1793: @110850
     /* 110850 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(110876), // Rule ID 6873 //
     /* 110855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110869 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /* 110869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110874 */   GIR_RootConstrainSelectedInstOperands,
     /* 110875 */   // GIR_Coverage, 6873,
     /* 110875 */   GIR_Done,
     /* 110876 */ // Label 1794: @110876
     /* 110876 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(110902), // Rule ID 6874 //
     /* 110881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110895 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /* 110895 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110900 */   GIR_RootConstrainSelectedInstOperands,
     /* 110901 */   // GIR_Coverage, 6874,
     /* 110901 */   GIR_Done,
     /* 110902 */ // Label 1795: @110902
     /* 110902 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(110931), // Rule ID 6875 //
     /* 110907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110918 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110930 */   // GIR_Coverage, 6875,
     /* 110930 */   GIR_EraseRootFromParent_Done,
     /* 110931 */ // Label 1796: @110931
     /* 110931 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(110963), // Rule ID 6889 //
     /* 110936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110950 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 110950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110962 */   // GIR_Coverage, 6889,
     /* 110962 */   GIR_EraseRootFromParent_Done,
     /* 110963 */ // Label 1797: @110963
     /* 110963 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(110995), // Rule ID 6890 //
     /* 110968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110982 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 110982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110994 */   // GIR_Coverage, 6890,
     /* 110994 */   GIR_EraseRootFromParent_Done,
     /* 110995 */ // Label 1798: @110995
     /* 110995 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(111027), // Rule ID 6891 //
     /* 111000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111014 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111026 */   // GIR_Coverage, 6891,
     /* 111026 */   GIR_EraseRootFromParent_Done,
     /* 111027 */ // Label 1799: @111027
     /* 111027 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(111059), // Rule ID 6892 //
     /* 111032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111046 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111058 */   // GIR_Coverage, 6892,
     /* 111058 */   GIR_EraseRootFromParent_Done,
     /* 111059 */ // Label 1800: @111059
     /* 111059 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(111091), // Rule ID 6893 //
     /* 111064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111078 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111081 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111090 */   // GIR_Coverage, 6893,
     /* 111090 */   GIR_EraseRootFromParent_Done,
     /* 111091 */ // Label 1801: @111091
     /* 111091 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(111123), // Rule ID 6894 //
     /* 111096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111110 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111113 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111122 */   // GIR_Coverage, 6894,
     /* 111122 */   GIR_EraseRootFromParent_Done,
     /* 111123 */ // Label 1802: @111123
     /* 111123 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(111194), // Rule ID 6895 //
     /* 111128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 111134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111142 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 111142 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 111145 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111149 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111154 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111172 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 111181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 111189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 111192 */   GIR_RootConstrainSelectedInstOperands,
     /* 111193 */   // GIR_Coverage, 6895,
     /* 111193 */   GIR_EraseRootFromParent_Done,
     /* 111194 */ // Label 1803: @111194
     /* 111194 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(111220), // Rule ID 6896 //
     /* 111199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111213 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /* 111213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111218 */   GIR_RootConstrainSelectedInstOperands,
     /* 111219 */   // GIR_Coverage, 6896,
     /* 111219 */   GIR_Done,
     /* 111220 */ // Label 1804: @111220
     /* 111220 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(111246), // Rule ID 6897 //
     /* 111225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111239 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /* 111239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 111244 */   GIR_RootConstrainSelectedInstOperands,
     /* 111245 */   // GIR_Coverage, 6897,
     /* 111245 */   GIR_Done,
     /* 111246 */ // Label 1805: @111246
     /* 111246 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(111272), // Rule ID 6898 //
     /* 111251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111265 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /* 111265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 111270 */   GIR_RootConstrainSelectedInstOperands,
     /* 111271 */   // GIR_Coverage, 6898,
     /* 111271 */   GIR_Done,
     /* 111272 */ // Label 1806: @111272
     /* 111272 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(111298), // Rule ID 6899 //
     /* 111277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111291 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /* 111291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111296 */   GIR_RootConstrainSelectedInstOperands,
     /* 111297 */   // GIR_Coverage, 6899,
     /* 111297 */   GIR_Done,
     /* 111298 */ // Label 1807: @111298
     /* 111298 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(111324), // Rule ID 6900 //
     /* 111303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111317 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /* 111317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 111322 */   GIR_RootConstrainSelectedInstOperands,
     /* 111323 */   // GIR_Coverage, 6900,
     /* 111323 */   GIR_Done,
     /* 111324 */ // Label 1808: @111324
     /* 111324 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(111353), // Rule ID 6901 //
     /* 111329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111340 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111343 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111345 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111352 */   // GIR_Coverage, 6901,
     /* 111352 */   GIR_EraseRootFromParent_Done,
     /* 111353 */ // Label 1809: @111353
     /* 111353 */ GIM_Reject,
     /* 111354 */ // Label 1608: @111354
     /* 111354 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(111428), // Rule ID 5704 //
     /* 111359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111366 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111370 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 111374 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111378 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111383 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111385 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /* 111385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /* 111392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111397 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 111401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111411 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 111417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111422 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 111427 */   // GIR_Coverage, 5704,
     /* 111427 */   GIR_EraseRootFromParent_Done,
     /* 111428 */ // Label 1810: @111428
     /* 111428 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(111458), // Rule ID 6699 //
     /* 111433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111447 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 111447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111452 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111457 */   // GIR_Coverage, 6699,
     /* 111457 */   GIR_Done,
     /* 111458 */ // Label 1811: @111458
     /* 111458 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(111508), // Rule ID 6710 //
     /* 111463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111477 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 111477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111489 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 111493 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111503 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111506 */   GIR_RootConstrainSelectedInstOperands,
     /* 111507 */   // GIR_Coverage, 6710,
     /* 111507 */   GIR_EraseRootFromParent_Done,
     /* 111508 */ // Label 1812: @111508
     /* 111508 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(111540), // Rule ID 6785 //
     /* 111513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111527 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111530 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111532 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111534 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111539 */   // GIR_Coverage, 6785,
     /* 111539 */   GIR_EraseRootFromParent_Done,
     /* 111540 */ // Label 1813: @111540
     /* 111540 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(111572), // Rule ID 6786 //
     /* 111545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111559 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111562 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111564 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111566 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111571 */   // GIR_Coverage, 6786,
     /* 111571 */   GIR_EraseRootFromParent_Done,
     /* 111572 */ // Label 1814: @111572
     /* 111572 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(111604), // Rule ID 6787 //
     /* 111577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111591 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111594 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111596 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111598 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111603 */   // GIR_Coverage, 6787,
     /* 111603 */   GIR_EraseRootFromParent_Done,
     /* 111604 */ // Label 1815: @111604
     /* 111604 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(111636), // Rule ID 6788 //
     /* 111609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111623 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111626 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111628 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111630 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111635 */   // GIR_Coverage, 6788,
     /* 111635 */   GIR_EraseRootFromParent_Done,
     /* 111636 */ // Label 1816: @111636
     /* 111636 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(111668), // Rule ID 6789 //
     /* 111641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111655 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111658 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111660 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111662 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111667 */   // GIR_Coverage, 6789,
     /* 111667 */   GIR_EraseRootFromParent_Done,
     /* 111668 */ // Label 1817: @111668
     /* 111668 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(111700), // Rule ID 6790 //
     /* 111673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111687 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111690 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111692 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111694 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111699 */   // GIR_Coverage, 6790,
     /* 111699 */   GIR_EraseRootFromParent_Done,
     /* 111700 */ // Label 1818: @111700
     /* 111700 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(111732), // Rule ID 6791 //
     /* 111705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111719 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111722 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111724 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111726 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111731 */   // GIR_Coverage, 6791,
     /* 111731 */   GIR_EraseRootFromParent_Done,
     /* 111732 */ // Label 1819: @111732
     /* 111732 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(111758), // Rule ID 6792 //
     /* 111737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111751 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /* 111751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111756 */   GIR_RootConstrainSelectedInstOperands,
     /* 111757 */   // GIR_Coverage, 6792,
     /* 111757 */   GIR_Done,
     /* 111758 */ // Label 1820: @111758
     /* 111758 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(111784), // Rule ID 6793 //
     /* 111763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111777 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /* 111777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 111782 */   GIR_RootConstrainSelectedInstOperands,
     /* 111783 */   // GIR_Coverage, 6793,
     /* 111783 */   GIR_Done,
     /* 111784 */ // Label 1821: @111784
     /* 111784 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(111810), // Rule ID 6794 //
     /* 111789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111803 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /* 111803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111808 */   GIR_RootConstrainSelectedInstOperands,
     /* 111809 */   // GIR_Coverage, 6794,
     /* 111809 */   GIR_Done,
     /* 111810 */ // Label 1822: @111810
     /* 111810 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(111836), // Rule ID 6795 //
     /* 111815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111829 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /* 111829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111834 */   GIR_RootConstrainSelectedInstOperands,
     /* 111835 */   // GIR_Coverage, 6795,
     /* 111835 */   GIR_Done,
     /* 111836 */ // Label 1823: @111836
     /* 111836 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(111862), // Rule ID 6796 //
     /* 111841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111855 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /* 111855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 111860 */   GIR_RootConstrainSelectedInstOperands,
     /* 111861 */   // GIR_Coverage, 6796,
     /* 111861 */   GIR_Done,
     /* 111862 */ // Label 1824: @111862
     /* 111862 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(111888), // Rule ID 6797 //
     /* 111867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111881 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /* 111881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111886 */   GIR_RootConstrainSelectedInstOperands,
     /* 111887 */   // GIR_Coverage, 6797,
     /* 111887 */   GIR_Done,
     /* 111888 */ // Label 1825: @111888
     /* 111888 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(111914), // Rule ID 6798 //
     /* 111893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111907 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /* 111907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111912 */   GIR_RootConstrainSelectedInstOperands,
     /* 111913 */   // GIR_Coverage, 6798,
     /* 111913 */   GIR_Done,
     /* 111914 */ // Label 1826: @111914
     /* 111914 */ GIM_Reject,
     /* 111915 */ // Label 1609: @111915
     /* 111915 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(111947), // Rule ID 6902 //
     /* 111920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 111926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111934 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111946 */   // GIR_Coverage, 6902,
     /* 111946 */   GIR_EraseRootFromParent_Done,
     /* 111947 */ // Label 1827: @111947
     /* 111947 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(111979), // Rule ID 6903 //
     /* 111952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111966 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111978 */   // GIR_Coverage, 6903,
     /* 111978 */   GIR_EraseRootFromParent_Done,
     /* 111979 */ // Label 1828: @111979
     /* 111979 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(112011), // Rule ID 6904 //
     /* 111984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111998 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112010 */   // GIR_Coverage, 6904,
     /* 112010 */   GIR_EraseRootFromParent_Done,
     /* 112011 */ // Label 1829: @112011
     /* 112011 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(112043), // Rule ID 6905 //
     /* 112016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112030 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 112030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112042 */   // GIR_Coverage, 6905,
     /* 112042 */   GIR_EraseRootFromParent_Done,
     /* 112043 */ // Label 1830: @112043
     /* 112043 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(112075), // Rule ID 6906 //
     /* 112048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112062 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 112062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112074 */   // GIR_Coverage, 6906,
     /* 112074 */   GIR_EraseRootFromParent_Done,
     /* 112075 */ // Label 1831: @112075
     /* 112075 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(112107), // Rule ID 6907 //
     /* 112080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112094 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 112094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112097 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112099 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112106 */   // GIR_Coverage, 6907,
     /* 112106 */   GIR_EraseRootFromParent_Done,
     /* 112107 */ // Label 1832: @112107
     /* 112107 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(112178), // Rule ID 6908 //
     /* 112112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112126 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112126 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112129 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112133 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112138 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112156 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112167 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112170 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112176 */   GIR_RootConstrainSelectedInstOperands,
     /* 112177 */   // GIR_Coverage, 6908,
     /* 112177 */   GIR_EraseRootFromParent_Done,
     /* 112178 */ // Label 1833: @112178
     /* 112178 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(112204), // Rule ID 6909 //
     /* 112183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112197 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /* 112197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112202 */   GIR_RootConstrainSelectedInstOperands,
     /* 112203 */   // GIR_Coverage, 6909,
     /* 112203 */   GIR_Done,
     /* 112204 */ // Label 1834: @112204
     /* 112204 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(112230), // Rule ID 6910 //
     /* 112209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112223 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /* 112223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112228 */   GIR_RootConstrainSelectedInstOperands,
     /* 112229 */   // GIR_Coverage, 6910,
     /* 112229 */   GIR_Done,
     /* 112230 */ // Label 1835: @112230
     /* 112230 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(112256), // Rule ID 6911 //
     /* 112235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112249 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /* 112249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 112254 */   GIR_RootConstrainSelectedInstOperands,
     /* 112255 */   // GIR_Coverage, 6911,
     /* 112255 */   GIR_Done,
     /* 112256 */ // Label 1836: @112256
     /* 112256 */ GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(112282), // Rule ID 6912 //
     /* 112261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112275 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /* 112275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112280 */   GIR_RootConstrainSelectedInstOperands,
     /* 112281 */   // GIR_Coverage, 6912,
     /* 112281 */   GIR_Done,
     /* 112282 */ // Label 1837: @112282
     /* 112282 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(112308), // Rule ID 6913 //
     /* 112287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112301 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /* 112301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112306 */   GIR_RootConstrainSelectedInstOperands,
     /* 112307 */   // GIR_Coverage, 6913,
     /* 112307 */   GIR_Done,
     /* 112308 */ // Label 1838: @112308
     /* 112308 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(112337), // Rule ID 6914 //
     /* 112313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112324 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 112324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112327 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112329 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112336 */   // GIR_Coverage, 6914,
     /* 112336 */   GIR_EraseRootFromParent_Done,
     /* 112337 */ // Label 1839: @112337
     /* 112337 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(112369), // Rule ID 6915 //
     /* 112342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112356 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112359 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112361 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112363 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112368 */   // GIR_Coverage, 6915,
     /* 112368 */   GIR_EraseRootFromParent_Done,
     /* 112369 */ // Label 1840: @112369
     /* 112369 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(112401), // Rule ID 6916 //
     /* 112374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112388 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112391 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112393 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112400 */   // GIR_Coverage, 6916,
     /* 112400 */   GIR_EraseRootFromParent_Done,
     /* 112401 */ // Label 1841: @112401
     /* 112401 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(112433), // Rule ID 6917 //
     /* 112406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112420 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112423 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112425 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112427 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112432 */   // GIR_Coverage, 6917,
     /* 112432 */   GIR_EraseRootFromParent_Done,
     /* 112433 */ // Label 1842: @112433
     /* 112433 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(112465), // Rule ID 6918 //
     /* 112438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112452 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112455 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112457 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112464 */   // GIR_Coverage, 6918,
     /* 112464 */   GIR_EraseRootFromParent_Done,
     /* 112465 */ // Label 1843: @112465
     /* 112465 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(112497), // Rule ID 6919 //
     /* 112470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112484 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112487 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112489 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112496 */   // GIR_Coverage, 6919,
     /* 112496 */   GIR_EraseRootFromParent_Done,
     /* 112497 */ // Label 1844: @112497
     /* 112497 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(112529), // Rule ID 6920 //
     /* 112502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112516 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112519 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112521 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112523 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112528 */   // GIR_Coverage, 6920,
     /* 112528 */   GIR_EraseRootFromParent_Done,
     /* 112529 */ // Label 1845: @112529
     /* 112529 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(112600), // Rule ID 6921 //
     /* 112534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112548 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112548 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112551 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112555 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112560 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112578 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112598 */   GIR_RootConstrainSelectedInstOperands,
     /* 112599 */   // GIR_Coverage, 6921,
     /* 112599 */   GIR_EraseRootFromParent_Done,
     /* 112600 */ // Label 1846: @112600
     /* 112600 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(112626), // Rule ID 6922 //
     /* 112605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112619 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /* 112619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112624 */   GIR_RootConstrainSelectedInstOperands,
     /* 112625 */   // GIR_Coverage, 6922,
     /* 112625 */   GIR_Done,
     /* 112626 */ // Label 1847: @112626
     /* 112626 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(112652), // Rule ID 6923 //
     /* 112631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112645 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /* 112645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112650 */   GIR_RootConstrainSelectedInstOperands,
     /* 112651 */   // GIR_Coverage, 6923,
     /* 112651 */   GIR_Done,
     /* 112652 */ // Label 1848: @112652
     /* 112652 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(112678), // Rule ID 6924 //
     /* 112657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112671 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /* 112671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 112676 */   GIR_RootConstrainSelectedInstOperands,
     /* 112677 */   // GIR_Coverage, 6924,
     /* 112677 */   GIR_Done,
     /* 112678 */ // Label 1849: @112678
     /* 112678 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(112704), // Rule ID 6925 //
     /* 112683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112697 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /* 112697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112702 */   GIR_RootConstrainSelectedInstOperands,
     /* 112703 */   // GIR_Coverage, 6925,
     /* 112703 */   GIR_Done,
     /* 112704 */ // Label 1850: @112704
     /* 112704 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(112730), // Rule ID 6926 //
     /* 112709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112723 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /* 112723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112728 */   GIR_RootConstrainSelectedInstOperands,
     /* 112729 */   // GIR_Coverage, 6926,
     /* 112729 */   GIR_Done,
     /* 112730 */ // Label 1851: @112730
     /* 112730 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(112759), // Rule ID 6927 //
     /* 112735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112746 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112749 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112751 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112753 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112758 */   // GIR_Coverage, 6927,
     /* 112758 */   GIR_EraseRootFromParent_Done,
     /* 112759 */ // Label 1852: @112759
     /* 112759 */ GIM_Reject,
     /* 112760 */ // Label 1610: @112760
     /* 112760 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(112792), // Rule ID 6928 //
     /* 112765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112779 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112782 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112784 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112786 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112791 */   // GIR_Coverage, 6928,
     /* 112791 */   GIR_EraseRootFromParent_Done,
     /* 112792 */ // Label 1853: @112792
     /* 112792 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(112824), // Rule ID 6929 //
     /* 112797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112811 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112814 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112818 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112823 */   // GIR_Coverage, 6929,
     /* 112823 */   GIR_EraseRootFromParent_Done,
     /* 112824 */ // Label 1854: @112824
     /* 112824 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(112856), // Rule ID 6930 //
     /* 112829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112843 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112846 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112848 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112850 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112855 */   // GIR_Coverage, 6930,
     /* 112855 */   GIR_EraseRootFromParent_Done,
     /* 112856 */ // Label 1855: @112856
     /* 112856 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(112888), // Rule ID 6931 //
     /* 112861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112875 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112878 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112880 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112882 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112887 */   // GIR_Coverage, 6931,
     /* 112887 */   GIR_EraseRootFromParent_Done,
     /* 112888 */ // Label 1856: @112888
     /* 112888 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(112920), // Rule ID 6932 //
     /* 112893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112907 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112910 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112912 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112914 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112919 */   // GIR_Coverage, 6932,
     /* 112919 */   GIR_EraseRootFromParent_Done,
     /* 112920 */ // Label 1857: @112920
     /* 112920 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(112952), // Rule ID 6933 //
     /* 112925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112939 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112942 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112944 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112946 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112951 */   // GIR_Coverage, 6933,
     /* 112951 */   GIR_EraseRootFromParent_Done,
     /* 112952 */ // Label 1858: @112952
     /* 112952 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(112984), // Rule ID 6934 //
     /* 112957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112971 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112974 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112976 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112978 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112983 */   // GIR_Coverage, 6934,
     /* 112983 */   GIR_EraseRootFromParent_Done,
     /* 112984 */ // Label 1859: @112984
     /* 112984 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(113055), // Rule ID 6935 //
     /* 112989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113003 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 113003 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 113006 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 113010 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113015 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113021 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 113024 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 113028 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113033 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 113042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 113044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 113050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 113053 */   GIR_RootConstrainSelectedInstOperands,
     /* 113054 */   // GIR_Coverage, 6935,
     /* 113054 */   GIR_EraseRootFromParent_Done,
     /* 113055 */ // Label 1860: @113055
     /* 113055 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(113081), // Rule ID 6936 //
     /* 113060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113074 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /* 113074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 113079 */   GIR_RootConstrainSelectedInstOperands,
     /* 113080 */   // GIR_Coverage, 6936,
     /* 113080 */   GIR_Done,
     /* 113081 */ // Label 1861: @113081
     /* 113081 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(113107), // Rule ID 6937 //
     /* 113086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113100 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /* 113100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 113105 */   GIR_RootConstrainSelectedInstOperands,
     /* 113106 */   // GIR_Coverage, 6937,
     /* 113106 */   GIR_Done,
     /* 113107 */ // Label 1862: @113107
     /* 113107 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(113133), // Rule ID 6938 //
     /* 113112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113126 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /* 113126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 113131 */   GIR_RootConstrainSelectedInstOperands,
     /* 113132 */   // GIR_Coverage, 6938,
     /* 113132 */   GIR_Done,
     /* 113133 */ // Label 1863: @113133
     /* 113133 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(113159), // Rule ID 6939 //
     /* 113138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113152 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /* 113152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 113157 */   GIR_RootConstrainSelectedInstOperands,
     /* 113158 */   // GIR_Coverage, 6939,
     /* 113158 */   GIR_Done,
     /* 113159 */ // Label 1864: @113159
     /* 113159 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(113185), // Rule ID 6940 //
     /* 113164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113178 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /* 113178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 113183 */   GIR_RootConstrainSelectedInstOperands,
     /* 113184 */   // GIR_Coverage, 6940,
     /* 113184 */   GIR_Done,
     /* 113185 */ // Label 1865: @113185
     /* 113185 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(113211), // Rule ID 6941 //
     /* 113190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113204 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /* 113204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 113209 */   GIR_RootConstrainSelectedInstOperands,
     /* 113210 */   // GIR_Coverage, 6941,
     /* 113210 */   GIR_Done,
     /* 113211 */ // Label 1866: @113211
     /* 113211 */ GIM_Reject,
     /* 113212 */ // Label 1611: @113212
     /* 113212 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(113244), // Rule ID 10642 //
     /* 113217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113231 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113234 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113236 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113238 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113243 */   // GIR_Coverage, 10642,
     /* 113243 */   GIR_EraseRootFromParent_Done,
     /* 113244 */ // Label 1867: @113244
     /* 113244 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(113276), // Rule ID 10643 //
     /* 113249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113263 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113266 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113268 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113270 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113275 */   // GIR_Coverage, 10643,
     /* 113275 */   GIR_EraseRootFromParent_Done,
     /* 113276 */ // Label 1868: @113276
     /* 113276 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(113308), // Rule ID 10644 //
     /* 113281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113295 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113298 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113300 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113307 */   // GIR_Coverage, 10644,
     /* 113307 */   GIR_EraseRootFromParent_Done,
     /* 113308 */ // Label 1869: @113308
     /* 113308 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(113340), // Rule ID 10645 //
     /* 113313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113327 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113330 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113332 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113334 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113339 */   // GIR_Coverage, 10645,
     /* 113339 */   GIR_EraseRootFromParent_Done,
     /* 113340 */ // Label 1870: @113340
     /* 113340 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(113372), // Rule ID 10646 //
     /* 113345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113359 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113362 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113364 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113371 */   // GIR_Coverage, 10646,
     /* 113371 */   GIR_EraseRootFromParent_Done,
     /* 113372 */ // Label 1871: @113372
     /* 113372 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(113404), // Rule ID 10647 //
     /* 113377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113391 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113394 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113396 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113398 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113403 */   // GIR_Coverage, 10647,
     /* 113403 */   GIR_EraseRootFromParent_Done,
     /* 113404 */ // Label 1872: @113404
     /* 113404 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(113436), // Rule ID 10660 //
     /* 113409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113423 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113426 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113428 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113430 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113435 */   // GIR_Coverage, 10660,
     /* 113435 */   GIR_EraseRootFromParent_Done,
     /* 113436 */ // Label 1873: @113436
     /* 113436 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(113468), // Rule ID 10661 //
     /* 113441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113455 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113458 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113460 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113462 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113467 */   // GIR_Coverage, 10661,
     /* 113467 */   GIR_EraseRootFromParent_Done,
     /* 113468 */ // Label 1874: @113468
     /* 113468 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(113500), // Rule ID 10662 //
     /* 113473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113487 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113490 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113492 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113494 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113499 */   // GIR_Coverage, 10662,
     /* 113499 */   GIR_EraseRootFromParent_Done,
     /* 113500 */ // Label 1875: @113500
     /* 113500 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(113532), // Rule ID 10663 //
     /* 113505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113519 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113522 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113524 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113526 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113531 */   // GIR_Coverage, 10663,
     /* 113531 */   GIR_EraseRootFromParent_Done,
     /* 113532 */ // Label 1876: @113532
     /* 113532 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(113564), // Rule ID 10664 //
     /* 113537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113551 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113554 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113558 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113563 */   // GIR_Coverage, 10664,
     /* 113563 */   GIR_EraseRootFromParent_Done,
     /* 113564 */ // Label 1877: @113564
     /* 113564 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(113596), // Rule ID 10665 //
     /* 113569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113583 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113586 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113588 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113590 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113595 */   // GIR_Coverage, 10665,
     /* 113595 */   GIR_EraseRootFromParent_Done,
     /* 113596 */ // Label 1878: @113596
     /* 113596 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(113628), // Rule ID 10670 //
     /* 113601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 113604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113615 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113618 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113620 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113622 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113627 */   // GIR_Coverage, 10670,
     /* 113627 */   GIR_EraseRootFromParent_Done,
     /* 113628 */ // Label 1879: @113628
     /* 113628 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(113660), // Rule ID 10671 //
     /* 113633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 113636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113647 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113650 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113652 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113654 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113659 */   // GIR_Coverage, 10671,
     /* 113659 */   GIR_EraseRootFromParent_Done,
     /* 113660 */ // Label 1880: @113660
     /* 113660 */ GIM_Reject,
     /* 113661 */ // Label 1612: @113661
     /* 113661 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(113693), // Rule ID 10636 //
     /* 113666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113680 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113683 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113685 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113687 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113692 */   // GIR_Coverage, 10636,
     /* 113692 */   GIR_EraseRootFromParent_Done,
     /* 113693 */ // Label 1881: @113693
     /* 113693 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(113725), // Rule ID 10637 //
     /* 113698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113712 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113715 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113717 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113724 */   // GIR_Coverage, 10637,
     /* 113724 */   GIR_EraseRootFromParent_Done,
     /* 113725 */ // Label 1882: @113725
     /* 113725 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(113757), // Rule ID 10638 //
     /* 113730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113744 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113747 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113749 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113756 */   // GIR_Coverage, 10638,
     /* 113756 */   GIR_EraseRootFromParent_Done,
     /* 113757 */ // Label 1883: @113757
     /* 113757 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(113789), // Rule ID 10639 //
     /* 113762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113776 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113779 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113781 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113783 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113788 */   // GIR_Coverage, 10639,
     /* 113788 */   GIR_EraseRootFromParent_Done,
     /* 113789 */ // Label 1884: @113789
     /* 113789 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(113821), // Rule ID 10640 //
     /* 113794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113808 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113811 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113813 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113815 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113820 */   // GIR_Coverage, 10640,
     /* 113820 */   GIR_EraseRootFromParent_Done,
     /* 113821 */ // Label 1885: @113821
     /* 113821 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(113853), // Rule ID 10641 //
     /* 113826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113840 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113843 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113845 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113847 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113852 */   // GIR_Coverage, 10641,
     /* 113852 */   GIR_EraseRootFromParent_Done,
     /* 113853 */ // Label 1886: @113853
     /* 113853 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(113885), // Rule ID 10654 //
     /* 113858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113872 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113875 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113884 */   // GIR_Coverage, 10654,
     /* 113884 */   GIR_EraseRootFromParent_Done,
     /* 113885 */ // Label 1887: @113885
     /* 113885 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(113917), // Rule ID 10655 //
     /* 113890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113904 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113907 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113909 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113911 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113916 */   // GIR_Coverage, 10655,
     /* 113916 */   GIR_EraseRootFromParent_Done,
     /* 113917 */ // Label 1888: @113917
     /* 113917 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(113949), // Rule ID 10656 //
     /* 113922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113936 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113939 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113941 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113943 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113948 */   // GIR_Coverage, 10656,
     /* 113948 */   GIR_EraseRootFromParent_Done,
     /* 113949 */ // Label 1889: @113949
     /* 113949 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(113981), // Rule ID 10657 //
     /* 113954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113968 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113971 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113973 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113975 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113980 */   // GIR_Coverage, 10657,
     /* 113980 */   GIR_EraseRootFromParent_Done,
     /* 113981 */ // Label 1890: @113981
     /* 113981 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(114013), // Rule ID 10658 //
     /* 113986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114000 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 114000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114003 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114005 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114007 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114012 */   // GIR_Coverage, 10658,
     /* 114012 */   GIR_EraseRootFromParent_Done,
     /* 114013 */ // Label 1891: @114013
     /* 114013 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(114045), // Rule ID 10659 //
     /* 114018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114032 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 114032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114035 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114037 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114039 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114044 */   // GIR_Coverage, 10659,
     /* 114044 */   GIR_EraseRootFromParent_Done,
     /* 114045 */ // Label 1892: @114045
     /* 114045 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(114077), // Rule ID 10668 //
     /* 114050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 114053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114064 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 114064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114067 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114069 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114076 */   // GIR_Coverage, 10668,
     /* 114076 */   GIR_EraseRootFromParent_Done,
     /* 114077 */ // Label 1893: @114077
     /* 114077 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(114109), // Rule ID 10669 //
     /* 114082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 114085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114096 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 114096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114099 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114101 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114103 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114108 */   // GIR_Coverage, 10669,
     /* 114108 */   GIR_EraseRootFromParent_Done,
     /* 114109 */ // Label 1894: @114109
     /* 114109 */ GIM_Reject,
     /* 114110 */ // Label 1613: @114110
     /* 114110 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(114142), // Rule ID 10630 //
     /* 114115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 114121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114129 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114132 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114134 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114141 */   // GIR_Coverage, 10630,
     /* 114141 */   GIR_EraseRootFromParent_Done,
     /* 114142 */ // Label 1895: @114142
     /* 114142 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(114174), // Rule ID 10631 //
     /* 114147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114161 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114164 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114166 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114168 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114173 */   // GIR_Coverage, 10631,
     /* 114173 */   GIR_EraseRootFromParent_Done,
     /* 114174 */ // Label 1896: @114174
     /* 114174 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(114206), // Rule ID 10632 //
     /* 114179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114193 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114196 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114198 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114200 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114205 */   // GIR_Coverage, 10632,
     /* 114205 */   GIR_EraseRootFromParent_Done,
     /* 114206 */ // Label 1897: @114206
     /* 114206 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(114238), // Rule ID 10633 //
     /* 114211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114225 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114228 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114230 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114232 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114237 */   // GIR_Coverage, 10633,
     /* 114237 */   GIR_EraseRootFromParent_Done,
     /* 114238 */ // Label 1898: @114238
     /* 114238 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(114270), // Rule ID 10634 //
     /* 114243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114257 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114260 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114262 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114264 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114269 */   // GIR_Coverage, 10634,
     /* 114269 */   GIR_EraseRootFromParent_Done,
     /* 114270 */ // Label 1899: @114270
     /* 114270 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(114302), // Rule ID 10635 //
     /* 114275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114289 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114292 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114294 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114296 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114301 */   // GIR_Coverage, 10635,
     /* 114301 */   GIR_EraseRootFromParent_Done,
     /* 114302 */ // Label 1900: @114302
     /* 114302 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(114334), // Rule ID 10648 //
     /* 114307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 114313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114321 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114324 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114326 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114328 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114333 */   // GIR_Coverage, 10648,
     /* 114333 */   GIR_EraseRootFromParent_Done,
     /* 114334 */ // Label 1901: @114334
     /* 114334 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(114366), // Rule ID 10649 //
     /* 114339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114353 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114356 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114358 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114365 */   // GIR_Coverage, 10649,
     /* 114365 */   GIR_EraseRootFromParent_Done,
     /* 114366 */ // Label 1902: @114366
     /* 114366 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(114398), // Rule ID 10650 //
     /* 114371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114385 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114388 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114390 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114392 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114397 */   // GIR_Coverage, 10650,
     /* 114397 */   GIR_EraseRootFromParent_Done,
     /* 114398 */ // Label 1903: @114398
     /* 114398 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(114430), // Rule ID 10651 //
     /* 114403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114417 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114420 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114422 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114424 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114429 */   // GIR_Coverage, 10651,
     /* 114429 */   GIR_EraseRootFromParent_Done,
     /* 114430 */ // Label 1904: @114430
     /* 114430 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(114462), // Rule ID 10652 //
     /* 114435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114449 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114452 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114454 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114456 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114461 */   // GIR_Coverage, 10652,
     /* 114461 */   GIR_EraseRootFromParent_Done,
     /* 114462 */ // Label 1905: @114462
     /* 114462 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(114494), // Rule ID 10653 //
     /* 114467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114481 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114484 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114486 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114488 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114493 */   // GIR_Coverage, 10653,
     /* 114493 */   GIR_EraseRootFromParent_Done,
     /* 114494 */ // Label 1906: @114494
     /* 114494 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(114526), // Rule ID 10666 //
     /* 114499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 114502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114513 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114516 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114518 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114525 */   // GIR_Coverage, 10666,
     /* 114525 */   GIR_EraseRootFromParent_Done,
     /* 114526 */ // Label 1907: @114526
     /* 114526 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(114558), // Rule ID 10667 //
     /* 114531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 114534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114545 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114548 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114550 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114557 */   // GIR_Coverage, 10667,
     /* 114557 */   GIR_EraseRootFromParent_Done,
     /* 114558 */ // Label 1908: @114558
     /* 114558 */ GIM_Reject,
     /* 114559 */ // Label 1614: @114559
     /* 114559 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(114591), // Rule ID 10624 //
     /* 114564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114578 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114581 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114583 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114585 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114590 */   // GIR_Coverage, 10624,
     /* 114590 */   GIR_EraseRootFromParent_Done,
     /* 114591 */ // Label 1909: @114591
     /* 114591 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(114623), // Rule ID 10625 //
     /* 114596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114610 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114613 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114615 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114617 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114622 */   // GIR_Coverage, 10625,
     /* 114622 */   GIR_EraseRootFromParent_Done,
     /* 114623 */ // Label 1910: @114623
     /* 114623 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(114655), // Rule ID 10626 //
     /* 114628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114642 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114645 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114647 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114649 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114654 */   // GIR_Coverage, 10626,
     /* 114654 */   GIR_EraseRootFromParent_Done,
     /* 114655 */ // Label 1911: @114655
     /* 114655 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(114687), // Rule ID 10627 //
     /* 114660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114674 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114677 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114679 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114686 */   // GIR_Coverage, 10627,
     /* 114686 */   GIR_EraseRootFromParent_Done,
     /* 114687 */ // Label 1912: @114687
     /* 114687 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(114719), // Rule ID 10628 //
     /* 114692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114706 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114709 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114711 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114713 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114718 */   // GIR_Coverage, 10628,
     /* 114718 */   GIR_EraseRootFromParent_Done,
     /* 114719 */ // Label 1913: @114719
     /* 114719 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(114751), // Rule ID 10629 //
     /* 114724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114738 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114741 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114743 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114745 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114750 */   // GIR_Coverage, 10629,
     /* 114750 */   GIR_EraseRootFromParent_Done,
     /* 114751 */ // Label 1914: @114751
     /* 114751 */ GIM_Reject,
     /* 114752 */ // Label 1615: @114752
     /* 114752 */ GIM_Reject,
     /* 114753 */ // Label 10: @114753
     /* 114753 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1923*/ GIMT_Encode4(115243),
     /* 114764 */ /*GILLT_s16*//*Label 1915*/ GIMT_Encode4(114804),
     /* 114768 */ /*GILLT_s32*//*Label 1916*/ GIMT_Encode4(114835),
     /* 114772 */ /*GILLT_s64*//*Label 1917*/ GIMT_Encode4(114866), GIMT_Encode4(0),
     /* 114780 */ /*GILLT_v2s32*//*Label 1918*/ GIMT_Encode4(114897),
     /* 114784 */ /*GILLT_v2s64*//*Label 1919*/ GIMT_Encode4(114928),
     /* 114788 */ /*GILLT_v4s16*//*Label 1920*/ GIMT_Encode4(114959),
     /* 114792 */ /*GILLT_v4s32*//*Label 1921*/ GIMT_Encode4(114990), GIMT_Encode4(0),
     /* 114800 */ /*GILLT_v8s16*//*Label 1922*/ GIMT_Encode4(115021),
     /* 114804 */ // Label 1915: @114804
     /* 114804 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(114834), // Rule ID 564 //
     /* 114809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 114812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114823 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 114823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /* 114828 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114832 */   GIR_RootConstrainSelectedInstOperands,
     /* 114833 */   // GIR_Coverage, 564,
     /* 114833 */   GIR_Done,
     /* 114834 */ // Label 1924: @114834
     /* 114834 */ GIM_Reject,
     /* 114835 */ // Label 1916: @114835
     /* 114835 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(114865), // Rule ID 566 //
     /* 114840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 114843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114854 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 114854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /* 114859 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114863 */   GIR_RootConstrainSelectedInstOperands,
     /* 114864 */   // GIR_Coverage, 566,
     /* 114864 */   GIR_Done,
     /* 114865 */ // Label 1925: @114865
     /* 114865 */ GIM_Reject,
     /* 114866 */ // Label 1917: @114866
     /* 114866 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(114896), // Rule ID 568 //
     /* 114871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 114874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114885 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 114885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /* 114890 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114894 */   GIR_RootConstrainSelectedInstOperands,
     /* 114895 */   // GIR_Coverage, 568,
     /* 114895 */   GIR_Done,
     /* 114896 */ // Label 1926: @114896
     /* 114896 */ GIM_Reject,
     /* 114897 */ // Label 1918: @114897
     /* 114897 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(114927), // Rule ID 933 //
     /* 114902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114916 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 114916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /* 114921 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114925 */   GIR_RootConstrainSelectedInstOperands,
     /* 114926 */   // GIR_Coverage, 933,
     /* 114926 */   GIR_Done,
     /* 114927 */ // Label 1927: @114927
     /* 114927 */ GIM_Reject,
     /* 114928 */ // Label 1919: @114928
     /* 114928 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(114958), // Rule ID 937 //
     /* 114933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114947 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 114947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /* 114952 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114956 */   GIR_RootConstrainSelectedInstOperands,
     /* 114957 */   // GIR_Coverage, 937,
     /* 114957 */   GIR_Done,
     /* 114958 */ // Label 1928: @114958
     /* 114958 */ GIM_Reject,
     /* 114959 */ // Label 1920: @114959
     /* 114959 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(114989), // Rule ID 929 //
     /* 114964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114978 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 114978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /* 114983 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114987 */   GIR_RootConstrainSelectedInstOperands,
     /* 114988 */   // GIR_Coverage, 929,
     /* 114988 */   GIR_Done,
     /* 114989 */ // Label 1929: @114989
     /* 114989 */ GIM_Reject,
     /* 114990 */ // Label 1921: @114990
     /* 114990 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(115020), // Rule ID 935 //
     /* 114995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115009 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 115009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 115014 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115018 */   GIR_RootConstrainSelectedInstOperands,
     /* 115019 */   // GIR_Coverage, 935,
     /* 115019 */   GIR_Done,
     /* 115020 */ // Label 1930: @115020
     /* 115020 */ GIM_Reject,
     /* 115021 */ // Label 1922: @115021
     /* 115021 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(115242),
     /* 115026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115037 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(115056), // Rule ID 931 //
     /* 115042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 115045 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 115045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /* 115050 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115054 */     GIR_RootConstrainSelectedInstOperands,
     /* 115055 */     // GIR_Coverage, 931,
     /* 115055 */     GIR_Done,
     /* 115056 */   // Label 1932: @115056
     /* 115056 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(115241), // Rule ID 7060 //
     /* 115061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 115064 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 115064 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 115067 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 115071 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115076 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 115082 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 115085 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 115089 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115094 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 115097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 115099 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 115102 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115106 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115111 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 115117 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115122 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115127 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 115130 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 115134 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115139 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 115142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 115144 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 115147 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 115151 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115156 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 115159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115161 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 115164 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 115168 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115173 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 115176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115178 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 115181 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115185 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 115199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115204 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115207 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 115210 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 115231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 115239 */     GIR_RootConstrainSelectedInstOperands,
     /* 115240 */     // GIR_Coverage, 7060,
     /* 115240 */     GIR_EraseRootFromParent_Done,
     /* 115241 */   // Label 1933: @115241
     /* 115241 */   GIM_Reject,
     /* 115242 */ // Label 1931: @115242
     /* 115242 */ GIM_Reject,
     /* 115243 */ // Label 1923: @115243
     /* 115243 */ GIM_Reject,
     /* 115244 */ // Label 11: @115244
     /* 115244 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1942*/ GIMT_Encode4(115734),
     /* 115255 */ /*GILLT_s16*//*Label 1934*/ GIMT_Encode4(115295),
     /* 115259 */ /*GILLT_s32*//*Label 1935*/ GIMT_Encode4(115326),
     /* 115263 */ /*GILLT_s64*//*Label 1936*/ GIMT_Encode4(115357), GIMT_Encode4(0),
     /* 115271 */ /*GILLT_v2s32*//*Label 1937*/ GIMT_Encode4(115388),
     /* 115275 */ /*GILLT_v2s64*//*Label 1938*/ GIMT_Encode4(115419),
     /* 115279 */ /*GILLT_v4s16*//*Label 1939*/ GIMT_Encode4(115450),
     /* 115283 */ /*GILLT_v4s32*//*Label 1940*/ GIMT_Encode4(115481), GIMT_Encode4(0),
     /* 115291 */ /*GILLT_v8s16*//*Label 1941*/ GIMT_Encode4(115512),
     /* 115295 */ // Label 1934: @115295
     /* 115295 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(115325), // Rule ID 528 //
     /* 115300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 115310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 115314 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 115314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /* 115319 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115323 */   GIR_RootConstrainSelectedInstOperands,
     /* 115324 */   // GIR_Coverage, 528,
     /* 115324 */   GIR_Done,
     /* 115325 */ // Label 1943: @115325
     /* 115325 */ GIM_Reject,
     /* 115326 */ // Label 1935: @115326
     /* 115326 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(115356), // Rule ID 530 //
     /* 115331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115345 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 115345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /* 115350 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115354 */   GIR_RootConstrainSelectedInstOperands,
     /* 115355 */   // GIR_Coverage, 530,
     /* 115355 */   GIR_Done,
     /* 115356 */ // Label 1944: @115356
     /* 115356 */ GIM_Reject,
     /* 115357 */ // Label 1936: @115357
     /* 115357 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(115387), // Rule ID 532 //
     /* 115362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115376 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 115376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /* 115381 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115385 */   GIR_RootConstrainSelectedInstOperands,
     /* 115386 */   // GIR_Coverage, 532,
     /* 115386 */   GIR_Done,
     /* 115387 */ // Label 1945: @115387
     /* 115387 */ GIM_Reject,
     /* 115388 */ // Label 1937: @115388
     /* 115388 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(115418), // Rule ID 873 //
     /* 115393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115407 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 115407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /* 115412 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115416 */   GIR_RootConstrainSelectedInstOperands,
     /* 115417 */   // GIR_Coverage, 873,
     /* 115417 */   GIR_Done,
     /* 115418 */ // Label 1946: @115418
     /* 115418 */ GIM_Reject,
     /* 115419 */ // Label 1938: @115419
     /* 115419 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(115449), // Rule ID 877 //
     /* 115424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 115430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115438 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 115438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /* 115443 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115447 */   GIR_RootConstrainSelectedInstOperands,
     /* 115448 */   // GIR_Coverage, 877,
     /* 115448 */   GIR_Done,
     /* 115449 */ // Label 1947: @115449
     /* 115449 */ GIM_Reject,
     /* 115450 */ // Label 1939: @115450
     /* 115450 */ GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(115480), // Rule ID 869 //
     /* 115455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 115458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 115461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115469 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 115469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /* 115474 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115478 */   GIR_RootConstrainSelectedInstOperands,
     /* 115479 */   // GIR_Coverage, 869,
     /* 115479 */   GIR_Done,
     /* 115480 */ // Label 1948: @115480
     /* 115480 */ GIM_Reject,
     /* 115481 */ // Label 1940: @115481
     /* 115481 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(115511), // Rule ID 875 //
     /* 115486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115500 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 115500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 115505 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115509 */   GIR_RootConstrainSelectedInstOperands,
     /* 115510 */   // GIR_Coverage, 875,
     /* 115510 */   GIR_Done,
     /* 115511 */ // Label 1949: @115511
     /* 115511 */ GIM_Reject,
     /* 115512 */ // Label 1941: @115512
     /* 115512 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(115733),
     /* 115517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115528 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(115547), // Rule ID 871 //
     /* 115533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 115536 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 115536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /* 115541 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115545 */     GIR_RootConstrainSelectedInstOperands,
     /* 115546 */     // GIR_Coverage, 871,
     /* 115546 */     GIR_Done,
     /* 115547 */   // Label 1951: @115547
     /* 115547 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(115732), // Rule ID 7054 //
     /* 115552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 115555 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 115555 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 115558 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 115562 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115567 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 115573 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 115576 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 115580 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115585 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 115588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 115590 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 115593 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115597 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115602 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 115608 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115613 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115618 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 115621 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 115625 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115630 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 115633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 115635 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 115638 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 115642 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115647 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 115650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115652 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 115655 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 115659 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115664 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 115667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 115672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 115690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115695 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115698 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 115701 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 115722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 115730 */     GIR_RootConstrainSelectedInstOperands,
     /* 115731 */     // GIR_Coverage, 7054,
     /* 115731 */     GIR_EraseRootFromParent_Done,
     /* 115732 */   // Label 1952: @115732
     /* 115732 */   GIM_Reject,
     /* 115733 */ // Label 1950: @115733
     /* 115733 */ GIM_Reject,
     /* 115734 */ // Label 1942: @115734
     /* 115734 */ GIM_Reject,
     /* 115735 */ // Label 12: @115735
     /* 115735 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1955*/ GIMT_Encode4(116002),
     /* 115746 */ /*GILLT_s32*//*Label 1953*/ GIMT_Encode4(115754),
     /* 115750 */ /*GILLT_s64*//*Label 1954*/ GIMT_Encode4(115878),
     /* 115754 */ // Label 1953: @115754
     /* 115754 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(115797), // Rule ID 4821 //
     /* 115759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115769 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 115769 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 115772 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 115776 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115781 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 115790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115792 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115795 */   GIR_RootConstrainSelectedInstOperands,
     /* 115796 */   // GIR_Coverage, 4821,
     /* 115796 */   GIR_EraseRootFromParent_Done,
     /* 115797 */ // Label 1956: @115797
     /* 115797 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(115837), // Rule ID 4827 //
     /* 115802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115809 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 115809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 115816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115821 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 115830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115835 */   GIR_RootConstrainSelectedInstOperands,
     /* 115836 */   // GIR_Coverage, 4827,
     /* 115836 */   GIR_EraseRootFromParent_Done,
     /* 115837 */ // Label 1957: @115837
     /* 115837 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(115877), // Rule ID 4829 //
     /* 115842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115849 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 115849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 115852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 115856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115861 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 115870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115875 */   GIR_RootConstrainSelectedInstOperands,
     /* 115876 */   // GIR_Coverage, 4829,
     /* 115876 */   GIR_EraseRootFromParent_Done,
     /* 115877 */ // Label 1958: @115877
     /* 115877 */ GIM_Reject,
     /* 115878 */ // Label 1954: @115878
     /* 115878 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(115921), // Rule ID 4823 //
     /* 115883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115893 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 115893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 115896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 115900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115905 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 115914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115919 */   GIR_RootConstrainSelectedInstOperands,
     /* 115920 */   // GIR_Coverage, 4823,
     /* 115920 */   GIR_EraseRootFromParent_Done,
     /* 115921 */ // Label 1959: @115921
     /* 115921 */ GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(115961), // Rule ID 4831 //
     /* 115926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115933 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 115933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 115940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115945 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 115954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115959 */   GIR_RootConstrainSelectedInstOperands,
     /* 115960 */   // GIR_Coverage, 4831,
     /* 115960 */   GIR_EraseRootFromParent_Done,
     /* 115961 */ // Label 1960: @115961
     /* 115961 */ GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(116001), // Rule ID 4833 //
     /* 115966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115973 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 115973 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 115976 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 115980 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115985 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 115994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115999 */   GIR_RootConstrainSelectedInstOperands,
     /* 116000 */   // GIR_Coverage, 4833,
     /* 116000 */   GIR_EraseRootFromParent_Done,
     /* 116001 */ // Label 1961: @116001
     /* 116001 */ GIM_Reject,
     /* 116002 */ // Label 1955: @116002
     /* 116002 */ GIM_Reject,
     /* 116003 */ // Label 13: @116003
     /* 116003 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(116152),
     /* 116008 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 116011 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1966*/ GIMT_Encode4(116151),
     /* 116022 */   /*GILLT_s16*//*Label 1963*/ GIMT_Encode4(116034),
     /* 116026 */   /*GILLT_s32*//*Label 1964*/ GIMT_Encode4(116075),
     /* 116030 */   /*GILLT_s64*//*Label 1965*/ GIMT_Encode4(116113),
     /* 116034 */   // Label 1963: @116034
     /* 116034 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(116074), // Rule ID 4825 //
     /* 116039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116046 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 116046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 116049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 116053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 116067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 116069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116072 */     GIR_RootConstrainSelectedInstOperands,
     /* 116073 */     // GIR_Coverage, 4825,
     /* 116073 */     GIR_EraseRootFromParent_Done,
     /* 116074 */   // Label 1967: @116074
     /* 116074 */   GIM_Reject,
     /* 116075 */   // Label 1964: @116075
     /* 116075 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(116112), // Rule ID 4835 //
     /* 116080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116084 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 116084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 116091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 116105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 116107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116110 */     GIR_RootConstrainSelectedInstOperands,
     /* 116111 */     // GIR_Coverage, 4835,
     /* 116111 */     GIR_EraseRootFromParent_Done,
     /* 116112 */   // Label 1968: @116112
     /* 116112 */   GIM_Reject,
     /* 116113 */   // Label 1965: @116113
     /* 116113 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(116150), // Rule ID 4837 //
     /* 116118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116122 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 116122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 116125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 116129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 116143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 116145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116148 */     GIR_RootConstrainSelectedInstOperands,
     /* 116149 */     // GIR_Coverage, 4837,
     /* 116149 */     GIR_EraseRootFromParent_Done,
     /* 116150 */   // Label 1969: @116150
     /* 116150 */   GIM_Reject,
     /* 116151 */   // Label 1966: @116151
     /* 116151 */   GIM_Reject,
     /* 116152 */ // Label 1962: @116152
     /* 116152 */ GIM_Reject,
     /* 116153 */ // Label 14: @116153
     /* 116153 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1978*/ GIMT_Encode4(116643),
     /* 116164 */ /*GILLT_s16*//*Label 1970*/ GIMT_Encode4(116204),
     /* 116168 */ /*GILLT_s32*//*Label 1971*/ GIMT_Encode4(116235),
     /* 116172 */ /*GILLT_s64*//*Label 1972*/ GIMT_Encode4(116266), GIMT_Encode4(0),
     /* 116180 */ /*GILLT_v2s32*//*Label 1973*/ GIMT_Encode4(116297),
     /* 116184 */ /*GILLT_v2s64*//*Label 1974*/ GIMT_Encode4(116328),
     /* 116188 */ /*GILLT_v4s16*//*Label 1975*/ GIMT_Encode4(116359),
     /* 116192 */ /*GILLT_v4s32*//*Label 1976*/ GIMT_Encode4(116390), GIMT_Encode4(0),
     /* 116200 */ /*GILLT_v8s16*//*Label 1977*/ GIMT_Encode4(116421),
     /* 116204 */ // Label 1970: @116204
     /* 116204 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(116234), // Rule ID 546 //
     /* 116209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116223 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 116223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /* 116228 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116232 */   GIR_RootConstrainSelectedInstOperands,
     /* 116233 */   // GIR_Coverage, 546,
     /* 116233 */   GIR_Done,
     /* 116234 */ // Label 1979: @116234
     /* 116234 */ GIM_Reject,
     /* 116235 */ // Label 1971: @116235
     /* 116235 */ GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(116265), // Rule ID 548 //
     /* 116240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116254 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 116254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /* 116259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116263 */   GIR_RootConstrainSelectedInstOperands,
     /* 116264 */   // GIR_Coverage, 548,
     /* 116264 */   GIR_Done,
     /* 116265 */ // Label 1980: @116265
     /* 116265 */ GIM_Reject,
     /* 116266 */ // Label 1972: @116266
     /* 116266 */ GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(116296), // Rule ID 550 //
     /* 116271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116285 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 116285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /* 116290 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116294 */   GIR_RootConstrainSelectedInstOperands,
     /* 116295 */   // GIR_Coverage, 550,
     /* 116295 */   GIR_Done,
     /* 116296 */ // Label 1981: @116296
     /* 116296 */ GIM_Reject,
     /* 116297 */ // Label 1973: @116297
     /* 116297 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(116327), // Rule ID 903 //
     /* 116302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116316 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 116316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /* 116321 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116325 */   GIR_RootConstrainSelectedInstOperands,
     /* 116326 */   // GIR_Coverage, 903,
     /* 116326 */   GIR_Done,
     /* 116327 */ // Label 1982: @116327
     /* 116327 */ GIM_Reject,
     /* 116328 */ // Label 1974: @116328
     /* 116328 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(116358), // Rule ID 907 //
     /* 116333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 116339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116347 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 116347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /* 116352 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116356 */   GIR_RootConstrainSelectedInstOperands,
     /* 116357 */   // GIR_Coverage, 907,
     /* 116357 */   GIR_Done,
     /* 116358 */ // Label 1983: @116358
     /* 116358 */ GIM_Reject,
     /* 116359 */ // Label 1975: @116359
     /* 116359 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(116389), // Rule ID 899 //
     /* 116364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116378 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 116378 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /* 116383 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116387 */   GIR_RootConstrainSelectedInstOperands,
     /* 116388 */   // GIR_Coverage, 899,
     /* 116388 */   GIR_Done,
     /* 116389 */ // Label 1984: @116389
     /* 116389 */ GIM_Reject,
     /* 116390 */ // Label 1976: @116390
     /* 116390 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(116420), // Rule ID 905 //
     /* 116395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116409 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 116409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 116414 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116418 */   GIR_RootConstrainSelectedInstOperands,
     /* 116419 */   // GIR_Coverage, 905,
     /* 116419 */   GIR_Done,
     /* 116420 */ // Label 1985: @116420
     /* 116420 */ GIM_Reject,
     /* 116421 */ // Label 1977: @116421
     /* 116421 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(116642),
     /* 116426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116437 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(116456), // Rule ID 901 //
     /* 116442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116445 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 116445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /* 116450 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116454 */     GIR_RootConstrainSelectedInstOperands,
     /* 116455 */     // GIR_Coverage, 901,
     /* 116455 */     GIR_Done,
     /* 116456 */   // Label 1987: @116456
     /* 116456 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(116641), // Rule ID 7056 //
     /* 116461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 116464 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 116464 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 116467 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 116471 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116476 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 116482 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 116485 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 116489 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116494 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 116497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 116499 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 116502 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116506 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116511 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 116517 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116522 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116527 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 116530 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 116534 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116539 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 116542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 116544 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 116547 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 116551 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116556 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 116559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 116564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 116568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116573 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 116576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116578 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 116581 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116585 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116607 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 116610 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 116631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 116639 */     GIR_RootConstrainSelectedInstOperands,
     /* 116640 */     // GIR_Coverage, 7056,
     /* 116640 */     GIR_EraseRootFromParent_Done,
     /* 116641 */   // Label 1988: @116641
     /* 116641 */   GIM_Reject,
     /* 116642 */ // Label 1986: @116642
     /* 116642 */ GIM_Reject,
     /* 116643 */ // Label 1978: @116643
     /* 116643 */ GIM_Reject,
     /* 116644 */ // Label 15: @116644
     /* 116644 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(116676), // Rule ID 3904 //
     /* 116649 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 116652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116656 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /* 116656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 116659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116661 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /* 116671 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 116674 */   GIR_RootConstrainSelectedInstOperands,
     /* 116675 */   // GIR_Coverage, 3904,
     /* 116675 */   GIR_EraseRootFromParent_Done,
     /* 116676 */ // Label 1989: @116676
     /* 116676 */ GIM_Reject,
     /* 116677 */ // Label 16: @116677
     /* 116677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2010*/ GIMT_Encode4(125614),
     /* 116688 */ /*GILLT_s8*//*Label 1990*/ GIMT_Encode4(116784),
     /* 116692 */ /*GILLT_s16*//*Label 1991*/ GIMT_Encode4(116960),
     /* 116696 */ /*GILLT_s32*//*Label 1992*/ GIMT_Encode4(117136),
     /* 116700 */ /*GILLT_s64*//*Label 1993*/ GIMT_Encode4(119530),
     /* 116704 */ /*GILLT_s128*//*Label 1994*/ GIMT_Encode4(122243),
     /* 116708 */ /*GILLT_v2s32*//*Label 1995*/ GIMT_Encode4(122452),
     /* 116712 */ /*GILLT_v2s64*//*Label 1996*/ GIMT_Encode4(122830),
     /* 116716 */ /*GILLT_v4s16*//*Label 1997*/ GIMT_Encode4(123208),
     /* 116720 */ /*GILLT_v4s32*//*Label 1998*/ GIMT_Encode4(123586),
     /* 116724 */ /*GILLT_v8s8*//*Label 1999*/ GIMT_Encode4(123964),
     /* 116728 */ /*GILLT_v8s16*//*Label 2000*/ GIMT_Encode4(124172),
     /* 116732 */ /*GILLT_v16s8*//*Label 2001*/ GIMT_Encode4(124550), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116744 */ /*GILLT_nxv2s16*//*Label 2002*/ GIMT_Encode4(124758),
     /* 116748 */ /*GILLT_nxv2s32*//*Label 2003*/ GIMT_Encode4(124822),
     /* 116752 */ /*GILLT_nxv2s64*//*Label 2004*/ GIMT_Encode4(124886), GIMT_Encode4(0),
     /* 116760 */ /*GILLT_nxv4s16*//*Label 2005*/ GIMT_Encode4(125060),
     /* 116764 */ /*GILLT_nxv4s32*//*Label 2006*/ GIMT_Encode4(125124), GIMT_Encode4(0),
     /* 116772 */ /*GILLT_nxv8s16*//*Label 2007*/ GIMT_Encode4(125298),
     /* 116776 */ /*GILLT_nxv16s1*//*Label 2008*/ GIMT_Encode4(125472),
     /* 116780 */ /*GILLT_nxv16s8*//*Label 2009*/ GIMT_Encode4(125516),
     /* 116784 */ // Label 1990: @116784
     /* 116784 */ GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(116959),
     /* 116789 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 116800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116804 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(116845), // Rule ID 237 //
     /* 116809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 116819 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 116819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 116822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116843 */     GIR_RootConstrainSelectedInstOperands,
     /* 116844 */     // GIR_Coverage, 237,
     /* 116844 */     GIR_EraseRootFromParent_Done,
     /* 116845 */   // Label 2012: @116845
     /* 116845 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(116886), // Rule ID 238 //
     /* 116850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 116860 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 116860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 116863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116884 */     GIR_RootConstrainSelectedInstOperands,
     /* 116885 */     // GIR_Coverage, 238,
     /* 116885 */     GIR_EraseRootFromParent_Done,
     /* 116886 */   // Label 2013: @116886
     /* 116886 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(116922), // Rule ID 261 //
     /* 116891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 116901 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 116901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 116904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116920 */     GIR_RootConstrainSelectedInstOperands,
     /* 116921 */     // GIR_Coverage, 261,
     /* 116921 */     GIR_EraseRootFromParent_Done,
     /* 116922 */   // Label 2014: @116922
     /* 116922 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(116958), // Rule ID 282 //
     /* 116927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 116937 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 116940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116956 */     GIR_RootConstrainSelectedInstOperands,
     /* 116957 */     // GIR_Coverage, 282,
     /* 116957 */     GIR_EraseRootFromParent_Done,
     /* 116958 */   // Label 2015: @116958
     /* 116958 */   GIM_Reject,
     /* 116959 */ // Label 2011: @116959
     /* 116959 */ GIM_Reject,
     /* 116960 */ // Label 1991: @116960
     /* 116960 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(117135),
     /* 116965 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116968 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116976 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116980 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(117021), // Rule ID 239 //
     /* 116985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 116995 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 116995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 116998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117019 */     GIR_RootConstrainSelectedInstOperands,
     /* 117020 */     // GIR_Coverage, 239,
     /* 117020 */     GIR_EraseRootFromParent_Done,
     /* 117021 */   // Label 2017: @117021
     /* 117021 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(117062), // Rule ID 240 //
     /* 117026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 117036 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 117036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 117039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117060 */     GIR_RootConstrainSelectedInstOperands,
     /* 117061 */     // GIR_Coverage, 240,
     /* 117061 */     GIR_EraseRootFromParent_Done,
     /* 117062 */   // Label 2018: @117062
     /* 117062 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(117098), // Rule ID 262 //
     /* 117067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 117077 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 117077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 117080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117096 */     GIR_RootConstrainSelectedInstOperands,
     /* 117097 */     // GIR_Coverage, 262,
     /* 117097 */     GIR_EraseRootFromParent_Done,
     /* 117098 */   // Label 2019: @117098
     /* 117098 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(117134), // Rule ID 283 //
     /* 117103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117113 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 117116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117132 */     GIR_RootConstrainSelectedInstOperands,
     /* 117133 */     // GIR_Coverage, 283,
     /* 117133 */     GIR_EraseRootFromParent_Done,
     /* 117134 */   // Label 2020: @117134
     /* 117134 */   GIM_Reject,
     /* 117135 */ // Label 2016: @117135
     /* 117135 */ GIM_Reject,
     /* 117136 */ // Label 1992: @117136
     /* 117136 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(117189), // Rule ID 233 //
     /* 117141 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117144 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117152 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117156 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117163 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 117166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117183 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117187 */   GIR_RootConstrainSelectedInstOperands,
     /* 117188 */   // GIR_Coverage, 233,
     /* 117188 */   GIR_EraseRootFromParent_Done,
     /* 117189 */ // Label 2021: @117189
     /* 117189 */ GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(117242), // Rule ID 234 //
     /* 117194 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117197 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117205 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117209 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117216 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 117219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117240 */   GIR_RootConstrainSelectedInstOperands,
     /* 117241 */   // GIR_Coverage, 234,
     /* 117241 */   GIR_EraseRootFromParent_Done,
     /* 117242 */ // Label 2022: @117242
     /* 117242 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(117298), // Rule ID 241 //
     /* 117247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117250 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117253 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117272 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 117275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117292 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117296 */   GIR_RootConstrainSelectedInstOperands,
     /* 117297 */   // GIR_Coverage, 241,
     /* 117297 */   GIR_EraseRootFromParent_Done,
     /* 117298 */ // Label 2023: @117298
     /* 117298 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(117354), // Rule ID 242 //
     /* 117303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117309 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117317 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117321 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117328 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 117331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117348 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117352 */   GIR_RootConstrainSelectedInstOperands,
     /* 117353 */   // GIR_Coverage, 242,
     /* 117353 */   GIR_EraseRootFromParent_Done,
     /* 117354 */ // Label 2024: @117354
     /* 117354 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(117414), // Rule ID 4120 //
     /* 117359 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117362 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117366 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117381 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 117388 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 117388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 117391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117408 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117412 */   GIR_RootConstrainSelectedInstOperands,
     /* 117413 */   // GIR_Coverage, 4120,
     /* 117413 */   GIR_EraseRootFromParent_Done,
     /* 117414 */ // Label 2025: @117414
     /* 117414 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(117474), // Rule ID 4121 //
     /* 117419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117422 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117426 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117437 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 117448 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 117448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 117451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117472 */   GIR_RootConstrainSelectedInstOperands,
     /* 117473 */   // GIR_Coverage, 4121,
     /* 117473 */   GIR_EraseRootFromParent_Done,
     /* 117474 */ // Label 2026: @117474
     /* 117474 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(117534), // Rule ID 4122 //
     /* 117479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117482 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117486 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117497 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117501 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 117508 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 117508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 117511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117523 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117528 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117532 */   GIR_RootConstrainSelectedInstOperands,
     /* 117533 */   // GIR_Coverage, 4122,
     /* 117533 */   GIR_EraseRootFromParent_Done,
     /* 117534 */ // Label 2027: @117534
     /* 117534 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(117594), // Rule ID 4123 //
     /* 117539 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117542 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117546 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117557 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117561 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 117568 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 117568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 117571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117588 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117592 */   GIR_RootConstrainSelectedInstOperands,
     /* 117593 */   // GIR_Coverage, 4123,
     /* 117593 */   GIR_EraseRootFromParent_Done,
     /* 117594 */ // Label 2028: @117594
     /* 117594 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(117654), // Rule ID 4124 //
     /* 117599 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117602 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117606 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117621 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117628 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 117631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117652 */   GIR_RootConstrainSelectedInstOperands,
     /* 117653 */   // GIR_Coverage, 4124,
     /* 117653 */   GIR_EraseRootFromParent_Done,
     /* 117654 */ // Label 2029: @117654
     /* 117654 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(117714), // Rule ID 4125 //
     /* 117659 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117662 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117666 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117677 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117681 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117688 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 117691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117708 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117712 */   GIR_RootConstrainSelectedInstOperands,
     /* 117713 */   // GIR_Coverage, 4125,
     /* 117713 */   GIR_EraseRootFromParent_Done,
     /* 117714 */ // Label 2030: @117714
     /* 117714 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(117762), // Rule ID 260 //
     /* 117719 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117722 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117730 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117734 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117741 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 117744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117746 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117756 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117760 */   GIR_RootConstrainSelectedInstOperands,
     /* 117761 */   // GIR_Coverage, 260,
     /* 117761 */   GIR_EraseRootFromParent_Done,
     /* 117762 */ // Label 2031: @117762
     /* 117762 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(117813), // Rule ID 263 //
     /* 117767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117770 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117773 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117781 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117785 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117792 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 117795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117807 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117811 */   GIR_RootConstrainSelectedInstOperands,
     /* 117812 */   // GIR_Coverage, 263,
     /* 117812 */   GIR_EraseRootFromParent_Done,
     /* 117813 */ // Label 2032: @117813
     /* 117813 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(117876), // Rule ID 7086 //
     /* 117818 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117821 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117825 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117832 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 117835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117839 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117843 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 117850 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15765>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 117850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 117853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117865 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117870 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117874 */   GIR_RootConstrainSelectedInstOperands,
     /* 117875 */   // GIR_Coverage, 7086,
     /* 117875 */   GIR_EraseRootFromParent_Done,
     /* 117876 */ // Label 2033: @117876
     /* 117876 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(117939), // Rule ID 7088 //
     /* 117881 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117884 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117888 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117895 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 117898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117902 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117906 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 117913 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15765>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 117913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 117916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117923 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117933 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117937 */   GIR_RootConstrainSelectedInstOperands,
     /* 117938 */   // GIR_Coverage, 7088,
     /* 117938 */   GIR_EraseRootFromParent_Done,
     /* 117939 */ // Label 2034: @117939
     /* 117939 */ GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(118002), // Rule ID 7098 //
     /* 117944 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117947 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117951 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117958 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 117961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117965 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117969 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 117976 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15773>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 117976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 117979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117996 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118000 */   GIR_RootConstrainSelectedInstOperands,
     /* 118001 */   // GIR_Coverage, 7098,
     /* 118001 */   GIR_EraseRootFromParent_Done,
     /* 118002 */ // Label 2035: @118002
     /* 118002 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(118065), // Rule ID 7100 //
     /* 118007 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118010 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118014 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118021 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118028 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118032 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 118039 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15773>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 118039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 118042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118063 */   GIR_RootConstrainSelectedInstOperands,
     /* 118064 */   // GIR_Coverage, 7100,
     /* 118064 */   GIR_EraseRootFromParent_Done,
     /* 118065 */ // Label 2036: @118065
     /* 118065 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(118128), // Rule ID 7108 //
     /* 118070 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118073 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118077 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118084 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118095 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 118102 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15781>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 118102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 118105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118126 */   GIR_RootConstrainSelectedInstOperands,
     /* 118127 */   // GIR_Coverage, 7108,
     /* 118127 */   GIR_EraseRootFromParent_Done,
     /* 118128 */ // Label 2037: @118128
     /* 118128 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(118191), // Rule ID 7109 //
     /* 118133 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118136 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118140 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118147 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118154 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118158 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 118165 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15781>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 118165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 118168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118185 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118189 */   GIR_RootConstrainSelectedInstOperands,
     /* 118190 */   // GIR_Coverage, 7109,
     /* 118190 */   GIR_EraseRootFromParent_Done,
     /* 118191 */ // Label 2038: @118191
     /* 118191 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(118239), // Rule ID 281 //
     /* 118196 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118199 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118207 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118211 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118218 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 118221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118237 */   GIR_RootConstrainSelectedInstOperands,
     /* 118238 */   // GIR_Coverage, 281,
     /* 118238 */   GIR_EraseRootFromParent_Done,
     /* 118239 */ // Label 2039: @118239
     /* 118239 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(118290), // Rule ID 284 //
     /* 118244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 118258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118262 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118269 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 118272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118284 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118288 */   GIR_RootConstrainSelectedInstOperands,
     /* 118289 */   // GIR_Coverage, 284,
     /* 118289 */   GIR_EraseRootFromParent_Done,
     /* 118290 */ // Label 2040: @118290
     /* 118290 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(118345), // Rule ID 4147 //
     /* 118295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118298 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118302 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118313 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118317 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118324 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 118327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118343 */   GIR_RootConstrainSelectedInstOperands,
     /* 118344 */   // GIR_Coverage, 4147,
     /* 118344 */   GIR_EraseRootFromParent_Done,
     /* 118345 */ // Label 2041: @118345
     /* 118345 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(118400), // Rule ID 4148 //
     /* 118350 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118353 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118357 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118368 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118372 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118379 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 118382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118398 */   GIR_RootConstrainSelectedInstOperands,
     /* 118399 */   // GIR_Coverage, 4148,
     /* 118399 */   GIR_EraseRootFromParent_Done,
     /* 118400 */ // Label 2042: @118400
     /* 118400 */ GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(118455), // Rule ID 4149 //
     /* 118405 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118408 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118412 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118423 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118427 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118434 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 118437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118439 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118449 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118453 */   GIR_RootConstrainSelectedInstOperands,
     /* 118454 */   // GIR_Coverage, 4149,
     /* 118454 */   GIR_EraseRootFromParent_Done,
     /* 118455 */ // Label 2043: @118455
     /* 118455 */ GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(118510), // Rule ID 4170 //
     /* 118460 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118463 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118467 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118478 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118482 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118489 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 118492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118504 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118508 */   GIR_RootConstrainSelectedInstOperands,
     /* 118509 */   // GIR_Coverage, 4170,
     /* 118509 */   GIR_EraseRootFromParent_Done,
     /* 118510 */ // Label 2044: @118510
     /* 118510 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(118565), // Rule ID 4171 //
     /* 118515 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118518 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118522 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118533 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118537 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118544 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 118547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118559 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118563 */   GIR_RootConstrainSelectedInstOperands,
     /* 118564 */   // GIR_Coverage, 4171,
     /* 118564 */   GIR_EraseRootFromParent_Done,
     /* 118565 */ // Label 2045: @118565
     /* 118565 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(118620), // Rule ID 4172 //
     /* 118570 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118573 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118577 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118588 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118592 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118599 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 118602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118609 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118614 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118618 */   GIR_RootConstrainSelectedInstOperands,
     /* 118619 */   // GIR_Coverage, 4172,
     /* 118619 */   GIR_EraseRootFromParent_Done,
     /* 118620 */ // Label 2046: @118620
     /* 118620 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(118678), // Rule ID 7090 //
     /* 118625 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118628 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118632 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118639 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118646 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118650 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118657 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15765>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 118660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118672 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118676 */   GIR_RootConstrainSelectedInstOperands,
     /* 118677 */   // GIR_Coverage, 7090,
     /* 118677 */   GIR_EraseRootFromParent_Done,
     /* 118678 */ // Label 2047: @118678
     /* 118678 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(118736), // Rule ID 7092 //
     /* 118683 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118686 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118690 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118697 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118704 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118708 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118715 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15765>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 118718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118730 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118734 */   GIR_RootConstrainSelectedInstOperands,
     /* 118735 */   // GIR_Coverage, 7092,
     /* 118735 */   GIR_EraseRootFromParent_Done,
     /* 118736 */ // Label 2048: @118736
     /* 118736 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(118794), // Rule ID 7102 //
     /* 118741 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118744 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118755 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118762 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118766 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118773 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15773>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 118776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118788 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118792 */   GIR_RootConstrainSelectedInstOperands,
     /* 118793 */   // GIR_Coverage, 7102,
     /* 118793 */   GIR_EraseRootFromParent_Done,
     /* 118794 */ // Label 2049: @118794
     /* 118794 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(118852), // Rule ID 7104 //
     /* 118799 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118802 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118806 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118813 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118820 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118824 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118831 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15773>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 118834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118846 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118850 */   GIR_RootConstrainSelectedInstOperands,
     /* 118851 */   // GIR_Coverage, 7104,
     /* 118851 */   GIR_EraseRootFromParent_Done,
     /* 118852 */ // Label 2050: @118852
     /* 118852 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(118910), // Rule ID 7110 //
     /* 118857 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118864 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118871 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118878 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118882 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 118889 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15781>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 118889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 118892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118904 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118908 */   GIR_RootConstrainSelectedInstOperands,
     /* 118909 */   // GIR_Coverage, 7110,
     /* 118909 */   GIR_EraseRootFromParent_Done,
     /* 118910 */ // Label 2051: @118910
     /* 118910 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(118968), // Rule ID 7111 //
     /* 118915 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118922 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118929 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118936 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118940 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118947 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15781>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 118950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118962 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118966 */   GIR_RootConstrainSelectedInstOperands,
     /* 118967 */   // GIR_Coverage, 7111,
     /* 118967 */   GIR_EraseRootFromParent_Done,
     /* 118968 */ // Label 2052: @118968
     /* 118968 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(119029), // Rule ID 7496 //
     /* 118973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 118976 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118979 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118983 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118990 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118997 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119001 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 119008 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15754>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 119011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119023 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119027 */   GIR_RootConstrainSelectedInstOperands,
     /* 119028 */   // GIR_Coverage, 7496,
     /* 119028 */   GIR_EraseRootFromParent_Done,
     /* 119029 */ // Label 2053: @119029
     /* 119029 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(119090), // Rule ID 7498 //
     /* 119034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 119037 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119040 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119044 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119051 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119058 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119062 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 119069 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15756>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 119072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119088 */   GIR_RootConstrainSelectedInstOperands,
     /* 119089 */   // GIR_Coverage, 7498,
     /* 119089 */   GIR_EraseRootFromParent_Done,
     /* 119090 */ // Label 2054: @119090
     /* 119090 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(119151), // Rule ID 7500 //
     /* 119095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 119098 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119101 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119112 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119119 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119123 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 119130 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15758>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 119133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119149 */   GIR_RootConstrainSelectedInstOperands,
     /* 119150 */   // GIR_Coverage, 7500,
     /* 119150 */   GIR_EraseRootFromParent_Done,
     /* 119151 */ // Label 2055: @119151
     /* 119151 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(119195), // Rule ID 7076 //
     /* 119156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 119159 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119162 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119166 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119173 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119180 */   // MIs[0] ptr
     /* 119180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119188 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15754>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 119193 */   GIR_RootConstrainSelectedInstOperands,
     /* 119194 */   // GIR_Coverage, 7076,
     /* 119194 */   GIR_Done,
     /* 119195 */ // Label 2056: @119195
     /* 119195 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(119239), // Rule ID 7078 //
     /* 119200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 119203 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119206 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119210 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119217 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119224 */   // MIs[0] ptr
     /* 119224 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119232 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15756>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 119237 */   GIR_RootConstrainSelectedInstOperands,
     /* 119238 */   // GIR_Coverage, 7078,
     /* 119238 */   GIR_Done,
     /* 119239 */ // Label 2057: @119239
     /* 119239 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(119283), // Rule ID 7080 //
     /* 119244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 119247 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119254 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119261 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119268 */   // MIs[0] ptr
     /* 119268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119276 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15758>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 119281 */   GIR_RootConstrainSelectedInstOperands,
     /* 119282 */   // GIR_Coverage, 7080,
     /* 119282 */   GIR_Done,
     /* 119283 */ // Label 2058: @119283
     /* 119283 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(119324), // Rule ID 7082 //
     /* 119288 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119291 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119295 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119302 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 119305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119309 */   // MIs[0] ptr
     /* 119309 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119317 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15762>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 119322 */   GIR_RootConstrainSelectedInstOperands,
     /* 119323 */   // GIR_Coverage, 7082,
     /* 119323 */   GIR_Done,
     /* 119324 */ // Label 2059: @119324
     /* 119324 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(119365), // Rule ID 7084 //
     /* 119329 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119332 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119343 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119350 */   // MIs[0] ptr
     /* 119350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119358 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15754>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 119363 */   GIR_RootConstrainSelectedInstOperands,
     /* 119364 */   // GIR_Coverage, 7084,
     /* 119364 */   GIR_Done,
     /* 119365 */ // Label 2060: @119365
     /* 119365 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(119406), // Rule ID 7094 //
     /* 119370 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119373 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119384 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 119387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119391 */   // MIs[0] ptr
     /* 119391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119399 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15770>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 119404 */   GIR_RootConstrainSelectedInstOperands,
     /* 119405 */   // GIR_Coverage, 7094,
     /* 119405 */   GIR_Done,
     /* 119406 */ // Label 2061: @119406
     /* 119406 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(119447), // Rule ID 7096 //
     /* 119411 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119414 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119418 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119425 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119432 */   // MIs[0] ptr
     /* 119432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119440 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15756>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 119445 */   GIR_RootConstrainSelectedInstOperands,
     /* 119446 */   // GIR_Coverage, 7096,
     /* 119446 */   GIR_Done,
     /* 119447 */ // Label 2062: @119447
     /* 119447 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(119488), // Rule ID 7106 //
     /* 119452 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119455 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119459 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119466 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 119469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119473 */   // MIs[0] ptr
     /* 119473 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119481 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15778>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 119486 */   GIR_RootConstrainSelectedInstOperands,
     /* 119487 */   // GIR_Coverage, 7106,
     /* 119487 */   GIR_Done,
     /* 119488 */ // Label 2063: @119488
     /* 119488 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(119529), // Rule ID 7107 //
     /* 119493 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119496 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119500 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119507 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119514 */   // MIs[0] ptr
     /* 119514 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119522 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15758>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 119527 */   GIR_RootConstrainSelectedInstOperands,
     /* 119528 */   // GIR_Coverage, 7107,
     /* 119528 */   GIR_Done,
     /* 119529 */ // Label 2064: @119529
     /* 119529 */ GIM_Reject,
     /* 119530 */ // Label 1993: @119530
     /* 119530 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(119583), // Rule ID 235 //
     /* 119535 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119538 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119546 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119550 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119557 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 119560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119581 */   GIR_RootConstrainSelectedInstOperands,
     /* 119582 */   // GIR_Coverage, 235,
     /* 119582 */   GIR_EraseRootFromParent_Done,
     /* 119583 */ // Label 2065: @119583
     /* 119583 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(119636), // Rule ID 236 //
     /* 119588 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119591 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119599 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119603 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119610 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 119613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119634 */   GIR_RootConstrainSelectedInstOperands,
     /* 119635 */   // GIR_Coverage, 236,
     /* 119635 */   GIR_EraseRootFromParent_Done,
     /* 119636 */ // Label 2066: @119636
     /* 119636 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(119692), // Rule ID 243 //
     /* 119641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119644 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119647 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119655 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119659 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119666 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 119669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119686 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119690 */   GIR_RootConstrainSelectedInstOperands,
     /* 119691 */   // GIR_Coverage, 243,
     /* 119691 */   GIR_EraseRootFromParent_Done,
     /* 119692 */ // Label 2067: @119692
     /* 119692 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(119748), // Rule ID 244 //
     /* 119697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119700 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119703 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119711 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119715 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119722 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 119725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119742 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119746 */   GIR_RootConstrainSelectedInstOperands,
     /* 119747 */   // GIR_Coverage, 244,
     /* 119747 */   GIR_EraseRootFromParent_Done,
     /* 119748 */ // Label 2068: @119748
     /* 119748 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(119801), // Rule ID 4086 //
     /* 119753 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119756 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119764 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119768 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119775 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 119778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119799 */   GIR_RootConstrainSelectedInstOperands,
     /* 119800 */   // GIR_Coverage, 4086,
     /* 119800 */   GIR_EraseRootFromParent_Done,
     /* 119801 */ // Label 2069: @119801
     /* 119801 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(119854), // Rule ID 4087 //
     /* 119806 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119809 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119817 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119821 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119828 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 119831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119852 */   GIR_RootConstrainSelectedInstOperands,
     /* 119853 */   // GIR_Coverage, 4087,
     /* 119853 */   GIR_EraseRootFromParent_Done,
     /* 119854 */ // Label 2070: @119854
     /* 119854 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(119907), // Rule ID 4088 //
     /* 119859 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119862 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119874 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119881 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 119884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119901 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119905 */   GIR_RootConstrainSelectedInstOperands,
     /* 119906 */   // GIR_Coverage, 4088,
     /* 119906 */   GIR_EraseRootFromParent_Done,
     /* 119907 */ // Label 2071: @119907
     /* 119907 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(119960), // Rule ID 4089 //
     /* 119912 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119915 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119923 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119927 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119934 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 119937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119954 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119958 */   GIR_RootConstrainSelectedInstOperands,
     /* 119959 */   // GIR_Coverage, 4089,
     /* 119959 */   GIR_EraseRootFromParent_Done,
     /* 119960 */ // Label 2072: @119960
     /* 119960 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(120052), // Rule ID 4112 //
     /* 119965 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119968 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119972 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 119983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 119994 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 119994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 120001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120021 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120051 */   // GIR_Coverage, 4112,
     /* 120051 */   GIR_EraseRootFromParent_Done,
     /* 120052 */ // Label 2073: @120052
     /* 120052 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(120144), // Rule ID 4113 //
     /* 120057 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120060 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120064 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120075 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120079 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 120086 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120086 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 120093 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120113 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120143 */   // GIR_Coverage, 4113,
     /* 120143 */   GIR_EraseRootFromParent_Done,
     /* 120144 */ // Label 2074: @120144
     /* 120144 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(120236), // Rule ID 4114 //
     /* 120149 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120152 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120156 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120167 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120171 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 120178 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 120185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120205 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120230 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120235 */   // GIR_Coverage, 4114,
     /* 120235 */   GIR_EraseRootFromParent_Done,
     /* 120236 */ // Label 2075: @120236
     /* 120236 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(120328), // Rule ID 4115 //
     /* 120241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120244 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120263 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 120270 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 120277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120297 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120327 */   // GIR_Coverage, 4115,
     /* 120327 */   GIR_EraseRootFromParent_Done,
     /* 120328 */ // Label 2076: @120328
     /* 120328 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(120420), // Rule ID 4116 //
     /* 120333 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120336 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120340 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120351 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120355 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 120362 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120362 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120365 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 120369 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120389 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120409 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120414 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120419 */   // GIR_Coverage, 4116,
     /* 120419 */   GIR_EraseRootFromParent_Done,
     /* 120420 */ // Label 2077: @120420
     /* 120420 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(120512), // Rule ID 4117 //
     /* 120425 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120428 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120432 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120443 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120447 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 120454 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 120461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120481 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120511 */   // GIR_Coverage, 4117,
     /* 120511 */   GIR_EraseRootFromParent_Done,
     /* 120512 */ // Label 2078: @120512
     /* 120512 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(120604), // Rule ID 4118 //
     /* 120517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120520 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120524 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120535 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120539 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 120546 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 120553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120558 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120563 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120573 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120593 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120598 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120603 */   // GIR_Coverage, 4118,
     /* 120603 */   GIR_EraseRootFromParent_Done,
     /* 120604 */ // Label 2079: @120604
     /* 120604 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(120696), // Rule ID 4119 //
     /* 120609 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120612 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120616 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120627 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120631 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 120638 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120638 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120641 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 120645 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120665 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120679 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120695 */   // GIR_Coverage, 4119,
     /* 120695 */   GIR_EraseRootFromParent_Done,
     /* 120696 */ // Label 2080: @120696
     /* 120696 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(120744), // Rule ID 259 //
     /* 120701 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120704 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120712 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120716 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120723 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 120726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120728 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120738 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120742 */   GIR_RootConstrainSelectedInstOperands,
     /* 120743 */   // GIR_Coverage, 259,
     /* 120743 */   GIR_EraseRootFromParent_Done,
     /* 120744 */ // Label 2081: @120744
     /* 120744 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(120795), // Rule ID 264 //
     /* 120749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120752 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120755 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120763 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120767 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120774 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 120777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120793 */   GIR_RootConstrainSelectedInstOperands,
     /* 120794 */   // GIR_Coverage, 264,
     /* 120794 */   GIR_EraseRootFromParent_Done,
     /* 120795 */ // Label 2082: @120795
     /* 120795 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(120858), // Rule ID 7114 //
     /* 120800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120803 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120807 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120814 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120821 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120825 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120832 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15789>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 120835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120837 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120856 */   GIR_RootConstrainSelectedInstOperands,
     /* 120857 */   // GIR_Coverage, 7114,
     /* 120857 */   GIR_EraseRootFromParent_Done,
     /* 120858 */ // Label 2083: @120858
     /* 120858 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(120921), // Rule ID 7115 //
     /* 120863 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120866 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120870 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120877 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120884 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120888 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120895 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15789>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 120898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120915 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120919 */   GIR_RootConstrainSelectedInstOperands,
     /* 120920 */   // GIR_Coverage, 7115,
     /* 120920 */   GIR_EraseRootFromParent_Done,
     /* 120921 */ // Label 2084: @120921
     /* 120921 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(120969), // Rule ID 280 //
     /* 120926 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120929 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120937 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120941 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120948 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 120951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120963 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120967 */   GIR_RootConstrainSelectedInstOperands,
     /* 120968 */   // GIR_Coverage, 280,
     /* 120968 */   GIR_EraseRootFromParent_Done,
     /* 120969 */ // Label 2085: @120969
     /* 120969 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(121020), // Rule ID 285 //
     /* 120974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120977 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120980 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120988 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120992 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120999 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 121002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121018 */   GIR_RootConstrainSelectedInstOperands,
     /* 121019 */   // GIR_Coverage, 285,
     /* 121019 */   GIR_EraseRootFromParent_Done,
     /* 121020 */ // Label 2086: @121020
     /* 121020 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(121068), // Rule ID 4133 //
     /* 121025 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121028 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121036 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121040 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121047 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 121050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121066 */   GIR_RootConstrainSelectedInstOperands,
     /* 121067 */   // GIR_Coverage, 4133,
     /* 121067 */   GIR_EraseRootFromParent_Done,
     /* 121068 */ // Label 2087: @121068
     /* 121068 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(121116), // Rule ID 4134 //
     /* 121073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121076 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121088 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121095 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 121098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121110 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121114 */   GIR_RootConstrainSelectedInstOperands,
     /* 121115 */   // GIR_Coverage, 4134,
     /* 121115 */   GIR_EraseRootFromParent_Done,
     /* 121116 */ // Label 2088: @121116
     /* 121116 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(121203), // Rule ID 4150 //
     /* 121121 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121124 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121128 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121139 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121143 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 121150 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121150 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121153 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 121157 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121172 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121197 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121202 */   // GIR_Coverage, 4150,
     /* 121202 */   GIR_EraseRootFromParent_Done,
     /* 121203 */ // Label 2089: @121203
     /* 121203 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(121290), // Rule ID 4151 //
     /* 121208 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121211 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121215 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121226 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121230 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 121237 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121237 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121240 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 121244 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121259 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121279 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121284 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121289 */   // GIR_Coverage, 4151,
     /* 121289 */   GIR_EraseRootFromParent_Done,
     /* 121290 */ // Label 2090: @121290
     /* 121290 */ GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(121377), // Rule ID 4152 //
     /* 121295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121298 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121302 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121313 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121317 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 121324 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121324 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121327 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 121331 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121346 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121360 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121371 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121376 */   // GIR_Coverage, 4152,
     /* 121376 */   GIR_EraseRootFromParent_Done,
     /* 121377 */ // Label 2091: @121377
     /* 121377 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(121464), // Rule ID 4153 //
     /* 121382 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121385 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121389 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121400 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121404 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 121411 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 121418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121433 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121463 */   // GIR_Coverage, 4153,
     /* 121463 */   GIR_EraseRootFromParent_Done,
     /* 121464 */ // Label 2092: @121464
     /* 121464 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(121512), // Rule ID 4161 //
     /* 121469 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121480 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121491 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 121494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121506 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121510 */   GIR_RootConstrainSelectedInstOperands,
     /* 121511 */   // GIR_Coverage, 4161,
     /* 121511 */   GIR_EraseRootFromParent_Done,
     /* 121512 */ // Label 2093: @121512
     /* 121512 */ GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(121560), // Rule ID 4162 //
     /* 121517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121520 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121532 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121539 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 121542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121558 */   GIR_RootConstrainSelectedInstOperands,
     /* 121559 */   // GIR_Coverage, 4162,
     /* 121559 */   GIR_EraseRootFromParent_Done,
     /* 121560 */ // Label 2094: @121560
     /* 121560 */ GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(121647), // Rule ID 4173 //
     /* 121565 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121568 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121572 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121583 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121587 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 121594 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121594 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 121601 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121616 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121630 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121641 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121646 */   // GIR_Coverage, 4173,
     /* 121646 */   GIR_EraseRootFromParent_Done,
     /* 121647 */ // Label 2095: @121647
     /* 121647 */ GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(121734), // Rule ID 4174 //
     /* 121652 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121655 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121659 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121670 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121674 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 121681 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 121688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121703 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121733 */   // GIR_Coverage, 4174,
     /* 121733 */   GIR_EraseRootFromParent_Done,
     /* 121734 */ // Label 2096: @121734
     /* 121734 */ GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(121821), // Rule ID 4175 //
     /* 121739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121742 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121746 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121761 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 121768 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 121775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121790 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121815 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121820 */   // GIR_Coverage, 4175,
     /* 121820 */   GIR_EraseRootFromParent_Done,
     /* 121821 */ // Label 2097: @121821
     /* 121821 */ GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(121908), // Rule ID 4176 //
     /* 121826 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121829 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121833 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121844 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121848 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 121855 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 121862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121877 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121897 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121902 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121907 */   // GIR_Coverage, 4176,
     /* 121907 */   GIR_EraseRootFromParent_Done,
     /* 121908 */ // Label 2098: @121908
     /* 121908 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(121966), // Rule ID 7116 //
     /* 121913 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121916 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121920 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121927 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121934 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121938 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121945 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15789>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 121948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121960 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121964 */   GIR_RootConstrainSelectedInstOperands,
     /* 121965 */   // GIR_Coverage, 7116,
     /* 121965 */   GIR_EraseRootFromParent_Done,
     /* 121966 */ // Label 2099: @121966
     /* 121966 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(122024), // Rule ID 7117 //
     /* 121971 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121974 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121978 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121985 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121992 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121996 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122003 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15789>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 122006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122018 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122022 */   GIR_RootConstrainSelectedInstOperands,
     /* 122023 */   // GIR_Coverage, 7117,
     /* 122023 */   GIR_EraseRootFromParent_Done,
     /* 122024 */ // Label 2100: @122024
     /* 122024 */ GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(122085), // Rule ID 7501 //
     /* 122029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 122032 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122035 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122039 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122046 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122053 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122057 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122064 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15760>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 122067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122069 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122083 */   GIR_RootConstrainSelectedInstOperands,
     /* 122084 */   // GIR_Coverage, 7501,
     /* 122084 */   GIR_EraseRootFromParent_Done,
     /* 122085 */ // Label 2101: @122085
     /* 122085 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(122116), // Rule ID 6457 //
     /* 122090 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122093 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122101 */   // MIs[0] Rn
     /* 122101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122109 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 122109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 122114 */   GIR_RootConstrainSelectedInstOperands,
     /* 122115 */   // GIR_Coverage, 6457,
     /* 122115 */   GIR_Done,
     /* 122116 */ // Label 2102: @122116
     /* 122116 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(122160), // Rule ID 7081 //
     /* 122121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 122124 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122127 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122131 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122138 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122145 */   // MIs[0] ptr
     /* 122145 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122153 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15760>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 122153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 122158 */   GIR_RootConstrainSelectedInstOperands,
     /* 122159 */   // GIR_Coverage, 7081,
     /* 122159 */   GIR_Done,
     /* 122160 */ // Label 2103: @122160
     /* 122160 */ GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(122201), // Rule ID 7112 //
     /* 122165 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122168 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122172 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122179 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122186 */   // MIs[0] ptr
     /* 122186 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122194 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15786>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 122194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 122199 */   GIR_RootConstrainSelectedInstOperands,
     /* 122200 */   // GIR_Coverage, 7112,
     /* 122200 */   GIR_Done,
     /* 122201 */ // Label 2104: @122201
     /* 122201 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(122242), // Rule ID 7113 //
     /* 122206 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122209 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122213 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122220 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122227 */   // MIs[0] ptr
     /* 122227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122235 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15760>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 122235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 122240 */   GIR_RootConstrainSelectedInstOperands,
     /* 122241 */   // GIR_Coverage, 7113,
     /* 122241 */   GIR_Done,
     /* 122242 */ // Label 2105: @122242
     /* 122242 */ GIM_Reject,
     /* 122243 */ // Label 1994: @122243
     /* 122243 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(122451),
     /* 122248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122251 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122263 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(122304), // Rule ID 245 //
     /* 122268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122278 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 122281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122302 */     GIR_RootConstrainSelectedInstOperands,
     /* 122303 */     // GIR_Coverage, 245,
     /* 122303 */     GIR_EraseRootFromParent_Done,
     /* 122304 */   // Label 2107: @122304
     /* 122304 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(122345), // Rule ID 246 //
     /* 122309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122319 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 122322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122343 */     GIR_RootConstrainSelectedInstOperands,
     /* 122344 */     // GIR_Coverage, 246,
     /* 122344 */     GIR_EraseRootFromParent_Done,
     /* 122345 */   // Label 2108: @122345
     /* 122345 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(122381), // Rule ID 265 //
     /* 122350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122360 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 122363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122379 */     GIR_RootConstrainSelectedInstOperands,
     /* 122380 */     // GIR_Coverage, 265,
     /* 122380 */     GIR_EraseRootFromParent_Done,
     /* 122381 */   // Label 2109: @122381
     /* 122381 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(122417), // Rule ID 286 //
     /* 122386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122396 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 122399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122415 */     GIR_RootConstrainSelectedInstOperands,
     /* 122416 */     // GIR_Coverage, 286,
     /* 122416 */     GIR_EraseRootFromParent_Done,
     /* 122417 */   // Label 2110: @122417
     /* 122417 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(122450), // Rule ID 4142 //
     /* 122422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122429 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 122432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122448 */     GIR_RootConstrainSelectedInstOperands,
     /* 122449 */     // GIR_Coverage, 4142,
     /* 122449 */     GIR_EraseRootFromParent_Done,
     /* 122450 */   // Label 2111: @122450
     /* 122450 */   GIM_Reject,
     /* 122451 */ // Label 2106: @122451
     /* 122451 */ GIM_Reject,
     /* 122452 */ // Label 1995: @122452
     /* 122452 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(122829),
     /* 122457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122460 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122468 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(122513), // Rule ID 4076 //
     /* 122473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122487 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 122490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122511 */     GIR_RootConstrainSelectedInstOperands,
     /* 122512 */     // GIR_Coverage, 4076,
     /* 122512 */     GIR_EraseRootFromParent_Done,
     /* 122513 */   // Label 2113: @122513
     /* 122513 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(122558), // Rule ID 4077 //
     /* 122518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122532 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 122535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122556 */     GIR_RootConstrainSelectedInstOperands,
     /* 122557 */     // GIR_Coverage, 4077,
     /* 122557 */     GIR_EraseRootFromParent_Done,
     /* 122558 */   // Label 2114: @122558
     /* 122558 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(122603), // Rule ID 4078 //
     /* 122563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122577 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 122580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122601 */     GIR_RootConstrainSelectedInstOperands,
     /* 122602 */     // GIR_Coverage, 4078,
     /* 122602 */     GIR_EraseRootFromParent_Done,
     /* 122603 */   // Label 2115: @122603
     /* 122603 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(122648), // Rule ID 4079 //
     /* 122608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122622 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 122625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122646 */     GIR_RootConstrainSelectedInstOperands,
     /* 122647 */     // GIR_Coverage, 4079,
     /* 122647 */     GIR_EraseRootFromParent_Done,
     /* 122648 */   // Label 2116: @122648
     /* 122648 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(122688), // Rule ID 4128 //
     /* 122653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122667 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122686 */     GIR_RootConstrainSelectedInstOperands,
     /* 122687 */     // GIR_Coverage, 4128,
     /* 122687 */     GIR_EraseRootFromParent_Done,
     /* 122688 */   // Label 2117: @122688
     /* 122688 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(122728), // Rule ID 4131 //
     /* 122693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122707 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122726 */     GIR_RootConstrainSelectedInstOperands,
     /* 122727 */     // GIR_Coverage, 4131,
     /* 122727 */     GIR_EraseRootFromParent_Done,
     /* 122728 */   // Label 2118: @122728
     /* 122728 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(122768), // Rule ID 4156 //
     /* 122733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122747 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122766 */     GIR_RootConstrainSelectedInstOperands,
     /* 122767 */     // GIR_Coverage, 4156,
     /* 122767 */     GIR_EraseRootFromParent_Done,
     /* 122768 */   // Label 2119: @122768
     /* 122768 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(122808), // Rule ID 4157 //
     /* 122773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122787 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122806 */     GIR_RootConstrainSelectedInstOperands,
     /* 122807 */     // GIR_Coverage, 4157,
     /* 122807 */     GIR_EraseRootFromParent_Done,
     /* 122808 */   // Label 2120: @122808
     /* 122808 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(122828), // Rule ID 6456 //
     /* 122813 */     // MIs[0] Rn
     /* 122813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122821 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 122821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 122826 */     GIR_RootConstrainSelectedInstOperands,
     /* 122827 */     // GIR_Coverage, 6456,
     /* 122827 */     GIR_Done,
     /* 122828 */   // Label 2121: @122828
     /* 122828 */   GIM_Reject,
     /* 122829 */ // Label 2112: @122829
     /* 122829 */ GIM_Reject,
     /* 122830 */ // Label 1996: @122830
     /* 122830 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(123207),
     /* 122835 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122838 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122846 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(122891), // Rule ID 4090 //
     /* 122851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122865 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 122868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122889 */     GIR_RootConstrainSelectedInstOperands,
     /* 122890 */     // GIR_Coverage, 4090,
     /* 122890 */     GIR_EraseRootFromParent_Done,
     /* 122891 */   // Label 2123: @122891
     /* 122891 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(122936), // Rule ID 4091 //
     /* 122896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122910 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 122913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122934 */     GIR_RootConstrainSelectedInstOperands,
     /* 122935 */     // GIR_Coverage, 4091,
     /* 122935 */     GIR_EraseRootFromParent_Done,
     /* 122936 */   // Label 2124: @122936
     /* 122936 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(122981), // Rule ID 4092 //
     /* 122941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122955 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 122958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122979 */     GIR_RootConstrainSelectedInstOperands,
     /* 122980 */     // GIR_Coverage, 4092,
     /* 122980 */     GIR_EraseRootFromParent_Done,
     /* 122981 */   // Label 2125: @122981
     /* 122981 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(123026), // Rule ID 4093 //
     /* 122986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123000 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 123003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123024 */     GIR_RootConstrainSelectedInstOperands,
     /* 123025 */     // GIR_Coverage, 4093,
     /* 123025 */     GIR_EraseRootFromParent_Done,
     /* 123026 */   // Label 2126: @123026
     /* 123026 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(123066), // Rule ID 4136 //
     /* 123031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123045 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123064 */     GIR_RootConstrainSelectedInstOperands,
     /* 123065 */     // GIR_Coverage, 4136,
     /* 123065 */     GIR_EraseRootFromParent_Done,
     /* 123066 */   // Label 2127: @123066
     /* 123066 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(123106), // Rule ID 4140 //
     /* 123071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123085 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123104 */     GIR_RootConstrainSelectedInstOperands,
     /* 123105 */     // GIR_Coverage, 4140,
     /* 123105 */     GIR_EraseRootFromParent_Done,
     /* 123106 */   // Label 2128: @123106
     /* 123106 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(123146), // Rule ID 4163 //
     /* 123111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123125 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123144 */     GIR_RootConstrainSelectedInstOperands,
     /* 123145 */     // GIR_Coverage, 4163,
     /* 123145 */     GIR_EraseRootFromParent_Done,
     /* 123146 */   // Label 2129: @123146
     /* 123146 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(123186), // Rule ID 4164 //
     /* 123151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123165 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123184 */     GIR_RootConstrainSelectedInstOperands,
     /* 123185 */     // GIR_Coverage, 4164,
     /* 123185 */     GIR_EraseRootFromParent_Done,
     /* 123186 */   // Label 2130: @123186
     /* 123186 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(123206), // Rule ID 6453 //
     /* 123191 */     // MIs[0] Rn
     /* 123191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123199 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 123204 */     GIR_RootConstrainSelectedInstOperands,
     /* 123205 */     // GIR_Coverage, 6453,
     /* 123205 */     GIR_Done,
     /* 123206 */   // Label 2131: @123206
     /* 123206 */   GIM_Reject,
     /* 123207 */ // Label 2122: @123207
     /* 123207 */ GIM_Reject,
     /* 123208 */ // Label 1997: @123208
     /* 123208 */ GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(123585),
     /* 123213 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123216 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123224 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(123269), // Rule ID 4082 //
     /* 123229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123243 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 123246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123267 */     GIR_RootConstrainSelectedInstOperands,
     /* 123268 */     // GIR_Coverage, 4082,
     /* 123268 */     GIR_EraseRootFromParent_Done,
     /* 123269 */   // Label 2133: @123269
     /* 123269 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(123314), // Rule ID 4083 //
     /* 123274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123288 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 123291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123312 */     GIR_RootConstrainSelectedInstOperands,
     /* 123313 */     // GIR_Coverage, 4083,
     /* 123313 */     GIR_EraseRootFromParent_Done,
     /* 123314 */   // Label 2134: @123314
     /* 123314 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(123359), // Rule ID 4084 //
     /* 123319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123333 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 123336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123357 */     GIR_RootConstrainSelectedInstOperands,
     /* 123358 */     // GIR_Coverage, 4084,
     /* 123358 */     GIR_EraseRootFromParent_Done,
     /* 123359 */   // Label 2135: @123359
     /* 123359 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(123404), // Rule ID 4085 //
     /* 123364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123378 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 123381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123402 */     GIR_RootConstrainSelectedInstOperands,
     /* 123403 */     // GIR_Coverage, 4085,
     /* 123403 */     GIR_EraseRootFromParent_Done,
     /* 123404 */   // Label 2136: @123404
     /* 123404 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(123444), // Rule ID 4130 //
     /* 123409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123423 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 123426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123442 */     GIR_RootConstrainSelectedInstOperands,
     /* 123443 */     // GIR_Coverage, 4130,
     /* 123443 */     GIR_EraseRootFromParent_Done,
     /* 123444 */   // Label 2137: @123444
     /* 123444 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(123484), // Rule ID 4132 //
     /* 123449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123463 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 123466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123482 */     GIR_RootConstrainSelectedInstOperands,
     /* 123483 */     // GIR_Coverage, 4132,
     /* 123483 */     GIR_EraseRootFromParent_Done,
     /* 123484 */   // Label 2138: @123484
     /* 123484 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(123524), // Rule ID 4158 //
     /* 123489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123503 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 123506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123522 */     GIR_RootConstrainSelectedInstOperands,
     /* 123523 */     // GIR_Coverage, 4158,
     /* 123523 */     GIR_EraseRootFromParent_Done,
     /* 123524 */   // Label 2139: @123524
     /* 123524 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(123564), // Rule ID 4160 //
     /* 123529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123543 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 123546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123562 */     GIR_RootConstrainSelectedInstOperands,
     /* 123563 */     // GIR_Coverage, 4160,
     /* 123563 */     GIR_EraseRootFromParent_Done,
     /* 123564 */   // Label 2140: @123564
     /* 123564 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(123584), // Rule ID 6455 //
     /* 123569 */     // MIs[0] Rn
     /* 123569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123577 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 123582 */     GIR_RootConstrainSelectedInstOperands,
     /* 123583 */     // GIR_Coverage, 6455,
     /* 123583 */     GIR_Done,
     /* 123584 */   // Label 2141: @123584
     /* 123584 */   GIM_Reject,
     /* 123585 */ // Label 2132: @123585
     /* 123585 */ GIM_Reject,
     /* 123586 */ // Label 1998: @123586
     /* 123586 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(123963),
     /* 123591 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123594 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123602 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(123647), // Rule ID 4094 //
     /* 123607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123621 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 123624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123645 */     GIR_RootConstrainSelectedInstOperands,
     /* 123646 */     // GIR_Coverage, 4094,
     /* 123646 */     GIR_EraseRootFromParent_Done,
     /* 123647 */   // Label 2143: @123647
     /* 123647 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(123692), // Rule ID 4095 //
     /* 123652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123666 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 123669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123690 */     GIR_RootConstrainSelectedInstOperands,
     /* 123691 */     // GIR_Coverage, 4095,
     /* 123691 */     GIR_EraseRootFromParent_Done,
     /* 123692 */   // Label 2144: @123692
     /* 123692 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(123737), // Rule ID 4096 //
     /* 123697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123711 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 123714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123735 */     GIR_RootConstrainSelectedInstOperands,
     /* 123736 */     // GIR_Coverage, 4096,
     /* 123736 */     GIR_EraseRootFromParent_Done,
     /* 123737 */   // Label 2145: @123737
     /* 123737 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(123782), // Rule ID 4097 //
     /* 123742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123756 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 123759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123780 */     GIR_RootConstrainSelectedInstOperands,
     /* 123781 */     // GIR_Coverage, 4097,
     /* 123781 */     GIR_EraseRootFromParent_Done,
     /* 123782 */   // Label 2146: @123782
     /* 123782 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(123822), // Rule ID 4135 //
     /* 123787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123801 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123820 */     GIR_RootConstrainSelectedInstOperands,
     /* 123821 */     // GIR_Coverage, 4135,
     /* 123821 */     GIR_EraseRootFromParent_Done,
     /* 123822 */   // Label 2147: @123822
     /* 123822 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(123862), // Rule ID 4139 //
     /* 123827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123841 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123860 */     GIR_RootConstrainSelectedInstOperands,
     /* 123861 */     // GIR_Coverage, 4139,
     /* 123861 */     GIR_EraseRootFromParent_Done,
     /* 123862 */   // Label 2148: @123862
     /* 123862 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(123902), // Rule ID 4165 //
     /* 123867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123881 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123900 */     GIR_RootConstrainSelectedInstOperands,
     /* 123901 */     // GIR_Coverage, 4165,
     /* 123901 */     GIR_EraseRootFromParent_Done,
     /* 123902 */   // Label 2149: @123902
     /* 123902 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(123942), // Rule ID 4166 //
     /* 123907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123921 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123940 */     GIR_RootConstrainSelectedInstOperands,
     /* 123941 */     // GIR_Coverage, 4166,
     /* 123941 */     GIR_EraseRootFromParent_Done,
     /* 123942 */   // Label 2150: @123942
     /* 123942 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(123962), // Rule ID 6452 //
     /* 123947 */     // MIs[0] Rn
     /* 123947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123955 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 123960 */     GIR_RootConstrainSelectedInstOperands,
     /* 123961 */     // GIR_Coverage, 6452,
     /* 123961 */     GIR_Done,
     /* 123962 */   // Label 2151: @123962
     /* 123962 */   GIM_Reject,
     /* 123963 */ // Label 2142: @123963
     /* 123963 */ GIM_Reject,
     /* 123964 */ // Label 1999: @123964
     /* 123964 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(124171),
     /* 123969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123972 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123980 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(124025), // Rule ID 4080 //
     /* 123985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123999 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 124002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124023 */     GIR_RootConstrainSelectedInstOperands,
     /* 124024 */     // GIR_Coverage, 4080,
     /* 124024 */     GIR_EraseRootFromParent_Done,
     /* 124025 */   // Label 2153: @124025
     /* 124025 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(124070), // Rule ID 4081 //
     /* 124030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124044 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124068 */     GIR_RootConstrainSelectedInstOperands,
     /* 124069 */     // GIR_Coverage, 4081,
     /* 124069 */     GIR_EraseRootFromParent_Done,
     /* 124070 */   // Label 2154: @124070
     /* 124070 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(124110), // Rule ID 4129 //
     /* 124075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124089 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124108 */     GIR_RootConstrainSelectedInstOperands,
     /* 124109 */     // GIR_Coverage, 4129,
     /* 124109 */     GIR_EraseRootFromParent_Done,
     /* 124110 */   // Label 2155: @124110
     /* 124110 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(124150), // Rule ID 4159 //
     /* 124115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124129 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124148 */     GIR_RootConstrainSelectedInstOperands,
     /* 124149 */     // GIR_Coverage, 4159,
     /* 124149 */     GIR_EraseRootFromParent_Done,
     /* 124150 */   // Label 2156: @124150
     /* 124150 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(124170), // Rule ID 6454 //
     /* 124155 */     // MIs[0] Rn
     /* 124155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124163 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 124168 */     GIR_RootConstrainSelectedInstOperands,
     /* 124169 */     // GIR_Coverage, 6454,
     /* 124169 */     GIR_Done,
     /* 124170 */   // Label 2157: @124170
     /* 124170 */   GIM_Reject,
     /* 124171 */ // Label 2152: @124171
     /* 124171 */ GIM_Reject,
     /* 124172 */ // Label 2000: @124172
     /* 124172 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(124549),
     /* 124177 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124180 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124188 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(124233), // Rule ID 4098 //
     /* 124193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124207 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124231 */     GIR_RootConstrainSelectedInstOperands,
     /* 124232 */     // GIR_Coverage, 4098,
     /* 124232 */     GIR_EraseRootFromParent_Done,
     /* 124233 */   // Label 2159: @124233
     /* 124233 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(124278), // Rule ID 4099 //
     /* 124238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124252 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124276 */     GIR_RootConstrainSelectedInstOperands,
     /* 124277 */     // GIR_Coverage, 4099,
     /* 124277 */     GIR_EraseRootFromParent_Done,
     /* 124278 */   // Label 2160: @124278
     /* 124278 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(124323), // Rule ID 4100 //
     /* 124283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124297 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124321 */     GIR_RootConstrainSelectedInstOperands,
     /* 124322 */     // GIR_Coverage, 4100,
     /* 124322 */     GIR_EraseRootFromParent_Done,
     /* 124323 */   // Label 2161: @124323
     /* 124323 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(124368), // Rule ID 4101 //
     /* 124328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124342 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124366 */     GIR_RootConstrainSelectedInstOperands,
     /* 124367 */     // GIR_Coverage, 4101,
     /* 124367 */     GIR_EraseRootFromParent_Done,
     /* 124368 */   // Label 2162: @124368
     /* 124368 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(124408), // Rule ID 4138 //
     /* 124373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124387 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124406 */     GIR_RootConstrainSelectedInstOperands,
     /* 124407 */     // GIR_Coverage, 4138,
     /* 124407 */     GIR_EraseRootFromParent_Done,
     /* 124408 */   // Label 2163: @124408
     /* 124408 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(124448), // Rule ID 4141 //
     /* 124413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124427 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124446 */     GIR_RootConstrainSelectedInstOperands,
     /* 124447 */     // GIR_Coverage, 4141,
     /* 124447 */     GIR_EraseRootFromParent_Done,
     /* 124448 */   // Label 2164: @124448
     /* 124448 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(124488), // Rule ID 4167 //
     /* 124453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124467 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124486 */     GIR_RootConstrainSelectedInstOperands,
     /* 124487 */     // GIR_Coverage, 4167,
     /* 124487 */     GIR_EraseRootFromParent_Done,
     /* 124488 */   // Label 2165: @124488
     /* 124488 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(124528), // Rule ID 4169 //
     /* 124493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124507 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124526 */     GIR_RootConstrainSelectedInstOperands,
     /* 124527 */     // GIR_Coverage, 4169,
     /* 124527 */     GIR_EraseRootFromParent_Done,
     /* 124528 */   // Label 2166: @124528
     /* 124528 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(124548), // Rule ID 6451 //
     /* 124533 */     // MIs[0] Rn
     /* 124533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124541 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 124546 */     GIR_RootConstrainSelectedInstOperands,
     /* 124547 */     // GIR_Coverage, 6451,
     /* 124547 */     GIR_Done,
     /* 124548 */   // Label 2167: @124548
     /* 124548 */   GIM_Reject,
     /* 124549 */ // Label 2158: @124549
     /* 124549 */ GIM_Reject,
     /* 124550 */ // Label 2001: @124550
     /* 124550 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(124757),
     /* 124555 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124558 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124566 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(124611), // Rule ID 4102 //
     /* 124571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124585 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124609 */     GIR_RootConstrainSelectedInstOperands,
     /* 124610 */     // GIR_Coverage, 4102,
     /* 124610 */     GIR_EraseRootFromParent_Done,
     /* 124611 */   // Label 2169: @124611
     /* 124611 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(124656), // Rule ID 4103 //
     /* 124616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124630 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124654 */     GIR_RootConstrainSelectedInstOperands,
     /* 124655 */     // GIR_Coverage, 4103,
     /* 124655 */     GIR_EraseRootFromParent_Done,
     /* 124656 */   // Label 2170: @124656
     /* 124656 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(124696), // Rule ID 4137 //
     /* 124661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124675 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124694 */     GIR_RootConstrainSelectedInstOperands,
     /* 124695 */     // GIR_Coverage, 4137,
     /* 124695 */     GIR_EraseRootFromParent_Done,
     /* 124696 */   // Label 2171: @124696
     /* 124696 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(124736), // Rule ID 4168 //
     /* 124701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124715 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124734 */     GIR_RootConstrainSelectedInstOperands,
     /* 124735 */     // GIR_Coverage, 4168,
     /* 124735 */     GIR_EraseRootFromParent_Done,
     /* 124736 */   // Label 2172: @124736
     /* 124736 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(124756), // Rule ID 6450 //
     /* 124741 */     // MIs[0] Rn
     /* 124741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124749 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 124754 */     GIR_RootConstrainSelectedInstOperands,
     /* 124755 */     // GIR_Coverage, 6450,
     /* 124755 */     GIR_Done,
     /* 124756 */   // Label 2173: @124756
     /* 124756 */   GIM_Reject,
     /* 124757 */ // Label 2168: @124757
     /* 124757 */ GIM_Reject,
     /* 124758 */ // Label 2002: @124758
     /* 124758 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(124821), // Rule ID 11026 //
     /* 124763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124766 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124769 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 124777 */   // MIs[0] base
     /* 124777 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124785 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124797 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 124805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124810 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124815 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124819 */   GIR_RootConstrainSelectedInstOperands,
     /* 124820 */   // GIR_Coverage, 11026,
     /* 124820 */   GIR_EraseRootFromParent_Done,
     /* 124821 */ // Label 2174: @124821
     /* 124821 */ GIM_Reject,
     /* 124822 */ // Label 2003: @124822
     /* 124822 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(124885), // Rule ID 11032 //
     /* 124827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124833 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 124841 */   // MIs[0] base
     /* 124841 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124849 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124861 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 124869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124871 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124874 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124883 */   GIR_RootConstrainSelectedInstOperands,
     /* 124884 */   // GIR_Coverage, 11032,
     /* 124884 */   GIR_EraseRootFromParent_Done,
     /* 124885 */ // Label 2175: @124885
     /* 124885 */ GIM_Reject,
     /* 124886 */ // Label 2004: @124886
     /* 124886 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(125059),
     /* 124891 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124894 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 124902 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124906 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(124954), // Rule ID 11017 //
     /* 124911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124918 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124930 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 124938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124943 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124952 */     GIR_RootConstrainSelectedInstOperands,
     /* 124953 */     // GIR_Coverage, 11017,
     /* 124953 */     GIR_EraseRootFromParent_Done,
     /* 124954 */   // Label 2177: @124954
     /* 124954 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(125002), // Rule ID 11035 //
     /* 124959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124966 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124978 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 124986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124991 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125000 */     GIR_RootConstrainSelectedInstOperands,
     /* 125001 */     // GIR_Coverage, 11035,
     /* 125001 */     GIR_EraseRootFromParent_Done,
     /* 125002 */   // Label 2178: @125002
     /* 125002 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(125030), // Rule ID 11062 //
     /* 125007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125014 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125019 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125028 */     GIR_RootConstrainSelectedInstOperands,
     /* 125029 */     // GIR_Coverage, 11062,
     /* 125029 */     GIR_EraseRootFromParent_Done,
     /* 125030 */   // Label 2179: @125030
     /* 125030 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(125058), // Rule ID 11074 //
     /* 125035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125042 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125047 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125056 */     GIR_RootConstrainSelectedInstOperands,
     /* 125057 */     // GIR_Coverage, 11074,
     /* 125057 */     GIR_EraseRootFromParent_Done,
     /* 125058 */   // Label 2180: @125058
     /* 125058 */   GIM_Reject,
     /* 125059 */ // Label 2176: @125059
     /* 125059 */ GIM_Reject,
     /* 125060 */ // Label 2005: @125060
     /* 125060 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(125123), // Rule ID 11023 //
     /* 125065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125068 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125071 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125079 */   // MIs[0] base
     /* 125079 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125087 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125099 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 125107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125112 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125117 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125121 */   GIR_RootConstrainSelectedInstOperands,
     /* 125122 */   // GIR_Coverage, 11023,
     /* 125122 */   GIR_EraseRootFromParent_Done,
     /* 125123 */ // Label 2181: @125123
     /* 125123 */ GIM_Reject,
     /* 125124 */ // Label 2006: @125124
     /* 125124 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(125297),
     /* 125129 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125132 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125140 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125144 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(125192), // Rule ID 11005 //
     /* 125149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125156 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125168 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 125176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125181 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125190 */     GIR_RootConstrainSelectedInstOperands,
     /* 125191 */     // GIR_Coverage, 11005,
     /* 125191 */     GIR_EraseRootFromParent_Done,
     /* 125192 */   // Label 2183: @125192
     /* 125192 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(125240), // Rule ID 11029 //
     /* 125197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125204 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125216 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 125224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125229 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125238 */     GIR_RootConstrainSelectedInstOperands,
     /* 125239 */     // GIR_Coverage, 11029,
     /* 125239 */     GIR_EraseRootFromParent_Done,
     /* 125240 */   // Label 2184: @125240
     /* 125240 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(125268), // Rule ID 11058 //
     /* 125245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125252 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125257 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125266 */     GIR_RootConstrainSelectedInstOperands,
     /* 125267 */     // GIR_Coverage, 11058,
     /* 125267 */     GIR_EraseRootFromParent_Done,
     /* 125268 */   // Label 2185: @125268
     /* 125268 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(125296), // Rule ID 11070 //
     /* 125273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125280 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125285 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125294 */     GIR_RootConstrainSelectedInstOperands,
     /* 125295 */     // GIR_Coverage, 11070,
     /* 125295 */     GIR_EraseRootFromParent_Done,
     /* 125296 */   // Label 2186: @125296
     /* 125296 */   GIM_Reject,
     /* 125297 */ // Label 2182: @125297
     /* 125297 */ GIM_Reject,
     /* 125298 */ // Label 2007: @125298
     /* 125298 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(125471),
     /* 125303 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125306 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125314 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125318 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(125366), // Rule ID 10984 //
     /* 125323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125330 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125342 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 125350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125355 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125364 */     GIR_RootConstrainSelectedInstOperands,
     /* 125365 */     // GIR_Coverage, 10984,
     /* 125365 */     GIR_EraseRootFromParent_Done,
     /* 125366 */   // Label 2188: @125366
     /* 125366 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(125414), // Rule ID 11020 //
     /* 125371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125378 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125390 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 125398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125403 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125412 */     GIR_RootConstrainSelectedInstOperands,
     /* 125413 */     // GIR_Coverage, 11020,
     /* 125413 */     GIR_EraseRootFromParent_Done,
     /* 125414 */   // Label 2189: @125414
     /* 125414 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(125442), // Rule ID 11054 //
     /* 125419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125426 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125431 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125440 */     GIR_RootConstrainSelectedInstOperands,
     /* 125441 */     // GIR_Coverage, 11054,
     /* 125441 */     GIR_EraseRootFromParent_Done,
     /* 125442 */   // Label 2190: @125442
     /* 125442 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(125470), // Rule ID 11066 //
     /* 125447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125454 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125459 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125468 */     GIR_RootConstrainSelectedInstOperands,
     /* 125469 */     // GIR_Coverage, 11066,
     /* 125469 */     GIR_EraseRootFromParent_Done,
     /* 125470 */   // Label 2191: @125470
     /* 125470 */   GIM_Reject,
     /* 125471 */ // Label 2187: @125471
     /* 125471 */ GIM_Reject,
     /* 125472 */ // Label 2008: @125472
     /* 125472 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(125515), // Rule ID 2428 //
     /* 125477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125480 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125483 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 125491 */   // MIs[0] base
     /* 125491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125499 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 125502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 125504 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125509 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125513 */   GIR_RootConstrainSelectedInstOperands,
     /* 125514 */   // GIR_Coverage, 2428,
     /* 125514 */   GIR_EraseRootFromParent_Done,
     /* 125515 */ // Label 2192: @125515
     /* 125515 */ GIM_Reject,
     /* 125516 */ // Label 2009: @125516
     /* 125516 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(125613),
     /* 125521 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125524 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125532 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125536 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(125584), // Rule ID 10952 //
     /* 125541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125548 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 125555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125560 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 125568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125573 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125582 */     GIR_RootConstrainSelectedInstOperands,
     /* 125583 */     // GIR_Coverage, 10952,
     /* 125583 */     GIR_EraseRootFromParent_Done,
     /* 125584 */   // Label 2194: @125584
     /* 125584 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(125612), // Rule ID 11050 //
     /* 125589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125596 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125601 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125610 */     GIR_RootConstrainSelectedInstOperands,
     /* 125611 */     // GIR_Coverage, 11050,
     /* 125611 */     GIR_EraseRootFromParent_Done,
     /* 125612 */   // Label 2195: @125612
     /* 125612 */   GIM_Reject,
     /* 125613 */ // Label 2193: @125613
     /* 125613 */ GIM_Reject,
     /* 125614 */ // Label 2010: @125614
     /* 125614 */ GIM_Reject,
     /* 125615 */ // Label 17: @125615
     /* 125615 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2198*/ GIMT_Encode4(126664),
     /* 125626 */ /*GILLT_s32*//*Label 2196*/ GIMT_Encode4(125634),
     /* 125630 */ /*GILLT_s64*//*Label 2197*/ GIMT_Encode4(126048),
     /* 125634 */ // Label 2196: @125634
     /* 125634 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(126047),
     /* 125639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125642 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(125695), // Rule ID 247 //
     /* 125647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 125669 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 125669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 125672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125693 */     GIR_RootConstrainSelectedInstOperands,
     /* 125694 */     // GIR_Coverage, 247,
     /* 125694 */     GIR_EraseRootFromParent_Done,
     /* 125695 */   // Label 2200: @125695
     /* 125695 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(125748), // Rule ID 248 //
     /* 125700 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 125722 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 125722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 125725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125746 */     GIR_RootConstrainSelectedInstOperands,
     /* 125747 */     // GIR_Coverage, 248,
     /* 125747 */     GIR_EraseRootFromParent_Done,
     /* 125748 */   // Label 2201: @125748
     /* 125748 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(125801), // Rule ID 251 //
     /* 125753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 125775 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 125775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 125778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125799 */     GIR_RootConstrainSelectedInstOperands,
     /* 125800 */     // GIR_Coverage, 251,
     /* 125800 */     GIR_EraseRootFromParent_Done,
     /* 125801 */   // Label 2202: @125801
     /* 125801 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(125854), // Rule ID 252 //
     /* 125806 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 125828 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 125828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 125831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125852 */     GIR_RootConstrainSelectedInstOperands,
     /* 125853 */     // GIR_Coverage, 252,
     /* 125853 */     GIR_EraseRootFromParent_Done,
     /* 125854 */   // Label 2203: @125854
     /* 125854 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(125902), // Rule ID 268 //
     /* 125859 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 125881 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 125881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 125884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125900 */     GIR_RootConstrainSelectedInstOperands,
     /* 125901 */     // GIR_Coverage, 268,
     /* 125901 */     GIR_EraseRootFromParent_Done,
     /* 125902 */   // Label 2204: @125902
     /* 125902 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(125950), // Rule ID 270 //
     /* 125907 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 125929 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 125929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 125932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125948 */     GIR_RootConstrainSelectedInstOperands,
     /* 125949 */     // GIR_Coverage, 270,
     /* 125949 */     GIR_EraseRootFromParent_Done,
     /* 125950 */   // Label 2205: @125950
     /* 125950 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(125998), // Rule ID 289 //
     /* 125955 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 125977 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 125977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 125980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125996 */     GIR_RootConstrainSelectedInstOperands,
     /* 125997 */     // GIR_Coverage, 289,
     /* 125997 */     GIR_EraseRootFromParent_Done,
     /* 125998 */   // Label 2206: @125998
     /* 125998 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(126046), // Rule ID 291 //
     /* 126003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 126025 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 126028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126044 */     GIR_RootConstrainSelectedInstOperands,
     /* 126045 */     // GIR_Coverage, 291,
     /* 126045 */     GIR_EraseRootFromParent_Done,
     /* 126046 */   // Label 2207: @126046
     /* 126046 */   GIM_Reject,
     /* 126047 */ // Label 2199: @126047
     /* 126047 */ GIM_Reject,
     /* 126048 */ // Label 2197: @126048
     /* 126048 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(126663),
     /* 126053 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126056 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(126109), // Rule ID 249 //
     /* 126061 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 126083 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 126083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 126086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126107 */     GIR_RootConstrainSelectedInstOperands,
     /* 126108 */     // GIR_Coverage, 249,
     /* 126108 */     GIR_EraseRootFromParent_Done,
     /* 126109 */   // Label 2209: @126109
     /* 126109 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(126162), // Rule ID 250 //
     /* 126114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 126136 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 126136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 126139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126160 */     GIR_RootConstrainSelectedInstOperands,
     /* 126161 */     // GIR_Coverage, 250,
     /* 126161 */     GIR_EraseRootFromParent_Done,
     /* 126162 */   // Label 2210: @126162
     /* 126162 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(126215), // Rule ID 253 //
     /* 126167 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 126189 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 126189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 126192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126213 */     GIR_RootConstrainSelectedInstOperands,
     /* 126214 */     // GIR_Coverage, 253,
     /* 126214 */     GIR_EraseRootFromParent_Done,
     /* 126215 */   // Label 2211: @126215
     /* 126215 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(126268), // Rule ID 254 //
     /* 126220 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 126242 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 126242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 126245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126266 */     GIR_RootConstrainSelectedInstOperands,
     /* 126267 */     // GIR_Coverage, 254,
     /* 126267 */     GIR_EraseRootFromParent_Done,
     /* 126268 */   // Label 2212: @126268
     /* 126268 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(126321), // Rule ID 255 //
     /* 126273 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 126295 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 126295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 126298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126319 */     GIR_RootConstrainSelectedInstOperands,
     /* 126320 */     // GIR_Coverage, 255,
     /* 126320 */     GIR_EraseRootFromParent_Done,
     /* 126321 */   // Label 2213: @126321
     /* 126321 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(126374), // Rule ID 256 //
     /* 126326 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 126348 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 126348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 126351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126372 */     GIR_RootConstrainSelectedInstOperands,
     /* 126373 */     // GIR_Coverage, 256,
     /* 126373 */     GIR_EraseRootFromParent_Done,
     /* 126374 */   // Label 2214: @126374
     /* 126374 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(126422), // Rule ID 269 //
     /* 126379 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 126401 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 126401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 126404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126420 */     GIR_RootConstrainSelectedInstOperands,
     /* 126421 */     // GIR_Coverage, 269,
     /* 126421 */     GIR_EraseRootFromParent_Done,
     /* 126422 */   // Label 2215: @126422
     /* 126422 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(126470), // Rule ID 271 //
     /* 126427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 126449 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 126449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 126452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126468 */     GIR_RootConstrainSelectedInstOperands,
     /* 126469 */     // GIR_Coverage, 271,
     /* 126469 */     GIR_EraseRootFromParent_Done,
     /* 126470 */   // Label 2216: @126470
     /* 126470 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(126518), // Rule ID 272 //
     /* 126475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 126497 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 126497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 126500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126516 */     GIR_RootConstrainSelectedInstOperands,
     /* 126517 */     // GIR_Coverage, 272,
     /* 126517 */     GIR_EraseRootFromParent_Done,
     /* 126518 */   // Label 2217: @126518
     /* 126518 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(126566), // Rule ID 290 //
     /* 126523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 126545 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 126548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126564 */     GIR_RootConstrainSelectedInstOperands,
     /* 126565 */     // GIR_Coverage, 290,
     /* 126565 */     GIR_EraseRootFromParent_Done,
     /* 126566 */   // Label 2218: @126566
     /* 126566 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(126614), // Rule ID 292 //
     /* 126571 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 126593 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 126596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126612 */     GIR_RootConstrainSelectedInstOperands,
     /* 126613 */     // GIR_Coverage, 292,
     /* 126613 */     GIR_EraseRootFromParent_Done,
     /* 126614 */   // Label 2219: @126614
     /* 126614 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(126662), // Rule ID 293 //
     /* 126619 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 126641 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 126644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126660 */     GIR_RootConstrainSelectedInstOperands,
     /* 126661 */     // GIR_Coverage, 293,
     /* 126661 */     GIR_EraseRootFromParent_Done,
     /* 126662 */   // Label 2220: @126662
     /* 126662 */   GIM_Reject,
     /* 126663 */ // Label 2208: @126663
     /* 126663 */ GIM_Reject,
     /* 126664 */ // Label 2198: @126664
     /* 126664 */ GIM_Reject,
     /* 126665 */ // Label 18: @126665
     /* 126665 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2223*/ GIMT_Encode4(129713),
     /* 126676 */ /*GILLT_s32*//*Label 2221*/ GIMT_Encode4(126684),
     /* 126680 */ /*GILLT_s64*//*Label 2222*/ GIMT_Encode4(128223),
     /* 126684 */ // Label 2221: @126684
     /* 126684 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(126740), // Rule ID 229 //
     /* 126689 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126692 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126703 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126707 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 126714 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 126714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 126717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126738 */   GIR_RootConstrainSelectedInstOperands,
     /* 126739 */   // GIR_Coverage, 229,
     /* 126739 */   GIR_EraseRootFromParent_Done,
     /* 126740 */ // Label 2224: @126740
     /* 126740 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(126796), // Rule ID 230 //
     /* 126745 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 126770 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 126770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 126773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126790 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126794 */   GIR_RootConstrainSelectedInstOperands,
     /* 126795 */   // GIR_Coverage, 230,
     /* 126795 */   GIR_EraseRootFromParent_Done,
     /* 126796 */ // Label 2225: @126796
     /* 126796 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(126852), // Rule ID 231 //
     /* 126801 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126804 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126815 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126819 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 126826 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 126826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 126829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126846 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126850 */   GIR_RootConstrainSelectedInstOperands,
     /* 126851 */   // GIR_Coverage, 231,
     /* 126851 */   GIR_EraseRootFromParent_Done,
     /* 126852 */ // Label 2226: @126852
     /* 126852 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(126908), // Rule ID 232 //
     /* 126857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126860 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 126882 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 126882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 126885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126902 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126906 */   GIR_RootConstrainSelectedInstOperands,
     /* 126907 */   // GIR_Coverage, 232,
     /* 126907 */   GIR_EraseRootFromParent_Done,
     /* 126908 */ // Label 2227: @126908
     /* 126908 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(126964), // Rule ID 4126 //
     /* 126913 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126916 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126927 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126931 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 126938 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 126938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 126941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126958 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126962 */   GIR_RootConstrainSelectedInstOperands,
     /* 126963 */   // GIR_Coverage, 4126,
     /* 126963 */   GIR_EraseRootFromParent_Done,
     /* 126964 */ // Label 2228: @126964
     /* 126964 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(127020), // Rule ID 4127 //
     /* 126969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126972 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 126994 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 126994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 126997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127018 */   GIR_RootConstrainSelectedInstOperands,
     /* 127019 */   // GIR_Coverage, 4127,
     /* 127019 */   GIR_EraseRootFromParent_Done,
     /* 127020 */ // Label 2229: @127020
     /* 127020 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(127071), // Rule ID 266 //
     /* 127025 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127028 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127039 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127043 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 127050 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 127050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 127053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127055 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127060 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127065 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127069 */   GIR_RootConstrainSelectedInstOperands,
     /* 127070 */   // GIR_Coverage, 266,
     /* 127070 */   GIR_EraseRootFromParent_Done,
     /* 127071 */ // Label 2230: @127071
     /* 127071 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(127122), // Rule ID 267 //
     /* 127076 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127079 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127090 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127094 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127101 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 127104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127116 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127120 */   GIR_RootConstrainSelectedInstOperands,
     /* 127121 */   // GIR_Coverage, 267,
     /* 127121 */   GIR_EraseRootFromParent_Done,
     /* 127122 */ // Label 2231: @127122
     /* 127122 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(127181), // Rule ID 7087 //
     /* 127127 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127130 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127137 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 127155 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15765>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 127155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 127158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 127175 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127179 */   GIR_RootConstrainSelectedInstOperands,
     /* 127180 */   // GIR_Coverage, 7087,
     /* 127180 */   GIR_EraseRootFromParent_Done,
     /* 127181 */ // Label 2232: @127181
     /* 127181 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(127240), // Rule ID 7089 //
     /* 127186 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127189 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127196 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127203 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127207 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 127214 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15765>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 127214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 127217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127219 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127224 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127229 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 127234 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127238 */   GIR_RootConstrainSelectedInstOperands,
     /* 127239 */   // GIR_Coverage, 7089,
     /* 127239 */   GIR_EraseRootFromParent_Done,
     /* 127240 */ // Label 2233: @127240
     /* 127240 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(127299), // Rule ID 7099 //
     /* 127245 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127255 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127262 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127266 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 127273 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15773>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 127273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 127276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127297 */   GIR_RootConstrainSelectedInstOperands,
     /* 127298 */   // GIR_Coverage, 7099,
     /* 127298 */   GIR_EraseRootFromParent_Done,
     /* 127299 */ // Label 2234: @127299
     /* 127299 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(127358), // Rule ID 7101 //
     /* 127304 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127307 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127314 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127321 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127325 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 127332 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15773>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 127332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 127335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127352 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127356 */   GIR_RootConstrainSelectedInstOperands,
     /* 127357 */   // GIR_Coverage, 7101,
     /* 127357 */   GIR_EraseRootFromParent_Done,
     /* 127358 */ // Label 2235: @127358
     /* 127358 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(127409), // Rule ID 287 //
     /* 127363 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127366 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127381 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127388 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 127391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127403 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127407 */   GIR_RootConstrainSelectedInstOperands,
     /* 127408 */   // GIR_Coverage, 287,
     /* 127408 */   GIR_EraseRootFromParent_Done,
     /* 127409 */ // Label 2236: @127409
     /* 127409 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(127460), // Rule ID 288 //
     /* 127414 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127417 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127428 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127432 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127439 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127454 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127458 */   GIR_RootConstrainSelectedInstOperands,
     /* 127459 */   // GIR_Coverage, 288,
     /* 127459 */   GIR_EraseRootFromParent_Done,
     /* 127460 */ // Label 2237: @127460
     /* 127460 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(127511), // Rule ID 4145 //
     /* 127465 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127468 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127479 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127483 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127490 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 127493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127505 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127509 */   GIR_RootConstrainSelectedInstOperands,
     /* 127510 */   // GIR_Coverage, 4145,
     /* 127510 */   GIR_EraseRootFromParent_Done,
     /* 127511 */ // Label 2238: @127511
     /* 127511 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(127562), // Rule ID 4177 //
     /* 127516 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127519 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127530 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127534 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127541 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 127544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127560 */   GIR_RootConstrainSelectedInstOperands,
     /* 127561 */   // GIR_Coverage, 4177,
     /* 127561 */   GIR_EraseRootFromParent_Done,
     /* 127562 */ // Label 2239: @127562
     /* 127562 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(127613), // Rule ID 4178 //
     /* 127567 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127570 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127581 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127585 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127592 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127611 */   GIR_RootConstrainSelectedInstOperands,
     /* 127612 */   // GIR_Coverage, 4178,
     /* 127612 */   GIR_EraseRootFromParent_Done,
     /* 127613 */ // Label 2240: @127613
     /* 127613 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(127664), // Rule ID 4179 //
     /* 127618 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127621 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127632 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127636 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127643 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127658 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127662 */   GIR_RootConstrainSelectedInstOperands,
     /* 127663 */   // GIR_Coverage, 4179,
     /* 127663 */   GIR_EraseRootFromParent_Done,
     /* 127664 */ // Label 2241: @127664
     /* 127664 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(127718), // Rule ID 7091 //
     /* 127669 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127672 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127679 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127686 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127690 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127697 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15765>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 127700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127712 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127716 */   GIR_RootConstrainSelectedInstOperands,
     /* 127717 */   // GIR_Coverage, 7091,
     /* 127717 */   GIR_EraseRootFromParent_Done,
     /* 127718 */ // Label 2242: @127718
     /* 127718 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(127772), // Rule ID 7093 //
     /* 127723 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127726 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127733 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127751 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15765>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127770 */   GIR_RootConstrainSelectedInstOperands,
     /* 127771 */   // GIR_Coverage, 7093,
     /* 127771 */   GIR_EraseRootFromParent_Done,
     /* 127772 */ // Label 2243: @127772
     /* 127772 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(127826), // Rule ID 7103 //
     /* 127777 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127780 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127787 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127798 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 127805 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15773>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 127805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 127808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127820 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127824 */   GIR_RootConstrainSelectedInstOperands,
     /* 127825 */   // GIR_Coverage, 7103,
     /* 127825 */   GIR_EraseRootFromParent_Done,
     /* 127826 */ // Label 2244: @127826
     /* 127826 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(127880), // Rule ID 7105 //
     /* 127831 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127834 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127841 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127859 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15773>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 127862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127874 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127878 */   GIR_RootConstrainSelectedInstOperands,
     /* 127879 */   // GIR_Coverage, 7105,
     /* 127879 */   GIR_EraseRootFromParent_Done,
     /* 127880 */ // Label 2245: @127880
     /* 127880 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(127937), // Rule ID 7497 //
     /* 127885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 127888 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127891 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127898 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127905 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127909 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127916 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15754>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 127919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127931 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127935 */   GIR_RootConstrainSelectedInstOperands,
     /* 127936 */   // GIR_Coverage, 7497,
     /* 127936 */   GIR_EraseRootFromParent_Done,
     /* 127937 */ // Label 2246: @127937
     /* 127937 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(127994), // Rule ID 7499 //
     /* 127942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 127945 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127948 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127955 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127962 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127966 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127973 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15756>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 127976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127988 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127992 */   GIR_RootConstrainSelectedInstOperands,
     /* 127993 */   // GIR_Coverage, 7499,
     /* 127993 */   GIR_EraseRootFromParent_Done,
     /* 127994 */ // Label 2247: @127994
     /* 127994 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(128034), // Rule ID 7077 //
     /* 127999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 128002 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128005 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128012 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128019 */   // MIs[0] ptr
     /* 128019 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128027 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15754>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 128032 */   GIR_RootConstrainSelectedInstOperands,
     /* 128033 */   // GIR_Coverage, 7077,
     /* 128033 */   GIR_Done,
     /* 128034 */ // Label 2248: @128034
     /* 128034 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(128074), // Rule ID 7079 //
     /* 128039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 128042 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128045 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128052 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128059 */   // MIs[0] ptr
     /* 128059 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128067 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15756>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 128072 */   GIR_RootConstrainSelectedInstOperands,
     /* 128073 */   // GIR_Coverage, 7079,
     /* 128073 */   GIR_Done,
     /* 128074 */ // Label 2249: @128074
     /* 128074 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(128111), // Rule ID 7083 //
     /* 128079 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128082 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128089 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128096 */   // MIs[0] ptr
     /* 128096 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128104 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15762>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 128109 */   GIR_RootConstrainSelectedInstOperands,
     /* 128110 */   // GIR_Coverage, 7083,
     /* 128110 */   GIR_Done,
     /* 128111 */ // Label 2250: @128111
     /* 128111 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(128148), // Rule ID 7085 //
     /* 128116 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128119 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128126 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128133 */   // MIs[0] ptr
     /* 128133 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128141 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15754>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128141 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 128146 */   GIR_RootConstrainSelectedInstOperands,
     /* 128147 */   // GIR_Coverage, 7085,
     /* 128147 */   GIR_Done,
     /* 128148 */ // Label 2251: @128148
     /* 128148 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(128185), // Rule ID 7095 //
     /* 128153 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128156 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128163 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128170 */   // MIs[0] ptr
     /* 128170 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128178 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15770>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 128183 */   GIR_RootConstrainSelectedInstOperands,
     /* 128184 */   // GIR_Coverage, 7095,
     /* 128184 */   GIR_Done,
     /* 128185 */ // Label 2252: @128185
     /* 128185 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(128222), // Rule ID 7097 //
     /* 128190 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128193 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128200 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128207 */   // MIs[0] ptr
     /* 128207 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128215 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15756>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 128220 */   GIR_RootConstrainSelectedInstOperands,
     /* 128221 */   // GIR_Coverage, 7097,
     /* 128221 */   GIR_Done,
     /* 128222 */ // Label 2253: @128222
     /* 128222 */ GIM_Reject,
     /* 128223 */ // Label 2222: @128223
     /* 128223 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(129712),
     /* 128228 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128231 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(128316), // Rule ID 4104 //
     /* 128236 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128258 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128285 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128315 */     // GIR_Coverage, 4104,
     /* 128315 */     GIR_EraseRootFromParent_Done,
     /* 128316 */   // Label 2255: @128316
     /* 128316 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(128401), // Rule ID 4105 //
     /* 128321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128343 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128370 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128400 */     // GIR_Coverage, 4105,
     /* 128400 */     GIR_EraseRootFromParent_Done,
     /* 128401 */   // Label 2256: @128401
     /* 128401 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(128486), // Rule ID 4106 //
     /* 128406 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 128428 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 128435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128455 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128485 */     // GIR_Coverage, 4106,
     /* 128485 */     GIR_EraseRootFromParent_Done,
     /* 128486 */   // Label 2257: @128486
     /* 128486 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(128571), // Rule ID 4107 //
     /* 128491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 128513 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 128520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128540 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128570 */     // GIR_Coverage, 4107,
     /* 128570 */     GIR_EraseRootFromParent_Done,
     /* 128571 */   // Label 2258: @128571
     /* 128571 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(128656), // Rule ID 4108 //
     /* 128576 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 128598 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 128605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128625 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128655 */     // GIR_Coverage, 4108,
     /* 128655 */     GIR_EraseRootFromParent_Done,
     /* 128656 */   // Label 2259: @128656
     /* 128656 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(128741), // Rule ID 4109 //
     /* 128661 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 128683 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 128690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128710 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128740 */     // GIR_Coverage, 4109,
     /* 128740 */     GIR_EraseRootFromParent_Done,
     /* 128741 */   // Label 2260: @128741
     /* 128741 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(128826), // Rule ID 4110 //
     /* 128746 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128768 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128795 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128825 */     // GIR_Coverage, 4110,
     /* 128825 */     GIR_EraseRootFromParent_Done,
     /* 128826 */   // Label 2261: @128826
     /* 128826 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(128911), // Rule ID 4111 //
     /* 128831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128853 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128880 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128910 */     // GIR_Coverage, 4111,
     /* 128910 */     GIR_EraseRootFromParent_Done,
     /* 128911 */   // Label 2262: @128911
     /* 128911 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(128991), // Rule ID 4143 //
     /* 128916 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 128938 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 128938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 128945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128960 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128990 */     // GIR_Coverage, 4143,
     /* 128990 */     GIR_EraseRootFromParent_Done,
     /* 128991 */   // Label 2263: @128991
     /* 128991 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(129071), // Rule ID 4144 //
     /* 128996 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 129018 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 129018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 129025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129040 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129070 */     // GIR_Coverage, 4144,
     /* 129070 */     GIR_EraseRootFromParent_Done,
     /* 129071 */   // Label 2264: @129071
     /* 129071 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(129151), // Rule ID 4146 //
     /* 129076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 129098 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 129098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 129105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129120 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129150 */     // GIR_Coverage, 4146,
     /* 129150 */     GIR_EraseRootFromParent_Done,
     /* 129151 */   // Label 2265: @129151
     /* 129151 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(129231), // Rule ID 4154 //
     /* 129156 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 129178 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 129178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 129185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129200 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129230 */     // GIR_Coverage, 4154,
     /* 129230 */     GIR_EraseRootFromParent_Done,
     /* 129231 */   // Label 2266: @129231
     /* 129231 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(129311), // Rule ID 4180 //
     /* 129236 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 129258 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 129265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129280 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129310 */     // GIR_Coverage, 4180,
     /* 129310 */     GIR_EraseRootFromParent_Done,
     /* 129311 */   // Label 2267: @129311
     /* 129311 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(129391), // Rule ID 4181 //
     /* 129316 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129338 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129360 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129390 */     // GIR_Coverage, 4181,
     /* 129390 */     GIR_EraseRootFromParent_Done,
     /* 129391 */   // Label 2268: @129391
     /* 129391 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(129471), // Rule ID 4182 //
     /* 129396 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129418 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129440 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129470 */     // GIR_Coverage, 4182,
     /* 129470 */     GIR_EraseRootFromParent_Done,
     /* 129471 */   // Label 2269: @129471
     /* 129471 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(129551), // Rule ID 4183 //
     /* 129476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129498 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129520 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129550 */     // GIR_Coverage, 4183,
     /* 129550 */     GIR_EraseRootFromParent_Done,
     /* 129551 */   // Label 2270: @129551
     /* 129551 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(129631), // Rule ID 4184 //
     /* 129556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129578 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129600 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129630 */     // GIR_Coverage, 4184,
     /* 129630 */     GIR_EraseRootFromParent_Done,
     /* 129631 */   // Label 2271: @129631
     /* 129631 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(129711), // Rule ID 4185 //
     /* 129636 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129658 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129680 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129710 */     // GIR_Coverage, 4185,
     /* 129710 */     GIR_EraseRootFromParent_Done,
     /* 129711 */   // Label 2272: @129711
     /* 129711 */   GIM_Reject,
     /* 129712 */ // Label 2254: @129712
     /* 129712 */ GIM_Reject,
     /* 129713 */ // Label 2223: @129713
     /* 129713 */ GIM_Reject,
     /* 129714 */ // Label 19: @129714
     /* 129714 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2293*/ GIMT_Encode4(143239),
     /* 129725 */ /*GILLT_s8*//*Label 2273*/ GIMT_Encode4(129821),
     /* 129729 */ /*GILLT_s16*//*Label 2274*/ GIMT_Encode4(130188),
     /* 129733 */ /*GILLT_s32*//*Label 2275*/ GIMT_Encode4(131327),
     /* 129737 */ /*GILLT_s64*//*Label 2276*/ GIMT_Encode4(135922),
     /* 129741 */ /*GILLT_s128*//*Label 2277*/ GIMT_Encode4(139691),
     /* 129745 */ /*GILLT_v2s32*//*Label 2278*/ GIMT_Encode4(139897),
     /* 129749 */ /*GILLT_v2s64*//*Label 2279*/ GIMT_Encode4(140303),
     /* 129753 */ /*GILLT_v4s16*//*Label 2280*/ GIMT_Encode4(140753),
     /* 129757 */ /*GILLT_v4s32*//*Label 2281*/ GIMT_Encode4(141159),
     /* 129761 */ /*GILLT_v8s8*//*Label 2282*/ GIMT_Encode4(141565),
     /* 129765 */ /*GILLT_v8s16*//*Label 2283*/ GIMT_Encode4(141785),
     /* 129769 */ /*GILLT_v16s8*//*Label 2284*/ GIMT_Encode4(142191), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129781 */ /*GILLT_nxv2s16*//*Label 2285*/ GIMT_Encode4(142411),
     /* 129785 */ /*GILLT_nxv2s32*//*Label 2286*/ GIMT_Encode4(142471),
     /* 129789 */ /*GILLT_nxv2s64*//*Label 2287*/ GIMT_Encode4(142531), GIMT_Encode4(0),
     /* 129797 */ /*GILLT_nxv4s16*//*Label 2288*/ GIMT_Encode4(142701),
     /* 129801 */ /*GILLT_nxv4s32*//*Label 2289*/ GIMT_Encode4(142761), GIMT_Encode4(0),
     /* 129809 */ /*GILLT_nxv8s16*//*Label 2290*/ GIMT_Encode4(142931),
     /* 129813 */ /*GILLT_nxv16s1*//*Label 2291*/ GIMT_Encode4(143101),
     /* 129817 */ /*GILLT_nxv16s8*//*Label 2292*/ GIMT_Encode4(143145),
     /* 129821 */ // Label 2273: @129821
     /* 129821 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(130187),
     /* 129826 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129829 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129833 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(129901), // Rule ID 13274 //
     /* 129838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 129842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 129846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 129859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 129863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129867 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 129871 */     // MIs[2] Operand 1
     /* 129871 */     // No operand predicates
     /* 129871 */     // MIs[0] Rn
     /* 129871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 129881 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 129881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 129884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 129888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 129891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 129899 */     GIR_RootConstrainSelectedInstOperands,
     /* 129900 */     // GIR_Coverage, 13274,
     /* 129900 */     GIR_EraseRootFromParent_Done,
     /* 129901 */   // Label 2295: @129901
     /* 129901 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(130000), // Rule ID 13275 //
     /* 129906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 129910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 129914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 129918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 129927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 129931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129935 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 129939 */     // MIs[2] Operand 1
     /* 129939 */     // No operand predicates
     /* 129939 */     // MIs[0] Rn
     /* 129939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 129949 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 129949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 129952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129961 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 129964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 129968 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 129971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 129976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 129981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 129984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 129990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 129998 */     GIR_RootConstrainSelectedInstOperands,
     /* 129999 */     // GIR_Coverage, 13275,
     /* 129999 */     GIR_EraseRootFromParent_Done,
     /* 130000 */   // Label 2296: @130000
     /* 130000 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(130049), // Rule ID 303 //
     /* 130005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 130008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 130012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 130023 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 130023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 130026 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 130028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130047 */     GIR_RootConstrainSelectedInstOperands,
     /* 130048 */     // GIR_Coverage, 303,
     /* 130048 */     GIR_EraseRootFromParent_Done,
     /* 130049 */   // Label 2297: @130049
     /* 130049 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(130098), // Rule ID 304 //
     /* 130054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 130057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 130061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 130072 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 130072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 130075 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 130077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130096 */     GIR_RootConstrainSelectedInstOperands,
     /* 130097 */     // GIR_Coverage, 304,
     /* 130097 */     GIR_EraseRootFromParent_Done,
     /* 130098 */   // Label 2298: @130098
     /* 130098 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(130142), // Rule ID 313 //
     /* 130103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 130106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 130110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 130121 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 130121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 130124 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 130126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130140 */     GIR_RootConstrainSelectedInstOperands,
     /* 130141 */     // GIR_Coverage, 313,
     /* 130141 */     GIR_EraseRootFromParent_Done,
     /* 130142 */   // Label 2299: @130142
     /* 130142 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(130186), // Rule ID 321 //
     /* 130147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 130150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 130154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 130165 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 130165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 130168 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 130170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130184 */     GIR_RootConstrainSelectedInstOperands,
     /* 130185 */     // GIR_Coverage, 321,
     /* 130185 */     GIR_EraseRootFromParent_Done,
     /* 130186 */   // Label 2300: @130186
     /* 130186 */   GIM_Reject,
     /* 130187 */ // Label 2294: @130187
     /* 130187 */ GIM_Reject,
     /* 130188 */ // Label 2274: @130188
     /* 130188 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(131326),
     /* 130193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130196 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130200 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(130299), // Rule ID 4518 //
     /* 130205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130226 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 130243 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 130243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130255 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 130274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130297 */     GIR_RootConstrainSelectedInstOperands,
     /* 130298 */     // GIR_Coverage, 4518,
     /* 130298 */     GIR_EraseRootFromParent_Done,
     /* 130299 */   // Label 2302: @130299
     /* 130299 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(130398), // Rule ID 4519 //
     /* 130304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130325 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 130342 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 130342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130354 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 130373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130396 */     GIR_RootConstrainSelectedInstOperands,
     /* 130397 */     // GIR_Coverage, 4519,
     /* 130397 */     GIR_EraseRootFromParent_Done,
     /* 130398 */   // Label 2303: @130398
     /* 130398 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(130497), // Rule ID 13272 //
     /* 130403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130424 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 130441 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 130441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130453 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 130472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130495 */     GIR_RootConstrainSelectedInstOperands,
     /* 130496 */     // GIR_Coverage, 13272,
     /* 130496 */     GIR_EraseRootFromParent_Done,
     /* 130497 */   // Label 2304: @130497
     /* 130497 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(130596), // Rule ID 13273 //
     /* 130502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130523 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 130540 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 130540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130552 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 130571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130594 */     GIR_RootConstrainSelectedInstOperands,
     /* 130595 */     // GIR_Coverage, 13273,
     /* 130595 */     GIR_EraseRootFromParent_Done,
     /* 130596 */   // Label 2305: @130596
     /* 130596 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(130690), // Rule ID 4547 //
     /* 130601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130622 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 130639 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 130639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130651 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 130670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130688 */     GIR_RootConstrainSelectedInstOperands,
     /* 130689 */     // GIR_Coverage, 4547,
     /* 130689 */     GIR_EraseRootFromParent_Done,
     /* 130690 */   // Label 2306: @130690
     /* 130690 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(130784), // Rule ID 4574 //
     /* 130695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130716 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 130733 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 130733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130745 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 130764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130782 */     GIR_RootConstrainSelectedInstOperands,
     /* 130783 */     // GIR_Coverage, 4574,
     /* 130783 */     GIR_EraseRootFromParent_Done,
     /* 130784 */   // Label 2307: @130784
     /* 130784 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(130878), // Rule ID 13271 //
     /* 130789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130810 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 130827 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 130827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130839 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 130858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130876 */     GIR_RootConstrainSelectedInstOperands,
     /* 130877 */     // GIR_Coverage, 13271,
     /* 130877 */     GIR_EraseRootFromParent_Done,
     /* 130878 */   // Label 2308: @130878
     /* 130878 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(130972), // Rule ID 13277 //
     /* 130883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130904 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 130921 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 130921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130933 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 130952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130970 */     GIR_RootConstrainSelectedInstOperands,
     /* 130971 */     // GIR_Coverage, 13277,
     /* 130971 */     GIR_EraseRootFromParent_Done,
     /* 130972 */   // Label 2309: @130972
     /* 130972 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(131040), // Rule ID 6519 //
     /* 130977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131006 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 131010 */     // MIs[2] Operand 1
     /* 131010 */     // No operand predicates
     /* 131010 */     // MIs[0] Rn
     /* 131010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131020 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 131020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 131023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131038 */     GIR_RootConstrainSelectedInstOperands,
     /* 131039 */     // GIR_Coverage, 6519,
     /* 131039 */     GIR_EraseRootFromParent_Done,
     /* 131040 */   // Label 2310: @131040
     /* 131040 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(131139), // Rule ID 6524 //
     /* 131045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 131057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131074 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 131078 */     // MIs[2] Operand 1
     /* 131078 */     // No operand predicates
     /* 131078 */     // MIs[0] Rn
     /* 131078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131088 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 131088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 131091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131100 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 131103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131107 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 131110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 131123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131137 */     GIR_RootConstrainSelectedInstOperands,
     /* 131138 */     // GIR_Coverage, 6524,
     /* 131138 */     GIR_EraseRootFromParent_Done,
     /* 131139 */   // Label 2311: @131139
     /* 131139 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(131188), // Rule ID 305 //
     /* 131144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 131162 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 131162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 131165 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131186 */     GIR_RootConstrainSelectedInstOperands,
     /* 131187 */     // GIR_Coverage, 305,
     /* 131187 */     GIR_EraseRootFromParent_Done,
     /* 131188 */   // Label 2312: @131188
     /* 131188 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(131237), // Rule ID 306 //
     /* 131193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 131211 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 131211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 131214 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131235 */     GIR_RootConstrainSelectedInstOperands,
     /* 131236 */     // GIR_Coverage, 306,
     /* 131236 */     GIR_EraseRootFromParent_Done,
     /* 131237 */   // Label 2313: @131237
     /* 131237 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(131281), // Rule ID 314 //
     /* 131242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 131260 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 131260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 131263 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131279 */     GIR_RootConstrainSelectedInstOperands,
     /* 131280 */     // GIR_Coverage, 314,
     /* 131280 */     GIR_EraseRootFromParent_Done,
     /* 131281 */   // Label 2314: @131281
     /* 131281 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(131325), // Rule ID 322 //
     /* 131286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 131304 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 131304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 131307 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131323 */     GIR_RootConstrainSelectedInstOperands,
     /* 131324 */     // GIR_Coverage, 322,
     /* 131324 */     GIR_EraseRootFromParent_Done,
     /* 131325 */   // Label 2315: @131325
     /* 131325 */   GIM_Reject,
     /* 131326 */ // Label 2301: @131326
     /* 131326 */ GIM_Reject,
     /* 131327 */ // Label 2275: @131327
     /* 131327 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(131440), // Rule ID 4516 //
     /* 131332 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131335 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131339 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131354 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 131358 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131362 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131367 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131371 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131375 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 131384 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 131384 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131387 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131391 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131396 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131402 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131407 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 131415 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131433 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131438 */   GIR_RootConstrainSelectedInstOperands,
     /* 131439 */   // GIR_Coverage, 4516,
     /* 131439 */   GIR_EraseRootFromParent_Done,
     /* 131440 */ // Label 2316: @131440
     /* 131440 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(131553), // Rule ID 4517 //
     /* 131445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131448 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131467 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 131471 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131475 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131480 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131484 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 131497 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 131497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131509 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131520 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 131528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131546 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131551 */   GIR_RootConstrainSelectedInstOperands,
     /* 131552 */   // GIR_Coverage, 4517,
     /* 131552 */   GIR_EraseRootFromParent_Done,
     /* 131553 */ // Label 2317: @131553
     /* 131553 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(131659), // Rule ID 4520 //
     /* 131558 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131561 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131573 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131577 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131581 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131586 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131590 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131594 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131596 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 131603 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 131603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131615 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131621 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131626 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 131634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131657 */   GIR_RootConstrainSelectedInstOperands,
     /* 131658 */   // GIR_Coverage, 4520,
     /* 131658 */   GIR_EraseRootFromParent_Done,
     /* 131659 */ // Label 2318: @131659
     /* 131659 */ GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(131765), // Rule ID 4521 //
     /* 131664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131667 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131671 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131675 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131679 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131683 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131687 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131692 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131696 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131700 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131702 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 131709 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 131709 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131712 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131716 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131721 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131727 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131732 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 131740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131748 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131758 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131763 */   GIR_RootConstrainSelectedInstOperands,
     /* 131764 */   // GIR_Coverage, 4521,
     /* 131764 */   GIR_EraseRootFromParent_Done,
     /* 131765 */ // Label 2319: @131765
     /* 131765 */ GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(131871), // Rule ID 4522 //
     /* 131770 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131773 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131777 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131781 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131785 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131789 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131793 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131798 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131802 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131806 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131808 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 131815 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 131815 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131818 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131822 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131827 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131838 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 131846 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131869 */   GIR_RootConstrainSelectedInstOperands,
     /* 131870 */   // GIR_Coverage, 4522,
     /* 131870 */   GIR_EraseRootFromParent_Done,
     /* 131871 */ // Label 2320: @131871
     /* 131871 */ GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(131977), // Rule ID 4523 //
     /* 131876 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131879 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131883 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131887 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131891 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131895 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131899 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131904 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131908 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131912 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131914 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 131921 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 131921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131933 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131939 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131944 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 131952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131965 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131970 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131975 */   GIR_RootConstrainSelectedInstOperands,
     /* 131976 */   // GIR_Coverage, 4523,
     /* 131976 */   GIR_EraseRootFromParent_Done,
     /* 131977 */ // Label 2321: @131977
     /* 131977 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(132083), // Rule ID 13279 //
     /* 131982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131985 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131989 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131993 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131997 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132001 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132005 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132010 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132014 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132018 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132020 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 132027 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 132027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132039 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132045 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132050 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 132058 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132076 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132081 */   GIR_RootConstrainSelectedInstOperands,
     /* 132082 */   // GIR_Coverage, 13279,
     /* 132082 */   GIR_EraseRootFromParent_Done,
     /* 132083 */ // Label 2322: @132083
     /* 132083 */ GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(132189), // Rule ID 13280 //
     /* 132088 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132091 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132095 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132099 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132103 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132107 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132111 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132116 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132124 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132126 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 132133 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 132133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132145 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132151 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132156 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 132164 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132187 */   GIR_RootConstrainSelectedInstOperands,
     /* 132188 */   // GIR_Coverage, 13280,
     /* 132188 */   GIR_EraseRootFromParent_Done,
     /* 132189 */ // Label 2323: @132189
     /* 132189 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(132297), // Rule ID 4546 //
     /* 132194 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132197 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132201 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132208 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132212 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132216 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132220 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132224 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132229 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132233 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132237 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132239 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132246 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132258 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132264 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132269 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132295 */   GIR_RootConstrainSelectedInstOperands,
     /* 132296 */   // GIR_Coverage, 4546,
     /* 132296 */   GIR_EraseRootFromParent_Done,
     /* 132297 */ // Label 2324: @132297
     /* 132297 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(132398), // Rule ID 4548 //
     /* 132302 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132305 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132309 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132313 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132317 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132321 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132325 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132330 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132334 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132338 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132340 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 132347 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 132347 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132350 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132354 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132359 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132370 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 132378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132391 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132396 */   GIR_RootConstrainSelectedInstOperands,
     /* 132397 */   // GIR_Coverage, 4548,
     /* 132397 */   GIR_EraseRootFromParent_Done,
     /* 132398 */ // Label 2325: @132398
     /* 132398 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(132499), // Rule ID 4549 //
     /* 132403 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132406 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132410 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132414 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132418 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132422 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132426 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132431 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132435 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132439 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 132448 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 132448 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132451 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132455 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132460 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132466 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132471 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 132479 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132497 */   GIR_RootConstrainSelectedInstOperands,
     /* 132498 */   // GIR_Coverage, 4549,
     /* 132498 */   GIR_EraseRootFromParent_Done,
     /* 132499 */ // Label 2326: @132499
     /* 132499 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(132607), // Rule ID 4573 //
     /* 132504 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132507 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132511 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132518 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132522 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132526 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132530 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132534 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132539 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132547 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132549 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132556 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132568 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132574 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132579 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132600 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132605 */   GIR_RootConstrainSelectedInstOperands,
     /* 132606 */   // GIR_Coverage, 4573,
     /* 132606 */   GIR_EraseRootFromParent_Done,
     /* 132607 */ // Label 2327: @132607
     /* 132607 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(132708), // Rule ID 4575 //
     /* 132612 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132615 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132619 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132627 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132631 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132635 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132640 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132644 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132648 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132650 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132657 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132669 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132675 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132680 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 132688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132691 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132701 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132706 */   GIR_RootConstrainSelectedInstOperands,
     /* 132707 */   // GIR_Coverage, 4575,
     /* 132707 */   GIR_EraseRootFromParent_Done,
     /* 132708 */ // Label 2328: @132708
     /* 132708 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(132809), // Rule ID 4576 //
     /* 132713 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132716 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132720 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132724 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132728 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132732 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132736 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132741 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132745 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132749 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132751 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132758 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132758 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132761 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132765 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132770 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132776 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132781 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 132789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132807 */   GIR_RootConstrainSelectedInstOperands,
     /* 132808 */   // GIR_Coverage, 4576,
     /* 132808 */   GIR_EraseRootFromParent_Done,
     /* 132809 */ // Label 2329: @132809
     /* 132809 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(132910), // Rule ID 13276 //
     /* 132814 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132817 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132821 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132825 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132829 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132833 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132837 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132842 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132846 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132850 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 132859 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 132859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132871 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132877 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132882 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 132890 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132908 */   GIR_RootConstrainSelectedInstOperands,
     /* 132909 */   // GIR_Coverage, 13276,
     /* 132909 */   GIR_EraseRootFromParent_Done,
     /* 132910 */ // Label 2330: @132910
     /* 132910 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(133011), // Rule ID 13278 //
     /* 132915 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132930 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132934 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132938 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132943 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132951 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132953 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 132960 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132972 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132978 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132983 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 132991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133009 */   GIR_RootConstrainSelectedInstOperands,
     /* 133010 */   // GIR_Coverage, 13278,
     /* 133010 */   GIR_EraseRootFromParent_Done,
     /* 133011 */ // Label 2331: @133011
     /* 133011 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(133093), // Rule ID 6513 //
     /* 133016 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133019 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133023 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133030 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133034 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133038 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 133042 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133046 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133051 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133055 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133059 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 133063 */   // MIs[2] Operand 1
     /* 133063 */   // No operand predicates
     /* 133063 */   // MIs[0] Rn
     /* 133063 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133071 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133073 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 133076 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133080 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133083 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133085 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133091 */   GIR_RootConstrainSelectedInstOperands,
     /* 133092 */   // GIR_Coverage, 6513,
     /* 133092 */   GIR_EraseRootFromParent_Done,
     /* 133093 */ // Label 2332: @133093
     /* 133093 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(133175), // Rule ID 6514 //
     /* 133098 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133101 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133112 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133116 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133120 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 133124 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133128 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133133 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133137 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133141 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 133145 */   // MIs[2] Operand 1
     /* 133145 */   // No operand predicates
     /* 133145 */   // MIs[0] Rn
     /* 133145 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133153 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133155 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 133158 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133162 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133165 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133167 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133173 */   GIR_RootConstrainSelectedInstOperands,
     /* 133174 */   // GIR_Coverage, 6514,
     /* 133174 */   GIR_EraseRootFromParent_Done,
     /* 133175 */ // Label 2333: @133175
     /* 133175 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(133250), // Rule ID 6515 //
     /* 133180 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133183 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133187 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133191 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133195 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133199 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133203 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133208 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133212 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133216 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133220 */   // MIs[2] Operand 1
     /* 133220 */   // No operand predicates
     /* 133220 */   // MIs[0] Rn
     /* 133220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133228 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133230 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133233 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133237 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133240 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133248 */   GIR_RootConstrainSelectedInstOperands,
     /* 133249 */   // GIR_Coverage, 6515,
     /* 133249 */   GIR_EraseRootFromParent_Done,
     /* 133250 */ // Label 2334: @133250
     /* 133250 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(133325), // Rule ID 6516 //
     /* 133255 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133258 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133262 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133266 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133270 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133274 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133278 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133283 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133287 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133291 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133295 */   // MIs[2] Operand 1
     /* 133295 */   // No operand predicates
     /* 133295 */   // MIs[0] Rn
     /* 133295 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133303 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133305 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133308 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133312 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133315 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133317 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133323 */   GIR_RootConstrainSelectedInstOperands,
     /* 133324 */   // GIR_Coverage, 6516,
     /* 133324 */   GIR_EraseRootFromParent_Done,
     /* 133325 */ // Label 2335: @133325
     /* 133325 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(133438), // Rule ID 6520 //
     /* 133330 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133333 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133337 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133344 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133348 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133352 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 133356 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133360 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133365 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133369 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133373 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 133377 */   // MIs[2] Operand 1
     /* 133377 */   // No operand predicates
     /* 133377 */   // MIs[0] Rn
     /* 133377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133385 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133387 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133399 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133402 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133406 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133409 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133414 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 133422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133425 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133428 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133430 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133436 */   GIR_RootConstrainSelectedInstOperands,
     /* 133437 */   // GIR_Coverage, 6520,
     /* 133437 */   GIR_EraseRootFromParent_Done,
     /* 133438 */ // Label 2336: @133438
     /* 133438 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(133551), // Rule ID 6521 //
     /* 133443 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133446 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133450 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133457 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133461 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133465 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 133469 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133473 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133478 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133482 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133486 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 133490 */   // MIs[2] Operand 1
     /* 133490 */   // No operand predicates
     /* 133490 */   // MIs[0] Rn
     /* 133490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133498 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133500 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133512 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133515 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133519 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133522 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133527 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 133535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133538 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133541 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133543 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133549 */   GIR_RootConstrainSelectedInstOperands,
     /* 133550 */   // GIR_Coverage, 6521,
     /* 133550 */   GIR_EraseRootFromParent_Done,
     /* 133551 */ // Label 2337: @133551
     /* 133551 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(133657), // Rule ID 6522 //
     /* 133556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133559 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133563 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133567 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133571 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133575 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133579 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133584 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133588 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133592 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133596 */   // MIs[2] Operand 1
     /* 133596 */   // No operand predicates
     /* 133596 */   // MIs[0] Rn
     /* 133596 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133604 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133606 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133618 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133621 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133625 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133628 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133633 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133644 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133647 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133649 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133655 */   GIR_RootConstrainSelectedInstOperands,
     /* 133656 */   // GIR_Coverage, 6522,
     /* 133656 */   GIR_EraseRootFromParent_Done,
     /* 133657 */ // Label 2338: @133657
     /* 133657 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(133763), // Rule ID 6523 //
     /* 133662 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133665 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133669 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133673 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133677 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133681 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133685 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133690 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133694 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133698 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133702 */   // MIs[2] Operand 1
     /* 133702 */   // No operand predicates
     /* 133702 */   // MIs[0] Rn
     /* 133702 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133710 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133712 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133712 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133715 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133719 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133724 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133727 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133731 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133734 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133750 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133753 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133761 */   GIR_RootConstrainSelectedInstOperands,
     /* 133762 */   // GIR_Coverage, 6523,
     /* 133762 */   GIR_EraseRootFromParent_Done,
     /* 133763 */ // Label 2339: @133763
     /* 133763 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(133823), // Rule ID 295 //
     /* 133768 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133771 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133775 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133786 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133790 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 133797 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 133797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 133800 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133817 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133821 */   GIR_RootConstrainSelectedInstOperands,
     /* 133822 */   // GIR_Coverage, 295,
     /* 133822 */   GIR_EraseRootFromParent_Done,
     /* 133823 */ // Label 2340: @133823
     /* 133823 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(133883), // Rule ID 296 //
     /* 133828 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133831 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133835 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133846 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133850 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 133857 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 133857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 133860 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133881 */   GIR_RootConstrainSelectedInstOperands,
     /* 133882 */   // GIR_Coverage, 296,
     /* 133882 */   GIR_EraseRootFromParent_Done,
     /* 133883 */ // Label 2341: @133883
     /* 133883 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(133943), // Rule ID 297 //
     /* 133888 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133891 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133895 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 133917 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 133917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 133920 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133937 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133941 */   GIR_RootConstrainSelectedInstOperands,
     /* 133942 */   // GIR_Coverage, 297,
     /* 133942 */   GIR_EraseRootFromParent_Done,
     /* 133943 */ // Label 2342: @133943
     /* 133943 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(134003), // Rule ID 298 //
     /* 133948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133951 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133955 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 133977 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 133977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 133980 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134001 */   GIR_RootConstrainSelectedInstOperands,
     /* 134002 */   // GIR_Coverage, 298,
     /* 134002 */   GIR_EraseRootFromParent_Done,
     /* 134003 */ // Label 2343: @134003
     /* 134003 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(134056), // Rule ID 299 //
     /* 134008 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134011 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134019 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134023 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134030 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 134033 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134040 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134050 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134054 */   GIR_RootConstrainSelectedInstOperands,
     /* 134055 */   // GIR_Coverage, 299,
     /* 134055 */   GIR_EraseRootFromParent_Done,
     /* 134056 */ // Label 2344: @134056
     /* 134056 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(134109), // Rule ID 300 //
     /* 134061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134064 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134072 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134076 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134083 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 134086 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134088 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134103 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134107 */   GIR_RootConstrainSelectedInstOperands,
     /* 134108 */   // GIR_Coverage, 300,
     /* 134108 */   GIR_EraseRootFromParent_Done,
     /* 134109 */ // Label 2345: @134109
     /* 134109 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(134165), // Rule ID 307 //
     /* 134114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134117 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134120 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134128 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134132 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134139 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 134142 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134159 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134163 */   GIR_RootConstrainSelectedInstOperands,
     /* 134164 */   // GIR_Coverage, 307,
     /* 134164 */   GIR_EraseRootFromParent_Done,
     /* 134165 */ // Label 2346: @134165
     /* 134165 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(134221), // Rule ID 308 //
     /* 134170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134173 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134176 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134188 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134195 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 134198 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134215 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134219 */   GIR_RootConstrainSelectedInstOperands,
     /* 134220 */   // GIR_Coverage, 308,
     /* 134220 */   GIR_EraseRootFromParent_Done,
     /* 134221 */ // Label 2347: @134221
     /* 134221 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(134273), // Rule ID 312 //
     /* 134226 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134229 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134248 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 134251 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 134257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134267 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134271 */   GIR_RootConstrainSelectedInstOperands,
     /* 134272 */   // GIR_Coverage, 312,
     /* 134272 */   GIR_EraseRootFromParent_Done,
     /* 134273 */ // Label 2348: @134273
     /* 134273 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(134324), // Rule ID 315 //
     /* 134278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134281 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134284 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134292 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134296 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134303 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 134306 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134318 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134322 */   GIR_RootConstrainSelectedInstOperands,
     /* 134323 */   // GIR_Coverage, 315,
     /* 134323 */   GIR_EraseRootFromParent_Done,
     /* 134324 */ // Label 2349: @134324
     /* 134324 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(134383), // Rule ID 317 //
     /* 134329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134332 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 134358 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 134358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 134361 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 134367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134377 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134381 */   GIR_RootConstrainSelectedInstOperands,
     /* 134382 */   // GIR_Coverage, 317,
     /* 134382 */   GIR_EraseRootFromParent_Done,
     /* 134383 */ // Label 2350: @134383
     /* 134383 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(134442), // Rule ID 318 //
     /* 134388 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134391 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134395 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134410 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 134417 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 134417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 134420 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 134426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134436 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134440 */   GIR_RootConstrainSelectedInstOperands,
     /* 134441 */   // GIR_Coverage, 318,
     /* 134441 */   GIR_EraseRootFromParent_Done,
     /* 134442 */ // Label 2351: @134442
     /* 134442 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(134519), // Rule ID 7146 //
     /* 134447 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134450 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134457 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134460 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 134468 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 134472 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134477 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134481 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134483 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134490 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15818>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 134493 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 134497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134517 */   GIR_RootConstrainSelectedInstOperands,
     /* 134518 */   // GIR_Coverage, 7146,
     /* 134518 */   GIR_EraseRootFromParent_Done,
     /* 134519 */ // Label 2352: @134519
     /* 134519 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(134596), // Rule ID 7147 //
     /* 134524 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134527 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134534 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134537 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134541 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 134545 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 134549 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134554 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134558 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134560 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134567 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15818>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 134570 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 134574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134594 */   GIR_RootConstrainSelectedInstOperands,
     /* 134595 */   // GIR_Coverage, 7147,
     /* 134595 */   GIR_EraseRootFromParent_Done,
     /* 134596 */ // Label 2353: @134596
     /* 134596 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(134655), // Rule ID 7127 //
     /* 134601 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134604 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134611 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134618 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 134629 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15804>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 134629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 134632 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134649 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134653 */   GIR_RootConstrainSelectedInstOperands,
     /* 134654 */   // GIR_Coverage, 7127,
     /* 134654 */   GIR_EraseRootFromParent_Done,
     /* 134655 */ // Label 2354: @134655
     /* 134655 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(134714), // Rule ID 7128 //
     /* 134660 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134663 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134670 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134677 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134681 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 134688 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15804>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 134688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 134691 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134708 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134712 */   GIR_RootConstrainSelectedInstOperands,
     /* 134713 */   // GIR_Coverage, 7128,
     /* 134713 */   GIR_EraseRootFromParent_Done,
     /* 134714 */ // Label 2355: @134714
     /* 134714 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(134773), // Rule ID 7132 //
     /* 134719 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134722 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134729 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134736 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 134747 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15811>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 134747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 134750 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134771 */   GIR_RootConstrainSelectedInstOperands,
     /* 134772 */   // GIR_Coverage, 7132,
     /* 134772 */   GIR_EraseRootFromParent_Done,
     /* 134773 */ // Label 2356: @134773
     /* 134773 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(134832), // Rule ID 7133 //
     /* 134778 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134781 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134788 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 134806 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15811>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 134806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 134809 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134826 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134830 */   GIR_RootConstrainSelectedInstOperands,
     /* 134831 */   // GIR_Coverage, 7133,
     /* 134831 */   GIR_EraseRootFromParent_Done,
     /* 134832 */ // Label 2357: @134832
     /* 134832 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(134891), // Rule ID 7137 //
     /* 134837 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134840 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134847 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134854 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134858 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134865 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15818>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 134868 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134885 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134889 */   GIR_RootConstrainSelectedInstOperands,
     /* 134890 */   // GIR_Coverage, 7137,
     /* 134890 */   GIR_EraseRootFromParent_Done,
     /* 134891 */ // Label 2358: @134891
     /* 134891 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(134950), // Rule ID 7138 //
     /* 134896 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134899 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134906 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134913 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134917 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134924 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15818>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 134927 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134948 */   GIR_RootConstrainSelectedInstOperands,
     /* 134949 */   // GIR_Coverage, 7138,
     /* 134949 */   GIR_EraseRootFromParent_Done,
     /* 134950 */ // Label 2359: @134950
     /* 134950 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(135022), // Rule ID 7148 //
     /* 134955 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134958 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134965 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 134976 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 134980 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134985 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134989 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134991 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134998 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15818>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 135001 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 135005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135015 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135020 */   GIR_RootConstrainSelectedInstOperands,
     /* 135021 */   // GIR_Coverage, 7148,
     /* 135021 */   GIR_EraseRootFromParent_Done,
     /* 135022 */ // Label 2360: @135022
     /* 135022 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(135094), // Rule ID 7149 //
     /* 135027 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135030 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135037 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 135048 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 135052 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135057 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135061 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135063 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135070 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15818>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 135073 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 135077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135092 */   GIR_RootConstrainSelectedInstOperands,
     /* 135093 */   // GIR_Coverage, 7149,
     /* 135093 */   GIR_EraseRootFromParent_Done,
     /* 135094 */ // Label 2361: @135094
     /* 135094 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(135146), // Rule ID 320 //
     /* 135099 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135102 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135110 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135114 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135121 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 135124 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135140 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135144 */   GIR_RootConstrainSelectedInstOperands,
     /* 135145 */   // GIR_Coverage, 320,
     /* 135145 */   GIR_EraseRootFromParent_Done,
     /* 135146 */ // Label 2362: @135146
     /* 135146 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(135197), // Rule ID 323 //
     /* 135151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135154 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135157 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135165 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135169 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135176 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 135179 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135191 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135195 */   GIR_RootConstrainSelectedInstOperands,
     /* 135196 */   // GIR_Coverage, 323,
     /* 135196 */   GIR_EraseRootFromParent_Done,
     /* 135197 */ // Label 2363: @135197
     /* 135197 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(135256), // Rule ID 326 //
     /* 135202 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135205 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135209 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135224 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 135231 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 135234 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135250 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135254 */   GIR_RootConstrainSelectedInstOperands,
     /* 135255 */   // GIR_Coverage, 326,
     /* 135255 */   GIR_EraseRootFromParent_Done,
     /* 135256 */ // Label 2364: @135256
     /* 135256 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(135315), // Rule ID 327 //
     /* 135261 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135264 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135268 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135279 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135283 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 135290 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 135293 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135309 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135313 */   GIR_RootConstrainSelectedInstOperands,
     /* 135314 */   // GIR_Coverage, 327,
     /* 135314 */   GIR_EraseRootFromParent_Done,
     /* 135315 */ // Label 2365: @135315
     /* 135315 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(135369), // Rule ID 7129 //
     /* 135320 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135330 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135341 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 135348 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15804>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 135348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 135351 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135367 */   GIR_RootConstrainSelectedInstOperands,
     /* 135368 */   // GIR_Coverage, 7129,
     /* 135368 */   GIR_EraseRootFromParent_Done,
     /* 135369 */ // Label 2366: @135369
     /* 135369 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(135423), // Rule ID 7130 //
     /* 135374 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135384 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135395 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 135402 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15804>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 135405 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135417 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135421 */   GIR_RootConstrainSelectedInstOperands,
     /* 135422 */   // GIR_Coverage, 7130,
     /* 135422 */   GIR_EraseRootFromParent_Done,
     /* 135423 */ // Label 2367: @135423
     /* 135423 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(135477), // Rule ID 7134 //
     /* 135428 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135438 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135445 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135449 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 135456 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15811>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 135456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 135459 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135475 */   GIR_RootConstrainSelectedInstOperands,
     /* 135476 */   // GIR_Coverage, 7134,
     /* 135476 */   GIR_EraseRootFromParent_Done,
     /* 135477 */ // Label 2368: @135477
     /* 135477 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(135531), // Rule ID 7135 //
     /* 135482 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135485 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135492 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135503 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 135510 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15811>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 135513 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135525 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135529 */   GIR_RootConstrainSelectedInstOperands,
     /* 135530 */   // GIR_Coverage, 7135,
     /* 135530 */   GIR_EraseRootFromParent_Done,
     /* 135531 */ // Label 2369: @135531
     /* 135531 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(135585), // Rule ID 7139 //
     /* 135536 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135539 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135546 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135553 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135557 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 135564 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15818>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 135564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 135567 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135579 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135583 */   GIR_RootConstrainSelectedInstOperands,
     /* 135584 */   // GIR_Coverage, 7139,
     /* 135584 */   GIR_EraseRootFromParent_Done,
     /* 135585 */ // Label 2370: @135585
     /* 135585 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(135639), // Rule ID 7140 //
     /* 135590 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135593 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135600 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135607 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135611 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135618 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15818>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 135621 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135633 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135637 */   GIR_RootConstrainSelectedInstOperands,
     /* 135638 */   // GIR_Coverage, 7140,
     /* 135638 */   GIR_EraseRootFromParent_Done,
     /* 135639 */ // Label 2371: @135639
     /* 135639 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(135696), // Rule ID 7502 //
     /* 135644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 135647 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135650 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135657 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135664 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135668 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 135675 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15802>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 135678 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135690 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135694 */   GIR_RootConstrainSelectedInstOperands,
     /* 135695 */   // GIR_Coverage, 7502,
     /* 135695 */   GIR_EraseRootFromParent_Done,
     /* 135696 */ // Label 2372: @135696
     /* 135696 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(135753), // Rule ID 7503 //
     /* 135701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 135704 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135707 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135714 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135721 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135725 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 135732 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15809>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 135735 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135747 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135751 */   GIR_RootConstrainSelectedInstOperands,
     /* 135752 */   // GIR_Coverage, 7503,
     /* 135752 */   GIR_EraseRootFromParent_Done,
     /* 135753 */ // Label 2373: @135753
     /* 135753 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(135810), // Rule ID 7504 //
     /* 135758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 135761 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135764 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135771 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135778 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135782 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135789 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15816>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 135792 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135804 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135808 */   GIR_RootConstrainSelectedInstOperands,
     /* 135809 */   // GIR_Coverage, 7504,
     /* 135809 */   GIR_EraseRootFromParent_Done,
     /* 135810 */ // Label 2374: @135810
     /* 135810 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(135847), // Rule ID 7126 //
     /* 135815 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135818 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135825 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135832 */   // MIs[0] ptr
     /* 135832 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135840 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15802>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 135840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 135845 */   GIR_RootConstrainSelectedInstOperands,
     /* 135846 */   // GIR_Coverage, 7126,
     /* 135846 */   GIR_Done,
     /* 135847 */ // Label 2375: @135847
     /* 135847 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(135884), // Rule ID 7131 //
     /* 135852 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135855 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135862 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135869 */   // MIs[0] ptr
     /* 135869 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135877 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15809>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 135877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 135882 */   GIR_RootConstrainSelectedInstOperands,
     /* 135883 */   // GIR_Coverage, 7131,
     /* 135883 */   GIR_Done,
     /* 135884 */ // Label 2376: @135884
     /* 135884 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(135921), // Rule ID 7136 //
     /* 135889 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135892 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135899 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135906 */   // MIs[0] ptr
     /* 135906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135914 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15816>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 135914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 135919 */   GIR_RootConstrainSelectedInstOperands,
     /* 135920 */   // GIR_Coverage, 7136,
     /* 135920 */   GIR_Done,
     /* 135921 */ // Label 2377: @135921
     /* 135921 */ GIM_Reject,
     /* 135922 */ // Label 2276: @135922
     /* 135922 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(136028), // Rule ID 4524 //
     /* 135927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135934 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135942 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 135946 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135950 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135955 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 135959 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135963 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135965 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 135972 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 135972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 135975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135984 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 135990 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 136003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136021 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136026 */   GIR_RootConstrainSelectedInstOperands,
     /* 136027 */   // GIR_Coverage, 4524,
     /* 136027 */   GIR_EraseRootFromParent_Done,
     /* 136028 */ // Label 2378: @136028
     /* 136028 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(136134), // Rule ID 4525 //
     /* 136033 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136036 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136048 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136052 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136056 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136061 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136071 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 136078 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 136078 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136085 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136090 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136096 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 136109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136132 */   GIR_RootConstrainSelectedInstOperands,
     /* 136133 */   // GIR_Coverage, 4525,
     /* 136133 */   GIR_EraseRootFromParent_Done,
     /* 136134 */ // Label 2379: @136134
     /* 136134 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(136240), // Rule ID 4526 //
     /* 136139 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136142 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136146 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136150 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136154 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136158 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136162 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136167 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136171 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136177 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 136184 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 136184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136196 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136202 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 136215 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136238 */   GIR_RootConstrainSelectedInstOperands,
     /* 136239 */   // GIR_Coverage, 4526,
     /* 136239 */   GIR_EraseRootFromParent_Done,
     /* 136240 */ // Label 2380: @136240
     /* 136240 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(136346), // Rule ID 4527 //
     /* 136245 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136248 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136260 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136264 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136268 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136273 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136283 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 136290 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 136290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136302 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136308 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136313 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 136321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136344 */   GIR_RootConstrainSelectedInstOperands,
     /* 136345 */   // GIR_Coverage, 4527,
     /* 136345 */   GIR_EraseRootFromParent_Done,
     /* 136346 */ // Label 2381: @136346
     /* 136346 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(136447), // Rule ID 4550 //
     /* 136351 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136354 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136366 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136370 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136374 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136379 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136383 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136387 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136389 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 136396 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 136396 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136399 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136403 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136408 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136414 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136419 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 136427 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136445 */   GIR_RootConstrainSelectedInstOperands,
     /* 136446 */   // GIR_Coverage, 4550,
     /* 136446 */   GIR_EraseRootFromParent_Done,
     /* 136447 */ // Label 2382: @136447
     /* 136447 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(136548), // Rule ID 4551 //
     /* 136452 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136455 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136467 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136471 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136475 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136480 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136484 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 136497 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 136497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136509 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136520 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 136528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136541 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136546 */   GIR_RootConstrainSelectedInstOperands,
     /* 136547 */   // GIR_Coverage, 4551,
     /* 136547 */   GIR_EraseRootFromParent_Done,
     /* 136548 */ // Label 2383: @136548
     /* 136548 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(136649), // Rule ID 4577 //
     /* 136553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136556 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136560 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136564 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136568 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136572 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136576 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136581 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136585 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136589 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136591 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 136598 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136610 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136616 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136621 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 136629 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136632 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136642 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136647 */   GIR_RootConstrainSelectedInstOperands,
     /* 136648 */   // GIR_Coverage, 4577,
     /* 136648 */   GIR_EraseRootFromParent_Done,
     /* 136649 */ // Label 2384: @136649
     /* 136649 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(136750), // Rule ID 4578 //
     /* 136654 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136657 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136661 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136665 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136669 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136673 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136677 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136682 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136686 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136690 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136692 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 136699 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136699 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136702 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136706 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136711 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136717 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136722 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 136730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136743 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136748 */   GIR_RootConstrainSelectedInstOperands,
     /* 136749 */   // GIR_Coverage, 4578,
     /* 136749 */   GIR_EraseRootFromParent_Done,
     /* 136750 */ // Label 2385: @136750
     /* 136750 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(136825), // Rule ID 6517 //
     /* 136755 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136758 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136762 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136770 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136774 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136778 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136783 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 136787 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 136791 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 136795 */   // MIs[2] Operand 1
     /* 136795 */   // No operand predicates
     /* 136795 */   // MIs[0] Rn
     /* 136795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136803 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 136805 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 136805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 136808 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 136812 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 136815 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136817 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 136823 */   GIR_RootConstrainSelectedInstOperands,
     /* 136824 */   // GIR_Coverage, 6517,
     /* 136824 */   GIR_EraseRootFromParent_Done,
     /* 136825 */ // Label 2386: @136825
     /* 136825 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(136900), // Rule ID 6518 //
     /* 136830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136833 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136837 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136845 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136849 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136853 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136858 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 136862 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 136866 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 136870 */   // MIs[2] Operand 1
     /* 136870 */   // No operand predicates
     /* 136870 */   // MIs[0] Rn
     /* 136870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136878 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 136880 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 136880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 136883 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 136887 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 136890 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136892 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 136898 */   GIR_RootConstrainSelectedInstOperands,
     /* 136899 */   // GIR_Coverage, 6518,
     /* 136899 */   GIR_EraseRootFromParent_Done,
     /* 136900 */ // Label 2387: @136900
     /* 136900 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(136953), // Rule ID 301 //
     /* 136905 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136908 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136916 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136920 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 136927 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 136927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 136930 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136947 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136951 */   GIR_RootConstrainSelectedInstOperands,
     /* 136952 */   // GIR_Coverage, 301,
     /* 136952 */   GIR_EraseRootFromParent_Done,
     /* 136953 */ // Label 2388: @136953
     /* 136953 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(137006), // Rule ID 302 //
     /* 136958 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136961 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136969 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136973 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 136980 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 136980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 136983 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137000 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137004 */   GIR_RootConstrainSelectedInstOperands,
     /* 137005 */   // GIR_Coverage, 302,
     /* 137005 */   GIR_EraseRootFromParent_Done,
     /* 137006 */ // Label 2389: @137006
     /* 137006 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(137062), // Rule ID 309 //
     /* 137011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137014 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137017 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137025 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137036 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137039 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137056 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137060 */   GIR_RootConstrainSelectedInstOperands,
     /* 137061 */   // GIR_Coverage, 309,
     /* 137061 */   GIR_EraseRootFromParent_Done,
     /* 137062 */ // Label 2390: @137062
     /* 137062 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(137118), // Rule ID 310 //
     /* 137067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137070 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137073 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137081 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137085 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137092 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137095 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137112 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137116 */   GIR_RootConstrainSelectedInstOperands,
     /* 137117 */   // GIR_Coverage, 310,
     /* 137117 */   GIR_EraseRootFromParent_Done,
     /* 137118 */ // Label 2391: @137118
     /* 137118 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(137207), // Rule ID 4482 //
     /* 137123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137126 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137130 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137141 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137145 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 137152 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 137152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137164 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137170 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137175 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 137183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137201 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137205 */   GIR_RootConstrainSelectedInstOperands,
     /* 137206 */   // GIR_Coverage, 4482,
     /* 137206 */   GIR_EraseRootFromParent_Done,
     /* 137207 */ // Label 2392: @137207
     /* 137207 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(137296), // Rule ID 4483 //
     /* 137212 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137215 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137219 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137234 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 137241 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 137241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137253 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137259 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137264 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 137272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137294 */   GIR_RootConstrainSelectedInstOperands,
     /* 137295 */   // GIR_Coverage, 4483,
     /* 137295 */   GIR_EraseRootFromParent_Done,
     /* 137296 */ // Label 2393: @137296
     /* 137296 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(137385), // Rule ID 4484 //
     /* 137301 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137304 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137308 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 137330 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 137330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137342 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137348 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137353 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 137361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137379 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137383 */   GIR_RootConstrainSelectedInstOperands,
     /* 137384 */   // GIR_Coverage, 4484,
     /* 137384 */   GIR_EraseRootFromParent_Done,
     /* 137385 */ // Label 2394: @137385
     /* 137385 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(137474), // Rule ID 4485 //
     /* 137390 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137393 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137397 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137408 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137412 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 137419 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 137419 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137422 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137426 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137431 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137437 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137442 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 137450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137472 */   GIR_RootConstrainSelectedInstOperands,
     /* 137473 */   // GIR_Coverage, 4485,
     /* 137473 */   GIR_EraseRootFromParent_Done,
     /* 137474 */ // Label 2395: @137474
     /* 137474 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(137563), // Rule ID 4486 //
     /* 137479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137482 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137486 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137497 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137501 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 137508 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 137508 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137511 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137515 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137520 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137526 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137531 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 137539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137557 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137561 */   GIR_RootConstrainSelectedInstOperands,
     /* 137562 */   // GIR_Coverage, 4486,
     /* 137562 */   GIR_EraseRootFromParent_Done,
     /* 137563 */ // Label 2396: @137563
     /* 137563 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(137652), // Rule ID 4487 //
     /* 137568 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137571 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137575 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137586 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137590 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 137597 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 137597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137609 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137620 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 137628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137646 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137650 */   GIR_RootConstrainSelectedInstOperands,
     /* 137651 */   // GIR_Coverage, 4487,
     /* 137651 */   GIR_EraseRootFromParent_Done,
     /* 137652 */ // Label 2397: @137652
     /* 137652 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(137705), // Rule ID 4498 //
     /* 137657 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137660 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137668 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137672 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137679 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137682 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137699 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137703 */   GIR_RootConstrainSelectedInstOperands,
     /* 137704 */   // GIR_Coverage, 4498,
     /* 137704 */   GIR_EraseRootFromParent_Done,
     /* 137705 */ // Label 2398: @137705
     /* 137705 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(137758), // Rule ID 4499 //
     /* 137710 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137713 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137721 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137725 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137732 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137735 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137752 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137756 */   GIR_RootConstrainSelectedInstOperands,
     /* 137757 */   // GIR_Coverage, 4499,
     /* 137757 */   GIR_EraseRootFromParent_Done,
     /* 137758 */ // Label 2399: @137758
     /* 137758 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(137811), // Rule ID 4500 //
     /* 137763 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137766 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137774 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137778 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137785 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137788 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137805 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137809 */   GIR_RootConstrainSelectedInstOperands,
     /* 137810 */   // GIR_Coverage, 4500,
     /* 137810 */   GIR_EraseRootFromParent_Done,
     /* 137811 */ // Label 2400: @137811
     /* 137811 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(137864), // Rule ID 4501 //
     /* 137816 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137819 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137831 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137838 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137841 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137848 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137858 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137862 */   GIR_RootConstrainSelectedInstOperands,
     /* 137863 */   // GIR_Coverage, 4501,
     /* 137863 */   GIR_EraseRootFromParent_Done,
     /* 137864 */ // Label 2401: @137864
     /* 137864 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(137916), // Rule ID 311 //
     /* 137869 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137872 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137891 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 137894 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 137900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137914 */   GIR_RootConstrainSelectedInstOperands,
     /* 137915 */   // GIR_Coverage, 311,
     /* 137915 */   GIR_EraseRootFromParent_Done,
     /* 137916 */ // Label 2402: @137916
     /* 137916 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(137967), // Rule ID 316 //
     /* 137921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137924 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137927 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137935 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137939 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137946 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 137949 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137961 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137965 */   GIR_RootConstrainSelectedInstOperands,
     /* 137966 */   // GIR_Coverage, 316,
     /* 137966 */   GIR_EraseRootFromParent_Done,
     /* 137967 */ // Label 2403: @137967
     /* 137967 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(138015), // Rule ID 4528 //
     /* 137972 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137975 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137994 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 137997 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138009 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138013 */   GIR_RootConstrainSelectedInstOperands,
     /* 138014 */   // GIR_Coverage, 4528,
     /* 138014 */   GIR_EraseRootFromParent_Done,
     /* 138015 */ // Label 2404: @138015
     /* 138015 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(138063), // Rule ID 4529 //
     /* 138020 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138023 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138031 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138035 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 138042 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 138042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 138045 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138057 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138061 */   GIR_RootConstrainSelectedInstOperands,
     /* 138062 */   // GIR_Coverage, 4529,
     /* 138062 */   GIR_EraseRootFromParent_Done,
     /* 138063 */ // Label 2405: @138063
     /* 138063 */ GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(138147), // Rule ID 4543 //
     /* 138068 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138071 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138075 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138086 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138090 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 138097 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 138097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138109 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138115 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138120 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 138128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138141 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138145 */   GIR_RootConstrainSelectedInstOperands,
     /* 138146 */   // GIR_Coverage, 4543,
     /* 138146 */   GIR_EraseRootFromParent_Done,
     /* 138147 */ // Label 2406: @138147
     /* 138147 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(138231), // Rule ID 4544 //
     /* 138152 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138155 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138170 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138174 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 138181 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 138181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138193 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138199 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138204 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 138212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138225 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138229 */   GIR_RootConstrainSelectedInstOperands,
     /* 138230 */   // GIR_Coverage, 4544,
     /* 138230 */   GIR_EraseRootFromParent_Done,
     /* 138231 */ // Label 2407: @138231
     /* 138231 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(138315), // Rule ID 4545 //
     /* 138236 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138239 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138243 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 138250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138254 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138258 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 138265 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 138265 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138268 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138272 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138277 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138283 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138288 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 138296 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138309 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138313 */   GIR_RootConstrainSelectedInstOperands,
     /* 138314 */   // GIR_Coverage, 4545,
     /* 138314 */   GIR_EraseRootFromParent_Done,
     /* 138315 */ // Label 2408: @138315
     /* 138315 */ GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(138392), // Rule ID 7150 //
     /* 138320 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138330 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138333 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138337 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138341 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138345 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138354 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138356 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138363 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15825>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 138366 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138385 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138390 */   GIR_RootConstrainSelectedInstOperands,
     /* 138391 */   // GIR_Coverage, 7150,
     /* 138391 */   GIR_EraseRootFromParent_Done,
     /* 138392 */ // Label 2409: @138392
     /* 138392 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(138469), // Rule ID 7151 //
     /* 138397 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138400 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138407 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138410 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138414 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138418 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138422 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138427 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138440 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15825>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 138443 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138447 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138462 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138467 */   GIR_RootConstrainSelectedInstOperands,
     /* 138468 */   // GIR_Coverage, 7151,
     /* 138468 */   GIR_EraseRootFromParent_Done,
     /* 138469 */ // Label 2410: @138469
     /* 138469 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(138528), // Rule ID 7142 //
     /* 138474 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138477 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138484 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138495 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138502 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15825>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 138505 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 138507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138522 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138526 */   GIR_RootConstrainSelectedInstOperands,
     /* 138527 */   // GIR_Coverage, 7142,
     /* 138527 */   GIR_EraseRootFromParent_Done,
     /* 138528 */ // Label 2411: @138528
     /* 138528 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(138587), // Rule ID 7143 //
     /* 138533 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138536 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138543 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138554 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138561 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15825>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 138564 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 138566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138581 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138585 */   GIR_RootConstrainSelectedInstOperands,
     /* 138586 */   // GIR_Coverage, 7143,
     /* 138586 */   GIR_EraseRootFromParent_Done,
     /* 138587 */ // Label 2412: @138587
     /* 138587 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(138659), // Rule ID 7152 //
     /* 138592 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138595 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138602 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138605 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138609 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138613 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138617 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138622 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138626 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 138635 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15825>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 138635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 138638 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138657 */   GIR_RootConstrainSelectedInstOperands,
     /* 138658 */   // GIR_Coverage, 7152,
     /* 138658 */   GIR_EraseRootFromParent_Done,
     /* 138659 */ // Label 2413: @138659
     /* 138659 */ GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(138731), // Rule ID 7153 //
     /* 138664 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138667 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138674 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138677 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138681 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138685 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138689 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138694 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138698 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138700 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 138707 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15825>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 138707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138710 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138724 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138729 */   GIR_RootConstrainSelectedInstOperands,
     /* 138730 */   // GIR_Coverage, 7153,
     /* 138730 */   GIR_EraseRootFromParent_Done,
     /* 138731 */ // Label 2414: @138731
     /* 138731 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(138828), // Rule ID 7494 //
     /* 138736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 138739 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138742 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138749 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138752 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138756 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138760 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138764 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 138768 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138772 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138776 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 138780 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138785 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 138789 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 138793 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 138797 */   // MIs[3] Operand 1
     /* 138797 */   // No operand predicates
     /* 138797 */   // MIs[0] Rn
     /* 138797 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138805 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 138807 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15823>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 138807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 138810 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 138814 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 138817 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 138826 */   GIR_RootConstrainSelectedInstOperands,
     /* 138827 */   // GIR_Coverage, 7494,
     /* 138827 */   GIR_EraseRootFromParent_Done,
     /* 138828 */ // Label 2415: @138828
     /* 138828 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(138880), // Rule ID 319 //
     /* 138833 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138836 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138844 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138848 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 138855 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 138855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 138858 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 138864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138874 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138878 */   GIR_RootConstrainSelectedInstOperands,
     /* 138879 */   // GIR_Coverage, 319,
     /* 138879 */   GIR_EraseRootFromParent_Done,
     /* 138880 */ // Label 2416: @138880
     /* 138880 */ GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(138931), // Rule ID 324 //
     /* 138885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138888 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138891 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138899 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138903 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 138910 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 138910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138913 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138925 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138929 */   GIR_RootConstrainSelectedInstOperands,
     /* 138930 */   // GIR_Coverage, 324,
     /* 138930 */   GIR_EraseRootFromParent_Done,
     /* 138931 */ // Label 2417: @138931
     /* 138931 */ GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(138985), // Rule ID 7144 //
     /* 138936 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138946 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138957 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 138964 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15825>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 138964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 138967 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 138969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138979 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138983 */   GIR_RootConstrainSelectedInstOperands,
     /* 138984 */   // GIR_Coverage, 7144,
     /* 138984 */   GIR_EraseRootFromParent_Done,
     /* 138985 */ // Label 2418: @138985
     /* 138985 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(139039), // Rule ID 7145 //
     /* 138990 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138993 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139000 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139007 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139011 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 139018 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15825>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 139021 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 139023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139033 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139037 */   GIR_RootConstrainSelectedInstOperands,
     /* 139038 */   // GIR_Coverage, 7145,
     /* 139038 */   GIR_EraseRootFromParent_Done,
     /* 139039 */ // Label 2419: @139039
     /* 139039 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(139096), // Rule ID 7505 //
     /* 139044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 139047 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139050 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139057 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139064 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139068 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 139075 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15823>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 139078 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 139080 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139090 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139094 */   GIR_RootConstrainSelectedInstOperands,
     /* 139095 */   // GIR_Coverage, 7505,
     /* 139095 */   GIR_EraseRootFromParent_Done,
     /* 139096 */ // Label 2420: @139096
     /* 139096 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(139144), // Rule ID 4552 //
     /* 139101 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139104 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 139123 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 139126 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139142 */   GIR_RootConstrainSelectedInstOperands,
     /* 139143 */   // GIR_Coverage, 4552,
     /* 139143 */   GIR_EraseRootFromParent_Done,
     /* 139144 */ // Label 2421: @139144
     /* 139144 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(139192), // Rule ID 4553 //
     /* 139149 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139152 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139160 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139164 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 139171 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 139174 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139186 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139190 */   GIR_RootConstrainSelectedInstOperands,
     /* 139191 */   // GIR_Coverage, 4553,
     /* 139191 */   GIR_EraseRootFromParent_Done,
     /* 139192 */ // Label 2422: @139192
     /* 139192 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(139276), // Rule ID 4568 //
     /* 139197 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139200 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139204 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139215 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139219 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 139226 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139226 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139229 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139233 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139238 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139244 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139249 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 139257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139274 */   GIR_RootConstrainSelectedInstOperands,
     /* 139275 */   // GIR_Coverage, 4568,
     /* 139275 */   GIR_EraseRootFromParent_Done,
     /* 139276 */ // Label 2423: @139276
     /* 139276 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(139360), // Rule ID 4569 //
     /* 139281 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139284 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139299 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139303 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 139310 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139322 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139328 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139333 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 139341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139354 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139358 */   GIR_RootConstrainSelectedInstOperands,
     /* 139359 */   // GIR_Coverage, 4569,
     /* 139359 */   GIR_EraseRootFromParent_Done,
     /* 139360 */ // Label 2424: @139360
     /* 139360 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(139444), // Rule ID 4570 //
     /* 139365 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139368 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139372 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 139379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139383 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139387 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 139394 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139394 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139397 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139401 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139406 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139412 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139417 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 139425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139438 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139442 */   GIR_RootConstrainSelectedInstOperands,
     /* 139443 */   // GIR_Coverage, 4570,
     /* 139443 */   GIR_EraseRootFromParent_Done,
     /* 139444 */ // Label 2425: @139444
     /* 139444 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(139528), // Rule ID 7493 //
     /* 139449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 139452 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139455 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139462 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139465 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 139469 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 139473 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 139477 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139481 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139486 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 139490 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 139494 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 139498 */   // MIs[2] Operand 1
     /* 139498 */   // No operand predicates
     /* 139498 */   // MIs[0] Rn
     /* 139498 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139506 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139508 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15823>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 139508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 139511 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 139515 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 139518 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139520 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 139526 */   GIR_RootConstrainSelectedInstOperands,
     /* 139527 */   // GIR_Coverage, 7493,
     /* 139527 */   GIR_EraseRootFromParent_Done,
     /* 139528 */ // Label 2426: @139528
     /* 139528 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(139626), // Rule ID 7495 //
     /* 139533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 139536 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139539 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139546 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139549 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 139553 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 139557 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 139561 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139566 */   // MIs[0] Rn
     /* 139566 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139576 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15823>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 139576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 139579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 139583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139588 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 139591 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 139595 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 139598 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 139611 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139617 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139619 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139624 */   GIR_RootConstrainSelectedInstOperands,
     /* 139625 */   // GIR_Coverage, 7495,
     /* 139625 */   GIR_EraseRootFromParent_Done,
     /* 139626 */ // Label 2427: @139626
     /* 139626 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(139663), // Rule ID 7141 //
     /* 139631 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139634 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139641 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139648 */   // MIs[0] ptr
     /* 139648 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139656 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15823>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 139656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 139661 */   GIR_RootConstrainSelectedInstOperands,
     /* 139662 */   // GIR_Coverage, 7141,
     /* 139662 */   GIR_Done,
     /* 139663 */ // Label 2428: @139663
     /* 139663 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(139690), // Rule ID 6465 //
     /* 139668 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139671 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139675 */   // MIs[0] Rn
     /* 139675 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139683 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 139683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 139688 */   GIR_RootConstrainSelectedInstOperands,
     /* 139689 */   // GIR_Coverage, 6465,
     /* 139689 */   GIR_Done,
     /* 139690 */ // Label 2429: @139690
     /* 139690 */ GIM_Reject,
     /* 139691 */ // Label 2277: @139691
     /* 139691 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(139896),
     /* 139696 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139699 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139707 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139711 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(139752), // Rule ID 4480 //
     /* 139716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 139719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 139726 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 139726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 139729 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139750 */     GIR_RootConstrainSelectedInstOperands,
     /* 139751 */     // GIR_Coverage, 4480,
     /* 139751 */     GIR_EraseRootFromParent_Done,
     /* 139752 */   // Label 2431: @139752
     /* 139752 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(139793), // Rule ID 4481 //
     /* 139757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 139760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 139767 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 139767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 139770 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139791 */     GIR_RootConstrainSelectedInstOperands,
     /* 139792 */     // GIR_Coverage, 4481,
     /* 139792 */     GIR_EraseRootFromParent_Done,
     /* 139793 */   // Label 2432: @139793
     /* 139793 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(139826), // Rule ID 4535 //
     /* 139798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 139805 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 139805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 139808 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139824 */     GIR_RootConstrainSelectedInstOperands,
     /* 139825 */     // GIR_Coverage, 4535,
     /* 139825 */     GIR_EraseRootFromParent_Done,
     /* 139826 */   // Label 2433: @139826
     /* 139826 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(139859), // Rule ID 4559 //
     /* 139831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 139838 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 139841 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139857 */     GIR_RootConstrainSelectedInstOperands,
     /* 139858 */     // GIR_Coverage, 4559,
     /* 139858 */     GIR_EraseRootFromParent_Done,
     /* 139859 */   // Label 2434: @139859
     /* 139859 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(139895), // Rule ID 325 //
     /* 139864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 139874 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 139874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 139877 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139893 */     GIR_RootConstrainSelectedInstOperands,
     /* 139894 */     // GIR_Coverage, 325,
     /* 139894 */     GIR_EraseRootFromParent_Done,
     /* 139895 */   // Label 2435: @139895
     /* 139895 */   GIM_Reject,
     /* 139896 */ // Label 2430: @139896
     /* 139896 */ GIM_Reject,
     /* 139897 */ // Label 2278: @139897
     /* 139897 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(140302),
     /* 139902 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139905 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139909 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(139958), // Rule ID 4488 //
     /* 139914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 139917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139932 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139935 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139956 */     GIR_RootConstrainSelectedInstOperands,
     /* 139957 */     // GIR_Coverage, 4488,
     /* 139957 */     GIR_EraseRootFromParent_Done,
     /* 139958 */   // Label 2437: @139958
     /* 139958 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(140007), // Rule ID 4489 //
     /* 139963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 139966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139981 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139984 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140005 */     GIR_RootConstrainSelectedInstOperands,
     /* 140006 */     // GIR_Coverage, 4489,
     /* 140006 */     GIR_EraseRootFromParent_Done,
     /* 140007 */   // Label 2438: @140007
     /* 140007 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(140056), // Rule ID 4490 //
     /* 140012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 140030 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 140030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 140033 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140054 */     GIR_RootConstrainSelectedInstOperands,
     /* 140055 */     // GIR_Coverage, 4490,
     /* 140055 */     GIR_EraseRootFromParent_Done,
     /* 140056 */   // Label 2439: @140056
     /* 140056 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(140105), // Rule ID 4491 //
     /* 140061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140079 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 140082 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140103 */     GIR_RootConstrainSelectedInstOperands,
     /* 140104 */     // GIR_Coverage, 4491,
     /* 140104 */     GIR_EraseRootFromParent_Done,
     /* 140105 */   // Label 2440: @140105
     /* 140105 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(140149), // Rule ID 4530 //
     /* 140110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140128 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140131 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140147 */     GIR_RootConstrainSelectedInstOperands,
     /* 140148 */     // GIR_Coverage, 4530,
     /* 140148 */     GIR_EraseRootFromParent_Done,
     /* 140149 */   // Label 2441: @140149
     /* 140149 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(140193), // Rule ID 4533 //
     /* 140154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140172 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140175 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140191 */     GIR_RootConstrainSelectedInstOperands,
     /* 140192 */     // GIR_Coverage, 4533,
     /* 140192 */     GIR_EraseRootFromParent_Done,
     /* 140193 */   // Label 2442: @140193
     /* 140193 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(140237), // Rule ID 4554 //
     /* 140198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140216 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140219 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140235 */     GIR_RootConstrainSelectedInstOperands,
     /* 140236 */     // GIR_Coverage, 4554,
     /* 140236 */     GIR_EraseRootFromParent_Done,
     /* 140237 */   // Label 2443: @140237
     /* 140237 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(140281), // Rule ID 4557 //
     /* 140242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140260 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140263 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140279 */     GIR_RootConstrainSelectedInstOperands,
     /* 140280 */     // GIR_Coverage, 4557,
     /* 140280 */     GIR_EraseRootFromParent_Done,
     /* 140281 */   // Label 2444: @140281
     /* 140281 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(140301), // Rule ID 6464 //
     /* 140286 */     // MIs[0] Rn
     /* 140286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140294 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 140294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 140299 */     GIR_RootConstrainSelectedInstOperands,
     /* 140300 */     // GIR_Coverage, 6464,
     /* 140300 */     GIR_Done,
     /* 140301 */   // Label 2445: @140301
     /* 140301 */   GIM_Reject,
     /* 140302 */ // Label 2436: @140302
     /* 140302 */ GIM_Reject,
     /* 140303 */ // Label 2279: @140303
     /* 140303 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(140752),
     /* 140308 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140311 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140315 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(140364), // Rule ID 4502 //
     /* 140320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 140338 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 140338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 140341 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140362 */     GIR_RootConstrainSelectedInstOperands,
     /* 140363 */     // GIR_Coverage, 4502,
     /* 140363 */     GIR_EraseRootFromParent_Done,
     /* 140364 */   // Label 2447: @140364
     /* 140364 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(140413), // Rule ID 4503 //
     /* 140369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 140387 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 140387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 140390 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140411 */     GIR_RootConstrainSelectedInstOperands,
     /* 140412 */     // GIR_Coverage, 4503,
     /* 140412 */     GIR_EraseRootFromParent_Done,
     /* 140413 */   // Label 2448: @140413
     /* 140413 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(140462), // Rule ID 4504 //
     /* 140418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 140436 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 140436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 140439 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140460 */     GIR_RootConstrainSelectedInstOperands,
     /* 140461 */     // GIR_Coverage, 4504,
     /* 140461 */     GIR_EraseRootFromParent_Done,
     /* 140462 */   // Label 2449: @140462
     /* 140462 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(140511), // Rule ID 4505 //
     /* 140467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 140485 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 140485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 140488 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140509 */     GIR_RootConstrainSelectedInstOperands,
     /* 140510 */     // GIR_Coverage, 4505,
     /* 140510 */     GIR_EraseRootFromParent_Done,
     /* 140511 */   // Label 2450: @140511
     /* 140511 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(140555), // Rule ID 4537 //
     /* 140516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 140534 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 140534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 140537 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140553 */     GIR_RootConstrainSelectedInstOperands,
     /* 140554 */     // GIR_Coverage, 4537,
     /* 140554 */     GIR_EraseRootFromParent_Done,
     /* 140555 */   // Label 2451: @140555
     /* 140555 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(140599), // Rule ID 4541 //
     /* 140560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 140578 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 140578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 140581 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140597 */     GIR_RootConstrainSelectedInstOperands,
     /* 140598 */     // GIR_Coverage, 4541,
     /* 140598 */     GIR_EraseRootFromParent_Done,
     /* 140599 */   // Label 2452: @140599
     /* 140599 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(140643), // Rule ID 4561 //
     /* 140604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 140622 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 140625 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140641 */     GIR_RootConstrainSelectedInstOperands,
     /* 140642 */     // GIR_Coverage, 4561,
     /* 140642 */     GIR_EraseRootFromParent_Done,
     /* 140643 */   // Label 2453: @140643
     /* 140643 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(140687), // Rule ID 4565 //
     /* 140648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 140666 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 140669 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140685 */     GIR_RootConstrainSelectedInstOperands,
     /* 140686 */     // GIR_Coverage, 4565,
     /* 140686 */     GIR_EraseRootFromParent_Done,
     /* 140687 */   // Label 2454: @140687
     /* 140687 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(140731), // Rule ID 4566 //
     /* 140692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 140710 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 140713 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140729 */     GIR_RootConstrainSelectedInstOperands,
     /* 140730 */     // GIR_Coverage, 4566,
     /* 140730 */     GIR_EraseRootFromParent_Done,
     /* 140731 */   // Label 2455: @140731
     /* 140731 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(140751), // Rule ID 6461 //
     /* 140736 */     // MIs[0] Rn
     /* 140736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140744 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 140744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 140749 */     GIR_RootConstrainSelectedInstOperands,
     /* 140750 */     // GIR_Coverage, 6461,
     /* 140750 */     GIR_Done,
     /* 140751 */   // Label 2456: @140751
     /* 140751 */   GIM_Reject,
     /* 140752 */ // Label 2446: @140752
     /* 140752 */ GIM_Reject,
     /* 140753 */ // Label 2280: @140753
     /* 140753 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(141158),
     /* 140758 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140761 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140765 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(140814), // Rule ID 4492 //
     /* 140770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 140788 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 140788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 140791 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140812 */     GIR_RootConstrainSelectedInstOperands,
     /* 140813 */     // GIR_Coverage, 4492,
     /* 140813 */     GIR_EraseRootFromParent_Done,
     /* 140814 */   // Label 2458: @140814
     /* 140814 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(140863), // Rule ID 4493 //
     /* 140819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140837 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 140840 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140861 */     GIR_RootConstrainSelectedInstOperands,
     /* 140862 */     // GIR_Coverage, 4493,
     /* 140862 */     GIR_EraseRootFromParent_Done,
     /* 140863 */   // Label 2459: @140863
     /* 140863 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(140912), // Rule ID 4496 //
     /* 140868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 140886 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 140886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 140889 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140910 */     GIR_RootConstrainSelectedInstOperands,
     /* 140911 */     // GIR_Coverage, 4496,
     /* 140911 */     GIR_EraseRootFromParent_Done,
     /* 140912 */   // Label 2460: @140912
     /* 140912 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(140961), // Rule ID 4497 //
     /* 140917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140935 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 140938 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140959 */     GIR_RootConstrainSelectedInstOperands,
     /* 140960 */     // GIR_Coverage, 4497,
     /* 140960 */     GIR_EraseRootFromParent_Done,
     /* 140961 */   // Label 2461: @140961
     /* 140961 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(141005), // Rule ID 4532 //
     /* 140966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140984 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140987 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141003 */     GIR_RootConstrainSelectedInstOperands,
     /* 141004 */     // GIR_Coverage, 4532,
     /* 141004 */     GIR_EraseRootFromParent_Done,
     /* 141005 */   // Label 2462: @141005
     /* 141005 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(141049), // Rule ID 4534 //
     /* 141010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 141028 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 141028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 141031 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141047 */     GIR_RootConstrainSelectedInstOperands,
     /* 141048 */     // GIR_Coverage, 4534,
     /* 141048 */     GIR_EraseRootFromParent_Done,
     /* 141049 */   // Label 2463: @141049
     /* 141049 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(141093), // Rule ID 4556 //
     /* 141054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141072 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141075 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141091 */     GIR_RootConstrainSelectedInstOperands,
     /* 141092 */     // GIR_Coverage, 4556,
     /* 141092 */     GIR_EraseRootFromParent_Done,
     /* 141093 */   // Label 2464: @141093
     /* 141093 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(141137), // Rule ID 4558 //
     /* 141098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141116 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141119 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141135 */     GIR_RootConstrainSelectedInstOperands,
     /* 141136 */     // GIR_Coverage, 4558,
     /* 141136 */     GIR_EraseRootFromParent_Done,
     /* 141137 */   // Label 2465: @141137
     /* 141137 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(141157), // Rule ID 6463 //
     /* 141142 */     // MIs[0] Rn
     /* 141142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141150 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 141155 */     GIR_RootConstrainSelectedInstOperands,
     /* 141156 */     // GIR_Coverage, 6463,
     /* 141156 */     GIR_Done,
     /* 141157 */   // Label 2466: @141157
     /* 141157 */   GIM_Reject,
     /* 141158 */ // Label 2457: @141158
     /* 141158 */ GIM_Reject,
     /* 141159 */ // Label 2281: @141159
     /* 141159 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(141564),
     /* 141164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141167 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141171 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(141220), // Rule ID 4506 //
     /* 141176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141194 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141197 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141218 */     GIR_RootConstrainSelectedInstOperands,
     /* 141219 */     // GIR_Coverage, 4506,
     /* 141219 */     GIR_EraseRootFromParent_Done,
     /* 141220 */   // Label 2468: @141220
     /* 141220 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(141269), // Rule ID 4507 //
     /* 141225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141243 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141246 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141267 */     GIR_RootConstrainSelectedInstOperands,
     /* 141268 */     // GIR_Coverage, 4507,
     /* 141268 */     GIR_EraseRootFromParent_Done,
     /* 141269 */   // Label 2469: @141269
     /* 141269 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(141318), // Rule ID 4508 //
     /* 141274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141292 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141295 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141316 */     GIR_RootConstrainSelectedInstOperands,
     /* 141317 */     // GIR_Coverage, 4508,
     /* 141317 */     GIR_EraseRootFromParent_Done,
     /* 141318 */   // Label 2470: @141318
     /* 141318 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(141367), // Rule ID 4509 //
     /* 141323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141341 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141344 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141365 */     GIR_RootConstrainSelectedInstOperands,
     /* 141366 */     // GIR_Coverage, 4509,
     /* 141366 */     GIR_EraseRootFromParent_Done,
     /* 141367 */   // Label 2471: @141367
     /* 141367 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(141411), // Rule ID 4536 //
     /* 141372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 141390 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 141390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 141393 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141409 */     GIR_RootConstrainSelectedInstOperands,
     /* 141410 */     // GIR_Coverage, 4536,
     /* 141410 */     GIR_EraseRootFromParent_Done,
     /* 141411 */   // Label 2472: @141411
     /* 141411 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(141455), // Rule ID 4540 //
     /* 141416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 141434 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 141434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 141437 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141453 */     GIR_RootConstrainSelectedInstOperands,
     /* 141454 */     // GIR_Coverage, 4540,
     /* 141454 */     GIR_EraseRootFromParent_Done,
     /* 141455 */   // Label 2473: @141455
     /* 141455 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(141499), // Rule ID 4560 //
     /* 141460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141478 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141481 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141497 */     GIR_RootConstrainSelectedInstOperands,
     /* 141498 */     // GIR_Coverage, 4560,
     /* 141498 */     GIR_EraseRootFromParent_Done,
     /* 141499 */   // Label 2474: @141499
     /* 141499 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(141543), // Rule ID 4564 //
     /* 141504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141522 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141525 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141541 */     GIR_RootConstrainSelectedInstOperands,
     /* 141542 */     // GIR_Coverage, 4564,
     /* 141542 */     GIR_EraseRootFromParent_Done,
     /* 141543 */   // Label 2475: @141543
     /* 141543 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(141563), // Rule ID 6460 //
     /* 141548 */     // MIs[0] Rn
     /* 141548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141556 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 141561 */     GIR_RootConstrainSelectedInstOperands,
     /* 141562 */     // GIR_Coverage, 6460,
     /* 141562 */     GIR_Done,
     /* 141563 */   // Label 2476: @141563
     /* 141563 */   GIM_Reject,
     /* 141564 */ // Label 2467: @141564
     /* 141564 */ GIM_Reject,
     /* 141565 */ // Label 2282: @141565
     /* 141565 */ GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(141784),
     /* 141570 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141573 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141577 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(141626), // Rule ID 4494 //
     /* 141582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 141600 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 141600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 141603 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141624 */     GIR_RootConstrainSelectedInstOperands,
     /* 141625 */     // GIR_Coverage, 4494,
     /* 141625 */     GIR_EraseRootFromParent_Done,
     /* 141626 */   // Label 2478: @141626
     /* 141626 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(141675), // Rule ID 4495 //
     /* 141631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 141649 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 141649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 141652 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141673 */     GIR_RootConstrainSelectedInstOperands,
     /* 141674 */     // GIR_Coverage, 4495,
     /* 141674 */     GIR_EraseRootFromParent_Done,
     /* 141675 */   // Label 2479: @141675
     /* 141675 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(141719), // Rule ID 4531 //
     /* 141680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 141698 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 141698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 141701 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141717 */     GIR_RootConstrainSelectedInstOperands,
     /* 141718 */     // GIR_Coverage, 4531,
     /* 141718 */     GIR_EraseRootFromParent_Done,
     /* 141719 */   // Label 2480: @141719
     /* 141719 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(141763), // Rule ID 4555 //
     /* 141724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141742 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141745 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141761 */     GIR_RootConstrainSelectedInstOperands,
     /* 141762 */     // GIR_Coverage, 4555,
     /* 141762 */     GIR_EraseRootFromParent_Done,
     /* 141763 */   // Label 2481: @141763
     /* 141763 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(141783), // Rule ID 6462 //
     /* 141768 */     // MIs[0] Rn
     /* 141768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141776 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 141781 */     GIR_RootConstrainSelectedInstOperands,
     /* 141782 */     // GIR_Coverage, 6462,
     /* 141782 */     GIR_Done,
     /* 141783 */   // Label 2482: @141783
     /* 141783 */   GIM_Reject,
     /* 141784 */ // Label 2477: @141784
     /* 141784 */ GIM_Reject,
     /* 141785 */ // Label 2283: @141785
     /* 141785 */ GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(142190),
     /* 141790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141793 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141797 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(141846), // Rule ID 4510 //
     /* 141802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141820 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141823 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141844 */     GIR_RootConstrainSelectedInstOperands,
     /* 141845 */     // GIR_Coverage, 4510,
     /* 141845 */     GIR_EraseRootFromParent_Done,
     /* 141846 */   // Label 2484: @141846
     /* 141846 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(141895), // Rule ID 4511 //
     /* 141851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141869 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141872 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141893 */     GIR_RootConstrainSelectedInstOperands,
     /* 141894 */     // GIR_Coverage, 4511,
     /* 141894 */     GIR_EraseRootFromParent_Done,
     /* 141895 */   // Label 2485: @141895
     /* 141895 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(141944), // Rule ID 4514 //
     /* 141900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141918 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141921 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141942 */     GIR_RootConstrainSelectedInstOperands,
     /* 141943 */     // GIR_Coverage, 4514,
     /* 141943 */     GIR_EraseRootFromParent_Done,
     /* 141944 */   // Label 2486: @141944
     /* 141944 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(141993), // Rule ID 4515 //
     /* 141949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141967 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141970 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141991 */     GIR_RootConstrainSelectedInstOperands,
     /* 141992 */     // GIR_Coverage, 4515,
     /* 141992 */     GIR_EraseRootFromParent_Done,
     /* 141993 */   // Label 2487: @141993
     /* 141993 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(142037), // Rule ID 4539 //
     /* 141998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142016 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142019 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142035 */     GIR_RootConstrainSelectedInstOperands,
     /* 142036 */     // GIR_Coverage, 4539,
     /* 142036 */     GIR_EraseRootFromParent_Done,
     /* 142037 */   // Label 2488: @142037
     /* 142037 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(142081), // Rule ID 4542 //
     /* 142042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142060 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142063 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142079 */     GIR_RootConstrainSelectedInstOperands,
     /* 142080 */     // GIR_Coverage, 4542,
     /* 142080 */     GIR_EraseRootFromParent_Done,
     /* 142081 */   // Label 2489: @142081
     /* 142081 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(142125), // Rule ID 4563 //
     /* 142086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142104 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142107 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142123 */     GIR_RootConstrainSelectedInstOperands,
     /* 142124 */     // GIR_Coverage, 4563,
     /* 142124 */     GIR_EraseRootFromParent_Done,
     /* 142125 */   // Label 2490: @142125
     /* 142125 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(142169), // Rule ID 4567 //
     /* 142130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142148 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142151 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142167 */     GIR_RootConstrainSelectedInstOperands,
     /* 142168 */     // GIR_Coverage, 4567,
     /* 142168 */     GIR_EraseRootFromParent_Done,
     /* 142169 */   // Label 2491: @142169
     /* 142169 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(142189), // Rule ID 6459 //
     /* 142174 */     // MIs[0] Rn
     /* 142174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142182 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 142187 */     GIR_RootConstrainSelectedInstOperands,
     /* 142188 */     // GIR_Coverage, 6459,
     /* 142188 */     GIR_Done,
     /* 142189 */   // Label 2492: @142189
     /* 142189 */   GIM_Reject,
     /* 142190 */ // Label 2483: @142190
     /* 142190 */ GIM_Reject,
     /* 142191 */ // Label 2284: @142191
     /* 142191 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(142410),
     /* 142196 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142199 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142203 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(142252), // Rule ID 4512 //
     /* 142208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 142226 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 142226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 142229 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142250 */     GIR_RootConstrainSelectedInstOperands,
     /* 142251 */     // GIR_Coverage, 4512,
     /* 142251 */     GIR_EraseRootFromParent_Done,
     /* 142252 */   // Label 2494: @142252
     /* 142252 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(142301), // Rule ID 4513 //
     /* 142257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 142275 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 142275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 142278 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142299 */     GIR_RootConstrainSelectedInstOperands,
     /* 142300 */     // GIR_Coverage, 4513,
     /* 142300 */     GIR_EraseRootFromParent_Done,
     /* 142301 */   // Label 2495: @142301
     /* 142301 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(142345), // Rule ID 4538 //
     /* 142306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142324 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142327 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142343 */     GIR_RootConstrainSelectedInstOperands,
     /* 142344 */     // GIR_Coverage, 4538,
     /* 142344 */     GIR_EraseRootFromParent_Done,
     /* 142345 */   // Label 2496: @142345
     /* 142345 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(142389), // Rule ID 4562 //
     /* 142350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142368 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142371 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142387 */     GIR_RootConstrainSelectedInstOperands,
     /* 142388 */     // GIR_Coverage, 4562,
     /* 142388 */     GIR_EraseRootFromParent_Done,
     /* 142389 */   // Label 2497: @142389
     /* 142389 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(142409), // Rule ID 6458 //
     /* 142394 */     // MIs[0] Rn
     /* 142394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142402 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 142407 */     GIR_RootConstrainSelectedInstOperands,
     /* 142408 */     // GIR_Coverage, 6458,
     /* 142408 */     GIR_Done,
     /* 142409 */   // Label 2498: @142409
     /* 142409 */   GIM_Reject,
     /* 142410 */ // Label 2493: @142410
     /* 142410 */ GIM_Reject,
     /* 142411 */ // Label 2285: @142411
     /* 142411 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(142470), // Rule ID 10942 //
     /* 142416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142422 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142426 */   // MIs[0] base
     /* 142426 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142434 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142446 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 142454 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142459 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142468 */   GIR_RootConstrainSelectedInstOperands,
     /* 142469 */   // GIR_Coverage, 10942,
     /* 142469 */   GIR_EraseRootFromParent_Done,
     /* 142470 */ // Label 2499: @142470
     /* 142470 */ GIM_Reject,
     /* 142471 */ // Label 2286: @142471
     /* 142471 */ GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(142530), // Rule ID 10948 //
     /* 142476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142482 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142486 */   // MIs[0] base
     /* 142486 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142494 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142506 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 142514 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142519 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142528 */   GIR_RootConstrainSelectedInstOperands,
     /* 142529 */   // GIR_Coverage, 10948,
     /* 142529 */   GIR_EraseRootFromParent_Done,
     /* 142530 */ // Label 2500: @142530
     /* 142530 */ GIM_Reject,
     /* 142531 */ // Label 2287: @142531
     /* 142531 */ GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(142700),
     /* 142536 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142539 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142547 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(142595), // Rule ID 10933 //
     /* 142552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142559 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142571 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 142579 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142584 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142593 */     GIR_RootConstrainSelectedInstOperands,
     /* 142594 */     // GIR_Coverage, 10933,
     /* 142594 */     GIR_EraseRootFromParent_Done,
     /* 142595 */   // Label 2502: @142595
     /* 142595 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(142643), // Rule ID 10951 //
     /* 142600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142607 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142619 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 142627 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142632 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142641 */     GIR_RootConstrainSelectedInstOperands,
     /* 142642 */     // GIR_Coverage, 10951,
     /* 142642 */     GIR_EraseRootFromParent_Done,
     /* 142643 */   // Label 2503: @142643
     /* 142643 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(142671), // Rule ID 11063 //
     /* 142648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142655 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142658 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142660 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142669 */     GIR_RootConstrainSelectedInstOperands,
     /* 142670 */     // GIR_Coverage, 11063,
     /* 142670 */     GIR_EraseRootFromParent_Done,
     /* 142671 */   // Label 2504: @142671
     /* 142671 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(142699), // Rule ID 11075 //
     /* 142676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142683 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142686 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142688 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142697 */     GIR_RootConstrainSelectedInstOperands,
     /* 142698 */     // GIR_Coverage, 11075,
     /* 142698 */     GIR_EraseRootFromParent_Done,
     /* 142699 */   // Label 2505: @142699
     /* 142699 */   GIM_Reject,
     /* 142700 */ // Label 2501: @142700
     /* 142700 */ GIM_Reject,
     /* 142701 */ // Label 2288: @142701
     /* 142701 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(142760), // Rule ID 10939 //
     /* 142706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142709 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142712 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142716 */   // MIs[0] base
     /* 142716 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142724 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142724 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142727 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 142731 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142736 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 142744 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142749 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142754 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142758 */   GIR_RootConstrainSelectedInstOperands,
     /* 142759 */   // GIR_Coverage, 10939,
     /* 142759 */   GIR_EraseRootFromParent_Done,
     /* 142760 */ // Label 2506: @142760
     /* 142760 */ GIM_Reject,
     /* 142761 */ // Label 2289: @142761
     /* 142761 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(142930),
     /* 142766 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142769 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142773 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142777 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(142825), // Rule ID 10927 //
     /* 142782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142789 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 142796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 142809 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142814 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142823 */     GIR_RootConstrainSelectedInstOperands,
     /* 142824 */     // GIR_Coverage, 10927,
     /* 142824 */     GIR_EraseRootFromParent_Done,
     /* 142825 */   // Label 2508: @142825
     /* 142825 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(142873), // Rule ID 10945 //
     /* 142830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142837 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 142844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142849 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 142857 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142862 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142871 */     GIR_RootConstrainSelectedInstOperands,
     /* 142872 */     // GIR_Coverage, 10945,
     /* 142872 */     GIR_EraseRootFromParent_Done,
     /* 142873 */   // Label 2509: @142873
     /* 142873 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(142901), // Rule ID 11059 //
     /* 142878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142885 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142888 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142890 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142899 */     GIR_RootConstrainSelectedInstOperands,
     /* 142900 */     // GIR_Coverage, 11059,
     /* 142900 */     GIR_EraseRootFromParent_Done,
     /* 142901 */   // Label 2510: @142901
     /* 142901 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(142929), // Rule ID 11071 //
     /* 142906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142913 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142916 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142918 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142927 */     GIR_RootConstrainSelectedInstOperands,
     /* 142928 */     // GIR_Coverage, 11071,
     /* 142928 */     GIR_EraseRootFromParent_Done,
     /* 142929 */   // Label 2511: @142929
     /* 142929 */   GIM_Reject,
     /* 142930 */ // Label 2507: @142930
     /* 142930 */ GIM_Reject,
     /* 142931 */ // Label 2290: @142931
     /* 142931 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(143100),
     /* 142936 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142939 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142943 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142947 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(142995), // Rule ID 10918 //
     /* 142952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142959 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 142966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142971 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 142979 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142984 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142993 */     GIR_RootConstrainSelectedInstOperands,
     /* 142994 */     // GIR_Coverage, 10918,
     /* 142994 */     GIR_EraseRootFromParent_Done,
     /* 142995 */   // Label 2513: @142995
     /* 142995 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(143043), // Rule ID 10936 //
     /* 143000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143007 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 143010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 143014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143019 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 143022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 143027 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143032 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143041 */     GIR_RootConstrainSelectedInstOperands,
     /* 143042 */     // GIR_Coverage, 10936,
     /* 143042 */     GIR_EraseRootFromParent_Done,
     /* 143043 */   // Label 2514: @143043
     /* 143043 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(143071), // Rule ID 11055 //
     /* 143048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 143051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143055 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 143058 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143060 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143069 */     GIR_RootConstrainSelectedInstOperands,
     /* 143070 */     // GIR_Coverage, 11055,
     /* 143070 */     GIR_EraseRootFromParent_Done,
     /* 143071 */   // Label 2515: @143071
     /* 143071 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(143099), // Rule ID 11067 //
     /* 143076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 143079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143083 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 143086 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143088 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143097 */     GIR_RootConstrainSelectedInstOperands,
     /* 143098 */     // GIR_Coverage, 11067,
     /* 143098 */     GIR_EraseRootFromParent_Done,
     /* 143099 */   // Label 2516: @143099
     /* 143099 */   GIM_Reject,
     /* 143100 */ // Label 2512: @143100
     /* 143100 */ GIM_Reject,
     /* 143101 */ // Label 2291: @143101
     /* 143101 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(143144), // Rule ID 2430 //
     /* 143106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143109 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143112 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 143120 */   // MIs[0] base
     /* 143120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143128 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 143131 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 143133 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143142 */   GIR_RootConstrainSelectedInstOperands,
     /* 143143 */   // GIR_Coverage, 2430,
     /* 143143 */   GIR_EraseRootFromParent_Done,
     /* 143144 */ // Label 2517: @143144
     /* 143144 */ GIM_Reject,
     /* 143145 */ // Label 2292: @143145
     /* 143145 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(143238),
     /* 143150 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143153 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143161 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(143209), // Rule ID 10904 //
     /* 143166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143173 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 143176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 143180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143185 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 143188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 143193 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143198 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143207 */     GIR_RootConstrainSelectedInstOperands,
     /* 143208 */     // GIR_Coverage, 10904,
     /* 143208 */     GIR_EraseRootFromParent_Done,
     /* 143209 */   // Label 2519: @143209
     /* 143209 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(143237), // Rule ID 11051 //
     /* 143214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 143217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143221 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 143224 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143226 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143235 */     GIR_RootConstrainSelectedInstOperands,
     /* 143236 */     // GIR_Coverage, 11051,
     /* 143236 */     GIR_EraseRootFromParent_Done,
     /* 143237 */   // Label 2520: @143237
     /* 143237 */   GIM_Reject,
     /* 143238 */ // Label 2518: @143238
     /* 143238 */ GIM_Reject,
     /* 143239 */ // Label 2293: @143239
     /* 143239 */ GIM_Reject,
     /* 143240 */ // Label 20: @143240
     /* 143240 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2523*/ GIMT_Encode4(144590),
     /* 143251 */ /*GILLT_s32*//*Label 2521*/ GIMT_Encode4(143259),
     /* 143255 */ /*GILLT_s64*//*Label 2522*/ GIMT_Encode4(144277),
     /* 143259 */ // Label 2521: @143259
     /* 143259 */ GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(144276),
     /* 143264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143267 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 143270 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(143325), // Rule ID 7364 //
     /* 143275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143278 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 143288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143292 */     // MIs[0] Rn
     /* 143292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143308 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 143311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143323 */     GIR_RootConstrainSelectedInstOperands,
     /* 143324 */     // GIR_Coverage, 7364,
     /* 143324 */     GIR_EraseRootFromParent_Done,
     /* 143325 */   // Label 2525: @143325
     /* 143325 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(143380), // Rule ID 7365 //
     /* 143330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143333 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143340 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 143343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143347 */     // MIs[0] Rn
     /* 143347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143363 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 143366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143378 */     GIR_RootConstrainSelectedInstOperands,
     /* 143379 */     // GIR_Coverage, 7365,
     /* 143379 */     GIR_EraseRootFromParent_Done,
     /* 143380 */   // Label 2526: @143380
     /* 143380 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(143435), // Rule ID 7366 //
     /* 143385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143388 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143395 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 143398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143402 */     // MIs[0] Rn
     /* 143402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143418 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 143421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143427 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143433 */     GIR_RootConstrainSelectedInstOperands,
     /* 143434 */     // GIR_Coverage, 7366,
     /* 143434 */     GIR_EraseRootFromParent_Done,
     /* 143435 */   // Label 2527: @143435
     /* 143435 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(143490), // Rule ID 7367 //
     /* 143440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143443 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143450 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 143453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143457 */     // MIs[0] Rn
     /* 143457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143473 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 143476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143488 */     GIR_RootConstrainSelectedInstOperands,
     /* 143489 */     // GIR_Coverage, 7367,
     /* 143489 */     GIR_EraseRootFromParent_Done,
     /* 143490 */   // Label 2528: @143490
     /* 143490 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(143545), // Rule ID 7368 //
     /* 143495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 143508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143512 */     // MIs[0] Rn
     /* 143512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143528 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 143531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143543 */     GIR_RootConstrainSelectedInstOperands,
     /* 143544 */     // GIR_Coverage, 7368,
     /* 143544 */     GIR_EraseRootFromParent_Done,
     /* 143545 */   // Label 2529: @143545
     /* 143545 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(143600), // Rule ID 7369 //
     /* 143550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143553 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143560 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 143563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143567 */     // MIs[0] Rn
     /* 143567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143583 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 143586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143598 */     GIR_RootConstrainSelectedInstOperands,
     /* 143599 */     // GIR_Coverage, 7369,
     /* 143599 */     GIR_EraseRootFromParent_Done,
     /* 143600 */   // Label 2530: @143600
     /* 143600 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(143655), // Rule ID 7370 //
     /* 143605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 143618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143622 */     // MIs[0] Rn
     /* 143622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143638 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 143641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143653 */     GIR_RootConstrainSelectedInstOperands,
     /* 143654 */     // GIR_Coverage, 7370,
     /* 143654 */     GIR_EraseRootFromParent_Done,
     /* 143655 */   // Label 2531: @143655
     /* 143655 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(143710), // Rule ID 7371 //
     /* 143660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 143673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143677 */     // MIs[0] Rn
     /* 143677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143693 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 143696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143708 */     GIR_RootConstrainSelectedInstOperands,
     /* 143709 */     // GIR_Coverage, 7371,
     /* 143709 */     GIR_EraseRootFromParent_Done,
     /* 143710 */   // Label 2532: @143710
     /* 143710 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(143765), // Rule ID 7372 //
     /* 143715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143718 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143725 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 143728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143732 */     // MIs[0] Rn
     /* 143732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143748 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 143751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143763 */     GIR_RootConstrainSelectedInstOperands,
     /* 143764 */     // GIR_Coverage, 7372,
     /* 143764 */     GIR_EraseRootFromParent_Done,
     /* 143765 */   // Label 2533: @143765
     /* 143765 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(143820), // Rule ID 7373 //
     /* 143770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143773 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143780 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 143783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143787 */     // MIs[0] Rn
     /* 143787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143803 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 143806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143818 */     GIR_RootConstrainSelectedInstOperands,
     /* 143819 */     // GIR_Coverage, 7373,
     /* 143819 */     GIR_EraseRootFromParent_Done,
     /* 143820 */   // Label 2534: @143820
     /* 143820 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(143875), // Rule ID 7374 //
     /* 143825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 143838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143842 */     // MIs[0] Rn
     /* 143842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143858 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 143861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143873 */     GIR_RootConstrainSelectedInstOperands,
     /* 143874 */     // GIR_Coverage, 7374,
     /* 143874 */     GIR_EraseRootFromParent_Done,
     /* 143875 */   // Label 2535: @143875
     /* 143875 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(143930), // Rule ID 7375 //
     /* 143880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143883 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143890 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 143893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143897 */     // MIs[0] Rn
     /* 143897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143913 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 143916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143928 */     GIR_RootConstrainSelectedInstOperands,
     /* 143929 */     // GIR_Coverage, 7375,
     /* 143929 */     GIR_EraseRootFromParent_Done,
     /* 143930 */   // Label 2536: @143930
     /* 143930 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(143985), // Rule ID 7376 //
     /* 143935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143938 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143945 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 143948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143952 */     // MIs[0] Rn
     /* 143952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143968 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 143971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143983 */     GIR_RootConstrainSelectedInstOperands,
     /* 143984 */     // GIR_Coverage, 7376,
     /* 143984 */     GIR_EraseRootFromParent_Done,
     /* 143985 */   // Label 2537: @143985
     /* 143985 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(144040), // Rule ID 7377 //
     /* 143990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143993 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144000 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144007 */     // MIs[0] Rn
     /* 144007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144023 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 144026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144038 */     GIR_RootConstrainSelectedInstOperands,
     /* 144039 */     // GIR_Coverage, 7377,
     /* 144039 */     GIR_EraseRootFromParent_Done,
     /* 144040 */   // Label 2538: @144040
     /* 144040 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(144095), // Rule ID 7378 //
     /* 144045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144062 */     // MIs[0] Rn
     /* 144062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144078 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 144081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144093 */     GIR_RootConstrainSelectedInstOperands,
     /* 144094 */     // GIR_Coverage, 7378,
     /* 144094 */     GIR_EraseRootFromParent_Done,
     /* 144095 */   // Label 2539: @144095
     /* 144095 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(144155), // Rule ID 13203 //
     /* 144100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144103 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144114 */     // MIs[0] addr
     /* 144114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144130 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 144130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 144136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144138 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144143 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144145 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144147 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144153 */     GIR_RootConstrainSelectedInstOperands,
     /* 144154 */     // GIR_Coverage, 13203,
     /* 144154 */     GIR_EraseRootFromParent_Done,
     /* 144155 */   // Label 2540: @144155
     /* 144155 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(144215), // Rule ID 13204 //
     /* 144160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144163 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144174 */     // MIs[0] addr
     /* 144174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144190 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 144190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 144196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144198 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144203 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144205 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144207 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144213 */     GIR_RootConstrainSelectedInstOperands,
     /* 144214 */     // GIR_Coverage, 13204,
     /* 144214 */     GIR_EraseRootFromParent_Done,
     /* 144215 */   // Label 2541: @144215
     /* 144215 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(144275), // Rule ID 13205 //
     /* 144220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144234 */     // MIs[0] addr
     /* 144234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144250 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 144250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 144256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144258 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144263 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144265 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144267 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144273 */     GIR_RootConstrainSelectedInstOperands,
     /* 144274 */     // GIR_Coverage, 13205,
     /* 144274 */     GIR_EraseRootFromParent_Done,
     /* 144275 */   // Label 2542: @144275
     /* 144275 */   GIM_Reject,
     /* 144276 */ // Label 2524: @144276
     /* 144276 */ GIM_Reject,
     /* 144277 */ // Label 2522: @144277
     /* 144277 */ GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(144589),
     /* 144282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 144288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 144295 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(144343), // Rule ID 2589 //
     /* 144300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144303 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144310 */     // MIs[0] Rn
     /* 144310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144326 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 144329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144341 */     GIR_RootConstrainSelectedInstOperands,
     /* 144342 */     // GIR_Coverage, 2589,
     /* 144342 */     GIR_EraseRootFromParent_Done,
     /* 144343 */   // Label 2544: @144343
     /* 144343 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(144391), // Rule ID 2590 //
     /* 144348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144358 */     // MIs[0] Rn
     /* 144358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144374 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 144377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144389 */     GIR_RootConstrainSelectedInstOperands,
     /* 144390 */     // GIR_Coverage, 2590,
     /* 144390 */     GIR_EraseRootFromParent_Done,
     /* 144391 */   // Label 2545: @144391
     /* 144391 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(144439), // Rule ID 2591 //
     /* 144396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144406 */     // MIs[0] Rn
     /* 144406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144422 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 144425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144437 */     GIR_RootConstrainSelectedInstOperands,
     /* 144438 */     // GIR_Coverage, 2591,
     /* 144438 */     GIR_EraseRootFromParent_Done,
     /* 144439 */   // Label 2546: @144439
     /* 144439 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(144487), // Rule ID 2592 //
     /* 144444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144454 */     // MIs[0] Rn
     /* 144454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144470 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 144473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144485 */     GIR_RootConstrainSelectedInstOperands,
     /* 144486 */     // GIR_Coverage, 2592,
     /* 144486 */     GIR_EraseRootFromParent_Done,
     /* 144487 */   // Label 2547: @144487
     /* 144487 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(144535), // Rule ID 2593 //
     /* 144492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144495 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144502 */     // MIs[0] Rn
     /* 144502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144518 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 144521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144533 */     GIR_RootConstrainSelectedInstOperands,
     /* 144534 */     // GIR_Coverage, 2593,
     /* 144534 */     GIR_EraseRootFromParent_Done,
     /* 144535 */   // Label 2548: @144535
     /* 144535 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(144588), // Rule ID 13206 //
     /* 144540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144547 */     // MIs[0] addr
     /* 144547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144563 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 144563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 144569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144571 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144576 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144578 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144580 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144586 */     GIR_RootConstrainSelectedInstOperands,
     /* 144587 */     // GIR_Coverage, 13206,
     /* 144587 */     GIR_EraseRootFromParent_Done,
     /* 144588 */   // Label 2549: @144588
     /* 144588 */   GIM_Reject,
     /* 144589 */ // Label 2543: @144589
     /* 144589 */ GIM_Reject,
     /* 144590 */ // Label 2523: @144590
     /* 144590 */ GIM_Reject,
     /* 144591 */ // Label 21: @144591
     /* 144591 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2552*/ GIMT_Encode4(145582),
     /* 144602 */ /*GILLT_s32*//*Label 2550*/ GIMT_Encode4(144610),
     /* 144606 */ /*GILLT_s64*//*Label 2551*/ GIMT_Encode4(145355),
     /* 144610 */ // Label 2550: @144610
     /* 144610 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(145354),
     /* 144615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144618 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(144667), // Rule ID 7349 //
     /* 144623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144626 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144633 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144640 */     // MIs[0] Rn
     /* 144640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144652 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 144655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144665 */     GIR_RootConstrainSelectedInstOperands,
     /* 144666 */     // GIR_Coverage, 7349,
     /* 144666 */     GIR_EraseRootFromParent_Done,
     /* 144667 */   // Label 2554: @144667
     /* 144667 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(144716), // Rule ID 7350 //
     /* 144672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144675 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144682 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144689 */     // MIs[0] Rn
     /* 144689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144701 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 144704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144714 */     GIR_RootConstrainSelectedInstOperands,
     /* 144715 */     // GIR_Coverage, 7350,
     /* 144715 */     GIR_EraseRootFromParent_Done,
     /* 144716 */   // Label 2555: @144716
     /* 144716 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(144765), // Rule ID 7351 //
     /* 144721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144724 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144731 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144738 */     // MIs[0] Rn
     /* 144738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144750 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 144753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144763 */     GIR_RootConstrainSelectedInstOperands,
     /* 144764 */     // GIR_Coverage, 7351,
     /* 144764 */     GIR_EraseRootFromParent_Done,
     /* 144765 */   // Label 2556: @144765
     /* 144765 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(144814), // Rule ID 7352 //
     /* 144770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144773 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144780 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144787 */     // MIs[0] Rn
     /* 144787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144799 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 144802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144806 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144812 */     GIR_RootConstrainSelectedInstOperands,
     /* 144813 */     // GIR_Coverage, 7352,
     /* 144813 */     GIR_EraseRootFromParent_Done,
     /* 144814 */   // Label 2557: @144814
     /* 144814 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(144863), // Rule ID 7353 //
     /* 144819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144822 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144829 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144836 */     // MIs[0] Rn
     /* 144836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144848 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 144851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144861 */     GIR_RootConstrainSelectedInstOperands,
     /* 144862 */     // GIR_Coverage, 7353,
     /* 144862 */     GIR_EraseRootFromParent_Done,
     /* 144863 */   // Label 2558: @144863
     /* 144863 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(144912), // Rule ID 7354 //
     /* 144868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144871 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144885 */     // MIs[0] Rn
     /* 144885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144897 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 144900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144910 */     GIR_RootConstrainSelectedInstOperands,
     /* 144911 */     // GIR_Coverage, 7354,
     /* 144911 */     GIR_EraseRootFromParent_Done,
     /* 144912 */   // Label 2559: @144912
     /* 144912 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(144961), // Rule ID 7355 //
     /* 144917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144934 */     // MIs[0] Rn
     /* 144934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144946 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 144949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144953 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144959 */     GIR_RootConstrainSelectedInstOperands,
     /* 144960 */     // GIR_Coverage, 7355,
     /* 144960 */     GIR_EraseRootFromParent_Done,
     /* 144961 */   // Label 2560: @144961
     /* 144961 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(145010), // Rule ID 7356 //
     /* 144966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144969 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144983 */     // MIs[0] Rn
     /* 144983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144995 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 144998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145008 */     GIR_RootConstrainSelectedInstOperands,
     /* 145009 */     // GIR_Coverage, 7356,
     /* 145009 */     GIR_EraseRootFromParent_Done,
     /* 145010 */   // Label 2561: @145010
     /* 145010 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(145059), // Rule ID 7357 //
     /* 145015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145032 */     // MIs[0] Rn
     /* 145032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145044 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 145047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145057 */     GIR_RootConstrainSelectedInstOperands,
     /* 145058 */     // GIR_Coverage, 7357,
     /* 145058 */     GIR_EraseRootFromParent_Done,
     /* 145059 */   // Label 2562: @145059
     /* 145059 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(145108), // Rule ID 7358 //
     /* 145064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145081 */     // MIs[0] Rn
     /* 145081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145093 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 145096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145106 */     GIR_RootConstrainSelectedInstOperands,
     /* 145107 */     // GIR_Coverage, 7358,
     /* 145107 */     GIR_EraseRootFromParent_Done,
     /* 145108 */   // Label 2563: @145108
     /* 145108 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(145157), // Rule ID 7359 //
     /* 145113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145130 */     // MIs[0] Rn
     /* 145130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145142 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 145145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145155 */     GIR_RootConstrainSelectedInstOperands,
     /* 145156 */     // GIR_Coverage, 7359,
     /* 145156 */     GIR_EraseRootFromParent_Done,
     /* 145157 */   // Label 2564: @145157
     /* 145157 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(145206), // Rule ID 7360 //
     /* 145162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145165 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145179 */     // MIs[0] Rn
     /* 145179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145191 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 145194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145204 */     GIR_RootConstrainSelectedInstOperands,
     /* 145205 */     // GIR_Coverage, 7360,
     /* 145205 */     GIR_EraseRootFromParent_Done,
     /* 145206 */   // Label 2565: @145206
     /* 145206 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(145255), // Rule ID 7361 //
     /* 145211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145214 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145221 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145228 */     // MIs[0] Rn
     /* 145228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145240 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 145243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145253 */     GIR_RootConstrainSelectedInstOperands,
     /* 145254 */     // GIR_Coverage, 7361,
     /* 145254 */     GIR_EraseRootFromParent_Done,
     /* 145255 */   // Label 2566: @145255
     /* 145255 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(145304), // Rule ID 7362 //
     /* 145260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145263 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145270 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145277 */     // MIs[0] Rn
     /* 145277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145289 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 145292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145302 */     GIR_RootConstrainSelectedInstOperands,
     /* 145303 */     // GIR_Coverage, 7362,
     /* 145303 */     GIR_EraseRootFromParent_Done,
     /* 145304 */   // Label 2567: @145304
     /* 145304 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(145353), // Rule ID 7363 //
     /* 145309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145312 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145326 */     // MIs[0] Rn
     /* 145326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145338 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 145341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145351 */     GIR_RootConstrainSelectedInstOperands,
     /* 145352 */     // GIR_Coverage, 7363,
     /* 145352 */     GIR_EraseRootFromParent_Done,
     /* 145353 */   // Label 2568: @145353
     /* 145353 */   GIM_Reject,
     /* 145354 */ // Label 2553: @145354
     /* 145354 */ GIM_Reject,
     /* 145355 */ // Label 2551: @145355
     /* 145355 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(145581),
     /* 145360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145363 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 145370 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(145412), // Rule ID 7344 //
     /* 145375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145378 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145385 */     // MIs[0] Rn
     /* 145385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145397 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 145400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145410 */     GIR_RootConstrainSelectedInstOperands,
     /* 145411 */     // GIR_Coverage, 7344,
     /* 145411 */     GIR_EraseRootFromParent_Done,
     /* 145412 */   // Label 2570: @145412
     /* 145412 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(145454), // Rule ID 7345 //
     /* 145417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145420 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145427 */     // MIs[0] Rn
     /* 145427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145439 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 145442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145452 */     GIR_RootConstrainSelectedInstOperands,
     /* 145453 */     // GIR_Coverage, 7345,
     /* 145453 */     GIR_EraseRootFromParent_Done,
     /* 145454 */   // Label 2571: @145454
     /* 145454 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(145496), // Rule ID 7346 //
     /* 145459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145462 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145469 */     // MIs[0] Rn
     /* 145469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145481 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 145484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145494 */     GIR_RootConstrainSelectedInstOperands,
     /* 145495 */     // GIR_Coverage, 7346,
     /* 145495 */     GIR_EraseRootFromParent_Done,
     /* 145496 */   // Label 2572: @145496
     /* 145496 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(145538), // Rule ID 7347 //
     /* 145501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145504 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145511 */     // MIs[0] Rn
     /* 145511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145523 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 145526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145536 */     GIR_RootConstrainSelectedInstOperands,
     /* 145537 */     // GIR_Coverage, 7347,
     /* 145537 */     GIR_EraseRootFromParent_Done,
     /* 145538 */   // Label 2573: @145538
     /* 145538 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(145580), // Rule ID 7348 //
     /* 145543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145553 */     // MIs[0] Rn
     /* 145553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145565 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 145568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145578 */     GIR_RootConstrainSelectedInstOperands,
     /* 145579 */     // GIR_Coverage, 7348,
     /* 145579 */     GIR_EraseRootFromParent_Done,
     /* 145580 */   // Label 2574: @145580
     /* 145580 */   GIM_Reject,
     /* 145581 */ // Label 2569: @145581
     /* 145581 */ GIM_Reject,
     /* 145582 */ // Label 2552: @145582
     /* 145582 */ GIM_Reject,
     /* 145583 */ // Label 22: @145583
     /* 145583 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2577*/ GIMT_Encode4(146574),
     /* 145594 */ /*GILLT_s32*//*Label 2575*/ GIMT_Encode4(145602),
     /* 145598 */ /*GILLT_s64*//*Label 2576*/ GIMT_Encode4(146347),
     /* 145602 */ // Label 2575: @145602
     /* 145602 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(146346),
     /* 145607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145610 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(145659), // Rule ID 7189 //
     /* 145615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145618 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145632 */     // MIs[0] Rn
     /* 145632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145644 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 145647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145657 */     GIR_RootConstrainSelectedInstOperands,
     /* 145658 */     // GIR_Coverage, 7189,
     /* 145658 */     GIR_EraseRootFromParent_Done,
     /* 145659 */   // Label 2579: @145659
     /* 145659 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(145708), // Rule ID 7190 //
     /* 145664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145667 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145674 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145681 */     // MIs[0] Rn
     /* 145681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145693 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 145696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145706 */     GIR_RootConstrainSelectedInstOperands,
     /* 145707 */     // GIR_Coverage, 7190,
     /* 145707 */     GIR_EraseRootFromParent_Done,
     /* 145708 */   // Label 2580: @145708
     /* 145708 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(145757), // Rule ID 7191 //
     /* 145713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145716 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145723 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145730 */     // MIs[0] Rn
     /* 145730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145742 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 145745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145755 */     GIR_RootConstrainSelectedInstOperands,
     /* 145756 */     // GIR_Coverage, 7191,
     /* 145756 */     GIR_EraseRootFromParent_Done,
     /* 145757 */   // Label 2581: @145757
     /* 145757 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(145806), // Rule ID 7192 //
     /* 145762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145765 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145772 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145779 */     // MIs[0] Rn
     /* 145779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145791 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 145794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145804 */     GIR_RootConstrainSelectedInstOperands,
     /* 145805 */     // GIR_Coverage, 7192,
     /* 145805 */     GIR_EraseRootFromParent_Done,
     /* 145806 */   // Label 2582: @145806
     /* 145806 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(145855), // Rule ID 7193 //
     /* 145811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145814 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145821 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145828 */     // MIs[0] Rn
     /* 145828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145840 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 145843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145853 */     GIR_RootConstrainSelectedInstOperands,
     /* 145854 */     // GIR_Coverage, 7193,
     /* 145854 */     GIR_EraseRootFromParent_Done,
     /* 145855 */   // Label 2583: @145855
     /* 145855 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(145904), // Rule ID 7194 //
     /* 145860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145863 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145870 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145877 */     // MIs[0] Rn
     /* 145877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145889 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 145892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145902 */     GIR_RootConstrainSelectedInstOperands,
     /* 145903 */     // GIR_Coverage, 7194,
     /* 145903 */     GIR_EraseRootFromParent_Done,
     /* 145904 */   // Label 2584: @145904
     /* 145904 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(145953), // Rule ID 7195 //
     /* 145909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145912 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145926 */     // MIs[0] Rn
     /* 145926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145938 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 145941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145951 */     GIR_RootConstrainSelectedInstOperands,
     /* 145952 */     // GIR_Coverage, 7195,
     /* 145952 */     GIR_EraseRootFromParent_Done,
     /* 145953 */   // Label 2585: @145953
     /* 145953 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(146002), // Rule ID 7196 //
     /* 145958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145975 */     // MIs[0] Rn
     /* 145975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145987 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 145990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146000 */     GIR_RootConstrainSelectedInstOperands,
     /* 146001 */     // GIR_Coverage, 7196,
     /* 146001 */     GIR_EraseRootFromParent_Done,
     /* 146002 */   // Label 2586: @146002
     /* 146002 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(146051), // Rule ID 7197 //
     /* 146007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146024 */     // MIs[0] Rn
     /* 146024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146036 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 146039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146049 */     GIR_RootConstrainSelectedInstOperands,
     /* 146050 */     // GIR_Coverage, 7197,
     /* 146050 */     GIR_EraseRootFromParent_Done,
     /* 146051 */   // Label 2587: @146051
     /* 146051 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(146100), // Rule ID 7198 //
     /* 146056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146073 */     // MIs[0] Rn
     /* 146073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146085 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 146088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146098 */     GIR_RootConstrainSelectedInstOperands,
     /* 146099 */     // GIR_Coverage, 7198,
     /* 146099 */     GIR_EraseRootFromParent_Done,
     /* 146100 */   // Label 2588: @146100
     /* 146100 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(146149), // Rule ID 7199 //
     /* 146105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146122 */     // MIs[0] Rn
     /* 146122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146134 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 146137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146147 */     GIR_RootConstrainSelectedInstOperands,
     /* 146148 */     // GIR_Coverage, 7199,
     /* 146148 */     GIR_EraseRootFromParent_Done,
     /* 146149 */   // Label 2589: @146149
     /* 146149 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(146198), // Rule ID 7200 //
     /* 146154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146157 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146171 */     // MIs[0] Rn
     /* 146171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146183 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 146186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146196 */     GIR_RootConstrainSelectedInstOperands,
     /* 146197 */     // GIR_Coverage, 7200,
     /* 146197 */     GIR_EraseRootFromParent_Done,
     /* 146198 */   // Label 2590: @146198
     /* 146198 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(146247), // Rule ID 7201 //
     /* 146203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146206 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146213 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146220 */     // MIs[0] Rn
     /* 146220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146232 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 146235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146245 */     GIR_RootConstrainSelectedInstOperands,
     /* 146246 */     // GIR_Coverage, 7201,
     /* 146246 */     GIR_EraseRootFromParent_Done,
     /* 146247 */   // Label 2591: @146247
     /* 146247 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(146296), // Rule ID 7202 //
     /* 146252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146255 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146269 */     // MIs[0] Rn
     /* 146269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146281 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 146284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146294 */     GIR_RootConstrainSelectedInstOperands,
     /* 146295 */     // GIR_Coverage, 7202,
     /* 146295 */     GIR_EraseRootFromParent_Done,
     /* 146296 */   // Label 2592: @146296
     /* 146296 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(146345), // Rule ID 7203 //
     /* 146301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146304 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146318 */     // MIs[0] Rn
     /* 146318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146330 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 146333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146343 */     GIR_RootConstrainSelectedInstOperands,
     /* 146344 */     // GIR_Coverage, 7203,
     /* 146344 */     GIR_EraseRootFromParent_Done,
     /* 146345 */   // Label 2593: @146345
     /* 146345 */   GIM_Reject,
     /* 146346 */ // Label 2578: @146346
     /* 146346 */ GIM_Reject,
     /* 146347 */ // Label 2576: @146347
     /* 146347 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(146573),
     /* 146352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146355 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 146362 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(146404), // Rule ID 2579 //
     /* 146367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146370 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146377 */     // MIs[0] Rn
     /* 146377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146389 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 146392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146402 */     GIR_RootConstrainSelectedInstOperands,
     /* 146403 */     // GIR_Coverage, 2579,
     /* 146403 */     GIR_EraseRootFromParent_Done,
     /* 146404 */   // Label 2595: @146404
     /* 146404 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(146446), // Rule ID 2580 //
     /* 146409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146412 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146419 */     // MIs[0] Rn
     /* 146419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146431 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 146434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146444 */     GIR_RootConstrainSelectedInstOperands,
     /* 146445 */     // GIR_Coverage, 2580,
     /* 146445 */     GIR_EraseRootFromParent_Done,
     /* 146446 */   // Label 2596: @146446
     /* 146446 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(146488), // Rule ID 2581 //
     /* 146451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146461 */     // MIs[0] Rn
     /* 146461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146473 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 146476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146486 */     GIR_RootConstrainSelectedInstOperands,
     /* 146487 */     // GIR_Coverage, 2581,
     /* 146487 */     GIR_EraseRootFromParent_Done,
     /* 146488 */   // Label 2597: @146488
     /* 146488 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(146530), // Rule ID 2582 //
     /* 146493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146496 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146503 */     // MIs[0] Rn
     /* 146503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146515 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 146518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146528 */     GIR_RootConstrainSelectedInstOperands,
     /* 146529 */     // GIR_Coverage, 2582,
     /* 146529 */     GIR_EraseRootFromParent_Done,
     /* 146530 */   // Label 2598: @146530
     /* 146530 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(146572), // Rule ID 2583 //
     /* 146535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146545 */     // MIs[0] Rn
     /* 146545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146557 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 146560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146570 */     GIR_RootConstrainSelectedInstOperands,
     /* 146571 */     // GIR_Coverage, 2583,
     /* 146571 */     GIR_EraseRootFromParent_Done,
     /* 146572 */   // Label 2599: @146572
     /* 146572 */   GIM_Reject,
     /* 146573 */ // Label 2594: @146573
     /* 146573 */ GIM_Reject,
     /* 146574 */ // Label 2577: @146574
     /* 146574 */ GIM_Reject,
     /* 146575 */ // Label 23: @146575
     /* 146575 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2602*/ GIMT_Encode4(148066),
     /* 146586 */ /*GILLT_s32*//*Label 2600*/ GIMT_Encode4(146594),
     /* 146590 */ /*GILLT_s64*//*Label 2601*/ GIMT_Encode4(147714),
     /* 146594 */ // Label 2600: @146594
     /* 146594 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(147713),
     /* 146599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146602 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(146676), // Rule ID 7384 //
     /* 146607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146610 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146624 */     // MIs[0] Rn
     /* 146624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146636 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146648 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 146663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146674 */     GIR_RootConstrainSelectedInstOperands,
     /* 146675 */     // GIR_Coverage, 7384,
     /* 146675 */     GIR_EraseRootFromParent_Done,
     /* 146676 */   // Label 2604: @146676
     /* 146676 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(146750), // Rule ID 7385 //
     /* 146681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146684 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146691 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146698 */     // MIs[0] Rn
     /* 146698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146710 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146722 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 146737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146748 */     GIR_RootConstrainSelectedInstOperands,
     /* 146749 */     // GIR_Coverage, 7385,
     /* 146749 */     GIR_EraseRootFromParent_Done,
     /* 146750 */   // Label 2605: @146750
     /* 146750 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(146824), // Rule ID 7386 //
     /* 146755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146758 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146765 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146772 */     // MIs[0] Rn
     /* 146772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146784 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146796 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 146811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146822 */     GIR_RootConstrainSelectedInstOperands,
     /* 146823 */     // GIR_Coverage, 7386,
     /* 146823 */     GIR_EraseRootFromParent_Done,
     /* 146824 */   // Label 2606: @146824
     /* 146824 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(146898), // Rule ID 7387 //
     /* 146829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146832 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146839 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146846 */     // MIs[0] Rn
     /* 146846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146858 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146870 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146876 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 146885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146896 */     GIR_RootConstrainSelectedInstOperands,
     /* 146897 */     // GIR_Coverage, 7387,
     /* 146897 */     GIR_EraseRootFromParent_Done,
     /* 146898 */   // Label 2607: @146898
     /* 146898 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(146972), // Rule ID 7388 //
     /* 146903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146913 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146920 */     // MIs[0] Rn
     /* 146920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146932 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146944 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 146959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146970 */     GIR_RootConstrainSelectedInstOperands,
     /* 146971 */     // GIR_Coverage, 7388,
     /* 146971 */     GIR_EraseRootFromParent_Done,
     /* 146972 */   // Label 2608: @146972
     /* 146972 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(147046), // Rule ID 7389 //
     /* 146977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146980 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146994 */     // MIs[0] Rn
     /* 146994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147006 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147018 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147024 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 147033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147044 */     GIR_RootConstrainSelectedInstOperands,
     /* 147045 */     // GIR_Coverage, 7389,
     /* 147045 */     GIR_EraseRootFromParent_Done,
     /* 147046 */   // Label 2609: @147046
     /* 147046 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(147120), // Rule ID 7390 //
     /* 147051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147054 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147061 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147068 */     // MIs[0] Rn
     /* 147068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147080 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147092 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 147107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147118 */     GIR_RootConstrainSelectedInstOperands,
     /* 147119 */     // GIR_Coverage, 7390,
     /* 147119 */     GIR_EraseRootFromParent_Done,
     /* 147120 */   // Label 2610: @147120
     /* 147120 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(147194), // Rule ID 7391 //
     /* 147125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147128 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147142 */     // MIs[0] Rn
     /* 147142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147154 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147166 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147172 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 147181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147192 */     GIR_RootConstrainSelectedInstOperands,
     /* 147193 */     // GIR_Coverage, 7391,
     /* 147193 */     GIR_EraseRootFromParent_Done,
     /* 147194 */   // Label 2611: @147194
     /* 147194 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(147268), // Rule ID 7392 //
     /* 147199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147202 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147209 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147216 */     // MIs[0] Rn
     /* 147216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147228 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147240 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147266 */     GIR_RootConstrainSelectedInstOperands,
     /* 147267 */     // GIR_Coverage, 7392,
     /* 147267 */     GIR_EraseRootFromParent_Done,
     /* 147268 */   // Label 2612: @147268
     /* 147268 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(147342), // Rule ID 7393 //
     /* 147273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147276 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147283 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147290 */     // MIs[0] Rn
     /* 147290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147302 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147314 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147340 */     GIR_RootConstrainSelectedInstOperands,
     /* 147341 */     // GIR_Coverage, 7393,
     /* 147341 */     GIR_EraseRootFromParent_Done,
     /* 147342 */   // Label 2613: @147342
     /* 147342 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(147416), // Rule ID 7394 //
     /* 147347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147350 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147357 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147364 */     // MIs[0] Rn
     /* 147364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147376 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147388 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 147403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147414 */     GIR_RootConstrainSelectedInstOperands,
     /* 147415 */     // GIR_Coverage, 7394,
     /* 147415 */     GIR_EraseRootFromParent_Done,
     /* 147416 */   // Label 2614: @147416
     /* 147416 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(147490), // Rule ID 7395 //
     /* 147421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147424 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147431 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147438 */     // MIs[0] Rn
     /* 147438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147450 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147462 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 147477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147488 */     GIR_RootConstrainSelectedInstOperands,
     /* 147489 */     // GIR_Coverage, 7395,
     /* 147489 */     GIR_EraseRootFromParent_Done,
     /* 147490 */   // Label 2615: @147490
     /* 147490 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(147564), // Rule ID 7396 //
     /* 147495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147512 */     // MIs[0] Rn
     /* 147512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147524 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147536 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 147551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147562 */     GIR_RootConstrainSelectedInstOperands,
     /* 147563 */     // GIR_Coverage, 7396,
     /* 147563 */     GIR_EraseRootFromParent_Done,
     /* 147564 */   // Label 2616: @147564
     /* 147564 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(147638), // Rule ID 7397 //
     /* 147569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147572 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147579 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147586 */     // MIs[0] Rn
     /* 147586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147598 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147610 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147616 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 147625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147636 */     GIR_RootConstrainSelectedInstOperands,
     /* 147637 */     // GIR_Coverage, 7397,
     /* 147637 */     GIR_EraseRootFromParent_Done,
     /* 147638 */   // Label 2617: @147638
     /* 147638 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(147712), // Rule ID 7398 //
     /* 147643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147660 */     // MIs[0] Rn
     /* 147660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147672 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147684 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 147699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147710 */     GIR_RootConstrainSelectedInstOperands,
     /* 147711 */     // GIR_Coverage, 7398,
     /* 147711 */     GIR_EraseRootFromParent_Done,
     /* 147712 */   // Label 2618: @147712
     /* 147712 */   GIM_Reject,
     /* 147713 */ // Label 2603: @147713
     /* 147713 */ GIM_Reject,
     /* 147714 */ // Label 2601: @147714
     /* 147714 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(148065),
     /* 147719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147722 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 147729 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(147796), // Rule ID 7379 //
     /* 147734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147737 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147744 */     // MIs[0] Rn
     /* 147744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147756 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147768 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 147783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147794 */     GIR_RootConstrainSelectedInstOperands,
     /* 147795 */     // GIR_Coverage, 7379,
     /* 147795 */     GIR_EraseRootFromParent_Done,
     /* 147796 */   // Label 2620: @147796
     /* 147796 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(147863), // Rule ID 7380 //
     /* 147801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147804 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147811 */     // MIs[0] Rn
     /* 147811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147823 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147835 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 147850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147861 */     GIR_RootConstrainSelectedInstOperands,
     /* 147862 */     // GIR_Coverage, 7380,
     /* 147862 */     GIR_EraseRootFromParent_Done,
     /* 147863 */   // Label 2621: @147863
     /* 147863 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(147930), // Rule ID 7381 //
     /* 147868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147871 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147878 */     // MIs[0] Rn
     /* 147878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147890 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147902 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 147917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147928 */     GIR_RootConstrainSelectedInstOperands,
     /* 147929 */     // GIR_Coverage, 7381,
     /* 147929 */     GIR_EraseRootFromParent_Done,
     /* 147930 */   // Label 2622: @147930
     /* 147930 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(147997), // Rule ID 7382 //
     /* 147935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147938 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147945 */     // MIs[0] Rn
     /* 147945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147957 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147969 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147975 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 147984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147995 */     GIR_RootConstrainSelectedInstOperands,
     /* 147996 */     // GIR_Coverage, 7382,
     /* 147996 */     GIR_EraseRootFromParent_Done,
     /* 147997 */   // Label 2623: @147997
     /* 147997 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(148064), // Rule ID 7383 //
     /* 148002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148005 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148012 */     // MIs[0] Rn
     /* 148012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148024 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 148027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 148031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148036 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 148051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148062 */     GIR_RootConstrainSelectedInstOperands,
     /* 148063 */     // GIR_Coverage, 7383,
     /* 148063 */     GIR_EraseRootFromParent_Done,
     /* 148064 */   // Label 2624: @148064
     /* 148064 */   GIM_Reject,
     /* 148065 */ // Label 2619: @148065
     /* 148065 */ GIM_Reject,
     /* 148066 */ // Label 2602: @148066
     /* 148066 */ GIM_Reject,
     /* 148067 */ // Label 24: @148067
     /* 148067 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2627*/ GIMT_Encode4(149558),
     /* 148078 */ /*GILLT_s32*//*Label 2625*/ GIMT_Encode4(148086),
     /* 148082 */ /*GILLT_s64*//*Label 2626*/ GIMT_Encode4(149206),
     /* 148086 */ // Label 2625: @148086
     /* 148086 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(149205),
     /* 148091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148094 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(148168), // Rule ID 7404 //
     /* 148099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148102 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148109 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148116 */     // MIs[0] Rn
     /* 148116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148128 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148140 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 148155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148166 */     GIR_RootConstrainSelectedInstOperands,
     /* 148167 */     // GIR_Coverage, 7404,
     /* 148167 */     GIR_EraseRootFromParent_Done,
     /* 148168 */   // Label 2629: @148168
     /* 148168 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(148242), // Rule ID 7405 //
     /* 148173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148176 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148183 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148190 */     // MIs[0] Rn
     /* 148190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148202 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148214 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 148229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148240 */     GIR_RootConstrainSelectedInstOperands,
     /* 148241 */     // GIR_Coverage, 7405,
     /* 148241 */     GIR_EraseRootFromParent_Done,
     /* 148242 */   // Label 2630: @148242
     /* 148242 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(148316), // Rule ID 7406 //
     /* 148247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148250 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148257 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148264 */     // MIs[0] Rn
     /* 148264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148276 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148288 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 148303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148314 */     GIR_RootConstrainSelectedInstOperands,
     /* 148315 */     // GIR_Coverage, 7406,
     /* 148315 */     GIR_EraseRootFromParent_Done,
     /* 148316 */   // Label 2631: @148316
     /* 148316 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(148390), // Rule ID 7407 //
     /* 148321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148324 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148331 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148338 */     // MIs[0] Rn
     /* 148338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148350 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148362 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 148377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148388 */     GIR_RootConstrainSelectedInstOperands,
     /* 148389 */     // GIR_Coverage, 7407,
     /* 148389 */     GIR_EraseRootFromParent_Done,
     /* 148390 */   // Label 2632: @148390
     /* 148390 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(148464), // Rule ID 7408 //
     /* 148395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148398 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148405 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148412 */     // MIs[0] Rn
     /* 148412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148424 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148436 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 148451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148462 */     GIR_RootConstrainSelectedInstOperands,
     /* 148463 */     // GIR_Coverage, 7408,
     /* 148463 */     GIR_EraseRootFromParent_Done,
     /* 148464 */   // Label 2633: @148464
     /* 148464 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(148538), // Rule ID 7409 //
     /* 148469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148472 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148486 */     // MIs[0] Rn
     /* 148486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148498 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148510 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 148525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148536 */     GIR_RootConstrainSelectedInstOperands,
     /* 148537 */     // GIR_Coverage, 7409,
     /* 148537 */     GIR_EraseRootFromParent_Done,
     /* 148538 */   // Label 2634: @148538
     /* 148538 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(148612), // Rule ID 7410 //
     /* 148543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148546 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148553 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148560 */     // MIs[0] Rn
     /* 148560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148572 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148584 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 148599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148610 */     GIR_RootConstrainSelectedInstOperands,
     /* 148611 */     // GIR_Coverage, 7410,
     /* 148611 */     GIR_EraseRootFromParent_Done,
     /* 148612 */   // Label 2635: @148612
     /* 148612 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(148686), // Rule ID 7411 //
     /* 148617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148620 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148627 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148634 */     // MIs[0] Rn
     /* 148634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148646 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148658 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148664 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 148673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148684 */     GIR_RootConstrainSelectedInstOperands,
     /* 148685 */     // GIR_Coverage, 7411,
     /* 148685 */     GIR_EraseRootFromParent_Done,
     /* 148686 */   // Label 2636: @148686
     /* 148686 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(148760), // Rule ID 7412 //
     /* 148691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148708 */     // MIs[0] Rn
     /* 148708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148720 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148732 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 148747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148758 */     GIR_RootConstrainSelectedInstOperands,
     /* 148759 */     // GIR_Coverage, 7412,
     /* 148759 */     GIR_EraseRootFromParent_Done,
     /* 148760 */   // Label 2637: @148760
     /* 148760 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(148834), // Rule ID 7413 //
     /* 148765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148768 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148775 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148782 */     // MIs[0] Rn
     /* 148782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148794 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148806 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148812 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 148821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148832 */     GIR_RootConstrainSelectedInstOperands,
     /* 148833 */     // GIR_Coverage, 7413,
     /* 148833 */     GIR_EraseRootFromParent_Done,
     /* 148834 */   // Label 2638: @148834
     /* 148834 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(148908), // Rule ID 7414 //
     /* 148839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148842 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148849 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148856 */     // MIs[0] Rn
     /* 148856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148868 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148880 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 148895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148906 */     GIR_RootConstrainSelectedInstOperands,
     /* 148907 */     // GIR_Coverage, 7414,
     /* 148907 */     GIR_EraseRootFromParent_Done,
     /* 148908 */   // Label 2639: @148908
     /* 148908 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(148982), // Rule ID 7415 //
     /* 148913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148916 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148923 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148930 */     // MIs[0] Rn
     /* 148930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148942 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148954 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 148969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148980 */     GIR_RootConstrainSelectedInstOperands,
     /* 148981 */     // GIR_Coverage, 7415,
     /* 148981 */     GIR_EraseRootFromParent_Done,
     /* 148982 */   // Label 2640: @148982
     /* 148982 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(149056), // Rule ID 7416 //
     /* 148987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148990 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148997 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149004 */     // MIs[0] Rn
     /* 149004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149016 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149028 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 149043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149054 */     GIR_RootConstrainSelectedInstOperands,
     /* 149055 */     // GIR_Coverage, 7416,
     /* 149055 */     GIR_EraseRootFromParent_Done,
     /* 149056 */   // Label 2641: @149056
     /* 149056 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(149130), // Rule ID 7417 //
     /* 149061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149078 */     // MIs[0] Rn
     /* 149078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149090 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149102 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149108 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 149117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149128 */     GIR_RootConstrainSelectedInstOperands,
     /* 149129 */     // GIR_Coverage, 7417,
     /* 149129 */     GIR_EraseRootFromParent_Done,
     /* 149130 */   // Label 2642: @149130
     /* 149130 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(149204), // Rule ID 7418 //
     /* 149135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149152 */     // MIs[0] Rn
     /* 149152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149164 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149176 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 149191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149202 */     GIR_RootConstrainSelectedInstOperands,
     /* 149203 */     // GIR_Coverage, 7418,
     /* 149203 */     GIR_EraseRootFromParent_Done,
     /* 149204 */   // Label 2643: @149204
     /* 149204 */   GIM_Reject,
     /* 149205 */ // Label 2628: @149205
     /* 149205 */ GIM_Reject,
     /* 149206 */ // Label 2626: @149206
     /* 149206 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(149557),
     /* 149211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149214 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149221 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(149288), // Rule ID 7399 //
     /* 149226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149229 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149236 */     // MIs[0] Rn
     /* 149236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149248 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149260 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 149275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149286 */     GIR_RootConstrainSelectedInstOperands,
     /* 149287 */     // GIR_Coverage, 7399,
     /* 149287 */     GIR_EraseRootFromParent_Done,
     /* 149288 */   // Label 2645: @149288
     /* 149288 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(149355), // Rule ID 7400 //
     /* 149293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149303 */     // MIs[0] Rn
     /* 149303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149315 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149327 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 149342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149353 */     GIR_RootConstrainSelectedInstOperands,
     /* 149354 */     // GIR_Coverage, 7400,
     /* 149354 */     GIR_EraseRootFromParent_Done,
     /* 149355 */   // Label 2646: @149355
     /* 149355 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(149422), // Rule ID 7401 //
     /* 149360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149363 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149370 */     // MIs[0] Rn
     /* 149370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149382 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149394 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 149409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149420 */     GIR_RootConstrainSelectedInstOperands,
     /* 149421 */     // GIR_Coverage, 7401,
     /* 149421 */     GIR_EraseRootFromParent_Done,
     /* 149422 */   // Label 2647: @149422
     /* 149422 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(149489), // Rule ID 7402 //
     /* 149427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149437 */     // MIs[0] Rn
     /* 149437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149449 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149461 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 149476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149487 */     GIR_RootConstrainSelectedInstOperands,
     /* 149488 */     // GIR_Coverage, 7402,
     /* 149488 */     GIR_EraseRootFromParent_Done,
     /* 149489 */   // Label 2648: @149489
     /* 149489 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(149556), // Rule ID 7403 //
     /* 149494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149504 */     // MIs[0] Rn
     /* 149504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149516 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149528 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 149543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149554 */     GIR_RootConstrainSelectedInstOperands,
     /* 149555 */     // GIR_Coverage, 7403,
     /* 149555 */     GIR_EraseRootFromParent_Done,
     /* 149556 */   // Label 2649: @149556
     /* 149556 */   GIM_Reject,
     /* 149557 */ // Label 2644: @149557
     /* 149557 */ GIM_Reject,
     /* 149558 */ // Label 2627: @149558
     /* 149558 */ GIM_Reject,
     /* 149559 */ // Label 25: @149559
     /* 149559 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2652*/ GIMT_Encode4(150550),
     /* 149570 */ /*GILLT_s32*//*Label 2650*/ GIMT_Encode4(149578),
     /* 149574 */ /*GILLT_s64*//*Label 2651*/ GIMT_Encode4(150323),
     /* 149578 */ // Label 2650: @149578
     /* 149578 */ GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(150322),
     /* 149583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149586 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(149635), // Rule ID 7209 //
     /* 149591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149594 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149601 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149608 */     // MIs[0] Rn
     /* 149608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149620 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 149623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149633 */     GIR_RootConstrainSelectedInstOperands,
     /* 149634 */     // GIR_Coverage, 7209,
     /* 149634 */     GIR_EraseRootFromParent_Done,
     /* 149635 */   // Label 2654: @149635
     /* 149635 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(149684), // Rule ID 7210 //
     /* 149640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149643 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149650 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149657 */     // MIs[0] Rn
     /* 149657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149669 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 149672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149682 */     GIR_RootConstrainSelectedInstOperands,
     /* 149683 */     // GIR_Coverage, 7210,
     /* 149683 */     GIR_EraseRootFromParent_Done,
     /* 149684 */   // Label 2655: @149684
     /* 149684 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(149733), // Rule ID 7211 //
     /* 149689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149692 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149699 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149706 */     // MIs[0] Rn
     /* 149706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149718 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 149721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149731 */     GIR_RootConstrainSelectedInstOperands,
     /* 149732 */     // GIR_Coverage, 7211,
     /* 149732 */     GIR_EraseRootFromParent_Done,
     /* 149733 */   // Label 2656: @149733
     /* 149733 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(149782), // Rule ID 7212 //
     /* 149738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149741 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149748 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149755 */     // MIs[0] Rn
     /* 149755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149767 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 149770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149780 */     GIR_RootConstrainSelectedInstOperands,
     /* 149781 */     // GIR_Coverage, 7212,
     /* 149781 */     GIR_EraseRootFromParent_Done,
     /* 149782 */   // Label 2657: @149782
     /* 149782 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(149831), // Rule ID 7213 //
     /* 149787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149790 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149797 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149804 */     // MIs[0] Rn
     /* 149804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149816 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 149819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149829 */     GIR_RootConstrainSelectedInstOperands,
     /* 149830 */     // GIR_Coverage, 7213,
     /* 149830 */     GIR_EraseRootFromParent_Done,
     /* 149831 */   // Label 2658: @149831
     /* 149831 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(149880), // Rule ID 7214 //
     /* 149836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149839 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149846 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149853 */     // MIs[0] Rn
     /* 149853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149865 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 149868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149878 */     GIR_RootConstrainSelectedInstOperands,
     /* 149879 */     // GIR_Coverage, 7214,
     /* 149879 */     GIR_EraseRootFromParent_Done,
     /* 149880 */   // Label 2659: @149880
     /* 149880 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(149929), // Rule ID 7215 //
     /* 149885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149888 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149895 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149902 */     // MIs[0] Rn
     /* 149902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149914 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 149917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149927 */     GIR_RootConstrainSelectedInstOperands,
     /* 149928 */     // GIR_Coverage, 7215,
     /* 149928 */     GIR_EraseRootFromParent_Done,
     /* 149929 */   // Label 2660: @149929
     /* 149929 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(149978), // Rule ID 7216 //
     /* 149934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149937 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149944 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149951 */     // MIs[0] Rn
     /* 149951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149963 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 149966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149976 */     GIR_RootConstrainSelectedInstOperands,
     /* 149977 */     // GIR_Coverage, 7216,
     /* 149977 */     GIR_EraseRootFromParent_Done,
     /* 149978 */   // Label 2661: @149978
     /* 149978 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(150027), // Rule ID 7217 //
     /* 149983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149986 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149993 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150000 */     // MIs[0] Rn
     /* 150000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150012 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 150015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150025 */     GIR_RootConstrainSelectedInstOperands,
     /* 150026 */     // GIR_Coverage, 7217,
     /* 150026 */     GIR_EraseRootFromParent_Done,
     /* 150027 */   // Label 2662: @150027
     /* 150027 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(150076), // Rule ID 7218 //
     /* 150032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150049 */     // MIs[0] Rn
     /* 150049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150061 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 150064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150074 */     GIR_RootConstrainSelectedInstOperands,
     /* 150075 */     // GIR_Coverage, 7218,
     /* 150075 */     GIR_EraseRootFromParent_Done,
     /* 150076 */   // Label 2663: @150076
     /* 150076 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(150125), // Rule ID 7219 //
     /* 150081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150084 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150091 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150098 */     // MIs[0] Rn
     /* 150098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150110 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 150113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150123 */     GIR_RootConstrainSelectedInstOperands,
     /* 150124 */     // GIR_Coverage, 7219,
     /* 150124 */     GIR_EraseRootFromParent_Done,
     /* 150125 */   // Label 2664: @150125
     /* 150125 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(150174), // Rule ID 7220 //
     /* 150130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150147 */     // MIs[0] Rn
     /* 150147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150159 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 150162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150172 */     GIR_RootConstrainSelectedInstOperands,
     /* 150173 */     // GIR_Coverage, 7220,
     /* 150173 */     GIR_EraseRootFromParent_Done,
     /* 150174 */   // Label 2665: @150174
     /* 150174 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(150223), // Rule ID 7221 //
     /* 150179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150196 */     // MIs[0] Rn
     /* 150196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150208 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 150211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150221 */     GIR_RootConstrainSelectedInstOperands,
     /* 150222 */     // GIR_Coverage, 7221,
     /* 150222 */     GIR_EraseRootFromParent_Done,
     /* 150223 */   // Label 2666: @150223
     /* 150223 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(150272), // Rule ID 7222 //
     /* 150228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150245 */     // MIs[0] Rn
     /* 150245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150257 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 150260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150270 */     GIR_RootConstrainSelectedInstOperands,
     /* 150271 */     // GIR_Coverage, 7222,
     /* 150271 */     GIR_EraseRootFromParent_Done,
     /* 150272 */   // Label 2667: @150272
     /* 150272 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(150321), // Rule ID 7223 //
     /* 150277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150294 */     // MIs[0] Rn
     /* 150294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150306 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 150309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150319 */     GIR_RootConstrainSelectedInstOperands,
     /* 150320 */     // GIR_Coverage, 7223,
     /* 150320 */     GIR_EraseRootFromParent_Done,
     /* 150321 */   // Label 2668: @150321
     /* 150321 */   GIM_Reject,
     /* 150322 */ // Label 2653: @150322
     /* 150322 */ GIM_Reject,
     /* 150323 */ // Label 2651: @150323
     /* 150323 */ GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(150549),
     /* 150328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150331 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 150338 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(150380), // Rule ID 7204 //
     /* 150343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150346 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150353 */     // MIs[0] Rn
     /* 150353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150365 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 150368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150378 */     GIR_RootConstrainSelectedInstOperands,
     /* 150379 */     // GIR_Coverage, 7204,
     /* 150379 */     GIR_EraseRootFromParent_Done,
     /* 150380 */   // Label 2670: @150380
     /* 150380 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(150422), // Rule ID 7205 //
     /* 150385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150388 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150395 */     // MIs[0] Rn
     /* 150395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150407 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 150410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150420 */     GIR_RootConstrainSelectedInstOperands,
     /* 150421 */     // GIR_Coverage, 7205,
     /* 150421 */     GIR_EraseRootFromParent_Done,
     /* 150422 */   // Label 2671: @150422
     /* 150422 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(150464), // Rule ID 7206 //
     /* 150427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150437 */     // MIs[0] Rn
     /* 150437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150449 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 150452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150462 */     GIR_RootConstrainSelectedInstOperands,
     /* 150463 */     // GIR_Coverage, 7206,
     /* 150463 */     GIR_EraseRootFromParent_Done,
     /* 150464 */   // Label 2672: @150464
     /* 150464 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(150506), // Rule ID 7207 //
     /* 150469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150472 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150479 */     // MIs[0] Rn
     /* 150479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150491 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 150494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150504 */     GIR_RootConstrainSelectedInstOperands,
     /* 150505 */     // GIR_Coverage, 7207,
     /* 150505 */     GIR_EraseRootFromParent_Done,
     /* 150506 */   // Label 2673: @150506
     /* 150506 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(150548), // Rule ID 7208 //
     /* 150511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150521 */     // MIs[0] Rn
     /* 150521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150533 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 150536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150546 */     GIR_RootConstrainSelectedInstOperands,
     /* 150547 */     // GIR_Coverage, 7208,
     /* 150547 */     GIR_EraseRootFromParent_Done,
     /* 150548 */   // Label 2674: @150548
     /* 150548 */   GIM_Reject,
     /* 150549 */ // Label 2669: @150549
     /* 150549 */ GIM_Reject,
     /* 150550 */ // Label 2652: @150550
     /* 150550 */ GIM_Reject,
     /* 150551 */ // Label 26: @150551
     /* 150551 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2677*/ GIMT_Encode4(151542),
     /* 150562 */ /*GILLT_s32*//*Label 2675*/ GIMT_Encode4(150570),
     /* 150566 */ /*GILLT_s64*//*Label 2676*/ GIMT_Encode4(151315),
     /* 150570 */ // Label 2675: @150570
     /* 150570 */ GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(151314),
     /* 150575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150578 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(150627), // Rule ID 7229 //
     /* 150583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150586 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150593 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150600 */     // MIs[0] Rn
     /* 150600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150612 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 150615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150625 */     GIR_RootConstrainSelectedInstOperands,
     /* 150626 */     // GIR_Coverage, 7229,
     /* 150626 */     GIR_EraseRootFromParent_Done,
     /* 150627 */   // Label 2679: @150627
     /* 150627 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(150676), // Rule ID 7230 //
     /* 150632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150635 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150642 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150649 */     // MIs[0] Rn
     /* 150649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150661 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 150664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150674 */     GIR_RootConstrainSelectedInstOperands,
     /* 150675 */     // GIR_Coverage, 7230,
     /* 150675 */     GIR_EraseRootFromParent_Done,
     /* 150676 */   // Label 2680: @150676
     /* 150676 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(150725), // Rule ID 7231 //
     /* 150681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150684 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150691 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150698 */     // MIs[0] Rn
     /* 150698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150710 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 150713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150723 */     GIR_RootConstrainSelectedInstOperands,
     /* 150724 */     // GIR_Coverage, 7231,
     /* 150724 */     GIR_EraseRootFromParent_Done,
     /* 150725 */   // Label 2681: @150725
     /* 150725 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(150774), // Rule ID 7232 //
     /* 150730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150733 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150740 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150747 */     // MIs[0] Rn
     /* 150747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150759 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 150762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150772 */     GIR_RootConstrainSelectedInstOperands,
     /* 150773 */     // GIR_Coverage, 7232,
     /* 150773 */     GIR_EraseRootFromParent_Done,
     /* 150774 */   // Label 2682: @150774
     /* 150774 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(150823), // Rule ID 7233 //
     /* 150779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150782 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150789 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150796 */     // MIs[0] Rn
     /* 150796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150808 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 150811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150821 */     GIR_RootConstrainSelectedInstOperands,
     /* 150822 */     // GIR_Coverage, 7233,
     /* 150822 */     GIR_EraseRootFromParent_Done,
     /* 150823 */   // Label 2683: @150823
     /* 150823 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(150872), // Rule ID 7234 //
     /* 150828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150838 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150845 */     // MIs[0] Rn
     /* 150845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150857 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 150860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150870 */     GIR_RootConstrainSelectedInstOperands,
     /* 150871 */     // GIR_Coverage, 7234,
     /* 150871 */     GIR_EraseRootFromParent_Done,
     /* 150872 */   // Label 2684: @150872
     /* 150872 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(150921), // Rule ID 7235 //
     /* 150877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150880 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150887 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150894 */     // MIs[0] Rn
     /* 150894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150906 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 150909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150919 */     GIR_RootConstrainSelectedInstOperands,
     /* 150920 */     // GIR_Coverage, 7235,
     /* 150920 */     GIR_EraseRootFromParent_Done,
     /* 150921 */   // Label 2685: @150921
     /* 150921 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(150970), // Rule ID 7236 //
     /* 150926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150943 */     // MIs[0] Rn
     /* 150943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150955 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 150958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150968 */     GIR_RootConstrainSelectedInstOperands,
     /* 150969 */     // GIR_Coverage, 7236,
     /* 150969 */     GIR_EraseRootFromParent_Done,
     /* 150970 */   // Label 2686: @150970
     /* 150970 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(151019), // Rule ID 7237 //
     /* 150975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150992 */     // MIs[0] Rn
     /* 150992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151004 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 151007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151017 */     GIR_RootConstrainSelectedInstOperands,
     /* 151018 */     // GIR_Coverage, 7237,
     /* 151018 */     GIR_EraseRootFromParent_Done,
     /* 151019 */   // Label 2687: @151019
     /* 151019 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(151068), // Rule ID 7238 //
     /* 151024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151027 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151034 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151041 */     // MIs[0] Rn
     /* 151041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151053 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 151056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151066 */     GIR_RootConstrainSelectedInstOperands,
     /* 151067 */     // GIR_Coverage, 7238,
     /* 151067 */     GIR_EraseRootFromParent_Done,
     /* 151068 */   // Label 2688: @151068
     /* 151068 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(151117), // Rule ID 7239 //
     /* 151073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151083 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151090 */     // MIs[0] Rn
     /* 151090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151102 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 151105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151115 */     GIR_RootConstrainSelectedInstOperands,
     /* 151116 */     // GIR_Coverage, 7239,
     /* 151116 */     GIR_EraseRootFromParent_Done,
     /* 151117 */   // Label 2689: @151117
     /* 151117 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(151166), // Rule ID 7240 //
     /* 151122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151139 */     // MIs[0] Rn
     /* 151139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151151 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 151154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151164 */     GIR_RootConstrainSelectedInstOperands,
     /* 151165 */     // GIR_Coverage, 7240,
     /* 151165 */     GIR_EraseRootFromParent_Done,
     /* 151166 */   // Label 2690: @151166
     /* 151166 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(151215), // Rule ID 7241 //
     /* 151171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151188 */     // MIs[0] Rn
     /* 151188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151200 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 151203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151213 */     GIR_RootConstrainSelectedInstOperands,
     /* 151214 */     // GIR_Coverage, 7241,
     /* 151214 */     GIR_EraseRootFromParent_Done,
     /* 151215 */   // Label 2691: @151215
     /* 151215 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(151264), // Rule ID 7242 //
     /* 151220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151237 */     // MIs[0] Rn
     /* 151237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151249 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 151252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151262 */     GIR_RootConstrainSelectedInstOperands,
     /* 151263 */     // GIR_Coverage, 7242,
     /* 151263 */     GIR_EraseRootFromParent_Done,
     /* 151264 */   // Label 2692: @151264
     /* 151264 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(151313), // Rule ID 7243 //
     /* 151269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151286 */     // MIs[0] Rn
     /* 151286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151298 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 151301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151311 */     GIR_RootConstrainSelectedInstOperands,
     /* 151312 */     // GIR_Coverage, 7243,
     /* 151312 */     GIR_EraseRootFromParent_Done,
     /* 151313 */   // Label 2693: @151313
     /* 151313 */   GIM_Reject,
     /* 151314 */ // Label 2678: @151314
     /* 151314 */ GIM_Reject,
     /* 151315 */ // Label 2676: @151315
     /* 151315 */ GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(151541),
     /* 151320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 151330 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(151372), // Rule ID 7224 //
     /* 151335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151338 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151345 */     // MIs[0] Rn
     /* 151345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151357 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 151360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151370 */     GIR_RootConstrainSelectedInstOperands,
     /* 151371 */     // GIR_Coverage, 7224,
     /* 151371 */     GIR_EraseRootFromParent_Done,
     /* 151372 */   // Label 2695: @151372
     /* 151372 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(151414), // Rule ID 7225 //
     /* 151377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151380 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151387 */     // MIs[0] Rn
     /* 151387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151399 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 151402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151412 */     GIR_RootConstrainSelectedInstOperands,
     /* 151413 */     // GIR_Coverage, 7225,
     /* 151413 */     GIR_EraseRootFromParent_Done,
     /* 151414 */   // Label 2696: @151414
     /* 151414 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(151456), // Rule ID 7226 //
     /* 151419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151422 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151429 */     // MIs[0] Rn
     /* 151429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151441 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 151444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151454 */     GIR_RootConstrainSelectedInstOperands,
     /* 151455 */     // GIR_Coverage, 7226,
     /* 151455 */     GIR_EraseRootFromParent_Done,
     /* 151456 */   // Label 2697: @151456
     /* 151456 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(151498), // Rule ID 7227 //
     /* 151461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151464 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151471 */     // MIs[0] Rn
     /* 151471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151483 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 151486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151496 */     GIR_RootConstrainSelectedInstOperands,
     /* 151497 */     // GIR_Coverage, 7227,
     /* 151497 */     GIR_EraseRootFromParent_Done,
     /* 151498 */   // Label 2698: @151498
     /* 151498 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(151540), // Rule ID 7228 //
     /* 151503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151513 */     // MIs[0] Rn
     /* 151513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151525 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 151528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151538 */     GIR_RootConstrainSelectedInstOperands,
     /* 151539 */     // GIR_Coverage, 7228,
     /* 151539 */     GIR_EraseRootFromParent_Done,
     /* 151540 */   // Label 2699: @151540
     /* 151540 */   GIM_Reject,
     /* 151541 */ // Label 2694: @151541
     /* 151541 */ GIM_Reject,
     /* 151542 */ // Label 2677: @151542
     /* 151542 */ GIM_Reject,
     /* 151543 */ // Label 27: @151543
     /* 151543 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2702*/ GIMT_Encode4(152534),
     /* 151554 */ /*GILLT_s32*//*Label 2700*/ GIMT_Encode4(151562),
     /* 151558 */ /*GILLT_s64*//*Label 2701*/ GIMT_Encode4(152307),
     /* 151562 */ // Label 2700: @151562
     /* 151562 */ GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(152306),
     /* 151567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151570 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(151619), // Rule ID 7269 //
     /* 151575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151578 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151585 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151592 */     // MIs[0] Rn
     /* 151592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151604 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 151607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151617 */     GIR_RootConstrainSelectedInstOperands,
     /* 151618 */     // GIR_Coverage, 7269,
     /* 151618 */     GIR_EraseRootFromParent_Done,
     /* 151619 */   // Label 2704: @151619
     /* 151619 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(151668), // Rule ID 7270 //
     /* 151624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151627 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151634 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151641 */     // MIs[0] Rn
     /* 151641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151653 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 151656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151666 */     GIR_RootConstrainSelectedInstOperands,
     /* 151667 */     // GIR_Coverage, 7270,
     /* 151667 */     GIR_EraseRootFromParent_Done,
     /* 151668 */   // Label 2705: @151668
     /* 151668 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(151717), // Rule ID 7271 //
     /* 151673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151676 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151683 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151690 */     // MIs[0] Rn
     /* 151690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151702 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 151705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151715 */     GIR_RootConstrainSelectedInstOperands,
     /* 151716 */     // GIR_Coverage, 7271,
     /* 151716 */     GIR_EraseRootFromParent_Done,
     /* 151717 */   // Label 2706: @151717
     /* 151717 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(151766), // Rule ID 7272 //
     /* 151722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151725 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151732 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151739 */     // MIs[0] Rn
     /* 151739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151751 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 151754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151764 */     GIR_RootConstrainSelectedInstOperands,
     /* 151765 */     // GIR_Coverage, 7272,
     /* 151765 */     GIR_EraseRootFromParent_Done,
     /* 151766 */   // Label 2707: @151766
     /* 151766 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(151815), // Rule ID 7273 //
     /* 151771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151774 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151781 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151788 */     // MIs[0] Rn
     /* 151788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151800 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 151803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151813 */     GIR_RootConstrainSelectedInstOperands,
     /* 151814 */     // GIR_Coverage, 7273,
     /* 151814 */     GIR_EraseRootFromParent_Done,
     /* 151815 */   // Label 2708: @151815
     /* 151815 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(151864), // Rule ID 7274 //
     /* 151820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151823 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151830 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151837 */     // MIs[0] Rn
     /* 151837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151849 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 151852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151862 */     GIR_RootConstrainSelectedInstOperands,
     /* 151863 */     // GIR_Coverage, 7274,
     /* 151863 */     GIR_EraseRootFromParent_Done,
     /* 151864 */   // Label 2709: @151864
     /* 151864 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(151913), // Rule ID 7275 //
     /* 151869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151872 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151886 */     // MIs[0] Rn
     /* 151886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151898 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 151901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151911 */     GIR_RootConstrainSelectedInstOperands,
     /* 151912 */     // GIR_Coverage, 7275,
     /* 151912 */     GIR_EraseRootFromParent_Done,
     /* 151913 */   // Label 2710: @151913
     /* 151913 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(151962), // Rule ID 7276 //
     /* 151918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151921 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151935 */     // MIs[0] Rn
     /* 151935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151947 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 151950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151960 */     GIR_RootConstrainSelectedInstOperands,
     /* 151961 */     // GIR_Coverage, 7276,
     /* 151961 */     GIR_EraseRootFromParent_Done,
     /* 151962 */   // Label 2711: @151962
     /* 151962 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(152011), // Rule ID 7277 //
     /* 151967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151984 */     // MIs[0] Rn
     /* 151984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151996 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 151999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152009 */     GIR_RootConstrainSelectedInstOperands,
     /* 152010 */     // GIR_Coverage, 7277,
     /* 152010 */     GIR_EraseRootFromParent_Done,
     /* 152011 */   // Label 2712: @152011
     /* 152011 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(152060), // Rule ID 7278 //
     /* 152016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152019 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152033 */     // MIs[0] Rn
     /* 152033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152045 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 152048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152058 */     GIR_RootConstrainSelectedInstOperands,
     /* 152059 */     // GIR_Coverage, 7278,
     /* 152059 */     GIR_EraseRootFromParent_Done,
     /* 152060 */   // Label 2713: @152060
     /* 152060 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(152109), // Rule ID 7279 //
     /* 152065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152068 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152075 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152082 */     // MIs[0] Rn
     /* 152082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152094 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 152097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152107 */     GIR_RootConstrainSelectedInstOperands,
     /* 152108 */     // GIR_Coverage, 7279,
     /* 152108 */     GIR_EraseRootFromParent_Done,
     /* 152109 */   // Label 2714: @152109
     /* 152109 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(152158), // Rule ID 7280 //
     /* 152114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152117 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152124 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152131 */     // MIs[0] Rn
     /* 152131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152143 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 152146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152156 */     GIR_RootConstrainSelectedInstOperands,
     /* 152157 */     // GIR_Coverage, 7280,
     /* 152157 */     GIR_EraseRootFromParent_Done,
     /* 152158 */   // Label 2715: @152158
     /* 152158 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(152207), // Rule ID 7281 //
     /* 152163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152166 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152180 */     // MIs[0] Rn
     /* 152180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152192 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 152195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152205 */     GIR_RootConstrainSelectedInstOperands,
     /* 152206 */     // GIR_Coverage, 7281,
     /* 152206 */     GIR_EraseRootFromParent_Done,
     /* 152207 */   // Label 2716: @152207
     /* 152207 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(152256), // Rule ID 7282 //
     /* 152212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152229 */     // MIs[0] Rn
     /* 152229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152241 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 152244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152254 */     GIR_RootConstrainSelectedInstOperands,
     /* 152255 */     // GIR_Coverage, 7282,
     /* 152255 */     GIR_EraseRootFromParent_Done,
     /* 152256 */   // Label 2717: @152256
     /* 152256 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(152305), // Rule ID 7283 //
     /* 152261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152278 */     // MIs[0] Rn
     /* 152278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152290 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 152293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152303 */     GIR_RootConstrainSelectedInstOperands,
     /* 152304 */     // GIR_Coverage, 7283,
     /* 152304 */     GIR_EraseRootFromParent_Done,
     /* 152305 */   // Label 2718: @152305
     /* 152305 */   GIM_Reject,
     /* 152306 */ // Label 2703: @152306
     /* 152306 */ GIM_Reject,
     /* 152307 */ // Label 2701: @152307
     /* 152307 */ GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(152533),
     /* 152312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152315 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 152322 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(152364), // Rule ID 7264 //
     /* 152327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152330 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152337 */     // MIs[0] Rn
     /* 152337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152349 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 152352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152362 */     GIR_RootConstrainSelectedInstOperands,
     /* 152363 */     // GIR_Coverage, 7264,
     /* 152363 */     GIR_EraseRootFromParent_Done,
     /* 152364 */   // Label 2720: @152364
     /* 152364 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(152406), // Rule ID 7265 //
     /* 152369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152372 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152379 */     // MIs[0] Rn
     /* 152379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152391 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 152394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152404 */     GIR_RootConstrainSelectedInstOperands,
     /* 152405 */     // GIR_Coverage, 7265,
     /* 152405 */     GIR_EraseRootFromParent_Done,
     /* 152406 */   // Label 2721: @152406
     /* 152406 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(152448), // Rule ID 7266 //
     /* 152411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152414 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152421 */     // MIs[0] Rn
     /* 152421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152433 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 152436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152446 */     GIR_RootConstrainSelectedInstOperands,
     /* 152447 */     // GIR_Coverage, 7266,
     /* 152447 */     GIR_EraseRootFromParent_Done,
     /* 152448 */   // Label 2722: @152448
     /* 152448 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(152490), // Rule ID 7267 //
     /* 152453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152463 */     // MIs[0] Rn
     /* 152463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152475 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 152478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152488 */     GIR_RootConstrainSelectedInstOperands,
     /* 152489 */     // GIR_Coverage, 7267,
     /* 152489 */     GIR_EraseRootFromParent_Done,
     /* 152490 */   // Label 2723: @152490
     /* 152490 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(152532), // Rule ID 7268 //
     /* 152495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152505 */     // MIs[0] Rn
     /* 152505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152517 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 152520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152530 */     GIR_RootConstrainSelectedInstOperands,
     /* 152531 */     // GIR_Coverage, 7268,
     /* 152531 */     GIR_EraseRootFromParent_Done,
     /* 152532 */   // Label 2724: @152532
     /* 152532 */   GIM_Reject,
     /* 152533 */ // Label 2719: @152533
     /* 152533 */ GIM_Reject,
     /* 152534 */ // Label 2702: @152534
     /* 152534 */ GIM_Reject,
     /* 152535 */ // Label 28: @152535
     /* 152535 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2727*/ GIMT_Encode4(153526),
     /* 152546 */ /*GILLT_s32*//*Label 2725*/ GIMT_Encode4(152554),
     /* 152550 */ /*GILLT_s64*//*Label 2726*/ GIMT_Encode4(153299),
     /* 152554 */ // Label 2725: @152554
     /* 152554 */ GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(153298),
     /* 152559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152562 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(152611), // Rule ID 7289 //
     /* 152567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152570 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152577 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152584 */     // MIs[0] Rn
     /* 152584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152596 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 152599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152609 */     GIR_RootConstrainSelectedInstOperands,
     /* 152610 */     // GIR_Coverage, 7289,
     /* 152610 */     GIR_EraseRootFromParent_Done,
     /* 152611 */   // Label 2729: @152611
     /* 152611 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(152660), // Rule ID 7290 //
     /* 152616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152619 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152626 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152633 */     // MIs[0] Rn
     /* 152633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152645 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 152648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152658 */     GIR_RootConstrainSelectedInstOperands,
     /* 152659 */     // GIR_Coverage, 7290,
     /* 152659 */     GIR_EraseRootFromParent_Done,
     /* 152660 */   // Label 2730: @152660
     /* 152660 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(152709), // Rule ID 7291 //
     /* 152665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152668 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152675 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152682 */     // MIs[0] Rn
     /* 152682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152694 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 152697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152707 */     GIR_RootConstrainSelectedInstOperands,
     /* 152708 */     // GIR_Coverage, 7291,
     /* 152708 */     GIR_EraseRootFromParent_Done,
     /* 152709 */   // Label 2731: @152709
     /* 152709 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(152758), // Rule ID 7292 //
     /* 152714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152717 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152724 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152731 */     // MIs[0] Rn
     /* 152731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152743 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 152746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152756 */     GIR_RootConstrainSelectedInstOperands,
     /* 152757 */     // GIR_Coverage, 7292,
     /* 152757 */     GIR_EraseRootFromParent_Done,
     /* 152758 */   // Label 2732: @152758
     /* 152758 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(152807), // Rule ID 7293 //
     /* 152763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152766 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152773 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152780 */     // MIs[0] Rn
     /* 152780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152792 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 152795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152805 */     GIR_RootConstrainSelectedInstOperands,
     /* 152806 */     // GIR_Coverage, 7293,
     /* 152806 */     GIR_EraseRootFromParent_Done,
     /* 152807 */   // Label 2733: @152807
     /* 152807 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(152856), // Rule ID 7294 //
     /* 152812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152815 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152822 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152829 */     // MIs[0] Rn
     /* 152829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152841 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 152844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152854 */     GIR_RootConstrainSelectedInstOperands,
     /* 152855 */     // GIR_Coverage, 7294,
     /* 152855 */     GIR_EraseRootFromParent_Done,
     /* 152856 */   // Label 2734: @152856
     /* 152856 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(152905), // Rule ID 7295 //
     /* 152861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152864 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152871 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152878 */     // MIs[0] Rn
     /* 152878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152890 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 152893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152903 */     GIR_RootConstrainSelectedInstOperands,
     /* 152904 */     // GIR_Coverage, 7295,
     /* 152904 */     GIR_EraseRootFromParent_Done,
     /* 152905 */   // Label 2735: @152905
     /* 152905 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(152954), // Rule ID 7296 //
     /* 152910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152913 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152920 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152927 */     // MIs[0] Rn
     /* 152927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152939 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 152942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152952 */     GIR_RootConstrainSelectedInstOperands,
     /* 152953 */     // GIR_Coverage, 7296,
     /* 152953 */     GIR_EraseRootFromParent_Done,
     /* 152954 */   // Label 2736: @152954
     /* 152954 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(153003), // Rule ID 7297 //
     /* 152959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152962 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152976 */     // MIs[0] Rn
     /* 152976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152988 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 152991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153001 */     GIR_RootConstrainSelectedInstOperands,
     /* 153002 */     // GIR_Coverage, 7297,
     /* 153002 */     GIR_EraseRootFromParent_Done,
     /* 153003 */   // Label 2737: @153003
     /* 153003 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(153052), // Rule ID 7298 //
     /* 153008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153011 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153025 */     // MIs[0] Rn
     /* 153025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153037 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 153040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153050 */     GIR_RootConstrainSelectedInstOperands,
     /* 153051 */     // GIR_Coverage, 7298,
     /* 153051 */     GIR_EraseRootFromParent_Done,
     /* 153052 */   // Label 2738: @153052
     /* 153052 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(153101), // Rule ID 7299 //
     /* 153057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153060 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153074 */     // MIs[0] Rn
     /* 153074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153086 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 153089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153099 */     GIR_RootConstrainSelectedInstOperands,
     /* 153100 */     // GIR_Coverage, 7299,
     /* 153100 */     GIR_EraseRootFromParent_Done,
     /* 153101 */   // Label 2739: @153101
     /* 153101 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(153150), // Rule ID 7300 //
     /* 153106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153109 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153123 */     // MIs[0] Rn
     /* 153123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153135 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 153138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153148 */     GIR_RootConstrainSelectedInstOperands,
     /* 153149 */     // GIR_Coverage, 7300,
     /* 153149 */     GIR_EraseRootFromParent_Done,
     /* 153150 */   // Label 2740: @153150
     /* 153150 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(153199), // Rule ID 7301 //
     /* 153155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153172 */     // MIs[0] Rn
     /* 153172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153184 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 153187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153197 */     GIR_RootConstrainSelectedInstOperands,
     /* 153198 */     // GIR_Coverage, 7301,
     /* 153198 */     GIR_EraseRootFromParent_Done,
     /* 153199 */   // Label 2741: @153199
     /* 153199 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(153248), // Rule ID 7302 //
     /* 153204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153207 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153221 */     // MIs[0] Rn
     /* 153221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153233 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 153236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153246 */     GIR_RootConstrainSelectedInstOperands,
     /* 153247 */     // GIR_Coverage, 7302,
     /* 153247 */     GIR_EraseRootFromParent_Done,
     /* 153248 */   // Label 2742: @153248
     /* 153248 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(153297), // Rule ID 7303 //
     /* 153253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153270 */     // MIs[0] Rn
     /* 153270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153282 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 153285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153295 */     GIR_RootConstrainSelectedInstOperands,
     /* 153296 */     // GIR_Coverage, 7303,
     /* 153296 */     GIR_EraseRootFromParent_Done,
     /* 153297 */   // Label 2743: @153297
     /* 153297 */   GIM_Reject,
     /* 153298 */ // Label 2728: @153298
     /* 153298 */ GIM_Reject,
     /* 153299 */ // Label 2726: @153299
     /* 153299 */ GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(153525),
     /* 153304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153307 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153314 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(153356), // Rule ID 7284 //
     /* 153319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153322 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153329 */     // MIs[0] Rn
     /* 153329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153341 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 153344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153354 */     GIR_RootConstrainSelectedInstOperands,
     /* 153355 */     // GIR_Coverage, 7284,
     /* 153355 */     GIR_EraseRootFromParent_Done,
     /* 153356 */   // Label 2745: @153356
     /* 153356 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(153398), // Rule ID 7285 //
     /* 153361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153364 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153371 */     // MIs[0] Rn
     /* 153371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153383 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 153386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153396 */     GIR_RootConstrainSelectedInstOperands,
     /* 153397 */     // GIR_Coverage, 7285,
     /* 153397 */     GIR_EraseRootFromParent_Done,
     /* 153398 */   // Label 2746: @153398
     /* 153398 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(153440), // Rule ID 7286 //
     /* 153403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153406 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153413 */     // MIs[0] Rn
     /* 153413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153425 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 153428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153438 */     GIR_RootConstrainSelectedInstOperands,
     /* 153439 */     // GIR_Coverage, 7286,
     /* 153439 */     GIR_EraseRootFromParent_Done,
     /* 153440 */   // Label 2747: @153440
     /* 153440 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(153482), // Rule ID 7287 //
     /* 153445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153455 */     // MIs[0] Rn
     /* 153455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153467 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 153470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153480 */     GIR_RootConstrainSelectedInstOperands,
     /* 153481 */     // GIR_Coverage, 7287,
     /* 153481 */     GIR_EraseRootFromParent_Done,
     /* 153482 */   // Label 2748: @153482
     /* 153482 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(153524), // Rule ID 7288 //
     /* 153487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153497 */     // MIs[0] Rn
     /* 153497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153509 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 153512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153522 */     GIR_RootConstrainSelectedInstOperands,
     /* 153523 */     // GIR_Coverage, 7288,
     /* 153523 */     GIR_EraseRootFromParent_Done,
     /* 153524 */   // Label 2749: @153524
     /* 153524 */   GIM_Reject,
     /* 153525 */ // Label 2744: @153525
     /* 153525 */ GIM_Reject,
     /* 153526 */ // Label 2727: @153526
     /* 153526 */ GIM_Reject,
     /* 153527 */ // Label 29: @153527
     /* 153527 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2752*/ GIMT_Encode4(154518),
     /* 153538 */ /*GILLT_s32*//*Label 2750*/ GIMT_Encode4(153546),
     /* 153542 */ /*GILLT_s64*//*Label 2751*/ GIMT_Encode4(154291),
     /* 153546 */ // Label 2750: @153546
     /* 153546 */ GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(154290),
     /* 153551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153554 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(153603), // Rule ID 7309 //
     /* 153559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153562 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153569 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153576 */     // MIs[0] Rn
     /* 153576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153588 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 153591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153601 */     GIR_RootConstrainSelectedInstOperands,
     /* 153602 */     // GIR_Coverage, 7309,
     /* 153602 */     GIR_EraseRootFromParent_Done,
     /* 153603 */   // Label 2754: @153603
     /* 153603 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(153652), // Rule ID 7310 //
     /* 153608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153611 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153618 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153625 */     // MIs[0] Rn
     /* 153625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153637 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 153640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153650 */     GIR_RootConstrainSelectedInstOperands,
     /* 153651 */     // GIR_Coverage, 7310,
     /* 153651 */     GIR_EraseRootFromParent_Done,
     /* 153652 */   // Label 2755: @153652
     /* 153652 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(153701), // Rule ID 7311 //
     /* 153657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153660 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153667 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153674 */     // MIs[0] Rn
     /* 153674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153686 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 153689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153699 */     GIR_RootConstrainSelectedInstOperands,
     /* 153700 */     // GIR_Coverage, 7311,
     /* 153700 */     GIR_EraseRootFromParent_Done,
     /* 153701 */   // Label 2756: @153701
     /* 153701 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(153750), // Rule ID 7312 //
     /* 153706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153709 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153716 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153723 */     // MIs[0] Rn
     /* 153723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153735 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 153738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153748 */     GIR_RootConstrainSelectedInstOperands,
     /* 153749 */     // GIR_Coverage, 7312,
     /* 153749 */     GIR_EraseRootFromParent_Done,
     /* 153750 */   // Label 2757: @153750
     /* 153750 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(153799), // Rule ID 7313 //
     /* 153755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153758 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153765 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153772 */     // MIs[0] Rn
     /* 153772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153784 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 153787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153797 */     GIR_RootConstrainSelectedInstOperands,
     /* 153798 */     // GIR_Coverage, 7313,
     /* 153798 */     GIR_EraseRootFromParent_Done,
     /* 153799 */   // Label 2758: @153799
     /* 153799 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(153848), // Rule ID 7314 //
     /* 153804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153807 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153814 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153821 */     // MIs[0] Rn
     /* 153821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153833 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 153836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153846 */     GIR_RootConstrainSelectedInstOperands,
     /* 153847 */     // GIR_Coverage, 7314,
     /* 153847 */     GIR_EraseRootFromParent_Done,
     /* 153848 */   // Label 2759: @153848
     /* 153848 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(153897), // Rule ID 7315 //
     /* 153853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153856 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153863 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153870 */     // MIs[0] Rn
     /* 153870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153882 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 153885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153895 */     GIR_RootConstrainSelectedInstOperands,
     /* 153896 */     // GIR_Coverage, 7315,
     /* 153896 */     GIR_EraseRootFromParent_Done,
     /* 153897 */   // Label 2760: @153897
     /* 153897 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(153946), // Rule ID 7316 //
     /* 153902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153905 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153919 */     // MIs[0] Rn
     /* 153919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153931 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 153934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153944 */     GIR_RootConstrainSelectedInstOperands,
     /* 153945 */     // GIR_Coverage, 7316,
     /* 153945 */     GIR_EraseRootFromParent_Done,
     /* 153946 */   // Label 2761: @153946
     /* 153946 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(153995), // Rule ID 7317 //
     /* 153951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153954 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153968 */     // MIs[0] Rn
     /* 153968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153980 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 153983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153993 */     GIR_RootConstrainSelectedInstOperands,
     /* 153994 */     // GIR_Coverage, 7317,
     /* 153994 */     GIR_EraseRootFromParent_Done,
     /* 153995 */   // Label 2762: @153995
     /* 153995 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(154044), // Rule ID 7318 //
     /* 154000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154017 */     // MIs[0] Rn
     /* 154017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154029 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 154032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154042 */     GIR_RootConstrainSelectedInstOperands,
     /* 154043 */     // GIR_Coverage, 7318,
     /* 154043 */     GIR_EraseRootFromParent_Done,
     /* 154044 */   // Label 2763: @154044
     /* 154044 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(154093), // Rule ID 7319 //
     /* 154049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154066 */     // MIs[0] Rn
     /* 154066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154078 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 154081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154091 */     GIR_RootConstrainSelectedInstOperands,
     /* 154092 */     // GIR_Coverage, 7319,
     /* 154092 */     GIR_EraseRootFromParent_Done,
     /* 154093 */   // Label 2764: @154093
     /* 154093 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(154142), // Rule ID 7320 //
     /* 154098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154101 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154108 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154115 */     // MIs[0] Rn
     /* 154115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154127 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 154130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154140 */     GIR_RootConstrainSelectedInstOperands,
     /* 154141 */     // GIR_Coverage, 7320,
     /* 154141 */     GIR_EraseRootFromParent_Done,
     /* 154142 */   // Label 2765: @154142
     /* 154142 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(154191), // Rule ID 7321 //
     /* 154147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154150 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154157 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154164 */     // MIs[0] Rn
     /* 154164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154176 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 154179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154189 */     GIR_RootConstrainSelectedInstOperands,
     /* 154190 */     // GIR_Coverage, 7321,
     /* 154190 */     GIR_EraseRootFromParent_Done,
     /* 154191 */   // Label 2766: @154191
     /* 154191 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(154240), // Rule ID 7322 //
     /* 154196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154199 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154206 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154213 */     // MIs[0] Rn
     /* 154213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154225 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 154228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154238 */     GIR_RootConstrainSelectedInstOperands,
     /* 154239 */     // GIR_Coverage, 7322,
     /* 154239 */     GIR_EraseRootFromParent_Done,
     /* 154240 */   // Label 2767: @154240
     /* 154240 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(154289), // Rule ID 7323 //
     /* 154245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154262 */     // MIs[0] Rn
     /* 154262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154274 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 154277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154287 */     GIR_RootConstrainSelectedInstOperands,
     /* 154288 */     // GIR_Coverage, 7323,
     /* 154288 */     GIR_EraseRootFromParent_Done,
     /* 154289 */   // Label 2768: @154289
     /* 154289 */   GIM_Reject,
     /* 154290 */ // Label 2753: @154290
     /* 154290 */ GIM_Reject,
     /* 154291 */ // Label 2751: @154291
     /* 154291 */ GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(154517),
     /* 154296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 154299 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154306 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(154348), // Rule ID 7304 //
     /* 154311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154314 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154321 */     // MIs[0] Rn
     /* 154321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154333 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 154336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154346 */     GIR_RootConstrainSelectedInstOperands,
     /* 154347 */     // GIR_Coverage, 7304,
     /* 154347 */     GIR_EraseRootFromParent_Done,
     /* 154348 */   // Label 2770: @154348
     /* 154348 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(154390), // Rule ID 7305 //
     /* 154353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154356 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154363 */     // MIs[0] Rn
     /* 154363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154375 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 154378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154388 */     GIR_RootConstrainSelectedInstOperands,
     /* 154389 */     // GIR_Coverage, 7305,
     /* 154389 */     GIR_EraseRootFromParent_Done,
     /* 154390 */   // Label 2771: @154390
     /* 154390 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(154432), // Rule ID 7306 //
     /* 154395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154398 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154405 */     // MIs[0] Rn
     /* 154405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154417 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 154420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154430 */     GIR_RootConstrainSelectedInstOperands,
     /* 154431 */     // GIR_Coverage, 7306,
     /* 154431 */     GIR_EraseRootFromParent_Done,
     /* 154432 */   // Label 2772: @154432
     /* 154432 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(154474), // Rule ID 7307 //
     /* 154437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154440 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154447 */     // MIs[0] Rn
     /* 154447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154459 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 154462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154472 */     GIR_RootConstrainSelectedInstOperands,
     /* 154473 */     // GIR_Coverage, 7307,
     /* 154473 */     GIR_EraseRootFromParent_Done,
     /* 154474 */   // Label 2773: @154474
     /* 154474 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(154516), // Rule ID 7308 //
     /* 154479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154489 */     // MIs[0] Rn
     /* 154489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154501 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 154504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154514 */     GIR_RootConstrainSelectedInstOperands,
     /* 154515 */     // GIR_Coverage, 7308,
     /* 154515 */     GIR_EraseRootFromParent_Done,
     /* 154516 */   // Label 2774: @154516
     /* 154516 */   GIM_Reject,
     /* 154517 */ // Label 2769: @154517
     /* 154517 */ GIM_Reject,
     /* 154518 */ // Label 2752: @154518
     /* 154518 */ GIM_Reject,
     /* 154519 */ // Label 30: @154519
     /* 154519 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2777*/ GIMT_Encode4(155510),
     /* 154530 */ /*GILLT_s32*//*Label 2775*/ GIMT_Encode4(154538),
     /* 154534 */ /*GILLT_s64*//*Label 2776*/ GIMT_Encode4(155283),
     /* 154538 */ // Label 2775: @154538
     /* 154538 */ GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(155282),
     /* 154543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154546 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(154595), // Rule ID 7329 //
     /* 154551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154554 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154561 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154568 */     // MIs[0] Rn
     /* 154568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154580 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 154583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154593 */     GIR_RootConstrainSelectedInstOperands,
     /* 154594 */     // GIR_Coverage, 7329,
     /* 154594 */     GIR_EraseRootFromParent_Done,
     /* 154595 */   // Label 2779: @154595
     /* 154595 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(154644), // Rule ID 7330 //
     /* 154600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154603 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154610 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154617 */     // MIs[0] Rn
     /* 154617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154629 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 154632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154636 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154642 */     GIR_RootConstrainSelectedInstOperands,
     /* 154643 */     // GIR_Coverage, 7330,
     /* 154643 */     GIR_EraseRootFromParent_Done,
     /* 154644 */   // Label 2780: @154644
     /* 154644 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(154693), // Rule ID 7331 //
     /* 154649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154652 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154659 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154666 */     // MIs[0] Rn
     /* 154666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154678 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 154681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154691 */     GIR_RootConstrainSelectedInstOperands,
     /* 154692 */     // GIR_Coverage, 7331,
     /* 154692 */     GIR_EraseRootFromParent_Done,
     /* 154693 */   // Label 2781: @154693
     /* 154693 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(154742), // Rule ID 7332 //
     /* 154698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154701 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154708 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154715 */     // MIs[0] Rn
     /* 154715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154727 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 154730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154740 */     GIR_RootConstrainSelectedInstOperands,
     /* 154741 */     // GIR_Coverage, 7332,
     /* 154741 */     GIR_EraseRootFromParent_Done,
     /* 154742 */   // Label 2782: @154742
     /* 154742 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(154791), // Rule ID 7333 //
     /* 154747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154750 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154757 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154764 */     // MIs[0] Rn
     /* 154764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154776 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 154779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154789 */     GIR_RootConstrainSelectedInstOperands,
     /* 154790 */     // GIR_Coverage, 7333,
     /* 154790 */     GIR_EraseRootFromParent_Done,
     /* 154791 */   // Label 2783: @154791
     /* 154791 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(154840), // Rule ID 7334 //
     /* 154796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154799 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154806 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154813 */     // MIs[0] Rn
     /* 154813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154825 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 154828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154838 */     GIR_RootConstrainSelectedInstOperands,
     /* 154839 */     // GIR_Coverage, 7334,
     /* 154839 */     GIR_EraseRootFromParent_Done,
     /* 154840 */   // Label 2784: @154840
     /* 154840 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(154889), // Rule ID 7335 //
     /* 154845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154848 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154855 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154862 */     // MIs[0] Rn
     /* 154862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154874 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 154877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154887 */     GIR_RootConstrainSelectedInstOperands,
     /* 154888 */     // GIR_Coverage, 7335,
     /* 154888 */     GIR_EraseRootFromParent_Done,
     /* 154889 */   // Label 2785: @154889
     /* 154889 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(154938), // Rule ID 7336 //
     /* 154894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154897 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154904 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154911 */     // MIs[0] Rn
     /* 154911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154923 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 154926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154936 */     GIR_RootConstrainSelectedInstOperands,
     /* 154937 */     // GIR_Coverage, 7336,
     /* 154937 */     GIR_EraseRootFromParent_Done,
     /* 154938 */   // Label 2786: @154938
     /* 154938 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(154987), // Rule ID 7337 //
     /* 154943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154946 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154953 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154960 */     // MIs[0] Rn
     /* 154960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154972 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 154975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154985 */     GIR_RootConstrainSelectedInstOperands,
     /* 154986 */     // GIR_Coverage, 7337,
     /* 154986 */     GIR_EraseRootFromParent_Done,
     /* 154987 */   // Label 2787: @154987
     /* 154987 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(155036), // Rule ID 7338 //
     /* 154992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154995 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155002 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155009 */     // MIs[0] Rn
     /* 155009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155021 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 155024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155034 */     GIR_RootConstrainSelectedInstOperands,
     /* 155035 */     // GIR_Coverage, 7338,
     /* 155035 */     GIR_EraseRootFromParent_Done,
     /* 155036 */   // Label 2788: @155036
     /* 155036 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(155085), // Rule ID 7339 //
     /* 155041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155044 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155058 */     // MIs[0] Rn
     /* 155058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155070 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 155073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155083 */     GIR_RootConstrainSelectedInstOperands,
     /* 155084 */     // GIR_Coverage, 7339,
     /* 155084 */     GIR_EraseRootFromParent_Done,
     /* 155085 */   // Label 2789: @155085
     /* 155085 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(155134), // Rule ID 7340 //
     /* 155090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155093 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155107 */     // MIs[0] Rn
     /* 155107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155119 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 155122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155132 */     GIR_RootConstrainSelectedInstOperands,
     /* 155133 */     // GIR_Coverage, 7340,
     /* 155133 */     GIR_EraseRootFromParent_Done,
     /* 155134 */   // Label 2790: @155134
     /* 155134 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(155183), // Rule ID 7341 //
     /* 155139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155142 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155149 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155156 */     // MIs[0] Rn
     /* 155156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155168 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 155171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155181 */     GIR_RootConstrainSelectedInstOperands,
     /* 155182 */     // GIR_Coverage, 7341,
     /* 155182 */     GIR_EraseRootFromParent_Done,
     /* 155183 */   // Label 2791: @155183
     /* 155183 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(155232), // Rule ID 7342 //
     /* 155188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155191 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155198 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155205 */     // MIs[0] Rn
     /* 155205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155217 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 155220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155230 */     GIR_RootConstrainSelectedInstOperands,
     /* 155231 */     // GIR_Coverage, 7342,
     /* 155231 */     GIR_EraseRootFromParent_Done,
     /* 155232 */   // Label 2792: @155232
     /* 155232 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(155281), // Rule ID 7343 //
     /* 155237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155240 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155247 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155254 */     // MIs[0] Rn
     /* 155254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155266 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 155269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155279 */     GIR_RootConstrainSelectedInstOperands,
     /* 155280 */     // GIR_Coverage, 7343,
     /* 155280 */     GIR_EraseRootFromParent_Done,
     /* 155281 */   // Label 2793: @155281
     /* 155281 */   GIM_Reject,
     /* 155282 */ // Label 2778: @155282
     /* 155282 */ GIM_Reject,
     /* 155283 */ // Label 2776: @155283
     /* 155283 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(155509),
     /* 155288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155291 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 155298 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(155340), // Rule ID 7324 //
     /* 155303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155313 */     // MIs[0] Rn
     /* 155313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155325 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 155328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155338 */     GIR_RootConstrainSelectedInstOperands,
     /* 155339 */     // GIR_Coverage, 7324,
     /* 155339 */     GIR_EraseRootFromParent_Done,
     /* 155340 */   // Label 2795: @155340
     /* 155340 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(155382), // Rule ID 7325 //
     /* 155345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155355 */     // MIs[0] Rn
     /* 155355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155367 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 155370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155380 */     GIR_RootConstrainSelectedInstOperands,
     /* 155381 */     // GIR_Coverage, 7325,
     /* 155381 */     GIR_EraseRootFromParent_Done,
     /* 155382 */   // Label 2796: @155382
     /* 155382 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(155424), // Rule ID 7326 //
     /* 155387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155397 */     // MIs[0] Rn
     /* 155397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155409 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 155412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155422 */     GIR_RootConstrainSelectedInstOperands,
     /* 155423 */     // GIR_Coverage, 7326,
     /* 155423 */     GIR_EraseRootFromParent_Done,
     /* 155424 */   // Label 2797: @155424
     /* 155424 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(155466), // Rule ID 7327 //
     /* 155429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155439 */     // MIs[0] Rn
     /* 155439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155451 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 155454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155464 */     GIR_RootConstrainSelectedInstOperands,
     /* 155465 */     // GIR_Coverage, 7327,
     /* 155465 */     GIR_EraseRootFromParent_Done,
     /* 155466 */   // Label 2798: @155466
     /* 155466 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(155508), // Rule ID 7328 //
     /* 155471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155474 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155481 */     // MIs[0] Rn
     /* 155481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155493 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 155496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155506 */     GIR_RootConstrainSelectedInstOperands,
     /* 155507 */     // GIR_Coverage, 7328,
     /* 155507 */     GIR_EraseRootFromParent_Done,
     /* 155508 */   // Label 2799: @155508
     /* 155508 */   GIM_Reject,
     /* 155509 */ // Label 2794: @155509
     /* 155509 */ GIM_Reject,
     /* 155510 */ // Label 2777: @155510
     /* 155510 */ GIM_Reject,
     /* 155511 */ // Label 31: @155511
     /* 155511 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2803*/ GIMT_Encode4(156215),
     /* 155522 */ /*GILLT_s16*//*Label 2800*/ GIMT_Encode4(155534),
     /* 155526 */ /*GILLT_s32*//*Label 2801*/ GIMT_Encode4(155761),
     /* 155530 */ /*GILLT_s64*//*Label 2802*/ GIMT_Encode4(155988),
     /* 155534 */ // Label 2800: @155534
     /* 155534 */ GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(155760),
     /* 155539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 155542 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155549 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(155591), // Rule ID 2584 //
     /* 155554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155557 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155564 */     // MIs[0] Rn
     /* 155564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155576 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 155579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155589 */     GIR_RootConstrainSelectedInstOperands,
     /* 155590 */     // GIR_Coverage, 2584,
     /* 155590 */     GIR_EraseRootFromParent_Done,
     /* 155591 */   // Label 2805: @155591
     /* 155591 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(155633), // Rule ID 2585 //
     /* 155596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155599 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155606 */     // MIs[0] Rn
     /* 155606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155618 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 155621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155631 */     GIR_RootConstrainSelectedInstOperands,
     /* 155632 */     // GIR_Coverage, 2585,
     /* 155632 */     GIR_EraseRootFromParent_Done,
     /* 155633 */   // Label 2806: @155633
     /* 155633 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(155675), // Rule ID 2586 //
     /* 155638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155641 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155648 */     // MIs[0] Rn
     /* 155648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155660 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 155663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155673 */     GIR_RootConstrainSelectedInstOperands,
     /* 155674 */     // GIR_Coverage, 2586,
     /* 155674 */     GIR_EraseRootFromParent_Done,
     /* 155675 */   // Label 2807: @155675
     /* 155675 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(155717), // Rule ID 2587 //
     /* 155680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155683 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155690 */     // MIs[0] Rn
     /* 155690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155702 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 155705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155715 */     GIR_RootConstrainSelectedInstOperands,
     /* 155716 */     // GIR_Coverage, 2587,
     /* 155716 */     GIR_EraseRootFromParent_Done,
     /* 155717 */   // Label 2808: @155717
     /* 155717 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(155759), // Rule ID 2588 //
     /* 155722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155725 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155732 */     // MIs[0] Rn
     /* 155732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155744 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 155747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155757 */     GIR_RootConstrainSelectedInstOperands,
     /* 155758 */     // GIR_Coverage, 2588,
     /* 155758 */     GIR_EraseRootFromParent_Done,
     /* 155759 */   // Label 2809: @155759
     /* 155759 */   GIM_Reject,
     /* 155760 */ // Label 2804: @155760
     /* 155760 */ GIM_Reject,
     /* 155761 */ // Label 2801: @155761
     /* 155761 */ GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(155987),
     /* 155766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155769 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155776 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(155818), // Rule ID 7419 //
     /* 155781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155791 */     // MIs[0] Rn
     /* 155791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155803 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 155806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155816 */     GIR_RootConstrainSelectedInstOperands,
     /* 155817 */     // GIR_Coverage, 7419,
     /* 155817 */     GIR_EraseRootFromParent_Done,
     /* 155818 */   // Label 2811: @155818
     /* 155818 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(155860), // Rule ID 7420 //
     /* 155823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155833 */     // MIs[0] Rn
     /* 155833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155845 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 155848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155858 */     GIR_RootConstrainSelectedInstOperands,
     /* 155859 */     // GIR_Coverage, 7420,
     /* 155859 */     GIR_EraseRootFromParent_Done,
     /* 155860 */   // Label 2812: @155860
     /* 155860 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(155902), // Rule ID 7421 //
     /* 155865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155875 */     // MIs[0] Rn
     /* 155875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155887 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 155890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155900 */     GIR_RootConstrainSelectedInstOperands,
     /* 155901 */     // GIR_Coverage, 7421,
     /* 155901 */     GIR_EraseRootFromParent_Done,
     /* 155902 */   // Label 2813: @155902
     /* 155902 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(155944), // Rule ID 7422 //
     /* 155907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155917 */     // MIs[0] Rn
     /* 155917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155929 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 155932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155942 */     GIR_RootConstrainSelectedInstOperands,
     /* 155943 */     // GIR_Coverage, 7422,
     /* 155943 */     GIR_EraseRootFromParent_Done,
     /* 155944 */   // Label 2814: @155944
     /* 155944 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(155986), // Rule ID 7423 //
     /* 155949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155952 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155959 */     // MIs[0] Rn
     /* 155959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155971 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 155974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155984 */     GIR_RootConstrainSelectedInstOperands,
     /* 155985 */     // GIR_Coverage, 7423,
     /* 155985 */     GIR_EraseRootFromParent_Done,
     /* 155986 */   // Label 2815: @155986
     /* 155986 */   GIM_Reject,
     /* 155987 */ // Label 2810: @155987
     /* 155987 */ GIM_Reject,
     /* 155988 */ // Label 2802: @155988
     /* 155988 */ GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(156214),
     /* 155993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155996 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156003 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(156045), // Rule ID 7424 //
     /* 156008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156011 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156018 */     // MIs[0] Rn
     /* 156018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156030 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 156033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156043 */     GIR_RootConstrainSelectedInstOperands,
     /* 156044 */     // GIR_Coverage, 7424,
     /* 156044 */     GIR_EraseRootFromParent_Done,
     /* 156045 */   // Label 2817: @156045
     /* 156045 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(156087), // Rule ID 7425 //
     /* 156050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156053 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156060 */     // MIs[0] Rn
     /* 156060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156072 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 156075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156085 */     GIR_RootConstrainSelectedInstOperands,
     /* 156086 */     // GIR_Coverage, 7425,
     /* 156086 */     GIR_EraseRootFromParent_Done,
     /* 156087 */   // Label 2818: @156087
     /* 156087 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(156129), // Rule ID 7426 //
     /* 156092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156102 */     // MIs[0] Rn
     /* 156102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156114 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 156117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156127 */     GIR_RootConstrainSelectedInstOperands,
     /* 156128 */     // GIR_Coverage, 7426,
     /* 156128 */     GIR_EraseRootFromParent_Done,
     /* 156129 */   // Label 2819: @156129
     /* 156129 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(156171), // Rule ID 7427 //
     /* 156134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156144 */     // MIs[0] Rn
     /* 156144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156156 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 156159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156169 */     GIR_RootConstrainSelectedInstOperands,
     /* 156170 */     // GIR_Coverage, 7427,
     /* 156170 */     GIR_EraseRootFromParent_Done,
     /* 156171 */   // Label 2820: @156171
     /* 156171 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(156213), // Rule ID 7428 //
     /* 156176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156186 */     // MIs[0] Rn
     /* 156186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156198 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 156201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156211 */     GIR_RootConstrainSelectedInstOperands,
     /* 156212 */     // GIR_Coverage, 7428,
     /* 156212 */     GIR_EraseRootFromParent_Done,
     /* 156213 */   // Label 2821: @156213
     /* 156213 */   GIM_Reject,
     /* 156214 */ // Label 2816: @156214
     /* 156214 */ GIM_Reject,
     /* 156215 */ // Label 2803: @156215
     /* 156215 */ GIM_Reject,
     /* 156216 */ // Label 32: @156216
     /* 156216 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2825*/ GIMT_Encode4(156920),
     /* 156227 */ /*GILLT_s16*//*Label 2822*/ GIMT_Encode4(156239),
     /* 156231 */ /*GILLT_s32*//*Label 2823*/ GIMT_Encode4(156466),
     /* 156235 */ /*GILLT_s64*//*Label 2824*/ GIMT_Encode4(156693),
     /* 156239 */ // Label 2822: @156239
     /* 156239 */ GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(156465),
     /* 156244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156247 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156254 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(156296), // Rule ID 7429 //
     /* 156259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156269 */     // MIs[0] Rn
     /* 156269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156281 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 156284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156294 */     GIR_RootConstrainSelectedInstOperands,
     /* 156295 */     // GIR_Coverage, 7429,
     /* 156295 */     GIR_EraseRootFromParent_Done,
     /* 156296 */   // Label 2827: @156296
     /* 156296 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(156338), // Rule ID 7430 //
     /* 156301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156311 */     // MIs[0] Rn
     /* 156311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156323 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 156326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156336 */     GIR_RootConstrainSelectedInstOperands,
     /* 156337 */     // GIR_Coverage, 7430,
     /* 156337 */     GIR_EraseRootFromParent_Done,
     /* 156338 */   // Label 2828: @156338
     /* 156338 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(156380), // Rule ID 7431 //
     /* 156343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156346 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156353 */     // MIs[0] Rn
     /* 156353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156365 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 156368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156378 */     GIR_RootConstrainSelectedInstOperands,
     /* 156379 */     // GIR_Coverage, 7431,
     /* 156379 */     GIR_EraseRootFromParent_Done,
     /* 156380 */   // Label 2829: @156380
     /* 156380 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(156422), // Rule ID 7432 //
     /* 156385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156388 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156395 */     // MIs[0] Rn
     /* 156395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156407 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 156410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156420 */     GIR_RootConstrainSelectedInstOperands,
     /* 156421 */     // GIR_Coverage, 7432,
     /* 156421 */     GIR_EraseRootFromParent_Done,
     /* 156422 */   // Label 2830: @156422
     /* 156422 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(156464), // Rule ID 7433 //
     /* 156427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156437 */     // MIs[0] Rn
     /* 156437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156449 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 156452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156462 */     GIR_RootConstrainSelectedInstOperands,
     /* 156463 */     // GIR_Coverage, 7433,
     /* 156463 */     GIR_EraseRootFromParent_Done,
     /* 156464 */   // Label 2831: @156464
     /* 156464 */   GIM_Reject,
     /* 156465 */ // Label 2826: @156465
     /* 156465 */ GIM_Reject,
     /* 156466 */ // Label 2823: @156466
     /* 156466 */ GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(156692),
     /* 156471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156474 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156481 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(156523), // Rule ID 7434 //
     /* 156486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156496 */     // MIs[0] Rn
     /* 156496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156508 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 156511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156521 */     GIR_RootConstrainSelectedInstOperands,
     /* 156522 */     // GIR_Coverage, 7434,
     /* 156522 */     GIR_EraseRootFromParent_Done,
     /* 156523 */   // Label 2833: @156523
     /* 156523 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(156565), // Rule ID 7435 //
     /* 156528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156538 */     // MIs[0] Rn
     /* 156538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156550 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 156553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156563 */     GIR_RootConstrainSelectedInstOperands,
     /* 156564 */     // GIR_Coverage, 7435,
     /* 156564 */     GIR_EraseRootFromParent_Done,
     /* 156565 */   // Label 2834: @156565
     /* 156565 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(156607), // Rule ID 7436 //
     /* 156570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156573 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156580 */     // MIs[0] Rn
     /* 156580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156592 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 156595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156605 */     GIR_RootConstrainSelectedInstOperands,
     /* 156606 */     // GIR_Coverage, 7436,
     /* 156606 */     GIR_EraseRootFromParent_Done,
     /* 156607 */   // Label 2835: @156607
     /* 156607 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(156649), // Rule ID 7437 //
     /* 156612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156622 */     // MIs[0] Rn
     /* 156622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156634 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 156637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156647 */     GIR_RootConstrainSelectedInstOperands,
     /* 156648 */     // GIR_Coverage, 7437,
     /* 156648 */     GIR_EraseRootFromParent_Done,
     /* 156649 */   // Label 2836: @156649
     /* 156649 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(156691), // Rule ID 7438 //
     /* 156654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156657 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156664 */     // MIs[0] Rn
     /* 156664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156676 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 156679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156689 */     GIR_RootConstrainSelectedInstOperands,
     /* 156690 */     // GIR_Coverage, 7438,
     /* 156690 */     GIR_EraseRootFromParent_Done,
     /* 156691 */   // Label 2837: @156691
     /* 156691 */   GIM_Reject,
     /* 156692 */ // Label 2832: @156692
     /* 156692 */ GIM_Reject,
     /* 156693 */ // Label 2824: @156693
     /* 156693 */ GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(156919),
     /* 156698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156701 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156708 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(156750), // Rule ID 7439 //
     /* 156713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156716 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156723 */     // MIs[0] Rn
     /* 156723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156735 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 156738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156748 */     GIR_RootConstrainSelectedInstOperands,
     /* 156749 */     // GIR_Coverage, 7439,
     /* 156749 */     GIR_EraseRootFromParent_Done,
     /* 156750 */   // Label 2839: @156750
     /* 156750 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(156792), // Rule ID 7440 //
     /* 156755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156758 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156765 */     // MIs[0] Rn
     /* 156765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156777 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 156780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156790 */     GIR_RootConstrainSelectedInstOperands,
     /* 156791 */     // GIR_Coverage, 7440,
     /* 156791 */     GIR_EraseRootFromParent_Done,
     /* 156792 */   // Label 2840: @156792
     /* 156792 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(156834), // Rule ID 7441 //
     /* 156797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156800 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156807 */     // MIs[0] Rn
     /* 156807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156819 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 156822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156832 */     GIR_RootConstrainSelectedInstOperands,
     /* 156833 */     // GIR_Coverage, 7441,
     /* 156833 */     GIR_EraseRootFromParent_Done,
     /* 156834 */   // Label 2841: @156834
     /* 156834 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(156876), // Rule ID 7442 //
     /* 156839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156849 */     // MIs[0] Rn
     /* 156849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156861 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 156864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156874 */     GIR_RootConstrainSelectedInstOperands,
     /* 156875 */     // GIR_Coverage, 7442,
     /* 156875 */     GIR_EraseRootFromParent_Done,
     /* 156876 */   // Label 2842: @156876
     /* 156876 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(156918), // Rule ID 7443 //
     /* 156881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156884 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156891 */     // MIs[0] Rn
     /* 156891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156903 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 156906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156916 */     GIR_RootConstrainSelectedInstOperands,
     /* 156917 */     // GIR_Coverage, 7443,
     /* 156917 */     GIR_EraseRootFromParent_Done,
     /* 156918 */   // Label 2843: @156918
     /* 156918 */   GIM_Reject,
     /* 156919 */ // Label 2838: @156919
     /* 156919 */ GIM_Reject,
     /* 156920 */ // Label 2825: @156920
     /* 156920 */ GIM_Reject,
     /* 156921 */ // Label 33: @156921
     /* 156921 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2847*/ GIMT_Encode4(157625),
     /* 156932 */ /*GILLT_s16*//*Label 2844*/ GIMT_Encode4(156944),
     /* 156936 */ /*GILLT_s32*//*Label 2845*/ GIMT_Encode4(157171),
     /* 156940 */ /*GILLT_s64*//*Label 2846*/ GIMT_Encode4(157398),
     /* 156944 */ // Label 2844: @156944
     /* 156944 */ GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(157170),
     /* 156949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156952 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156959 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(157001), // Rule ID 7444 //
     /* 156964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156967 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156974 */     // MIs[0] Rn
     /* 156974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156986 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 156989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156999 */     GIR_RootConstrainSelectedInstOperands,
     /* 157000 */     // GIR_Coverage, 7444,
     /* 157000 */     GIR_EraseRootFromParent_Done,
     /* 157001 */   // Label 2849: @157001
     /* 157001 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(157043), // Rule ID 7445 //
     /* 157006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157009 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157016 */     // MIs[0] Rn
     /* 157016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157028 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 157031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157041 */     GIR_RootConstrainSelectedInstOperands,
     /* 157042 */     // GIR_Coverage, 7445,
     /* 157042 */     GIR_EraseRootFromParent_Done,
     /* 157043 */   // Label 2850: @157043
     /* 157043 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(157085), // Rule ID 7446 //
     /* 157048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157058 */     // MIs[0] Rn
     /* 157058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157070 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 157073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157083 */     GIR_RootConstrainSelectedInstOperands,
     /* 157084 */     // GIR_Coverage, 7446,
     /* 157084 */     GIR_EraseRootFromParent_Done,
     /* 157085 */   // Label 2851: @157085
     /* 157085 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(157127), // Rule ID 7447 //
     /* 157090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157093 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157100 */     // MIs[0] Rn
     /* 157100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157112 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 157115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157125 */     GIR_RootConstrainSelectedInstOperands,
     /* 157126 */     // GIR_Coverage, 7447,
     /* 157126 */     GIR_EraseRootFromParent_Done,
     /* 157127 */   // Label 2852: @157127
     /* 157127 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(157169), // Rule ID 7448 //
     /* 157132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157142 */     // MIs[0] Rn
     /* 157142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157154 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 157157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157167 */     GIR_RootConstrainSelectedInstOperands,
     /* 157168 */     // GIR_Coverage, 7448,
     /* 157168 */     GIR_EraseRootFromParent_Done,
     /* 157169 */   // Label 2853: @157169
     /* 157169 */   GIM_Reject,
     /* 157170 */ // Label 2848: @157170
     /* 157170 */ GIM_Reject,
     /* 157171 */ // Label 2845: @157171
     /* 157171 */ GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(157397),
     /* 157176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157179 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157186 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(157228), // Rule ID 7449 //
     /* 157191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157201 */     // MIs[0] Rn
     /* 157201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157213 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 157216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157226 */     GIR_RootConstrainSelectedInstOperands,
     /* 157227 */     // GIR_Coverage, 7449,
     /* 157227 */     GIR_EraseRootFromParent_Done,
     /* 157228 */   // Label 2855: @157228
     /* 157228 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(157270), // Rule ID 7450 //
     /* 157233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157243 */     // MIs[0] Rn
     /* 157243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157255 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 157258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157268 */     GIR_RootConstrainSelectedInstOperands,
     /* 157269 */     // GIR_Coverage, 7450,
     /* 157269 */     GIR_EraseRootFromParent_Done,
     /* 157270 */   // Label 2856: @157270
     /* 157270 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(157312), // Rule ID 7451 //
     /* 157275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157285 */     // MIs[0] Rn
     /* 157285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157297 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 157300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157310 */     GIR_RootConstrainSelectedInstOperands,
     /* 157311 */     // GIR_Coverage, 7451,
     /* 157311 */     GIR_EraseRootFromParent_Done,
     /* 157312 */   // Label 2857: @157312
     /* 157312 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(157354), // Rule ID 7452 //
     /* 157317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157327 */     // MIs[0] Rn
     /* 157327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157339 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 157342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157352 */     GIR_RootConstrainSelectedInstOperands,
     /* 157353 */     // GIR_Coverage, 7452,
     /* 157353 */     GIR_EraseRootFromParent_Done,
     /* 157354 */   // Label 2858: @157354
     /* 157354 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(157396), // Rule ID 7453 //
     /* 157359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157362 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157369 */     // MIs[0] Rn
     /* 157369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157381 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 157384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157394 */     GIR_RootConstrainSelectedInstOperands,
     /* 157395 */     // GIR_Coverage, 7453,
     /* 157395 */     GIR_EraseRootFromParent_Done,
     /* 157396 */   // Label 2859: @157396
     /* 157396 */   GIM_Reject,
     /* 157397 */ // Label 2854: @157397
     /* 157397 */ GIM_Reject,
     /* 157398 */ // Label 2846: @157398
     /* 157398 */ GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(157624),
     /* 157403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157406 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157413 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(157455), // Rule ID 7454 //
     /* 157418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157421 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157428 */     // MIs[0] Rn
     /* 157428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157440 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 157443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157453 */     GIR_RootConstrainSelectedInstOperands,
     /* 157454 */     // GIR_Coverage, 7454,
     /* 157454 */     GIR_EraseRootFromParent_Done,
     /* 157455 */   // Label 2861: @157455
     /* 157455 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(157497), // Rule ID 7455 //
     /* 157460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157463 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157470 */     // MIs[0] Rn
     /* 157470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157482 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 157485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157495 */     GIR_RootConstrainSelectedInstOperands,
     /* 157496 */     // GIR_Coverage, 7455,
     /* 157496 */     GIR_EraseRootFromParent_Done,
     /* 157497 */   // Label 2862: @157497
     /* 157497 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(157539), // Rule ID 7456 //
     /* 157502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157512 */     // MIs[0] Rn
     /* 157512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157524 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 157527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157537 */     GIR_RootConstrainSelectedInstOperands,
     /* 157538 */     // GIR_Coverage, 7456,
     /* 157538 */     GIR_EraseRootFromParent_Done,
     /* 157539 */   // Label 2863: @157539
     /* 157539 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(157581), // Rule ID 7457 //
     /* 157544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157554 */     // MIs[0] Rn
     /* 157554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157566 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 157569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157579 */     GIR_RootConstrainSelectedInstOperands,
     /* 157580 */     // GIR_Coverage, 7457,
     /* 157580 */     GIR_EraseRootFromParent_Done,
     /* 157581 */   // Label 2864: @157581
     /* 157581 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(157623), // Rule ID 7458 //
     /* 157586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157596 */     // MIs[0] Rn
     /* 157596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157608 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 157611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157621 */     GIR_RootConstrainSelectedInstOperands,
     /* 157622 */     // GIR_Coverage, 7458,
     /* 157622 */     GIR_EraseRootFromParent_Done,
     /* 157623 */   // Label 2865: @157623
     /* 157623 */   GIM_Reject,
     /* 157624 */ // Label 2860: @157624
     /* 157624 */ GIM_Reject,
     /* 157625 */ // Label 2847: @157625
     /* 157625 */ GIM_Reject,
     /* 157626 */ // Label 34: @157626
     /* 157626 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2869*/ GIMT_Encode4(158330),
     /* 157637 */ /*GILLT_s16*//*Label 2866*/ GIMT_Encode4(157649),
     /* 157641 */ /*GILLT_s32*//*Label 2867*/ GIMT_Encode4(157876),
     /* 157645 */ /*GILLT_s64*//*Label 2868*/ GIMT_Encode4(158103),
     /* 157649 */ // Label 2866: @157649
     /* 157649 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(157875),
     /* 157654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157657 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157664 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(157706), // Rule ID 7459 //
     /* 157669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157679 */     // MIs[0] Rn
     /* 157679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157691 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_monotonic>>  =>  (LDFMAXH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXH),
     /* 157694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157704 */     GIR_RootConstrainSelectedInstOperands,
     /* 157705 */     // GIR_Coverage, 7459,
     /* 157705 */     GIR_EraseRootFromParent_Done,
     /* 157706 */   // Label 2871: @157706
     /* 157706 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(157748), // Rule ID 7460 //
     /* 157711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157714 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157721 */     // MIs[0] Rn
     /* 157721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157733 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acquire>>  =>  (LDFMAXAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAH),
     /* 157736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157746 */     GIR_RootConstrainSelectedInstOperands,
     /* 157747 */     // GIR_Coverage, 7460,
     /* 157747 */     GIR_EraseRootFromParent_Done,
     /* 157748 */   // Label 2872: @157748
     /* 157748 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(157790), // Rule ID 7461 //
     /* 157753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157756 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157763 */     // MIs[0] Rn
     /* 157763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157775 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_release>>  =>  (LDFMAXLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLH),
     /* 157778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157788 */     GIR_RootConstrainSelectedInstOperands,
     /* 157789 */     // GIR_Coverage, 7461,
     /* 157789 */     GIR_EraseRootFromParent_Done,
     /* 157790 */   // Label 2873: @157790
     /* 157790 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(157832), // Rule ID 7462 //
     /* 157795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157798 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157805 */     // MIs[0] Rn
     /* 157805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157817 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acq_rel>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 157820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157830 */     GIR_RootConstrainSelectedInstOperands,
     /* 157831 */     // GIR_Coverage, 7462,
     /* 157831 */     GIR_EraseRootFromParent_Done,
     /* 157832 */   // Label 2874: @157832
     /* 157832 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(157874), // Rule ID 7463 //
     /* 157837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157840 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157847 */     // MIs[0] Rn
     /* 157847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157859 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_seq_cst>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 157862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157872 */     GIR_RootConstrainSelectedInstOperands,
     /* 157873 */     // GIR_Coverage, 7463,
     /* 157873 */     GIR_EraseRootFromParent_Done,
     /* 157874 */   // Label 2875: @157874
     /* 157874 */   GIM_Reject,
     /* 157875 */ // Label 2870: @157875
     /* 157875 */ GIM_Reject,
     /* 157876 */ // Label 2867: @157876
     /* 157876 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(158102),
     /* 157881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157884 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157891 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(157933), // Rule ID 7464 //
     /* 157896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157906 */     // MIs[0] Rn
     /* 157906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157918 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_monotonic>>  =>  (LDFMAXS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXS),
     /* 157921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157931 */     GIR_RootConstrainSelectedInstOperands,
     /* 157932 */     // GIR_Coverage, 7464,
     /* 157932 */     GIR_EraseRootFromParent_Done,
     /* 157933 */   // Label 2877: @157933
     /* 157933 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(157975), // Rule ID 7465 //
     /* 157938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157941 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157948 */     // MIs[0] Rn
     /* 157948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157960 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acquire>>  =>  (LDFMAXAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAS),
     /* 157963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157973 */     GIR_RootConstrainSelectedInstOperands,
     /* 157974 */     // GIR_Coverage, 7465,
     /* 157974 */     GIR_EraseRootFromParent_Done,
     /* 157975 */   // Label 2878: @157975
     /* 157975 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(158017), // Rule ID 7466 //
     /* 157980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157983 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157990 */     // MIs[0] Rn
     /* 157990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158002 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_release>>  =>  (LDFMAXLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLS),
     /* 158005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158015 */     GIR_RootConstrainSelectedInstOperands,
     /* 158016 */     // GIR_Coverage, 7466,
     /* 158016 */     GIR_EraseRootFromParent_Done,
     /* 158017 */   // Label 2879: @158017
     /* 158017 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(158059), // Rule ID 7467 //
     /* 158022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158032 */     // MIs[0] Rn
     /* 158032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158044 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acq_rel>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 158047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158057 */     GIR_RootConstrainSelectedInstOperands,
     /* 158058 */     // GIR_Coverage, 7467,
     /* 158058 */     GIR_EraseRootFromParent_Done,
     /* 158059 */   // Label 2880: @158059
     /* 158059 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(158101), // Rule ID 7468 //
     /* 158064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158074 */     // MIs[0] Rn
     /* 158074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158086 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_seq_cst>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 158089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158099 */     GIR_RootConstrainSelectedInstOperands,
     /* 158100 */     // GIR_Coverage, 7468,
     /* 158100 */     GIR_EraseRootFromParent_Done,
     /* 158101 */   // Label 2881: @158101
     /* 158101 */   GIM_Reject,
     /* 158102 */ // Label 2876: @158102
     /* 158102 */ GIM_Reject,
     /* 158103 */ // Label 2868: @158103
     /* 158103 */ GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(158329),
     /* 158108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158111 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158118 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(158160), // Rule ID 7469 //
     /* 158123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158133 */     // MIs[0] Rn
     /* 158133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158145 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_monotonic>>  =>  (LDFMAXD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXD),
     /* 158148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158158 */     GIR_RootConstrainSelectedInstOperands,
     /* 158159 */     // GIR_Coverage, 7469,
     /* 158159 */     GIR_EraseRootFromParent_Done,
     /* 158160 */   // Label 2883: @158160
     /* 158160 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(158202), // Rule ID 7470 //
     /* 158165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158175 */     // MIs[0] Rn
     /* 158175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158187 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acquire>>  =>  (LDFMAXAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAD),
     /* 158190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158200 */     GIR_RootConstrainSelectedInstOperands,
     /* 158201 */     // GIR_Coverage, 7470,
     /* 158201 */     GIR_EraseRootFromParent_Done,
     /* 158202 */   // Label 2884: @158202
     /* 158202 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(158244), // Rule ID 7471 //
     /* 158207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158217 */     // MIs[0] Rn
     /* 158217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158229 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_release>>  =>  (LDFMAXLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLD),
     /* 158232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158242 */     GIR_RootConstrainSelectedInstOperands,
     /* 158243 */     // GIR_Coverage, 7471,
     /* 158243 */     GIR_EraseRootFromParent_Done,
     /* 158244 */   // Label 2885: @158244
     /* 158244 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(158286), // Rule ID 7472 //
     /* 158249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158259 */     // MIs[0] Rn
     /* 158259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158271 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acq_rel>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 158274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158284 */     GIR_RootConstrainSelectedInstOperands,
     /* 158285 */     // GIR_Coverage, 7472,
     /* 158285 */     GIR_EraseRootFromParent_Done,
     /* 158286 */   // Label 2886: @158286
     /* 158286 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(158328), // Rule ID 7473 //
     /* 158291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158301 */     // MIs[0] Rn
     /* 158301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158313 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_seq_cst>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 158316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158326 */     GIR_RootConstrainSelectedInstOperands,
     /* 158327 */     // GIR_Coverage, 7473,
     /* 158327 */     GIR_EraseRootFromParent_Done,
     /* 158328 */   // Label 2887: @158328
     /* 158328 */   GIM_Reject,
     /* 158329 */ // Label 2882: @158329
     /* 158329 */ GIM_Reject,
     /* 158330 */ // Label 2869: @158330
     /* 158330 */ GIM_Reject,
     /* 158331 */ // Label 35: @158331
     /* 158331 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2891*/ GIMT_Encode4(159035),
     /* 158342 */ /*GILLT_s16*//*Label 2888*/ GIMT_Encode4(158354),
     /* 158346 */ /*GILLT_s32*//*Label 2889*/ GIMT_Encode4(158581),
     /* 158350 */ /*GILLT_s64*//*Label 2890*/ GIMT_Encode4(158808),
     /* 158354 */ // Label 2888: @158354
     /* 158354 */ GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(158580),
     /* 158359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158362 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158369 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(158411), // Rule ID 7474 //
     /* 158374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158377 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158384 */     // MIs[0] Rn
     /* 158384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158396 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_monotonic>>  =>  (LDFMINH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINH),
     /* 158399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158409 */     GIR_RootConstrainSelectedInstOperands,
     /* 158410 */     // GIR_Coverage, 7474,
     /* 158410 */     GIR_EraseRootFromParent_Done,
     /* 158411 */   // Label 2893: @158411
     /* 158411 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(158453), // Rule ID 7475 //
     /* 158416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158419 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158426 */     // MIs[0] Rn
     /* 158426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158438 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acquire>>  =>  (LDFMINAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAH),
     /* 158441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158451 */     GIR_RootConstrainSelectedInstOperands,
     /* 158452 */     // GIR_Coverage, 7475,
     /* 158452 */     GIR_EraseRootFromParent_Done,
     /* 158453 */   // Label 2894: @158453
     /* 158453 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(158495), // Rule ID 7476 //
     /* 158458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158461 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158468 */     // MIs[0] Rn
     /* 158468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158480 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_release>>  =>  (LDFMINLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLH),
     /* 158483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158493 */     GIR_RootConstrainSelectedInstOperands,
     /* 158494 */     // GIR_Coverage, 7476,
     /* 158494 */     GIR_EraseRootFromParent_Done,
     /* 158495 */   // Label 2895: @158495
     /* 158495 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(158537), // Rule ID 7477 //
     /* 158500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158503 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158510 */     // MIs[0] Rn
     /* 158510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158522 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acq_rel>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 158525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158535 */     GIR_RootConstrainSelectedInstOperands,
     /* 158536 */     // GIR_Coverage, 7477,
     /* 158536 */     GIR_EraseRootFromParent_Done,
     /* 158537 */   // Label 2896: @158537
     /* 158537 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(158579), // Rule ID 7478 //
     /* 158542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158545 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158552 */     // MIs[0] Rn
     /* 158552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158564 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_seq_cst>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 158567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158577 */     GIR_RootConstrainSelectedInstOperands,
     /* 158578 */     // GIR_Coverage, 7478,
     /* 158578 */     GIR_EraseRootFromParent_Done,
     /* 158579 */   // Label 2897: @158579
     /* 158579 */   GIM_Reject,
     /* 158580 */ // Label 2892: @158580
     /* 158580 */ GIM_Reject,
     /* 158581 */ // Label 2889: @158581
     /* 158581 */ GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(158807),
     /* 158586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158589 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158596 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(158638), // Rule ID 7479 //
     /* 158601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158611 */     // MIs[0] Rn
     /* 158611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158623 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_monotonic>>  =>  (LDFMINS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINS),
     /* 158626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158636 */     GIR_RootConstrainSelectedInstOperands,
     /* 158637 */     // GIR_Coverage, 7479,
     /* 158637 */     GIR_EraseRootFromParent_Done,
     /* 158638 */   // Label 2899: @158638
     /* 158638 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(158680), // Rule ID 7480 //
     /* 158643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158653 */     // MIs[0] Rn
     /* 158653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158665 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acquire>>  =>  (LDFMINAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAS),
     /* 158668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158678 */     GIR_RootConstrainSelectedInstOperands,
     /* 158679 */     // GIR_Coverage, 7480,
     /* 158679 */     GIR_EraseRootFromParent_Done,
     /* 158680 */   // Label 2900: @158680
     /* 158680 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(158722), // Rule ID 7481 //
     /* 158685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158688 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158695 */     // MIs[0] Rn
     /* 158695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158707 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_release>>  =>  (LDFMINLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLS),
     /* 158710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158720 */     GIR_RootConstrainSelectedInstOperands,
     /* 158721 */     // GIR_Coverage, 7481,
     /* 158721 */     GIR_EraseRootFromParent_Done,
     /* 158722 */   // Label 2901: @158722
     /* 158722 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(158764), // Rule ID 7482 //
     /* 158727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158730 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158737 */     // MIs[0] Rn
     /* 158737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158749 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acq_rel>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 158752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158762 */     GIR_RootConstrainSelectedInstOperands,
     /* 158763 */     // GIR_Coverage, 7482,
     /* 158763 */     GIR_EraseRootFromParent_Done,
     /* 158764 */   // Label 2902: @158764
     /* 158764 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(158806), // Rule ID 7483 //
     /* 158769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158772 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158779 */     // MIs[0] Rn
     /* 158779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158791 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_seq_cst>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 158794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158804 */     GIR_RootConstrainSelectedInstOperands,
     /* 158805 */     // GIR_Coverage, 7483,
     /* 158805 */     GIR_EraseRootFromParent_Done,
     /* 158806 */   // Label 2903: @158806
     /* 158806 */   GIM_Reject,
     /* 158807 */ // Label 2898: @158807
     /* 158807 */ GIM_Reject,
     /* 158808 */ // Label 2890: @158808
     /* 158808 */ GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(159034),
     /* 158813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158823 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(158865), // Rule ID 7484 //
     /* 158828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158831 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158838 */     // MIs[0] Rn
     /* 158838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158850 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_monotonic>>  =>  (LDFMIND:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMIND),
     /* 158853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158863 */     GIR_RootConstrainSelectedInstOperands,
     /* 158864 */     // GIR_Coverage, 7484,
     /* 158864 */     GIR_EraseRootFromParent_Done,
     /* 158865 */   // Label 2905: @158865
     /* 158865 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(158907), // Rule ID 7485 //
     /* 158870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158873 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158880 */     // MIs[0] Rn
     /* 158880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158892 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acquire>>  =>  (LDFMINAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAD),
     /* 158895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158905 */     GIR_RootConstrainSelectedInstOperands,
     /* 158906 */     // GIR_Coverage, 7485,
     /* 158906 */     GIR_EraseRootFromParent_Done,
     /* 158907 */   // Label 2906: @158907
     /* 158907 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(158949), // Rule ID 7486 //
     /* 158912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158922 */     // MIs[0] Rn
     /* 158922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158934 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_release>>  =>  (LDFMINLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLD),
     /* 158937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158947 */     GIR_RootConstrainSelectedInstOperands,
     /* 158948 */     // GIR_Coverage, 7486,
     /* 158948 */     GIR_EraseRootFromParent_Done,
     /* 158949 */   // Label 2907: @158949
     /* 158949 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(158991), // Rule ID 7487 //
     /* 158954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158964 */     // MIs[0] Rn
     /* 158964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158976 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acq_rel>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 158979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158989 */     GIR_RootConstrainSelectedInstOperands,
     /* 158990 */     // GIR_Coverage, 7487,
     /* 158990 */     GIR_EraseRootFromParent_Done,
     /* 158991 */   // Label 2908: @158991
     /* 158991 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(159033), // Rule ID 7488 //
     /* 158996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158999 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159006 */     // MIs[0] Rn
     /* 159006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159018 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_seq_cst>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 159021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159031 */     GIR_RootConstrainSelectedInstOperands,
     /* 159032 */     // GIR_Coverage, 7488,
     /* 159032 */     GIR_EraseRootFromParent_Done,
     /* 159033 */   // Label 2909: @159033
     /* 159033 */   GIM_Reject,
     /* 159034 */ // Label 2904: @159034
     /* 159034 */ GIM_Reject,
     /* 159035 */ // Label 2891: @159035
     /* 159035 */ GIM_Reject,
     /* 159036 */ // Label 36: @159036
     /* 159036 */ GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(159063), // Rule ID 7074 //
     /* 159041 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159044 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 159048 */   // MIs[0] Operand 1
     /* 159048 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 159051 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 159051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 159054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 159057 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159061 */   GIR_RootConstrainSelectedInstOperands,
     /* 159062 */   // GIR_Coverage, 7074,
     /* 159062 */   GIR_EraseRootFromParent_Done,
     /* 159063 */ // Label 2910: @159063
     /* 159063 */ GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(159086), // Rule ID 7075 //
     /* 159068 */   // MIs[0] Operand 0
     /* 159068 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 159071 */   // MIs[0] Operand 1
     /* 159071 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 159074 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 159074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 159077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 159080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159084 */   GIR_RootConstrainSelectedInstOperands,
     /* 159085 */   // GIR_Coverage, 7075,
     /* 159085 */   GIR_EraseRootFromParent_Done,
     /* 159086 */ // Label 2911: @159086
     /* 159086 */ GIM_Reject,
     /* 159087 */ // Label 37: @159087
     /* 159087 */ GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(171614),
     /* 159092 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 159095 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(159186), // Rule ID 6553 //
     /* 159100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 159103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 159108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 159111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159126 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159129 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 159134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159138 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 159142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159154 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 159154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 159157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 159161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 159170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 159174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 159179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159184 */     GIR_RootConstrainSelectedInstOperands,
     /* 159185 */     // GIR_Coverage, 6553,
     /* 159185 */     GIR_EraseRootFromParent_Done,
     /* 159186 */   // Label 2913: @159186
     /* 159186 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(159277), // Rule ID 6554 //
     /* 159191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 159194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 159199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 159202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159217 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159220 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 159225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159229 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 159233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159245 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 159245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 159248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 159252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159257 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 159261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 159265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 159270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159275 */     GIR_RootConstrainSelectedInstOperands,
     /* 159276 */     // GIR_Coverage, 6554,
     /* 159276 */     GIR_EraseRootFromParent_Done,
     /* 159277 */   // Label 2914: @159277
     /* 159277 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(159338), // Rule ID 4934 //
     /* 159282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 159287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159314 */     // MIs[1] Operand 2
     /* 159314 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 159325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159327 */     // (intrinsic_wo_chain:{ *:[v4f32] } 768:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 159327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 159330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 159336 */     GIR_RootConstrainSelectedInstOperands,
     /* 159337 */     // GIR_Coverage, 4934,
     /* 159337 */     GIR_EraseRootFromParent_Done,
     /* 159338 */   // Label 2915: @159338
     /* 159338 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(159378), // Rule ID 2651 //
     /* 159343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 159351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159358 */     // MIs[0] pattern
     /* 159358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159366 */     // (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 159369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159371 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159376 */     GIR_RootConstrainSelectedInstOperands,
     /* 159377 */     // GIR_Coverage, 2651,
     /* 159377 */     GIR_EraseRootFromParent_Done,
     /* 159378 */   // Label 2916: @159378
     /* 159378 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(159418), // Rule ID 9995 //
     /* 159383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 159391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159398 */     // MIs[0] pattern
     /* 159398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159406 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 159409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159411 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159416 */     GIR_RootConstrainSelectedInstOperands,
     /* 159417 */     // GIR_Coverage, 9995,
     /* 159417 */     GIR_EraseRootFromParent_Done,
     /* 159418 */   // Label 2917: @159418
     /* 159418 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(159458), // Rule ID 9998 //
     /* 159423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 159431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159438 */     // MIs[0] pattern
     /* 159438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159446 */     // (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 159449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159451 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159456 */     GIR_RootConstrainSelectedInstOperands,
     /* 159457 */     // GIR_Coverage, 9998,
     /* 159457 */     GIR_EraseRootFromParent_Done,
     /* 159458 */   // Label 2918: @159458
     /* 159458 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(159498), // Rule ID 10001 //
     /* 159463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 159471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159478 */     // MIs[0] pattern
     /* 159478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159481 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159486 */     // (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 159489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159491 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159496 */     GIR_RootConstrainSelectedInstOperands,
     /* 159497 */     // GIR_Coverage, 10001,
     /* 159497 */     GIR_EraseRootFromParent_Done,
     /* 159498 */   // Label 2919: @159498
     /* 159498 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(159537), // Rule ID 66 //
     /* 159503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 159506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 159511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159525 */     // (intrinsic_wo_chain:{ *:[i32] } 547:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 159525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 159528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 159535 */     GIR_RootConstrainSelectedInstOperands,
     /* 159536 */     // GIR_Coverage, 66,
     /* 159536 */     GIR_EraseRootFromParent_Done,
     /* 159537 */   // Label 2920: @159537
     /* 159537 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(159573), // Rule ID 346 //
     /* 159542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159564 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 159564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 159567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159571 */     GIR_RootConstrainSelectedInstOperands,
     /* 159572 */     // GIR_Coverage, 346,
     /* 159572 */     GIR_EraseRootFromParent_Done,
     /* 159573 */   // Label 2921: @159573
     /* 159573 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(159609), // Rule ID 347 //
     /* 159578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159600 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 159600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 159603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159607 */     GIR_RootConstrainSelectedInstOperands,
     /* 159608 */     // GIR_Coverage, 347,
     /* 159608 */     GIR_EraseRootFromParent_Done,
     /* 159609 */   // Label 2922: @159609
     /* 159609 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(159645), // Rule ID 348 //
     /* 159614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159636 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 159636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 159639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159643 */     GIR_RootConstrainSelectedInstOperands,
     /* 159644 */     // GIR_Coverage, 348,
     /* 159644 */     GIR_EraseRootFromParent_Done,
     /* 159645 */   // Label 2923: @159645
     /* 159645 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(159681), // Rule ID 349 //
     /* 159650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159672 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 159672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 159675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159679 */     GIR_RootConstrainSelectedInstOperands,
     /* 159680 */     // GIR_Coverage, 349,
     /* 159680 */     GIR_EraseRootFromParent_Done,
     /* 159681 */   // Label 2924: @159681
     /* 159681 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(159717), // Rule ID 350 //
     /* 159686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159708 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 159708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 159711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159715 */     GIR_RootConstrainSelectedInstOperands,
     /* 159716 */     // GIR_Coverage, 350,
     /* 159716 */     GIR_EraseRootFromParent_Done,
     /* 159717 */   // Label 2925: @159717
     /* 159717 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(159753), // Rule ID 351 //
     /* 159722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159744 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 159744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 159747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159751 */     GIR_RootConstrainSelectedInstOperands,
     /* 159752 */     // GIR_Coverage, 351,
     /* 159752 */     GIR_EraseRootFromParent_Done,
     /* 159753 */   // Label 2926: @159753
     /* 159753 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(159789), // Rule ID 352 //
     /* 159758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159780 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 159780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 159783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159787 */     GIR_RootConstrainSelectedInstOperands,
     /* 159788 */     // GIR_Coverage, 352,
     /* 159788 */     GIR_EraseRootFromParent_Done,
     /* 159789 */   // Label 2927: @159789
     /* 159789 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(159825), // Rule ID 353 //
     /* 159794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159816 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 159816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 159819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159823 */     GIR_RootConstrainSelectedInstOperands,
     /* 159824 */     // GIR_Coverage, 353,
     /* 159824 */     GIR_EraseRootFromParent_Done,
     /* 159825 */   // Label 2928: @159825
     /* 159825 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(159861), // Rule ID 354 //
     /* 159830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159852 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 159852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 159855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159859 */     GIR_RootConstrainSelectedInstOperands,
     /* 159860 */     // GIR_Coverage, 354,
     /* 159860 */     GIR_EraseRootFromParent_Done,
     /* 159861 */   // Label 2929: @159861
     /* 159861 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(159897), // Rule ID 355 //
     /* 159866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159888 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 159888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 159891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159895 */     GIR_RootConstrainSelectedInstOperands,
     /* 159896 */     // GIR_Coverage, 355,
     /* 159896 */     GIR_EraseRootFromParent_Done,
     /* 159897 */   // Label 2930: @159897
     /* 159897 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(159933), // Rule ID 356 //
     /* 159902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159924 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 159924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 159927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159931 */     GIR_RootConstrainSelectedInstOperands,
     /* 159932 */     // GIR_Coverage, 356,
     /* 159932 */     GIR_EraseRootFromParent_Done,
     /* 159933 */   // Label 2931: @159933
     /* 159933 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(159969), // Rule ID 357 //
     /* 159938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159960 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 159960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 159963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159967 */     GIR_RootConstrainSelectedInstOperands,
     /* 159968 */     // GIR_Coverage, 357,
     /* 159968 */     GIR_EraseRootFromParent_Done,
     /* 159969 */   // Label 2932: @159969
     /* 159969 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(160005), // Rule ID 358 //
     /* 159974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 159982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159996 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 159996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 159999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160003 */     GIR_RootConstrainSelectedInstOperands,
     /* 160004 */     // GIR_Coverage, 358,
     /* 160004 */     GIR_EraseRootFromParent_Done,
     /* 160005 */   // Label 2933: @160005
     /* 160005 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(160041), // Rule ID 359 //
     /* 160010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160032 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 160035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160039 */     GIR_RootConstrainSelectedInstOperands,
     /* 160040 */     // GIR_Coverage, 359,
     /* 160040 */     GIR_EraseRootFromParent_Done,
     /* 160041 */   // Label 2934: @160041
     /* 160041 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(160077), // Rule ID 360 //
     /* 160046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160068 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 160071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160075 */     GIR_RootConstrainSelectedInstOperands,
     /* 160076 */     // GIR_Coverage, 360,
     /* 160076 */     GIR_EraseRootFromParent_Done,
     /* 160077 */   // Label 2935: @160077
     /* 160077 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(160113), // Rule ID 361 //
     /* 160082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160104 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 160107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160111 */     GIR_RootConstrainSelectedInstOperands,
     /* 160112 */     // GIR_Coverage, 361,
     /* 160112 */     GIR_EraseRootFromParent_Done,
     /* 160113 */   // Label 2936: @160113
     /* 160113 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(160149), // Rule ID 362 //
     /* 160118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160140 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 160143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160147 */     GIR_RootConstrainSelectedInstOperands,
     /* 160148 */     // GIR_Coverage, 362,
     /* 160148 */     GIR_EraseRootFromParent_Done,
     /* 160149 */   // Label 2937: @160149
     /* 160149 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(160185), // Rule ID 363 //
     /* 160154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160176 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 160179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160183 */     GIR_RootConstrainSelectedInstOperands,
     /* 160184 */     // GIR_Coverage, 363,
     /* 160184 */     GIR_EraseRootFromParent_Done,
     /* 160185 */   // Label 2938: @160185
     /* 160185 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(160221), // Rule ID 364 //
     /* 160190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160212 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 160215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160219 */     GIR_RootConstrainSelectedInstOperands,
     /* 160220 */     // GIR_Coverage, 364,
     /* 160220 */     GIR_EraseRootFromParent_Done,
     /* 160221 */   // Label 2939: @160221
     /* 160221 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(160257), // Rule ID 365 //
     /* 160226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160248 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 160251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160255 */     GIR_RootConstrainSelectedInstOperands,
     /* 160256 */     // GIR_Coverage, 365,
     /* 160256 */     GIR_EraseRootFromParent_Done,
     /* 160257 */   // Label 2940: @160257
     /* 160257 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(160293), // Rule ID 366 //
     /* 160262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160284 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 160287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160291 */     GIR_RootConstrainSelectedInstOperands,
     /* 160292 */     // GIR_Coverage, 366,
     /* 160292 */     GIR_EraseRootFromParent_Done,
     /* 160293 */   // Label 2941: @160293
     /* 160293 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(160329), // Rule ID 367 //
     /* 160298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160320 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 160323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160327 */     GIR_RootConstrainSelectedInstOperands,
     /* 160328 */     // GIR_Coverage, 367,
     /* 160328 */     GIR_EraseRootFromParent_Done,
     /* 160329 */   // Label 2942: @160329
     /* 160329 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(160365), // Rule ID 368 //
     /* 160334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160356 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 160359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160363 */     GIR_RootConstrainSelectedInstOperands,
     /* 160364 */     // GIR_Coverage, 368,
     /* 160364 */     GIR_EraseRootFromParent_Done,
     /* 160365 */   // Label 2943: @160365
     /* 160365 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(160401), // Rule ID 369 //
     /* 160370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160392 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 160395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160399 */     GIR_RootConstrainSelectedInstOperands,
     /* 160400 */     // GIR_Coverage, 369,
     /* 160400 */     GIR_EraseRootFromParent_Done,
     /* 160401 */   // Label 2944: @160401
     /* 160401 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(160437), // Rule ID 370 //
     /* 160406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160428 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 160431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160435 */     GIR_RootConstrainSelectedInstOperands,
     /* 160436 */     // GIR_Coverage, 370,
     /* 160436 */     GIR_EraseRootFromParent_Done,
     /* 160437 */   // Label 2945: @160437
     /* 160437 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(160473), // Rule ID 371 //
     /* 160442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160464 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 160467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160471 */     GIR_RootConstrainSelectedInstOperands,
     /* 160472 */     // GIR_Coverage, 371,
     /* 160472 */     GIR_EraseRootFromParent_Done,
     /* 160473 */   // Label 2946: @160473
     /* 160473 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(160509), // Rule ID 372 //
     /* 160478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160500 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 160503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160507 */     GIR_RootConstrainSelectedInstOperands,
     /* 160508 */     // GIR_Coverage, 372,
     /* 160508 */     GIR_EraseRootFromParent_Done,
     /* 160509 */   // Label 2947: @160509
     /* 160509 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(160545), // Rule ID 373 //
     /* 160514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160536 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 160539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160543 */     GIR_RootConstrainSelectedInstOperands,
     /* 160544 */     // GIR_Coverage, 373,
     /* 160544 */     GIR_EraseRootFromParent_Done,
     /* 160545 */   // Label 2948: @160545
     /* 160545 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(160581), // Rule ID 374 //
     /* 160550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160572 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 160575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160579 */     GIR_RootConstrainSelectedInstOperands,
     /* 160580 */     // GIR_Coverage, 374,
     /* 160580 */     GIR_EraseRootFromParent_Done,
     /* 160581 */   // Label 2949: @160581
     /* 160581 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(160617), // Rule ID 375 //
     /* 160586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160608 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 160611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160615 */     GIR_RootConstrainSelectedInstOperands,
     /* 160616 */     // GIR_Coverage, 375,
     /* 160616 */     GIR_EraseRootFromParent_Done,
     /* 160617 */   // Label 2950: @160617
     /* 160617 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(160653), // Rule ID 376 //
     /* 160622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160644 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 160647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160651 */     GIR_RootConstrainSelectedInstOperands,
     /* 160652 */     // GIR_Coverage, 376,
     /* 160652 */     GIR_EraseRootFromParent_Done,
     /* 160653 */   // Label 2951: @160653
     /* 160653 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(160689), // Rule ID 377 //
     /* 160658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160680 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 160683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160687 */     GIR_RootConstrainSelectedInstOperands,
     /* 160688 */     // GIR_Coverage, 377,
     /* 160688 */     GIR_EraseRootFromParent_Done,
     /* 160689 */   // Label 2952: @160689
     /* 160689 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(160725), // Rule ID 378 //
     /* 160694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160716 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 160719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160723 */     GIR_RootConstrainSelectedInstOperands,
     /* 160724 */     // GIR_Coverage, 378,
     /* 160724 */     GIR_EraseRootFromParent_Done,
     /* 160725 */   // Label 2953: @160725
     /* 160725 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(160761), // Rule ID 379 //
     /* 160730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160752 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 160755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160759 */     GIR_RootConstrainSelectedInstOperands,
     /* 160760 */     // GIR_Coverage, 379,
     /* 160760 */     GIR_EraseRootFromParent_Done,
     /* 160761 */   // Label 2954: @160761
     /* 160761 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(160797), // Rule ID 380 //
     /* 160766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160788 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 160791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160795 */     GIR_RootConstrainSelectedInstOperands,
     /* 160796 */     // GIR_Coverage, 380,
     /* 160796 */     GIR_EraseRootFromParent_Done,
     /* 160797 */   // Label 2955: @160797
     /* 160797 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(160833), // Rule ID 381 //
     /* 160802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160824 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 160827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160831 */     GIR_RootConstrainSelectedInstOperands,
     /* 160832 */     // GIR_Coverage, 381,
     /* 160832 */     GIR_EraseRootFromParent_Done,
     /* 160833 */   // Label 2956: @160833
     /* 160833 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(160869), // Rule ID 382 //
     /* 160838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160860 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 160863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160867 */     GIR_RootConstrainSelectedInstOperands,
     /* 160868 */     // GIR_Coverage, 382,
     /* 160868 */     GIR_EraseRootFromParent_Done,
     /* 160869 */   // Label 2957: @160869
     /* 160869 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(160905), // Rule ID 383 //
     /* 160874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160896 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 160899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160903 */     GIR_RootConstrainSelectedInstOperands,
     /* 160904 */     // GIR_Coverage, 383,
     /* 160904 */     GIR_EraseRootFromParent_Done,
     /* 160905 */   // Label 2958: @160905
     /* 160905 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(160941), // Rule ID 384 //
     /* 160910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160932 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 160935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160939 */     GIR_RootConstrainSelectedInstOperands,
     /* 160940 */     // GIR_Coverage, 384,
     /* 160940 */     GIR_EraseRootFromParent_Done,
     /* 160941 */   // Label 2959: @160941
     /* 160941 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(160977), // Rule ID 385 //
     /* 160946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160968 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 160971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160975 */     GIR_RootConstrainSelectedInstOperands,
     /* 160976 */     // GIR_Coverage, 385,
     /* 160976 */     GIR_EraseRootFromParent_Done,
     /* 160977 */   // Label 2960: @160977
     /* 160977 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(161013), // Rule ID 386 //
     /* 160982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161004 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 161007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161011 */     GIR_RootConstrainSelectedInstOperands,
     /* 161012 */     // GIR_Coverage, 386,
     /* 161012 */     GIR_EraseRootFromParent_Done,
     /* 161013 */   // Label 2961: @161013
     /* 161013 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(161049), // Rule ID 387 //
     /* 161018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 161026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161040 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 161043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161047 */     GIR_RootConstrainSelectedInstOperands,
     /* 161048 */     // GIR_Coverage, 387,
     /* 161048 */     GIR_EraseRootFromParent_Done,
     /* 161049 */   // Label 2962: @161049
     /* 161049 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(161085), // Rule ID 388 //
     /* 161054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161076 */     // (intrinsic_wo_chain:{ *:[i32] } 591:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 161079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161083 */     GIR_RootConstrainSelectedInstOperands,
     /* 161084 */     // GIR_Coverage, 388,
     /* 161084 */     GIR_EraseRootFromParent_Done,
     /* 161085 */   // Label 2963: @161085
     /* 161085 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(161121), // Rule ID 389 //
     /* 161090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161112 */     // (intrinsic_wo_chain:{ *:[i64] } 591:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 161115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161119 */     GIR_RootConstrainSelectedInstOperands,
     /* 161120 */     // GIR_Coverage, 389,
     /* 161120 */     GIR_EraseRootFromParent_Done,
     /* 161121 */   // Label 2964: @161121
     /* 161121 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(161157), // Rule ID 390 //
     /* 161126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161148 */     // (intrinsic_wo_chain:{ *:[i32] } 591:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 161151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161155 */     GIR_RootConstrainSelectedInstOperands,
     /* 161156 */     // GIR_Coverage, 390,
     /* 161156 */     GIR_EraseRootFromParent_Done,
     /* 161157 */   // Label 2965: @161157
     /* 161157 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(161193), // Rule ID 391 //
     /* 161162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161184 */     // (intrinsic_wo_chain:{ *:[i64] } 591:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 161187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161191 */     GIR_RootConstrainSelectedInstOperands,
     /* 161192 */     // GIR_Coverage, 391,
     /* 161192 */     GIR_EraseRootFromParent_Done,
     /* 161193 */   // Label 2966: @161193
     /* 161193 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(161229), // Rule ID 392 //
     /* 161198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161220 */     // (intrinsic_wo_chain:{ *:[i32] } 591:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 161223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161227 */     GIR_RootConstrainSelectedInstOperands,
     /* 161228 */     // GIR_Coverage, 392,
     /* 161228 */     GIR_EraseRootFromParent_Done,
     /* 161229 */   // Label 2967: @161229
     /* 161229 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(161265), // Rule ID 393 //
     /* 161234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161256 */     // (intrinsic_wo_chain:{ *:[i64] } 591:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 161259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161263 */     GIR_RootConstrainSelectedInstOperands,
     /* 161264 */     // GIR_Coverage, 393,
     /* 161264 */     GIR_EraseRootFromParent_Done,
     /* 161265 */   // Label 2968: @161265
     /* 161265 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(161301), // Rule ID 575 //
     /* 161270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 161278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161292 */     // (intrinsic_wo_chain:{ *:[f32] } 549:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 161295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161299 */     GIR_RootConstrainSelectedInstOperands,
     /* 161300 */     // GIR_Coverage, 575,
     /* 161300 */     GIR_EraseRootFromParent_Done,
     /* 161301 */   // Label 2969: @161301
     /* 161301 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(161337), // Rule ID 576 //
     /* 161306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 161314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161328 */     // (intrinsic_wo_chain:{ *:[f64] } 549:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 161331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161335 */     GIR_RootConstrainSelectedInstOperands,
     /* 161336 */     // GIR_Coverage, 576,
     /* 161336 */     GIR_EraseRootFromParent_Done,
     /* 161337 */   // Label 2970: @161337
     /* 161337 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(161373), // Rule ID 577 //
     /* 161342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 161350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161364 */     // (intrinsic_wo_chain:{ *:[f32] } 551:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 161367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161371 */     GIR_RootConstrainSelectedInstOperands,
     /* 161372 */     // GIR_Coverage, 577,
     /* 161372 */     GIR_EraseRootFromParent_Done,
     /* 161373 */   // Label 2971: @161373
     /* 161373 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(161409), // Rule ID 578 //
     /* 161378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 161386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161400 */     // (intrinsic_wo_chain:{ *:[f64] } 551:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 161403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161407 */     GIR_RootConstrainSelectedInstOperands,
     /* 161408 */     // GIR_Coverage, 578,
     /* 161408 */     GIR_EraseRootFromParent_Done,
     /* 161409 */   // Label 2972: @161409
     /* 161409 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(161445), // Rule ID 579 //
     /* 161414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 161422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161436 */     // (intrinsic_wo_chain:{ *:[f32] } 548:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 161439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161443 */     GIR_RootConstrainSelectedInstOperands,
     /* 161444 */     // GIR_Coverage, 579,
     /* 161444 */     GIR_EraseRootFromParent_Done,
     /* 161445 */   // Label 2973: @161445
     /* 161445 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(161481), // Rule ID 580 //
     /* 161450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 161458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161472 */     // (intrinsic_wo_chain:{ *:[f64] } 548:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 161475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161479 */     GIR_RootConstrainSelectedInstOperands,
     /* 161480 */     // GIR_Coverage, 580,
     /* 161480 */     GIR_EraseRootFromParent_Done,
     /* 161481 */   // Label 2974: @161481
     /* 161481 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(161517), // Rule ID 581 //
     /* 161486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 161494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161508 */     // (intrinsic_wo_chain:{ *:[f32] } 550:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 161511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161515 */     GIR_RootConstrainSelectedInstOperands,
     /* 161516 */     // GIR_Coverage, 581,
     /* 161516 */     GIR_EraseRootFromParent_Done,
     /* 161517 */   // Label 2975: @161517
     /* 161517 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(161553), // Rule ID 582 //
     /* 161522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 161530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161544 */     // (intrinsic_wo_chain:{ *:[f64] } 550:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 161547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161551 */     GIR_RootConstrainSelectedInstOperands,
     /* 161552 */     // GIR_Coverage, 582,
     /* 161552 */     GIR_EraseRootFromParent_Done,
     /* 161553 */   // Label 2976: @161553
     /* 161553 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(161589), // Rule ID 710 //
     /* 161558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 161572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161580 */     // (intrinsic_wo_chain:{ *:[v8i8] } 576:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 161580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 161583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161587 */     GIR_RootConstrainSelectedInstOperands,
     /* 161588 */     // GIR_Coverage, 710,
     /* 161588 */     GIR_EraseRootFromParent_Done,
     /* 161589 */   // Label 2977: @161589
     /* 161589 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(161625), // Rule ID 711 //
     /* 161594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 161605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161616 */     // (intrinsic_wo_chain:{ *:[v16i8] } 576:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 161616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 161619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161623 */     GIR_RootConstrainSelectedInstOperands,
     /* 161624 */     // GIR_Coverage, 711,
     /* 161624 */     GIR_EraseRootFromParent_Done,
     /* 161625 */   // Label 2978: @161625
     /* 161625 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(161661), // Rule ID 712 //
     /* 161630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161652 */     // (intrinsic_wo_chain:{ *:[v4i16] } 576:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 161652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 161655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161659 */     GIR_RootConstrainSelectedInstOperands,
     /* 161660 */     // GIR_Coverage, 712,
     /* 161660 */     GIR_EraseRootFromParent_Done,
     /* 161661 */   // Label 2979: @161661
     /* 161661 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(161697), // Rule ID 713 //
     /* 161666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161688 */     // (intrinsic_wo_chain:{ *:[v8i16] } 576:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 161688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 161691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161695 */     GIR_RootConstrainSelectedInstOperands,
     /* 161696 */     // GIR_Coverage, 713,
     /* 161696 */     GIR_EraseRootFromParent_Done,
     /* 161697 */   // Label 2980: @161697
     /* 161697 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(161733), // Rule ID 714 //
     /* 161702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161724 */     // (intrinsic_wo_chain:{ *:[v2i32] } 576:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 161724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 161727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161731 */     GIR_RootConstrainSelectedInstOperands,
     /* 161732 */     // GIR_Coverage, 714,
     /* 161732 */     GIR_EraseRootFromParent_Done,
     /* 161733 */   // Label 2981: @161733
     /* 161733 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(161769), // Rule ID 715 //
     /* 161738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161760 */     // (intrinsic_wo_chain:{ *:[v4i32] } 576:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 161760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 161763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161767 */     GIR_RootConstrainSelectedInstOperands,
     /* 161768 */     // GIR_Coverage, 715,
     /* 161768 */     GIR_EraseRootFromParent_Done,
     /* 161769 */   // Label 2982: @161769
     /* 161769 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(161805), // Rule ID 796 //
     /* 161774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161796 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 161796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 161799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161803 */     GIR_RootConstrainSelectedInstOperands,
     /* 161804 */     // GIR_Coverage, 796,
     /* 161804 */     GIR_EraseRootFromParent_Done,
     /* 161805 */   // Label 2983: @161805
     /* 161805 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(161841), // Rule ID 797 //
     /* 161810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161832 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 161832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 161835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161839 */     GIR_RootConstrainSelectedInstOperands,
     /* 161840 */     // GIR_Coverage, 797,
     /* 161840 */     GIR_EraseRootFromParent_Done,
     /* 161841 */   // Label 2984: @161841
     /* 161841 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(161877), // Rule ID 798 //
     /* 161846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161868 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 161868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 161871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161875 */     GIR_RootConstrainSelectedInstOperands,
     /* 161876 */     // GIR_Coverage, 798,
     /* 161876 */     GIR_EraseRootFromParent_Done,
     /* 161877 */   // Label 2985: @161877
     /* 161877 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(161913), // Rule ID 799 //
     /* 161882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161904 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 161904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 161907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161911 */     GIR_RootConstrainSelectedInstOperands,
     /* 161912 */     // GIR_Coverage, 799,
     /* 161912 */     GIR_EraseRootFromParent_Done,
     /* 161913 */   // Label 2986: @161913
     /* 161913 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(161949), // Rule ID 800 //
     /* 161918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161940 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 161940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 161943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161947 */     GIR_RootConstrainSelectedInstOperands,
     /* 161948 */     // GIR_Coverage, 800,
     /* 161948 */     GIR_EraseRootFromParent_Done,
     /* 161949 */   // Label 2987: @161949
     /* 161949 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(161985), // Rule ID 801 //
     /* 161954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161976 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 161976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 161979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161983 */     GIR_RootConstrainSelectedInstOperands,
     /* 161984 */     // GIR_Coverage, 801,
     /* 161984 */     GIR_EraseRootFromParent_Done,
     /* 161985 */   // Label 2988: @161985
     /* 161985 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(162021), // Rule ID 802 //
     /* 161990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162012 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 162015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162019 */     GIR_RootConstrainSelectedInstOperands,
     /* 162020 */     // GIR_Coverage, 802,
     /* 162020 */     GIR_EraseRootFromParent_Done,
     /* 162021 */   // Label 2989: @162021
     /* 162021 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(162057), // Rule ID 803 //
     /* 162026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 162034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162048 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 162051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162055 */     GIR_RootConstrainSelectedInstOperands,
     /* 162056 */     // GIR_Coverage, 803,
     /* 162056 */     GIR_EraseRootFromParent_Done,
     /* 162057 */   // Label 2990: @162057
     /* 162057 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(162093), // Rule ID 804 //
     /* 162062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 162070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162084 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 162087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162091 */     GIR_RootConstrainSelectedInstOperands,
     /* 162092 */     // GIR_Coverage, 804,
     /* 162092 */     GIR_EraseRootFromParent_Done,
     /* 162093 */   // Label 2991: @162093
     /* 162093 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(162129), // Rule ID 805 //
     /* 162098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 162106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162120 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 162123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162127 */     GIR_RootConstrainSelectedInstOperands,
     /* 162128 */     // GIR_Coverage, 805,
     /* 162128 */     GIR_EraseRootFromParent_Done,
     /* 162129 */   // Label 2992: @162129
     /* 162129 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(162165), // Rule ID 806 //
     /* 162134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162156 */     // (intrinsic_wo_chain:{ *:[v4i16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 162159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162163 */     GIR_RootConstrainSelectedInstOperands,
     /* 162164 */     // GIR_Coverage, 806,
     /* 162164 */     GIR_EraseRootFromParent_Done,
     /* 162165 */   // Label 2993: @162165
     /* 162165 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(162201), // Rule ID 807 //
     /* 162170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162192 */     // (intrinsic_wo_chain:{ *:[v8i16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 162195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162199 */     GIR_RootConstrainSelectedInstOperands,
     /* 162200 */     // GIR_Coverage, 807,
     /* 162200 */     GIR_EraseRootFromParent_Done,
     /* 162201 */   // Label 2994: @162201
     /* 162201 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(162237), // Rule ID 808 //
     /* 162206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162228 */     // (intrinsic_wo_chain:{ *:[v2i32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 162231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162235 */     GIR_RootConstrainSelectedInstOperands,
     /* 162236 */     // GIR_Coverage, 808,
     /* 162236 */     GIR_EraseRootFromParent_Done,
     /* 162237 */   // Label 2995: @162237
     /* 162237 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(162273), // Rule ID 809 //
     /* 162242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162264 */     // (intrinsic_wo_chain:{ *:[v4i32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 162267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162271 */     GIR_RootConstrainSelectedInstOperands,
     /* 162272 */     // GIR_Coverage, 809,
     /* 162272 */     GIR_EraseRootFromParent_Done,
     /* 162273 */   // Label 2996: @162273
     /* 162273 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(162309), // Rule ID 810 //
     /* 162278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162300 */     // (intrinsic_wo_chain:{ *:[v2i64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 162303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162307 */     GIR_RootConstrainSelectedInstOperands,
     /* 162308 */     // GIR_Coverage, 810,
     /* 162308 */     GIR_EraseRootFromParent_Done,
     /* 162309 */   // Label 2997: @162309
     /* 162309 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(162345), // Rule ID 811 //
     /* 162314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162336 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 162339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162343 */     GIR_RootConstrainSelectedInstOperands,
     /* 162344 */     // GIR_Coverage, 811,
     /* 162344 */     GIR_EraseRootFromParent_Done,
     /* 162345 */   // Label 2998: @162345
     /* 162345 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(162381), // Rule ID 812 //
     /* 162350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162372 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 162375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162379 */     GIR_RootConstrainSelectedInstOperands,
     /* 162380 */     // GIR_Coverage, 812,
     /* 162380 */     GIR_EraseRootFromParent_Done,
     /* 162381 */   // Label 2999: @162381
     /* 162381 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(162417), // Rule ID 813 //
     /* 162386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162408 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 162411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162415 */     GIR_RootConstrainSelectedInstOperands,
     /* 162416 */     // GIR_Coverage, 813,
     /* 162416 */     GIR_EraseRootFromParent_Done,
     /* 162417 */   // Label 3000: @162417
     /* 162417 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(162453), // Rule ID 814 //
     /* 162422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162444 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 162447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162451 */     GIR_RootConstrainSelectedInstOperands,
     /* 162452 */     // GIR_Coverage, 814,
     /* 162452 */     GIR_EraseRootFromParent_Done,
     /* 162453 */   // Label 3001: @162453
     /* 162453 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(162489), // Rule ID 815 //
     /* 162458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162480 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 162483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162487 */     GIR_RootConstrainSelectedInstOperands,
     /* 162488 */     // GIR_Coverage, 815,
     /* 162488 */     GIR_EraseRootFromParent_Done,
     /* 162489 */   // Label 3002: @162489
     /* 162489 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(162525), // Rule ID 816 //
     /* 162494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162516 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 162519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162523 */     GIR_RootConstrainSelectedInstOperands,
     /* 162524 */     // GIR_Coverage, 816,
     /* 162524 */     GIR_EraseRootFromParent_Done,
     /* 162525 */   // Label 3003: @162525
     /* 162525 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(162561), // Rule ID 817 //
     /* 162530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162552 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 162555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162559 */     GIR_RootConstrainSelectedInstOperands,
     /* 162560 */     // GIR_Coverage, 817,
     /* 162560 */     GIR_EraseRootFromParent_Done,
     /* 162561 */   // Label 3004: @162561
     /* 162561 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(162597), // Rule ID 818 //
     /* 162566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162588 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 162591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162595 */     GIR_RootConstrainSelectedInstOperands,
     /* 162596 */     // GIR_Coverage, 818,
     /* 162596 */     GIR_EraseRootFromParent_Done,
     /* 162597 */   // Label 3005: @162597
     /* 162597 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(162633), // Rule ID 819 //
     /* 162602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162624 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 162627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162631 */     GIR_RootConstrainSelectedInstOperands,
     /* 162632 */     // GIR_Coverage, 819,
     /* 162632 */     GIR_EraseRootFromParent_Done,
     /* 162633 */   // Label 3006: @162633
     /* 162633 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(162669), // Rule ID 820 //
     /* 162638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162660 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 162663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162667 */     GIR_RootConstrainSelectedInstOperands,
     /* 162668 */     // GIR_Coverage, 820,
     /* 162668 */     GIR_EraseRootFromParent_Done,
     /* 162669 */   // Label 3007: @162669
     /* 162669 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(162705), // Rule ID 821 //
     /* 162674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162696 */     // (intrinsic_wo_chain:{ *:[v4i16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 162699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162703 */     GIR_RootConstrainSelectedInstOperands,
     /* 162704 */     // GIR_Coverage, 821,
     /* 162704 */     GIR_EraseRootFromParent_Done,
     /* 162705 */   // Label 3008: @162705
     /* 162705 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(162741), // Rule ID 822 //
     /* 162710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162732 */     // (intrinsic_wo_chain:{ *:[v8i16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 162735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162739 */     GIR_RootConstrainSelectedInstOperands,
     /* 162740 */     // GIR_Coverage, 822,
     /* 162740 */     GIR_EraseRootFromParent_Done,
     /* 162741 */   // Label 3009: @162741
     /* 162741 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(162777), // Rule ID 823 //
     /* 162746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162768 */     // (intrinsic_wo_chain:{ *:[v2i32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 162771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162775 */     GIR_RootConstrainSelectedInstOperands,
     /* 162776 */     // GIR_Coverage, 823,
     /* 162776 */     GIR_EraseRootFromParent_Done,
     /* 162777 */   // Label 3010: @162777
     /* 162777 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(162813), // Rule ID 824 //
     /* 162782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162804 */     // (intrinsic_wo_chain:{ *:[v4i32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 162807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162811 */     GIR_RootConstrainSelectedInstOperands,
     /* 162812 */     // GIR_Coverage, 824,
     /* 162812 */     GIR_EraseRootFromParent_Done,
     /* 162813 */   // Label 3011: @162813
     /* 162813 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(162849), // Rule ID 825 //
     /* 162818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162840 */     // (intrinsic_wo_chain:{ *:[v2i64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 162843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162847 */     GIR_RootConstrainSelectedInstOperands,
     /* 162848 */     // GIR_Coverage, 825,
     /* 162848 */     GIR_EraseRootFromParent_Done,
     /* 162849 */   // Label 3012: @162849
     /* 162849 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(162885), // Rule ID 826 //
     /* 162854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162876 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 162879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162883 */     GIR_RootConstrainSelectedInstOperands,
     /* 162884 */     // GIR_Coverage, 826,
     /* 162884 */     GIR_EraseRootFromParent_Done,
     /* 162885 */   // Label 3013: @162885
     /* 162885 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(162921), // Rule ID 827 //
     /* 162890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162912 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 162915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162919 */     GIR_RootConstrainSelectedInstOperands,
     /* 162920 */     // GIR_Coverage, 827,
     /* 162920 */     GIR_EraseRootFromParent_Done,
     /* 162921 */   // Label 3014: @162921
     /* 162921 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(162957), // Rule ID 828 //
     /* 162926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162948 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 162951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162955 */     GIR_RootConstrainSelectedInstOperands,
     /* 162956 */     // GIR_Coverage, 828,
     /* 162956 */     GIR_EraseRootFromParent_Done,
     /* 162957 */   // Label 3015: @162957
     /* 162957 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(162993), // Rule ID 829 //
     /* 162962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162984 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 162987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162991 */     GIR_RootConstrainSelectedInstOperands,
     /* 162992 */     // GIR_Coverage, 829,
     /* 162992 */     GIR_EraseRootFromParent_Done,
     /* 162993 */   // Label 3016: @162993
     /* 162993 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(163029), // Rule ID 830 //
     /* 162998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 163006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163020 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 163023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163027 */     GIR_RootConstrainSelectedInstOperands,
     /* 163028 */     // GIR_Coverage, 830,
     /* 163028 */     GIR_EraseRootFromParent_Done,
     /* 163029 */   // Label 3017: @163029
     /* 163029 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(163065), // Rule ID 831 //
     /* 163034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163056 */     // (intrinsic_wo_chain:{ *:[v4i16] } 591:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 163059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163063 */     GIR_RootConstrainSelectedInstOperands,
     /* 163064 */     // GIR_Coverage, 831,
     /* 163064 */     GIR_EraseRootFromParent_Done,
     /* 163065 */   // Label 3018: @163065
     /* 163065 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(163101), // Rule ID 832 //
     /* 163070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163092 */     // (intrinsic_wo_chain:{ *:[v8i16] } 591:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 163095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163099 */     GIR_RootConstrainSelectedInstOperands,
     /* 163100 */     // GIR_Coverage, 832,
     /* 163100 */     GIR_EraseRootFromParent_Done,
     /* 163101 */   // Label 3019: @163101
     /* 163101 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(163137), // Rule ID 833 //
     /* 163106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163128 */     // (intrinsic_wo_chain:{ *:[v2i32] } 591:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 163131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163135 */     GIR_RootConstrainSelectedInstOperands,
     /* 163136 */     // GIR_Coverage, 833,
     /* 163136 */     GIR_EraseRootFromParent_Done,
     /* 163137 */   // Label 3020: @163137
     /* 163137 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(163173), // Rule ID 834 //
     /* 163142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163164 */     // (intrinsic_wo_chain:{ *:[v4i32] } 591:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 163167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163171 */     GIR_RootConstrainSelectedInstOperands,
     /* 163172 */     // GIR_Coverage, 834,
     /* 163172 */     GIR_EraseRootFromParent_Done,
     /* 163173 */   // Label 3021: @163173
     /* 163173 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(163209), // Rule ID 835 //
     /* 163178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163200 */     // (intrinsic_wo_chain:{ *:[v2i64] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 163203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163207 */     GIR_RootConstrainSelectedInstOperands,
     /* 163208 */     // GIR_Coverage, 835,
     /* 163208 */     GIR_EraseRootFromParent_Done,
     /* 163209 */   // Label 3022: @163209
     /* 163209 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(163245), // Rule ID 836 //
     /* 163214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 163222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163236 */     // (intrinsic_wo_chain:{ *:[v2f32] } 592:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 163236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 163239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163243 */     GIR_RootConstrainSelectedInstOperands,
     /* 163244 */     // GIR_Coverage, 836,
     /* 163244 */     GIR_EraseRootFromParent_Done,
     /* 163245 */   // Label 3023: @163245
     /* 163245 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(163281), // Rule ID 863 //
     /* 163250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163272 */     // (intrinsic_wo_chain:{ *:[v4f16] } 633:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 163272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 163275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163279 */     GIR_RootConstrainSelectedInstOperands,
     /* 163280 */     // GIR_Coverage, 863,
     /* 163280 */     GIR_EraseRootFromParent_Done,
     /* 163281 */   // Label 3024: @163281
     /* 163281 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(163317), // Rule ID 864 //
     /* 163286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163308 */     // (intrinsic_wo_chain:{ *:[v8f16] } 633:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 163308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 163311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163315 */     GIR_RootConstrainSelectedInstOperands,
     /* 163316 */     // GIR_Coverage, 864,
     /* 163316 */     GIR_EraseRootFromParent_Done,
     /* 163317 */   // Label 3025: @163317
     /* 163317 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(163353), // Rule ID 865 //
     /* 163322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163344 */     // (intrinsic_wo_chain:{ *:[v2f32] } 633:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 163347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163351 */     GIR_RootConstrainSelectedInstOperands,
     /* 163352 */     // GIR_Coverage, 865,
     /* 163352 */     GIR_EraseRootFromParent_Done,
     /* 163353 */   // Label 3026: @163353
     /* 163353 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(163389), // Rule ID 866 //
     /* 163358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163380 */     // (intrinsic_wo_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 163383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163387 */     GIR_RootConstrainSelectedInstOperands,
     /* 163388 */     // GIR_Coverage, 866,
     /* 163388 */     GIR_EraseRootFromParent_Done,
     /* 163389 */   // Label 3027: @163389
     /* 163389 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(163425), // Rule ID 867 //
     /* 163394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163416 */     // (intrinsic_wo_chain:{ *:[v2f64] } 633:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 163419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163423 */     GIR_RootConstrainSelectedInstOperands,
     /* 163424 */     // GIR_Coverage, 867,
     /* 163424 */     GIR_EraseRootFromParent_Done,
     /* 163425 */   // Label 3028: @163425
     /* 163425 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(163461), // Rule ID 938 //
     /* 163430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 163438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163452 */     // (intrinsic_wo_chain:{ *:[v2f32] } 637:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 163455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163459 */     GIR_RootConstrainSelectedInstOperands,
     /* 163460 */     // GIR_Coverage, 938,
     /* 163460 */     GIR_EraseRootFromParent_Done,
     /* 163461 */   // Label 3029: @163461
     /* 163461 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(163497), // Rule ID 939 //
     /* 163466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 163474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163488 */     // (intrinsic_wo_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 163491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163495 */     GIR_RootConstrainSelectedInstOperands,
     /* 163496 */     // GIR_Coverage, 939,
     /* 163496 */     GIR_EraseRootFromParent_Done,
     /* 163497 */   // Label 3030: @163497
     /* 163497 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(163533), // Rule ID 940 //
     /* 163502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 163510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163524 */     // (intrinsic_wo_chain:{ *:[v2f64] } 637:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 163527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163531 */     GIR_RootConstrainSelectedInstOperands,
     /* 163532 */     // GIR_Coverage, 940,
     /* 163532 */     GIR_EraseRootFromParent_Done,
     /* 163533 */   // Label 3031: @163533
     /* 163533 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(163569), // Rule ID 941 //
     /* 163538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 163546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163560 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 163563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163567 */     GIR_RootConstrainSelectedInstOperands,
     /* 163568 */     // GIR_Coverage, 941,
     /* 163568 */     GIR_EraseRootFromParent_Done,
     /* 163569 */   // Label 3032: @163569
     /* 163569 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(163605), // Rule ID 942 //
     /* 163574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 163582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163596 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 163599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163603 */     GIR_RootConstrainSelectedInstOperands,
     /* 163604 */     // GIR_Coverage, 942,
     /* 163604 */     GIR_EraseRootFromParent_Done,
     /* 163605 */   // Label 3033: @163605
     /* 163605 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(163641), // Rule ID 943 //
     /* 163610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 163618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163632 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 163635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163639 */     GIR_RootConstrainSelectedInstOperands,
     /* 163640 */     // GIR_Coverage, 943,
     /* 163640 */     GIR_EraseRootFromParent_Done,
     /* 163641 */   // Label 3034: @163641
     /* 163641 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(163677), // Rule ID 944 //
     /* 163646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 163654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163668 */     // (intrinsic_wo_chain:{ *:[v2f32] } 636:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 163671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163675 */     GIR_RootConstrainSelectedInstOperands,
     /* 163676 */     // GIR_Coverage, 944,
     /* 163676 */     GIR_EraseRootFromParent_Done,
     /* 163677 */   // Label 3035: @163677
     /* 163677 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(163713), // Rule ID 945 //
     /* 163682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 163690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163704 */     // (intrinsic_wo_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 163707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163711 */     GIR_RootConstrainSelectedInstOperands,
     /* 163712 */     // GIR_Coverage, 945,
     /* 163712 */     GIR_EraseRootFromParent_Done,
     /* 163713 */   // Label 3036: @163713
     /* 163713 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(163749), // Rule ID 946 //
     /* 163718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 163726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163740 */     // (intrinsic_wo_chain:{ *:[v2f64] } 636:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 163743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163747 */     GIR_RootConstrainSelectedInstOperands,
     /* 163748 */     // GIR_Coverage, 946,
     /* 163748 */     GIR_EraseRootFromParent_Done,
     /* 163749 */   // Label 3037: @163749
     /* 163749 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(163785), // Rule ID 947 //
     /* 163754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 163762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163776 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 163779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163783 */     GIR_RootConstrainSelectedInstOperands,
     /* 163784 */     // GIR_Coverage, 947,
     /* 163784 */     GIR_EraseRootFromParent_Done,
     /* 163785 */   // Label 3038: @163785
     /* 163785 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(163821), // Rule ID 948 //
     /* 163790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 163798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163812 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 163815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163819 */     GIR_RootConstrainSelectedInstOperands,
     /* 163820 */     // GIR_Coverage, 948,
     /* 163820 */     GIR_EraseRootFromParent_Done,
     /* 163821 */   // Label 3039: @163821
     /* 163821 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(163857), // Rule ID 949 //
     /* 163826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 163834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163848 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 163851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163855 */     GIR_RootConstrainSelectedInstOperands,
     /* 163856 */     // GIR_Coverage, 949,
     /* 163856 */     GIR_EraseRootFromParent_Done,
     /* 163857 */   // Label 3040: @163857
     /* 163857 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(163893), // Rule ID 950 //
     /* 163862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163884 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 163884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 163887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163891 */     GIR_RootConstrainSelectedInstOperands,
     /* 163892 */     // GIR_Coverage, 950,
     /* 163892 */     GIR_EraseRootFromParent_Done,
     /* 163893 */   // Label 3041: @163893
     /* 163893 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(163929), // Rule ID 951 //
     /* 163898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163920 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 163920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 163923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163927 */     GIR_RootConstrainSelectedInstOperands,
     /* 163928 */     // GIR_Coverage, 951,
     /* 163928 */     GIR_EraseRootFromParent_Done,
     /* 163929 */   // Label 3042: @163929
     /* 163929 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(163965), // Rule ID 952 //
     /* 163934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163956 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 163959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163963 */     GIR_RootConstrainSelectedInstOperands,
     /* 163964 */     // GIR_Coverage, 952,
     /* 163964 */     GIR_EraseRootFromParent_Done,
     /* 163965 */   // Label 3043: @163965
     /* 163965 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(164001), // Rule ID 953 //
     /* 163970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163992 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 163995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163999 */     GIR_RootConstrainSelectedInstOperands,
     /* 164000 */     // GIR_Coverage, 953,
     /* 164000 */     GIR_EraseRootFromParent_Done,
     /* 164001 */   // Label 3044: @164001
     /* 164001 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(164037), // Rule ID 954 //
     /* 164006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 164014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164028 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 164028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 164031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164035 */     GIR_RootConstrainSelectedInstOperands,
     /* 164036 */     // GIR_Coverage, 954,
     /* 164036 */     GIR_EraseRootFromParent_Done,
     /* 164037 */   // Label 3045: @164037
     /* 164037 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(164073), // Rule ID 1001 //
     /* 164042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164064 */     // (intrinsic_wo_chain:{ *:[v4i16] } 661:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 164064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 164067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164071 */     GIR_RootConstrainSelectedInstOperands,
     /* 164072 */     // GIR_Coverage, 1001,
     /* 164072 */     GIR_EraseRootFromParent_Done,
     /* 164073 */   // Label 3046: @164073
     /* 164073 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(164109), // Rule ID 1003 //
     /* 164078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164100 */     // (intrinsic_wo_chain:{ *:[v8i16] } 661:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 164100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 164103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164107 */     GIR_RootConstrainSelectedInstOperands,
     /* 164108 */     // GIR_Coverage, 1003,
     /* 164108 */     GIR_EraseRootFromParent_Done,
     /* 164109 */   // Label 3047: @164109
     /* 164109 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(164145), // Rule ID 1005 //
     /* 164114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164136 */     // (intrinsic_wo_chain:{ *:[v2i32] } 661:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 164136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 164139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164143 */     GIR_RootConstrainSelectedInstOperands,
     /* 164144 */     // GIR_Coverage, 1005,
     /* 164144 */     GIR_EraseRootFromParent_Done,
     /* 164145 */   // Label 3048: @164145
     /* 164145 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(164181), // Rule ID 1007 //
     /* 164150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164172 */     // (intrinsic_wo_chain:{ *:[v4i32] } 661:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 164172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 164175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164179 */     GIR_RootConstrainSelectedInstOperands,
     /* 164180 */     // GIR_Coverage, 1007,
     /* 164180 */     GIR_EraseRootFromParent_Done,
     /* 164181 */   // Label 3049: @164181
     /* 164181 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(164217), // Rule ID 1009 //
     /* 164186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164208 */     // (intrinsic_wo_chain:{ *:[v1i64] } 661:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 164208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 164211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164215 */     GIR_RootConstrainSelectedInstOperands,
     /* 164216 */     // GIR_Coverage, 1009,
     /* 164216 */     GIR_EraseRootFromParent_Done,
     /* 164217 */   // Label 3050: @164217
     /* 164217 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(164253), // Rule ID 1011 //
     /* 164222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164244 */     // (intrinsic_wo_chain:{ *:[v2i64] } 661:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 164244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 164247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164251 */     GIR_RootConstrainSelectedInstOperands,
     /* 164252 */     // GIR_Coverage, 1011,
     /* 164252 */     GIR_EraseRootFromParent_Done,
     /* 164253 */   // Label 3051: @164253
     /* 164253 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(164289), // Rule ID 1022 //
     /* 164258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164280 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 164280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 164283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164287 */     GIR_RootConstrainSelectedInstOperands,
     /* 164288 */     // GIR_Coverage, 1022,
     /* 164288 */     GIR_EraseRootFromParent_Done,
     /* 164289 */   // Label 3052: @164289
     /* 164289 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(164325), // Rule ID 1023 //
     /* 164294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 164305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164316 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 164316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 164319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164323 */     GIR_RootConstrainSelectedInstOperands,
     /* 164324 */     // GIR_Coverage, 1023,
     /* 164324 */     GIR_EraseRootFromParent_Done,
     /* 164325 */   // Label 3053: @164325
     /* 164325 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(164361), // Rule ID 1024 //
     /* 164330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164352 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 164352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 164355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164359 */     GIR_RootConstrainSelectedInstOperands,
     /* 164360 */     // GIR_Coverage, 1024,
     /* 164360 */     GIR_EraseRootFromParent_Done,
     /* 164361 */   // Label 3054: @164361
     /* 164361 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(164397), // Rule ID 1025 //
     /* 164366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164388 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 164388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 164391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164395 */     GIR_RootConstrainSelectedInstOperands,
     /* 164396 */     // GIR_Coverage, 1025,
     /* 164396 */     GIR_EraseRootFromParent_Done,
     /* 164397 */   // Label 3055: @164397
     /* 164397 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(164433), // Rule ID 1026 //
     /* 164402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164424 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 164424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 164427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164431 */     GIR_RootConstrainSelectedInstOperands,
     /* 164432 */     // GIR_Coverage, 1026,
     /* 164432 */     GIR_EraseRootFromParent_Done,
     /* 164433 */   // Label 3056: @164433
     /* 164433 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(164469), // Rule ID 1027 //
     /* 164438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164460 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 164460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 164463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164467 */     GIR_RootConstrainSelectedInstOperands,
     /* 164468 */     // GIR_Coverage, 1027,
     /* 164468 */     GIR_EraseRootFromParent_Done,
     /* 164469 */   // Label 3057: @164469
     /* 164469 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(164505), // Rule ID 1028 //
     /* 164474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164496 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 164496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 164499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164503 */     GIR_RootConstrainSelectedInstOperands,
     /* 164504 */     // GIR_Coverage, 1028,
     /* 164504 */     GIR_EraseRootFromParent_Done,
     /* 164505 */   // Label 3058: @164505
     /* 164505 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(164541), // Rule ID 1029 //
     /* 164510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164532 */     // (intrinsic_wo_chain:{ *:[v8i8] } 686:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 164532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 164535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164539 */     GIR_RootConstrainSelectedInstOperands,
     /* 164540 */     // GIR_Coverage, 1029,
     /* 164540 */     GIR_EraseRootFromParent_Done,
     /* 164541 */   // Label 3059: @164541
     /* 164541 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(164577), // Rule ID 1030 //
     /* 164546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 164557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164568 */     // (intrinsic_wo_chain:{ *:[v16i8] } 686:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 164568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 164571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164575 */     GIR_RootConstrainSelectedInstOperands,
     /* 164576 */     // GIR_Coverage, 1030,
     /* 164576 */     GIR_EraseRootFromParent_Done,
     /* 164577 */   // Label 3060: @164577
     /* 164577 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(164613), // Rule ID 1031 //
     /* 164582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164604 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 164604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 164607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164611 */     GIR_RootConstrainSelectedInstOperands,
     /* 164612 */     // GIR_Coverage, 1031,
     /* 164612 */     GIR_EraseRootFromParent_Done,
     /* 164613 */   // Label 3061: @164613
     /* 164613 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(164649), // Rule ID 1032 //
     /* 164618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164640 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 164640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 164643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164647 */     GIR_RootConstrainSelectedInstOperands,
     /* 164648 */     // GIR_Coverage, 1032,
     /* 164648 */     GIR_EraseRootFromParent_Done,
     /* 164649 */   // Label 3062: @164649
     /* 164649 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(164685), // Rule ID 1033 //
     /* 164654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164676 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 164676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 164679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164683 */     GIR_RootConstrainSelectedInstOperands,
     /* 164684 */     // GIR_Coverage, 1033,
     /* 164684 */     GIR_EraseRootFromParent_Done,
     /* 164685 */   // Label 3063: @164685
     /* 164685 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(164721), // Rule ID 1034 //
     /* 164690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164712 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 164712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 164715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164719 */     GIR_RootConstrainSelectedInstOperands,
     /* 164720 */     // GIR_Coverage, 1034,
     /* 164720 */     GIR_EraseRootFromParent_Done,
     /* 164721 */   // Label 3064: @164721
     /* 164721 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(164757), // Rule ID 1035 //
     /* 164726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164748 */     // (intrinsic_wo_chain:{ *:[v2i64] } 686:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 164748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 164751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164755 */     GIR_RootConstrainSelectedInstOperands,
     /* 164756 */     // GIR_Coverage, 1035,
     /* 164756 */     GIR_EraseRootFromParent_Done,
     /* 164757 */   // Label 3065: @164757
     /* 164757 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(164793), // Rule ID 1062 //
     /* 164762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164784 */     // (intrinsic_wo_chain:{ *:[v4i16] } 726:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 164784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 164787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164791 */     GIR_RootConstrainSelectedInstOperands,
     /* 164792 */     // GIR_Coverage, 1062,
     /* 164792 */     GIR_EraseRootFromParent_Done,
     /* 164793 */   // Label 3066: @164793
     /* 164793 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(164829), // Rule ID 1064 //
     /* 164798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164820 */     // (intrinsic_wo_chain:{ *:[v8i16] } 726:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 164820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 164823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164827 */     GIR_RootConstrainSelectedInstOperands,
     /* 164828 */     // GIR_Coverage, 1064,
     /* 164828 */     GIR_EraseRootFromParent_Done,
     /* 164829 */   // Label 3067: @164829
     /* 164829 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(164865), // Rule ID 1066 //
     /* 164834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164856 */     // (intrinsic_wo_chain:{ *:[v2i32] } 726:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 164856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 164859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164863 */     GIR_RootConstrainSelectedInstOperands,
     /* 164864 */     // GIR_Coverage, 1066,
     /* 164864 */     GIR_EraseRootFromParent_Done,
     /* 164865 */   // Label 3068: @164865
     /* 164865 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(164901), // Rule ID 1068 //
     /* 164870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164892 */     // (intrinsic_wo_chain:{ *:[v4i32] } 726:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 164892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 164895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164899 */     GIR_RootConstrainSelectedInstOperands,
     /* 164900 */     // GIR_Coverage, 1068,
     /* 164900 */     GIR_EraseRootFromParent_Done,
     /* 164901 */   // Label 3069: @164901
     /* 164901 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(164937), // Rule ID 1070 //
     /* 164906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164928 */     // (intrinsic_wo_chain:{ *:[v1i64] } 726:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 164928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 164931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164935 */     GIR_RootConstrainSelectedInstOperands,
     /* 164936 */     // GIR_Coverage, 1070,
     /* 164936 */     GIR_EraseRootFromParent_Done,
     /* 164937 */   // Label 3070: @164937
     /* 164937 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(164973), // Rule ID 1072 //
     /* 164942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164964 */     // (intrinsic_wo_chain:{ *:[v2i64] } 726:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 164964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 164967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164971 */     GIR_RootConstrainSelectedInstOperands,
     /* 164972 */     // GIR_Coverage, 1072,
     /* 164972 */     GIR_EraseRootFromParent_Done,
     /* 164973 */   // Label 3071: @164973
     /* 164973 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(165009), // Rule ID 1086 //
     /* 164978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 164986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165000 */     // (intrinsic_wo_chain:{ *:[v2i32] } 747:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 165000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 165003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165007 */     GIR_RootConstrainSelectedInstOperands,
     /* 165008 */     // GIR_Coverage, 1086,
     /* 165008 */     GIR_EraseRootFromParent_Done,
     /* 165009 */   // Label 3072: @165009
     /* 165009 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(165045), // Rule ID 1087 //
     /* 165014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 165022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165036 */     // (intrinsic_wo_chain:{ *:[v4i32] } 747:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 165036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 165039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165043 */     GIR_RootConstrainSelectedInstOperands,
     /* 165044 */     // GIR_Coverage, 1087,
     /* 165044 */     GIR_EraseRootFromParent_Done,
     /* 165045 */   // Label 3073: @165045
     /* 165045 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(165081), // Rule ID 1088 //
     /* 165050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 165058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165072 */     // (intrinsic_wo_chain:{ *:[v2i32] } 750:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 165072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 165075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165079 */     GIR_RootConstrainSelectedInstOperands,
     /* 165080 */     // GIR_Coverage, 1088,
     /* 165080 */     GIR_EraseRootFromParent_Done,
     /* 165081 */   // Label 3074: @165081
     /* 165081 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(165117), // Rule ID 1089 //
     /* 165086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 165094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165108 */     // (intrinsic_wo_chain:{ *:[v4i32] } 750:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 165108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 165111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165115 */     GIR_RootConstrainSelectedInstOperands,
     /* 165116 */     // GIR_Coverage, 1089,
     /* 165116 */     GIR_EraseRootFromParent_Done,
     /* 165117 */   // Label 3075: @165117
     /* 165117 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(165153), // Rule ID 1653 //
     /* 165122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 165130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165144 */     // (intrinsic_wo_chain:{ *:[f32] } 787:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 165147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165151 */     GIR_RootConstrainSelectedInstOperands,
     /* 165152 */     // GIR_Coverage, 1653,
     /* 165152 */     GIR_EraseRootFromParent_Done,
     /* 165153 */   // Label 3076: @165153
     /* 165153 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(165189), // Rule ID 1659 //
     /* 165158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165180 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 165180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 165183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165187 */     GIR_RootConstrainSelectedInstOperands,
     /* 165188 */     // GIR_Coverage, 1659,
     /* 165188 */     GIR_EraseRootFromParent_Done,
     /* 165189 */   // Label 3077: @165189
     /* 165189 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(165225), // Rule ID 1660 //
     /* 165194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165216 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 165216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 165219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165223 */     GIR_RootConstrainSelectedInstOperands,
     /* 165224 */     // GIR_Coverage, 1660,
     /* 165224 */     GIR_EraseRootFromParent_Done,
     /* 165225 */   // Label 3078: @165225
     /* 165225 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(165261), // Rule ID 1661 //
     /* 165230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 165238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165252 */     // (intrinsic_wo_chain:{ *:[i64] } 686:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 165252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 165255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165259 */     GIR_RootConstrainSelectedInstOperands,
     /* 165260 */     // GIR_Coverage, 1661,
     /* 165260 */     GIR_EraseRootFromParent_Done,
     /* 165261 */   // Label 3079: @165261
     /* 165261 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(165297), // Rule ID 1662 //
     /* 165266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 165274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165288 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 165288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 165291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165295 */     GIR_RootConstrainSelectedInstOperands,
     /* 165296 */     // GIR_Coverage, 1662,
     /* 165296 */     GIR_EraseRootFromParent_Done,
     /* 165297 */   // Label 3080: @165297
     /* 165297 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(165333), // Rule ID 1663 //
     /* 165302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 165310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165324 */     // (intrinsic_wo_chain:{ *:[f32] } 664:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 165327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165331 */     GIR_RootConstrainSelectedInstOperands,
     /* 165332 */     // GIR_Coverage, 1663,
     /* 165332 */     GIR_EraseRootFromParent_Done,
     /* 165333 */   // Label 3081: @165333
     /* 165333 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(165369), // Rule ID 1664 //
     /* 165338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 165346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165360 */     // (intrinsic_wo_chain:{ *:[f32] } 665:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 165363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165367 */     GIR_RootConstrainSelectedInstOperands,
     /* 165368 */     // GIR_Coverage, 1664,
     /* 165368 */     GIR_EraseRootFromParent_Done,
     /* 165369 */   // Label 3082: @165369
     /* 165369 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(165405), // Rule ID 1670 //
     /* 165374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 165382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165396 */     // (intrinsic_wo_chain:{ *:[f32] } 666:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 165399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165403 */     GIR_RootConstrainSelectedInstOperands,
     /* 165404 */     // GIR_Coverage, 1670,
     /* 165404 */     GIR_EraseRootFromParent_Done,
     /* 165405 */   // Label 3083: @165405
     /* 165405 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(165441), // Rule ID 1943 //
     /* 165410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 165418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165432 */     // (intrinsic_wo_chain:{ *:[f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 165435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165439 */     GIR_RootConstrainSelectedInstOperands,
     /* 165440 */     // GIR_Coverage, 1943,
     /* 165440 */     GIR_EraseRootFromParent_Done,
     /* 165441 */   // Label 3084: @165441
     /* 165441 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(165477), // Rule ID 1945 //
     /* 165446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 165454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165468 */     // (intrinsic_wo_chain:{ *:[f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 165471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165475 */     GIR_RootConstrainSelectedInstOperands,
     /* 165476 */     // GIR_Coverage, 1945,
     /* 165476 */     GIR_EraseRootFromParent_Done,
     /* 165477 */   // Label 3085: @165477
     /* 165477 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(165513), // Rule ID 1947 //
     /* 165482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 165490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165504 */     // (intrinsic_wo_chain:{ *:[f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 165507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165511 */     GIR_RootConstrainSelectedInstOperands,
     /* 165512 */     // GIR_Coverage, 1947,
     /* 165512 */     GIR_EraseRootFromParent_Done,
     /* 165513 */   // Label 3086: @165513
     /* 165513 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(165549), // Rule ID 1949 //
     /* 165518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 165526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165540 */     // (intrinsic_wo_chain:{ *:[f16] } 600:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 165543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165547 */     GIR_RootConstrainSelectedInstOperands,
     /* 165548 */     // GIR_Coverage, 1949,
     /* 165548 */     GIR_EraseRootFromParent_Done,
     /* 165549 */   // Label 3087: @165549
     /* 165549 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(165585), // Rule ID 1951 //
     /* 165554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 165562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165576 */     // (intrinsic_wo_chain:{ *:[f16] } 600:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 165579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165583 */     GIR_RootConstrainSelectedInstOperands,
     /* 165584 */     // GIR_Coverage, 1951,
     /* 165584 */     GIR_EraseRootFromParent_Done,
     /* 165585 */   // Label 3088: @165585
     /* 165585 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(165621), // Rule ID 1953 //
     /* 165590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 165598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165612 */     // (intrinsic_wo_chain:{ *:[f32] } 600:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 165615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165619 */     GIR_RootConstrainSelectedInstOperands,
     /* 165620 */     // GIR_Coverage, 1953,
     /* 165620 */     GIR_EraseRootFromParent_Done,
     /* 165621 */   // Label 3089: @165621
     /* 165621 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(165657), // Rule ID 1955 //
     /* 165626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 165634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165648 */     // (intrinsic_wo_chain:{ *:[f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 165651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165655 */     GIR_RootConstrainSelectedInstOperands,
     /* 165656 */     // GIR_Coverage, 1955,
     /* 165656 */     GIR_EraseRootFromParent_Done,
     /* 165657 */   // Label 3090: @165657
     /* 165657 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(165693), // Rule ID 1957 //
     /* 165662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 165670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165684 */     // (intrinsic_wo_chain:{ *:[f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 165687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165691 */     GIR_RootConstrainSelectedInstOperands,
     /* 165692 */     // GIR_Coverage, 1957,
     /* 165692 */     GIR_EraseRootFromParent_Done,
     /* 165693 */   // Label 3091: @165693
     /* 165693 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(165729), // Rule ID 1959 //
     /* 165698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 165706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165720 */     // (intrinsic_wo_chain:{ *:[f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 165723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165727 */     GIR_RootConstrainSelectedInstOperands,
     /* 165728 */     // GIR_Coverage, 1959,
     /* 165728 */     GIR_EraseRootFromParent_Done,
     /* 165729 */   // Label 3092: @165729
     /* 165729 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(165765), // Rule ID 1961 //
     /* 165734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 165742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165756 */     // (intrinsic_wo_chain:{ *:[f16] } 606:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 165759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165763 */     GIR_RootConstrainSelectedInstOperands,
     /* 165764 */     // GIR_Coverage, 1961,
     /* 165764 */     GIR_EraseRootFromParent_Done,
     /* 165765 */   // Label 3093: @165765
     /* 165765 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(165801), // Rule ID 1963 //
     /* 165770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 165778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165792 */     // (intrinsic_wo_chain:{ *:[f16] } 606:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 165795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165799 */     GIR_RootConstrainSelectedInstOperands,
     /* 165800 */     // GIR_Coverage, 1963,
     /* 165800 */     GIR_EraseRootFromParent_Done,
     /* 165801 */   // Label 3094: @165801
     /* 165801 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(165837), // Rule ID 1965 //
     /* 165806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 165814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165828 */     // (intrinsic_wo_chain:{ *:[f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 165831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165835 */     GIR_RootConstrainSelectedInstOperands,
     /* 165836 */     // GIR_Coverage, 1965,
     /* 165836 */     GIR_EraseRootFromParent_Done,
     /* 165837 */   // Label 3095: @165837
     /* 165837 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(165873), // Rule ID 2305 //
     /* 165842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 165845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 165850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165864 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 165864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 165867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165871 */     GIR_RootConstrainSelectedInstOperands,
     /* 165872 */     // GIR_Coverage, 2305,
     /* 165872 */     GIR_EraseRootFromParent_Done,
     /* 165873 */   // Label 3096: @165873
     /* 165873 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(165909), // Rule ID 2306 //
     /* 165878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 165881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 165886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165900 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 165900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 165903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165907 */     GIR_RootConstrainSelectedInstOperands,
     /* 165908 */     // GIR_Coverage, 2306,
     /* 165908 */     GIR_EraseRootFromParent_Done,
     /* 165909 */   // Label 3097: @165909
     /* 165909 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(165945), // Rule ID 2314 //
     /* 165914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 165917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 165922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165936 */     // (intrinsic_wo_chain:{ *:[i32] } 522:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 165936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 165939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165943 */     GIR_RootConstrainSelectedInstOperands,
     /* 165944 */     // GIR_Coverage, 2314,
     /* 165944 */     GIR_EraseRootFromParent_Done,
     /* 165945 */   // Label 3098: @165945
     /* 165945 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(165981), // Rule ID 2515 //
     /* 165950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165972 */     // (intrinsic_wo_chain:{ *:[v1i64] } 679:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 165972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 165975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165979 */     GIR_RootConstrainSelectedInstOperands,
     /* 165980 */     // GIR_Coverage, 2515,
     /* 165980 */     GIR_EraseRootFromParent_Done,
     /* 165981 */   // Label 3099: @165981
     /* 165981 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(166020), // Rule ID 3548 //
     /* 165986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 165994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 165997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 166000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166008 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 166008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 166011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 166013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 166015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166018 */     GIR_RootConstrainSelectedInstOperands,
     /* 166019 */     // GIR_Coverage, 3548,
     /* 166019 */     GIR_EraseRootFromParent_Done,
     /* 166020 */   // Label 3100: @166020
     /* 166020 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(166059), // Rule ID 3549 //
     /* 166025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 166033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 166036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166047 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 166047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 166050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 166052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 166054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166057 */     GIR_RootConstrainSelectedInstOperands,
     /* 166058 */     // GIR_Coverage, 3549,
     /* 166058 */     GIR_EraseRootFromParent_Done,
     /* 166059 */   // Label 3101: @166059
     /* 166059 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(166098), // Rule ID 3550 //
     /* 166064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 166072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 166075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166086 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 166086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 166089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 166091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 166093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166096 */     GIR_RootConstrainSelectedInstOperands,
     /* 166097 */     // GIR_Coverage, 3550,
     /* 166097 */     GIR_EraseRootFromParent_Done,
     /* 166098 */   // Label 3102: @166098
     /* 166098 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(166137), // Rule ID 3551 //
     /* 166103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 166111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 166114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 166117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166125 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 166125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 166128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 166130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 166132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166135 */     GIR_RootConstrainSelectedInstOperands,
     /* 166136 */     // GIR_Coverage, 3551,
     /* 166136 */     GIR_EraseRootFromParent_Done,
     /* 166137 */   // Label 3103: @166137
     /* 166137 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(166193), // Rule ID 3555 //
     /* 166142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 166153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 166156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166164 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1630:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 166164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 166181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166191 */     GIR_RootConstrainSelectedInstOperands,
     /* 166192 */     // GIR_Coverage, 3555,
     /* 166192 */     GIR_EraseRootFromParent_Done,
     /* 166193 */   // Label 3104: @166193
     /* 166193 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(166249), // Rule ID 3556 //
     /* 166198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 166212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166220 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1630:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 166220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 166237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166247 */     GIR_RootConstrainSelectedInstOperands,
     /* 166248 */     // GIR_Coverage, 3556,
     /* 166248 */     GIR_EraseRootFromParent_Done,
     /* 166249 */   // Label 3105: @166249
     /* 166249 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(166305), // Rule ID 3557 //
     /* 166254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 166268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1630:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 166276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 166293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166303 */     GIR_RootConstrainSelectedInstOperands,
     /* 166304 */     // GIR_Coverage, 3557,
     /* 166304 */     GIR_EraseRootFromParent_Done,
     /* 166305 */   // Label 3106: @166305
     /* 166305 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(166361), // Rule ID 3558 //
     /* 166310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 166321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 166324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1630:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 166332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 166349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166359 */     GIR_RootConstrainSelectedInstOperands,
     /* 166360 */     // GIR_Coverage, 3558,
     /* 166360 */     GIR_EraseRootFromParent_Done,
     /* 166361 */   // Label 3107: @166361
     /* 166361 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(166394), // Rule ID 4009 //
     /* 166366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 166371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166385 */     // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 166385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 166388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166392 */     GIR_RootConstrainSelectedInstOperands,
     /* 166393 */     // GIR_Coverage, 4009,
     /* 166393 */     GIR_EraseRootFromParent_Done,
     /* 166394 */   // Label 3108: @166394
     /* 166394 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(166459), // Rule ID 4010 //
     /* 166399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 166404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166418 */     // (intrinsic_wo_chain:{ *:[i32] } 503:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 166418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 166425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 166434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166441 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 166448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166458 */     // GIR_Coverage, 4010,
     /* 166458 */     GIR_EraseRootFromParent_Done,
     /* 166459 */   // Label 3109: @166459
     /* 166459 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(166492), // Rule ID 4816 //
     /* 166464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 166469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166483 */     // (intrinsic_wo_chain:{ *:[v1f64] } 637:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 166486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166490 */     GIR_RootConstrainSelectedInstOperands,
     /* 166491 */     // GIR_Coverage, 4816,
     /* 166491 */     GIR_EraseRootFromParent_Done,
     /* 166492 */   // Label 3110: @166492
     /* 166492 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(166525), // Rule ID 4817 //
     /* 166497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 166502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166516 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 166519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166523 */     GIR_RootConstrainSelectedInstOperands,
     /* 166524 */     // GIR_Coverage, 4817,
     /* 166524 */     GIR_EraseRootFromParent_Done,
     /* 166525 */   // Label 3111: @166525
     /* 166525 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(166558), // Rule ID 4818 //
     /* 166530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 166535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166549 */     // (intrinsic_wo_chain:{ *:[v1f64] } 636:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 166552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166556 */     GIR_RootConstrainSelectedInstOperands,
     /* 166557 */     // GIR_Coverage, 4818,
     /* 166557 */     GIR_EraseRootFromParent_Done,
     /* 166558 */   // Label 3112: @166558
     /* 166558 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(166591), // Rule ID 4819 //
     /* 166563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 166568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166582 */     // (intrinsic_wo_chain:{ *:[v1f64] } 638:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 166585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166589 */     GIR_RootConstrainSelectedInstOperands,
     /* 166590 */     // GIR_Coverage, 4819,
     /* 166590 */     GIR_EraseRootFromParent_Done,
     /* 166591 */   // Label 3113: @166591
     /* 166591 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(166624), // Rule ID 4933 //
     /* 166596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 166601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166615 */     // (intrinsic_wo_chain:{ *:[v4f32] } 768:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 166615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 166618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166622 */     GIR_RootConstrainSelectedInstOperands,
     /* 166623 */     // GIR_Coverage, 4933,
     /* 166623 */     GIR_EraseRootFromParent_Done,
     /* 166624 */   // Label 3114: @166624
     /* 166624 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(166657), // Rule ID 4943 //
     /* 166629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 166634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166648 */     // (intrinsic_wo_chain:{ *:[v4i16] } 765:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 166648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 166651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166655 */     GIR_RootConstrainSelectedInstOperands,
     /* 166656 */     // GIR_Coverage, 4943,
     /* 166656 */     GIR_EraseRootFromParent_Done,
     /* 166657 */   // Label 3115: @166657
     /* 166657 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(166693), // Rule ID 5285 //
     /* 166662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166684 */     // (intrinsic_wo_chain:{ *:[v1i64] } 686:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 166684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 166687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166691 */     GIR_RootConstrainSelectedInstOperands,
     /* 166692 */     // GIR_Coverage, 5285,
     /* 166692 */     GIR_EraseRootFromParent_Done,
     /* 166693 */   // Label 3116: @166693
     /* 166693 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(166726), // Rule ID 5288 //
     /* 166698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 166703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166717 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 166720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166724 */     GIR_RootConstrainSelectedInstOperands,
     /* 166725 */     // GIR_Coverage, 5288,
     /* 166725 */     GIR_EraseRootFromParent_Done,
     /* 166726 */   // Label 3117: @166726
     /* 166726 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(166759), // Rule ID 5289 //
     /* 166731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 166736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166750 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 166753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166757 */     GIR_RootConstrainSelectedInstOperands,
     /* 166758 */     // GIR_Coverage, 5289,
     /* 166758 */     GIR_EraseRootFromParent_Done,
     /* 166759 */   // Label 3118: @166759
     /* 166759 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(166792), // Rule ID 5290 //
     /* 166764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 166769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166783 */     // (intrinsic_wo_chain:{ *:[v1i64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 166786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166790 */     GIR_RootConstrainSelectedInstOperands,
     /* 166791 */     // GIR_Coverage, 5290,
     /* 166791 */     GIR_EraseRootFromParent_Done,
     /* 166792 */   // Label 3119: @166792
     /* 166792 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(166825), // Rule ID 5291 //
     /* 166797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 166802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166816 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 166819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166823 */     GIR_RootConstrainSelectedInstOperands,
     /* 166824 */     // GIR_Coverage, 5291,
     /* 166824 */     GIR_EraseRootFromParent_Done,
     /* 166825 */   // Label 3120: @166825
     /* 166825 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(166858), // Rule ID 5292 //
     /* 166830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 166835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166849 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 166852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166856 */     GIR_RootConstrainSelectedInstOperands,
     /* 166857 */     // GIR_Coverage, 5292,
     /* 166857 */     GIR_EraseRootFromParent_Done,
     /* 166858 */   // Label 3121: @166858
     /* 166858 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(166891), // Rule ID 5293 //
     /* 166863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 166868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166882 */     // (intrinsic_wo_chain:{ *:[v1i64] } 589:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 166885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166889 */     GIR_RootConstrainSelectedInstOperands,
     /* 166890 */     // GIR_Coverage, 5293,
     /* 166890 */     GIR_EraseRootFromParent_Done,
     /* 166891 */   // Label 3122: @166891
     /* 166891 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(166924), // Rule ID 5294 //
     /* 166896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 166901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166915 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 166918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166922 */     GIR_RootConstrainSelectedInstOperands,
     /* 166923 */     // GIR_Coverage, 5294,
     /* 166923 */     GIR_EraseRootFromParent_Done,
     /* 166924 */   // Label 3123: @166924
     /* 166924 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(166957), // Rule ID 5295 //
     /* 166929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 166934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166948 */     // (intrinsic_wo_chain:{ *:[v1i64] } 591:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 166951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166955 */     GIR_RootConstrainSelectedInstOperands,
     /* 166956 */     // GIR_Coverage, 5295,
     /* 166956 */     GIR_EraseRootFromParent_Done,
     /* 166957 */   // Label 3124: @166957
     /* 166957 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(166990), // Rule ID 5296 //
     /* 166962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 166967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166981 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 166984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166988 */     GIR_RootConstrainSelectedInstOperands,
     /* 166989 */     // GIR_Coverage, 5296,
     /* 166989 */     GIR_EraseRootFromParent_Done,
     /* 166990 */   // Label 3125: @166990
     /* 166990 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(167023), // Rule ID 5297 //
     /* 166995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 167000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167014 */     // (intrinsic_wo_chain:{ *:[v1i64] } 594:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 167017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167021 */     GIR_RootConstrainSelectedInstOperands,
     /* 167022 */     // GIR_Coverage, 5297,
     /* 167022 */     GIR_EraseRootFromParent_Done,
     /* 167023 */   // Label 3126: @167023
     /* 167023 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(167056), // Rule ID 5298 //
     /* 167028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 167033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 167039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167047 */     // (intrinsic_wo_chain:{ *:[f16] } 633:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 167047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 167050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167054 */     GIR_RootConstrainSelectedInstOperands,
     /* 167055 */     // GIR_Coverage, 5298,
     /* 167055 */     GIR_EraseRootFromParent_Done,
     /* 167056 */   // Label 3127: @167056
     /* 167056 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(167089), // Rule ID 5299 //
     /* 167061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 167066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167080 */     // (intrinsic_wo_chain:{ *:[f32] } 633:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 167080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 167083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167087 */     GIR_RootConstrainSelectedInstOperands,
     /* 167088 */     // GIR_Coverage, 5299,
     /* 167088 */     GIR_EraseRootFromParent_Done,
     /* 167089 */   // Label 3128: @167089
     /* 167089 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(167122), // Rule ID 5300 //
     /* 167094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 167099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167113 */     // (intrinsic_wo_chain:{ *:[f64] } 633:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 167113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 167116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167120 */     GIR_RootConstrainSelectedInstOperands,
     /* 167121 */     // GIR_Coverage, 5300,
     /* 167121 */     GIR_EraseRootFromParent_Done,
     /* 167122 */   // Label 3129: @167122
     /* 167122 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(167155), // Rule ID 5301 //
     /* 167127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 167132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167146 */     // (intrinsic_wo_chain:{ *:[v1f64] } 633:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 167149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167153 */     GIR_RootConstrainSelectedInstOperands,
     /* 167154 */     // GIR_Coverage, 5301,
     /* 167154 */     GIR_EraseRootFromParent_Done,
     /* 167155 */   // Label 3130: @167155
     /* 167155 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(167188), // Rule ID 5313 //
     /* 167160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 167165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 167171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167179 */     // (intrinsic_wo_chain:{ *:[f16] } 635:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 167179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 167182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167186 */     GIR_RootConstrainSelectedInstOperands,
     /* 167187 */     // GIR_Coverage, 5313,
     /* 167187 */     GIR_EraseRootFromParent_Done,
     /* 167188 */   // Label 3131: @167188
     /* 167188 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(167221), // Rule ID 5314 //
     /* 167193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 167198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167212 */     // (intrinsic_wo_chain:{ *:[f32] } 635:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 167212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 167215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167219 */     GIR_RootConstrainSelectedInstOperands,
     /* 167220 */     // GIR_Coverage, 5314,
     /* 167220 */     GIR_EraseRootFromParent_Done,
     /* 167221 */   // Label 3132: @167221
     /* 167221 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(167254), // Rule ID 5315 //
     /* 167226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 167231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167245 */     // (intrinsic_wo_chain:{ *:[f64] } 635:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 167245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 167248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167252 */     GIR_RootConstrainSelectedInstOperands,
     /* 167253 */     // GIR_Coverage, 5315,
     /* 167253 */     GIR_EraseRootFromParent_Done,
     /* 167254 */   // Label 3133: @167254
     /* 167254 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(167287), // Rule ID 5316 //
     /* 167259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 167270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167278 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 167278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 167281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167285 */     GIR_RootConstrainSelectedInstOperands,
     /* 167286 */     // GIR_Coverage, 5316,
     /* 167286 */     GIR_EraseRootFromParent_Done,
     /* 167287 */   // Label 3134: @167287
     /* 167287 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(167320), // Rule ID 5317 //
     /* 167292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167311 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 167311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 167314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167318 */     GIR_RootConstrainSelectedInstOperands,
     /* 167319 */     // GIR_Coverage, 5317,
     /* 167319 */     GIR_EraseRootFromParent_Done,
     /* 167320 */   // Label 3135: @167320
     /* 167320 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(167353), // Rule ID 5318 //
     /* 167325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167344 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 167344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 167347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167351 */     GIR_RootConstrainSelectedInstOperands,
     /* 167352 */     // GIR_Coverage, 5318,
     /* 167352 */     GIR_EraseRootFromParent_Done,
     /* 167353 */   // Label 3136: @167353
     /* 167353 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(167386), // Rule ID 5319 //
     /* 167358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167377 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 167380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167384 */     GIR_RootConstrainSelectedInstOperands,
     /* 167385 */     // GIR_Coverage, 5319,
     /* 167385 */     GIR_EraseRootFromParent_Done,
     /* 167386 */   // Label 3137: @167386
     /* 167386 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(167419), // Rule ID 5649 //
     /* 167391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 167396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167410 */     // (intrinsic_wo_chain:{ *:[f32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 167413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167417 */     GIR_RootConstrainSelectedInstOperands,
     /* 167418 */     // GIR_Coverage, 5649,
     /* 167418 */     GIR_EraseRootFromParent_Done,
     /* 167419 */   // Label 3138: @167419
     /* 167419 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(167504), // Rule ID 5650 //
     /* 167424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 167429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167443 */     // (intrinsic_wo_chain:{ *:[f32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 167443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 167450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167455 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 167459 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 167463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167477 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 167484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 167497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167502 */     GIR_RootConstrainSelectedInstOperands,
     /* 167503 */     // GIR_Coverage, 5650,
     /* 167503 */     GIR_EraseRootFromParent_Done,
     /* 167504 */   // Label 3139: @167504
     /* 167504 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(167537), // Rule ID 5651 //
     /* 167509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 167514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167528 */     // (intrinsic_wo_chain:{ *:[f64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 167531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167535 */     GIR_RootConstrainSelectedInstOperands,
     /* 167536 */     // GIR_Coverage, 5651,
     /* 167536 */     GIR_EraseRootFromParent_Done,
     /* 167537 */   // Label 3140: @167537
     /* 167537 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(167570), // Rule ID 5653 //
     /* 167542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 167547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167561 */     // (intrinsic_wo_chain:{ *:[f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 167564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167568 */     GIR_RootConstrainSelectedInstOperands,
     /* 167569 */     // GIR_Coverage, 5653,
     /* 167569 */     GIR_EraseRootFromParent_Done,
     /* 167570 */   // Label 3141: @167570
     /* 167570 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(167603), // Rule ID 5655 //
     /* 167575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 167580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167594 */     // (intrinsic_wo_chain:{ *:[f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 167597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167601 */     GIR_RootConstrainSelectedInstOperands,
     /* 167602 */     // GIR_Coverage, 5655,
     /* 167602 */     GIR_EraseRootFromParent_Done,
     /* 167603 */   // Label 3142: @167603
     /* 167603 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(167636), // Rule ID 5657 //
     /* 167608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167627 */     // (intrinsic_wo_chain:{ *:[f32] } 600:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 167630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167634 */     GIR_RootConstrainSelectedInstOperands,
     /* 167635 */     // GIR_Coverage, 5657,
     /* 167635 */     GIR_EraseRootFromParent_Done,
     /* 167636 */   // Label 3143: @167636
     /* 167636 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(167669), // Rule ID 5659 //
     /* 167641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167660 */     // (intrinsic_wo_chain:{ *:[f64] } 600:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 167663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167667 */     GIR_RootConstrainSelectedInstOperands,
     /* 167668 */     // GIR_Coverage, 5659,
     /* 167668 */     GIR_EraseRootFromParent_Done,
     /* 167669 */   // Label 3144: @167669
     /* 167669 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(167702), // Rule ID 5661 //
     /* 167674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167693 */     // (intrinsic_wo_chain:{ *:[f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 167696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167700 */     GIR_RootConstrainSelectedInstOperands,
     /* 167701 */     // GIR_Coverage, 5661,
     /* 167701 */     GIR_EraseRootFromParent_Done,
     /* 167702 */   // Label 3145: @167702
     /* 167702 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(167735), // Rule ID 5663 //
     /* 167707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167726 */     // (intrinsic_wo_chain:{ *:[f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 167729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167733 */     GIR_RootConstrainSelectedInstOperands,
     /* 167734 */     // GIR_Coverage, 5663,
     /* 167734 */     GIR_EraseRootFromParent_Done,
     /* 167735 */   // Label 3146: @167735
     /* 167735 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(167768), // Rule ID 5665 //
     /* 167740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167759 */     // (intrinsic_wo_chain:{ *:[f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 167762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167766 */     GIR_RootConstrainSelectedInstOperands,
     /* 167767 */     // GIR_Coverage, 5665,
     /* 167767 */     GIR_EraseRootFromParent_Done,
     /* 167768 */   // Label 3147: @167768
     /* 167768 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(167801), // Rule ID 5667 //
     /* 167773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167792 */     // (intrinsic_wo_chain:{ *:[f64] } 606:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 167795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167799 */     GIR_RootConstrainSelectedInstOperands,
     /* 167800 */     // GIR_Coverage, 5667,
     /* 167800 */     GIR_EraseRootFromParent_Done,
     /* 167801 */   // Label 3148: @167801
     /* 167801 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(167834), // Rule ID 13210 //
     /* 167806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 167814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 167821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167825 */     // (intrinsic_wo_chain:{ *:[i8] } 663:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 167825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 167828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167832 */     GIR_RootConstrainSelectedInstOperands,
     /* 167833 */     // GIR_Coverage, 13210,
     /* 167833 */     GIR_EraseRootFromParent_Done,
     /* 167834 */   // Label 3149: @167834
     /* 167834 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(167867), // Rule ID 13212 //
     /* 167839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 167847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 167854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167858 */     // (intrinsic_wo_chain:{ *:[i8] } 663:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 167858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 167861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167865 */     GIR_RootConstrainSelectedInstOperands,
     /* 167866 */     // GIR_Coverage, 13212,
     /* 167866 */     GIR_EraseRootFromParent_Done,
     /* 167867 */   // Label 3150: @167867
     /* 167867 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(167900), // Rule ID 13214 //
     /* 167872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167891 */     // (intrinsic_wo_chain:{ *:[i16] } 663:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 167891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 167894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167898 */     GIR_RootConstrainSelectedInstOperands,
     /* 167899 */     // GIR_Coverage, 13214,
     /* 167899 */     GIR_EraseRootFromParent_Done,
     /* 167900 */   // Label 3151: @167900
     /* 167900 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(167933), // Rule ID 13216 //
     /* 167905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167924 */     // (intrinsic_wo_chain:{ *:[i16] } 663:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 167924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 167927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167931 */     GIR_RootConstrainSelectedInstOperands,
     /* 167932 */     // GIR_Coverage, 13216,
     /* 167932 */     GIR_EraseRootFromParent_Done,
     /* 167933 */   // Label 3152: @167933
     /* 167933 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(168048), // Rule ID 13217 //
     /* 167938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167957 */     // (intrinsic_wo_chain:{ *:[i32] } 663:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 167957 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 167960 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 167964 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167969 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 167973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 167975 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 167978 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167982 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 167992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 167996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168001 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168004 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168007 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 168010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168030 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168047 */     // GIR_Coverage, 13217,
     /* 168047 */     GIR_EraseRootFromParent_Done,
     /* 168048 */   // Label 3153: @168048
     /* 168048 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(168081), // Rule ID 13219 //
     /* 168053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 168061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 168068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168072 */     // (intrinsic_wo_chain:{ *:[i8] } 728:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 168072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 168075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168079 */     GIR_RootConstrainSelectedInstOperands,
     /* 168080 */     // GIR_Coverage, 13219,
     /* 168080 */     GIR_EraseRootFromParent_Done,
     /* 168081 */   // Label 3154: @168081
     /* 168081 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(168114), // Rule ID 13221 //
     /* 168086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 168094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 168101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168105 */     // (intrinsic_wo_chain:{ *:[i8] } 728:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 168105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 168108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168112 */     GIR_RootConstrainSelectedInstOperands,
     /* 168113 */     // GIR_Coverage, 13221,
     /* 168113 */     GIR_EraseRootFromParent_Done,
     /* 168114 */   // Label 3155: @168114
     /* 168114 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(168147), // Rule ID 13223 //
     /* 168119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168138 */     // (intrinsic_wo_chain:{ *:[i16] } 728:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 168138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 168141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168145 */     GIR_RootConstrainSelectedInstOperands,
     /* 168146 */     // GIR_Coverage, 13223,
     /* 168146 */     GIR_EraseRootFromParent_Done,
     /* 168147 */   // Label 3156: @168147
     /* 168147 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(168180), // Rule ID 13225 //
     /* 168152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168171 */     // (intrinsic_wo_chain:{ *:[i16] } 728:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 168171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 168174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168178 */     GIR_RootConstrainSelectedInstOperands,
     /* 168179 */     // GIR_Coverage, 13225,
     /* 168179 */     GIR_EraseRootFromParent_Done,
     /* 168180 */   // Label 3157: @168180
     /* 168180 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(168295), // Rule ID 13226 //
     /* 168185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168204 */     // (intrinsic_wo_chain:{ *:[i32] } 728:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168204 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 168207 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 168211 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168216 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168222 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168225 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168229 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168248 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168251 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168254 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 168257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168277 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168294 */     // GIR_Coverage, 13226,
     /* 168294 */     GIR_EraseRootFromParent_Done,
     /* 168295 */   // Label 3158: @168295
     /* 168295 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(168414), // Rule ID 13227 //
     /* 168300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 168305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168319 */     // (intrinsic_wo_chain:{ *:[i32] } 663:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168319 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168322 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 168326 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168331 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168335 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168341 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168344 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168348 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168370 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168373 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168396 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168413 */     // GIR_Coverage, 13227,
     /* 168413 */     GIR_EraseRootFromParent_Done,
     /* 168414 */   // Label 3159: @168414
     /* 168414 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(168529), // Rule ID 13228 //
     /* 168419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 168424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168438 */     // (intrinsic_wo_chain:{ *:[i64] } 663:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 168438 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168441 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 168445 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168450 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168456 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 168459 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168463 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 168473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168482 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168485 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168488 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168511 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 168518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168528 */     // GIR_Coverage, 13228,
     /* 168528 */     GIR_EraseRootFromParent_Done,
     /* 168529 */   // Label 3160: @168529
     /* 168529 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(168648), // Rule ID 13229 //
     /* 168534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168553 */     // (intrinsic_wo_chain:{ *:[i32] } 728:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168553 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168556 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 168560 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168565 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168569 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168607 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168630 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168647 */     // GIR_Coverage, 13229,
     /* 168647 */     GIR_EraseRootFromParent_Done,
     /* 168648 */   // Label 3161: @168648
     /* 168648 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(168763), // Rule ID 13230 //
     /* 168653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168672 */     // (intrinsic_wo_chain:{ *:[i64] } 728:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 168672 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168675 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 168679 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168684 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 168693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 168707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168719 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168722 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168745 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 168752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168762 */     // GIR_Coverage, 13230,
     /* 168762 */     GIR_EraseRootFromParent_Done,
     /* 168763 */   // Label 3162: @168763
     /* 168763 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(168796), // Rule ID 13232 //
     /* 168768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 168776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 168783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168787 */     // (intrinsic_wo_chain:{ *:[i8] } 673:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 168787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 168790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168794 */     GIR_RootConstrainSelectedInstOperands,
     /* 168795 */     // GIR_Coverage, 13232,
     /* 168795 */     GIR_EraseRootFromParent_Done,
     /* 168796 */   // Label 3163: @168796
     /* 168796 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(168829), // Rule ID 13234 //
     /* 168801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 168809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 168816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168820 */     // (intrinsic_wo_chain:{ *:[i8] } 673:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 168820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 168823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168827 */     GIR_RootConstrainSelectedInstOperands,
     /* 168828 */     // GIR_Coverage, 13234,
     /* 168828 */     GIR_EraseRootFromParent_Done,
     /* 168829 */   // Label 3164: @168829
     /* 168829 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(168862), // Rule ID 13236 //
     /* 168834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168853 */     // (intrinsic_wo_chain:{ *:[i16] } 673:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 168853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 168856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168860 */     GIR_RootConstrainSelectedInstOperands,
     /* 168861 */     // GIR_Coverage, 13236,
     /* 168861 */     GIR_EraseRootFromParent_Done,
     /* 168862 */   // Label 3165: @168862
     /* 168862 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(168895), // Rule ID 13238 //
     /* 168867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168886 */     // (intrinsic_wo_chain:{ *:[i16] } 673:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 168886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 168889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168893 */     GIR_RootConstrainSelectedInstOperands,
     /* 168894 */     // GIR_Coverage, 13238,
     /* 168894 */     GIR_EraseRootFromParent_Done,
     /* 168895 */   // Label 3166: @168895
     /* 168895 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(169010), // Rule ID 13239 //
     /* 168900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168919 */     // (intrinsic_wo_chain:{ *:[i32] } 673:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168919 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 168922 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 168926 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168931 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168937 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168940 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168944 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168963 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168966 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168969 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 168972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168992 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169009 */     // GIR_Coverage, 13239,
     /* 169009 */     GIR_EraseRootFromParent_Done,
     /* 169010 */   // Label 3167: @169010
     /* 169010 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(169129), // Rule ID 13240 //
     /* 169015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 169020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169034 */     // (intrinsic_wo_chain:{ *:[i32] } 673:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169034 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169037 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 169041 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169046 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169050 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169056 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169059 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169063 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169082 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169085 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169088 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169111 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169128 */     // GIR_Coverage, 13240,
     /* 169128 */     GIR_EraseRootFromParent_Done,
     /* 169129 */   // Label 3168: @169129
     /* 169129 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(169162), // Rule ID 13242 //
     /* 169134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169153 */     // (intrinsic_wo_chain:{ *:[i8] } 676:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 169156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169160 */     GIR_RootConstrainSelectedInstOperands,
     /* 169161 */     // GIR_Coverage, 13242,
     /* 169161 */     GIR_EraseRootFromParent_Done,
     /* 169162 */   // Label 3169: @169162
     /* 169162 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(169195), // Rule ID 13244 //
     /* 169167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169186 */     // (intrinsic_wo_chain:{ *:[i8] } 676:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 169189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169193 */     GIR_RootConstrainSelectedInstOperands,
     /* 169194 */     // GIR_Coverage, 13244,
     /* 169194 */     GIR_EraseRootFromParent_Done,
     /* 169195 */   // Label 3170: @169195
     /* 169195 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(169228), // Rule ID 13246 //
     /* 169200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169219 */     // (intrinsic_wo_chain:{ *:[i16] } 676:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 169222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169226 */     GIR_RootConstrainSelectedInstOperands,
     /* 169227 */     // GIR_Coverage, 13246,
     /* 169227 */     GIR_EraseRootFromParent_Done,
     /* 169228 */   // Label 3171: @169228
     /* 169228 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(169261), // Rule ID 13248 //
     /* 169233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169252 */     // (intrinsic_wo_chain:{ *:[i16] } 676:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 169255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169259 */     GIR_RootConstrainSelectedInstOperands,
     /* 169260 */     // GIR_Coverage, 13248,
     /* 169260 */     GIR_EraseRootFromParent_Done,
     /* 169261 */   // Label 3172: @169261
     /* 169261 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(169376), // Rule ID 13249 //
     /* 169266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169285 */     // (intrinsic_wo_chain:{ *:[i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169285 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169288 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 169292 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169297 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169303 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169306 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169310 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169329 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169332 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169358 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169375 */     // GIR_Coverage, 13249,
     /* 169375 */     GIR_EraseRootFromParent_Done,
     /* 169376 */   // Label 3173: @169376
     /* 169376 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(169495), // Rule ID 13250 //
     /* 169381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169400 */     // (intrinsic_wo_chain:{ *:[i32] } 676:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 169407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169412 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169416 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169448 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169451 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169454 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169477 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169494 */     // GIR_Coverage, 13250,
     /* 169494 */     GIR_EraseRootFromParent_Done,
     /* 169495 */   // Label 3174: @169495
     /* 169495 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(169528), // Rule ID 13252 //
     /* 169500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169519 */     // (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 169522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169526 */     GIR_RootConstrainSelectedInstOperands,
     /* 169527 */     // GIR_Coverage, 13252,
     /* 169527 */     GIR_EraseRootFromParent_Done,
     /* 169528 */   // Label 3175: @169528
     /* 169528 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(169561), // Rule ID 13254 //
     /* 169533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169552 */     // (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 169555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169559 */     GIR_RootConstrainSelectedInstOperands,
     /* 169560 */     // GIR_Coverage, 13254,
     /* 169560 */     GIR_EraseRootFromParent_Done,
     /* 169561 */   // Label 3176: @169561
     /* 169561 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(169594), // Rule ID 13256 //
     /* 169566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169585 */     // (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 169588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169592 */     GIR_RootConstrainSelectedInstOperands,
     /* 169593 */     // GIR_Coverage, 13256,
     /* 169593 */     GIR_EraseRootFromParent_Done,
     /* 169594 */   // Label 3177: @169594
     /* 169594 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(169627), // Rule ID 13258 //
     /* 169599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169618 */     // (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 169621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169625 */     GIR_RootConstrainSelectedInstOperands,
     /* 169626 */     // GIR_Coverage, 13258,
     /* 169626 */     GIR_EraseRootFromParent_Done,
     /* 169627 */   // Label 3178: @169627
     /* 169627 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(169742), // Rule ID 13259 //
     /* 169632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169651 */     // (intrinsic_wo_chain:{ *:[i32] } 734:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169651 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169654 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 169658 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169663 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169695 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169698 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169701 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169724 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169741 */     // GIR_Coverage, 13259,
     /* 169741 */     GIR_EraseRootFromParent_Done,
     /* 169742 */   // Label 3179: @169742
     /* 169742 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(169861), // Rule ID 13260 //
     /* 169747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169766 */     // (intrinsic_wo_chain:{ *:[i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169766 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169769 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 169773 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169778 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169782 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169788 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169791 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169795 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169814 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169817 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169820 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169843 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169860 */     // GIR_Coverage, 13260,
     /* 169860 */     GIR_EraseRootFromParent_Done,
     /* 169861 */   // Label 3180: @169861
     /* 169861 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(169894), // Rule ID 13262 //
     /* 169866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169885 */     // (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 169888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169892 */     GIR_RootConstrainSelectedInstOperands,
     /* 169893 */     // GIR_Coverage, 13262,
     /* 169893 */     GIR_EraseRootFromParent_Done,
     /* 169894 */   // Label 3181: @169894
     /* 169894 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(169927), // Rule ID 13264 //
     /* 169899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169918 */     // (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 169921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169925 */     GIR_RootConstrainSelectedInstOperands,
     /* 169926 */     // GIR_Coverage, 13264,
     /* 169926 */     GIR_EraseRootFromParent_Done,
     /* 169927 */   // Label 3182: @169927
     /* 169927 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(169960), // Rule ID 13266 //
     /* 169932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169951 */     // (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 169954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169958 */     GIR_RootConstrainSelectedInstOperands,
     /* 169959 */     // GIR_Coverage, 13266,
     /* 169959 */     GIR_EraseRootFromParent_Done,
     /* 169960 */   // Label 3183: @169960
     /* 169960 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(169993), // Rule ID 13268 //
     /* 169965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169984 */     // (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 169987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169991 */     GIR_RootConstrainSelectedInstOperands,
     /* 169992 */     // GIR_Coverage, 13268,
     /* 169992 */     GIR_EraseRootFromParent_Done,
     /* 169993 */   // Label 3184: @169993
     /* 169993 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(170108), // Rule ID 13269 //
     /* 169998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 170003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170017 */     // (intrinsic_wo_chain:{ *:[i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170017 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 170020 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 170024 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170029 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170061 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170064 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170067 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 170070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170090 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170107 */     // GIR_Coverage, 13269,
     /* 170107 */     GIR_EraseRootFromParent_Done,
     /* 170108 */   // Label 3185: @170108
     /* 170108 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(170227), // Rule ID 13270 //
     /* 170113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 170118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170132 */     // (intrinsic_wo_chain:{ *:[i32] } 737:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170132 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170135 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 170139 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170144 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170148 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170180 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170183 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170186 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170209 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170226 */     // GIR_Coverage, 13270,
     /* 170226 */     GIR_EraseRootFromParent_Done,
     /* 170227 */   // Label 3186: @170227
     /* 170227 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(170259), // Rule ID 2393 //
     /* 170232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 170240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 170243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170250 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1670:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 170250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 170253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 170257 */     GIR_RootConstrainSelectedInstOperands,
     /* 170258 */     // GIR_Coverage, 2393,
     /* 170258 */     GIR_EraseRootFromParent_Done,
     /* 170259 */   // Label 3187: @170259
     /* 170259 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(170291), // Rule ID 2394 //
     /* 170264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 170272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 170275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170282 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1671:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 170282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 170285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 170289 */     GIR_RootConstrainSelectedInstOperands,
     /* 170290 */     // GIR_Coverage, 2394,
     /* 170290 */     GIR_EraseRootFromParent_Done,
     /* 170291 */   // Label 3188: @170291
     /* 170291 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(170323), // Rule ID 2395 //
     /* 170296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 170304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 170307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170314 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1672:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 170314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 170317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 170321 */     GIR_RootConstrainSelectedInstOperands,
     /* 170322 */     // GIR_Coverage, 2395,
     /* 170322 */     GIR_EraseRootFromParent_Done,
     /* 170323 */   // Label 3189: @170323
     /* 170323 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(170355), // Rule ID 3093 //
     /* 170328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 170331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 170336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 170339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 170342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 170346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 170349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170353 */     GIR_RootConstrainSelectedInstOperands,
     /* 170354 */     // GIR_Coverage, 3093,
     /* 170354 */     GIR_EraseRootFromParent_Done,
     /* 170355 */   // Label 3190: @170355
     /* 170355 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(170387), // Rule ID 3094 //
     /* 170360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 170363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 170368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 170371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 170374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170378 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 170378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 170381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170385 */     GIR_RootConstrainSelectedInstOperands,
     /* 170386 */     // GIR_Coverage, 3094,
     /* 170386 */     GIR_EraseRootFromParent_Done,
     /* 170387 */   // Label 3191: @170387
     /* 170387 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(170419), // Rule ID 3095 //
     /* 170392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 170395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 170400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 170403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 170406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170410 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 170410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 170413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170417 */     GIR_RootConstrainSelectedInstOperands,
     /* 170418 */     // GIR_Coverage, 3095,
     /* 170418 */     GIR_EraseRootFromParent_Done,
     /* 170419 */   // Label 3192: @170419
     /* 170419 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(170451), // Rule ID 3349 //
     /* 170424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 170432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 170435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170442 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1662:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 170442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 170445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170449 */     GIR_RootConstrainSelectedInstOperands,
     /* 170450 */     // GIR_Coverage, 3349,
     /* 170450 */     GIR_EraseRootFromParent_Done,
     /* 170451 */   // Label 3193: @170451
     /* 170451 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(170483), // Rule ID 3350 //
     /* 170456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 170464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 170467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 170470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170474 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1662:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 170474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 170477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170481 */     GIR_RootConstrainSelectedInstOperands,
     /* 170482 */     // GIR_Coverage, 3350,
     /* 170482 */     GIR_EraseRootFromParent_Done,
     /* 170483 */   // Label 3194: @170483
     /* 170483 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(170515), // Rule ID 3351 //
     /* 170488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 170496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 170499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 170502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170506 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1662:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 170506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 170509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170513 */     GIR_RootConstrainSelectedInstOperands,
     /* 170514 */     // GIR_Coverage, 3351,
     /* 170514 */     GIR_EraseRootFromParent_Done,
     /* 170515 */   // Label 3195: @170515
     /* 170515 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(170547), // Rule ID 3430 //
     /* 170520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 170523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 170528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 170531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 170534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170538 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1423:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 170538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 170541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170545 */     GIR_RootConstrainSelectedInstOperands,
     /* 170546 */     // GIR_Coverage, 3430,
     /* 170546 */     GIR_EraseRootFromParent_Done,
     /* 170547 */   // Label 3196: @170547
     /* 170547 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(170579), // Rule ID 3431 //
     /* 170552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 170555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 170560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 170563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 170566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170570 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1423:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 170570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 170573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170577 */     GIR_RootConstrainSelectedInstOperands,
     /* 170578 */     // GIR_Coverage, 3431,
     /* 170578 */     GIR_EraseRootFromParent_Done,
     /* 170579 */   // Label 3197: @170579
     /* 170579 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(170611), // Rule ID 3432 //
     /* 170584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 170587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 170592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 170595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 170598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170602 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1423:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 170602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 170605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170609 */     GIR_RootConstrainSelectedInstOperands,
     /* 170610 */     // GIR_Coverage, 3432,
     /* 170610 */     GIR_EraseRootFromParent_Done,
     /* 170611 */   // Label 3198: @170611
     /* 170611 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(170643), // Rule ID 3458 //
     /* 170616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 170619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 170624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 170627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 170630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170634 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1262:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 170634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 170637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 170639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170641 */     GIR_RootConstrainSelectedInstOperands,
     /* 170642 */     // GIR_Coverage, 3458,
     /* 170642 */     GIR_EraseRootFromParent_Done,
     /* 170643 */   // Label 3199: @170643
     /* 170643 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(170675), // Rule ID 4661 //
     /* 170648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170666 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 170666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 170669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170673 */     GIR_RootConstrainSelectedInstOperands,
     /* 170674 */     // GIR_Coverage, 4661,
     /* 170674 */     GIR_EraseRootFromParent_Done,
     /* 170675 */   // Label 3200: @170675
     /* 170675 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(170707), // Rule ID 4662 //
     /* 170680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170698 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 170698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 170701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170705 */     GIR_RootConstrainSelectedInstOperands,
     /* 170706 */     // GIR_Coverage, 4662,
     /* 170706 */     GIR_EraseRootFromParent_Done,
     /* 170707 */   // Label 3201: @170707
     /* 170707 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(170736), // Rule ID 4663 //
     /* 170712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170727 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 170727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 170730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170734 */     GIR_RootConstrainSelectedInstOperands,
     /* 170735 */     // GIR_Coverage, 4663,
     /* 170735 */     GIR_EraseRootFromParent_Done,
     /* 170736 */   // Label 3202: @170736
     /* 170736 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(170765), // Rule ID 4664 //
     /* 170741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170756 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 170756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 170759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170763 */     GIR_RootConstrainSelectedInstOperands,
     /* 170764 */     // GIR_Coverage, 4664,
     /* 170764 */     GIR_EraseRootFromParent_Done,
     /* 170765 */   // Label 3203: @170765
     /* 170765 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(170794), // Rule ID 4665 //
     /* 170770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170785 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 170785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 170788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170792 */     GIR_RootConstrainSelectedInstOperands,
     /* 170793 */     // GIR_Coverage, 4665,
     /* 170793 */     GIR_EraseRootFromParent_Done,
     /* 170794 */   // Label 3204: @170794
     /* 170794 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(170823), // Rule ID 4666 //
     /* 170799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170814 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 170814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 170817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170821 */     GIR_RootConstrainSelectedInstOperands,
     /* 170822 */     // GIR_Coverage, 4666,
     /* 170822 */     GIR_EraseRootFromParent_Done,
     /* 170823 */   // Label 3205: @170823
     /* 170823 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(170855), // Rule ID 4673 //
     /* 170828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170846 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 170846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 170849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170853 */     GIR_RootConstrainSelectedInstOperands,
     /* 170854 */     // GIR_Coverage, 4673,
     /* 170854 */     GIR_EraseRootFromParent_Done,
     /* 170855 */   // Label 3206: @170855
     /* 170855 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(170887), // Rule ID 4674 //
     /* 170860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170878 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 170878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 170881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170885 */     GIR_RootConstrainSelectedInstOperands,
     /* 170886 */     // GIR_Coverage, 4674,
     /* 170886 */     GIR_EraseRootFromParent_Done,
     /* 170887 */   // Label 3207: @170887
     /* 170887 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(170916), // Rule ID 4675 //
     /* 170892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170907 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 170907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 170910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170914 */     GIR_RootConstrainSelectedInstOperands,
     /* 170915 */     // GIR_Coverage, 4675,
     /* 170915 */     GIR_EraseRootFromParent_Done,
     /* 170916 */   // Label 3208: @170916
     /* 170916 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(170945), // Rule ID 4676 //
     /* 170921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170936 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 170936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 170939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170943 */     GIR_RootConstrainSelectedInstOperands,
     /* 170944 */     // GIR_Coverage, 4676,
     /* 170944 */     GIR_EraseRootFromParent_Done,
     /* 170945 */   // Label 3209: @170945
     /* 170945 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(170974), // Rule ID 4677 //
     /* 170950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170965 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 170965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 170968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170972 */     GIR_RootConstrainSelectedInstOperands,
     /* 170973 */     // GIR_Coverage, 4677,
     /* 170973 */     GIR_EraseRootFromParent_Done,
     /* 170974 */   // Label 3210: @170974
     /* 170974 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(171003), // Rule ID 4678 //
     /* 170979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170994 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 170994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 170997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171001 */     GIR_RootConstrainSelectedInstOperands,
     /* 171002 */     // GIR_Coverage, 4678,
     /* 171002 */     GIR_EraseRootFromParent_Done,
     /* 171003 */   // Label 3211: @171003
     /* 171003 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(171032), // Rule ID 4973 //
     /* 171008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171023 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 171023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 171026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171030 */     GIR_RootConstrainSelectedInstOperands,
     /* 171031 */     // GIR_Coverage, 4973,
     /* 171031 */     GIR_EraseRootFromParent_Done,
     /* 171032 */   // Label 3212: @171032
     /* 171032 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(171061), // Rule ID 4974 //
     /* 171037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171052 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 171052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 171055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171059 */     GIR_RootConstrainSelectedInstOperands,
     /* 171060 */     // GIR_Coverage, 4974,
     /* 171060 */     GIR_EraseRootFromParent_Done,
     /* 171061 */   // Label 3213: @171061
     /* 171061 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(171090), // Rule ID 4975 //
     /* 171066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171081 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 171081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 171084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171088 */     GIR_RootConstrainSelectedInstOperands,
     /* 171089 */     // GIR_Coverage, 4975,
     /* 171089 */     GIR_EraseRootFromParent_Done,
     /* 171090 */   // Label 3214: @171090
     /* 171090 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(171119), // Rule ID 4976 //
     /* 171095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171110 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 171110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 171113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171117 */     GIR_RootConstrainSelectedInstOperands,
     /* 171118 */     // GIR_Coverage, 4976,
     /* 171118 */     GIR_EraseRootFromParent_Done,
     /* 171119 */   // Label 3215: @171119
     /* 171119 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(171148), // Rule ID 4977 //
     /* 171124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171139 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 171139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 171142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171146 */     GIR_RootConstrainSelectedInstOperands,
     /* 171147 */     // GIR_Coverage, 4977,
     /* 171147 */     GIR_EraseRootFromParent_Done,
     /* 171148 */   // Label 3216: @171148
     /* 171148 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(171177), // Rule ID 4978 //
     /* 171153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171168 */     // (intrinsic_wo_chain:{ *:[v4i16] } 594:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 171168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 171171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171175 */     GIR_RootConstrainSelectedInstOperands,
     /* 171176 */     // GIR_Coverage, 4978,
     /* 171176 */     GIR_EraseRootFromParent_Done,
     /* 171177 */   // Label 3217: @171177
     /* 171177 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(171206), // Rule ID 4979 //
     /* 171182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171197 */     // (intrinsic_wo_chain:{ *:[v8i16] } 594:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 171197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 171200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171204 */     GIR_RootConstrainSelectedInstOperands,
     /* 171205 */     // GIR_Coverage, 4979,
     /* 171205 */     GIR_EraseRootFromParent_Done,
     /* 171206 */   // Label 3218: @171206
     /* 171206 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(171235), // Rule ID 4980 //
     /* 171211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171226 */     // (intrinsic_wo_chain:{ *:[v2i32] } 594:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 171226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 171229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171233 */     GIR_RootConstrainSelectedInstOperands,
     /* 171234 */     // GIR_Coverage, 4980,
     /* 171234 */     GIR_EraseRootFromParent_Done,
     /* 171235 */   // Label 3219: @171235
     /* 171235 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(171264), // Rule ID 4981 //
     /* 171240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171255 */     // (intrinsic_wo_chain:{ *:[v4i32] } 594:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 171255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 171258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171262 */     GIR_RootConstrainSelectedInstOperands,
     /* 171263 */     // GIR_Coverage, 4981,
     /* 171263 */     GIR_EraseRootFromParent_Done,
     /* 171264 */   // Label 3220: @171264
     /* 171264 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(171293), // Rule ID 4982 //
     /* 171269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171284 */     // (intrinsic_wo_chain:{ *:[v2i64] } 594:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 171284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 171287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171291 */     GIR_RootConstrainSelectedInstOperands,
     /* 171292 */     // GIR_Coverage, 4982,
     /* 171292 */     GIR_EraseRootFromParent_Done,
     /* 171293 */   // Label 3221: @171293
     /* 171293 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(171325), // Rule ID 8473 //
     /* 171298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 171306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 171309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171316 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1661:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 171316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 171319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171323 */     GIR_RootConstrainSelectedInstOperands,
     /* 171324 */     // GIR_Coverage, 8473,
     /* 171324 */     GIR_EraseRootFromParent_Done,
     /* 171325 */   // Label 3222: @171325
     /* 171325 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(171357), // Rule ID 8474 //
     /* 171330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 171338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 171341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 171344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171348 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1661:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 171348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 171351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171355 */     GIR_RootConstrainSelectedInstOperands,
     /* 171356 */     // GIR_Coverage, 8474,
     /* 171356 */     GIR_EraseRootFromParent_Done,
     /* 171357 */   // Label 3223: @171357
     /* 171357 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(171389), // Rule ID 8475 //
     /* 171362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 171370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 171373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 171376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171380 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1661:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 171380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 171383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171387 */     GIR_RootConstrainSelectedInstOperands,
     /* 171388 */     // GIR_Coverage, 8475,
     /* 171388 */     GIR_EraseRootFromParent_Done,
     /* 171389 */   // Label 3224: @171389
     /* 171389 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(171421), // Rule ID 11884 //
     /* 171394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 171402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 171408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171412 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 171412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 171415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171419 */     GIR_RootConstrainSelectedInstOperands,
     /* 171420 */     // GIR_Coverage, 11884,
     /* 171420 */     GIR_EraseRootFromParent_Done,
     /* 171421 */   // Label 3225: @171421
     /* 171421 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(171453), // Rule ID 11885 //
     /* 171426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 171434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 171437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 171440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 171444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 171447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171451 */     GIR_RootConstrainSelectedInstOperands,
     /* 171452 */     // GIR_Coverage, 11885,
     /* 171452 */     GIR_EraseRootFromParent_Done,
     /* 171453 */   // Label 3226: @171453
     /* 171453 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(171485), // Rule ID 11886 //
     /* 171458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 171466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 171469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 171472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 171476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 171479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171483 */     GIR_RootConstrainSelectedInstOperands,
     /* 171484 */     // GIR_Coverage, 11886,
     /* 171484 */     GIR_EraseRootFromParent_Done,
     /* 171485 */   // Label 3227: @171485
     /* 171485 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(171517), // Rule ID 11887 //
     /* 171490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 171498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 171504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171508 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1854:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 171508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 171511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171515 */     GIR_RootConstrainSelectedInstOperands,
     /* 171516 */     // GIR_Coverage, 11887,
     /* 171516 */     GIR_EraseRootFromParent_Done,
     /* 171517 */   // Label 3228: @171517
     /* 171517 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(171549), // Rule ID 11888 //
     /* 171522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 171530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 171533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 171536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171540 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 171540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 171543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171547 */     GIR_RootConstrainSelectedInstOperands,
     /* 171548 */     // GIR_Coverage, 11888,
     /* 171548 */     GIR_EraseRootFromParent_Done,
     /* 171549 */   // Label 3229: @171549
     /* 171549 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(171581), // Rule ID 11889 //
     /* 171554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 171562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 171565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 171568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171572 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 171572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 171575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171579 */     GIR_RootConstrainSelectedInstOperands,
     /* 171580 */     // GIR_Coverage, 11889,
     /* 171580 */     GIR_EraseRootFromParent_Done,
     /* 171581 */   // Label 3230: @171581
     /* 171581 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(171613), // Rule ID 12056 //
     /* 171586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 171589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 171594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 171600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171604 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1261:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 171604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 171607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 171609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171611 */     GIR_RootConstrainSelectedInstOperands,
     /* 171612 */     // GIR_Coverage, 12056,
     /* 171612 */     GIR_EraseRootFromParent_Done,
     /* 171613 */   // Label 3231: @171613
     /* 171613 */   GIM_Reject,
     /* 171614 */ // Label 2912: @171614
     /* 171614 */ GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(217608),
     /* 171619 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 171622 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(171806), // Rule ID 2568 //
     /* 171627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 171656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 171660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 171668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 171672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 171676 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 171679 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 171684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171688 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 171701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 171705 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171709 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 171713 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 171717 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171721 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 171725 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 171730 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 171734 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 171738 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 171742 */     // MIs[5] Operand 1
     /* 171742 */     // No operand predicates
     /* 171742 */     // MIs[3] Operand 2
     /* 171742 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 171753 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 171757 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 171759 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 171759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 171762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171771 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 171777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 171790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 171794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 171801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 171804 */     GIR_RootConstrainSelectedInstOperands,
     /* 171805 */     // GIR_Coverage, 2568,
     /* 171805 */     GIR_EraseRootFromParent_Done,
     /* 171806 */   // Label 3233: @171806
     /* 171806 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(171990), // Rule ID 6321 //
     /* 171811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 171819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 171840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 171844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 171852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 171856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 171860 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 171863 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 171868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171872 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 171885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 171889 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171893 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 171897 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 171901 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171905 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 171909 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 171914 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 171918 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 171922 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 171926 */     // MIs[5] Operand 1
     /* 171926 */     // No operand predicates
     /* 171926 */     // MIs[3] Operand 2
     /* 171926 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 171937 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 171941 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 171943 */     // (intrinsic_wo_chain:{ *:[i32] } 699:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 171943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 171946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171955 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 171961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 171974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 171978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 171985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 171988 */     GIR_RootConstrainSelectedInstOperands,
     /* 171989 */     // GIR_Coverage, 6321,
     /* 171989 */     GIR_EraseRootFromParent_Done,
     /* 171990 */   // Label 3234: @171990
     /* 171990 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(172130), // Rule ID 2057 //
     /* 171995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172028 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 172031 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172040 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 172048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 172060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 172064 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172068 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172072 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 172077 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172081 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172085 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 172089 */     // MIs[4] Operand 1
     /* 172089 */     // No operand predicates
     /* 172089 */     // MIs[2] Operand 2
     /* 172089 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 172100 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 172109 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 172112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 172121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172128 */     GIR_RootConstrainSelectedInstOperands,
     /* 172129 */     // GIR_Coverage, 2057,
     /* 172129 */     GIR_EraseRootFromParent_Done,
     /* 172130 */   // Label 3235: @172130
     /* 172130 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(172270), // Rule ID 2064 //
     /* 172135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172168 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 172171 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172180 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 172188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 172200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 172204 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172208 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172212 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 172217 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172221 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172225 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 172229 */     // MIs[4] Operand 1
     /* 172229 */     // No operand predicates
     /* 172229 */     // MIs[2] Operand 2
     /* 172229 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 172240 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 172249 */     // (intrinsic_wo_chain:{ *:[v4i32] } 699:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 172252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 172261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172268 */     GIR_RootConstrainSelectedInstOperands,
     /* 172269 */     // GIR_Coverage, 2064,
     /* 172269 */     GIR_EraseRootFromParent_Done,
     /* 172270 */   // Label 3236: @172270
     /* 172270 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(172410), // Rule ID 2060 //
     /* 172275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172308 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 172311 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172320 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 172328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 172340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 172344 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172348 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172352 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172357 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172361 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172365 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 172369 */     // MIs[4] Operand 1
     /* 172369 */     // No operand predicates
     /* 172369 */     // MIs[2] Operand 2
     /* 172369 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 172380 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 172389 */     // (intrinsic_wo_chain:{ *:[v2i64] } 680:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 172392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 172401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172408 */     GIR_RootConstrainSelectedInstOperands,
     /* 172409 */     // GIR_Coverage, 2060,
     /* 172409 */     GIR_EraseRootFromParent_Done,
     /* 172410 */   // Label 3237: @172410
     /* 172410 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(172550), // Rule ID 2067 //
     /* 172415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172448 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 172451 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172460 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 172468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 172480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 172484 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172488 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172492 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172497 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172501 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172505 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 172509 */     // MIs[4] Operand 1
     /* 172509 */     // No operand predicates
     /* 172509 */     // MIs[2] Operand 2
     /* 172509 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 172520 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 172529 */     // (intrinsic_wo_chain:{ *:[v2i64] } 699:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 172532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 172541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172548 */     GIR_RootConstrainSelectedInstOperands,
     /* 172549 */     // GIR_Coverage, 2067,
     /* 172549 */     GIR_EraseRootFromParent_Done,
     /* 172550 */   // Label 3238: @172550
     /* 172550 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(172687), // Rule ID 2055 //
     /* 172555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172588 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 172591 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172600 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 172613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 172625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 172629 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172633 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172637 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 172642 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172646 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172650 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 172654 */     // MIs[4] Operand 1
     /* 172654 */     // No operand predicates
     /* 172654 */     // MIs[2] Operand 2
     /* 172654 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 172665 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172667 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 172670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 172678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172685 */     GIR_RootConstrainSelectedInstOperands,
     /* 172686 */     // GIR_Coverage, 2055,
     /* 172686 */     GIR_EraseRootFromParent_Done,
     /* 172687 */   // Label 3239: @172687
     /* 172687 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(172824), // Rule ID 2062 //
     /* 172692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172725 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 172728 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172737 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 172750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 172762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 172766 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172770 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172774 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 172779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172783 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172787 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 172791 */     // MIs[4] Operand 1
     /* 172791 */     // No operand predicates
     /* 172791 */     // MIs[2] Operand 2
     /* 172791 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 172802 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172804 */     // (intrinsic_wo_chain:{ *:[v4i32] } 699:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 172807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 172815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172822 */     GIR_RootConstrainSelectedInstOperands,
     /* 172823 */     // GIR_Coverage, 2062,
     /* 172823 */     GIR_EraseRootFromParent_Done,
     /* 172824 */   // Label 3240: @172824
     /* 172824 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(172961), // Rule ID 2058 //
     /* 172829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172862 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 172865 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172874 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 172887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 172899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 172903 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172907 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172911 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172916 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172920 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172924 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 172928 */     // MIs[4] Operand 1
     /* 172928 */     // No operand predicates
     /* 172928 */     // MIs[2] Operand 2
     /* 172928 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 172939 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172941 */     // (intrinsic_wo_chain:{ *:[v2i64] } 680:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 172944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 172952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172959 */     GIR_RootConstrainSelectedInstOperands,
     /* 172960 */     // GIR_Coverage, 2058,
     /* 172960 */     GIR_EraseRootFromParent_Done,
     /* 172961 */   // Label 3241: @172961
     /* 172961 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(173098), // Rule ID 2065 //
     /* 172966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172999 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 173002 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173011 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 173024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 173036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 173040 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173044 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 173048 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173053 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 173057 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173061 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 173065 */     // MIs[4] Operand 1
     /* 173065 */     // No operand predicates
     /* 173065 */     // MIs[2] Operand 2
     /* 173065 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 173076 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 173078 */     // (intrinsic_wo_chain:{ *:[v2i64] } 699:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 173081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 173089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 173093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 173096 */     GIR_RootConstrainSelectedInstOperands,
     /* 173097 */     // GIR_Coverage, 2065,
     /* 173097 */     GIR_EraseRootFromParent_Done,
     /* 173098 */   // Label 3242: @173098
     /* 173098 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(173259), // Rule ID 2569 //
     /* 173103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173152 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173155 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173164 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173181 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173185 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 173189 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173194 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 173198 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173202 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173206 */     // MIs[4] Operand 1
     /* 173206 */     // No operand predicates
     /* 173206 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173210 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 173212 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173224 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 173243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 173254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 173257 */     GIR_RootConstrainSelectedInstOperands,
     /* 173258 */     // GIR_Coverage, 2569,
     /* 173258 */     GIR_EraseRootFromParent_Done,
     /* 173259 */   // Label 3243: @173259
     /* 173259 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(173420), // Rule ID 6322 //
     /* 173264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173313 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173316 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173325 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173342 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173346 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 173350 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173355 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 173359 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173363 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173367 */     // MIs[4] Operand 1
     /* 173367 */     // No operand predicates
     /* 173367 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173371 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 173373 */     // (intrinsic_wo_chain:{ *:[i32] } 699:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173385 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 173404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 173415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 173418 */     GIR_RootConstrainSelectedInstOperands,
     /* 173419 */     // GIR_Coverage, 6322,
     /* 173419 */     GIR_EraseRootFromParent_Done,
     /* 173420 */   // Label 3244: @173420
     /* 173420 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(173530), // Rule ID 2085 //
     /* 173425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173487 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173491 */     // MIs[3] Operand 1
     /* 173491 */     // No operand predicates
     /* 173491 */     // MIs[1] Operand 2
     /* 173491 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 173502 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 173511 */     // (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 173514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173528 */     GIR_RootConstrainSelectedInstOperands,
     /* 173529 */     // GIR_Coverage, 2085,
     /* 173529 */     GIR_EraseRootFromParent_Done,
     /* 173530 */   // Label 3245: @173530
     /* 173530 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(173640), // Rule ID 2088 //
     /* 173535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 173576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173593 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173597 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 173601 */     // MIs[3] Operand 1
     /* 173601 */     // No operand predicates
     /* 173601 */     // MIs[1] Operand 2
     /* 173601 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 173612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 173621 */     // (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 173624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173638 */     GIR_RootConstrainSelectedInstOperands,
     /* 173639 */     // GIR_Coverage, 2088,
     /* 173639 */     GIR_EraseRootFromParent_Done,
     /* 173640 */   // Label 3246: @173640
     /* 173640 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(173729), // Rule ID 1743 //
     /* 173645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173678 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 173681 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173690 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173696 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 173703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 173710 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 173713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 173727 */     GIR_RootConstrainSelectedInstOperands,
     /* 173728 */     // GIR_Coverage, 1743,
     /* 173728 */     GIR_EraseRootFromParent_Done,
     /* 173729 */   // Label 3247: @173729
     /* 173729 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(173818), // Rule ID 1745 //
     /* 173734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173767 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 173770 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173779 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 173792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 173799 */     // (intrinsic_wo_chain:{ *:[v2i64] } 680:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 173802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 173816 */     GIR_RootConstrainSelectedInstOperands,
     /* 173817 */     // GIR_Coverage, 1745,
     /* 173817 */     GIR_EraseRootFromParent_Done,
     /* 173818 */   // Label 3248: @173818
     /* 173818 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(173907), // Rule ID 1747 //
     /* 173823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173856 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 173859 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173868 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 173881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 173888 */     // (intrinsic_wo_chain:{ *:[v4i32] } 699:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 173891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 173905 */     GIR_RootConstrainSelectedInstOperands,
     /* 173906 */     // GIR_Coverage, 1747,
     /* 173906 */     GIR_EraseRootFromParent_Done,
     /* 173907 */   // Label 3249: @173907
     /* 173907 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(173996), // Rule ID 1749 //
     /* 173912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173945 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 173948 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173957 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 173970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 173977 */     // (intrinsic_wo_chain:{ *:[v2i64] } 699:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 173980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 173994 */     GIR_RootConstrainSelectedInstOperands,
     /* 173995 */     // GIR_Coverage, 1749,
     /* 173995 */     GIR_EraseRootFromParent_Done,
     /* 173996 */   // Label 3250: @173996
     /* 173996 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(174118), // Rule ID 6975 //
     /* 174001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174036 */     // MIs[1] Operand 2
     /* 174036 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174055 */     // MIs[2] Rn
     /* 174055 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174060 */     // MIs[2] Operand 2
     /* 174060 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 174071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174073 */     // (intrinsic_wo_chain:{ *:[v2i32] } 571:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 174073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 174080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174085 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174089 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174100 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174107 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174117 */     // GIR_Coverage, 6975,
     /* 174117 */     GIR_EraseRootFromParent_Done,
     /* 174118 */   // Label 3251: @174118
     /* 174118 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(174240), // Rule ID 6977 //
     /* 174123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174158 */     // MIs[1] Operand 2
     /* 174158 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174177 */     // MIs[2] Rn
     /* 174177 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174182 */     // MIs[2] Operand 2
     /* 174182 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 174193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174195 */     // (intrinsic_wo_chain:{ *:[v4i16] } 571:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 174195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 174202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174207 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174211 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174222 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174239 */     // GIR_Coverage, 6977,
     /* 174239 */     GIR_EraseRootFromParent_Done,
     /* 174240 */   // Label 3252: @174240
     /* 174240 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(174362), // Rule ID 6979 //
     /* 174245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 174275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174280 */     // MIs[1] Operand 2
     /* 174280 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174299 */     // MIs[2] Rn
     /* 174299 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174304 */     // MIs[2] Operand 2
     /* 174304 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 174315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174317 */     // (intrinsic_wo_chain:{ *:[v8i8] } 571:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 174317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 174324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174344 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174351 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174361 */     // GIR_Coverage, 6979,
     /* 174361 */     GIR_EraseRootFromParent_Done,
     /* 174362 */   // Label 3253: @174362
     /* 174362 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(174484), // Rule ID 6981 //
     /* 174367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 174372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174402 */     // MIs[1] Operand 2
     /* 174402 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174421 */     // MIs[2] Rn
     /* 174421 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174426 */     // MIs[2] Operand 2
     /* 174426 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 174437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174439 */     // (intrinsic_wo_chain:{ *:[v2f32] } 580:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 174439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 174446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174451 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174466 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174483 */     // GIR_Coverage, 6981,
     /* 174483 */     GIR_EraseRootFromParent_Done,
     /* 174484 */   // Label 3254: @174484
     /* 174484 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(174606), // Rule ID 6983 //
     /* 174489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 174494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174524 */     // MIs[1] Operand 2
     /* 174524 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174543 */     // MIs[2] Rn
     /* 174543 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174548 */     // MIs[2] Operand 2
     /* 174548 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 174559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174561 */     // (intrinsic_wo_chain:{ *:[v4f16] } 580:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 174561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 174568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174588 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174605 */     // GIR_Coverage, 6983,
     /* 174605 */     GIR_EraseRootFromParent_Done,
     /* 174606 */   // Label 3255: @174606
     /* 174606 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(174789), // Rule ID 2567 //
     /* 174611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174660 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 174663 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 174668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174672 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174686 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 174690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174692 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 174692 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 174695 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174699 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 174706 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 174709 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 174713 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174718 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 174721 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 174725 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 174728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174738 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174755 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 174761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 174774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 174784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174787 */     GIR_RootConstrainSelectedInstOperands,
     /* 174788 */     // GIR_Coverage, 2567,
     /* 174788 */     GIR_EraseRootFromParent_Done,
     /* 174789 */   // Label 3256: @174789
     /* 174789 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(174972), // Rule ID 6320 //
     /* 174794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174843 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 174846 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 174851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174855 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174859 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174869 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 174873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174875 */     // (intrinsic_wo_chain:{ *:[i32] } 699:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 174875 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 174878 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174882 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 174889 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 174892 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 174896 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174901 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 174904 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 174908 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 174911 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174916 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174921 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174938 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 174944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 174957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 174967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174970 */     GIR_RootConstrainSelectedInstOperands,
     /* 174971 */     // GIR_Coverage, 6320,
     /* 174971 */     GIR_EraseRootFromParent_Done,
     /* 174972 */   // Label 3257: @174972
     /* 174972 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(175076), // Rule ID 13521 //
     /* 174977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 174980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 174985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 175018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 175031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175035 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175039 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175043 */     // MIs[3] Operand 1
     /* 175043 */     // No operand predicates
     /* 175043 */     // MIs[1] Operand 2
     /* 175043 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175058 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175060 */     // (intrinsic_wo_chain:{ *:[v4f16] } 611:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 175063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175074 */     GIR_RootConstrainSelectedInstOperands,
     /* 175075 */     // GIR_Coverage, 13521,
     /* 175075 */     GIR_EraseRootFromParent_Done,
     /* 175076 */   // Label 3258: @175076
     /* 175076 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(175180), // Rule ID 13524 //
     /* 175081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 175122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175143 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175147 */     // MIs[3] Operand 1
     /* 175147 */     // No operand predicates
     /* 175147 */     // MIs[1] Operand 2
     /* 175147 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175164 */     // (intrinsic_wo_chain:{ *:[v2f32] } 611:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 175167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175178 */     GIR_RootConstrainSelectedInstOperands,
     /* 175179 */     // GIR_Coverage, 13524,
     /* 175179 */     GIR_EraseRootFromParent_Done,
     /* 175180 */   // Label 3259: @175180
     /* 175180 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(175311), // Rule ID 2524 //
     /* 175185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 175188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 175199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 175202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175227 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175247 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175260 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175264 */     // MIs[3] Operand 1
     /* 175264 */     // No operand predicates
     /* 175264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175266 */     // (intrinsic_wo_chain:{ *:[f16] } 611:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 175266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175278 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 175297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175309 */     GIR_RootConstrainSelectedInstOperands,
     /* 175310 */     // GIR_Coverage, 2524,
     /* 175310 */     GIR_EraseRootFromParent_Done,
     /* 175311 */   // Label 3260: @175311
     /* 175311 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(175442), // Rule ID 2525 //
     /* 175316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175358 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175391 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175395 */     // MIs[3] Operand 1
     /* 175395 */     // No operand predicates
     /* 175395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175397 */     // (intrinsic_wo_chain:{ *:[f32] } 611:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 175397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175409 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 175415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 175428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175440 */     GIR_RootConstrainSelectedInstOperands,
     /* 175441 */     // GIR_Coverage, 2525,
     /* 175441 */     GIR_EraseRootFromParent_Done,
     /* 175442 */   // Label 3261: @175442
     /* 175442 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(175573), // Rule ID 2526 //
     /* 175447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175489 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175522 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 175526 */     // MIs[3] Operand 1
     /* 175526 */     // No operand predicates
     /* 175526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175528 */     // (intrinsic_wo_chain:{ *:[f64] } 611:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 175528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175540 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 175546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 175559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175571 */     GIR_RootConstrainSelectedInstOperands,
     /* 175572 */     // GIR_Coverage, 2526,
     /* 175572 */     GIR_EraseRootFromParent_Done,
     /* 175573 */   // Label 3262: @175573
     /* 175573 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(175704), // Rule ID 13707 //
     /* 175578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 175581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 175592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 175595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175628 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175632 */     // MIs[2] Operand 1
     /* 175632 */     // No operand predicates
     /* 175632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175640 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175644 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175648 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175653 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175659 */     // (intrinsic_wo_chain:{ *:[f16] } 611:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 175659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175671 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 175690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175702 */     GIR_RootConstrainSelectedInstOperands,
     /* 175703 */     // GIR_Coverage, 13707,
     /* 175703 */     GIR_EraseRootFromParent_Done,
     /* 175704 */   // Label 3263: @175704
     /* 175704 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(175835), // Rule ID 13708 //
     /* 175709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175759 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175763 */     // MIs[2] Operand 1
     /* 175763 */     // No operand predicates
     /* 175763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175771 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175775 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175779 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175784 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175790 */     // (intrinsic_wo_chain:{ *:[f32] } 611:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 175790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175802 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 175808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 175821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175833 */     GIR_RootConstrainSelectedInstOperands,
     /* 175834 */     // GIR_Coverage, 13708,
     /* 175834 */     GIR_EraseRootFromParent_Done,
     /* 175835 */   // Label 3264: @175835
     /* 175835 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(175966), // Rule ID 13709 //
     /* 175840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175890 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 175894 */     // MIs[2] Operand 1
     /* 175894 */     // No operand predicates
     /* 175894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175902 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175906 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175910 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175915 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175921 */     // (intrinsic_wo_chain:{ *:[f64] } 611:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 175921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175933 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 175939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 175952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175964 */     GIR_RootConstrainSelectedInstOperands,
     /* 175965 */     // GIR_Coverage, 13709,
     /* 175965 */     GIR_EraseRootFromParent_Done,
     /* 175966 */   // Label 3265: @175966
     /* 175966 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(176080), // Rule ID 2056 //
     /* 175971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 175979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176004 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176007 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176016 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176054 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176058 */     // MIs[3] Operand 1
     /* 176058 */     // No operand predicates
     /* 176058 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176060 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 176063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176078 */     GIR_RootConstrainSelectedInstOperands,
     /* 176079 */     // GIR_Coverage, 2056,
     /* 176079 */     GIR_EraseRootFromParent_Done,
     /* 176080 */   // Label 3266: @176080
     /* 176080 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(176194), // Rule ID 2063 //
     /* 176085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176118 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176121 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176130 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176168 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176172 */     // MIs[3] Operand 1
     /* 176172 */     // No operand predicates
     /* 176172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176174 */     // (intrinsic_wo_chain:{ *:[v4i32] } 699:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 176177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176192 */     GIR_RootConstrainSelectedInstOperands,
     /* 176193 */     // GIR_Coverage, 2063,
     /* 176193 */     GIR_EraseRootFromParent_Done,
     /* 176194 */   // Label 3267: @176194
     /* 176194 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(176308), // Rule ID 2059 //
     /* 176199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 176207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176232 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176235 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176244 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176282 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176286 */     // MIs[3] Operand 1
     /* 176286 */     // No operand predicates
     /* 176286 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176288 */     // (intrinsic_wo_chain:{ *:[v2i64] } 680:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 176291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176306 */     GIR_RootConstrainSelectedInstOperands,
     /* 176307 */     // GIR_Coverage, 2059,
     /* 176307 */     GIR_EraseRootFromParent_Done,
     /* 176308 */   // Label 3268: @176308
     /* 176308 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(176422), // Rule ID 2066 //
     /* 176313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176346 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176349 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176358 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176379 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176396 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176400 */     // MIs[3] Operand 1
     /* 176400 */     // No operand predicates
     /* 176400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176402 */     // (intrinsic_wo_chain:{ *:[v2i64] } 699:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 176405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176420 */     GIR_RootConstrainSelectedInstOperands,
     /* 176421 */     // GIR_Coverage, 2066,
     /* 176421 */     GIR_EraseRootFromParent_Done,
     /* 176422 */   // Label 3269: @176422
     /* 176422 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(176536), // Rule ID 2061 //
     /* 176427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 176435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176460 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176463 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176472 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176510 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176514 */     // MIs[3] Operand 1
     /* 176514 */     // No operand predicates
     /* 176514 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176516 */     // (intrinsic_wo_chain:{ *:[i64] } 680:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 176519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176534 */     GIR_RootConstrainSelectedInstOperands,
     /* 176535 */     // GIR_Coverage, 2061,
     /* 176535 */     GIR_EraseRootFromParent_Done,
     /* 176536 */   // Label 3270: @176536
     /* 176536 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(176650), // Rule ID 2068 //
     /* 176541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176574 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176577 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176586 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176624 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176628 */     // MIs[3] Operand 1
     /* 176628 */     // No operand predicates
     /* 176628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176630 */     // (intrinsic_wo_chain:{ *:[i64] } 699:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 176633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176648 */     GIR_RootConstrainSelectedInstOperands,
     /* 176649 */     // GIR_Coverage, 2068,
     /* 176649 */     GIR_EraseRootFromParent_Done,
     /* 176650 */   // Label 3271: @176650
     /* 176650 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(176754), // Rule ID 1987 //
     /* 176655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 176658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176721 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176725 */     // MIs[3] Operand 1
     /* 176725 */     // No operand predicates
     /* 176725 */     // MIs[1] Operand 2
     /* 176725 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176736 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176738 */     // (intrinsic_wo_chain:{ *:[v4f16] } 611:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 176741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176752 */     GIR_RootConstrainSelectedInstOperands,
     /* 176753 */     // GIR_Coverage, 1987,
     /* 176753 */     GIR_EraseRootFromParent_Done,
     /* 176754 */   // Label 3272: @176754
     /* 176754 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(176858), // Rule ID 2017 //
     /* 176759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 176767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176825 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176829 */     // MIs[3] Operand 1
     /* 176829 */     // No operand predicates
     /* 176829 */     // MIs[1] Operand 2
     /* 176829 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176842 */     // (intrinsic_wo_chain:{ *:[v4i16] } 681:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 176845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176856 */     GIR_RootConstrainSelectedInstOperands,
     /* 176857 */     // GIR_Coverage, 2017,
     /* 176857 */     GIR_EraseRootFromParent_Done,
     /* 176858 */   // Label 3273: @176858
     /* 176858 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(176962), // Rule ID 2024 //
     /* 176863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 176871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176929 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176933 */     // MIs[3] Operand 1
     /* 176933 */     // No operand predicates
     /* 176933 */     // MIs[1] Operand 2
     /* 176933 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176946 */     // (intrinsic_wo_chain:{ *:[v4i16] } 689:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 176949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176960 */     GIR_RootConstrainSelectedInstOperands,
     /* 176961 */     // GIR_Coverage, 2024,
     /* 176961 */     GIR_EraseRootFromParent_Done,
     /* 176962 */   // Label 3274: @176962
     /* 176962 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(177066), // Rule ID 2083 //
     /* 176967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 177000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 177008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 177020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177033 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177037 */     // MIs[3] Operand 1
     /* 177037 */     // No operand predicates
     /* 177037 */     // MIs[1] Operand 2
     /* 177037 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177050 */     // (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 177053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177064 */     GIR_RootConstrainSelectedInstOperands,
     /* 177065 */     // GIR_Coverage, 2083,
     /* 177065 */     GIR_EraseRootFromParent_Done,
     /* 177066 */   // Label 3275: @177066
     /* 177066 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(177170), // Rule ID 1990 //
     /* 177071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 177104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 177112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 177124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177137 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177141 */     // MIs[3] Operand 1
     /* 177141 */     // No operand predicates
     /* 177141 */     // MIs[1] Operand 2
     /* 177141 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177154 */     // (intrinsic_wo_chain:{ *:[v2f32] } 611:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 177157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177168 */     GIR_RootConstrainSelectedInstOperands,
     /* 177169 */     // GIR_Coverage, 1990,
     /* 177169 */     GIR_EraseRootFromParent_Done,
     /* 177170 */   // Label 3276: @177170
     /* 177170 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(177274), // Rule ID 2020 //
     /* 177175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 177183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 177208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 177216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 177228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177241 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177245 */     // MIs[3] Operand 1
     /* 177245 */     // No operand predicates
     /* 177245 */     // MIs[1] Operand 2
     /* 177245 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177256 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177258 */     // (intrinsic_wo_chain:{ *:[v2i32] } 681:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 177261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177272 */     GIR_RootConstrainSelectedInstOperands,
     /* 177273 */     // GIR_Coverage, 2020,
     /* 177273 */     GIR_EraseRootFromParent_Done,
     /* 177274 */   // Label 3277: @177274
     /* 177274 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(177378), // Rule ID 2027 //
     /* 177279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 177287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 177312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 177320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 177332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177345 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177349 */     // MIs[3] Operand 1
     /* 177349 */     // No operand predicates
     /* 177349 */     // MIs[1] Operand 2
     /* 177349 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177362 */     // (intrinsic_wo_chain:{ *:[v2i32] } 689:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 177365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177376 */     GIR_RootConstrainSelectedInstOperands,
     /* 177377 */     // GIR_Coverage, 2027,
     /* 177377 */     GIR_EraseRootFromParent_Done,
     /* 177378 */   // Label 3278: @177378
     /* 177378 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(177482), // Rule ID 2086 //
     /* 177383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 177416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 177424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 177436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177449 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177453 */     // MIs[3] Operand 1
     /* 177453 */     // No operand predicates
     /* 177453 */     // MIs[1] Operand 2
     /* 177453 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177466 */     // (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 177469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177480 */     GIR_RootConstrainSelectedInstOperands,
     /* 177481 */     // GIR_Coverage, 2086,
     /* 177481 */     GIR_EraseRootFromParent_Done,
     /* 177482 */   // Label 3279: @177482
     /* 177482 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(177539), // Rule ID 1751 //
     /* 177487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 177515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 177522 */     // (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 177525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 177532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 177537 */     GIR_RootConstrainSelectedInstOperands,
     /* 177538 */     // GIR_Coverage, 1751,
     /* 177538 */     GIR_EraseRootFromParent_Done,
     /* 177539 */   // Label 3280: @177539
     /* 177539 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(177596), // Rule ID 1753 //
     /* 177544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 177572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 177579 */     // (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 177582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 177589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 177594 */     GIR_RootConstrainSelectedInstOperands,
     /* 177595 */     // GIR_Coverage, 1753,
     /* 177595 */     GIR_EraseRootFromParent_Done,
     /* 177596 */   // Label 3281: @177596
     /* 177596 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(177706), // Rule ID 6339 //
     /* 177601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 177606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 177627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 177631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 177635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177640 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 177651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 177655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177659 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 177663 */     // MIs[2] Operand 1
     /* 177663 */     // No operand predicates
     /* 177663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177665 */     // (intrinsic_wo_chain:{ *:[f16] } 767:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 177665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177677 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 177683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 177696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 177704 */     GIR_RootConstrainSelectedInstOperands,
     /* 177705 */     // GIR_Coverage, 6339,
     /* 177705 */     GIR_EraseRootFromParent_Done,
     /* 177706 */   // Label 3282: @177706
     /* 177706 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(177803), // Rule ID 13978 //
     /* 177711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177753 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177763 */     // (intrinsic_wo_chain:{ *:[f16] } 611:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 177763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177775 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 177781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 177794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177801 */     GIR_RootConstrainSelectedInstOperands,
     /* 177802 */     // GIR_Coverage, 13978,
     /* 177802 */     GIR_EraseRootFromParent_Done,
     /* 177803 */   // Label 3283: @177803
     /* 177803 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(177900), // Rule ID 13979 //
     /* 177808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177850 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177860 */     // (intrinsic_wo_chain:{ *:[f32] } 611:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 177860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177872 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 177878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 177891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177898 */     GIR_RootConstrainSelectedInstOperands,
     /* 177899 */     // GIR_Coverage, 13979,
     /* 177899 */     GIR_EraseRootFromParent_Done,
     /* 177900 */   // Label 3284: @177900
     /* 177900 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(177997), // Rule ID 13980 //
     /* 177905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 177938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177947 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177957 */     // (intrinsic_wo_chain:{ *:[f64] } 611:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 177957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177969 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 177975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 177988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177995 */     GIR_RootConstrainSelectedInstOperands,
     /* 177996 */     // GIR_Coverage, 13980,
     /* 177996 */     GIR_EraseRootFromParent_Done,
     /* 177997 */   // Label 3285: @177997
     /* 177997 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(178080), // Rule ID 1742 //
     /* 178002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 178010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 178035 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 178038 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 178043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178047 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178063 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 178063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 178066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 178074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 178078 */     GIR_RootConstrainSelectedInstOperands,
     /* 178079 */     // GIR_Coverage, 1742,
     /* 178079 */     GIR_EraseRootFromParent_Done,
     /* 178080 */   // Label 3286: @178080
     /* 178080 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(178163), // Rule ID 1744 //
     /* 178085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 178093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 178118 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 178121 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 178126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178130 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178146 */     // (intrinsic_wo_chain:{ *:[v2i64] } 680:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 178146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 178149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 178157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 178161 */     GIR_RootConstrainSelectedInstOperands,
     /* 178162 */     // GIR_Coverage, 1744,
     /* 178162 */     GIR_EraseRootFromParent_Done,
     /* 178163 */   // Label 3287: @178163
     /* 178163 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(178246), // Rule ID 1746 //
     /* 178168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 178176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 178201 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 178204 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 178209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178213 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178229 */     // (intrinsic_wo_chain:{ *:[v4i32] } 699:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 178229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 178232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 178240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 178244 */     GIR_RootConstrainSelectedInstOperands,
     /* 178245 */     // GIR_Coverage, 1746,
     /* 178245 */     GIR_EraseRootFromParent_Done,
     /* 178246 */   // Label 3288: @178246
     /* 178246 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(178329), // Rule ID 1748 //
     /* 178251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 178259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 178284 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 178287 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 178292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178296 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178312 */     // (intrinsic_wo_chain:{ *:[v2i64] } 699:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 178312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 178315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 178323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 178327 */     GIR_RootConstrainSelectedInstOperands,
     /* 178328 */     // GIR_Coverage, 1748,
     /* 178328 */     GIR_EraseRootFromParent_Done,
     /* 178329 */   // Label 3289: @178329
     /* 178329 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(178409), // Rule ID 5273 //
     /* 178334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 178339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 178364 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 178367 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 178372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 178376 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 178380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178392 */     // (intrinsic_wo_chain:{ *:[i64] } 680:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 178395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 178403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 178407 */     GIR_RootConstrainSelectedInstOperands,
     /* 178408 */     // GIR_Coverage, 5273,
     /* 178408 */     GIR_EraseRootFromParent_Done,
     /* 178409 */   // Label 3290: @178409
     /* 178409 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(178489), // Rule ID 5274 //
     /* 178414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 178419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 178444 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 178447 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 178452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 178456 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 178460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178472 */     // (intrinsic_wo_chain:{ *:[i64] } 699:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 178475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 178483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 178487 */     GIR_RootConstrainSelectedInstOperands,
     /* 178488 */     // GIR_Coverage, 5274,
     /* 178488 */     GIR_EraseRootFromParent_Done,
     /* 178489 */   // Label 3291: @178489
     /* 178489 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(178586), // Rule ID 5270 //
     /* 178494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 178497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178540 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 178544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178546 */     // (intrinsic_wo_chain:{ *:[f16] } 611:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 178546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 178549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 178553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178558 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 178564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 178577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178584 */     GIR_RootConstrainSelectedInstOperands,
     /* 178585 */     // GIR_Coverage, 5270,
     /* 178585 */     GIR_EraseRootFromParent_Done,
     /* 178586 */   // Label 3292: @178586
     /* 178586 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(178683), // Rule ID 5271 //
     /* 178591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178637 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 178641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178643 */     // (intrinsic_wo_chain:{ *:[f32] } 611:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 178643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 178650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178655 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 178661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 178674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178681 */     GIR_RootConstrainSelectedInstOperands,
     /* 178682 */     // GIR_Coverage, 5271,
     /* 178682 */     GIR_EraseRootFromParent_Done,
     /* 178683 */   // Label 3293: @178683
     /* 178683 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(178780), // Rule ID 5272 //
     /* 178688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178734 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 178738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178740 */     // (intrinsic_wo_chain:{ *:[f64] } 611:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 178740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 178747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178752 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 178758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 178771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178778 */     GIR_RootConstrainSelectedInstOperands,
     /* 178779 */     // GIR_Coverage, 5272,
     /* 178779 */     GIR_EraseRootFromParent_Done,
     /* 178780 */   // Label 3294: @178780
     /* 178780 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(178861), // Rule ID 13522 //
     /* 178785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178835 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178839 */     // MIs[2] Operand 1
     /* 178839 */     // No operand predicates
     /* 178839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178845 */     // (intrinsic_wo_chain:{ *:[v4f16] } 611:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 178848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178859 */     GIR_RootConstrainSelectedInstOperands,
     /* 178860 */     // GIR_Coverage, 13522,
     /* 178860 */     GIR_EraseRootFromParent_Done,
     /* 178861 */   // Label 3295: @178861
     /* 178861 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(178942), // Rule ID 13523 //
     /* 178866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178916 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178920 */     // MIs[2] Operand 1
     /* 178920 */     // No operand predicates
     /* 178920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178926 */     // (intrinsic_wo_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 178929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178940 */     GIR_RootConstrainSelectedInstOperands,
     /* 178941 */     // GIR_Coverage, 13523,
     /* 178941 */     GIR_EraseRootFromParent_Done,
     /* 178942 */   // Label 3296: @178942
     /* 178942 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(179023), // Rule ID 13525 //
     /* 178947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178997 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179001 */     // MIs[2] Operand 1
     /* 179001 */     // No operand predicates
     /* 179001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179007 */     // (intrinsic_wo_chain:{ *:[v2f32] } 611:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 179010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179021 */     GIR_RootConstrainSelectedInstOperands,
     /* 179022 */     // GIR_Coverage, 13525,
     /* 179022 */     GIR_EraseRootFromParent_Done,
     /* 179023 */   // Label 3297: @179023
     /* 179023 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(179104), // Rule ID 13526 //
     /* 179028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179078 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179082 */     // MIs[2] Operand 1
     /* 179082 */     // No operand predicates
     /* 179082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179088 */     // (intrinsic_wo_chain:{ *:[v4f32] } 611:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 179091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179102 */     GIR_RootConstrainSelectedInstOperands,
     /* 179103 */     // GIR_Coverage, 13526,
     /* 179103 */     GIR_EraseRootFromParent_Done,
     /* 179104 */   // Label 3298: @179104
     /* 179104 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(179185), // Rule ID 13527 //
     /* 179109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 179138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 179142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179159 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 179163 */     // MIs[2] Operand 1
     /* 179163 */     // No operand predicates
     /* 179163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179169 */     // (intrinsic_wo_chain:{ *:[v2f64] } 611:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 179172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179183 */     GIR_RootConstrainSelectedInstOperands,
     /* 179184 */     // GIR_Coverage, 13527,
     /* 179184 */     GIR_EraseRootFromParent_Done,
     /* 179185 */   // Label 3299: @179185
     /* 179185 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(179266), // Rule ID 13528 //
     /* 179190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 179193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 179201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 179204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 179207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 179219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179240 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179244 */     // MIs[2] Operand 1
     /* 179244 */     // No operand predicates
     /* 179244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179250 */     // (intrinsic_wo_chain:{ *:[f16] } 611:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 179253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179264 */     GIR_RootConstrainSelectedInstOperands,
     /* 179265 */     // GIR_Coverage, 13528,
     /* 179265 */     GIR_EraseRootFromParent_Done,
     /* 179266 */   // Label 3300: @179266
     /* 179266 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(179347), // Rule ID 13529 //
     /* 179271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 179300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179321 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179325 */     // MIs[2] Operand 1
     /* 179325 */     // No operand predicates
     /* 179325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179331 */     // (intrinsic_wo_chain:{ *:[f32] } 611:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 179334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179345 */     GIR_RootConstrainSelectedInstOperands,
     /* 179346 */     // GIR_Coverage, 13529,
     /* 179346 */     GIR_EraseRootFromParent_Done,
     /* 179347 */   // Label 3301: @179347
     /* 179347 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(179428), // Rule ID 13530 //
     /* 179352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 179381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 179385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179402 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 179406 */     // MIs[2] Operand 1
     /* 179406 */     // No operand predicates
     /* 179406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179412 */     // (intrinsic_wo_chain:{ *:[f64] } 611:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 179415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179426 */     GIR_RootConstrainSelectedInstOperands,
     /* 179427 */     // GIR_Coverage, 13530,
     /* 179427 */     GIR_EraseRootFromParent_Done,
     /* 179428 */   // Label 3302: @179428
     /* 179428 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(179534), // Rule ID 6336 //
     /* 179433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 179438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 179441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 179459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 179463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179468 */     // MIs[1] Operand 2
     /* 179468 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 179479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 179483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179487 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 179491 */     // MIs[2] Operand 1
     /* 179491 */     // No operand predicates
     /* 179491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179493 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 179493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 179496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179505 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 179511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 179524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 179532 */     GIR_RootConstrainSelectedInstOperands,
     /* 179533 */     // GIR_Coverage, 6336,
     /* 179533 */     GIR_EraseRootFromParent_Done,
     /* 179534 */   // Label 3303: @179534
     /* 179534 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(179615), // Rule ID 1988 //
     /* 179539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 179542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179593 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179597 */     // MIs[2] Operand 1
     /* 179597 */     // No operand predicates
     /* 179597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179599 */     // (intrinsic_wo_chain:{ *:[v4f16] } 611:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 179602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179613 */     GIR_RootConstrainSelectedInstOperands,
     /* 179614 */     // GIR_Coverage, 1988,
     /* 179614 */     GIR_EraseRootFromParent_Done,
     /* 179615 */   // Label 3304: @179615
     /* 179615 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(179696), // Rule ID 1989 //
     /* 179620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 179623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179674 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179678 */     // MIs[2] Operand 1
     /* 179678 */     // No operand predicates
     /* 179678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179680 */     // (intrinsic_wo_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 179683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179694 */     GIR_RootConstrainSelectedInstOperands,
     /* 179695 */     // GIR_Coverage, 1989,
     /* 179695 */     GIR_EraseRootFromParent_Done,
     /* 179696 */   // Label 3305: @179696
     /* 179696 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(179777), // Rule ID 2018 //
     /* 179701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179755 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179759 */     // MIs[2] Operand 1
     /* 179759 */     // No operand predicates
     /* 179759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179761 */     // (intrinsic_wo_chain:{ *:[v4i16] } 681:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 179764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179775 */     GIR_RootConstrainSelectedInstOperands,
     /* 179776 */     // GIR_Coverage, 2018,
     /* 179776 */     GIR_EraseRootFromParent_Done,
     /* 179777 */   // Label 3306: @179777
     /* 179777 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(179858), // Rule ID 2019 //
     /* 179782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179836 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179840 */     // MIs[2] Operand 1
     /* 179840 */     // No operand predicates
     /* 179840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179842 */     // (intrinsic_wo_chain:{ *:[v8i16] } 681:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 179845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179856 */     GIR_RootConstrainSelectedInstOperands,
     /* 179857 */     // GIR_Coverage, 2019,
     /* 179857 */     GIR_EraseRootFromParent_Done,
     /* 179858 */   // Label 3307: @179858
     /* 179858 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(179939), // Rule ID 2025 //
     /* 179863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179917 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179921 */     // MIs[2] Operand 1
     /* 179921 */     // No operand predicates
     /* 179921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179923 */     // (intrinsic_wo_chain:{ *:[v4i16] } 689:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 179926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179937 */     GIR_RootConstrainSelectedInstOperands,
     /* 179938 */     // GIR_Coverage, 2025,
     /* 179938 */     GIR_EraseRootFromParent_Done,
     /* 179939 */   // Label 3308: @179939
     /* 179939 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(180020), // Rule ID 2026 //
     /* 179944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179998 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 180002 */     // MIs[2] Operand 1
     /* 180002 */     // No operand predicates
     /* 180002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180004 */     // (intrinsic_wo_chain:{ *:[v8i16] } 689:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 180007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180018 */     GIR_RootConstrainSelectedInstOperands,
     /* 180019 */     // GIR_Coverage, 2026,
     /* 180019 */     GIR_EraseRootFromParent_Done,
     /* 180020 */   // Label 3309: @180020
     /* 180020 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(180101), // Rule ID 2084 //
     /* 180025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 180033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 180039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 180042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 180058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 180062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 180071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180079 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 180083 */     // MIs[2] Operand 1
     /* 180083 */     // No operand predicates
     /* 180083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180085 */     // (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 180088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180099 */     GIR_RootConstrainSelectedInstOperands,
     /* 180100 */     // GIR_Coverage, 2084,
     /* 180100 */     GIR_EraseRootFromParent_Done,
     /* 180101 */   // Label 3310: @180101
     /* 180101 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(180182), // Rule ID 1991 //
     /* 180106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180160 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180164 */     // MIs[2] Operand 1
     /* 180164 */     // No operand predicates
     /* 180164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180166 */     // (intrinsic_wo_chain:{ *:[v2f32] } 611:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 180169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180180 */     GIR_RootConstrainSelectedInstOperands,
     /* 180181 */     // GIR_Coverage, 1991,
     /* 180181 */     GIR_EraseRootFromParent_Done,
     /* 180182 */   // Label 3311: @180182
     /* 180182 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(180263), // Rule ID 1992 //
     /* 180187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180241 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180245 */     // MIs[2] Operand 1
     /* 180245 */     // No operand predicates
     /* 180245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180247 */     // (intrinsic_wo_chain:{ *:[v4f32] } 611:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 180250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180261 */     GIR_RootConstrainSelectedInstOperands,
     /* 180262 */     // GIR_Coverage, 1992,
     /* 180262 */     GIR_EraseRootFromParent_Done,
     /* 180263 */   // Label 3312: @180263
     /* 180263 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(180344), // Rule ID 2021 //
     /* 180268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 180276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180322 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180326 */     // MIs[2] Operand 1
     /* 180326 */     // No operand predicates
     /* 180326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180328 */     // (intrinsic_wo_chain:{ *:[v2i32] } 681:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 180331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180342 */     GIR_RootConstrainSelectedInstOperands,
     /* 180343 */     // GIR_Coverage, 2021,
     /* 180343 */     GIR_EraseRootFromParent_Done,
     /* 180344 */   // Label 3313: @180344
     /* 180344 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(180425), // Rule ID 2022 //
     /* 180349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 180357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180403 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180407 */     // MIs[2] Operand 1
     /* 180407 */     // No operand predicates
     /* 180407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180409 */     // (intrinsic_wo_chain:{ *:[v4i32] } 681:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 180412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180423 */     GIR_RootConstrainSelectedInstOperands,
     /* 180424 */     // GIR_Coverage, 2022,
     /* 180424 */     GIR_EraseRootFromParent_Done,
     /* 180425 */   // Label 3314: @180425
     /* 180425 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(180506), // Rule ID 2028 //
     /* 180430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 180438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180484 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180488 */     // MIs[2] Operand 1
     /* 180488 */     // No operand predicates
     /* 180488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180490 */     // (intrinsic_wo_chain:{ *:[v2i32] } 689:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 180493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180504 */     GIR_RootConstrainSelectedInstOperands,
     /* 180505 */     // GIR_Coverage, 2028,
     /* 180505 */     GIR_EraseRootFromParent_Done,
     /* 180506 */   // Label 3315: @180506
     /* 180506 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(180587), // Rule ID 2029 //
     /* 180511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 180519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180565 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180569 */     // MIs[2] Operand 1
     /* 180569 */     // No operand predicates
     /* 180569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180571 */     // (intrinsic_wo_chain:{ *:[v4i32] } 689:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 180574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180585 */     GIR_RootConstrainSelectedInstOperands,
     /* 180586 */     // GIR_Coverage, 2029,
     /* 180586 */     GIR_EraseRootFromParent_Done,
     /* 180587 */   // Label 3316: @180587
     /* 180587 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(180668), // Rule ID 2087 //
     /* 180592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 180600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180646 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180650 */     // MIs[2] Operand 1
     /* 180650 */     // No operand predicates
     /* 180650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180652 */     // (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 180655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180666 */     GIR_RootConstrainSelectedInstOperands,
     /* 180667 */     // GIR_Coverage, 2087,
     /* 180667 */     GIR_EraseRootFromParent_Done,
     /* 180668 */   // Label 3317: @180668
     /* 180668 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(180749), // Rule ID 1993 //
     /* 180673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 180706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 180710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180727 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 180731 */     // MIs[2] Operand 1
     /* 180731 */     // No operand predicates
     /* 180731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180733 */     // (intrinsic_wo_chain:{ *:[v2f64] } 611:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 180736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180747 */     GIR_RootConstrainSelectedInstOperands,
     /* 180748 */     // GIR_Coverage, 1993,
     /* 180748 */     GIR_EraseRootFromParent_Done,
     /* 180749 */   // Label 3318: @180749
     /* 180749 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(180830), // Rule ID 1994 //
     /* 180754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 180757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 180768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 180771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 180791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 180800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 180812 */     // MIs[2] Operand 1
     /* 180812 */     // No operand predicates
     /* 180812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180814 */     // (intrinsic_wo_chain:{ *:[f16] } 611:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 180817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180828 */     GIR_RootConstrainSelectedInstOperands,
     /* 180829 */     // GIR_Coverage, 1994,
     /* 180829 */     GIR_EraseRootFromParent_Done,
     /* 180830 */   // Label 3319: @180830
     /* 180830 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(180911), // Rule ID 1995 //
     /* 180835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180889 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180893 */     // MIs[2] Operand 1
     /* 180893 */     // No operand predicates
     /* 180893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180895 */     // (intrinsic_wo_chain:{ *:[f32] } 611:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 180898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180909 */     GIR_RootConstrainSelectedInstOperands,
     /* 180910 */     // GIR_Coverage, 1995,
     /* 180910 */     GIR_EraseRootFromParent_Done,
     /* 180911 */   // Label 3320: @180911
     /* 180911 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(180992), // Rule ID 1996 //
     /* 180916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 180953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180970 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 180974 */     // MIs[2] Operand 1
     /* 180974 */     // No operand predicates
     /* 180974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180976 */     // (intrinsic_wo_chain:{ *:[f64] } 611:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 180979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180990 */     GIR_RootConstrainSelectedInstOperands,
     /* 180991 */     // GIR_Coverage, 1996,
     /* 180991 */     GIR_EraseRootFromParent_Done,
     /* 180992 */   // Label 3321: @180992
     /* 180992 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(181073), // Rule ID 2023 //
     /* 180997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 181005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 181030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 181038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 181047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181051 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 181055 */     // MIs[2] Operand 1
     /* 181055 */     // No operand predicates
     /* 181055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 181057 */     // (intrinsic_wo_chain:{ *:[i32] } 681:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 181057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 181060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 181068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 181071 */     GIR_RootConstrainSelectedInstOperands,
     /* 181072 */     // GIR_Coverage, 2023,
     /* 181072 */     GIR_EraseRootFromParent_Done,
     /* 181073 */   // Label 3322: @181073
     /* 181073 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(181154), // Rule ID 2030 //
     /* 181078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 181086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 181111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 181119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 181128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181132 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 181136 */     // MIs[2] Operand 1
     /* 181136 */     // No operand predicates
     /* 181136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 181138 */     // (intrinsic_wo_chain:{ *:[i32] } 689:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 181138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 181141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 181149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 181152 */     GIR_RootConstrainSelectedInstOperands,
     /* 181153 */     // GIR_Coverage, 2030,
     /* 181153 */     GIR_EraseRootFromParent_Done,
     /* 181154 */   // Label 3323: @181154
     /* 181154 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(181232), // Rule ID 6323 //
     /* 181159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 181164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 181189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 181197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 181206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181210 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 181214 */     // MIs[2] Operand 1
     /* 181214 */     // No operand predicates
     /* 181214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 181216 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 181216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 181219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 181227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 181230 */     GIR_RootConstrainSelectedInstOperands,
     /* 181231 */     // GIR_Coverage, 6323,
     /* 181231 */     GIR_EraseRootFromParent_Done,
     /* 181232 */   // Label 3324: @181232
     /* 181232 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(181292), // Rule ID 6389 //
     /* 181237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 181263 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 181263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 181266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 181270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181275 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 181278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 181283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181290 */     GIR_RootConstrainSelectedInstOperands,
     /* 181291 */     // GIR_Coverage, 6389,
     /* 181291 */     GIR_EraseRootFromParent_Done,
     /* 181292 */   // Label 3325: @181292
     /* 181292 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(181352), // Rule ID 6390 //
     /* 181297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 181323 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 181323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 181326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 181330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 181338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 181343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181350 */     GIR_RootConstrainSelectedInstOperands,
     /* 181351 */     // GIR_Coverage, 6390,
     /* 181351 */     GIR_EraseRootFromParent_Done,
     /* 181352 */   // Label 3326: @181352
     /* 181352 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(181412), // Rule ID 6391 //
     /* 181357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 181383 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 181383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 181386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 181390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181395 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 181398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 181403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181410 */     GIR_RootConstrainSelectedInstOperands,
     /* 181411 */     // GIR_Coverage, 6391,
     /* 181411 */     GIR_EraseRootFromParent_Done,
     /* 181412 */   // Label 3327: @181412
     /* 181412 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(181459), // Rule ID 3897 //
     /* 181417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 181420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 181425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181439 */     // MIs[0] Operand 3
     /* 181439 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 181450 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 181450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 181453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181457 */     GIR_RootConstrainSelectedInstOperands,
     /* 181458 */     // GIR_Coverage, 3897,
     /* 181458 */     GIR_EraseRootFromParent_Done,
     /* 181459 */   // Label 3328: @181459
     /* 181459 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(181506), // Rule ID 3898 //
     /* 181464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 181467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 181472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181486 */     // MIs[0] Operand 3
     /* 181486 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 181497 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 181497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 181500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181504 */     GIR_RootConstrainSelectedInstOperands,
     /* 181505 */     // GIR_Coverage, 3898,
     /* 181505 */     GIR_EraseRootFromParent_Done,
     /* 181506 */   // Label 3329: @181506
     /* 181506 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(181553), // Rule ID 3899 //
     /* 181511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 181514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 181519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181533 */     // MIs[0] Operand 3
     /* 181533 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 181544 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 181544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 181547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181551 */     GIR_RootConstrainSelectedInstOperands,
     /* 181552 */     // GIR_Coverage, 3899,
     /* 181552 */     GIR_EraseRootFromParent_Done,
     /* 181553 */   // Label 3330: @181553
     /* 181553 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(181600), // Rule ID 3900 //
     /* 181558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 181561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 181566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181580 */     // MIs[0] Operand 3
     /* 181580 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 181591 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 181591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 181594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181598 */     GIR_RootConstrainSelectedInstOperands,
     /* 181599 */     // GIR_Coverage, 3900,
     /* 181599 */     GIR_EraseRootFromParent_Done,
     /* 181600 */   // Label 3331: @181600
     /* 181600 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(181646), // Rule ID 3544 //
     /* 181605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 181613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 181616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181627 */     // MIs[0] Idx
     /* 181627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 181635 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 181635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 181638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181644 */     GIR_RootConstrainSelectedInstOperands,
     /* 181645 */     // GIR_Coverage, 3544,
     /* 181645 */     GIR_EraseRootFromParent_Done,
     /* 181646 */   // Label 3332: @181646
     /* 181646 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(181692), // Rule ID 3545 //
     /* 181651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 181659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 181662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181673 */     // MIs[0] Idx
     /* 181673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 181681 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 181681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 181684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181690 */     GIR_RootConstrainSelectedInstOperands,
     /* 181691 */     // GIR_Coverage, 3545,
     /* 181691 */     GIR_EraseRootFromParent_Done,
     /* 181692 */   // Label 3333: @181692
     /* 181692 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(181738), // Rule ID 3546 //
     /* 181697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 181705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 181708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181719 */     // MIs[0] Idx
     /* 181719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181722 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 181727 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 181727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 181730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181736 */     GIR_RootConstrainSelectedInstOperands,
     /* 181737 */     // GIR_Coverage, 3546,
     /* 181737 */     GIR_EraseRootFromParent_Done,
     /* 181738 */   // Label 3334: @181738
     /* 181738 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(181784), // Rule ID 3547 //
     /* 181743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 181751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 181754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181765 */     // MIs[0] Idx
     /* 181765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 181773 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 181773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 181776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181782 */     GIR_RootConstrainSelectedInstOperands,
     /* 181783 */     // GIR_Coverage, 3547,
     /* 181783 */     GIR_EraseRootFromParent_Done,
     /* 181784 */   // Label 3335: @181784
     /* 181784 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(181840), // Rule ID 2109 //
     /* 181789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 181797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181826 */     // MIs[1] Operand 1
     /* 181826 */     // No operand predicates
     /* 181826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181828 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 181831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181838 */     GIR_RootConstrainSelectedInstOperands,
     /* 181839 */     // GIR_Coverage, 2109,
     /* 181839 */     GIR_EraseRootFromParent_Done,
     /* 181840 */   // Label 3336: @181840
     /* 181840 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(181896), // Rule ID 2110 //
     /* 181845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 181853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181882 */     // MIs[1] Operand 1
     /* 181882 */     // No operand predicates
     /* 181882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181884 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 181887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181894 */     GIR_RootConstrainSelectedInstOperands,
     /* 181895 */     // GIR_Coverage, 2110,
     /* 181895 */     GIR_EraseRootFromParent_Done,
     /* 181896 */   // Label 3337: @181896
     /* 181896 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(181952), // Rule ID 2115 //
     /* 181901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 181909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181934 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181938 */     // MIs[1] Operand 1
     /* 181938 */     // No operand predicates
     /* 181938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181940 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 181943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181950 */     GIR_RootConstrainSelectedInstOperands,
     /* 181951 */     // GIR_Coverage, 2115,
     /* 181951 */     GIR_EraseRootFromParent_Done,
     /* 181952 */   // Label 3338: @181952
     /* 181952 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(182008), // Rule ID 2116 //
     /* 181957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 181965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181994 */     // MIs[1] Operand 1
     /* 181994 */     // No operand predicates
     /* 181994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181996 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 181999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182006 */     GIR_RootConstrainSelectedInstOperands,
     /* 182007 */     // GIR_Coverage, 2116,
     /* 182007 */     GIR_EraseRootFromParent_Done,
     /* 182008 */   // Label 3339: @182008
     /* 182008 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(182064), // Rule ID 2123 //
     /* 182013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 182021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182050 */     // MIs[1] Operand 1
     /* 182050 */     // No operand predicates
     /* 182050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182052 */     // (intrinsic_wo_chain:{ *:[i32] } 742:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 182052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 182055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182062 */     GIR_RootConstrainSelectedInstOperands,
     /* 182063 */     // GIR_Coverage, 2123,
     /* 182063 */     GIR_EraseRootFromParent_Done,
     /* 182064 */   // Label 3340: @182064
     /* 182064 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(182120), // Rule ID 2126 //
     /* 182069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 182077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182106 */     // MIs[1] Operand 1
     /* 182106 */     // No operand predicates
     /* 182106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182108 */     // (intrinsic_wo_chain:{ *:[i32] } 744:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 182108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 182111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182118 */     GIR_RootConstrainSelectedInstOperands,
     /* 182119 */     // GIR_Coverage, 2126,
     /* 182119 */     GIR_EraseRootFromParent_Done,
     /* 182120 */   // Label 3341: @182120
     /* 182120 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(182176), // Rule ID 2148 //
     /* 182125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 182133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 182136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 182139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 182162 */     // MIs[1] Operand 1
     /* 182162 */     // No operand predicates
     /* 182162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182164 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 182164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 182167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182174 */     GIR_RootConstrainSelectedInstOperands,
     /* 182175 */     // GIR_Coverage, 2148,
     /* 182175 */     GIR_EraseRootFromParent_Done,
     /* 182176 */   // Label 3342: @182176
     /* 182176 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(182232), // Rule ID 2150 //
     /* 182181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 182189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 182192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 182195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182214 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 182218 */     // MIs[1] Operand 1
     /* 182218 */     // No operand predicates
     /* 182218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182220 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 182220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 182223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182230 */     GIR_RootConstrainSelectedInstOperands,
     /* 182231 */     // GIR_Coverage, 2150,
     /* 182231 */     GIR_EraseRootFromParent_Done,
     /* 182232 */   // Label 3343: @182232
     /* 182232 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(182288), // Rule ID 2152 //
     /* 182237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 182245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 182248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 182251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 182274 */     // MIs[1] Operand 1
     /* 182274 */     // No operand predicates
     /* 182274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182276 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 182276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 182279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182286 */     GIR_RootConstrainSelectedInstOperands,
     /* 182287 */     // GIR_Coverage, 2152,
     /* 182287 */     GIR_EraseRootFromParent_Done,
     /* 182288 */   // Label 3344: @182288
     /* 182288 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(182341), // Rule ID 6324 //
     /* 182293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182327 */     // MIs[1] Operand 1
     /* 182327 */     // No operand predicates
     /* 182327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182329 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 182329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 182332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182339 */     GIR_RootConstrainSelectedInstOperands,
     /* 182340 */     // GIR_Coverage, 6324,
     /* 182340 */     GIR_EraseRootFromParent_Done,
     /* 182341 */   // Label 3345: @182341
     /* 182341 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(182394), // Rule ID 6325 //
     /* 182346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 182351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182380 */     // MIs[1] Operand 1
     /* 182380 */     // No operand predicates
     /* 182380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182382 */     // (intrinsic_wo_chain:{ *:[i32] } 764:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 182382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 182385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182392 */     GIR_RootConstrainSelectedInstOperands,
     /* 182393 */     // GIR_Coverage, 6325,
     /* 182393 */     GIR_EraseRootFromParent_Done,
     /* 182394 */   // Label 3346: @182394
     /* 182394 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(182447), // Rule ID 6326 //
     /* 182399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182433 */     // MIs[1] Operand 1
     /* 182433 */     // No operand predicates
     /* 182433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182435 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 182438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182445 */     GIR_RootConstrainSelectedInstOperands,
     /* 182446 */     // GIR_Coverage, 6326,
     /* 182446 */     GIR_EraseRootFromParent_Done,
     /* 182447 */   // Label 3347: @182447
     /* 182447 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(182500), // Rule ID 6327 //
     /* 182452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 182457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182486 */     // MIs[1] Operand 1
     /* 182486 */     // No operand predicates
     /* 182486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182488 */     // (intrinsic_wo_chain:{ *:[i64] } 764:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 182491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182498 */     GIR_RootConstrainSelectedInstOperands,
     /* 182499 */     // GIR_Coverage, 6327,
     /* 182499 */     GIR_EraseRootFromParent_Done,
     /* 182500 */   // Label 3348: @182500
     /* 182500 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(182553), // Rule ID 6328 //
     /* 182505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182539 */     // MIs[1] Operand 1
     /* 182539 */     // No operand predicates
     /* 182539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182541 */     // (intrinsic_wo_chain:{ *:[v1i64] } 763:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 182544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182551 */     GIR_RootConstrainSelectedInstOperands,
     /* 182552 */     // GIR_Coverage, 6328,
     /* 182552 */     GIR_EraseRootFromParent_Done,
     /* 182553 */   // Label 3349: @182553
     /* 182553 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(182606), // Rule ID 6329 //
     /* 182558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 182563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182592 */     // MIs[1] Operand 1
     /* 182592 */     // No operand predicates
     /* 182592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182594 */     // (intrinsic_wo_chain:{ *:[v1i64] } 764:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 182597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182604 */     GIR_RootConstrainSelectedInstOperands,
     /* 182605 */     // GIR_Coverage, 6329,
     /* 182605 */     GIR_EraseRootFromParent_Done,
     /* 182606 */   // Label 3350: @182606
     /* 182606 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(182659), // Rule ID 6330 //
     /* 182611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182645 */     // MIs[1] Operand 1
     /* 182645 */     // No operand predicates
     /* 182645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182647 */     // (intrinsic_wo_chain:{ *:[f32] } 767:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 182647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 182650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182657 */     GIR_RootConstrainSelectedInstOperands,
     /* 182658 */     // GIR_Coverage, 6330,
     /* 182658 */     GIR_EraseRootFromParent_Done,
     /* 182659 */   // Label 3351: @182659
     /* 182659 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(182712), // Rule ID 6331 //
     /* 182664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182698 */     // MIs[1] Operand 1
     /* 182698 */     // No operand predicates
     /* 182698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182700 */     // (intrinsic_wo_chain:{ *:[f64] } 767:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 182703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182710 */     GIR_RootConstrainSelectedInstOperands,
     /* 182711 */     // GIR_Coverage, 6331,
     /* 182711 */     GIR_EraseRootFromParent_Done,
     /* 182712 */   // Label 3352: @182712
     /* 182712 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(182765), // Rule ID 6332 //
     /* 182717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182751 */     // MIs[1] Operand 1
     /* 182751 */     // No operand predicates
     /* 182751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182753 */     // (intrinsic_wo_chain:{ *:[v1f64] } 766:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 182756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182763 */     GIR_RootConstrainSelectedInstOperands,
     /* 182764 */     // GIR_Coverage, 6332,
     /* 182764 */     GIR_EraseRootFromParent_Done,
     /* 182765 */   // Label 3353: @182765
     /* 182765 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(182818), // Rule ID 6333 //
     /* 182770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182804 */     // MIs[1] Operand 1
     /* 182804 */     // No operand predicates
     /* 182804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182806 */     // (intrinsic_wo_chain:{ *:[f64] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 182809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182816 */     GIR_RootConstrainSelectedInstOperands,
     /* 182817 */     // GIR_Coverage, 6333,
     /* 182817 */     GIR_EraseRootFromParent_Done,
     /* 182818 */   // Label 3354: @182818
     /* 182818 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(182871), // Rule ID 6334 //
     /* 182823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182857 */     // MIs[1] Operand 1
     /* 182857 */     // No operand predicates
     /* 182857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182859 */     // (intrinsic_wo_chain:{ *:[v1f64] } 767:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 182862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182869 */     GIR_RootConstrainSelectedInstOperands,
     /* 182870 */     // GIR_Coverage, 6334,
     /* 182870 */     GIR_EraseRootFromParent_Done,
     /* 182871 */   // Label 3355: @182871
     /* 182871 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(182924), // Rule ID 6335 //
     /* 182876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182910 */     // MIs[1] Operand 1
     /* 182910 */     // No operand predicates
     /* 182910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182912 */     // (intrinsic_wo_chain:{ *:[f32] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 182912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 182915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182922 */     GIR_RootConstrainSelectedInstOperands,
     /* 182923 */     // GIR_Coverage, 6335,
     /* 182923 */     GIR_EraseRootFromParent_Done,
     /* 182924 */   // Label 3356: @182924
     /* 182924 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(183006), // Rule ID 6337 //
     /* 182929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182963 */     // MIs[1] Operand 1
     /* 182963 */     // No operand predicates
     /* 182963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182965 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182977 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 182996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183004 */     GIR_RootConstrainSelectedInstOperands,
     /* 183005 */     // GIR_Coverage, 6337,
     /* 183005 */     GIR_EraseRootFromParent_Done,
     /* 183006 */   // Label 3357: @183006
     /* 183006 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(183088), // Rule ID 6338 //
     /* 183011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 183016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 183019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 183045 */     // MIs[1] Operand 1
     /* 183045 */     // No operand predicates
     /* 183045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183047 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 183047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 183050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183059 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 183065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 183078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183086 */     GIR_RootConstrainSelectedInstOperands,
     /* 183087 */     // GIR_Coverage, 6338,
     /* 183087 */     GIR_EraseRootFromParent_Done,
     /* 183088 */   // Label 3358: @183088
     /* 183088 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(183170), // Rule ID 6340 //
     /* 183093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 183098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 183101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 183127 */     // MIs[1] Operand 1
     /* 183127 */     // No operand predicates
     /* 183127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183129 */     // (intrinsic_wo_chain:{ *:[f16] } 767:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 183129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 183132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183141 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 183147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 183160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183168 */     GIR_RootConstrainSelectedInstOperands,
     /* 183169 */     // GIR_Coverage, 6340,
     /* 183169 */     GIR_EraseRootFromParent_Done,
     /* 183170 */   // Label 3359: @183170
     /* 183170 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(183252), // Rule ID 6341 //
     /* 183175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 183180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 183183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 183209 */     // MIs[1] Operand 1
     /* 183209 */     // No operand predicates
     /* 183209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183211 */     // (intrinsic_wo_chain:{ *:[f16] } 767:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 183211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 183214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183223 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 183229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 183242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183250 */     GIR_RootConstrainSelectedInstOperands,
     /* 183251 */     // GIR_Coverage, 6341,
     /* 183251 */     GIR_EraseRootFromParent_Done,
     /* 183252 */   // Label 3360: @183252
     /* 183252 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(183358), // Rule ID 6342 //
     /* 183257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 183262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 183268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 183291 */     // MIs[1] Operand 1
     /* 183291 */     // No operand predicates
     /* 183291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183293 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 183293 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183296 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 183300 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183305 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 183312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 183317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183357 */     // GIR_Coverage, 6342,
     /* 183357 */     GIR_EraseRootFromParent_Done,
     /* 183358 */   // Label 3361: @183358
     /* 183358 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(183464), // Rule ID 6343 //
     /* 183363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 183368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 183374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 183397 */     // MIs[1] Operand 1
     /* 183397 */     // No operand predicates
     /* 183397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183399 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 183399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 183406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183411 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 183418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 183423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183463 */     // GIR_Coverage, 6343,
     /* 183463 */     GIR_EraseRootFromParent_Done,
     /* 183464 */   // Label 3362: @183464
     /* 183464 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(183570), // Rule ID 6344 //
     /* 183469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 183480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 183503 */     // MIs[1] Operand 1
     /* 183503 */     // No operand predicates
     /* 183503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183505 */     // (intrinsic_wo_chain:{ *:[i32] } 764:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 183505 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183508 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 183512 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183517 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 183524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 183529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183569 */     // GIR_Coverage, 6344,
     /* 183569 */     GIR_EraseRootFromParent_Done,
     /* 183570 */   // Label 3363: @183570
     /* 183570 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(183676), // Rule ID 6345 //
     /* 183575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 183586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 183609 */     // MIs[1] Operand 1
     /* 183609 */     // No operand predicates
     /* 183609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183611 */     // (intrinsic_wo_chain:{ *:[i64] } 764:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 183611 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183614 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 183618 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183623 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 183630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 183635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183675 */     // GIR_Coverage, 6345,
     /* 183675 */     GIR_EraseRootFromParent_Done,
     /* 183676 */   // Label 3364: @183676
     /* 183676 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(183734), // Rule ID 7036 //
     /* 183681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 183686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 183715 */     // MIs[1] Operand 1
     /* 183715 */     // No operand predicates
     /* 183715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183717 */     // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (MOVKXi:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm), 48:{ *:[i32] })
     /* 183717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVKXi),
     /* 183720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 183724 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 183729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 183732 */     GIR_RootConstrainSelectedInstOperands,
     /* 183733 */     // GIR_Coverage, 7036,
     /* 183733 */     GIR_EraseRootFromParent_Done,
     /* 183734 */   // Label 3365: @183734
     /* 183734 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(183776), // Rule ID 3045 //
     /* 183739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183757 */     // MIs[0] Op2
     /* 183757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 183765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1865:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 183765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 183768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183774 */     GIR_RootConstrainSelectedInstOperands,
     /* 183775 */     // GIR_Coverage, 3045,
     /* 183775 */     GIR_EraseRootFromParent_Done,
     /* 183776 */   // Label 3366: @183776
     /* 183776 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(183818), // Rule ID 3046 //
     /* 183781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183799 */     // MIs[0] Op2
     /* 183799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 183807 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 183807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 183810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183816 */     GIR_RootConstrainSelectedInstOperands,
     /* 183817 */     // GIR_Coverage, 3046,
     /* 183817 */     GIR_EraseRootFromParent_Done,
     /* 183818 */   // Label 3367: @183818
     /* 183818 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(183860), // Rule ID 3047 //
     /* 183823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183841 */     // MIs[0] Op2
     /* 183841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 183849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1865:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 183849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 183852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183858 */     GIR_RootConstrainSelectedInstOperands,
     /* 183859 */     // GIR_Coverage, 3047,
     /* 183859 */     GIR_EraseRootFromParent_Done,
     /* 183860 */   // Label 3368: @183860
     /* 183860 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(183902), // Rule ID 3081 //
     /* 183865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183883 */     // MIs[0] Op2
     /* 183883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183891 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1846:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 183894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183900 */     GIR_RootConstrainSelectedInstOperands,
     /* 183901 */     // GIR_Coverage, 3081,
     /* 183901 */     GIR_EraseRootFromParent_Done,
     /* 183902 */   // Label 3369: @183902
     /* 183902 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(183944), // Rule ID 3082 //
     /* 183907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183925 */     // MIs[0] Op2
     /* 183925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183933 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1846:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 183936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183942 */     GIR_RootConstrainSelectedInstOperands,
     /* 183943 */     // GIR_Coverage, 3082,
     /* 183943 */     GIR_EraseRootFromParent_Done,
     /* 183944 */   // Label 3370: @183944
     /* 183944 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(183986), // Rule ID 3083 //
     /* 183949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183967 */     // MIs[0] Op2
     /* 183967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183970 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183975 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1846:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 183978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183984 */     GIR_RootConstrainSelectedInstOperands,
     /* 183985 */     // GIR_Coverage, 3083,
     /* 183985 */     GIR_EraseRootFromParent_Done,
     /* 183986 */   // Label 3371: @183986
     /* 183986 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(184028), // Rule ID 3530 //
     /* 183991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184009 */     // MIs[0] Op2
     /* 184009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 184017 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1346:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 184017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 184020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184026 */     GIR_RootConstrainSelectedInstOperands,
     /* 184027 */     // GIR_Coverage, 3530,
     /* 184027 */     GIR_EraseRootFromParent_Done,
     /* 184028 */   // Label 3372: @184028
     /* 184028 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(184070), // Rule ID 3531 //
     /* 184033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 184041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184051 */     // MIs[0] Op2
     /* 184051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 184059 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1346:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 184059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 184062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184068 */     GIR_RootConstrainSelectedInstOperands,
     /* 184069 */     // GIR_Coverage, 3531,
     /* 184069 */     GIR_EraseRootFromParent_Done,
     /* 184070 */   // Label 3373: @184070
     /* 184070 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(184112), // Rule ID 3532 //
     /* 184075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 184083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184093 */     // MIs[0] Op2
     /* 184093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 184101 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1346:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 184101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 184104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184110 */     GIR_RootConstrainSelectedInstOperands,
     /* 184111 */     // GIR_Coverage, 3532,
     /* 184111 */     GIR_EraseRootFromParent_Done,
     /* 184112 */   // Label 3374: @184112
     /* 184112 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(184154), // Rule ID 3533 //
     /* 184117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 184125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184135 */     // MIs[0] Op2
     /* 184135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 184143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1346:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 184143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 184146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184152 */     GIR_RootConstrainSelectedInstOperands,
     /* 184153 */     // GIR_Coverage, 3533,
     /* 184153 */     GIR_EraseRootFromParent_Done,
     /* 184154 */   // Label 3375: @184154
     /* 184154 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(184196), // Rule ID 3534 //
     /* 184159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 184167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184177 */     // MIs[0] Op2
     /* 184177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 184185 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1346:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 184185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 184188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184194 */     GIR_RootConstrainSelectedInstOperands,
     /* 184195 */     // GIR_Coverage, 3534,
     /* 184195 */     GIR_EraseRootFromParent_Done,
     /* 184196 */   // Label 3376: @184196
     /* 184196 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(184238), // Rule ID 3535 //
     /* 184201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 184209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184219 */     // MIs[0] Op2
     /* 184219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 184227 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1346:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 184227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 184230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184236 */     GIR_RootConstrainSelectedInstOperands,
     /* 184237 */     // GIR_Coverage, 3535,
     /* 184237 */     GIR_EraseRootFromParent_Done,
     /* 184238 */   // Label 3377: @184238
     /* 184238 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(184280), // Rule ID 3536 //
     /* 184243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 184251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184261 */     // MIs[0] Op2
     /* 184261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 184269 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1346:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 184269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 184272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184278 */     GIR_RootConstrainSelectedInstOperands,
     /* 184279 */     // GIR_Coverage, 3536,
     /* 184279 */     GIR_EraseRootFromParent_Done,
     /* 184280 */   // Label 3378: @184280
     /* 184280 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(184322), // Rule ID 11821 //
     /* 184285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 184293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184303 */     // MIs[0] Op2
     /* 184303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184311 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1840:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 184314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184320 */     GIR_RootConstrainSelectedInstOperands,
     /* 184321 */     // GIR_Coverage, 11821,
     /* 184321 */     GIR_EraseRootFromParent_Done,
     /* 184322 */   // Label 3379: @184322
     /* 184322 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(184364), // Rule ID 11822 //
     /* 184327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 184335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184345 */     // MIs[0] Op2
     /* 184345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1840:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 184356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184362 */     GIR_RootConstrainSelectedInstOperands,
     /* 184363 */     // GIR_Coverage, 11822,
     /* 184363 */     GIR_EraseRootFromParent_Done,
     /* 184364 */   // Label 3380: @184364
     /* 184364 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(184406), // Rule ID 11823 //
     /* 184369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 184377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184387 */     // MIs[0] Op2
     /* 184387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1840:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 184398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184404 */     GIR_RootConstrainSelectedInstOperands,
     /* 184405 */     // GIR_Coverage, 11823,
     /* 184405 */     GIR_EraseRootFromParent_Done,
     /* 184406 */   // Label 3381: @184406
     /* 184406 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(184448), // Rule ID 11824 //
     /* 184411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 184419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184429 */     // MIs[0] Op2
     /* 184429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184437 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1719:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 184440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184446 */     GIR_RootConstrainSelectedInstOperands,
     /* 184447 */     // GIR_Coverage, 11824,
     /* 184447 */     GIR_EraseRootFromParent_Done,
     /* 184448 */   // Label 3382: @184448
     /* 184448 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(184490), // Rule ID 11825 //
     /* 184453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 184461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184471 */     // MIs[0] Op2
     /* 184471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184474 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184479 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1719:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 184482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184488 */     GIR_RootConstrainSelectedInstOperands,
     /* 184489 */     // GIR_Coverage, 11825,
     /* 184489 */     GIR_EraseRootFromParent_Done,
     /* 184490 */   // Label 3383: @184490
     /* 184490 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(184532), // Rule ID 11826 //
     /* 184495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 184503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184513 */     // MIs[0] Op2
     /* 184513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184521 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1719:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 184524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184530 */     GIR_RootConstrainSelectedInstOperands,
     /* 184531 */     // GIR_Coverage, 11826,
     /* 184531 */     GIR_EraseRootFromParent_Done,
     /* 184532 */   // Label 3384: @184532
     /* 184532 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(184574), // Rule ID 11828 //
     /* 184537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 184545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184555 */     // MIs[0] Op2
     /* 184555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184563 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1677:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 184566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184572 */     GIR_RootConstrainSelectedInstOperands,
     /* 184573 */     // GIR_Coverage, 11828,
     /* 184573 */     GIR_EraseRootFromParent_Done,
     /* 184574 */   // Label 3385: @184574
     /* 184574 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(184616), // Rule ID 11830 //
     /* 184579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 184587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184597 */     // MIs[0] Op2
     /* 184597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184605 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1677:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 184608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184614 */     GIR_RootConstrainSelectedInstOperands,
     /* 184615 */     // GIR_Coverage, 11830,
     /* 184615 */     GIR_EraseRootFromParent_Done,
     /* 184616 */   // Label 3386: @184616
     /* 184616 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(184658), // Rule ID 11832 //
     /* 184621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 184629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184639 */     // MIs[0] Op2
     /* 184639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1677:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 184650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184656 */     GIR_RootConstrainSelectedInstOperands,
     /* 184657 */     // GIR_Coverage, 11832,
     /* 184657 */     GIR_EraseRootFromParent_Done,
     /* 184658 */   // Label 3387: @184658
     /* 184658 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(184700), // Rule ID 11833 //
     /* 184663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 184671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184681 */     // MIs[0] Op2
     /* 184681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184689 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1844:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 184692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184698 */     GIR_RootConstrainSelectedInstOperands,
     /* 184699 */     // GIR_Coverage, 11833,
     /* 184699 */     GIR_EraseRootFromParent_Done,
     /* 184700 */   // Label 3388: @184700
     /* 184700 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(184742), // Rule ID 11834 //
     /* 184705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 184713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184723 */     // MIs[0] Op2
     /* 184723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1844:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 184734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184740 */     GIR_RootConstrainSelectedInstOperands,
     /* 184741 */     // GIR_Coverage, 11834,
     /* 184741 */     GIR_EraseRootFromParent_Done,
     /* 184742 */   // Label 3389: @184742
     /* 184742 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(184784), // Rule ID 11835 //
     /* 184747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 184755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184765 */     // MIs[0] Op2
     /* 184765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1844:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 184776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184782 */     GIR_RootConstrainSelectedInstOperands,
     /* 184783 */     // GIR_Coverage, 11835,
     /* 184783 */     GIR_EraseRootFromParent_Done,
     /* 184784 */   // Label 3390: @184784
     /* 184784 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(184826), // Rule ID 11836 //
     /* 184789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184807 */     // MIs[0] Op2
     /* 184807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184815 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1834:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 184818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184824 */     GIR_RootConstrainSelectedInstOperands,
     /* 184825 */     // GIR_Coverage, 11836,
     /* 184825 */     GIR_EraseRootFromParent_Done,
     /* 184826 */   // Label 3391: @184826
     /* 184826 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(184868), // Rule ID 11837 //
     /* 184831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184849 */     // MIs[0] Op2
     /* 184849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184857 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1834:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 184860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184866 */     GIR_RootConstrainSelectedInstOperands,
     /* 184867 */     // GIR_Coverage, 11837,
     /* 184867 */     GIR_EraseRootFromParent_Done,
     /* 184868 */   // Label 3392: @184868
     /* 184868 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(184910), // Rule ID 11838 //
     /* 184873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184891 */     // MIs[0] Op2
     /* 184891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1834:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 184902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184908 */     GIR_RootConstrainSelectedInstOperands,
     /* 184909 */     // GIR_Coverage, 11838,
     /* 184909 */     GIR_EraseRootFromParent_Done,
     /* 184910 */   // Label 3393: @184910
     /* 184910 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(184952), // Rule ID 11839 //
     /* 184915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184933 */     // MIs[0] Op2
     /* 184933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184941 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2039:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 184944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184950 */     GIR_RootConstrainSelectedInstOperands,
     /* 184951 */     // GIR_Coverage, 11839,
     /* 184951 */     GIR_EraseRootFromParent_Done,
     /* 184952 */   // Label 3394: @184952
     /* 184952 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(184994), // Rule ID 11840 //
     /* 184957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184975 */     // MIs[0] Op2
     /* 184975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184978 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184983 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2039:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 184986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184992 */     GIR_RootConstrainSelectedInstOperands,
     /* 184993 */     // GIR_Coverage, 11840,
     /* 184993 */     GIR_EraseRootFromParent_Done,
     /* 184994 */   // Label 3395: @184994
     /* 184994 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(185036), // Rule ID 11841 //
     /* 184999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 185007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185017 */     // MIs[0] Op2
     /* 185017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 185025 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2039:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 185025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 185028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185034 */     GIR_RootConstrainSelectedInstOperands,
     /* 185035 */     // GIR_Coverage, 11841,
     /* 185035 */     GIR_EraseRootFromParent_Done,
     /* 185036 */   // Label 3396: @185036
     /* 185036 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(185078), // Rule ID 11842 //
     /* 185041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 185049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185059 */     // MIs[0] Op2
     /* 185059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185062 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 185067 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2036:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 185067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 185070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185076 */     GIR_RootConstrainSelectedInstOperands,
     /* 185077 */     // GIR_Coverage, 11842,
     /* 185077 */     GIR_EraseRootFromParent_Done,
     /* 185078 */   // Label 3397: @185078
     /* 185078 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(185120), // Rule ID 11843 //
     /* 185083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 185091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185101 */     // MIs[0] Op2
     /* 185101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 185109 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2036:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 185109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 185112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185118 */     GIR_RootConstrainSelectedInstOperands,
     /* 185119 */     // GIR_Coverage, 11843,
     /* 185119 */     GIR_EraseRootFromParent_Done,
     /* 185120 */   // Label 3398: @185120
     /* 185120 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(185162), // Rule ID 11844 //
     /* 185125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 185133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185143 */     // MIs[0] Op2
     /* 185143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 185151 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2036:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 185151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 185154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185160 */     GIR_RootConstrainSelectedInstOperands,
     /* 185161 */     // GIR_Coverage, 11844,
     /* 185161 */     GIR_EraseRootFromParent_Done,
     /* 185162 */   // Label 3399: @185162
     /* 185162 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(185204), // Rule ID 11902 //
     /* 185167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 185175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185185 */     // MIs[0] Op2
     /* 185185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 185193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1866:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 185193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 185196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185202 */     GIR_RootConstrainSelectedInstOperands,
     /* 185203 */     // GIR_Coverage, 11902,
     /* 185203 */     GIR_EraseRootFromParent_Done,
     /* 185204 */   // Label 3400: @185204
     /* 185204 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(185246), // Rule ID 11903 //
     /* 185209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 185217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185227 */     // MIs[0] Op2
     /* 185227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 185235 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1866:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 185235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 185238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185244 */     GIR_RootConstrainSelectedInstOperands,
     /* 185245 */     // GIR_Coverage, 11903,
     /* 185245 */     GIR_EraseRootFromParent_Done,
     /* 185246 */   // Label 3401: @185246
     /* 185246 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(185288), // Rule ID 11904 //
     /* 185251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 185259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185269 */     // MIs[0] Op2
     /* 185269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185272 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 185277 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1866:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 185277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 185280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185286 */     GIR_RootConstrainSelectedInstOperands,
     /* 185287 */     // GIR_Coverage, 11904,
     /* 185287 */     GIR_EraseRootFromParent_Done,
     /* 185288 */   // Label 3402: @185288
     /* 185288 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(185330), // Rule ID 11905 //
     /* 185293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 185301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185311 */     // MIs[0] Op2
     /* 185311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 185319 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2059:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 185319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 185322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185328 */     GIR_RootConstrainSelectedInstOperands,
     /* 185329 */     // GIR_Coverage, 11905,
     /* 185329 */     GIR_EraseRootFromParent_Done,
     /* 185330 */   // Label 3403: @185330
     /* 185330 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(185372), // Rule ID 11906 //
     /* 185335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 185343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185353 */     // MIs[0] Op2
     /* 185353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 185361 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2059:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 185361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 185364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185370 */     GIR_RootConstrainSelectedInstOperands,
     /* 185371 */     // GIR_Coverage, 11906,
     /* 185371 */     GIR_EraseRootFromParent_Done,
     /* 185372 */   // Label 3404: @185372
     /* 185372 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(185414), // Rule ID 11907 //
     /* 185377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 185385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185395 */     // MIs[0] Op2
     /* 185395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 185403 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2059:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 185403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 185406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185412 */     GIR_RootConstrainSelectedInstOperands,
     /* 185413 */     // GIR_Coverage, 11907,
     /* 185413 */     GIR_EraseRootFromParent_Done,
     /* 185414 */   // Label 3405: @185414
     /* 185414 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(185456), // Rule ID 11908 //
     /* 185419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 185427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185437 */     // MIs[0] Op2
     /* 185437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185440 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 185445 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2060:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 185445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 185448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185454 */     GIR_RootConstrainSelectedInstOperands,
     /* 185455 */     // GIR_Coverage, 11908,
     /* 185455 */     GIR_EraseRootFromParent_Done,
     /* 185456 */   // Label 3406: @185456
     /* 185456 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(185498), // Rule ID 11909 //
     /* 185461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 185469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185479 */     // MIs[0] Op2
     /* 185479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185482 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 185487 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2060:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 185487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 185490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185496 */     GIR_RootConstrainSelectedInstOperands,
     /* 185497 */     // GIR_Coverage, 11909,
     /* 185497 */     GIR_EraseRootFromParent_Done,
     /* 185498 */   // Label 3407: @185498
     /* 185498 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(185540), // Rule ID 11910 //
     /* 185503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 185511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185521 */     // MIs[0] Op2
     /* 185521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 185529 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2060:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 185529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 185532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185538 */     GIR_RootConstrainSelectedInstOperands,
     /* 185539 */     // GIR_Coverage, 11910,
     /* 185539 */     GIR_EraseRootFromParent_Done,
     /* 185540 */   // Label 3408: @185540
     /* 185540 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(185592), // Rule ID 2132 //
     /* 185545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185578 */     // MIs[1] Operand 1
     /* 185578 */     // No operand predicates
     /* 185578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185580 */     // (intrinsic_wo_chain:{ *:[v4i16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 185583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185590 */     GIR_RootConstrainSelectedInstOperands,
     /* 185591 */     // GIR_Coverage, 2132,
     /* 185591 */     GIR_EraseRootFromParent_Done,
     /* 185592 */   // Label 3409: @185592
     /* 185592 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(185644), // Rule ID 2133 //
     /* 185597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185630 */     // MIs[1] Operand 1
     /* 185630 */     // No operand predicates
     /* 185630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185632 */     // (intrinsic_wo_chain:{ *:[v8i16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 185635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185642 */     GIR_RootConstrainSelectedInstOperands,
     /* 185643 */     // GIR_Coverage, 2133,
     /* 185643 */     GIR_EraseRootFromParent_Done,
     /* 185644 */   // Label 3410: @185644
     /* 185644 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(185696), // Rule ID 2134 //
     /* 185649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185682 */     // MIs[1] Operand 1
     /* 185682 */     // No operand predicates
     /* 185682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185684 */     // (intrinsic_wo_chain:{ *:[v2i32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 185687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185694 */     GIR_RootConstrainSelectedInstOperands,
     /* 185695 */     // GIR_Coverage, 2134,
     /* 185695 */     GIR_EraseRootFromParent_Done,
     /* 185696 */   // Label 3411: @185696
     /* 185696 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(185748), // Rule ID 2135 //
     /* 185701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185734 */     // MIs[1] Operand 1
     /* 185734 */     // No operand predicates
     /* 185734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185736 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 185739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185746 */     GIR_RootConstrainSelectedInstOperands,
     /* 185747 */     // GIR_Coverage, 2135,
     /* 185747 */     GIR_EraseRootFromParent_Done,
     /* 185748 */   // Label 3412: @185748
     /* 185748 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(185800), // Rule ID 2136 //
     /* 185753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185786 */     // MIs[1] Operand 1
     /* 185786 */     // No operand predicates
     /* 185786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185788 */     // (intrinsic_wo_chain:{ *:[v2i64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 185791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185798 */     GIR_RootConstrainSelectedInstOperands,
     /* 185799 */     // GIR_Coverage, 2136,
     /* 185799 */     GIR_EraseRootFromParent_Done,
     /* 185800 */   // Label 3413: @185800
     /* 185800 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(185852), // Rule ID 2137 //
     /* 185805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185838 */     // MIs[1] Operand 1
     /* 185838 */     // No operand predicates
     /* 185838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185840 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 185843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185850 */     GIR_RootConstrainSelectedInstOperands,
     /* 185851 */     // GIR_Coverage, 2137,
     /* 185851 */     GIR_EraseRootFromParent_Done,
     /* 185852 */   // Label 3414: @185852
     /* 185852 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(185904), // Rule ID 2138 //
     /* 185857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185890 */     // MIs[1] Operand 1
     /* 185890 */     // No operand predicates
     /* 185890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185892 */     // (intrinsic_wo_chain:{ *:[v8i16] } 764:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 185895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185902 */     GIR_RootConstrainSelectedInstOperands,
     /* 185903 */     // GIR_Coverage, 2138,
     /* 185903 */     GIR_EraseRootFromParent_Done,
     /* 185904 */   // Label 3415: @185904
     /* 185904 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(185956), // Rule ID 2139 //
     /* 185909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185942 */     // MIs[1] Operand 1
     /* 185942 */     // No operand predicates
     /* 185942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185944 */     // (intrinsic_wo_chain:{ *:[v2i32] } 764:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 185947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185954 */     GIR_RootConstrainSelectedInstOperands,
     /* 185955 */     // GIR_Coverage, 2139,
     /* 185955 */     GIR_EraseRootFromParent_Done,
     /* 185956 */   // Label 3416: @185956
     /* 185956 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(186008), // Rule ID 2140 //
     /* 185961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185994 */     // MIs[1] Operand 1
     /* 185994 */     // No operand predicates
     /* 185994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185996 */     // (intrinsic_wo_chain:{ *:[v4i32] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 185999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186006 */     GIR_RootConstrainSelectedInstOperands,
     /* 186007 */     // GIR_Coverage, 2140,
     /* 186007 */     GIR_EraseRootFromParent_Done,
     /* 186008 */   // Label 3417: @186008
     /* 186008 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(186060), // Rule ID 2141 //
     /* 186013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 186021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186046 */     // MIs[1] Operand 1
     /* 186046 */     // No operand predicates
     /* 186046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186048 */     // (intrinsic_wo_chain:{ *:[v2i64] } 764:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 186051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186058 */     GIR_RootConstrainSelectedInstOperands,
     /* 186059 */     // GIR_Coverage, 2141,
     /* 186059 */     GIR_EraseRootFromParent_Done,
     /* 186060 */   // Label 3418: @186060
     /* 186060 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(186112), // Rule ID 2142 //
     /* 186065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 186073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186098 */     // MIs[1] Operand 1
     /* 186098 */     // No operand predicates
     /* 186098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186100 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 186103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186110 */     GIR_RootConstrainSelectedInstOperands,
     /* 186111 */     // GIR_Coverage, 2142,
     /* 186111 */     GIR_EraseRootFromParent_Done,
     /* 186112 */   // Label 3419: @186112
     /* 186112 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(186164), // Rule ID 2143 //
     /* 186117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 186125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186150 */     // MIs[1] Operand 1
     /* 186150 */     // No operand predicates
     /* 186150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186152 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 186155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186162 */     GIR_RootConstrainSelectedInstOperands,
     /* 186163 */     // GIR_Coverage, 2143,
     /* 186163 */     GIR_EraseRootFromParent_Done,
     /* 186164 */   // Label 3420: @186164
     /* 186164 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(186216), // Rule ID 2144 //
     /* 186169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 186177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186202 */     // MIs[1] Operand 1
     /* 186202 */     // No operand predicates
     /* 186202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186204 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 186207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186214 */     GIR_RootConstrainSelectedInstOperands,
     /* 186215 */     // GIR_Coverage, 2144,
     /* 186215 */     GIR_EraseRootFromParent_Done,
     /* 186216 */   // Label 3421: @186216
     /* 186216 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(186268), // Rule ID 2145 //
     /* 186221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 186229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186254 */     // MIs[1] Operand 1
     /* 186254 */     // No operand predicates
     /* 186254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186256 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 186259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186266 */     GIR_RootConstrainSelectedInstOperands,
     /* 186267 */     // GIR_Coverage, 2145,
     /* 186267 */     GIR_EraseRootFromParent_Done,
     /* 186268 */   // Label 3422: @186268
     /* 186268 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(186320), // Rule ID 2146 //
     /* 186273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 186281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186306 */     // MIs[1] Operand 1
     /* 186306 */     // No operand predicates
     /* 186306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186308 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 186311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186318 */     GIR_RootConstrainSelectedInstOperands,
     /* 186319 */     // GIR_Coverage, 2146,
     /* 186319 */     GIR_EraseRootFromParent_Done,
     /* 186320 */   // Label 3423: @186320
     /* 186320 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(186372), // Rule ID 2244 //
     /* 186325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 186333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186358 */     // MIs[1] Operand 1
     /* 186358 */     // No operand predicates
     /* 186358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186360 */     // (intrinsic_wo_chain:{ *:[v4f16] } 767:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 186363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186370 */     GIR_RootConstrainSelectedInstOperands,
     /* 186371 */     // GIR_Coverage, 2244,
     /* 186371 */     GIR_EraseRootFromParent_Done,
     /* 186372 */   // Label 3424: @186372
     /* 186372 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(186424), // Rule ID 2245 //
     /* 186377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 186385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186410 */     // MIs[1] Operand 1
     /* 186410 */     // No operand predicates
     /* 186410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186412 */     // (intrinsic_wo_chain:{ *:[v8f16] } 767:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 186415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186422 */     GIR_RootConstrainSelectedInstOperands,
     /* 186423 */     // GIR_Coverage, 2245,
     /* 186423 */     GIR_EraseRootFromParent_Done,
     /* 186424 */   // Label 3425: @186424
     /* 186424 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(186476), // Rule ID 2246 //
     /* 186429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 186437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186462 */     // MIs[1] Operand 1
     /* 186462 */     // No operand predicates
     /* 186462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186464 */     // (intrinsic_wo_chain:{ *:[v2f32] } 767:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 186467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186474 */     GIR_RootConstrainSelectedInstOperands,
     /* 186475 */     // GIR_Coverage, 2246,
     /* 186475 */     GIR_EraseRootFromParent_Done,
     /* 186476 */   // Label 3426: @186476
     /* 186476 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(186528), // Rule ID 2247 //
     /* 186481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 186489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186514 */     // MIs[1] Operand 1
     /* 186514 */     // No operand predicates
     /* 186514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186516 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 186519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186526 */     GIR_RootConstrainSelectedInstOperands,
     /* 186527 */     // GIR_Coverage, 2247,
     /* 186527 */     GIR_EraseRootFromParent_Done,
     /* 186528 */   // Label 3427: @186528
     /* 186528 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(186580), // Rule ID 2248 //
     /* 186533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 186541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186566 */     // MIs[1] Operand 1
     /* 186566 */     // No operand predicates
     /* 186566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186568 */     // (intrinsic_wo_chain:{ *:[v2f64] } 767:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 186571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186578 */     GIR_RootConstrainSelectedInstOperands,
     /* 186579 */     // GIR_Coverage, 2248,
     /* 186579 */     GIR_EraseRootFromParent_Done,
     /* 186580 */   // Label 3428: @186580
     /* 186580 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(186625), // Rule ID 63 //
     /* 186585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 186588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 186593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 186596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 186614 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 186614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 186617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186623 */     GIR_RootConstrainSelectedInstOperands,
     /* 186624 */     // GIR_Coverage, 63,
     /* 186624 */     GIR_EraseRootFromParent_Done,
     /* 186625 */   // Label 3429: @186625
     /* 186625 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(186670), // Rule ID 129 //
     /* 186630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 186638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186659 */     // (intrinsic_wo_chain:{ *:[i32] } 504:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 186662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186668 */     GIR_RootConstrainSelectedInstOperands,
     /* 186669 */     // GIR_Coverage, 129,
     /* 186669 */     GIR_EraseRootFromParent_Done,
     /* 186670 */   // Label 3430: @186670
     /* 186670 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(186715), // Rule ID 130 //
     /* 186675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 186683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186704 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 186707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186713 */     GIR_RootConstrainSelectedInstOperands,
     /* 186714 */     // GIR_Coverage, 130,
     /* 186714 */     GIR_EraseRootFromParent_Done,
     /* 186715 */   // Label 3431: @186715
     /* 186715 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(186760), // Rule ID 131 //
     /* 186720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 186728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186749 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 186752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186758 */     GIR_RootConstrainSelectedInstOperands,
     /* 186759 */     // GIR_Coverage, 131,
     /* 186759 */     GIR_EraseRootFromParent_Done,
     /* 186760 */   // Label 3432: @186760
     /* 186760 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(186805), // Rule ID 132 //
     /* 186765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 186773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186794 */     // (intrinsic_wo_chain:{ *:[i32] } 511:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 186794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 186797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186803 */     GIR_RootConstrainSelectedInstOperands,
     /* 186804 */     // GIR_Coverage, 132,
     /* 186804 */     GIR_EraseRootFromParent_Done,
     /* 186805 */   // Label 3433: @186805
     /* 186805 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(186850), // Rule ID 133 //
     /* 186810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 186818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186839 */     // (intrinsic_wo_chain:{ *:[i32] } 505:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 186842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186848 */     GIR_RootConstrainSelectedInstOperands,
     /* 186849 */     // GIR_Coverage, 133,
     /* 186849 */     GIR_EraseRootFromParent_Done,
     /* 186850 */   // Label 3434: @186850
     /* 186850 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(186895), // Rule ID 134 //
     /* 186855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 186863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186884 */     // (intrinsic_wo_chain:{ *:[i32] } 506:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 186887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186893 */     GIR_RootConstrainSelectedInstOperands,
     /* 186894 */     // GIR_Coverage, 134,
     /* 186894 */     GIR_EraseRootFromParent_Done,
     /* 186895 */   // Label 3435: @186895
     /* 186895 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(186940), // Rule ID 135 //
     /* 186900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 186908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186929 */     // (intrinsic_wo_chain:{ *:[i32] } 507:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 186932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186938 */     GIR_RootConstrainSelectedInstOperands,
     /* 186939 */     // GIR_Coverage, 135,
     /* 186939 */     GIR_EraseRootFromParent_Done,
     /* 186940 */   // Label 3436: @186940
     /* 186940 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(186985), // Rule ID 136 //
     /* 186945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 186953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186974 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 186974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 186977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186983 */     GIR_RootConstrainSelectedInstOperands,
     /* 186984 */     // GIR_Coverage, 136,
     /* 186984 */     GIR_EraseRootFromParent_Done,
     /* 186985 */   // Label 3437: @186985
     /* 186985 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(187030), // Rule ID 1042 //
     /* 186990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 187001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 187004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 187007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187019 */     // (intrinsic_wo_chain:{ *:[v8i8] } 716:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 187019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 187022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187028 */     GIR_RootConstrainSelectedInstOperands,
     /* 187029 */     // GIR_Coverage, 1042,
     /* 187029 */     GIR_EraseRootFromParent_Done,
     /* 187030 */   // Label 3438: @187030
     /* 187030 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(187075), // Rule ID 1043 //
     /* 187035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 187043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 187046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 187049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 187052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187064 */     // (intrinsic_wo_chain:{ *:[v16i8] } 716:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 187064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 187067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187073 */     GIR_RootConstrainSelectedInstOperands,
     /* 187074 */     // GIR_Coverage, 1043,
     /* 187074 */     GIR_EraseRootFromParent_Done,
     /* 187075 */   // Label 3439: @187075
     /* 187075 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(187120), // Rule ID 1044 //
     /* 187080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 187088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187109 */     // (intrinsic_wo_chain:{ *:[v4i16] } 716:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 187109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 187112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187118 */     GIR_RootConstrainSelectedInstOperands,
     /* 187119 */     // GIR_Coverage, 1044,
     /* 187119 */     GIR_EraseRootFromParent_Done,
     /* 187120 */   // Label 3440: @187120
     /* 187120 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(187165), // Rule ID 1045 //
     /* 187125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 187133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187154 */     // (intrinsic_wo_chain:{ *:[v8i16] } 716:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 187154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 187157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187163 */     GIR_RootConstrainSelectedInstOperands,
     /* 187164 */     // GIR_Coverage, 1045,
     /* 187164 */     GIR_EraseRootFromParent_Done,
     /* 187165 */   // Label 3441: @187165
     /* 187165 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(187210), // Rule ID 1046 //
     /* 187170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 187178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187199 */     // (intrinsic_wo_chain:{ *:[v2i32] } 716:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 187199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 187202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187208 */     GIR_RootConstrainSelectedInstOperands,
     /* 187209 */     // GIR_Coverage, 1046,
     /* 187209 */     GIR_EraseRootFromParent_Done,
     /* 187210 */   // Label 3442: @187210
     /* 187210 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(187255), // Rule ID 1047 //
     /* 187215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 187223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187244 */     // (intrinsic_wo_chain:{ *:[v4i32] } 716:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 187244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 187247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187253 */     GIR_RootConstrainSelectedInstOperands,
     /* 187254 */     // GIR_Coverage, 1047,
     /* 187254 */     GIR_EraseRootFromParent_Done,
     /* 187255 */   // Label 3443: @187255
     /* 187255 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(187300), // Rule ID 1048 //
     /* 187260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 187268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187289 */     // (intrinsic_wo_chain:{ *:[v2i64] } 716:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 187289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 187292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187298 */     GIR_RootConstrainSelectedInstOperands,
     /* 187299 */     // GIR_Coverage, 1048,
     /* 187299 */     GIR_EraseRootFromParent_Done,
     /* 187300 */   // Label 3444: @187300
     /* 187300 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(187345), // Rule ID 1090 //
     /* 187305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 187316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 187319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 187322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187334 */     // (intrinsic_wo_chain:{ *:[v8i8] } 755:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 187334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 187337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187343 */     GIR_RootConstrainSelectedInstOperands,
     /* 187344 */     // GIR_Coverage, 1090,
     /* 187344 */     GIR_EraseRootFromParent_Done,
     /* 187345 */   // Label 3445: @187345
     /* 187345 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(187390), // Rule ID 1091 //
     /* 187350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 187361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 187364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 187367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187379 */     // (intrinsic_wo_chain:{ *:[v16i8] } 755:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 187379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 187382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187388 */     GIR_RootConstrainSelectedInstOperands,
     /* 187389 */     // GIR_Coverage, 1091,
     /* 187389 */     GIR_EraseRootFromParent_Done,
     /* 187390 */   // Label 3446: @187390
     /* 187390 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(187435), // Rule ID 1092 //
     /* 187395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187424 */     // (intrinsic_wo_chain:{ *:[v4i16] } 755:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 187424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 187427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187433 */     GIR_RootConstrainSelectedInstOperands,
     /* 187434 */     // GIR_Coverage, 1092,
     /* 187434 */     GIR_EraseRootFromParent_Done,
     /* 187435 */   // Label 3447: @187435
     /* 187435 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(187480), // Rule ID 1093 //
     /* 187440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187469 */     // (intrinsic_wo_chain:{ *:[v8i16] } 755:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 187469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 187472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187478 */     GIR_RootConstrainSelectedInstOperands,
     /* 187479 */     // GIR_Coverage, 1093,
     /* 187479 */     GIR_EraseRootFromParent_Done,
     /* 187480 */   // Label 3448: @187480
     /* 187480 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(187525), // Rule ID 1094 //
     /* 187485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187514 */     // (intrinsic_wo_chain:{ *:[v2i32] } 755:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 187514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 187517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187523 */     GIR_RootConstrainSelectedInstOperands,
     /* 187524 */     // GIR_Coverage, 1094,
     /* 187524 */     GIR_EraseRootFromParent_Done,
     /* 187525 */   // Label 3449: @187525
     /* 187525 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(187570), // Rule ID 1095 //
     /* 187530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187559 */     // (intrinsic_wo_chain:{ *:[v4i32] } 755:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 187559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 187562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187568 */     GIR_RootConstrainSelectedInstOperands,
     /* 187569 */     // GIR_Coverage, 1095,
     /* 187569 */     GIR_EraseRootFromParent_Done,
     /* 187570 */   // Label 3450: @187570
     /* 187570 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(187615), // Rule ID 1096 //
     /* 187575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187604 */     // (intrinsic_wo_chain:{ *:[v2i64] } 755:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 187604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 187607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187613 */     GIR_RootConstrainSelectedInstOperands,
     /* 187614 */     // GIR_Coverage, 1096,
     /* 187614 */     GIR_EraseRootFromParent_Done,
     /* 187615 */   // Label 3451: @187615
     /* 187615 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(187660), // Rule ID 1108 //
     /* 187620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 187631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 187634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 187637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187649 */     // (intrinsic_wo_chain:{ *:[v8i8] } 571:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 187649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 187652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187658 */     GIR_RootConstrainSelectedInstOperands,
     /* 187659 */     // GIR_Coverage, 1108,
     /* 187659 */     GIR_EraseRootFromParent_Done,
     /* 187660 */   // Label 3452: @187660
     /* 187660 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(187705), // Rule ID 1110 //
     /* 187665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 187676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 187679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 187682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187694 */     // (intrinsic_wo_chain:{ *:[v16i8] } 571:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 187694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 187697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187703 */     GIR_RootConstrainSelectedInstOperands,
     /* 187704 */     // GIR_Coverage, 1110,
     /* 187704 */     GIR_EraseRootFromParent_Done,
     /* 187705 */   // Label 3453: @187705
     /* 187705 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(187750), // Rule ID 1112 //
     /* 187710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187739 */     // (intrinsic_wo_chain:{ *:[v4i16] } 571:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 187739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 187742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187748 */     GIR_RootConstrainSelectedInstOperands,
     /* 187749 */     // GIR_Coverage, 1112,
     /* 187749 */     GIR_EraseRootFromParent_Done,
     /* 187750 */   // Label 3454: @187750
     /* 187750 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(187795), // Rule ID 1114 //
     /* 187755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187784 */     // (intrinsic_wo_chain:{ *:[v8i16] } 571:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 187784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 187787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187793 */     GIR_RootConstrainSelectedInstOperands,
     /* 187794 */     // GIR_Coverage, 1114,
     /* 187794 */     GIR_EraseRootFromParent_Done,
     /* 187795 */   // Label 3455: @187795
     /* 187795 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(187840), // Rule ID 1116 //
     /* 187800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187829 */     // (intrinsic_wo_chain:{ *:[v2i32] } 571:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 187829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 187832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187838 */     GIR_RootConstrainSelectedInstOperands,
     /* 187839 */     // GIR_Coverage, 1116,
     /* 187839 */     GIR_EraseRootFromParent_Done,
     /* 187840 */   // Label 3456: @187840
     /* 187840 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(187885), // Rule ID 1118 //
     /* 187845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187874 */     // (intrinsic_wo_chain:{ *:[v4i32] } 571:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 187874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 187877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187883 */     GIR_RootConstrainSelectedInstOperands,
     /* 187884 */     // GIR_Coverage, 1118,
     /* 187884 */     GIR_EraseRootFromParent_Done,
     /* 187885 */   // Label 3457: @187885
     /* 187885 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(187930), // Rule ID 1120 //
     /* 187890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187919 */     // (intrinsic_wo_chain:{ *:[v2i64] } 571:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 187919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 187922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187928 */     GIR_RootConstrainSelectedInstOperands,
     /* 187929 */     // GIR_Coverage, 1120,
     /* 187929 */     GIR_EraseRootFromParent_Done,
     /* 187930 */   // Label 3458: @187930
     /* 187930 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(187975), // Rule ID 1163 //
     /* 187935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187964 */     // (intrinsic_wo_chain:{ *:[v4f16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 187967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187973 */     GIR_RootConstrainSelectedInstOperands,
     /* 187974 */     // GIR_Coverage, 1163,
     /* 187974 */     GIR_EraseRootFromParent_Done,
     /* 187975 */   // Label 3459: @187975
     /* 187975 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(188020), // Rule ID 1164 //
     /* 187980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188009 */     // (intrinsic_wo_chain:{ *:[v8f16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 188012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188018 */     GIR_RootConstrainSelectedInstOperands,
     /* 188019 */     // GIR_Coverage, 1164,
     /* 188019 */     GIR_EraseRootFromParent_Done,
     /* 188020 */   // Label 3460: @188020
     /* 188020 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(188065), // Rule ID 1165 //
     /* 188025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 188033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188054 */     // (intrinsic_wo_chain:{ *:[v2f32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 188057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188063 */     GIR_RootConstrainSelectedInstOperands,
     /* 188064 */     // GIR_Coverage, 1165,
     /* 188064 */     GIR_EraseRootFromParent_Done,
     /* 188065 */   // Label 3461: @188065
     /* 188065 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(188110), // Rule ID 1166 //
     /* 188070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 188078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188099 */     // (intrinsic_wo_chain:{ *:[v4f32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 188102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188108 */     GIR_RootConstrainSelectedInstOperands,
     /* 188109 */     // GIR_Coverage, 1166,
     /* 188109 */     GIR_EraseRootFromParent_Done,
     /* 188110 */   // Label 3462: @188110
     /* 188110 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(188155), // Rule ID 1167 //
     /* 188115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 188123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188144 */     // (intrinsic_wo_chain:{ *:[v2f64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 188147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188153 */     GIR_RootConstrainSelectedInstOperands,
     /* 188154 */     // GIR_Coverage, 1167,
     /* 188154 */     GIR_EraseRootFromParent_Done,
     /* 188155 */   // Label 3463: @188155
     /* 188155 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(188200), // Rule ID 1169 //
     /* 188160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 188168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188189 */     // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 188192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188198 */     GIR_RootConstrainSelectedInstOperands,
     /* 188199 */     // GIR_Coverage, 1169,
     /* 188199 */     GIR_EraseRootFromParent_Done,
     /* 188200 */   // Label 3464: @188200
     /* 188200 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(188245), // Rule ID 1171 //
     /* 188205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 188213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188234 */     // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 188237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188243 */     GIR_RootConstrainSelectedInstOperands,
     /* 188244 */     // GIR_Coverage, 1171,
     /* 188244 */     GIR_EraseRootFromParent_Done,
     /* 188245 */   // Label 3465: @188245
     /* 188245 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(188290), // Rule ID 1173 //
     /* 188250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 188258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188279 */     // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 188282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188288 */     GIR_RootConstrainSelectedInstOperands,
     /* 188289 */     // GIR_Coverage, 1173,
     /* 188289 */     GIR_EraseRootFromParent_Done,
     /* 188290 */   // Label 3466: @188290
     /* 188290 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(188335), // Rule ID 1175 //
     /* 188295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 188303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188324 */     // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 188327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188333 */     GIR_RootConstrainSelectedInstOperands,
     /* 188334 */     // GIR_Coverage, 1175,
     /* 188334 */     GIR_EraseRootFromParent_Done,
     /* 188335 */   // Label 3467: @188335
     /* 188335 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(188380), // Rule ID 1177 //
     /* 188340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 188348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188369 */     // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 188372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188378 */     GIR_RootConstrainSelectedInstOperands,
     /* 188379 */     // GIR_Coverage, 1177,
     /* 188379 */     GIR_EraseRootFromParent_Done,
     /* 188380 */   // Label 3468: @188380
     /* 188380 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(188425), // Rule ID 1179 //
     /* 188385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188414 */     // (intrinsic_wo_chain:{ *:[v4i16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 188417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188423 */     GIR_RootConstrainSelectedInstOperands,
     /* 188424 */     // GIR_Coverage, 1179,
     /* 188424 */     GIR_EraseRootFromParent_Done,
     /* 188425 */   // Label 3469: @188425
     /* 188425 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(188470), // Rule ID 1181 //
     /* 188430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188459 */     // (intrinsic_wo_chain:{ *:[v8i16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 188462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188468 */     GIR_RootConstrainSelectedInstOperands,
     /* 188469 */     // GIR_Coverage, 1181,
     /* 188469 */     GIR_EraseRootFromParent_Done,
     /* 188470 */   // Label 3470: @188470
     /* 188470 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(188515), // Rule ID 1183 //
     /* 188475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188504 */     // (intrinsic_wo_chain:{ *:[v2i32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 188507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188513 */     GIR_RootConstrainSelectedInstOperands,
     /* 188514 */     // GIR_Coverage, 1183,
     /* 188514 */     GIR_EraseRootFromParent_Done,
     /* 188515 */   // Label 3471: @188515
     /* 188515 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(188560), // Rule ID 1185 //
     /* 188520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188549 */     // (intrinsic_wo_chain:{ *:[v4i32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 188552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188558 */     GIR_RootConstrainSelectedInstOperands,
     /* 188559 */     // GIR_Coverage, 1185,
     /* 188559 */     GIR_EraseRootFromParent_Done,
     /* 188560 */   // Label 3472: @188560
     /* 188560 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(188605), // Rule ID 1187 //
     /* 188565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188594 */     // (intrinsic_wo_chain:{ *:[v2i64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 188597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188603 */     GIR_RootConstrainSelectedInstOperands,
     /* 188604 */     // GIR_Coverage, 1187,
     /* 188604 */     GIR_EraseRootFromParent_Done,
     /* 188605 */   // Label 3473: @188605
     /* 188605 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(188650), // Rule ID 1189 //
     /* 188610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188639 */     // (intrinsic_wo_chain:{ *:[v4f16] } 580:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 188642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188648 */     GIR_RootConstrainSelectedInstOperands,
     /* 188649 */     // GIR_Coverage, 1189,
     /* 188649 */     GIR_EraseRootFromParent_Done,
     /* 188650 */   // Label 3474: @188650
     /* 188650 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(188695), // Rule ID 1191 //
     /* 188655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188684 */     // (intrinsic_wo_chain:{ *:[v8f16] } 580:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 188687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188693 */     GIR_RootConstrainSelectedInstOperands,
     /* 188694 */     // GIR_Coverage, 1191,
     /* 188694 */     GIR_EraseRootFromParent_Done,
     /* 188695 */   // Label 3475: @188695
     /* 188695 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(188740), // Rule ID 1193 //
     /* 188700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188729 */     // (intrinsic_wo_chain:{ *:[v2f32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 188732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188738 */     GIR_RootConstrainSelectedInstOperands,
     /* 188739 */     // GIR_Coverage, 1193,
     /* 188739 */     GIR_EraseRootFromParent_Done,
     /* 188740 */   // Label 3476: @188740
     /* 188740 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(188785), // Rule ID 1195 //
     /* 188745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188774 */     // (intrinsic_wo_chain:{ *:[v4f32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 188777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188783 */     GIR_RootConstrainSelectedInstOperands,
     /* 188784 */     // GIR_Coverage, 1195,
     /* 188784 */     GIR_EraseRootFromParent_Done,
     /* 188785 */   // Label 3477: @188785
     /* 188785 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(188830), // Rule ID 1197 //
     /* 188790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188819 */     // (intrinsic_wo_chain:{ *:[v2f64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 188822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188828 */     GIR_RootConstrainSelectedInstOperands,
     /* 188829 */     // GIR_Coverage, 1197,
     /* 188829 */     GIR_EraseRootFromParent_Done,
     /* 188830 */   // Label 3478: @188830
     /* 188830 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(188875), // Rule ID 1233 //
     /* 188835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188864 */     // (intrinsic_wo_chain:{ *:[v4f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 188867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188873 */     GIR_RootConstrainSelectedInstOperands,
     /* 188874 */     // GIR_Coverage, 1233,
     /* 188874 */     GIR_EraseRootFromParent_Done,
     /* 188875 */   // Label 3479: @188875
     /* 188875 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(188920), // Rule ID 1234 //
     /* 188880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188909 */     // (intrinsic_wo_chain:{ *:[v8f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 188912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188918 */     GIR_RootConstrainSelectedInstOperands,
     /* 188919 */     // GIR_Coverage, 1234,
     /* 188919 */     GIR_EraseRootFromParent_Done,
     /* 188920 */   // Label 3480: @188920
     /* 188920 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(188965), // Rule ID 1235 //
     /* 188925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188954 */     // (intrinsic_wo_chain:{ *:[v2f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 188957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188963 */     GIR_RootConstrainSelectedInstOperands,
     /* 188964 */     // GIR_Coverage, 1235,
     /* 188964 */     GIR_EraseRootFromParent_Done,
     /* 188965 */   // Label 3481: @188965
     /* 188965 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(189010), // Rule ID 1236 //
     /* 188970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188999 */     // (intrinsic_wo_chain:{ *:[v4f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 189002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189008 */     GIR_RootConstrainSelectedInstOperands,
     /* 189009 */     // GIR_Coverage, 1236,
     /* 189009 */     GIR_EraseRootFromParent_Done,
     /* 189010 */   // Label 3482: @189010
     /* 189010 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(189055), // Rule ID 1237 //
     /* 189015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 189023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189044 */     // (intrinsic_wo_chain:{ *:[v2f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 189047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189053 */     GIR_RootConstrainSelectedInstOperands,
     /* 189054 */     // GIR_Coverage, 1237,
     /* 189054 */     GIR_EraseRootFromParent_Done,
     /* 189055 */   // Label 3483: @189055
     /* 189055 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(189100), // Rule ID 1248 //
     /* 189060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 189068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189089 */     // (intrinsic_wo_chain:{ *:[v4f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 189092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189098 */     GIR_RootConstrainSelectedInstOperands,
     /* 189099 */     // GIR_Coverage, 1248,
     /* 189099 */     GIR_EraseRootFromParent_Done,
     /* 189100 */   // Label 3484: @189100
     /* 189100 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(189145), // Rule ID 1249 //
     /* 189105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 189113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189134 */     // (intrinsic_wo_chain:{ *:[v8f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 189137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189143 */     GIR_RootConstrainSelectedInstOperands,
     /* 189144 */     // GIR_Coverage, 1249,
     /* 189144 */     GIR_EraseRootFromParent_Done,
     /* 189145 */   // Label 3485: @189145
     /* 189145 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(189190), // Rule ID 1250 //
     /* 189150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 189158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189179 */     // (intrinsic_wo_chain:{ *:[v2f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 189182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189188 */     GIR_RootConstrainSelectedInstOperands,
     /* 189189 */     // GIR_Coverage, 1250,
     /* 189189 */     GIR_EraseRootFromParent_Done,
     /* 189190 */   // Label 3486: @189190
     /* 189190 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(189235), // Rule ID 1251 //
     /* 189195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 189203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189224 */     // (intrinsic_wo_chain:{ *:[v4f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 189227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189233 */     GIR_RootConstrainSelectedInstOperands,
     /* 189234 */     // GIR_Coverage, 1251,
     /* 189234 */     GIR_EraseRootFromParent_Done,
     /* 189235 */   // Label 3487: @189235
     /* 189235 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(189280), // Rule ID 1252 //
     /* 189240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 189248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189269 */     // (intrinsic_wo_chain:{ *:[v2f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 189272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189278 */     GIR_RootConstrainSelectedInstOperands,
     /* 189279 */     // GIR_Coverage, 1252,
     /* 189279 */     GIR_EraseRootFromParent_Done,
     /* 189280 */   // Label 3488: @189280
     /* 189280 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(189325), // Rule ID 1263 //
     /* 189285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 189293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189314 */     // (intrinsic_wo_chain:{ *:[v4f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 189317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189323 */     GIR_RootConstrainSelectedInstOperands,
     /* 189324 */     // GIR_Coverage, 1263,
     /* 189324 */     GIR_EraseRootFromParent_Done,
     /* 189325 */   // Label 3489: @189325
     /* 189325 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(189370), // Rule ID 1264 //
     /* 189330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 189338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189359 */     // (intrinsic_wo_chain:{ *:[v8f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 189362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189368 */     GIR_RootConstrainSelectedInstOperands,
     /* 189369 */     // GIR_Coverage, 1264,
     /* 189369 */     GIR_EraseRootFromParent_Done,
     /* 189370 */   // Label 3490: @189370
     /* 189370 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(189415), // Rule ID 1265 //
     /* 189375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 189383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189404 */     // (intrinsic_wo_chain:{ *:[v2f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 189407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189413 */     GIR_RootConstrainSelectedInstOperands,
     /* 189414 */     // GIR_Coverage, 1265,
     /* 189414 */     GIR_EraseRootFromParent_Done,
     /* 189415 */   // Label 3491: @189415
     /* 189415 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(189460), // Rule ID 1266 //
     /* 189420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 189428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189449 */     // (intrinsic_wo_chain:{ *:[v4f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 189452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189458 */     GIR_RootConstrainSelectedInstOperands,
     /* 189459 */     // GIR_Coverage, 1266,
     /* 189459 */     GIR_EraseRootFromParent_Done,
     /* 189460 */   // Label 3492: @189460
     /* 189460 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(189505), // Rule ID 1267 //
     /* 189465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 189473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189494 */     // (intrinsic_wo_chain:{ *:[v2f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 189497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189503 */     GIR_RootConstrainSelectedInstOperands,
     /* 189504 */     // GIR_Coverage, 1267,
     /* 189504 */     GIR_EraseRootFromParent_Done,
     /* 189505 */   // Label 3493: @189505
     /* 189505 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(189550), // Rule ID 1278 //
     /* 189510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189539 */     // (intrinsic_wo_chain:{ *:[v4f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 189542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189548 */     GIR_RootConstrainSelectedInstOperands,
     /* 189549 */     // GIR_Coverage, 1278,
     /* 189549 */     GIR_EraseRootFromParent_Done,
     /* 189550 */   // Label 3494: @189550
     /* 189550 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(189595), // Rule ID 1279 //
     /* 189555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189584 */     // (intrinsic_wo_chain:{ *:[v8f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 189587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189593 */     GIR_RootConstrainSelectedInstOperands,
     /* 189594 */     // GIR_Coverage, 1279,
     /* 189594 */     GIR_EraseRootFromParent_Done,
     /* 189595 */   // Label 3495: @189595
     /* 189595 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(189640), // Rule ID 1280 //
     /* 189600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189629 */     // (intrinsic_wo_chain:{ *:[v2f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 189632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189638 */     GIR_RootConstrainSelectedInstOperands,
     /* 189639 */     // GIR_Coverage, 1280,
     /* 189639 */     GIR_EraseRootFromParent_Done,
     /* 189640 */   // Label 3496: @189640
     /* 189640 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(189685), // Rule ID 1281 //
     /* 189645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189674 */     // (intrinsic_wo_chain:{ *:[v4f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 189677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189683 */     GIR_RootConstrainSelectedInstOperands,
     /* 189684 */     // GIR_Coverage, 1281,
     /* 189684 */     GIR_EraseRootFromParent_Done,
     /* 189685 */   // Label 3497: @189685
     /* 189685 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(189730), // Rule ID 1282 //
     /* 189690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189719 */     // (intrinsic_wo_chain:{ *:[v2f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 189722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189728 */     GIR_RootConstrainSelectedInstOperands,
     /* 189729 */     // GIR_Coverage, 1282,
     /* 189729 */     GIR_EraseRootFromParent_Done,
     /* 189730 */   // Label 3498: @189730
     /* 189730 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(189775), // Rule ID 1313 //
     /* 189735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189764 */     // (intrinsic_wo_chain:{ *:[v4f16] } 611:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 189767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189773 */     GIR_RootConstrainSelectedInstOperands,
     /* 189774 */     // GIR_Coverage, 1313,
     /* 189774 */     GIR_EraseRootFromParent_Done,
     /* 189775 */   // Label 3499: @189775
     /* 189775 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(189820), // Rule ID 1314 //
     /* 189780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189809 */     // (intrinsic_wo_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 189812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189818 */     GIR_RootConstrainSelectedInstOperands,
     /* 189819 */     // GIR_Coverage, 1314,
     /* 189819 */     GIR_EraseRootFromParent_Done,
     /* 189820 */   // Label 3500: @189820
     /* 189820 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(189865), // Rule ID 1315 //
     /* 189825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189854 */     // (intrinsic_wo_chain:{ *:[v2f32] } 611:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 189857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189863 */     GIR_RootConstrainSelectedInstOperands,
     /* 189864 */     // GIR_Coverage, 1315,
     /* 189864 */     GIR_EraseRootFromParent_Done,
     /* 189865 */   // Label 3501: @189865
     /* 189865 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(189910), // Rule ID 1316 //
     /* 189870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189899 */     // (intrinsic_wo_chain:{ *:[v4f32] } 611:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 189902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189908 */     GIR_RootConstrainSelectedInstOperands,
     /* 189909 */     // GIR_Coverage, 1316,
     /* 189909 */     GIR_EraseRootFromParent_Done,
     /* 189910 */   // Label 3502: @189910
     /* 189910 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(189955), // Rule ID 1317 //
     /* 189915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189944 */     // (intrinsic_wo_chain:{ *:[v2f64] } 611:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 189947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189953 */     GIR_RootConstrainSelectedInstOperands,
     /* 189954 */     // GIR_Coverage, 1317,
     /* 189954 */     GIR_EraseRootFromParent_Done,
     /* 189955 */   // Label 3503: @189955
     /* 189955 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(190000), // Rule ID 1328 //
     /* 189960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189989 */     // (intrinsic_wo_chain:{ *:[v4f16] } 634:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 189992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189998 */     GIR_RootConstrainSelectedInstOperands,
     /* 189999 */     // GIR_Coverage, 1328,
     /* 189999 */     GIR_EraseRootFromParent_Done,
     /* 190000 */   // Label 3504: @190000
     /* 190000 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(190045), // Rule ID 1329 //
     /* 190005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 190008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 190013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190034 */     // (intrinsic_wo_chain:{ *:[v8f16] } 634:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 190034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 190037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190043 */     GIR_RootConstrainSelectedInstOperands,
     /* 190044 */     // GIR_Coverage, 1329,
     /* 190044 */     GIR_EraseRootFromParent_Done,
     /* 190045 */   // Label 3505: @190045
     /* 190045 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(190090), // Rule ID 1330 //
     /* 190050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 190058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190079 */     // (intrinsic_wo_chain:{ *:[v2f32] } 634:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 190079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 190082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190088 */     GIR_RootConstrainSelectedInstOperands,
     /* 190089 */     // GIR_Coverage, 1330,
     /* 190089 */     GIR_EraseRootFromParent_Done,
     /* 190090 */   // Label 3506: @190090
     /* 190090 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(190135), // Rule ID 1331 //
     /* 190095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 190103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190124 */     // (intrinsic_wo_chain:{ *:[v4f32] } 634:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 190124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 190127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190133 */     GIR_RootConstrainSelectedInstOperands,
     /* 190134 */     // GIR_Coverage, 1331,
     /* 190134 */     GIR_EraseRootFromParent_Done,
     /* 190135 */   // Label 3507: @190135
     /* 190135 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(190180), // Rule ID 1332 //
     /* 190140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 190148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 190154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 190157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190169 */     // (intrinsic_wo_chain:{ *:[v2f64] } 634:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 190169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 190172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190178 */     GIR_RootConstrainSelectedInstOperands,
     /* 190179 */     // GIR_Coverage, 1332,
     /* 190179 */     GIR_EraseRootFromParent_Done,
     /* 190180 */   // Label 3508: @190180
     /* 190180 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(190225), // Rule ID 1333 //
     /* 190185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 190188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 190193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190214 */     // (intrinsic_wo_chain:{ *:[v4f16] } 641:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 190214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 190217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190223 */     GIR_RootConstrainSelectedInstOperands,
     /* 190224 */     // GIR_Coverage, 1333,
     /* 190224 */     GIR_EraseRootFromParent_Done,
     /* 190225 */   // Label 3509: @190225
     /* 190225 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(190270), // Rule ID 1334 //
     /* 190230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 190233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 190238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190259 */     // (intrinsic_wo_chain:{ *:[v8f16] } 641:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 190259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 190262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190268 */     GIR_RootConstrainSelectedInstOperands,
     /* 190269 */     // GIR_Coverage, 1334,
     /* 190269 */     GIR_EraseRootFromParent_Done,
     /* 190270 */   // Label 3510: @190270
     /* 190270 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(190315), // Rule ID 1335 //
     /* 190275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 190283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190304 */     // (intrinsic_wo_chain:{ *:[v2f32] } 641:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 190304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 190307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190313 */     GIR_RootConstrainSelectedInstOperands,
     /* 190314 */     // GIR_Coverage, 1335,
     /* 190314 */     GIR_EraseRootFromParent_Done,
     /* 190315 */   // Label 3511: @190315
     /* 190315 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(190360), // Rule ID 1336 //
     /* 190320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 190328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190349 */     // (intrinsic_wo_chain:{ *:[v4f32] } 641:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 190349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 190352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190358 */     GIR_RootConstrainSelectedInstOperands,
     /* 190359 */     // GIR_Coverage, 1336,
     /* 190359 */     GIR_EraseRootFromParent_Done,
     /* 190360 */   // Label 3512: @190360
     /* 190360 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(190405), // Rule ID 1337 //
     /* 190365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 190373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 190379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 190382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190394 */     // (intrinsic_wo_chain:{ *:[v2f64] } 641:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 190394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 190397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190403 */     GIR_RootConstrainSelectedInstOperands,
     /* 190404 */     // GIR_Coverage, 1337,
     /* 190404 */     GIR_EraseRootFromParent_Done,
     /* 190405 */   // Label 3513: @190405
     /* 190405 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(190450), // Rule ID 1354 //
     /* 190410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 190418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190439 */     // (intrinsic_wo_chain:{ *:[v8i8] } 654:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 190442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190448 */     GIR_RootConstrainSelectedInstOperands,
     /* 190449 */     // GIR_Coverage, 1354,
     /* 190449 */     GIR_EraseRootFromParent_Done,
     /* 190450 */   // Label 3514: @190450
     /* 190450 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(190495), // Rule ID 1355 //
     /* 190455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 190463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190484 */     // (intrinsic_wo_chain:{ *:[v16i8] } 654:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 190487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190493 */     GIR_RootConstrainSelectedInstOperands,
     /* 190494 */     // GIR_Coverage, 1355,
     /* 190494 */     GIR_EraseRootFromParent_Done,
     /* 190495 */   // Label 3515: @190495
     /* 190495 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(190540), // Rule ID 1369 //
     /* 190500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190529 */     // (intrinsic_wo_chain:{ *:[v8i8] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 190532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190538 */     GIR_RootConstrainSelectedInstOperands,
     /* 190539 */     // GIR_Coverage, 1369,
     /* 190539 */     GIR_EraseRootFromParent_Done,
     /* 190540 */   // Label 3516: @190540
     /* 190540 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(190585), // Rule ID 1371 //
     /* 190545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190574 */     // (intrinsic_wo_chain:{ *:[v16i8] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 190577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190583 */     GIR_RootConstrainSelectedInstOperands,
     /* 190584 */     // GIR_Coverage, 1371,
     /* 190584 */     GIR_EraseRootFromParent_Done,
     /* 190585 */   // Label 3517: @190585
     /* 190585 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(190630), // Rule ID 1373 //
     /* 190590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190619 */     // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 190622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190628 */     GIR_RootConstrainSelectedInstOperands,
     /* 190629 */     // GIR_Coverage, 1373,
     /* 190629 */     GIR_EraseRootFromParent_Done,
     /* 190630 */   // Label 3518: @190630
     /* 190630 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(190675), // Rule ID 1375 //
     /* 190635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190664 */     // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 190667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190673 */     GIR_RootConstrainSelectedInstOperands,
     /* 190674 */     // GIR_Coverage, 1375,
     /* 190674 */     GIR_EraseRootFromParent_Done,
     /* 190675 */   // Label 3519: @190675
     /* 190675 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(190720), // Rule ID 1377 //
     /* 190680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190709 */     // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 190712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190718 */     GIR_RootConstrainSelectedInstOperands,
     /* 190719 */     // GIR_Coverage, 1377,
     /* 190719 */     GIR_EraseRootFromParent_Done,
     /* 190720 */   // Label 3520: @190720
     /* 190720 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(190765), // Rule ID 1379 //
     /* 190725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190754 */     // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 190757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190763 */     GIR_RootConstrainSelectedInstOperands,
     /* 190764 */     // GIR_Coverage, 1379,
     /* 190764 */     GIR_EraseRootFromParent_Done,
     /* 190765 */   // Label 3521: @190765
     /* 190765 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(190810), // Rule ID 1386 //
     /* 190770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190799 */     // (intrinsic_wo_chain:{ *:[v8i8] } 670:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 190802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190808 */     GIR_RootConstrainSelectedInstOperands,
     /* 190809 */     // GIR_Coverage, 1386,
     /* 190809 */     GIR_EraseRootFromParent_Done,
     /* 190810 */   // Label 3522: @190810
     /* 190810 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(190855), // Rule ID 1387 //
     /* 190815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190844 */     // (intrinsic_wo_chain:{ *:[v16i8] } 670:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 190847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190853 */     GIR_RootConstrainSelectedInstOperands,
     /* 190854 */     // GIR_Coverage, 1387,
     /* 190854 */     GIR_EraseRootFromParent_Done,
     /* 190855 */   // Label 3523: @190855
     /* 190855 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(190900), // Rule ID 1388 //
     /* 190860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190889 */     // (intrinsic_wo_chain:{ *:[v4i16] } 670:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 190892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190898 */     GIR_RootConstrainSelectedInstOperands,
     /* 190899 */     // GIR_Coverage, 1388,
     /* 190899 */     GIR_EraseRootFromParent_Done,
     /* 190900 */   // Label 3524: @190900
     /* 190900 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(190945), // Rule ID 1389 //
     /* 190905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190934 */     // (intrinsic_wo_chain:{ *:[v8i16] } 670:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 190937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190943 */     GIR_RootConstrainSelectedInstOperands,
     /* 190944 */     // GIR_Coverage, 1389,
     /* 190944 */     GIR_EraseRootFromParent_Done,
     /* 190945 */   // Label 3525: @190945
     /* 190945 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(190990), // Rule ID 1390 //
     /* 190950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190979 */     // (intrinsic_wo_chain:{ *:[v2i32] } 670:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 190982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190988 */     GIR_RootConstrainSelectedInstOperands,
     /* 190989 */     // GIR_Coverage, 1390,
     /* 190989 */     GIR_EraseRootFromParent_Done,
     /* 190990 */   // Label 3526: @190990
     /* 190990 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(191035), // Rule ID 1391 //
     /* 190995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 191003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191024 */     // (intrinsic_wo_chain:{ *:[v4i32] } 670:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 191027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191033 */     GIR_RootConstrainSelectedInstOperands,
     /* 191034 */     // GIR_Coverage, 1391,
     /* 191034 */     GIR_EraseRootFromParent_Done,
     /* 191035 */   // Label 3527: @191035
     /* 191035 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(191080), // Rule ID 1392 //
     /* 191040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 191048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191069 */     // (intrinsic_wo_chain:{ *:[v8i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 191072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191078 */     GIR_RootConstrainSelectedInstOperands,
     /* 191079 */     // GIR_Coverage, 1392,
     /* 191079 */     GIR_EraseRootFromParent_Done,
     /* 191080 */   // Label 3528: @191080
     /* 191080 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(191125), // Rule ID 1393 //
     /* 191085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 191093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191114 */     // (intrinsic_wo_chain:{ *:[v16i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 191117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191123 */     GIR_RootConstrainSelectedInstOperands,
     /* 191124 */     // GIR_Coverage, 1393,
     /* 191124 */     GIR_EraseRootFromParent_Done,
     /* 191125 */   // Label 3529: @191125
     /* 191125 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(191170), // Rule ID 1394 //
     /* 191130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 191138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191159 */     // (intrinsic_wo_chain:{ *:[v4i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 191162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191168 */     GIR_RootConstrainSelectedInstOperands,
     /* 191169 */     // GIR_Coverage, 1394,
     /* 191169 */     GIR_EraseRootFromParent_Done,
     /* 191170 */   // Label 3530: @191170
     /* 191170 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(191215), // Rule ID 1395 //
     /* 191175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 191183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191204 */     // (intrinsic_wo_chain:{ *:[v8i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 191207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191213 */     GIR_RootConstrainSelectedInstOperands,
     /* 191214 */     // GIR_Coverage, 1395,
     /* 191214 */     GIR_EraseRootFromParent_Done,
     /* 191215 */   // Label 3531: @191215
     /* 191215 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(191260), // Rule ID 1396 //
     /* 191220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 191228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191249 */     // (intrinsic_wo_chain:{ *:[v2i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 191252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191258 */     GIR_RootConstrainSelectedInstOperands,
     /* 191259 */     // GIR_Coverage, 1396,
     /* 191259 */     GIR_EraseRootFromParent_Done,
     /* 191260 */   // Label 3532: @191260
     /* 191260 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(191305), // Rule ID 1397 //
     /* 191265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 191273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191294 */     // (intrinsic_wo_chain:{ *:[v4i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 191297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191303 */     GIR_RootConstrainSelectedInstOperands,
     /* 191304 */     // GIR_Coverage, 1397,
     /* 191304 */     GIR_EraseRootFromParent_Done,
     /* 191305 */   // Label 3533: @191305
     /* 191305 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(191350), // Rule ID 1404 //
     /* 191310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191339 */     // (intrinsic_wo_chain:{ *:[v8i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 191342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191348 */     GIR_RootConstrainSelectedInstOperands,
     /* 191349 */     // GIR_Coverage, 1404,
     /* 191349 */     GIR_EraseRootFromParent_Done,
     /* 191350 */   // Label 3534: @191350
     /* 191350 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(191395), // Rule ID 1405 //
     /* 191355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191384 */     // (intrinsic_wo_chain:{ *:[v16i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 191387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191393 */     GIR_RootConstrainSelectedInstOperands,
     /* 191394 */     // GIR_Coverage, 1405,
     /* 191394 */     GIR_EraseRootFromParent_Done,
     /* 191395 */   // Label 3535: @191395
     /* 191395 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(191440), // Rule ID 1406 //
     /* 191400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191429 */     // (intrinsic_wo_chain:{ *:[v4i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 191432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191438 */     GIR_RootConstrainSelectedInstOperands,
     /* 191439 */     // GIR_Coverage, 1406,
     /* 191439 */     GIR_EraseRootFromParent_Done,
     /* 191440 */   // Label 3536: @191440
     /* 191440 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(191485), // Rule ID 1407 //
     /* 191445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191474 */     // (intrinsic_wo_chain:{ *:[v8i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 191477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191483 */     GIR_RootConstrainSelectedInstOperands,
     /* 191484 */     // GIR_Coverage, 1407,
     /* 191484 */     GIR_EraseRootFromParent_Done,
     /* 191485 */   // Label 3537: @191485
     /* 191485 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(191530), // Rule ID 1408 //
     /* 191490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191519 */     // (intrinsic_wo_chain:{ *:[v2i32] } 675:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 191522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191528 */     GIR_RootConstrainSelectedInstOperands,
     /* 191529 */     // GIR_Coverage, 1408,
     /* 191529 */     GIR_EraseRootFromParent_Done,
     /* 191530 */   // Label 3538: @191530
     /* 191530 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(191575), // Rule ID 1409 //
     /* 191535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191564 */     // (intrinsic_wo_chain:{ *:[v4i32] } 675:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 191567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191573 */     GIR_RootConstrainSelectedInstOperands,
     /* 191574 */     // GIR_Coverage, 1409,
     /* 191574 */     GIR_EraseRootFromParent_Done,
     /* 191575 */   // Label 3539: @191575
     /* 191575 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(191620), // Rule ID 1416 //
     /* 191580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 191588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191609 */     // (intrinsic_wo_chain:{ *:[v8i8] } 680:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 191612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191618 */     GIR_RootConstrainSelectedInstOperands,
     /* 191619 */     // GIR_Coverage, 1416,
     /* 191619 */     GIR_EraseRootFromParent_Done,
     /* 191620 */   // Label 3540: @191620
     /* 191620 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(191665), // Rule ID 1417 //
     /* 191625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 191633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191654 */     // (intrinsic_wo_chain:{ *:[v16i8] } 680:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 191657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191663 */     GIR_RootConstrainSelectedInstOperands,
     /* 191664 */     // GIR_Coverage, 1417,
     /* 191664 */     GIR_EraseRootFromParent_Done,
     /* 191665 */   // Label 3541: @191665
     /* 191665 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(191710), // Rule ID 1418 //
     /* 191670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 191678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191699 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 191702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191708 */     GIR_RootConstrainSelectedInstOperands,
     /* 191709 */     // GIR_Coverage, 1418,
     /* 191709 */     GIR_EraseRootFromParent_Done,
     /* 191710 */   // Label 3542: @191710
     /* 191710 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(191755), // Rule ID 1419 //
     /* 191715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 191723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191744 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 191747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191753 */     GIR_RootConstrainSelectedInstOperands,
     /* 191754 */     // GIR_Coverage, 1419,
     /* 191754 */     GIR_EraseRootFromParent_Done,
     /* 191755 */   // Label 3543: @191755
     /* 191755 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(191800), // Rule ID 1420 //
     /* 191760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 191768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191789 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 191792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191798 */     GIR_RootConstrainSelectedInstOperands,
     /* 191799 */     // GIR_Coverage, 1420,
     /* 191799 */     GIR_EraseRootFromParent_Done,
     /* 191800 */   // Label 3544: @191800
     /* 191800 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(191845), // Rule ID 1421 //
     /* 191805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 191813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191834 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 191837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191843 */     GIR_RootConstrainSelectedInstOperands,
     /* 191844 */     // GIR_Coverage, 1421,
     /* 191844 */     GIR_EraseRootFromParent_Done,
     /* 191845 */   // Label 3545: @191845
     /* 191845 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(191890), // Rule ID 1422 //
     /* 191850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 191858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 191864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 191867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191879 */     // (intrinsic_wo_chain:{ *:[v2i64] } 680:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 191879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 191882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191888 */     GIR_RootConstrainSelectedInstOperands,
     /* 191889 */     // GIR_Coverage, 1422,
     /* 191889 */     GIR_EraseRootFromParent_Done,
     /* 191890 */   // Label 3546: @191890
     /* 191890 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(191935), // Rule ID 1423 //
     /* 191895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 191903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191924 */     // (intrinsic_wo_chain:{ *:[v4i16] } 681:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 191927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191933 */     GIR_RootConstrainSelectedInstOperands,
     /* 191934 */     // GIR_Coverage, 1423,
     /* 191934 */     GIR_EraseRootFromParent_Done,
     /* 191935 */   // Label 3547: @191935
     /* 191935 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(191980), // Rule ID 1424 //
     /* 191940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 191948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191969 */     // (intrinsic_wo_chain:{ *:[v8i16] } 681:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 191972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191978 */     GIR_RootConstrainSelectedInstOperands,
     /* 191979 */     // GIR_Coverage, 1424,
     /* 191979 */     GIR_EraseRootFromParent_Done,
     /* 191980 */   // Label 3548: @191980
     /* 191980 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(192025), // Rule ID 1425 //
     /* 191985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 191993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192014 */     // (intrinsic_wo_chain:{ *:[v2i32] } 681:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 192017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192023 */     GIR_RootConstrainSelectedInstOperands,
     /* 192024 */     // GIR_Coverage, 1425,
     /* 192024 */     GIR_EraseRootFromParent_Done,
     /* 192025 */   // Label 3549: @192025
     /* 192025 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(192070), // Rule ID 1426 //
     /* 192030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 192038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192059 */     // (intrinsic_wo_chain:{ *:[v4i32] } 681:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 192062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192068 */     GIR_RootConstrainSelectedInstOperands,
     /* 192069 */     // GIR_Coverage, 1426,
     /* 192069 */     GIR_EraseRootFromParent_Done,
     /* 192070 */   // Label 3550: @192070
     /* 192070 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(192115), // Rule ID 1427 //
     /* 192075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 192083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192104 */     // (intrinsic_wo_chain:{ *:[v4i16] } 689:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 192107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192113 */     GIR_RootConstrainSelectedInstOperands,
     /* 192114 */     // GIR_Coverage, 1427,
     /* 192114 */     GIR_EraseRootFromParent_Done,
     /* 192115 */   // Label 3551: @192115
     /* 192115 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(192160), // Rule ID 1428 //
     /* 192120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 192128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192149 */     // (intrinsic_wo_chain:{ *:[v8i16] } 689:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 192152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192158 */     GIR_RootConstrainSelectedInstOperands,
     /* 192159 */     // GIR_Coverage, 1428,
     /* 192159 */     GIR_EraseRootFromParent_Done,
     /* 192160 */   // Label 3552: @192160
     /* 192160 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(192205), // Rule ID 1429 //
     /* 192165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 192173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192194 */     // (intrinsic_wo_chain:{ *:[v2i32] } 689:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 192197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192203 */     GIR_RootConstrainSelectedInstOperands,
     /* 192204 */     // GIR_Coverage, 1429,
     /* 192204 */     GIR_EraseRootFromParent_Done,
     /* 192205 */   // Label 3553: @192205
     /* 192205 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(192250), // Rule ID 1430 //
     /* 192210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 192218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192239 */     // (intrinsic_wo_chain:{ *:[v4i32] } 689:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 192242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192248 */     GIR_RootConstrainSelectedInstOperands,
     /* 192249 */     // GIR_Coverage, 1430,
     /* 192249 */     GIR_EraseRootFromParent_Done,
     /* 192250 */   // Label 3554: @192250
     /* 192250 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(192295), // Rule ID 1431 //
     /* 192255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 192263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192284 */     // (intrinsic_wo_chain:{ *:[v8i8] } 692:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 192287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192293 */     GIR_RootConstrainSelectedInstOperands,
     /* 192294 */     // GIR_Coverage, 1431,
     /* 192294 */     GIR_EraseRootFromParent_Done,
     /* 192295 */   // Label 3555: @192295
     /* 192295 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(192340), // Rule ID 1432 //
     /* 192300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 192308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192329 */     // (intrinsic_wo_chain:{ *:[v16i8] } 692:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 192332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192338 */     GIR_RootConstrainSelectedInstOperands,
     /* 192339 */     // GIR_Coverage, 1432,
     /* 192339 */     GIR_EraseRootFromParent_Done,
     /* 192340 */   // Label 3556: @192340
     /* 192340 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(192385), // Rule ID 1433 //
     /* 192345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 192353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192374 */     // (intrinsic_wo_chain:{ *:[v4i16] } 692:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 192377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192383 */     GIR_RootConstrainSelectedInstOperands,
     /* 192384 */     // GIR_Coverage, 1433,
     /* 192384 */     GIR_EraseRootFromParent_Done,
     /* 192385 */   // Label 3557: @192385
     /* 192385 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(192430), // Rule ID 1434 //
     /* 192390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 192398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192419 */     // (intrinsic_wo_chain:{ *:[v8i16] } 692:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 192422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192428 */     GIR_RootConstrainSelectedInstOperands,
     /* 192429 */     // GIR_Coverage, 1434,
     /* 192429 */     GIR_EraseRootFromParent_Done,
     /* 192430 */   // Label 3558: @192430
     /* 192430 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(192475), // Rule ID 1435 //
     /* 192435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 192443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192464 */     // (intrinsic_wo_chain:{ *:[v2i32] } 692:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 192467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192473 */     GIR_RootConstrainSelectedInstOperands,
     /* 192474 */     // GIR_Coverage, 1435,
     /* 192474 */     GIR_EraseRootFromParent_Done,
     /* 192475 */   // Label 3559: @192475
     /* 192475 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(192520), // Rule ID 1436 //
     /* 192480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 192488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192509 */     // (intrinsic_wo_chain:{ *:[v4i32] } 692:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 192512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192518 */     GIR_RootConstrainSelectedInstOperands,
     /* 192519 */     // GIR_Coverage, 1436,
     /* 192519 */     GIR_EraseRootFromParent_Done,
     /* 192520 */   // Label 3560: @192520
     /* 192520 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(192565), // Rule ID 1437 //
     /* 192525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 192533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192554 */     // (intrinsic_wo_chain:{ *:[v2i64] } 692:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 192557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192563 */     GIR_RootConstrainSelectedInstOperands,
     /* 192564 */     // GIR_Coverage, 1437,
     /* 192564 */     GIR_EraseRootFromParent_Done,
     /* 192565 */   // Label 3561: @192565
     /* 192565 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(192610), // Rule ID 1438 //
     /* 192570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192599 */     // (intrinsic_wo_chain:{ *:[v8i8] } 695:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 192602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192608 */     GIR_RootConstrainSelectedInstOperands,
     /* 192609 */     // GIR_Coverage, 1438,
     /* 192609 */     GIR_EraseRootFromParent_Done,
     /* 192610 */   // Label 3562: @192610
     /* 192610 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(192655), // Rule ID 1439 //
     /* 192615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192644 */     // (intrinsic_wo_chain:{ *:[v16i8] } 695:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 192647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192653 */     GIR_RootConstrainSelectedInstOperands,
     /* 192654 */     // GIR_Coverage, 1439,
     /* 192654 */     GIR_EraseRootFromParent_Done,
     /* 192655 */   // Label 3563: @192655
     /* 192655 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(192700), // Rule ID 1440 //
     /* 192660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192689 */     // (intrinsic_wo_chain:{ *:[v4i16] } 695:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 192692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192698 */     GIR_RootConstrainSelectedInstOperands,
     /* 192699 */     // GIR_Coverage, 1440,
     /* 192699 */     GIR_EraseRootFromParent_Done,
     /* 192700 */   // Label 3564: @192700
     /* 192700 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(192745), // Rule ID 1441 //
     /* 192705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192734 */     // (intrinsic_wo_chain:{ *:[v8i16] } 695:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 192737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192743 */     GIR_RootConstrainSelectedInstOperands,
     /* 192744 */     // GIR_Coverage, 1441,
     /* 192744 */     GIR_EraseRootFromParent_Done,
     /* 192745 */   // Label 3565: @192745
     /* 192745 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(192790), // Rule ID 1442 //
     /* 192750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192779 */     // (intrinsic_wo_chain:{ *:[v2i32] } 695:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 192782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192788 */     GIR_RootConstrainSelectedInstOperands,
     /* 192789 */     // GIR_Coverage, 1442,
     /* 192789 */     GIR_EraseRootFromParent_Done,
     /* 192790 */   // Label 3566: @192790
     /* 192790 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(192835), // Rule ID 1443 //
     /* 192795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192824 */     // (intrinsic_wo_chain:{ *:[v4i32] } 695:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 192827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192833 */     GIR_RootConstrainSelectedInstOperands,
     /* 192834 */     // GIR_Coverage, 1443,
     /* 192834 */     GIR_EraseRootFromParent_Done,
     /* 192835 */   // Label 3567: @192835
     /* 192835 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(192880), // Rule ID 1444 //
     /* 192840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192869 */     // (intrinsic_wo_chain:{ *:[v2i64] } 695:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 192872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192878 */     GIR_RootConstrainSelectedInstOperands,
     /* 192879 */     // GIR_Coverage, 1444,
     /* 192879 */     GIR_EraseRootFromParent_Done,
     /* 192880 */   // Label 3568: @192880
     /* 192880 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(192925), // Rule ID 1445 //
     /* 192885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 192893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192914 */     // (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 192917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192923 */     GIR_RootConstrainSelectedInstOperands,
     /* 192924 */     // GIR_Coverage, 1445,
     /* 192924 */     GIR_EraseRootFromParent_Done,
     /* 192925 */   // Label 3569: @192925
     /* 192925 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(192970), // Rule ID 1446 //
     /* 192930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 192938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192959 */     // (intrinsic_wo_chain:{ *:[v16i8] } 699:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 192962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192968 */     GIR_RootConstrainSelectedInstOperands,
     /* 192969 */     // GIR_Coverage, 1446,
     /* 192969 */     GIR_EraseRootFromParent_Done,
     /* 192970 */   // Label 3570: @192970
     /* 192970 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(193015), // Rule ID 1447 //
     /* 192975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 192983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193004 */     // (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 193007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193013 */     GIR_RootConstrainSelectedInstOperands,
     /* 193014 */     // GIR_Coverage, 1447,
     /* 193014 */     GIR_EraseRootFromParent_Done,
     /* 193015 */   // Label 3571: @193015
     /* 193015 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(193060), // Rule ID 1448 //
     /* 193020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 193028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193049 */     // (intrinsic_wo_chain:{ *:[v8i16] } 699:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 193052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193058 */     GIR_RootConstrainSelectedInstOperands,
     /* 193059 */     // GIR_Coverage, 1448,
     /* 193059 */     GIR_EraseRootFromParent_Done,
     /* 193060 */   // Label 3572: @193060
     /* 193060 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(193105), // Rule ID 1449 //
     /* 193065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 193073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193094 */     // (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 193097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193103 */     GIR_RootConstrainSelectedInstOperands,
     /* 193104 */     // GIR_Coverage, 1449,
     /* 193104 */     GIR_EraseRootFromParent_Done,
     /* 193105 */   // Label 3573: @193105
     /* 193105 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(193150), // Rule ID 1450 //
     /* 193110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 193118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193139 */     // (intrinsic_wo_chain:{ *:[v4i32] } 699:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 193142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193148 */     GIR_RootConstrainSelectedInstOperands,
     /* 193149 */     // GIR_Coverage, 1450,
     /* 193149 */     GIR_EraseRootFromParent_Done,
     /* 193150 */   // Label 3574: @193150
     /* 193150 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(193195), // Rule ID 1451 //
     /* 193155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 193163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 193169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 193172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193184 */     // (intrinsic_wo_chain:{ *:[v2i64] } 699:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 193184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 193187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193193 */     GIR_RootConstrainSelectedInstOperands,
     /* 193194 */     // GIR_Coverage, 1451,
     /* 193194 */     GIR_EraseRootFromParent_Done,
     /* 193195 */   // Label 3575: @193195
     /* 193195 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(193240), // Rule ID 1458 //
     /* 193200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 193208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193229 */     // (intrinsic_wo_chain:{ *:[v8i8] } 703:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 193232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193238 */     GIR_RootConstrainSelectedInstOperands,
     /* 193239 */     // GIR_Coverage, 1458,
     /* 193239 */     GIR_EraseRootFromParent_Done,
     /* 193240 */   // Label 3576: @193240
     /* 193240 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(193285), // Rule ID 1459 //
     /* 193245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 193253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193274 */     // (intrinsic_wo_chain:{ *:[v16i8] } 703:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 193277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193283 */     GIR_RootConstrainSelectedInstOperands,
     /* 193284 */     // GIR_Coverage, 1459,
     /* 193284 */     GIR_EraseRootFromParent_Done,
     /* 193285 */   // Label 3577: @193285
     /* 193285 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(193330), // Rule ID 1460 //
     /* 193290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 193298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193319 */     // (intrinsic_wo_chain:{ *:[v4i16] } 703:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 193322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193328 */     GIR_RootConstrainSelectedInstOperands,
     /* 193329 */     // GIR_Coverage, 1460,
     /* 193329 */     GIR_EraseRootFromParent_Done,
     /* 193330 */   // Label 3578: @193330
     /* 193330 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(193375), // Rule ID 1461 //
     /* 193335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 193343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193364 */     // (intrinsic_wo_chain:{ *:[v8i16] } 703:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 193367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193373 */     GIR_RootConstrainSelectedInstOperands,
     /* 193374 */     // GIR_Coverage, 1461,
     /* 193374 */     GIR_EraseRootFromParent_Done,
     /* 193375 */   // Label 3579: @193375
     /* 193375 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(193420), // Rule ID 1462 //
     /* 193380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 193388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193409 */     // (intrinsic_wo_chain:{ *:[v2i32] } 703:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 193412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193418 */     GIR_RootConstrainSelectedInstOperands,
     /* 193419 */     // GIR_Coverage, 1462,
     /* 193419 */     GIR_EraseRootFromParent_Done,
     /* 193420 */   // Label 3580: @193420
     /* 193420 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(193465), // Rule ID 1463 //
     /* 193425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 193433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193454 */     // (intrinsic_wo_chain:{ *:[v4i32] } 703:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 193457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193463 */     GIR_RootConstrainSelectedInstOperands,
     /* 193464 */     // GIR_Coverage, 1463,
     /* 193464 */     GIR_EraseRootFromParent_Done,
     /* 193465 */   // Label 3581: @193465
     /* 193465 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(193510), // Rule ID 1464 //
     /* 193470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 193478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 193484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 193487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193499 */     // (intrinsic_wo_chain:{ *:[v2i64] } 703:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 193499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 193502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193508 */     GIR_RootConstrainSelectedInstOperands,
     /* 193509 */     // GIR_Coverage, 1464,
     /* 193509 */     GIR_EraseRootFromParent_Done,
     /* 193510 */   // Label 3582: @193510
     /* 193510 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(193555), // Rule ID 1465 //
     /* 193515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 193523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193544 */     // (intrinsic_wo_chain:{ *:[v8i8] } 704:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 193547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193553 */     GIR_RootConstrainSelectedInstOperands,
     /* 193554 */     // GIR_Coverage, 1465,
     /* 193554 */     GIR_EraseRootFromParent_Done,
     /* 193555 */   // Label 3583: @193555
     /* 193555 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(193600), // Rule ID 1466 //
     /* 193560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 193568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193589 */     // (intrinsic_wo_chain:{ *:[v16i8] } 704:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 193592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193598 */     GIR_RootConstrainSelectedInstOperands,
     /* 193599 */     // GIR_Coverage, 1466,
     /* 193599 */     GIR_EraseRootFromParent_Done,
     /* 193600 */   // Label 3584: @193600
     /* 193600 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(193645), // Rule ID 1467 //
     /* 193605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 193613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193634 */     // (intrinsic_wo_chain:{ *:[v4i16] } 704:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 193637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193643 */     GIR_RootConstrainSelectedInstOperands,
     /* 193644 */     // GIR_Coverage, 1467,
     /* 193644 */     GIR_EraseRootFromParent_Done,
     /* 193645 */   // Label 3585: @193645
     /* 193645 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(193690), // Rule ID 1468 //
     /* 193650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 193658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193679 */     // (intrinsic_wo_chain:{ *:[v8i16] } 704:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 193682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193688 */     GIR_RootConstrainSelectedInstOperands,
     /* 193689 */     // GIR_Coverage, 1468,
     /* 193689 */     GIR_EraseRootFromParent_Done,
     /* 193690 */   // Label 3586: @193690
     /* 193690 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(193735), // Rule ID 1469 //
     /* 193695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 193703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193724 */     // (intrinsic_wo_chain:{ *:[v2i32] } 704:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 193727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193733 */     GIR_RootConstrainSelectedInstOperands,
     /* 193734 */     // GIR_Coverage, 1469,
     /* 193734 */     GIR_EraseRootFromParent_Done,
     /* 193735 */   // Label 3587: @193735
     /* 193735 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(193780), // Rule ID 1470 //
     /* 193740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 193748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193769 */     // (intrinsic_wo_chain:{ *:[v4i32] } 704:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 193772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193778 */     GIR_RootConstrainSelectedInstOperands,
     /* 193779 */     // GIR_Coverage, 1470,
     /* 193779 */     GIR_EraseRootFromParent_Done,
     /* 193780 */   // Label 3588: @193780
     /* 193780 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(193825), // Rule ID 1471 //
     /* 193785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 193793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 193799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 193802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193814 */     // (intrinsic_wo_chain:{ *:[v2i64] } 704:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 193814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 193817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193823 */     GIR_RootConstrainSelectedInstOperands,
     /* 193824 */     // GIR_Coverage, 1471,
     /* 193824 */     GIR_EraseRootFromParent_Done,
     /* 193825 */   // Label 3589: @193825
     /* 193825 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(193870), // Rule ID 1492 //
     /* 193830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 193838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193859 */     // (intrinsic_wo_chain:{ *:[v8i8] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 193862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193868 */     GIR_RootConstrainSelectedInstOperands,
     /* 193869 */     // GIR_Coverage, 1492,
     /* 193869 */     GIR_EraseRootFromParent_Done,
     /* 193870 */   // Label 3590: @193870
     /* 193870 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(193915), // Rule ID 1494 //
     /* 193875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 193883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193904 */     // (intrinsic_wo_chain:{ *:[v16i8] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 193907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193913 */     GIR_RootConstrainSelectedInstOperands,
     /* 193914 */     // GIR_Coverage, 1494,
     /* 193914 */     GIR_EraseRootFromParent_Done,
     /* 193915 */   // Label 3591: @193915
     /* 193915 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(193960), // Rule ID 1496 //
     /* 193920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 193928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193949 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 193952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193958 */     GIR_RootConstrainSelectedInstOperands,
     /* 193959 */     // GIR_Coverage, 1496,
     /* 193959 */     GIR_EraseRootFromParent_Done,
     /* 193960 */   // Label 3592: @193960
     /* 193960 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(194005), // Rule ID 1498 //
     /* 193965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 193973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193994 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 193997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194003 */     GIR_RootConstrainSelectedInstOperands,
     /* 194004 */     // GIR_Coverage, 1498,
     /* 194004 */     GIR_EraseRootFromParent_Done,
     /* 194005 */   // Label 3593: @194005
     /* 194005 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(194050), // Rule ID 1500 //
     /* 194010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 194018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194039 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 194042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194048 */     GIR_RootConstrainSelectedInstOperands,
     /* 194049 */     // GIR_Coverage, 1500,
     /* 194049 */     GIR_EraseRootFromParent_Done,
     /* 194050 */   // Label 3594: @194050
     /* 194050 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(194095), // Rule ID 1502 //
     /* 194055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 194063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194084 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 194087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194093 */     GIR_RootConstrainSelectedInstOperands,
     /* 194094 */     // GIR_Coverage, 1502,
     /* 194094 */     GIR_EraseRootFromParent_Done,
     /* 194095 */   // Label 3595: @194095
     /* 194095 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(194140), // Rule ID 1509 //
     /* 194100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 194108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194129 */     // (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 194132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194138 */     GIR_RootConstrainSelectedInstOperands,
     /* 194139 */     // GIR_Coverage, 1509,
     /* 194139 */     GIR_EraseRootFromParent_Done,
     /* 194140 */   // Label 3596: @194140
     /* 194140 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(194185), // Rule ID 1510 //
     /* 194145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 194153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194174 */     // (intrinsic_wo_chain:{ *:[v16i8] } 731:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 194177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194183 */     GIR_RootConstrainSelectedInstOperands,
     /* 194184 */     // GIR_Coverage, 1510,
     /* 194184 */     GIR_EraseRootFromParent_Done,
     /* 194185 */   // Label 3597: @194185
     /* 194185 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(194230), // Rule ID 1511 //
     /* 194190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 194198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194219 */     // (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 194222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194228 */     GIR_RootConstrainSelectedInstOperands,
     /* 194229 */     // GIR_Coverage, 1511,
     /* 194229 */     GIR_EraseRootFromParent_Done,
     /* 194230 */   // Label 3598: @194230
     /* 194230 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(194275), // Rule ID 1512 //
     /* 194235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 194243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194264 */     // (intrinsic_wo_chain:{ *:[v8i16] } 731:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 194267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194273 */     GIR_RootConstrainSelectedInstOperands,
     /* 194274 */     // GIR_Coverage, 1512,
     /* 194274 */     GIR_EraseRootFromParent_Done,
     /* 194275 */   // Label 3599: @194275
     /* 194275 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(194320), // Rule ID 1513 //
     /* 194280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 194288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194309 */     // (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 194312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194318 */     GIR_RootConstrainSelectedInstOperands,
     /* 194319 */     // GIR_Coverage, 1513,
     /* 194319 */     GIR_EraseRootFromParent_Done,
     /* 194320 */   // Label 3600: @194320
     /* 194320 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(194365), // Rule ID 1514 //
     /* 194325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 194333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194354 */     // (intrinsic_wo_chain:{ *:[v4i32] } 731:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 194357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194363 */     GIR_RootConstrainSelectedInstOperands,
     /* 194364 */     // GIR_Coverage, 1514,
     /* 194364 */     GIR_EraseRootFromParent_Done,
     /* 194365 */   // Label 3601: @194365
     /* 194365 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(194410), // Rule ID 1515 //
     /* 194370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 194378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194399 */     // (intrinsic_wo_chain:{ *:[v8i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 194402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194408 */     GIR_RootConstrainSelectedInstOperands,
     /* 194409 */     // GIR_Coverage, 1515,
     /* 194409 */     GIR_EraseRootFromParent_Done,
     /* 194410 */   // Label 3602: @194410
     /* 194410 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(194455), // Rule ID 1516 //
     /* 194415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 194423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194444 */     // (intrinsic_wo_chain:{ *:[v16i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 194447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194453 */     GIR_RootConstrainSelectedInstOperands,
     /* 194454 */     // GIR_Coverage, 1516,
     /* 194454 */     GIR_EraseRootFromParent_Done,
     /* 194455 */   // Label 3603: @194455
     /* 194455 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(194500), // Rule ID 1517 //
     /* 194460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 194468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194489 */     // (intrinsic_wo_chain:{ *:[v4i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 194492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194498 */     GIR_RootConstrainSelectedInstOperands,
     /* 194499 */     // GIR_Coverage, 1517,
     /* 194499 */     GIR_EraseRootFromParent_Done,
     /* 194500 */   // Label 3604: @194500
     /* 194500 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(194545), // Rule ID 1518 //
     /* 194505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 194513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194534 */     // (intrinsic_wo_chain:{ *:[v8i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 194537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194543 */     GIR_RootConstrainSelectedInstOperands,
     /* 194544 */     // GIR_Coverage, 1518,
     /* 194544 */     GIR_EraseRootFromParent_Done,
     /* 194545 */   // Label 3605: @194545
     /* 194545 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(194590), // Rule ID 1519 //
     /* 194550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 194558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194579 */     // (intrinsic_wo_chain:{ *:[v2i32] } 733:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 194582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194588 */     GIR_RootConstrainSelectedInstOperands,
     /* 194589 */     // GIR_Coverage, 1519,
     /* 194589 */     GIR_EraseRootFromParent_Done,
     /* 194590 */   // Label 3606: @194590
     /* 194590 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(194635), // Rule ID 1520 //
     /* 194595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 194603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194624 */     // (intrinsic_wo_chain:{ *:[v4i32] } 733:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 194627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194633 */     GIR_RootConstrainSelectedInstOperands,
     /* 194634 */     // GIR_Coverage, 1520,
     /* 194634 */     GIR_EraseRootFromParent_Done,
     /* 194635 */   // Label 3607: @194635
     /* 194635 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(194680), // Rule ID 1527 //
     /* 194640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 194648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194669 */     // (intrinsic_wo_chain:{ *:[v8i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 194672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194678 */     GIR_RootConstrainSelectedInstOperands,
     /* 194679 */     // GIR_Coverage, 1527,
     /* 194679 */     GIR_EraseRootFromParent_Done,
     /* 194680 */   // Label 3608: @194680
     /* 194680 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(194725), // Rule ID 1528 //
     /* 194685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 194693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194714 */     // (intrinsic_wo_chain:{ *:[v16i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 194717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194723 */     GIR_RootConstrainSelectedInstOperands,
     /* 194724 */     // GIR_Coverage, 1528,
     /* 194724 */     GIR_EraseRootFromParent_Done,
     /* 194725 */   // Label 3609: @194725
     /* 194725 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(194770), // Rule ID 1529 //
     /* 194730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 194738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194759 */     // (intrinsic_wo_chain:{ *:[v4i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 194762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194768 */     GIR_RootConstrainSelectedInstOperands,
     /* 194769 */     // GIR_Coverage, 1529,
     /* 194769 */     GIR_EraseRootFromParent_Done,
     /* 194770 */   // Label 3610: @194770
     /* 194770 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(194815), // Rule ID 1530 //
     /* 194775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 194783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194804 */     // (intrinsic_wo_chain:{ *:[v8i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 194807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194813 */     GIR_RootConstrainSelectedInstOperands,
     /* 194814 */     // GIR_Coverage, 1530,
     /* 194814 */     GIR_EraseRootFromParent_Done,
     /* 194815 */   // Label 3611: @194815
     /* 194815 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(194860), // Rule ID 1531 //
     /* 194820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 194828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194849 */     // (intrinsic_wo_chain:{ *:[v2i32] } 736:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 194852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194858 */     GIR_RootConstrainSelectedInstOperands,
     /* 194859 */     // GIR_Coverage, 1531,
     /* 194859 */     GIR_EraseRootFromParent_Done,
     /* 194860 */   // Label 3612: @194860
     /* 194860 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(194905), // Rule ID 1532 //
     /* 194865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 194873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194894 */     // (intrinsic_wo_chain:{ *:[v4i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 194897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194903 */     GIR_RootConstrainSelectedInstOperands,
     /* 194904 */     // GIR_Coverage, 1532,
     /* 194904 */     GIR_EraseRootFromParent_Done,
     /* 194905 */   // Label 3613: @194905
     /* 194905 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(194950), // Rule ID 1539 //
     /* 194910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 194918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194939 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 194942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194948 */     GIR_RootConstrainSelectedInstOperands,
     /* 194949 */     // GIR_Coverage, 1539,
     /* 194949 */     GIR_EraseRootFromParent_Done,
     /* 194950 */   // Label 3614: @194950
     /* 194950 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(194995), // Rule ID 1540 //
     /* 194955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 194963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194984 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 194987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194993 */     GIR_RootConstrainSelectedInstOperands,
     /* 194994 */     // GIR_Coverage, 1540,
     /* 194994 */     GIR_EraseRootFromParent_Done,
     /* 194995 */   // Label 3615: @194995
     /* 194995 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(195040), // Rule ID 1541 //
     /* 195000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 195008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195029 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 195029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 195032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195038 */     GIR_RootConstrainSelectedInstOperands,
     /* 195039 */     // GIR_Coverage, 1541,
     /* 195039 */     GIR_EraseRootFromParent_Done,
     /* 195040 */   // Label 3616: @195040
     /* 195040 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(195085), // Rule ID 1542 //
     /* 195045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 195053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195074 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 195074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 195077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195083 */     GIR_RootConstrainSelectedInstOperands,
     /* 195084 */     // GIR_Coverage, 1542,
     /* 195084 */     GIR_EraseRootFromParent_Done,
     /* 195085 */   // Label 3617: @195085
     /* 195085 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(195130), // Rule ID 1543 //
     /* 195090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 195098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 195104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195119 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 195119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 195122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195128 */     GIR_RootConstrainSelectedInstOperands,
     /* 195129 */     // GIR_Coverage, 1543,
     /* 195129 */     GIR_EraseRootFromParent_Done,
     /* 195130 */   // Label 3618: @195130
     /* 195130 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(195175), // Rule ID 1544 //
     /* 195135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 195143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195164 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 195164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 195167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195173 */     GIR_RootConstrainSelectedInstOperands,
     /* 195174 */     // GIR_Coverage, 1544,
     /* 195174 */     GIR_EraseRootFromParent_Done,
     /* 195175 */   // Label 3619: @195175
     /* 195175 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(195220), // Rule ID 1545 //
     /* 195180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 195188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195209 */     // (intrinsic_wo_chain:{ *:[v2i64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 195209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 195212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195218 */     GIR_RootConstrainSelectedInstOperands,
     /* 195219 */     // GIR_Coverage, 1545,
     /* 195219 */     GIR_EraseRootFromParent_Done,
     /* 195220 */   // Label 3620: @195220
     /* 195220 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(195265), // Rule ID 1546 //
     /* 195225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 195236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 195239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 195242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195254 */     // (intrinsic_wo_chain:{ *:[v8i8] } 741:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 195254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 195257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195263 */     GIR_RootConstrainSelectedInstOperands,
     /* 195264 */     // GIR_Coverage, 1546,
     /* 195264 */     GIR_EraseRootFromParent_Done,
     /* 195265 */   // Label 3621: @195265
     /* 195265 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(195310), // Rule ID 1547 //
     /* 195270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 195281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 195284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 195287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195299 */     // (intrinsic_wo_chain:{ *:[v16i8] } 741:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 195299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 195302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195308 */     GIR_RootConstrainSelectedInstOperands,
     /* 195309 */     // GIR_Coverage, 1547,
     /* 195309 */     GIR_EraseRootFromParent_Done,
     /* 195310 */   // Label 3622: @195310
     /* 195310 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(195355), // Rule ID 1548 //
     /* 195315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195344 */     // (intrinsic_wo_chain:{ *:[v4i16] } 741:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 195344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 195347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195353 */     GIR_RootConstrainSelectedInstOperands,
     /* 195354 */     // GIR_Coverage, 1548,
     /* 195354 */     GIR_EraseRootFromParent_Done,
     /* 195355 */   // Label 3623: @195355
     /* 195355 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(195400), // Rule ID 1549 //
     /* 195360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195389 */     // (intrinsic_wo_chain:{ *:[v8i16] } 741:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 195389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 195392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195398 */     GIR_RootConstrainSelectedInstOperands,
     /* 195399 */     // GIR_Coverage, 1549,
     /* 195399 */     GIR_EraseRootFromParent_Done,
     /* 195400 */   // Label 3624: @195400
     /* 195400 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(195445), // Rule ID 1550 //
     /* 195405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 195419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195434 */     // (intrinsic_wo_chain:{ *:[v2i32] } 741:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 195434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 195437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195443 */     GIR_RootConstrainSelectedInstOperands,
     /* 195444 */     // GIR_Coverage, 1550,
     /* 195444 */     GIR_EraseRootFromParent_Done,
     /* 195445 */   // Label 3625: @195445
     /* 195445 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(195490), // Rule ID 1551 //
     /* 195450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195479 */     // (intrinsic_wo_chain:{ *:[v4i32] } 741:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 195479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 195482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195488 */     GIR_RootConstrainSelectedInstOperands,
     /* 195489 */     // GIR_Coverage, 1551,
     /* 195489 */     GIR_EraseRootFromParent_Done,
     /* 195490 */   // Label 3626: @195490
     /* 195490 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(195535), // Rule ID 1552 //
     /* 195495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195524 */     // (intrinsic_wo_chain:{ *:[v2i64] } 741:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 195524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 195527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195533 */     GIR_RootConstrainSelectedInstOperands,
     /* 195534 */     // GIR_Coverage, 1552,
     /* 195534 */     GIR_EraseRootFromParent_Done,
     /* 195535 */   // Label 3627: @195535
     /* 195535 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(195580), // Rule ID 1553 //
     /* 195540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 195551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 195554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 195557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195569 */     // (intrinsic_wo_chain:{ *:[v8i8] } 743:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 195569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 195572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195578 */     GIR_RootConstrainSelectedInstOperands,
     /* 195579 */     // GIR_Coverage, 1553,
     /* 195579 */     GIR_EraseRootFromParent_Done,
     /* 195580 */   // Label 3628: @195580
     /* 195580 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(195625), // Rule ID 1554 //
     /* 195585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 195596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 195599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 195602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195614 */     // (intrinsic_wo_chain:{ *:[v16i8] } 743:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 195614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 195617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195623 */     GIR_RootConstrainSelectedInstOperands,
     /* 195624 */     // GIR_Coverage, 1554,
     /* 195624 */     GIR_EraseRootFromParent_Done,
     /* 195625 */   // Label 3629: @195625
     /* 195625 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(195670), // Rule ID 1555 //
     /* 195630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195659 */     // (intrinsic_wo_chain:{ *:[v4i16] } 743:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 195659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 195662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195668 */     GIR_RootConstrainSelectedInstOperands,
     /* 195669 */     // GIR_Coverage, 1555,
     /* 195669 */     GIR_EraseRootFromParent_Done,
     /* 195670 */   // Label 3630: @195670
     /* 195670 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(195715), // Rule ID 1556 //
     /* 195675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195704 */     // (intrinsic_wo_chain:{ *:[v8i16] } 743:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 195704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 195707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195713 */     GIR_RootConstrainSelectedInstOperands,
     /* 195714 */     // GIR_Coverage, 1556,
     /* 195714 */     GIR_EraseRootFromParent_Done,
     /* 195715 */   // Label 3631: @195715
     /* 195715 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(195760), // Rule ID 1557 //
     /* 195720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 195734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195749 */     // (intrinsic_wo_chain:{ *:[v2i32] } 743:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 195749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 195752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195758 */     GIR_RootConstrainSelectedInstOperands,
     /* 195759 */     // GIR_Coverage, 1557,
     /* 195759 */     GIR_EraseRootFromParent_Done,
     /* 195760 */   // Label 3632: @195760
     /* 195760 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(195805), // Rule ID 1558 //
     /* 195765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195794 */     // (intrinsic_wo_chain:{ *:[v4i32] } 743:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 195794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 195797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195803 */     GIR_RootConstrainSelectedInstOperands,
     /* 195804 */     // GIR_Coverage, 1558,
     /* 195804 */     GIR_EraseRootFromParent_Done,
     /* 195805 */   // Label 3633: @195805
     /* 195805 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(195850), // Rule ID 1559 //
     /* 195810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195839 */     // (intrinsic_wo_chain:{ *:[v2i64] } 743:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 195839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 195842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195848 */     GIR_RootConstrainSelectedInstOperands,
     /* 195849 */     // GIR_Coverage, 1559,
     /* 195849 */     GIR_EraseRootFromParent_Done,
     /* 195850 */   // Label 3634: @195850
     /* 195850 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(195895), // Rule ID 1560 //
     /* 195855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 195863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 195866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 195869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 195872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195884 */     // (intrinsic_wo_chain:{ *:[v8i8] } 745:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 195884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 195887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195893 */     GIR_RootConstrainSelectedInstOperands,
     /* 195894 */     // GIR_Coverage, 1560,
     /* 195894 */     GIR_EraseRootFromParent_Done,
     /* 195895 */   // Label 3635: @195895
     /* 195895 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(195940), // Rule ID 1561 //
     /* 195900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 195908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 195911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 195914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 195917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195929 */     // (intrinsic_wo_chain:{ *:[v16i8] } 745:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 195929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 195932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195938 */     GIR_RootConstrainSelectedInstOperands,
     /* 195939 */     // GIR_Coverage, 1561,
     /* 195939 */     GIR_EraseRootFromParent_Done,
     /* 195940 */   // Label 3636: @195940
     /* 195940 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(195985), // Rule ID 1562 //
     /* 195945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 195953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195974 */     // (intrinsic_wo_chain:{ *:[v4i16] } 745:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 195974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 195977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195983 */     GIR_RootConstrainSelectedInstOperands,
     /* 195984 */     // GIR_Coverage, 1562,
     /* 195984 */     GIR_EraseRootFromParent_Done,
     /* 195985 */   // Label 3637: @195985
     /* 195985 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(196030), // Rule ID 1563 //
     /* 195990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 195998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196019 */     // (intrinsic_wo_chain:{ *:[v8i16] } 745:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 196022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196028 */     GIR_RootConstrainSelectedInstOperands,
     /* 196029 */     // GIR_Coverage, 1563,
     /* 196029 */     GIR_EraseRootFromParent_Done,
     /* 196030 */   // Label 3638: @196030
     /* 196030 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(196075), // Rule ID 1564 //
     /* 196035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 196043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 196052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196064 */     // (intrinsic_wo_chain:{ *:[v2i32] } 745:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 196064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 196067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196073 */     GIR_RootConstrainSelectedInstOperands,
     /* 196074 */     // GIR_Coverage, 1564,
     /* 196074 */     GIR_EraseRootFromParent_Done,
     /* 196075 */   // Label 3639: @196075
     /* 196075 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(196120), // Rule ID 1565 //
     /* 196080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 196088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196109 */     // (intrinsic_wo_chain:{ *:[v4i32] } 745:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 196112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196118 */     GIR_RootConstrainSelectedInstOperands,
     /* 196119 */     // GIR_Coverage, 1565,
     /* 196119 */     GIR_EraseRootFromParent_Done,
     /* 196120 */   // Label 3640: @196120
     /* 196120 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(196165), // Rule ID 1566 //
     /* 196125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 196133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196154 */     // (intrinsic_wo_chain:{ *:[v2i64] } 745:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 196157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196163 */     GIR_RootConstrainSelectedInstOperands,
     /* 196164 */     // GIR_Coverage, 1566,
     /* 196164 */     GIR_EraseRootFromParent_Done,
     /* 196165 */   // Label 3641: @196165
     /* 196165 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(196210), // Rule ID 1573 //
     /* 196170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 196184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 196187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196199 */     // (intrinsic_wo_chain:{ *:[v8i8] } 749:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 196199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 196202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196208 */     GIR_RootConstrainSelectedInstOperands,
     /* 196209 */     // GIR_Coverage, 1573,
     /* 196209 */     GIR_EraseRootFromParent_Done,
     /* 196210 */   // Label 3642: @196210
     /* 196210 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(196255), // Rule ID 1574 //
     /* 196215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 196229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 196232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196244 */     // (intrinsic_wo_chain:{ *:[v16i8] } 749:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 196244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 196247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196253 */     GIR_RootConstrainSelectedInstOperands,
     /* 196254 */     // GIR_Coverage, 1574,
     /* 196254 */     GIR_EraseRootFromParent_Done,
     /* 196255 */   // Label 3643: @196255
     /* 196255 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(196300), // Rule ID 1575 //
     /* 196260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196289 */     // (intrinsic_wo_chain:{ *:[v4i16] } 749:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 196289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 196292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196298 */     GIR_RootConstrainSelectedInstOperands,
     /* 196299 */     // GIR_Coverage, 1575,
     /* 196299 */     GIR_EraseRootFromParent_Done,
     /* 196300 */   // Label 3644: @196300
     /* 196300 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(196345), // Rule ID 1576 //
     /* 196305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196334 */     // (intrinsic_wo_chain:{ *:[v8i16] } 749:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 196337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196343 */     GIR_RootConstrainSelectedInstOperands,
     /* 196344 */     // GIR_Coverage, 1576,
     /* 196344 */     GIR_EraseRootFromParent_Done,
     /* 196345 */   // Label 3645: @196345
     /* 196345 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(196390), // Rule ID 1577 //
     /* 196350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 196367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196379 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 196379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 196382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196388 */     GIR_RootConstrainSelectedInstOperands,
     /* 196389 */     // GIR_Coverage, 1577,
     /* 196389 */     GIR_EraseRootFromParent_Done,
     /* 196390 */   // Label 3646: @196390
     /* 196390 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(196435), // Rule ID 1578 //
     /* 196395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196424 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 196427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196433 */     GIR_RootConstrainSelectedInstOperands,
     /* 196434 */     // GIR_Coverage, 1578,
     /* 196434 */     GIR_EraseRootFromParent_Done,
     /* 196435 */   // Label 3647: @196435
     /* 196435 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(196480), // Rule ID 1579 //
     /* 196440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196469 */     // (intrinsic_wo_chain:{ *:[v2i64] } 749:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 196472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196478 */     GIR_RootConstrainSelectedInstOperands,
     /* 196479 */     // GIR_Coverage, 1579,
     /* 196479 */     GIR_EraseRootFromParent_Done,
     /* 196480 */   // Label 3648: @196480
     /* 196480 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(196525), // Rule ID 1580 //
     /* 196485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 196499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 196502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196514 */     // (intrinsic_wo_chain:{ *:[v8i8] } 752:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 196514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 196517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196523 */     GIR_RootConstrainSelectedInstOperands,
     /* 196524 */     // GIR_Coverage, 1580,
     /* 196524 */     GIR_EraseRootFromParent_Done,
     /* 196525 */   // Label 3649: @196525
     /* 196525 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(196570), // Rule ID 1581 //
     /* 196530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 196544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 196547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196559 */     // (intrinsic_wo_chain:{ *:[v16i8] } 752:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 196559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 196562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196568 */     GIR_RootConstrainSelectedInstOperands,
     /* 196569 */     // GIR_Coverage, 1581,
     /* 196569 */     GIR_EraseRootFromParent_Done,
     /* 196570 */   // Label 3650: @196570
     /* 196570 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(196615), // Rule ID 1582 //
     /* 196575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196604 */     // (intrinsic_wo_chain:{ *:[v4i16] } 752:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 196604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 196607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196613 */     GIR_RootConstrainSelectedInstOperands,
     /* 196614 */     // GIR_Coverage, 1582,
     /* 196614 */     GIR_EraseRootFromParent_Done,
     /* 196615 */   // Label 3651: @196615
     /* 196615 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(196660), // Rule ID 1583 //
     /* 196620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196649 */     // (intrinsic_wo_chain:{ *:[v8i16] } 752:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 196652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196658 */     GIR_RootConstrainSelectedInstOperands,
     /* 196659 */     // GIR_Coverage, 1583,
     /* 196659 */     GIR_EraseRootFromParent_Done,
     /* 196660 */   // Label 3652: @196660
     /* 196660 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(196705), // Rule ID 1584 //
     /* 196665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 196682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196694 */     // (intrinsic_wo_chain:{ *:[v2i32] } 752:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 196694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 196697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196703 */     GIR_RootConstrainSelectedInstOperands,
     /* 196704 */     // GIR_Coverage, 1584,
     /* 196704 */     GIR_EraseRootFromParent_Done,
     /* 196705 */   // Label 3653: @196705
     /* 196705 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(196750), // Rule ID 1585 //
     /* 196710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196739 */     // (intrinsic_wo_chain:{ *:[v4i32] } 752:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 196742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196748 */     GIR_RootConstrainSelectedInstOperands,
     /* 196749 */     // GIR_Coverage, 1585,
     /* 196749 */     GIR_EraseRootFromParent_Done,
     /* 196750 */   // Label 3654: @196750
     /* 196750 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(196795), // Rule ID 1586 //
     /* 196755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196784 */     // (intrinsic_wo_chain:{ *:[v2i64] } 752:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 196787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196793 */     GIR_RootConstrainSelectedInstOperands,
     /* 196794 */     // GIR_Coverage, 1586,
     /* 196794 */     GIR_EraseRootFromParent_Done,
     /* 196795 */   // Label 3655: @196795
     /* 196795 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(196840), // Rule ID 1614 //
     /* 196800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 196808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196829 */     // (intrinsic_wo_chain:{ *:[f64] } 786:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 196829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 196832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196838 */     GIR_RootConstrainSelectedInstOperands,
     /* 196839 */     // GIR_Coverage, 1614,
     /* 196839 */     GIR_EraseRootFromParent_Done,
     /* 196840 */   // Label 3656: @196840
     /* 196840 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(196885), // Rule ID 1615 //
     /* 196845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 196853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196874 */     // (intrinsic_wo_chain:{ *:[f32] } 786:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 196874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 196877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196883 */     GIR_RootConstrainSelectedInstOperands,
     /* 196884 */     // GIR_Coverage, 1615,
     /* 196884 */     GIR_EraseRootFromParent_Done,
     /* 196885 */   // Label 3657: @196885
     /* 196885 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(196930), // Rule ID 1616 //
     /* 196890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 196893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 196898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 196901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 196904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 196907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 196911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 196915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 196919 */     // (intrinsic_wo_chain:{ *:[f16] } 786:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 196919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 196922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196928 */     GIR_RootConstrainSelectedInstOperands,
     /* 196929 */     // GIR_Coverage, 1616,
     /* 196929 */     GIR_EraseRootFromParent_Done,
     /* 196930 */   // Label 3658: @196930
     /* 196930 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(196975), // Rule ID 1617 //
     /* 196935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 196943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196964 */     // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 196964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 196967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196973 */     GIR_RootConstrainSelectedInstOperands,
     /* 196974 */     // GIR_Coverage, 1617,
     /* 196974 */     GIR_EraseRootFromParent_Done,
     /* 196975 */   // Label 3659: @196975
     /* 196975 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(197020), // Rule ID 1618 //
     /* 196980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 196988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197009 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 197009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 197012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197018 */     GIR_RootConstrainSelectedInstOperands,
     /* 197019 */     // GIR_Coverage, 1618,
     /* 197019 */     GIR_EraseRootFromParent_Done,
     /* 197020 */   // Label 3660: @197020
     /* 197020 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(197065), // Rule ID 1619 //
     /* 197025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 197033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197054 */     // (intrinsic_wo_chain:{ *:[i64] } 579:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 197054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 197057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197063 */     GIR_RootConstrainSelectedInstOperands,
     /* 197064 */     // GIR_Coverage, 1619,
     /* 197064 */     GIR_EraseRootFromParent_Done,
     /* 197065 */   // Label 3661: @197065
     /* 197065 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(197110), // Rule ID 1620 //
     /* 197070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 197078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197099 */     // (intrinsic_wo_chain:{ *:[i32] } 579:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 197099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 197102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197108 */     GIR_RootConstrainSelectedInstOperands,
     /* 197109 */     // GIR_Coverage, 1620,
     /* 197109 */     GIR_EraseRootFromParent_Done,
     /* 197110 */   // Label 3662: @197110
     /* 197110 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(197155), // Rule ID 1627 //
     /* 197115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 197118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 197123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197144 */     // (intrinsic_wo_chain:{ *:[f64] } 611:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 197144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 197147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197153 */     GIR_RootConstrainSelectedInstOperands,
     /* 197154 */     // GIR_Coverage, 1627,
     /* 197154 */     GIR_EraseRootFromParent_Done,
     /* 197155 */   // Label 3663: @197155
     /* 197155 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(197200), // Rule ID 1628 //
     /* 197160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 197163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 197168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197189 */     // (intrinsic_wo_chain:{ *:[f32] } 611:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 197189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 197192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197198 */     GIR_RootConstrainSelectedInstOperands,
     /* 197199 */     // GIR_Coverage, 1628,
     /* 197199 */     GIR_EraseRootFromParent_Done,
     /* 197200 */   // Label 3664: @197200
     /* 197200 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(197245), // Rule ID 1629 //
     /* 197205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 197208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 197213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 197216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 197219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 197222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197234 */     // (intrinsic_wo_chain:{ *:[f16] } 611:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 197234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 197237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197243 */     GIR_RootConstrainSelectedInstOperands,
     /* 197244 */     // GIR_Coverage, 1629,
     /* 197244 */     GIR_EraseRootFromParent_Done,
     /* 197245 */   // Label 3665: @197245
     /* 197245 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(197290), // Rule ID 1630 //
     /* 197250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 197253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 197258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197279 */     // (intrinsic_wo_chain:{ *:[f64] } 634:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 197279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 197282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197288 */     GIR_RootConstrainSelectedInstOperands,
     /* 197289 */     // GIR_Coverage, 1630,
     /* 197289 */     GIR_EraseRootFromParent_Done,
     /* 197290 */   // Label 3666: @197290
     /* 197290 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(197335), // Rule ID 1631 //
     /* 197295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 197298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 197303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197324 */     // (intrinsic_wo_chain:{ *:[f32] } 634:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 197324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 197327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197333 */     GIR_RootConstrainSelectedInstOperands,
     /* 197334 */     // GIR_Coverage, 1631,
     /* 197334 */     GIR_EraseRootFromParent_Done,
     /* 197335 */   // Label 3667: @197335
     /* 197335 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(197380), // Rule ID 1632 //
     /* 197340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 197343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 197348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 197351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 197354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 197357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197369 */     // (intrinsic_wo_chain:{ *:[f16] } 634:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 197369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 197372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197378 */     GIR_RootConstrainSelectedInstOperands,
     /* 197379 */     // GIR_Coverage, 1632,
     /* 197379 */     GIR_EraseRootFromParent_Done,
     /* 197380 */   // Label 3668: @197380
     /* 197380 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(197425), // Rule ID 1633 //
     /* 197385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 197388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 197393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197414 */     // (intrinsic_wo_chain:{ *:[f64] } 641:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 197414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 197417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197423 */     GIR_RootConstrainSelectedInstOperands,
     /* 197424 */     // GIR_Coverage, 1633,
     /* 197424 */     GIR_EraseRootFromParent_Done,
     /* 197425 */   // Label 3669: @197425
     /* 197425 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(197470), // Rule ID 1634 //
     /* 197430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 197433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 197438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197459 */     // (intrinsic_wo_chain:{ *:[f32] } 641:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 197459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 197462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197468 */     GIR_RootConstrainSelectedInstOperands,
     /* 197469 */     // GIR_Coverage, 1634,
     /* 197469 */     GIR_EraseRootFromParent_Done,
     /* 197470 */   // Label 3670: @197470
     /* 197470 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(197515), // Rule ID 1635 //
     /* 197475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 197478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 197483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 197486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 197489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 197492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197504 */     // (intrinsic_wo_chain:{ *:[f16] } 641:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 197504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 197507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197513 */     GIR_RootConstrainSelectedInstOperands,
     /* 197514 */     // GIR_Coverage, 1635,
     /* 197514 */     GIR_EraseRootFromParent_Done,
     /* 197515 */   // Label 3671: @197515
     /* 197515 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(197560), // Rule ID 1636 //
     /* 197520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 197528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197549 */     // (intrinsic_wo_chain:{ *:[v1i64] } 680:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 197552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197558 */     GIR_RootConstrainSelectedInstOperands,
     /* 197559 */     // GIR_Coverage, 1636,
     /* 197559 */     GIR_EraseRootFromParent_Done,
     /* 197560 */   // Label 3672: @197560
     /* 197560 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(197605), // Rule ID 1637 //
     /* 197565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 197573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197594 */     // (intrinsic_wo_chain:{ *:[i32] } 681:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 197594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 197597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197603 */     GIR_RootConstrainSelectedInstOperands,
     /* 197604 */     // GIR_Coverage, 1637,
     /* 197604 */     GIR_EraseRootFromParent_Done,
     /* 197605 */   // Label 3673: @197605
     /* 197605 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(197650), // Rule ID 1638 //
     /* 197610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 197618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197639 */     // (intrinsic_wo_chain:{ *:[i32] } 689:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 197639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 197642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197648 */     GIR_RootConstrainSelectedInstOperands,
     /* 197649 */     // GIR_Coverage, 1638,
     /* 197649 */     GIR_EraseRootFromParent_Done,
     /* 197650 */   // Label 3674: @197650
     /* 197650 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(197695), // Rule ID 1639 //
     /* 197655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 197663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197684 */     // (intrinsic_wo_chain:{ *:[v1i64] } 692:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 197687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197693 */     GIR_RootConstrainSelectedInstOperands,
     /* 197694 */     // GIR_Coverage, 1639,
     /* 197694 */     GIR_EraseRootFromParent_Done,
     /* 197695 */   // Label 3675: @197695
     /* 197695 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(197740), // Rule ID 1640 //
     /* 197700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 197708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197729 */     // (intrinsic_wo_chain:{ *:[v1i64] } 695:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 197732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197738 */     GIR_RootConstrainSelectedInstOperands,
     /* 197739 */     // GIR_Coverage, 1640,
     /* 197739 */     GIR_EraseRootFromParent_Done,
     /* 197740 */   // Label 3676: @197740
     /* 197740 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(197785), // Rule ID 1641 //
     /* 197745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 197753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197774 */     // (intrinsic_wo_chain:{ *:[v1i64] } 699:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 197777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197783 */     GIR_RootConstrainSelectedInstOperands,
     /* 197784 */     // GIR_Coverage, 1641,
     /* 197784 */     GIR_EraseRootFromParent_Done,
     /* 197785 */   // Label 3677: @197785
     /* 197785 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(197830), // Rule ID 1642 //
     /* 197790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 197798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197819 */     // (intrinsic_wo_chain:{ *:[v1i64] } 703:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 197822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197828 */     GIR_RootConstrainSelectedInstOperands,
     /* 197829 */     // GIR_Coverage, 1642,
     /* 197829 */     GIR_EraseRootFromParent_Done,
     /* 197830 */   // Label 3678: @197830
     /* 197830 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(197875), // Rule ID 1643 //
     /* 197835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 197843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197864 */     // (intrinsic_wo_chain:{ *:[v1i64] } 704:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 197867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197873 */     GIR_RootConstrainSelectedInstOperands,
     /* 197874 */     // GIR_Coverage, 1643,
     /* 197874 */     GIR_EraseRootFromParent_Done,
     /* 197875 */   // Label 3679: @197875
     /* 197875 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(197920), // Rule ID 1645 //
     /* 197880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 197888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197909 */     // (intrinsic_wo_chain:{ *:[v1i64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 197912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197918 */     GIR_RootConstrainSelectedInstOperands,
     /* 197919 */     // GIR_Coverage, 1645,
     /* 197919 */     GIR_EraseRootFromParent_Done,
     /* 197920 */   // Label 3680: @197920
     /* 197920 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(197965), // Rule ID 1646 //
     /* 197925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 197933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197954 */     // (intrinsic_wo_chain:{ *:[v1i64] } 741:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 197957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197963 */     GIR_RootConstrainSelectedInstOperands,
     /* 197964 */     // GIR_Coverage, 1646,
     /* 197964 */     GIR_EraseRootFromParent_Done,
     /* 197965 */   // Label 3681: @197965
     /* 197965 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(198010), // Rule ID 1647 //
     /* 197970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 197978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197999 */     // (intrinsic_wo_chain:{ *:[v1i64] } 743:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 198002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198008 */     GIR_RootConstrainSelectedInstOperands,
     /* 198009 */     // GIR_Coverage, 1647,
     /* 198009 */     GIR_EraseRootFromParent_Done,
     /* 198010 */   // Label 3682: @198010
     /* 198010 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(198055), // Rule ID 1648 //
     /* 198015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 198023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198044 */     // (intrinsic_wo_chain:{ *:[v1i64] } 745:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 198044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 198047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198053 */     GIR_RootConstrainSelectedInstOperands,
     /* 198054 */     // GIR_Coverage, 1648,
     /* 198054 */     GIR_EraseRootFromParent_Done,
     /* 198055 */   // Label 3683: @198055
     /* 198055 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(198100), // Rule ID 1649 //
     /* 198060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 198068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198089 */     // (intrinsic_wo_chain:{ *:[v1i64] } 749:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 198089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 198092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198098 */     GIR_RootConstrainSelectedInstOperands,
     /* 198099 */     // GIR_Coverage, 1649,
     /* 198099 */     GIR_EraseRootFromParent_Done,
     /* 198100 */   // Label 3684: @198100
     /* 198100 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(198145), // Rule ID 1650 //
     /* 198105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 198113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198134 */     // (intrinsic_wo_chain:{ *:[v1i64] } 752:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 198134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 198137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198143 */     GIR_RootConstrainSelectedInstOperands,
     /* 198144 */     // GIR_Coverage, 1650,
     /* 198144 */     GIR_EraseRootFromParent_Done,
     /* 198145 */   // Label 3685: @198145
     /* 198145 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(198190), // Rule ID 1651 //
     /* 198150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 198158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198179 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 198182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198188 */     GIR_RootConstrainSelectedInstOperands,
     /* 198189 */     // GIR_Coverage, 1651,
     /* 198189 */     GIR_EraseRootFromParent_Done,
     /* 198190 */   // Label 3686: @198190
     /* 198190 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(198235), // Rule ID 1665 //
     /* 198195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 198203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198224 */     // (intrinsic_wo_chain:{ *:[i64] } 716:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 198224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 198227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198233 */     GIR_RootConstrainSelectedInstOperands,
     /* 198234 */     // GIR_Coverage, 1665,
     /* 198234 */     GIR_EraseRootFromParent_Done,
     /* 198235 */   // Label 3687: @198235
     /* 198235 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(198280), // Rule ID 1666 //
     /* 198240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 198248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198269 */     // (intrinsic_wo_chain:{ *:[i32] } 716:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 198269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 198272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198278 */     GIR_RootConstrainSelectedInstOperands,
     /* 198279 */     // GIR_Coverage, 1666,
     /* 198279 */     GIR_EraseRootFromParent_Done,
     /* 198280 */   // Label 3688: @198280
     /* 198280 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(198325), // Rule ID 1671 //
     /* 198285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 198293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198314 */     // (intrinsic_wo_chain:{ *:[i64] } 755:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 198314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 198317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198323 */     GIR_RootConstrainSelectedInstOperands,
     /* 198324 */     // GIR_Coverage, 1671,
     /* 198324 */     GIR_EraseRootFromParent_Done,
     /* 198325 */   // Label 3689: @198325
     /* 198325 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(198370), // Rule ID 1672 //
     /* 198330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 198338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198359 */     // (intrinsic_wo_chain:{ *:[i32] } 755:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 198359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 198362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198368 */     GIR_RootConstrainSelectedInstOperands,
     /* 198369 */     // GIR_Coverage, 1672,
     /* 198369 */     GIR_EraseRootFromParent_Done,
     /* 198370 */   // Label 3690: @198370
     /* 198370 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(198415), // Rule ID 1673 //
     /* 198375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 198383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 198386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198404 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 198404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 198407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198413 */     GIR_RootConstrainSelectedInstOperands,
     /* 198414 */     // GIR_Coverage, 1673,
     /* 198414 */     GIR_EraseRootFromParent_Done,
     /* 198415 */   // Label 3691: @198415
     /* 198415 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(198460), // Rule ID 1674 //
     /* 198420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 198428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198449 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 198449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 198452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198458 */     GIR_RootConstrainSelectedInstOperands,
     /* 198459 */     // GIR_Coverage, 1674,
     /* 198459 */     GIR_EraseRootFromParent_Done,
     /* 198460 */   // Label 3692: @198460
     /* 198460 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(198505), // Rule ID 1675 //
     /* 198465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 198473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198494 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 198494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 198497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198503 */     GIR_RootConstrainSelectedInstOperands,
     /* 198504 */     // GIR_Coverage, 1675,
     /* 198504 */     GIR_EraseRootFromParent_Done,
     /* 198505 */   // Label 3693: @198505
     /* 198505 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(198550), // Rule ID 1676 //
     /* 198510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 198518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 198521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198539 */     // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 198539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 198542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198548 */     GIR_RootConstrainSelectedInstOperands,
     /* 198549 */     // GIR_Coverage, 1676,
     /* 198549 */     GIR_EraseRootFromParent_Done,
     /* 198550 */   // Label 3694: @198550
     /* 198550 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(198595), // Rule ID 1677 //
     /* 198555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 198563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198584 */     // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 198584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 198587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198593 */     GIR_RootConstrainSelectedInstOperands,
     /* 198594 */     // GIR_Coverage, 1677,
     /* 198594 */     GIR_EraseRootFromParent_Done,
     /* 198595 */   // Label 3695: @198595
     /* 198595 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(198640), // Rule ID 1678 //
     /* 198600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 198608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198629 */     // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 198629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 198632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198638 */     GIR_RootConstrainSelectedInstOperands,
     /* 198639 */     // GIR_Coverage, 1678,
     /* 198639 */     GIR_EraseRootFromParent_Done,
     /* 198640 */   // Label 3696: @198640
     /* 198640 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(198685), // Rule ID 1679 //
     /* 198645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 198653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 198656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198674 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 198674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 198677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198683 */     GIR_RootConstrainSelectedInstOperands,
     /* 198684 */     // GIR_Coverage, 1679,
     /* 198684 */     GIR_EraseRootFromParent_Done,
     /* 198685 */   // Label 3697: @198685
     /* 198685 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(198730), // Rule ID 1680 //
     /* 198690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 198698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198719 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 198719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 198722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198728 */     GIR_RootConstrainSelectedInstOperands,
     /* 198729 */     // GIR_Coverage, 1680,
     /* 198729 */     GIR_EraseRootFromParent_Done,
     /* 198730 */   // Label 3698: @198730
     /* 198730 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(198775), // Rule ID 1681 //
     /* 198735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 198743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198764 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 198764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 198767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198773 */     GIR_RootConstrainSelectedInstOperands,
     /* 198774 */     // GIR_Coverage, 1681,
     /* 198774 */     GIR_EraseRootFromParent_Done,
     /* 198775 */   // Label 3699: @198775
     /* 198775 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(198820), // Rule ID 1682 //
     /* 198780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 198788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 198791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198809 */     // (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 198809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 198812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198818 */     GIR_RootConstrainSelectedInstOperands,
     /* 198819 */     // GIR_Coverage, 1682,
     /* 198819 */     GIR_EraseRootFromParent_Done,
     /* 198820 */   // Label 3700: @198820
     /* 198820 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(198865), // Rule ID 1683 //
     /* 198825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 198833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198854 */     // (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 198854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 198857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198863 */     GIR_RootConstrainSelectedInstOperands,
     /* 198864 */     // GIR_Coverage, 1683,
     /* 198864 */     GIR_EraseRootFromParent_Done,
     /* 198865 */   // Label 3701: @198865
     /* 198865 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(198910), // Rule ID 1684 //
     /* 198870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 198878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198899 */     // (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 198899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 198902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198908 */     GIR_RootConstrainSelectedInstOperands,
     /* 198909 */     // GIR_Coverage, 1684,
     /* 198909 */     GIR_EraseRootFromParent_Done,
     /* 198910 */   // Label 3702: @198910
     /* 198910 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(198955), // Rule ID 1750 //
     /* 198915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 198923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198944 */     // (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 198944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 198947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198953 */     GIR_RootConstrainSelectedInstOperands,
     /* 198954 */     // GIR_Coverage, 1750,
     /* 198954 */     GIR_EraseRootFromParent_Done,
     /* 198955 */   // Label 3703: @198955
     /* 198955 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(199000), // Rule ID 1752 //
     /* 198960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 198968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 198977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198989 */     // (intrinsic_wo_chain:{ *:[v2i64] } 684:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 198989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 198992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198998 */     GIR_RootConstrainSelectedInstOperands,
     /* 198999 */     // GIR_Coverage, 1752,
     /* 198999 */     GIR_EraseRootFromParent_Done,
     /* 199000 */   // Label 3704: @199000
     /* 199000 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(199045), // Rule ID 2303 //
     /* 199005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 199008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 199013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 199016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 199019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 199022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199034 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 199034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 199037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199043 */     GIR_RootConstrainSelectedInstOperands,
     /* 199044 */     // GIR_Coverage, 2303,
     /* 199044 */     GIR_EraseRootFromParent_Done,
     /* 199045 */   // Label 3705: @199045
     /* 199045 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(199090), // Rule ID 2304 //
     /* 199050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 199053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 199058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 199061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 199064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 199067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199079 */     // (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 199079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 199082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199088 */     GIR_RootConstrainSelectedInstOperands,
     /* 199089 */     // GIR_Coverage, 2304,
     /* 199089 */     GIR_EraseRootFromParent_Done,
     /* 199090 */   // Label 3706: @199090
     /* 199090 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(199135), // Rule ID 2315 //
     /* 199095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 199098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 199103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199124 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 199124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 199127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199133 */     GIR_RootConstrainSelectedInstOperands,
     /* 199134 */     // GIR_Coverage, 2315,
     /* 199134 */     GIR_EraseRootFromParent_Done,
     /* 199135 */   // Label 3707: @199135
     /* 199135 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(199180), // Rule ID 2316 //
     /* 199140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 199143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 199148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199169 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 199169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 199172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199178 */     GIR_RootConstrainSelectedInstOperands,
     /* 199179 */     // GIR_Coverage, 2316,
     /* 199179 */     GIR_EraseRootFromParent_Done,
     /* 199180 */   // Label 3708: @199180
     /* 199180 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(199225), // Rule ID 2339 //
     /* 199185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 199188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 199193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199214 */     // (intrinsic_wo_chain:{ *:[v4f16] } 632:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 199214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 199217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199223 */     GIR_RootConstrainSelectedInstOperands,
     /* 199224 */     // GIR_Coverage, 2339,
     /* 199224 */     GIR_EraseRootFromParent_Done,
     /* 199225 */   // Label 3709: @199225
     /* 199225 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(199270), // Rule ID 2340 //
     /* 199230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 199233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 199238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199259 */     // (intrinsic_wo_chain:{ *:[v8f16] } 632:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 199259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 199262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199268 */     GIR_RootConstrainSelectedInstOperands,
     /* 199269 */     // GIR_Coverage, 2340,
     /* 199269 */     GIR_EraseRootFromParent_Done,
     /* 199270 */   // Label 3710: @199270
     /* 199270 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(199315), // Rule ID 2341 //
     /* 199275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 199278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 199283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 199292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199304 */     // (intrinsic_wo_chain:{ *:[v2f32] } 632:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 199304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 199307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199313 */     GIR_RootConstrainSelectedInstOperands,
     /* 199314 */     // GIR_Coverage, 2341,
     /* 199314 */     GIR_EraseRootFromParent_Done,
     /* 199315 */   // Label 3711: @199315
     /* 199315 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(199360), // Rule ID 2342 //
     /* 199320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 199323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 199328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199349 */     // (intrinsic_wo_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 199349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 199352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199358 */     GIR_RootConstrainSelectedInstOperands,
     /* 199359 */     // GIR_Coverage, 2342,
     /* 199359 */     GIR_EraseRootFromParent_Done,
     /* 199360 */   // Label 3712: @199360
     /* 199360 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(199405), // Rule ID 2343 //
     /* 199365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 199368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 199373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 199379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 199382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199394 */     // (intrinsic_wo_chain:{ *:[v2f64] } 632:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 199394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 199397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199403 */     GIR_RootConstrainSelectedInstOperands,
     /* 199404 */     // GIR_Coverage, 2343,
     /* 199404 */     GIR_EraseRootFromParent_Done,
     /* 199405 */   // Label 3713: @199405
     /* 199405 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(199450), // Rule ID 2344 //
     /* 199410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 199418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199439 */     // (intrinsic_wo_chain:{ *:[v4f16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 199439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 199442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199448 */     GIR_RootConstrainSelectedInstOperands,
     /* 199449 */     // GIR_Coverage, 2344,
     /* 199449 */     GIR_EraseRootFromParent_Done,
     /* 199450 */   // Label 3714: @199450
     /* 199450 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(199495), // Rule ID 2347 //
     /* 199455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 199463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199484 */     // (intrinsic_wo_chain:{ *:[v8f16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 199484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 199487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199493 */     GIR_RootConstrainSelectedInstOperands,
     /* 199494 */     // GIR_Coverage, 2347,
     /* 199494 */     GIR_EraseRootFromParent_Done,
     /* 199495 */   // Label 3715: @199495
     /* 199495 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(199540), // Rule ID 2350 //
     /* 199500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 199508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 199517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199529 */     // (intrinsic_wo_chain:{ *:[v2f32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 199529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 199532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199538 */     GIR_RootConstrainSelectedInstOperands,
     /* 199539 */     // GIR_Coverage, 2350,
     /* 199539 */     GIR_EraseRootFromParent_Done,
     /* 199540 */   // Label 3716: @199540
     /* 199540 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(199585), // Rule ID 2353 //
     /* 199545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 199553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199574 */     // (intrinsic_wo_chain:{ *:[v4f32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 199574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 199577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199583 */     GIR_RootConstrainSelectedInstOperands,
     /* 199584 */     // GIR_Coverage, 2353,
     /* 199584 */     GIR_EraseRootFromParent_Done,
     /* 199585 */   // Label 3717: @199585
     /* 199585 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(199630), // Rule ID 2356 //
     /* 199590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 199598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 199604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 199607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199619 */     // (intrinsic_wo_chain:{ *:[v2f64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 199619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 199622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199628 */     GIR_RootConstrainSelectedInstOperands,
     /* 199629 */     // GIR_Coverage, 2356,
     /* 199629 */     GIR_EraseRootFromParent_Done,
     /* 199630 */   // Label 3718: @199630
     /* 199630 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(199675), // Rule ID 2359 //
     /* 199635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 199643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199664 */     // (intrinsic_wo_chain:{ *:[v4f16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 199664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 199667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199673 */     GIR_RootConstrainSelectedInstOperands,
     /* 199674 */     // GIR_Coverage, 2359,
     /* 199674 */     GIR_EraseRootFromParent_Done,
     /* 199675 */   // Label 3719: @199675
     /* 199675 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(199720), // Rule ID 2362 //
     /* 199680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 199688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199709 */     // (intrinsic_wo_chain:{ *:[v8f16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 199709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 199712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199718 */     GIR_RootConstrainSelectedInstOperands,
     /* 199719 */     // GIR_Coverage, 2362,
     /* 199719 */     GIR_EraseRootFromParent_Done,
     /* 199720 */   // Label 3720: @199720
     /* 199720 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(199765), // Rule ID 2365 //
     /* 199725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 199733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 199742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199754 */     // (intrinsic_wo_chain:{ *:[v2f32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 199754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 199757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199763 */     GIR_RootConstrainSelectedInstOperands,
     /* 199764 */     // GIR_Coverage, 2365,
     /* 199764 */     GIR_EraseRootFromParent_Done,
     /* 199765 */   // Label 3721: @199765
     /* 199765 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(199810), // Rule ID 2368 //
     /* 199770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 199778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199799 */     // (intrinsic_wo_chain:{ *:[v4f32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 199799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 199802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199808 */     GIR_RootConstrainSelectedInstOperands,
     /* 199809 */     // GIR_Coverage, 2368,
     /* 199809 */     GIR_EraseRootFromParent_Done,
     /* 199810 */   // Label 3722: @199810
     /* 199810 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(199855), // Rule ID 2371 //
     /* 199815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 199823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 199829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 199832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199844 */     // (intrinsic_wo_chain:{ *:[v2f64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 199844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 199847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199853 */     GIR_RootConstrainSelectedInstOperands,
     /* 199854 */     // GIR_Coverage, 2371,
     /* 199854 */     GIR_EraseRootFromParent_Done,
     /* 199855 */   // Label 3723: @199855
     /* 199855 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(199900), // Rule ID 2508 //
     /* 199860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 199868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199889 */     // (intrinsic_wo_chain:{ *:[i64] } 680:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 199892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199898 */     GIR_RootConstrainSelectedInstOperands,
     /* 199899 */     // GIR_Coverage, 2508,
     /* 199899 */     GIR_EraseRootFromParent_Done,
     /* 199900 */   // Label 3724: @199900
     /* 199900 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(199945), // Rule ID 2509 //
     /* 199905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 199913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199934 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 199937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199943 */     GIR_RootConstrainSelectedInstOperands,
     /* 199944 */     // GIR_Coverage, 2509,
     /* 199944 */     GIR_EraseRootFromParent_Done,
     /* 199945 */   // Label 3725: @199945
     /* 199945 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(199990), // Rule ID 2510 //
     /* 199950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 199958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199979 */     // (intrinsic_wo_chain:{ *:[v1f64] } 786:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 199982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199988 */     GIR_RootConstrainSelectedInstOperands,
     /* 199989 */     // GIR_Coverage, 2510,
     /* 199989 */     GIR_EraseRootFromParent_Done,
     /* 199990 */   // Label 3726: @199990
     /* 199990 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(200035), // Rule ID 2511 //
     /* 199995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 200003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200024 */     // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 200024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 200027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200033 */     GIR_RootConstrainSelectedInstOperands,
     /* 200034 */     // GIR_Coverage, 2511,
     /* 200034 */     GIR_EraseRootFromParent_Done,
     /* 200035 */   // Label 3727: @200035
     /* 200035 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(200080), // Rule ID 2516 //
     /* 200040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 200048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200069 */     // (intrinsic_wo_chain:{ *:[v1i64] } 716:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 200069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 200072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200078 */     GIR_RootConstrainSelectedInstOperands,
     /* 200079 */     // GIR_Coverage, 2516,
     /* 200079 */     GIR_EraseRootFromParent_Done,
     /* 200080 */   // Label 3728: @200080
     /* 200080 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(200125), // Rule ID 2634 //
     /* 200085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 200093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200114 */     // (intrinsic_wo_chain:{ *:[i32] } 2026:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 200114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 200117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200123 */     GIR_RootConstrainSelectedInstOperands,
     /* 200124 */     // GIR_Coverage, 2634,
     /* 200124 */     GIR_EraseRootFromParent_Done,
     /* 200125 */   // Label 3729: @200125
     /* 200125 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(200170), // Rule ID 2635 //
     /* 200130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 200138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200159 */     // (intrinsic_wo_chain:{ *:[i32] } 2026:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 200159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 200162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200168 */     GIR_RootConstrainSelectedInstOperands,
     /* 200169 */     // GIR_Coverage, 2635,
     /* 200169 */     GIR_EraseRootFromParent_Done,
     /* 200170 */   // Label 3730: @200170
     /* 200170 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(200215), // Rule ID 2636 //
     /* 200175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 200183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200204 */     // (intrinsic_wo_chain:{ *:[i32] } 2026:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 200204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 200207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200213 */     GIR_RootConstrainSelectedInstOperands,
     /* 200214 */     // GIR_Coverage, 2636,
     /* 200214 */     GIR_EraseRootFromParent_Done,
     /* 200215 */   // Label 3731: @200215
     /* 200215 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(200260), // Rule ID 2637 //
     /* 200220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 200228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200249 */     // (intrinsic_wo_chain:{ *:[i32] } 2026:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 200249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 200252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200258 */     GIR_RootConstrainSelectedInstOperands,
     /* 200259 */     // GIR_Coverage, 2637,
     /* 200259 */     GIR_EraseRootFromParent_Done,
     /* 200260 */   // Label 3732: @200260
     /* 200260 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(200305), // Rule ID 2638 //
     /* 200265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 200273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200294 */     // (intrinsic_wo_chain:{ *:[i64] } 1816:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 200297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200303 */     GIR_RootConstrainSelectedInstOperands,
     /* 200304 */     // GIR_Coverage, 2638,
     /* 200304 */     GIR_EraseRootFromParent_Done,
     /* 200305 */   // Label 3733: @200305
     /* 200305 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(200350), // Rule ID 2639 //
     /* 200310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 200318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200339 */     // (intrinsic_wo_chain:{ *:[i64] } 1816:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 200342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200348 */     GIR_RootConstrainSelectedInstOperands,
     /* 200349 */     // GIR_Coverage, 2639,
     /* 200349 */     GIR_EraseRootFromParent_Done,
     /* 200350 */   // Label 3734: @200350
     /* 200350 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(200395), // Rule ID 2640 //
     /* 200355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 200363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200384 */     // (intrinsic_wo_chain:{ *:[i64] } 1816:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 200387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200393 */     GIR_RootConstrainSelectedInstOperands,
     /* 200394 */     // GIR_Coverage, 2640,
     /* 200394 */     GIR_EraseRootFromParent_Done,
     /* 200395 */   // Label 3735: @200395
     /* 200395 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(200440), // Rule ID 2641 //
     /* 200400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 200408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200429 */     // (intrinsic_wo_chain:{ *:[i64] } 1816:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 200432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200438 */     GIR_RootConstrainSelectedInstOperands,
     /* 200439 */     // GIR_Coverage, 2641,
     /* 200439 */     GIR_EraseRootFromParent_Done,
     /* 200440 */   // Label 3736: @200440
     /* 200440 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(200485), // Rule ID 3815 //
     /* 200445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 200448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 200453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 200456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 200459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 200462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200474 */     // (intrinsic_wo_chain:{ *:[v2i64] } 533:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 200474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 200477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 200479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 200481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 200483 */     GIR_RootConstrainSelectedInstOperands,
     /* 200484 */     // GIR_Coverage, 3815,
     /* 200484 */     GIR_EraseRootFromParent_Done,
     /* 200485 */   // Label 3737: @200485
     /* 200485 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(200530), // Rule ID 3843 //
     /* 200490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 200493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 200498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 200501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 200504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 200507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200519 */     // (intrinsic_wo_chain:{ *:[v2i64] } 520:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 200519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 200522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 200524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 200526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 200528 */     GIR_RootConstrainSelectedInstOperands,
     /* 200529 */     // GIR_Coverage, 3843,
     /* 200529 */     GIR_EraseRootFromParent_Done,
     /* 200530 */   // Label 3738: @200530
     /* 200530 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(200575), // Rule ID 3853 //
     /* 200535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 200538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 200543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200564 */     // (intrinsic_wo_chain:{ *:[v4i32] } 543:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 200564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 200567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 200569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 200571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 200573 */     GIR_RootConstrainSelectedInstOperands,
     /* 200574 */     // GIR_Coverage, 3853,
     /* 200574 */     GIR_EraseRootFromParent_Done,
     /* 200575 */   // Label 3739: @200575
     /* 200575 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(200620), // Rule ID 3854 //
     /* 200580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 200583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 200588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200609 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 200609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 200612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 200614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 200616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 200618 */     GIR_RootConstrainSelectedInstOperands,
     /* 200619 */     // GIR_Coverage, 3854,
     /* 200619 */     GIR_EraseRootFromParent_Done,
     /* 200620 */   // Label 3740: @200620
     /* 200620 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(200668), // Rule ID 3855 //
     /* 200625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 200628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 200633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 200636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 200639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 200642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200654 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 200654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 200657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200666 */     GIR_RootConstrainSelectedInstOperands,
     /* 200667 */     // GIR_Coverage, 3855,
     /* 200667 */     GIR_EraseRootFromParent_Done,
     /* 200668 */   // Label 3741: @200668
     /* 200668 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(200716), // Rule ID 3856 //
     /* 200673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 200676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 200681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 200684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 200687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 200690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200702 */     // (intrinsic_wo_chain:{ *:[v4f16] } 756:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 200702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 200705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200714 */     GIR_RootConstrainSelectedInstOperands,
     /* 200715 */     // GIR_Coverage, 3856,
     /* 200715 */     GIR_EraseRootFromParent_Done,
     /* 200716 */   // Label 3742: @200716
     /* 200716 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(200764), // Rule ID 3857 //
     /* 200721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 200724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 200729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 200732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 200735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 200738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200750 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 200750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 200753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200762 */     GIR_RootConstrainSelectedInstOperands,
     /* 200763 */     // GIR_Coverage, 3857,
     /* 200763 */     GIR_EraseRootFromParent_Done,
     /* 200764 */   // Label 3743: @200764
     /* 200764 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(200812), // Rule ID 3858 //
     /* 200769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 200772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 200777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 200780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 200783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 200786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200798 */     // (intrinsic_wo_chain:{ *:[v8f16] } 756:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 200798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 200801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200810 */     GIR_RootConstrainSelectedInstOperands,
     /* 200811 */     // GIR_Coverage, 3858,
     /* 200811 */     GIR_EraseRootFromParent_Done,
     /* 200812 */   // Label 3744: @200812
     /* 200812 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(200860), // Rule ID 3859 //
     /* 200817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 200825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 200828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 200831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 200834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200846 */     // (intrinsic_wo_chain:{ *:[v2f32] } 757:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 200846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 200849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200858 */     GIR_RootConstrainSelectedInstOperands,
     /* 200859 */     // GIR_Coverage, 3859,
     /* 200859 */     GIR_EraseRootFromParent_Done,
     /* 200860 */   // Label 3745: @200860
     /* 200860 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(200908), // Rule ID 3860 //
     /* 200865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 200873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 200876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 200879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 200882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200894 */     // (intrinsic_wo_chain:{ *:[v2f32] } 756:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 200894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 200897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200906 */     GIR_RootConstrainSelectedInstOperands,
     /* 200907 */     // GIR_Coverage, 3860,
     /* 200907 */     GIR_EraseRootFromParent_Done,
     /* 200908 */   // Label 3746: @200908
     /* 200908 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(200956), // Rule ID 3861 //
     /* 200913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 200921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200942 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 200942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 200945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200954 */     GIR_RootConstrainSelectedInstOperands,
     /* 200955 */     // GIR_Coverage, 3861,
     /* 200955 */     GIR_EraseRootFromParent_Done,
     /* 200956 */   // Label 3747: @200956
     /* 200956 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(201004), // Rule ID 3862 //
     /* 200961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 200969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200990 */     // (intrinsic_wo_chain:{ *:[v4f32] } 756:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 200990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 200993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201002 */     GIR_RootConstrainSelectedInstOperands,
     /* 201003 */     // GIR_Coverage, 3862,
     /* 201003 */     GIR_EraseRootFromParent_Done,
     /* 201004 */   // Label 3748: @201004
     /* 201004 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(201052), // Rule ID 3863 //
     /* 201009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 201012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 201017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 201020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 201023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 201026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201038 */     // (intrinsic_wo_chain:{ *:[v2f64] } 757:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 201038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 201041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201050 */     GIR_RootConstrainSelectedInstOperands,
     /* 201051 */     // GIR_Coverage, 3863,
     /* 201051 */     GIR_EraseRootFromParent_Done,
     /* 201052 */   // Label 3749: @201052
     /* 201052 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(201100), // Rule ID 3864 //
     /* 201057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 201060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 201065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 201068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 201071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 201074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201086 */     // (intrinsic_wo_chain:{ *:[v2f64] } 756:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 201086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 201089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201098 */     GIR_RootConstrainSelectedInstOperands,
     /* 201099 */     // GIR_Coverage, 3864,
     /* 201099 */     GIR_EraseRootFromParent_Done,
     /* 201100 */   // Label 3750: @201100
     /* 201100 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(201142), // Rule ID 3929 //
     /* 201105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 201110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201131 */     // (intrinsic_wo_chain:{ *:[i32] } 2170:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 201131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 201134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201140 */     GIR_RootConstrainSelectedInstOperands,
     /* 201141 */     // GIR_Coverage, 3929,
     /* 201141 */     GIR_EraseRootFromParent_Done,
     /* 201142 */   // Label 3751: @201142
     /* 201142 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(201184), // Rule ID 3930 //
     /* 201147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 201152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201173 */     // (intrinsic_wo_chain:{ *:[i64] } 2170:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 201173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 201176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201182 */     GIR_RootConstrainSelectedInstOperands,
     /* 201183 */     // GIR_Coverage, 3930,
     /* 201183 */     GIR_EraseRootFromParent_Done,
     /* 201184 */   // Label 3752: @201184
     /* 201184 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(201226), // Rule ID 3931 //
     /* 201189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 201194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201215 */     // (intrinsic_wo_chain:{ *:[i32] } 780:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 201215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 201218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201224 */     GIR_RootConstrainSelectedInstOperands,
     /* 201225 */     // GIR_Coverage, 3931,
     /* 201225 */     GIR_EraseRootFromParent_Done,
     /* 201226 */   // Label 3753: @201226
     /* 201226 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(201268), // Rule ID 3932 //
     /* 201231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 201236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201257 */     // (intrinsic_wo_chain:{ *:[i64] } 780:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 201257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 201260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201266 */     GIR_RootConstrainSelectedInstOperands,
     /* 201267 */     // GIR_Coverage, 3932,
     /* 201267 */     GIR_EraseRootFromParent_Done,
     /* 201268 */   // Label 3754: @201268
     /* 201268 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(201310), // Rule ID 5243 //
     /* 201273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 201278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201299 */     // (intrinsic_wo_chain:{ *:[v1f64] } 577:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 201299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 201302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201308 */     GIR_RootConstrainSelectedInstOperands,
     /* 201309 */     // GIR_Coverage, 5243,
     /* 201309 */     GIR_EraseRootFromParent_Done,
     /* 201310 */   // Label 3755: @201310
     /* 201310 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(201355), // Rule ID 5247 //
     /* 201315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 201323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201344 */     // (intrinsic_wo_chain:{ *:[v1i64] } 579:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 201344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 201347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201353 */     GIR_RootConstrainSelectedInstOperands,
     /* 201354 */     // GIR_Coverage, 5247,
     /* 201354 */     GIR_EraseRootFromParent_Done,
     /* 201355 */   // Label 3756: @201355
     /* 201355 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(201400), // Rule ID 5251 //
     /* 201360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 201368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201389 */     // (intrinsic_wo_chain:{ *:[v1f64] } 611:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 201389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 201392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201398 */     GIR_RootConstrainSelectedInstOperands,
     /* 201399 */     // GIR_Coverage, 5251,
     /* 201399 */     GIR_EraseRootFromParent_Done,
     /* 201400 */   // Label 3757: @201400
     /* 201400 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(201445), // Rule ID 5252 //
     /* 201405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 201413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201434 */     // (intrinsic_wo_chain:{ *:[v1f64] } 634:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 201434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 201437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201443 */     GIR_RootConstrainSelectedInstOperands,
     /* 201444 */     // GIR_Coverage, 5252,
     /* 201444 */     GIR_EraseRootFromParent_Done,
     /* 201445 */   // Label 3758: @201445
     /* 201445 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(201490), // Rule ID 5253 //
     /* 201450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 201458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201479 */     // (intrinsic_wo_chain:{ *:[v1f64] } 641:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 201479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 201482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201488 */     GIR_RootConstrainSelectedInstOperands,
     /* 201489 */     // GIR_Coverage, 5253,
     /* 201489 */     GIR_EraseRootFromParent_Done,
     /* 201490 */   // Label 3759: @201490
     /* 201490 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(201535), // Rule ID 5254 //
     /* 201495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 201503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201524 */     // (intrinsic_wo_chain:{ *:[i64] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 201524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 201527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201533 */     GIR_RootConstrainSelectedInstOperands,
     /* 201534 */     // GIR_Coverage, 5254,
     /* 201534 */     GIR_EraseRootFromParent_Done,
     /* 201535 */   // Label 3760: @201535
     /* 201535 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(201580), // Rule ID 5255 //
     /* 201540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 201548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201569 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 201569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 201572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201578 */     GIR_RootConstrainSelectedInstOperands,
     /* 201579 */     // GIR_Coverage, 5255,
     /* 201579 */     GIR_EraseRootFromParent_Done,
     /* 201580 */   // Label 3761: @201580
     /* 201580 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(201625), // Rule ID 5256 //
     /* 201585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 201593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201614 */     // (intrinsic_wo_chain:{ *:[i64] } 695:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 201614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 201617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201623 */     GIR_RootConstrainSelectedInstOperands,
     /* 201624 */     // GIR_Coverage, 5256,
     /* 201624 */     GIR_EraseRootFromParent_Done,
     /* 201625 */   // Label 3762: @201625
     /* 201625 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(201670), // Rule ID 5257 //
     /* 201630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 201638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201659 */     // (intrinsic_wo_chain:{ *:[i32] } 695:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 201659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 201662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201668 */     GIR_RootConstrainSelectedInstOperands,
     /* 201669 */     // GIR_Coverage, 5257,
     /* 201669 */     GIR_EraseRootFromParent_Done,
     /* 201670 */   // Label 3763: @201670
     /* 201670 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(201715), // Rule ID 5258 //
     /* 201675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 201683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201704 */     // (intrinsic_wo_chain:{ *:[i64] } 699:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 201704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 201707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201713 */     GIR_RootConstrainSelectedInstOperands,
     /* 201714 */     // GIR_Coverage, 5258,
     /* 201714 */     GIR_EraseRootFromParent_Done,
     /* 201715 */   // Label 3764: @201715
     /* 201715 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(201760), // Rule ID 5259 //
     /* 201720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 201728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201749 */     // (intrinsic_wo_chain:{ *:[i32] } 699:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 201749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 201752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201758 */     GIR_RootConstrainSelectedInstOperands,
     /* 201759 */     // GIR_Coverage, 5259,
     /* 201759 */     GIR_EraseRootFromParent_Done,
     /* 201760 */   // Label 3765: @201760
     /* 201760 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(201805), // Rule ID 5260 //
     /* 201765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 201773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201794 */     // (intrinsic_wo_chain:{ *:[i64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 201794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 201797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201803 */     GIR_RootConstrainSelectedInstOperands,
     /* 201804 */     // GIR_Coverage, 5260,
     /* 201804 */     GIR_EraseRootFromParent_Done,
     /* 201805 */   // Label 3766: @201805
     /* 201805 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(201850), // Rule ID 5261 //
     /* 201810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 201818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201839 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 201839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 201842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201848 */     GIR_RootConstrainSelectedInstOperands,
     /* 201849 */     // GIR_Coverage, 5261,
     /* 201849 */     GIR_EraseRootFromParent_Done,
     /* 201850 */   // Label 3767: @201850
     /* 201850 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(201895), // Rule ID 5262 //
     /* 201855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 201863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201884 */     // (intrinsic_wo_chain:{ *:[i64] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 201884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 201887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201893 */     GIR_RootConstrainSelectedInstOperands,
     /* 201894 */     // GIR_Coverage, 5262,
     /* 201894 */     GIR_EraseRootFromParent_Done,
     /* 201895 */   // Label 3768: @201895
     /* 201895 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(201940), // Rule ID 5263 //
     /* 201900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 201908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201929 */     // (intrinsic_wo_chain:{ *:[i32] } 741:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 201929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 201932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201938 */     GIR_RootConstrainSelectedInstOperands,
     /* 201939 */     // GIR_Coverage, 5263,
     /* 201939 */     GIR_EraseRootFromParent_Done,
     /* 201940 */   // Label 3769: @201940
     /* 201940 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(201985), // Rule ID 5264 //
     /* 201945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 201953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201974 */     // (intrinsic_wo_chain:{ *:[i64] } 743:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 201974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 201977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201983 */     GIR_RootConstrainSelectedInstOperands,
     /* 201984 */     // GIR_Coverage, 5264,
     /* 201984 */     GIR_EraseRootFromParent_Done,
     /* 201985 */   // Label 3770: @201985
     /* 201985 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(202030), // Rule ID 5265 //
     /* 201990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 201998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 202001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 202007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202019 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 202019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 202022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 202028 */     GIR_RootConstrainSelectedInstOperands,
     /* 202029 */     // GIR_Coverage, 5265,
     /* 202029 */     GIR_EraseRootFromParent_Done,
     /* 202030 */   // Label 3771: @202030
     /* 202030 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(202075), // Rule ID 5266 //
     /* 202035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 202038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 202043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202064 */     // (intrinsic_wo_chain:{ *:[i64] } 745:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 202064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 202067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 202073 */     GIR_RootConstrainSelectedInstOperands,
     /* 202074 */     // GIR_Coverage, 5266,
     /* 202074 */     GIR_EraseRootFromParent_Done,
     /* 202075 */   // Label 3772: @202075
     /* 202075 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(202120), // Rule ID 5267 //
     /* 202080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 202083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 202088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 202091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 202097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202109 */     // (intrinsic_wo_chain:{ *:[i32] } 745:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 202109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 202112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 202118 */     GIR_RootConstrainSelectedInstOperands,
     /* 202119 */     // GIR_Coverage, 5267,
     /* 202119 */     GIR_EraseRootFromParent_Done,
     /* 202120 */   // Label 3773: @202120
     /* 202120 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(202165), // Rule ID 5286 //
     /* 202125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 202128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 202133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202154 */     // (intrinsic_wo_chain:{ *:[v1i64] } 755:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 202154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 202157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202163 */     GIR_RootConstrainSelectedInstOperands,
     /* 202164 */     // GIR_Coverage, 5286,
     /* 202164 */     GIR_EraseRootFromParent_Done,
     /* 202165 */   // Label 3774: @202165
     /* 202165 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(202207), // Rule ID 5620 //
     /* 202170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 202175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 202178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 202181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 202184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202196 */     // (intrinsic_wo_chain:{ *:[v8i8] } 717:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 202196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 202199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 202201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 202205 */     GIR_RootConstrainSelectedInstOperands,
     /* 202206 */     // GIR_Coverage, 5620,
     /* 202206 */     GIR_EraseRootFromParent_Done,
     /* 202207 */   // Label 3775: @202207
     /* 202207 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(202249), // Rule ID 5621 //
     /* 202212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 202217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 202220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 202223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 202226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202238 */     // (intrinsic_wo_chain:{ *:[v16i8] } 717:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 202238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 202241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 202243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 202245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202247 */     GIR_RootConstrainSelectedInstOperands,
     /* 202248 */     // GIR_Coverage, 5621,
     /* 202248 */     GIR_EraseRootFromParent_Done,
     /* 202249 */   // Label 3776: @202249
     /* 202249 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(202346), // Rule ID 6346 //
     /* 202254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 202259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 202262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 202265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 202268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 202276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 202280 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 202280 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 202283 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 202287 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202292 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 202296 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 202300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 202302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 202305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 202324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 202327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 202330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 202345 */     // GIR_Coverage, 6346,
     /* 202345 */     GIR_EraseRootFromParent_Done,
     /* 202346 */   // Label 3777: @202346
     /* 202346 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(202443), // Rule ID 6347 //
     /* 202351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 202356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 202359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 202362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 202365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 202373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 202377 */     // (intrinsic_wo_chain:{ *:[i32] } 579:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 202377 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 202380 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 202384 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202389 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 202393 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 202397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 202399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 202402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 202421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 202424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 202427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 202442 */     // GIR_Coverage, 6347,
     /* 202442 */     GIR_EraseRootFromParent_Done,
     /* 202443 */   // Label 3778: @202443
     /* 202443 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(202485), // Rule ID 6994 //
     /* 202448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 202453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202474 */     // (intrinsic_wo_chain:{ *:[i64] } 704:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 202474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 202477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 202483 */     GIR_RootConstrainSelectedInstOperands,
     /* 202484 */     // GIR_Coverage, 6994,
     /* 202484 */     GIR_EraseRootFromParent_Done,
     /* 202485 */   // Label 3779: @202485
     /* 202485 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(202527), // Rule ID 6995 //
     /* 202490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 202495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202516 */     // (intrinsic_wo_chain:{ *:[i64] } 752:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 202516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 202519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 202525 */     GIR_RootConstrainSelectedInstOperands,
     /* 202526 */     // GIR_Coverage, 6995,
     /* 202526 */     GIR_EraseRootFromParent_Done,
     /* 202527 */   // Label 3780: @202527
     /* 202527 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(202569), // Rule ID 6996 //
     /* 202532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 202537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202558 */     // (intrinsic_wo_chain:{ *:[i64] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 202558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 202561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 202567 */     GIR_RootConstrainSelectedInstOperands,
     /* 202568 */     // GIR_Coverage, 6996,
     /* 202568 */     GIR_EraseRootFromParent_Done,
     /* 202569 */   // Label 3781: @202569
     /* 202569 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(202611), // Rule ID 6997 //
     /* 202574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 202579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202600 */     // (intrinsic_wo_chain:{ *:[i64] } 749:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 202600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 202603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 202609 */     GIR_RootConstrainSelectedInstOperands,
     /* 202610 */     // GIR_Coverage, 6997,
     /* 202610 */     GIR_EraseRootFromParent_Done,
     /* 202611 */   // Label 3782: @202611
     /* 202611 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(202659), // Rule ID 7037 //
     /* 202616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 202621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202642 */     // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 202642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 202645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 202654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 202657 */     GIR_RootConstrainSelectedInstOperands,
     /* 202658 */     // GIR_Coverage, 7037,
     /* 202658 */     GIR_EraseRootFromParent_Done,
     /* 202659 */   // Label 3783: @202659
     /* 202659 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(202704), // Rule ID 10095 //
     /* 202664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 202672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202693 */     // (intrinsic_wo_chain:{ *:[i64] } 2027:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 202696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202702 */     GIR_RootConstrainSelectedInstOperands,
     /* 202703 */     // GIR_Coverage, 10095,
     /* 202703 */     GIR_EraseRootFromParent_Done,
     /* 202704 */   // Label 3784: @202704
     /* 202704 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(202749), // Rule ID 10096 //
     /* 202709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 202717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202738 */     // (intrinsic_wo_chain:{ *:[i64] } 2027:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 202741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202747 */     GIR_RootConstrainSelectedInstOperands,
     /* 202748 */     // GIR_Coverage, 10096,
     /* 202748 */     GIR_EraseRootFromParent_Done,
     /* 202749 */   // Label 3785: @202749
     /* 202749 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(202794), // Rule ID 10097 //
     /* 202754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 202762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202783 */     // (intrinsic_wo_chain:{ *:[i64] } 2027:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 202786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202792 */     GIR_RootConstrainSelectedInstOperands,
     /* 202793 */     // GIR_Coverage, 10097,
     /* 202793 */     GIR_EraseRootFromParent_Done,
     /* 202794 */   // Label 3786: @202794
     /* 202794 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(202839), // Rule ID 10098 //
     /* 202799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 202807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202828 */     // (intrinsic_wo_chain:{ *:[i64] } 2027:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 202831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202837 */     GIR_RootConstrainSelectedInstOperands,
     /* 202838 */     // GIR_Coverage, 10098,
     /* 202838 */     GIR_EraseRootFromParent_Done,
     /* 202839 */   // Label 3787: @202839
     /* 202839 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(202884), // Rule ID 10107 //
     /* 202844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 202852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202873 */     // (intrinsic_wo_chain:{ *:[i64] } 1782:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 202876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202882 */     GIR_RootConstrainSelectedInstOperands,
     /* 202883 */     // GIR_Coverage, 10107,
     /* 202883 */     GIR_EraseRootFromParent_Done,
     /* 202884 */   // Label 3788: @202884
     /* 202884 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(202929), // Rule ID 10108 //
     /* 202889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 202897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202918 */     // (intrinsic_wo_chain:{ *:[i64] } 1782:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 202921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202927 */     GIR_RootConstrainSelectedInstOperands,
     /* 202928 */     // GIR_Coverage, 10108,
     /* 202928 */     GIR_EraseRootFromParent_Done,
     /* 202929 */   // Label 3789: @202929
     /* 202929 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(202974), // Rule ID 10109 //
     /* 202934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 202942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202963 */     // (intrinsic_wo_chain:{ *:[i64] } 1782:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 202966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202972 */     GIR_RootConstrainSelectedInstOperands,
     /* 202973 */     // GIR_Coverage, 10109,
     /* 202973 */     GIR_EraseRootFromParent_Done,
     /* 202974 */   // Label 3790: @202974
     /* 202974 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(203019), // Rule ID 10110 //
     /* 202979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 202987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203008 */     // (intrinsic_wo_chain:{ *:[i64] } 1782:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 203008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 203011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203017 */     GIR_RootConstrainSelectedInstOperands,
     /* 203018 */     // GIR_Coverage, 10110,
     /* 203018 */     GIR_EraseRootFromParent_Done,
     /* 203019 */   // Label 3791: @203019
     /* 203019 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(203064), // Rule ID 10111 //
     /* 203024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 203032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203053 */     // (intrinsic_wo_chain:{ *:[i32] } 2012:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 203053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 203056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203062 */     GIR_RootConstrainSelectedInstOperands,
     /* 203063 */     // GIR_Coverage, 10111,
     /* 203063 */     GIR_EraseRootFromParent_Done,
     /* 203064 */   // Label 3792: @203064
     /* 203064 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(203109), // Rule ID 10112 //
     /* 203069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 203077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 203086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203098 */     // (intrinsic_wo_chain:{ *:[i32] } 2012:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 203098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 203101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203107 */     GIR_RootConstrainSelectedInstOperands,
     /* 203108 */     // GIR_Coverage, 10112,
     /* 203108 */     GIR_EraseRootFromParent_Done,
     /* 203109 */   // Label 3793: @203109
     /* 203109 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(203154), // Rule ID 10113 //
     /* 203114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 203122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 203131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203143 */     // (intrinsic_wo_chain:{ *:[i32] } 2012:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 203143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 203146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203152 */     GIR_RootConstrainSelectedInstOperands,
     /* 203153 */     // GIR_Coverage, 10113,
     /* 203153 */     GIR_EraseRootFromParent_Done,
     /* 203154 */   // Label 3794: @203154
     /* 203154 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(203199), // Rule ID 10114 //
     /* 203159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 203167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 203176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203188 */     // (intrinsic_wo_chain:{ *:[i32] } 2012:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 203188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 203191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203197 */     GIR_RootConstrainSelectedInstOperands,
     /* 203198 */     // GIR_Coverage, 10114,
     /* 203198 */     GIR_EraseRootFromParent_Done,
     /* 203199 */   // Label 3795: @203199
     /* 203199 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(203244), // Rule ID 10115 //
     /* 203204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 203212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203233 */     // (intrinsic_wo_chain:{ *:[i64] } 2013:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 203233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 203236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203242 */     GIR_RootConstrainSelectedInstOperands,
     /* 203243 */     // GIR_Coverage, 10115,
     /* 203243 */     GIR_EraseRootFromParent_Done,
     /* 203244 */   // Label 3796: @203244
     /* 203244 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(203289), // Rule ID 10116 //
     /* 203249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 203257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 203266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203278 */     // (intrinsic_wo_chain:{ *:[i64] } 2013:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 203278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 203281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203287 */     GIR_RootConstrainSelectedInstOperands,
     /* 203288 */     // GIR_Coverage, 10116,
     /* 203288 */     GIR_EraseRootFromParent_Done,
     /* 203289 */   // Label 3797: @203289
     /* 203289 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(203334), // Rule ID 10117 //
     /* 203294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 203302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 203311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203323 */     // (intrinsic_wo_chain:{ *:[i64] } 2013:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 203323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 203326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203332 */     GIR_RootConstrainSelectedInstOperands,
     /* 203333 */     // GIR_Coverage, 10117,
     /* 203333 */     GIR_EraseRootFromParent_Done,
     /* 203334 */   // Label 3798: @203334
     /* 203334 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(203379), // Rule ID 10118 //
     /* 203339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 203347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 203356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203368 */     // (intrinsic_wo_chain:{ *:[i64] } 2013:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 203368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 203371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203377 */     GIR_RootConstrainSelectedInstOperands,
     /* 203378 */     // GIR_Coverage, 10118,
     /* 203378 */     GIR_EraseRootFromParent_Done,
     /* 203379 */   // Label 3799: @203379
     /* 203379 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(203425), // Rule ID 138 //
     /* 203384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 203387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 203392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 203398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203402 */     // MIs[0] Rn
     /* 203402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 203406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 203410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203414 */     // (intrinsic_wo_chain:{ *:[i64] } 556:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 203414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 203417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 203419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 203423 */     GIR_RootConstrainSelectedInstOperands,
     /* 203424 */     // GIR_Coverage, 138,
     /* 203424 */     GIR_EraseRootFromParent_Done,
     /* 203425 */   // Label 3800: @203425
     /* 203425 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(203472), // Rule ID 139 //
     /* 203430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 203433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 203438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203445 */     // MIs[0] Rn
     /* 203445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 203449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 203453 */     // MIs[0] Rm
     /* 203453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 203457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 203461 */     // (intrinsic_wo_chain:{ *:[i64] } 1243:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 203461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 203464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 203466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 203470 */     GIR_RootConstrainSelectedInstOperands,
     /* 203471 */     // GIR_Coverage, 139,
     /* 203471 */     GIR_EraseRootFromParent_Done,
     /* 203472 */   // Label 3801: @203472
     /* 203472 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(203509), // Rule ID 2399 //
     /* 203477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 203485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203498 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2152:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 203501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203507 */     GIR_RootConstrainSelectedInstOperands,
     /* 203508 */     // GIR_Coverage, 2399,
     /* 203508 */     GIR_EraseRootFromParent_Done,
     /* 203509 */   // Label 3802: @203509
     /* 203509 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(203546), // Rule ID 2400 //
     /* 203514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 203522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203535 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2153:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 203538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203544 */     GIR_RootConstrainSelectedInstOperands,
     /* 203545 */     // GIR_Coverage, 2400,
     /* 203545 */     GIR_EraseRootFromParent_Done,
     /* 203546 */   // Label 3803: @203546
     /* 203546 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(203583), // Rule ID 2401 //
     /* 203551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 203559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203572 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2154:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 203575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203581 */     GIR_RootConstrainSelectedInstOperands,
     /* 203582 */     // GIR_Coverage, 2401,
     /* 203582 */     GIR_EraseRootFromParent_Done,
     /* 203583 */   // Label 3804: @203583
     /* 203583 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(203620), // Rule ID 2403 //
     /* 203588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 203596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203609 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2157:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 203612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203618 */     GIR_RootConstrainSelectedInstOperands,
     /* 203619 */     // GIR_Coverage, 2403,
     /* 203619 */     GIR_EraseRootFromParent_Done,
     /* 203620 */   // Label 3805: @203620
     /* 203620 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(203657), // Rule ID 2404 //
     /* 203625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 203633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203646 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2158:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 203649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203655 */     GIR_RootConstrainSelectedInstOperands,
     /* 203656 */     // GIR_Coverage, 2404,
     /* 203656 */     GIR_EraseRootFromParent_Done,
     /* 203657 */   // Label 3806: @203657
     /* 203657 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(203694), // Rule ID 2405 //
     /* 203662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 203670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203683 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2159:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 203686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203692 */     GIR_RootConstrainSelectedInstOperands,
     /* 203693 */     // GIR_Coverage, 2405,
     /* 203693 */     GIR_EraseRootFromParent_Done,
     /* 203694 */   // Label 3807: @203694
     /* 203694 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(203731), // Rule ID 2407 //
     /* 203699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 203707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203720 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2078:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 203723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203729 */     GIR_RootConstrainSelectedInstOperands,
     /* 203730 */     // GIR_Coverage, 2407,
     /* 203730 */     GIR_EraseRootFromParent_Done,
     /* 203731 */   // Label 3808: @203731
     /* 203731 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(203768), // Rule ID 2408 //
     /* 203736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 203744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203757 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2079:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 203760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203766 */     GIR_RootConstrainSelectedInstOperands,
     /* 203767 */     // GIR_Coverage, 2408,
     /* 203767 */     GIR_EraseRootFromParent_Done,
     /* 203768 */   // Label 3809: @203768
     /* 203768 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(203805), // Rule ID 2409 //
     /* 203773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 203781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203794 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2080:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 203797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203803 */     GIR_RootConstrainSelectedInstOperands,
     /* 203804 */     // GIR_Coverage, 2409,
     /* 203804 */     GIR_EraseRootFromParent_Done,
     /* 203805 */   // Label 3810: @203805
     /* 203805 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(203842), // Rule ID 2411 //
     /* 203810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 203818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203831 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2083:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 203834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203840 */     GIR_RootConstrainSelectedInstOperands,
     /* 203841 */     // GIR_Coverage, 2411,
     /* 203841 */     GIR_EraseRootFromParent_Done,
     /* 203842 */   // Label 3811: @203842
     /* 203842 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(203879), // Rule ID 2412 //
     /* 203847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 203855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203868 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2084:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 203871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203877 */     GIR_RootConstrainSelectedInstOperands,
     /* 203878 */     // GIR_Coverage, 2412,
     /* 203878 */     GIR_EraseRootFromParent_Done,
     /* 203879 */   // Label 3812: @203879
     /* 203879 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(203916), // Rule ID 2413 //
     /* 203884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 203892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203905 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2085:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 203908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203914 */     GIR_RootConstrainSelectedInstOperands,
     /* 203915 */     // GIR_Coverage, 2413,
     /* 203915 */     GIR_EraseRootFromParent_Done,
     /* 203916 */   // Label 3813: @203916
     /* 203916 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(203953), // Rule ID 2415 //
     /* 203921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 203929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203942 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1922:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 203945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203951 */     GIR_RootConstrainSelectedInstOperands,
     /* 203952 */     // GIR_Coverage, 2415,
     /* 203952 */     GIR_EraseRootFromParent_Done,
     /* 203953 */   // Label 3814: @203953
     /* 203953 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(203990), // Rule ID 2416 //
     /* 203958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 203966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203979 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1923:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 203982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203988 */     GIR_RootConstrainSelectedInstOperands,
     /* 203989 */     // GIR_Coverage, 2416,
     /* 203989 */     GIR_EraseRootFromParent_Done,
     /* 203990 */   // Label 3815: @203990
     /* 203990 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(204027), // Rule ID 2417 //
     /* 203995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 204003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204016 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1924:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 204016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 204019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 204023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 204025 */     GIR_RootConstrainSelectedInstOperands,
     /* 204026 */     // GIR_Coverage, 2417,
     /* 204026 */     GIR_EraseRootFromParent_Done,
     /* 204027 */   // Label 3816: @204027
     /* 204027 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(204064), // Rule ID 2419 //
     /* 204032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 204040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204053 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1927:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 204053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 204056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 204060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 204062 */     GIR_RootConstrainSelectedInstOperands,
     /* 204063 */     // GIR_Coverage, 2419,
     /* 204063 */     GIR_EraseRootFromParent_Done,
     /* 204064 */   // Label 3817: @204064
     /* 204064 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(204101), // Rule ID 2420 //
     /* 204069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 204077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204090 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1928:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 204090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 204093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 204097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 204099 */     GIR_RootConstrainSelectedInstOperands,
     /* 204100 */     // GIR_Coverage, 2420,
     /* 204100 */     GIR_EraseRootFromParent_Done,
     /* 204101 */   // Label 3818: @204101
     /* 204101 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(204138), // Rule ID 2421 //
     /* 204106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 204114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204127 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1929:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 204127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 204130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 204134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 204136 */     GIR_RootConstrainSelectedInstOperands,
     /* 204137 */     // GIR_Coverage, 2421,
     /* 204137 */     GIR_EraseRootFromParent_Done,
     /* 204138 */   // Label 3819: @204138
     /* 204138 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(204175), // Rule ID 2422 //
     /* 204143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 204146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 204151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204164 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1547:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 204164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 204167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 204173 */     GIR_RootConstrainSelectedInstOperands,
     /* 204174 */     // GIR_Coverage, 2422,
     /* 204174 */     GIR_EraseRootFromParent_Done,
     /* 204175 */   // Label 3820: @204175
     /* 204175 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(204215), // Rule ID 2621 //
     /* 204180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 204188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204201 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1626:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 204201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 204204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 204206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204213 */     GIR_RootConstrainSelectedInstOperands,
     /* 204214 */     // GIR_Coverage, 2621,
     /* 204214 */     GIR_EraseRootFromParent_Done,
     /* 204215 */   // Label 3821: @204215
     /* 204215 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(204255), // Rule ID 2622 //
     /* 204220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 204228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204241 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1634:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 204241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 204244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 204246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204253 */     GIR_RootConstrainSelectedInstOperands,
     /* 204254 */     // GIR_Coverage, 2622,
     /* 204254 */     GIR_EraseRootFromParent_Done,
     /* 204255 */   // Label 3822: @204255
     /* 204255 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(204295), // Rule ID 2623 //
     /* 204260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 204268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 204271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 204277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204281 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1634:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 204281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 204284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 204286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204293 */     GIR_RootConstrainSelectedInstOperands,
     /* 204294 */     // GIR_Coverage, 2623,
     /* 204294 */     GIR_EraseRootFromParent_Done,
     /* 204295 */   // Label 3823: @204295
     /* 204295 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(204335), // Rule ID 2624 //
     /* 204300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 204308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 204311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 204317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204321 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1634:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 204321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 204324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 204326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204333 */     GIR_RootConstrainSelectedInstOperands,
     /* 204334 */     // GIR_Coverage, 2624,
     /* 204334 */     GIR_EraseRootFromParent_Done,
     /* 204335 */   // Label 3824: @204335
     /* 204335 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(204375), // Rule ID 2625 //
     /* 204340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 204348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 204351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 204357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204361 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1634:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 204361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 204364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 204366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204373 */     GIR_RootConstrainSelectedInstOperands,
     /* 204374 */     // GIR_Coverage, 2625,
     /* 204374 */     GIR_EraseRootFromParent_Done,
     /* 204375 */   // Label 3825: @204375
     /* 204375 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(204412), // Rule ID 2642 //
     /* 204380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 204388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 204397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204401 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1814:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 204401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 204404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204410 */     GIR_RootConstrainSelectedInstOperands,
     /* 204411 */     // GIR_Coverage, 2642,
     /* 204411 */     GIR_EraseRootFromParent_Done,
     /* 204412 */   // Label 3826: @204412
     /* 204412 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(204449), // Rule ID 2643 //
     /* 204417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 204425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 204434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204438 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1814:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 204438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 204441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204447 */     GIR_RootConstrainSelectedInstOperands,
     /* 204448 */     // GIR_Coverage, 2643,
     /* 204448 */     GIR_EraseRootFromParent_Done,
     /* 204449 */   // Label 3827: @204449
     /* 204449 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(204486), // Rule ID 2644 //
     /* 204454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 204462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 204471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204475 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1814:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 204475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 204478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204484 */     GIR_RootConstrainSelectedInstOperands,
     /* 204485 */     // GIR_Coverage, 2644,
     /* 204485 */     GIR_EraseRootFromParent_Done,
     /* 204486 */   // Label 3828: @204486
     /* 204486 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(204523), // Rule ID 2645 //
     /* 204491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 204499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 204502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204512 */     // (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 204512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 204515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 204517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204521 */     GIR_RootConstrainSelectedInstOperands,
     /* 204522 */     // GIR_Coverage, 2645,
     /* 204522 */     GIR_EraseRootFromParent_Done,
     /* 204523 */   // Label 3829: @204523
     /* 204523 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(204560), // Rule ID 2646 //
     /* 204528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 204536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 204539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 204545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204549 */     // (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 204549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 204552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 204554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204558 */     GIR_RootConstrainSelectedInstOperands,
     /* 204559 */     // GIR_Coverage, 2646,
     /* 204559 */     GIR_EraseRootFromParent_Done,
     /* 204560 */   // Label 3830: @204560
     /* 204560 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(204597), // Rule ID 2647 //
     /* 204565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 204573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 204576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 204582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204586 */     // (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 204586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 204589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 204591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204595 */     GIR_RootConstrainSelectedInstOperands,
     /* 204596 */     // GIR_Coverage, 2647,
     /* 204596 */     GIR_EraseRootFromParent_Done,
     /* 204597 */   // Label 3831: @204597
     /* 204597 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(204634), // Rule ID 2648 //
     /* 204602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 204610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 204613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 204619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204623 */     // (intrinsic_wo_chain:{ *:[i64] } 1336:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 204623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 204626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 204628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204632 */     GIR_RootConstrainSelectedInstOperands,
     /* 204633 */     // GIR_Coverage, 2648,
     /* 204633 */     GIR_EraseRootFromParent_Done,
     /* 204634 */   // Label 3832: @204634
     /* 204634 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(204671), // Rule ID 2826 //
     /* 204639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 204647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204660 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1544:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 204663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204669 */     GIR_RootConstrainSelectedInstOperands,
     /* 204670 */     // GIR_Coverage, 2826,
     /* 204670 */     GIR_EraseRootFromParent_Done,
     /* 204671 */   // Label 3833: @204671
     /* 204671 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(204708), // Rule ID 2827 //
     /* 204676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 204684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204697 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1544:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 204700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204706 */     GIR_RootConstrainSelectedInstOperands,
     /* 204707 */     // GIR_Coverage, 2827,
     /* 204707 */     GIR_EraseRootFromParent_Done,
     /* 204708 */   // Label 3834: @204708
     /* 204708 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(204745), // Rule ID 2828 //
     /* 204713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 204721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204734 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1544:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 204737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204743 */     GIR_RootConstrainSelectedInstOperands,
     /* 204744 */     // GIR_Coverage, 2828,
     /* 204744 */     GIR_EraseRootFromParent_Done,
     /* 204745 */   // Label 3835: @204745
     /* 204745 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(204782), // Rule ID 2999 //
     /* 204750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 204758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204771 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1796:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 204774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204780 */     GIR_RootConstrainSelectedInstOperands,
     /* 204781 */     // GIR_Coverage, 2999,
     /* 204781 */     GIR_EraseRootFromParent_Done,
     /* 204782 */   // Label 3836: @204782
     /* 204782 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(204819), // Rule ID 3000 //
     /* 204787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 204795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204808 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1796:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 204811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204817 */     GIR_RootConstrainSelectedInstOperands,
     /* 204818 */     // GIR_Coverage, 3000,
     /* 204818 */     GIR_EraseRootFromParent_Done,
     /* 204819 */   // Label 3837: @204819
     /* 204819 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(204856), // Rule ID 3001 //
     /* 204824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 204832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204845 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1796:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 204848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204854 */     GIR_RootConstrainSelectedInstOperands,
     /* 204855 */     // GIR_Coverage, 3001,
     /* 204855 */     GIR_EraseRootFromParent_Done,
     /* 204856 */   // Label 3838: @204856
     /* 204856 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(204893), // Rule ID 3002 //
     /* 204861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 204869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1796:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 204885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204891 */     GIR_RootConstrainSelectedInstOperands,
     /* 204892 */     // GIR_Coverage, 3002,
     /* 204892 */     GIR_EraseRootFromParent_Done,
     /* 204893 */   // Label 3839: @204893
     /* 204893 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(204930), // Rule ID 3003 //
     /* 204898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 204906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204919 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1631:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 204922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204928 */     GIR_RootConstrainSelectedInstOperands,
     /* 204929 */     // GIR_Coverage, 3003,
     /* 204929 */     GIR_EraseRootFromParent_Done,
     /* 204930 */   // Label 3840: @204930
     /* 204930 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(204967), // Rule ID 3025 //
     /* 204935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 204943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204956 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1689:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 204959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204965 */     GIR_RootConstrainSelectedInstOperands,
     /* 204966 */     // GIR_Coverage, 3025,
     /* 204966 */     GIR_EraseRootFromParent_Done,
     /* 204967 */   // Label 3841: @204967
     /* 204967 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(205004), // Rule ID 3026 //
     /* 204972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 204980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204993 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1689:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 204996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205002 */     GIR_RootConstrainSelectedInstOperands,
     /* 205003 */     // GIR_Coverage, 3026,
     /* 205003 */     GIR_EraseRootFromParent_Done,
     /* 205004 */   // Label 3842: @205004
     /* 205004 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(205041), // Rule ID 3027 //
     /* 205009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 205017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205030 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1689:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 205033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205039 */     GIR_RootConstrainSelectedInstOperands,
     /* 205040 */     // GIR_Coverage, 3027,
     /* 205040 */     GIR_EraseRootFromParent_Done,
     /* 205041 */   // Label 3843: @205041
     /* 205041 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(205078), // Rule ID 3031 //
     /* 205046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 205049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 205054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205067 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1632:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 205070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205076 */     GIR_RootConstrainSelectedInstOperands,
     /* 205077 */     // GIR_Coverage, 3031,
     /* 205077 */     GIR_EraseRootFromParent_Done,
     /* 205078 */   // Label 3844: @205078
     /* 205078 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(205115), // Rule ID 3032 //
     /* 205083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 205091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205104 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1632:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 205107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205113 */     GIR_RootConstrainSelectedInstOperands,
     /* 205114 */     // GIR_Coverage, 3032,
     /* 205114 */     GIR_EraseRootFromParent_Done,
     /* 205115 */   // Label 3845: @205115
     /* 205115 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(205152), // Rule ID 3033 //
     /* 205120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 205128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205141 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1632:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 205144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205150 */     GIR_RootConstrainSelectedInstOperands,
     /* 205151 */     // GIR_Coverage, 3033,
     /* 205151 */     GIR_EraseRootFromParent_Done,
     /* 205152 */   // Label 3846: @205152
     /* 205152 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(205189), // Rule ID 3034 //
     /* 205157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 205160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 205165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205178 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1274:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 205181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205187 */     GIR_RootConstrainSelectedInstOperands,
     /* 205188 */     // GIR_Coverage, 3034,
     /* 205188 */     GIR_EraseRootFromParent_Done,
     /* 205189 */   // Label 3847: @205189
     /* 205189 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(205226), // Rule ID 3035 //
     /* 205194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 205197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 205202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205215 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1274:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 205218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205224 */     GIR_RootConstrainSelectedInstOperands,
     /* 205225 */     // GIR_Coverage, 3035,
     /* 205225 */     GIR_EraseRootFromParent_Done,
     /* 205226 */   // Label 3848: @205226
     /* 205226 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(205263), // Rule ID 3036 //
     /* 205231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 205234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 205239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1274:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 205255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205261 */     GIR_RootConstrainSelectedInstOperands,
     /* 205262 */     // GIR_Coverage, 3036,
     /* 205262 */     GIR_EraseRootFromParent_Done,
     /* 205263 */   // Label 3849: @205263
     /* 205263 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(205300), // Rule ID 3037 //
     /* 205268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 205271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 205276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1274:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 205292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205298 */     GIR_RootConstrainSelectedInstOperands,
     /* 205299 */     // GIR_Coverage, 3037,
     /* 205299 */     GIR_EraseRootFromParent_Done,
     /* 205300 */   // Label 3850: @205300
     /* 205300 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(205337), // Rule ID 3038 //
     /* 205305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 205313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205326 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1690:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 205329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205335 */     GIR_RootConstrainSelectedInstOperands,
     /* 205336 */     // GIR_Coverage, 3038,
     /* 205336 */     GIR_EraseRootFromParent_Done,
     /* 205337 */   // Label 3851: @205337
     /* 205337 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(205374), // Rule ID 3039 //
     /* 205342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 205350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205363 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1690:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 205366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205372 */     GIR_RootConstrainSelectedInstOperands,
     /* 205373 */     // GIR_Coverage, 3039,
     /* 205373 */     GIR_EraseRootFromParent_Done,
     /* 205374 */   // Label 3852: @205374
     /* 205374 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(205411), // Rule ID 3040 //
     /* 205379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 205387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205400 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1690:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 205403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205409 */     GIR_RootConstrainSelectedInstOperands,
     /* 205410 */     // GIR_Coverage, 3040,
     /* 205410 */     GIR_EraseRootFromParent_Done,
     /* 205411 */   // Label 3853: @205411
     /* 205411 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(205448), // Rule ID 3087 //
     /* 205416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 205424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205437 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1251:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 205440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205446 */     GIR_RootConstrainSelectedInstOperands,
     /* 205447 */     // GIR_Coverage, 3087,
     /* 205447 */     GIR_EraseRootFromParent_Done,
     /* 205448 */   // Label 3854: @205448
     /* 205448 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(205485), // Rule ID 3088 //
     /* 205453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 205461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205474 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1251:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 205477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205483 */     GIR_RootConstrainSelectedInstOperands,
     /* 205484 */     // GIR_Coverage, 3088,
     /* 205484 */     GIR_EraseRootFromParent_Done,
     /* 205485 */   // Label 3855: @205485
     /* 205485 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(205522), // Rule ID 3089 //
     /* 205490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 205498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205511 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1251:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 205514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205520 */     GIR_RootConstrainSelectedInstOperands,
     /* 205521 */     // GIR_Coverage, 3089,
     /* 205521 */     GIR_EraseRootFromParent_Done,
     /* 205522 */   // Label 3856: @205522
     /* 205522 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(205559), // Rule ID 3096 //
     /* 205527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 205535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205548 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1853:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 205551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205557 */     GIR_RootConstrainSelectedInstOperands,
     /* 205558 */     // GIR_Coverage, 3096,
     /* 205558 */     GIR_EraseRootFromParent_Done,
     /* 205559 */   // Label 3857: @205559
     /* 205559 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(205596), // Rule ID 3097 //
     /* 205564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 205572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205585 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 205588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205594 */     GIR_RootConstrainSelectedInstOperands,
     /* 205595 */     // GIR_Coverage, 3097,
     /* 205595 */     GIR_EraseRootFromParent_Done,
     /* 205596 */   // Label 3858: @205596
     /* 205596 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(205633), // Rule ID 3098 //
     /* 205601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 205609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205622 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 205625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205631 */     GIR_RootConstrainSelectedInstOperands,
     /* 205632 */     // GIR_Coverage, 3098,
     /* 205632 */     GIR_EraseRootFromParent_Done,
     /* 205633 */   // Label 3859: @205633
     /* 205633 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(205673), // Rule ID 3202 //
     /* 205638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205659 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 205662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205671 */     GIR_RootConstrainSelectedInstOperands,
     /* 205672 */     // GIR_Coverage, 3202,
     /* 205672 */     GIR_EraseRootFromParent_Done,
     /* 205673 */   // Label 3860: @205673
     /* 205673 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(205713), // Rule ID 3203 //
     /* 205678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 205689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205699 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 205702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205711 */     GIR_RootConstrainSelectedInstOperands,
     /* 205712 */     // GIR_Coverage, 3203,
     /* 205712 */     GIR_EraseRootFromParent_Done,
     /* 205713 */   // Label 3861: @205713
     /* 205713 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(205753), // Rule ID 3204 //
     /* 205718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 205729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205739 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 205742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205751 */     GIR_RootConstrainSelectedInstOperands,
     /* 205752 */     // GIR_Coverage, 3204,
     /* 205752 */     GIR_EraseRootFromParent_Done,
     /* 205753 */   // Label 3862: @205753
     /* 205753 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(205793), // Rule ID 3205 //
     /* 205758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 205769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205779 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 205782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205791 */     GIR_RootConstrainSelectedInstOperands,
     /* 205792 */     // GIR_Coverage, 3205,
     /* 205792 */     GIR_EraseRootFromParent_Done,
     /* 205793 */   // Label 3863: @205793
     /* 205793 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(205833), // Rule ID 3210 //
     /* 205798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 205812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 205815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205819 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 205819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 205822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205831 */     GIR_RootConstrainSelectedInstOperands,
     /* 205832 */     // GIR_Coverage, 3210,
     /* 205832 */     GIR_EraseRootFromParent_Done,
     /* 205833 */   // Label 3864: @205833
     /* 205833 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(205873), // Rule ID 3211 //
     /* 205838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 205849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 205852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 205855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205859 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 205859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 205862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205871 */     GIR_RootConstrainSelectedInstOperands,
     /* 205872 */     // GIR_Coverage, 3211,
     /* 205872 */     GIR_EraseRootFromParent_Done,
     /* 205873 */   // Label 3865: @205873
     /* 205873 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(205913), // Rule ID 3212 //
     /* 205878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 205889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 205892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 205895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205899 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 205899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 205902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205911 */     GIR_RootConstrainSelectedInstOperands,
     /* 205912 */     // GIR_Coverage, 3212,
     /* 205912 */     GIR_EraseRootFromParent_Done,
     /* 205913 */   // Label 3866: @205913
     /* 205913 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(205953), // Rule ID 3213 //
     /* 205918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 205929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 205932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 205935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205939 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 205939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 205942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205951 */     GIR_RootConstrainSelectedInstOperands,
     /* 205952 */     // GIR_Coverage, 3213,
     /* 205952 */     GIR_EraseRootFromParent_Done,
     /* 205953 */   // Label 3867: @205953
     /* 205953 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(205990), // Rule ID 3402 //
     /* 205958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 205961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 205966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205979 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1342:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 205982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205988 */     GIR_RootConstrainSelectedInstOperands,
     /* 205989 */     // GIR_Coverage, 3402,
     /* 205989 */     GIR_EraseRootFromParent_Done,
     /* 205990 */   // Label 3868: @205990
     /* 205990 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(206027), // Rule ID 3403 //
     /* 205995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 205998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 206003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206016 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1342:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 206016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 206019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206025 */     GIR_RootConstrainSelectedInstOperands,
     /* 206026 */     // GIR_Coverage, 3403,
     /* 206026 */     GIR_EraseRootFromParent_Done,
     /* 206027 */   // Label 3869: @206027
     /* 206027 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(206064), // Rule ID 3404 //
     /* 206032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 206035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 206040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206053 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1342:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 206056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206062 */     GIR_RootConstrainSelectedInstOperands,
     /* 206063 */     // GIR_Coverage, 3404,
     /* 206063 */     GIR_EraseRootFromParent_Done,
     /* 206064 */   // Label 3870: @206064
     /* 206064 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(206101), // Rule ID 3405 //
     /* 206069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 206072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 206077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206090 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1342:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 206090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 206093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206099 */     GIR_RootConstrainSelectedInstOperands,
     /* 206100 */     // GIR_Coverage, 3405,
     /* 206100 */     GIR_EraseRootFromParent_Done,
     /* 206101 */   // Label 3871: @206101
     /* 206101 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(206138), // Rule ID 3427 //
     /* 206106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 206109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 206114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206127 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1545:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 206130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206136 */     GIR_RootConstrainSelectedInstOperands,
     /* 206137 */     // GIR_Coverage, 3427,
     /* 206137 */     GIR_EraseRootFromParent_Done,
     /* 206138 */   // Label 3872: @206138
     /* 206138 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(206175), // Rule ID 3428 //
     /* 206143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 206146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 206151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206164 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1545:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 206167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206173 */     GIR_RootConstrainSelectedInstOperands,
     /* 206174 */     // GIR_Coverage, 3428,
     /* 206174 */     GIR_EraseRootFromParent_Done,
     /* 206175 */   // Label 3873: @206175
     /* 206175 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(206212), // Rule ID 3429 //
     /* 206180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 206183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 206188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206201 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1545:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 206204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206210 */     GIR_RootConstrainSelectedInstOperands,
     /* 206211 */     // GIR_Coverage, 3429,
     /* 206211 */     GIR_EraseRootFromParent_Done,
     /* 206212 */   // Label 3874: @206212
     /* 206212 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(206249), // Rule ID 3451 //
     /* 206217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 206225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 206228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 206231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 206234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206238 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1295:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 206238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 206241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206247 */     GIR_RootConstrainSelectedInstOperands,
     /* 206248 */     // GIR_Coverage, 3451,
     /* 206248 */     GIR_EraseRootFromParent_Done,
     /* 206249 */   // Label 3875: @206249
     /* 206249 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(206286), // Rule ID 3456 //
     /* 206254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 206257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 206262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206275 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1725:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 206278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206284 */     GIR_RootConstrainSelectedInstOperands,
     /* 206285 */     // GIR_Coverage, 3456,
     /* 206285 */     GIR_EraseRootFromParent_Done,
     /* 206286 */   // Label 3876: @206286
     /* 206286 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(206323), // Rule ID 3457 //
     /* 206291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 206294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 206299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206312 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1260:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 206315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206321 */     GIR_RootConstrainSelectedInstOperands,
     /* 206322 */     // GIR_Coverage, 3457,
     /* 206322 */     GIR_EraseRootFromParent_Done,
     /* 206323 */   // Label 3877: @206323
     /* 206323 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(206360), // Rule ID 3466 //
     /* 206328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 206336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206349 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2155:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 206352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206358 */     GIR_RootConstrainSelectedInstOperands,
     /* 206359 */     // GIR_Coverage, 3466,
     /* 206359 */     GIR_EraseRootFromParent_Done,
     /* 206360 */   // Label 3878: @206360
     /* 206360 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(206397), // Rule ID 3467 //
     /* 206365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 206373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206386 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2155:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 206389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206395 */     GIR_RootConstrainSelectedInstOperands,
     /* 206396 */     // GIR_Coverage, 3467,
     /* 206396 */     GIR_EraseRootFromParent_Done,
     /* 206397 */   // Label 3879: @206397
     /* 206397 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(206434), // Rule ID 3468 //
     /* 206402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 206410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206423 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2155:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 206423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 206426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206432 */     GIR_RootConstrainSelectedInstOperands,
     /* 206433 */     // GIR_Coverage, 3468,
     /* 206433 */     GIR_EraseRootFromParent_Done,
     /* 206434 */   // Label 3880: @206434
     /* 206434 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(206471), // Rule ID 3469 //
     /* 206439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 206447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206460 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2155:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 206463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206469 */     GIR_RootConstrainSelectedInstOperands,
     /* 206470 */     // GIR_Coverage, 3469,
     /* 206470 */     GIR_EraseRootFromParent_Done,
     /* 206471 */   // Label 3881: @206471
     /* 206471 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(206508), // Rule ID 3470 //
     /* 206476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 206484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206497 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2155:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 206497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 206500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206506 */     GIR_RootConstrainSelectedInstOperands,
     /* 206507 */     // GIR_Coverage, 3470,
     /* 206507 */     GIR_EraseRootFromParent_Done,
     /* 206508 */   // Label 3882: @206508
     /* 206508 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(206545), // Rule ID 3471 //
     /* 206513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 206521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2155:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 206537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206543 */     GIR_RootConstrainSelectedInstOperands,
     /* 206544 */     // GIR_Coverage, 3471,
     /* 206544 */     GIR_EraseRootFromParent_Done,
     /* 206545 */   // Label 3883: @206545
     /* 206545 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(206582), // Rule ID 3472 //
     /* 206550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 206558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206571 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2155:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 206571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 206574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206580 */     GIR_RootConstrainSelectedInstOperands,
     /* 206581 */     // GIR_Coverage, 3472,
     /* 206581 */     GIR_EraseRootFromParent_Done,
     /* 206582 */   // Label 3884: @206582
     /* 206582 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(206619), // Rule ID 3527 //
     /* 206587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 206595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 206598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206608 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1368:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 206608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 206611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 206613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206617 */     GIR_RootConstrainSelectedInstOperands,
     /* 206618 */     // GIR_Coverage, 3527,
     /* 206618 */     GIR_EraseRootFromParent_Done,
     /* 206619 */   // Label 3885: @206619
     /* 206619 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(206656), // Rule ID 3528 //
     /* 206624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 206632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 206635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206645 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1368:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 206645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 206648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 206650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206654 */     GIR_RootConstrainSelectedInstOperands,
     /* 206655 */     // GIR_Coverage, 3528,
     /* 206655 */     GIR_EraseRootFromParent_Done,
     /* 206656 */   // Label 3886: @206656
     /* 206656 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(206693), // Rule ID 3529 //
     /* 206661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 206669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 206672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206682 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1368:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 206682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 206685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 206687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206691 */     GIR_RootConstrainSelectedInstOperands,
     /* 206692 */     // GIR_Coverage, 3529,
     /* 206692 */     GIR_EraseRootFromParent_Done,
     /* 206693 */   // Label 3887: @206693
     /* 206693 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(206730), // Rule ID 3559 //
     /* 206698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 206706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 206709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 206712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206719 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1619:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 206722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 206724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206728 */     GIR_RootConstrainSelectedInstOperands,
     /* 206729 */     // GIR_Coverage, 3559,
     /* 206729 */     GIR_EraseRootFromParent_Done,
     /* 206730 */   // Label 3888: @206730
     /* 206730 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(206767), // Rule ID 3560 //
     /* 206735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 206743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 206746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206756 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1619:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 206759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 206761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206765 */     GIR_RootConstrainSelectedInstOperands,
     /* 206766 */     // GIR_Coverage, 3560,
     /* 206766 */     GIR_EraseRootFromParent_Done,
     /* 206767 */   // Label 3889: @206767
     /* 206767 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(206804), // Rule ID 3561 //
     /* 206772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 206780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 206783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206793 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1619:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 206796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 206798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206802 */     GIR_RootConstrainSelectedInstOperands,
     /* 206803 */     // GIR_Coverage, 3561,
     /* 206803 */     GIR_EraseRootFromParent_Done,
     /* 206804 */   // Label 3890: @206804
     /* 206804 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(206841), // Rule ID 3562 //
     /* 206809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 206817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 206820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206830 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1619:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 206833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 206835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206839 */     GIR_RootConstrainSelectedInstOperands,
     /* 206840 */     // GIR_Coverage, 3562,
     /* 206840 */     GIR_EraseRootFromParent_Done,
     /* 206841 */   // Label 3891: @206841
     /* 206841 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(206878), // Rule ID 3563 //
     /* 206846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 206854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206867 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2163:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 206870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206876 */     GIR_RootConstrainSelectedInstOperands,
     /* 206877 */     // GIR_Coverage, 3563,
     /* 206877 */     GIR_EraseRootFromParent_Done,
     /* 206878 */   // Label 3892: @206878
     /* 206878 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(206915), // Rule ID 3564 //
     /* 206883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 206891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206904 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2163:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 206907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206913 */     GIR_RootConstrainSelectedInstOperands,
     /* 206914 */     // GIR_Coverage, 3564,
     /* 206914 */     GIR_EraseRootFromParent_Done,
     /* 206915 */   // Label 3893: @206915
     /* 206915 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(206952), // Rule ID 3565 //
     /* 206920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 206928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206941 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2163:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 206944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206950 */     GIR_RootConstrainSelectedInstOperands,
     /* 206951 */     // GIR_Coverage, 3565,
     /* 206951 */     GIR_EraseRootFromParent_Done,
     /* 206952 */   // Label 3894: @206952
     /* 206952 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(206989), // Rule ID 3566 //
     /* 206957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 206965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206978 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2163:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 206981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206987 */     GIR_RootConstrainSelectedInstOperands,
     /* 206988 */     // GIR_Coverage, 3566,
     /* 206988 */     GIR_EraseRootFromParent_Done,
     /* 206989 */   // Label 3895: @206989
     /* 206989 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(207026), // Rule ID 3567 //
     /* 206994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 207002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207015 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2163:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 207018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207024 */     GIR_RootConstrainSelectedInstOperands,
     /* 207025 */     // GIR_Coverage, 3567,
     /* 207025 */     GIR_EraseRootFromParent_Done,
     /* 207026 */   // Label 3896: @207026
     /* 207026 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(207063), // Rule ID 3568 //
     /* 207031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 207039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207052 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2163:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 207055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207061 */     GIR_RootConstrainSelectedInstOperands,
     /* 207062 */     // GIR_Coverage, 3568,
     /* 207062 */     GIR_EraseRootFromParent_Done,
     /* 207063 */   // Label 3897: @207063
     /* 207063 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(207100), // Rule ID 3569 //
     /* 207068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 207076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207089 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2163:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 207092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207098 */     GIR_RootConstrainSelectedInstOperands,
     /* 207099 */     // GIR_Coverage, 3569,
     /* 207099 */     GIR_EraseRootFromParent_Done,
     /* 207100 */   // Label 3898: @207100
     /* 207100 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(207137), // Rule ID 3570 //
     /* 207105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 207113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207126 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1918:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 207129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207135 */     GIR_RootConstrainSelectedInstOperands,
     /* 207136 */     // GIR_Coverage, 3570,
     /* 207136 */     GIR_EraseRootFromParent_Done,
     /* 207137 */   // Label 3899: @207137
     /* 207137 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(207174), // Rule ID 3571 //
     /* 207142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 207150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207163 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1918:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 207166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207172 */     GIR_RootConstrainSelectedInstOperands,
     /* 207173 */     // GIR_Coverage, 3571,
     /* 207173 */     GIR_EraseRootFromParent_Done,
     /* 207174 */   // Label 3900: @207174
     /* 207174 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(207211), // Rule ID 3572 //
     /* 207179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 207187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207200 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1918:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 207203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207209 */     GIR_RootConstrainSelectedInstOperands,
     /* 207210 */     // GIR_Coverage, 3572,
     /* 207210 */     GIR_EraseRootFromParent_Done,
     /* 207211 */   // Label 3901: @207211
     /* 207211 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(207248), // Rule ID 3573 //
     /* 207216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 207224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207237 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1918:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 207240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207246 */     GIR_RootConstrainSelectedInstOperands,
     /* 207247 */     // GIR_Coverage, 3573,
     /* 207247 */     GIR_EraseRootFromParent_Done,
     /* 207248 */   // Label 3902: @207248
     /* 207248 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(207285), // Rule ID 3574 //
     /* 207253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 207261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207274 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1918:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 207277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207283 */     GIR_RootConstrainSelectedInstOperands,
     /* 207284 */     // GIR_Coverage, 3574,
     /* 207284 */     GIR_EraseRootFromParent_Done,
     /* 207285 */   // Label 3903: @207285
     /* 207285 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(207322), // Rule ID 3575 //
     /* 207290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 207298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207311 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1918:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 207314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207320 */     GIR_RootConstrainSelectedInstOperands,
     /* 207321 */     // GIR_Coverage, 3575,
     /* 207321 */     GIR_EraseRootFromParent_Done,
     /* 207322 */   // Label 3904: @207322
     /* 207322 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(207359), // Rule ID 3576 //
     /* 207327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 207335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207348 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1918:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 207351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207357 */     GIR_RootConstrainSelectedInstOperands,
     /* 207358 */     // GIR_Coverage, 3576,
     /* 207358 */     GIR_EraseRootFromParent_Done,
     /* 207359 */   // Label 3905: @207359
     /* 207359 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(207396), // Rule ID 8478 //
     /* 207364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 207372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 207375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 207378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 207381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207385 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1297:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 207385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 207388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207394 */     GIR_RootConstrainSelectedInstOperands,
     /* 207395 */     // GIR_Coverage, 8478,
     /* 207395 */     GIR_EraseRootFromParent_Done,
     /* 207396 */   // Label 3906: @207396
     /* 207396 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(207433), // Rule ID 8954 //
     /* 207401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 207409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207422 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1255:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 207425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207431 */     GIR_RootConstrainSelectedInstOperands,
     /* 207432 */     // GIR_Coverage, 8954,
     /* 207432 */     GIR_EraseRootFromParent_Done,
     /* 207433 */   // Label 3907: @207433
     /* 207433 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(207470), // Rule ID 8955 //
     /* 207438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 207446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 207462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207468 */     GIR_RootConstrainSelectedInstOperands,
     /* 207469 */     // GIR_Coverage, 8955,
     /* 207469 */     GIR_EraseRootFromParent_Done,
     /* 207470 */   // Label 3908: @207470
     /* 207470 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(207507), // Rule ID 8956 //
     /* 207475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 207483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1258:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 207499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207505 */     GIR_RootConstrainSelectedInstOperands,
     /* 207506 */     // GIR_Coverage, 8956,
     /* 207506 */     GIR_EraseRootFromParent_Done,
     /* 207507 */   // Label 3909: @207507
     /* 207507 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(207544), // Rule ID 8957 //
     /* 207512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 207520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207533 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1256:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 207536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207542 */     GIR_RootConstrainSelectedInstOperands,
     /* 207543 */     // GIR_Coverage, 8957,
     /* 207543 */     GIR_EraseRootFromParent_Done,
     /* 207544 */   // Label 3910: @207544
     /* 207544 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(207581), // Rule ID 8958 //
     /* 207549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 207557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207570 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1255:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 207573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207579 */     GIR_RootConstrainSelectedInstOperands,
     /* 207580 */     // GIR_Coverage, 8958,
     /* 207580 */     GIR_EraseRootFromParent_Done,
     /* 207581 */   // Label 3911: @207581
     /* 207581 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(207618), // Rule ID 8959 //
     /* 207586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 207594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207607 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 207610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207616 */     GIR_RootConstrainSelectedInstOperands,
     /* 207617 */     // GIR_Coverage, 8959,
     /* 207617 */     GIR_EraseRootFromParent_Done,
     /* 207618 */   // Label 3912: @207618
     /* 207618 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(207655), // Rule ID 8960 //
     /* 207623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 207631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207644 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1258:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 207647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207653 */     GIR_RootConstrainSelectedInstOperands,
     /* 207654 */     // GIR_Coverage, 8960,
     /* 207654 */     GIR_EraseRootFromParent_Done,
     /* 207655 */   // Label 3913: @207655
     /* 207655 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(207692), // Rule ID 8961 //
     /* 207660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 207668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1256:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 207684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207690 */     GIR_RootConstrainSelectedInstOperands,
     /* 207691 */     // GIR_Coverage, 8961,
     /* 207691 */     GIR_EraseRootFromParent_Done,
     /* 207692 */   // Label 3914: @207692
     /* 207692 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(207732), // Rule ID 9961 //
     /* 207697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 207705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 207708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207718 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 207721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207730 */     GIR_RootConstrainSelectedInstOperands,
     /* 207731 */     // GIR_Coverage, 9961,
     /* 207731 */     GIR_EraseRootFromParent_Done,
     /* 207732 */   // Label 3915: @207732
     /* 207732 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(207772), // Rule ID 9962 //
     /* 207737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 207745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 207748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207758 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 207761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207770 */     GIR_RootConstrainSelectedInstOperands,
     /* 207771 */     // GIR_Coverage, 9962,
     /* 207771 */     GIR_EraseRootFromParent_Done,
     /* 207772 */   // Label 3916: @207772
     /* 207772 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(207812), // Rule ID 9963 //
     /* 207777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 207785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 207788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207798 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 207801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207810 */     GIR_RootConstrainSelectedInstOperands,
     /* 207811 */     // GIR_Coverage, 9963,
     /* 207811 */     GIR_EraseRootFromParent_Done,
     /* 207812 */   // Label 3917: @207812
     /* 207812 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(207852), // Rule ID 9964 //
     /* 207817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 207825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 207828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207838 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 207841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207847 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207850 */     GIR_RootConstrainSelectedInstOperands,
     /* 207851 */     // GIR_Coverage, 9964,
     /* 207851 */     GIR_EraseRootFromParent_Done,
     /* 207852 */   // Label 3918: @207852
     /* 207852 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(207892), // Rule ID 9973 //
     /* 207857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 207865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 207868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207878 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2127:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 207881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207890 */     GIR_RootConstrainSelectedInstOperands,
     /* 207891 */     // GIR_Coverage, 9973,
     /* 207891 */     GIR_EraseRootFromParent_Done,
     /* 207892 */   // Label 3919: @207892
     /* 207892 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(207932), // Rule ID 9974 //
     /* 207897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 207905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 207908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207918 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2127:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 207921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207930 */     GIR_RootConstrainSelectedInstOperands,
     /* 207931 */     // GIR_Coverage, 9974,
     /* 207931 */     GIR_EraseRootFromParent_Done,
     /* 207932 */   // Label 3920: @207932
     /* 207932 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(207972), // Rule ID 9975 //
     /* 207937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 207945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 207948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207958 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2127:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 207961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207970 */     GIR_RootConstrainSelectedInstOperands,
     /* 207971 */     // GIR_Coverage, 9975,
     /* 207971 */     GIR_EraseRootFromParent_Done,
     /* 207972 */   // Label 3921: @207972
     /* 207972 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(208012), // Rule ID 9976 //
     /* 207977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 207985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 207988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2127:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 208001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208007 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208010 */     GIR_RootConstrainSelectedInstOperands,
     /* 208011 */     // GIR_Coverage, 9976,
     /* 208011 */     GIR_EraseRootFromParent_Done,
     /* 208012 */   // Label 3922: @208012
     /* 208012 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(208052), // Rule ID 9977 //
     /* 208017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 208025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 208028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208038 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 208041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208050 */     GIR_RootConstrainSelectedInstOperands,
     /* 208051 */     // GIR_Coverage, 9977,
     /* 208051 */     GIR_EraseRootFromParent_Done,
     /* 208052 */   // Label 3923: @208052
     /* 208052 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(208092), // Rule ID 9978 //
     /* 208057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 208065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 208068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208078 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 208081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208090 */     GIR_RootConstrainSelectedInstOperands,
     /* 208091 */     // GIR_Coverage, 9978,
     /* 208091 */     GIR_EraseRootFromParent_Done,
     /* 208092 */   // Label 3924: @208092
     /* 208092 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(208132), // Rule ID 9979 //
     /* 208097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 208105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 208108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208118 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 208121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208130 */     GIR_RootConstrainSelectedInstOperands,
     /* 208131 */     // GIR_Coverage, 9979,
     /* 208131 */     GIR_EraseRootFromParent_Done,
     /* 208132 */   // Label 3925: @208132
     /* 208132 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(208172), // Rule ID 9980 //
     /* 208137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 208145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 208148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208158 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 208161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208170 */     GIR_RootConstrainSelectedInstOperands,
     /* 208171 */     // GIR_Coverage, 9980,
     /* 208171 */     GIR_EraseRootFromParent_Done,
     /* 208172 */   // Label 3926: @208172
     /* 208172 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(208212), // Rule ID 9989 //
     /* 208177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 208185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 208188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208198 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2127:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 208201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208210 */     GIR_RootConstrainSelectedInstOperands,
     /* 208211 */     // GIR_Coverage, 9989,
     /* 208211 */     GIR_EraseRootFromParent_Done,
     /* 208212 */   // Label 3927: @208212
     /* 208212 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(208252), // Rule ID 9990 //
     /* 208217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 208225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 208228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208238 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2127:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 208241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208250 */     GIR_RootConstrainSelectedInstOperands,
     /* 208251 */     // GIR_Coverage, 9990,
     /* 208251 */     GIR_EraseRootFromParent_Done,
     /* 208252 */   // Label 3928: @208252
     /* 208252 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(208292), // Rule ID 9991 //
     /* 208257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 208265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 208268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208278 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2127:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 208281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208290 */     GIR_RootConstrainSelectedInstOperands,
     /* 208291 */     // GIR_Coverage, 9991,
     /* 208291 */     GIR_EraseRootFromParent_Done,
     /* 208292 */   // Label 3929: @208292
     /* 208292 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(208332), // Rule ID 9992 //
     /* 208297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 208305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 208308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208318 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2127:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 208321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208330 */     GIR_RootConstrainSelectedInstOperands,
     /* 208331 */     // GIR_Coverage, 9992,
     /* 208331 */     GIR_EraseRootFromParent_Done,
     /* 208332 */   // Label 3930: @208332
     /* 208332 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(208369), // Rule ID 10151 //
     /* 208337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 208345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 208354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208358 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2025:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 208358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 208361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208367 */     GIR_RootConstrainSelectedInstOperands,
     /* 208368 */     // GIR_Coverage, 10151,
     /* 208368 */     GIR_EraseRootFromParent_Done,
     /* 208369 */   // Label 3931: @208369
     /* 208369 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(208406), // Rule ID 10152 //
     /* 208374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 208382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 208391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2025:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 208395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 208398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208404 */     GIR_RootConstrainSelectedInstOperands,
     /* 208405 */     // GIR_Coverage, 10152,
     /* 208405 */     GIR_EraseRootFromParent_Done,
     /* 208406 */   // Label 3932: @208406
     /* 208406 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(208443), // Rule ID 10153 //
     /* 208411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 208419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 208428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2025:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 208432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 208435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208441 */     GIR_RootConstrainSelectedInstOperands,
     /* 208442 */     // GIR_Coverage, 10153,
     /* 208442 */     GIR_EraseRootFromParent_Done,
     /* 208443 */   // Label 3933: @208443
     /* 208443 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(208480), // Rule ID 10154 //
     /* 208448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 208456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 208465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208469 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1780:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 208469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 208472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208478 */     GIR_RootConstrainSelectedInstOperands,
     /* 208479 */     // GIR_Coverage, 10154,
     /* 208479 */     GIR_EraseRootFromParent_Done,
     /* 208480 */   // Label 3934: @208480
     /* 208480 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(208517), // Rule ID 10155 //
     /* 208485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 208493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 208502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208506 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1780:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 208506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 208509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208515 */     GIR_RootConstrainSelectedInstOperands,
     /* 208516 */     // GIR_Coverage, 10155,
     /* 208516 */     GIR_EraseRootFromParent_Done,
     /* 208517 */   // Label 3935: @208517
     /* 208517 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(208554), // Rule ID 10156 //
     /* 208522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 208530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 208539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208543 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1780:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 208543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 208546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208552 */     GIR_RootConstrainSelectedInstOperands,
     /* 208553 */     // GIR_Coverage, 10156,
     /* 208553 */     GIR_EraseRootFromParent_Done,
     /* 208554 */   // Label 3936: @208554
     /* 208554 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(208591), // Rule ID 10157 //
     /* 208559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 208567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 208576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208580 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2011:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 208580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 208583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208589 */     GIR_RootConstrainSelectedInstOperands,
     /* 208590 */     // GIR_Coverage, 10157,
     /* 208590 */     GIR_EraseRootFromParent_Done,
     /* 208591 */   // Label 3937: @208591
     /* 208591 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(208628), // Rule ID 10158 //
     /* 208596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 208604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 208613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208617 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2011:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 208617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 208620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208626 */     GIR_RootConstrainSelectedInstOperands,
     /* 208627 */     // GIR_Coverage, 10158,
     /* 208627 */     GIR_EraseRootFromParent_Done,
     /* 208628 */   // Label 3938: @208628
     /* 208628 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(208665), // Rule ID 10159 //
     /* 208633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 208641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 208650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2011:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 208654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 208657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208663 */     GIR_RootConstrainSelectedInstOperands,
     /* 208664 */     // GIR_Coverage, 10159,
     /* 208664 */     GIR_EraseRootFromParent_Done,
     /* 208665 */   // Label 3939: @208665
     /* 208665 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(208702), // Rule ID 11347 //
     /* 208670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 208678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208691 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2160:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 208694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208700 */     GIR_RootConstrainSelectedInstOperands,
     /* 208701 */     // GIR_Coverage, 11347,
     /* 208701 */     GIR_EraseRootFromParent_Done,
     /* 208702 */   // Label 3940: @208702
     /* 208702 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(208739), // Rule ID 11348 //
     /* 208707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 208715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2160:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 208731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208737 */     GIR_RootConstrainSelectedInstOperands,
     /* 208738 */     // GIR_Coverage, 11348,
     /* 208738 */     GIR_EraseRootFromParent_Done,
     /* 208739 */   // Label 3941: @208739
     /* 208739 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(208776), // Rule ID 11349 //
     /* 208744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 208752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208765 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2160:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 208765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 208768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208774 */     GIR_RootConstrainSelectedInstOperands,
     /* 208775 */     // GIR_Coverage, 11349,
     /* 208775 */     GIR_EraseRootFromParent_Done,
     /* 208776 */   // Label 3942: @208776
     /* 208776 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(208813), // Rule ID 11350 //
     /* 208781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 208789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2160:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 208805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208811 */     GIR_RootConstrainSelectedInstOperands,
     /* 208812 */     // GIR_Coverage, 11350,
     /* 208812 */     GIR_EraseRootFromParent_Done,
     /* 208813 */   // Label 3943: @208813
     /* 208813 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(208850), // Rule ID 11351 //
     /* 208818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 208826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208839 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2160:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 208839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 208842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208848 */     GIR_RootConstrainSelectedInstOperands,
     /* 208849 */     // GIR_Coverage, 11351,
     /* 208849 */     GIR_EraseRootFromParent_Done,
     /* 208850 */   // Label 3944: @208850
     /* 208850 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(208887), // Rule ID 11352 //
     /* 208855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 208863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2160:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 208876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 208879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208885 */     GIR_RootConstrainSelectedInstOperands,
     /* 208886 */     // GIR_Coverage, 11352,
     /* 208886 */     GIR_EraseRootFromParent_Done,
     /* 208887 */   // Label 3945: @208887
     /* 208887 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(208924), // Rule ID 11353 //
     /* 208892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 208900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208913 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2160:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 208913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 208916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208922 */     GIR_RootConstrainSelectedInstOperands,
     /* 208923 */     // GIR_Coverage, 11353,
     /* 208923 */     GIR_EraseRootFromParent_Done,
     /* 208924 */   // Label 3946: @208924
     /* 208924 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(208961), // Rule ID 11354 //
     /* 208929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 208937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208950 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2081:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 208953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208959 */     GIR_RootConstrainSelectedInstOperands,
     /* 208960 */     // GIR_Coverage, 11354,
     /* 208960 */     GIR_EraseRootFromParent_Done,
     /* 208961 */   // Label 3947: @208961
     /* 208961 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(208998), // Rule ID 11355 //
     /* 208966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 208974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208987 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2081:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 208990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208996 */     GIR_RootConstrainSelectedInstOperands,
     /* 208997 */     // GIR_Coverage, 11355,
     /* 208997 */     GIR_EraseRootFromParent_Done,
     /* 208998 */   // Label 3948: @208998
     /* 208998 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(209035), // Rule ID 11356 //
     /* 209003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 209011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209024 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2081:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 209024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 209027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209033 */     GIR_RootConstrainSelectedInstOperands,
     /* 209034 */     // GIR_Coverage, 11356,
     /* 209034 */     GIR_EraseRootFromParent_Done,
     /* 209035 */   // Label 3949: @209035
     /* 209035 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(209072), // Rule ID 11357 //
     /* 209040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 209048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2081:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 209064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209070 */     GIR_RootConstrainSelectedInstOperands,
     /* 209071 */     // GIR_Coverage, 11357,
     /* 209071 */     GIR_EraseRootFromParent_Done,
     /* 209072 */   // Label 3950: @209072
     /* 209072 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(209109), // Rule ID 11358 //
     /* 209077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 209085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209098 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2081:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 209098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 209101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209107 */     GIR_RootConstrainSelectedInstOperands,
     /* 209108 */     // GIR_Coverage, 11358,
     /* 209108 */     GIR_EraseRootFromParent_Done,
     /* 209109 */   // Label 3951: @209109
     /* 209109 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(209146), // Rule ID 11359 //
     /* 209114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 209122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209135 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2081:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 209138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209144 */     GIR_RootConstrainSelectedInstOperands,
     /* 209145 */     // GIR_Coverage, 11359,
     /* 209145 */     GIR_EraseRootFromParent_Done,
     /* 209146 */   // Label 3952: @209146
     /* 209146 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(209183), // Rule ID 11360 //
     /* 209151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 209159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209172 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2081:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 209172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 209175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209181 */     GIR_RootConstrainSelectedInstOperands,
     /* 209182 */     // GIR_Coverage, 11360,
     /* 209182 */     GIR_EraseRootFromParent_Done,
     /* 209183 */   // Label 3953: @209183
     /* 209183 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(209220), // Rule ID 11361 //
     /* 209188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 209196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209209 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2086:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 209212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209218 */     GIR_RootConstrainSelectedInstOperands,
     /* 209219 */     // GIR_Coverage, 11361,
     /* 209219 */     GIR_EraseRootFromParent_Done,
     /* 209220 */   // Label 3954: @209220
     /* 209220 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(209257), // Rule ID 11362 //
     /* 209225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 209233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2086:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 209249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209255 */     GIR_RootConstrainSelectedInstOperands,
     /* 209256 */     // GIR_Coverage, 11362,
     /* 209256 */     GIR_EraseRootFromParent_Done,
     /* 209257 */   // Label 3955: @209257
     /* 209257 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(209294), // Rule ID 11363 //
     /* 209262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 209270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209283 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2086:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 209283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 209286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209292 */     GIR_RootConstrainSelectedInstOperands,
     /* 209293 */     // GIR_Coverage, 11363,
     /* 209293 */     GIR_EraseRootFromParent_Done,
     /* 209294 */   // Label 3956: @209294
     /* 209294 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(209331), // Rule ID 11364 //
     /* 209299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 209307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209320 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2086:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 209323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209329 */     GIR_RootConstrainSelectedInstOperands,
     /* 209330 */     // GIR_Coverage, 11364,
     /* 209330 */     GIR_EraseRootFromParent_Done,
     /* 209331 */   // Label 3957: @209331
     /* 209331 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(209368), // Rule ID 11365 //
     /* 209336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 209344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209357 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2086:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 209357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 209360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209366 */     GIR_RootConstrainSelectedInstOperands,
     /* 209367 */     // GIR_Coverage, 11365,
     /* 209367 */     GIR_EraseRootFromParent_Done,
     /* 209368 */   // Label 3958: @209368
     /* 209368 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(209405), // Rule ID 11366 //
     /* 209373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 209381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2086:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 209397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209403 */     GIR_RootConstrainSelectedInstOperands,
     /* 209404 */     // GIR_Coverage, 11366,
     /* 209404 */     GIR_EraseRootFromParent_Done,
     /* 209405 */   // Label 3959: @209405
     /* 209405 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(209442), // Rule ID 11367 //
     /* 209410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 209418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209431 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2086:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 209431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 209434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209440 */     GIR_RootConstrainSelectedInstOperands,
     /* 209441 */     // GIR_Coverage, 11367,
     /* 209441 */     GIR_EraseRootFromParent_Done,
     /* 209442 */   // Label 3960: @209442
     /* 209442 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(209479), // Rule ID 11368 //
     /* 209447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 209455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209468 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1925:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 209471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209477 */     GIR_RootConstrainSelectedInstOperands,
     /* 209478 */     // GIR_Coverage, 11368,
     /* 209478 */     GIR_EraseRootFromParent_Done,
     /* 209479 */   // Label 3961: @209479
     /* 209479 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(209516), // Rule ID 11369 //
     /* 209484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 209492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209505 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1925:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 209508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209514 */     GIR_RootConstrainSelectedInstOperands,
     /* 209515 */     // GIR_Coverage, 11369,
     /* 209515 */     GIR_EraseRootFromParent_Done,
     /* 209516 */   // Label 3962: @209516
     /* 209516 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(209553), // Rule ID 11370 //
     /* 209521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 209529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209542 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1925:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 209542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 209545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209551 */     GIR_RootConstrainSelectedInstOperands,
     /* 209552 */     // GIR_Coverage, 11370,
     /* 209552 */     GIR_EraseRootFromParent_Done,
     /* 209553 */   // Label 3963: @209553
     /* 209553 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(209590), // Rule ID 11371 //
     /* 209558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 209566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209579 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1925:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 209582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209588 */     GIR_RootConstrainSelectedInstOperands,
     /* 209589 */     // GIR_Coverage, 11371,
     /* 209589 */     GIR_EraseRootFromParent_Done,
     /* 209590 */   // Label 3964: @209590
     /* 209590 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(209627), // Rule ID 11372 //
     /* 209595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 209603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209616 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1925:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 209616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 209619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209625 */     GIR_RootConstrainSelectedInstOperands,
     /* 209626 */     // GIR_Coverage, 11372,
     /* 209626 */     GIR_EraseRootFromParent_Done,
     /* 209627 */   // Label 3965: @209627
     /* 209627 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(209664), // Rule ID 11373 //
     /* 209632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 209640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209653 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1925:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 209656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209662 */     GIR_RootConstrainSelectedInstOperands,
     /* 209663 */     // GIR_Coverage, 11373,
     /* 209663 */     GIR_EraseRootFromParent_Done,
     /* 209664 */   // Label 3966: @209664
     /* 209664 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(209701), // Rule ID 11374 //
     /* 209669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 209677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209690 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1925:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 209690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 209693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209699 */     GIR_RootConstrainSelectedInstOperands,
     /* 209700 */     // GIR_Coverage, 11374,
     /* 209700 */     GIR_EraseRootFromParent_Done,
     /* 209701 */   // Label 3967: @209701
     /* 209701 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(209738), // Rule ID 11375 //
     /* 209706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 209714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209727 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1930:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 209730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209736 */     GIR_RootConstrainSelectedInstOperands,
     /* 209737 */     // GIR_Coverage, 11375,
     /* 209737 */     GIR_EraseRootFromParent_Done,
     /* 209738 */   // Label 3968: @209738
     /* 209738 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(209775), // Rule ID 11376 //
     /* 209743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 209751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209764 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1930:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 209767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209773 */     GIR_RootConstrainSelectedInstOperands,
     /* 209774 */     // GIR_Coverage, 11376,
     /* 209774 */     GIR_EraseRootFromParent_Done,
     /* 209775 */   // Label 3969: @209775
     /* 209775 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(209812), // Rule ID 11377 //
     /* 209780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 209788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209801 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1930:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 209801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 209804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209810 */     GIR_RootConstrainSelectedInstOperands,
     /* 209811 */     // GIR_Coverage, 11377,
     /* 209811 */     GIR_EraseRootFromParent_Done,
     /* 209812 */   // Label 3970: @209812
     /* 209812 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(209849), // Rule ID 11378 //
     /* 209817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 209825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1930:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 209841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209847 */     GIR_RootConstrainSelectedInstOperands,
     /* 209848 */     // GIR_Coverage, 11378,
     /* 209848 */     GIR_EraseRootFromParent_Done,
     /* 209849 */   // Label 3971: @209849
     /* 209849 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(209886), // Rule ID 11379 //
     /* 209854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 209862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209875 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1930:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 209875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 209878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209884 */     GIR_RootConstrainSelectedInstOperands,
     /* 209885 */     // GIR_Coverage, 11379,
     /* 209885 */     GIR_EraseRootFromParent_Done,
     /* 209886 */   // Label 3972: @209886
     /* 209886 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(209923), // Rule ID 11380 //
     /* 209891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 209899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209912 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1930:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 209915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209921 */     GIR_RootConstrainSelectedInstOperands,
     /* 209922 */     // GIR_Coverage, 11380,
     /* 209922 */     GIR_EraseRootFromParent_Done,
     /* 209923 */   // Label 3973: @209923
     /* 209923 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(209960), // Rule ID 11381 //
     /* 209928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 209936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209949 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1930:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 209949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 209952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209958 */     GIR_RootConstrainSelectedInstOperands,
     /* 209959 */     // GIR_Coverage, 11381,
     /* 209959 */     GIR_EraseRootFromParent_Done,
     /* 209960 */   // Label 3974: @209960
     /* 209960 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(209997), // Rule ID 11401 //
     /* 209965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 209973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209986 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1827:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 209989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209995 */     GIR_RootConstrainSelectedInstOperands,
     /* 209996 */     // GIR_Coverage, 11401,
     /* 209996 */     GIR_EraseRootFromParent_Done,
     /* 209997 */   // Label 3975: @209997
     /* 209997 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(210034), // Rule ID 11402 //
     /* 210002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 210010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210023 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1827:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 210026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210032 */     GIR_RootConstrainSelectedInstOperands,
     /* 210033 */     // GIR_Coverage, 11402,
     /* 210033 */     GIR_EraseRootFromParent_Done,
     /* 210034 */   // Label 3976: @210034
     /* 210034 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(210071), // Rule ID 11403 //
     /* 210039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 210047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210060 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1827:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 210063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210069 */     GIR_RootConstrainSelectedInstOperands,
     /* 210070 */     // GIR_Coverage, 11403,
     /* 210070 */     GIR_EraseRootFromParent_Done,
     /* 210071 */   // Label 3977: @210071
     /* 210071 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(210108), // Rule ID 11404 //
     /* 210076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 210084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210097 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1827:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 210100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210106 */     GIR_RootConstrainSelectedInstOperands,
     /* 210107 */     // GIR_Coverage, 11404,
     /* 210107 */     GIR_EraseRootFromParent_Done,
     /* 210108 */   // Label 3978: @210108
     /* 210108 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(210145), // Rule ID 11692 //
     /* 210113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 210121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210134 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1691:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 210137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210143 */     GIR_RootConstrainSelectedInstOperands,
     /* 210144 */     // GIR_Coverage, 11692,
     /* 210144 */     GIR_EraseRootFromParent_Done,
     /* 210145 */   // Label 3979: @210145
     /* 210145 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(210182), // Rule ID 11693 //
     /* 210150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 210158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210171 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1691:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 210174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210180 */     GIR_RootConstrainSelectedInstOperands,
     /* 210181 */     // GIR_Coverage, 11693,
     /* 210181 */     GIR_EraseRootFromParent_Done,
     /* 210182 */   // Label 3980: @210182
     /* 210182 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(210219), // Rule ID 11694 //
     /* 210187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 210195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210208 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1691:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 210211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210217 */     GIR_RootConstrainSelectedInstOperands,
     /* 210218 */     // GIR_Coverage, 11694,
     /* 210218 */     GIR_EraseRootFromParent_Done,
     /* 210219 */   // Label 3981: @210219
     /* 210219 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(210256), // Rule ID 11695 //
     /* 210224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 210232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1939:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 210248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210254 */     GIR_RootConstrainSelectedInstOperands,
     /* 210255 */     // GIR_Coverage, 11695,
     /* 210255 */     GIR_EraseRootFromParent_Done,
     /* 210256 */   // Label 3982: @210256
     /* 210256 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(210293), // Rule ID 11696 //
     /* 210261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 210269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210282 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 210285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210291 */     GIR_RootConstrainSelectedInstOperands,
     /* 210292 */     // GIR_Coverage, 11696,
     /* 210292 */     GIR_EraseRootFromParent_Done,
     /* 210293 */   // Label 3983: @210293
     /* 210293 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(210330), // Rule ID 11697 //
     /* 210298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 210306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210319 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 210322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210328 */     GIR_RootConstrainSelectedInstOperands,
     /* 210329 */     // GIR_Coverage, 11697,
     /* 210329 */     GIR_EraseRootFromParent_Done,
     /* 210330 */   // Label 3984: @210330
     /* 210330 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(210367), // Rule ID 11698 //
     /* 210335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 210343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210356 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1940:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 210359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210365 */     GIR_RootConstrainSelectedInstOperands,
     /* 210366 */     // GIR_Coverage, 11698,
     /* 210366 */     GIR_EraseRootFromParent_Done,
     /* 210367 */   // Label 3985: @210367
     /* 210367 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(210404), // Rule ID 11699 //
     /* 210372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 210380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1940:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 210396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210402 */     GIR_RootConstrainSelectedInstOperands,
     /* 210403 */     // GIR_Coverage, 11699,
     /* 210403 */     GIR_EraseRootFromParent_Done,
     /* 210404 */   // Label 3986: @210404
     /* 210404 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(210441), // Rule ID 11700 //
     /* 210409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 210417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210430 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1940:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 210433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210439 */     GIR_RootConstrainSelectedInstOperands,
     /* 210440 */     // GIR_Coverage, 11700,
     /* 210440 */     GIR_EraseRootFromParent_Done,
     /* 210441 */   // Label 3987: @210441
     /* 210441 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(210478), // Rule ID 11701 //
     /* 210446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 210454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210467 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1868:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 210470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210476 */     GIR_RootConstrainSelectedInstOperands,
     /* 210477 */     // GIR_Coverage, 11701,
     /* 210477 */     GIR_EraseRootFromParent_Done,
     /* 210478 */   // Label 3988: @210478
     /* 210478 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(210515), // Rule ID 11702 //
     /* 210483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 210491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210504 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1868:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 210507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210513 */     GIR_RootConstrainSelectedInstOperands,
     /* 210514 */     // GIR_Coverage, 11702,
     /* 210514 */     GIR_EraseRootFromParent_Done,
     /* 210515 */   // Label 3989: @210515
     /* 210515 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(210552), // Rule ID 11703 //
     /* 210520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 210528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210541 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1868:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 210544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210550 */     GIR_RootConstrainSelectedInstOperands,
     /* 210551 */     // GIR_Coverage, 11703,
     /* 210551 */     GIR_EraseRootFromParent_Done,
     /* 210552 */   // Label 3990: @210552
     /* 210552 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(210589), // Rule ID 11704 //
     /* 210557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 210565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210578 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1870:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 210581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210587 */     GIR_RootConstrainSelectedInstOperands,
     /* 210588 */     // GIR_Coverage, 11704,
     /* 210588 */     GIR_EraseRootFromParent_Done,
     /* 210589 */   // Label 3991: @210589
     /* 210589 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(210626), // Rule ID 11705 //
     /* 210594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 210602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210615 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1870:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 210618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210624 */     GIR_RootConstrainSelectedInstOperands,
     /* 210625 */     // GIR_Coverage, 11705,
     /* 210625 */     GIR_EraseRootFromParent_Done,
     /* 210626 */   // Label 3992: @210626
     /* 210626 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(210663), // Rule ID 11706 //
     /* 210631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 210639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1870:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 210655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210661 */     GIR_RootConstrainSelectedInstOperands,
     /* 210662 */     // GIR_Coverage, 11706,
     /* 210662 */     GIR_EraseRootFromParent_Done,
     /* 210663 */   // Label 3993: @210663
     /* 210663 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(210700), // Rule ID 11707 //
     /* 210668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 210676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210689 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2064:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 210692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210698 */     GIR_RootConstrainSelectedInstOperands,
     /* 210699 */     // GIR_Coverage, 11707,
     /* 210699 */     GIR_EraseRootFromParent_Done,
     /* 210700 */   // Label 3994: @210700
     /* 210700 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(210737), // Rule ID 11708 //
     /* 210705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 210713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 210729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210735 */     GIR_RootConstrainSelectedInstOperands,
     /* 210736 */     // GIR_Coverage, 11708,
     /* 210736 */     GIR_EraseRootFromParent_Done,
     /* 210737 */   // Label 3995: @210737
     /* 210737 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(210774), // Rule ID 11709 //
     /* 210742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 210750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210763 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2064:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 210766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210772 */     GIR_RootConstrainSelectedInstOperands,
     /* 210773 */     // GIR_Coverage, 11709,
     /* 210773 */     GIR_EraseRootFromParent_Done,
     /* 210774 */   // Label 3996: @210774
     /* 210774 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(210811), // Rule ID 11710 //
     /* 210779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 210787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210800 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 210803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210809 */     GIR_RootConstrainSelectedInstOperands,
     /* 210810 */     // GIR_Coverage, 11710,
     /* 210810 */     GIR_EraseRootFromParent_Done,
     /* 210811 */   // Label 3997: @210811
     /* 210811 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(210848), // Rule ID 11711 //
     /* 210816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 210824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210837 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 210840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210846 */     GIR_RootConstrainSelectedInstOperands,
     /* 210847 */     // GIR_Coverage, 11711,
     /* 210847 */     GIR_EraseRootFromParent_Done,
     /* 210848 */   // Label 3998: @210848
     /* 210848 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(210885), // Rule ID 11712 //
     /* 210853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 210861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 210877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210883 */     GIR_RootConstrainSelectedInstOperands,
     /* 210884 */     // GIR_Coverage, 11712,
     /* 210884 */     GIR_EraseRootFromParent_Done,
     /* 210885 */   // Label 3999: @210885
     /* 210885 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(210922), // Rule ID 11713 //
     /* 210890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 210898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210911 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1686:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 210914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210920 */     GIR_RootConstrainSelectedInstOperands,
     /* 210921 */     // GIR_Coverage, 11713,
     /* 210921 */     GIR_EraseRootFromParent_Done,
     /* 210922 */   // Label 4000: @210922
     /* 210922 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(210959), // Rule ID 11714 //
     /* 210927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 210935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210948 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1686:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 210951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210957 */     GIR_RootConstrainSelectedInstOperands,
     /* 210958 */     // GIR_Coverage, 11714,
     /* 210958 */     GIR_EraseRootFromParent_Done,
     /* 210959 */   // Label 4001: @210959
     /* 210959 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(210996), // Rule ID 11715 //
     /* 210964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 210972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210985 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1686:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 210988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210994 */     GIR_RootConstrainSelectedInstOperands,
     /* 210995 */     // GIR_Coverage, 11715,
     /* 210995 */     GIR_EraseRootFromParent_Done,
     /* 210996 */   // Label 4002: @210996
     /* 210996 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(211033), // Rule ID 11716 //
     /* 211001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 211009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211022 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1687:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 211025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211031 */     GIR_RootConstrainSelectedInstOperands,
     /* 211032 */     // GIR_Coverage, 11716,
     /* 211032 */     GIR_EraseRootFromParent_Done,
     /* 211033 */   // Label 4003: @211033
     /* 211033 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(211070), // Rule ID 11717 //
     /* 211038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 211046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211059 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1687:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 211062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211068 */     GIR_RootConstrainSelectedInstOperands,
     /* 211069 */     // GIR_Coverage, 11717,
     /* 211069 */     GIR_EraseRootFromParent_Done,
     /* 211070 */   // Label 4004: @211070
     /* 211070 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(211107), // Rule ID 11718 //
     /* 211075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 211083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211096 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1687:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 211099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211105 */     GIR_RootConstrainSelectedInstOperands,
     /* 211106 */     // GIR_Coverage, 11718,
     /* 211106 */     GIR_EraseRootFromParent_Done,
     /* 211107 */   // Label 4005: @211107
     /* 211107 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(211144), // Rule ID 11719 //
     /* 211112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 211120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211133 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1936:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 211136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211142 */     GIR_RootConstrainSelectedInstOperands,
     /* 211143 */     // GIR_Coverage, 11719,
     /* 211143 */     GIR_EraseRootFromParent_Done,
     /* 211144 */   // Label 4006: @211144
     /* 211144 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(211181), // Rule ID 11720 //
     /* 211149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 211157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211170 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1936:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 211173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211179 */     GIR_RootConstrainSelectedInstOperands,
     /* 211180 */     // GIR_Coverage, 11720,
     /* 211180 */     GIR_EraseRootFromParent_Done,
     /* 211181 */   // Label 4007: @211181
     /* 211181 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(211218), // Rule ID 11721 //
     /* 211186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 211194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211207 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1936:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 211210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211216 */     GIR_RootConstrainSelectedInstOperands,
     /* 211217 */     // GIR_Coverage, 11721,
     /* 211217 */     GIR_EraseRootFromParent_Done,
     /* 211218 */   // Label 4008: @211218
     /* 211218 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(211255), // Rule ID 11722 //
     /* 211223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 211231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211244 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1937:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 211247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211253 */     GIR_RootConstrainSelectedInstOperands,
     /* 211254 */     // GIR_Coverage, 11722,
     /* 211254 */     GIR_EraseRootFromParent_Done,
     /* 211255 */   // Label 4009: @211255
     /* 211255 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(211292), // Rule ID 11723 //
     /* 211260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 211268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211281 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1937:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 211284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211290 */     GIR_RootConstrainSelectedInstOperands,
     /* 211291 */     // GIR_Coverage, 11723,
     /* 211291 */     GIR_EraseRootFromParent_Done,
     /* 211292 */   // Label 4010: @211292
     /* 211292 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(211329), // Rule ID 11724 //
     /* 211297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 211305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1937:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 211321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211327 */     GIR_RootConstrainSelectedInstOperands,
     /* 211328 */     // GIR_Coverage, 11724,
     /* 211328 */     GIR_EraseRootFromParent_Done,
     /* 211329 */   // Label 4011: @211329
     /* 211329 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(211366), // Rule ID 11734 //
     /* 211334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 211342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211355 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1872:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 211358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211364 */     GIR_RootConstrainSelectedInstOperands,
     /* 211365 */     // GIR_Coverage, 11734,
     /* 211365 */     GIR_EraseRootFromParent_Done,
     /* 211366 */   // Label 4012: @211366
     /* 211366 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(211403), // Rule ID 11735 //
     /* 211371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 211379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1872:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 211395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211401 */     GIR_RootConstrainSelectedInstOperands,
     /* 211402 */     // GIR_Coverage, 11735,
     /* 211402 */     GIR_EraseRootFromParent_Done,
     /* 211403 */   // Label 4013: @211403
     /* 211403 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(211440), // Rule ID 11736 //
     /* 211408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 211416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211429 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1872:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 211432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211438 */     GIR_RootConstrainSelectedInstOperands,
     /* 211439 */     // GIR_Coverage, 11736,
     /* 211439 */     GIR_EraseRootFromParent_Done,
     /* 211440 */   // Label 4014: @211440
     /* 211440 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(211477), // Rule ID 11737 //
     /* 211445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 211453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1873:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 211469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211475 */     GIR_RootConstrainSelectedInstOperands,
     /* 211476 */     // GIR_Coverage, 11737,
     /* 211476 */     GIR_EraseRootFromParent_Done,
     /* 211477 */   // Label 4015: @211477
     /* 211477 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(211514), // Rule ID 11738 //
     /* 211482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 211490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211503 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1873:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 211506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211512 */     GIR_RootConstrainSelectedInstOperands,
     /* 211513 */     // GIR_Coverage, 11738,
     /* 211513 */     GIR_EraseRootFromParent_Done,
     /* 211514 */   // Label 4016: @211514
     /* 211514 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(211551), // Rule ID 11739 //
     /* 211519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 211527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211540 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1873:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 211543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211549 */     GIR_RootConstrainSelectedInstOperands,
     /* 211550 */     // GIR_Coverage, 11739,
     /* 211550 */     GIR_EraseRootFromParent_Done,
     /* 211551 */   // Label 4017: @211551
     /* 211551 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(211588), // Rule ID 11740 //
     /* 211556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 211564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211577 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2066:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 211580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211586 */     GIR_RootConstrainSelectedInstOperands,
     /* 211587 */     // GIR_Coverage, 11740,
     /* 211587 */     GIR_EraseRootFromParent_Done,
     /* 211588 */   // Label 4018: @211588
     /* 211588 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(211625), // Rule ID 11741 //
     /* 211593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 211601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2066:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 211617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211623 */     GIR_RootConstrainSelectedInstOperands,
     /* 211624 */     // GIR_Coverage, 11741,
     /* 211624 */     GIR_EraseRootFromParent_Done,
     /* 211625 */   // Label 4019: @211625
     /* 211625 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(211662), // Rule ID 11742 //
     /* 211630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 211638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211651 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2066:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 211654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211660 */     GIR_RootConstrainSelectedInstOperands,
     /* 211661 */     // GIR_Coverage, 11742,
     /* 211661 */     GIR_EraseRootFromParent_Done,
     /* 211662 */   // Label 4020: @211662
     /* 211662 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(211699), // Rule ID 11743 //
     /* 211667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 211675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211688 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2067:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 211691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211697 */     GIR_RootConstrainSelectedInstOperands,
     /* 211698 */     // GIR_Coverage, 11743,
     /* 211698 */     GIR_EraseRootFromParent_Done,
     /* 211699 */   // Label 4021: @211699
     /* 211699 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(211736), // Rule ID 11744 //
     /* 211704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 211712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211725 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2067:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 211728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211734 */     GIR_RootConstrainSelectedInstOperands,
     /* 211735 */     // GIR_Coverage, 11744,
     /* 211735 */     GIR_EraseRootFromParent_Done,
     /* 211736 */   // Label 4022: @211736
     /* 211736 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(211773), // Rule ID 11745 //
     /* 211741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 211749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211762 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2067:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 211765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211771 */     GIR_RootConstrainSelectedInstOperands,
     /* 211772 */     // GIR_Coverage, 11745,
     /* 211772 */     GIR_EraseRootFromParent_Done,
     /* 211773 */   // Label 4023: @211773
     /* 211773 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(211810), // Rule ID 11746 //
     /* 211778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 211786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211799 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1802:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 211802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211808 */     GIR_RootConstrainSelectedInstOperands,
     /* 211809 */     // GIR_Coverage, 11746,
     /* 211809 */     GIR_EraseRootFromParent_Done,
     /* 211810 */   // Label 4024: @211810
     /* 211810 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(211847), // Rule ID 11747 //
     /* 211815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 211823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 211839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211845 */     GIR_RootConstrainSelectedInstOperands,
     /* 211846 */     // GIR_Coverage, 11747,
     /* 211846 */     GIR_EraseRootFromParent_Done,
     /* 211847 */   // Label 4025: @211847
     /* 211847 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(211884), // Rule ID 11748 //
     /* 211852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 211860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211873 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1802:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 211876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211882 */     GIR_RootConstrainSelectedInstOperands,
     /* 211883 */     // GIR_Coverage, 11748,
     /* 211883 */     GIR_EraseRootFromParent_Done,
     /* 211884 */   // Label 4026: @211884
     /* 211884 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(211921), // Rule ID 11749 //
     /* 211889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 211897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211910 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1804:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 211913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211919 */     GIR_RootConstrainSelectedInstOperands,
     /* 211920 */     // GIR_Coverage, 11749,
     /* 211920 */     GIR_EraseRootFromParent_Done,
     /* 211921 */   // Label 4027: @211921
     /* 211921 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(211958), // Rule ID 11750 //
     /* 211926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 211934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211947 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1804:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 211950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211956 */     GIR_RootConstrainSelectedInstOperands,
     /* 211957 */     // GIR_Coverage, 11750,
     /* 211957 */     GIR_EraseRootFromParent_Done,
     /* 211958 */   // Label 4028: @211958
     /* 211958 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(211995), // Rule ID 11751 //
     /* 211963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 211971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211984 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1804:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 211987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211993 */     GIR_RootConstrainSelectedInstOperands,
     /* 211994 */     // GIR_Coverage, 11751,
     /* 211994 */     GIR_EraseRootFromParent_Done,
     /* 211995 */   // Label 4029: @211995
     /* 211995 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(212032), // Rule ID 11752 //
     /* 212000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 212008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212021 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1755:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 212024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212030 */     GIR_RootConstrainSelectedInstOperands,
     /* 212031 */     // GIR_Coverage, 11752,
     /* 212031 */     GIR_EraseRootFromParent_Done,
     /* 212032 */   // Label 4030: @212032
     /* 212032 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(212069), // Rule ID 11753 //
     /* 212037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 212045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1755:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 212061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212067 */     GIR_RootConstrainSelectedInstOperands,
     /* 212068 */     // GIR_Coverage, 11753,
     /* 212068 */     GIR_EraseRootFromParent_Done,
     /* 212069 */   // Label 4031: @212069
     /* 212069 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(212106), // Rule ID 11754 //
     /* 212074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 212082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212095 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1755:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 212098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212104 */     GIR_RootConstrainSelectedInstOperands,
     /* 212105 */     // GIR_Coverage, 11754,
     /* 212105 */     GIR_EraseRootFromParent_Done,
     /* 212106 */   // Label 4032: @212106
     /* 212106 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(212143), // Rule ID 11755 //
     /* 212111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 212119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212132 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1757:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 212135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212141 */     GIR_RootConstrainSelectedInstOperands,
     /* 212142 */     // GIR_Coverage, 11755,
     /* 212142 */     GIR_EraseRootFromParent_Done,
     /* 212143 */   // Label 4033: @212143
     /* 212143 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(212180), // Rule ID 11756 //
     /* 212148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 212156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 212172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212178 */     GIR_RootConstrainSelectedInstOperands,
     /* 212179 */     // GIR_Coverage, 11756,
     /* 212179 */     GIR_EraseRootFromParent_Done,
     /* 212180 */   // Label 4034: @212180
     /* 212180 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(212217), // Rule ID 11757 //
     /* 212185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 212193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212206 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 212209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212215 */     GIR_RootConstrainSelectedInstOperands,
     /* 212216 */     // GIR_Coverage, 11757,
     /* 212216 */     GIR_EraseRootFromParent_Done,
     /* 212217 */   // Label 4035: @212217
     /* 212217 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(212254), // Rule ID 11758 //
     /* 212222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 212230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1993:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 212246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212252 */     GIR_RootConstrainSelectedInstOperands,
     /* 212253 */     // GIR_Coverage, 11758,
     /* 212253 */     GIR_EraseRootFromParent_Done,
     /* 212254 */   // Label 4036: @212254
     /* 212254 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(212291), // Rule ID 11759 //
     /* 212259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 212267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1993:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 212283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212289 */     GIR_RootConstrainSelectedInstOperands,
     /* 212290 */     // GIR_Coverage, 11759,
     /* 212290 */     GIR_EraseRootFromParent_Done,
     /* 212291 */   // Label 4037: @212291
     /* 212291 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(212328), // Rule ID 11760 //
     /* 212296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 212304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212317 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1993:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 212320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212326 */     GIR_RootConstrainSelectedInstOperands,
     /* 212327 */     // GIR_Coverage, 11760,
     /* 212327 */     GIR_EraseRootFromParent_Done,
     /* 212328 */   // Label 4038: @212328
     /* 212328 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(212365), // Rule ID 11761 //
     /* 212333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 212341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212354 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1995:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 212357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212363 */     GIR_RootConstrainSelectedInstOperands,
     /* 212364 */     // GIR_Coverage, 11761,
     /* 212364 */     GIR_EraseRootFromParent_Done,
     /* 212365 */   // Label 4039: @212365
     /* 212365 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(212402), // Rule ID 11762 //
     /* 212370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 212378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212391 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 212394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212400 */     GIR_RootConstrainSelectedInstOperands,
     /* 212401 */     // GIR_Coverage, 11762,
     /* 212401 */     GIR_EraseRootFromParent_Done,
     /* 212402 */   // Label 4040: @212402
     /* 212402 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(212439), // Rule ID 11763 //
     /* 212407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 212415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212428 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 212431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212437 */     GIR_RootConstrainSelectedInstOperands,
     /* 212438 */     // GIR_Coverage, 11763,
     /* 212438 */     GIR_EraseRootFromParent_Done,
     /* 212439 */   // Label 4041: @212439
     /* 212439 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(212476), // Rule ID 11764 //
     /* 212444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 212452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212465 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1633:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 212468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212474 */     GIR_RootConstrainSelectedInstOperands,
     /* 212475 */     // GIR_Coverage, 11764,
     /* 212475 */     GIR_EraseRootFromParent_Done,
     /* 212476 */   // Label 4042: @212476
     /* 212476 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(212513), // Rule ID 11765 //
     /* 212481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 212489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1633:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 212505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212511 */     GIR_RootConstrainSelectedInstOperands,
     /* 212512 */     // GIR_Coverage, 11765,
     /* 212512 */     GIR_EraseRootFromParent_Done,
     /* 212513 */   // Label 4043: @212513
     /* 212513 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(212550), // Rule ID 11866 //
     /* 212518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 212526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212539 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1663:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 212542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212548 */     GIR_RootConstrainSelectedInstOperands,
     /* 212549 */     // GIR_Coverage, 11866,
     /* 212549 */     GIR_EraseRootFromParent_Done,
     /* 212550 */   // Label 4044: @212550
     /* 212550 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(212587), // Rule ID 11867 //
     /* 212555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 212563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212576 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1663:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 212579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212585 */     GIR_RootConstrainSelectedInstOperands,
     /* 212586 */     // GIR_Coverage, 11867,
     /* 212586 */     GIR_EraseRootFromParent_Done,
     /* 212587 */   // Label 4045: @212587
     /* 212587 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(212624), // Rule ID 11868 //
     /* 212592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 212600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212613 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1663:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 212616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212622 */     GIR_RootConstrainSelectedInstOperands,
     /* 212623 */     // GIR_Coverage, 11868,
     /* 212623 */     GIR_EraseRootFromParent_Done,
     /* 212624 */   // Label 4046: @212624
     /* 212624 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(212661), // Rule ID 11869 //
     /* 212629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 212637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212650 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1904:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 212653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212659 */     GIR_RootConstrainSelectedInstOperands,
     /* 212660 */     // GIR_Coverage, 11869,
     /* 212660 */     GIR_EraseRootFromParent_Done,
     /* 212661 */   // Label 4047: @212661
     /* 212661 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(212698), // Rule ID 11870 //
     /* 212666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 212674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212687 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1904:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 212690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212696 */     GIR_RootConstrainSelectedInstOperands,
     /* 212697 */     // GIR_Coverage, 11870,
     /* 212697 */     GIR_EraseRootFromParent_Done,
     /* 212698 */   // Label 4048: @212698
     /* 212698 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(212735), // Rule ID 11871 //
     /* 212703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 212711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1904:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 212727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212733 */     GIR_RootConstrainSelectedInstOperands,
     /* 212734 */     // GIR_Coverage, 11871,
     /* 212734 */     GIR_EraseRootFromParent_Done,
     /* 212735 */   // Label 4049: @212735
     /* 212735 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(212772), // Rule ID 11872 //
     /* 212740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 212748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212761 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1679:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 212764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212770 */     GIR_RootConstrainSelectedInstOperands,
     /* 212771 */     // GIR_Coverage, 11872,
     /* 212771 */     GIR_EraseRootFromParent_Done,
     /* 212772 */   // Label 4050: @212772
     /* 212772 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(212809), // Rule ID 11873 //
     /* 212777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 212785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212798 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1679:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 212801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212807 */     GIR_RootConstrainSelectedInstOperands,
     /* 212808 */     // GIR_Coverage, 11873,
     /* 212808 */     GIR_EraseRootFromParent_Done,
     /* 212809 */   // Label 4051: @212809
     /* 212809 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(212846), // Rule ID 11874 //
     /* 212814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 212822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1679:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 212838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212844 */     GIR_RootConstrainSelectedInstOperands,
     /* 212845 */     // GIR_Coverage, 11874,
     /* 212845 */     GIR_EraseRootFromParent_Done,
     /* 212846 */   // Label 4052: @212846
     /* 212846 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(212883), // Rule ID 11890 //
     /* 212851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 212859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212872 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2046:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 212875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212881 */     GIR_RootConstrainSelectedInstOperands,
     /* 212882 */     // GIR_Coverage, 11890,
     /* 212882 */     GIR_EraseRootFromParent_Done,
     /* 212883 */   // Label 4053: @212883
     /* 212883 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(212920), // Rule ID 11891 //
     /* 212888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 212896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2046:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 212912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212918 */     GIR_RootConstrainSelectedInstOperands,
     /* 212919 */     // GIR_Coverage, 11891,
     /* 212919 */     GIR_EraseRootFromParent_Done,
     /* 212920 */   // Label 4054: @212920
     /* 212920 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(212957), // Rule ID 11892 //
     /* 212925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 212933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 212949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212955 */     GIR_RootConstrainSelectedInstOperands,
     /* 212956 */     // GIR_Coverage, 11892,
     /* 212956 */     GIR_EraseRootFromParent_Done,
     /* 212957 */   // Label 4055: @212957
     /* 212957 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(212994), // Rule ID 11893 //
     /* 212962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 212970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212983 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1855:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 212986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212992 */     GIR_RootConstrainSelectedInstOperands,
     /* 212993 */     // GIR_Coverage, 11893,
     /* 212993 */     GIR_EraseRootFromParent_Done,
     /* 212994 */   // Label 4056: @212994
     /* 212994 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(213031), // Rule ID 11894 //
     /* 212999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 213007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1855:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 213023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213029 */     GIR_RootConstrainSelectedInstOperands,
     /* 213030 */     // GIR_Coverage, 11894,
     /* 213030 */     GIR_EraseRootFromParent_Done,
     /* 213031 */   // Label 4057: @213031
     /* 213031 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(213068), // Rule ID 11895 //
     /* 213036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 213044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213057 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1855:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 213060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213066 */     GIR_RootConstrainSelectedInstOperands,
     /* 213067 */     // GIR_Coverage, 11895,
     /* 213067 */     GIR_EraseRootFromParent_Done,
     /* 213068 */   // Label 4058: @213068
     /* 213068 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(213105), // Rule ID 11911 //
     /* 213073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 213081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213094 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1869:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 213097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213103 */     GIR_RootConstrainSelectedInstOperands,
     /* 213104 */     // GIR_Coverage, 11911,
     /* 213104 */     GIR_EraseRootFromParent_Done,
     /* 213105 */   // Label 4059: @213105
     /* 213105 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(213142), // Rule ID 11912 //
     /* 213110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 213118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213131 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1869:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 213134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213140 */     GIR_RootConstrainSelectedInstOperands,
     /* 213141 */     // GIR_Coverage, 11912,
     /* 213141 */     GIR_EraseRootFromParent_Done,
     /* 213142 */   // Label 4060: @213142
     /* 213142 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(213179), // Rule ID 11913 //
     /* 213147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 213155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1869:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 213171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213177 */     GIR_RootConstrainSelectedInstOperands,
     /* 213178 */     // GIR_Coverage, 11913,
     /* 213178 */     GIR_EraseRootFromParent_Done,
     /* 213179 */   // Label 4061: @213179
     /* 213179 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(213216), // Rule ID 11914 //
     /* 213184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 213192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213205 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1871:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 213208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213214 */     GIR_RootConstrainSelectedInstOperands,
     /* 213215 */     // GIR_Coverage, 11914,
     /* 213215 */     GIR_EraseRootFromParent_Done,
     /* 213216 */   // Label 4062: @213216
     /* 213216 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(213253), // Rule ID 11915 //
     /* 213221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 213229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1871:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 213245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213251 */     GIR_RootConstrainSelectedInstOperands,
     /* 213252 */     // GIR_Coverage, 11915,
     /* 213252 */     GIR_EraseRootFromParent_Done,
     /* 213253 */   // Label 4063: @213253
     /* 213253 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(213290), // Rule ID 11916 //
     /* 213258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 213266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213279 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1871:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 213282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213288 */     GIR_RootConstrainSelectedInstOperands,
     /* 213289 */     // GIR_Coverage, 11916,
     /* 213289 */     GIR_EraseRootFromParent_Done,
     /* 213290 */   // Label 4064: @213290
     /* 213290 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(213330), // Rule ID 12003 //
     /* 213295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 213303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 213306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213316 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2091:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 213319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213328 */     GIR_RootConstrainSelectedInstOperands,
     /* 213329 */     // GIR_Coverage, 12003,
     /* 213329 */     GIR_EraseRootFromParent_Done,
     /* 213330 */   // Label 4065: @213330
     /* 213330 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(213370), // Rule ID 12004 //
     /* 213335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 213343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 213346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213356 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2091:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 213359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213368 */     GIR_RootConstrainSelectedInstOperands,
     /* 213369 */     // GIR_Coverage, 12004,
     /* 213369 */     GIR_EraseRootFromParent_Done,
     /* 213370 */   // Label 4066: @213370
     /* 213370 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(213410), // Rule ID 12005 //
     /* 213375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 213383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 213386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213396 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2091:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 213399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213408 */     GIR_RootConstrainSelectedInstOperands,
     /* 213409 */     // GIR_Coverage, 12005,
     /* 213409 */     GIR_EraseRootFromParent_Done,
     /* 213410 */   // Label 4067: @213410
     /* 213410 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(213450), // Rule ID 12006 //
     /* 213415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 213423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 213426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213436 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2091:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 213439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213448 */     GIR_RootConstrainSelectedInstOperands,
     /* 213449 */     // GIR_Coverage, 12006,
     /* 213449 */     GIR_EraseRootFromParent_Done,
     /* 213450 */   // Label 4068: @213450
     /* 213450 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(213490), // Rule ID 12007 //
     /* 213455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 213463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 213466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213476 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 213479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213488 */     GIR_RootConstrainSelectedInstOperands,
     /* 213489 */     // GIR_Coverage, 12007,
     /* 213489 */     GIR_EraseRootFromParent_Done,
     /* 213490 */   // Label 4069: @213490
     /* 213490 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(213530), // Rule ID 12008 //
     /* 213495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 213503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 213506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213516 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 213519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213528 */     GIR_RootConstrainSelectedInstOperands,
     /* 213529 */     // GIR_Coverage, 12008,
     /* 213529 */     GIR_EraseRootFromParent_Done,
     /* 213530 */   // Label 4070: @213530
     /* 213530 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(213570), // Rule ID 12009 //
     /* 213535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 213543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 213546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213556 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 213559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213568 */     GIR_RootConstrainSelectedInstOperands,
     /* 213569 */     // GIR_Coverage, 12009,
     /* 213569 */     GIR_EraseRootFromParent_Done,
     /* 213570 */   // Label 4071: @213570
     /* 213570 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(213610), // Rule ID 12010 //
     /* 213575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 213583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 213586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213596 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 213599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213608 */     GIR_RootConstrainSelectedInstOperands,
     /* 213609 */     // GIR_Coverage, 12010,
     /* 213609 */     GIR_EraseRootFromParent_Done,
     /* 213610 */   // Label 4072: @213610
     /* 213610 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(213650), // Rule ID 12015 //
     /* 213615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 213623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 213626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213636 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 213639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213648 */     GIR_RootConstrainSelectedInstOperands,
     /* 213649 */     // GIR_Coverage, 12015,
     /* 213649 */     GIR_EraseRootFromParent_Done,
     /* 213650 */   // Label 4073: @213650
     /* 213650 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(213690), // Rule ID 12016 //
     /* 213655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 213663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 213666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213676 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 213679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213688 */     GIR_RootConstrainSelectedInstOperands,
     /* 213689 */     // GIR_Coverage, 12016,
     /* 213689 */     GIR_EraseRootFromParent_Done,
     /* 213690 */   // Label 4074: @213690
     /* 213690 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(213730), // Rule ID 12017 //
     /* 213695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 213703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 213706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213716 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 213719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213728 */     GIR_RootConstrainSelectedInstOperands,
     /* 213729 */     // GIR_Coverage, 12017,
     /* 213729 */     GIR_EraseRootFromParent_Done,
     /* 213730 */   // Label 4075: @213730
     /* 213730 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(213770), // Rule ID 12018 //
     /* 213735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 213743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 213746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213756 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 213759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213768 */     GIR_RootConstrainSelectedInstOperands,
     /* 213769 */     // GIR_Coverage, 12018,
     /* 213769 */     GIR_EraseRootFromParent_Done,
     /* 213770 */   // Label 4076: @213770
     /* 213770 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(213810), // Rule ID 12019 //
     /* 213775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 213783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 213786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213796 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 213799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213808 */     GIR_RootConstrainSelectedInstOperands,
     /* 213809 */     // GIR_Coverage, 12019,
     /* 213809 */     GIR_EraseRootFromParent_Done,
     /* 213810 */   // Label 4077: @213810
     /* 213810 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(213850), // Rule ID 12020 //
     /* 213815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 213823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 213826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213836 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 213839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213848 */     GIR_RootConstrainSelectedInstOperands,
     /* 213849 */     // GIR_Coverage, 12020,
     /* 213849 */     GIR_EraseRootFromParent_Done,
     /* 213850 */   // Label 4078: @213850
     /* 213850 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(213890), // Rule ID 12021 //
     /* 213855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 213863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 213866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213876 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 213879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213888 */     GIR_RootConstrainSelectedInstOperands,
     /* 213889 */     // GIR_Coverage, 12021,
     /* 213889 */     GIR_EraseRootFromParent_Done,
     /* 213890 */   // Label 4079: @213890
     /* 213890 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(213930), // Rule ID 12022 //
     /* 213895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 213903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 213906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213916 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 213919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213928 */     GIR_RootConstrainSelectedInstOperands,
     /* 213929 */     // GIR_Coverage, 12022,
     /* 213929 */     GIR_EraseRootFromParent_Done,
     /* 213930 */   // Label 4080: @213930
     /* 213930 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(213970), // Rule ID 12027 //
     /* 213935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 213943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 213946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 213949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 213952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213956 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2091:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 213959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213968 */     GIR_RootConstrainSelectedInstOperands,
     /* 213969 */     // GIR_Coverage, 12027,
     /* 213969 */     GIR_EraseRootFromParent_Done,
     /* 213970 */   // Label 4081: @213970
     /* 213970 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(214010), // Rule ID 12028 //
     /* 213975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 213983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 213986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 213989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 213992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213996 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2091:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 213999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214008 */     GIR_RootConstrainSelectedInstOperands,
     /* 214009 */     // GIR_Coverage, 12028,
     /* 214009 */     GIR_EraseRootFromParent_Done,
     /* 214010 */   // Label 4082: @214010
     /* 214010 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(214050), // Rule ID 12029 //
     /* 214015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 214023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 214026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214036 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2091:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 214039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214048 */     GIR_RootConstrainSelectedInstOperands,
     /* 214049 */     // GIR_Coverage, 12029,
     /* 214049 */     GIR_EraseRootFromParent_Done,
     /* 214050 */   // Label 4083: @214050
     /* 214050 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(214090), // Rule ID 12030 //
     /* 214055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 214063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 214066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214076 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2091:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 214079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214088 */     GIR_RootConstrainSelectedInstOperands,
     /* 214089 */     // GIR_Coverage, 12030,
     /* 214089 */     GIR_EraseRootFromParent_Done,
     /* 214090 */   // Label 4084: @214090
     /* 214090 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(214130), // Rule ID 12031 //
     /* 214095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 214103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 214106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214116 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 214119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214128 */     GIR_RootConstrainSelectedInstOperands,
     /* 214129 */     // GIR_Coverage, 12031,
     /* 214129 */     GIR_EraseRootFromParent_Done,
     /* 214130 */   // Label 4085: @214130
     /* 214130 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(214170), // Rule ID 12032 //
     /* 214135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 214143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 214146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214156 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 214159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214168 */     GIR_RootConstrainSelectedInstOperands,
     /* 214169 */     // GIR_Coverage, 12032,
     /* 214169 */     GIR_EraseRootFromParent_Done,
     /* 214170 */   // Label 4086: @214170
     /* 214170 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(214210), // Rule ID 12033 //
     /* 214175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 214183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 214186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214196 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 214199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214208 */     GIR_RootConstrainSelectedInstOperands,
     /* 214209 */     // GIR_Coverage, 12033,
     /* 214209 */     GIR_EraseRootFromParent_Done,
     /* 214210 */   // Label 4087: @214210
     /* 214210 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(214250), // Rule ID 12034 //
     /* 214215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 214223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 214226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214236 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 214239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214248 */     GIR_RootConstrainSelectedInstOperands,
     /* 214249 */     // GIR_Coverage, 12034,
     /* 214249 */     GIR_EraseRootFromParent_Done,
     /* 214250 */   // Label 4088: @214250
     /* 214250 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(214290), // Rule ID 12039 //
     /* 214255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 214263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 214266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214276 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 214279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214288 */     GIR_RootConstrainSelectedInstOperands,
     /* 214289 */     // GIR_Coverage, 12039,
     /* 214289 */     GIR_EraseRootFromParent_Done,
     /* 214290 */   // Label 4089: @214290
     /* 214290 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(214330), // Rule ID 12040 //
     /* 214295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 214303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 214306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214316 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 214319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214328 */     GIR_RootConstrainSelectedInstOperands,
     /* 214329 */     // GIR_Coverage, 12040,
     /* 214329 */     GIR_EraseRootFromParent_Done,
     /* 214330 */   // Label 4090: @214330
     /* 214330 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(214370), // Rule ID 12041 //
     /* 214335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 214343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 214346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214356 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 214359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214368 */     GIR_RootConstrainSelectedInstOperands,
     /* 214369 */     // GIR_Coverage, 12041,
     /* 214369 */     GIR_EraseRootFromParent_Done,
     /* 214370 */   // Label 4091: @214370
     /* 214370 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(214410), // Rule ID 12042 //
     /* 214375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 214383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 214386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214396 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 214399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214408 */     GIR_RootConstrainSelectedInstOperands,
     /* 214409 */     // GIR_Coverage, 12042,
     /* 214409 */     GIR_EraseRootFromParent_Done,
     /* 214410 */   // Label 4092: @214410
     /* 214410 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(214450), // Rule ID 12043 //
     /* 214415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 214423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 214426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214436 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 214439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214448 */     GIR_RootConstrainSelectedInstOperands,
     /* 214449 */     // GIR_Coverage, 12043,
     /* 214449 */     GIR_EraseRootFromParent_Done,
     /* 214450 */   // Label 4093: @214450
     /* 214450 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(214490), // Rule ID 12044 //
     /* 214455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 214463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 214466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214476 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 214479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214488 */     GIR_RootConstrainSelectedInstOperands,
     /* 214489 */     // GIR_Coverage, 12044,
     /* 214489 */     GIR_EraseRootFromParent_Done,
     /* 214490 */   // Label 4094: @214490
     /* 214490 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(214530), // Rule ID 12045 //
     /* 214495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 214503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 214506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214516 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 214519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214528 */     GIR_RootConstrainSelectedInstOperands,
     /* 214529 */     // GIR_Coverage, 12045,
     /* 214529 */     GIR_EraseRootFromParent_Done,
     /* 214530 */   // Label 4095: @214530
     /* 214530 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(214570), // Rule ID 12046 //
     /* 214535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 214543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 214546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214556 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 214559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214568 */     GIR_RootConstrainSelectedInstOperands,
     /* 214569 */     // GIR_Coverage, 12046,
     /* 214569 */     GIR_EraseRootFromParent_Done,
     /* 214570 */   // Label 4096: @214570
     /* 214570 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(214607), // Rule ID 12055 //
     /* 214575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 214578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 214583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214596 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1259:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 214599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214605 */     GIR_RootConstrainSelectedInstOperands,
     /* 214606 */     // GIR_Coverage, 12055,
     /* 214606 */     GIR_EraseRootFromParent_Done,
     /* 214607 */   // Label 4097: @214607
     /* 214607 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(214644), // Rule ID 12057 //
     /* 214612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 214615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 214620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214633 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1633:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 214636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214642 */     GIR_RootConstrainSelectedInstOperands,
     /* 214643 */     // GIR_Coverage, 12057,
     /* 214643 */     GIR_EraseRootFromParent_Done,
     /* 214644 */   // Label 4098: @214644
     /* 214644 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(214681), // Rule ID 12058 //
     /* 214649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 214652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 214657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214670 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1724:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 214673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214679 */     GIR_RootConstrainSelectedInstOperands,
     /* 214680 */     // GIR_Coverage, 12058,
     /* 214680 */     GIR_EraseRootFromParent_Done,
     /* 214681 */   // Label 4099: @214681
     /* 214681 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(214718), // Rule ID 12059 //
     /* 214686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 214689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 214694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214707 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1665:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 214710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214716 */     GIR_RootConstrainSelectedInstOperands,
     /* 214717 */     // GIR_Coverage, 12059,
     /* 214717 */     GIR_EraseRootFromParent_Done,
     /* 214718 */   // Label 4100: @214718
     /* 214718 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(214755), // Rule ID 12060 //
     /* 214723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 214726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 214731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214744 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1273:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 214747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214753 */     GIR_RootConstrainSelectedInstOperands,
     /* 214754 */     // GIR_Coverage, 12060,
     /* 214754 */     GIR_EraseRootFromParent_Done,
     /* 214755 */   // Label 4101: @214755
     /* 214755 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(214792), // Rule ID 12061 //
     /* 214760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 214763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 214768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214781 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1273:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 214784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214790 */     GIR_RootConstrainSelectedInstOperands,
     /* 214791 */     // GIR_Coverage, 12061,
     /* 214791 */     GIR_EraseRootFromParent_Done,
     /* 214792 */   // Label 4102: @214792
     /* 214792 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(214829), // Rule ID 12062 //
     /* 214797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 214800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 214805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1273:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 214821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214827 */     GIR_RootConstrainSelectedInstOperands,
     /* 214828 */     // GIR_Coverage, 12062,
     /* 214828 */     GIR_EraseRootFromParent_Done,
     /* 214829 */   // Label 4103: @214829
     /* 214829 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(214866), // Rule ID 12063 //
     /* 214834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 214837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 214842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214855 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1273:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 214858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214864 */     GIR_RootConstrainSelectedInstOperands,
     /* 214865 */     // GIR_Coverage, 12063,
     /* 214865 */     GIR_EraseRootFromParent_Done,
     /* 214866 */   // Label 4104: @214866
     /* 214866 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(214903), // Rule ID 12064 //
     /* 214871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 214874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 214879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214892 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1290:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 214895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214901 */     GIR_RootConstrainSelectedInstOperands,
     /* 214902 */     // GIR_Coverage, 12064,
     /* 214902 */     GIR_EraseRootFromParent_Done,
     /* 214903 */   // Label 4105: @214903
     /* 214903 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(214940), // Rule ID 12065 //
     /* 214908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 214911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 214916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214929 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1290:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 214932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214938 */     GIR_RootConstrainSelectedInstOperands,
     /* 214939 */     // GIR_Coverage, 12065,
     /* 214939 */     GIR_EraseRootFromParent_Done,
     /* 214940 */   // Label 4106: @214940
     /* 214940 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(214977), // Rule ID 12066 //
     /* 214945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 214948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 214953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214966 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1290:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 214969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214975 */     GIR_RootConstrainSelectedInstOperands,
     /* 214976 */     // GIR_Coverage, 12066,
     /* 214976 */     GIR_EraseRootFromParent_Done,
     /* 214977 */   // Label 4107: @214977
     /* 214977 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(215014), // Rule ID 12067 //
     /* 214982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 214985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 214990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215003 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1290:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 215006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215012 */     GIR_RootConstrainSelectedInstOperands,
     /* 215013 */     // GIR_Coverage, 12067,
     /* 215013 */     GIR_EraseRootFromParent_Done,
     /* 215014 */   // Label 4108: @215014
     /* 215014 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(215051), // Rule ID 12180 //
     /* 215019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 215027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215040 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1439:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 215040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 215043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215049 */     GIR_RootConstrainSelectedInstOperands,
     /* 215050 */     // GIR_Coverage, 12180,
     /* 215050 */     GIR_EraseRootFromParent_Done,
     /* 215051 */   // Label 4109: @215051
     /* 215051 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(215088), // Rule ID 12181 //
     /* 215056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 215064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215077 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1439:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 215077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 215080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215086 */     GIR_RootConstrainSelectedInstOperands,
     /* 215087 */     // GIR_Coverage, 12181,
     /* 215087 */     GIR_EraseRootFromParent_Done,
     /* 215088 */   // Label 4110: @215088
     /* 215088 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(215125), // Rule ID 12182 //
     /* 215093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 215101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215114 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1439:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 215114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 215117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215123 */     GIR_RootConstrainSelectedInstOperands,
     /* 215124 */     // GIR_Coverage, 12182,
     /* 215124 */     GIR_EraseRootFromParent_Done,
     /* 215125 */   // Label 4111: @215125
     /* 215125 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(215162), // Rule ID 12183 //
     /* 215130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 215138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215151 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1457:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 215151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 215154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215160 */     GIR_RootConstrainSelectedInstOperands,
     /* 215161 */     // GIR_Coverage, 12183,
     /* 215161 */     GIR_EraseRootFromParent_Done,
     /* 215162 */   // Label 4112: @215162
     /* 215162 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(215199), // Rule ID 12184 //
     /* 215167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 215175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215188 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1457:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 215188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 215191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215197 */     GIR_RootConstrainSelectedInstOperands,
     /* 215198 */     // GIR_Coverage, 12184,
     /* 215198 */     GIR_EraseRootFromParent_Done,
     /* 215199 */   // Label 4113: @215199
     /* 215199 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(215236), // Rule ID 12185 //
     /* 215204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 215212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215225 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1457:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 215225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 215228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215234 */     GIR_RootConstrainSelectedInstOperands,
     /* 215235 */     // GIR_Coverage, 12185,
     /* 215235 */     GIR_EraseRootFromParent_Done,
     /* 215236 */   // Label 4114: @215236
     /* 215236 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(215273), // Rule ID 12186 //
     /* 215241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 215249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215262 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1442:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 215262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 215265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215271 */     GIR_RootConstrainSelectedInstOperands,
     /* 215272 */     // GIR_Coverage, 12186,
     /* 215272 */     GIR_EraseRootFromParent_Done,
     /* 215273 */   // Label 4115: @215273
     /* 215273 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(215310), // Rule ID 12187 //
     /* 215278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 215286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215299 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1442:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 215299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 215302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215308 */     GIR_RootConstrainSelectedInstOperands,
     /* 215309 */     // GIR_Coverage, 12187,
     /* 215309 */     GIR_EraseRootFromParent_Done,
     /* 215310 */   // Label 4116: @215310
     /* 215310 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(215347), // Rule ID 12188 //
     /* 215315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 215323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215336 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1442:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 215336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 215339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215345 */     GIR_RootConstrainSelectedInstOperands,
     /* 215346 */     // GIR_Coverage, 12188,
     /* 215346 */     GIR_EraseRootFromParent_Done,
     /* 215347 */   // Label 4117: @215347
     /* 215347 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(215384), // Rule ID 12189 //
     /* 215352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 215360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215373 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1460:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 215373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 215376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215382 */     GIR_RootConstrainSelectedInstOperands,
     /* 215383 */     // GIR_Coverage, 12189,
     /* 215383 */     GIR_EraseRootFromParent_Done,
     /* 215384 */   // Label 4118: @215384
     /* 215384 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(215421), // Rule ID 12190 //
     /* 215389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 215397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215410 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1460:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 215410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 215413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215419 */     GIR_RootConstrainSelectedInstOperands,
     /* 215420 */     // GIR_Coverage, 12190,
     /* 215420 */     GIR_EraseRootFromParent_Done,
     /* 215421 */   // Label 4119: @215421
     /* 215421 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(215458), // Rule ID 12191 //
     /* 215426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 215434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215447 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1460:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 215447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 215450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215456 */     GIR_RootConstrainSelectedInstOperands,
     /* 215457 */     // GIR_Coverage, 12191,
     /* 215457 */     GIR_EraseRootFromParent_Done,
     /* 215458 */   // Label 4120: @215458
     /* 215458 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(215495), // Rule ID 12192 //
     /* 215463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 215471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215484 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1354:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 215487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215493 */     GIR_RootConstrainSelectedInstOperands,
     /* 215494 */     // GIR_Coverage, 12192,
     /* 215494 */     GIR_EraseRootFromParent_Done,
     /* 215495 */   // Label 4121: @215495
     /* 215495 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(215532), // Rule ID 12193 //
     /* 215500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 215508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215521 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1354:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 215524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215530 */     GIR_RootConstrainSelectedInstOperands,
     /* 215531 */     // GIR_Coverage, 12193,
     /* 215531 */     GIR_EraseRootFromParent_Done,
     /* 215532 */   // Label 4122: @215532
     /* 215532 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(215569), // Rule ID 12194 //
     /* 215537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 215545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215558 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1354:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 215561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215567 */     GIR_RootConstrainSelectedInstOperands,
     /* 215568 */     // GIR_Coverage, 12194,
     /* 215568 */     GIR_EraseRootFromParent_Done,
     /* 215569 */   // Label 4123: @215569
     /* 215569 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(215606), // Rule ID 12195 //
     /* 215574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 215582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215595 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1354:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 215598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215604 */     GIR_RootConstrainSelectedInstOperands,
     /* 215605 */     // GIR_Coverage, 12195,
     /* 215605 */     GIR_EraseRootFromParent_Done,
     /* 215606 */   // Label 4124: @215606
     /* 215606 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(215643), // Rule ID 12196 //
     /* 215611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 215619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215632 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1266:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 215635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215641 */     GIR_RootConstrainSelectedInstOperands,
     /* 215642 */     // GIR_Coverage, 12196,
     /* 215642 */     GIR_EraseRootFromParent_Done,
     /* 215643 */   // Label 4125: @215643
     /* 215643 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(215680), // Rule ID 12197 //
     /* 215648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 215656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215669 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1266:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 215672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215678 */     GIR_RootConstrainSelectedInstOperands,
     /* 215679 */     // GIR_Coverage, 12197,
     /* 215679 */     GIR_EraseRootFromParent_Done,
     /* 215680 */   // Label 4126: @215680
     /* 215680 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(215717), // Rule ID 12198 //
     /* 215685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 215693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215706 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1266:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 215709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215715 */     GIR_RootConstrainSelectedInstOperands,
     /* 215716 */     // GIR_Coverage, 12198,
     /* 215716 */     GIR_EraseRootFromParent_Done,
     /* 215717 */   // Label 4127: @215717
     /* 215717 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(215754), // Rule ID 12199 //
     /* 215722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 215730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215743 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1266:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 215746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215752 */     GIR_RootConstrainSelectedInstOperands,
     /* 215753 */     // GIR_Coverage, 12199,
     /* 215753 */     GIR_EraseRootFromParent_Done,
     /* 215754 */   // Label 4128: @215754
     /* 215754 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(215791), // Rule ID 12200 //
     /* 215759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 215767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215780 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1254:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 215783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215789 */     GIR_RootConstrainSelectedInstOperands,
     /* 215790 */     // GIR_Coverage, 12200,
     /* 215790 */     GIR_EraseRootFromParent_Done,
     /* 215791 */   // Label 4129: @215791
     /* 215791 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(215828), // Rule ID 12201 //
     /* 215796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 215804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215817 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1254:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 215820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215826 */     GIR_RootConstrainSelectedInstOperands,
     /* 215827 */     // GIR_Coverage, 12201,
     /* 215827 */     GIR_EraseRootFromParent_Done,
     /* 215828 */   // Label 4130: @215828
     /* 215828 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(215865), // Rule ID 12202 //
     /* 215833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 215841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215854 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1254:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 215857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215863 */     GIR_RootConstrainSelectedInstOperands,
     /* 215864 */     // GIR_Coverage, 12202,
     /* 215864 */     GIR_EraseRootFromParent_Done,
     /* 215865 */   // Label 4131: @215865
     /* 215865 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(215902), // Rule ID 12203 //
     /* 215870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 215878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215891 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1254:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 215894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215900 */     GIR_RootConstrainSelectedInstOperands,
     /* 215901 */     // GIR_Coverage, 12203,
     /* 215901 */     GIR_EraseRootFromParent_Done,
     /* 215902 */   // Label 4132: @215902
     /* 215902 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(215939), // Rule ID 12204 //
     /* 215907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 215915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215928 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1733:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 215931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215937 */     GIR_RootConstrainSelectedInstOperands,
     /* 215938 */     // GIR_Coverage, 12204,
     /* 215938 */     GIR_EraseRootFromParent_Done,
     /* 215939 */   // Label 4133: @215939
     /* 215939 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(215976), // Rule ID 12205 //
     /* 215944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 215952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215965 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1733:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 215968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215974 */     GIR_RootConstrainSelectedInstOperands,
     /* 215975 */     // GIR_Coverage, 12205,
     /* 215975 */     GIR_EraseRootFromParent_Done,
     /* 215976 */   // Label 4134: @215976
     /* 215976 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(216013), // Rule ID 12206 //
     /* 215981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 215989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216002 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1733:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 216002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 216005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216011 */     GIR_RootConstrainSelectedInstOperands,
     /* 216012 */     // GIR_Coverage, 12206,
     /* 216012 */     GIR_EraseRootFromParent_Done,
     /* 216013 */   // Label 4135: @216013
     /* 216013 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(216050), // Rule ID 12207 //
     /* 216018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 216026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216039 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1733:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 216039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 216042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216048 */     GIR_RootConstrainSelectedInstOperands,
     /* 216049 */     // GIR_Coverage, 12207,
     /* 216049 */     GIR_EraseRootFromParent_Done,
     /* 216050 */   // Label 4136: @216050
     /* 216050 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(216087), // Rule ID 12208 //
     /* 216055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 216063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216076 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1971:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 216076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 216079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216085 */     GIR_RootConstrainSelectedInstOperands,
     /* 216086 */     // GIR_Coverage, 12208,
     /* 216086 */     GIR_EraseRootFromParent_Done,
     /* 216087 */   // Label 4137: @216087
     /* 216087 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(216124), // Rule ID 12209 //
     /* 216092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 216100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216113 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1971:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 216113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 216116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216122 */     GIR_RootConstrainSelectedInstOperands,
     /* 216123 */     // GIR_Coverage, 12209,
     /* 216123 */     GIR_EraseRootFromParent_Done,
     /* 216124 */   // Label 4138: @216124
     /* 216124 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(216161), // Rule ID 12210 //
     /* 216129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 216137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216150 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1971:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 216150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 216153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216159 */     GIR_RootConstrainSelectedInstOperands,
     /* 216160 */     // GIR_Coverage, 12210,
     /* 216160 */     GIR_EraseRootFromParent_Done,
     /* 216161 */   // Label 4139: @216161
     /* 216161 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(216198), // Rule ID 12211 //
     /* 216166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 216174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216187 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1971:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 216187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 216190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216196 */     GIR_RootConstrainSelectedInstOperands,
     /* 216197 */     // GIR_Coverage, 12211,
     /* 216197 */     GIR_EraseRootFromParent_Done,
     /* 216198 */   // Label 4140: @216198
     /* 216198 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(216235), // Rule ID 12212 //
     /* 216203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 216211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216224 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1742:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 216224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 216227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216233 */     GIR_RootConstrainSelectedInstOperands,
     /* 216234 */     // GIR_Coverage, 12212,
     /* 216234 */     GIR_EraseRootFromParent_Done,
     /* 216235 */   // Label 4141: @216235
     /* 216235 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(216272), // Rule ID 12213 //
     /* 216240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 216248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216261 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1742:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 216261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 216264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216270 */     GIR_RootConstrainSelectedInstOperands,
     /* 216271 */     // GIR_Coverage, 12213,
     /* 216271 */     GIR_EraseRootFromParent_Done,
     /* 216272 */   // Label 4142: @216272
     /* 216272 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(216309), // Rule ID 12214 //
     /* 216277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 216285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216298 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1742:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 216298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 216301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216307 */     GIR_RootConstrainSelectedInstOperands,
     /* 216308 */     // GIR_Coverage, 12214,
     /* 216308 */     GIR_EraseRootFromParent_Done,
     /* 216309 */   // Label 4143: @216309
     /* 216309 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(216346), // Rule ID 12215 //
     /* 216314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 216322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216335 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1742:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 216335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 216338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216344 */     GIR_RootConstrainSelectedInstOperands,
     /* 216345 */     // GIR_Coverage, 12215,
     /* 216345 */     GIR_EraseRootFromParent_Done,
     /* 216346 */   // Label 4144: @216346
     /* 216346 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(216383), // Rule ID 12216 //
     /* 216351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 216359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216372 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1980:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 216372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 216375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216381 */     GIR_RootConstrainSelectedInstOperands,
     /* 216382 */     // GIR_Coverage, 12216,
     /* 216382 */     GIR_EraseRootFromParent_Done,
     /* 216383 */   // Label 4145: @216383
     /* 216383 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(216420), // Rule ID 12217 //
     /* 216388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 216396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216409 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1980:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 216409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 216412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216418 */     GIR_RootConstrainSelectedInstOperands,
     /* 216419 */     // GIR_Coverage, 12217,
     /* 216419 */     GIR_EraseRootFromParent_Done,
     /* 216420 */   // Label 4146: @216420
     /* 216420 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(216457), // Rule ID 12218 //
     /* 216425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 216433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216446 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1980:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 216446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 216449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216455 */     GIR_RootConstrainSelectedInstOperands,
     /* 216456 */     // GIR_Coverage, 12218,
     /* 216456 */     GIR_EraseRootFromParent_Done,
     /* 216457 */   // Label 4147: @216457
     /* 216457 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(216494), // Rule ID 12219 //
     /* 216462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 216470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216483 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1980:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 216483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 216486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216492 */     GIR_RootConstrainSelectedInstOperands,
     /* 216493 */     // GIR_Coverage, 12219,
     /* 216493 */     GIR_EraseRootFromParent_Done,
     /* 216494 */   // Label 4148: @216494
     /* 216494 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(216531), // Rule ID 12220 //
     /* 216499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 216507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 216513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216520 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2164:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 216520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 216523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216529 */     GIR_RootConstrainSelectedInstOperands,
     /* 216530 */     // GIR_Coverage, 12220,
     /* 216530 */     GIR_EraseRootFromParent_Done,
     /* 216531 */   // Label 4149: @216531
     /* 216531 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(216568), // Rule ID 12221 //
     /* 216536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 216544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216557 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2164:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 216557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 216560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216566 */     GIR_RootConstrainSelectedInstOperands,
     /* 216567 */     // GIR_Coverage, 12221,
     /* 216567 */     GIR_EraseRootFromParent_Done,
     /* 216568 */   // Label 4150: @216568
     /* 216568 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(216605), // Rule ID 12222 //
     /* 216573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 216581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2164:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 216594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 216597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216603 */     GIR_RootConstrainSelectedInstOperands,
     /* 216604 */     // GIR_Coverage, 12222,
     /* 216604 */     GIR_EraseRootFromParent_Done,
     /* 216605 */   // Label 4151: @216605
     /* 216605 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(216642), // Rule ID 12223 //
     /* 216610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 216618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2164:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 216631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 216634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216640 */     GIR_RootConstrainSelectedInstOperands,
     /* 216641 */     // GIR_Coverage, 12223,
     /* 216641 */     GIR_EraseRootFromParent_Done,
     /* 216642 */   // Label 4152: @216642
     /* 216642 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(216679), // Rule ID 12224 //
     /* 216647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 216655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216668 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2164:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 216668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 216671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216677 */     GIR_RootConstrainSelectedInstOperands,
     /* 216678 */     // GIR_Coverage, 12224,
     /* 216678 */     GIR_EraseRootFromParent_Done,
     /* 216679 */   // Label 4153: @216679
     /* 216679 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(216716), // Rule ID 12225 //
     /* 216684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 216692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216705 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2164:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 216705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 216708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216714 */     GIR_RootConstrainSelectedInstOperands,
     /* 216715 */     // GIR_Coverage, 12225,
     /* 216715 */     GIR_EraseRootFromParent_Done,
     /* 216716 */   // Label 4154: @216716
     /* 216716 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(216753), // Rule ID 12226 //
     /* 216721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 216729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216742 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2164:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 216742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 216745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216751 */     GIR_RootConstrainSelectedInstOperands,
     /* 216752 */     // GIR_Coverage, 12226,
     /* 216752 */     GIR_EraseRootFromParent_Done,
     /* 216753 */   // Label 4155: @216753
     /* 216753 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(216790), // Rule ID 12227 //
     /* 216758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 216766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 216772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216779 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2089:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 216779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 216782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216788 */     GIR_RootConstrainSelectedInstOperands,
     /* 216789 */     // GIR_Coverage, 12227,
     /* 216789 */     GIR_EraseRootFromParent_Done,
     /* 216790 */   // Label 4156: @216790
     /* 216790 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(216827), // Rule ID 12228 //
     /* 216795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 216803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216816 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2089:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 216816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 216819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216825 */     GIR_RootConstrainSelectedInstOperands,
     /* 216826 */     // GIR_Coverage, 12228,
     /* 216826 */     GIR_EraseRootFromParent_Done,
     /* 216827 */   // Label 4157: @216827
     /* 216827 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(216864), // Rule ID 12229 //
     /* 216832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 216840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216853 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2089:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 216853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 216856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216862 */     GIR_RootConstrainSelectedInstOperands,
     /* 216863 */     // GIR_Coverage, 12229,
     /* 216863 */     GIR_EraseRootFromParent_Done,
     /* 216864 */   // Label 4158: @216864
     /* 216864 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(216901), // Rule ID 12230 //
     /* 216869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 216877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216890 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2089:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 216890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 216893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216899 */     GIR_RootConstrainSelectedInstOperands,
     /* 216900 */     // GIR_Coverage, 12230,
     /* 216900 */     GIR_EraseRootFromParent_Done,
     /* 216901 */   // Label 4159: @216901
     /* 216901 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(216938), // Rule ID 12231 //
     /* 216906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 216914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216927 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2089:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 216927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 216930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216936 */     GIR_RootConstrainSelectedInstOperands,
     /* 216937 */     // GIR_Coverage, 12231,
     /* 216937 */     GIR_EraseRootFromParent_Done,
     /* 216938 */   // Label 4160: @216938
     /* 216938 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(216975), // Rule ID 12232 //
     /* 216943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 216951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216964 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2089:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 216964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 216967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216973 */     GIR_RootConstrainSelectedInstOperands,
     /* 216974 */     // GIR_Coverage, 12232,
     /* 216974 */     GIR_EraseRootFromParent_Done,
     /* 216975 */   // Label 4161: @216975
     /* 216975 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(217012), // Rule ID 12233 //
     /* 216980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 216988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217001 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2089:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 217001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 217004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217010 */     GIR_RootConstrainSelectedInstOperands,
     /* 217011 */     // GIR_Coverage, 12233,
     /* 217011 */     GIR_EraseRootFromParent_Done,
     /* 217012 */   // Label 4162: @217012
     /* 217012 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(217049), // Rule ID 12234 //
     /* 217017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 217025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 217031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217038 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2090:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 217038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 217041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217047 */     GIR_RootConstrainSelectedInstOperands,
     /* 217048 */     // GIR_Coverage, 12234,
     /* 217048 */     GIR_EraseRootFromParent_Done,
     /* 217049 */   // Label 4163: @217049
     /* 217049 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(217086), // Rule ID 12235 //
     /* 217054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 217062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217075 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2090:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 217075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 217078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217084 */     GIR_RootConstrainSelectedInstOperands,
     /* 217085 */     // GIR_Coverage, 12235,
     /* 217085 */     GIR_EraseRootFromParent_Done,
     /* 217086 */   // Label 4164: @217086
     /* 217086 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(217123), // Rule ID 12236 //
     /* 217091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 217099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217112 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2090:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 217112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 217115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217121 */     GIR_RootConstrainSelectedInstOperands,
     /* 217122 */     // GIR_Coverage, 12236,
     /* 217122 */     GIR_EraseRootFromParent_Done,
     /* 217123 */   // Label 4165: @217123
     /* 217123 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(217160), // Rule ID 12237 //
     /* 217128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 217136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217149 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2090:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 217149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 217152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217158 */     GIR_RootConstrainSelectedInstOperands,
     /* 217159 */     // GIR_Coverage, 12237,
     /* 217159 */     GIR_EraseRootFromParent_Done,
     /* 217160 */   // Label 4166: @217160
     /* 217160 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(217197), // Rule ID 12238 //
     /* 217165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 217173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217186 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2090:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 217186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 217189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217195 */     GIR_RootConstrainSelectedInstOperands,
     /* 217196 */     // GIR_Coverage, 12238,
     /* 217196 */     GIR_EraseRootFromParent_Done,
     /* 217197 */   // Label 4167: @217197
     /* 217197 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(217234), // Rule ID 12239 //
     /* 217202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 217210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217223 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2090:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 217223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 217226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217232 */     GIR_RootConstrainSelectedInstOperands,
     /* 217233 */     // GIR_Coverage, 12239,
     /* 217233 */     GIR_EraseRootFromParent_Done,
     /* 217234 */   // Label 4168: @217234
     /* 217234 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(217271), // Rule ID 12240 //
     /* 217239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 217247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217260 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2090:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 217260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 217263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217269 */     GIR_RootConstrainSelectedInstOperands,
     /* 217270 */     // GIR_Coverage, 12240,
     /* 217270 */     GIR_EraseRootFromParent_Done,
     /* 217271 */   // Label 4169: @217271
     /* 217271 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(217313), // Rule ID 3218 //
     /* 217276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 217284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217291 */     // MIs[0] Op1
     /* 217291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217295 */     // MIs[0] Op2
     /* 217295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217299 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2143:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 217302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217311 */     GIR_RootConstrainSelectedInstOperands,
     /* 217312 */     // GIR_Coverage, 3218,
     /* 217312 */     GIR_EraseRootFromParent_Done,
     /* 217313 */   // Label 4170: @217313
     /* 217313 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(217355), // Rule ID 3219 //
     /* 217318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 217326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 217329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217333 */     // MIs[0] Op1
     /* 217333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217337 */     // MIs[0] Op2
     /* 217337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217341 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2145:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 217344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217353 */     GIR_RootConstrainSelectedInstOperands,
     /* 217354 */     // GIR_Coverage, 3219,
     /* 217354 */     GIR_EraseRootFromParent_Done,
     /* 217355 */   // Label 4171: @217355
     /* 217355 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(217397), // Rule ID 3220 //
     /* 217360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 217368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 217371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217375 */     // MIs[0] Op1
     /* 217375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217379 */     // MIs[0] Op2
     /* 217379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217383 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2146:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 217386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217395 */     GIR_RootConstrainSelectedInstOperands,
     /* 217396 */     // GIR_Coverage, 3220,
     /* 217396 */     GIR_EraseRootFromParent_Done,
     /* 217397 */   // Label 4172: @217397
     /* 217397 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(217439), // Rule ID 3221 //
     /* 217402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 217410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 217413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217417 */     // MIs[0] Op1
     /* 217417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217421 */     // MIs[0] Op2
     /* 217421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217425 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2144:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 217428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217437 */     GIR_RootConstrainSelectedInstOperands,
     /* 217438 */     // GIR_Coverage, 3221,
     /* 217438 */     GIR_EraseRootFromParent_Done,
     /* 217439 */   // Label 4173: @217439
     /* 217439 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(217481), // Rule ID 12051 //
     /* 217444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 217452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217459 */     // MIs[0] Op1
     /* 217459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217463 */     // MIs[0] Op2
     /* 217463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217467 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 217470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217479 */     GIR_RootConstrainSelectedInstOperands,
     /* 217480 */     // GIR_Coverage, 12051,
     /* 217480 */     GIR_EraseRootFromParent_Done,
     /* 217481 */   // Label 4174: @217481
     /* 217481 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(217523), // Rule ID 12052 //
     /* 217486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 217494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 217497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217501 */     // MIs[0] Op1
     /* 217501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217505 */     // MIs[0] Op2
     /* 217505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217509 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2141:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 217512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217521 */     GIR_RootConstrainSelectedInstOperands,
     /* 217522 */     // GIR_Coverage, 12052,
     /* 217522 */     GIR_EraseRootFromParent_Done,
     /* 217523 */   // Label 4175: @217523
     /* 217523 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(217565), // Rule ID 12053 //
     /* 217528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 217536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 217539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217543 */     // MIs[0] Op1
     /* 217543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217547 */     // MIs[0] Op2
     /* 217547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217551 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 217554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217563 */     GIR_RootConstrainSelectedInstOperands,
     /* 217564 */     // GIR_Coverage, 12053,
     /* 217564 */     GIR_EraseRootFromParent_Done,
     /* 217565 */   // Label 4176: @217565
     /* 217565 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(217607), // Rule ID 12054 //
     /* 217570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 217578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 217581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217585 */     // MIs[0] Op1
     /* 217585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217589 */     // MIs[0] Op2
     /* 217589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217593 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2140:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 217596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217605 */     GIR_RootConstrainSelectedInstOperands,
     /* 217606 */     // GIR_Coverage, 12054,
     /* 217606 */     GIR_EraseRootFromParent_Done,
     /* 217607 */   // Label 4177: @217607
     /* 217607 */   GIM_Reject,
     /* 217608 */ // Label 3232: @217608
     /* 217608 */ GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(260719),
     /* 217613 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 217616 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(217729), // Rule ID 2069 //
     /* 217621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 217624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 217629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 217632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 217635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 217638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 217641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 217661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 217665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 217673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 217677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 217686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217694 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 217698 */     // MIs[3] Operand 1
     /* 217698 */     // No operand predicates
     /* 217698 */     // MIs[1] Operand 2
     /* 217698 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 217709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217711 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 217711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 217714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217727 */     GIR_RootConstrainSelectedInstOperands,
     /* 217728 */     // GIR_Coverage, 2069,
     /* 217728 */     GIR_EraseRootFromParent_Done,
     /* 217729 */   // Label 4179: @217729
     /* 217729 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(217842), // Rule ID 2076 //
     /* 217734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 217737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 217742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 217745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 217748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 217751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 217754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 217774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 217778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 217786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 217790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 217799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217807 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 217811 */     // MIs[3] Operand 1
     /* 217811 */     // No operand predicates
     /* 217811 */     // MIs[1] Operand 2
     /* 217811 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 217822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217824 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 217824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 217827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217840 */     GIR_RootConstrainSelectedInstOperands,
     /* 217841 */     // GIR_Coverage, 2076,
     /* 217841 */     GIR_EraseRootFromParent_Done,
     /* 217842 */   // Label 4180: @217842
     /* 217842 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(217955), // Rule ID 2072 //
     /* 217847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 217850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 217855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 217887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 217891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 217899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 217903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217920 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 217924 */     // MIs[3] Operand 1
     /* 217924 */     // No operand predicates
     /* 217924 */     // MIs[1] Operand 2
     /* 217924 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 217935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217937 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 217937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 217940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217953 */     GIR_RootConstrainSelectedInstOperands,
     /* 217954 */     // GIR_Coverage, 2072,
     /* 217954 */     GIR_EraseRootFromParent_Done,
     /* 217955 */   // Label 4181: @217955
     /* 217955 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(218068), // Rule ID 2079 //
     /* 217960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 217963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 217968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 218000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218033 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 218037 */     // MIs[3] Operand 1
     /* 218037 */     // No operand predicates
     /* 218037 */     // MIs[1] Operand 2
     /* 218037 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 218048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218050 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 218053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218066 */     GIR_RootConstrainSelectedInstOperands,
     /* 218067 */     // GIR_Coverage, 2079,
     /* 218067 */     GIR_EraseRootFromParent_Done,
     /* 218068 */   // Label 4182: @218068
     /* 218068 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(218173), // Rule ID 3869 //
     /* 218073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 218081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 218084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 218087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 218117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218146 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 218150 */     // MIs[3] Operand 1
     /* 218150 */     // No operand predicates
     /* 218150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218152 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 218152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 218155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218171 */     GIR_RootConstrainSelectedInstOperands,
     /* 218172 */     // GIR_Coverage, 3869,
     /* 218172 */     GIR_EraseRootFromParent_Done,
     /* 218173 */   // Label 4183: @218173
     /* 218173 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(218278), // Rule ID 3870 //
     /* 218178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 218186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 218189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 218192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 218222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218251 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 218255 */     // MIs[3] Operand 1
     /* 218255 */     // No operand predicates
     /* 218255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218257 */     // (intrinsic_wo_chain:{ *:[v4f16] } 761:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 218257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 218260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218276 */     GIR_RootConstrainSelectedInstOperands,
     /* 218277 */     // GIR_Coverage, 3870,
     /* 218277 */     GIR_EraseRootFromParent_Done,
     /* 218278 */   // Label 4184: @218278
     /* 218278 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(218383), // Rule ID 3871 //
     /* 218283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 218291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 218294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 218297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 218327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 218360 */     // MIs[3] Operand 1
     /* 218360 */     // No operand predicates
     /* 218360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218362 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 218362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 218365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 218381 */     GIR_RootConstrainSelectedInstOperands,
     /* 218382 */     // GIR_Coverage, 3871,
     /* 218382 */     GIR_EraseRootFromParent_Done,
     /* 218383 */   // Label 4185: @218383
     /* 218383 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(218488), // Rule ID 3872 //
     /* 218388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 218396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 218399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 218402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 218432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218457 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218461 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 218465 */     // MIs[3] Operand 1
     /* 218465 */     // No operand predicates
     /* 218465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218467 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 218467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 218470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 218486 */     GIR_RootConstrainSelectedInstOperands,
     /* 218487 */     // GIR_Coverage, 3872,
     /* 218487 */     GIR_EraseRootFromParent_Done,
     /* 218488 */   // Label 4186: @218488
     /* 218488 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(218593), // Rule ID 3877 //
     /* 218493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 218501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218566 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 218570 */     // MIs[3] Operand 1
     /* 218570 */     // No operand predicates
     /* 218570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218572 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 218572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 218575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218591 */     GIR_RootConstrainSelectedInstOperands,
     /* 218592 */     // GIR_Coverage, 3877,
     /* 218592 */     GIR_EraseRootFromParent_Done,
     /* 218593 */   // Label 4187: @218593
     /* 218593 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(218698), // Rule ID 3878 //
     /* 218598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 218606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218671 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 218675 */     // MIs[3] Operand 1
     /* 218675 */     // No operand predicates
     /* 218675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218677 */     // (intrinsic_wo_chain:{ *:[v8f16] } 761:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 218677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 218680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218696 */     GIR_RootConstrainSelectedInstOperands,
     /* 218697 */     // GIR_Coverage, 3878,
     /* 218697 */     GIR_EraseRootFromParent_Done,
     /* 218698 */   // Label 4188: @218698
     /* 218698 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(218803), // Rule ID 3879 //
     /* 218703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 218711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218776 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 218780 */     // MIs[3] Operand 1
     /* 218780 */     // No operand predicates
     /* 218780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218782 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 218782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 218785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 218801 */     GIR_RootConstrainSelectedInstOperands,
     /* 218802 */     // GIR_Coverage, 3879,
     /* 218802 */     GIR_EraseRootFromParent_Done,
     /* 218803 */   // Label 4189: @218803
     /* 218803 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(218908), // Rule ID 3880 //
     /* 218808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 218816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218881 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 218885 */     // MIs[3] Operand 1
     /* 218885 */     // No operand predicates
     /* 218885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218887 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 218887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 218890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 218906 */     GIR_RootConstrainSelectedInstOperands,
     /* 218907 */     // GIR_Coverage, 3880,
     /* 218907 */     GIR_EraseRootFromParent_Done,
     /* 218908 */   // Label 4190: @218908
     /* 218908 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(219013), // Rule ID 3893 //
     /* 218913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 218921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 218957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 218965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 218969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218973 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218986 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 218990 */     // MIs[3] Operand 1
     /* 218990 */     // No operand predicates
     /* 218990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218992 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 218992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 218995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 219005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 219008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219011 */     GIR_RootConstrainSelectedInstOperands,
     /* 219012 */     // GIR_Coverage, 3893,
     /* 219012 */     GIR_EraseRootFromParent_Done,
     /* 219013 */   // Label 4191: @219013
     /* 219013 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(219118), // Rule ID 3894 //
     /* 219018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 219026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 219058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 219070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 219078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 219087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219091 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 219095 */     // MIs[3] Operand 1
     /* 219095 */     // No operand predicates
     /* 219095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 219097 */     // (intrinsic_wo_chain:{ *:[v4f32] } 761:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 219097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 219100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 219110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 219113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219116 */     GIR_RootConstrainSelectedInstOperands,
     /* 219117 */     // GIR_Coverage, 3894,
     /* 219117 */     GIR_EraseRootFromParent_Done,
     /* 219118 */   // Label 4192: @219118
     /* 219118 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(219223), // Rule ID 3895 //
     /* 219123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 219131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 219163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 219175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 219183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 219192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219196 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 219200 */     // MIs[3] Operand 1
     /* 219200 */     // No operand predicates
     /* 219200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 219202 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 219202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 219205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 219215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 219218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 219221 */     GIR_RootConstrainSelectedInstOperands,
     /* 219222 */     // GIR_Coverage, 3895,
     /* 219222 */     GIR_EraseRootFromParent_Done,
     /* 219223 */   // Label 4193: @219223
     /* 219223 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(219328), // Rule ID 3896 //
     /* 219228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 219236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 219268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 219280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 219288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 219297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219301 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 219305 */     // MIs[3] Operand 1
     /* 219305 */     // No operand predicates
     /* 219305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 219307 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 219307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 219310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 219320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 219323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 219326 */     GIR_RootConstrainSelectedInstOperands,
     /* 219327 */     // GIR_Coverage, 3896,
     /* 219327 */     GIR_EraseRootFromParent_Done,
     /* 219328 */   // Label 4194: @219328
     /* 219328 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(219382), // Rule ID 59 //
     /* 219333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 219336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 219341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 219350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219358 */     // MIs[0] Operand 3
     /* 219358 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 219369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 219373 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 219373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 219376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219380 */     GIR_RootConstrainSelectedInstOperands,
     /* 219381 */     // GIR_Coverage, 59,
     /* 219381 */     GIR_EraseRootFromParent_Done,
     /* 219382 */   // Label 4195: @219382
     /* 219382 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(219436), // Rule ID 60 //
     /* 219387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 219390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 219395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 219404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219412 */     // MIs[0] Operand 3
     /* 219412 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 219423 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 219427 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 219427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 219430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219434 */     GIR_RootConstrainSelectedInstOperands,
     /* 219435 */     // GIR_Coverage, 60,
     /* 219435 */     GIR_EraseRootFromParent_Done,
     /* 219436 */   // Label 4196: @219436
     /* 219436 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(219490), // Rule ID 61 //
     /* 219441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 219444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 219449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 219458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219466 */     // MIs[0] Operand 3
     /* 219466 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 219477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 219481 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 219481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 219484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219488 */     GIR_RootConstrainSelectedInstOperands,
     /* 219489 */     // GIR_Coverage, 61,
     /* 219489 */     GIR_EraseRootFromParent_Done,
     /* 219490 */   // Label 4197: @219490
     /* 219490 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(219544), // Rule ID 62 //
     /* 219495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 219498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 219503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 219512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219520 */     // MIs[0] Operand 3
     /* 219520 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 219531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 219535 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 219535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 219538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219542 */     GIR_RootConstrainSelectedInstOperands,
     /* 219543 */     // GIR_Coverage, 62,
     /* 219543 */     GIR_EraseRootFromParent_Done,
     /* 219544 */   // Label 4198: @219544
     /* 219544 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(219600), // Rule ID 2652 //
     /* 219549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 219557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219571 */     // MIs[0] pattern
     /* 219571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219579 */     // MIs[0] imm4
     /* 219579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219587 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 219590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219594 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219596 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219598 */     GIR_RootConstrainSelectedInstOperands,
     /* 219599 */     // GIR_Coverage, 2652,
     /* 219599 */     GIR_EraseRootFromParent_Done,
     /* 219600 */   // Label 4199: @219600
     /* 219600 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(219656), // Rule ID 2661 //
     /* 219605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 219613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 219616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 219619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 219623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 219627 */     // MIs[0] pattern
     /* 219627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219635 */     // MIs[0] imm4
     /* 219635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219643 */     // (intrinsic_wo_chain:{ *:[i32] } 2017:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 219646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219650 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219652 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219654 */     GIR_RootConstrainSelectedInstOperands,
     /* 219655 */     // GIR_Coverage, 2661,
     /* 219655 */     GIR_EraseRootFromParent_Done,
     /* 219656 */   // Label 4200: @219656
     /* 219656 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(219712), // Rule ID 2662 //
     /* 219661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 219669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219683 */     // MIs[0] pattern
     /* 219683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219691 */     // MIs[0] imm4
     /* 219691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219699 */     // (intrinsic_wo_chain:{ *:[i64] } 1807:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 219702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219706 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219708 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219710 */     GIR_RootConstrainSelectedInstOperands,
     /* 219711 */     // GIR_Coverage, 2662,
     /* 219711 */     GIR_EraseRootFromParent_Done,
     /* 219712 */   // Label 4201: @219712
     /* 219712 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(219768), // Rule ID 10050 //
     /* 219717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 219725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 219728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 219731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 219735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 219739 */     // MIs[0] pattern
     /* 219739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219747 */     // MIs[0] imm4
     /* 219747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219755 */     // (intrinsic_wo_chain:{ *:[i32] } 2003:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 219758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219762 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219764 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219766 */     GIR_RootConstrainSelectedInstOperands,
     /* 219767 */     // GIR_Coverage, 10050,
     /* 219767 */     GIR_EraseRootFromParent_Done,
     /* 219768 */   // Label 4202: @219768
     /* 219768 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(219824), // Rule ID 10051 //
     /* 219773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 219781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219795 */     // MIs[0] pattern
     /* 219795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219803 */     // MIs[0] imm4
     /* 219803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219806 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219811 */     // (intrinsic_wo_chain:{ *:[i64] } 2018:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 219814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219818 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219820 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219822 */     GIR_RootConstrainSelectedInstOperands,
     /* 219823 */     // GIR_Coverage, 10051,
     /* 219823 */     GIR_EraseRootFromParent_Done,
     /* 219824 */   // Label 4203: @219824
     /* 219824 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(219880), // Rule ID 10052 //
     /* 219829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 219837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219851 */     // MIs[0] pattern
     /* 219851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219859 */     // MIs[0] imm4
     /* 219859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219867 */     // (intrinsic_wo_chain:{ *:[i64] } 1773:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 219870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219874 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219876 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219878 */     GIR_RootConstrainSelectedInstOperands,
     /* 219879 */     // GIR_Coverage, 10052,
     /* 219879 */     GIR_EraseRootFromParent_Done,
     /* 219880 */   // Label 4204: @219880
     /* 219880 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(219936), // Rule ID 10053 //
     /* 219885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 219893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219907 */     // MIs[0] pattern
     /* 219907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219910 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219915 */     // MIs[0] imm4
     /* 219915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219923 */     // (intrinsic_wo_chain:{ *:[i64] } 2004:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 219926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219930 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219932 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219934 */     GIR_RootConstrainSelectedInstOperands,
     /* 219935 */     // GIR_Coverage, 10053,
     /* 219935 */     GIR_EraseRootFromParent_Done,
     /* 219936 */   // Label 4205: @219936
     /* 219936 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(219992), // Rule ID 10056 //
     /* 219941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 219949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 219952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 219955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 219959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 219963 */     // MIs[0] pattern
     /* 219963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219966 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219971 */     // MIs[0] imm4
     /* 219971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219974 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219979 */     // (intrinsic_wo_chain:{ *:[i32] } 2023:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 219982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219986 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219988 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219990 */     GIR_RootConstrainSelectedInstOperands,
     /* 219991 */     // GIR_Coverage, 10056,
     /* 219991 */     GIR_EraseRootFromParent_Done,
     /* 219992 */   // Label 4206: @219992
     /* 219992 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(220048), // Rule ID 10059 //
     /* 219997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 220005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220019 */     // MIs[0] pattern
     /* 220019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220027 */     // MIs[0] imm4
     /* 220027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220035 */     // (intrinsic_wo_chain:{ *:[i32] } 2009:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 220038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220042 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220044 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220046 */     GIR_RootConstrainSelectedInstOperands,
     /* 220047 */     // GIR_Coverage, 10059,
     /* 220047 */     GIR_EraseRootFromParent_Done,
     /* 220048 */   // Label 4207: @220048
     /* 220048 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(220104), // Rule ID 10060 //
     /* 220053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 220061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220075 */     // MIs[0] pattern
     /* 220075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220083 */     // MIs[0] imm4
     /* 220083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220091 */     // (intrinsic_wo_chain:{ *:[i64] } 1813:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 220094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220098 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220100 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220102 */     GIR_RootConstrainSelectedInstOperands,
     /* 220103 */     // GIR_Coverage, 10060,
     /* 220103 */     GIR_EraseRootFromParent_Done,
     /* 220104 */   // Label 4208: @220104
     /* 220104 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(220160), // Rule ID 10061 //
     /* 220109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 220117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220131 */     // MIs[0] pattern
     /* 220131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220134 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220139 */     // MIs[0] imm4
     /* 220139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220142 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220147 */     // (intrinsic_wo_chain:{ *:[i64] } 2024:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 220150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220154 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220156 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220158 */     GIR_RootConstrainSelectedInstOperands,
     /* 220159 */     // GIR_Coverage, 10061,
     /* 220159 */     GIR_EraseRootFromParent_Done,
     /* 220160 */   // Label 4209: @220160
     /* 220160 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(220216), // Rule ID 10062 //
     /* 220165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 220173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220187 */     // MIs[0] pattern
     /* 220187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220190 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220195 */     // MIs[0] imm4
     /* 220195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220203 */     // (intrinsic_wo_chain:{ *:[i64] } 1779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 220206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220210 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220212 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220214 */     GIR_RootConstrainSelectedInstOperands,
     /* 220215 */     // GIR_Coverage, 10062,
     /* 220215 */     GIR_EraseRootFromParent_Done,
     /* 220216 */   // Label 4210: @220216
     /* 220216 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(220272), // Rule ID 10063 //
     /* 220221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 220229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220243 */     // MIs[0] pattern
     /* 220243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220251 */     // MIs[0] imm4
     /* 220251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220254 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220259 */     // (intrinsic_wo_chain:{ *:[i64] } 2010:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 220262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220266 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220268 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220270 */     GIR_RootConstrainSelectedInstOperands,
     /* 220271 */     // GIR_Coverage, 10063,
     /* 220271 */     GIR_EraseRootFromParent_Done,
     /* 220272 */   // Label 4211: @220272
     /* 220272 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(220328), // Rule ID 10066 //
     /* 220277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 220285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220299 */     // MIs[0] pattern
     /* 220299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220302 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220307 */     // MIs[0] imm4
     /* 220307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220310 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220315 */     // (intrinsic_wo_chain:{ *:[i32] } 2029:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 220318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220322 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220324 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220326 */     GIR_RootConstrainSelectedInstOperands,
     /* 220327 */     // GIR_Coverage, 10066,
     /* 220327 */     GIR_EraseRootFromParent_Done,
     /* 220328 */   // Label 4212: @220328
     /* 220328 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(220384), // Rule ID 10069 //
     /* 220333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 220341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220355 */     // MIs[0] pattern
     /* 220355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220363 */     // MIs[0] imm4
     /* 220363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220371 */     // (intrinsic_wo_chain:{ *:[i32] } 2015:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 220374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220378 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220380 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220382 */     GIR_RootConstrainSelectedInstOperands,
     /* 220383 */     // GIR_Coverage, 10069,
     /* 220383 */     GIR_EraseRootFromParent_Done,
     /* 220384 */   // Label 4213: @220384
     /* 220384 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(220440), // Rule ID 10070 //
     /* 220389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 220397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220411 */     // MIs[0] pattern
     /* 220411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220414 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220419 */     // MIs[0] imm4
     /* 220419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220422 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220427 */     // (intrinsic_wo_chain:{ *:[i64] } 1819:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 220430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220434 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220436 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220438 */     GIR_RootConstrainSelectedInstOperands,
     /* 220439 */     // GIR_Coverage, 10070,
     /* 220439 */     GIR_EraseRootFromParent_Done,
     /* 220440 */   // Label 4214: @220440
     /* 220440 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(220496), // Rule ID 10071 //
     /* 220445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 220453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220467 */     // MIs[0] pattern
     /* 220467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220470 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220475 */     // MIs[0] imm4
     /* 220475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220478 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220483 */     // (intrinsic_wo_chain:{ *:[i64] } 2030:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 220486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220490 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220492 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220494 */     GIR_RootConstrainSelectedInstOperands,
     /* 220495 */     // GIR_Coverage, 10071,
     /* 220495 */     GIR_EraseRootFromParent_Done,
     /* 220496 */   // Label 4215: @220496
     /* 220496 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(220552), // Rule ID 10072 //
     /* 220501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 220509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220523 */     // MIs[0] pattern
     /* 220523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220531 */     // MIs[0] imm4
     /* 220531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220539 */     // (intrinsic_wo_chain:{ *:[i64] } 1785:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 220542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220546 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220548 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220550 */     GIR_RootConstrainSelectedInstOperands,
     /* 220551 */     // GIR_Coverage, 10072,
     /* 220551 */     GIR_EraseRootFromParent_Done,
     /* 220552 */   // Label 4216: @220552
     /* 220552 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(220608), // Rule ID 10073 //
     /* 220557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 220565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220579 */     // MIs[0] pattern
     /* 220579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220587 */     // MIs[0] imm4
     /* 220587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220590 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220595 */     // (intrinsic_wo_chain:{ *:[i64] } 2016:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 220598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220602 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220604 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220606 */     GIR_RootConstrainSelectedInstOperands,
     /* 220607 */     // GIR_Coverage, 10073,
     /* 220607 */     GIR_EraseRootFromParent_Done,
     /* 220608 */   // Label 4217: @220608
     /* 220608 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(220664), // Rule ID 10076 //
     /* 220613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 220621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220635 */     // MIs[0] pattern
     /* 220635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220643 */     // MIs[0] imm4
     /* 220643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220646 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220651 */     // (intrinsic_wo_chain:{ *:[i32] } 2020:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 220654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220658 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220660 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220662 */     GIR_RootConstrainSelectedInstOperands,
     /* 220663 */     // GIR_Coverage, 10076,
     /* 220663 */     GIR_EraseRootFromParent_Done,
     /* 220664 */   // Label 4218: @220664
     /* 220664 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(220720), // Rule ID 10079 //
     /* 220669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 220677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220691 */     // MIs[0] pattern
     /* 220691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220699 */     // MIs[0] imm4
     /* 220699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220707 */     // (intrinsic_wo_chain:{ *:[i32] } 2006:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 220710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220714 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220716 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220718 */     GIR_RootConstrainSelectedInstOperands,
     /* 220719 */     // GIR_Coverage, 10079,
     /* 220719 */     GIR_EraseRootFromParent_Done,
     /* 220720 */   // Label 4219: @220720
     /* 220720 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(220776), // Rule ID 10080 //
     /* 220725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 220733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220747 */     // MIs[0] pattern
     /* 220747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220755 */     // MIs[0] imm4
     /* 220755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220758 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220763 */     // (intrinsic_wo_chain:{ *:[i64] } 1810:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 220766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220770 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220772 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220774 */     GIR_RootConstrainSelectedInstOperands,
     /* 220775 */     // GIR_Coverage, 10080,
     /* 220775 */     GIR_EraseRootFromParent_Done,
     /* 220776 */   // Label 4220: @220776
     /* 220776 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(220832), // Rule ID 10081 //
     /* 220781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 220789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220803 */     // MIs[0] pattern
     /* 220803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220806 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220811 */     // MIs[0] imm4
     /* 220811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220814 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220819 */     // (intrinsic_wo_chain:{ *:[i64] } 2021:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 220822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220826 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220828 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220830 */     GIR_RootConstrainSelectedInstOperands,
     /* 220831 */     // GIR_Coverage, 10081,
     /* 220831 */     GIR_EraseRootFromParent_Done,
     /* 220832 */   // Label 4221: @220832
     /* 220832 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(220888), // Rule ID 10082 //
     /* 220837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 220845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220859 */     // MIs[0] pattern
     /* 220859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220867 */     // MIs[0] imm4
     /* 220867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220875 */     // (intrinsic_wo_chain:{ *:[i64] } 1776:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 220878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220882 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220884 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220886 */     GIR_RootConstrainSelectedInstOperands,
     /* 220887 */     // GIR_Coverage, 10082,
     /* 220887 */     GIR_EraseRootFromParent_Done,
     /* 220888 */   // Label 4222: @220888
     /* 220888 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(220944), // Rule ID 10083 //
     /* 220893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 220901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220915 */     // MIs[0] pattern
     /* 220915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220923 */     // MIs[0] imm4
     /* 220923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220931 */     // (intrinsic_wo_chain:{ *:[i64] } 2007:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 220934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220938 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220940 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220942 */     GIR_RootConstrainSelectedInstOperands,
     /* 220943 */     // GIR_Coverage, 10083,
     /* 220943 */     GIR_EraseRootFromParent_Done,
     /* 220944 */   // Label 4223: @220944
     /* 220944 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(221000), // Rule ID 10084 //
     /* 220949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 220957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220971 */     // MIs[0] pattern
     /* 220971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220974 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220979 */     // MIs[0] imm4
     /* 220979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220982 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220987 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2022:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 220990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 220994 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220996 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220998 */     GIR_RootConstrainSelectedInstOperands,
     /* 220999 */     // GIR_Coverage, 10084,
     /* 220999 */     GIR_EraseRootFromParent_Done,
     /* 221000 */   // Label 4224: @221000
     /* 221000 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(221056), // Rule ID 10085 //
     /* 221005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 221013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221027 */     // MIs[0] pattern
     /* 221027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221035 */     // MIs[0] imm4
     /* 221035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1777:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 221046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221050 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221052 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221054 */     GIR_RootConstrainSelectedInstOperands,
     /* 221055 */     // GIR_Coverage, 10085,
     /* 221055 */     GIR_EraseRootFromParent_Done,
     /* 221056 */   // Label 4225: @221056
     /* 221056 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(221112), // Rule ID 10086 //
     /* 221061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 221069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221083 */     // MIs[0] pattern
     /* 221083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221091 */     // MIs[0] imm4
     /* 221091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221094 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221099 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2008:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 221102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221106 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221108 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221110 */     GIR_RootConstrainSelectedInstOperands,
     /* 221111 */     // GIR_Coverage, 10086,
     /* 221111 */     GIR_EraseRootFromParent_Done,
     /* 221112 */   // Label 4226: @221112
     /* 221112 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(221168), // Rule ID 10087 //
     /* 221117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 221125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221139 */     // MIs[0] pattern
     /* 221139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221142 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221147 */     // MIs[0] imm4
     /* 221147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221155 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1817:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 221158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221162 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221164 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221166 */     GIR_RootConstrainSelectedInstOperands,
     /* 221167 */     // GIR_Coverage, 10087,
     /* 221167 */     GIR_EraseRootFromParent_Done,
     /* 221168 */   // Label 4227: @221168
     /* 221168 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(221224), // Rule ID 10088 //
     /* 221173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 221181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221195 */     // MIs[0] pattern
     /* 221195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221203 */     // MIs[0] imm4
     /* 221203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2028:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 221214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221218 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221220 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221222 */     GIR_RootConstrainSelectedInstOperands,
     /* 221223 */     // GIR_Coverage, 10088,
     /* 221223 */     GIR_EraseRootFromParent_Done,
     /* 221224 */   // Label 4228: @221224
     /* 221224 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(221280), // Rule ID 10089 //
     /* 221229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 221237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221251 */     // MIs[0] pattern
     /* 221251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221254 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221259 */     // MIs[0] imm4
     /* 221259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221262 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221267 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1783:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 221270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221274 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221276 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221278 */     GIR_RootConstrainSelectedInstOperands,
     /* 221279 */     // GIR_Coverage, 10089,
     /* 221279 */     GIR_EraseRootFromParent_Done,
     /* 221280 */   // Label 4229: @221280
     /* 221280 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(221336), // Rule ID 10090 //
     /* 221285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 221293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221307 */     // MIs[0] pattern
     /* 221307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221310 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221315 */     // MIs[0] imm4
     /* 221315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221323 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2014:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 221326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221330 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221332 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221334 */     GIR_RootConstrainSelectedInstOperands,
     /* 221335 */     // GIR_Coverage, 10090,
     /* 221335 */     GIR_EraseRootFromParent_Done,
     /* 221336 */   // Label 4230: @221336
     /* 221336 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(221392), // Rule ID 10091 //
     /* 221341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 221349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221363 */     // MIs[0] pattern
     /* 221363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221371 */     // MIs[0] imm4
     /* 221371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221374 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221379 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1808:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 221382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221386 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221388 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221390 */     GIR_RootConstrainSelectedInstOperands,
     /* 221391 */     // GIR_Coverage, 10091,
     /* 221391 */     GIR_EraseRootFromParent_Done,
     /* 221392 */   // Label 4231: @221392
     /* 221392 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(221448), // Rule ID 10092 //
     /* 221397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 221405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221419 */     // MIs[0] pattern
     /* 221419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221422 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221427 */     // MIs[0] imm4
     /* 221427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221430 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221435 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2019:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 221438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221442 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221444 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221446 */     GIR_RootConstrainSelectedInstOperands,
     /* 221447 */     // GIR_Coverage, 10092,
     /* 221447 */     GIR_EraseRootFromParent_Done,
     /* 221448 */   // Label 4232: @221448
     /* 221448 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(221504), // Rule ID 10093 //
     /* 221453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 221461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221475 */     // MIs[0] pattern
     /* 221475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221478 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221483 */     // MIs[0] imm4
     /* 221483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221491 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1774:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 221494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221498 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221500 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221502 */     GIR_RootConstrainSelectedInstOperands,
     /* 221503 */     // GIR_Coverage, 10093,
     /* 221503 */     GIR_EraseRootFromParent_Done,
     /* 221504 */   // Label 4233: @221504
     /* 221504 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(221560), // Rule ID 10094 //
     /* 221509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 221517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221531 */     // MIs[0] pattern
     /* 221531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221539 */     // MIs[0] imm4
     /* 221539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221542 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221547 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2005:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 221550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221554 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221556 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221558 */     GIR_RootConstrainSelectedInstOperands,
     /* 221559 */     // GIR_Coverage, 10094,
     /* 221559 */     GIR_EraseRootFromParent_Done,
     /* 221560 */   // Label 4234: @221560
     /* 221560 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(221650), // Rule ID 47 //
     /* 221565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 221568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 221573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 221576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 221579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 221582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 221585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 221605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 221609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 221618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221626 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 221630 */     // MIs[2] Operand 1
     /* 221630 */     // No operand predicates
     /* 221630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221632 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 221635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221648 */     GIR_RootConstrainSelectedInstOperands,
     /* 221649 */     // GIR_Coverage, 47,
     /* 221649 */     GIR_EraseRootFromParent_Done,
     /* 221650 */   // Label 4235: @221650
     /* 221650 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(221740), // Rule ID 48 //
     /* 221655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 221658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 221663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 221666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 221669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 221672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 221675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 221695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 221699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 221708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221716 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 221720 */     // MIs[2] Operand 1
     /* 221720 */     // No operand predicates
     /* 221720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221722 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 221725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221738 */     GIR_RootConstrainSelectedInstOperands,
     /* 221739 */     // GIR_Coverage, 48,
     /* 221739 */     GIR_EraseRootFromParent_Done,
     /* 221740 */   // Label 4236: @221740
     /* 221740 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(221830), // Rule ID 49 //
     /* 221745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 221748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 221753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 221756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 221759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 221762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 221765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 221785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 221789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 221798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221806 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 221810 */     // MIs[2] Operand 1
     /* 221810 */     // No operand predicates
     /* 221810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221812 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 221815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221828 */     GIR_RootConstrainSelectedInstOperands,
     /* 221829 */     // GIR_Coverage, 49,
     /* 221829 */     GIR_EraseRootFromParent_Done,
     /* 221830 */   // Label 4237: @221830
     /* 221830 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(221920), // Rule ID 50 //
     /* 221835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 221838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 221843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 221846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 221849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 221852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 221855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 221875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 221879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 221888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221896 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 221900 */     // MIs[2] Operand 1
     /* 221900 */     // No operand predicates
     /* 221900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221902 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 221905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221918 */     GIR_RootConstrainSelectedInstOperands,
     /* 221919 */     // GIR_Coverage, 50,
     /* 221919 */     GIR_EraseRootFromParent_Done,
     /* 221920 */   // Label 4238: @221920
     /* 221920 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(222010), // Rule ID 51 //
     /* 221925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 221928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 221933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 221936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 221939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 221942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 221945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 221965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 221969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 221978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221986 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 221990 */     // MIs[2] Operand 1
     /* 221990 */     // No operand predicates
     /* 221990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221992 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 221995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222008 */     GIR_RootConstrainSelectedInstOperands,
     /* 222009 */     // GIR_Coverage, 51,
     /* 222009 */     GIR_EraseRootFromParent_Done,
     /* 222010 */   // Label 4239: @222010
     /* 222010 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(222100), // Rule ID 52 //
     /* 222015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 222018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 222023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 222026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 222029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 222032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 222035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222076 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222080 */     // MIs[2] Operand 1
     /* 222080 */     // No operand predicates
     /* 222080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222082 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 222085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222098 */     GIR_RootConstrainSelectedInstOperands,
     /* 222099 */     // GIR_Coverage, 52,
     /* 222099 */     GIR_EraseRootFromParent_Done,
     /* 222100 */   // Label 4240: @222100
     /* 222100 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(222190), // Rule ID 53 //
     /* 222105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 222108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 222113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 222116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 222119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 222122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 222125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222166 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222170 */     // MIs[2] Operand 1
     /* 222170 */     // No operand predicates
     /* 222170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222172 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 222175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222188 */     GIR_RootConstrainSelectedInstOperands,
     /* 222189 */     // GIR_Coverage, 53,
     /* 222189 */     GIR_EraseRootFromParent_Done,
     /* 222190 */   // Label 4241: @222190
     /* 222190 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(222280), // Rule ID 54 //
     /* 222195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 222198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 222203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 222206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 222209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 222212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 222215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222256 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222260 */     // MIs[2] Operand 1
     /* 222260 */     // No operand predicates
     /* 222260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222262 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 222265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222278 */     GIR_RootConstrainSelectedInstOperands,
     /* 222279 */     // GIR_Coverage, 54,
     /* 222279 */     GIR_EraseRootFromParent_Done,
     /* 222280 */   // Label 4242: @222280
     /* 222280 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(222370), // Rule ID 2070 //
     /* 222285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 222288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 222293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 222296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 222299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 222302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 222305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222346 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222350 */     // MIs[2] Operand 1
     /* 222350 */     // No operand predicates
     /* 222350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222352 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 222355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222368 */     GIR_RootConstrainSelectedInstOperands,
     /* 222369 */     // GIR_Coverage, 2070,
     /* 222369 */     GIR_EraseRootFromParent_Done,
     /* 222370 */   // Label 4243: @222370
     /* 222370 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(222460), // Rule ID 2071 //
     /* 222375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 222378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 222383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 222386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 222389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 222392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 222395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222436 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222440 */     // MIs[2] Operand 1
     /* 222440 */     // No operand predicates
     /* 222440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222442 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 222445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222458 */     GIR_RootConstrainSelectedInstOperands,
     /* 222459 */     // GIR_Coverage, 2071,
     /* 222459 */     GIR_EraseRootFromParent_Done,
     /* 222460 */   // Label 4244: @222460
     /* 222460 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(222550), // Rule ID 2077 //
     /* 222465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 222468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 222473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 222476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 222479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 222482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 222485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222526 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222530 */     // MIs[2] Operand 1
     /* 222530 */     // No operand predicates
     /* 222530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222532 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 222535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222548 */     GIR_RootConstrainSelectedInstOperands,
     /* 222549 */     // GIR_Coverage, 2077,
     /* 222549 */     GIR_EraseRootFromParent_Done,
     /* 222550 */   // Label 4245: @222550
     /* 222550 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(222640), // Rule ID 2078 //
     /* 222555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 222558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 222563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 222566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 222569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 222572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 222575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222616 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222620 */     // MIs[2] Operand 1
     /* 222620 */     // No operand predicates
     /* 222620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222622 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 222625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222638 */     GIR_RootConstrainSelectedInstOperands,
     /* 222639 */     // GIR_Coverage, 2078,
     /* 222639 */     GIR_EraseRootFromParent_Done,
     /* 222640 */   // Label 4246: @222640
     /* 222640 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(222730), // Rule ID 2073 //
     /* 222645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 222648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 222653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 222656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 222659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 222662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 222665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 222685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 222689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222706 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 222710 */     // MIs[2] Operand 1
     /* 222710 */     // No operand predicates
     /* 222710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222712 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 222715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222728 */     GIR_RootConstrainSelectedInstOperands,
     /* 222729 */     // GIR_Coverage, 2073,
     /* 222729 */     GIR_EraseRootFromParent_Done,
     /* 222730 */   // Label 4247: @222730
     /* 222730 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(222820), // Rule ID 2074 //
     /* 222735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 222738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 222743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 222746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 222749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 222752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 222755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 222775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 222779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222796 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 222800 */     // MIs[2] Operand 1
     /* 222800 */     // No operand predicates
     /* 222800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222802 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 222805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222818 */     GIR_RootConstrainSelectedInstOperands,
     /* 222819 */     // GIR_Coverage, 2074,
     /* 222819 */     GIR_EraseRootFromParent_Done,
     /* 222820 */   // Label 4248: @222820
     /* 222820 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(222910), // Rule ID 2080 //
     /* 222825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 222828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 222833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 222836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 222839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 222842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 222845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 222865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 222869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222886 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 222890 */     // MIs[2] Operand 1
     /* 222890 */     // No operand predicates
     /* 222890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222892 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 222895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222908 */     GIR_RootConstrainSelectedInstOperands,
     /* 222909 */     // GIR_Coverage, 2080,
     /* 222909 */     GIR_EraseRootFromParent_Done,
     /* 222910 */   // Label 4249: @222910
     /* 222910 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(223000), // Rule ID 2081 //
     /* 222915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 222918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 222923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 222926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 222929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 222932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 222935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 222955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 222959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222976 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 222980 */     // MIs[2] Operand 1
     /* 222980 */     // No operand predicates
     /* 222980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222982 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 222985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222998 */     GIR_RootConstrainSelectedInstOperands,
     /* 222999 */     // GIR_Coverage, 2081,
     /* 222999 */     GIR_EraseRootFromParent_Done,
     /* 223000 */   // Label 4250: @223000
     /* 223000 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(223090), // Rule ID 2075 //
     /* 223005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 223008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 223013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 223016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 223019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 223022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 223025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 223029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 223033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 223037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 223045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 223049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 223053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 223062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 223066 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 223070 */     // MIs[2] Operand 1
     /* 223070 */     // No operand predicates
     /* 223070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223072 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 223072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 223075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 223081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 223085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 223088 */     GIR_RootConstrainSelectedInstOperands,
     /* 223089 */     // GIR_Coverage, 2075,
     /* 223089 */     GIR_EraseRootFromParent_Done,
     /* 223090 */   // Label 4251: @223090
     /* 223090 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(223180), // Rule ID 2082 //
     /* 223095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 223098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 223103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 223106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 223109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 223112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 223115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 223119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 223123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 223127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 223135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 223139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 223143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 223152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 223156 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 223160 */     // MIs[2] Operand 1
     /* 223160 */     // No operand predicates
     /* 223160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223162 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 223162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 223165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 223171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 223175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 223178 */     GIR_RootConstrainSelectedInstOperands,
     /* 223179 */     // GIR_Coverage, 2082,
     /* 223179 */     GIR_EraseRootFromParent_Done,
     /* 223180 */   // Label 4252: @223180
     /* 223180 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(223257), // Rule ID 2781 //
     /* 223185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 223193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223237 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 223241 */     // MIs[2] Operand 1
     /* 223241 */     // No operand predicates
     /* 223241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223243 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1364:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 223243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 223246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223255 */     GIR_RootConstrainSelectedInstOperands,
     /* 223256 */     // GIR_Coverage, 2781,
     /* 223256 */     GIR_EraseRootFromParent_Done,
     /* 223257 */   // Label 4253: @223257
     /* 223257 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(223334), // Rule ID 2782 //
     /* 223262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 223270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223314 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223318 */     // MIs[2] Operand 1
     /* 223318 */     // No operand predicates
     /* 223318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223320 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1364:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 223320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 223323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223332 */     GIR_RootConstrainSelectedInstOperands,
     /* 223333 */     // GIR_Coverage, 2782,
     /* 223333 */     GIR_EraseRootFromParent_Done,
     /* 223334 */   // Label 4254: @223334
     /* 223334 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(223411), // Rule ID 2783 //
     /* 223339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 223347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223391 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 223395 */     // MIs[2] Operand 1
     /* 223395 */     // No operand predicates
     /* 223395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223397 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1364:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 223397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 223400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223409 */     GIR_RootConstrainSelectedInstOperands,
     /* 223410 */     // GIR_Coverage, 2783,
     /* 223410 */     GIR_EraseRootFromParent_Done,
     /* 223411 */   // Label 4255: @223411
     /* 223411 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(223488), // Rule ID 2784 //
     /* 223416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 223424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223468 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223472 */     // MIs[2] Operand 1
     /* 223472 */     // No operand predicates
     /* 223472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223474 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1364:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 223474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 223477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223486 */     GIR_RootConstrainSelectedInstOperands,
     /* 223487 */     // GIR_Coverage, 2784,
     /* 223487 */     GIR_EraseRootFromParent_Done,
     /* 223488 */   // Label 4256: @223488
     /* 223488 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(223565), // Rule ID 2785 //
     /* 223493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 223501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223545 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 223549 */     // MIs[2] Operand 1
     /* 223549 */     // No operand predicates
     /* 223549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223551 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1364:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 223551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 223554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223563 */     GIR_RootConstrainSelectedInstOperands,
     /* 223564 */     // GIR_Coverage, 2785,
     /* 223564 */     GIR_EraseRootFromParent_Done,
     /* 223565 */   // Label 4257: @223565
     /* 223565 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(223642), // Rule ID 2786 //
     /* 223570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 223578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223622 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223626 */     // MIs[2] Operand 1
     /* 223626 */     // No operand predicates
     /* 223626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223628 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1364:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 223628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 223631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223640 */     GIR_RootConstrainSelectedInstOperands,
     /* 223641 */     // GIR_Coverage, 2786,
     /* 223641 */     GIR_EraseRootFromParent_Done,
     /* 223642 */   // Label 4258: @223642
     /* 223642 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(223719), // Rule ID 7937 //
     /* 223647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 223655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223699 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 223703 */     // MIs[2] Operand 1
     /* 223703 */     // No operand predicates
     /* 223703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223705 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 223705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 223708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223717 */     GIR_RootConstrainSelectedInstOperands,
     /* 223718 */     // GIR_Coverage, 7937,
     /* 223718 */     GIR_EraseRootFromParent_Done,
     /* 223719 */   // Label 4259: @223719
     /* 223719 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(223796), // Rule ID 7938 //
     /* 223724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 223732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223776 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223780 */     // MIs[2] Operand 1
     /* 223780 */     // No operand predicates
     /* 223780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223782 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 223782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 223785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223794 */     GIR_RootConstrainSelectedInstOperands,
     /* 223795 */     // GIR_Coverage, 7938,
     /* 223795 */     GIR_EraseRootFromParent_Done,
     /* 223796 */   // Label 4260: @223796
     /* 223796 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(223873), // Rule ID 7939 //
     /* 223801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 223809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223853 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 223857 */     // MIs[2] Operand 1
     /* 223857 */     // No operand predicates
     /* 223857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223859 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 223859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 223862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223871 */     GIR_RootConstrainSelectedInstOperands,
     /* 223872 */     // GIR_Coverage, 7939,
     /* 223872 */     GIR_EraseRootFromParent_Done,
     /* 223873 */   // Label 4261: @223873
     /* 223873 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(223950), // Rule ID 7940 //
     /* 223878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 223886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223930 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223934 */     // MIs[2] Operand 1
     /* 223934 */     // No operand predicates
     /* 223934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223936 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 223936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 223939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223948 */     GIR_RootConstrainSelectedInstOperands,
     /* 223949 */     // GIR_Coverage, 7940,
     /* 223949 */     GIR_EraseRootFromParent_Done,
     /* 223950 */   // Label 4262: @223950
     /* 223950 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(224027), // Rule ID 7941 //
     /* 223955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 223963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224007 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 224011 */     // MIs[2] Operand 1
     /* 224011 */     // No operand predicates
     /* 224011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224013 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 224013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 224016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224025 */     GIR_RootConstrainSelectedInstOperands,
     /* 224026 */     // GIR_Coverage, 7941,
     /* 224026 */     GIR_EraseRootFromParent_Done,
     /* 224027 */   // Label 4263: @224027
     /* 224027 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(224104), // Rule ID 7942 //
     /* 224032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224084 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224088 */     // MIs[2] Operand 1
     /* 224088 */     // No operand predicates
     /* 224088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224090 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 224090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 224093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224102 */     GIR_RootConstrainSelectedInstOperands,
     /* 224103 */     // GIR_Coverage, 7942,
     /* 224103 */     GIR_EraseRootFromParent_Done,
     /* 224104 */   // Label 4264: @224104
     /* 224104 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(224181), // Rule ID 7943 //
     /* 224109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 224117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224161 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 224165 */     // MIs[2] Operand 1
     /* 224165 */     // No operand predicates
     /* 224165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224167 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1478:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 224167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 224170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224179 */     GIR_RootConstrainSelectedInstOperands,
     /* 224180 */     // GIR_Coverage, 7943,
     /* 224180 */     GIR_EraseRootFromParent_Done,
     /* 224181 */   // Label 4265: @224181
     /* 224181 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(224258), // Rule ID 7944 //
     /* 224186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 224194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224238 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 224242 */     // MIs[2] Operand 1
     /* 224242 */     // No operand predicates
     /* 224242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224244 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1478:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 224244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 224247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224256 */     GIR_RootConstrainSelectedInstOperands,
     /* 224257 */     // GIR_Coverage, 7944,
     /* 224257 */     GIR_EraseRootFromParent_Done,
     /* 224258 */   // Label 4266: @224258
     /* 224258 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(224335), // Rule ID 7945 //
     /* 224263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 224271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224315 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 224319 */     // MIs[2] Operand 1
     /* 224319 */     // No operand predicates
     /* 224319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224321 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1478:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 224321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 224324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224333 */     GIR_RootConstrainSelectedInstOperands,
     /* 224334 */     // GIR_Coverage, 7945,
     /* 224334 */     GIR_EraseRootFromParent_Done,
     /* 224335 */   // Label 4267: @224335
     /* 224335 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(224412), // Rule ID 7946 //
     /* 224340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 224348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224392 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 224396 */     // MIs[2] Operand 1
     /* 224396 */     // No operand predicates
     /* 224396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224398 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1478:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 224398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 224401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224410 */     GIR_RootConstrainSelectedInstOperands,
     /* 224411 */     // GIR_Coverage, 7946,
     /* 224411 */     GIR_EraseRootFromParent_Done,
     /* 224412 */   // Label 4268: @224412
     /* 224412 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(224489), // Rule ID 7947 //
     /* 224417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 224425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224469 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 224473 */     // MIs[2] Operand 1
     /* 224473 */     // No operand predicates
     /* 224473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224475 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1478:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 224475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 224478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224487 */     GIR_RootConstrainSelectedInstOperands,
     /* 224488 */     // GIR_Coverage, 7947,
     /* 224488 */     GIR_EraseRootFromParent_Done,
     /* 224489 */   // Label 4269: @224489
     /* 224489 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(224566), // Rule ID 7948 //
     /* 224494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 224502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224546 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 224550 */     // MIs[2] Operand 1
     /* 224550 */     // No operand predicates
     /* 224550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224552 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1478:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 224552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 224555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224564 */     GIR_RootConstrainSelectedInstOperands,
     /* 224565 */     // GIR_Coverage, 7948,
     /* 224565 */     GIR_EraseRootFromParent_Done,
     /* 224566 */   // Label 4270: @224566
     /* 224566 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(224643), // Rule ID 7949 //
     /* 224571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224623 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 224627 */     // MIs[2] Operand 1
     /* 224627 */     // No operand predicates
     /* 224627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224629 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1542:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 224629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 224632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224641 */     GIR_RootConstrainSelectedInstOperands,
     /* 224642 */     // GIR_Coverage, 7949,
     /* 224642 */     GIR_EraseRootFromParent_Done,
     /* 224643 */   // Label 4271: @224643
     /* 224643 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(224720), // Rule ID 7950 //
     /* 224648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224700 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224704 */     // MIs[2] Operand 1
     /* 224704 */     // No operand predicates
     /* 224704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224706 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1542:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 224706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 224709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224718 */     GIR_RootConstrainSelectedInstOperands,
     /* 224719 */     // GIR_Coverage, 7950,
     /* 224719 */     GIR_EraseRootFromParent_Done,
     /* 224720 */   // Label 4272: @224720
     /* 224720 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(224797), // Rule ID 7951 //
     /* 224725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224777 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 224781 */     // MIs[2] Operand 1
     /* 224781 */     // No operand predicates
     /* 224781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224783 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1542:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 224783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 224786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224795 */     GIR_RootConstrainSelectedInstOperands,
     /* 224796 */     // GIR_Coverage, 7951,
     /* 224796 */     GIR_EraseRootFromParent_Done,
     /* 224797 */   // Label 4273: @224797
     /* 224797 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(224874), // Rule ID 7952 //
     /* 224802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224854 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224858 */     // MIs[2] Operand 1
     /* 224858 */     // No operand predicates
     /* 224858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224860 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1542:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 224860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 224863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224872 */     GIR_RootConstrainSelectedInstOperands,
     /* 224873 */     // GIR_Coverage, 7952,
     /* 224873 */     GIR_EraseRootFromParent_Done,
     /* 224874 */   // Label 4274: @224874
     /* 224874 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(224951), // Rule ID 7953 //
     /* 224879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224931 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 224935 */     // MIs[2] Operand 1
     /* 224935 */     // No operand predicates
     /* 224935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224937 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1542:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 224937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 224940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224949 */     GIR_RootConstrainSelectedInstOperands,
     /* 224950 */     // GIR_Coverage, 7953,
     /* 224950 */     GIR_EraseRootFromParent_Done,
     /* 224951 */   // Label 4275: @224951
     /* 224951 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(225028), // Rule ID 7954 //
     /* 224956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 225000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225008 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225012 */     // MIs[2] Operand 1
     /* 225012 */     // No operand predicates
     /* 225012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225014 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1542:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 225014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 225017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225026 */     GIR_RootConstrainSelectedInstOperands,
     /* 225027 */     // GIR_Coverage, 7954,
     /* 225027 */     GIR_EraseRootFromParent_Done,
     /* 225028 */   // Label 4276: @225028
     /* 225028 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(225105), // Rule ID 7955 //
     /* 225033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 225041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 225077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225085 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 225089 */     // MIs[2] Operand 1
     /* 225089 */     // No operand predicates
     /* 225089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225091 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 225091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 225094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225103 */     GIR_RootConstrainSelectedInstOperands,
     /* 225104 */     // GIR_Coverage, 7955,
     /* 225104 */     GIR_EraseRootFromParent_Done,
     /* 225105 */   // Label 4277: @225105
     /* 225105 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(225182), // Rule ID 7956 //
     /* 225110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 225118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 225154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225162 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225166 */     // MIs[2] Operand 1
     /* 225166 */     // No operand predicates
     /* 225166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225168 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 225168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 225171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225180 */     GIR_RootConstrainSelectedInstOperands,
     /* 225181 */     // GIR_Coverage, 7956,
     /* 225181 */     GIR_EraseRootFromParent_Done,
     /* 225182 */   // Label 4278: @225182
     /* 225182 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(225259), // Rule ID 7957 //
     /* 225187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 225195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 225231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225239 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 225243 */     // MIs[2] Operand 1
     /* 225243 */     // No operand predicates
     /* 225243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225245 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 225245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 225248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225257 */     GIR_RootConstrainSelectedInstOperands,
     /* 225258 */     // GIR_Coverage, 7957,
     /* 225258 */     GIR_EraseRootFromParent_Done,
     /* 225259 */   // Label 4279: @225259
     /* 225259 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(225336), // Rule ID 7958 //
     /* 225264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 225272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 225308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225316 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225320 */     // MIs[2] Operand 1
     /* 225320 */     // No operand predicates
     /* 225320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225322 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 225322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 225325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225334 */     GIR_RootConstrainSelectedInstOperands,
     /* 225335 */     // GIR_Coverage, 7958,
     /* 225335 */     GIR_EraseRootFromParent_Done,
     /* 225336 */   // Label 4280: @225336
     /* 225336 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(225413), // Rule ID 7959 //
     /* 225341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 225349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 225385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225393 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 225397 */     // MIs[2] Operand 1
     /* 225397 */     // No operand predicates
     /* 225397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225399 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 225399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 225402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225411 */     GIR_RootConstrainSelectedInstOperands,
     /* 225412 */     // GIR_Coverage, 7959,
     /* 225412 */     GIR_EraseRootFromParent_Done,
     /* 225413 */   // Label 4281: @225413
     /* 225413 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(225490), // Rule ID 7960 //
     /* 225418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 225426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 225462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225470 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225474 */     // MIs[2] Operand 1
     /* 225474 */     // No operand predicates
     /* 225474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225476 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 225476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 225479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225488 */     GIR_RootConstrainSelectedInstOperands,
     /* 225489 */     // GIR_Coverage, 7960,
     /* 225489 */     GIR_EraseRootFromParent_Done,
     /* 225490 */   // Label 4282: @225490
     /* 225490 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(225567), // Rule ID 7961 //
     /* 225495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 225503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 225539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225547 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 225551 */     // MIs[2] Operand 1
     /* 225551 */     // No operand predicates
     /* 225551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225553 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 225553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 225556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225565 */     GIR_RootConstrainSelectedInstOperands,
     /* 225566 */     // GIR_Coverage, 7961,
     /* 225566 */     GIR_EraseRootFromParent_Done,
     /* 225567 */   // Label 4283: @225567
     /* 225567 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(225644), // Rule ID 7962 //
     /* 225572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 225580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 225616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225624 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225628 */     // MIs[2] Operand 1
     /* 225628 */     // No operand predicates
     /* 225628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225630 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 225630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 225633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225642 */     GIR_RootConstrainSelectedInstOperands,
     /* 225643 */     // GIR_Coverage, 7962,
     /* 225643 */     GIR_EraseRootFromParent_Done,
     /* 225644 */   // Label 4284: @225644
     /* 225644 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(225721), // Rule ID 7963 //
     /* 225649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 225657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 225693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225701 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 225705 */     // MIs[2] Operand 1
     /* 225705 */     // No operand predicates
     /* 225705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225707 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 225707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 225710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225719 */     GIR_RootConstrainSelectedInstOperands,
     /* 225720 */     // GIR_Coverage, 7963,
     /* 225720 */     GIR_EraseRootFromParent_Done,
     /* 225721 */   // Label 4285: @225721
     /* 225721 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(225798), // Rule ID 7964 //
     /* 225726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 225734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 225770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225778 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225782 */     // MIs[2] Operand 1
     /* 225782 */     // No operand predicates
     /* 225782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225784 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 225784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 225787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225796 */     GIR_RootConstrainSelectedInstOperands,
     /* 225797 */     // GIR_Coverage, 7964,
     /* 225797 */     GIR_EraseRootFromParent_Done,
     /* 225798 */   // Label 4286: @225798
     /* 225798 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(225875), // Rule ID 7965 //
     /* 225803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 225811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 225847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225855 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 225859 */     // MIs[2] Operand 1
     /* 225859 */     // No operand predicates
     /* 225859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225861 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 225861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 225864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225873 */     GIR_RootConstrainSelectedInstOperands,
     /* 225874 */     // GIR_Coverage, 7965,
     /* 225874 */     GIR_EraseRootFromParent_Done,
     /* 225875 */   // Label 4287: @225875
     /* 225875 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(225952), // Rule ID 7966 //
     /* 225880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 225888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 225924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225932 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225936 */     // MIs[2] Operand 1
     /* 225936 */     // No operand predicates
     /* 225936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225938 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 225938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 225941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225950 */     GIR_RootConstrainSelectedInstOperands,
     /* 225951 */     // GIR_Coverage, 7966,
     /* 225951 */     GIR_EraseRootFromParent_Done,
     /* 225952 */   // Label 4288: @225952
     /* 225952 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(226029), // Rule ID 7967 //
     /* 225957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 225965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 226001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226009 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 226013 */     // MIs[2] Operand 1
     /* 226013 */     // No operand predicates
     /* 226013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226015 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1426:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 226015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 226018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226027 */     GIR_RootConstrainSelectedInstOperands,
     /* 226028 */     // GIR_Coverage, 7967,
     /* 226028 */     GIR_EraseRootFromParent_Done,
     /* 226029 */   // Label 4289: @226029
     /* 226029 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(226106), // Rule ID 7968 //
     /* 226034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 226042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 226078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226086 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 226090 */     // MIs[2] Operand 1
     /* 226090 */     // No operand predicates
     /* 226090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226092 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1426:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 226092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 226095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226104 */     GIR_RootConstrainSelectedInstOperands,
     /* 226105 */     // GIR_Coverage, 7968,
     /* 226105 */     GIR_EraseRootFromParent_Done,
     /* 226106 */   // Label 4290: @226106
     /* 226106 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(226183), // Rule ID 7969 //
     /* 226111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 226119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 226155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226163 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 226167 */     // MIs[2] Operand 1
     /* 226167 */     // No operand predicates
     /* 226167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226169 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1426:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 226169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 226172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226181 */     GIR_RootConstrainSelectedInstOperands,
     /* 226182 */     // GIR_Coverage, 7969,
     /* 226182 */     GIR_EraseRootFromParent_Done,
     /* 226183 */   // Label 4291: @226183
     /* 226183 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(226260), // Rule ID 7970 //
     /* 226188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 226196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 226232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226240 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 226244 */     // MIs[2] Operand 1
     /* 226244 */     // No operand predicates
     /* 226244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226246 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1426:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 226246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 226249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226258 */     GIR_RootConstrainSelectedInstOperands,
     /* 226259 */     // GIR_Coverage, 7970,
     /* 226259 */     GIR_EraseRootFromParent_Done,
     /* 226260 */   // Label 4292: @226260
     /* 226260 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(226337), // Rule ID 7971 //
     /* 226265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 226273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 226309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226317 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 226321 */     // MIs[2] Operand 1
     /* 226321 */     // No operand predicates
     /* 226321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226323 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1426:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 226323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 226326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226335 */     GIR_RootConstrainSelectedInstOperands,
     /* 226336 */     // GIR_Coverage, 7971,
     /* 226336 */     GIR_EraseRootFromParent_Done,
     /* 226337 */   // Label 4293: @226337
     /* 226337 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(226414), // Rule ID 7972 //
     /* 226342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 226350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 226386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226394 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 226398 */     // MIs[2] Operand 1
     /* 226398 */     // No operand predicates
     /* 226398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226400 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1426:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 226400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 226403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226412 */     GIR_RootConstrainSelectedInstOperands,
     /* 226413 */     // GIR_Coverage, 7972,
     /* 226413 */     GIR_EraseRootFromParent_Done,
     /* 226414 */   // Label 4294: @226414
     /* 226414 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(226491), // Rule ID 7973 //
     /* 226419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 226427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 226463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226471 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 226475 */     // MIs[2] Operand 1
     /* 226475 */     // No operand predicates
     /* 226475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226477 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1444:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 226477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 226480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226489 */     GIR_RootConstrainSelectedInstOperands,
     /* 226490 */     // GIR_Coverage, 7973,
     /* 226490 */     GIR_EraseRootFromParent_Done,
     /* 226491 */   // Label 4295: @226491
     /* 226491 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(226568), // Rule ID 7974 //
     /* 226496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 226504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 226540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226548 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 226552 */     // MIs[2] Operand 1
     /* 226552 */     // No operand predicates
     /* 226552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226554 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1444:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 226554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 226557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226566 */     GIR_RootConstrainSelectedInstOperands,
     /* 226567 */     // GIR_Coverage, 7974,
     /* 226567 */     GIR_EraseRootFromParent_Done,
     /* 226568 */   // Label 4296: @226568
     /* 226568 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(226645), // Rule ID 7975 //
     /* 226573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 226581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 226617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226625 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 226629 */     // MIs[2] Operand 1
     /* 226629 */     // No operand predicates
     /* 226629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226631 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1444:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 226631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 226634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226643 */     GIR_RootConstrainSelectedInstOperands,
     /* 226644 */     // GIR_Coverage, 7975,
     /* 226644 */     GIR_EraseRootFromParent_Done,
     /* 226645 */   // Label 4297: @226645
     /* 226645 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(226722), // Rule ID 7976 //
     /* 226650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 226658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 226694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226702 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 226706 */     // MIs[2] Operand 1
     /* 226706 */     // No operand predicates
     /* 226706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226708 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1444:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 226708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 226711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226720 */     GIR_RootConstrainSelectedInstOperands,
     /* 226721 */     // GIR_Coverage, 7976,
     /* 226721 */     GIR_EraseRootFromParent_Done,
     /* 226722 */   // Label 4298: @226722
     /* 226722 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(226799), // Rule ID 7977 //
     /* 226727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 226735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 226771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226779 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 226783 */     // MIs[2] Operand 1
     /* 226783 */     // No operand predicates
     /* 226783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226785 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1444:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 226785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 226788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226797 */     GIR_RootConstrainSelectedInstOperands,
     /* 226798 */     // GIR_Coverage, 7977,
     /* 226798 */     GIR_EraseRootFromParent_Done,
     /* 226799 */   // Label 4299: @226799
     /* 226799 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(226876), // Rule ID 7978 //
     /* 226804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 226812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 226848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226856 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 226860 */     // MIs[2] Operand 1
     /* 226860 */     // No operand predicates
     /* 226860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226862 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1444:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 226862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 226865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226874 */     GIR_RootConstrainSelectedInstOperands,
     /* 226875 */     // GIR_Coverage, 7978,
     /* 226875 */     GIR_EraseRootFromParent_Done,
     /* 226876 */   // Label 4300: @226876
     /* 226876 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(226932), // Rule ID 55 //
     /* 226881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 226884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 226889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 226892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 226895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 226898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 226902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 226906 */     // MIs[0] Operand 3
     /* 226906 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 226917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 226921 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 226921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 226924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 226928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 226930 */     GIR_RootConstrainSelectedInstOperands,
     /* 226931 */     // GIR_Coverage, 55,
     /* 226931 */     GIR_EraseRootFromParent_Done,
     /* 226932 */   // Label 4301: @226932
     /* 226932 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(226988), // Rule ID 56 //
     /* 226937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 226940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 226945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 226948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 226951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 226954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 226958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 226962 */     // MIs[0] Operand 3
     /* 226962 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 226973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 226977 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 226977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 226980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 226984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 226986 */     GIR_RootConstrainSelectedInstOperands,
     /* 226987 */     // GIR_Coverage, 56,
     /* 226987 */     GIR_EraseRootFromParent_Done,
     /* 226988 */   // Label 4302: @226988
     /* 226988 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(227044), // Rule ID 57 //
     /* 226993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 226996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 227001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 227004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 227007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 227010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 227014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 227018 */     // MIs[0] Operand 3
     /* 227018 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 227029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 227033 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 227033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 227036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 227040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 227042 */     GIR_RootConstrainSelectedInstOperands,
     /* 227043 */     // GIR_Coverage, 57,
     /* 227043 */     GIR_EraseRootFromParent_Done,
     /* 227044 */   // Label 4303: @227044
     /* 227044 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(227100), // Rule ID 58 //
     /* 227049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 227052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 227057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 227060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 227063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 227066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 227070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 227074 */     // MIs[0] Operand 3
     /* 227074 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 227085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 227089 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 227089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 227092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 227096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 227098 */     GIR_RootConstrainSelectedInstOperands,
     /* 227099 */     // GIR_Coverage, 58,
     /* 227099 */     GIR_EraseRootFromParent_Done,
     /* 227100 */   // Label 4304: @227100
     /* 227100 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(227155), // Rule ID 2799 //
     /* 227105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 227108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 227113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227134 */     // MIs[0] imm
     /* 227134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 227142 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1543:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 227142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 227145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 227149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 227151 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 227153 */     GIR_RootConstrainSelectedInstOperands,
     /* 227154 */     // GIR_Coverage, 2799,
     /* 227154 */     GIR_EraseRootFromParent_Done,
     /* 227155 */   // Label 4305: @227155
     /* 227155 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(227210), // Rule ID 2800 //
     /* 227160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 227163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 227168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227189 */     // MIs[0] imm
     /* 227189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227192 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 227197 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1543:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 227197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 227200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 227204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 227206 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 227208 */     GIR_RootConstrainSelectedInstOperands,
     /* 227209 */     // GIR_Coverage, 2800,
     /* 227209 */     GIR_EraseRootFromParent_Done,
     /* 227210 */   // Label 4306: @227210
     /* 227210 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(227265), // Rule ID 2801 //
     /* 227215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 227218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 227223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227244 */     // MIs[0] imm
     /* 227244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227247 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 227252 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1543:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 227252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 227255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 227259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 227261 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 227263 */     GIR_RootConstrainSelectedInstOperands,
     /* 227264 */     // GIR_Coverage, 2801,
     /* 227264 */     GIR_EraseRootFromParent_Done,
     /* 227265 */   // Label 4307: @227265
     /* 227265 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(227320), // Rule ID 3552 //
     /* 227270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 227273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 227278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 227287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227299 */     // MIs[0] Idx
     /* 227299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227302 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 227307 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1629:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 227307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 227310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 227314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 227316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 227318 */     GIR_RootConstrainSelectedInstOperands,
     /* 227319 */     // GIR_Coverage, 3552,
     /* 227319 */     GIR_EraseRootFromParent_Done,
     /* 227320 */   // Label 4308: @227320
     /* 227320 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(227375), // Rule ID 3553 //
     /* 227325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 227328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 227333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 227342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227354 */     // MIs[0] Idx
     /* 227354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227357 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 227362 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1629:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 227362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 227365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 227369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 227371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 227373 */     GIR_RootConstrainSelectedInstOperands,
     /* 227374 */     // GIR_Coverage, 3553,
     /* 227374 */     GIR_EraseRootFromParent_Done,
     /* 227375 */   // Label 4309: @227375
     /* 227375 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(227430), // Rule ID 3554 //
     /* 227380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 227383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 227388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 227397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227409 */     // MIs[0] Idx
     /* 227409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227412 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 227417 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1629:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 227417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 227420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 227424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 227426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 227428 */     GIR_RootConstrainSelectedInstOperands,
     /* 227429 */     // GIR_Coverage, 3554,
     /* 227429 */     GIR_EraseRootFromParent_Done,
     /* 227430 */   // Label 4310: @227430
     /* 227430 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(227485), // Rule ID 3844 //
     /* 227435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 227438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 227443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 227446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 227449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 227452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 227456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 227460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 227464 */     // MIs[0] imm
     /* 227464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 227472 */     // (intrinsic_wo_chain:{ *:[v2i64] } 544:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 227472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 227475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 227477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 227479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 227481 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 227483 */     GIR_RootConstrainSelectedInstOperands,
     /* 227484 */     // GIR_Coverage, 3844,
     /* 227484 */     GIR_EraseRootFromParent_Done,
     /* 227485 */   // Label 4311: @227485
     /* 227485 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(227532), // Rule ID 2853 //
     /* 227490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 227498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227511 */     // MIs[0] idx
     /* 227511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227519 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1479:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 227519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 227522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227528 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 227530 */     GIR_RootConstrainSelectedInstOperands,
     /* 227531 */     // GIR_Coverage, 2853,
     /* 227531 */     GIR_EraseRootFromParent_Done,
     /* 227532 */   // Label 4312: @227532
     /* 227532 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(227579), // Rule ID 2854 //
     /* 227537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 227545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227558 */     // MIs[0] idx
     /* 227558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227566 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1479:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 227566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 227569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227575 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 227577 */     GIR_RootConstrainSelectedInstOperands,
     /* 227578 */     // GIR_Coverage, 2854,
     /* 227578 */     GIR_EraseRootFromParent_Done,
     /* 227579 */   // Label 4313: @227579
     /* 227579 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(227626), // Rule ID 2855 //
     /* 227584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 227592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227605 */     // MIs[0] idx
     /* 227605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227608 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 227613 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1479:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 227613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 227616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227622 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 227624 */     GIR_RootConstrainSelectedInstOperands,
     /* 227625 */     // GIR_Coverage, 2855,
     /* 227625 */     GIR_EraseRootFromParent_Done,
     /* 227626 */   // Label 4314: @227626
     /* 227626 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(227673), // Rule ID 3004 //
     /* 227631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 227639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227652 */     // MIs[0] Op3
     /* 227652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1610:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 227663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227671 */     GIR_RootConstrainSelectedInstOperands,
     /* 227672 */     // GIR_Coverage, 3004,
     /* 227672 */     GIR_EraseRootFromParent_Done,
     /* 227673 */   // Label 4315: @227673
     /* 227673 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(227720), // Rule ID 3005 //
     /* 227678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 227686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227699 */     // MIs[0] Op3
     /* 227699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227707 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1610:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 227710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227718 */     GIR_RootConstrainSelectedInstOperands,
     /* 227719 */     // GIR_Coverage, 3005,
     /* 227719 */     GIR_EraseRootFromParent_Done,
     /* 227720 */   // Label 4316: @227720
     /* 227720 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(227767), // Rule ID 3006 //
     /* 227725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 227733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227746 */     // MIs[0] Op3
     /* 227746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227749 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 227754 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1610:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 227754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 227757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227765 */     GIR_RootConstrainSelectedInstOperands,
     /* 227766 */     // GIR_Coverage, 3006,
     /* 227766 */     GIR_EraseRootFromParent_Done,
     /* 227767 */   // Label 4317: @227767
     /* 227767 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(227814), // Rule ID 3007 //
     /* 227772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 227780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227793 */     // MIs[0] Op3
     /* 227793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227801 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 227804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227812 */     GIR_RootConstrainSelectedInstOperands,
     /* 227813 */     // GIR_Coverage, 3007,
     /* 227813 */     GIR_EraseRootFromParent_Done,
     /* 227814 */   // Label 4318: @227814
     /* 227814 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(227861), // Rule ID 3008 //
     /* 227819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 227827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227840 */     // MIs[0] Op3
     /* 227840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227848 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 227851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227859 */     GIR_RootConstrainSelectedInstOperands,
     /* 227860 */     // GIR_Coverage, 3008,
     /* 227860 */     GIR_EraseRootFromParent_Done,
     /* 227861 */   // Label 4319: @227861
     /* 227861 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(227908), // Rule ID 3056 //
     /* 227866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 227874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227887 */     // MIs[0] Op3
     /* 227887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227895 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1867:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 227898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227906 */     GIR_RootConstrainSelectedInstOperands,
     /* 227907 */     // GIR_Coverage, 3056,
     /* 227907 */     GIR_EraseRootFromParent_Done,
     /* 227908 */   // Label 4320: @227908
     /* 227908 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(227955), // Rule ID 3058 //
     /* 227913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 227921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227934 */     // MIs[0] Op3
     /* 227934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227942 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1867:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 227945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227953 */     GIR_RootConstrainSelectedInstOperands,
     /* 227954 */     // GIR_Coverage, 3058,
     /* 227954 */     GIR_EraseRootFromParent_Done,
     /* 227955 */   // Label 4321: @227955
     /* 227955 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(228002), // Rule ID 3060 //
     /* 227960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 227968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227981 */     // MIs[0] Op3
     /* 227981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227989 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 227992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228000 */     GIR_RootConstrainSelectedInstOperands,
     /* 228001 */     // GIR_Coverage, 3060,
     /* 228001 */     GIR_EraseRootFromParent_Done,
     /* 228002 */   // Label 4322: @228002
     /* 228002 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(228049), // Rule ID 3062 //
     /* 228007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 228015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228028 */     // MIs[0] Op3
     /* 228028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228036 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1867:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 228039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228047 */     GIR_RootConstrainSelectedInstOperands,
     /* 228048 */     // GIR_Coverage, 3062,
     /* 228048 */     GIR_EraseRootFromParent_Done,
     /* 228049 */   // Label 4323: @228049
     /* 228049 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(228096), // Rule ID 3084 //
     /* 228054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 228062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228075 */     // MIs[0] Op3
     /* 228075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228083 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1847:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 228086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228094 */     GIR_RootConstrainSelectedInstOperands,
     /* 228095 */     // GIR_Coverage, 3084,
     /* 228095 */     GIR_EraseRootFromParent_Done,
     /* 228096 */   // Label 4324: @228096
     /* 228096 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(228143), // Rule ID 3085 //
     /* 228101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 228109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228122 */     // MIs[0] Op3
     /* 228122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1847:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 228133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228141 */     GIR_RootConstrainSelectedInstOperands,
     /* 228142 */     // GIR_Coverage, 3085,
     /* 228142 */     GIR_EraseRootFromParent_Done,
     /* 228143 */   // Label 4325: @228143
     /* 228143 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(228190), // Rule ID 3086 //
     /* 228148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 228156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228169 */     // MIs[0] Op3
     /* 228169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1847:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 228180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228188 */     GIR_RootConstrainSelectedInstOperands,
     /* 228189 */     // GIR_Coverage, 3086,
     /* 228189 */     GIR_EraseRootFromParent_Done,
     /* 228190 */   // Label 4326: @228190
     /* 228190 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(228237), // Rule ID 3155 //
     /* 228195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 228203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228216 */     // MIs[0] Op3
     /* 228216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228224 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2148:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 228227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228235 */     GIR_RootConstrainSelectedInstOperands,
     /* 228236 */     // GIR_Coverage, 3155,
     /* 228236 */     GIR_EraseRootFromParent_Done,
     /* 228237 */   // Label 4327: @228237
     /* 228237 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(228284), // Rule ID 3156 //
     /* 228242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 228250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228263 */     // MIs[0] Op3
     /* 228263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228271 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2148:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 228274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228282 */     GIR_RootConstrainSelectedInstOperands,
     /* 228283 */     // GIR_Coverage, 3156,
     /* 228283 */     GIR_EraseRootFromParent_Done,
     /* 228284 */   // Label 4328: @228284
     /* 228284 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(228331), // Rule ID 3157 //
     /* 228289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 228297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228310 */     // MIs[0] Op3
     /* 228310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228313 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2148:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 228321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228329 */     GIR_RootConstrainSelectedInstOperands,
     /* 228330 */     // GIR_Coverage, 3157,
     /* 228330 */     GIR_EraseRootFromParent_Done,
     /* 228331 */   // Label 4329: @228331
     /* 228331 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(228378), // Rule ID 3158 //
     /* 228336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 228344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228357 */     // MIs[0] Op3
     /* 228357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228365 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2148:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 228368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228376 */     GIR_RootConstrainSelectedInstOperands,
     /* 228377 */     // GIR_Coverage, 3158,
     /* 228377 */     GIR_EraseRootFromParent_Done,
     /* 228378 */   // Label 4330: @228378
     /* 228378 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(228425), // Rule ID 3537 //
     /* 228383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 228386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 228391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228404 */     // MIs[0] Op3
     /* 228404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 228412 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1358:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 228412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 228415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228423 */     GIR_RootConstrainSelectedInstOperands,
     /* 228424 */     // GIR_Coverage, 3537,
     /* 228424 */     GIR_EraseRootFromParent_Done,
     /* 228425 */   // Label 4331: @228425
     /* 228425 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(228472), // Rule ID 3585 //
     /* 228430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 228433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 228438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228451 */     // MIs[0] Op3
     /* 228451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 228459 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1597:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 228459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 228462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228470 */     GIR_RootConstrainSelectedInstOperands,
     /* 228471 */     // GIR_Coverage, 3585,
     /* 228471 */     GIR_EraseRootFromParent_Done,
     /* 228472 */   // Label 4332: @228472
     /* 228472 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(228519), // Rule ID 3586 //
     /* 228477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 228480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 228485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228498 */     // MIs[0] Op3
     /* 228498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 228506 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1597:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 228506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 228509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228515 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228517 */     GIR_RootConstrainSelectedInstOperands,
     /* 228518 */     // GIR_Coverage, 3586,
     /* 228518 */     GIR_EraseRootFromParent_Done,
     /* 228519 */   // Label 4333: @228519
     /* 228519 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(228566), // Rule ID 3587 //
     /* 228524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 228527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 228532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228545 */     // MIs[0] Op3
     /* 228545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 228553 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1597:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 228553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 228556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228564 */     GIR_RootConstrainSelectedInstOperands,
     /* 228565 */     // GIR_Coverage, 3587,
     /* 228565 */     GIR_EraseRootFromParent_Done,
     /* 228566 */   // Label 4334: @228566
     /* 228566 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(228613), // Rule ID 3588 //
     /* 228571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 228574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 228579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228592 */     // MIs[0] Op3
     /* 228592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 228600 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1598:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 228600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 228603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228611 */     GIR_RootConstrainSelectedInstOperands,
     /* 228612 */     // GIR_Coverage, 3588,
     /* 228612 */     GIR_EraseRootFromParent_Done,
     /* 228613 */   // Label 4335: @228613
     /* 228613 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(228660), // Rule ID 3589 //
     /* 228618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 228621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 228626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228639 */     // MIs[0] Op3
     /* 228639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 228647 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1598:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 228647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 228650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228658 */     GIR_RootConstrainSelectedInstOperands,
     /* 228659 */     // GIR_Coverage, 3589,
     /* 228659 */     GIR_EraseRootFromParent_Done,
     /* 228660 */   // Label 4336: @228660
     /* 228660 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(228707), // Rule ID 3590 //
     /* 228665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 228668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 228673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228686 */     // MIs[0] Op3
     /* 228686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228689 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 228694 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1598:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 228694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 228697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228705 */     GIR_RootConstrainSelectedInstOperands,
     /* 228706 */     // GIR_Coverage, 3590,
     /* 228706 */     GIR_EraseRootFromParent_Done,
     /* 228707 */   // Label 4337: @228707
     /* 228707 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(228754), // Rule ID 11395 //
     /* 228712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 228720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228733 */     // MIs[0] Op3
     /* 228733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 228741 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1797:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 228741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 228744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228752 */     GIR_RootConstrainSelectedInstOperands,
     /* 228753 */     // GIR_Coverage, 11395,
     /* 228753 */     GIR_EraseRootFromParent_Done,
     /* 228754 */   // Label 4338: @228754
     /* 228754 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(228801), // Rule ID 11396 //
     /* 228759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 228767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228780 */     // MIs[0] Op3
     /* 228780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 228788 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1797:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 228788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 228791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228799 */     GIR_RootConstrainSelectedInstOperands,
     /* 228800 */     // GIR_Coverage, 11396,
     /* 228800 */     GIR_EraseRootFromParent_Done,
     /* 228801 */   // Label 4339: @228801
     /* 228801 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(228848), // Rule ID 11397 //
     /* 228806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 228814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228827 */     // MIs[0] Op3
     /* 228827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 228835 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1797:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 228835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 228838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228846 */     GIR_RootConstrainSelectedInstOperands,
     /* 228847 */     // GIR_Coverage, 11397,
     /* 228847 */     GIR_EraseRootFromParent_Done,
     /* 228848 */   // Label 4340: @228848
     /* 228848 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(228895), // Rule ID 11398 //
     /* 228853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 228861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228874 */     // MIs[0] Op3
     /* 228874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 228882 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1828:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 228882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 228885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228893 */     GIR_RootConstrainSelectedInstOperands,
     /* 228894 */     // GIR_Coverage, 11398,
     /* 228894 */     GIR_EraseRootFromParent_Done,
     /* 228895 */   // Label 4341: @228895
     /* 228895 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(228942), // Rule ID 11399 //
     /* 228900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 228908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228921 */     // MIs[0] Op3
     /* 228921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 228929 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1828:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 228929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 228932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228940 */     GIR_RootConstrainSelectedInstOperands,
     /* 228941 */     // GIR_Coverage, 11399,
     /* 228941 */     GIR_EraseRootFromParent_Done,
     /* 228942 */   // Label 4342: @228942
     /* 228942 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(228989), // Rule ID 11400 //
     /* 228947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 228955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228968 */     // MIs[0] Op3
     /* 228968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228971 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 228976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1828:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 228976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 228979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228987 */     GIR_RootConstrainSelectedInstOperands,
     /* 228988 */     // GIR_Coverage, 11400,
     /* 228988 */     GIR_EraseRootFromParent_Done,
     /* 228989 */   // Label 4343: @228989
     /* 228989 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(229036), // Rule ID 11423 //
     /* 228994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 229002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229015 */     // MIs[0] Op3
     /* 229015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 229023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1758:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 229023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 229026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229032 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229034 */     GIR_RootConstrainSelectedInstOperands,
     /* 229035 */     // GIR_Coverage, 11423,
     /* 229035 */     GIR_EraseRootFromParent_Done,
     /* 229036 */   // Label 4344: @229036
     /* 229036 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(229083), // Rule ID 11424 //
     /* 229041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 229049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229062 */     // MIs[0] Op3
     /* 229062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 229070 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1758:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 229070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 229073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229081 */     GIR_RootConstrainSelectedInstOperands,
     /* 229082 */     // GIR_Coverage, 11424,
     /* 229082 */     GIR_EraseRootFromParent_Done,
     /* 229083 */   // Label 4345: @229083
     /* 229083 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(229130), // Rule ID 11425 //
     /* 229088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 229096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229109 */     // MIs[0] Op3
     /* 229109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 229117 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 229117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 229120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229128 */     GIR_RootConstrainSelectedInstOperands,
     /* 229129 */     // GIR_Coverage, 11425,
     /* 229129 */     GIR_EraseRootFromParent_Done,
     /* 229130 */   // Label 4346: @229130
     /* 229130 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(229177), // Rule ID 11426 //
     /* 229135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 229143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229156 */     // MIs[0] Op3
     /* 229156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 229164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 229164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 229167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229175 */     GIR_RootConstrainSelectedInstOperands,
     /* 229176 */     // GIR_Coverage, 11426,
     /* 229176 */     GIR_EraseRootFromParent_Done,
     /* 229177 */   // Label 4347: @229177
     /* 229177 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(229224), // Rule ID 11427 //
     /* 229182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 229190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229203 */     // MIs[0] Op3
     /* 229203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 229211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 229211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 229214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229222 */     GIR_RootConstrainSelectedInstOperands,
     /* 229223 */     // GIR_Coverage, 11427,
     /* 229223 */     GIR_EraseRootFromParent_Done,
     /* 229224 */   // Label 4348: @229224
     /* 229224 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(229271), // Rule ID 11428 //
     /* 229229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 229237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229250 */     // MIs[0] Op3
     /* 229250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 229258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1996:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 229258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 229261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229269 */     GIR_RootConstrainSelectedInstOperands,
     /* 229270 */     // GIR_Coverage, 11428,
     /* 229270 */     GIR_EraseRootFromParent_Done,
     /* 229271 */   // Label 4349: @229271
     /* 229271 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(229318), // Rule ID 11429 //
     /* 229276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 229284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229297 */     // MIs[0] Op3
     /* 229297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 229305 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1803:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 229305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 229308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229316 */     GIR_RootConstrainSelectedInstOperands,
     /* 229317 */     // GIR_Coverage, 11429,
     /* 229317 */     GIR_EraseRootFromParent_Done,
     /* 229318 */   // Label 4350: @229318
     /* 229318 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(229365), // Rule ID 11430 //
     /* 229323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 229331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229344 */     // MIs[0] Op3
     /* 229344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229347 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 229352 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1803:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 229352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 229355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229363 */     GIR_RootConstrainSelectedInstOperands,
     /* 229364 */     // GIR_Coverage, 11430,
     /* 229364 */     GIR_EraseRootFromParent_Done,
     /* 229365 */   // Label 4351: @229365
     /* 229365 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(229412), // Rule ID 11431 //
     /* 229370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 229378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229391 */     // MIs[0] Op3
     /* 229391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 229399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1805:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 229399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 229402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229410 */     GIR_RootConstrainSelectedInstOperands,
     /* 229411 */     // GIR_Coverage, 11431,
     /* 229411 */     GIR_EraseRootFromParent_Done,
     /* 229412 */   // Label 4352: @229412
     /* 229412 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(229459), // Rule ID 11432 //
     /* 229417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 229425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229438 */     // MIs[0] Op3
     /* 229438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 229446 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1805:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 229446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 229449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229455 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229457 */     GIR_RootConstrainSelectedInstOperands,
     /* 229458 */     // GIR_Coverage, 11432,
     /* 229458 */     GIR_EraseRootFromParent_Done,
     /* 229459 */   // Label 4353: @229459
     /* 229459 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(229506), // Rule ID 11676 //
     /* 229464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 229472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229485 */     // MIs[0] Op3
     /* 229485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229493 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1863:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 229496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229504 */     GIR_RootConstrainSelectedInstOperands,
     /* 229505 */     // GIR_Coverage, 11676,
     /* 229505 */     GIR_EraseRootFromParent_Done,
     /* 229506 */   // Label 4354: @229506
     /* 229506 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(229553), // Rule ID 11677 //
     /* 229511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 229519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229532 */     // MIs[0] Op3
     /* 229532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229540 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1863:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 229543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229549 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229551 */     GIR_RootConstrainSelectedInstOperands,
     /* 229552 */     // GIR_Coverage, 11677,
     /* 229552 */     GIR_EraseRootFromParent_Done,
     /* 229553 */   // Label 4355: @229553
     /* 229553 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(229600), // Rule ID 11678 //
     /* 229558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 229566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229579 */     // MIs[0] Op3
     /* 229579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229587 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 229590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229598 */     GIR_RootConstrainSelectedInstOperands,
     /* 229599 */     // GIR_Coverage, 11678,
     /* 229599 */     GIR_EraseRootFromParent_Done,
     /* 229600 */   // Label 4356: @229600
     /* 229600 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(229647), // Rule ID 11679 //
     /* 229605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 229613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229626 */     // MIs[0] Op3
     /* 229626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 229634 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1863:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 229634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 229637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229645 */     GIR_RootConstrainSelectedInstOperands,
     /* 229646 */     // GIR_Coverage, 11679,
     /* 229646 */     GIR_EraseRootFromParent_Done,
     /* 229647 */   // Label 4357: @229647
     /* 229647 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(229694), // Rule ID 11680 //
     /* 229652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 229660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229673 */     // MIs[0] Op3
     /* 229673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229681 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2054:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 229684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229692 */     GIR_RootConstrainSelectedInstOperands,
     /* 229693 */     // GIR_Coverage, 11680,
     /* 229693 */     GIR_EraseRootFromParent_Done,
     /* 229694 */   // Label 4358: @229694
     /* 229694 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(229741), // Rule ID 11682 //
     /* 229699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 229707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229720 */     // MIs[0] Op3
     /* 229720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2054:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 229731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229737 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229739 */     GIR_RootConstrainSelectedInstOperands,
     /* 229740 */     // GIR_Coverage, 11682,
     /* 229740 */     GIR_EraseRootFromParent_Done,
     /* 229741 */   // Label 4359: @229741
     /* 229741 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(229788), // Rule ID 11684 //
     /* 229746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 229754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229767 */     // MIs[0] Op3
     /* 229767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229775 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 229778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229786 */     GIR_RootConstrainSelectedInstOperands,
     /* 229787 */     // GIR_Coverage, 11684,
     /* 229787 */     GIR_EraseRootFromParent_Done,
     /* 229788 */   // Label 4360: @229788
     /* 229788 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(229835), // Rule ID 11686 //
     /* 229793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 229801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229814 */     // MIs[0] Op3
     /* 229814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229817 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 229822 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2054:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 229822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 229825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229833 */     GIR_RootConstrainSelectedInstOperands,
     /* 229834 */     // GIR_Coverage, 11686,
     /* 229834 */     GIR_EraseRootFromParent_Done,
     /* 229835 */   // Label 4361: @229835
     /* 229835 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(229882), // Rule ID 11688 //
     /* 229840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 229848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229861 */     // MIs[0] Op3
     /* 229861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 229869 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1843:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 229869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 229872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229880 */     GIR_RootConstrainSelectedInstOperands,
     /* 229881 */     // GIR_Coverage, 11688,
     /* 229881 */     GIR_EraseRootFromParent_Done,
     /* 229882 */   // Label 4362: @229882
     /* 229882 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(229929), // Rule ID 11689 //
     /* 229887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 229895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229908 */     // MIs[0] Op3
     /* 229908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 229916 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 229916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 229919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229925 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229927 */     GIR_RootConstrainSelectedInstOperands,
     /* 229928 */     // GIR_Coverage, 11689,
     /* 229928 */     GIR_EraseRootFromParent_Done,
     /* 229929 */   // Label 4363: @229929
     /* 229929 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(229976), // Rule ID 11690 //
     /* 229934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 229942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229955 */     // MIs[0] Op3
     /* 229955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229958 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 229963 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 229963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 229966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229974 */     GIR_RootConstrainSelectedInstOperands,
     /* 229975 */     // GIR_Coverage, 11690,
     /* 229975 */     GIR_EraseRootFromParent_Done,
     /* 229976 */   // Label 4364: @229976
     /* 229976 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(230023), // Rule ID 11691 //
     /* 229981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 229989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230002 */     // MIs[0] Op3
     /* 230002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 230010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1843:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 230010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 230013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230021 */     GIR_RootConstrainSelectedInstOperands,
     /* 230022 */     // GIR_Coverage, 11691,
     /* 230022 */     GIR_EraseRootFromParent_Done,
     /* 230023 */   // Label 4365: @230023
     /* 230023 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(230070), // Rule ID 11766 //
     /* 230028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 230036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230049 */     // MIs[0] Op3
     /* 230049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230052 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 230057 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2063:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 230057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 230060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230066 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230068 */     GIR_RootConstrainSelectedInstOperands,
     /* 230069 */     // GIR_Coverage, 11766,
     /* 230069 */     GIR_EraseRootFromParent_Done,
     /* 230070 */   // Label 4366: @230070
     /* 230070 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(230117), // Rule ID 11768 //
     /* 230075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 230083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230096 */     // MIs[0] Op3
     /* 230096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 230104 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2063:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 230104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 230107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230115 */     GIR_RootConstrainSelectedInstOperands,
     /* 230116 */     // GIR_Coverage, 11768,
     /* 230116 */     GIR_EraseRootFromParent_Done,
     /* 230117 */   // Label 4367: @230117
     /* 230117 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(230164), // Rule ID 11770 //
     /* 230122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 230130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230143 */     // MIs[0] Op3
     /* 230143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 230151 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2063:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 230151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 230154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230162 */     GIR_RootConstrainSelectedInstOperands,
     /* 230163 */     // GIR_Coverage, 11770,
     /* 230163 */     GIR_EraseRootFromParent_Done,
     /* 230164 */   // Label 4368: @230164
     /* 230164 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(230211), // Rule ID 11772 //
     /* 230169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 230177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230190 */     // MIs[0] Op3
     /* 230190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230193 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 230198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2063:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 230198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 230201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230209 */     GIR_RootConstrainSelectedInstOperands,
     /* 230210 */     // GIR_Coverage, 11772,
     /* 230210 */     GIR_EraseRootFromParent_Done,
     /* 230211 */   // Label 4369: @230211
     /* 230211 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(230258), // Rule ID 11774 //
     /* 230216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 230224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230237 */     // MIs[0] Op3
     /* 230237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 230245 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1864:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 230245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 230248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230256 */     GIR_RootConstrainSelectedInstOperands,
     /* 230257 */     // GIR_Coverage, 11774,
     /* 230257 */     GIR_EraseRootFromParent_Done,
     /* 230258 */   // Label 4370: @230258
     /* 230258 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(230305), // Rule ID 11775 //
     /* 230263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 230271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230284 */     // MIs[0] Op3
     /* 230284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 230292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1864:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 230292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 230295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230303 */     GIR_RootConstrainSelectedInstOperands,
     /* 230304 */     // GIR_Coverage, 11775,
     /* 230304 */     GIR_EraseRootFromParent_Done,
     /* 230305 */   // Label 4371: @230305
     /* 230305 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(230352), // Rule ID 11776 //
     /* 230310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 230318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230331 */     // MIs[0] Op3
     /* 230331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 230339 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 230339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 230342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230350 */     GIR_RootConstrainSelectedInstOperands,
     /* 230351 */     // GIR_Coverage, 11776,
     /* 230351 */     GIR_EraseRootFromParent_Done,
     /* 230352 */   // Label 4372: @230352
     /* 230352 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(230399), // Rule ID 11777 //
     /* 230357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 230365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230378 */     // MIs[0] Op3
     /* 230378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230381 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 230386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1864:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 230386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 230389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230395 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230397 */     GIR_RootConstrainSelectedInstOperands,
     /* 230398 */     // GIR_Coverage, 11777,
     /* 230398 */     GIR_EraseRootFromParent_Done,
     /* 230399 */   // Label 4373: @230399
     /* 230399 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(230446), // Rule ID 11782 //
     /* 230404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 230412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230425 */     // MIs[0] Op3
     /* 230425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230428 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 230433 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2056:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 230433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 230436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230444 */     GIR_RootConstrainSelectedInstOperands,
     /* 230445 */     // GIR_Coverage, 11782,
     /* 230445 */     GIR_EraseRootFromParent_Done,
     /* 230446 */   // Label 4374: @230446
     /* 230446 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(230493), // Rule ID 11783 //
     /* 230451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 230459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230472 */     // MIs[0] Op3
     /* 230472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 230480 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2056:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 230480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 230483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230489 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230491 */     GIR_RootConstrainSelectedInstOperands,
     /* 230492 */     // GIR_Coverage, 11783,
     /* 230492 */     GIR_EraseRootFromParent_Done,
     /* 230493 */   // Label 4375: @230493
     /* 230493 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(230540), // Rule ID 11784 //
     /* 230498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 230506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230519 */     // MIs[0] Op3
     /* 230519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230522 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 230527 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2056:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 230527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 230530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230536 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230538 */     GIR_RootConstrainSelectedInstOperands,
     /* 230539 */     // GIR_Coverage, 11784,
     /* 230539 */     GIR_EraseRootFromParent_Done,
     /* 230540 */   // Label 4376: @230540
     /* 230540 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(230587), // Rule ID 11785 //
     /* 230545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 230553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230566 */     // MIs[0] Op3
     /* 230566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 230574 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2056:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 230574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 230577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230585 */     GIR_RootConstrainSelectedInstOperands,
     /* 230586 */     // GIR_Coverage, 11785,
     /* 230586 */     GIR_EraseRootFromParent_Done,
     /* 230587 */   // Label 4377: @230587
     /* 230587 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(230634), // Rule ID 11845 //
     /* 230592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 230600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230613 */     // MIs[0] Op3
     /* 230613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230616 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 230621 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1841:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 230621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 230624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230632 */     GIR_RootConstrainSelectedInstOperands,
     /* 230633 */     // GIR_Coverage, 11845,
     /* 230633 */     GIR_EraseRootFromParent_Done,
     /* 230634 */   // Label 4378: @230634
     /* 230634 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(230681), // Rule ID 11846 //
     /* 230639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 230647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230660 */     // MIs[0] Op3
     /* 230660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 230668 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 230668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 230671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230679 */     GIR_RootConstrainSelectedInstOperands,
     /* 230680 */     // GIR_Coverage, 11846,
     /* 230680 */     GIR_EraseRootFromParent_Done,
     /* 230681 */   // Label 4379: @230681
     /* 230681 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(230728), // Rule ID 11847 //
     /* 230686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 230694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230707 */     // MIs[0] Op3
     /* 230707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 230715 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 230715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 230718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230726 */     GIR_RootConstrainSelectedInstOperands,
     /* 230727 */     // GIR_Coverage, 11847,
     /* 230727 */     GIR_EraseRootFromParent_Done,
     /* 230728 */   // Label 4380: @230728
     /* 230728 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(230775), // Rule ID 11848 //
     /* 230733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 230741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230754 */     // MIs[0] Op3
     /* 230754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230757 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 230762 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1720:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 230762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 230765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230773 */     GIR_RootConstrainSelectedInstOperands,
     /* 230774 */     // GIR_Coverage, 11848,
     /* 230774 */     GIR_EraseRootFromParent_Done,
     /* 230775 */   // Label 4381: @230775
     /* 230775 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(230822), // Rule ID 11849 //
     /* 230780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 230788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230801 */     // MIs[0] Op3
     /* 230801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 230809 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1720:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 230809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 230812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230820 */     GIR_RootConstrainSelectedInstOperands,
     /* 230821 */     // GIR_Coverage, 11849,
     /* 230821 */     GIR_EraseRootFromParent_Done,
     /* 230822 */   // Label 4382: @230822
     /* 230822 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(230869), // Rule ID 11850 //
     /* 230827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 230835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230848 */     // MIs[0] Op3
     /* 230848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230851 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 230856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1720:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 230856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 230859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230867 */     GIR_RootConstrainSelectedInstOperands,
     /* 230868 */     // GIR_Coverage, 11850,
     /* 230868 */     GIR_EraseRootFromParent_Done,
     /* 230869 */   // Label 4383: @230869
     /* 230869 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(230916), // Rule ID 11851 //
     /* 230874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 230882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230895 */     // MIs[0] Op3
     /* 230895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 230903 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1678:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 230903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 230906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230914 */     GIR_RootConstrainSelectedInstOperands,
     /* 230915 */     // GIR_Coverage, 11851,
     /* 230915 */     GIR_EraseRootFromParent_Done,
     /* 230916 */   // Label 4384: @230916
     /* 230916 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(230963), // Rule ID 11852 //
     /* 230921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 230929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230942 */     // MIs[0] Op3
     /* 230942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 230950 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1678:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 230950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 230953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230961 */     GIR_RootConstrainSelectedInstOperands,
     /* 230962 */     // GIR_Coverage, 11852,
     /* 230962 */     GIR_EraseRootFromParent_Done,
     /* 230963 */   // Label 4385: @230963
     /* 230963 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(231010), // Rule ID 11853 //
     /* 230968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 230976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230989 */     // MIs[0] Op3
     /* 230989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 230997 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1678:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 230997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 231000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231008 */     GIR_RootConstrainSelectedInstOperands,
     /* 231009 */     // GIR_Coverage, 11853,
     /* 231009 */     GIR_EraseRootFromParent_Done,
     /* 231010 */   // Label 4386: @231010
     /* 231010 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(231057), // Rule ID 11854 //
     /* 231015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 231023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231036 */     // MIs[0] Op3
     /* 231036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 231044 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1845:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 231044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 231047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231055 */     GIR_RootConstrainSelectedInstOperands,
     /* 231056 */     // GIR_Coverage, 11854,
     /* 231056 */     GIR_EraseRootFromParent_Done,
     /* 231057 */   // Label 4387: @231057
     /* 231057 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(231104), // Rule ID 11855 //
     /* 231062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 231070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231083 */     // MIs[0] Op3
     /* 231083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 231091 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1845:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 231091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 231094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231102 */     GIR_RootConstrainSelectedInstOperands,
     /* 231103 */     // GIR_Coverage, 11855,
     /* 231103 */     GIR_EraseRootFromParent_Done,
     /* 231104 */   // Label 4388: @231104
     /* 231104 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(231151), // Rule ID 11856 //
     /* 231109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 231117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231130 */     // MIs[0] Op3
     /* 231130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 231138 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1845:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 231138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 231141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231149 */     GIR_RootConstrainSelectedInstOperands,
     /* 231150 */     // GIR_Coverage, 11856,
     /* 231150 */     GIR_EraseRootFromParent_Done,
     /* 231151 */   // Label 4389: @231151
     /* 231151 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(231198), // Rule ID 11857 //
     /* 231156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 231164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231177 */     // MIs[0] Op3
     /* 231177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 231185 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1835:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 231185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 231188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231196 */     GIR_RootConstrainSelectedInstOperands,
     /* 231197 */     // GIR_Coverage, 11857,
     /* 231197 */     GIR_EraseRootFromParent_Done,
     /* 231198 */   // Label 4390: @231198
     /* 231198 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(231245), // Rule ID 11858 //
     /* 231203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 231211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231224 */     // MIs[0] Op3
     /* 231224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 231232 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1835:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 231232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 231235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231243 */     GIR_RootConstrainSelectedInstOperands,
     /* 231244 */     // GIR_Coverage, 11858,
     /* 231244 */     GIR_EraseRootFromParent_Done,
     /* 231245 */   // Label 4391: @231245
     /* 231245 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(231292), // Rule ID 11859 //
     /* 231250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 231258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231271 */     // MIs[0] Op3
     /* 231271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231274 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 231279 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1835:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 231279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 231282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231290 */     GIR_RootConstrainSelectedInstOperands,
     /* 231291 */     // GIR_Coverage, 11859,
     /* 231291 */     GIR_EraseRootFromParent_Done,
     /* 231292 */   // Label 4392: @231292
     /* 231292 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(231339), // Rule ID 11860 //
     /* 231297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 231305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231318 */     // MIs[0] Op3
     /* 231318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 231326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2040:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 231326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 231329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231337 */     GIR_RootConstrainSelectedInstOperands,
     /* 231338 */     // GIR_Coverage, 11860,
     /* 231338 */     GIR_EraseRootFromParent_Done,
     /* 231339 */   // Label 4393: @231339
     /* 231339 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(231386), // Rule ID 11861 //
     /* 231344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 231352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231365 */     // MIs[0] Op3
     /* 231365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 231373 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2040:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 231373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 231376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231384 */     GIR_RootConstrainSelectedInstOperands,
     /* 231385 */     // GIR_Coverage, 11861,
     /* 231385 */     GIR_EraseRootFromParent_Done,
     /* 231386 */   // Label 4394: @231386
     /* 231386 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(231433), // Rule ID 11862 //
     /* 231391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 231399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231412 */     // MIs[0] Op3
     /* 231412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 231420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 231420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 231423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231429 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231431 */     GIR_RootConstrainSelectedInstOperands,
     /* 231432 */     // GIR_Coverage, 11862,
     /* 231432 */     GIR_EraseRootFromParent_Done,
     /* 231433 */   // Label 4395: @231433
     /* 231433 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(231480), // Rule ID 11863 //
     /* 231438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 231446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231459 */     // MIs[0] Op3
     /* 231459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 231467 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2037:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 231467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 231470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231478 */     GIR_RootConstrainSelectedInstOperands,
     /* 231479 */     // GIR_Coverage, 11863,
     /* 231479 */     GIR_EraseRootFromParent_Done,
     /* 231480 */   // Label 4396: @231480
     /* 231480 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(231527), // Rule ID 11864 //
     /* 231485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 231493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231506 */     // MIs[0] Op3
     /* 231506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231509 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 231514 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2037:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 231514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 231517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231525 */     GIR_RootConstrainSelectedInstOperands,
     /* 231526 */     // GIR_Coverage, 11864,
     /* 231526 */     GIR_EraseRootFromParent_Done,
     /* 231527 */   // Label 4397: @231527
     /* 231527 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(231574), // Rule ID 11865 //
     /* 231532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 231540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231553 */     // MIs[0] Op3
     /* 231553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 231561 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2037:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 231561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 231564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231572 */     GIR_RootConstrainSelectedInstOperands,
     /* 231573 */     // GIR_Coverage, 11865,
     /* 231573 */     GIR_EraseRootFromParent_Done,
     /* 231574 */   // Label 4398: @231574
     /* 231574 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(231641), // Rule ID 2604 //
     /* 231579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 231587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 231596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 231611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231613 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 231613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 231616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 231620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 231630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231639 */     GIR_RootConstrainSelectedInstOperands,
     /* 231640 */     // GIR_Coverage, 2604,
     /* 231640 */     GIR_EraseRootFromParent_Done,
     /* 231641 */   // Label 4399: @231641
     /* 231641 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(231708), // Rule ID 7776 //
     /* 231646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 231654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 231663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 231678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231680 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1311:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 231680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 231683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 231687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 231697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231706 */     GIR_RootConstrainSelectedInstOperands,
     /* 231707 */     // GIR_Coverage, 7776,
     /* 231707 */     GIR_EraseRootFromParent_Done,
     /* 231708 */   // Label 4400: @231708
     /* 231708 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(231775), // Rule ID 7778 //
     /* 231713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 231721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 231730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 231745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231747 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1311:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 231747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 231750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 231754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 231764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231773 */     GIR_RootConstrainSelectedInstOperands,
     /* 231774 */     // GIR_Coverage, 7778,
     /* 231774 */     GIR_EraseRootFromParent_Done,
     /* 231775 */   // Label 4401: @231775
     /* 231775 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(231842), // Rule ID 7780 //
     /* 231780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 231788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 231797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 231812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231814 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1311:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 231814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 231817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 231821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 231831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231840 */     GIR_RootConstrainSelectedInstOperands,
     /* 231841 */     // GIR_Coverage, 7780,
     /* 231841 */     GIR_EraseRootFromParent_Done,
     /* 231842 */   // Label 4402: @231842
     /* 231842 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(231909), // Rule ID 7782 //
     /* 231847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 231855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 231879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231881 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1311:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 231881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 231884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 231888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 231898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231905 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231907 */     GIR_RootConstrainSelectedInstOperands,
     /* 231908 */     // GIR_Coverage, 7782,
     /* 231908 */     GIR_EraseRootFromParent_Done,
     /* 231909 */   // Label 4403: @231909
     /* 231909 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(231976), // Rule ID 7812 //
     /* 231914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 231922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 231931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 231946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1331:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 231948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 231951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 231955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 231965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231974 */     GIR_RootConstrainSelectedInstOperands,
     /* 231975 */     // GIR_Coverage, 7812,
     /* 231975 */     GIR_EraseRootFromParent_Done,
     /* 231976 */   // Label 4404: @231976
     /* 231976 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(232043), // Rule ID 7814 //
     /* 231981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 231989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 231998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232015 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1331:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 232015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 232032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232041 */     GIR_RootConstrainSelectedInstOperands,
     /* 232042 */     // GIR_Coverage, 7814,
     /* 232042 */     GIR_EraseRootFromParent_Done,
     /* 232043 */   // Label 4405: @232043
     /* 232043 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(232110), // Rule ID 7816 //
     /* 232048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 232056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1331:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 232082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 232099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232108 */     GIR_RootConstrainSelectedInstOperands,
     /* 232109 */     // GIR_Coverage, 7816,
     /* 232109 */     GIR_EraseRootFromParent_Done,
     /* 232110 */   // Label 4406: @232110
     /* 232110 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(232177), // Rule ID 7818 //
     /* 232115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 232123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232149 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1331:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 232149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 232166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232175 */     GIR_RootConstrainSelectedInstOperands,
     /* 232176 */     // GIR_Coverage, 7818,
     /* 232176 */     GIR_EraseRootFromParent_Done,
     /* 232177 */   // Label 4407: @232177
     /* 232177 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(232244), // Rule ID 7824 //
     /* 232182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 232190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 232199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232216 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1617:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 232216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 232233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232242 */     GIR_RootConstrainSelectedInstOperands,
     /* 232243 */     // GIR_Coverage, 7824,
     /* 232243 */     GIR_EraseRootFromParent_Done,
     /* 232244 */   // Label 4408: @232244
     /* 232244 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(232311), // Rule ID 7826 //
     /* 232249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 232257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 232266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232283 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1617:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 232283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 232300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232309 */     GIR_RootConstrainSelectedInstOperands,
     /* 232310 */     // GIR_Coverage, 7826,
     /* 232310 */     GIR_EraseRootFromParent_Done,
     /* 232311 */   // Label 4409: @232311
     /* 232311 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(232378), // Rule ID 7828 //
     /* 232316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 232324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232350 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1617:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 232350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 232367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232376 */     GIR_RootConstrainSelectedInstOperands,
     /* 232377 */     // GIR_Coverage, 7828,
     /* 232377 */     GIR_EraseRootFromParent_Done,
     /* 232378 */   // Label 4410: @232378
     /* 232378 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(232445), // Rule ID 7830 //
     /* 232383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 232391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232417 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1617:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 232417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 232434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232443 */     GIR_RootConstrainSelectedInstOperands,
     /* 232444 */     // GIR_Coverage, 7830,
     /* 232444 */     GIR_EraseRootFromParent_Done,
     /* 232445 */   // Label 4411: @232445
     /* 232445 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(232512), // Rule ID 11558 //
     /* 232450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 232458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2055:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 232484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 232501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232510 */     GIR_RootConstrainSelectedInstOperands,
     /* 232511 */     // GIR_Coverage, 11558,
     /* 232511 */     GIR_EraseRootFromParent_Done,
     /* 232512 */   // Label 4412: @232512
     /* 232512 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(232579), // Rule ID 11560 //
     /* 232517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 232525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 232534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232551 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1760:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 232551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 232568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232577 */     GIR_RootConstrainSelectedInstOperands,
     /* 232578 */     // GIR_Coverage, 11560,
     /* 232578 */     GIR_EraseRootFromParent_Done,
     /* 232579 */   // Label 4413: @232579
     /* 232579 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(232646), // Rule ID 11562 //
     /* 232584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 232592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 232601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232618 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1760:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 232618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 232635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232644 */     GIR_RootConstrainSelectedInstOperands,
     /* 232645 */     // GIR_Coverage, 11562,
     /* 232645 */     GIR_EraseRootFromParent_Done,
     /* 232646 */   // Label 4414: @232646
     /* 232646 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(232713), // Rule ID 11564 //
     /* 232651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 232659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232685 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 232685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 232702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232709 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232711 */     GIR_RootConstrainSelectedInstOperands,
     /* 232712 */     // GIR_Coverage, 11564,
     /* 232712 */     GIR_EraseRootFromParent_Done,
     /* 232713 */   // Label 4415: @232713
     /* 232713 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(232780), // Rule ID 11566 //
     /* 232718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 232726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1760:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 232752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 232769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232778 */     GIR_RootConstrainSelectedInstOperands,
     /* 232779 */     // GIR_Coverage, 11566,
     /* 232779 */     GIR_EraseRootFromParent_Done,
     /* 232780 */   // Label 4416: @232780
     /* 232780 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(232847), // Rule ID 11572 //
     /* 232785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 232793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 232802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232819 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1820:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 232819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 232836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232843 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232845 */     GIR_RootConstrainSelectedInstOperands,
     /* 232846 */     // GIR_Coverage, 11572,
     /* 232846 */     GIR_EraseRootFromParent_Done,
     /* 232847 */   // Label 4417: @232847
     /* 232847 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(232914), // Rule ID 11574 //
     /* 232852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 232860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 232869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1820:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 232886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 232903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232912 */     GIR_RootConstrainSelectedInstOperands,
     /* 232913 */     // GIR_Coverage, 11574,
     /* 232913 */     GIR_EraseRootFromParent_Done,
     /* 232914 */   // Label 4418: @232914
     /* 232914 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(232981), // Rule ID 11576 //
     /* 232919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 232927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232953 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1820:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 232953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 232970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232979 */     GIR_RootConstrainSelectedInstOperands,
     /* 232980 */     // GIR_Coverage, 11576,
     /* 232980 */     GIR_EraseRootFromParent_Done,
     /* 232981 */   // Label 4419: @232981
     /* 232981 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(233048), // Rule ID 11578 //
     /* 232986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 232994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 233003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 233014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 233018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233020 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1820:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 233020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 233023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 233037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 233044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 233046 */     GIR_RootConstrainSelectedInstOperands,
     /* 233047 */     // GIR_Coverage, 11578,
     /* 233047 */     GIR_EraseRootFromParent_Done,
     /* 233048 */   // Label 4420: @233048
     /* 233048 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(233102), // Rule ID 30 //
     /* 233053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 233056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 233061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233089 */     // (intrinsic_wo_chain:{ *:[v4i32] } 677:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 233089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 233092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233100 */     GIR_RootConstrainSelectedInstOperands,
     /* 233101 */     // GIR_Coverage, 30,
     /* 233101 */     GIR_EraseRootFromParent_Done,
     /* 233102 */   // Label 4421: @233102
     /* 233102 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(233156), // Rule ID 31 //
     /* 233107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 233110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 233115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233143 */     // (intrinsic_wo_chain:{ *:[v4i32] } 738:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 233143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 233146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233154 */     GIR_RootConstrainSelectedInstOperands,
     /* 233155 */     // GIR_Coverage, 31,
     /* 233155 */     GIR_EraseRootFromParent_Done,
     /* 233156 */   // Label 4422: @233156
     /* 233156 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(233210), // Rule ID 32 //
     /* 233161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 233164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 233169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233197 */     // (intrinsic_wo_chain:{ *:[v4i32] } 754:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 233197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 233200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233208 */     GIR_RootConstrainSelectedInstOperands,
     /* 233209 */     // GIR_Coverage, 32,
     /* 233209 */     GIR_EraseRootFromParent_Done,
     /* 233210 */   // Label 4423: @233210
     /* 233210 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(233264), // Rule ID 39 //
     /* 233215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 233223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 233226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 233229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233251 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 233251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 233254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233262 */     GIR_RootConstrainSelectedInstOperands,
     /* 233263 */     // GIR_Coverage, 39,
     /* 233263 */     GIR_EraseRootFromParent_Done,
     /* 233264 */   // Label 4424: @233264
     /* 233264 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(233318), // Rule ID 40 //
     /* 233269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 233277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233305 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 233305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 233308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233316 */     GIR_RootConstrainSelectedInstOperands,
     /* 233317 */     // GIR_Coverage, 40,
     /* 233317 */     GIR_EraseRootFromParent_Done,
     /* 233318 */   // Label 4425: @233318
     /* 233318 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(233372), // Rule ID 41 //
     /* 233323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 233331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 233334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 233337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233359 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 233359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 233362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233368 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233370 */     GIR_RootConstrainSelectedInstOperands,
     /* 233371 */     // GIR_Coverage, 41,
     /* 233371 */     GIR_EraseRootFromParent_Done,
     /* 233372 */   // Label 4426: @233372
     /* 233372 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(233426), // Rule ID 42 //
     /* 233377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 233385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233413 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 233413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 233416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233424 */     GIR_RootConstrainSelectedInstOperands,
     /* 233425 */     // GIR_Coverage, 42,
     /* 233425 */     GIR_EraseRootFromParent_Done,
     /* 233426 */   // Label 4427: @233426
     /* 233426 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(233480), // Rule ID 43 //
     /* 233431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 233439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 233442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 233445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233467 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 233467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 233470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233478 */     GIR_RootConstrainSelectedInstOperands,
     /* 233479 */     // GIR_Coverage, 43,
     /* 233479 */     GIR_EraseRootFromParent_Done,
     /* 233480 */   // Label 4428: @233480
     /* 233480 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(233534), // Rule ID 44 //
     /* 233485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 233493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233521 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 233521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 233524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233532 */     GIR_RootConstrainSelectedInstOperands,
     /* 233533 */     // GIR_Coverage, 44,
     /* 233533 */     GIR_EraseRootFromParent_Done,
     /* 233534 */   // Label 4429: @233534
     /* 233534 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(233588), // Rule ID 45 //
     /* 233539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 233547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 233550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 233553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233575 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 233575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 233578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233586 */     GIR_RootConstrainSelectedInstOperands,
     /* 233587 */     // GIR_Coverage, 45,
     /* 233587 */     GIR_EraseRootFromParent_Done,
     /* 233588 */   // Label 4430: @233588
     /* 233588 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(233642), // Rule ID 46 //
     /* 233593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 233601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233629 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 233629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 233632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233640 */     GIR_RootConstrainSelectedInstOperands,
     /* 233641 */     // GIR_Coverage, 46,
     /* 233641 */     GIR_EraseRootFromParent_Done,
     /* 233642 */   // Label 4431: @233642
     /* 233642 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(233696), // Rule ID 1587 //
     /* 233647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 233650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 233655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233683 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 233683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 233686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233694 */     GIR_RootConstrainSelectedInstOperands,
     /* 233695 */     // GIR_Coverage, 1587,
     /* 233695 */     GIR_EraseRootFromParent_Done,
     /* 233696 */   // Label 4432: @233696
     /* 233696 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(233750), // Rule ID 1588 //
     /* 233701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 233704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 233709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233737 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 233737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 233740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233748 */     GIR_RootConstrainSelectedInstOperands,
     /* 233749 */     // GIR_Coverage, 1588,
     /* 233749 */     GIR_EraseRootFromParent_Done,
     /* 233750 */   // Label 4433: @233750
     /* 233750 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(233804), // Rule ID 1589 //
     /* 233755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 233758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 233763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 233766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 233769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 233772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 233775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233791 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 233791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 233794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233802 */     GIR_RootConstrainSelectedInstOperands,
     /* 233803 */     // GIR_Coverage, 1589,
     /* 233803 */     GIR_EraseRootFromParent_Done,
     /* 233804 */   // Label 4434: @233804
     /* 233804 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(233858), // Rule ID 1590 //
     /* 233809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 233812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 233817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233845 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 233845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 233848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233856 */     GIR_RootConstrainSelectedInstOperands,
     /* 233857 */     // GIR_Coverage, 1590,
     /* 233857 */     GIR_EraseRootFromParent_Done,
     /* 233858 */   // Label 4435: @233858
     /* 233858 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(233912), // Rule ID 1591 //
     /* 233863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 233866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 233871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233899 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 233899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 233902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233910 */     GIR_RootConstrainSelectedInstOperands,
     /* 233911 */     // GIR_Coverage, 1591,
     /* 233911 */     GIR_EraseRootFromParent_Done,
     /* 233912 */   // Label 4436: @233912
     /* 233912 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(233966), // Rule ID 1592 //
     /* 233917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 233920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 233925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233953 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 233953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 233956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233964 */     GIR_RootConstrainSelectedInstOperands,
     /* 233965 */     // GIR_Coverage, 1592,
     /* 233965 */     GIR_EraseRootFromParent_Done,
     /* 233966 */   // Label 4437: @233966
     /* 233966 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(234020), // Rule ID 1593 //
     /* 233971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 233974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 233979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 233982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 233985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 233988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 233991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234007 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 234007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 234010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234018 */     GIR_RootConstrainSelectedInstOperands,
     /* 234019 */     // GIR_Coverage, 1593,
     /* 234019 */     GIR_EraseRootFromParent_Done,
     /* 234020 */   // Label 4438: @234020
     /* 234020 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(234074), // Rule ID 1594 //
     /* 234025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 234028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 234033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234061 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 234064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234072 */     GIR_RootConstrainSelectedInstOperands,
     /* 234073 */     // GIR_Coverage, 1594,
     /* 234073 */     GIR_EraseRootFromParent_Done,
     /* 234074 */   // Label 4439: @234074
     /* 234074 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(234128), // Rule ID 2307 //
     /* 234079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 234082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 234087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234115 */     // (intrinsic_wo_chain:{ *:[v4i32] } 521:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 234118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234126 */     GIR_RootConstrainSelectedInstOperands,
     /* 234127 */     // GIR_Coverage, 2307,
     /* 234127 */     GIR_EraseRootFromParent_Done,
     /* 234128 */   // Label 4440: @234128
     /* 234128 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(234182), // Rule ID 2308 //
     /* 234133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 234136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 234141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234169 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 234172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234180 */     GIR_RootConstrainSelectedInstOperands,
     /* 234181 */     // GIR_Coverage, 2308,
     /* 234181 */     GIR_EraseRootFromParent_Done,
     /* 234182 */   // Label 4441: @234182
     /* 234182 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(234236), // Rule ID 2309 //
     /* 234187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 234190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 234195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234223 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 234226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234234 */     GIR_RootConstrainSelectedInstOperands,
     /* 234235 */     // GIR_Coverage, 2309,
     /* 234235 */     GIR_EraseRootFromParent_Done,
     /* 234236 */   // Label 4442: @234236
     /* 234236 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(234290), // Rule ID 2310 //
     /* 234241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 234244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 234249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234277 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 234280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234288 */     GIR_RootConstrainSelectedInstOperands,
     /* 234289 */     // GIR_Coverage, 2310,
     /* 234289 */     GIR_EraseRootFromParent_Done,
     /* 234290 */   // Label 4443: @234290
     /* 234290 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(234344), // Rule ID 2311 //
     /* 234295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 234298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 234303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234331 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 234334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234342 */     GIR_RootConstrainSelectedInstOperands,
     /* 234343 */     // GIR_Coverage, 2311,
     /* 234343 */     GIR_EraseRootFromParent_Done,
     /* 234344 */   // Label 4444: @234344
     /* 234344 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(234398), // Rule ID 2312 //
     /* 234349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 234352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 234357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234385 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 234388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234394 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234396 */     GIR_RootConstrainSelectedInstOperands,
     /* 234397 */     // GIR_Coverage, 2312,
     /* 234397 */     GIR_EraseRootFromParent_Done,
     /* 234398 */   // Label 4445: @234398
     /* 234398 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(234452), // Rule ID 2313 //
     /* 234403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 234406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 234411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234439 */     // (intrinsic_wo_chain:{ *:[v4i32] } 530:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 234442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234450 */     GIR_RootConstrainSelectedInstOperands,
     /* 234451 */     // GIR_Coverage, 2313,
     /* 234451 */     GIR_EraseRootFromParent_Done,
     /* 234452 */   // Label 4446: @234452
     /* 234452 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(234509), // Rule ID 3640 //
     /* 234457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 234460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 234465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 234468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 234474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 234481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 234493 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1652:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 234493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 234496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 234500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 234502 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 234504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234507 */     GIR_RootConstrainSelectedInstOperands,
     /* 234508 */     // GIR_Coverage, 3640,
     /* 234508 */     GIR_EraseRootFromParent_Done,
     /* 234509 */   // Label 4447: @234509
     /* 234509 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(234566), // Rule ID 3641 //
     /* 234514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 234517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 234522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 234525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 234531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 234538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 234550 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1652:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 234550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 234553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 234557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 234559 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 234561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234564 */     GIR_RootConstrainSelectedInstOperands,
     /* 234565 */     // GIR_Coverage, 3641,
     /* 234565 */     GIR_EraseRootFromParent_Done,
     /* 234566 */   // Label 4448: @234566
     /* 234566 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(234623), // Rule ID 3642 //
     /* 234571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 234574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 234579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 234582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 234595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 234607 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1652:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 234607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 234610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 234614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 234616 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 234618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234621 */     GIR_RootConstrainSelectedInstOperands,
     /* 234622 */     // GIR_Coverage, 3642,
     /* 234622 */     GIR_EraseRootFromParent_Done,
     /* 234623 */   // Label 4449: @234623
     /* 234623 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(234680), // Rule ID 3643 //
     /* 234628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 234631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 234636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 234639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 234652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 234664 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1652:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 234664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 234667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 234671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 234673 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 234675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234678 */     GIR_RootConstrainSelectedInstOperands,
     /* 234679 */     // GIR_Coverage, 3643,
     /* 234679 */     GIR_EraseRootFromParent_Done,
     /* 234680 */   // Label 4450: @234680
     /* 234680 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(234734), // Rule ID 3816 //
     /* 234685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 234688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 234693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234721 */     // (intrinsic_wo_chain:{ *:[v2i64] } 531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 234721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 234724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 234726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 234728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 234730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 234732 */     GIR_RootConstrainSelectedInstOperands,
     /* 234733 */     // GIR_Coverage, 3816,
     /* 234733 */     GIR_EraseRootFromParent_Done,
     /* 234734 */   // Label 4451: @234734
     /* 234734 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(234788), // Rule ID 3817 //
     /* 234739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 234742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 234747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234775 */     // (intrinsic_wo_chain:{ *:[v2i64] } 532:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 234775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 234778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 234780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 234782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 234784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 234786 */     GIR_RootConstrainSelectedInstOperands,
     /* 234787 */     // GIR_Coverage, 3817,
     /* 234787 */     GIR_EraseRootFromParent_Done,
     /* 234788 */   // Label 4452: @234788
     /* 234788 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(234842), // Rule ID 3818 //
     /* 234793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 234796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 234801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234829 */     // (intrinsic_wo_chain:{ *:[v2i64] } 534:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 234829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 234832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 234834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 234836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 234838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 234840 */     GIR_RootConstrainSelectedInstOperands,
     /* 234841 */     // GIR_Coverage, 3818,
     /* 234841 */     GIR_EraseRootFromParent_Done,
     /* 234842 */   // Label 4453: @234842
     /* 234842 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(234896), // Rule ID 3819 //
     /* 234847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 234850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 234855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 234858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 234861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 234864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 234867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234883 */     // (intrinsic_wo_chain:{ *:[v16i8] } 519:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 234883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 234886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 234888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 234890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 234892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 234894 */     GIR_RootConstrainSelectedInstOperands,
     /* 234895 */     // GIR_Coverage, 3819,
     /* 234895 */     GIR_EraseRootFromParent_Done,
     /* 234896 */   // Label 4454: @234896
     /* 234896 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(234950), // Rule ID 3820 //
     /* 234901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 234904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 234909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234937 */     // (intrinsic_wo_chain:{ *:[v8i16] } 519:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 234937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 234940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 234942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 234944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 234946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 234948 */     GIR_RootConstrainSelectedInstOperands,
     /* 234949 */     // GIR_Coverage, 3820,
     /* 234949 */     GIR_EraseRootFromParent_Done,
     /* 234950 */   // Label 4455: @234950
     /* 234950 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(235004), // Rule ID 3821 //
     /* 234955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 234958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 234963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234991 */     // (intrinsic_wo_chain:{ *:[v4i32] } 519:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 234991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 234994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 234996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 234998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235002 */     GIR_RootConstrainSelectedInstOperands,
     /* 235003 */     // GIR_Coverage, 3821,
     /* 235003 */     GIR_EraseRootFromParent_Done,
     /* 235004 */   // Label 4456: @235004
     /* 235004 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(235058), // Rule ID 3822 //
     /* 235009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 235017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 235020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 235023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 235026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 235029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235045 */     // (intrinsic_wo_chain:{ *:[v2i64] } 519:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 235045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 235048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235056 */     GIR_RootConstrainSelectedInstOperands,
     /* 235057 */     // GIR_Coverage, 3822,
     /* 235057 */     GIR_EraseRootFromParent_Done,
     /* 235058 */   // Label 4457: @235058
     /* 235058 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(235112), // Rule ID 3831 //
     /* 235063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 235071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 235083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235099 */     // (intrinsic_wo_chain:{ *:[v16i8] } 517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 235099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235110 */     GIR_RootConstrainSelectedInstOperands,
     /* 235111 */     // GIR_Coverage, 3831,
     /* 235111 */     GIR_EraseRootFromParent_Done,
     /* 235112 */   // Label 4458: @235112
     /* 235112 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(235166), // Rule ID 3832 //
     /* 235117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 235125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 235134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 235137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235153 */     // (intrinsic_wo_chain:{ *:[v8i16] } 517:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 235153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235164 */     GIR_RootConstrainSelectedInstOperands,
     /* 235165 */     // GIR_Coverage, 3832,
     /* 235165 */     GIR_EraseRootFromParent_Done,
     /* 235166 */   // Label 4459: @235166
     /* 235166 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(235220), // Rule ID 3833 //
     /* 235171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 235179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 235182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 235185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 235188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 235191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235207 */     // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 235207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235218 */     GIR_RootConstrainSelectedInstOperands,
     /* 235219 */     // GIR_Coverage, 3833,
     /* 235219 */     GIR_EraseRootFromParent_Done,
     /* 235220 */   // Label 4460: @235220
     /* 235220 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(235274), // Rule ID 3834 //
     /* 235225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 235233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 235236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 235239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 235242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 235245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235261 */     // (intrinsic_wo_chain:{ *:[v2i64] } 517:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 235261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235272 */     GIR_RootConstrainSelectedInstOperands,
     /* 235273 */     // GIR_Coverage, 3834,
     /* 235273 */     GIR_EraseRootFromParent_Done,
     /* 235274 */   // Label 4461: @235274
     /* 235274 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(235328), // Rule ID 3835 //
     /* 235279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 235287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 235299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235315 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 235315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 235318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235326 */     GIR_RootConstrainSelectedInstOperands,
     /* 235327 */     // GIR_Coverage, 3835,
     /* 235327 */     GIR_EraseRootFromParent_Done,
     /* 235328 */   // Label 4462: @235328
     /* 235328 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(235382), // Rule ID 3836 //
     /* 235333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 235341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 235350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 235353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235369 */     // (intrinsic_wo_chain:{ *:[v8i16] } 518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 235369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 235372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235380 */     GIR_RootConstrainSelectedInstOperands,
     /* 235381 */     // GIR_Coverage, 3836,
     /* 235381 */     GIR_EraseRootFromParent_Done,
     /* 235382 */   // Label 4463: @235382
     /* 235382 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(235436), // Rule ID 3837 //
     /* 235387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 235395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 235398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 235401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 235404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 235407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235423 */     // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 235423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 235426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235434 */     GIR_RootConstrainSelectedInstOperands,
     /* 235435 */     // GIR_Coverage, 3837,
     /* 235435 */     GIR_EraseRootFromParent_Done,
     /* 235436 */   // Label 4464: @235436
     /* 235436 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(235490), // Rule ID 3838 //
     /* 235441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 235449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 235452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 235455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 235458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 235461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235477 */     // (intrinsic_wo_chain:{ *:[v2i64] } 518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 235477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 235480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235488 */     GIR_RootConstrainSelectedInstOperands,
     /* 235489 */     // GIR_Coverage, 3838,
     /* 235489 */     GIR_EraseRootFromParent_Done,
     /* 235490 */   // Label 4465: @235490
     /* 235490 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(235544), // Rule ID 3839 //
     /* 235495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 235503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 235515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235531 */     // (intrinsic_wo_chain:{ *:[v16i8] } 516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 235531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235542 */     GIR_RootConstrainSelectedInstOperands,
     /* 235543 */     // GIR_Coverage, 3839,
     /* 235543 */     GIR_EraseRootFromParent_Done,
     /* 235544 */   // Label 4466: @235544
     /* 235544 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(235598), // Rule ID 3840 //
     /* 235549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 235557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 235566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 235569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235585 */     // (intrinsic_wo_chain:{ *:[v8i16] } 516:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 235585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235596 */     GIR_RootConstrainSelectedInstOperands,
     /* 235597 */     // GIR_Coverage, 3840,
     /* 235597 */     GIR_EraseRootFromParent_Done,
     /* 235598 */   // Label 4467: @235598
     /* 235598 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(235652), // Rule ID 3841 //
     /* 235603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 235611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 235614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 235617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 235620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 235623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235639 */     // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 235639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235650 */     GIR_RootConstrainSelectedInstOperands,
     /* 235651 */     // GIR_Coverage, 3841,
     /* 235651 */     GIR_EraseRootFromParent_Done,
     /* 235652 */   // Label 4468: @235652
     /* 235652 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(235706), // Rule ID 3842 //
     /* 235657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 235665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 235668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 235671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 235674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 235677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235693 */     // (intrinsic_wo_chain:{ *:[v2i64] } 516:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 235693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235704 */     GIR_RootConstrainSelectedInstOperands,
     /* 235705 */     // GIR_Coverage, 3842,
     /* 235705 */     GIR_EraseRootFromParent_Done,
     /* 235706 */   // Label 4469: @235706
     /* 235706 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(235760), // Rule ID 3846 //
     /* 235711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 235714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 235719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 235722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 235725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 235728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 235731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235747 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 235747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 235750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 235754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 235756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 235758 */     GIR_RootConstrainSelectedInstOperands,
     /* 235759 */     // GIR_Coverage, 3846,
     /* 235759 */     GIR_EraseRootFromParent_Done,
     /* 235760 */   // Label 4470: @235760
     /* 235760 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(235814), // Rule ID 3847 //
     /* 235765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 235768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 235773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 235776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 235779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 235782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 235785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235801 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 235801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 235804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 235806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235812 */     GIR_RootConstrainSelectedInstOperands,
     /* 235813 */     // GIR_Coverage, 3847,
     /* 235813 */     GIR_EraseRootFromParent_Done,
     /* 235814 */   // Label 4471: @235814
     /* 235814 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(235868), // Rule ID 3848 //
     /* 235819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 235822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 235827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 235830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 235833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 235836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 235839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235855 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 235855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 235858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 235860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235864 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235866 */     GIR_RootConstrainSelectedInstOperands,
     /* 235867 */     // GIR_Coverage, 3848,
     /* 235867 */     GIR_EraseRootFromParent_Done,
     /* 235868 */   // Label 4472: @235868
     /* 235868 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(235925), // Rule ID 3865 //
     /* 235873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 235876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 235881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 235884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 235887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 235890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 235893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235909 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 235909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 235912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 235920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235923 */     GIR_RootConstrainSelectedInstOperands,
     /* 235924 */     // GIR_Coverage, 3865,
     /* 235924 */     GIR_EraseRootFromParent_Done,
     /* 235925 */   // Label 4473: @235925
     /* 235925 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(235982), // Rule ID 3866 //
     /* 235930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 235933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 235938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 235941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 235944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 235947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 235950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235966 */     // (intrinsic_wo_chain:{ *:[v4f16] } 761:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 235966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 235969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 235977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 235980 */     GIR_RootConstrainSelectedInstOperands,
     /* 235981 */     // GIR_Coverage, 3866,
     /* 235981 */     GIR_EraseRootFromParent_Done,
     /* 235982 */   // Label 4474: @235982
     /* 235982 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(236039), // Rule ID 3867 //
     /* 235987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 235990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 235995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 235998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 236001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 236004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 236007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236023 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 236023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 236026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236032 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 236037 */     GIR_RootConstrainSelectedInstOperands,
     /* 236038 */     // GIR_Coverage, 3867,
     /* 236038 */     GIR_EraseRootFromParent_Done,
     /* 236039 */   // Label 4475: @236039
     /* 236039 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(236096), // Rule ID 3868 //
     /* 236044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 236047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 236052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 236055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 236058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 236061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 236064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236080 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 236080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 236083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 236094 */     GIR_RootConstrainSelectedInstOperands,
     /* 236095 */     // GIR_Coverage, 3868,
     /* 236095 */     GIR_EraseRootFromParent_Done,
     /* 236096 */   // Label 4476: @236096
     /* 236096 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(236153), // Rule ID 3873 //
     /* 236101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 236104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 236109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 236112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 236115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 236118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 236121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236137 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 236137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 236140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236151 */     GIR_RootConstrainSelectedInstOperands,
     /* 236152 */     // GIR_Coverage, 3873,
     /* 236152 */     GIR_EraseRootFromParent_Done,
     /* 236153 */   // Label 4477: @236153
     /* 236153 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(236210), // Rule ID 3874 //
     /* 236158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 236161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 236166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 236169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 236172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 236175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 236178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236194 */     // (intrinsic_wo_chain:{ *:[v8f16] } 761:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 236194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 236197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 236208 */     GIR_RootConstrainSelectedInstOperands,
     /* 236209 */     // GIR_Coverage, 3874,
     /* 236209 */     GIR_EraseRootFromParent_Done,
     /* 236210 */   // Label 4478: @236210
     /* 236210 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(236267), // Rule ID 3875 //
     /* 236215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 236218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 236223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 236226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 236229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 236232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 236235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236251 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 236251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 236254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 236265 */     GIR_RootConstrainSelectedInstOperands,
     /* 236266 */     // GIR_Coverage, 3875,
     /* 236266 */     GIR_EraseRootFromParent_Done,
     /* 236267 */   // Label 4479: @236267
     /* 236267 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(236324), // Rule ID 3876 //
     /* 236272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 236275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 236280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 236283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 236286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 236289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 236292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236308 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 236308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 236311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 236322 */     GIR_RootConstrainSelectedInstOperands,
     /* 236323 */     // GIR_Coverage, 3876,
     /* 236323 */     GIR_EraseRootFromParent_Done,
     /* 236324 */   // Label 4480: @236324
     /* 236324 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(236381), // Rule ID 3881 //
     /* 236329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 236337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 236340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 236343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 236346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 236349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236365 */     // (intrinsic_wo_chain:{ *:[v2f32] } 758:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 236365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 236368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236379 */     GIR_RootConstrainSelectedInstOperands,
     /* 236380 */     // GIR_Coverage, 3881,
     /* 236380 */     GIR_EraseRootFromParent_Done,
     /* 236381 */   // Label 4481: @236381
     /* 236381 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(236438), // Rule ID 3882 //
     /* 236386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 236394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 236397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 236400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 236403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 236406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236422 */     // (intrinsic_wo_chain:{ *:[v2f32] } 761:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 236422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 236425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 236436 */     GIR_RootConstrainSelectedInstOperands,
     /* 236437 */     // GIR_Coverage, 3882,
     /* 236437 */     GIR_EraseRootFromParent_Done,
     /* 236438 */   // Label 4482: @236438
     /* 236438 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(236495), // Rule ID 3883 //
     /* 236443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 236451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 236454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 236457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 236460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 236463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236479 */     // (intrinsic_wo_chain:{ *:[v2f32] } 759:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 236479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 236482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 236493 */     GIR_RootConstrainSelectedInstOperands,
     /* 236494 */     // GIR_Coverage, 3883,
     /* 236494 */     GIR_EraseRootFromParent_Done,
     /* 236495 */   // Label 4483: @236495
     /* 236495 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(236552), // Rule ID 3884 //
     /* 236500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 236508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 236511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 236514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 236517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 236520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236536 */     // (intrinsic_wo_chain:{ *:[v2f32] } 760:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 236536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 236539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 236550 */     GIR_RootConstrainSelectedInstOperands,
     /* 236551 */     // GIR_Coverage, 3884,
     /* 236551 */     GIR_EraseRootFromParent_Done,
     /* 236552 */   // Label 4484: @236552
     /* 236552 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(236609), // Rule ID 3885 //
     /* 236557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 236565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236593 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 236593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 236596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236607 */     GIR_RootConstrainSelectedInstOperands,
     /* 236608 */     // GIR_Coverage, 3885,
     /* 236608 */     GIR_EraseRootFromParent_Done,
     /* 236609 */   // Label 4485: @236609
     /* 236609 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(236666), // Rule ID 3886 //
     /* 236614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 236622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236650 */     // (intrinsic_wo_chain:{ *:[v4f32] } 761:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 236650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 236653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 236664 */     GIR_RootConstrainSelectedInstOperands,
     /* 236665 */     // GIR_Coverage, 3886,
     /* 236665 */     GIR_EraseRootFromParent_Done,
     /* 236666 */   // Label 4486: @236666
     /* 236666 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(236723), // Rule ID 3887 //
     /* 236671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 236679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236707 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 236707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 236710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 236721 */     GIR_RootConstrainSelectedInstOperands,
     /* 236722 */     // GIR_Coverage, 3887,
     /* 236722 */     GIR_EraseRootFromParent_Done,
     /* 236723 */   // Label 4487: @236723
     /* 236723 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(236780), // Rule ID 3888 //
     /* 236728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 236736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236764 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 236764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 236767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 236778 */     GIR_RootConstrainSelectedInstOperands,
     /* 236779 */     // GIR_Coverage, 3888,
     /* 236779 */     GIR_EraseRootFromParent_Done,
     /* 236780 */   // Label 4488: @236780
     /* 236780 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(236837), // Rule ID 3889 //
     /* 236785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 236793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 236796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 236799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 236802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 236805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236821 */     // (intrinsic_wo_chain:{ *:[v2f64] } 758:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 236821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 236824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236830 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236835 */     GIR_RootConstrainSelectedInstOperands,
     /* 236836 */     // GIR_Coverage, 3889,
     /* 236836 */     GIR_EraseRootFromParent_Done,
     /* 236837 */   // Label 4489: @236837
     /* 236837 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(236894), // Rule ID 3890 //
     /* 236842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 236850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 236853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 236856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 236859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 236862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236878 */     // (intrinsic_wo_chain:{ *:[v2f64] } 761:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 236878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 236881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 236892 */     GIR_RootConstrainSelectedInstOperands,
     /* 236893 */     // GIR_Coverage, 3890,
     /* 236893 */     GIR_EraseRootFromParent_Done,
     /* 236894 */   // Label 4490: @236894
     /* 236894 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(236951), // Rule ID 3891 //
     /* 236899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 236907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 236910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 236913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 236916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 236919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236935 */     // (intrinsic_wo_chain:{ *:[v2f64] } 759:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 236935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 236938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 236949 */     GIR_RootConstrainSelectedInstOperands,
     /* 236950 */     // GIR_Coverage, 3891,
     /* 236950 */     GIR_EraseRootFromParent_Done,
     /* 236951 */   // Label 4491: @236951
     /* 236951 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(237008), // Rule ID 3892 //
     /* 236956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 236964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 236967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 236970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 236973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 236976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236992 */     // (intrinsic_wo_chain:{ *:[v2f64] } 760:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 236992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 236995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 237001 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 237003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 237006 */     GIR_RootConstrainSelectedInstOperands,
     /* 237007 */     // GIR_Coverage, 3892,
     /* 237007 */     GIR_EraseRootFromParent_Done,
     /* 237008 */   // Label 4492: @237008
     /* 237008 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(237062), // Rule ID 5268 //
     /* 237013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 237016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 237021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237049 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 237049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 237052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 237054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 237056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 237058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 237060 */     GIR_RootConstrainSelectedInstOperands,
     /* 237061 */     // GIR_Coverage, 5268,
     /* 237061 */     GIR_EraseRootFromParent_Done,
     /* 237062 */   // Label 4493: @237062
     /* 237062 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(237116), // Rule ID 5269 //
     /* 237067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 237070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 237075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237103 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 237103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 237106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 237108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 237110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 237112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 237114 */     GIR_RootConstrainSelectedInstOperands,
     /* 237115 */     // GIR_Coverage, 5269,
     /* 237115 */     GIR_EraseRootFromParent_Done,
     /* 237116 */   // Label 4494: @237116
     /* 237116 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(237167), // Rule ID 5622 //
     /* 237121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 237126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 237129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 237132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 237135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 237138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 237142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 237146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 237154 */     // (intrinsic_wo_chain:{ *:[v8i8] } 721:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 237154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 237157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 237159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 237161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 237163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 237165 */     GIR_RootConstrainSelectedInstOperands,
     /* 237166 */     // GIR_Coverage, 5622,
     /* 237166 */     GIR_EraseRootFromParent_Done,
     /* 237167 */   // Label 4495: @237167
     /* 237167 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(237218), // Rule ID 5623 //
     /* 237172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 237177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 237180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 237183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 237186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 237189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237205 */     // (intrinsic_wo_chain:{ *:[v16i8] } 721:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 237205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 237208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 237210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 237212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 237214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 237216 */     GIR_RootConstrainSelectedInstOperands,
     /* 237217 */     // GIR_Coverage, 5623,
     /* 237217 */     GIR_EraseRootFromParent_Done,
     /* 237218 */   // Label 4496: @237218
     /* 237218 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(237260), // Rule ID 2699 //
     /* 237223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 237231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237247 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1919:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 237250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237258 */     GIR_RootConstrainSelectedInstOperands,
     /* 237259 */     // GIR_Coverage, 2699,
     /* 237259 */     GIR_EraseRootFromParent_Done,
     /* 237260 */   // Label 4497: @237260
     /* 237260 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(237302), // Rule ID 2700 //
     /* 237265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 237273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237289 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1919:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 237292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237300 */     GIR_RootConstrainSelectedInstOperands,
     /* 237301 */     // GIR_Coverage, 2700,
     /* 237301 */     GIR_EraseRootFromParent_Done,
     /* 237302 */   // Label 4498: @237302
     /* 237302 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(237344), // Rule ID 2701 //
     /* 237307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 237315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237331 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1919:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 237334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237342 */     GIR_RootConstrainSelectedInstOperands,
     /* 237343 */     // GIR_Coverage, 2701,
     /* 237343 */     GIR_EraseRootFromParent_Done,
     /* 237344 */   // Label 4499: @237344
     /* 237344 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(237386), // Rule ID 2702 //
     /* 237349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 237357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237373 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1919:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 237376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237384 */     GIR_RootConstrainSelectedInstOperands,
     /* 237385 */     // GIR_Coverage, 2702,
     /* 237385 */     GIR_EraseRootFromParent_Done,
     /* 237386 */   // Label 4500: @237386
     /* 237386 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(237428), // Rule ID 2703 //
     /* 237391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 237399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237415 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1919:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 237418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237426 */     GIR_RootConstrainSelectedInstOperands,
     /* 237427 */     // GIR_Coverage, 2703,
     /* 237427 */     GIR_EraseRootFromParent_Done,
     /* 237428 */   // Label 4501: @237428
     /* 237428 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(237470), // Rule ID 2704 //
     /* 237433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 237441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237457 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1919:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 237460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237468 */     GIR_RootConstrainSelectedInstOperands,
     /* 237469 */     // GIR_Coverage, 2704,
     /* 237469 */     GIR_EraseRootFromParent_Done,
     /* 237470 */   // Label 4502: @237470
     /* 237470 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(237512), // Rule ID 2705 //
     /* 237475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 237483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237499 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1919:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 237502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237510 */     GIR_RootConstrainSelectedInstOperands,
     /* 237511 */     // GIR_Coverage, 2705,
     /* 237511 */     GIR_EraseRootFromParent_Done,
     /* 237512 */   // Label 4503: @237512
     /* 237512 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(237554), // Rule ID 2744 //
     /* 237517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 237525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 237528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 237534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 237537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 237541 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1265:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 237541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 237544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237552 */     GIR_RootConstrainSelectedInstOperands,
     /* 237553 */     // GIR_Coverage, 2744,
     /* 237553 */     GIR_EraseRootFromParent_Done,
     /* 237554 */   // Label 4504: @237554
     /* 237554 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(237596), // Rule ID 2745 //
     /* 237559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 237567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 237570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 237576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 237579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 237583 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1265:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 237583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 237586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237594 */     GIR_RootConstrainSelectedInstOperands,
     /* 237595 */     // GIR_Coverage, 2745,
     /* 237595 */     GIR_EraseRootFromParent_Done,
     /* 237596 */   // Label 4505: @237596
     /* 237596 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(237638), // Rule ID 2746 //
     /* 237601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 237609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 237612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 237618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 237621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 237625 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1265:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 237625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 237628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237636 */     GIR_RootConstrainSelectedInstOperands,
     /* 237637 */     // GIR_Coverage, 2746,
     /* 237637 */     GIR_EraseRootFromParent_Done,
     /* 237638 */   // Label 4506: @237638
     /* 237638 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(237680), // Rule ID 2747 //
     /* 237643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 237651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 237654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 237660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 237663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 237667 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 237667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 237670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237678 */     GIR_RootConstrainSelectedInstOperands,
     /* 237679 */     // GIR_Coverage, 2747,
     /* 237679 */     GIR_EraseRootFromParent_Done,
     /* 237680 */   // Label 4507: @237680
     /* 237680 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(237722), // Rule ID 2748 //
     /* 237685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 237693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 237696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 237699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 237702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 237705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 237709 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1265:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 237709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 237712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237720 */     GIR_RootConstrainSelectedInstOperands,
     /* 237721 */     // GIR_Coverage, 2748,
     /* 237721 */     GIR_EraseRootFromParent_Done,
     /* 237722 */   // Label 4508: @237722
     /* 237722 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(237764), // Rule ID 2787 //
     /* 237727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 237735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237751 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1364:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 237754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237762 */     GIR_RootConstrainSelectedInstOperands,
     /* 237763 */     // GIR_Coverage, 2787,
     /* 237763 */     GIR_EraseRootFromParent_Done,
     /* 237764 */   // Label 4509: @237764
     /* 237764 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(237806), // Rule ID 2789 //
     /* 237769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 237777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237793 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1364:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 237793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 237796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237804 */     GIR_RootConstrainSelectedInstOperands,
     /* 237805 */     // GIR_Coverage, 2789,
     /* 237805 */     GIR_EraseRootFromParent_Done,
     /* 237806 */   // Label 4510: @237806
     /* 237806 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(237848), // Rule ID 2791 //
     /* 237811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 237819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237835 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1364:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 237835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 237838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237846 */     GIR_RootConstrainSelectedInstOperands,
     /* 237847 */     // GIR_Coverage, 2791,
     /* 237847 */     GIR_EraseRootFromParent_Done,
     /* 237848 */   // Label 4511: @237848
     /* 237848 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(237890), // Rule ID 2793 //
     /* 237853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 237861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237877 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1538:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 237880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237888 */     GIR_RootConstrainSelectedInstOperands,
     /* 237889 */     // GIR_Coverage, 2793,
     /* 237889 */     GIR_EraseRootFromParent_Done,
     /* 237890 */   // Label 4512: @237890
     /* 237890 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(237932), // Rule ID 2794 //
     /* 237895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 237903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237919 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1538:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 237922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237930 */     GIR_RootConstrainSelectedInstOperands,
     /* 237931 */     // GIR_Coverage, 2794,
     /* 237931 */     GIR_EraseRootFromParent_Done,
     /* 237932 */   // Label 4513: @237932
     /* 237932 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(237974), // Rule ID 2795 //
     /* 237937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 237945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237961 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1538:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 237964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237972 */     GIR_RootConstrainSelectedInstOperands,
     /* 237973 */     // GIR_Coverage, 2795,
     /* 237973 */     GIR_EraseRootFromParent_Done,
     /* 237974 */   // Label 4514: @237974
     /* 237974 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(238016), // Rule ID 2864 //
     /* 237979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 237987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 237996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238003 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1400:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 238006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238014 */     GIR_RootConstrainSelectedInstOperands,
     /* 238015 */     // GIR_Coverage, 2864,
     /* 238015 */     GIR_EraseRootFromParent_Done,
     /* 238016 */   // Label 4515: @238016
     /* 238016 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(238058), // Rule ID 2865 //
     /* 238021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 238029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 238038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238045 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1401:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 238048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238056 */     GIR_RootConstrainSelectedInstOperands,
     /* 238057 */     // GIR_Coverage, 2865,
     /* 238057 */     GIR_EraseRootFromParent_Done,
     /* 238058 */   // Label 4516: @238058
     /* 238058 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(238100), // Rule ID 2866 //
     /* 238063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 238071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 238080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238087 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1396:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 238090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238098 */     GIR_RootConstrainSelectedInstOperands,
     /* 238099 */     // GIR_Coverage, 2866,
     /* 238099 */     GIR_EraseRootFromParent_Done,
     /* 238100 */   // Label 4517: @238100
     /* 238100 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(238142), // Rule ID 2867 //
     /* 238105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 238113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 238122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238129 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1397:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 238132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238140 */     GIR_RootConstrainSelectedInstOperands,
     /* 238141 */     // GIR_Coverage, 2867,
     /* 238141 */     GIR_EraseRootFromParent_Done,
     /* 238142 */   // Label 4518: @238142
     /* 238142 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(238184), // Rule ID 2868 //
     /* 238147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 238155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 238164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238171 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1403:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 238174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238182 */     GIR_RootConstrainSelectedInstOperands,
     /* 238183 */     // GIR_Coverage, 2868,
     /* 238183 */     GIR_EraseRootFromParent_Done,
     /* 238184 */   // Label 4519: @238184
     /* 238184 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(238226), // Rule ID 2869 //
     /* 238189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 238197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238213 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1367:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 238216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238224 */     GIR_RootConstrainSelectedInstOperands,
     /* 238225 */     // GIR_Coverage, 2869,
     /* 238225 */     GIR_EraseRootFromParent_Done,
     /* 238226 */   // Label 4520: @238226
     /* 238226 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(238268), // Rule ID 2870 //
     /* 238231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 238239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238255 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 238258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238266 */     GIR_RootConstrainSelectedInstOperands,
     /* 238267 */     // GIR_Coverage, 2870,
     /* 238267 */     GIR_EraseRootFromParent_Done,
     /* 238268 */   // Label 4521: @238268
     /* 238268 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(238310), // Rule ID 2871 //
     /* 238273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 238281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238297 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 238300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238308 */     GIR_RootConstrainSelectedInstOperands,
     /* 238309 */     // GIR_Coverage, 2871,
     /* 238309 */     GIR_EraseRootFromParent_Done,
     /* 238310 */   // Label 4522: @238310
     /* 238310 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(238352), // Rule ID 2882 //
     /* 238315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 238323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 238332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238339 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1389:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 238342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238350 */     GIR_RootConstrainSelectedInstOperands,
     /* 238351 */     // GIR_Coverage, 2882,
     /* 238351 */     GIR_EraseRootFromParent_Done,
     /* 238352 */   // Label 4523: @238352
     /* 238352 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(238394), // Rule ID 2884 //
     /* 238357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 238365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 238374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238381 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1387:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 238384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238392 */     GIR_RootConstrainSelectedInstOperands,
     /* 238393 */     // GIR_Coverage, 2884,
     /* 238393 */     GIR_EraseRootFromParent_Done,
     /* 238394 */   // Label 4524: @238394
     /* 238394 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(238436), // Rule ID 2892 //
     /* 238399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 238407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 238416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238423 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1424:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 238426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238434 */     GIR_RootConstrainSelectedInstOperands,
     /* 238435 */     // GIR_Coverage, 2892,
     /* 238435 */     GIR_EraseRootFromParent_Done,
     /* 238436 */   // Label 4525: @238436
     /* 238436 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(238478), // Rule ID 2893 //
     /* 238441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 238449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 238458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238465 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1424:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 238468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238476 */     GIR_RootConstrainSelectedInstOperands,
     /* 238477 */     // GIR_Coverage, 2893,
     /* 238477 */     GIR_EraseRootFromParent_Done,
     /* 238478 */   // Label 4526: @238478
     /* 238478 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(238520), // Rule ID 2894 //
     /* 238483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 238491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 238500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238507 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1424:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 238510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238518 */     GIR_RootConstrainSelectedInstOperands,
     /* 238519 */     // GIR_Coverage, 2894,
     /* 238519 */     GIR_EraseRootFromParent_Done,
     /* 238520 */   // Label 4527: @238520
     /* 238520 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(238562), // Rule ID 2898 //
     /* 238525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 238533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 238542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238549 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1402:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 238552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238560 */     GIR_RootConstrainSelectedInstOperands,
     /* 238561 */     // GIR_Coverage, 2898,
     /* 238561 */     GIR_EraseRootFromParent_Done,
     /* 238562 */   // Label 4528: @238562
     /* 238562 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(238604), // Rule ID 2943 //
     /* 238567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 238575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238591 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1707:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 238594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238602 */     GIR_RootConstrainSelectedInstOperands,
     /* 238603 */     // GIR_Coverage, 2943,
     /* 238603 */     GIR_EraseRootFromParent_Done,
     /* 238604 */   // Label 4529: @238604
     /* 238604 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(238646), // Rule ID 2944 //
     /* 238609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 238617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238633 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1707:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 238636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238644 */     GIR_RootConstrainSelectedInstOperands,
     /* 238645 */     // GIR_Coverage, 2944,
     /* 238645 */     GIR_EraseRootFromParent_Done,
     /* 238646 */   // Label 4530: @238646
     /* 238646 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(238688), // Rule ID 2973 //
     /* 238651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 238659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238675 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1823:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 238678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238684 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238686 */     GIR_RootConstrainSelectedInstOperands,
     /* 238687 */     // GIR_Coverage, 2973,
     /* 238687 */     GIR_EraseRootFromParent_Done,
     /* 238688 */   // Label 4531: @238688
     /* 238688 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(238730), // Rule ID 2974 //
     /* 238693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 238701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238717 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1823:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 238720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238728 */     GIR_RootConstrainSelectedInstOperands,
     /* 238729 */     // GIR_Coverage, 2974,
     /* 238729 */     GIR_EraseRootFromParent_Done,
     /* 238730 */   // Label 4532: @238730
     /* 238730 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(238772), // Rule ID 2975 //
     /* 238735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 238743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 238762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238770 */     GIR_RootConstrainSelectedInstOperands,
     /* 238771 */     // GIR_Coverage, 2975,
     /* 238771 */     GIR_EraseRootFromParent_Done,
     /* 238772 */   // Label 4533: @238772
     /* 238772 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(238814), // Rule ID 2976 //
     /* 238777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 238785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238801 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1823:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 238804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238812 */     GIR_RootConstrainSelectedInstOperands,
     /* 238813 */     // GIR_Coverage, 2976,
     /* 238813 */     GIR_EraseRootFromParent_Done,
     /* 238814 */   // Label 4534: @238814
     /* 238814 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(238856), // Rule ID 2977 //
     /* 238819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 238827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1744:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 238846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238854 */     GIR_RootConstrainSelectedInstOperands,
     /* 238855 */     // GIR_Coverage, 2977,
     /* 238855 */     GIR_EraseRootFromParent_Done,
     /* 238856 */   // Label 4535: @238856
     /* 238856 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(238898), // Rule ID 2978 //
     /* 238861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 238869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238885 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1744:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 238888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238896 */     GIR_RootConstrainSelectedInstOperands,
     /* 238897 */     // GIR_Coverage, 2978,
     /* 238897 */     GIR_EraseRootFromParent_Done,
     /* 238898 */   // Label 4536: @238898
     /* 238898 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(238940), // Rule ID 2979 //
     /* 238903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 238911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1744:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 238930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238938 */     GIR_RootConstrainSelectedInstOperands,
     /* 238939 */     // GIR_Coverage, 2979,
     /* 238939 */     GIR_EraseRootFromParent_Done,
     /* 238940 */   // Label 4537: @238940
     /* 238940 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(238982), // Rule ID 3009 //
     /* 238945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 238953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238969 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1718:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 238972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238980 */     GIR_RootConstrainSelectedInstOperands,
     /* 238981 */     // GIR_Coverage, 3009,
     /* 238981 */     GIR_EraseRootFromParent_Done,
     /* 238982 */   // Label 4538: @238982
     /* 238982 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(239024), // Rule ID 3011 //
     /* 238987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 238995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239011 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1718:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 239014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239022 */     GIR_RootConstrainSelectedInstOperands,
     /* 239023 */     // GIR_Coverage, 3011,
     /* 239023 */     GIR_EraseRootFromParent_Done,
     /* 239024 */   // Label 4539: @239024
     /* 239024 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(239066), // Rule ID 3013 //
     /* 239029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 239037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239053 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1718:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 239056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239064 */     GIR_RootConstrainSelectedInstOperands,
     /* 239065 */     // GIR_Coverage, 3013,
     /* 239065 */     GIR_EraseRootFromParent_Done,
     /* 239066 */   // Label 4540: @239066
     /* 239066 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(239108), // Rule ID 3015 //
     /* 239071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 239079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239095 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1718:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 239098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239106 */     GIR_RootConstrainSelectedInstOperands,
     /* 239107 */     // GIR_Coverage, 3015,
     /* 239107 */     GIR_EraseRootFromParent_Done,
     /* 239108 */   // Label 4541: @239108
     /* 239108 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(239150), // Rule ID 3017 //
     /* 239113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 239121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239137 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1688:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 239140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239148 */     GIR_RootConstrainSelectedInstOperands,
     /* 239149 */     // GIR_Coverage, 3017,
     /* 239149 */     GIR_EraseRootFromParent_Done,
     /* 239150 */   // Label 4542: @239150
     /* 239150 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(239192), // Rule ID 3018 //
     /* 239155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 239163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239179 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 239182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239190 */     GIR_RootConstrainSelectedInstOperands,
     /* 239191 */     // GIR_Coverage, 3018,
     /* 239191 */     GIR_EraseRootFromParent_Done,
     /* 239192 */   // Label 4543: @239192
     /* 239192 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(239234), // Rule ID 3019 //
     /* 239197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 239205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239221 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1688:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 239224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239232 */     GIR_RootConstrainSelectedInstOperands,
     /* 239233 */     // GIR_Coverage, 3019,
     /* 239233 */     GIR_EraseRootFromParent_Done,
     /* 239234 */   // Label 4544: @239234
     /* 239234 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(239276), // Rule ID 3020 //
     /* 239239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 239247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 239256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 239266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239274 */     GIR_RootConstrainSelectedInstOperands,
     /* 239275 */     // GIR_Coverage, 3020,
     /* 239275 */     GIR_EraseRootFromParent_Done,
     /* 239276 */   // Label 4545: @239276
     /* 239276 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(239318), // Rule ID 3021 //
     /* 239281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 239289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239305 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1760:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 239308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239316 */     GIR_RootConstrainSelectedInstOperands,
     /* 239317 */     // GIR_Coverage, 3021,
     /* 239317 */     GIR_EraseRootFromParent_Done,
     /* 239318 */   // Label 4546: @239318
     /* 239318 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(239360), // Rule ID 3022 //
     /* 239323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 239331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 239340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239347 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1760:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 239350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239358 */     GIR_RootConstrainSelectedInstOperands,
     /* 239359 */     // GIR_Coverage, 3022,
     /* 239359 */     GIR_EraseRootFromParent_Done,
     /* 239360 */   // Label 4547: @239360
     /* 239360 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(239402), // Rule ID 3023 //
     /* 239365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 239373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 239382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 239392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239400 */     GIR_RootConstrainSelectedInstOperands,
     /* 239401 */     // GIR_Coverage, 3023,
     /* 239401 */     GIR_EraseRootFromParent_Done,
     /* 239402 */   // Label 4548: @239402
     /* 239402 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(239444), // Rule ID 3024 //
     /* 239407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 239415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 239424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239431 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1760:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 239434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239442 */     GIR_RootConstrainSelectedInstOperands,
     /* 239443 */     // GIR_Coverage, 3024,
     /* 239443 */     GIR_EraseRootFromParent_Done,
     /* 239444 */   // Label 4549: @239444
     /* 239444 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(239486), // Rule ID 3041 //
     /* 239449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 239457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239473 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1353:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 239476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239484 */     GIR_RootConstrainSelectedInstOperands,
     /* 239485 */     // GIR_Coverage, 3041,
     /* 239485 */     GIR_EraseRootFromParent_Done,
     /* 239486 */   // Label 4550: @239486
     /* 239486 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(239528), // Rule ID 3042 //
     /* 239491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 239499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239515 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1353:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 239518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239526 */     GIR_RootConstrainSelectedInstOperands,
     /* 239527 */     // GIR_Coverage, 3042,
     /* 239527 */     GIR_EraseRootFromParent_Done,
     /* 239528 */   // Label 4551: @239528
     /* 239528 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(239570), // Rule ID 3043 //
     /* 239533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 239541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239557 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1353:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 239560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239568 */     GIR_RootConstrainSelectedInstOperands,
     /* 239569 */     // GIR_Coverage, 3043,
     /* 239569 */     GIR_EraseRootFromParent_Done,
     /* 239570 */   // Label 4552: @239570
     /* 239570 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(239612), // Rule ID 3044 //
     /* 239575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 239583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239599 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1353:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 239602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239610 */     GIR_RootConstrainSelectedInstOperands,
     /* 239611 */     // GIR_Coverage, 3044,
     /* 239611 */     GIR_EraseRootFromParent_Done,
     /* 239612 */   // Label 4553: @239612
     /* 239612 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(239654), // Rule ID 3068 //
     /* 239617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 239625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239641 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1681:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 239644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239652 */     GIR_RootConstrainSelectedInstOperands,
     /* 239653 */     // GIR_Coverage, 3068,
     /* 239653 */     GIR_EraseRootFromParent_Done,
     /* 239654 */   // Label 4554: @239654
     /* 239654 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(239696), // Rule ID 3070 //
     /* 239659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 239667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239683 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1681:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 239686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239694 */     GIR_RootConstrainSelectedInstOperands,
     /* 239695 */     // GIR_Coverage, 3070,
     /* 239695 */     GIR_EraseRootFromParent_Done,
     /* 239696 */   // Label 4555: @239696
     /* 239696 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(239738), // Rule ID 3072 //
     /* 239701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 239709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239725 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1681:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 239728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239736 */     GIR_RootConstrainSelectedInstOperands,
     /* 239737 */     // GIR_Coverage, 3072,
     /* 239737 */     GIR_EraseRootFromParent_Done,
     /* 239738 */   // Label 4556: @239738
     /* 239738 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(239780), // Rule ID 3074 //
     /* 239743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 239751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239767 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1681:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 239770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239778 */     GIR_RootConstrainSelectedInstOperands,
     /* 239779 */     // GIR_Coverage, 3074,
     /* 239779 */     GIR_EraseRootFromParent_Done,
     /* 239780 */   // Label 4557: @239780
     /* 239780 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(239822), // Rule ID 3076 //
     /* 239785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 239793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239809 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1682:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 239812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239820 */     GIR_RootConstrainSelectedInstOperands,
     /* 239821 */     // GIR_Coverage, 3076,
     /* 239821 */     GIR_EraseRootFromParent_Done,
     /* 239822 */   // Label 4558: @239822
     /* 239822 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(239864), // Rule ID 3077 //
     /* 239827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 239835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239851 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1682:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 239854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239862 */     GIR_RootConstrainSelectedInstOperands,
     /* 239863 */     // GIR_Coverage, 3077,
     /* 239863 */     GIR_EraseRootFromParent_Done,
     /* 239864 */   // Label 4559: @239864
     /* 239864 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(239906), // Rule ID 3078 //
     /* 239869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 239877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239893 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1682:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 239896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239904 */     GIR_RootConstrainSelectedInstOperands,
     /* 239905 */     // GIR_Coverage, 3078,
     /* 239905 */     GIR_EraseRootFromParent_Done,
     /* 239906 */   // Label 4560: @239906
     /* 239906 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(239948), // Rule ID 3079 //
     /* 239911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 239919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239935 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1245:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 239938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239946 */     GIR_RootConstrainSelectedInstOperands,
     /* 239947 */     // GIR_Coverage, 3079,
     /* 239947 */     GIR_EraseRootFromParent_Done,
     /* 239948 */   // Label 4561: @239948
     /* 239948 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(239990), // Rule ID 3080 //
     /* 239953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 239961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1245:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 239980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239988 */     GIR_RootConstrainSelectedInstOperands,
     /* 239989 */     // GIR_Coverage, 3080,
     /* 239989 */     GIR_EraseRootFromParent_Done,
     /* 239990 */   // Label 4562: @239990
     /* 239990 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(240032), // Rule ID 3090 //
     /* 239995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 240003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240019 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1252:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 240022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240030 */     GIR_RootConstrainSelectedInstOperands,
     /* 240031 */     // GIR_Coverage, 3090,
     /* 240031 */     GIR_EraseRootFromParent_Done,
     /* 240032 */   // Label 4563: @240032
     /* 240032 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(240074), // Rule ID 3091 //
     /* 240037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 240045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240061 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1252:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 240064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240072 */     GIR_RootConstrainSelectedInstOperands,
     /* 240073 */     // GIR_Coverage, 3091,
     /* 240073 */     GIR_EraseRootFromParent_Done,
     /* 240074 */   // Label 4564: @240074
     /* 240074 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(240116), // Rule ID 3092 //
     /* 240079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 240087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240103 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1252:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 240106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240114 */     GIR_RootConstrainSelectedInstOperands,
     /* 240115 */     // GIR_Coverage, 3092,
     /* 240115 */     GIR_EraseRootFromParent_Done,
     /* 240116 */   // Label 4565: @240116
     /* 240116 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(240158), // Rule ID 3109 //
     /* 240121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 240129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 240138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240145 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1311:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 240145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 240148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 240152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 240154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 240156 */     GIR_RootConstrainSelectedInstOperands,
     /* 240157 */     // GIR_Coverage, 3109,
     /* 240157 */     GIR_EraseRootFromParent_Done,
     /* 240158 */   // Label 4566: @240158
     /* 240158 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(240200), // Rule ID 3110 //
     /* 240163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 240171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 240180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240187 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1311:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 240187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 240190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 240194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 240196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 240198 */     GIR_RootConstrainSelectedInstOperands,
     /* 240199 */     // GIR_Coverage, 3110,
     /* 240199 */     GIR_EraseRootFromParent_Done,
     /* 240200 */   // Label 4567: @240200
     /* 240200 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(240242), // Rule ID 3111 //
     /* 240205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 240213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 240222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240229 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1311:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 240229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 240232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 240236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 240238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 240240 */     GIR_RootConstrainSelectedInstOperands,
     /* 240241 */     // GIR_Coverage, 3111,
     /* 240241 */     GIR_EraseRootFromParent_Done,
     /* 240242 */   // Label 4568: @240242
     /* 240242 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(240284), // Rule ID 3112 //
     /* 240247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 240255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 240264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240271 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1311:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 240271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 240274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 240278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 240280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 240282 */     GIR_RootConstrainSelectedInstOperands,
     /* 240283 */     // GIR_Coverage, 3112,
     /* 240283 */     GIR_EraseRootFromParent_Done,
     /* 240284 */   // Label 4569: @240284
     /* 240284 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(240326), // Rule ID 3147 //
     /* 240289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 240297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240313 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1352:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 240316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240322 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240324 */     GIR_RootConstrainSelectedInstOperands,
     /* 240325 */     // GIR_Coverage, 3147,
     /* 240325 */     GIR_EraseRootFromParent_Done,
     /* 240326 */   // Label 4570: @240326
     /* 240326 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(240368), // Rule ID 3149 //
     /* 240331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 240339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240355 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1352:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 240358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240366 */     GIR_RootConstrainSelectedInstOperands,
     /* 240367 */     // GIR_Coverage, 3149,
     /* 240367 */     GIR_EraseRootFromParent_Done,
     /* 240368 */   // Label 4571: @240368
     /* 240368 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(240410), // Rule ID 3151 //
     /* 240373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 240381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240397 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1352:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 240400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240408 */     GIR_RootConstrainSelectedInstOperands,
     /* 240409 */     // GIR_Coverage, 3151,
     /* 240409 */     GIR_EraseRootFromParent_Done,
     /* 240410 */   // Label 4572: @240410
     /* 240410 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(240452), // Rule ID 3153 //
     /* 240415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 240423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240439 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1352:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 240442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240450 */     GIR_RootConstrainSelectedInstOperands,
     /* 240451 */     // GIR_Coverage, 3153,
     /* 240451 */     GIR_EraseRootFromParent_Done,
     /* 240452 */   // Label 4573: @240452
     /* 240452 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(240497), // Rule ID 3192 //
     /* 240457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 240465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 240468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240481 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1316:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 240484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240495 */     GIR_RootConstrainSelectedInstOperands,
     /* 240496 */     // GIR_Coverage, 3192,
     /* 240496 */     GIR_EraseRootFromParent_Done,
     /* 240497 */   // Label 4574: @240497
     /* 240497 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(240542), // Rule ID 3193 //
     /* 240502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 240510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 240513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240526 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1316:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 240529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240535 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240540 */     GIR_RootConstrainSelectedInstOperands,
     /* 240541 */     // GIR_Coverage, 3193,
     /* 240541 */     GIR_EraseRootFromParent_Done,
     /* 240542 */   // Label 4575: @240542
     /* 240542 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(240587), // Rule ID 3194 //
     /* 240547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 240555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 240558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240571 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1316:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 240574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240585 */     GIR_RootConstrainSelectedInstOperands,
     /* 240586 */     // GIR_Coverage, 3194,
     /* 240586 */     GIR_EraseRootFromParent_Done,
     /* 240587 */   // Label 4576: @240587
     /* 240587 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(240632), // Rule ID 3195 //
     /* 240592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 240600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 240603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240616 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1318:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 240619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240630 */     GIR_RootConstrainSelectedInstOperands,
     /* 240631 */     // GIR_Coverage, 3195,
     /* 240631 */     GIR_EraseRootFromParent_Done,
     /* 240632 */   // Label 4577: @240632
     /* 240632 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(240677), // Rule ID 3196 //
     /* 240637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 240645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 240648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240661 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1318:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 240664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240675 */     GIR_RootConstrainSelectedInstOperands,
     /* 240676 */     // GIR_Coverage, 3196,
     /* 240676 */     GIR_EraseRootFromParent_Done,
     /* 240677 */   // Label 4578: @240677
     /* 240677 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(240722), // Rule ID 3197 //
     /* 240682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 240690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 240693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240706 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1318:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 240709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240715 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240720 */     GIR_RootConstrainSelectedInstOperands,
     /* 240721 */     // GIR_Coverage, 3197,
     /* 240721 */     GIR_EraseRootFromParent_Done,
     /* 240722 */   // Label 4579: @240722
     /* 240722 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(240764), // Rule ID 3252 //
     /* 240727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 240735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 240738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240751 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1362:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 240754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240762 */     GIR_RootConstrainSelectedInstOperands,
     /* 240763 */     // GIR_Coverage, 3252,
     /* 240763 */     GIR_EraseRootFromParent_Done,
     /* 240764 */   // Label 4580: @240764
     /* 240764 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(240806), // Rule ID 3253 //
     /* 240769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 240777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 240780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240793 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1362:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 240796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240804 */     GIR_RootConstrainSelectedInstOperands,
     /* 240805 */     // GIR_Coverage, 3253,
     /* 240805 */     GIR_EraseRootFromParent_Done,
     /* 240806 */   // Label 4581: @240806
     /* 240806 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(240848), // Rule ID 3254 //
     /* 240811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 240819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 240822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240835 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1362:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 240838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240846 */     GIR_RootConstrainSelectedInstOperands,
     /* 240847 */     // GIR_Coverage, 3254,
     /* 240847 */     GIR_EraseRootFromParent_Done,
     /* 240848 */   // Label 4582: @240848
     /* 240848 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(240890), // Rule ID 3306 //
     /* 240853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 240861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240877 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1268:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 240880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240888 */     GIR_RootConstrainSelectedInstOperands,
     /* 240889 */     // GIR_Coverage, 3306,
     /* 240889 */     GIR_EraseRootFromParent_Done,
     /* 240890 */   // Label 4583: @240890
     /* 240890 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(240932), // Rule ID 3307 //
     /* 240895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 240903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240919 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1268:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 240922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240930 */     GIR_RootConstrainSelectedInstOperands,
     /* 240931 */     // GIR_Coverage, 3307,
     /* 240931 */     GIR_EraseRootFromParent_Done,
     /* 240932 */   // Label 4584: @240932
     /* 240932 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(240974), // Rule ID 3308 //
     /* 240937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 240945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240961 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1268:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 240964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240972 */     GIR_RootConstrainSelectedInstOperands,
     /* 240973 */     // GIR_Coverage, 3308,
     /* 240973 */     GIR_EraseRootFromParent_Done,
     /* 240974 */   // Label 4585: @240974
     /* 240974 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(241016), // Rule ID 3309 //
     /* 240979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 240987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241003 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1268:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 241006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241014 */     GIR_RootConstrainSelectedInstOperands,
     /* 241015 */     // GIR_Coverage, 3309,
     /* 241015 */     GIR_EraseRootFromParent_Done,
     /* 241016 */   // Label 4586: @241016
     /* 241016 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(241058), // Rule ID 3318 //
     /* 241021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 241029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241045 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1270:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 241048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241056 */     GIR_RootConstrainSelectedInstOperands,
     /* 241057 */     // GIR_Coverage, 3318,
     /* 241057 */     GIR_EraseRootFromParent_Done,
     /* 241058 */   // Label 4587: @241058
     /* 241058 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(241100), // Rule ID 3319 //
     /* 241063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 241071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241087 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1270:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 241090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241098 */     GIR_RootConstrainSelectedInstOperands,
     /* 241099 */     // GIR_Coverage, 3319,
     /* 241099 */     GIR_EraseRootFromParent_Done,
     /* 241100 */   // Label 4588: @241100
     /* 241100 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(241142), // Rule ID 3320 //
     /* 241105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 241113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241129 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1270:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 241132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241140 */     GIR_RootConstrainSelectedInstOperands,
     /* 241141 */     // GIR_Coverage, 3320,
     /* 241141 */     GIR_EraseRootFromParent_Done,
     /* 241142 */   // Label 4589: @241142
     /* 241142 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(241184), // Rule ID 3359 //
     /* 241147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 241155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241171 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1307:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 241174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241182 */     GIR_RootConstrainSelectedInstOperands,
     /* 241183 */     // GIR_Coverage, 3359,
     /* 241183 */     GIR_EraseRootFromParent_Done,
     /* 241184 */   // Label 4590: @241184
     /* 241184 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(241226), // Rule ID 3360 //
     /* 241189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 241197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241213 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1307:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 241216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241224 */     GIR_RootConstrainSelectedInstOperands,
     /* 241225 */     // GIR_Coverage, 3360,
     /* 241225 */     GIR_EraseRootFromParent_Done,
     /* 241226 */   // Label 4591: @241226
     /* 241226 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(241268), // Rule ID 3361 //
     /* 241231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 241239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1307:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 241258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241266 */     GIR_RootConstrainSelectedInstOperands,
     /* 241267 */     // GIR_Coverage, 3361,
     /* 241267 */     GIR_EraseRootFromParent_Done,
     /* 241268 */   // Label 4592: @241268
     /* 241268 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(241310), // Rule ID 3362 //
     /* 241273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 241281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241297 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1307:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 241300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241308 */     GIR_RootConstrainSelectedInstOperands,
     /* 241309 */     // GIR_Coverage, 3362,
     /* 241309 */     GIR_EraseRootFromParent_Done,
     /* 241310 */   // Label 4593: @241310
     /* 241310 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(241352), // Rule ID 3363 //
     /* 241315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 241323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241339 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1307:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 241342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241350 */     GIR_RootConstrainSelectedInstOperands,
     /* 241351 */     // GIR_Coverage, 3363,
     /* 241351 */     GIR_EraseRootFromParent_Done,
     /* 241352 */   // Label 4594: @241352
     /* 241352 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(241394), // Rule ID 3364 //
     /* 241357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 241365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241381 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1307:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 241384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241392 */     GIR_RootConstrainSelectedInstOperands,
     /* 241393 */     // GIR_Coverage, 3364,
     /* 241393 */     GIR_EraseRootFromParent_Done,
     /* 241394 */   // Label 4595: @241394
     /* 241394 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(241436), // Rule ID 3365 //
     /* 241399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 241407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241423 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1307:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 241426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241434 */     GIR_RootConstrainSelectedInstOperands,
     /* 241435 */     // GIR_Coverage, 3365,
     /* 241435 */     GIR_EraseRootFromParent_Done,
     /* 241436 */   // Label 4596: @241436
     /* 241436 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(241478), // Rule ID 3448 //
     /* 241441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 241449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241465 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1299:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 241468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241476 */     GIR_RootConstrainSelectedInstOperands,
     /* 241477 */     // GIR_Coverage, 3448,
     /* 241477 */     GIR_EraseRootFromParent_Done,
     /* 241478 */   // Label 4597: @241478
     /* 241478 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(241520), // Rule ID 3449 //
     /* 241483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 241491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241507 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1298:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 241510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 241512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241518 */     GIR_RootConstrainSelectedInstOperands,
     /* 241519 */     // GIR_Coverage, 3449,
     /* 241519 */     GIR_EraseRootFromParent_Done,
     /* 241520 */   // Label 4598: @241520
     /* 241520 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(241562), // Rule ID 3450 //
     /* 241525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 241533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241549 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1294:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 241552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241560 */     GIR_RootConstrainSelectedInstOperands,
     /* 241561 */     // GIR_Coverage, 3450,
     /* 241561 */     GIR_EraseRootFromParent_Done,
     /* 241562 */   // Label 4599: @241562
     /* 241562 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(241607), // Rule ID 3452 //
     /* 241567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 241570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 241575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241591 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1601:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 241594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 241605 */     GIR_RootConstrainSelectedInstOperands,
     /* 241606 */     // GIR_Coverage, 3452,
     /* 241606 */     GIR_EraseRootFromParent_Done,
     /* 241607 */   // Label 4600: @241607
     /* 241607 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(241652), // Rule ID 3453 //
     /* 241612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 241615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 241620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 241623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241636 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1601:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 241639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 241650 */     GIR_RootConstrainSelectedInstOperands,
     /* 241651 */     // GIR_Coverage, 3453,
     /* 241651 */     GIR_EraseRootFromParent_Done,
     /* 241652 */   // Label 4601: @241652
     /* 241652 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(241694), // Rule ID 3454 //
     /* 241657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 241660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 241665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1546:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 241684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241692 */     GIR_RootConstrainSelectedInstOperands,
     /* 241693 */     // GIR_Coverage, 3454,
     /* 241693 */     GIR_EraseRootFromParent_Done,
     /* 241694 */   // Label 4602: @241694
     /* 241694 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(241736), // Rule ID 3455 //
     /* 241699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 241702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 241707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241723 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1546:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 241726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241734 */     GIR_RootConstrainSelectedInstOperands,
     /* 241735 */     // GIR_Coverage, 3455,
     /* 241735 */     GIR_EraseRootFromParent_Done,
     /* 241736 */   // Label 4603: @241736
     /* 241736 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(241778), // Rule ID 3460 //
     /* 241741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 241744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 241749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 241768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241776 */     GIR_RootConstrainSelectedInstOperands,
     /* 241777 */     // GIR_Coverage, 3460,
     /* 241777 */     GIR_EraseRootFromParent_Done,
     /* 241778 */   // Label 4604: @241778
     /* 241778 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(241820), // Rule ID 3499 //
     /* 241783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 241786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 241791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241807 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1375:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 241810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241818 */     GIR_RootConstrainSelectedInstOperands,
     /* 241819 */     // GIR_Coverage, 3499,
     /* 241819 */     GIR_EraseRootFromParent_Done,
     /* 241820 */   // Label 4605: @241820
     /* 241820 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(241862), // Rule ID 3501 //
     /* 241825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 241828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 241833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241849 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1375:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 241852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241860 */     GIR_RootConstrainSelectedInstOperands,
     /* 241861 */     // GIR_Coverage, 3501,
     /* 241861 */     GIR_EraseRootFromParent_Done,
     /* 241862 */   // Label 4606: @241862
     /* 241862 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(241904), // Rule ID 3503 //
     /* 241867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 241870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 241875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241891 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1375:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 241894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241902 */     GIR_RootConstrainSelectedInstOperands,
     /* 241903 */     // GIR_Coverage, 3503,
     /* 241903 */     GIR_EraseRootFromParent_Done,
     /* 241904 */   // Label 4607: @241904
     /* 241904 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(241946), // Rule ID 3505 //
     /* 241909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 241912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 241917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241933 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1713:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 241936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241944 */     GIR_RootConstrainSelectedInstOperands,
     /* 241945 */     // GIR_Coverage, 3505,
     /* 241945 */     GIR_EraseRootFromParent_Done,
     /* 241946 */   // Label 4608: @241946
     /* 241946 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(241988), // Rule ID 3632 //
     /* 241951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 241954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 241959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241975 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1697:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 241978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241986 */     GIR_RootConstrainSelectedInstOperands,
     /* 241987 */     // GIR_Coverage, 3632,
     /* 241987 */     GIR_EraseRootFromParent_Done,
     /* 241988 */   // Label 4609: @241988
     /* 241988 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(242030), // Rule ID 3634 //
     /* 241993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 241996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 242001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 242007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242017 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1697:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 242020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242028 */     GIR_RootConstrainSelectedInstOperands,
     /* 242029 */     // GIR_Coverage, 3634,
     /* 242029 */     GIR_EraseRootFromParent_Done,
     /* 242030 */   // Label 4610: @242030
     /* 242030 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(242072), // Rule ID 3636 //
     /* 242035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 242038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 242043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242059 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1697:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 242062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242070 */     GIR_RootConstrainSelectedInstOperands,
     /* 242071 */     // GIR_Coverage, 3636,
     /* 242071 */     GIR_EraseRootFromParent_Done,
     /* 242072 */   // Label 4611: @242072
     /* 242072 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(242114), // Rule ID 3638 //
     /* 242077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 242080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 242085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 242091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242101 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1697:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 242104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242112 */     GIR_RootConstrainSelectedInstOperands,
     /* 242113 */     // GIR_Coverage, 3638,
     /* 242113 */     GIR_EraseRootFromParent_Done,
     /* 242114 */   // Label 4612: @242114
     /* 242114 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(242156), // Rule ID 7558 //
     /* 242119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 242127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242143 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1906:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 242143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 242146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242154 */     GIR_RootConstrainSelectedInstOperands,
     /* 242155 */     // GIR_Coverage, 7558,
     /* 242155 */     GIR_EraseRootFromParent_Done,
     /* 242156 */   // Label 4613: @242156
     /* 242156 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(242198), // Rule ID 7560 //
     /* 242161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 242169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242185 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1906:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 242188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242196 */     GIR_RootConstrainSelectedInstOperands,
     /* 242197 */     // GIR_Coverage, 7560,
     /* 242197 */     GIR_EraseRootFromParent_Done,
     /* 242198 */   // Label 4614: @242198
     /* 242198 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(242240), // Rule ID 7562 //
     /* 242203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 242211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242227 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1906:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 242230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242238 */     GIR_RootConstrainSelectedInstOperands,
     /* 242239 */     // GIR_Coverage, 7562,
     /* 242239 */     GIR_EraseRootFromParent_Done,
     /* 242240 */   // Label 4615: @242240
     /* 242240 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(242282), // Rule ID 7564 //
     /* 242245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 242253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242269 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1906:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 242272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242280 */     GIR_RootConstrainSelectedInstOperands,
     /* 242281 */     // GIR_Coverage, 7564,
     /* 242281 */     GIR_EraseRootFromParent_Done,
     /* 242282 */   // Label 4616: @242282
     /* 242282 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(242324), // Rule ID 7582 //
     /* 242287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 242295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242311 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1291:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 242311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 242314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242322 */     GIR_RootConstrainSelectedInstOperands,
     /* 242323 */     // GIR_Coverage, 7582,
     /* 242323 */     GIR_EraseRootFromParent_Done,
     /* 242324 */   // Label 4617: @242324
     /* 242324 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(242366), // Rule ID 7583 //
     /* 242329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 242337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1291:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 242356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242364 */     GIR_RootConstrainSelectedInstOperands,
     /* 242365 */     // GIR_Coverage, 7583,
     /* 242365 */     GIR_EraseRootFromParent_Done,
     /* 242366 */   // Label 4618: @242366
     /* 242366 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(242408), // Rule ID 7584 //
     /* 242371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 242379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1291:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 242398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242406 */     GIR_RootConstrainSelectedInstOperands,
     /* 242407 */     // GIR_Coverage, 7584,
     /* 242407 */     GIR_EraseRootFromParent_Done,
     /* 242408 */   // Label 4619: @242408
     /* 242408 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(242450), // Rule ID 7585 //
     /* 242413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 242421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242437 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1291:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 242440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242448 */     GIR_RootConstrainSelectedInstOperands,
     /* 242449 */     // GIR_Coverage, 7585,
     /* 242449 */     GIR_EraseRootFromParent_Done,
     /* 242450 */   // Label 4620: @242450
     /* 242450 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(242492), // Rule ID 7698 //
     /* 242455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 242463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242479 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1753:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 242479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 242482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242490 */     GIR_RootConstrainSelectedInstOperands,
     /* 242491 */     // GIR_Coverage, 7698,
     /* 242491 */     GIR_EraseRootFromParent_Done,
     /* 242492 */   // Label 4621: @242492
     /* 242492 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(242534), // Rule ID 7699 //
     /* 242497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 242505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1753:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 242524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242532 */     GIR_RootConstrainSelectedInstOperands,
     /* 242533 */     // GIR_Coverage, 7699,
     /* 242533 */     GIR_EraseRootFromParent_Done,
     /* 242534 */   // Label 4622: @242534
     /* 242534 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(242576), // Rule ID 7700 //
     /* 242539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 242547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1753:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 242566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242574 */     GIR_RootConstrainSelectedInstOperands,
     /* 242575 */     // GIR_Coverage, 7700,
     /* 242575 */     GIR_EraseRootFromParent_Done,
     /* 242576 */   // Label 4623: @242576
     /* 242576 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(242618), // Rule ID 7701 //
     /* 242581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 242589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242605 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1753:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 242608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242616 */     GIR_RootConstrainSelectedInstOperands,
     /* 242617 */     // GIR_Coverage, 7701,
     /* 242617 */     GIR_EraseRootFromParent_Done,
     /* 242618 */   // Label 4624: @242618
     /* 242618 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(242660), // Rule ID 7702 //
     /* 242623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 242631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242647 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1991:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 242647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 242650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242658 */     GIR_RootConstrainSelectedInstOperands,
     /* 242659 */     // GIR_Coverage, 7702,
     /* 242659 */     GIR_EraseRootFromParent_Done,
     /* 242660 */   // Label 4625: @242660
     /* 242660 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(242702), // Rule ID 7703 //
     /* 242665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 242673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242689 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1991:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 242692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242700 */     GIR_RootConstrainSelectedInstOperands,
     /* 242701 */     // GIR_Coverage, 7703,
     /* 242701 */     GIR_EraseRootFromParent_Done,
     /* 242702 */   // Label 4626: @242702
     /* 242702 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(242744), // Rule ID 7704 //
     /* 242707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 242715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242731 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1991:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 242734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242742 */     GIR_RootConstrainSelectedInstOperands,
     /* 242743 */     // GIR_Coverage, 7704,
     /* 242743 */     GIR_EraseRootFromParent_Done,
     /* 242744 */   // Label 4627: @242744
     /* 242744 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(242786), // Rule ID 7705 //
     /* 242749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 242757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242773 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1991:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 242776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242784 */     GIR_RootConstrainSelectedInstOperands,
     /* 242785 */     // GIR_Coverage, 7705,
     /* 242785 */     GIR_EraseRootFromParent_Done,
     /* 242786 */   // Label 4628: @242786
     /* 242786 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(242828), // Rule ID 7714 //
     /* 242791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 242799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242815 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1954:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 242818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242826 */     GIR_RootConstrainSelectedInstOperands,
     /* 242827 */     // GIR_Coverage, 7714,
     /* 242827 */     GIR_EraseRootFromParent_Done,
     /* 242828 */   // Label 4629: @242828
     /* 242828 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(242870), // Rule ID 7715 //
     /* 242833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 242841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242857 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1954:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 242860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242868 */     GIR_RootConstrainSelectedInstOperands,
     /* 242869 */     // GIR_Coverage, 7715,
     /* 242869 */     GIR_EraseRootFromParent_Done,
     /* 242870 */   // Label 4630: @242870
     /* 242870 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(242912), // Rule ID 7716 //
     /* 242875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 242883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1709:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 242902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242910 */     GIR_RootConstrainSelectedInstOperands,
     /* 242911 */     // GIR_Coverage, 7716,
     /* 242911 */     GIR_EraseRootFromParent_Done,
     /* 242912 */   // Label 4631: @242912
     /* 242912 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(242954), // Rule ID 7717 //
     /* 242917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 242925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242941 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1709:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 242944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242952 */     GIR_RootConstrainSelectedInstOperands,
     /* 242953 */     // GIR_Coverage, 7717,
     /* 242953 */     GIR_EraseRootFromParent_Done,
     /* 242954 */   // Label 4632: @242954
     /* 242954 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(242996), // Rule ID 7718 //
     /* 242959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 242967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242983 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1956:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 242986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242994 */     GIR_RootConstrainSelectedInstOperands,
     /* 242995 */     // GIR_Coverage, 7718,
     /* 242995 */     GIR_EraseRootFromParent_Done,
     /* 242996 */   // Label 4633: @242996
     /* 242996 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(243038), // Rule ID 7719 //
     /* 243001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 243009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243025 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1956:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 243028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243036 */     GIR_RootConstrainSelectedInstOperands,
     /* 243037 */     // GIR_Coverage, 7719,
     /* 243037 */     GIR_EraseRootFromParent_Done,
     /* 243038 */   // Label 4634: @243038
     /* 243038 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(243080), // Rule ID 7808 //
     /* 243043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 243051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 243054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 243057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243067 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1331:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 243067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 243070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243078 */     GIR_RootConstrainSelectedInstOperands,
     /* 243079 */     // GIR_Coverage, 7808,
     /* 243079 */     GIR_EraseRootFromParent_Done,
     /* 243080 */   // Label 4635: @243080
     /* 243080 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(243122), // Rule ID 7809 //
     /* 243085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 243093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243109 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1331:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 243109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 243112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243120 */     GIR_RootConstrainSelectedInstOperands,
     /* 243121 */     // GIR_Coverage, 7809,
     /* 243121 */     GIR_EraseRootFromParent_Done,
     /* 243122 */   // Label 4636: @243122
     /* 243122 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(243164), // Rule ID 7810 //
     /* 243127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 243135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243151 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1331:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 243151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 243154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243162 */     GIR_RootConstrainSelectedInstOperands,
     /* 243163 */     // GIR_Coverage, 7810,
     /* 243163 */     GIR_EraseRootFromParent_Done,
     /* 243164 */   // Label 4637: @243164
     /* 243164 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(243206), // Rule ID 7811 //
     /* 243169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 243177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243193 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1331:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 243193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 243196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243204 */     GIR_RootConstrainSelectedInstOperands,
     /* 243205 */     // GIR_Coverage, 7811,
     /* 243205 */     GIR_EraseRootFromParent_Done,
     /* 243206 */   // Label 4638: @243206
     /* 243206 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(243248), // Rule ID 7820 //
     /* 243211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 243219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 243222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 243225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243235 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1617:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 243235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 243238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243246 */     GIR_RootConstrainSelectedInstOperands,
     /* 243247 */     // GIR_Coverage, 7820,
     /* 243247 */     GIR_EraseRootFromParent_Done,
     /* 243248 */   // Label 4639: @243248
     /* 243248 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(243290), // Rule ID 7821 //
     /* 243253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 243261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243277 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1617:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 243277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 243280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243288 */     GIR_RootConstrainSelectedInstOperands,
     /* 243289 */     // GIR_Coverage, 7821,
     /* 243289 */     GIR_EraseRootFromParent_Done,
     /* 243290 */   // Label 4640: @243290
     /* 243290 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(243332), // Rule ID 7822 //
     /* 243295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 243303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243319 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1617:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 243319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 243322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243330 */     GIR_RootConstrainSelectedInstOperands,
     /* 243331 */     // GIR_Coverage, 7822,
     /* 243331 */     GIR_EraseRootFromParent_Done,
     /* 243332 */   // Label 4641: @243332
     /* 243332 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(243374), // Rule ID 7823 //
     /* 243337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 243345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243361 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1617:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 243361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 243364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243372 */     GIR_RootConstrainSelectedInstOperands,
     /* 243373 */     // GIR_Coverage, 7823,
     /* 243373 */     GIR_EraseRootFromParent_Done,
     /* 243374 */   // Label 4642: @243374
     /* 243374 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(243416), // Rule ID 7902 //
     /* 243379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 243387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 243390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243403 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1684:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 243403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 243406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243414 */     GIR_RootConstrainSelectedInstOperands,
     /* 243415 */     // GIR_Coverage, 7902,
     /* 243415 */     GIR_EraseRootFromParent_Done,
     /* 243416 */   // Label 4643: @243416
     /* 243416 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(243458), // Rule ID 7903 //
     /* 243421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 243429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243445 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1684:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 243445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 243448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243456 */     GIR_RootConstrainSelectedInstOperands,
     /* 243457 */     // GIR_Coverage, 7903,
     /* 243457 */     GIR_EraseRootFromParent_Done,
     /* 243458 */   // Label 4644: @243458
     /* 243458 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(243500), // Rule ID 7904 //
     /* 243463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 243471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243487 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1684:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 243487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 243490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243498 */     GIR_RootConstrainSelectedInstOperands,
     /* 243499 */     // GIR_Coverage, 7904,
     /* 243499 */     GIR_EraseRootFromParent_Done,
     /* 243500 */   // Label 4645: @243500
     /* 243500 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(243542), // Rule ID 7905 //
     /* 243505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 243513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243529 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1684:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 243532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243540 */     GIR_RootConstrainSelectedInstOperands,
     /* 243541 */     // GIR_Coverage, 7905,
     /* 243541 */     GIR_EraseRootFromParent_Done,
     /* 243542 */   // Label 4646: @243542
     /* 243542 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(243584), // Rule ID 7906 //
     /* 243547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 243555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 243558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243571 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1934:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 243571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 243574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243582 */     GIR_RootConstrainSelectedInstOperands,
     /* 243583 */     // GIR_Coverage, 7906,
     /* 243583 */     GIR_EraseRootFromParent_Done,
     /* 243584 */   // Label 4647: @243584
     /* 243584 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(243626), // Rule ID 7907 //
     /* 243589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 243597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243613 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1934:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 243613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 243616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243624 */     GIR_RootConstrainSelectedInstOperands,
     /* 243625 */     // GIR_Coverage, 7907,
     /* 243625 */     GIR_EraseRootFromParent_Done,
     /* 243626 */   // Label 4648: @243626
     /* 243626 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(243668), // Rule ID 7908 //
     /* 243631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 243639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243655 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1934:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 243655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 243658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243666 */     GIR_RootConstrainSelectedInstOperands,
     /* 243667 */     // GIR_Coverage, 7908,
     /* 243667 */     GIR_EraseRootFromParent_Done,
     /* 243668 */   // Label 4649: @243668
     /* 243668 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(243710), // Rule ID 7909 //
     /* 243673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 243681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243697 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1934:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 243700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243708 */     GIR_RootConstrainSelectedInstOperands,
     /* 243709 */     // GIR_Coverage, 7909,
     /* 243709 */     GIR_EraseRootFromParent_Done,
     /* 243710 */   // Label 4650: @243710
     /* 243710 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(243752), // Rule ID 8105 //
     /* 243715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 243723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243739 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1540:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 243739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 243742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243750 */     GIR_RootConstrainSelectedInstOperands,
     /* 243751 */     // GIR_Coverage, 8105,
     /* 243751 */     GIR_EraseRootFromParent_Done,
     /* 243752 */   // Label 4651: @243752
     /* 243752 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(243794), // Rule ID 8107 //
     /* 243757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 243765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243781 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1540:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 243781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 243784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243792 */     GIR_RootConstrainSelectedInstOperands,
     /* 243793 */     // GIR_Coverage, 8107,
     /* 243793 */     GIR_EraseRootFromParent_Done,
     /* 243794 */   // Label 4652: @243794
     /* 243794 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(243836), // Rule ID 8109 //
     /* 243799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 243807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243823 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1540:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 243823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 243826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243834 */     GIR_RootConstrainSelectedInstOperands,
     /* 243835 */     // GIR_Coverage, 8109,
     /* 243835 */     GIR_EraseRootFromParent_Done,
     /* 243836 */   // Label 4653: @243836
     /* 243836 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(243878), // Rule ID 8117 //
     /* 243841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 243849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243865 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1542:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 243865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 243868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243876 */     GIR_RootConstrainSelectedInstOperands,
     /* 243877 */     // GIR_Coverage, 8117,
     /* 243877 */     GIR_EraseRootFromParent_Done,
     /* 243878 */   // Label 4654: @243878
     /* 243878 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(243920), // Rule ID 8119 //
     /* 243883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 243891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243907 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1542:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 243907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 243910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243918 */     GIR_RootConstrainSelectedInstOperands,
     /* 243919 */     // GIR_Coverage, 8119,
     /* 243919 */     GIR_EraseRootFromParent_Done,
     /* 243920 */   // Label 4655: @243920
     /* 243920 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(243962), // Rule ID 8121 //
     /* 243925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 243933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243949 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1542:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 243949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 243952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243960 */     GIR_RootConstrainSelectedInstOperands,
     /* 243961 */     // GIR_Coverage, 8121,
     /* 243961 */     GIR_EraseRootFromParent_Done,
     /* 243962 */   // Label 4656: @243962
     /* 243962 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(244004), // Rule ID 8159 //
     /* 243967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 243975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243991 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1359:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 243991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 243994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244002 */     GIR_RootConstrainSelectedInstOperands,
     /* 244003 */     // GIR_Coverage, 8159,
     /* 244003 */     GIR_EraseRootFromParent_Done,
     /* 244004 */   // Label 4657: @244004
     /* 244004 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(244046), // Rule ID 8160 //
     /* 244009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 244017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244033 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1359:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 244036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244044 */     GIR_RootConstrainSelectedInstOperands,
     /* 244045 */     // GIR_Coverage, 8160,
     /* 244045 */     GIR_EraseRootFromParent_Done,
     /* 244046 */   // Label 4658: @244046
     /* 244046 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(244088), // Rule ID 8161 //
     /* 244051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 244059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244075 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 244078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244086 */     GIR_RootConstrainSelectedInstOperands,
     /* 244087 */     // GIR_Coverage, 8161,
     /* 244087 */     GIR_EraseRootFromParent_Done,
     /* 244088 */   // Label 4659: @244088
     /* 244088 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(244130), // Rule ID 8162 //
     /* 244093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 244101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244117 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1481:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 244120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244128 */     GIR_RootConstrainSelectedInstOperands,
     /* 244129 */     // GIR_Coverage, 8162,
     /* 244129 */     GIR_EraseRootFromParent_Done,
     /* 244130 */   // Label 4660: @244130
     /* 244130 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(244172), // Rule ID 8163 //
     /* 244135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 244143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244159 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1481:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 244162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244170 */     GIR_RootConstrainSelectedInstOperands,
     /* 244171 */     // GIR_Coverage, 8163,
     /* 244171 */     GIR_EraseRootFromParent_Done,
     /* 244172 */   // Label 4661: @244172
     /* 244172 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(244214), // Rule ID 8164 //
     /* 244177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 244185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244201 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 244204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244212 */     GIR_RootConstrainSelectedInstOperands,
     /* 244213 */     // GIR_Coverage, 8164,
     /* 244213 */     GIR_EraseRootFromParent_Done,
     /* 244214 */   // Label 4662: @244214
     /* 244214 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(244256), // Rule ID 8165 //
     /* 244219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 244227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244243 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1420:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 244246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244254 */     GIR_RootConstrainSelectedInstOperands,
     /* 244255 */     // GIR_Coverage, 8165,
     /* 244255 */     GIR_EraseRootFromParent_Done,
     /* 244256 */   // Label 4663: @244256
     /* 244256 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(244298), // Rule ID 8166 //
     /* 244261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 244269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244285 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1420:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 244288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244296 */     GIR_RootConstrainSelectedInstOperands,
     /* 244297 */     // GIR_Coverage, 8166,
     /* 244297 */     GIR_EraseRootFromParent_Done,
     /* 244298 */   // Label 4664: @244298
     /* 244298 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(244340), // Rule ID 8167 //
     /* 244303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 244311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244327 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1420:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 244330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244338 */     GIR_RootConstrainSelectedInstOperands,
     /* 244339 */     // GIR_Coverage, 8167,
     /* 244339 */     GIR_EraseRootFromParent_Done,
     /* 244340 */   // Label 4665: @244340
     /* 244340 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(244382), // Rule ID 8168 //
     /* 244345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 244353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244369 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1418:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 244372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244380 */     GIR_RootConstrainSelectedInstOperands,
     /* 244381 */     // GIR_Coverage, 8168,
     /* 244381 */     GIR_EraseRootFromParent_Done,
     /* 244382 */   // Label 4666: @244382
     /* 244382 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(244424), // Rule ID 8169 //
     /* 244387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 244395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244411 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1418:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 244414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244422 */     GIR_RootConstrainSelectedInstOperands,
     /* 244423 */     // GIR_Coverage, 8169,
     /* 244423 */     GIR_EraseRootFromParent_Done,
     /* 244424 */   // Label 4667: @244424
     /* 244424 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(244466), // Rule ID 8170 //
     /* 244429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 244437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244453 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1418:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 244456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244464 */     GIR_RootConstrainSelectedInstOperands,
     /* 244465 */     // GIR_Coverage, 8170,
     /* 244465 */     GIR_EraseRootFromParent_Done,
     /* 244466 */   // Label 4668: @244466
     /* 244466 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(244508), // Rule ID 8207 //
     /* 244471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 244479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244495 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1360:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 244498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244506 */     GIR_RootConstrainSelectedInstOperands,
     /* 244507 */     // GIR_Coverage, 8207,
     /* 244507 */     GIR_EraseRootFromParent_Done,
     /* 244508 */   // Label 4669: @244508
     /* 244508 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(244550), // Rule ID 8209 //
     /* 244513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 244521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 244524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 244530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 244533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244537 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1360:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 244537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 244540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244548 */     GIR_RootConstrainSelectedInstOperands,
     /* 244549 */     // GIR_Coverage, 8209,
     /* 244549 */     GIR_EraseRootFromParent_Done,
     /* 244550 */   // Label 4670: @244550
     /* 244550 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(244592), // Rule ID 8211 //
     /* 244555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 244563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 244566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 244572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 244575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244579 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1360:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 244579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 244582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244590 */     GIR_RootConstrainSelectedInstOperands,
     /* 244591 */     // GIR_Coverage, 8211,
     /* 244591 */     GIR_EraseRootFromParent_Done,
     /* 244592 */   // Label 4671: @244592
     /* 244592 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(244634), // Rule ID 8213 //
     /* 244597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 244605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244621 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1360:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 244624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244632 */     GIR_RootConstrainSelectedInstOperands,
     /* 244633 */     // GIR_Coverage, 8213,
     /* 244633 */     GIR_EraseRootFromParent_Done,
     /* 244634 */   // Label 4672: @244634
     /* 244634 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(244676), // Rule ID 8215 //
     /* 244639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 244647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 244650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 244656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 244659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244663 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1360:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 244663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 244666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244674 */     GIR_RootConstrainSelectedInstOperands,
     /* 244675 */     // GIR_Coverage, 8215,
     /* 244675 */     GIR_EraseRootFromParent_Done,
     /* 244676 */   // Label 4673: @244676
     /* 244676 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(244718), // Rule ID 8217 //
     /* 244681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 244689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244705 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1360:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 244708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244716 */     GIR_RootConstrainSelectedInstOperands,
     /* 244717 */     // GIR_Coverage, 8217,
     /* 244717 */     GIR_EraseRootFromParent_Done,
     /* 244718 */   // Label 4674: @244718
     /* 244718 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(244760), // Rule ID 8219 //
     /* 244723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 244731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244747 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1482:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 244750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244758 */     GIR_RootConstrainSelectedInstOperands,
     /* 244759 */     // GIR_Coverage, 8219,
     /* 244759 */     GIR_EraseRootFromParent_Done,
     /* 244760 */   // Label 4675: @244760
     /* 244760 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(244802), // Rule ID 8220 //
     /* 244765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 244773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 244776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 244782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 244785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244789 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1482:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 244789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 244792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244800 */     GIR_RootConstrainSelectedInstOperands,
     /* 244801 */     // GIR_Coverage, 8220,
     /* 244801 */     GIR_EraseRootFromParent_Done,
     /* 244802 */   // Label 4676: @244802
     /* 244802 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(244844), // Rule ID 8221 //
     /* 244807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 244815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 244818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 244824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 244827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244831 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1482:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 244831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 244834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244842 */     GIR_RootConstrainSelectedInstOperands,
     /* 244843 */     // GIR_Coverage, 8221,
     /* 244843 */     GIR_EraseRootFromParent_Done,
     /* 244844 */   // Label 4677: @244844
     /* 244844 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(244886), // Rule ID 8222 //
     /* 244849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 244857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244873 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1482:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 244876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244884 */     GIR_RootConstrainSelectedInstOperands,
     /* 244885 */     // GIR_Coverage, 8222,
     /* 244885 */     GIR_EraseRootFromParent_Done,
     /* 244886 */   // Label 4678: @244886
     /* 244886 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(244928), // Rule ID 8223 //
     /* 244891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 244899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 244902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 244908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 244911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244915 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1482:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 244915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 244918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244926 */     GIR_RootConstrainSelectedInstOperands,
     /* 244927 */     // GIR_Coverage, 8223,
     /* 244927 */     GIR_EraseRootFromParent_Done,
     /* 244928 */   // Label 4679: @244928
     /* 244928 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(244970), // Rule ID 8224 //
     /* 244933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 244941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244957 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1482:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 244960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244966 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244968 */     GIR_RootConstrainSelectedInstOperands,
     /* 244969 */     // GIR_Coverage, 8224,
     /* 244969 */     GIR_EraseRootFromParent_Done,
     /* 244970 */   // Label 4680: @244970
     /* 244970 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(245012), // Rule ID 8477 //
     /* 244975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 244983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 244992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 244995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244999 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1300:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 244999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 245002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245010 */     GIR_RootConstrainSelectedInstOperands,
     /* 245011 */     // GIR_Coverage, 8477,
     /* 245011 */     GIR_EraseRootFromParent_Done,
     /* 245012 */   // Label 4681: @245012
     /* 245012 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(245054), // Rule ID 8479 //
     /* 245017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 245025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 245034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 245037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245041 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1296:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 245041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 245044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245052 */     GIR_RootConstrainSelectedInstOperands,
     /* 245053 */     // GIR_Coverage, 8479,
     /* 245053 */     GIR_EraseRootFromParent_Done,
     /* 245054 */   // Label 4682: @245054
     /* 245054 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(245096), // Rule ID 8480 //
     /* 245059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 245067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 245076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 245079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245083 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1293:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 245083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 245086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245094 */     GIR_RootConstrainSelectedInstOperands,
     /* 245095 */     // GIR_Coverage, 8480,
     /* 245095 */     GIR_EraseRootFromParent_Done,
     /* 245096 */   // Label 4683: @245096
     /* 245096 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(245138), // Rule ID 8481 //
     /* 245101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 245109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 245118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 245121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245125 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1293:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 245125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 245128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245136 */     GIR_RootConstrainSelectedInstOperands,
     /* 245137 */     // GIR_Coverage, 8481,
     /* 245137 */     GIR_EraseRootFromParent_Done,
     /* 245138 */   // Label 4684: @245138
     /* 245138 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(245180), // Rule ID 8482 //
     /* 245143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 245151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 245160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 245163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245167 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1293:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 245167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 245170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245178 */     GIR_RootConstrainSelectedInstOperands,
     /* 245179 */     // GIR_Coverage, 8482,
     /* 245179 */     GIR_EraseRootFromParent_Done,
     /* 245180 */   // Label 4685: @245180
     /* 245180 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(245222), // Rule ID 8483 //
     /* 245185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 245193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 245196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 245205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245209 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1293:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 245209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 245212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245220 */     GIR_RootConstrainSelectedInstOperands,
     /* 245221 */     // GIR_Coverage, 8483,
     /* 245221 */     GIR_EraseRootFromParent_Done,
     /* 245222 */   // Label 4686: @245222
     /* 245222 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(245264), // Rule ID 8484 //
     /* 245227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 245235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 245238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 245241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 245244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 245247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245251 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1293:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 245251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 245254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245262 */     GIR_RootConstrainSelectedInstOperands,
     /* 245263 */     // GIR_Coverage, 8484,
     /* 245263 */     GIR_EraseRootFromParent_Done,
     /* 245264 */   // Label 4687: @245264
     /* 245264 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(245306), // Rule ID 8505 //
     /* 245269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 245277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 245286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 245289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245293 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1351:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 245293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 245296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245304 */     GIR_RootConstrainSelectedInstOperands,
     /* 245305 */     // GIR_Coverage, 8505,
     /* 245305 */     GIR_EraseRootFromParent_Done,
     /* 245306 */   // Label 4688: @245306
     /* 245306 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(245348), // Rule ID 8506 //
     /* 245311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 245319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 245328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 245331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245335 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1351:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 245335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 245338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245346 */     GIR_RootConstrainSelectedInstOperands,
     /* 245347 */     // GIR_Coverage, 8506,
     /* 245347 */     GIR_EraseRootFromParent_Done,
     /* 245348 */   // Label 4689: @245348
     /* 245348 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(245390), // Rule ID 8507 //
     /* 245353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 245361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 245370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 245373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245377 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1351:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 245377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 245380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245386 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245388 */     GIR_RootConstrainSelectedInstOperands,
     /* 245389 */     // GIR_Coverage, 8507,
     /* 245389 */     GIR_EraseRootFromParent_Done,
     /* 245390 */   // Label 4690: @245390
     /* 245390 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(245432), // Rule ID 8508 //
     /* 245395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 245403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 245406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 245415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245419 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1351:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 245419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 245422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245428 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245430 */     GIR_RootConstrainSelectedInstOperands,
     /* 245431 */     // GIR_Coverage, 8508,
     /* 245431 */     GIR_EraseRootFromParent_Done,
     /* 245432 */   // Label 4691: @245432
     /* 245432 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(245474), // Rule ID 8509 //
     /* 245437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 245445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 245448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 245451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 245454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 245457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245461 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1351:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 245461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 245464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245472 */     GIR_RootConstrainSelectedInstOperands,
     /* 245473 */     // GIR_Coverage, 8509,
     /* 245473 */     GIR_EraseRootFromParent_Done,
     /* 245474 */   // Label 4692: @245474
     /* 245474 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(245516), // Rule ID 8525 //
     /* 245479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 245487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 245496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 245499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245503 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1622:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 245503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 245506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245512 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245514 */     GIR_RootConstrainSelectedInstOperands,
     /* 245515 */     // GIR_Coverage, 8525,
     /* 245515 */     GIR_EraseRootFromParent_Done,
     /* 245516 */   // Label 4693: @245516
     /* 245516 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(245558), // Rule ID 8526 //
     /* 245521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 245529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 245538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 245541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245545 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1622:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 245545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 245548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245556 */     GIR_RootConstrainSelectedInstOperands,
     /* 245557 */     // GIR_Coverage, 8526,
     /* 245557 */     GIR_EraseRootFromParent_Done,
     /* 245558 */   // Label 4694: @245558
     /* 245558 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(245600), // Rule ID 8527 //
     /* 245563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 245571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 245580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 245583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245587 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1622:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 245587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 245590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245598 */     GIR_RootConstrainSelectedInstOperands,
     /* 245599 */     // GIR_Coverage, 8527,
     /* 245599 */     GIR_EraseRootFromParent_Done,
     /* 245600 */   // Label 4695: @245600
     /* 245600 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(245642), // Rule ID 8528 //
     /* 245605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 245613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 245616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 245625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245629 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1622:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 245629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 245632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245640 */     GIR_RootConstrainSelectedInstOperands,
     /* 245641 */     // GIR_Coverage, 8528,
     /* 245641 */     GIR_EraseRootFromParent_Done,
     /* 245642 */   // Label 4696: @245642
     /* 245642 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(245684), // Rule ID 8529 //
     /* 245647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 245655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 245658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 245661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 245664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 245667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245671 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1622:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 245671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 245674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245680 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245682 */     GIR_RootConstrainSelectedInstOperands,
     /* 245683 */     // GIR_Coverage, 8529,
     /* 245683 */     GIR_EraseRootFromParent_Done,
     /* 245684 */   // Label 4697: @245684
     /* 245684 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(245726), // Rule ID 8530 //
     /* 245689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 245697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 245706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 245709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245713 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1618:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 245713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 245716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245724 */     GIR_RootConstrainSelectedInstOperands,
     /* 245725 */     // GIR_Coverage, 8530,
     /* 245725 */     GIR_EraseRootFromParent_Done,
     /* 245726 */   // Label 4698: @245726
     /* 245726 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(245768), // Rule ID 8531 //
     /* 245731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 245739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 245748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 245751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245755 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1618:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 245755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 245758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245766 */     GIR_RootConstrainSelectedInstOperands,
     /* 245767 */     // GIR_Coverage, 8531,
     /* 245767 */     GIR_EraseRootFromParent_Done,
     /* 245768 */   // Label 4699: @245768
     /* 245768 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(245810), // Rule ID 8532 //
     /* 245773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 245781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 245790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 245793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245797 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1618:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 245797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 245800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245808 */     GIR_RootConstrainSelectedInstOperands,
     /* 245809 */     // GIR_Coverage, 8532,
     /* 245809 */     GIR_EraseRootFromParent_Done,
     /* 245810 */   // Label 4700: @245810
     /* 245810 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(245852), // Rule ID 8533 //
     /* 245815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 245823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 245826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 245835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245839 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1618:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 245839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 245842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245850 */     GIR_RootConstrainSelectedInstOperands,
     /* 245851 */     // GIR_Coverage, 8533,
     /* 245851 */     GIR_EraseRootFromParent_Done,
     /* 245852 */   // Label 4701: @245852
     /* 245852 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(245894), // Rule ID 8534 //
     /* 245857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 245865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 245868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 245871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 245874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 245877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245881 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1618:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 245881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 245884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245890 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245892 */     GIR_RootConstrainSelectedInstOperands,
     /* 245893 */     // GIR_Coverage, 8534,
     /* 245893 */     GIR_EraseRootFromParent_Done,
     /* 245894 */   // Label 4702: @245894
     /* 245894 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(245936), // Rule ID 8535 //
     /* 245899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 245907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 245916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 245919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245923 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1616:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 245923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 245926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245932 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245934 */     GIR_RootConstrainSelectedInstOperands,
     /* 245935 */     // GIR_Coverage, 8535,
     /* 245935 */     GIR_EraseRootFromParent_Done,
     /* 245936 */   // Label 4703: @245936
     /* 245936 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(245978), // Rule ID 8536 //
     /* 245941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 245949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 245958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 245961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245965 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1616:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 245965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 245968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245976 */     GIR_RootConstrainSelectedInstOperands,
     /* 245977 */     // GIR_Coverage, 8536,
     /* 245977 */     GIR_EraseRootFromParent_Done,
     /* 245978 */   // Label 4704: @245978
     /* 245978 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(246020), // Rule ID 8537 //
     /* 245983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 245991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 246003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246007 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1616:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 246007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 246010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246018 */     GIR_RootConstrainSelectedInstOperands,
     /* 246019 */     // GIR_Coverage, 8537,
     /* 246019 */     GIR_EraseRootFromParent_Done,
     /* 246020 */   // Label 4705: @246020
     /* 246020 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(246062), // Rule ID 8538 //
     /* 246025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 246033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 246036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 246045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246049 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1616:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 246049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 246052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246060 */     GIR_RootConstrainSelectedInstOperands,
     /* 246061 */     // GIR_Coverage, 8538,
     /* 246061 */     GIR_EraseRootFromParent_Done,
     /* 246062 */   // Label 4706: @246062
     /* 246062 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(246104), // Rule ID 8539 //
     /* 246067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 246075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 246078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 246081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 246084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 246087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246091 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1616:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 246091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 246094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246102 */     GIR_RootConstrainSelectedInstOperands,
     /* 246103 */     // GIR_Coverage, 8539,
     /* 246103 */     GIR_EraseRootFromParent_Done,
     /* 246104 */   // Label 4707: @246104
     /* 246104 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(246146), // Rule ID 8540 //
     /* 246109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 246117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 246120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 246126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 246129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246133 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1612:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 246133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 246136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246144 */     GIR_RootConstrainSelectedInstOperands,
     /* 246145 */     // GIR_Coverage, 8540,
     /* 246145 */     GIR_EraseRootFromParent_Done,
     /* 246146 */   // Label 4708: @246146
     /* 246146 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(246188), // Rule ID 8541 //
     /* 246151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 246159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 246162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 246168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 246171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246175 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1612:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 246175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 246178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246186 */     GIR_RootConstrainSelectedInstOperands,
     /* 246187 */     // GIR_Coverage, 8541,
     /* 246187 */     GIR_EraseRootFromParent_Done,
     /* 246188 */   // Label 4709: @246188
     /* 246188 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(246230), // Rule ID 8542 //
     /* 246193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 246201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 246204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 246213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246217 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1612:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 246217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 246220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246226 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246228 */     GIR_RootConstrainSelectedInstOperands,
     /* 246229 */     // GIR_Coverage, 8542,
     /* 246229 */     GIR_EraseRootFromParent_Done,
     /* 246230 */   // Label 4710: @246230
     /* 246230 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(246272), // Rule ID 8543 //
     /* 246235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 246243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 246246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 246255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246259 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1612:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 246259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 246262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246270 */     GIR_RootConstrainSelectedInstOperands,
     /* 246271 */     // GIR_Coverage, 8543,
     /* 246271 */     GIR_EraseRootFromParent_Done,
     /* 246272 */   // Label 4711: @246272
     /* 246272 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(246314), // Rule ID 8544 //
     /* 246277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 246285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 246288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 246291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 246294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 246297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246301 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1612:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 246301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 246304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246312 */     GIR_RootConstrainSelectedInstOperands,
     /* 246313 */     // GIR_Coverage, 8544,
     /* 246313 */     GIR_EraseRootFromParent_Done,
     /* 246314 */   // Label 4712: @246314
     /* 246314 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(246356), // Rule ID 8552 //
     /* 246319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 246327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246343 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1309:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 246346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246354 */     GIR_RootConstrainSelectedInstOperands,
     /* 246355 */     // GIR_Coverage, 8552,
     /* 246355 */     GIR_EraseRootFromParent_Done,
     /* 246356 */   // Label 4713: @246356
     /* 246356 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(246398), // Rule ID 8553 //
     /* 246361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 246369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246385 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1309:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 246388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246394 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246396 */     GIR_RootConstrainSelectedInstOperands,
     /* 246397 */     // GIR_Coverage, 8553,
     /* 246397 */     GIR_EraseRootFromParent_Done,
     /* 246398 */   // Label 4714: @246398
     /* 246398 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(246440), // Rule ID 8554 //
     /* 246403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 246411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246427 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1309:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 246430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246436 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246438 */     GIR_RootConstrainSelectedInstOperands,
     /* 246439 */     // GIR_Coverage, 8554,
     /* 246439 */     GIR_EraseRootFromParent_Done,
     /* 246440 */   // Label 4715: @246440
     /* 246440 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(246482), // Rule ID 8555 //
     /* 246445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 246453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1309:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 246472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246478 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246480 */     GIR_RootConstrainSelectedInstOperands,
     /* 246481 */     // GIR_Coverage, 8555,
     /* 246481 */     GIR_EraseRootFromParent_Done,
     /* 246482 */   // Label 4716: @246482
     /* 246482 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(246524), // Rule ID 8556 //
     /* 246487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 246495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246511 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1309:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 246511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 246514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246522 */     GIR_RootConstrainSelectedInstOperands,
     /* 246523 */     // GIR_Coverage, 8556,
     /* 246523 */     GIR_EraseRootFromParent_Done,
     /* 246524 */   // Label 4717: @246524
     /* 246524 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(246566), // Rule ID 8557 //
     /* 246529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 246537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246553 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1309:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 246553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 246556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246564 */     GIR_RootConstrainSelectedInstOperands,
     /* 246565 */     // GIR_Coverage, 8557,
     /* 246565 */     GIR_EraseRootFromParent_Done,
     /* 246566 */   // Label 4718: @246566
     /* 246566 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(246608), // Rule ID 8558 //
     /* 246571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 246579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246595 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1309:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 246598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246604 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246606 */     GIR_RootConstrainSelectedInstOperands,
     /* 246607 */     // GIR_Coverage, 8558,
     /* 246607 */     GIR_EraseRootFromParent_Done,
     /* 246608 */   // Label 4719: @246608
     /* 246608 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(246653), // Rule ID 9254 //
     /* 246613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 246621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 246624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246637 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1330:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 246640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246646 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 246651 */     GIR_RootConstrainSelectedInstOperands,
     /* 246652 */     // GIR_Coverage, 9254,
     /* 246652 */     GIR_EraseRootFromParent_Done,
     /* 246653 */   // Label 4720: @246653
     /* 246653 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(246698), // Rule ID 9255 //
     /* 246658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 246666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 246669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246682 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1330:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 246685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 246696 */     GIR_RootConstrainSelectedInstOperands,
     /* 246697 */     // GIR_Coverage, 9255,
     /* 246697 */     GIR_EraseRootFromParent_Done,
     /* 246698 */   // Label 4721: @246698
     /* 246698 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(246743), // Rule ID 9256 //
     /* 246703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 246711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 246714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246727 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1330:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 246730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 246741 */     GIR_RootConstrainSelectedInstOperands,
     /* 246742 */     // GIR_Coverage, 9256,
     /* 246742 */     GIR_EraseRootFromParent_Done,
     /* 246743 */   // Label 4722: @246743
     /* 246743 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(246788), // Rule ID 9257 //
     /* 246748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 246756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 246759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246772 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1320:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 246775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 246786 */     GIR_RootConstrainSelectedInstOperands,
     /* 246787 */     // GIR_Coverage, 9257,
     /* 246787 */     GIR_EraseRootFromParent_Done,
     /* 246788 */   // Label 4723: @246788
     /* 246788 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(246833), // Rule ID 9258 //
     /* 246793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 246801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 246804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246817 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1320:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 246820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 246831 */     GIR_RootConstrainSelectedInstOperands,
     /* 246832 */     // GIR_Coverage, 9258,
     /* 246832 */     GIR_EraseRootFromParent_Done,
     /* 246833 */   // Label 4724: @246833
     /* 246833 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(246878), // Rule ID 9259 //
     /* 246838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 246846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 246849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246862 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1320:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 246865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246871 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 246876 */     GIR_RootConstrainSelectedInstOperands,
     /* 246877 */     // GIR_Coverage, 9259,
     /* 246877 */     GIR_EraseRootFromParent_Done,
     /* 246878 */   // Label 4725: @246878
     /* 246878 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(246923), // Rule ID 9260 //
     /* 246883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 246891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 246894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246907 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1328:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 246910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 246921 */     GIR_RootConstrainSelectedInstOperands,
     /* 246922 */     // GIR_Coverage, 9260,
     /* 246922 */     GIR_EraseRootFromParent_Done,
     /* 246923 */   // Label 4726: @246923
     /* 246923 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(246968), // Rule ID 9261 //
     /* 246928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 246936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 246939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246952 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1328:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 246955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 246966 */     GIR_RootConstrainSelectedInstOperands,
     /* 246967 */     // GIR_Coverage, 9261,
     /* 246967 */     GIR_EraseRootFromParent_Done,
     /* 246968 */   // Label 4727: @246968
     /* 246968 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(247013), // Rule ID 9262 //
     /* 246973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 246981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 246984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246997 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1328:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 247000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247011 */     GIR_RootConstrainSelectedInstOperands,
     /* 247012 */     // GIR_Coverage, 9262,
     /* 247012 */     GIR_EraseRootFromParent_Done,
     /* 247013 */   // Label 4728: @247013
     /* 247013 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(247058), // Rule ID 9263 //
     /* 247018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 247026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 247029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247042 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1325:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 247045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247056 */     GIR_RootConstrainSelectedInstOperands,
     /* 247057 */     // GIR_Coverage, 9263,
     /* 247057 */     GIR_EraseRootFromParent_Done,
     /* 247058 */   // Label 4729: @247058
     /* 247058 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(247103), // Rule ID 9264 //
     /* 247063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 247071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 247074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247087 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1325:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 247090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247101 */     GIR_RootConstrainSelectedInstOperands,
     /* 247102 */     // GIR_Coverage, 9264,
     /* 247102 */     GIR_EraseRootFromParent_Done,
     /* 247103 */   // Label 4730: @247103
     /* 247103 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(247148), // Rule ID 9265 //
     /* 247108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 247116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 247119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247132 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1325:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 247135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247146 */     GIR_RootConstrainSelectedInstOperands,
     /* 247147 */     // GIR_Coverage, 9265,
     /* 247147 */     GIR_EraseRootFromParent_Done,
     /* 247148 */   // Label 4731: @247148
     /* 247148 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(247193), // Rule ID 9266 //
     /* 247153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 247161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 247164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247177 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1324:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 247180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247191 */     GIR_RootConstrainSelectedInstOperands,
     /* 247192 */     // GIR_Coverage, 9266,
     /* 247192 */     GIR_EraseRootFromParent_Done,
     /* 247193 */   // Label 4732: @247193
     /* 247193 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(247238), // Rule ID 9267 //
     /* 247198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 247206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 247209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247222 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1324:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 247225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247236 */     GIR_RootConstrainSelectedInstOperands,
     /* 247237 */     // GIR_Coverage, 9267,
     /* 247237 */     GIR_EraseRootFromParent_Done,
     /* 247238 */   // Label 4733: @247238
     /* 247238 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(247283), // Rule ID 9268 //
     /* 247243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 247251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 247254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247267 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1324:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 247270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247281 */     GIR_RootConstrainSelectedInstOperands,
     /* 247282 */     // GIR_Coverage, 9268,
     /* 247282 */     GIR_EraseRootFromParent_Done,
     /* 247283 */   // Label 4734: @247283
     /* 247283 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(247328), // Rule ID 9269 //
     /* 247288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 247296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 247299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247312 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1322:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 247315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247321 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247326 */     GIR_RootConstrainSelectedInstOperands,
     /* 247327 */     // GIR_Coverage, 9269,
     /* 247327 */     GIR_EraseRootFromParent_Done,
     /* 247328 */   // Label 4735: @247328
     /* 247328 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(247373), // Rule ID 9270 //
     /* 247333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 247341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 247344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247357 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1322:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 247360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247371 */     GIR_RootConstrainSelectedInstOperands,
     /* 247372 */     // GIR_Coverage, 9270,
     /* 247372 */     GIR_EraseRootFromParent_Done,
     /* 247373 */   // Label 4736: @247373
     /* 247373 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(247418), // Rule ID 9271 //
     /* 247378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 247386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 247389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247402 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1322:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 247405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247416 */     GIR_RootConstrainSelectedInstOperands,
     /* 247417 */     // GIR_Coverage, 9271,
     /* 247417 */     GIR_EraseRootFromParent_Done,
     /* 247418 */   // Label 4737: @247418
     /* 247418 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(247463), // Rule ID 9272 //
     /* 247423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 247431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 247434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247447 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1326:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 247450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247458 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247461 */     GIR_RootConstrainSelectedInstOperands,
     /* 247462 */     // GIR_Coverage, 9272,
     /* 247462 */     GIR_EraseRootFromParent_Done,
     /* 247463 */   // Label 4738: @247463
     /* 247463 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(247508), // Rule ID 9273 //
     /* 247468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 247476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 247479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247492 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1326:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 247495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247506 */     GIR_RootConstrainSelectedInstOperands,
     /* 247507 */     // GIR_Coverage, 9273,
     /* 247507 */     GIR_EraseRootFromParent_Done,
     /* 247508 */   // Label 4739: @247508
     /* 247508 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(247553), // Rule ID 9274 //
     /* 247513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 247521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 247524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247537 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1326:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 247540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247551 */     GIR_RootConstrainSelectedInstOperands,
     /* 247552 */     // GIR_Coverage, 9274,
     /* 247552 */     GIR_EraseRootFromParent_Done,
     /* 247553 */   // Label 4740: @247553
     /* 247553 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(247598), // Rule ID 9275 //
     /* 247558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 247566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 247569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247582 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1327:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 247585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247591 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247596 */     GIR_RootConstrainSelectedInstOperands,
     /* 247597 */     // GIR_Coverage, 9275,
     /* 247597 */     GIR_EraseRootFromParent_Done,
     /* 247598 */   // Label 4741: @247598
     /* 247598 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(247643), // Rule ID 9276 //
     /* 247603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 247611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 247614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247627 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1327:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 247630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247641 */     GIR_RootConstrainSelectedInstOperands,
     /* 247642 */     // GIR_Coverage, 9276,
     /* 247642 */     GIR_EraseRootFromParent_Done,
     /* 247643 */   // Label 4742: @247643
     /* 247643 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(247688), // Rule ID 9277 //
     /* 247648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 247656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 247659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247672 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 247675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247686 */     GIR_RootConstrainSelectedInstOperands,
     /* 247687 */     // GIR_Coverage, 9277,
     /* 247687 */     GIR_EraseRootFromParent_Done,
     /* 247688 */   // Label 4743: @247688
     /* 247688 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(247730), // Rule ID 9674 //
     /* 247693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 247701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 247704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247717 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1363:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 247717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 247720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247728 */     GIR_RootConstrainSelectedInstOperands,
     /* 247729 */     // GIR_Coverage, 9674,
     /* 247729 */     GIR_EraseRootFromParent_Done,
     /* 247730 */   // Label 4744: @247730
     /* 247730 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(247772), // Rule ID 9675 //
     /* 247735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 247743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 247746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247759 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1363:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 247759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 247762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247770 */     GIR_RootConstrainSelectedInstOperands,
     /* 247771 */     // GIR_Coverage, 9675,
     /* 247771 */     GIR_EraseRootFromParent_Done,
     /* 247772 */   // Label 4745: @247772
     /* 247772 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(247814), // Rule ID 9676 //
     /* 247777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 247785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 247788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247801 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1363:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 247801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 247804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247812 */     GIR_RootConstrainSelectedInstOperands,
     /* 247813 */     // GIR_Coverage, 9676,
     /* 247813 */     GIR_EraseRootFromParent_Done,
     /* 247814 */   // Label 4746: @247814
     /* 247814 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(247856), // Rule ID 10214 //
     /* 247819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 247827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247843 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1594:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 247846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247854 */     GIR_RootConstrainSelectedInstOperands,
     /* 247855 */     // GIR_Coverage, 10214,
     /* 247855 */     GIR_EraseRootFromParent_Done,
     /* 247856 */   // Label 4747: @247856
     /* 247856 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(247898), // Rule ID 10215 //
     /* 247861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 247869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247885 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1594:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 247888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247896 */     GIR_RootConstrainSelectedInstOperands,
     /* 247897 */     // GIR_Coverage, 10215,
     /* 247897 */     GIR_EraseRootFromParent_Done,
     /* 247898 */   // Label 4748: @247898
     /* 247898 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(247940), // Rule ID 10216 //
     /* 247903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 247911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247927 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1594:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 247930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247938 */     GIR_RootConstrainSelectedInstOperands,
     /* 247939 */     // GIR_Coverage, 10216,
     /* 247939 */     GIR_EraseRootFromParent_Done,
     /* 247940 */   // Label 4749: @247940
     /* 247940 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(247982), // Rule ID 10217 //
     /* 247945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 247953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247969 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1594:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 247972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247980 */     GIR_RootConstrainSelectedInstOperands,
     /* 247981 */     // GIR_Coverage, 10217,
     /* 247981 */     GIR_EraseRootFromParent_Done,
     /* 247982 */   // Label 4750: @247982
     /* 247982 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(248024), // Rule ID 10218 //
     /* 247987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 247995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248011 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1591:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 248014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248022 */     GIR_RootConstrainSelectedInstOperands,
     /* 248023 */     // GIR_Coverage, 10218,
     /* 248023 */     GIR_EraseRootFromParent_Done,
     /* 248024 */   // Label 4751: @248024
     /* 248024 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(248066), // Rule ID 10219 //
     /* 248029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 248037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248053 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1591:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 248056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248064 */     GIR_RootConstrainSelectedInstOperands,
     /* 248065 */     // GIR_Coverage, 10219,
     /* 248065 */     GIR_EraseRootFromParent_Done,
     /* 248066 */   // Label 4752: @248066
     /* 248066 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(248108), // Rule ID 10220 //
     /* 248071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 248079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248095 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1591:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 248098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248106 */     GIR_RootConstrainSelectedInstOperands,
     /* 248107 */     // GIR_Coverage, 10220,
     /* 248107 */     GIR_EraseRootFromParent_Done,
     /* 248108 */   // Label 4753: @248108
     /* 248108 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(248150), // Rule ID 10221 //
     /* 248113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 248121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248137 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1591:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 248140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248148 */     GIR_RootConstrainSelectedInstOperands,
     /* 248149 */     // GIR_Coverage, 10221,
     /* 248149 */     GIR_EraseRootFromParent_Done,
     /* 248150 */   // Label 4754: @248150
     /* 248150 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(248192), // Rule ID 10234 //
     /* 248155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 248163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248179 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1596:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 248182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248190 */     GIR_RootConstrainSelectedInstOperands,
     /* 248191 */     // GIR_Coverage, 10234,
     /* 248191 */     GIR_EraseRootFromParent_Done,
     /* 248192 */   // Label 4755: @248192
     /* 248192 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(248234), // Rule ID 10235 //
     /* 248197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 248205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1596:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 248224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248232 */     GIR_RootConstrainSelectedInstOperands,
     /* 248233 */     // GIR_Coverage, 10235,
     /* 248233 */     GIR_EraseRootFromParent_Done,
     /* 248234 */   // Label 4756: @248234
     /* 248234 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(248276), // Rule ID 10236 //
     /* 248239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 248247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1596:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 248266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248274 */     GIR_RootConstrainSelectedInstOperands,
     /* 248275 */     // GIR_Coverage, 10236,
     /* 248275 */     GIR_EraseRootFromParent_Done,
     /* 248276 */   // Label 4757: @248276
     /* 248276 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(248318), // Rule ID 10237 //
     /* 248281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 248289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248305 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1593:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 248308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248316 */     GIR_RootConstrainSelectedInstOperands,
     /* 248317 */     // GIR_Coverage, 10237,
     /* 248317 */     GIR_EraseRootFromParent_Done,
     /* 248318 */   // Label 4758: @248318
     /* 248318 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(248360), // Rule ID 10238 //
     /* 248323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 248331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248347 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1593:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 248350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248358 */     GIR_RootConstrainSelectedInstOperands,
     /* 248359 */     // GIR_Coverage, 10238,
     /* 248359 */     GIR_EraseRootFromParent_Done,
     /* 248360 */   // Label 4759: @248360
     /* 248360 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(248402), // Rule ID 10239 //
     /* 248365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 248373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1593:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 248392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248400 */     GIR_RootConstrainSelectedInstOperands,
     /* 248401 */     // GIR_Coverage, 10239,
     /* 248401 */     GIR_EraseRootFromParent_Done,
     /* 248402 */   // Label 4760: @248402
     /* 248402 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(248444), // Rule ID 10266 //
     /* 248407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 248415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248431 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1388:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 248431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 248434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248442 */     GIR_RootConstrainSelectedInstOperands,
     /* 248443 */     // GIR_Coverage, 10266,
     /* 248443 */     GIR_EraseRootFromParent_Done,
     /* 248444 */   // Label 4761: @248444
     /* 248444 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(248486), // Rule ID 10270 //
     /* 248449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 248457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248473 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1391:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 248473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 248476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248484 */     GIR_RootConstrainSelectedInstOperands,
     /* 248485 */     // GIR_Coverage, 10270,
     /* 248485 */     GIR_EraseRootFromParent_Done,
     /* 248486 */   // Label 4762: @248486
     /* 248486 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(248528), // Rule ID 10274 //
     /* 248491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 248499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248515 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1390:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 248515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 248518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248526 */     GIR_RootConstrainSelectedInstOperands,
     /* 248527 */     // GIR_Coverage, 10274,
     /* 248527 */     GIR_EraseRootFromParent_Done,
     /* 248528 */   // Label 4763: @248528
     /* 248528 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(248570), // Rule ID 10278 //
     /* 248533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 248541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248557 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1392:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 248557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 248560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248568 */     GIR_RootConstrainSelectedInstOperands,
     /* 248569 */     // GIR_Coverage, 10278,
     /* 248569 */     GIR_EraseRootFromParent_Done,
     /* 248570 */   // Label 4764: @248570
     /* 248570 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(248612), // Rule ID 10282 //
     /* 248575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 248583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248599 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1704:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 248602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248610 */     GIR_RootConstrainSelectedInstOperands,
     /* 248611 */     // GIR_Coverage, 10282,
     /* 248611 */     GIR_EraseRootFromParent_Done,
     /* 248612 */   // Label 4765: @248612
     /* 248612 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(248654), // Rule ID 10283 //
     /* 248617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 248625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248641 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1951:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 248644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248652 */     GIR_RootConstrainSelectedInstOperands,
     /* 248653 */     // GIR_Coverage, 10283,
     /* 248653 */     GIR_EraseRootFromParent_Done,
     /* 248654 */   // Label 4766: @248654
     /* 248654 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(248696), // Rule ID 10284 //
     /* 248659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 248667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 248676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248683 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1948:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 248686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248694 */     GIR_RootConstrainSelectedInstOperands,
     /* 248695 */     // GIR_Coverage, 10284,
     /* 248695 */     GIR_EraseRootFromParent_Done,
     /* 248696 */   // Label 4767: @248696
     /* 248696 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(248738), // Rule ID 10288 //
     /* 248701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 248709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248725 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1703:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 248728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248736 */     GIR_RootConstrainSelectedInstOperands,
     /* 248737 */     // GIR_Coverage, 10288,
     /* 248737 */     GIR_EraseRootFromParent_Done,
     /* 248738 */   // Label 4768: @248738
     /* 248738 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(248780), // Rule ID 10292 //
     /* 248743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 248751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 248760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248767 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1701:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 248770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248778 */     GIR_RootConstrainSelectedInstOperands,
     /* 248779 */     // GIR_Coverage, 10292,
     /* 248779 */     GIR_EraseRootFromParent_Done,
     /* 248780 */   // Label 4769: @248780
     /* 248780 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(248822), // Rule ID 10296 //
     /* 248785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 248793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248809 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1702:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 248812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248820 */     GIR_RootConstrainSelectedInstOperands,
     /* 248821 */     // GIR_Coverage, 10296,
     /* 248821 */     GIR_EraseRootFromParent_Done,
     /* 248822 */   // Label 4770: @248822
     /* 248822 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(248864), // Rule ID 10300 //
     /* 248827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 248835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248851 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1950:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 248854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248862 */     GIR_RootConstrainSelectedInstOperands,
     /* 248863 */     // GIR_Coverage, 10300,
     /* 248863 */     GIR_EraseRootFromParent_Done,
     /* 248864 */   // Label 4771: @248864
     /* 248864 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(248906), // Rule ID 10304 //
     /* 248869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 248877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248893 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1949:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 248896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248904 */     GIR_RootConstrainSelectedInstOperands,
     /* 248905 */     // GIR_Coverage, 10304,
     /* 248905 */     GIR_EraseRootFromParent_Done,
     /* 248906 */   // Label 4772: @248906
     /* 248906 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(248948), // Rule ID 10314 //
     /* 248911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 248919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248935 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1406:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 248935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 248938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248946 */     GIR_RootConstrainSelectedInstOperands,
     /* 248947 */     // GIR_Coverage, 10314,
     /* 248947 */     GIR_EraseRootFromParent_Done,
     /* 248948 */   // Label 4773: @248948
     /* 248948 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(248990), // Rule ID 10315 //
     /* 248953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 248961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248977 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1413:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 248977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 248980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248988 */     GIR_RootConstrainSelectedInstOperands,
     /* 248989 */     // GIR_Coverage, 10315,
     /* 248989 */     GIR_EraseRootFromParent_Done,
     /* 248990 */   // Label 4774: @248990
     /* 248990 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(249032), // Rule ID 10316 //
     /* 248995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 249003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 249012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249019 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1408:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 249019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 249022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249030 */     GIR_RootConstrainSelectedInstOperands,
     /* 249031 */     // GIR_Coverage, 10316,
     /* 249031 */     GIR_EraseRootFromParent_Done,
     /* 249032 */   // Label 4775: @249032
     /* 249032 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(249074), // Rule ID 10320 //
     /* 249037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 249045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 249054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1405:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 249061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 249064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249072 */     GIR_RootConstrainSelectedInstOperands,
     /* 249073 */     // GIR_Coverage, 10320,
     /* 249073 */     GIR_EraseRootFromParent_Done,
     /* 249074 */   // Label 4776: @249074
     /* 249074 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(249116), // Rule ID 10324 //
     /* 249079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 249087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 249096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249103 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1407:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 249103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 249106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249114 */     GIR_RootConstrainSelectedInstOperands,
     /* 249115 */     // GIR_Coverage, 10324,
     /* 249115 */     GIR_EraseRootFromParent_Done,
     /* 249116 */   // Label 4777: @249116
     /* 249116 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(249158), // Rule ID 10328 //
     /* 249121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 249129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 249138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249145 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1412:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 249145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 249148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249156 */     GIR_RootConstrainSelectedInstOperands,
     /* 249157 */     // GIR_Coverage, 10328,
     /* 249157 */     GIR_EraseRootFromParent_Done,
     /* 249158 */   // Label 4778: @249158
     /* 249158 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(249200), // Rule ID 10332 //
     /* 249163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 249171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 249180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249187 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1414:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 249187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 249190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249198 */     GIR_RootConstrainSelectedInstOperands,
     /* 249199 */     // GIR_Coverage, 10332,
     /* 249199 */     GIR_EraseRootFromParent_Done,
     /* 249200 */   // Label 4779: @249200
     /* 249200 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(249242), // Rule ID 10336 //
     /* 249205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 249213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 249222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249229 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1415:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 249229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 249232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249240 */     GIR_RootConstrainSelectedInstOperands,
     /* 249241 */     // GIR_Coverage, 10336,
     /* 249241 */     GIR_EraseRootFromParent_Done,
     /* 249242 */   // Label 4780: @249242
     /* 249242 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(249284), // Rule ID 11333 //
     /* 249247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 249250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 249255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1990:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 249274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249282 */     GIR_RootConstrainSelectedInstOperands,
     /* 249283 */     // GIR_Coverage, 11333,
     /* 249283 */     GIR_EraseRootFromParent_Done,
     /* 249284 */   // Label 4781: @249284
     /* 249284 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(249326), // Rule ID 11334 //
     /* 249289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 249292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 249297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249313 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2061:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 249316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249322 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249324 */     GIR_RootConstrainSelectedInstOperands,
     /* 249325 */     // GIR_Coverage, 11334,
     /* 249325 */     GIR_EraseRootFromParent_Done,
     /* 249326 */   // Label 4782: @249326
     /* 249326 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(249368), // Rule ID 11336 //
     /* 249331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 249334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 249339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249355 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1476:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 249355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 249358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249366 */     GIR_RootConstrainSelectedInstOperands,
     /* 249367 */     // GIR_Coverage, 11336,
     /* 249367 */     GIR_EraseRootFromParent_Done,
     /* 249368 */   // Label 4783: @249368
     /* 249368 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(249410), // Rule ID 11337 //
     /* 249373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 249376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 249381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249397 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1476:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 249397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 249400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249408 */     GIR_RootConstrainSelectedInstOperands,
     /* 249409 */     // GIR_Coverage, 11337,
     /* 249409 */     GIR_EraseRootFromParent_Done,
     /* 249410 */   // Label 4784: @249410
     /* 249410 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(249452), // Rule ID 11391 //
     /* 249415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 249423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 249429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249439 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1825:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 249442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249450 */     GIR_RootConstrainSelectedInstOperands,
     /* 249451 */     // GIR_Coverage, 11391,
     /* 249451 */     GIR_EraseRootFromParent_Done,
     /* 249452 */   // Label 4785: @249452
     /* 249452 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(249494), // Rule ID 11392 //
     /* 249457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 249465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249481 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1825:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 249484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249492 */     GIR_RootConstrainSelectedInstOperands,
     /* 249493 */     // GIR_Coverage, 11392,
     /* 249493 */     GIR_EraseRootFromParent_Done,
     /* 249494 */   // Label 4786: @249494
     /* 249494 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(249536), // Rule ID 11393 //
     /* 249499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 249507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249523 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1825:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 249526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249534 */     GIR_RootConstrainSelectedInstOperands,
     /* 249535 */     // GIR_Coverage, 11393,
     /* 249535 */     GIR_EraseRootFromParent_Done,
     /* 249536 */   // Label 4787: @249536
     /* 249536 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(249578), // Rule ID 11394 //
     /* 249541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 249549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249565 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1825:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 249568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249576 */     GIR_RootConstrainSelectedInstOperands,
     /* 249577 */     // GIR_Coverage, 11394,
     /* 249577 */     GIR_EraseRootFromParent_Done,
     /* 249578 */   // Label 4788: @249578
     /* 249578 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(249620), // Rule ID 11447 //
     /* 249583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 249591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249607 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1746:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 249610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249616 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249618 */     GIR_RootConstrainSelectedInstOperands,
     /* 249619 */     // GIR_Coverage, 11447,
     /* 249619 */     GIR_EraseRootFromParent_Done,
     /* 249620 */   // Label 4789: @249620
     /* 249620 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(249662), // Rule ID 11448 //
     /* 249625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 249633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249649 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 249652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249660 */     GIR_RootConstrainSelectedInstOperands,
     /* 249661 */     // GIR_Coverage, 11448,
     /* 249661 */     GIR_EraseRootFromParent_Done,
     /* 249662 */   // Label 4790: @249662
     /* 249662 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(249704), // Rule ID 11449 //
     /* 249667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 249675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249691 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1746:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 249694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249702 */     GIR_RootConstrainSelectedInstOperands,
     /* 249703 */     // GIR_Coverage, 11449,
     /* 249703 */     GIR_EraseRootFromParent_Done,
     /* 249704 */   // Label 4791: @249704
     /* 249704 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(249746), // Rule ID 11450 //
     /* 249709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 249717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249733 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1982:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 249736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249744 */     GIR_RootConstrainSelectedInstOperands,
     /* 249745 */     // GIR_Coverage, 11450,
     /* 249745 */     GIR_EraseRootFromParent_Done,
     /* 249746 */   // Label 4792: @249746
     /* 249746 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(249788), // Rule ID 11451 //
     /* 249751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 249759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249775 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1982:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 249778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249786 */     GIR_RootConstrainSelectedInstOperands,
     /* 249787 */     // GIR_Coverage, 11451,
     /* 249787 */     GIR_EraseRootFromParent_Done,
     /* 249788 */   // Label 4793: @249788
     /* 249788 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(249830), // Rule ID 11452 //
     /* 249793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 249801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249817 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1982:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 249820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249828 */     GIR_RootConstrainSelectedInstOperands,
     /* 249829 */     // GIR_Coverage, 11452,
     /* 249829 */     GIR_EraseRootFromParent_Done,
     /* 249830 */   // Label 4794: @249830
     /* 249830 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(249872), // Rule ID 11453 //
     /* 249835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 249843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249859 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1984:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 249862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249870 */     GIR_RootConstrainSelectedInstOperands,
     /* 249871 */     // GIR_Coverage, 11453,
     /* 249871 */     GIR_EraseRootFromParent_Done,
     /* 249872 */   // Label 4795: @249872
     /* 249872 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(249914), // Rule ID 11454 //
     /* 249877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 249885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249901 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1984:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 249904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249912 */     GIR_RootConstrainSelectedInstOperands,
     /* 249913 */     // GIR_Coverage, 11454,
     /* 249913 */     GIR_EraseRootFromParent_Done,
     /* 249914 */   // Label 4796: @249914
     /* 249914 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(249956), // Rule ID 11455 //
     /* 249919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 249927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1984:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 249946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249954 */     GIR_RootConstrainSelectedInstOperands,
     /* 249955 */     // GIR_Coverage, 11455,
     /* 249955 */     GIR_EraseRootFromParent_Done,
     /* 249956 */   // Label 4797: @249956
     /* 249956 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(249998), // Rule ID 11456 //
     /* 249961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 249969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249985 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1748:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 249988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249996 */     GIR_RootConstrainSelectedInstOperands,
     /* 249997 */     // GIR_Coverage, 11456,
     /* 249997 */     GIR_EraseRootFromParent_Done,
     /* 249998 */   // Label 4798: @249998
     /* 249998 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(250040), // Rule ID 11457 //
     /* 250003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 250011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250027 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1748:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 250030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250038 */     GIR_RootConstrainSelectedInstOperands,
     /* 250039 */     // GIR_Coverage, 11457,
     /* 250039 */     GIR_EraseRootFromParent_Done,
     /* 250040 */   // Label 4799: @250040
     /* 250040 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(250082), // Rule ID 11458 //
     /* 250045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 250053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250069 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1748:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 250072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250080 */     GIR_RootConstrainSelectedInstOperands,
     /* 250081 */     // GIR_Coverage, 11458,
     /* 250081 */     GIR_EraseRootFromParent_Done,
     /* 250082 */   // Label 4800: @250082
     /* 250082 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(250124), // Rule ID 11459 //
     /* 250087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 250095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250111 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1750:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 250114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250122 */     GIR_RootConstrainSelectedInstOperands,
     /* 250123 */     // GIR_Coverage, 11459,
     /* 250123 */     GIR_EraseRootFromParent_Done,
     /* 250124 */   // Label 4801: @250124
     /* 250124 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(250166), // Rule ID 11460 //
     /* 250129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 250137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250153 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 250156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250164 */     GIR_RootConstrainSelectedInstOperands,
     /* 250165 */     // GIR_Coverage, 11460,
     /* 250165 */     GIR_EraseRootFromParent_Done,
     /* 250166 */   // Label 4802: @250166
     /* 250166 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(250208), // Rule ID 11461 //
     /* 250171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 250179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250195 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1750:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 250198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250206 */     GIR_RootConstrainSelectedInstOperands,
     /* 250207 */     // GIR_Coverage, 11461,
     /* 250207 */     GIR_EraseRootFromParent_Done,
     /* 250208 */   // Label 4803: @250208
     /* 250208 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(250250), // Rule ID 11462 //
     /* 250213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 250221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250237 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1986:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 250240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250248 */     GIR_RootConstrainSelectedInstOperands,
     /* 250249 */     // GIR_Coverage, 11462,
     /* 250249 */     GIR_EraseRootFromParent_Done,
     /* 250250 */   // Label 4804: @250250
     /* 250250 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(250292), // Rule ID 11463 //
     /* 250255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 250263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250279 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1986:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 250282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250290 */     GIR_RootConstrainSelectedInstOperands,
     /* 250291 */     // GIR_Coverage, 11463,
     /* 250291 */     GIR_EraseRootFromParent_Done,
     /* 250292 */   // Label 4805: @250292
     /* 250292 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(250334), // Rule ID 11464 //
     /* 250297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 250305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1986:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 250324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250332 */     GIR_RootConstrainSelectedInstOperands,
     /* 250333 */     // GIR_Coverage, 11464,
     /* 250333 */     GIR_EraseRootFromParent_Done,
     /* 250334 */   // Label 4806: @250334
     /* 250334 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(250376), // Rule ID 11465 //
     /* 250339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 250347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250363 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1988:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 250366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250374 */     GIR_RootConstrainSelectedInstOperands,
     /* 250375 */     // GIR_Coverage, 11465,
     /* 250375 */     GIR_EraseRootFromParent_Done,
     /* 250376 */   // Label 4807: @250376
     /* 250376 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(250418), // Rule ID 11466 //
     /* 250381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 250389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250405 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1988:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 250408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250416 */     GIR_RootConstrainSelectedInstOperands,
     /* 250417 */     // GIR_Coverage, 11466,
     /* 250417 */     GIR_EraseRootFromParent_Done,
     /* 250418 */   // Label 4808: @250418
     /* 250418 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(250460), // Rule ID 11467 //
     /* 250423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 250431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250447 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1988:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 250450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250458 */     GIR_RootConstrainSelectedInstOperands,
     /* 250459 */     // GIR_Coverage, 11467,
     /* 250459 */     GIR_EraseRootFromParent_Done,
     /* 250460 */   // Label 4809: @250460
     /* 250460 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(250502), // Rule ID 11476 //
     /* 250465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 250473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250489 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1786:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 250492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250500 */     GIR_RootConstrainSelectedInstOperands,
     /* 250501 */     // GIR_Coverage, 11476,
     /* 250501 */     GIR_EraseRootFromParent_Done,
     /* 250502 */   // Label 4810: @250502
     /* 250502 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(250544), // Rule ID 11477 //
     /* 250507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 250515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250531 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1786:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 250534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250542 */     GIR_RootConstrainSelectedInstOperands,
     /* 250543 */     // GIR_Coverage, 11477,
     /* 250543 */     GIR_EraseRootFromParent_Done,
     /* 250544 */   // Label 4811: @250544
     /* 250544 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(250586), // Rule ID 11478 //
     /* 250549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 250557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250573 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1786:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 250576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250584 */     GIR_RootConstrainSelectedInstOperands,
     /* 250585 */     // GIR_Coverage, 11478,
     /* 250585 */     GIR_EraseRootFromParent_Done,
     /* 250586 */   // Label 4812: @250586
     /* 250586 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(250628), // Rule ID 11479 //
     /* 250591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 250599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250615 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1789:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 250618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250626 */     GIR_RootConstrainSelectedInstOperands,
     /* 250627 */     // GIR_Coverage, 11479,
     /* 250627 */     GIR_EraseRootFromParent_Done,
     /* 250628 */   // Label 4813: @250628
     /* 250628 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(250670), // Rule ID 11480 //
     /* 250633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 250641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250657 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 250660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250668 */     GIR_RootConstrainSelectedInstOperands,
     /* 250669 */     // GIR_Coverage, 11480,
     /* 250669 */     GIR_EraseRootFromParent_Done,
     /* 250670 */   // Label 4814: @250670
     /* 250670 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(250712), // Rule ID 11481 //
     /* 250675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 250683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250699 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1789:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 250702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250710 */     GIR_RootConstrainSelectedInstOperands,
     /* 250711 */     // GIR_Coverage, 11481,
     /* 250711 */     GIR_EraseRootFromParent_Done,
     /* 250712 */   // Label 4815: @250712
     /* 250712 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(250754), // Rule ID 11482 //
     /* 250717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 250725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250741 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1791:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 250744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250752 */     GIR_RootConstrainSelectedInstOperands,
     /* 250753 */     // GIR_Coverage, 11482,
     /* 250753 */     GIR_EraseRootFromParent_Done,
     /* 250754 */   // Label 4816: @250754
     /* 250754 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(250796), // Rule ID 11483 //
     /* 250759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 250767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250783 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1791:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 250786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250794 */     GIR_RootConstrainSelectedInstOperands,
     /* 250795 */     // GIR_Coverage, 11483,
     /* 250795 */     GIR_EraseRootFromParent_Done,
     /* 250796 */   // Label 4817: @250796
     /* 250796 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(250838), // Rule ID 11484 //
     /* 250801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 250809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250825 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1791:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 250828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250836 */     GIR_RootConstrainSelectedInstOperands,
     /* 250837 */     // GIR_Coverage, 11484,
     /* 250837 */     GIR_EraseRootFromParent_Done,
     /* 250838 */   // Label 4818: @250838
     /* 250838 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(250880), // Rule ID 11485 //
     /* 250843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 250851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250867 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1794:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 250870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250878 */     GIR_RootConstrainSelectedInstOperands,
     /* 250879 */     // GIR_Coverage, 11485,
     /* 250879 */     GIR_EraseRootFromParent_Done,
     /* 250880 */   // Label 4819: @250880
     /* 250880 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(250922), // Rule ID 11486 //
     /* 250885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 250893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250909 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1794:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 250912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250920 */     GIR_RootConstrainSelectedInstOperands,
     /* 250921 */     // GIR_Coverage, 11486,
     /* 250921 */     GIR_EraseRootFromParent_Done,
     /* 250922 */   // Label 4820: @250922
     /* 250922 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(250964), // Rule ID 11487 //
     /* 250927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 250935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1794:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 250954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250962 */     GIR_RootConstrainSelectedInstOperands,
     /* 250963 */     // GIR_Coverage, 11487,
     /* 250963 */     GIR_EraseRootFromParent_Done,
     /* 250964 */   // Label 4821: @250964
     /* 250964 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(251006), // Rule ID 11488 //
     /* 250969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 250977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250993 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1788:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 250996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251004 */     GIR_RootConstrainSelectedInstOperands,
     /* 251005 */     // GIR_Coverage, 11488,
     /* 251005 */     GIR_EraseRootFromParent_Done,
     /* 251006 */   // Label 4822: @251006
     /* 251006 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(251048), // Rule ID 11489 //
     /* 251011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 251019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 251025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251035 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1788:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 251038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251046 */     GIR_RootConstrainSelectedInstOperands,
     /* 251047 */     // GIR_Coverage, 11489,
     /* 251047 */     GIR_EraseRootFromParent_Done,
     /* 251048 */   // Label 4823: @251048
     /* 251048 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(251090), // Rule ID 11490 //
     /* 251053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 251061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 251067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251077 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1788:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 251080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251088 */     GIR_RootConstrainSelectedInstOperands,
     /* 251089 */     // GIR_Coverage, 11490,
     /* 251089 */     GIR_EraseRootFromParent_Done,
     /* 251090 */   // Label 4824: @251090
     /* 251090 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(251132), // Rule ID 11491 //
     /* 251095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 251103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 251109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251119 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1793:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 251122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251130 */     GIR_RootConstrainSelectedInstOperands,
     /* 251131 */     // GIR_Coverage, 11491,
     /* 251131 */     GIR_EraseRootFromParent_Done,
     /* 251132 */   // Label 4825: @251132
     /* 251132 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(251174), // Rule ID 11492 //
     /* 251137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 251145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 251151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251161 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1793:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 251164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251172 */     GIR_RootConstrainSelectedInstOperands,
     /* 251173 */     // GIR_Coverage, 11492,
     /* 251173 */     GIR_EraseRootFromParent_Done,
     /* 251174 */   // Label 4826: @251174
     /* 251174 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(251216), // Rule ID 11493 //
     /* 251179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 251187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 251193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251203 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1793:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 251206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251214 */     GIR_RootConstrainSelectedInstOperands,
     /* 251215 */     // GIR_Coverage, 11493,
     /* 251215 */     GIR_EraseRootFromParent_Done,
     /* 251216 */   // Label 4827: @251216
     /* 251216 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(251258), // Rule ID 11494 //
     /* 251221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 251229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251245 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1961:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 251248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251256 */     GIR_RootConstrainSelectedInstOperands,
     /* 251257 */     // GIR_Coverage, 11494,
     /* 251257 */     GIR_EraseRootFromParent_Done,
     /* 251258 */   // Label 4828: @251258
     /* 251258 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(251300), // Rule ID 11496 //
     /* 251263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 251271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251287 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1961:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 251290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251298 */     GIR_RootConstrainSelectedInstOperands,
     /* 251299 */     // GIR_Coverage, 11496,
     /* 251299 */     GIR_EraseRootFromParent_Done,
     /* 251300 */   // Label 4829: @251300
     /* 251300 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(251342), // Rule ID 11498 //
     /* 251305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 251313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251329 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1961:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 251332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251340 */     GIR_RootConstrainSelectedInstOperands,
     /* 251341 */     // GIR_Coverage, 11498,
     /* 251341 */     GIR_EraseRootFromParent_Done,
     /* 251342 */   // Label 4830: @251342
     /* 251342 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(251384), // Rule ID 11500 //
     /* 251347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 251355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251371 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1961:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 251374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251382 */     GIR_RootConstrainSelectedInstOperands,
     /* 251383 */     // GIR_Coverage, 11500,
     /* 251383 */     GIR_EraseRootFromParent_Done,
     /* 251384 */   // Label 4831: @251384
     /* 251384 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(251426), // Rule ID 11502 //
     /* 251389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 251397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251413 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1721:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 251416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251424 */     GIR_RootConstrainSelectedInstOperands,
     /* 251425 */     // GIR_Coverage, 11502,
     /* 251425 */     GIR_EraseRootFromParent_Done,
     /* 251426 */   // Label 4832: @251426
     /* 251426 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(251468), // Rule ID 11503 //
     /* 251431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 251439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251455 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1721:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 251458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251466 */     GIR_RootConstrainSelectedInstOperands,
     /* 251467 */     // GIR_Coverage, 11503,
     /* 251467 */     GIR_EraseRootFromParent_Done,
     /* 251468 */   // Label 4833: @251468
     /* 251468 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(251510), // Rule ID 11504 //
     /* 251473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 251481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251497 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1721:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 251500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251508 */     GIR_RootConstrainSelectedInstOperands,
     /* 251509 */     // GIR_Coverage, 11504,
     /* 251509 */     GIR_EraseRootFromParent_Done,
     /* 251510 */   // Label 4834: @251510
     /* 251510 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(251552), // Rule ID 11505 //
     /* 251515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 251523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251539 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1721:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 251542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251550 */     GIR_RootConstrainSelectedInstOperands,
     /* 251551 */     // GIR_Coverage, 11505,
     /* 251551 */     GIR_EraseRootFromParent_Done,
     /* 251552 */   // Label 4835: @251552
     /* 251552 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(251594), // Rule ID 11506 //
     /* 251557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 251565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251581 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1962:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 251584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251592 */     GIR_RootConstrainSelectedInstOperands,
     /* 251593 */     // GIR_Coverage, 11506,
     /* 251593 */     GIR_EraseRootFromParent_Done,
     /* 251594 */   // Label 4836: @251594
     /* 251594 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(251636), // Rule ID 11507 //
     /* 251599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 251607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251623 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1962:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 251626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251634 */     GIR_RootConstrainSelectedInstOperands,
     /* 251635 */     // GIR_Coverage, 11507,
     /* 251635 */     GIR_EraseRootFromParent_Done,
     /* 251636 */   // Label 4837: @251636
     /* 251636 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(251678), // Rule ID 11508 //
     /* 251641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 251649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251665 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1962:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 251668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251676 */     GIR_RootConstrainSelectedInstOperands,
     /* 251677 */     // GIR_Coverage, 11508,
     /* 251677 */     GIR_EraseRootFromParent_Done,
     /* 251678 */   // Label 4838: @251678
     /* 251678 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(251720), // Rule ID 11509 //
     /* 251683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 251691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251707 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1962:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 251710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251718 */     GIR_RootConstrainSelectedInstOperands,
     /* 251719 */     // GIR_Coverage, 11509,
     /* 251719 */     GIR_EraseRootFromParent_Done,
     /* 251720 */   // Label 4839: @251720
     /* 251720 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(251762), // Rule ID 11510 //
     /* 251725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 251733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251749 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1856:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 251752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251760 */     GIR_RootConstrainSelectedInstOperands,
     /* 251761 */     // GIR_Coverage, 11510,
     /* 251761 */     GIR_EraseRootFromParent_Done,
     /* 251762 */   // Label 4840: @251762
     /* 251762 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(251804), // Rule ID 11512 //
     /* 251767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 251775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251791 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1856:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 251794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251802 */     GIR_RootConstrainSelectedInstOperands,
     /* 251803 */     // GIR_Coverage, 11512,
     /* 251803 */     GIR_EraseRootFromParent_Done,
     /* 251804 */   // Label 4841: @251804
     /* 251804 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(251846), // Rule ID 11514 //
     /* 251809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 251817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251833 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1856:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 251836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251844 */     GIR_RootConstrainSelectedInstOperands,
     /* 251845 */     // GIR_Coverage, 11514,
     /* 251845 */     GIR_EraseRootFromParent_Done,
     /* 251846 */   // Label 4842: @251846
     /* 251846 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(251888), // Rule ID 11516 //
     /* 251851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 251859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251875 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1856:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 251878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251886 */     GIR_RootConstrainSelectedInstOperands,
     /* 251887 */     // GIR_Coverage, 11516,
     /* 251887 */     GIR_EraseRootFromParent_Done,
     /* 251888 */   // Label 4843: @251888
     /* 251888 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(251930), // Rule ID 11518 //
     /* 251893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 251901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251917 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2048:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 251920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251928 */     GIR_RootConstrainSelectedInstOperands,
     /* 251929 */     // GIR_Coverage, 11518,
     /* 251929 */     GIR_EraseRootFromParent_Done,
     /* 251930 */   // Label 4844: @251930
     /* 251930 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(251972), // Rule ID 11520 //
     /* 251935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 251943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251959 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2048:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 251962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251970 */     GIR_RootConstrainSelectedInstOperands,
     /* 251971 */     // GIR_Coverage, 11520,
     /* 251971 */     GIR_EraseRootFromParent_Done,
     /* 251972 */   // Label 4845: @251972
     /* 251972 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(252014), // Rule ID 11522 //
     /* 251977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 251985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252001 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2048:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 252004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252012 */     GIR_RootConstrainSelectedInstOperands,
     /* 252013 */     // GIR_Coverage, 11522,
     /* 252013 */     GIR_EraseRootFromParent_Done,
     /* 252014 */   // Label 4846: @252014
     /* 252014 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(252056), // Rule ID 11524 //
     /* 252019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 252027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252043 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2048:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 252046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252054 */     GIR_RootConstrainSelectedInstOperands,
     /* 252055 */     // GIR_Coverage, 11524,
     /* 252055 */     GIR_EraseRootFromParent_Done,
     /* 252056 */   // Label 4847: @252056
     /* 252056 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(252098), // Rule ID 11526 //
     /* 252061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 252069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252085 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1722:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 252088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252096 */     GIR_RootConstrainSelectedInstOperands,
     /* 252097 */     // GIR_Coverage, 11526,
     /* 252097 */     GIR_EraseRootFromParent_Done,
     /* 252098 */   // Label 4848: @252098
     /* 252098 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(252140), // Rule ID 11527 //
     /* 252103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 252111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252127 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1722:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 252130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252138 */     GIR_RootConstrainSelectedInstOperands,
     /* 252139 */     // GIR_Coverage, 11527,
     /* 252139 */     GIR_EraseRootFromParent_Done,
     /* 252140 */   // Label 4849: @252140
     /* 252140 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(252182), // Rule ID 11528 //
     /* 252145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 252153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1722:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 252172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252180 */     GIR_RootConstrainSelectedInstOperands,
     /* 252181 */     // GIR_Coverage, 11528,
     /* 252181 */     GIR_EraseRootFromParent_Done,
     /* 252182 */   // Label 4850: @252182
     /* 252182 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(252224), // Rule ID 11529 //
     /* 252187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 252195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252211 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1722:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 252214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252222 */     GIR_RootConstrainSelectedInstOperands,
     /* 252223 */     // GIR_Coverage, 11529,
     /* 252223 */     GIR_EraseRootFromParent_Done,
     /* 252224 */   // Label 4851: @252224
     /* 252224 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(252266), // Rule ID 11530 //
     /* 252229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 252237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252253 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1963:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 252256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252264 */     GIR_RootConstrainSelectedInstOperands,
     /* 252265 */     // GIR_Coverage, 11530,
     /* 252265 */     GIR_EraseRootFromParent_Done,
     /* 252266 */   // Label 4852: @252266
     /* 252266 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(252308), // Rule ID 11531 //
     /* 252271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 252279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252295 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1963:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 252298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252306 */     GIR_RootConstrainSelectedInstOperands,
     /* 252307 */     // GIR_Coverage, 11531,
     /* 252307 */     GIR_EraseRootFromParent_Done,
     /* 252308 */   // Label 4853: @252308
     /* 252308 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(252350), // Rule ID 11532 //
     /* 252313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 252321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252337 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1963:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 252340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252348 */     GIR_RootConstrainSelectedInstOperands,
     /* 252349 */     // GIR_Coverage, 11532,
     /* 252349 */     GIR_EraseRootFromParent_Done,
     /* 252350 */   // Label 4854: @252350
     /* 252350 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(252392), // Rule ID 11533 //
     /* 252355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 252363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252379 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1963:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 252382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252390 */     GIR_RootConstrainSelectedInstOperands,
     /* 252391 */     // GIR_Coverage, 11533,
     /* 252391 */     GIR_EraseRootFromParent_Done,
     /* 252392 */   // Label 4855: @252392
     /* 252392 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(252434), // Rule ID 11534 //
     /* 252397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 252405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1938:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 252424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252432 */     GIR_RootConstrainSelectedInstOperands,
     /* 252433 */     // GIR_Coverage, 11534,
     /* 252433 */     GIR_EraseRootFromParent_Done,
     /* 252434 */   // Label 4856: @252434
     /* 252434 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(252476), // Rule ID 11535 //
     /* 252439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 252447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252463 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1938:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 252466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252474 */     GIR_RootConstrainSelectedInstOperands,
     /* 252475 */     // GIR_Coverage, 11535,
     /* 252475 */     GIR_EraseRootFromParent_Done,
     /* 252476 */   // Label 4857: @252476
     /* 252476 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(252518), // Rule ID 11536 //
     /* 252481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 252489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252505 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1938:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 252508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252516 */     GIR_RootConstrainSelectedInstOperands,
     /* 252517 */     // GIR_Coverage, 11536,
     /* 252517 */     GIR_EraseRootFromParent_Done,
     /* 252518 */   // Label 4858: @252518
     /* 252518 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(252560), // Rule ID 11537 //
     /* 252523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 252531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252547 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1253:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 252550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252558 */     GIR_RootConstrainSelectedInstOperands,
     /* 252559 */     // GIR_Coverage, 11537,
     /* 252559 */     GIR_EraseRootFromParent_Done,
     /* 252560 */   // Label 4859: @252560
     /* 252560 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(252602), // Rule ID 11538 //
     /* 252565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 252573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252589 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1253:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 252592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252600 */     GIR_RootConstrainSelectedInstOperands,
     /* 252601 */     // GIR_Coverage, 11538,
     /* 252601 */     GIR_EraseRootFromParent_Done,
     /* 252602 */   // Label 4860: @252602
     /* 252602 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(252644), // Rule ID 11539 //
     /* 252607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 252615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252631 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1253:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 252634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252642 */     GIR_RootConstrainSelectedInstOperands,
     /* 252643 */     // GIR_Coverage, 11539,
     /* 252643 */     GIR_EraseRootFromParent_Done,
     /* 252644 */   // Label 4861: @252644
     /* 252644 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(252686), // Rule ID 11540 //
     /* 252649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 252657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252673 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1253:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 252676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252684 */     GIR_RootConstrainSelectedInstOperands,
     /* 252685 */     // GIR_Coverage, 11540,
     /* 252685 */     GIR_EraseRootFromParent_Done,
     /* 252686 */   // Label 4862: @252686
     /* 252686 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(252728), // Rule ID 11541 //
     /* 252691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 252699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252715 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1732:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 252718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252726 */     GIR_RootConstrainSelectedInstOperands,
     /* 252727 */     // GIR_Coverage, 11541,
     /* 252727 */     GIR_EraseRootFromParent_Done,
     /* 252728 */   // Label 4863: @252728
     /* 252728 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(252770), // Rule ID 11542 //
     /* 252733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 252741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252757 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1732:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 252760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252768 */     GIR_RootConstrainSelectedInstOperands,
     /* 252769 */     // GIR_Coverage, 11542,
     /* 252769 */     GIR_EraseRootFromParent_Done,
     /* 252770 */   // Label 4864: @252770
     /* 252770 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(252812), // Rule ID 11543 //
     /* 252775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 252783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1732:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 252802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252810 */     GIR_RootConstrainSelectedInstOperands,
     /* 252811 */     // GIR_Coverage, 11543,
     /* 252811 */     GIR_EraseRootFromParent_Done,
     /* 252812 */   // Label 4865: @252812
     /* 252812 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(252854), // Rule ID 11544 //
     /* 252817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 252825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252841 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1732:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 252844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252852 */     GIR_RootConstrainSelectedInstOperands,
     /* 252853 */     // GIR_Coverage, 11544,
     /* 252853 */     GIR_EraseRootFromParent_Done,
     /* 252854 */   // Label 4866: @252854
     /* 252854 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(252896), // Rule ID 11545 //
     /* 252859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 252867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252883 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1970:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 252886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252894 */     GIR_RootConstrainSelectedInstOperands,
     /* 252895 */     // GIR_Coverage, 11545,
     /* 252895 */     GIR_EraseRootFromParent_Done,
     /* 252896 */   // Label 4867: @252896
     /* 252896 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(252938), // Rule ID 11546 //
     /* 252901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 252909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252925 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1970:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 252928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252936 */     GIR_RootConstrainSelectedInstOperands,
     /* 252937 */     // GIR_Coverage, 11546,
     /* 252937 */     GIR_EraseRootFromParent_Done,
     /* 252938 */   // Label 4868: @252938
     /* 252938 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(252980), // Rule ID 11547 //
     /* 252943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 252951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252967 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1970:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 252970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252978 */     GIR_RootConstrainSelectedInstOperands,
     /* 252979 */     // GIR_Coverage, 11547,
     /* 252979 */     GIR_EraseRootFromParent_Done,
     /* 252980 */   // Label 4869: @252980
     /* 252980 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(253022), // Rule ID 11548 //
     /* 252985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 252993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1970:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 253012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253020 */     GIR_RootConstrainSelectedInstOperands,
     /* 253021 */     // GIR_Coverage, 11548,
     /* 253021 */     GIR_EraseRootFromParent_Done,
     /* 253022 */   // Label 4870: @253022
     /* 253022 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(253064), // Rule ID 11549 //
     /* 253027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 253035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253051 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1741:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 253054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253062 */     GIR_RootConstrainSelectedInstOperands,
     /* 253063 */     // GIR_Coverage, 11549,
     /* 253063 */     GIR_EraseRootFromParent_Done,
     /* 253064 */   // Label 4871: @253064
     /* 253064 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(253106), // Rule ID 11550 //
     /* 253069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 253077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253093 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1741:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 253096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253104 */     GIR_RootConstrainSelectedInstOperands,
     /* 253105 */     // GIR_Coverage, 11550,
     /* 253105 */     GIR_EraseRootFromParent_Done,
     /* 253106 */   // Label 4872: @253106
     /* 253106 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(253148), // Rule ID 11551 //
     /* 253111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 253119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253135 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1741:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 253138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253146 */     GIR_RootConstrainSelectedInstOperands,
     /* 253147 */     // GIR_Coverage, 11551,
     /* 253147 */     GIR_EraseRootFromParent_Done,
     /* 253148 */   // Label 4873: @253148
     /* 253148 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(253190), // Rule ID 11552 //
     /* 253153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 253161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253177 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1741:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 253180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253188 */     GIR_RootConstrainSelectedInstOperands,
     /* 253189 */     // GIR_Coverage, 11552,
     /* 253189 */     GIR_EraseRootFromParent_Done,
     /* 253190 */   // Label 4874: @253190
     /* 253190 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(253232), // Rule ID 11553 //
     /* 253195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 253203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253219 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1979:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 253222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253230 */     GIR_RootConstrainSelectedInstOperands,
     /* 253231 */     // GIR_Coverage, 11553,
     /* 253231 */     GIR_EraseRootFromParent_Done,
     /* 253232 */   // Label 4875: @253232
     /* 253232 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(253274), // Rule ID 11554 //
     /* 253237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 253245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253261 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1979:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 253264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253272 */     GIR_RootConstrainSelectedInstOperands,
     /* 253273 */     // GIR_Coverage, 11554,
     /* 253273 */     GIR_EraseRootFromParent_Done,
     /* 253274 */   // Label 4876: @253274
     /* 253274 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(253316), // Rule ID 11555 //
     /* 253279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 253287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253303 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1979:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 253306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253314 */     GIR_RootConstrainSelectedInstOperands,
     /* 253315 */     // GIR_Coverage, 11555,
     /* 253315 */     GIR_EraseRootFromParent_Done,
     /* 253316 */   // Label 4877: @253316
     /* 253316 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(253358), // Rule ID 11556 //
     /* 253321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 253329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253345 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1979:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 253348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253356 */     GIR_RootConstrainSelectedInstOperands,
     /* 253357 */     // GIR_Coverage, 11556,
     /* 253357 */     GIR_EraseRootFromParent_Done,
     /* 253358 */   // Label 4878: @253358
     /* 253358 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(253400), // Rule ID 11557 //
     /* 253363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 253371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 253380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253387 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2055:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 253390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253398 */     GIR_RootConstrainSelectedInstOperands,
     /* 253399 */     // GIR_Coverage, 11557,
     /* 253399 */     GIR_EraseRootFromParent_Done,
     /* 253400 */   // Label 4879: @253400
     /* 253400 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(253442), // Rule ID 11568 //
     /* 253405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 253413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 253422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253429 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1820:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 253432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253440 */     GIR_RootConstrainSelectedInstOperands,
     /* 253441 */     // GIR_Coverage, 11568,
     /* 253441 */     GIR_EraseRootFromParent_Done,
     /* 253442 */   // Label 4880: @253442
     /* 253442 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(253484), // Rule ID 11569 //
     /* 253447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 253455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 253464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1820:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 253474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253482 */     GIR_RootConstrainSelectedInstOperands,
     /* 253483 */     // GIR_Coverage, 11569,
     /* 253483 */     GIR_EraseRootFromParent_Done,
     /* 253484 */   // Label 4881: @253484
     /* 253484 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(253526), // Rule ID 11570 //
     /* 253489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 253497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 253506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253513 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1820:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 253516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253524 */     GIR_RootConstrainSelectedInstOperands,
     /* 253525 */     // GIR_Coverage, 11570,
     /* 253525 */     GIR_EraseRootFromParent_Done,
     /* 253526 */   // Label 4882: @253526
     /* 253526 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(253568), // Rule ID 11571 //
     /* 253531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 253539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 253548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253555 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1820:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 253558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253566 */     GIR_RootConstrainSelectedInstOperands,
     /* 253567 */     // GIR_Coverage, 11571,
     /* 253567 */     GIR_EraseRootFromParent_Done,
     /* 253568 */   // Label 4883: @253568
     /* 253568 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(253610), // Rule ID 11580 //
     /* 253573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 253581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253597 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1761:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 253600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253608 */     GIR_RootConstrainSelectedInstOperands,
     /* 253609 */     // GIR_Coverage, 11580,
     /* 253609 */     GIR_EraseRootFromParent_Done,
     /* 253610 */   // Label 4884: @253610
     /* 253610 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(253652), // Rule ID 11581 //
     /* 253615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 253623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253639 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1761:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 253642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253650 */     GIR_RootConstrainSelectedInstOperands,
     /* 253651 */     // GIR_Coverage, 11581,
     /* 253651 */     GIR_EraseRootFromParent_Done,
     /* 253652 */   // Label 4885: @253652
     /* 253652 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(253694), // Rule ID 11582 //
     /* 253657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 253665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1761:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 253684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253692 */     GIR_RootConstrainSelectedInstOperands,
     /* 253693 */     // GIR_Coverage, 11582,
     /* 253693 */     GIR_EraseRootFromParent_Done,
     /* 253694 */   // Label 4886: @253694
     /* 253694 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(253736), // Rule ID 11583 //
     /* 253699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 253707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253723 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1761:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 253726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253734 */     GIR_RootConstrainSelectedInstOperands,
     /* 253735 */     // GIR_Coverage, 11583,
     /* 253735 */     GIR_EraseRootFromParent_Done,
     /* 253736 */   // Label 4887: @253736
     /* 253736 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(253778), // Rule ID 11584 //
     /* 253741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 253749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253765 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1997:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 253768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253776 */     GIR_RootConstrainSelectedInstOperands,
     /* 253777 */     // GIR_Coverage, 11584,
     /* 253777 */     GIR_EraseRootFromParent_Done,
     /* 253778 */   // Label 4888: @253778
     /* 253778 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(253820), // Rule ID 11585 //
     /* 253783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 253791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253807 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1997:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 253810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253818 */     GIR_RootConstrainSelectedInstOperands,
     /* 253819 */     // GIR_Coverage, 11585,
     /* 253819 */     GIR_EraseRootFromParent_Done,
     /* 253820 */   // Label 4889: @253820
     /* 253820 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(253862), // Rule ID 11586 //
     /* 253825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 253833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253849 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1997:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 253852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253860 */     GIR_RootConstrainSelectedInstOperands,
     /* 253861 */     // GIR_Coverage, 11586,
     /* 253861 */     GIR_EraseRootFromParent_Done,
     /* 253862 */   // Label 4890: @253862
     /* 253862 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(253904), // Rule ID 11587 //
     /* 253867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 253875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1997:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 253894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253902 */     GIR_RootConstrainSelectedInstOperands,
     /* 253903 */     // GIR_Coverage, 11587,
     /* 253903 */     GIR_EraseRootFromParent_Done,
     /* 253904 */   // Label 4891: @253904
     /* 253904 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(253946), // Rule ID 11588 //
     /* 253909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 253917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253933 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1848:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 253936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253944 */     GIR_RootConstrainSelectedInstOperands,
     /* 253945 */     // GIR_Coverage, 11588,
     /* 253945 */     GIR_EraseRootFromParent_Done,
     /* 253946 */   // Label 4892: @253946
     /* 253946 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(253988), // Rule ID 11589 //
     /* 253951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 253959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253975 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1848:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 253978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253986 */     GIR_RootConstrainSelectedInstOperands,
     /* 253987 */     // GIR_Coverage, 11589,
     /* 253987 */     GIR_EraseRootFromParent_Done,
     /* 253988 */   // Label 4893: @253988
     /* 253988 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(254030), // Rule ID 11590 //
     /* 253993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 254001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254017 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1848:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 254020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254028 */     GIR_RootConstrainSelectedInstOperands,
     /* 254029 */     // GIR_Coverage, 11590,
     /* 254029 */     GIR_EraseRootFromParent_Done,
     /* 254030 */   // Label 4894: @254030
     /* 254030 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(254072), // Rule ID 11591 //
     /* 254035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 254043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1848:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 254062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254070 */     GIR_RootConstrainSelectedInstOperands,
     /* 254071 */     // GIR_Coverage, 11591,
     /* 254071 */     GIR_EraseRootFromParent_Done,
     /* 254072 */   // Label 4895: @254072
     /* 254072 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(254114), // Rule ID 11592 //
     /* 254077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 254085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2041:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 254104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254112 */     GIR_RootConstrainSelectedInstOperands,
     /* 254113 */     // GIR_Coverage, 11592,
     /* 254113 */     GIR_EraseRootFromParent_Done,
     /* 254114 */   // Label 4896: @254114
     /* 254114 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(254156), // Rule ID 11593 //
     /* 254119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 254127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2041:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 254146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254154 */     GIR_RootConstrainSelectedInstOperands,
     /* 254155 */     // GIR_Coverage, 11593,
     /* 254155 */     GIR_EraseRootFromParent_Done,
     /* 254156 */   // Label 4897: @254156
     /* 254156 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(254198), // Rule ID 11594 //
     /* 254161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 254169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254185 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2041:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 254188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254196 */     GIR_RootConstrainSelectedInstOperands,
     /* 254197 */     // GIR_Coverage, 11594,
     /* 254197 */     GIR_EraseRootFromParent_Done,
     /* 254198 */   // Label 4898: @254198
     /* 254198 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(254240), // Rule ID 11595 //
     /* 254203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 254211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254227 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2041:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 254230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254238 */     GIR_RootConstrainSelectedInstOperands,
     /* 254239 */     // GIR_Coverage, 11595,
     /* 254239 */     GIR_EraseRootFromParent_Done,
     /* 254240 */   // Label 4899: @254240
     /* 254240 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(254282), // Rule ID 11596 //
     /* 254245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 254253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254269 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1912:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 254272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254280 */     GIR_RootConstrainSelectedInstOperands,
     /* 254281 */     // GIR_Coverage, 11596,
     /* 254281 */     GIR_EraseRootFromParent_Done,
     /* 254282 */   // Label 4900: @254282
     /* 254282 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(254324), // Rule ID 11597 //
     /* 254287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 254295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254311 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1912:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 254314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254322 */     GIR_RootConstrainSelectedInstOperands,
     /* 254323 */     // GIR_Coverage, 11597,
     /* 254323 */     GIR_EraseRootFromParent_Done,
     /* 254324 */   // Label 4901: @254324
     /* 254324 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(254366), // Rule ID 11598 //
     /* 254329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 254337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254353 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1912:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 254356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254364 */     GIR_RootConstrainSelectedInstOperands,
     /* 254365 */     // GIR_Coverage, 11598,
     /* 254365 */     GIR_EraseRootFromParent_Done,
     /* 254366 */   // Label 4902: @254366
     /* 254366 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(254408), // Rule ID 11599 //
     /* 254371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 254379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254395 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1912:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 254398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254406 */     GIR_RootConstrainSelectedInstOperands,
     /* 254407 */     // GIR_Coverage, 11599,
     /* 254407 */     GIR_EraseRootFromParent_Done,
     /* 254408 */   // Label 4903: @254408
     /* 254408 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(254450), // Rule ID 11600 //
     /* 254413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 254421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254437 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2062:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 254440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254448 */     GIR_RootConstrainSelectedInstOperands,
     /* 254449 */     // GIR_Coverage, 11600,
     /* 254449 */     GIR_EraseRootFromParent_Done,
     /* 254450 */   // Label 4904: @254450
     /* 254450 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(254492), // Rule ID 11601 //
     /* 254455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 254463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254479 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2062:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 254482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254490 */     GIR_RootConstrainSelectedInstOperands,
     /* 254491 */     // GIR_Coverage, 11601,
     /* 254491 */     GIR_EraseRootFromParent_Done,
     /* 254492 */   // Label 4905: @254492
     /* 254492 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(254534), // Rule ID 11602 //
     /* 254497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 254505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254521 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2062:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 254524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254532 */     GIR_RootConstrainSelectedInstOperands,
     /* 254533 */     // GIR_Coverage, 11602,
     /* 254533 */     GIR_EraseRootFromParent_Done,
     /* 254534 */   // Label 4906: @254534
     /* 254534 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(254576), // Rule ID 11603 //
     /* 254539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 254547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254563 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2062:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 254566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254574 */     GIR_RootConstrainSelectedInstOperands,
     /* 254575 */     // GIR_Coverage, 11603,
     /* 254575 */     GIR_EraseRootFromParent_Done,
     /* 254576 */   // Label 4907: @254576
     /* 254576 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(254618), // Rule ID 11604 //
     /* 254581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 254589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254605 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1851:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 254608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254616 */     GIR_RootConstrainSelectedInstOperands,
     /* 254617 */     // GIR_Coverage, 11604,
     /* 254617 */     GIR_EraseRootFromParent_Done,
     /* 254618 */   // Label 4908: @254618
     /* 254618 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(254660), // Rule ID 11605 //
     /* 254623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 254631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254647 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 254650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254658 */     GIR_RootConstrainSelectedInstOperands,
     /* 254659 */     // GIR_Coverage, 11605,
     /* 254659 */     GIR_EraseRootFromParent_Done,
     /* 254660 */   // Label 4909: @254660
     /* 254660 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(254702), // Rule ID 11606 //
     /* 254665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 254673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254689 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 254692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254700 */     GIR_RootConstrainSelectedInstOperands,
     /* 254701 */     // GIR_Coverage, 11606,
     /* 254701 */     GIR_EraseRootFromParent_Done,
     /* 254702 */   // Label 4910: @254702
     /* 254702 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(254744), // Rule ID 11607 //
     /* 254707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 254715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254731 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1851:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 254734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254742 */     GIR_RootConstrainSelectedInstOperands,
     /* 254743 */     // GIR_Coverage, 11607,
     /* 254743 */     GIR_EraseRootFromParent_Done,
     /* 254744 */   // Label 4911: @254744
     /* 254744 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(254786), // Rule ID 11608 //
     /* 254749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 254757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254773 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2044:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 254776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254784 */     GIR_RootConstrainSelectedInstOperands,
     /* 254785 */     // GIR_Coverage, 11608,
     /* 254785 */     GIR_EraseRootFromParent_Done,
     /* 254786 */   // Label 4912: @254786
     /* 254786 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(254828), // Rule ID 11609 //
     /* 254791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 254799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254815 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2044:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 254818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254826 */     GIR_RootConstrainSelectedInstOperands,
     /* 254827 */     // GIR_Coverage, 11609,
     /* 254827 */     GIR_EraseRootFromParent_Done,
     /* 254828 */   // Label 4913: @254828
     /* 254828 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(254870), // Rule ID 11610 //
     /* 254833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 254841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254857 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2044:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 254860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254868 */     GIR_RootConstrainSelectedInstOperands,
     /* 254869 */     // GIR_Coverage, 11610,
     /* 254869 */     GIR_EraseRootFromParent_Done,
     /* 254870 */   // Label 4914: @254870
     /* 254870 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(254912), // Rule ID 11611 //
     /* 254875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 254883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254899 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2044:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 254902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254910 */     GIR_RootConstrainSelectedInstOperands,
     /* 254911 */     // GIR_Coverage, 11611,
     /* 254911 */     GIR_EraseRootFromParent_Done,
     /* 254912 */   // Label 4915: @254912
     /* 254912 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(254954), // Rule ID 11612 //
     /* 254917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 254925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254941 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1858:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 254944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254952 */     GIR_RootConstrainSelectedInstOperands,
     /* 254953 */     // GIR_Coverage, 11612,
     /* 254953 */     GIR_EraseRootFromParent_Done,
     /* 254954 */   // Label 4916: @254954
     /* 254954 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(254996), // Rule ID 11613 //
     /* 254959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 254967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254983 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1858:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 254986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254994 */     GIR_RootConstrainSelectedInstOperands,
     /* 254995 */     // GIR_Coverage, 11613,
     /* 254995 */     GIR_EraseRootFromParent_Done,
     /* 254996 */   // Label 4917: @254996
     /* 254996 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(255038), // Rule ID 11614 //
     /* 255001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 255009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255025 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1858:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 255028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255036 */     GIR_RootConstrainSelectedInstOperands,
     /* 255037 */     // GIR_Coverage, 11614,
     /* 255037 */     GIR_EraseRootFromParent_Done,
     /* 255038 */   // Label 4918: @255038
     /* 255038 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(255080), // Rule ID 11615 //
     /* 255043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 255051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255067 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1858:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 255070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255078 */     GIR_RootConstrainSelectedInstOperands,
     /* 255079 */     // GIR_Coverage, 11615,
     /* 255079 */     GIR_EraseRootFromParent_Done,
     /* 255080 */   // Label 4919: @255080
     /* 255080 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(255122), // Rule ID 11616 //
     /* 255085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 255093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 255099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255109 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2049:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 255112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255120 */     GIR_RootConstrainSelectedInstOperands,
     /* 255121 */     // GIR_Coverage, 11616,
     /* 255121 */     GIR_EraseRootFromParent_Done,
     /* 255122 */   // Label 4920: @255122
     /* 255122 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(255164), // Rule ID 11617 //
     /* 255127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 255135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255151 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2049:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 255154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255162 */     GIR_RootConstrainSelectedInstOperands,
     /* 255163 */     // GIR_Coverage, 11617,
     /* 255163 */     GIR_EraseRootFromParent_Done,
     /* 255164 */   // Label 4921: @255164
     /* 255164 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(255206), // Rule ID 11618 //
     /* 255169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 255177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255193 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2049:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 255196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255204 */     GIR_RootConstrainSelectedInstOperands,
     /* 255205 */     // GIR_Coverage, 11618,
     /* 255205 */     GIR_EraseRootFromParent_Done,
     /* 255206 */   // Label 4922: @255206
     /* 255206 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(255248), // Rule ID 11619 //
     /* 255211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 255219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255235 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2049:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 255238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255246 */     GIR_RootConstrainSelectedInstOperands,
     /* 255247 */     // GIR_Coverage, 11619,
     /* 255247 */     GIR_EraseRootFromParent_Done,
     /* 255248 */   // Label 4923: @255248
     /* 255248 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(255290), // Rule ID 11620 //
     /* 255253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 255261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 255267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255277 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1842:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 255280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255288 */     GIR_RootConstrainSelectedInstOperands,
     /* 255289 */     // GIR_Coverage, 11620,
     /* 255289 */     GIR_EraseRootFromParent_Done,
     /* 255290 */   // Label 4924: @255290
     /* 255290 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(255332), // Rule ID 11621 //
     /* 255295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 255303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255319 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1842:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 255322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255330 */     GIR_RootConstrainSelectedInstOperands,
     /* 255331 */     // GIR_Coverage, 11621,
     /* 255331 */     GIR_EraseRootFromParent_Done,
     /* 255332 */   // Label 4925: @255332
     /* 255332 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(255374), // Rule ID 11622 //
     /* 255337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 255345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255361 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1842:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 255364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255372 */     GIR_RootConstrainSelectedInstOperands,
     /* 255373 */     // GIR_Coverage, 11622,
     /* 255373 */     GIR_EraseRootFromParent_Done,
     /* 255374 */   // Label 4926: @255374
     /* 255374 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(255416), // Rule ID 11623 //
     /* 255379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 255387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255403 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1842:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 255406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255414 */     GIR_RootConstrainSelectedInstOperands,
     /* 255415 */     // GIR_Coverage, 11623,
     /* 255415 */     GIR_EraseRootFromParent_Done,
     /* 255416 */   // Label 4927: @255416
     /* 255416 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(255458), // Rule ID 11624 //
     /* 255421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 255429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 255435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255445 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2038:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 255448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255456 */     GIR_RootConstrainSelectedInstOperands,
     /* 255457 */     // GIR_Coverage, 11624,
     /* 255457 */     GIR_EraseRootFromParent_Done,
     /* 255458 */   // Label 4928: @255458
     /* 255458 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(255500), // Rule ID 11625 //
     /* 255463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 255471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255487 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2038:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 255490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255498 */     GIR_RootConstrainSelectedInstOperands,
     /* 255499 */     // GIR_Coverage, 11625,
     /* 255499 */     GIR_EraseRootFromParent_Done,
     /* 255500 */   // Label 4929: @255500
     /* 255500 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(255542), // Rule ID 11626 //
     /* 255505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 255513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255529 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2038:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 255532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255540 */     GIR_RootConstrainSelectedInstOperands,
     /* 255541 */     // GIR_Coverage, 11626,
     /* 255541 */     GIR_EraseRootFromParent_Done,
     /* 255542 */   // Label 4930: @255542
     /* 255542 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(255584), // Rule ID 11627 //
     /* 255547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 255555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255571 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2038:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 255574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255582 */     GIR_RootConstrainSelectedInstOperands,
     /* 255583 */     // GIR_Coverage, 11627,
     /* 255583 */     GIR_EraseRootFromParent_Done,
     /* 255584 */   // Label 4931: @255584
     /* 255584 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(255626), // Rule ID 11628 //
     /* 255589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 255597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 255603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255613 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1829:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 255616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255624 */     GIR_RootConstrainSelectedInstOperands,
     /* 255625 */     // GIR_Coverage, 11628,
     /* 255625 */     GIR_EraseRootFromParent_Done,
     /* 255626 */   // Label 4932: @255626
     /* 255626 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(255668), // Rule ID 11629 //
     /* 255631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 255639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255655 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1829:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 255658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255666 */     GIR_RootConstrainSelectedInstOperands,
     /* 255667 */     // GIR_Coverage, 11629,
     /* 255667 */     GIR_EraseRootFromParent_Done,
     /* 255668 */   // Label 4933: @255668
     /* 255668 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(255710), // Rule ID 11630 //
     /* 255673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 255681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255697 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1829:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 255700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255708 */     GIR_RootConstrainSelectedInstOperands,
     /* 255709 */     // GIR_Coverage, 11630,
     /* 255709 */     GIR_EraseRootFromParent_Done,
     /* 255710 */   // Label 4934: @255710
     /* 255710 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(255752), // Rule ID 11631 //
     /* 255715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 255723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255739 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1829:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 255742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255750 */     GIR_RootConstrainSelectedInstOperands,
     /* 255751 */     // GIR_Coverage, 11631,
     /* 255751 */     GIR_EraseRootFromParent_Done,
     /* 255752 */   // Label 4935: @255752
     /* 255752 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(255794), // Rule ID 11632 //
     /* 255757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 255765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 255771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255781 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2031:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 255784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255792 */     GIR_RootConstrainSelectedInstOperands,
     /* 255793 */     // GIR_Coverage, 11632,
     /* 255793 */     GIR_EraseRootFromParent_Done,
     /* 255794 */   // Label 4936: @255794
     /* 255794 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(255836), // Rule ID 11633 //
     /* 255799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 255807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255823 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2031:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 255826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255834 */     GIR_RootConstrainSelectedInstOperands,
     /* 255835 */     // GIR_Coverage, 11633,
     /* 255835 */     GIR_EraseRootFromParent_Done,
     /* 255836 */   // Label 4937: @255836
     /* 255836 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(255878), // Rule ID 11634 //
     /* 255841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 255849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255865 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2031:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 255868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255876 */     GIR_RootConstrainSelectedInstOperands,
     /* 255877 */     // GIR_Coverage, 11634,
     /* 255877 */     GIR_EraseRootFromParent_Done,
     /* 255878 */   // Label 4938: @255878
     /* 255878 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(255920), // Rule ID 11635 //
     /* 255883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 255891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255907 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2031:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 255910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255918 */     GIR_RootConstrainSelectedInstOperands,
     /* 255919 */     // GIR_Coverage, 11635,
     /* 255919 */     GIR_EraseRootFromParent_Done,
     /* 255920 */   // Label 4939: @255920
     /* 255920 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(255962), // Rule ID 11798 //
     /* 255925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 255933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255949 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1931:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 255952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255960 */     GIR_RootConstrainSelectedInstOperands,
     /* 255961 */     // GIR_Coverage, 11798,
     /* 255961 */     GIR_EraseRootFromParent_Done,
     /* 255962 */   // Label 4940: @255962
     /* 255962 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(256004), // Rule ID 11800 //
     /* 255967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 255975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255991 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1931:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 255994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256002 */     GIR_RootConstrainSelectedInstOperands,
     /* 256003 */     // GIR_Coverage, 11800,
     /* 256003 */     GIR_EraseRootFromParent_Done,
     /* 256004 */   // Label 4941: @256004
     /* 256004 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(256046), // Rule ID 11802 //
     /* 256009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 256017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256033 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1931:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 256036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256044 */     GIR_RootConstrainSelectedInstOperands,
     /* 256045 */     // GIR_Coverage, 11802,
     /* 256045 */     GIR_EraseRootFromParent_Done,
     /* 256046 */   // Label 4942: @256046
     /* 256046 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(256088), // Rule ID 11804 //
     /* 256051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 256059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256075 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1931:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 256078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256086 */     GIR_RootConstrainSelectedInstOperands,
     /* 256087 */     // GIR_Coverage, 11804,
     /* 256087 */     GIR_EraseRootFromParent_Done,
     /* 256088 */   // Label 4943: @256088
     /* 256088 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(256130), // Rule ID 11806 //
     /* 256093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 256101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256117 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1683:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 256120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256128 */     GIR_RootConstrainSelectedInstOperands,
     /* 256129 */     // GIR_Coverage, 11806,
     /* 256129 */     GIR_EraseRootFromParent_Done,
     /* 256130 */   // Label 4944: @256130
     /* 256130 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(256172), // Rule ID 11807 //
     /* 256135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 256143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1683:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 256162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256170 */     GIR_RootConstrainSelectedInstOperands,
     /* 256171 */     // GIR_Coverage, 11807,
     /* 256171 */     GIR_EraseRootFromParent_Done,
     /* 256172 */   // Label 4945: @256172
     /* 256172 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(256214), // Rule ID 11808 //
     /* 256177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 256185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256201 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1683:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 256204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256212 */     GIR_RootConstrainSelectedInstOperands,
     /* 256213 */     // GIR_Coverage, 11808,
     /* 256213 */     GIR_EraseRootFromParent_Done,
     /* 256214 */   // Label 4946: @256214
     /* 256214 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(256256), // Rule ID 11809 //
     /* 256219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 256227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1932:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 256246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256254 */     GIR_RootConstrainSelectedInstOperands,
     /* 256255 */     // GIR_Coverage, 11809,
     /* 256255 */     GIR_EraseRootFromParent_Done,
     /* 256256 */   // Label 4947: @256256
     /* 256256 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(256298), // Rule ID 11810 //
     /* 256261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 256269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256285 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1932:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 256288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256296 */     GIR_RootConstrainSelectedInstOperands,
     /* 256297 */     // GIR_Coverage, 11810,
     /* 256297 */     GIR_EraseRootFromParent_Done,
     /* 256298 */   // Label 4948: @256298
     /* 256298 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(256340), // Rule ID 11811 //
     /* 256303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 256311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256327 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1932:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 256330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256338 */     GIR_RootConstrainSelectedInstOperands,
     /* 256339 */     // GIR_Coverage, 11811,
     /* 256339 */     GIR_EraseRootFromParent_Done,
     /* 256340 */   // Label 4949: @256340
     /* 256340 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(256382), // Rule ID 11812 //
     /* 256345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 256353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1933:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 256372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256380 */     GIR_RootConstrainSelectedInstOperands,
     /* 256381 */     // GIR_Coverage, 11812,
     /* 256381 */     GIR_EraseRootFromParent_Done,
     /* 256382 */   // Label 4950: @256382
     /* 256382 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(256424), // Rule ID 11813 //
     /* 256387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 256395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256411 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1933:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 256414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256422 */     GIR_RootConstrainSelectedInstOperands,
     /* 256423 */     // GIR_Coverage, 11813,
     /* 256423 */     GIR_EraseRootFromParent_Done,
     /* 256424 */   // Label 4951: @256424
     /* 256424 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(256466), // Rule ID 11814 //
     /* 256429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 256437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256453 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1933:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 256456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256464 */     GIR_RootConstrainSelectedInstOperands,
     /* 256465 */     // GIR_Coverage, 11814,
     /* 256465 */     GIR_EraseRootFromParent_Done,
     /* 256466 */   // Label 4952: @256466
     /* 256466 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(256508), // Rule ID 11815 //
     /* 256471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 256479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256495 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1246:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 256498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256506 */     GIR_RootConstrainSelectedInstOperands,
     /* 256507 */     // GIR_Coverage, 11815,
     /* 256507 */     GIR_EraseRootFromParent_Done,
     /* 256508 */   // Label 4953: @256508
     /* 256508 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(256550), // Rule ID 11816 //
     /* 256513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 256521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256537 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1246:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 256540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256548 */     GIR_RootConstrainSelectedInstOperands,
     /* 256549 */     // GIR_Coverage, 11816,
     /* 256549 */     GIR_EraseRootFromParent_Done,
     /* 256550 */   // Label 4954: @256550
     /* 256550 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(256592), // Rule ID 11817 //
     /* 256555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 256563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256579 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 256582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256590 */     GIR_RootConstrainSelectedInstOperands,
     /* 256591 */     // GIR_Coverage, 11817,
     /* 256591 */     GIR_EraseRootFromParent_Done,
     /* 256592 */   // Label 4955: @256592
     /* 256592 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(256634), // Rule ID 11818 //
     /* 256597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 256605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256621 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 256624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256632 */     GIR_RootConstrainSelectedInstOperands,
     /* 256633 */     // GIR_Coverage, 11818,
     /* 256633 */     GIR_EraseRootFromParent_Done,
     /* 256634 */   // Label 4956: @256634
     /* 256634 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(256676), // Rule ID 11819 //
     /* 256639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 256647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256663 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 256666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256674 */     GIR_RootConstrainSelectedInstOperands,
     /* 256675 */     // GIR_Coverage, 11819,
     /* 256675 */     GIR_EraseRootFromParent_Done,
     /* 256676 */   // Label 4957: @256676
     /* 256676 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(256718), // Rule ID 11820 //
     /* 256681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 256689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256705 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 256708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256716 */     GIR_RootConstrainSelectedInstOperands,
     /* 256717 */     // GIR_Coverage, 11820,
     /* 256717 */     GIR_EraseRootFromParent_Done,
     /* 256718 */   // Label 4958: @256718
     /* 256718 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(256760), // Rule ID 11875 //
     /* 256723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 256731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 256734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 256737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256747 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1664:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 256750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256758 */     GIR_RootConstrainSelectedInstOperands,
     /* 256759 */     // GIR_Coverage, 11875,
     /* 256759 */     GIR_EraseRootFromParent_Done,
     /* 256760 */   // Label 4959: @256760
     /* 256760 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(256802), // Rule ID 11876 //
     /* 256765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 256773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256789 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1664:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 256792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256800 */     GIR_RootConstrainSelectedInstOperands,
     /* 256801 */     // GIR_Coverage, 11876,
     /* 256801 */     GIR_EraseRootFromParent_Done,
     /* 256802 */   // Label 4960: @256802
     /* 256802 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(256844), // Rule ID 11877 //
     /* 256807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 256815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256831 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1664:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 256834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256842 */     GIR_RootConstrainSelectedInstOperands,
     /* 256843 */     // GIR_Coverage, 11877,
     /* 256843 */     GIR_EraseRootFromParent_Done,
     /* 256844 */   // Label 4961: @256844
     /* 256844 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(256886), // Rule ID 11878 //
     /* 256849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 256857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 256860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 256863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256873 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1905:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 256876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256884 */     GIR_RootConstrainSelectedInstOperands,
     /* 256885 */     // GIR_Coverage, 11878,
     /* 256885 */     GIR_EraseRootFromParent_Done,
     /* 256886 */   // Label 4962: @256886
     /* 256886 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(256928), // Rule ID 11879 //
     /* 256891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 256899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256915 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1905:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 256918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256926 */     GIR_RootConstrainSelectedInstOperands,
     /* 256927 */     // GIR_Coverage, 11879,
     /* 256927 */     GIR_EraseRootFromParent_Done,
     /* 256928 */   // Label 4963: @256928
     /* 256928 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(256970), // Rule ID 11880 //
     /* 256933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 256941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256957 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1905:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 256960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256966 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256968 */     GIR_RootConstrainSelectedInstOperands,
     /* 256969 */     // GIR_Coverage, 11880,
     /* 256969 */     GIR_EraseRootFromParent_Done,
     /* 256970 */   // Label 4964: @256970
     /* 256970 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(257012), // Rule ID 11881 //
     /* 256975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 256983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 256986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 256989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256999 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1680:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 257002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257010 */     GIR_RootConstrainSelectedInstOperands,
     /* 257011 */     // GIR_Coverage, 11881,
     /* 257011 */     GIR_EraseRootFromParent_Done,
     /* 257012 */   // Label 4965: @257012
     /* 257012 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(257054), // Rule ID 11882 //
     /* 257017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 257025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257041 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1680:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 257041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 257044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257052 */     GIR_RootConstrainSelectedInstOperands,
     /* 257053 */     // GIR_Coverage, 11882,
     /* 257053 */     GIR_EraseRootFromParent_Done,
     /* 257054 */   // Label 4966: @257054
     /* 257054 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(257096), // Rule ID 11883 //
     /* 257059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 257067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257083 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1680:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 257083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 257086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257094 */     GIR_RootConstrainSelectedInstOperands,
     /* 257095 */     // GIR_Coverage, 11883,
     /* 257095 */     GIR_EraseRootFromParent_Done,
     /* 257096 */   // Label 4967: @257096
     /* 257096 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(257141), // Rule ID 11896 //
     /* 257101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 257104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 257109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 257112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 257115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 257125 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1615:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 257128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 257130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 257139 */     GIR_RootConstrainSelectedInstOperands,
     /* 257140 */     // GIR_Coverage, 11896,
     /* 257140 */     GIR_EraseRootFromParent_Done,
     /* 257141 */   // Label 4968: @257141
     /* 257141 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(257186), // Rule ID 11897 //
     /* 257146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 257149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 257154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 257157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 257170 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1615:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 257170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 257173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 257175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 257184 */     GIR_RootConstrainSelectedInstOperands,
     /* 257185 */     // GIR_Coverage, 11897,
     /* 257185 */     GIR_EraseRootFromParent_Done,
     /* 257186 */   // Label 4969: @257186
     /* 257186 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(257228), // Rule ID 11898 //
     /* 257191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 257199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 257202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 257205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257215 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1355:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 257218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257226 */     GIR_RootConstrainSelectedInstOperands,
     /* 257227 */     // GIR_Coverage, 11898,
     /* 257227 */     GIR_EraseRootFromParent_Done,
     /* 257228 */   // Label 4970: @257228
     /* 257228 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(257270), // Rule ID 11899 //
     /* 257233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 257241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257257 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1355:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 257257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 257260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257268 */     GIR_RootConstrainSelectedInstOperands,
     /* 257269 */     // GIR_Coverage, 11899,
     /* 257269 */     GIR_EraseRootFromParent_Done,
     /* 257270 */   // Label 4971: @257270
     /* 257270 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(257312), // Rule ID 11900 //
     /* 257275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 257283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257299 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1355:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 257299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 257302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257310 */     GIR_RootConstrainSelectedInstOperands,
     /* 257311 */     // GIR_Coverage, 11900,
     /* 257311 */     GIR_EraseRootFromParent_Done,
     /* 257312 */   // Label 4972: @257312
     /* 257312 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(257354), // Rule ID 11901 //
     /* 257317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 257325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 257331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257341 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1355:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 257341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 257344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257352 */     GIR_RootConstrainSelectedInstOperands,
     /* 257353 */     // GIR_Coverage, 11901,
     /* 257353 */     GIR_EraseRootFromParent_Done,
     /* 257354 */   // Label 4973: @257354
     /* 257354 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(257396), // Rule ID 11917 //
     /* 257359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 257367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257383 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1438:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 257386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257394 */     GIR_RootConstrainSelectedInstOperands,
     /* 257395 */     // GIR_Coverage, 11917,
     /* 257395 */     GIR_EraseRootFromParent_Done,
     /* 257396 */   // Label 4974: @257396
     /* 257396 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(257438), // Rule ID 11918 //
     /* 257401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 257409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257425 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1438:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 257428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257436 */     GIR_RootConstrainSelectedInstOperands,
     /* 257437 */     // GIR_Coverage, 11918,
     /* 257437 */     GIR_EraseRootFromParent_Done,
     /* 257438 */   // Label 4975: @257438
     /* 257438 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(257480), // Rule ID 11919 //
     /* 257443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 257451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257467 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1438:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 257470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257478 */     GIR_RootConstrainSelectedInstOperands,
     /* 257479 */     // GIR_Coverage, 11919,
     /* 257479 */     GIR_EraseRootFromParent_Done,
     /* 257480 */   // Label 4976: @257480
     /* 257480 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(257522), // Rule ID 11920 //
     /* 257485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 257493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257509 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1456:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 257512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257520 */     GIR_RootConstrainSelectedInstOperands,
     /* 257521 */     // GIR_Coverage, 11920,
     /* 257521 */     GIR_EraseRootFromParent_Done,
     /* 257522 */   // Label 4977: @257522
     /* 257522 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(257564), // Rule ID 11921 //
     /* 257527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 257535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257551 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1456:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 257554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257562 */     GIR_RootConstrainSelectedInstOperands,
     /* 257563 */     // GIR_Coverage, 11921,
     /* 257563 */     GIR_EraseRootFromParent_Done,
     /* 257564 */   // Label 4978: @257564
     /* 257564 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(257606), // Rule ID 11922 //
     /* 257569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 257577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257593 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 257596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257604 */     GIR_RootConstrainSelectedInstOperands,
     /* 257605 */     // GIR_Coverage, 11922,
     /* 257605 */     GIR_EraseRootFromParent_Done,
     /* 257606 */   // Label 4979: @257606
     /* 257606 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(257648), // Rule ID 11923 //
     /* 257611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 257619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257635 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1441:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 257638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257646 */     GIR_RootConstrainSelectedInstOperands,
     /* 257647 */     // GIR_Coverage, 11923,
     /* 257647 */     GIR_EraseRootFromParent_Done,
     /* 257648 */   // Label 4980: @257648
     /* 257648 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(257690), // Rule ID 11924 //
     /* 257653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 257661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257677 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1441:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 257680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257688 */     GIR_RootConstrainSelectedInstOperands,
     /* 257689 */     // GIR_Coverage, 11924,
     /* 257689 */     GIR_EraseRootFromParent_Done,
     /* 257690 */   // Label 4981: @257690
     /* 257690 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(257732), // Rule ID 11925 //
     /* 257695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 257703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257719 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1441:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 257722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257730 */     GIR_RootConstrainSelectedInstOperands,
     /* 257731 */     // GIR_Coverage, 11925,
     /* 257731 */     GIR_EraseRootFromParent_Done,
     /* 257732 */   // Label 4982: @257732
     /* 257732 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(257774), // Rule ID 11926 //
     /* 257737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 257745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257761 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1459:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 257764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257772 */     GIR_RootConstrainSelectedInstOperands,
     /* 257773 */     // GIR_Coverage, 11926,
     /* 257773 */     GIR_EraseRootFromParent_Done,
     /* 257774 */   // Label 4983: @257774
     /* 257774 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(257816), // Rule ID 11927 //
     /* 257779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 257787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257803 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1459:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 257806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257814 */     GIR_RootConstrainSelectedInstOperands,
     /* 257815 */     // GIR_Coverage, 11927,
     /* 257815 */     GIR_EraseRootFromParent_Done,
     /* 257816 */   // Label 4984: @257816
     /* 257816 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(257858), // Rule ID 11928 //
     /* 257821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 257829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257845 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1459:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 257848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257856 */     GIR_RootConstrainSelectedInstOperands,
     /* 257857 */     // GIR_Coverage, 11928,
     /* 257857 */     GIR_EraseRootFromParent_Done,
     /* 257858 */   // Label 4985: @257858
     /* 257858 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(257900), // Rule ID 11933 //
     /* 257863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 257871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257887 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1465:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 257890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257898 */     GIR_RootConstrainSelectedInstOperands,
     /* 257899 */     // GIR_Coverage, 11933,
     /* 257899 */     GIR_EraseRootFromParent_Done,
     /* 257900 */   // Label 4986: @257900
     /* 257900 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(257942), // Rule ID 11934 //
     /* 257905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 257913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257929 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1467:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 257932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257940 */     GIR_RootConstrainSelectedInstOperands,
     /* 257941 */     // GIR_Coverage, 11934,
     /* 257941 */     GIR_EraseRootFromParent_Done,
     /* 257942 */   // Label 4987: @257942
     /* 257942 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(257984), // Rule ID 11935 //
     /* 257947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 257955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257971 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 257974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257982 */     GIR_RootConstrainSelectedInstOperands,
     /* 257983 */     // GIR_Coverage, 11935,
     /* 257983 */     GIR_EraseRootFromParent_Done,
     /* 257984 */   // Label 4988: @257984
     /* 257984 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(258026), // Rule ID 11936 //
     /* 257989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 257997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258013 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 258013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 258016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258024 */     GIR_RootConstrainSelectedInstOperands,
     /* 258025 */     // GIR_Coverage, 11936,
     /* 258025 */     GIR_EraseRootFromParent_Done,
     /* 258026 */   // Label 4989: @258026
     /* 258026 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(258068), // Rule ID 11937 //
     /* 258031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 258039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 258042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 258045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258055 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1272:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 258058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258066 */     GIR_RootConstrainSelectedInstOperands,
     /* 258067 */     // GIR_Coverage, 11937,
     /* 258067 */     GIR_EraseRootFromParent_Done,
     /* 258068 */   // Label 4990: @258068
     /* 258068 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(258110), // Rule ID 11939 //
     /* 258073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 258081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258097 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1272:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 258097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 258100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258108 */     GIR_RootConstrainSelectedInstOperands,
     /* 258109 */     // GIR_Coverage, 11939,
     /* 258109 */     GIR_EraseRootFromParent_Done,
     /* 258110 */   // Label 4991: @258110
     /* 258110 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(258152), // Rule ID 11941 //
     /* 258115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 258123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1272:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 258139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 258142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258150 */     GIR_RootConstrainSelectedInstOperands,
     /* 258151 */     // GIR_Coverage, 11941,
     /* 258151 */     GIR_EraseRootFromParent_Done,
     /* 258152 */   // Label 4992: @258152
     /* 258152 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(258194), // Rule ID 11943 //
     /* 258157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 258165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258181 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1272:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 258181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 258184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258192 */     GIR_RootConstrainSelectedInstOperands,
     /* 258193 */     // GIR_Coverage, 11943,
     /* 258193 */     GIR_EraseRootFromParent_Done,
     /* 258194 */   // Label 4993: @258194
     /* 258194 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(258236), // Rule ID 12068 //
     /* 258199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 258202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 258207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 258210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 258213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258223 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1944:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 258226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258234 */     GIR_RootConstrainSelectedInstOperands,
     /* 258235 */     // GIR_Coverage, 12068,
     /* 258235 */     GIR_EraseRootFromParent_Done,
     /* 258236 */   // Label 4994: @258236
     /* 258236 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(258278), // Rule ID 12070 //
     /* 258241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 258244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 258249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258265 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1944:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 258265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 258268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258276 */     GIR_RootConstrainSelectedInstOperands,
     /* 258277 */     // GIR_Coverage, 12070,
     /* 258277 */     GIR_EraseRootFromParent_Done,
     /* 258278 */   // Label 4995: @258278
     /* 258278 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(258320), // Rule ID 12072 //
     /* 258283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 258286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 258291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258307 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1944:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 258307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 258310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258318 */     GIR_RootConstrainSelectedInstOperands,
     /* 258319 */     // GIR_Coverage, 12072,
     /* 258319 */     GIR_EraseRootFromParent_Done,
     /* 258320 */   // Label 4996: @258320
     /* 258320 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(258362), // Rule ID 12074 //
     /* 258325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 258328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 258333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258349 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1944:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 258349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 258352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258360 */     GIR_RootConstrainSelectedInstOperands,
     /* 258361 */     // GIR_Coverage, 12074,
     /* 258361 */     GIR_EraseRootFromParent_Done,
     /* 258362 */   // Label 4997: @258362
     /* 258362 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(258404), // Rule ID 12076 //
     /* 258367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 258370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 258375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258391 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1422:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 258391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 258394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258402 */     GIR_RootConstrainSelectedInstOperands,
     /* 258403 */     // GIR_Coverage, 12076,
     /* 258403 */     GIR_EraseRootFromParent_Done,
     /* 258404 */   // Label 4998: @258404
     /* 258404 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(258446), // Rule ID 12078 //
     /* 258409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 258412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 258417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 258433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 258436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258444 */     GIR_RootConstrainSelectedInstOperands,
     /* 258445 */     // GIR_Coverage, 12078,
     /* 258445 */     GIR_EraseRootFromParent_Done,
     /* 258446 */   // Label 4999: @258446
     /* 258446 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(258488), // Rule ID 12241 //
     /* 258451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 258454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 258459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 258462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 258465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258475 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1920:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 258478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258486 */     GIR_RootConstrainSelectedInstOperands,
     /* 258487 */     // GIR_Coverage, 12241,
     /* 258487 */     GIR_EraseRootFromParent_Done,
     /* 258488 */   // Label 5000: @258488
     /* 258488 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(258530), // Rule ID 12242 //
     /* 258493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 258496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 258501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258517 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1920:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 258517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 258520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258528 */     GIR_RootConstrainSelectedInstOperands,
     /* 258529 */     // GIR_Coverage, 12242,
     /* 258529 */     GIR_EraseRootFromParent_Done,
     /* 258530 */   // Label 5001: @258530
     /* 258530 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(258572), // Rule ID 12243 //
     /* 258535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 258538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 258543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258559 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1920:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 258559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 258562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258570 */     GIR_RootConstrainSelectedInstOperands,
     /* 258571 */     // GIR_Coverage, 12243,
     /* 258571 */     GIR_EraseRootFromParent_Done,
     /* 258572 */   // Label 5002: @258572
     /* 258572 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(258614), // Rule ID 12244 //
     /* 258577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 258580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 258585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258601 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1920:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 258601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 258604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258612 */     GIR_RootConstrainSelectedInstOperands,
     /* 258613 */     // GIR_Coverage, 12244,
     /* 258613 */     GIR_EraseRootFromParent_Done,
     /* 258614 */   // Label 5003: @258614
     /* 258614 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(258656), // Rule ID 12245 //
     /* 258619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 258622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 258627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258643 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1920:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 258643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 258646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258654 */     GIR_RootConstrainSelectedInstOperands,
     /* 258655 */     // GIR_Coverage, 12245,
     /* 258655 */     GIR_EraseRootFromParent_Done,
     /* 258656 */   // Label 5004: @258656
     /* 258656 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(258698), // Rule ID 12246 //
     /* 258661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 258664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 258669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258685 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1920:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 258685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 258688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258696 */     GIR_RootConstrainSelectedInstOperands,
     /* 258697 */     // GIR_Coverage, 12246,
     /* 258697 */     GIR_EraseRootFromParent_Done,
     /* 258698 */   // Label 5005: @258698
     /* 258698 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(258740), // Rule ID 12247 //
     /* 258703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 258706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 258711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258727 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1920:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 258727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 258730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258738 */     GIR_RootConstrainSelectedInstOperands,
     /* 258739 */     // GIR_Coverage, 12247,
     /* 258739 */     GIR_EraseRootFromParent_Done,
     /* 258740 */   // Label 5006: @258740
     /* 258740 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(258782), // Rule ID 12592 //
     /* 258745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 258748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 258753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258769 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1372:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 258769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 258772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258778 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258780 */     GIR_RootConstrainSelectedInstOperands,
     /* 258781 */     // GIR_Coverage, 12592,
     /* 258781 */     GIR_EraseRootFromParent_Done,
     /* 258782 */   // Label 5007: @258782
     /* 258782 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(258824), // Rule ID 12593 //
     /* 258787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 258790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 258795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258811 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1372:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 258811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 258814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258822 */     GIR_RootConstrainSelectedInstOperands,
     /* 258823 */     // GIR_Coverage, 12593,
     /* 258823 */     GIR_EraseRootFromParent_Done,
     /* 258824 */   // Label 5008: @258824
     /* 258824 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(258866), // Rule ID 12594 //
     /* 258829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 258832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 258837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258853 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 258853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 258856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258864 */     GIR_RootConstrainSelectedInstOperands,
     /* 258865 */     // GIR_Coverage, 12594,
     /* 258865 */     GIR_EraseRootFromParent_Done,
     /* 258866 */   // Label 5009: @258866
     /* 258866 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(258908), // Rule ID 12595 //
     /* 258871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 258874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 258879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258895 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 258895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 258898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258906 */     GIR_RootConstrainSelectedInstOperands,
     /* 258907 */     // GIR_Coverage, 12595,
     /* 258907 */     GIR_EraseRootFromParent_Done,
     /* 258908 */   // Label 5010: @258908
     /* 258908 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(258950), // Rule ID 12596 //
     /* 258913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 258916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 258921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258937 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 258937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 258940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258948 */     GIR_RootConstrainSelectedInstOperands,
     /* 258949 */     // GIR_Coverage, 12596,
     /* 258949 */     GIR_EraseRootFromParent_Done,
     /* 258950 */   // Label 5011: @258950
     /* 258950 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(258992), // Rule ID 12597 //
     /* 258955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 258958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 258963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258979 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 258979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 258982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258990 */     GIR_RootConstrainSelectedInstOperands,
     /* 258991 */     // GIR_Coverage, 12597,
     /* 258991 */     GIR_EraseRootFromParent_Done,
     /* 258992 */   // Label 5012: @258992
     /* 258992 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(259034), // Rule ID 12598 //
     /* 258997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 259005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259021 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1371:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 259021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 259024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259032 */     GIR_RootConstrainSelectedInstOperands,
     /* 259033 */     // GIR_Coverage, 12598,
     /* 259033 */     GIR_EraseRootFromParent_Done,
     /* 259034 */   // Label 5013: @259034
     /* 259034 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(259076), // Rule ID 12601 //
     /* 259039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 259047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 259050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 259056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 259059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259063 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1371:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 259063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 259066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259074 */     GIR_RootConstrainSelectedInstOperands,
     /* 259075 */     // GIR_Coverage, 12601,
     /* 259075 */     GIR_EraseRootFromParent_Done,
     /* 259076 */   // Label 5014: @259076
     /* 259076 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(259118), // Rule ID 12604 //
     /* 259081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 259089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 259092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 259098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 259101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259105 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1371:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 259105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 259108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259116 */     GIR_RootConstrainSelectedInstOperands,
     /* 259117 */     // GIR_Coverage, 12604,
     /* 259117 */     GIR_EraseRootFromParent_Done,
     /* 259118 */   // Label 5015: @259118
     /* 259118 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(259160), // Rule ID 12607 //
     /* 259123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 259131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259147 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1371:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 259147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 259150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259158 */     GIR_RootConstrainSelectedInstOperands,
     /* 259159 */     // GIR_Coverage, 12607,
     /* 259159 */     GIR_EraseRootFromParent_Done,
     /* 259160 */   // Label 5016: @259160
     /* 259160 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(259202), // Rule ID 12610 //
     /* 259165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 259173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 259176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 259182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 259185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259189 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1371:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 259189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 259192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259200 */     GIR_RootConstrainSelectedInstOperands,
     /* 259201 */     // GIR_Coverage, 12610,
     /* 259201 */     GIR_EraseRootFromParent_Done,
     /* 259202 */   // Label 5017: @259202
     /* 259202 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(259244), // Rule ID 12613 //
     /* 259207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 259215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259231 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1371:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 259231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 259234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259242 */     GIR_RootConstrainSelectedInstOperands,
     /* 259243 */     // GIR_Coverage, 12613,
     /* 259243 */     GIR_EraseRootFromParent_Done,
     /* 259244 */   // Label 5018: @259244
     /* 259244 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(259286), // Rule ID 12616 //
     /* 259249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 259257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259273 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 259273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 259276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259284 */     GIR_RootConstrainSelectedInstOperands,
     /* 259285 */     // GIR_Coverage, 12616,
     /* 259285 */     GIR_EraseRootFromParent_Done,
     /* 259286 */   // Label 5019: @259286
     /* 259286 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(259328), // Rule ID 12619 //
     /* 259291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 259299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 259302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 259308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 259311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259315 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1373:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 259315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 259318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259326 */     GIR_RootConstrainSelectedInstOperands,
     /* 259327 */     // GIR_Coverage, 12619,
     /* 259327 */     GIR_EraseRootFromParent_Done,
     /* 259328 */   // Label 5020: @259328
     /* 259328 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(259370), // Rule ID 12622 //
     /* 259333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 259341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 259344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 259350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 259353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259357 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1373:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 259357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 259360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259368 */     GIR_RootConstrainSelectedInstOperands,
     /* 259369 */     // GIR_Coverage, 12622,
     /* 259369 */     GIR_EraseRootFromParent_Done,
     /* 259370 */   // Label 5021: @259370
     /* 259370 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(259412), // Rule ID 12625 //
     /* 259375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 259383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259399 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 259399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 259402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259410 */     GIR_RootConstrainSelectedInstOperands,
     /* 259411 */     // GIR_Coverage, 12625,
     /* 259411 */     GIR_EraseRootFromParent_Done,
     /* 259412 */   // Label 5022: @259412
     /* 259412 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(259454), // Rule ID 12628 //
     /* 259417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 259425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 259428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 259434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 259437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259441 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1373:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 259441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 259444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259452 */     GIR_RootConstrainSelectedInstOperands,
     /* 259453 */     // GIR_Coverage, 12628,
     /* 259453 */     GIR_EraseRootFromParent_Done,
     /* 259454 */   // Label 5023: @259454
     /* 259454 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(259496), // Rule ID 12631 //
     /* 259459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 259467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259483 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1373:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 259483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 259486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259494 */     GIR_RootConstrainSelectedInstOperands,
     /* 259495 */     // GIR_Coverage, 12631,
     /* 259495 */     GIR_EraseRootFromParent_Done,
     /* 259496 */   // Label 5024: @259496
     /* 259496 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(259639), // Rule ID 5624 //
     /* 259501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 259504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 259509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 259512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 259515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 259518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259522 */     // MIs[0] idx
     /* 259522 */     // No operand predicates
     /* 259522 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 259522 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 259525 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259529 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259536 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 259539 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259543 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259548 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 259551 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 259555 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 259558 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259563 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259568 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259573 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 259576 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259580 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 259590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259599 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 259602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 259606 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 259609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 259627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 259635 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 259637 */     GIR_RootConstrainSelectedInstOperands,
     /* 259638 */     // GIR_Coverage, 5624,
     /* 259638 */     GIR_EraseRootFromParent_Done,
     /* 259639 */   // Label 5025: @259639
     /* 259639 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(259730), // Rule ID 5625 //
     /* 259644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 259647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 259652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 259655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 259658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259665 */     // MIs[0] idx
     /* 259665 */     // No operand predicates
     /* 259665 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 259665 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 259668 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259672 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 259682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259691 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 259694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 259698 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 259701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 259719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 259726 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 259728 */     GIR_RootConstrainSelectedInstOperands,
     /* 259729 */     // GIR_Coverage, 5625,
     /* 259729 */     GIR_EraseRootFromParent_Done,
     /* 259730 */   // Label 5026: @259730
     /* 259730 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(259821), // Rule ID 5626 //
     /* 259735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 259738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 259743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 259746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 259749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 259752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259756 */     // MIs[0] idx
     /* 259756 */     // No operand predicates
     /* 259756 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 259756 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 259759 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259763 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 259773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259782 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 259785 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 259789 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 259792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 259810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 259814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259817 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 259819 */     GIR_RootConstrainSelectedInstOperands,
     /* 259820 */     // GIR_Coverage, 5626,
     /* 259820 */     GIR_EraseRootFromParent_Done,
     /* 259821 */   // Label 5027: @259821
     /* 259821 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(259860), // Rule ID 5627 //
     /* 259826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 259829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 259834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 259837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 259840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259847 */     // MIs[0] idx
     /* 259847 */     // No operand predicates
     /* 259847 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 259847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 259850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 259854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 259856 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 259858 */     GIR_RootConstrainSelectedInstOperands,
     /* 259859 */     // GIR_Coverage, 5627,
     /* 259859 */     GIR_EraseRootFromParent_Done,
     /* 259860 */   // Label 5028: @259860
     /* 259860 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(260003), // Rule ID 5628 //
     /* 259865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 259868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 259873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 259876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 259882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259886 */     // MIs[0] idx
     /* 259886 */     // No operand predicates
     /* 259886 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 259886 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 259889 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259893 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259900 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 259903 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259907 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259912 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 259915 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 259919 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 259922 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259927 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259932 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259937 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 259940 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259944 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 259954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259963 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 259966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 259970 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 259973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 259991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 259999 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260001 */     GIR_RootConstrainSelectedInstOperands,
     /* 260002 */     // GIR_Coverage, 5628,
     /* 260002 */     GIR_EraseRootFromParent_Done,
     /* 260003 */   // Label 5029: @260003
     /* 260003 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(260094), // Rule ID 5629 //
     /* 260008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 260016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 260022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260029 */     // MIs[0] idx
     /* 260029 */     // No operand predicates
     /* 260029 */     // (intrinsic_wo_chain:{ *:[v8i16] } 770:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260029 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 260032 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260036 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 260043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 260046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260055 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 260058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 260062 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 260065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 260090 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260092 */     GIR_RootConstrainSelectedInstOperands,
     /* 260093 */     // GIR_Coverage, 5629,
     /* 260093 */     GIR_EraseRootFromParent_Done,
     /* 260094 */   // Label 5030: @260094
     /* 260094 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(260185), // Rule ID 5630 //
     /* 260099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 260107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 260116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260120 */     // MIs[0] idx
     /* 260120 */     // No operand predicates
     /* 260120 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260120 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 260123 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260127 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 260134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 260137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260146 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 260149 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 260153 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 260156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 260178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260181 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260183 */     GIR_RootConstrainSelectedInstOperands,
     /* 260184 */     // GIR_Coverage, 5630,
     /* 260184 */     GIR_EraseRootFromParent_Done,
     /* 260185 */   // Label 5031: @260185
     /* 260185 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(260224), // Rule ID 5631 //
     /* 260190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 260198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260211 */     // MIs[0] idx
     /* 260211 */     // No operand predicates
     /* 260211 */     // (intrinsic_wo_chain:{ *:[v8i16] } 770:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 260218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 260220 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260222 */     GIR_RootConstrainSelectedInstOperands,
     /* 260223 */     // GIR_Coverage, 5631,
     /* 260223 */     GIR_EraseRootFromParent_Done,
     /* 260224 */   // Label 5032: @260224
     /* 260224 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(260367), // Rule ID 5632 //
     /* 260229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 260237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 260243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 260246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260250 */     // MIs[0] idx
     /* 260250 */     // No operand predicates
     /* 260250 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260250 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 260253 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260257 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260264 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 260267 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260271 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260276 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 260279 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 260283 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 260286 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260291 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260296 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260301 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 260304 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260308 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 260315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 260318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260327 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 260330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 260334 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 260337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 260363 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260365 */     GIR_RootConstrainSelectedInstOperands,
     /* 260366 */     // GIR_Coverage, 5632,
     /* 260366 */     GIR_EraseRootFromParent_Done,
     /* 260367 */   // Label 5033: @260367
     /* 260367 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(260458), // Rule ID 5633 //
     /* 260372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 260380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 260386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260393 */     // MIs[0] idx
     /* 260393 */     // No operand predicates
     /* 260393 */     // (intrinsic_wo_chain:{ *:[v8f16] } 770:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260393 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 260396 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260400 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 260407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 260410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260419 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 260422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 260426 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 260429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 260454 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260456 */     GIR_RootConstrainSelectedInstOperands,
     /* 260457 */     // GIR_Coverage, 5633,
     /* 260457 */     GIR_EraseRootFromParent_Done,
     /* 260458 */   // Label 5034: @260458
     /* 260458 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(260549), // Rule ID 5634 //
     /* 260463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 260471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 260480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260484 */     // MIs[0] idx
     /* 260484 */     // No operand predicates
     /* 260484 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260484 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 260487 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260491 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 260498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 260501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260510 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 260513 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 260517 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 260520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 260542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260545 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260547 */     GIR_RootConstrainSelectedInstOperands,
     /* 260548 */     // GIR_Coverage, 5634,
     /* 260548 */     GIR_EraseRootFromParent_Done,
     /* 260549 */   // Label 5035: @260549
     /* 260549 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(260588), // Rule ID 5635 //
     /* 260554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 260562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260575 */     // MIs[0] idx
     /* 260575 */     // No operand predicates
     /* 260575 */     // (intrinsic_wo_chain:{ *:[v8f16] } 770:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 260582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 260584 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260586 */     GIR_RootConstrainSelectedInstOperands,
     /* 260587 */     // GIR_Coverage, 5635,
     /* 260587 */     GIR_EraseRootFromParent_Done,
     /* 260588 */   // Label 5036: @260588
     /* 260588 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(260627), // Rule ID 5636 //
     /* 260593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 260601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 260604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 260607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260614 */     // MIs[0] idx
     /* 260614 */     // No operand predicates
     /* 260614 */     // (intrinsic_wo_chain:{ *:[v16i8] } 773:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 260614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 260617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 260621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 260623 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260625 */     GIR_RootConstrainSelectedInstOperands,
     /* 260626 */     // GIR_Coverage, 5636,
     /* 260626 */     GIR_EraseRootFromParent_Done,
     /* 260627 */   // Label 5037: @260627
     /* 260627 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(260718), // Rule ID 5637 //
     /* 260632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 260640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 260643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 260646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 260649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260653 */     // MIs[0] idx
     /* 260653 */     // No operand predicates
     /* 260653 */     // (intrinsic_wo_chain:{ *:[v16i8] } 771:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 260653 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 260656 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260660 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 260667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 260670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260679 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 260682 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 260686 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 260689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 260707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 260711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260714 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260716 */     GIR_RootConstrainSelectedInstOperands,
     /* 260717 */     // GIR_Coverage, 5637,
     /* 260717 */     GIR_EraseRootFromParent_Done,
     /* 260718 */   // Label 5038: @260718
     /* 260718 */   GIM_Reject,
     /* 260719 */ // Label 4178: @260719
     /* 260719 */ GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(267830),
     /* 260724 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 260727 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(260774), // Rule ID 2965 //
     /* 260732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 260740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 260743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 260746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 260755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260759 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1604:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 260759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 260762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 260764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260770 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260772 */     GIR_RootConstrainSelectedInstOperands,
     /* 260773 */     // GIR_Coverage, 2965,
     /* 260773 */     GIR_EraseRootFromParent_Done,
     /* 260774 */   // Label 5040: @260774
     /* 260774 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(260821), // Rule ID 2967 //
     /* 260779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 260787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260806 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1604:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 260806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 260809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 260811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260817 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260819 */     GIR_RootConstrainSelectedInstOperands,
     /* 260820 */     // GIR_Coverage, 2967,
     /* 260820 */     GIR_EraseRootFromParent_Done,
     /* 260821 */   // Label 5041: @260821
     /* 260821 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(260868), // Rule ID 2969 //
     /* 260826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 260834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 260840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 260849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260853 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1604:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 260853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 260856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 260858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260864 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260866 */     GIR_RootConstrainSelectedInstOperands,
     /* 260867 */     // GIR_Coverage, 2969,
     /* 260867 */     GIR_EraseRootFromParent_Done,
     /* 260868 */   // Label 5042: @260868
     /* 260868 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(260915), // Rule ID 2971 //
     /* 260873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 260881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 260887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 260896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1604:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 260900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 260903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 260905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260911 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260913 */     GIR_RootConstrainSelectedInstOperands,
     /* 260914 */     // GIR_Coverage, 2971,
     /* 260914 */     GIR_EraseRootFromParent_Done,
     /* 260915 */   // Label 5043: @260915
     /* 260915 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(260962), // Rule ID 7654 //
     /* 260920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 260928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 260931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 260934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 260943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260947 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1607:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 260947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 260950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 260952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260958 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260960 */     GIR_RootConstrainSelectedInstOperands,
     /* 260961 */     // GIR_Coverage, 7654,
     /* 260961 */     GIR_EraseRootFromParent_Done,
     /* 260962 */   // Label 5044: @260962
     /* 260962 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(261009), // Rule ID 7656 //
     /* 260967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 260975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260994 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1607:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 260994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 260997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 260999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261005 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261007 */     GIR_RootConstrainSelectedInstOperands,
     /* 261008 */     // GIR_Coverage, 7656,
     /* 261008 */     GIR_EraseRootFromParent_Done,
     /* 261009 */   // Label 5045: @261009
     /* 261009 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(261056), // Rule ID 7658 //
     /* 261014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 261022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261041 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1607:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 261041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 261044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261052 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261054 */     GIR_RootConstrainSelectedInstOperands,
     /* 261055 */     // GIR_Coverage, 7658,
     /* 261055 */     GIR_EraseRootFromParent_Done,
     /* 261056 */   // Label 5046: @261056
     /* 261056 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(261103), // Rule ID 7660 //
     /* 261061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 261069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261088 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1607:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 261088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 261091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261099 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261101 */     GIR_RootConstrainSelectedInstOperands,
     /* 261102 */     // GIR_Coverage, 7660,
     /* 261102 */     GIR_EraseRootFromParent_Done,
     /* 261103 */   // Label 5047: @261103
     /* 261103 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(261183), // Rule ID 5744 //
     /* 261108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 261113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 261116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 261119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 261122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 261125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 261128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 261140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 261148 */     // MIs[1] Operand 1
     /* 261148 */     // No operand predicates
     /* 261148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 261156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261160 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 261164 */     // MIs[2] Operand 1
     /* 261164 */     // No operand predicates
     /* 261164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261166 */     // (intrinsic_wo_chain:{ *:[v16i8] } 762:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 261166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 261169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 261176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 261178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 261181 */     GIR_RootConstrainSelectedInstOperands,
     /* 261182 */     // GIR_Coverage, 5744,
     /* 261182 */     GIR_EraseRootFromParent_Done,
     /* 261183 */   // Label 5048: @261183
     /* 261183 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(261263), // Rule ID 5745 //
     /* 261188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 261193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 261196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 261199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 261202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 261205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 261208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 261220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 261228 */     // MIs[1] Operand 1
     /* 261228 */     // No operand predicates
     /* 261228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 261236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261240 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 261244 */     // MIs[2] Operand 1
     /* 261244 */     // No operand predicates
     /* 261244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261246 */     // (intrinsic_wo_chain:{ *:[v8i16] } 762:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 261246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 261249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 261256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 261258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 261261 */     GIR_RootConstrainSelectedInstOperands,
     /* 261262 */     // GIR_Coverage, 5745,
     /* 261262 */     GIR_EraseRootFromParent_Done,
     /* 261263 */   // Label 5049: @261263
     /* 261263 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(261343), // Rule ID 5746 //
     /* 261268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 261273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 261282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 261288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 261300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 261308 */     // MIs[1] Operand 1
     /* 261308 */     // No operand predicates
     /* 261308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 261316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261320 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 261324 */     // MIs[2] Operand 1
     /* 261324 */     // No operand predicates
     /* 261324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261326 */     // (intrinsic_wo_chain:{ *:[v4i32] } 762:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 261326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 261329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 261336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 261338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 261341 */     GIR_RootConstrainSelectedInstOperands,
     /* 261342 */     // GIR_Coverage, 5746,
     /* 261342 */     GIR_EraseRootFromParent_Done,
     /* 261343 */   // Label 5050: @261343
     /* 261343 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(261423), // Rule ID 5747 //
     /* 261348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 261353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 261356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 261359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 261362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 261365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 261368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 261380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 261388 */     // MIs[1] Operand 1
     /* 261388 */     // No operand predicates
     /* 261388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 261396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261400 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 261404 */     // MIs[2] Operand 1
     /* 261404 */     // No operand predicates
     /* 261404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261406 */     // (intrinsic_wo_chain:{ *:[v2i64] } 762:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 261406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 261409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 261416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 261418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 261421 */     GIR_RootConstrainSelectedInstOperands,
     /* 261422 */     // GIR_Coverage, 5747,
     /* 261422 */     GIR_EraseRootFromParent_Done,
     /* 261423 */   // Label 5051: @261423
     /* 261423 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(261487), // Rule ID 3849 //
     /* 261428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 261431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 261436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 261445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261464 */     // MIs[0] imm
     /* 261464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 261472 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 261472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 261475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 261477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 261481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 261483 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 261485 */     GIR_RootConstrainSelectedInstOperands,
     /* 261486 */     // GIR_Coverage, 3849,
     /* 261486 */     GIR_EraseRootFromParent_Done,
     /* 261487 */   // Label 5052: @261487
     /* 261487 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(261551), // Rule ID 3850 //
     /* 261492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 261495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 261500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 261509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261528 */     // MIs[0] imm
     /* 261528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 261536 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 261536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 261539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 261541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 261545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 261547 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 261549 */     GIR_RootConstrainSelectedInstOperands,
     /* 261550 */     // GIR_Coverage, 3850,
     /* 261550 */     GIR_EraseRootFromParent_Done,
     /* 261551 */   // Label 5053: @261551
     /* 261551 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(261615), // Rule ID 3851 //
     /* 261556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 261559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 261564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 261573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261592 */     // MIs[0] imm
     /* 261592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 261600 */     // (intrinsic_wo_chain:{ *:[v4i32] } 540:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 261600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 261603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 261605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 261609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 261611 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 261613 */     GIR_RootConstrainSelectedInstOperands,
     /* 261614 */     // GIR_Coverage, 3851,
     /* 261614 */     GIR_EraseRootFromParent_Done,
     /* 261615 */   // Label 5054: @261615
     /* 261615 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(261679), // Rule ID 3852 //
     /* 261620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 261623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 261628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 261637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261656 */     // MIs[0] imm
     /* 261656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261659 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 261664 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 261664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 261667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 261669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 261673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 261675 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 261677 */     GIR_RootConstrainSelectedInstOperands,
     /* 261678 */     // GIR_Coverage, 3852,
     /* 261678 */     GIR_EraseRootFromParent_Done,
     /* 261679 */   // Label 5055: @261679
     /* 261679 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(261731), // Rule ID 2850 //
     /* 261684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 261692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 261698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261708 */     // MIs[0] idx
     /* 261708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261711 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261716 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1463:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 261716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 261719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261725 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261727 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 261729 */     GIR_RootConstrainSelectedInstOperands,
     /* 261730 */     // GIR_Coverage, 2850,
     /* 261730 */     GIR_EraseRootFromParent_Done,
     /* 261731 */   // Label 5056: @261731
     /* 261731 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(261783), // Rule ID 2851 //
     /* 261736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 261744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261760 */     // MIs[0] idx
     /* 261760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261768 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1463:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 261768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 261771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261779 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 261781 */     GIR_RootConstrainSelectedInstOperands,
     /* 261782 */     // GIR_Coverage, 2851,
     /* 261782 */     GIR_EraseRootFromParent_Done,
     /* 261783 */   // Label 5057: @261783
     /* 261783 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(261835), // Rule ID 2852 //
     /* 261788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 261796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261812 */     // MIs[0] idx
     /* 261812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261815 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 261820 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1463:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 261820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 261823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261829 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261831 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 261833 */     GIR_RootConstrainSelectedInstOperands,
     /* 261834 */     // GIR_Coverage, 2852,
     /* 261834 */     GIR_EraseRootFromParent_Done,
     /* 261835 */   // Label 5058: @261835
     /* 261835 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(261887), // Rule ID 2980 //
     /* 261840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 261848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 261854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261864 */     // MIs[0] Op4
     /* 261864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261867 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261872 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1603:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 261875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261883 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261885 */     GIR_RootConstrainSelectedInstOperands,
     /* 261886 */     // GIR_Coverage, 2980,
     /* 261886 */     GIR_EraseRootFromParent_Done,
     /* 261887 */   // Label 5059: @261887
     /* 261887 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(261939), // Rule ID 2981 //
     /* 261892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 261900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261916 */     // MIs[0] Op4
     /* 261916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261924 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1603:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 261927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261933 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261935 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261937 */     GIR_RootConstrainSelectedInstOperands,
     /* 261938 */     // GIR_Coverage, 2981,
     /* 261938 */     GIR_EraseRootFromParent_Done,
     /* 261939 */   // Label 5060: @261939
     /* 261939 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(261991), // Rule ID 2982 //
     /* 261944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 261952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261968 */     // MIs[0] Op4
     /* 261968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261971 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 261976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1603:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 261976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 261979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261987 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261989 */     GIR_RootConstrainSelectedInstOperands,
     /* 261990 */     // GIR_Coverage, 2982,
     /* 261990 */     GIR_EraseRootFromParent_Done,
     /* 261991 */   // Label 5061: @261991
     /* 261991 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(262043), // Rule ID 2983 //
     /* 261996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 262004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262020 */     // MIs[0] Op4
     /* 262020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262028 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 262031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262039 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262041 */     GIR_RootConstrainSelectedInstOperands,
     /* 262042 */     // GIR_Coverage, 2983,
     /* 262042 */     GIR_EraseRootFromParent_Done,
     /* 262043 */   // Label 5062: @262043
     /* 262043 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(262095), // Rule ID 2984 //
     /* 262048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 262056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262072 */     // MIs[0] Op4
     /* 262072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1745:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 262083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262091 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262093 */     GIR_RootConstrainSelectedInstOperands,
     /* 262094 */     // GIR_Coverage, 2984,
     /* 262094 */     GIR_EraseRootFromParent_Done,
     /* 262095 */   // Label 5063: @262095
     /* 262095 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(262147), // Rule ID 2987 //
     /* 262100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 262108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262124 */     // MIs[0] Op4
     /* 262124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262127 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262132 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1711:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 262135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262143 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262145 */     GIR_RootConstrainSelectedInstOperands,
     /* 262146 */     // GIR_Coverage, 2987,
     /* 262146 */     GIR_EraseRootFromParent_Done,
     /* 262147 */   // Label 5064: @262147
     /* 262147 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(262199), // Rule ID 2988 //
     /* 262152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 262160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262176 */     // MIs[0] Op4
     /* 262176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262179 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 262184 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1711:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 262184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 262187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262195 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262197 */     GIR_RootConstrainSelectedInstOperands,
     /* 262198 */     // GIR_Coverage, 2988,
     /* 262198 */     GIR_EraseRootFromParent_Done,
     /* 262199 */   // Label 5065: @262199
     /* 262199 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(262251), // Rule ID 3462 //
     /* 262204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 262207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 262212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262228 */     // MIs[0] Op4
     /* 262228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2058:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 262239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262247 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262249 */     GIR_RootConstrainSelectedInstOperands,
     /* 262250 */     // GIR_Coverage, 3462,
     /* 262250 */     GIR_EraseRootFromParent_Done,
     /* 262251 */   // Label 5066: @262251
     /* 262251 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(262303), // Rule ID 3506 //
     /* 262256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 262259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 262264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262280 */     // MIs[0] Op4
     /* 262280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262288 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1712:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 262291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262299 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262301 */     GIR_RootConstrainSelectedInstOperands,
     /* 262302 */     // GIR_Coverage, 3506,
     /* 262302 */     GIR_EraseRootFromParent_Done,
     /* 262303 */   // Label 5067: @262303
     /* 262303 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(262355), // Rule ID 7728 //
     /* 262308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 262316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262332 */     // MIs[0] Op4
     /* 262332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1958:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 262343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262351 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262353 */     GIR_RootConstrainSelectedInstOperands,
     /* 262354 */     // GIR_Coverage, 7728,
     /* 262354 */     GIR_EraseRootFromParent_Done,
     /* 262355 */   // Label 5068: @262355
     /* 262355 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(262407), // Rule ID 7729 //
     /* 262360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 262368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262384 */     // MIs[0] Op4
     /* 262384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262387 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 262392 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1958:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 262392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 262395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262403 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262405 */     GIR_RootConstrainSelectedInstOperands,
     /* 262406 */     // GIR_Coverage, 7729,
     /* 262406 */     GIR_EraseRootFromParent_Done,
     /* 262407 */   // Label 5069: @262407
     /* 262407 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(262459), // Rule ID 8369 //
     /* 262412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 262420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 262426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262436 */     // MIs[0] idx
     /* 262436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262444 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1470:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 262444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 262447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262455 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 262457 */     GIR_RootConstrainSelectedInstOperands,
     /* 262458 */     // GIR_Coverage, 8369,
     /* 262458 */     GIR_EraseRootFromParent_Done,
     /* 262459 */   // Label 5070: @262459
     /* 262459 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(262511), // Rule ID 8370 //
     /* 262464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 262472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262488 */     // MIs[0] idx
     /* 262488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262491 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262496 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1470:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 262496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 262499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262507 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 262509 */     GIR_RootConstrainSelectedInstOperands,
     /* 262510 */     // GIR_Coverage, 8370,
     /* 262510 */     GIR_EraseRootFromParent_Done,
     /* 262511 */   // Label 5071: @262511
     /* 262511 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(262563), // Rule ID 8371 //
     /* 262516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 262524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262540 */     // MIs[0] idx
     /* 262540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 262548 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1470:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 262548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 262551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262557 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262559 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 262561 */     GIR_RootConstrainSelectedInstOperands,
     /* 262562 */     // GIR_Coverage, 8371,
     /* 262562 */     GIR_EraseRootFromParent_Done,
     /* 262563 */   // Label 5072: @262563
     /* 262563 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(262615), // Rule ID 11335 //
     /* 262568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 262571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 262576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262592 */     // MIs[0] Op4
     /* 262592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262600 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1907:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 262603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262611 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262613 */     GIR_RootConstrainSelectedInstOperands,
     /* 262614 */     // GIR_Coverage, 11335,
     /* 262614 */     GIR_EraseRootFromParent_Done,
     /* 262615 */   // Label 5073: @262615
     /* 262615 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(262667), // Rule ID 11382 //
     /* 262620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 262628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 262634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262644 */     // MIs[0] Op4
     /* 262644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262647 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1606:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 262655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262663 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262665 */     GIR_RootConstrainSelectedInstOperands,
     /* 262666 */     // GIR_Coverage, 11382,
     /* 262666 */     GIR_EraseRootFromParent_Done,
     /* 262667 */   // Label 5074: @262667
     /* 262667 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(262719), // Rule ID 11383 //
     /* 262672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 262680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262696 */     // MIs[0] Op4
     /* 262696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262699 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1606:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 262707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262715 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262717 */     GIR_RootConstrainSelectedInstOperands,
     /* 262718 */     // GIR_Coverage, 11383,
     /* 262718 */     GIR_EraseRootFromParent_Done,
     /* 262719 */   // Label 5075: @262719
     /* 262719 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(262771), // Rule ID 11384 //
     /* 262724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 262732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262748 */     // MIs[0] Op4
     /* 262748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 262756 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1606:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 262756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 262759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262765 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262767 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262769 */     GIR_RootConstrainSelectedInstOperands,
     /* 262770 */     // GIR_Coverage, 11384,
     /* 262770 */     GIR_EraseRootFromParent_Done,
     /* 262771 */   // Label 5076: @262771
     /* 262771 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(262823), // Rule ID 11385 //
     /* 262776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 262784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 262790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262800 */     // MIs[0] Op4
     /* 262800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262803 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262808 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1824:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 262811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262817 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262819 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262821 */     GIR_RootConstrainSelectedInstOperands,
     /* 262822 */     // GIR_Coverage, 11385,
     /* 262822 */     GIR_EraseRootFromParent_Done,
     /* 262823 */   // Label 5077: @262823
     /* 262823 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(262875), // Rule ID 11386 //
     /* 262828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 262836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262852 */     // MIs[0] Op4
     /* 262852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262860 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1824:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 262863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262871 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262873 */     GIR_RootConstrainSelectedInstOperands,
     /* 262874 */     // GIR_Coverage, 11386,
     /* 262874 */     GIR_EraseRootFromParent_Done,
     /* 262875 */   // Label 5078: @262875
     /* 262875 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(262927), // Rule ID 11387 //
     /* 262880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 262888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262904 */     // MIs[0] Op4
     /* 262904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262907 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 262912 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1824:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 262912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 262915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262923 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262925 */     GIR_RootConstrainSelectedInstOperands,
     /* 262926 */     // GIR_Coverage, 11387,
     /* 262926 */     GIR_EraseRootFromParent_Done,
     /* 262927 */   // Label 5079: @262927
     /* 262927 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(262979), // Rule ID 11388 //
     /* 262932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 262940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 262946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262956 */     // MIs[0] Op4
     /* 262956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 262967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262975 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262977 */     GIR_RootConstrainSelectedInstOperands,
     /* 262978 */     // GIR_Coverage, 11388,
     /* 262978 */     GIR_EraseRootFromParent_Done,
     /* 262979 */   // Label 5080: @262979
     /* 262979 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(263031), // Rule ID 11389 //
     /* 262984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 262992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263008 */     // MIs[0] Op4
     /* 263008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263011 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263016 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 263019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263025 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263027 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263029 */     GIR_RootConstrainSelectedInstOperands,
     /* 263030 */     // GIR_Coverage, 11389,
     /* 263030 */     GIR_EraseRootFromParent_Done,
     /* 263031 */   // Label 5081: @263031
     /* 263031 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(263083), // Rule ID 11390 //
     /* 263036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 263044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263060 */     // MIs[0] Op4
     /* 263060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 263068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1826:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 263068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 263071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263079 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263081 */     GIR_RootConstrainSelectedInstOperands,
     /* 263082 */     // GIR_Coverage, 11390,
     /* 263082 */     GIR_EraseRootFromParent_Done,
     /* 263083 */   // Label 5082: @263083
     /* 263083 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(263135), // Rule ID 11433 //
     /* 263088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 263096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263112 */     // MIs[0] Op4
     /* 263112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263120 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 263123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263131 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263133 */     GIR_RootConstrainSelectedInstOperands,
     /* 263134 */     // GIR_Coverage, 11433,
     /* 263134 */     GIR_EraseRootFromParent_Done,
     /* 263135 */   // Label 5083: @263135
     /* 263135 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(263187), // Rule ID 11434 //
     /* 263140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 263148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263164 */     // MIs[0] Op4
     /* 263164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263167 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263172 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 263175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263183 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263185 */     GIR_RootConstrainSelectedInstOperands,
     /* 263186 */     // GIR_Coverage, 11434,
     /* 263186 */     GIR_EraseRootFromParent_Done,
     /* 263187 */   // Label 5084: @263187
     /* 263187 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(263239), // Rule ID 11435 //
     /* 263192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 263200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263216 */     // MIs[0] Op4
     /* 263216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263224 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1983:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 263227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263235 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263237 */     GIR_RootConstrainSelectedInstOperands,
     /* 263238 */     // GIR_Coverage, 11435,
     /* 263238 */     GIR_EraseRootFromParent_Done,
     /* 263239 */   // Label 5085: @263239
     /* 263239 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(263291), // Rule ID 11436 //
     /* 263244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 263252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263268 */     // MIs[0] Op4
     /* 263268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1983:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 263279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263287 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263289 */     GIR_RootConstrainSelectedInstOperands,
     /* 263290 */     // GIR_Coverage, 11436,
     /* 263290 */     GIR_EraseRootFromParent_Done,
     /* 263291 */   // Label 5086: @263291
     /* 263291 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(263343), // Rule ID 11437 //
     /* 263296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 263304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263320 */     // MIs[0] Op4
     /* 263320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263323 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1985:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 263331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263339 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263341 */     GIR_RootConstrainSelectedInstOperands,
     /* 263342 */     // GIR_Coverage, 11437,
     /* 263342 */     GIR_EraseRootFromParent_Done,
     /* 263343 */   // Label 5087: @263343
     /* 263343 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(263395), // Rule ID 11438 //
     /* 263348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 263356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263372 */     // MIs[0] Op4
     /* 263372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263375 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263380 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1985:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 263383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263389 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263391 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263393 */     GIR_RootConstrainSelectedInstOperands,
     /* 263394 */     // GIR_Coverage, 11438,
     /* 263394 */     GIR_EraseRootFromParent_Done,
     /* 263395 */   // Label 5088: @263395
     /* 263395 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(263447), // Rule ID 11439 //
     /* 263400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 263408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263424 */     // MIs[0] Op4
     /* 263424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263432 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1749:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 263435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263443 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263445 */     GIR_RootConstrainSelectedInstOperands,
     /* 263446 */     // GIR_Coverage, 11439,
     /* 263446 */     GIR_EraseRootFromParent_Done,
     /* 263447 */   // Label 5089: @263447
     /* 263447 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(263499), // Rule ID 11440 //
     /* 263452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 263460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263476 */     // MIs[0] Op4
     /* 263476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263479 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1749:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 263487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263495 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263497 */     GIR_RootConstrainSelectedInstOperands,
     /* 263498 */     // GIR_Coverage, 11440,
     /* 263498 */     GIR_EraseRootFromParent_Done,
     /* 263499 */   // Label 5090: @263499
     /* 263499 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(263551), // Rule ID 11441 //
     /* 263504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 263512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263528 */     // MIs[0] Op4
     /* 263528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 263539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263547 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263549 */     GIR_RootConstrainSelectedInstOperands,
     /* 263550 */     // GIR_Coverage, 11441,
     /* 263550 */     GIR_EraseRootFromParent_Done,
     /* 263551 */   // Label 5091: @263551
     /* 263551 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(263603), // Rule ID 11442 //
     /* 263556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 263564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263580 */     // MIs[0] Op4
     /* 263580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263583 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263588 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1751:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 263591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263599 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263601 */     GIR_RootConstrainSelectedInstOperands,
     /* 263602 */     // GIR_Coverage, 11442,
     /* 263602 */     GIR_EraseRootFromParent_Done,
     /* 263603 */   // Label 5092: @263603
     /* 263603 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(263655), // Rule ID 11443 //
     /* 263608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 263616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263632 */     // MIs[0] Op4
     /* 263632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263635 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1987:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 263643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263649 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263651 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263653 */     GIR_RootConstrainSelectedInstOperands,
     /* 263654 */     // GIR_Coverage, 11443,
     /* 263654 */     GIR_EraseRootFromParent_Done,
     /* 263655 */   // Label 5093: @263655
     /* 263655 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(263707), // Rule ID 11444 //
     /* 263660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 263668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263684 */     // MIs[0] Op4
     /* 263684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1987:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 263695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263703 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263705 */     GIR_RootConstrainSelectedInstOperands,
     /* 263706 */     // GIR_Coverage, 11444,
     /* 263706 */     GIR_EraseRootFromParent_Done,
     /* 263707 */   // Label 5094: @263707
     /* 263707 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(263759), // Rule ID 11445 //
     /* 263712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 263720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263736 */     // MIs[0] Op4
     /* 263736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1989:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 263747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263755 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263757 */     GIR_RootConstrainSelectedInstOperands,
     /* 263758 */     // GIR_Coverage, 11445,
     /* 263758 */     GIR_EraseRootFromParent_Done,
     /* 263759 */   // Label 5095: @263759
     /* 263759 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(263811), // Rule ID 11446 //
     /* 263764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 263772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263788 */     // MIs[0] Op4
     /* 263788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263791 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263796 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1989:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 263799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263807 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263809 */     GIR_RootConstrainSelectedInstOperands,
     /* 263810 */     // GIR_Coverage, 11446,
     /* 263810 */     GIR_EraseRootFromParent_Done,
     /* 263811 */   // Label 5096: @263811
     /* 263811 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(263863), // Rule ID 11468 //
     /* 263816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 263824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263840 */     // MIs[0] Op4
     /* 263840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1787:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 263851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263859 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263861 */     GIR_RootConstrainSelectedInstOperands,
     /* 263862 */     // GIR_Coverage, 11468,
     /* 263862 */     GIR_EraseRootFromParent_Done,
     /* 263863 */   // Label 5097: @263863
     /* 263863 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(263915), // Rule ID 11469 //
     /* 263868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 263876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263892 */     // MIs[0] Op4
     /* 263892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1787:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 263903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263911 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263913 */     GIR_RootConstrainSelectedInstOperands,
     /* 263914 */     // GIR_Coverage, 11469,
     /* 263914 */     GIR_EraseRootFromParent_Done,
     /* 263915 */   // Label 5098: @263915
     /* 263915 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(263967), // Rule ID 11470 //
     /* 263920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 263928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263944 */     // MIs[0] Op4
     /* 263944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263952 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1790:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 263955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263963 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263965 */     GIR_RootConstrainSelectedInstOperands,
     /* 263966 */     // GIR_Coverage, 11470,
     /* 263966 */     GIR_EraseRootFromParent_Done,
     /* 263967 */   // Label 5099: @263967
     /* 263967 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(264019), // Rule ID 11471 //
     /* 263972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 263980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263996 */     // MIs[0] Op4
     /* 263996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263999 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 264004 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1790:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 264004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 264007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264015 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264017 */     GIR_RootConstrainSelectedInstOperands,
     /* 264018 */     // GIR_Coverage, 11471,
     /* 264018 */     GIR_EraseRootFromParent_Done,
     /* 264019 */   // Label 5100: @264019
     /* 264019 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(264071), // Rule ID 11472 //
     /* 264024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 264032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264048 */     // MIs[0] Op4
     /* 264048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264051 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 264056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1792:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 264056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 264059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264067 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264069 */     GIR_RootConstrainSelectedInstOperands,
     /* 264070 */     // GIR_Coverage, 11472,
     /* 264070 */     GIR_EraseRootFromParent_Done,
     /* 264071 */   // Label 5101: @264071
     /* 264071 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(264123), // Rule ID 11473 //
     /* 264076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 264084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 264090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264100 */     // MIs[0] Op4
     /* 264100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 264108 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1792:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 264108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 264111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264119 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264121 */     GIR_RootConstrainSelectedInstOperands,
     /* 264122 */     // GIR_Coverage, 11473,
     /* 264122 */     GIR_EraseRootFromParent_Done,
     /* 264123 */   // Label 5102: @264123
     /* 264123 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(264175), // Rule ID 11474 //
     /* 264128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 264136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264152 */     // MIs[0] Op4
     /* 264152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264155 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 264160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1795:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 264160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 264163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264169 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264171 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264173 */     GIR_RootConstrainSelectedInstOperands,
     /* 264174 */     // GIR_Coverage, 11474,
     /* 264174 */     GIR_EraseRootFromParent_Done,
     /* 264175 */   // Label 5103: @264175
     /* 264175 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(264227), // Rule ID 11475 //
     /* 264180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 264188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 264194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264204 */     // MIs[0] Op4
     /* 264204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264207 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 264212 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1795:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 264212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 264215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264223 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264225 */     GIR_RootConstrainSelectedInstOperands,
     /* 264226 */     // GIR_Coverage, 11475,
     /* 264226 */     GIR_EraseRootFromParent_Done,
     /* 264227 */   // Label 5104: @264227
     /* 264227 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(264279), // Rule ID 11929 //
     /* 264232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 264240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264256 */     // MIs[0] Op4
     /* 264256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264259 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 264264 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1466:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 264264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 264267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264275 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264277 */     GIR_RootConstrainSelectedInstOperands,
     /* 264278 */     // GIR_Coverage, 11929,
     /* 264278 */     GIR_EraseRootFromParent_Done,
     /* 264279 */   // Label 5105: @264279
     /* 264279 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(264331), // Rule ID 11930 //
     /* 264284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 264292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264308 */     // MIs[0] Op4
     /* 264308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 264316 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1468:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 264316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 264319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264327 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264329 */     GIR_RootConstrainSelectedInstOperands,
     /* 264330 */     // GIR_Coverage, 11930,
     /* 264330 */     GIR_EraseRootFromParent_Done,
     /* 264331 */   // Label 5106: @264331
     /* 264331 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(264383), // Rule ID 11931 //
     /* 264336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 264344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264360 */     // MIs[0] Op4
     /* 264360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264363 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 264368 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 264368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 264371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264379 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264381 */     GIR_RootConstrainSelectedInstOperands,
     /* 264382 */     // GIR_Coverage, 11931,
     /* 264382 */     GIR_EraseRootFromParent_Done,
     /* 264383 */   // Label 5107: @264383
     /* 264383 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(264435), // Rule ID 11932 //
     /* 264388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 264396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264412 */     // MIs[0] Op4
     /* 264412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 264420 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1475:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 264420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 264423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264429 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264431 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264433 */     GIR_RootConstrainSelectedInstOperands,
     /* 264434 */     // GIR_Coverage, 11932,
     /* 264434 */     GIR_EraseRootFromParent_Done,
     /* 264435 */   // Label 5108: @264435
     /* 264435 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(264487), // Rule ID 12077 //
     /* 264440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 264443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 264448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264464 */     // MIs[0] Op4
     /* 264464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 264472 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1421:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 264472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 264475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264483 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264485 */     GIR_RootConstrainSelectedInstOperands,
     /* 264486 */     // GIR_Coverage, 12077,
     /* 264486 */     GIR_EraseRootFromParent_Done,
     /* 264487 */   // Label 5109: @264487
     /* 264487 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(264539), // Rule ID 12079 //
     /* 264492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 264495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 264500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264516 */     // MIs[0] Op4
     /* 264516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 264524 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1959:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 264524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 264527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264535 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264537 */     GIR_RootConstrainSelectedInstOperands,
     /* 264538 */     // GIR_Coverage, 12079,
     /* 264538 */     GIR_EraseRootFromParent_Done,
     /* 264539 */   // Label 5110: @264539
     /* 264539 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(264586), // Rule ID 2829 //
     /* 264544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 264552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264571 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1462:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 264574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264582 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264584 */     GIR_RootConstrainSelectedInstOperands,
     /* 264585 */     // GIR_Coverage, 2829,
     /* 264585 */     GIR_EraseRootFromParent_Done,
     /* 264586 */   // Label 5111: @264586
     /* 264586 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(264633), // Rule ID 2832 //
     /* 264591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 264599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 264602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 264608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 264611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 264614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264618 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1462:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 264618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 264621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264629 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264631 */     GIR_RootConstrainSelectedInstOperands,
     /* 264632 */     // GIR_Coverage, 2832,
     /* 264632 */     GIR_EraseRootFromParent_Done,
     /* 264633 */   // Label 5112: @264633
     /* 264633 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(264680), // Rule ID 2835 //
     /* 264638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 264646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 264649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 264655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 264658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 264661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264665 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1462:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 264665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 264668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264676 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264678 */     GIR_RootConstrainSelectedInstOperands,
     /* 264679 */     // GIR_Coverage, 2835,
     /* 264679 */     GIR_EraseRootFromParent_Done,
     /* 264680 */   // Label 5113: @264680
     /* 264680 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(264727), // Rule ID 2838 //
     /* 264685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 264693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264712 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1462:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 264715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264723 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264725 */     GIR_RootConstrainSelectedInstOperands,
     /* 264726 */     // GIR_Coverage, 2838,
     /* 264726 */     GIR_EraseRootFromParent_Done,
     /* 264727 */   // Label 5114: @264727
     /* 264727 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(264774), // Rule ID 2841 //
     /* 264732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 264740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 264743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 264749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 264752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 264755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264759 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1462:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 264759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 264762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264770 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264772 */     GIR_RootConstrainSelectedInstOperands,
     /* 264773 */     // GIR_Coverage, 2841,
     /* 264773 */     GIR_EraseRootFromParent_Done,
     /* 264774 */   // Label 5115: @264774
     /* 264774 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(264821), // Rule ID 2844 //
     /* 264779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 264787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264806 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1462:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 264809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264817 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264819 */     GIR_RootConstrainSelectedInstOperands,
     /* 264820 */     // GIR_Coverage, 2844,
     /* 264820 */     GIR_EraseRootFromParent_Done,
     /* 264821 */   // Label 5116: @264821
     /* 264821 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(264868), // Rule ID 2847 //
     /* 264826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 264834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264853 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1425:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 264856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264864 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264866 */     GIR_RootConstrainSelectedInstOperands,
     /* 264867 */     // GIR_Coverage, 2847,
     /* 264867 */     GIR_EraseRootFromParent_Done,
     /* 264868 */   // Label 5117: @264868
     /* 264868 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(264915), // Rule ID 2848 //
     /* 264873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 264881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264900 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1425:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 264903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264911 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264913 */     GIR_RootConstrainSelectedInstOperands,
     /* 264914 */     // GIR_Coverage, 2848,
     /* 264914 */     GIR_EraseRootFromParent_Done,
     /* 264915 */   // Label 5118: @264915
     /* 264915 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(264962), // Rule ID 2849 //
     /* 264920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 264928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264947 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1425:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 264950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264958 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264960 */     GIR_RootConstrainSelectedInstOperands,
     /* 264961 */     // GIR_Coverage, 2849,
     /* 264961 */     GIR_EraseRootFromParent_Done,
     /* 264962 */   // Label 5119: @264962
     /* 264962 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(265009), // Rule ID 2945 //
     /* 264967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 264975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 264978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 264981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 264984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 264987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 264990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264994 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 264994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 264997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265005 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265007 */     GIR_RootConstrainSelectedInstOperands,
     /* 265008 */     // GIR_Coverage, 2945,
     /* 265008 */     GIR_EraseRootFromParent_Done,
     /* 265009 */   // Label 5120: @265009
     /* 265009 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(265056), // Rule ID 2948 //
     /* 265014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 265022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265041 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 265041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 265044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265052 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265054 */     GIR_RootConstrainSelectedInstOperands,
     /* 265055 */     // GIR_Coverage, 2948,
     /* 265055 */     GIR_EraseRootFromParent_Done,
     /* 265056 */   // Label 5121: @265056
     /* 265056 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(265103), // Rule ID 2951 //
     /* 265061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 265069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1600:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 265088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 265091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265099 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265101 */     GIR_RootConstrainSelectedInstOperands,
     /* 265102 */     // GIR_Coverage, 2951,
     /* 265102 */     GIR_EraseRootFromParent_Done,
     /* 265103 */   // Label 5122: @265103
     /* 265103 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(265150), // Rule ID 2954 //
     /* 265108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 265116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265135 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1600:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 265135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 265138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265146 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265148 */     GIR_RootConstrainSelectedInstOperands,
     /* 265149 */     // GIR_Coverage, 2954,
     /* 265149 */     GIR_EraseRootFromParent_Done,
     /* 265150 */   // Label 5123: @265150
     /* 265150 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(265197), // Rule ID 2957 //
     /* 265155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 265163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 265166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 265169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 265172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 265175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 265178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265182 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 265182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 265185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265193 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265195 */     GIR_RootConstrainSelectedInstOperands,
     /* 265196 */     // GIR_Coverage, 2957,
     /* 265196 */     GIR_EraseRootFromParent_Done,
     /* 265197 */   // Label 5124: @265197
     /* 265197 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(265244), // Rule ID 2959 //
     /* 265202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 265210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265229 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 265229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 265232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265240 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265242 */     GIR_RootConstrainSelectedInstOperands,
     /* 265243 */     // GIR_Coverage, 2959,
     /* 265243 */     GIR_EraseRootFromParent_Done,
     /* 265244 */   // Label 5125: @265244
     /* 265244 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(265291), // Rule ID 2961 //
     /* 265249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 265257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 265276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 265279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265287 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265289 */     GIR_RootConstrainSelectedInstOperands,
     /* 265290 */     // GIR_Coverage, 2961,
     /* 265290 */     GIR_EraseRootFromParent_Done,
     /* 265291 */   // Label 5126: @265291
     /* 265291 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(265338), // Rule ID 2963 //
     /* 265296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 265304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265323 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 265323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 265326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265334 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265336 */     GIR_RootConstrainSelectedInstOperands,
     /* 265337 */     // GIR_Coverage, 2963,
     /* 265337 */     GIR_EraseRootFromParent_Done,
     /* 265338 */   // Label 5127: @265338
     /* 265338 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(265385), // Rule ID 7634 //
     /* 265343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 265351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 265354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 265357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 265360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 265363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 265366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265370 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1608:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 265370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 265373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265381 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265383 */     GIR_RootConstrainSelectedInstOperands,
     /* 265384 */     // GIR_Coverage, 7634,
     /* 265384 */     GIR_EraseRootFromParent_Done,
     /* 265385 */   // Label 5128: @265385
     /* 265385 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(265432), // Rule ID 7637 //
     /* 265390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 265398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265417 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1608:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 265417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 265420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265428 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265430 */     GIR_RootConstrainSelectedInstOperands,
     /* 265431 */     // GIR_Coverage, 7637,
     /* 265431 */     GIR_EraseRootFromParent_Done,
     /* 265432 */   // Label 5129: @265432
     /* 265432 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(265479), // Rule ID 7640 //
     /* 265437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 265445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1608:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 265464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 265467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265475 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265477 */     GIR_RootConstrainSelectedInstOperands,
     /* 265478 */     // GIR_Coverage, 7640,
     /* 265478 */     GIR_EraseRootFromParent_Done,
     /* 265479 */   // Label 5130: @265479
     /* 265479 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(265526), // Rule ID 7643 //
     /* 265484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 265492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265511 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1608:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 265511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 265514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265522 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265524 */     GIR_RootConstrainSelectedInstOperands,
     /* 265525 */     // GIR_Coverage, 7643,
     /* 265525 */     GIR_EraseRootFromParent_Done,
     /* 265526 */   // Label 5131: @265526
     /* 265526 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(265573), // Rule ID 7646 //
     /* 265531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 265539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 265542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 265545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 265548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 265551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 265554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265558 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1605:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 265558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 265561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265569 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265571 */     GIR_RootConstrainSelectedInstOperands,
     /* 265572 */     // GIR_Coverage, 7646,
     /* 265572 */     GIR_EraseRootFromParent_Done,
     /* 265573 */   // Label 5132: @265573
     /* 265573 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(265620), // Rule ID 7648 //
     /* 265578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 265586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265605 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1605:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 265605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 265608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265616 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265618 */     GIR_RootConstrainSelectedInstOperands,
     /* 265619 */     // GIR_Coverage, 7648,
     /* 265619 */     GIR_EraseRootFromParent_Done,
     /* 265620 */   // Label 5133: @265620
     /* 265620 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(265667), // Rule ID 7650 //
     /* 265625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 265633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265652 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1605:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 265652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 265655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265663 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265665 */     GIR_RootConstrainSelectedInstOperands,
     /* 265666 */     // GIR_Coverage, 7650,
     /* 265666 */     GIR_EraseRootFromParent_Done,
     /* 265667 */   // Label 5134: @265667
     /* 265667 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(265714), // Rule ID 7652 //
     /* 265672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 265680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265699 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1605:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 265699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 265702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265710 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265712 */     GIR_RootConstrainSelectedInstOperands,
     /* 265713 */     // GIR_Coverage, 7652,
     /* 265713 */     GIR_EraseRootFromParent_Done,
     /* 265714 */   // Label 5135: @265714
     /* 265714 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(265761), // Rule ID 8282 //
     /* 265719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 265727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265746 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1469:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 265746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 265749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265757 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265759 */     GIR_RootConstrainSelectedInstOperands,
     /* 265760 */     // GIR_Coverage, 8282,
     /* 265760 */     GIR_EraseRootFromParent_Done,
     /* 265761 */   // Label 5136: @265761
     /* 265761 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(265808), // Rule ID 8285 //
     /* 265766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 265774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 265777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 265783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 265786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 265789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265793 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1469:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 265793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 265796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265804 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265806 */     GIR_RootConstrainSelectedInstOperands,
     /* 265807 */     // GIR_Coverage, 8285,
     /* 265807 */     GIR_EraseRootFromParent_Done,
     /* 265808 */   // Label 5137: @265808
     /* 265808 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(265855), // Rule ID 8288 //
     /* 265813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 265821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 265824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 265830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 265833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 265836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265840 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1469:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 265840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 265843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265851 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265853 */     GIR_RootConstrainSelectedInstOperands,
     /* 265854 */     // GIR_Coverage, 8288,
     /* 265854 */     GIR_EraseRootFromParent_Done,
     /* 265855 */   // Label 5138: @265855
     /* 265855 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(265902), // Rule ID 8291 //
     /* 265860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 265868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265887 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1469:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 265887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 265890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265898 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265900 */     GIR_RootConstrainSelectedInstOperands,
     /* 265901 */     // GIR_Coverage, 8291,
     /* 265901 */     GIR_EraseRootFromParent_Done,
     /* 265902 */   // Label 5139: @265902
     /* 265902 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(265949), // Rule ID 8294 //
     /* 265907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 265915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 265918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 265924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 265927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 265930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265934 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1469:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 265934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 265937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265945 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265947 */     GIR_RootConstrainSelectedInstOperands,
     /* 265948 */     // GIR_Coverage, 8294,
     /* 265948 */     GIR_EraseRootFromParent_Done,
     /* 265949 */   // Label 5140: @265949
     /* 265949 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(265996), // Rule ID 8297 //
     /* 265954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 265962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265981 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1469:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 265984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265992 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265994 */     GIR_RootConstrainSelectedInstOperands,
     /* 265995 */     // GIR_Coverage, 8297,
     /* 265995 */     GIR_EraseRootFromParent_Done,
     /* 265996 */   // Label 5141: @265996
     /* 265996 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(266043), // Rule ID 8300 //
     /* 266001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 266009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 266012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 266015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 266018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 266021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 266024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266028 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1485:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 266028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 266031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266039 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266041 */     GIR_RootConstrainSelectedInstOperands,
     /* 266042 */     // GIR_Coverage, 8300,
     /* 266042 */     GIR_EraseRootFromParent_Done,
     /* 266043 */   // Label 5142: @266043
     /* 266043 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(266090), // Rule ID 8301 //
     /* 266048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 266056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 266059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 266065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 266068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 266071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266075 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1485:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 266075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 266078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266086 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266088 */     GIR_RootConstrainSelectedInstOperands,
     /* 266089 */     // GIR_Coverage, 8301,
     /* 266089 */     GIR_EraseRootFromParent_Done,
     /* 266090 */   // Label 5143: @266090
     /* 266090 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(266137), // Rule ID 8302 //
     /* 266095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 266103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 266106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 266112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 266115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 266118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266122 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 266122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 266125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266131 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266133 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266135 */     GIR_RootConstrainSelectedInstOperands,
     /* 266136 */     // GIR_Coverage, 8302,
     /* 266136 */     GIR_EraseRootFromParent_Done,
     /* 266137 */   // Label 5144: @266137
     /* 266137 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(266184), // Rule ID 8303 //
     /* 266142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 266150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 266153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 266159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 266162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 266165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266169 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1485:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 266169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 266172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266180 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266182 */     GIR_RootConstrainSelectedInstOperands,
     /* 266183 */     // GIR_Coverage, 8303,
     /* 266183 */     GIR_EraseRootFromParent_Done,
     /* 266184 */   // Label 5145: @266184
     /* 266184 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(266231), // Rule ID 8304 //
     /* 266189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 266197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 266200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 266206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 266209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 266212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266216 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 266216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 266219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266227 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266229 */     GIR_RootConstrainSelectedInstOperands,
     /* 266230 */     // GIR_Coverage, 8304,
     /* 266230 */     GIR_EraseRootFromParent_Done,
     /* 266231 */   // Label 5146: @266231
     /* 266231 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(266278), // Rule ID 8305 //
     /* 266236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 266244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 266247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 266253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 266256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 266259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266263 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 266263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 266266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266274 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266276 */     GIR_RootConstrainSelectedInstOperands,
     /* 266277 */     // GIR_Coverage, 8305,
     /* 266277 */     GIR_EraseRootFromParent_Done,
     /* 266278 */   // Label 5147: @266278
     /* 266278 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(266325), // Rule ID 8306 //
     /* 266283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 266291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 266294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 266297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 266300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 266303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 266306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266310 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 266310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 266313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266321 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266323 */     GIR_RootConstrainSelectedInstOperands,
     /* 266324 */     // GIR_Coverage, 8306,
     /* 266324 */     GIR_EraseRootFromParent_Done,
     /* 266325 */   // Label 5148: @266325
     /* 266325 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(266372), // Rule ID 8307 //
     /* 266330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 266338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 266341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 266347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 266350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 266353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266357 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 266357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 266360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266368 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266370 */     GIR_RootConstrainSelectedInstOperands,
     /* 266371 */     // GIR_Coverage, 8307,
     /* 266371 */     GIR_EraseRootFromParent_Done,
     /* 266372 */   // Label 5149: @266372
     /* 266372 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(266419), // Rule ID 8308 //
     /* 266377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 266385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 266388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 266394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 266397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 266400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266404 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 266404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 266407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266415 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266417 */     GIR_RootConstrainSelectedInstOperands,
     /* 266418 */     // GIR_Coverage, 8308,
     /* 266418 */     GIR_EraseRootFromParent_Done,
     /* 266419 */   // Label 5150: @266419
     /* 266419 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(266466), // Rule ID 8309 //
     /* 266424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 266432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 266435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 266441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 266444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 266447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266451 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 266451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 266454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266462 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266464 */     GIR_RootConstrainSelectedInstOperands,
     /* 266465 */     // GIR_Coverage, 8309,
     /* 266465 */     GIR_EraseRootFromParent_Done,
     /* 266466 */   // Label 5151: @266466
     /* 266466 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(266513), // Rule ID 8310 //
     /* 266471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 266479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 266482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 266488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 266491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 266494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266498 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 266498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 266501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266507 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266509 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266511 */     GIR_RootConstrainSelectedInstOperands,
     /* 266512 */     // GIR_Coverage, 8310,
     /* 266512 */     GIR_EraseRootFromParent_Done,
     /* 266513 */   // Label 5152: @266513
     /* 266513 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(266560), // Rule ID 8311 //
     /* 266518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 266526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 266529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 266535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 266538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 266541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266545 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 266545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 266548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266556 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266558 */     GIR_RootConstrainSelectedInstOperands,
     /* 266559 */     // GIR_Coverage, 8311,
     /* 266559 */     GIR_EraseRootFromParent_Done,
     /* 266560 */   // Label 5153: @266560
     /* 266560 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(266607), // Rule ID 8312 //
     /* 266565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 266573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 266576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 266579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 266582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 266585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 266588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266592 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 266592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 266595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 266597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266603 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266605 */     GIR_RootConstrainSelectedInstOperands,
     /* 266606 */     // GIR_Coverage, 8312,
     /* 266606 */     GIR_EraseRootFromParent_Done,
     /* 266607 */   // Label 5154: @266607
     /* 266607 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(266654), // Rule ID 8313 //
     /* 266612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 266620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 266623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 266629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 266632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 266635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266639 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 266639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 266642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 266644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266650 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266652 */     GIR_RootConstrainSelectedInstOperands,
     /* 266653 */     // GIR_Coverage, 8313,
     /* 266653 */     GIR_EraseRootFromParent_Done,
     /* 266654 */   // Label 5155: @266654
     /* 266654 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(266701), // Rule ID 8314 //
     /* 266659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 266667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 266670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 266676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 266679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 266682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266686 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 266686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 266689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 266691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266695 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266697 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266699 */     GIR_RootConstrainSelectedInstOperands,
     /* 266700 */     // GIR_Coverage, 8314,
     /* 266700 */     GIR_EraseRootFromParent_Done,
     /* 266701 */   // Label 5156: @266701
     /* 266701 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(266748), // Rule ID 8315 //
     /* 266706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 266714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 266717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 266720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 266723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 266726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 266729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266733 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 266733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 266736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 266738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266744 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266746 */     GIR_RootConstrainSelectedInstOperands,
     /* 266747 */     // GIR_Coverage, 8315,
     /* 266747 */     GIR_EraseRootFromParent_Done,
     /* 266748 */   // Label 5157: @266748
     /* 266748 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(266795), // Rule ID 8316 //
     /* 266753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 266761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 266764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 266770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 266773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 266776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266780 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 266780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 266783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 266785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266791 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266793 */     GIR_RootConstrainSelectedInstOperands,
     /* 266794 */     // GIR_Coverage, 8316,
     /* 266794 */     GIR_EraseRootFromParent_Done,
     /* 266795 */   // Label 5158: @266795
     /* 266795 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(266842), // Rule ID 8317 //
     /* 266800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 266808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 266811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 266817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 266820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 266823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266827 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 266827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 266830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 266832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266838 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266840 */     GIR_RootConstrainSelectedInstOperands,
     /* 266841 */     // GIR_Coverage, 8317,
     /* 266841 */     GIR_EraseRootFromParent_Done,
     /* 266842 */   // Label 5159: @266842
     /* 266842 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(266889), // Rule ID 8318 //
     /* 266847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 266855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 266858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 266861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 266864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 266867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 266870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266874 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1489:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 266874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 266877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 266879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266883 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266885 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266887 */     GIR_RootConstrainSelectedInstOperands,
     /* 266888 */     // GIR_Coverage, 8318,
     /* 266888 */     GIR_EraseRootFromParent_Done,
     /* 266889 */   // Label 5160: @266889
     /* 266889 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(266936), // Rule ID 8319 //
     /* 266894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 266902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 266905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 266911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 266914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 266917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266921 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1489:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 266921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 266924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 266926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266932 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266934 */     GIR_RootConstrainSelectedInstOperands,
     /* 266935 */     // GIR_Coverage, 8319,
     /* 266935 */     GIR_EraseRootFromParent_Done,
     /* 266936 */   // Label 5161: @266936
     /* 266936 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(266983), // Rule ID 8320 //
     /* 266941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 266949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 266952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 266958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 266961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 266964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266968 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1489:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 266968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 266971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 266973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266979 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266981 */     GIR_RootConstrainSelectedInstOperands,
     /* 266982 */     // GIR_Coverage, 8320,
     /* 266982 */     GIR_EraseRootFromParent_Done,
     /* 266983 */   // Label 5162: @266983
     /* 266983 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(267030), // Rule ID 8321 //
     /* 266988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 266996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 266999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 267002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 267008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 267011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267015 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1471:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 267015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 267018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267026 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267028 */     GIR_RootConstrainSelectedInstOperands,
     /* 267029 */     // GIR_Coverage, 8321,
     /* 267029 */     GIR_EraseRootFromParent_Done,
     /* 267030 */   // Label 5163: @267030
     /* 267030 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(267077), // Rule ID 8324 //
     /* 267035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 267043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 267046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 267049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 267052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 267055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 267058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267062 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1471:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 267062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 267065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267073 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267075 */     GIR_RootConstrainSelectedInstOperands,
     /* 267076 */     // GIR_Coverage, 8324,
     /* 267076 */     GIR_EraseRootFromParent_Done,
     /* 267077 */   // Label 5164: @267077
     /* 267077 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(267124), // Rule ID 8327 //
     /* 267082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 267090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 267093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 267099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 267102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 267105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267109 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 267109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 267112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267120 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267122 */     GIR_RootConstrainSelectedInstOperands,
     /* 267123 */     // GIR_Coverage, 8327,
     /* 267123 */     GIR_EraseRootFromParent_Done,
     /* 267124 */   // Label 5165: @267124
     /* 267124 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(267171), // Rule ID 8330 //
     /* 267129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 267137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 267140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 267143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 267146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 267149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 267152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267156 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 267156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 267159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267167 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267169 */     GIR_RootConstrainSelectedInstOperands,
     /* 267170 */     // GIR_Coverage, 8330,
     /* 267170 */     GIR_EraseRootFromParent_Done,
     /* 267171 */   // Label 5166: @267171
     /* 267171 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(267218), // Rule ID 8333 //
     /* 267176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 267184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 267187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 267193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 267196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 267199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267203 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 267203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 267206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267214 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267216 */     GIR_RootConstrainSelectedInstOperands,
     /* 267217 */     // GIR_Coverage, 8333,
     /* 267217 */     GIR_EraseRootFromParent_Done,
     /* 267218 */   // Label 5167: @267218
     /* 267218 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(267265), // Rule ID 8336 //
     /* 267223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 267231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 267234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 267240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 267243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 267246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267250 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 267250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 267253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267261 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267263 */     GIR_RootConstrainSelectedInstOperands,
     /* 267264 */     // GIR_Coverage, 8336,
     /* 267264 */     GIR_EraseRootFromParent_Done,
     /* 267265 */   // Label 5168: @267265
     /* 267265 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(267312), // Rule ID 8339 //
     /* 267270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 267278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 267284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 267290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 267293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267297 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1486:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 267297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 267300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267308 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267310 */     GIR_RootConstrainSelectedInstOperands,
     /* 267311 */     // GIR_Coverage, 8339,
     /* 267311 */     GIR_EraseRootFromParent_Done,
     /* 267312 */   // Label 5169: @267312
     /* 267312 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(267359), // Rule ID 8342 //
     /* 267317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 267325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 267328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 267331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 267334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 267337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 267340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267344 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 267344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 267347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267355 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267357 */     GIR_RootConstrainSelectedInstOperands,
     /* 267358 */     // GIR_Coverage, 8342,
     /* 267358 */     GIR_EraseRootFromParent_Done,
     /* 267359 */   // Label 5170: @267359
     /* 267359 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(267406), // Rule ID 8345 //
     /* 267364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 267372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 267375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 267381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 267384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 267387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267391 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 267391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 267394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267402 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267404 */     GIR_RootConstrainSelectedInstOperands,
     /* 267405 */     // GIR_Coverage, 8345,
     /* 267405 */     GIR_EraseRootFromParent_Done,
     /* 267406 */   // Label 5171: @267406
     /* 267406 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(267453), // Rule ID 8348 //
     /* 267411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 267419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 267422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 267425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 267428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 267431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 267434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267438 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 267438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 267441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267449 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267451 */     GIR_RootConstrainSelectedInstOperands,
     /* 267452 */     // GIR_Coverage, 8348,
     /* 267452 */     GIR_EraseRootFromParent_Done,
     /* 267453 */   // Label 5172: @267453
     /* 267453 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(267500), // Rule ID 8351 //
     /* 267458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 267466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 267469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 267475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 267478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 267481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267485 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 267485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 267488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267496 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267498 */     GIR_RootConstrainSelectedInstOperands,
     /* 267499 */     // GIR_Coverage, 8351,
     /* 267499 */     GIR_EraseRootFromParent_Done,
     /* 267500 */   // Label 5173: @267500
     /* 267500 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(267547), // Rule ID 8354 //
     /* 267505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 267513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 267516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 267522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 267525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 267528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267532 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 267532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 267535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267543 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267545 */     GIR_RootConstrainSelectedInstOperands,
     /* 267546 */     // GIR_Coverage, 8354,
     /* 267546 */     GIR_EraseRootFromParent_Done,
     /* 267547 */   // Label 5174: @267547
     /* 267547 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(267594), // Rule ID 8357 //
     /* 267552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 267560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 267566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 267572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 267575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267579 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1488:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 267579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 267582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267590 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267592 */     GIR_RootConstrainSelectedInstOperands,
     /* 267593 */     // GIR_Coverage, 8357,
     /* 267593 */     GIR_EraseRootFromParent_Done,
     /* 267594 */   // Label 5175: @267594
     /* 267594 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(267641), // Rule ID 8359 //
     /* 267599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 267607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 267610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 267613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 267616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 267619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 267622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267626 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1488:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 267626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 267629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267637 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267639 */     GIR_RootConstrainSelectedInstOperands,
     /* 267640 */     // GIR_Coverage, 8359,
     /* 267640 */     GIR_EraseRootFromParent_Done,
     /* 267641 */   // Label 5176: @267641
     /* 267641 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(267688), // Rule ID 8361 //
     /* 267646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 267654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 267657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 267663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 267666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 267669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267673 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 267673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 267676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267684 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267686 */     GIR_RootConstrainSelectedInstOperands,
     /* 267687 */     // GIR_Coverage, 8361,
     /* 267687 */     GIR_EraseRootFromParent_Done,
     /* 267688 */   // Label 5177: @267688
     /* 267688 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(267735), // Rule ID 8363 //
     /* 267693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 267701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 267704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 267707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 267710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 267713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 267716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267720 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1488:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 267720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 267723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267731 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267733 */     GIR_RootConstrainSelectedInstOperands,
     /* 267734 */     // GIR_Coverage, 8363,
     /* 267734 */     GIR_EraseRootFromParent_Done,
     /* 267735 */   // Label 5178: @267735
     /* 267735 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(267782), // Rule ID 8365 //
     /* 267740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 267748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 267751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 267757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 267760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 267763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267767 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 267767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 267770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267778 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267780 */     GIR_RootConstrainSelectedInstOperands,
     /* 267781 */     // GIR_Coverage, 8365,
     /* 267781 */     GIR_EraseRootFromParent_Done,
     /* 267782 */   // Label 5179: @267782
     /* 267782 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(267829), // Rule ID 8367 //
     /* 267787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 267795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 267798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 267804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 267807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 267810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267814 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 267814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 267817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267825 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267827 */     GIR_RootConstrainSelectedInstOperands,
     /* 267828 */     // GIR_Coverage, 8367,
     /* 267828 */     GIR_EraseRootFromParent_Done,
     /* 267829 */   // Label 5180: @267829
     /* 267829 */   GIM_Reject,
     /* 267830 */ // Label 5039: @267830
     /* 267830 */ GIM_Reject,
     /* 267831 */ // Label 38: @267831
     /* 267831 */ GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(267909),
     /* 267836 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 267839 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(267861), // Rule ID 78 //
     /* 267844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 267847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 267852 */     // (intrinsic_void 2167:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 267852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 267855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267859 */     GIR_RootConstrainSelectedInstOperands,
     /* 267860 */     // GIR_Coverage, 78,
     /* 267860 */     GIR_EraseRootFromParent_Done,
     /* 267861 */   // Label 5182: @267861
     /* 267861 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(267886), // Rule ID 2386 //
     /* 267866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 267869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 267874 */     // (intrinsic_void 1717:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 267874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 267877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 267880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267884 */     GIR_RootConstrainSelectedInstOperands,
     /* 267885 */     // GIR_Coverage, 2386,
     /* 267885 */     GIR_EraseRootFromParent_Done,
     /* 267886 */   // Label 5183: @267886
     /* 267886 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(267908), // Rule ID 7188 //
     /* 267891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 267896 */     // (intrinsic_void 501:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 267896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 267899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 267902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267906 */     GIR_RootConstrainSelectedInstOperands,
     /* 267907 */     // GIR_Coverage, 7188,
     /* 267907 */     GIR_EraseRootFromParent_Done,
     /* 267908 */   // Label 5184: @267908
     /* 267908 */   GIM_Reject,
     /* 267909 */ // Label 5181: @267909
     /* 267909 */ GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(268509),
     /* 267914 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 267917 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(267949), // Rule ID 79 //
     /* 267922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 267925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 267930 */     // MIs[0] imm
     /* 267930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267933 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 267938 */     // (intrinsic_void 2166:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 267938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 267941 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 267943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267947 */     GIR_RootConstrainSelectedInstOperands,
     /* 267948 */     // GIR_Coverage, 79,
     /* 267948 */     GIR_EraseRootFromParent_Done,
     /* 267949 */   // Label 5186: @267949
     /* 267949 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(267974), // Rule ID 227 //
     /* 267954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 267959 */     // MIs[0] imm
     /* 267959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 267967 */     // (intrinsic_void 499:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 267967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 267970 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 267972 */     GIR_RootConstrainSelectedInstOperands,
     /* 267973 */     // GIR_Coverage, 227,
     /* 267973 */     GIR_EraseRootFromParent_Done,
     /* 267974 */   // Label 5187: @267974
     /* 267974 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(267999), // Rule ID 228 //
     /* 267979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 267984 */     // MIs[0] imm
     /* 267984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267987 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 267992 */     // (intrinsic_void 558:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 267992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 267995 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 267997 */     GIR_RootConstrainSelectedInstOperands,
     /* 267998 */     // GIR_Coverage, 228,
     /* 267998 */     GIR_EraseRootFromParent_Done,
     /* 267999 */   // Label 5188: @267999
     /* 267999 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(268031), // Rule ID 3624 //
     /* 268004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 268007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 268012 */     // MIs[0] imm
     /* 268012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268015 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 268020 */     // (intrinsic_void 1223:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 268020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 268023 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 268025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268029 */     GIR_RootConstrainSelectedInstOperands,
     /* 268030 */     // GIR_Coverage, 3624,
     /* 268030 */     GIR_EraseRootFromParent_Done,
     /* 268031 */   // Label 5189: @268031
     /* 268031 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(268071), // Rule ID 16 //
     /* 268036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 268041 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 268044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 268056 */     // MIs[1] Operand 1
     /* 268056 */     // No operand predicates
     /* 268056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268058 */     // (intrinsic_void 557:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 268058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 268061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 268064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268069 */     GIR_RootConstrainSelectedInstOperands,
     /* 268070 */     // GIR_Coverage, 16,
     /* 268070 */     GIR_EraseRootFromParent_Done,
     /* 268071 */   // Label 5190: @268071
     /* 268071 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(268111), // Rule ID 17 //
     /* 268076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 268081 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 268084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 268096 */     // MIs[1] Operand 1
     /* 268096 */     // No operand predicates
     /* 268096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268098 */     // (intrinsic_void 545:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 268098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 268101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 268104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268109 */     GIR_RootConstrainSelectedInstOperands,
     /* 268110 */     // GIR_Coverage, 17,
     /* 268110 */     GIR_EraseRootFromParent_Done,
     /* 268111 */   // Label 5191: @268111
     /* 268111 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(268151), // Rule ID 18 //
     /* 268116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 268121 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 268124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 268136 */     // MIs[1] Operand 1
     /* 268136 */     // No operand predicates
     /* 268136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268138 */     // (intrinsic_void 546:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 268138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 268141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 268144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268149 */     GIR_RootConstrainSelectedInstOperands,
     /* 268150 */     // GIR_Coverage, 18,
     /* 268150 */     GIR_EraseRootFromParent_Done,
     /* 268151 */   // Label 5192: @268151
     /* 268151 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(268191), // Rule ID 19 //
     /* 268156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 268161 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 268164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 268176 */     // MIs[1] Operand 1
     /* 268176 */     // No operand predicates
     /* 268176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268178 */     // (intrinsic_void 561:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 268178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 268181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 268184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268189 */     GIR_RootConstrainSelectedInstOperands,
     /* 268190 */     // GIR_Coverage, 19,
     /* 268190 */     GIR_EraseRootFromParent_Done,
     /* 268191 */   // Label 5193: @268191
     /* 268191 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(268215), // Rule ID 72 //
     /* 268196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 268201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268208 */     // (intrinsic_w_chain:{ *:[i64] } 554:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 268208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 268211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268213 */     GIR_RootConstrainSelectedInstOperands,
     /* 268214 */     // GIR_Coverage, 72,
     /* 268214 */     GIR_EraseRootFromParent_Done,
     /* 268215 */   // Label 5194: @268215
     /* 268215 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(268239), // Rule ID 74 //
     /* 268220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 268225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268232 */     // (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 268232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 268235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268237 */     GIR_RootConstrainSelectedInstOperands,
     /* 268238 */     // GIR_Coverage, 74,
     /* 268238 */     GIR_EraseRootFromParent_Done,
     /* 268239 */   // Label 5195: @268239
     /* 268239 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(268270), // Rule ID 77 //
     /* 268244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 268247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 268252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268259 */     // (intrinsic_w_chain:{ *:[i64] } 2168:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 268259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 268262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 268264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268268 */     GIR_RootConstrainSelectedInstOperands,
     /* 268269 */     // GIR_Coverage, 77,
     /* 268269 */     GIR_EraseRootFromParent_Done,
     /* 268270 */   // Label 5196: @268270
     /* 268270 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(268297), // Rule ID 80 //
     /* 268275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 268278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 268283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268290 */     // (intrinsic_w_chain:{ *:[i64] } 2169:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 268290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 268293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 268295 */     GIR_RootConstrainSelectedInstOperands,
     /* 268296 */     // GIR_Coverage, 80,
     /* 268296 */     GIR_EraseRootFromParent_Done,
     /* 268297 */   // Label 5197: @268297
     /* 268297 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(268328), // Rule ID 2385 //
     /* 268302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 268305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 268310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 268313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 268317 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1667:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 268317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 268320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 268322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268326 */     GIR_RootConstrainSelectedInstOperands,
     /* 268327 */     // GIR_Coverage, 2385,
     /* 268327 */     GIR_EraseRootFromParent_Done,
     /* 268328 */   // Label 5198: @268328
     /* 268328 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(268368), // Rule ID 12863 //
     /* 268333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 268336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 268341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268348 */     // (intrinsic_w_chain:{ *:[i64] } 892:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 268348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 268351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 268353 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 268363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 268366 */     GIR_RootConstrainSelectedInstOperands,
     /* 268367 */     // GIR_Coverage, 12863,
     /* 268367 */     GIR_EraseRootFromParent_Done,
     /* 268368 */   // Label 5199: @268368
     /* 268368 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(268402), // Rule ID 2387 //
     /* 268373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 268376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 268381 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 268384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 268388 */     // (intrinsic_void 2147:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 268388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 268391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 268393 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 268396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268400 */     GIR_RootConstrainSelectedInstOperands,
     /* 268401 */     // GIR_Coverage, 2387,
     /* 268401 */     GIR_EraseRootFromParent_Done,
     /* 268402 */   // Label 5200: @268402
     /* 268402 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(268425), // Rule ID 73 //
     /* 268407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 268412 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 268415 */     // (intrinsic_void 781:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 268415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 268418 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 268420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 268423 */     GIR_RootConstrainSelectedInstOperands,
     /* 268424 */     // GIR_Coverage, 73,
     /* 268424 */     GIR_EraseRootFromParent_Done,
     /* 268425 */   // Label 5201: @268425
     /* 268425 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(268448), // Rule ID 75 //
     /* 268430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 268435 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 268438 */     // (intrinsic_void 783:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 268438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 268441 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 268443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 268446 */     GIR_RootConstrainSelectedInstOperands,
     /* 268447 */     // GIR_Coverage, 75,
     /* 268447 */     GIR_EraseRootFromParent_Done,
     /* 268448 */   // Label 5202: @268448
     /* 268448 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(268475), // Rule ID 76 //
     /* 268453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 268458 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 268461 */     // (intrinsic_void 782:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 268461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 268464 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 268466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 268469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268473 */     GIR_RootConstrainSelectedInstOperands,
     /* 268474 */     // GIR_Coverage, 76,
     /* 268474 */     GIR_EraseRootFromParent_Done,
     /* 268475 */   // Label 5203: @268475
     /* 268475 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(268508), // Rule ID 12862 //
     /* 268480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 268483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 268488 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 268491 */     // (intrinsic_void 967:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 268491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 268494 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 268504 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 268506 */     GIR_RootConstrainSelectedInstOperands,
     /* 268507 */     // GIR_Coverage, 12862,
     /* 268507 */     GIR_EraseRootFromParent_Done,
     /* 268508 */   // Label 5204: @268508
     /* 268508 */   GIM_Reject,
     /* 268509 */ // Label 5185: @268509
     /* 268509 */ GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(269480),
     /* 268514 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 268517 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(268593), // Rule ID 7154 //
     /* 268522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 268527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268534 */     // MIs[0] addr
     /* 268534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 268546 */     // (intrinsic_w_chain:{ *:[i64] } 567:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 268546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 268553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268558 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 268562 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 268571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 268582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268587 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268592 */     // GIR_Coverage, 7154,
     /* 268592 */     GIR_EraseRootFromParent_Done,
     /* 268593 */   // Label 5206: @268593
     /* 268593 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(268669), // Rule ID 7155 //
     /* 268598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 268603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268610 */     // MIs[0] addr
     /* 268610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268618 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 268622 */     // (intrinsic_w_chain:{ *:[i64] } 567:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 268622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 268629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 268638 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 268647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 268658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268668 */     // GIR_Coverage, 7155,
     /* 268668 */     GIR_EraseRootFromParent_Done,
     /* 268669 */   // Label 5207: @268669
     /* 268669 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(268745), // Rule ID 7156 //
     /* 268674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 268679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268686 */     // MIs[0] addr
     /* 268686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 268698 */     // (intrinsic_w_chain:{ *:[i64] } 567:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 268698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 268705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268710 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 268714 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 268723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 268734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268744 */     // GIR_Coverage, 7156,
     /* 268744 */     GIR_EraseRootFromParent_Done,
     /* 268745 */   // Label 5208: @268745
     /* 268745 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(268787), // Rule ID 7157 //
     /* 268750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 268755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268762 */     // MIs[0] addr
     /* 268762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268770 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 268774 */     // (intrinsic_w_chain:{ *:[i64] } 567:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 268774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 268777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 268779 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 268781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268785 */     GIR_RootConstrainSelectedInstOperands,
     /* 268786 */     // GIR_Coverage, 7157,
     /* 268786 */     GIR_EraseRootFromParent_Done,
     /* 268787 */   // Label 5209: @268787
     /* 268787 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(268863), // Rule ID 7161 //
     /* 268792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 268797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268804 */     // MIs[0] addr
     /* 268804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 268816 */     // (intrinsic_w_chain:{ *:[i64] } 564:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 268816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 268823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 268832 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 268841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 268852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268862 */     // GIR_Coverage, 7161,
     /* 268862 */     GIR_EraseRootFromParent_Done,
     /* 268863 */   // Label 5210: @268863
     /* 268863 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(268939), // Rule ID 7162 //
     /* 268868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 268873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268880 */     // MIs[0] addr
     /* 268880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 268892 */     // (intrinsic_w_chain:{ *:[i64] } 564:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 268892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 268899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268904 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 268908 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 268917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 268928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268933 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268938 */     // GIR_Coverage, 7162,
     /* 268938 */     GIR_EraseRootFromParent_Done,
     /* 268939 */   // Label 5211: @268939
     /* 268939 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(269015), // Rule ID 7163 //
     /* 268944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 268949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268956 */     // MIs[0] addr
     /* 268956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 268968 */     // (intrinsic_w_chain:{ *:[i64] } 564:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 268968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 268975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 268984 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 268993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 269004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269014 */     // GIR_Coverage, 7163,
     /* 269014 */     GIR_EraseRootFromParent_Done,
     /* 269015 */   // Label 5212: @269015
     /* 269015 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(269057), // Rule ID 7164 //
     /* 269020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 269025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 269028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269032 */     // MIs[0] addr
     /* 269032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 269036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269040 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 269044 */     // (intrinsic_w_chain:{ *:[i64] } 564:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 269044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 269047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 269049 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 269051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269055 */     GIR_RootConstrainSelectedInstOperands,
     /* 269056 */     // GIR_Coverage, 7164,
     /* 269056 */     GIR_EraseRootFromParent_Done,
     /* 269057 */   // Label 5213: @269057
     /* 269057 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(269097), // Rule ID 20 //
     /* 269062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 269065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 269070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 269073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269084 */     // (intrinsic_w_chain:{ *:[i64] } 552:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 269084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 269087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 269089 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 269091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269095 */     GIR_RootConstrainSelectedInstOperands,
     /* 269096 */     // GIR_Coverage, 20,
     /* 269096 */     GIR_EraseRootFromParent_Done,
     /* 269097 */   // Label 5214: @269097
     /* 269097 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(269137), // Rule ID 2384 //
     /* 269102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 269105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 269110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 269113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 269116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 269120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 269124 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1668:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 269124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 269127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 269129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269135 */     GIR_RootConstrainSelectedInstOperands,
     /* 269136 */     // GIR_Coverage, 2384,
     /* 269136 */     GIR_EraseRootFromParent_Done,
     /* 269137 */   // Label 5215: @269137
     /* 269137 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(269177), // Rule ID 2495 //
     /* 269142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 269145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 269150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 269153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269164 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 269164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 269167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269175 */     GIR_RootConstrainSelectedInstOperands,
     /* 269176 */     // GIR_Coverage, 2495,
     /* 269176 */     GIR_EraseRootFromParent_Done,
     /* 269177 */   // Label 5216: @269177
     /* 269177 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(269217), // Rule ID 2496 //
     /* 269182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 269185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 269190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 269193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 269196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269204 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 269204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 269207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269215 */     GIR_RootConstrainSelectedInstOperands,
     /* 269216 */     // GIR_Coverage, 2496,
     /* 269216 */     GIR_EraseRootFromParent_Done,
     /* 269217 */   // Label 5217: @269217
     /* 269217 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(269257), // Rule ID 7041 //
     /* 269222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 269225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 269230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 269233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269244 */     // (intrinsic_w_chain:{ *:[v8f16] } 613:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 269244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 269247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269255 */     GIR_RootConstrainSelectedInstOperands,
     /* 269256 */     // GIR_Coverage, 7041,
     /* 269256 */     GIR_EraseRootFromParent_Done,
     /* 269257 */   // Label 5218: @269257
     /* 269257 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(269297), // Rule ID 7042 //
     /* 269262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 269265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 269270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 269273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 269276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269284 */     // (intrinsic_w_chain:{ *:[v8f16] } 613:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 269284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 269287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269295 */     GIR_RootConstrainSelectedInstOperands,
     /* 269296 */     // GIR_Coverage, 7042,
     /* 269296 */     GIR_EraseRootFromParent_Done,
     /* 269297 */   // Label 5219: @269297
     /* 269297 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(269333), // Rule ID 3577 //
     /* 269302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 269305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 269310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 269313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269320 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1492:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 269320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 269323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 269325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 269327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269331 */     GIR_RootConstrainSelectedInstOperands,
     /* 269332 */     // GIR_Coverage, 3577,
     /* 269332 */     GIR_EraseRootFromParent_Done,
     /* 269333 */   // Label 5220: @269333
     /* 269333 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(269371), // Rule ID 4001 //
     /* 269338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 269341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 269346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 269349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269356 */     // (intrinsic_w_chain:{ *:[i64] } 560:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 269356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 269359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 269367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 269369 */     GIR_RootConstrainSelectedInstOperands,
     /* 269370 */     // GIR_Coverage, 4001,
     /* 269370 */     GIR_EraseRootFromParent_Done,
     /* 269371 */   // Label 5221: @269371
     /* 269371 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(269407), // Rule ID 12588 //
     /* 269376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 269379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 269384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 269387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269394 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1494:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 269394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 269397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 269399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 269401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269405 */     GIR_RootConstrainSelectedInstOperands,
     /* 269406 */     // GIR_Coverage, 12588,
     /* 269406 */     GIR_EraseRootFromParent_Done,
     /* 269407 */   // Label 5222: @269407
     /* 269407 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(269443), // Rule ID 12589 //
     /* 269412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 269415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 269420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 269423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269430 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1498:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 269430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 269433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 269435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 269437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269441 */     GIR_RootConstrainSelectedInstOperands,
     /* 269442 */     // GIR_Coverage, 12589,
     /* 269442 */     GIR_EraseRootFromParent_Done,
     /* 269443 */   // Label 5223: @269443
     /* 269443 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(269479), // Rule ID 12590 //
     /* 269448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 269451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 269456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 269459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269466 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1499:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 269466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 269469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 269471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 269473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269477 */     GIR_RootConstrainSelectedInstOperands,
     /* 269478 */     // GIR_Coverage, 12590,
     /* 269478 */     GIR_EraseRootFromParent_Done,
     /* 269479 */   // Label 5224: @269479
     /* 269479 */   GIM_Reject,
     /* 269480 */ // Label 5205: @269480
     /* 269480 */ GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(273648),
     /* 269485 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 269488 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(269585), // Rule ID 7172 //
     /* 269493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 269498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 269524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 269528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 269536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269541 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 269552 */     // MIs[0] addr
     /* 269552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 269564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 269566 */     // (intrinsic_w_chain:{ *:[i32] } 1242:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 269566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 269569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 269575 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 269583 */     GIR_RootConstrainSelectedInstOperands,
     /* 269584 */     // GIR_Coverage, 7172,
     /* 269584 */     GIR_EraseRootFromParent_Done,
     /* 269585 */   // Label 5226: @269585
     /* 269585 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(269682), // Rule ID 7173 //
     /* 269590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 269595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 269621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 269625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 269633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269638 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 269649 */     // MIs[0] addr
     /* 269649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 269661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 269663 */     // (intrinsic_w_chain:{ *:[i32] } 1242:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 269663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 269666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 269672 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 269680 */     GIR_RootConstrainSelectedInstOperands,
     /* 269681 */     // GIR_Coverage, 7173,
     /* 269681 */     GIR_EraseRootFromParent_Done,
     /* 269682 */   // Label 5227: @269682
     /* 269682 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(269779), // Rule ID 7182 //
     /* 269687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 269692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 269718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 269722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 269730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269735 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 269746 */     // MIs[0] addr
     /* 269746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269754 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 269758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 269760 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 269760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 269763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 269769 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 269777 */     GIR_RootConstrainSelectedInstOperands,
     /* 269778 */     // GIR_Coverage, 7182,
     /* 269778 */     GIR_EraseRootFromParent_Done,
     /* 269779 */   // Label 5228: @269779
     /* 269779 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(269876), // Rule ID 7183 //
     /* 269784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 269789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 269815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 269819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 269827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269832 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 269843 */     // MIs[0] addr
     /* 269843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 269855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 269857 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 269857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 269860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 269866 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 269874 */     GIR_RootConstrainSelectedInstOperands,
     /* 269875 */     // GIR_Coverage, 7183,
     /* 269875 */     GIR_EraseRootFromParent_Done,
     /* 269876 */   // Label 5229: @269876
     /* 269876 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(269987), // Rule ID 7175 //
     /* 269881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 269886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 269904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 269908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 269912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269917 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 269928 */     // MIs[0] addr
     /* 269928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 269940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269942 */     // (intrinsic_w_chain:{ *:[i32] } 1242:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 269942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269954 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 269960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 269973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269978 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 269985 */     GIR_RootConstrainSelectedInstOperands,
     /* 269986 */     // GIR_Coverage, 7175,
     /* 269986 */     GIR_EraseRootFromParent_Done,
     /* 269987 */   // Label 5230: @269987
     /* 269987 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(270098), // Rule ID 7176 //
     /* 269992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 269997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 270015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 270023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270028 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 270039 */     // MIs[0] addr
     /* 270039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270047 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 270051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270053 */     // (intrinsic_w_chain:{ *:[i32] } 1242:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270065 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 270084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270089 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270096 */     GIR_RootConstrainSelectedInstOperands,
     /* 270097 */     // GIR_Coverage, 7176,
     /* 270097 */     GIR_EraseRootFromParent_Done,
     /* 270098 */   // Label 5231: @270098
     /* 270098 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(270209), // Rule ID 7177 //
     /* 270103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 270126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 270134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270139 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 270150 */     // MIs[0] addr
     /* 270150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 270162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270164 */     // (intrinsic_w_chain:{ *:[i32] } 1242:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270176 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 270195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270200 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270207 */     GIR_RootConstrainSelectedInstOperands,
     /* 270208 */     // GIR_Coverage, 7177,
     /* 270208 */     GIR_EraseRootFromParent_Done,
     /* 270209 */   // Label 5232: @270209
     /* 270209 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(270320), // Rule ID 7185 //
     /* 270214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 270237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 270245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270250 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 270261 */     // MIs[0] addr
     /* 270261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270269 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 270273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270275 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270287 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 270306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270311 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270318 */     GIR_RootConstrainSelectedInstOperands,
     /* 270319 */     // GIR_Coverage, 7185,
     /* 270319 */     GIR_EraseRootFromParent_Done,
     /* 270320 */   // Label 5233: @270320
     /* 270320 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(270431), // Rule ID 7186 //
     /* 270325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 270348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 270356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270361 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 270372 */     // MIs[0] addr
     /* 270372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270380 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 270384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270386 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270398 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 270417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270422 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270429 */     GIR_RootConstrainSelectedInstOperands,
     /* 270430 */     // GIR_Coverage, 7186,
     /* 270430 */     GIR_EraseRootFromParent_Done,
     /* 270431 */   // Label 5234: @270431
     /* 270431 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(270542), // Rule ID 7187 //
     /* 270436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 270459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 270467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270472 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 270483 */     // MIs[0] addr
     /* 270483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 270495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270497 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270509 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 270528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270533 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270540 */     GIR_RootConstrainSelectedInstOperands,
     /* 270541 */     // GIR_Coverage, 7187,
     /* 270541 */     GIR_EraseRootFromParent_Done,
     /* 270542 */   // Label 5235: @270542
     /* 270542 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(270593), // Rule ID 70 //
     /* 270547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 270552 */     // MIs[0] ptr
     /* 270552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 270556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 270560 */     // MIs[0] accessinfo
     /* 270560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 270563 */     // MIs[0] fixed_shadow
     /* 270563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270566 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 270566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 270569 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 270571 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 270573 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 270575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 270578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 270581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 270584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 270587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270591 */     GIR_RootConstrainSelectedInstOperands,
     /* 270592 */     // GIR_Coverage, 70,
     /* 270592 */     GIR_EraseRootFromParent_Done,
     /* 270593 */   // Label 5236: @270593
     /* 270593 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(270644), // Rule ID 71 //
     /* 270598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 270603 */     // MIs[0] ptr
     /* 270603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 270607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 270611 */     // MIs[0] accessinfo
     /* 270611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 270614 */     // MIs[0] fixed_shadow
     /* 270614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270617 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 270617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 270620 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 270622 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 270624 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 270626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 270629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 270632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 270635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 270638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270642 */     GIR_RootConstrainSelectedInstOperands,
     /* 270643 */     // GIR_Coverage, 71,
     /* 270643 */     GIR_EraseRootFromParent_Done,
     /* 270644 */   // Label 5237: @270644
     /* 270644 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(270713), // Rule ID 7174 //
     /* 270649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270681 */     // MIs[0] addr
     /* 270681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 270693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270695 */     // (intrinsic_w_chain:{ *:[i32] } 1242:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 270695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 270698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 270704 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270711 */     GIR_RootConstrainSelectedInstOperands,
     /* 270712 */     // GIR_Coverage, 7174,
     /* 270712 */     GIR_EraseRootFromParent_Done,
     /* 270713 */   // Label 5238: @270713
     /* 270713 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(270782), // Rule ID 7184 //
     /* 270718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270750 */     // MIs[0] addr
     /* 270750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270758 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 270762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270764 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 270764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 270767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 270773 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270780 */     GIR_RootConstrainSelectedInstOperands,
     /* 270781 */     // GIR_Coverage, 7184,
     /* 270781 */     GIR_EraseRootFromParent_Done,
     /* 270782 */   // Label 5239: @270782
     /* 270782 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(270824), // Rule ID 3601 //
     /* 270787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 270790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 270795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 270798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 270801 */     // MIs[0] tile
     /* 270801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 270809 */     // (intrinsic_void 1016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 270809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 270812 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270822 */     GIR_RootConstrainSelectedInstOperands,
     /* 270823 */     // GIR_Coverage, 3601,
     /* 270823 */     GIR_EraseRootFromParent_Done,
     /* 270824 */   // Label 5240: @270824
     /* 270824 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(270866), // Rule ID 3605 //
     /* 270829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 270832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 270837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 270840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 270843 */     // MIs[0] tile
     /* 270843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 270851 */     // (intrinsic_void 1016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 270851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 270854 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270864 */     GIR_RootConstrainSelectedInstOperands,
     /* 270865 */     // GIR_Coverage, 3605,
     /* 270865 */     GIR_EraseRootFromParent_Done,
     /* 270866 */   // Label 5241: @270866
     /* 270866 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(270908), // Rule ID 3609 //
     /* 270871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 270874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 270879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 270882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 270885 */     // MIs[0] tile
     /* 270885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270888 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 270893 */     // (intrinsic_void 1020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 270893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 270896 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270906 */     GIR_RootConstrainSelectedInstOperands,
     /* 270907 */     // GIR_Coverage, 3609,
     /* 270907 */     GIR_EraseRootFromParent_Done,
     /* 270908 */   // Label 5242: @270908
     /* 270908 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(270950), // Rule ID 3779 //
     /* 270913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 270916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 270921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 270924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 270927 */     // MIs[0] tile
     /* 270927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270930 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 270935 */     // (intrinsic_void 913:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 270935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 270938 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270948 */     GIR_RootConstrainSelectedInstOperands,
     /* 270949 */     // GIR_Coverage, 3779,
     /* 270949 */     GIR_EraseRootFromParent_Done,
     /* 270950 */   // Label 5243: @270950
     /* 270950 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(270992), // Rule ID 3783 //
     /* 270955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32_HasSME_MOP4),
     /* 270958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za32_1x1),
     /* 270963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 270966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 270969 */     // MIs[0] tile
     /* 270969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 270977 */     // (intrinsic_void 876:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 270977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoS_PSEUDO),
     /* 270980 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270990 */     GIR_RootConstrainSelectedInstOperands,
     /* 270991 */     // GIR_Coverage, 3783,
     /* 270991 */     GIR_EraseRootFromParent_Done,
     /* 270992 */   // Label 5244: @270992
     /* 270992 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(271034), // Rule ID 3787 //
     /* 270997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 271005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 271008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 271011 */     // MIs[0] tile
     /* 271011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271019 */     // (intrinsic_void 913:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 271019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 271022 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271032 */     GIR_RootConstrainSelectedInstOperands,
     /* 271033 */     // GIR_Coverage, 3787,
     /* 271033 */     GIR_EraseRootFromParent_Done,
     /* 271034 */   // Label 5245: @271034
     /* 271034 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(271076), // Rule ID 3791 //
     /* 271039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 271042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 271047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 271050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271053 */     // MIs[0] tile
     /* 271053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271056 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271061 */     // (intrinsic_void 913:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 271061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 271064 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271074 */     GIR_RootConstrainSelectedInstOperands,
     /* 271075 */     // GIR_Coverage, 3791,
     /* 271075 */     GIR_EraseRootFromParent_Done,
     /* 271076 */   // Label 5246: @271076
     /* 271076 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(271118), // Rule ID 3795 //
     /* 271081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 271089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271095 */     // MIs[0] tile
     /* 271095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271098 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271103 */     // (intrinsic_void 917:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 271103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 271106 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271116 */     GIR_RootConstrainSelectedInstOperands,
     /* 271117 */     // GIR_Coverage, 3795,
     /* 271117 */     GIR_EraseRootFromParent_Done,
     /* 271118 */   // Label 5247: @271118
     /* 271118 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(271160), // Rule ID 3799 //
     /* 271123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16_HasSME_MOP4),
     /* 271126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za16_1x1),
     /* 271131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271137 */     // MIs[0] tile
     /* 271137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271140 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 271145 */     // (intrinsic_void 872:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoH_PSEUDO),
     /* 271148 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271158 */     GIR_RootConstrainSelectedInstOperands,
     /* 271159 */     // GIR_Coverage, 3799,
     /* 271159 */     GIR_EraseRootFromParent_Done,
     /* 271160 */   // Label 5248: @271160
     /* 271160 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(271202), // Rule ID 12667 //
     /* 271165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 271173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271179 */     // MIs[0] tile
     /* 271179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271187 */     // (intrinsic_void 1024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 271190 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271200 */     GIR_RootConstrainSelectedInstOperands,
     /* 271201 */     // GIR_Coverage, 12667,
     /* 271201 */     GIR_EraseRootFromParent_Done,
     /* 271202 */   // Label 5249: @271202
     /* 271202 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(271244), // Rule ID 12671 //
     /* 271207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 271215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271221 */     // MIs[0] tile
     /* 271221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271224 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271229 */     // (intrinsic_void 1068:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 271232 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271242 */     GIR_RootConstrainSelectedInstOperands,
     /* 271243 */     // GIR_Coverage, 12671,
     /* 271243 */     GIR_EraseRootFromParent_Done,
     /* 271244 */   // Label 5250: @271244
     /* 271244 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(271286), // Rule ID 12675 //
     /* 271249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 271257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271263 */     // MIs[0] tile
     /* 271263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271271 */     // (intrinsic_void 1076:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 271274 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271284 */     GIR_RootConstrainSelectedInstOperands,
     /* 271285 */     // GIR_Coverage, 12675,
     /* 271285 */     GIR_EraseRootFromParent_Done,
     /* 271286 */   // Label 5251: @271286
     /* 271286 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(271328), // Rule ID 12679 //
     /* 271291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 271299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271305 */     // MIs[0] tile
     /* 271305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271308 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271313 */     // (intrinsic_void 1185:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 271316 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271326 */     GIR_RootConstrainSelectedInstOperands,
     /* 271327 */     // GIR_Coverage, 12679,
     /* 271327 */     GIR_EraseRootFromParent_Done,
     /* 271328 */   // Label 5252: @271328
     /* 271328 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(271370), // Rule ID 12683 //
     /* 271333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 271341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271347 */     // MIs[0] tile
     /* 271347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271355 */     // (intrinsic_void 1193:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 271358 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271368 */     GIR_RootConstrainSelectedInstOperands,
     /* 271369 */     // GIR_Coverage, 12683,
     /* 271369 */     GIR_EraseRootFromParent_Done,
     /* 271370 */   // Label 5253: @271370
     /* 271370 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(271412), // Rule ID 12687 //
     /* 271375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 271383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271389 */     // MIs[0] tile
     /* 271389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271392 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271397 */     // (intrinsic_void 1151:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 271400 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271410 */     GIR_RootConstrainSelectedInstOperands,
     /* 271411 */     // GIR_Coverage, 12687,
     /* 271411 */     GIR_EraseRootFromParent_Done,
     /* 271412 */   // Label 5254: @271412
     /* 271412 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(271454), // Rule ID 12691 //
     /* 271417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 271425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271431 */     // MIs[0] tile
     /* 271431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271439 */     // (intrinsic_void 1159:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 271442 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271452 */     GIR_RootConstrainSelectedInstOperands,
     /* 271453 */     // GIR_Coverage, 12691,
     /* 271453 */     GIR_EraseRootFromParent_Done,
     /* 271454 */   // Label 5255: @271454
     /* 271454 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(271496), // Rule ID 12695 //
     /* 271459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 271467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271473 */     // MIs[0] tile
     /* 271473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271476 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271481 */     // (intrinsic_void 1024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 271484 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271494 */     GIR_RootConstrainSelectedInstOperands,
     /* 271495 */     // GIR_Coverage, 12695,
     /* 271495 */     GIR_EraseRootFromParent_Done,
     /* 271496 */   // Label 5256: @271496
     /* 271496 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(271538), // Rule ID 12699 //
     /* 271501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 271509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271515 */     // MIs[0] tile
     /* 271515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271523 */     // (intrinsic_void 1151:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 271526 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271536 */     GIR_RootConstrainSelectedInstOperands,
     /* 271537 */     // GIR_Coverage, 12699,
     /* 271537 */     GIR_EraseRootFromParent_Done,
     /* 271538 */   // Label 5257: @271538
     /* 271538 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(271580), // Rule ID 12703 //
     /* 271543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 271551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271557 */     // MIs[0] tile
     /* 271557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271560 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271565 */     // (intrinsic_void 1159:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 271568 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271578 */     GIR_RootConstrainSelectedInstOperands,
     /* 271579 */     // GIR_Coverage, 12703,
     /* 271579 */     GIR_EraseRootFromParent_Done,
     /* 271580 */   // Label 5258: @271580
     /* 271580 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(271622), // Rule ID 12707 //
     /* 271585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 271588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 271593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271599 */     // MIs[0] tile
     /* 271599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271602 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271607 */     // (intrinsic_void 1028:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 271610 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271620 */     GIR_RootConstrainSelectedInstOperands,
     /* 271621 */     // GIR_Coverage, 12707,
     /* 271621 */     GIR_EraseRootFromParent_Done,
     /* 271622 */   // Label 5259: @271622
     /* 271622 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(271664), // Rule ID 12711 //
     /* 271627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 271630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 271635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271641 */     // MIs[0] tile
     /* 271641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271649 */     // (intrinsic_void 1072:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 271652 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271662 */     GIR_RootConstrainSelectedInstOperands,
     /* 271663 */     // GIR_Coverage, 12711,
     /* 271663 */     GIR_EraseRootFromParent_Done,
     /* 271664 */   // Label 5260: @271664
     /* 271664 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(271706), // Rule ID 12715 //
     /* 271669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 271672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 271677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271683 */     // MIs[0] tile
     /* 271683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271691 */     // (intrinsic_void 1080:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 271694 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271704 */     GIR_RootConstrainSelectedInstOperands,
     /* 271705 */     // GIR_Coverage, 12715,
     /* 271705 */     GIR_EraseRootFromParent_Done,
     /* 271706 */   // Label 5261: @271706
     /* 271706 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(271748), // Rule ID 12719 //
     /* 271711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 271714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 271719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271725 */     // MIs[0] tile
     /* 271725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271728 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271733 */     // (intrinsic_void 1155:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 271736 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271746 */     GIR_RootConstrainSelectedInstOperands,
     /* 271747 */     // GIR_Coverage, 12719,
     /* 271747 */     GIR_EraseRootFromParent_Done,
     /* 271748 */   // Label 5262: @271748
     /* 271748 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(271790), // Rule ID 12723 //
     /* 271753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 271756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 271761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271767 */     // MIs[0] tile
     /* 271767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271775 */     // (intrinsic_void 1163:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 271778 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271788 */     GIR_RootConstrainSelectedInstOperands,
     /* 271789 */     // GIR_Coverage, 12723,
     /* 271789 */     GIR_EraseRootFromParent_Done,
     /* 271790 */   // Label 5263: @271790
     /* 271790 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(271832), // Rule ID 12727 //
     /* 271795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 271798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 271803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271809 */     // MIs[0] tile
     /* 271809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271817 */     // (intrinsic_void 1189:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 271820 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271830 */     GIR_RootConstrainSelectedInstOperands,
     /* 271831 */     // GIR_Coverage, 12727,
     /* 271831 */     GIR_EraseRootFromParent_Done,
     /* 271832 */   // Label 5264: @271832
     /* 271832 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(271874), // Rule ID 12731 //
     /* 271837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 271840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 271845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271851 */     // MIs[0] tile
     /* 271851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271859 */     // (intrinsic_void 1197:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 271862 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271872 */     GIR_RootConstrainSelectedInstOperands,
     /* 271873 */     // GIR_Coverage, 12731,
     /* 271873 */     GIR_EraseRootFromParent_Done,
     /* 271874 */   // Label 5265: @271874
     /* 271874 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(271916), // Rule ID 13186 //
     /* 271879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 271887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271893 */     // MIs[0] tile
     /* 271893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271896 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271901 */     // (intrinsic_void 925:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 271901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 271904 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271914 */     GIR_RootConstrainSelectedInstOperands,
     /* 271915 */     // GIR_Coverage, 13186,
     /* 271915 */     GIR_EraseRootFromParent_Done,
     /* 271916 */   // Label 5266: @271916
     /* 271916 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(271958), // Rule ID 13190 //
     /* 271921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 271929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 271932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 271935 */     // MIs[0] tile
     /* 271935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271938 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271943 */     // (intrinsic_void 921:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 271943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 271946 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271956 */     GIR_RootConstrainSelectedInstOperands,
     /* 271957 */     // GIR_Coverage, 13190,
     /* 271957 */     GIR_EraseRootFromParent_Done,
     /* 271958 */   // Label 5267: @271958
     /* 271958 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(272000), // Rule ID 13194 //
     /* 271963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 271966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 271971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271977 */     // MIs[0] tile
     /* 271977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 271985 */     // (intrinsic_void 921:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 271985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 271988 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271998 */     GIR_RootConstrainSelectedInstOperands,
     /* 271999 */     // GIR_Coverage, 13194,
     /* 271999 */     GIR_EraseRootFromParent_Done,
     /* 272000 */   // Label 5268: @272000
     /* 272000 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(272042), // Rule ID 13198 //
     /* 272005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 272008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 272013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 272016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272019 */     // MIs[0] tile
     /* 272019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 272022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 272027 */     // (intrinsic_void 921:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 272027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 272030 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 272032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 272034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272040 */     GIR_RootConstrainSelectedInstOperands,
     /* 272041 */     // GIR_Coverage, 13198,
     /* 272041 */     GIR_EraseRootFromParent_Done,
     /* 272042 */   // Label 5269: @272042
     /* 272042 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(272096), // Rule ID 8921 //
     /* 272047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 272055 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 272058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272062 */     // MIs[0] base
     /* 272062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272070 */     // MIs[0] prfop
     /* 272070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 272073 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272078 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 272078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 272081 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 272083 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 272085 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 272087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 272090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272094 */     GIR_RootConstrainSelectedInstOperands,
     /* 272095 */     // GIR_Coverage, 8921,
     /* 272095 */     GIR_EraseRootFromParent_Done,
     /* 272096 */   // Label 5270: @272096
     /* 272096 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(272150), // Rule ID 8924 //
     /* 272101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 272109 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 272112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272116 */     // MIs[0] base
     /* 272116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272124 */     // MIs[0] prfop
     /* 272124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 272127 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272132 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 272132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 272135 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 272137 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 272139 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 272141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 272144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272148 */     GIR_RootConstrainSelectedInstOperands,
     /* 272149 */     // GIR_Coverage, 8924,
     /* 272149 */     GIR_EraseRootFromParent_Done,
     /* 272150 */   // Label 5271: @272150
     /* 272150 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(272204), // Rule ID 8927 //
     /* 272155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 272163 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272170 */     // MIs[0] base
     /* 272170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272178 */     // MIs[0] prfop
     /* 272178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 272181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272186 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 272186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 272189 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 272191 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 272193 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 272195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 272198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272202 */     GIR_RootConstrainSelectedInstOperands,
     /* 272203 */     // GIR_Coverage, 8927,
     /* 272203 */     GIR_EraseRootFromParent_Done,
     /* 272204 */   // Label 5272: @272204
     /* 272204 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(272258), // Rule ID 8930 //
     /* 272209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 272217 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272224 */     // MIs[0] base
     /* 272224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272232 */     // MIs[0] prfop
     /* 272232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 272235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272240 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 272240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 272243 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 272245 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 272247 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 272249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 272252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272256 */     GIR_RootConstrainSelectedInstOperands,
     /* 272257 */     // GIR_Coverage, 8930,
     /* 272257 */     GIR_EraseRootFromParent_Done,
     /* 272258 */   // Label 5273: @272258
     /* 272258 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(272312), // Rule ID 15 //
     /* 272263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 272268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 272271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 272274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 272277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272289 */     // MIs[1] Operand 1
     /* 272289 */     // No operand predicates
     /* 272289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272295 */     // (intrinsic_w_chain:{ *:[i64] } 1233:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 272295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 272298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 272303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 272310 */     GIR_RootConstrainSelectedInstOperands,
     /* 272311 */     // GIR_Coverage, 15,
     /* 272311 */     GIR_EraseRootFromParent_Done,
     /* 272312 */   // Label 5274: @272312
     /* 272312 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(272380), // Rule ID 68 //
     /* 272317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 272322 */     // MIs[0] Operand 1
     /* 272322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 272326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 272330 */     // MIs[0] ptr
     /* 272330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 272338 */     // MIs[0] accessinfo
     /* 272338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 272341 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 272341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272345 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 272355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 272358 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 272360 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 272362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 272365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 272368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 272371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 272374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272378 */     GIR_RootConstrainSelectedInstOperands,
     /* 272379 */     // GIR_Coverage, 68,
     /* 272379 */     GIR_EraseRootFromParent_Done,
     /* 272380 */   // Label 5275: @272380
     /* 272380 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(272448), // Rule ID 69 //
     /* 272385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 272390 */     // MIs[0] Operand 1
     /* 272390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 272394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 272398 */     // MIs[0] ptr
     /* 272398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 272406 */     // MIs[0] accessinfo
     /* 272406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 272409 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 272409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272413 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 272423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 272426 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 272428 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 272430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 272433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 272436 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 272439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 272442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272446 */     GIR_RootConstrainSelectedInstOperands,
     /* 272447 */     // GIR_Coverage, 69,
     /* 272447 */     GIR_EraseRootFromParent_Done,
     /* 272448 */   // Label 5276: @272448
     /* 272448 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(272528), // Rule ID 7168 //
     /* 272453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 272458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272472 */     // MIs[0] addr
     /* 272472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 272476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272480 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 272484 */     // (intrinsic_w_chain:{ *:[i32] } 1242:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 272484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 272487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272496 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 272502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 272515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272520 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 272522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272526 */     GIR_RootConstrainSelectedInstOperands,
     /* 272527 */     // GIR_Coverage, 7168,
     /* 272527 */     GIR_EraseRootFromParent_Done,
     /* 272528 */   // Label 5277: @272528
     /* 272528 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(272608), // Rule ID 7169 //
     /* 272533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 272538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272552 */     // MIs[0] addr
     /* 272552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 272556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 272564 */     // (intrinsic_w_chain:{ *:[i32] } 1242:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 272564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 272567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272576 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 272582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 272595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272600 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 272602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272606 */     GIR_RootConstrainSelectedInstOperands,
     /* 272607 */     // GIR_Coverage, 7169,
     /* 272607 */     GIR_EraseRootFromParent_Done,
     /* 272608 */   // Label 5278: @272608
     /* 272608 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(272688), // Rule ID 7170 //
     /* 272613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 272618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272632 */     // MIs[0] addr
     /* 272632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 272636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 272644 */     // (intrinsic_w_chain:{ *:[i32] } 1242:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 272644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 272647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272656 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 272662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 272675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272680 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 272682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272686 */     GIR_RootConstrainSelectedInstOperands,
     /* 272687 */     // GIR_Coverage, 7170,
     /* 272687 */     GIR_EraseRootFromParent_Done,
     /* 272688 */   // Label 5279: @272688
     /* 272688 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(272739), // Rule ID 7171 //
     /* 272693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 272698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272712 */     // MIs[0] addr
     /* 272712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 272716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272720 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 272724 */     // (intrinsic_w_chain:{ *:[i32] } 1242:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 272724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 272727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272729 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 272731 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 272733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272737 */     GIR_RootConstrainSelectedInstOperands,
     /* 272738 */     // GIR_Coverage, 7171,
     /* 272738 */     GIR_EraseRootFromParent_Done,
     /* 272739 */   // Label 5280: @272739
     /* 272739 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(272819), // Rule ID 7178 //
     /* 272744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 272749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272763 */     // MIs[0] addr
     /* 272763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 272767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272771 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 272775 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 272775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 272778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272787 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 272793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 272806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272811 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 272813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272817 */     GIR_RootConstrainSelectedInstOperands,
     /* 272818 */     // GIR_Coverage, 7178,
     /* 272818 */     GIR_EraseRootFromParent_Done,
     /* 272819 */   // Label 5281: @272819
     /* 272819 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(272899), // Rule ID 7179 //
     /* 272824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 272829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272843 */     // MIs[0] addr
     /* 272843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 272847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 272855 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 272855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 272858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272867 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 272873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 272886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272891 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 272893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272897 */     GIR_RootConstrainSelectedInstOperands,
     /* 272898 */     // GIR_Coverage, 7179,
     /* 272898 */     GIR_EraseRootFromParent_Done,
     /* 272899 */   // Label 5282: @272899
     /* 272899 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(272979), // Rule ID 7180 //
     /* 272904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 272909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272923 */     // MIs[0] addr
     /* 272923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 272927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272931 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 272935 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 272935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 272938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272947 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 272953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 272966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272971 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 272973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272977 */     GIR_RootConstrainSelectedInstOperands,
     /* 272978 */     // GIR_Coverage, 7180,
     /* 272978 */     GIR_EraseRootFromParent_Done,
     /* 272979 */   // Label 5283: @272979
     /* 272979 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(273030), // Rule ID 7181 //
     /* 272984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 272989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273003 */     // MIs[0] addr
     /* 273003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273011 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 273015 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 273015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 273018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 273020 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 273022 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 273024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273028 */     GIR_RootConstrainSelectedInstOperands,
     /* 273029 */     // GIR_Coverage, 7181,
     /* 273029 */     GIR_EraseRootFromParent_Done,
     /* 273030 */   // Label 5284: @273030
     /* 273030 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(273079), // Rule ID 2488 //
     /* 273035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 273038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 273043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 273046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 273049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 273052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273064 */     // (intrinsic_w_chain:{ *:[v8i8] } 614:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 273064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 273067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273077 */     GIR_RootConstrainSelectedInstOperands,
     /* 273078 */     // GIR_Coverage, 2488,
     /* 273078 */     GIR_EraseRootFromParent_Done,
     /* 273079 */   // Label 5285: @273079
     /* 273079 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(273128), // Rule ID 2489 //
     /* 273084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 273087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 273092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 273095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 273101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273113 */     // (intrinsic_w_chain:{ *:[v16i8] } 614:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 273113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 273116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273126 */     GIR_RootConstrainSelectedInstOperands,
     /* 273127 */     // GIR_Coverage, 2489,
     /* 273127 */     GIR_EraseRootFromParent_Done,
     /* 273128 */   // Label 5286: @273128
     /* 273128 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(273177), // Rule ID 2490 //
     /* 273133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 273136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 273141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 273144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273162 */     // (intrinsic_w_chain:{ *:[v8i8] } 614:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 273162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 273165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273175 */     GIR_RootConstrainSelectedInstOperands,
     /* 273176 */     // GIR_Coverage, 2490,
     /* 273176 */     GIR_EraseRootFromParent_Done,
     /* 273177 */   // Label 5287: @273177
     /* 273177 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(273230), // Rule ID 8807 //
     /* 273182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 273190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 273193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273204 */     // MIs[0] base
     /* 273204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273212 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1568:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 273215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 273217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273219 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273228 */     GIR_RootConstrainSelectedInstOperands,
     /* 273229 */     // GIR_Coverage, 8807,
     /* 273229 */     GIR_EraseRootFromParent_Done,
     /* 273230 */   // Label 5288: @273230
     /* 273230 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(273283), // Rule ID 8810 //
     /* 273235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 273243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 273246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273257 */     // MIs[0] base
     /* 273257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273265 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1568:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 273268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 273270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273272 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273281 */     GIR_RootConstrainSelectedInstOperands,
     /* 273282 */     // GIR_Coverage, 8810,
     /* 273282 */     GIR_EraseRootFromParent_Done,
     /* 273283 */   // Label 5289: @273283
     /* 273283 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(273336), // Rule ID 8819 //
     /* 273288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 273296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 273299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273310 */     // MIs[0] base
     /* 273310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273318 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1567:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 273321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 273323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273325 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273334 */     GIR_RootConstrainSelectedInstOperands,
     /* 273335 */     // GIR_Coverage, 8819,
     /* 273335 */     GIR_EraseRootFromParent_Done,
     /* 273336 */   // Label 5290: @273336
     /* 273336 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(273389), // Rule ID 8822 //
     /* 273341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 273349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 273352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273363 */     // MIs[0] base
     /* 273363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273371 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1567:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 273374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 273376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273378 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273387 */     GIR_RootConstrainSelectedInstOperands,
     /* 273388 */     // GIR_Coverage, 8822,
     /* 273388 */     GIR_EraseRootFromParent_Done,
     /* 273389 */   // Label 5291: @273389
     /* 273389 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(273435), // Rule ID 137 //
     /* 273394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 273397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 273402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 273405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273412 */     // MIs[0] Rn
     /* 273412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273424 */     // (intrinsic_w_chain:{ *:[i64] } 559:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 273424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 273427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273433 */     GIR_RootConstrainSelectedInstOperands,
     /* 273434 */     // GIR_Coverage, 137,
     /* 273434 */     GIR_EraseRootFromParent_Done,
     /* 273435 */   // Label 5292: @273435
     /* 273435 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(273488), // Rule ID 8813 //
     /* 273440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 273448 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 273451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273462 */     // MIs[0] base
     /* 273462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273470 */     // (intrinsic_void 1888:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 273473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 273475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273477 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273486 */     GIR_RootConstrainSelectedInstOperands,
     /* 273487 */     // GIR_Coverage, 8813,
     /* 273487 */     GIR_EraseRootFromParent_Done,
     /* 273488 */   // Label 5293: @273488
     /* 273488 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(273541), // Rule ID 8816 //
     /* 273493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 273501 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 273504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273515 */     // MIs[0] base
     /* 273515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273523 */     // (intrinsic_void 1888:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 273526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 273528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273530 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273539 */     GIR_RootConstrainSelectedInstOperands,
     /* 273540 */     // GIR_Coverage, 8816,
     /* 273540 */     GIR_EraseRootFromParent_Done,
     /* 273541 */   // Label 5294: @273541
     /* 273541 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(273594), // Rule ID 8825 //
     /* 273546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 273554 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 273557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273568 */     // MIs[0] base
     /* 273568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273576 */     // (intrinsic_void 1884:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 273579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 273581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273583 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273592 */     GIR_RootConstrainSelectedInstOperands,
     /* 273593 */     // GIR_Coverage, 8825,
     /* 273593 */     GIR_EraseRootFromParent_Done,
     /* 273594 */   // Label 5295: @273594
     /* 273594 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(273647), // Rule ID 8828 //
     /* 273599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 273607 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 273610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273621 */     // MIs[0] base
     /* 273621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273629 */     // (intrinsic_void 1884:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 273632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 273634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273636 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273645 */     GIR_RootConstrainSelectedInstOperands,
     /* 273646 */     // GIR_Coverage, 8828,
     /* 273646 */     GIR_EraseRootFromParent_Done,
     /* 273647 */   // Label 5296: @273647
     /* 273647 */   GIM_Reject,
     /* 273648 */ // Label 5225: @273648
     /* 273648 */ GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(276353),
     /* 273653 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 273656 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(273727), // Rule ID 3413 //
     /* 273661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 273669 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 273672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 273675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 273698 */     // MIs[1] Operand 1
     /* 273698 */     // No operand predicates
     /* 273698 */     // MIs[0] prfop
     /* 273698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273701 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273708 */     // (intrinsic_void 1637:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 273708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 273711 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 273717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 273720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 273725 */     GIR_RootConstrainSelectedInstOperands,
     /* 273726 */     // GIR_Coverage, 3413,
     /* 273726 */     GIR_EraseRootFromParent_Done,
     /* 273727 */   // Label 5298: @273727
     /* 273727 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(273798), // Rule ID 3426 //
     /* 273732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 273740 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 273746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 273769 */     // MIs[1] Operand 1
     /* 273769 */     // No operand predicates
     /* 273769 */     // MIs[0] prfop
     /* 273769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273779 */     // (intrinsic_void 1637:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 273779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 273782 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 273788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 273791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 273796 */     GIR_RootConstrainSelectedInstOperands,
     /* 273797 */     // GIR_Coverage, 3426,
     /* 273797 */     GIR_EraseRootFromParent_Done,
     /* 273798 */   // Label 5299: @273798
     /* 273798 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(273857), // Rule ID 3613 //
     /* 273803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 273806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 273811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 273814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 273817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 273820 */     // MIs[0] tile
     /* 273820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273823 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 273828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273840 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 273840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 273843 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273845 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 273847 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 273849 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 273851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273855 */     GIR_RootConstrainSelectedInstOperands,
     /* 273856 */     // GIR_Coverage, 3613,
     /* 273856 */     GIR_EraseRootFromParent_Done,
     /* 273857 */   // Label 5300: @273857
     /* 273857 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(273916), // Rule ID 3614 //
     /* 273862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 273865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 273870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 273873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 273876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 273879 */     // MIs[0] tile
     /* 273879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 273887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273899 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 273899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 273902 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273904 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 273906 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 273908 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 273910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273914 */     GIR_RootConstrainSelectedInstOperands,
     /* 273915 */     // GIR_Coverage, 3614,
     /* 273915 */     GIR_EraseRootFromParent_Done,
     /* 273916 */   // Label 5301: @273916
     /* 273916 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(273975), // Rule ID 12648 //
     /* 273921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 273924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 273929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 273932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 273935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 273938 */     // MIs[0] tile
     /* 273938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 273946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273958 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 273958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 273961 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273963 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 273965 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 273967 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 273969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273973 */     GIR_RootConstrainSelectedInstOperands,
     /* 273974 */     // GIR_Coverage, 12648,
     /* 273974 */     GIR_EraseRootFromParent_Done,
     /* 273975 */   // Label 5302: @273975
     /* 273975 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(274034), // Rule ID 12649 //
     /* 273980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 273983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 273988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 273991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 273994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 273997 */     // MIs[0] tile
     /* 273997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274000 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274017 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 274017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 274020 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274022 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 274024 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 274026 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 274028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274032 */     GIR_RootConstrainSelectedInstOperands,
     /* 274033 */     // GIR_Coverage, 12649,
     /* 274033 */     GIR_EraseRootFromParent_Done,
     /* 274034 */   // Label 5303: @274034
     /* 274034 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(274094), // Rule ID 3411 //
     /* 274039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 274047 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274057 */     // MIs[0] Rn
     /* 274057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274069 */     // MIs[0] prfop
     /* 274069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274077 */     // (intrinsic_void 1639:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 274077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 274080 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274092 */     GIR_RootConstrainSelectedInstOperands,
     /* 274093 */     // GIR_Coverage, 3411,
     /* 274093 */     GIR_EraseRootFromParent_Done,
     /* 274094 */   // Label 5304: @274094
     /* 274094 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(274154), // Rule ID 3412 //
     /* 274099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 274107 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274117 */     // MIs[0] Rn
     /* 274117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274129 */     // MIs[0] prfop
     /* 274129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274132 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274137 */     // (intrinsic_void 1638:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 274137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 274140 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274152 */     GIR_RootConstrainSelectedInstOperands,
     /* 274153 */     // GIR_Coverage, 3412,
     /* 274153 */     GIR_EraseRootFromParent_Done,
     /* 274154 */   // Label 5305: @274154
     /* 274154 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(274214), // Rule ID 3423 //
     /* 274159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 274167 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 274170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 274173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274177 */     // MIs[0] Rn
     /* 274177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274189 */     // MIs[0] prfop
     /* 274189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274192 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274197 */     // (intrinsic_void 1639:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 274197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 274200 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274212 */     GIR_RootConstrainSelectedInstOperands,
     /* 274213 */     // GIR_Coverage, 3423,
     /* 274213 */     GIR_EraseRootFromParent_Done,
     /* 274214 */   // Label 5306: @274214
     /* 274214 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(274274), // Rule ID 3424 //
     /* 274219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 274227 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 274230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 274233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274237 */     // MIs[0] Rn
     /* 274237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274249 */     // MIs[0] prfop
     /* 274249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274257 */     // (intrinsic_void 1638:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 274257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 274260 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274272 */     GIR_RootConstrainSelectedInstOperands,
     /* 274273 */     // GIR_Coverage, 3424,
     /* 274273 */     GIR_EraseRootFromParent_Done,
     /* 274274 */   // Label 5307: @274274
     /* 274274 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(274334), // Rule ID 3425 //
     /* 274279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 274287 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 274290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 274293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274297 */     // MIs[0] Rn
     /* 274297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274309 */     // MIs[0] prfop
     /* 274309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274312 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274317 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 274317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 274320 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274332 */     GIR_RootConstrainSelectedInstOperands,
     /* 274333 */     // GIR_Coverage, 3425,
     /* 274333 */     GIR_EraseRootFromParent_Done,
     /* 274334 */   // Label 5308: @274334
     /* 274334 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(274394), // Rule ID 8933 //
     /* 274339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 274347 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274357 */     // MIs[0] Rn
     /* 274357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274369 */     // MIs[0] prfop
     /* 274369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274377 */     // (intrinsic_void 1647:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 274377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 274380 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274392 */     GIR_RootConstrainSelectedInstOperands,
     /* 274393 */     // GIR_Coverage, 8933,
     /* 274393 */     GIR_EraseRootFromParent_Done,
     /* 274394 */   // Label 5309: @274394
     /* 274394 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(274454), // Rule ID 8934 //
     /* 274399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 274407 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274417 */     // MIs[0] Rn
     /* 274417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274429 */     // MIs[0] prfop
     /* 274429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274437 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 274437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 274440 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274452 */     GIR_RootConstrainSelectedInstOperands,
     /* 274453 */     // GIR_Coverage, 8934,
     /* 274453 */     GIR_EraseRootFromParent_Done,
     /* 274454 */   // Label 5310: @274454
     /* 274454 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(274514), // Rule ID 8935 //
     /* 274459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 274467 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274477 */     // MIs[0] Rn
     /* 274477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274489 */     // MIs[0] prfop
     /* 274489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274497 */     // (intrinsic_void 1651:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 274497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 274500 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274512 */     GIR_RootConstrainSelectedInstOperands,
     /* 274513 */     // GIR_Coverage, 8935,
     /* 274513 */     GIR_EraseRootFromParent_Done,
     /* 274514 */   // Label 5311: @274514
     /* 274514 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(274574), // Rule ID 8936 //
     /* 274519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 274527 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274537 */     // MIs[0] Rn
     /* 274537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274549 */     // MIs[0] prfop
     /* 274549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274557 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 274557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 274560 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274572 */     GIR_RootConstrainSelectedInstOperands,
     /* 274573 */     // GIR_Coverage, 8936,
     /* 274573 */     GIR_EraseRootFromParent_Done,
     /* 274574 */   // Label 5312: @274574
     /* 274574 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(274634), // Rule ID 8937 //
     /* 274579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 274587 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274597 */     // MIs[0] Rn
     /* 274597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274609 */     // MIs[0] prfop
     /* 274609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274617 */     // (intrinsic_void 1643:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 274617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 274620 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274632 */     GIR_RootConstrainSelectedInstOperands,
     /* 274633 */     // GIR_Coverage, 8937,
     /* 274633 */     GIR_EraseRootFromParent_Done,
     /* 274634 */   // Label 5313: @274634
     /* 274634 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(274694), // Rule ID 8938 //
     /* 274639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 274647 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274657 */     // MIs[0] Rn
     /* 274657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274669 */     // MIs[0] prfop
     /* 274669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274677 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 274677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 274680 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274682 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274692 */     GIR_RootConstrainSelectedInstOperands,
     /* 274693 */     // GIR_Coverage, 8938,
     /* 274693 */     GIR_EraseRootFromParent_Done,
     /* 274694 */   // Label 5314: @274694
     /* 274694 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(274754), // Rule ID 8939 //
     /* 274699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 274707 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 274710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 274713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274717 */     // MIs[0] Rn
     /* 274717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274729 */     // MIs[0] prfop
     /* 274729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274737 */     // (intrinsic_void 1647:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 274737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 274740 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274752 */     GIR_RootConstrainSelectedInstOperands,
     /* 274753 */     // GIR_Coverage, 8939,
     /* 274753 */     GIR_EraseRootFromParent_Done,
     /* 274754 */   // Label 5315: @274754
     /* 274754 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(274814), // Rule ID 8940 //
     /* 274759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 274767 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 274770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 274773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274777 */     // MIs[0] Rn
     /* 274777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274789 */     // MIs[0] prfop
     /* 274789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274792 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274797 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 274797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 274800 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274812 */     GIR_RootConstrainSelectedInstOperands,
     /* 274813 */     // GIR_Coverage, 8940,
     /* 274813 */     GIR_EraseRootFromParent_Done,
     /* 274814 */   // Label 5316: @274814
     /* 274814 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(274874), // Rule ID 8941 //
     /* 274819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 274827 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 274830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 274833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274837 */     // MIs[0] Rn
     /* 274837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274849 */     // MIs[0] prfop
     /* 274849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274857 */     // (intrinsic_void 1651:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 274857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 274860 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274872 */     GIR_RootConstrainSelectedInstOperands,
     /* 274873 */     // GIR_Coverage, 8941,
     /* 274873 */     GIR_EraseRootFromParent_Done,
     /* 274874 */   // Label 5317: @274874
     /* 274874 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(274934), // Rule ID 8942 //
     /* 274879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 274887 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 274890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 274893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274897 */     // MIs[0] Rn
     /* 274897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274909 */     // MIs[0] prfop
     /* 274909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274912 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274917 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 274917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 274920 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274932 */     GIR_RootConstrainSelectedInstOperands,
     /* 274933 */     // GIR_Coverage, 8942,
     /* 274933 */     GIR_EraseRootFromParent_Done,
     /* 274934 */   // Label 5318: @274934
     /* 274934 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(274994), // Rule ID 8943 //
     /* 274939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 274947 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 274950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 274953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274957 */     // MIs[0] Rn
     /* 274957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274969 */     // MIs[0] prfop
     /* 274969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274977 */     // (intrinsic_void 1643:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 274977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 274980 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274992 */     GIR_RootConstrainSelectedInstOperands,
     /* 274993 */     // GIR_Coverage, 8943,
     /* 274993 */     GIR_EraseRootFromParent_Done,
     /* 274994 */   // Label 5319: @274994
     /* 274994 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(275054), // Rule ID 8944 //
     /* 274999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 275002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 275007 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 275013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275017 */     // MIs[0] Rn
     /* 275017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 275021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 275025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275029 */     // MIs[0] prfop
     /* 275029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 275032 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 275037 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 275037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 275040 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 275042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 275044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 275048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275052 */     GIR_RootConstrainSelectedInstOperands,
     /* 275053 */     // GIR_Coverage, 8944,
     /* 275053 */     GIR_EraseRootFromParent_Done,
     /* 275054 */   // Label 5320: @275054
     /* 275054 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(275114), // Rule ID 8945 //
     /* 275059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 275062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 275067 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 275073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275077 */     // MIs[0] Rn
     /* 275077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 275081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 275085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275089 */     // MIs[0] prfop
     /* 275089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 275092 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 275097 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 275097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 275100 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 275102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 275104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 275108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275112 */     GIR_RootConstrainSelectedInstOperands,
     /* 275113 */     // GIR_Coverage, 8945,
     /* 275113 */     GIR_EraseRootFromParent_Done,
     /* 275114 */   // Label 5321: @275114
     /* 275114 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(275174), // Rule ID 8946 //
     /* 275119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 275122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 275127 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 275133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275137 */     // MIs[0] Rn
     /* 275137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 275141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 275145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275149 */     // MIs[0] prfop
     /* 275149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 275152 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 275157 */     // (intrinsic_void 1648:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 275157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 275160 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 275162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 275164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 275168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275172 */     GIR_RootConstrainSelectedInstOperands,
     /* 275173 */     // GIR_Coverage, 8946,
     /* 275173 */     GIR_EraseRootFromParent_Done,
     /* 275174 */   // Label 5322: @275174
     /* 275174 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(275234), // Rule ID 8947 //
     /* 275179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 275182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 275187 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 275193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275197 */     // MIs[0] Rn
     /* 275197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 275201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 275205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275209 */     // MIs[0] prfop
     /* 275209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 275212 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 275217 */     // (intrinsic_void 1640:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 275217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 275220 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 275222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 275224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 275228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275232 */     GIR_RootConstrainSelectedInstOperands,
     /* 275233 */     // GIR_Coverage, 8947,
     /* 275233 */     GIR_EraseRootFromParent_Done,
     /* 275234 */   // Label 5323: @275234
     /* 275234 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(275292), // Rule ID 2374 //
     /* 275239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 275247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 275250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 275253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275275 */     // (intrinsic_w_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 275278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275290 */     GIR_RootConstrainSelectedInstOperands,
     /* 275291 */     // GIR_Coverage, 2374,
     /* 275291 */     GIR_EraseRootFromParent_Done,
     /* 275292 */   // Label 5324: @275292
     /* 275292 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(275350), // Rule ID 2375 //
     /* 275297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 275305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 275308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 275311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275333 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 275336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275348 */     GIR_RootConstrainSelectedInstOperands,
     /* 275349 */     // GIR_Coverage, 2375,
     /* 275349 */     GIR_EraseRootFromParent_Done,
     /* 275350 */   // Label 5325: @275350
     /* 275350 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(275408), // Rule ID 2376 //
     /* 275355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 275363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275391 */     // (intrinsic_w_chain:{ *:[v4f32] } 622:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 275394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275406 */     GIR_RootConstrainSelectedInstOperands,
     /* 275407 */     // GIR_Coverage, 2376,
     /* 275407 */     GIR_EraseRootFromParent_Done,
     /* 275408 */   // Label 5326: @275408
     /* 275408 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(275466), // Rule ID 2377 //
     /* 275413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 275421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275449 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 275452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275464 */     GIR_RootConstrainSelectedInstOperands,
     /* 275465 */     // GIR_Coverage, 2377,
     /* 275465 */     GIR_EraseRootFromParent_Done,
     /* 275466 */   // Label 5327: @275466
     /* 275466 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(275524), // Rule ID 2378 //
     /* 275471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 275479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275507 */     // (intrinsic_w_chain:{ *:[v4f32] } 626:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 275510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275522 */     GIR_RootConstrainSelectedInstOperands,
     /* 275523 */     // GIR_Coverage, 2378,
     /* 275523 */     GIR_EraseRootFromParent_Done,
     /* 275524 */   // Label 5328: @275524
     /* 275524 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(275582), // Rule ID 2379 //
     /* 275529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 275537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275565 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 275568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275580 */     GIR_RootConstrainSelectedInstOperands,
     /* 275581 */     // GIR_Coverage, 2379,
     /* 275581 */     GIR_EraseRootFromParent_Done,
     /* 275582 */   // Label 5329: @275582
     /* 275582 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(275640), // Rule ID 2380 //
     /* 275587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 275590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 275595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 275598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 275601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 275604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 275607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275623 */     // (intrinsic_w_chain:{ *:[v4f16] } 616:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 275623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 275626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275638 */     GIR_RootConstrainSelectedInstOperands,
     /* 275639 */     // GIR_Coverage, 2380,
     /* 275639 */     GIR_EraseRootFromParent_Done,
     /* 275640 */   // Label 5330: @275640
     /* 275640 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(275698), // Rule ID 2381 //
     /* 275645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 275648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 275653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 275656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 275659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275681 */     // (intrinsic_w_chain:{ *:[v8f16] } 616:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 275684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275696 */     GIR_RootConstrainSelectedInstOperands,
     /* 275697 */     // GIR_Coverage, 2381,
     /* 275697 */     GIR_EraseRootFromParent_Done,
     /* 275698 */   // Label 5331: @275698
     /* 275698 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(275756), // Rule ID 2382 //
     /* 275703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 275706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 275711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 275714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 275717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 275720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 275723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275739 */     // (intrinsic_w_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 275739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 275742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275754 */     GIR_RootConstrainSelectedInstOperands,
     /* 275755 */     // GIR_Coverage, 2382,
     /* 275755 */     GIR_EraseRootFromParent_Done,
     /* 275756 */   // Label 5332: @275756
     /* 275756 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(275814), // Rule ID 2383 //
     /* 275761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 275764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 275769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275797 */     // (intrinsic_w_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 275800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275812 */     GIR_RootConstrainSelectedInstOperands,
     /* 275813 */     // GIR_Coverage, 2383,
     /* 275813 */     GIR_EraseRootFromParent_Done,
     /* 275814 */   // Label 5333: @275814
     /* 275814 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(275872), // Rule ID 2491 //
     /* 275819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 275822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 275827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 275830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 275833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 275836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 275839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275855 */     // (intrinsic_w_chain:{ *:[v16i8] } 615:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 275855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 275858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275860 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 275862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275864 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275870 */     GIR_RootConstrainSelectedInstOperands,
     /* 275871 */     // GIR_Coverage, 2491,
     /* 275871 */     GIR_EraseRootFromParent_Done,
     /* 275872 */   // Label 5334: @275872
     /* 275872 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(275928), // Rule ID 13207 //
     /* 275877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 275882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 275885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 275888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 275891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 275895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 275899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 275903 */     // MIs[0] addr
     /* 275903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 275907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 275911 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 275911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 275914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 275916 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 275918 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 275920 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 275922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275926 */     GIR_RootConstrainSelectedInstOperands,
     /* 275927 */     // GIR_Coverage, 13207,
     /* 275927 */     GIR_EraseRootFromParent_Done,
     /* 275928 */   // Label 5335: @275928
     /* 275928 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(275984), // Rule ID 13208 //
     /* 275933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 275938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 275941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 275944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 275947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 275951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 275955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 275959 */     // MIs[0] addr
     /* 275959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 275963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 275967 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 275967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 275970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 275972 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 275974 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 275976 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 275978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275982 */     GIR_RootConstrainSelectedInstOperands,
     /* 275983 */     // GIR_Coverage, 13208,
     /* 275983 */     GIR_EraseRootFromParent_Done,
     /* 275984 */   // Label 5336: @275984
     /* 275984 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(276030), // Rule ID 3459 //
     /* 275989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 275992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 275997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 276000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276013 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1504:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 276016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276028 */     GIR_RootConstrainSelectedInstOperands,
     /* 276029 */     // GIR_Coverage, 3459,
     /* 276029 */     GIR_EraseRootFromParent_Done,
     /* 276030 */   // Label 5337: @276030
     /* 276030 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(276076), // Rule ID 3581 //
     /* 276035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 276043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 276046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276059 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1506:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 276062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276074 */     GIR_RootConstrainSelectedInstOperands,
     /* 276075 */     // GIR_Coverage, 3581,
     /* 276075 */     GIR_EraseRootFromParent_Done,
     /* 276076 */   // Label 5338: @276076
     /* 276076 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(276122), // Rule ID 12635 //
     /* 276081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 276089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 276092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276105 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1516:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 276108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276120 */     GIR_RootConstrainSelectedInstOperands,
     /* 276121 */     // GIR_Coverage, 12635,
     /* 276121 */     GIR_EraseRootFromParent_Done,
     /* 276122 */   // Label 5339: @276122
     /* 276122 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(276168), // Rule ID 12639 //
     /* 276127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 276135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 276138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276151 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1508:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 276154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276166 */     GIR_RootConstrainSelectedInstOperands,
     /* 276167 */     // GIR_Coverage, 12639,
     /* 276167 */     GIR_EraseRootFromParent_Done,
     /* 276168 */   // Label 5340: @276168
     /* 276168 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(276214), // Rule ID 12640 //
     /* 276173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 276181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 276184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276197 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1510:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 276200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276212 */     GIR_RootConstrainSelectedInstOperands,
     /* 276213 */     // GIR_Coverage, 12640,
     /* 276213 */     GIR_EraseRootFromParent_Done,
     /* 276214 */   // Label 5341: @276214
     /* 276214 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(276260), // Rule ID 12641 //
     /* 276219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 276227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 276230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276243 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1512:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 276246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276258 */     GIR_RootConstrainSelectedInstOperands,
     /* 276259 */     // GIR_Coverage, 12641,
     /* 276259 */     GIR_EraseRootFromParent_Done,
     /* 276260 */   // Label 5342: @276260
     /* 276260 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(276306), // Rule ID 12642 //
     /* 276265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 276273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 276276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276289 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1514:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 276292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276304 */     GIR_RootConstrainSelectedInstOperands,
     /* 276305 */     // GIR_Coverage, 12642,
     /* 276305 */     GIR_EraseRootFromParent_Done,
     /* 276306 */   // Label 5343: @276306
     /* 276306 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(276352), // Rule ID 12643 //
     /* 276311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 276314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 276319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 276322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276335 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1504:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 276338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276350 */     GIR_RootConstrainSelectedInstOperands,
     /* 276351 */     // GIR_Coverage, 12643,
     /* 276351 */     GIR_EraseRootFromParent_Done,
     /* 276352 */   // Label 5344: @276352
     /* 276352 */   GIM_Reject,
     /* 276353 */ // Label 5297: @276353
     /* 276353 */ GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(279346),
     /* 276358 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 276361 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(276429), // Rule ID 2518 //
     /* 276366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 276369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 276374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 276377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 276380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 276383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 276402 */     // MIs[0] Idx
     /* 276402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276405 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 276410 */     // (intrinsic_w_chain:{ *:[v8f16] } 621:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 276413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276421 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276427 */     GIR_RootConstrainSelectedInstOperands,
     /* 276428 */     // GIR_Coverage, 2518,
     /* 276428 */     GIR_EraseRootFromParent_Done,
     /* 276429 */   // Label 5346: @276429
     /* 276429 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(276497), // Rule ID 2519 //
     /* 276434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 276437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 276442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 276445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 276451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 276470 */     // MIs[0] Idx
     /* 276470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 276478 */     // (intrinsic_w_chain:{ *:[v4f32] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 276481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276489 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276495 */     GIR_RootConstrainSelectedInstOperands,
     /* 276496 */     // GIR_Coverage, 2519,
     /* 276496 */     GIR_EraseRootFromParent_Done,
     /* 276497 */   // Label 5347: @276497
     /* 276497 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(276565), // Rule ID 2520 //
     /* 276502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 276505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 276510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 276513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 276516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 276519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276538 */     // MIs[0] Idx
     /* 276538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276541 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 276546 */     // (intrinsic_w_chain:{ *:[v2f32] } 619:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 276549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276557 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276563 */     GIR_RootConstrainSelectedInstOperands,
     /* 276564 */     // GIR_Coverage, 2520,
     /* 276564 */     GIR_EraseRootFromParent_Done,
     /* 276565 */   // Label 5348: @276565
     /* 276565 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(276633), // Rule ID 2521 //
     /* 276570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 276573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 276578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 276581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 276587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276606 */     // MIs[0] Idx
     /* 276606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 276614 */     // (intrinsic_w_chain:{ *:[v4f32] } 619:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 276617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276623 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276625 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276631 */     GIR_RootConstrainSelectedInstOperands,
     /* 276632 */     // GIR_Coverage, 2521,
     /* 276632 */     GIR_EraseRootFromParent_Done,
     /* 276633 */   // Label 5349: @276633
     /* 276633 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(276701), // Rule ID 2522 //
     /* 276638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 276641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 276646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 276649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 276652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 276655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 276674 */     // MIs[0] Idx
     /* 276674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276677 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 276682 */     // (intrinsic_w_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 276685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276693 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276699 */     GIR_RootConstrainSelectedInstOperands,
     /* 276700 */     // GIR_Coverage, 2522,
     /* 276700 */     GIR_EraseRootFromParent_Done,
     /* 276701 */   // Label 5350: @276701
     /* 276701 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(276769), // Rule ID 2523 //
     /* 276706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 276709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 276714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 276717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 276720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 276723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 276742 */     // MIs[0] Idx
     /* 276742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 276750 */     // (intrinsic_w_chain:{ *:[v8f16] } 617:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 276753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276761 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276767 */     GIR_RootConstrainSelectedInstOperands,
     /* 276768 */     // GIR_Coverage, 2523,
     /* 276768 */     GIR_EraseRootFromParent_Done,
     /* 276769 */   // Label 5351: @276769
     /* 276769 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(276837), // Rule ID 7043 //
     /* 276774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 276777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 276782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 276785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 276788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 276791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 276810 */     // MIs[0] Idx
     /* 276810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 276818 */     // (intrinsic_w_chain:{ *:[v8f16] } 631:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 276821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276829 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276835 */     GIR_RootConstrainSelectedInstOperands,
     /* 276836 */     // GIR_Coverage, 7043,
     /* 276836 */     GIR_EraseRootFromParent_Done,
     /* 276837 */   // Label 5352: @276837
     /* 276837 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(276905), // Rule ID 7044 //
     /* 276842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 276845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 276850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 276853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 276859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 276878 */     // MIs[0] Idx
     /* 276878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 276886 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 276889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276897 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276903 */     GIR_RootConstrainSelectedInstOperands,
     /* 276904 */     // GIR_Coverage, 7044,
     /* 276904 */     GIR_EraseRootFromParent_Done,
     /* 276905 */   // Label 5353: @276905
     /* 276905 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(276973), // Rule ID 7045 //
     /* 276910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 276913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 276918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 276921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 276927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 276946 */     // MIs[0] Idx
     /* 276946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276949 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 276954 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 276957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276965 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276971 */     GIR_RootConstrainSelectedInstOperands,
     /* 276972 */     // GIR_Coverage, 7045,
     /* 276972 */     GIR_EraseRootFromParent_Done,
     /* 276973 */   // Label 5354: @276973
     /* 276973 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(277041), // Rule ID 7046 //
     /* 276978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 276981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 276986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 276989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 276995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 277014 */     // MIs[0] Idx
     /* 277014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277017 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 277022 */     // (intrinsic_w_chain:{ *:[v4f32] } 629:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 277022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 277025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 277029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 277033 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 277035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277039 */     GIR_RootConstrainSelectedInstOperands,
     /* 277040 */     // GIR_Coverage, 7046,
     /* 277040 */     GIR_EraseRootFromParent_Done,
     /* 277041 */   // Label 5355: @277041
     /* 277041 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(277101), // Rule ID 3593 //
     /* 277046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 277049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 277054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 277057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 277060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 277063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 277066 */     // MIs[0] tile
     /* 277066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277082 */     // (intrinsic_void 929:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 277082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 277085 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277093 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277099 */     GIR_RootConstrainSelectedInstOperands,
     /* 277100 */     // GIR_Coverage, 3593,
     /* 277100 */     GIR_EraseRootFromParent_Done,
     /* 277101 */   // Label 5356: @277101
     /* 277101 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(277161), // Rule ID 3594 //
     /* 277106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 277109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 277114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 277117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 277120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 277126 */     // MIs[0] tile
     /* 277126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277142 */     // (intrinsic_void 881:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 277142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 277145 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277151 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277153 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277159 */     GIR_RootConstrainSelectedInstOperands,
     /* 277160 */     // GIR_Coverage, 3594,
     /* 277160 */     GIR_EraseRootFromParent_Done,
     /* 277161 */   // Label 5357: @277161
     /* 277161 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(277221), // Rule ID 3595 //
     /* 277166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 277169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 277174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 277177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 277180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 277183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 277186 */     // MIs[0] tile
     /* 277186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 277194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277202 */     // (intrinsic_void 929:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 277202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 277205 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277213 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277219 */     GIR_RootConstrainSelectedInstOperands,
     /* 277220 */     // GIR_Coverage, 3595,
     /* 277220 */     GIR_EraseRootFromParent_Done,
     /* 277221 */   // Label 5358: @277221
     /* 277221 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(277281), // Rule ID 3596 //
     /* 277226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 277229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 277234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 277237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 277240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 277246 */     // MIs[0] tile
     /* 277246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277249 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 277254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277262 */     // (intrinsic_void 880:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 277262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 277265 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277273 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277279 */     GIR_RootConstrainSelectedInstOperands,
     /* 277280 */     // GIR_Coverage, 3596,
     /* 277280 */     GIR_EraseRootFromParent_Done,
     /* 277281 */   // Label 5359: @277281
     /* 277281 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(277341), // Rule ID 3597 //
     /* 277286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 277289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 277294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 277297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 277300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 277303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 277306 */     // MIs[0] tile
     /* 277306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277309 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 277314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277322 */     // (intrinsic_void 929:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 277322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 277325 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277333 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277339 */     GIR_RootConstrainSelectedInstOperands,
     /* 277340 */     // GIR_Coverage, 3597,
     /* 277340 */     GIR_EraseRootFromParent_Done,
     /* 277341 */   // Label 5360: @277341
     /* 277341 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(277401), // Rule ID 3598 //
     /* 277346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 277349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 277354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 277357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 277360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 277366 */     // MIs[0] tile
     /* 277366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277382 */     // (intrinsic_void 1032:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 277382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 277385 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277393 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277399 */     GIR_RootConstrainSelectedInstOperands,
     /* 277400 */     // GIR_Coverage, 3598,
     /* 277400 */     GIR_EraseRootFromParent_Done,
     /* 277401 */   // Label 5361: @277401
     /* 277401 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(277461), // Rule ID 3599 //
     /* 277406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 277409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 277414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 277417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 277420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 277423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 277426 */     // MIs[0] tile
     /* 277426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 277434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277442 */     // (intrinsic_void 1032:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 277442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 277445 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277453 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277459 */     GIR_RootConstrainSelectedInstOperands,
     /* 277460 */     // GIR_Coverage, 3599,
     /* 277460 */     GIR_EraseRootFromParent_Done,
     /* 277461 */   // Label 5362: @277461
     /* 277461 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(277521), // Rule ID 3600 //
     /* 277466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 277469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 277474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 277477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 277480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 277483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 277486 */     // MIs[0] tile
     /* 277486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277489 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277502 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 277502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 277505 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277513 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277519 */     GIR_RootConstrainSelectedInstOperands,
     /* 277520 */     // GIR_Coverage, 3600,
     /* 277520 */     GIR_EraseRootFromParent_Done,
     /* 277521 */   // Label 5363: @277521
     /* 277521 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(277581), // Rule ID 3694 //
     /* 277526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 277529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 277534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 277537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 277540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 277543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 277546 */     // MIs[0] tile
     /* 277546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277549 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277562 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 277562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 277565 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277573 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277579 */     GIR_RootConstrainSelectedInstOperands,
     /* 277580 */     // GIR_Coverage, 3694,
     /* 277580 */     GIR_EraseRootFromParent_Done,
     /* 277581 */   // Label 5364: @277581
     /* 277581 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(277641), // Rule ID 3695 //
     /* 277586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 277589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 277594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 277597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 277600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 277603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 277606 */     // MIs[0] tile
     /* 277606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277622 */     // (intrinsic_void 800:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 277622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 277625 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277633 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277639 */     GIR_RootConstrainSelectedInstOperands,
     /* 277640 */     // GIR_Coverage, 3695,
     /* 277640 */     GIR_EraseRootFromParent_Done,
     /* 277641 */   // Label 5365: @277641
     /* 277641 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(277701), // Rule ID 12650 //
     /* 277646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 277649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 277654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 277657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 277660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 277663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 277666 */     // MIs[0] tile
     /* 277666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277669 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277682 */     // (intrinsic_void 932:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 277682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 277685 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277693 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277699 */     GIR_RootConstrainSelectedInstOperands,
     /* 277700 */     // GIR_Coverage, 12650,
     /* 277700 */     GIR_EraseRootFromParent_Done,
     /* 277701 */   // Label 5366: @277701
     /* 277701 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(277761), // Rule ID 12651 //
     /* 277706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 277709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 277714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 277717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 277720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 277723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 277726 */     // MIs[0] tile
     /* 277726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 277734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277742 */     // (intrinsic_void 932:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 277742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 277745 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277751 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277753 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277759 */     GIR_RootConstrainSelectedInstOperands,
     /* 277760 */     // GIR_Coverage, 12651,
     /* 277760 */     GIR_EraseRootFromParent_Done,
     /* 277761 */   // Label 5367: @277761
     /* 277761 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(277821), // Rule ID 12652 //
     /* 277766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 277769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 277774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 277777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 277780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 277783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 277786 */     // MIs[0] tile
     /* 277786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277802 */     // (intrinsic_void 934:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 277802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 277805 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277813 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277819 */     GIR_RootConstrainSelectedInstOperands,
     /* 277820 */     // GIR_Coverage, 12652,
     /* 277820 */     GIR_EraseRootFromParent_Done,
     /* 277821 */   // Label 5368: @277821
     /* 277821 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(277881), // Rule ID 12653 //
     /* 277826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 277829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 277834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 277837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 277840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 277846 */     // MIs[0] tile
     /* 277846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277862 */     // (intrinsic_void 1034:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 277862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 277865 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277871 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277873 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277879 */     GIR_RootConstrainSelectedInstOperands,
     /* 277880 */     // GIR_Coverage, 12653,
     /* 277880 */     GIR_EraseRootFromParent_Done,
     /* 277881 */   // Label 5369: @277881
     /* 277881 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(277941), // Rule ID 12654 //
     /* 277886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 277889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 277894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 277897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 277900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 277906 */     // MIs[0] tile
     /* 277906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277922 */     // (intrinsic_void 1167:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 277922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 277925 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277933 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277939 */     GIR_RootConstrainSelectedInstOperands,
     /* 277940 */     // GIR_Coverage, 12654,
     /* 277940 */     GIR_EraseRootFromParent_Done,
     /* 277941 */   // Label 5370: @277941
     /* 277941 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(278001), // Rule ID 12655 //
     /* 277946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 277949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 277954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 277957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 277960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 277966 */     // MIs[0] tile
     /* 277966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277982 */     // (intrinsic_void 1169:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 277982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 277985 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277993 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277999 */     GIR_RootConstrainSelectedInstOperands,
     /* 278000 */     // GIR_Coverage, 12655,
     /* 278000 */     GIR_EraseRootFromParent_Done,
     /* 278001 */   // Label 5371: @278001
     /* 278001 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(278061), // Rule ID 12656 //
     /* 278006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 278009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 278014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 278017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 278020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 278023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 278026 */     // MIs[0] tile
     /* 278026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278029 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278042 */     // (intrinsic_void 1084:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 278042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 278045 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278053 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278059 */     GIR_RootConstrainSelectedInstOperands,
     /* 278060 */     // GIR_Coverage, 12656,
     /* 278060 */     GIR_EraseRootFromParent_Done,
     /* 278061 */   // Label 5372: @278061
     /* 278061 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(278121), // Rule ID 12657 //
     /* 278066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 278069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 278074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 278077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 278080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 278083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 278086 */     // MIs[0] tile
     /* 278086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278102 */     // (intrinsic_void 1085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 278102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 278105 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278111 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278113 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278119 */     GIR_RootConstrainSelectedInstOperands,
     /* 278120 */     // GIR_Coverage, 12657,
     /* 278120 */     GIR_EraseRootFromParent_Done,
     /* 278121 */   // Label 5373: @278121
     /* 278121 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(278181), // Rule ID 12658 //
     /* 278126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 278129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 278134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 278137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 278140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 278143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 278146 */     // MIs[0] tile
     /* 278146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278162 */     // (intrinsic_void 1201:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 278162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 278165 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278173 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278179 */     GIR_RootConstrainSelectedInstOperands,
     /* 278180 */     // GIR_Coverage, 12658,
     /* 278180 */     GIR_EraseRootFromParent_Done,
     /* 278181 */   // Label 5374: @278181
     /* 278181 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(278241), // Rule ID 12659 //
     /* 278186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 278189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 278194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 278197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 278200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 278203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 278206 */     // MIs[0] tile
     /* 278206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278209 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278222 */     // (intrinsic_void 1202:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 278222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 278225 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278233 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278239 */     GIR_RootConstrainSelectedInstOperands,
     /* 278240 */     // GIR_Coverage, 12659,
     /* 278240 */     GIR_EraseRootFromParent_Done,
     /* 278241 */   // Label 5375: @278241
     /* 278241 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(278301), // Rule ID 12660 //
     /* 278246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 278249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 278254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278266 */     // MIs[0] tile
     /* 278266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 278274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278282 */     // (intrinsic_void 1034:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 278285 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278293 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278299 */     GIR_RootConstrainSelectedInstOperands,
     /* 278300 */     // GIR_Coverage, 12660,
     /* 278300 */     GIR_EraseRootFromParent_Done,
     /* 278301 */   // Label 5376: @278301
     /* 278301 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(278361), // Rule ID 12661 //
     /* 278306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 278309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 278314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278326 */     // MIs[0] tile
     /* 278326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 278334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278342 */     // (intrinsic_void 1167:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 278345 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278353 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278359 */     GIR_RootConstrainSelectedInstOperands,
     /* 278360 */     // GIR_Coverage, 12661,
     /* 278360 */     GIR_EraseRootFromParent_Done,
     /* 278361 */   // Label 5377: @278361
     /* 278361 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(278421), // Rule ID 12662 //
     /* 278366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 278369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 278374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278386 */     // MIs[0] tile
     /* 278386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278389 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 278394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278402 */     // (intrinsic_void 1169:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 278405 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278413 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278419 */     GIR_RootConstrainSelectedInstOperands,
     /* 278420 */     // GIR_Coverage, 12662,
     /* 278420 */     GIR_EraseRootFromParent_Done,
     /* 278421 */   // Label 5378: @278421
     /* 278421 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(278481), // Rule ID 12663 //
     /* 278426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 278429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 278434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278446 */     // MIs[0] tile
     /* 278446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 278454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278462 */     // (intrinsic_void 1084:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 278465 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278471 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278473 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278479 */     GIR_RootConstrainSelectedInstOperands,
     /* 278480 */     // GIR_Coverage, 12663,
     /* 278480 */     GIR_EraseRootFromParent_Done,
     /* 278481 */   // Label 5379: @278481
     /* 278481 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(278541), // Rule ID 12664 //
     /* 278486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 278489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 278494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278506 */     // MIs[0] tile
     /* 278506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278509 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 278514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278522 */     // (intrinsic_void 1085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 278525 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278533 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278539 */     GIR_RootConstrainSelectedInstOperands,
     /* 278540 */     // GIR_Coverage, 12664,
     /* 278540 */     GIR_EraseRootFromParent_Done,
     /* 278541 */   // Label 5380: @278541
     /* 278541 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(278601), // Rule ID 12665 //
     /* 278546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 278549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 278554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278566 */     // MIs[0] tile
     /* 278566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 278574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278582 */     // (intrinsic_void 1201:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 278585 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278591 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278593 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278599 */     GIR_RootConstrainSelectedInstOperands,
     /* 278600 */     // GIR_Coverage, 12665,
     /* 278600 */     GIR_EraseRootFromParent_Done,
     /* 278601 */   // Label 5381: @278601
     /* 278601 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(278661), // Rule ID 12666 //
     /* 278606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 278609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 278614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278626 */     // MIs[0] tile
     /* 278626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 278634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278642 */     // (intrinsic_void 1202:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 278645 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278653 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278659 */     GIR_RootConstrainSelectedInstOperands,
     /* 278660 */     // GIR_Coverage, 12666,
     /* 278660 */     GIR_EraseRootFromParent_Done,
     /* 278661 */   // Label 5382: @278661
     /* 278661 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(278721), // Rule ID 13040 //
     /* 278666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 278669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 278674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 278677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 278680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 278683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 278686 */     // MIs[0] tile
     /* 278686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278689 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278702 */     // (intrinsic_void 801:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 278702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 278705 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278711 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278713 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278719 */     GIR_RootConstrainSelectedInstOperands,
     /* 278720 */     // GIR_Coverage, 13040,
     /* 278720 */     GIR_EraseRootFromParent_Done,
     /* 278721 */   // Label 5383: @278721
     /* 278721 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(278781), // Rule ID 13041 //
     /* 278726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 278729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 278734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278746 */     // MIs[0] tile
     /* 278746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278749 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278762 */     // (intrinsic_void 1035:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 278765 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278773 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278779 */     GIR_RootConstrainSelectedInstOperands,
     /* 278780 */     // GIR_Coverage, 13041,
     /* 278780 */     GIR_EraseRootFromParent_Done,
     /* 278781 */   // Label 5384: @278781
     /* 278781 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(278841), // Rule ID 13042 //
     /* 278786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 278789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 278794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278806 */     // MIs[0] tile
     /* 278806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278822 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 278825 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278833 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278839 */     GIR_RootConstrainSelectedInstOperands,
     /* 278840 */     // GIR_Coverage, 13042,
     /* 278840 */     GIR_EraseRootFromParent_Done,
     /* 278841 */   // Label 5385: @278841
     /* 278841 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(278901), // Rule ID 13043 //
     /* 278846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 278849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 278854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278866 */     // MIs[0] tile
     /* 278866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278869 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278882 */     // (intrinsic_void 1170:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 278885 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278893 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278899 */     GIR_RootConstrainSelectedInstOperands,
     /* 278900 */     // GIR_Coverage, 13043,
     /* 278900 */     GIR_EraseRootFromParent_Done,
     /* 278901 */   // Label 5386: @278901
     /* 278901 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(278961), // Rule ID 13154 //
     /* 278906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 278909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 278914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278926 */     // MIs[0] tile
     /* 278926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278929 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 278934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278942 */     // (intrinsic_void 932:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 278942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 278945 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278953 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278959 */     GIR_RootConstrainSelectedInstOperands,
     /* 278960 */     // GIR_Coverage, 13154,
     /* 278960 */     GIR_EraseRootFromParent_Done,
     /* 278961 */   // Label 5387: @278961
     /* 278961 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(279009), // Rule ID 3580 //
     /* 278966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 278969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 278974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 278977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 278980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 278983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 278986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278990 */     // MIs[0] Op4
     /* 278990 */     // No operand predicates
     /* 278990 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1507:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 278990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 278993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 278995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 278997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 278999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279001 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279007 */     GIR_RootConstrainSelectedInstOperands,
     /* 279008 */     // GIR_Coverage, 3580,
     /* 279008 */     GIR_EraseRootFromParent_Done,
     /* 279009 */   // Label 5388: @279009
     /* 279009 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(279057), // Rule ID 3582 //
     /* 279014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 279017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 279022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 279025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279038 */     // MIs[0] Op4
     /* 279038 */     // No operand predicates
     /* 279038 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1509:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 279041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279049 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279055 */     GIR_RootConstrainSelectedInstOperands,
     /* 279056 */     // GIR_Coverage, 3582,
     /* 279056 */     GIR_EraseRootFromParent_Done,
     /* 279057 */   // Label 5389: @279057
     /* 279057 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(279105), // Rule ID 3583 //
     /* 279062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 279065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 279070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 279073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 279076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279086 */     // MIs[0] Op4
     /* 279086 */     // No operand predicates
     /* 279086 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1505:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 279089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279095 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279097 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279103 */     GIR_RootConstrainSelectedInstOperands,
     /* 279104 */     // GIR_Coverage, 3583,
     /* 279104 */     GIR_EraseRootFromParent_Done,
     /* 279105 */   // Label 5390: @279105
     /* 279105 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(279153), // Rule ID 3584 //
     /* 279110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 279113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 279118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 279121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279134 */     // MIs[0] Op4
     /* 279134 */     // No operand predicates
     /* 279134 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1505:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 279137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279145 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279151 */     GIR_RootConstrainSelectedInstOperands,
     /* 279152 */     // GIR_Coverage, 3584,
     /* 279152 */     GIR_EraseRootFromParent_Done,
     /* 279153 */   // Label 5391: @279153
     /* 279153 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(279201), // Rule ID 12634 //
     /* 279158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 279161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 279166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 279169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 279172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279182 */     // MIs[0] Op4
     /* 279182 */     // No operand predicates
     /* 279182 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1517:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 279185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279193 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279199 */     GIR_RootConstrainSelectedInstOperands,
     /* 279200 */     // GIR_Coverage, 12634,
     /* 279200 */     GIR_EraseRootFromParent_Done,
     /* 279201 */   // Label 5392: @279201
     /* 279201 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(279249), // Rule ID 12636 //
     /* 279206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 279209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 279214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 279217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279230 */     // MIs[0] Op4
     /* 279230 */     // No operand predicates
     /* 279230 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1511:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 279233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279241 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279247 */     GIR_RootConstrainSelectedInstOperands,
     /* 279248 */     // GIR_Coverage, 12636,
     /* 279248 */     GIR_EraseRootFromParent_Done,
     /* 279249 */   // Label 5393: @279249
     /* 279249 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(279297), // Rule ID 12637 //
     /* 279254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 279257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 279262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 279265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279278 */     // MIs[0] Op4
     /* 279278 */     // No operand predicates
     /* 279278 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1513:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 279281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279287 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279289 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279295 */     GIR_RootConstrainSelectedInstOperands,
     /* 279296 */     // GIR_Coverage, 12637,
     /* 279296 */     GIR_EraseRootFromParent_Done,
     /* 279297 */   // Label 5394: @279297
     /* 279297 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(279345), // Rule ID 12638 //
     /* 279302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 279305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 279310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 279313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279326 */     // MIs[0] Op4
     /* 279326 */     // No operand predicates
     /* 279326 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1515:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 279329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279337 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279343 */     GIR_RootConstrainSelectedInstOperands,
     /* 279344 */     // GIR_Coverage, 12638,
     /* 279344 */     GIR_EraseRootFromParent_Done,
     /* 279345 */   // Label 5395: @279345
     /* 279345 */   GIM_Reject,
     /* 279346 */ // Label 5345: @279346
     /* 279346 */ GIM_Reject,
     /* 279347 */ // Label 39: @279347
     /* 279347 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5400*/ GIMT_Encode4(279636),
     /* 279358 */ /*GILLT_s64*//*Label 5396*/ GIMT_Encode4(279390), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 279370 */ /*GILLT_v2s64*//*Label 5397*/ GIMT_Encode4(279450), GIMT_Encode4(0),
     /* 279378 */ /*GILLT_v4s32*//*Label 5398*/ GIMT_Encode4(279512), GIMT_Encode4(0),
     /* 279386 */ /*GILLT_v8s16*//*Label 5399*/ GIMT_Encode4(279574),
     /* 279390 */ // Label 5396: @279390
     /* 279390 */ GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(279449), // Rule ID 6555 //
     /* 279395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 279398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279406 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 279406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279428 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 279430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 279433 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279438 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279443 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279448 */   // GIR_Coverage, 6555,
     /* 279448 */   GIR_EraseRootFromParent_Done,
     /* 279449 */ // Label 5401: @279449
     /* 279449 */ GIM_Reject,
     /* 279450 */ // Label 5397: @279450
     /* 279450 */ GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(279511),
     /* 279455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 279458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279462 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(279489), // Rule ID 6425 //
     /* 279467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 279474 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 279474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 279477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 279484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279487 */     GIR_RootConstrainSelectedInstOperands,
     /* 279488 */     // GIR_Coverage, 6425,
     /* 279488 */     GIR_EraseRootFromParent_Done,
     /* 279489 */   // Label 5403: @279489
     /* 279489 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(279510), // Rule ID 6418 //
     /* 279494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279498 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 279498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 279501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279508 */     GIR_RootConstrainSelectedInstOperands,
     /* 279509 */     // GIR_Coverage, 6418,
     /* 279509 */     GIR_EraseRootFromParent_Done,
     /* 279510 */   // Label 5404: @279510
     /* 279510 */   GIM_Reject,
     /* 279511 */ // Label 5402: @279511
     /* 279511 */ GIM_Reject,
     /* 279512 */ // Label 5398: @279512
     /* 279512 */ GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(279573),
     /* 279517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 279520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279524 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(279551), // Rule ID 6422 //
     /* 279529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 279536 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 279536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 279539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 279546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279549 */     GIR_RootConstrainSelectedInstOperands,
     /* 279550 */     // GIR_Coverage, 6422,
     /* 279550 */     GIR_EraseRootFromParent_Done,
     /* 279551 */   // Label 5406: @279551
     /* 279551 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(279572), // Rule ID 6415 //
     /* 279556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279560 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 279560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 279563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279570 */     GIR_RootConstrainSelectedInstOperands,
     /* 279571 */     // GIR_Coverage, 6415,
     /* 279571 */     GIR_EraseRootFromParent_Done,
     /* 279572 */   // Label 5407: @279572
     /* 279572 */   GIM_Reject,
     /* 279573 */ // Label 5405: @279573
     /* 279573 */ GIM_Reject,
     /* 279574 */ // Label 5399: @279574
     /* 279574 */ GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(279635),
     /* 279579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 279582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279586 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(279613), // Rule ID 6419 //
     /* 279591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 279598 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 279598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 279601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 279608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279611 */     GIR_RootConstrainSelectedInstOperands,
     /* 279612 */     // GIR_Coverage, 6419,
     /* 279612 */     GIR_EraseRootFromParent_Done,
     /* 279613 */   // Label 5409: @279613
     /* 279613 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(279634), // Rule ID 6412 //
     /* 279618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279622 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 279622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 279625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279632 */     GIR_RootConstrainSelectedInstOperands,
     /* 279633 */     // GIR_Coverage, 6412,
     /* 279633 */     GIR_EraseRootFromParent_Done,
     /* 279634 */   // Label 5410: @279634
     /* 279634 */   GIM_Reject,
     /* 279635 */ // Label 5408: @279635
     /* 279635 */ GIM_Reject,
     /* 279636 */ // Label 5400: @279636
     /* 279636 */ GIM_Reject,
     /* 279637 */ // Label 40: @279637
     /* 279637 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5415*/ GIMT_Encode4(281073),
     /* 279648 */ /*GILLT_s32*//*Label 5411*/ GIMT_Encode4(279680), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 279660 */ /*GILLT_v2s32*//*Label 5412*/ GIMT_Encode4(279719), GIMT_Encode4(0),
     /* 279668 */ /*GILLT_v4s16*//*Label 5413*/ GIMT_Encode4(280075), GIMT_Encode4(0),
     /* 279676 */ /*GILLT_v8s8*//*Label 5414*/ GIMT_Encode4(280574),
     /* 279680 */ // Label 5411: @279680
     /* 279680 */ GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(279718), // Rule ID 6576 //
     /* 279685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 279688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 279692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 279696 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 279696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279701 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 279707 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 279712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 279717 */   // GIR_Coverage, 6576,
     /* 279717 */   GIR_EraseRootFromParent_Done,
     /* 279718 */ // Label 5416: @279718
     /* 279718 */ GIM_Reject,
     /* 279719 */ // Label 5412: @279719
     /* 279719 */ GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(280074),
     /* 279724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279731 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(279809), // Rule ID 5466 //
     /* 279736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 279744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 279756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 279764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 279773 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279779 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 279781 */     // MIs[1] Operand 2
     /* 279781 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 279792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279794 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 279794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 279797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 279803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 279807 */     GIR_RootConstrainSelectedInstOperands,
     /* 279808 */     // GIR_Coverage, 5466,
     /* 279808 */     GIR_EraseRootFromParent_Done,
     /* 279809 */   // Label 5418: @279809
     /* 279809 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(279880), // Rule ID 5462 //
     /* 279814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 279822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 279834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 279842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279852 */     // MIs[1] Operand 2
     /* 279852 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 279863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279865 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 279865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 279868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 279874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 279878 */     GIR_RootConstrainSelectedInstOperands,
     /* 279879 */     // GIR_Coverage, 5462,
     /* 279879 */     GIR_EraseRootFromParent_Done,
     /* 279880 */   // Label 5419: @279880
     /* 279880 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(279951), // Rule ID 5464 //
     /* 279885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 279893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 279905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 279913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279923 */     // MIs[1] Operand 2
     /* 279923 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 279934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279936 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 279936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 279939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 279945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 279949 */     GIR_RootConstrainSelectedInstOperands,
     /* 279950 */     // GIR_Coverage, 5464,
     /* 279950 */     GIR_EraseRootFromParent_Done,
     /* 279951 */   // Label 5420: @279951
     /* 279951 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(280004), // Rule ID 2162 //
     /* 279956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 279967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279976 */     // MIs[1] imm
     /* 279976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279984 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 279988 */     // MIs[2] Operand 1
     /* 279988 */     // No operand predicates
     /* 279988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279990 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 279990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 279993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 279999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 280002 */     GIR_RootConstrainSelectedInstOperands,
     /* 280003 */     // GIR_Coverage, 2162,
     /* 280003 */     GIR_EraseRootFromParent_Done,
     /* 280004 */   // Label 5421: @280004
     /* 280004 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(280054), // Rule ID 6400 //
     /* 280009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280026 */     // MIs[1] imm
     /* 280026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280034 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 280038 */     // MIs[2] Operand 1
     /* 280038 */     // No operand predicates
     /* 280038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280040 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 280040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 280043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 280052 */     GIR_RootConstrainSelectedInstOperands,
     /* 280053 */     // GIR_Coverage, 6400,
     /* 280053 */     GIR_EraseRootFromParent_Done,
     /* 280054 */   // Label 5422: @280054
     /* 280054 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(280073), // Rule ID 1099 //
     /* 280059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280066 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 280066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 280071 */     GIR_RootConstrainSelectedInstOperands,
     /* 280072 */     // GIR_Coverage, 1099,
     /* 280072 */     GIR_Done,
     /* 280073 */   // Label 5423: @280073
     /* 280073 */   GIM_Reject,
     /* 280074 */ // Label 5417: @280074
     /* 280074 */ GIM_Reject,
     /* 280075 */ // Label 5413: @280075
     /* 280075 */ GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(280573),
     /* 280080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280087 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(280165), // Rule ID 5460 //
     /* 280092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 280112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280129 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280135 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 280137 */     // MIs[1] Operand 2
     /* 280137 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 280148 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280150 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 280150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 280153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 280159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280163 */     GIR_RootConstrainSelectedInstOperands,
     /* 280164 */     // GIR_Coverage, 5460,
     /* 280164 */     GIR_EraseRootFromParent_Done,
     /* 280165 */   // Label 5425: @280165
     /* 280165 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(280236), // Rule ID 5456 //
     /* 280170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 280190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280194 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280208 */     // MIs[1] Operand 2
     /* 280208 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 280219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280221 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 280221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 280224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 280234 */     GIR_RootConstrainSelectedInstOperands,
     /* 280235 */     // GIR_Coverage, 5456,
     /* 280235 */     GIR_EraseRootFromParent_Done,
     /* 280236 */   // Label 5426: @280236
     /* 280236 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(280307), // Rule ID 5458 //
     /* 280241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280279 */     // MIs[1] Operand 2
     /* 280279 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 280290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280292 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 280292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 280295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 280305 */     GIR_RootConstrainSelectedInstOperands,
     /* 280306 */     // GIR_Coverage, 5458,
     /* 280306 */     GIR_EraseRootFromParent_Done,
     /* 280307 */   // Label 5427: @280307
     /* 280307 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(280399), // Rule ID 5582 //
     /* 280312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 280320 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 280327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 280331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 280339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 280352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 280356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280360 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280367 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 280367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 280370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 280374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280379 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 280383 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 280387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 280392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280397 */     GIR_RootConstrainSelectedInstOperands,
     /* 280398 */     // GIR_Coverage, 5582,
     /* 280398 */     GIR_EraseRootFromParent_Done,
     /* 280399 */   // Label 5428: @280399
     /* 280399 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(280452), // Rule ID 2161 //
     /* 280404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 280415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280424 */     // MIs[1] imm
     /* 280424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280432 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 280436 */     // MIs[2] Operand 1
     /* 280436 */     // No operand predicates
     /* 280436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280438 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 280438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 280441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 280450 */     GIR_RootConstrainSelectedInstOperands,
     /* 280451 */     // GIR_Coverage, 2161,
     /* 280451 */     GIR_EraseRootFromParent_Done,
     /* 280452 */   // Label 5429: @280452
     /* 280452 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(280502), // Rule ID 6399 //
     /* 280457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280474 */     // MIs[1] imm
     /* 280474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280482 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 280486 */     // MIs[2] Operand 1
     /* 280486 */     // No operand predicates
     /* 280486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280488 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 280488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 280491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 280500 */     GIR_RootConstrainSelectedInstOperands,
     /* 280501 */     // GIR_Coverage, 6399,
     /* 280501 */     GIR_EraseRootFromParent_Done,
     /* 280502 */   // Label 5430: @280502
     /* 280502 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(280553), // Rule ID 5610 //
     /* 280507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 280515 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 280522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 280526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280538 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 280538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 280541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 280547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 280551 */     GIR_RootConstrainSelectedInstOperands,
     /* 280552 */     // GIR_Coverage, 5610,
     /* 280552 */     GIR_EraseRootFromParent_Done,
     /* 280553 */   // Label 5431: @280553
     /* 280553 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(280572), // Rule ID 1098 //
     /* 280558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280565 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 280565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 280570 */     GIR_RootConstrainSelectedInstOperands,
     /* 280571 */     // GIR_Coverage, 1098,
     /* 280571 */     GIR_Done,
     /* 280572 */   // Label 5432: @280572
     /* 280572 */   GIM_Reject,
     /* 280573 */ // Label 5424: @280573
     /* 280573 */ GIM_Reject,
     /* 280574 */ // Label 5414: @280574
     /* 280574 */ GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(281072),
     /* 280579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280586 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(280664), // Rule ID 5454 //
     /* 280591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 280611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280628 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280634 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 280636 */     // MIs[1] Operand 2
     /* 280636 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 280647 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280649 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 280649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 280652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 280658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280662 */     GIR_RootConstrainSelectedInstOperands,
     /* 280663 */     // GIR_Coverage, 5454,
     /* 280663 */     GIR_EraseRootFromParent_Done,
     /* 280664 */   // Label 5434: @280664
     /* 280664 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(280735), // Rule ID 5450 //
     /* 280669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 280689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280707 */     // MIs[1] Operand 2
     /* 280707 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 280718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280720 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 280723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 280733 */     GIR_RootConstrainSelectedInstOperands,
     /* 280734 */     // GIR_Coverage, 5450,
     /* 280734 */     GIR_EraseRootFromParent_Done,
     /* 280735 */   // Label 5435: @280735
     /* 280735 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(280806), // Rule ID 5452 //
     /* 280740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280778 */     // MIs[1] Operand 2
     /* 280778 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 280789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280791 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 280794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 280804 */     GIR_RootConstrainSelectedInstOperands,
     /* 280805 */     // GIR_Coverage, 5452,
     /* 280805 */     GIR_EraseRootFromParent_Done,
     /* 280806 */   // Label 5436: @280806
     /* 280806 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(280898), // Rule ID 5555 //
     /* 280811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 280819 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 280826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 280830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 280838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 280851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 280855 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280859 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280866 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 280866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 280869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 280873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 280882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 280886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 280891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280896 */     GIR_RootConstrainSelectedInstOperands,
     /* 280897 */     // GIR_Coverage, 5555,
     /* 280897 */     GIR_EraseRootFromParent_Done,
     /* 280898 */   // Label 5437: @280898
     /* 280898 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(280951), // Rule ID 2160 //
     /* 280903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 280914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280923 */     // MIs[1] imm
     /* 280923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280931 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 280935 */     // MIs[2] Operand 1
     /* 280935 */     // No operand predicates
     /* 280935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280937 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 280937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 280940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 280949 */     GIR_RootConstrainSelectedInstOperands,
     /* 280950 */     // GIR_Coverage, 2160,
     /* 280950 */     GIR_EraseRootFromParent_Done,
     /* 280951 */   // Label 5438: @280951
     /* 280951 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(281001), // Rule ID 6398 //
     /* 280956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280973 */     // MIs[1] imm
     /* 280973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280981 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 280985 */     // MIs[2] Operand 1
     /* 280985 */     // No operand predicates
     /* 280985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280987 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 280987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 280990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 280999 */     GIR_RootConstrainSelectedInstOperands,
     /* 281000 */     // GIR_Coverage, 6398,
     /* 281000 */     GIR_EraseRootFromParent_Done,
     /* 281001 */   // Label 5439: @281001
     /* 281001 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(281052), // Rule ID 5609 //
     /* 281006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 281014 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 281021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 281025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281037 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 281037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 281040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 281046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 281050 */     GIR_RootConstrainSelectedInstOperands,
     /* 281051 */     // GIR_Coverage, 5609,
     /* 281051 */     GIR_EraseRootFromParent_Done,
     /* 281052 */   // Label 5440: @281052
     /* 281052 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(281071), // Rule ID 1097 //
     /* 281057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281064 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 281064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 281069 */     GIR_RootConstrainSelectedInstOperands,
     /* 281070 */     // GIR_Coverage, 1097,
     /* 281070 */     GIR_Done,
     /* 281071 */   // Label 5441: @281071
     /* 281071 */   GIM_Reject,
     /* 281072 */ // Label 5433: @281072
     /* 281072 */ GIM_Reject,
     /* 281073 */ // Label 5415: @281073
     /* 281073 */ GIM_Reject,
     /* 281074 */ // Label 41: @281074
     /* 281074 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5444*/ GIMT_Encode4(281193),
     /* 281085 */ /*GILLT_s32*//*Label 5442*/ GIMT_Encode4(281093),
     /* 281089 */ /*GILLT_s64*//*Label 5443*/ GIMT_Encode4(281113),
     /* 281093 */ // Label 5442: @281093
     /* 281093 */ GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(281112), // Rule ID 81 //
     /* 281098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281102 */   // MIs[0] Operand 1
     /* 281102 */   // No operand predicates
     /* 281102 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 281102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 281105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281107 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 281110 */   GIR_RootConstrainSelectedInstOperands,
     /* 281111 */   // GIR_Coverage, 81,
     /* 281111 */   GIR_EraseRootFromParent_Done,
     /* 281112 */ // Label 5445: @281112
     /* 281112 */ GIM_Reject,
     /* 281113 */ // Label 5443: @281113
     /* 281113 */ GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(281173), // Rule ID 3905 //
     /* 281118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 281121 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 281125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 281129 */   // MIs[0] Operand 1
     /* 281129 */   // No operand predicates
     /* 281129 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 281129 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 281132 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 281136 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281141 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 281146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 281151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281156 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 281162 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 281167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281172 */   // GIR_Coverage, 3905,
     /* 281172 */   GIR_EraseRootFromParent_Done,
     /* 281173 */ // Label 5446: @281173
     /* 281173 */ GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(281192), // Rule ID 82 //
     /* 281178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281182 */   // MIs[0] Operand 1
     /* 281182 */   // No operand predicates
     /* 281182 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 281182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 281185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281187 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 281190 */   GIR_RootConstrainSelectedInstOperands,
     /* 281191 */   // GIR_Coverage, 82,
     /* 281191 */   GIR_EraseRootFromParent_Done,
     /* 281192 */ // Label 5447: @281192
     /* 281192 */ GIM_Reject,
     /* 281193 */ // Label 5444: @281193
     /* 281193 */ GIM_Reject,
     /* 281194 */ // Label 42: @281194
     /* 281194 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5451*/ GIMT_Encode4(281434),
     /* 281205 */ /*GILLT_s16*//*Label 5448*/ GIMT_Encode4(281217),
     /* 281209 */ /*GILLT_s32*//*Label 5449*/ GIMT_Encode4(281269),
     /* 281213 */ /*GILLT_s64*//*Label 5450*/ GIMT_Encode4(281382),
     /* 281217 */ // Label 5448: @281217
     /* 281217 */ GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(281240), // Rule ID 506 //
     /* 281222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 281225 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 281229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281233 */   // MIs[0] Operand 1
     /* 281233 */   // No operand predicates
     /* 281233 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 281233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 281236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281238 */   GIR_RootConstrainSelectedInstOperands,
     /* 281239 */   // GIR_Coverage, 506,
     /* 281239 */   GIR_EraseRootFromParent_Done,
     /* 281240 */ // Label 5452: @281240
     /* 281240 */ GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(281268), // Rule ID 688 //
     /* 281245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281248 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 281252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281256 */   // MIs[0] Operand 1
     /* 281256 */   // No operand predicates
     /* 281256 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 281256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 281259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281261 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 281266 */   GIR_RootConstrainSelectedInstOperands,
     /* 281267 */   // GIR_Coverage, 688,
     /* 281267 */   GIR_EraseRootFromParent_Done,
     /* 281268 */ // Label 5453: @281268
     /* 281268 */ GIM_Reject,
     /* 281269 */ // Label 5449: @281269
     /* 281269 */ GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(281292), // Rule ID 507 //
     /* 281274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 281277 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 281281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281285 */   // MIs[0] Operand 1
     /* 281285 */   // No operand predicates
     /* 281285 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 281285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 281288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281290 */   GIR_RootConstrainSelectedInstOperands,
     /* 281291 */   // GIR_Coverage, 507,
     /* 281291 */   GIR_EraseRootFromParent_Done,
     /* 281292 */ // Label 5454: @281292
     /* 281292 */ GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(281320), // Rule ID 689 //
     /* 281297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 281300 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 281304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281308 */   // MIs[0] Operand 1
     /* 281308 */   // No operand predicates
     /* 281308 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 281308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 281311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281313 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 281318 */   GIR_RootConstrainSelectedInstOperands,
     /* 281319 */   // GIR_Coverage, 689,
     /* 281319 */   GIR_EraseRootFromParent_Done,
     /* 281320 */ // Label 5455: @281320
     /* 281320 */ GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(281381), // Rule ID 6087 //
     /* 281325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281328 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 281332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281336 */   // MIs[0] Operand 1
     /* 281336 */   // No operand predicates
     /* 281336 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 281336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 281339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 281343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281348 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 281353 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 281356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281363 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 281370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281375 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281380 */   // GIR_Coverage, 6087,
     /* 281380 */   GIR_EraseRootFromParent_Done,
     /* 281381 */ // Label 5456: @281381
     /* 281381 */ GIM_Reject,
     /* 281382 */ // Label 5450: @281382
     /* 281382 */ GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(281405), // Rule ID 508 //
     /* 281387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 281390 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 281394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281398 */   // MIs[0] Operand 1
     /* 281398 */   // No operand predicates
     /* 281398 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 281398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 281401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281403 */   GIR_RootConstrainSelectedInstOperands,
     /* 281404 */   // GIR_Coverage, 508,
     /* 281404 */   GIR_EraseRootFromParent_Done,
     /* 281405 */ // Label 5457: @281405
     /* 281405 */ GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(281433), // Rule ID 690 //
     /* 281410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 281413 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 281417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281421 */   // MIs[0] Operand 1
     /* 281421 */   // No operand predicates
     /* 281421 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 281421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 281424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281426 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 281431 */   GIR_RootConstrainSelectedInstOperands,
     /* 281432 */   // GIR_Coverage, 690,
     /* 281432 */   GIR_EraseRootFromParent_Done,
     /* 281433 */ // Label 5458: @281433
     /* 281433 */ GIM_Reject,
     /* 281434 */ // Label 5451: @281434
     /* 281434 */ GIM_Reject,
     /* 281435 */ // Label 43: @281435
     /* 281435 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5464*/ GIMT_Encode4(283332),
     /* 281446 */ /*GILLT_s32*//*Label 5459*/ GIMT_Encode4(281482),
     /* 281450 */ /*GILLT_s64*//*Label 5460*/ GIMT_Encode4(282923), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281462 */ /*GILLT_v2s64*//*Label 5461*/ GIMT_Encode4(283146), GIMT_Encode4(0),
     /* 281470 */ /*GILLT_v4s32*//*Label 5462*/ GIMT_Encode4(283208), GIMT_Encode4(0),
     /* 281478 */ /*GILLT_v8s16*//*Label 5463*/ GIMT_Encode4(283270),
     /* 281482 */ // Label 5459: @281482
     /* 281482 */ GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(281602), // Rule ID 13209 //
     /* 281487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 281490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281494 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281498 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281502 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281505 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 281510 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 281514 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281519 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281521 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 663:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 281521 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 281524 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 281528 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281533 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281539 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281542 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281546 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281553 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 281556 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281560 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281565 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281568 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281571 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 281574 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281579 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281584 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 281589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 281592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281600 */   GIR_RootConstrainSelectedInstOperands,
     /* 281601 */   // GIR_Coverage, 13209,
     /* 281601 */   GIR_EraseRootFromParent_Done,
     /* 281602 */ // Label 5465: @281602
     /* 281602 */ GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(281722), // Rule ID 13211 //
     /* 281607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 281610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281614 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281618 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281622 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281625 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 281630 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281634 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281639 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281641 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 663:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 281641 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 281644 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 281648 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281653 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281659 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281662 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281666 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 281676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281685 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281688 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281691 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 281694 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281699 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281704 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 281709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 281712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281714 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281720 */   GIR_RootConstrainSelectedInstOperands,
     /* 281721 */   // GIR_Coverage, 13211,
     /* 281721 */   GIR_EraseRootFromParent_Done,
     /* 281722 */ // Label 5466: @281722
     /* 281722 */ GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(281842), // Rule ID 13213 //
     /* 281727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281734 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281738 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281742 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281745 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 281750 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 281754 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281759 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281761 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 663:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 281761 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 281764 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 281768 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281773 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281779 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281782 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281786 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 281796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281805 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281808 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281811 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 281814 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281819 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281840 */   GIR_RootConstrainSelectedInstOperands,
     /* 281841 */   // GIR_Coverage, 13213,
     /* 281841 */   GIR_EraseRootFromParent_Done,
     /* 281842 */ // Label 5467: @281842
     /* 281842 */ GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(281962), // Rule ID 13215 //
     /* 281847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281854 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281858 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281862 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281865 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 281870 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 281874 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281881 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 663:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 281881 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 281884 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 281888 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281893 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281899 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281902 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281906 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281913 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 281916 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281920 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281925 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281928 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281931 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 281934 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281939 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281944 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281960 */   GIR_RootConstrainSelectedInstOperands,
     /* 281961 */   // GIR_Coverage, 13215,
     /* 281961 */   GIR_EraseRootFromParent_Done,
     /* 281962 */ // Label 5468: @281962
     /* 281962 */ GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(282082), // Rule ID 13231 //
     /* 281967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 281970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281974 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281978 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281982 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281985 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 281990 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 281994 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281999 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282001 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 673:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282001 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 282004 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 282008 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282013 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282019 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282022 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282026 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282033 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282036 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282040 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282045 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282048 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282051 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 282054 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282059 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282064 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 282072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282074 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282080 */   GIR_RootConstrainSelectedInstOperands,
     /* 282081 */   // GIR_Coverage, 13231,
     /* 282081 */   GIR_EraseRootFromParent_Done,
     /* 282082 */ // Label 5469: @282082
     /* 282082 */ GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(282202), // Rule ID 13233 //
     /* 282087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282094 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282098 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282102 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282105 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 282110 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282114 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282119 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282121 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 673:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282121 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 282124 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 282128 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282133 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282139 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282142 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282146 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282153 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282156 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282160 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282165 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282168 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282171 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 282174 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282179 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282184 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 282192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282200 */   GIR_RootConstrainSelectedInstOperands,
     /* 282201 */   // GIR_Coverage, 13233,
     /* 282201 */   GIR_EraseRootFromParent_Done,
     /* 282202 */ // Label 5470: @282202
     /* 282202 */ GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(282322), // Rule ID 13235 //
     /* 282207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282214 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282218 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282222 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282225 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 282230 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282234 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282239 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282241 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 673:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282241 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 282244 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 282248 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282253 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282259 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282262 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282266 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282271 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282285 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282288 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282291 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 282294 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282299 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282304 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 282312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282314 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282320 */   GIR_RootConstrainSelectedInstOperands,
     /* 282321 */   // GIR_Coverage, 13235,
     /* 282321 */   GIR_EraseRootFromParent_Done,
     /* 282322 */ // Label 5471: @282322
     /* 282322 */ GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(282442), // Rule ID 13237 //
     /* 282327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282334 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282342 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282345 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 282350 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282354 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282359 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282361 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 673:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282361 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 282364 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 282368 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282373 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282379 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282382 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282386 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282391 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282393 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282396 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282400 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282405 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282408 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282411 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 282414 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282419 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282424 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 282432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282440 */   GIR_RootConstrainSelectedInstOperands,
     /* 282441 */   // GIR_Coverage, 13237,
     /* 282441 */   GIR_EraseRootFromParent_Done,
     /* 282442 */ // Label 5472: @282442
     /* 282442 */ GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(282562), // Rule ID 13241 //
     /* 282447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282454 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282458 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282462 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282465 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 282470 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282474 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282479 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282481 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 676:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282481 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 282484 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 282488 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282493 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282499 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282502 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282506 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282525 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282528 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282531 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 282534 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282539 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282544 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 282552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282560 */   GIR_RootConstrainSelectedInstOperands,
     /* 282561 */   // GIR_Coverage, 13241,
     /* 282561 */   GIR_EraseRootFromParent_Done,
     /* 282562 */ // Label 5473: @282562
     /* 282562 */ GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(282682), // Rule ID 13243 //
     /* 282567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282574 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282582 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282585 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 282590 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282594 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282599 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282601 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 676:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282601 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 282604 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 282608 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282613 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282619 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282622 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282626 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282645 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282648 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282651 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 282654 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282664 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 282672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282674 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282680 */   GIR_RootConstrainSelectedInstOperands,
     /* 282681 */   // GIR_Coverage, 13243,
     /* 282681 */   GIR_EraseRootFromParent_Done,
     /* 282682 */ // Label 5474: @282682
     /* 282682 */ GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(282802), // Rule ID 13245 //
     /* 282687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282694 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282698 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282702 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282705 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 282710 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282714 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282721 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 676:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282721 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 282724 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 282728 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282733 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282739 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282742 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282746 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282765 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282768 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282771 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 282774 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282779 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282784 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 282792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282800 */   GIR_RootConstrainSelectedInstOperands,
     /* 282801 */   // GIR_Coverage, 13245,
     /* 282801 */   GIR_EraseRootFromParent_Done,
     /* 282802 */ // Label 5475: @282802
     /* 282802 */ GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(282922), // Rule ID 13247 //
     /* 282807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282814 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282818 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282822 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282825 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 282830 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282834 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282839 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282841 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 676:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282841 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 282844 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 282848 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282853 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282859 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282862 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282866 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282873 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282876 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282880 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282885 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282888 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282891 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 282894 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282899 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282904 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 282912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282914 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282920 */   GIR_RootConstrainSelectedInstOperands,
     /* 282921 */   // GIR_Coverage, 13247,
     /* 282921 */   GIR_EraseRootFromParent_Done,
     /* 282922 */ // Label 5476: @282922
     /* 282922 */ GIM_Reject,
     /* 282923 */ // Label 5460: @282923
     /* 282923 */ GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(283145),
     /* 282928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 282931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282935 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(282989), // Rule ID 5693 //
     /* 282940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282969 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 282973 */     // MIs[2] Operand 1
     /* 282973 */     // No operand predicates
     /* 282973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282975 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 282975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 282978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 282984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282987 */     GIR_RootConstrainSelectedInstOperands,
     /* 282988 */     // GIR_Coverage, 5693,
     /* 282988 */     GIR_EraseRootFromParent_Done,
     /* 282989 */   // Label 5478: @282989
     /* 282989 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(283068), // Rule ID 11302 //
     /* 282994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 283009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283021 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283025 */     // MIs[2] Operand 1
     /* 283025 */     // No operand predicates
     /* 283025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283027 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 283027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 283030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283039 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 283045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 283058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 283066 */     GIR_RootConstrainSelectedInstOperands,
     /* 283067 */     // GIR_Coverage, 11302,
     /* 283067 */     GIR_EraseRootFromParent_Done,
     /* 283068 */   // Label 5479: @283068
     /* 283068 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(283144), // Rule ID 6557 //
     /* 283073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283077 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 283077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 283080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283103 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 283106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 283110 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 283113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 283118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 283123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 283131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 283142 */     GIR_RootConstrainSelectedInstOperands,
     /* 283143 */     // GIR_Coverage, 6557,
     /* 283143 */     GIR_EraseRootFromParent_Done,
     /* 283144 */   // Label 5480: @283144
     /* 283144 */   GIM_Reject,
     /* 283145 */ // Label 5477: @283145
     /* 283145 */ GIM_Reject,
     /* 283146 */ // Label 5461: @283146
     /* 283146 */ GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(283207),
     /* 283151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283158 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(283185), // Rule ID 6427 //
     /* 283163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 283170 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 283170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 283173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283183 */     GIR_RootConstrainSelectedInstOperands,
     /* 283184 */     // GIR_Coverage, 6427,
     /* 283184 */     GIR_EraseRootFromParent_Done,
     /* 283185 */   // Label 5482: @283185
     /* 283185 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(283206), // Rule ID 6416 //
     /* 283190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283194 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 283194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 283197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283204 */     GIR_RootConstrainSelectedInstOperands,
     /* 283205 */     // GIR_Coverage, 6416,
     /* 283205 */     GIR_EraseRootFromParent_Done,
     /* 283206 */   // Label 5483: @283206
     /* 283206 */   GIM_Reject,
     /* 283207 */ // Label 5481: @283207
     /* 283207 */ GIM_Reject,
     /* 283208 */ // Label 5462: @283208
     /* 283208 */ GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(283269),
     /* 283213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 283216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283220 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(283247), // Rule ID 6424 //
     /* 283225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 283232 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 283232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 283235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283245 */     GIR_RootConstrainSelectedInstOperands,
     /* 283246 */     // GIR_Coverage, 6424,
     /* 283246 */     GIR_EraseRootFromParent_Done,
     /* 283247 */   // Label 5485: @283247
     /* 283247 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(283268), // Rule ID 6413 //
     /* 283252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283256 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 283256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 283259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283266 */     GIR_RootConstrainSelectedInstOperands,
     /* 283267 */     // GIR_Coverage, 6413,
     /* 283267 */     GIR_EraseRootFromParent_Done,
     /* 283268 */   // Label 5486: @283268
     /* 283268 */   GIM_Reject,
     /* 283269 */ // Label 5484: @283269
     /* 283269 */ GIM_Reject,
     /* 283270 */ // Label 5463: @283270
     /* 283270 */ GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(283331),
     /* 283275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 283278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283282 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(283309), // Rule ID 6421 //
     /* 283287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 283294 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 283294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 283297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283307 */     GIR_RootConstrainSelectedInstOperands,
     /* 283308 */     // GIR_Coverage, 6421,
     /* 283308 */     GIR_EraseRootFromParent_Done,
     /* 283309 */   // Label 5488: @283309
     /* 283309 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(283330), // Rule ID 6410 //
     /* 283314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283318 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 283318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 283321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283328 */     GIR_RootConstrainSelectedInstOperands,
     /* 283329 */     // GIR_Coverage, 6410,
     /* 283329 */     GIR_EraseRootFromParent_Done,
     /* 283330 */   // Label 5489: @283330
     /* 283330 */   GIM_Reject,
     /* 283331 */ // Label 5487: @283331
     /* 283331 */ GIM_Reject,
     /* 283332 */ // Label 5464: @283332
     /* 283332 */ GIM_Reject,
     /* 283333 */ // Label 44: @283333
     /* 283333 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5495*/ GIMT_Encode4(284986),
     /* 283344 */ /*GILLT_s32*//*Label 5490*/ GIMT_Encode4(283424),
     /* 283348 */ /*GILLT_s64*//*Label 5491*/ GIMT_Encode4(283918), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283400 */ /*GILLT_nxv2s64*//*Label 5492*/ GIMT_Encode4(284560), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283412 */ /*GILLT_nxv4s32*//*Label 5493*/ GIMT_Encode4(284769), GIMT_Encode4(0),
     /* 283420 */ /*GILLT_nxv8s16*//*Label 5494*/ GIMT_Encode4(284913),
     /* 283424 */ // Label 5490: @283424
     /* 283424 */ GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(283917),
     /* 283429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 283432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283436 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(283501), // Rule ID 5688 //
     /* 283441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 283453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283470 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 283474 */     // MIs[2] Operand 1
     /* 283474 */     // No operand predicates
     /* 283474 */     // MIs[0] Operand 2
     /* 283474 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 283485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283487 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 283487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 283490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283499 */     GIR_RootConstrainSelectedInstOperands,
     /* 283500 */     // GIR_Coverage, 5688,
     /* 283500 */     GIR_EraseRootFromParent_Done,
     /* 283501 */   // Label 5497: @283501
     /* 283501 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(283566), // Rule ID 5690 //
     /* 283506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283535 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 283539 */     // MIs[2] Operand 1
     /* 283539 */     // No operand predicates
     /* 283539 */     // MIs[0] Operand 2
     /* 283539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 283550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283552 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 283552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 283555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283564 */     GIR_RootConstrainSelectedInstOperands,
     /* 283565 */     // GIR_Coverage, 5690,
     /* 283565 */     GIR_EraseRootFromParent_Done,
     /* 283566 */   // Label 5498: @283566
     /* 283566 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(283631), // Rule ID 5692 //
     /* 283571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283600 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 283604 */     // MIs[2] Operand 1
     /* 283604 */     // No operand predicates
     /* 283604 */     // MIs[0] Operand 2
     /* 283604 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 283615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283617 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 283617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 283620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283629 */     GIR_RootConstrainSelectedInstOperands,
     /* 283630 */     // GIR_Coverage, 5692,
     /* 283630 */     GIR_EraseRootFromParent_Done,
     /* 283631 */   // Label 5499: @283631
     /* 283631 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(283721), // Rule ID 11298 //
     /* 283636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 283651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283663 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 283667 */     // MIs[2] Operand 1
     /* 283667 */     // No operand predicates
     /* 283667 */     // MIs[0] Operand 2
     /* 283667 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 283678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283680 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 283680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 283683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283692 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 283698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 283711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 283719 */     GIR_RootConstrainSelectedInstOperands,
     /* 283720 */     // GIR_Coverage, 11298,
     /* 283720 */     GIR_EraseRootFromParent_Done,
     /* 283721 */   // Label 5500: @283721
     /* 283721 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(283811), // Rule ID 11300 //
     /* 283726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 283741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 283757 */     // MIs[2] Operand 1
     /* 283757 */     // No operand predicates
     /* 283757 */     // MIs[0] Operand 2
     /* 283757 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 283768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283770 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 283770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 283773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283782 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 283788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 283801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 283809 */     GIR_RootConstrainSelectedInstOperands,
     /* 283810 */     // GIR_Coverage, 11300,
     /* 283810 */     GIR_EraseRootFromParent_Done,
     /* 283811 */   // Label 5501: @283811
     /* 283811 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(283846), // Rule ID 6562 //
     /* 283816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283820 */     // MIs[0] Operand 2
     /* 283820 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 283831 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 283831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 283834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283836 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 283838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 283844 */     GIR_RootConstrainSelectedInstOperands,
     /* 283845 */     // GIR_Coverage, 6562,
     /* 283845 */     GIR_EraseRootFromParent_Done,
     /* 283846 */   // Label 5502: @283846
     /* 283846 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(283881), // Rule ID 6563 //
     /* 283851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283855 */     // MIs[0] Operand 2
     /* 283855 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 283866 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 283866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 283869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283871 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 283873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 283879 */     GIR_RootConstrainSelectedInstOperands,
     /* 283880 */     // GIR_Coverage, 6563,
     /* 283880 */     GIR_EraseRootFromParent_Done,
     /* 283881 */   // Label 5503: @283881
     /* 283881 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(283916), // Rule ID 6564 //
     /* 283886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283890 */     // MIs[0] Operand 2
     /* 283890 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 283901 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 283901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 283904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283906 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 283908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283914 */     GIR_RootConstrainSelectedInstOperands,
     /* 283915 */     // GIR_Coverage, 6564,
     /* 283915 */     GIR_EraseRootFromParent_Done,
     /* 283916 */   // Label 5504: @283916
     /* 283916 */   GIM_Reject,
     /* 283917 */ // Label 5496: @283917
     /* 283917 */ GIM_Reject,
     /* 283918 */ // Label 5491: @283918
     /* 283918 */ GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(284559),
     /* 283923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 283926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 283930 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(284007), // Rule ID 5694 //
     /* 283935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 283943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 283951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 283959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 283972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283976 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 283980 */     // MIs[3] Operand 1
     /* 283980 */     // No operand predicates
     /* 283980 */     // MIs[0] Operand 2
     /* 283980 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 283991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283993 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 283993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 283996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 284002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284005 */     GIR_RootConstrainSelectedInstOperands,
     /* 284006 */     // GIR_Coverage, 5694,
     /* 284006 */     GIR_EraseRootFromParent_Done,
     /* 284007 */   // Label 5506: @284007
     /* 284007 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(284084), // Rule ID 5695 //
     /* 284012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 284020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284053 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 284057 */     // MIs[3] Operand 1
     /* 284057 */     // No operand predicates
     /* 284057 */     // MIs[0] Operand 2
     /* 284057 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 284068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284070 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 284070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 284073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 284079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284082 */     GIR_RootConstrainSelectedInstOperands,
     /* 284083 */     // GIR_Coverage, 5695,
     /* 284083 */     GIR_EraseRootFromParent_Done,
     /* 284084 */   // Label 5507: @284084
     /* 284084 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(284186), // Rule ID 11299 //
     /* 284089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 284100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 284116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284128 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 284132 */     // MIs[3] Operand 1
     /* 284132 */     // No operand predicates
     /* 284132 */     // MIs[0] Operand 2
     /* 284132 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 284143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284145 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 284145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 284148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284157 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 284163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 284176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 284184 */     GIR_RootConstrainSelectedInstOperands,
     /* 284185 */     // GIR_Coverage, 11299,
     /* 284185 */     GIR_EraseRootFromParent_Done,
     /* 284186 */   // Label 5508: @284186
     /* 284186 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(284288), // Rule ID 11301 //
     /* 284191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 284202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 284218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284230 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 284234 */     // MIs[3] Operand 1
     /* 284234 */     // No operand predicates
     /* 284234 */     // MIs[0] Operand 2
     /* 284234 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 284245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284247 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 284247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 284250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284259 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 284265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 284278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 284286 */     GIR_RootConstrainSelectedInstOperands,
     /* 284287 */     // GIR_Coverage, 11301,
     /* 284287 */     GIR_EraseRootFromParent_Done,
     /* 284288 */   // Label 5509: @284288
     /* 284288 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(284353), // Rule ID 5689 //
     /* 284293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 284305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284322 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 284326 */     // MIs[2] Operand 1
     /* 284326 */     // No operand predicates
     /* 284326 */     // MIs[0] Operand 2
     /* 284326 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 284337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284339 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 284339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 284342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284351 */     GIR_RootConstrainSelectedInstOperands,
     /* 284352 */     // GIR_Coverage, 5689,
     /* 284352 */     GIR_EraseRootFromParent_Done,
     /* 284353 */   // Label 5510: @284353
     /* 284353 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(284418), // Rule ID 5691 //
     /* 284358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 284391 */     // MIs[2] Operand 1
     /* 284391 */     // No operand predicates
     /* 284391 */     // MIs[0] Operand 2
     /* 284391 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 284402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284404 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 284404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 284407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284416 */     GIR_RootConstrainSelectedInstOperands,
     /* 284417 */     // GIR_Coverage, 5691,
     /* 284417 */     GIR_EraseRootFromParent_Done,
     /* 284418 */   // Label 5511: @284418
     /* 284418 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(284453), // Rule ID 6558 //
     /* 284423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284427 */     // MIs[0] Operand 2
     /* 284427 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 284438 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 284438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 284441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284443 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 284445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 284451 */     GIR_RootConstrainSelectedInstOperands,
     /* 284452 */     // GIR_Coverage, 6558,
     /* 284452 */     GIR_EraseRootFromParent_Done,
     /* 284453 */   // Label 5512: @284453
     /* 284453 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(284488), // Rule ID 6559 //
     /* 284458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284462 */     // MIs[0] Operand 2
     /* 284462 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 284473 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 284473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 284476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284478 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 284480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 284486 */     GIR_RootConstrainSelectedInstOperands,
     /* 284487 */     // GIR_Coverage, 6559,
     /* 284487 */     GIR_EraseRootFromParent_Done,
     /* 284488 */   // Label 5513: @284488
     /* 284488 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(284523), // Rule ID 6560 //
     /* 284493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284497 */     // MIs[0] Operand 2
     /* 284497 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 284508 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 284508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 284511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284513 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 284515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 284521 */     GIR_RootConstrainSelectedInstOperands,
     /* 284522 */     // GIR_Coverage, 6560,
     /* 284522 */     GIR_EraseRootFromParent_Done,
     /* 284523 */   // Label 5514: @284523
     /* 284523 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(284558), // Rule ID 6561 //
     /* 284528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284532 */     // MIs[0] Operand 2
     /* 284532 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 284543 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 284543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 284546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284548 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 284550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284556 */     GIR_RootConstrainSelectedInstOperands,
     /* 284557 */     // GIR_Coverage, 6561,
     /* 284557 */     GIR_EraseRootFromParent_Done,
     /* 284558 */   // Label 5515: @284558
     /* 284558 */   GIM_Reject,
     /* 284559 */ // Label 5505: @284559
     /* 284559 */ GIM_Reject,
     /* 284560 */ // Label 5492: @284560
     /* 284560 */ GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(284768),
     /* 284565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 284568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284572 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(284637), // Rule ID 10570 //
     /* 284577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284580 */     // MIs[0] Operand 2
     /* 284580 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 284591 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 284591 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 284594 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 284598 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284603 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 284606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 284611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 284625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 284627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 284635 */     GIR_RootConstrainSelectedInstOperands,
     /* 284636 */     // GIR_Coverage, 10570,
     /* 284636 */     GIR_EraseRootFromParent_Done,
     /* 284637 */   // Label 5517: @284637
     /* 284637 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(284702), // Rule ID 10571 //
     /* 284642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284645 */     // MIs[0] Operand 2
     /* 284645 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 284656 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 284656 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 284659 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 284663 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284668 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 284671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 284676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 284690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 284692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 284700 */     GIR_RootConstrainSelectedInstOperands,
     /* 284701 */     // GIR_Coverage, 10571,
     /* 284701 */     GIR_EraseRootFromParent_Done,
     /* 284702 */   // Label 5518: @284702
     /* 284702 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(284767), // Rule ID 10572 //
     /* 284707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284710 */     // MIs[0] Operand 2
     /* 284710 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 284721 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 284721 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 284724 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 284728 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284733 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 284736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 284741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 284755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 284757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284763 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 284765 */     GIR_RootConstrainSelectedInstOperands,
     /* 284766 */     // GIR_Coverage, 10572,
     /* 284766 */     GIR_EraseRootFromParent_Done,
     /* 284767 */   // Label 5519: @284767
     /* 284767 */   GIM_Reject,
     /* 284768 */ // Label 5516: @284768
     /* 284768 */ GIM_Reject,
     /* 284769 */ // Label 5493: @284769
     /* 284769 */ GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(284912),
     /* 284774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 284777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284781 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(284846), // Rule ID 10573 //
     /* 284786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284789 */     // MIs[0] Operand 2
     /* 284789 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 284800 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 284800 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 284803 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 284807 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284812 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 284815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 284820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 284834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 284836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 284844 */     GIR_RootConstrainSelectedInstOperands,
     /* 284845 */     // GIR_Coverage, 10573,
     /* 284845 */     GIR_EraseRootFromParent_Done,
     /* 284846 */   // Label 5521: @284846
     /* 284846 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(284911), // Rule ID 10574 //
     /* 284851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284854 */     // MIs[0] Operand 2
     /* 284854 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 284865 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 284865 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 284868 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 284872 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284877 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 284880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 284885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 284899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 284901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 284909 */     GIR_RootConstrainSelectedInstOperands,
     /* 284910 */     // GIR_Coverage, 10574,
     /* 284910 */     GIR_EraseRootFromParent_Done,
     /* 284911 */   // Label 5522: @284911
     /* 284911 */   GIM_Reject,
     /* 284912 */ // Label 5520: @284912
     /* 284912 */ GIM_Reject,
     /* 284913 */ // Label 5494: @284913
     /* 284913 */ GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(284985), // Rule ID 10575 //
     /* 284918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 284924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284928 */   // MIs[0] Operand 2
     /* 284928 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 284939 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 284939 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 284942 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 284946 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284951 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 284954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284956 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 284959 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284963 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 284973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 284975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284978 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284981 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 284983 */   GIR_RootConstrainSelectedInstOperands,
     /* 284984 */   // GIR_Coverage, 10575,
     /* 284984 */   GIR_EraseRootFromParent_Done,
     /* 284985 */ // Label 5523: @284985
     /* 284985 */ GIM_Reject,
     /* 284986 */ // Label 5495: @284986
     /* 284986 */ GIM_Reject,
     /* 284987 */ // Label 45: @284987
     /* 284987 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5528*/ GIMT_Encode4(287765),
     /* 284998 */ /*GILLT_s32*//*Label 5524*/ GIMT_Encode4(285034), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285014 */ /*GILLT_v2s64*//*Label 5525*/ GIMT_Encode4(286835), GIMT_Encode4(0),
     /* 285022 */ /*GILLT_v4s32*//*Label 5526*/ GIMT_Encode4(287145), GIMT_Encode4(0),
     /* 285030 */ /*GILLT_v8s16*//*Label 5527*/ GIMT_Encode4(287455),
     /* 285034 */ // Label 5524: @285034
     /* 285034 */ GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(285184), // Rule ID 13218 //
     /* 285039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 285042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285046 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285050 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285054 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 285057 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 285062 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285066 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285071 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285073 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 728:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 285073 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 285076 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 285080 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285085 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285089 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285091 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 285094 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285098 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285105 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 285108 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285112 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285117 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 285120 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 285123 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 285126 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285131 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285136 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 285141 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285144 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285148 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285153 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 285160 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285165 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285175 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285178 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285183 */   // GIR_Coverage, 13218,
     /* 285183 */   GIR_EraseRootFromParent_Done,
     /* 285184 */ // Label 5529: @285184
     /* 285184 */ GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(285334), // Rule ID 13220 //
     /* 285189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 285192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285196 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285200 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285204 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 285207 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 285212 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 285216 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285221 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285223 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 728:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 285223 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 285226 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 285230 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285235 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285241 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 285244 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285248 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285255 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 285258 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285262 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285267 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 285270 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 285273 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 285276 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285281 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285286 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 285291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285303 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 285310 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285315 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285328 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285333 */   // GIR_Coverage, 13220,
     /* 285333 */   GIR_EraseRootFromParent_Done,
     /* 285334 */ // Label 5530: @285334
     /* 285334 */ GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(285484), // Rule ID 13222 //
     /* 285339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 285342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285346 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285354 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 285357 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 285362 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285366 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285371 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285373 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 728:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 285373 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 285376 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 285380 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285385 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285391 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 285394 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285398 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285405 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 285408 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285412 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285417 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 285420 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 285423 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 285426 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285431 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285436 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285441 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285444 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285448 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285453 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 285460 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285465 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285475 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285478 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285483 */   // GIR_Coverage, 13222,
     /* 285483 */   GIR_EraseRootFromParent_Done,
     /* 285484 */ // Label 5531: @285484
     /* 285484 */ GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(285634), // Rule ID 13224 //
     /* 285489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 285492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285496 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285500 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285504 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 285507 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 285512 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285516 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285521 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285523 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 728:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 285523 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 285526 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 285530 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285535 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285541 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 285544 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285548 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285555 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 285558 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285562 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285567 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 285570 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 285573 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 285576 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285581 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285586 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285603 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 285610 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285625 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285628 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285633 */   // GIR_Coverage, 13224,
     /* 285633 */   GIR_EraseRootFromParent_Done,
     /* 285634 */ // Label 5532: @285634
     /* 285634 */ GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(285784), // Rule ID 13251 //
     /* 285639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 285642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285646 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285650 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285654 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 285657 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 285662 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285666 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285671 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285673 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 285673 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 285676 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 285680 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285685 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285691 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 285694 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285698 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285705 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 285708 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285712 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285717 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 285720 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 285723 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 285726 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285731 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285736 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 285741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285753 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 285760 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285765 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285775 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285783 */   // GIR_Coverage, 13251,
     /* 285783 */   GIR_EraseRootFromParent_Done,
     /* 285784 */ // Label 5533: @285784
     /* 285784 */ GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(285934), // Rule ID 13253 //
     /* 285789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 285792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285796 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285800 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285804 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 285807 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 285812 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 285816 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285821 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285823 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 285823 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 285826 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 285830 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285835 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285841 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 285844 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285848 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285855 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 285858 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285862 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285867 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 285870 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 285873 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 285876 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285881 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285886 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 285891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285903 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 285910 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285915 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285925 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285928 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285933 */   // GIR_Coverage, 13253,
     /* 285933 */   GIR_EraseRootFromParent_Done,
     /* 285934 */ // Label 5534: @285934
     /* 285934 */ GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(286084), // Rule ID 13255 //
     /* 285939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 285942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285946 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285954 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 285957 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 285962 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285966 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285971 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285973 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 285973 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 285976 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 285980 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285985 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285991 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 285994 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285998 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 286005 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 286008 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286012 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286017 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 286020 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 286023 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 286026 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286031 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286036 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286041 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286044 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286048 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286053 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 286060 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286065 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286075 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286078 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286083 */   // GIR_Coverage, 13255,
     /* 286083 */   GIR_EraseRootFromParent_Done,
     /* 286084 */ // Label 5535: @286084
     /* 286084 */ GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(286234), // Rule ID 13257 //
     /* 286089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 286092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286096 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286100 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286104 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 286107 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 286112 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 286116 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286121 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286123 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 286123 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 286126 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 286130 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286135 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 286139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 286141 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 286144 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 286148 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 286155 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 286158 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286162 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286167 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 286170 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 286173 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 286176 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286181 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286186 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286203 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 286210 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286215 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286233 */   // GIR_Coverage, 13257,
     /* 286233 */   GIR_EraseRootFromParent_Done,
     /* 286234 */ // Label 5536: @286234
     /* 286234 */ GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(286384), // Rule ID 13261 //
     /* 286239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 286242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286246 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286250 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286254 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 286257 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 286262 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 286266 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286271 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286273 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 286273 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 286276 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 286280 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286285 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 286289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 286291 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 286294 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 286298 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 286305 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 286308 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286312 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286317 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 286320 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 286323 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 286326 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286331 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286336 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 286341 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286344 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286348 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286353 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 286360 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286375 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286383 */   // GIR_Coverage, 13261,
     /* 286383 */   GIR_EraseRootFromParent_Done,
     /* 286384 */ // Label 5537: @286384
     /* 286384 */ GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(286534), // Rule ID 13263 //
     /* 286389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 286392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286396 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286400 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286404 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 286407 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 286412 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 286416 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286421 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286423 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 286423 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 286426 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 286430 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286435 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 286439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 286441 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 286444 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 286448 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 286455 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 286458 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286462 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286467 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 286470 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 286473 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 286476 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286481 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286486 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 286491 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286494 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286498 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286503 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 286510 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286528 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286533 */   // GIR_Coverage, 13263,
     /* 286533 */   GIR_EraseRootFromParent_Done,
     /* 286534 */ // Label 5538: @286534
     /* 286534 */ GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(286684), // Rule ID 13265 //
     /* 286539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 286542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286546 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286554 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 286557 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 286562 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 286566 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286573 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 286573 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 286576 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 286580 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286585 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 286589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 286591 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 286594 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 286598 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 286605 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 286608 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286612 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286617 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 286620 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 286623 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 286626 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286631 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286636 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286641 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286644 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286648 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286653 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 286660 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286665 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286675 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286678 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286683 */   // GIR_Coverage, 13265,
     /* 286683 */   GIR_EraseRootFromParent_Done,
     /* 286684 */ // Label 5539: @286684
     /* 286684 */ GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(286834), // Rule ID 13267 //
     /* 286689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 286692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286696 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286704 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 286707 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 286712 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 286716 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286721 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286723 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 286723 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 286726 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 286730 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286735 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 286739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 286741 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 286744 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 286748 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 286755 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 286758 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286762 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286767 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 286770 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 286773 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 286776 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286781 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286786 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286791 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286794 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286798 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286803 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 286810 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286815 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286825 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286828 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286833 */   // GIR_Coverage, 13267,
     /* 286833 */   GIR_EraseRootFromParent_Done,
     /* 286834 */ // Label 5540: @286834
     /* 286834 */ GIM_Reject,
     /* 286835 */ // Label 5525: @286835
     /* 286835 */ GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(287144),
     /* 286840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286847 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(286912), // Rule ID 702 //
     /* 286852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286863 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 286866 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 286871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 286875 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 286879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 286888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 286895 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 286895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 286898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 286905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 286910 */     GIR_RootConstrainSelectedInstOperands,
     /* 286911 */     // GIR_Coverage, 702,
     /* 286911 */     GIR_EraseRootFromParent_Done,
     /* 286912 */   // Label 5542: @286912
     /* 286912 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(286977), // Rule ID 1711 //
     /* 286917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286928 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 286931 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 286936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 286940 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 286944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 286953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 286960 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 286960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 286963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 286970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 286975 */     GIR_RootConstrainSelectedInstOperands,
     /* 286976 */     // GIR_Coverage, 1711,
     /* 286976 */     GIR_EraseRootFromParent_Done,
     /* 286977 */   // Label 5543: @286977
     /* 286977 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(287036), // Rule ID 700 //
     /* 286982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286993 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 286996 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 287001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 287005 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 287009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287021 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 287021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 287024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 287030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 287034 */     GIR_RootConstrainSelectedInstOperands,
     /* 287035 */     // GIR_Coverage, 700,
     /* 287035 */     GIR_EraseRootFromParent_Done,
     /* 287036 */   // Label 5544: @287036
     /* 287036 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(287095), // Rule ID 1709 //
     /* 287041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287052 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287055 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 287060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 287064 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 287068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287080 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 287080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 287083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 287089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 287093 */     GIR_RootConstrainSelectedInstOperands,
     /* 287094 */     // GIR_Coverage, 1709,
     /* 287094 */     GIR_EraseRootFromParent_Done,
     /* 287095 */   // Label 5545: @287095
     /* 287095 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(287122), // Rule ID 6426 //
     /* 287100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 287107 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 287107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 287110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287120 */     GIR_RootConstrainSelectedInstOperands,
     /* 287121 */     // GIR_Coverage, 6426,
     /* 287121 */     GIR_EraseRootFromParent_Done,
     /* 287122 */   // Label 5546: @287122
     /* 287122 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(287143), // Rule ID 6417 //
     /* 287127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287131 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 287131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 287134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287141 */     GIR_RootConstrainSelectedInstOperands,
     /* 287142 */     // GIR_Coverage, 6417,
     /* 287142 */     GIR_EraseRootFromParent_Done,
     /* 287143 */   // Label 5547: @287143
     /* 287143 */   GIM_Reject,
     /* 287144 */ // Label 5541: @287144
     /* 287144 */ GIM_Reject,
     /* 287145 */ // Label 5526: @287145
     /* 287145 */ GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(287454),
     /* 287150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 287153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287157 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(287222), // Rule ID 698 //
     /* 287162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287173 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287176 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 287181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 287185 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 287189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 287198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 287205 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 287205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 287208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 287220 */     GIR_RootConstrainSelectedInstOperands,
     /* 287221 */     // GIR_Coverage, 698,
     /* 287221 */     GIR_EraseRootFromParent_Done,
     /* 287222 */   // Label 5549: @287222
     /* 287222 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(287287), // Rule ID 1707 //
     /* 287227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287238 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287241 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 287246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 287250 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 287254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 287263 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 287270 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 287270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 287273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 287285 */     GIR_RootConstrainSelectedInstOperands,
     /* 287286 */     // GIR_Coverage, 1707,
     /* 287286 */     GIR_EraseRootFromParent_Done,
     /* 287287 */   // Label 5550: @287287
     /* 287287 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(287346), // Rule ID 696 //
     /* 287292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287303 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287306 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 287311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 287315 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 287319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287331 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 287331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 287334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 287340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 287344 */     GIR_RootConstrainSelectedInstOperands,
     /* 287345 */     // GIR_Coverage, 696,
     /* 287345 */     GIR_EraseRootFromParent_Done,
     /* 287346 */   // Label 5551: @287346
     /* 287346 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(287405), // Rule ID 1705 //
     /* 287351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287362 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287365 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 287370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 287374 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 287378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287390 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 287390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 287393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 287399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 287403 */     GIR_RootConstrainSelectedInstOperands,
     /* 287404 */     // GIR_Coverage, 1705,
     /* 287404 */     GIR_EraseRootFromParent_Done,
     /* 287405 */   // Label 5552: @287405
     /* 287405 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(287432), // Rule ID 6423 //
     /* 287410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 287417 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 287417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 287420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287430 */     GIR_RootConstrainSelectedInstOperands,
     /* 287431 */     // GIR_Coverage, 6423,
     /* 287431 */     GIR_EraseRootFromParent_Done,
     /* 287432 */   // Label 5553: @287432
     /* 287432 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(287453), // Rule ID 6414 //
     /* 287437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287441 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 287441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 287444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287451 */     GIR_RootConstrainSelectedInstOperands,
     /* 287452 */     // GIR_Coverage, 6414,
     /* 287452 */     GIR_EraseRootFromParent_Done,
     /* 287453 */   // Label 5554: @287453
     /* 287453 */   GIM_Reject,
     /* 287454 */ // Label 5548: @287454
     /* 287454 */ GIM_Reject,
     /* 287455 */ // Label 5527: @287455
     /* 287455 */ GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(287764),
     /* 287460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 287463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287467 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(287532), // Rule ID 694 //
     /* 287472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287483 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287486 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 287491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 287495 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 287499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 287508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 287515 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 725:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 287515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 287518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 287530 */     GIR_RootConstrainSelectedInstOperands,
     /* 287531 */     // GIR_Coverage, 694,
     /* 287531 */     GIR_EraseRootFromParent_Done,
     /* 287532 */   // Label 5556: @287532
     /* 287532 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(287597), // Rule ID 1703 //
     /* 287537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287548 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287551 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 287556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 287560 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 287564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 287573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 287580 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 660:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 287580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 287583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 287595 */     GIR_RootConstrainSelectedInstOperands,
     /* 287596 */     // GIR_Coverage, 1703,
     /* 287596 */     GIR_EraseRootFromParent_Done,
     /* 287597 */   // Label 5557: @287597
     /* 287597 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(287656), // Rule ID 692 //
     /* 287602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287613 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287616 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 287621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 287625 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 287629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287641 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 287641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 287644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 287650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 287654 */     GIR_RootConstrainSelectedInstOperands,
     /* 287655 */     // GIR_Coverage, 692,
     /* 287655 */     GIR_EraseRootFromParent_Done,
     /* 287656 */   // Label 5558: @287656
     /* 287656 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(287715), // Rule ID 1701 //
     /* 287661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287672 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287675 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 287680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 287684 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 287688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287700 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 287700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 287703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 287709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 287713 */     GIR_RootConstrainSelectedInstOperands,
     /* 287714 */     // GIR_Coverage, 1701,
     /* 287714 */     GIR_EraseRootFromParent_Done,
     /* 287715 */   // Label 5559: @287715
     /* 287715 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(287742), // Rule ID 6420 //
     /* 287720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 287727 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 287727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 287730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287740 */     GIR_RootConstrainSelectedInstOperands,
     /* 287741 */     // GIR_Coverage, 6420,
     /* 287741 */     GIR_EraseRootFromParent_Done,
     /* 287742 */   // Label 5560: @287742
     /* 287742 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(287763), // Rule ID 6411 //
     /* 287747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287751 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 287751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 287754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287761 */     GIR_RootConstrainSelectedInstOperands,
     /* 287762 */     // GIR_Coverage, 6411,
     /* 287762 */     GIR_EraseRootFromParent_Done,
     /* 287763 */   // Label 5561: @287763
     /* 287763 */   GIM_Reject,
     /* 287764 */ // Label 5555: @287764
     /* 287764 */ GIM_Reject,
     /* 287765 */ // Label 5528: @287765
     /* 287765 */ GIM_Reject,
     /* 287766 */ // Label 46: @287766
     /* 287766 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5567*/ GIMT_Encode4(288590),
     /* 287777 */ /*GILLT_s32*//*Label 5562*/ GIMT_Encode4(287813),
     /* 287781 */ /*GILLT_s64*//*Label 5563*/ GIMT_Encode4(287990), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 287793 */ /*GILLT_v2s64*//*Label 5564*/ GIMT_Encode4(288163), GIMT_Encode4(0),
     /* 287801 */ /*GILLT_v4s32*//*Label 5565*/ GIMT_Encode4(288308), GIMT_Encode4(0),
     /* 287809 */ /*GILLT_v8s16*//*Label 5566*/ GIMT_Encode4(288449),
     /* 287813 */ // Label 5562: @287813
     /* 287813 */ GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(287989),
     /* 287818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 287821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287832 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(287869), // Rule ID 3935 //
     /* 287837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 287845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287856 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 287859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287867 */     GIR_RootConstrainSelectedInstOperands,
     /* 287868 */     // GIR_Coverage, 3935,
     /* 287868 */     GIR_EraseRootFromParent_Done,
     /* 287869 */   // Label 5569: @287869
     /* 287869 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(287906), // Rule ID 3936 //
     /* 287874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 287882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287893 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 287896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287898 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287904 */     GIR_RootConstrainSelectedInstOperands,
     /* 287905 */     // GIR_Coverage, 3936,
     /* 287905 */     GIR_EraseRootFromParent_Done,
     /* 287906 */   // Label 5570: @287906
     /* 287906 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(287943), // Rule ID 3934 //
     /* 287911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 287919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287930 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 287933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287941 */     GIR_RootConstrainSelectedInstOperands,
     /* 287942 */     // GIR_Coverage, 3934,
     /* 287942 */     GIR_EraseRootFromParent_Done,
     /* 287943 */   // Label 5571: @287943
     /* 287943 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(287988), // Rule ID 3933 //
     /* 287948 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 287948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287960 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 287966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 287979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287986 */     GIR_RootConstrainSelectedInstOperands,
     /* 287987 */     // GIR_Coverage, 3933,
     /* 287987 */     GIR_EraseRootFromParent_Done,
     /* 287988 */   // Label 5572: @287988
     /* 287988 */   GIM_Reject,
     /* 287989 */ // Label 5568: @287989
     /* 287989 */ GIM_Reject,
     /* 287990 */ // Label 5563: @287990
     /* 287990 */ GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(288162),
     /* 287995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 287998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288009 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(288077), // Rule ID 3937 //
     /* 288014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288033 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288045 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288052 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 288068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288075 */     GIR_RootConstrainSelectedInstOperands,
     /* 288076 */     // GIR_Coverage, 3937,
     /* 288076 */     GIR_EraseRootFromParent_Done,
     /* 288077 */   // Label 5574: @288077
     /* 288077 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(288145), // Rule ID 3938 //
     /* 288082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288101 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288113 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288116 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288120 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 288136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288143 */     GIR_RootConstrainSelectedInstOperands,
     /* 288144 */     // GIR_Coverage, 3938,
     /* 288144 */     GIR_EraseRootFromParent_Done,
     /* 288145 */   // Label 5575: @288145
     /* 288145 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(288161), // Rule ID 120 //
     /* 288150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288154 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 288154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 288159 */     GIR_RootConstrainSelectedInstOperands,
     /* 288160 */     // GIR_Coverage, 120,
     /* 288160 */     GIR_Done,
     /* 288161 */   // Label 5576: @288161
     /* 288161 */   GIM_Reject,
     /* 288162 */ // Label 5573: @288162
     /* 288162 */ GIM_Reject,
     /* 288163 */ // Label 5564: @288163
     /* 288163 */ GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(288307),
     /* 288168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 288174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288178 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(288242), // Rule ID 6409 //
     /* 288183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 288208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 288212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 288216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288220 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 288224 */     // MIs[3] Operand 1
     /* 288224 */     // No operand predicates
     /* 288224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288226 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 288226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 288229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288235 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 288240 */     GIR_RootConstrainSelectedInstOperands,
     /* 288241 */     // GIR_Coverage, 6409,
     /* 288241 */     GIR_EraseRootFromParent_Done,
     /* 288242 */   // Label 5578: @288242
     /* 288242 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(288306), // Rule ID 6406 //
     /* 288247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 288272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 288276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 288280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288284 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 288288 */     // MIs[3] Operand 1
     /* 288288 */     // No operand predicates
     /* 288288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288290 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 288290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 288293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288299 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 288304 */     GIR_RootConstrainSelectedInstOperands,
     /* 288305 */     // GIR_Coverage, 6406,
     /* 288305 */     GIR_EraseRootFromParent_Done,
     /* 288306 */   // Label 5579: @288306
     /* 288306 */   GIM_Reject,
     /* 288307 */ // Label 5577: @288307
     /* 288307 */ GIM_Reject,
     /* 288308 */ // Label 5565: @288308
     /* 288308 */ GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(288448),
     /* 288313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 288319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288323 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(288385), // Rule ID 6408 //
     /* 288328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 288340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 288353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 288357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 288361 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288365 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 288369 */     // MIs[3] Operand 1
     /* 288369 */     // No operand predicates
     /* 288369 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288371 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 288371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 288374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 288383 */     GIR_RootConstrainSelectedInstOperands,
     /* 288384 */     // GIR_Coverage, 6408,
     /* 288384 */     GIR_EraseRootFromParent_Done,
     /* 288385 */   // Label 5581: @288385
     /* 288385 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(288447), // Rule ID 6405 //
     /* 288390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 288402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 288415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 288419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 288423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288427 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 288431 */     // MIs[3] Operand 1
     /* 288431 */     // No operand predicates
     /* 288431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288433 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 288433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 288436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 288445 */     GIR_RootConstrainSelectedInstOperands,
     /* 288446 */     // GIR_Coverage, 6405,
     /* 288446 */     GIR_EraseRootFromParent_Done,
     /* 288447 */   // Label 5582: @288447
     /* 288447 */   GIM_Reject,
     /* 288448 */ // Label 5580: @288448
     /* 288448 */ GIM_Reject,
     /* 288449 */ // Label 5566: @288449
     /* 288449 */ GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(288589),
     /* 288454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 288460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288464 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(288526), // Rule ID 6407 //
     /* 288469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 288481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 288494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 288498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 288502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288506 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 288510 */     // MIs[3] Operand 1
     /* 288510 */     // No operand predicates
     /* 288510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288512 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 288512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 288515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 288524 */     GIR_RootConstrainSelectedInstOperands,
     /* 288525 */     // GIR_Coverage, 6407,
     /* 288525 */     GIR_EraseRootFromParent_Done,
     /* 288526 */   // Label 5584: @288526
     /* 288526 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(288588), // Rule ID 6404 //
     /* 288531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 288543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 288556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 288560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 288564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288568 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 288572 */     // MIs[3] Operand 1
     /* 288572 */     // No operand predicates
     /* 288572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288574 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 288574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 288577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 288586 */     GIR_RootConstrainSelectedInstOperands,
     /* 288587 */     // GIR_Coverage, 6404,
     /* 288587 */     GIR_EraseRootFromParent_Done,
     /* 288588 */   // Label 5585: @288588
     /* 288588 */   GIM_Reject,
     /* 288589 */ // Label 5583: @288589
     /* 288589 */ GIM_Reject,
     /* 288590 */ // Label 5567: @288590
     /* 288590 */ GIM_Reject,
     /* 288591 */ // Label 47: @288591
     /* 288591 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5588*/ GIMT_Encode4(289028),
     /* 288602 */ /*GILLT_s32*//*Label 5586*/ GIMT_Encode4(288610),
     /* 288606 */ /*GILLT_s64*//*Label 5587*/ GIMT_Encode4(288821),
     /* 288610 */ // Label 5586: @288610
     /* 288610 */ GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(288820),
     /* 288615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 288618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288629 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(288663), // Rule ID 4024 //
     /* 288634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 288646 */     // MIs[1] Operand 1
     /* 288646 */     // No operand predicates
     /* 288646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288648 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 288648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 288651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 288661 */     GIR_RootConstrainSelectedInstOperands,
     /* 288662 */     // GIR_Coverage, 4024,
     /* 288662 */     GIR_EraseRootFromParent_Done,
     /* 288663 */   // Label 5590: @288663
     /* 288663 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(288700), // Rule ID 3941 //
     /* 288668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 288676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288687 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 288690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288698 */     GIR_RootConstrainSelectedInstOperands,
     /* 288699 */     // GIR_Coverage, 3941,
     /* 288699 */     GIR_EraseRootFromParent_Done,
     /* 288700 */   // Label 5591: @288700
     /* 288700 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(288737), // Rule ID 3942 //
     /* 288705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288724 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 288727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288729 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288735 */     GIR_RootConstrainSelectedInstOperands,
     /* 288736 */     // GIR_Coverage, 3942,
     /* 288736 */     GIR_EraseRootFromParent_Done,
     /* 288737 */   // Label 5592: @288737
     /* 288737 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(288774), // Rule ID 3940 //
     /* 288742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288761 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 288764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288772 */     GIR_RootConstrainSelectedInstOperands,
     /* 288773 */     // GIR_Coverage, 3940,
     /* 288773 */     GIR_EraseRootFromParent_Done,
     /* 288774 */   // Label 5593: @288774
     /* 288774 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(288819), // Rule ID 3939 //
     /* 288779 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 288779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 288782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288791 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 288797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 288810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288817 */     GIR_RootConstrainSelectedInstOperands,
     /* 288818 */     // GIR_Coverage, 3939,
     /* 288818 */     GIR_EraseRootFromParent_Done,
     /* 288819 */   // Label 5594: @288819
     /* 288819 */   GIM_Reject,
     /* 288820 */ // Label 5589: @288820
     /* 288820 */ GIM_Reject,
     /* 288821 */ // Label 5587: @288821
     /* 288821 */ GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(289027),
     /* 288826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 288829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288840 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(288874), // Rule ID 4025 //
     /* 288845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 288857 */     // MIs[1] Operand 1
     /* 288857 */     // No operand predicates
     /* 288857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288859 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 288859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 288862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 288872 */     GIR_RootConstrainSelectedInstOperands,
     /* 288873 */     // GIR_Coverage, 4025,
     /* 288873 */     GIR_EraseRootFromParent_Done,
     /* 288874 */   // Label 5596: @288874
     /* 288874 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(288942), // Rule ID 3943 //
     /* 288879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288898 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288910 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288917 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 288933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288940 */     GIR_RootConstrainSelectedInstOperands,
     /* 288941 */     // GIR_Coverage, 3943,
     /* 288941 */     GIR_EraseRootFromParent_Done,
     /* 288942 */   // Label 5597: @288942
     /* 288942 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(289010), // Rule ID 3944 //
     /* 288947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288966 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288978 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288985 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 289001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289008 */     GIR_RootConstrainSelectedInstOperands,
     /* 289009 */     // GIR_Coverage, 3944,
     /* 289009 */     GIR_EraseRootFromParent_Done,
     /* 289010 */   // Label 5598: @289010
     /* 289010 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(289026), // Rule ID 121 //
     /* 289015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289019 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 289019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 289024 */     GIR_RootConstrainSelectedInstOperands,
     /* 289025 */     // GIR_Coverage, 121,
     /* 289025 */     GIR_Done,
     /* 289026 */   // Label 5599: @289026
     /* 289026 */   GIM_Reject,
     /* 289027 */ // Label 5595: @289027
     /* 289027 */ GIM_Reject,
     /* 289028 */ // Label 5588: @289028
     /* 289028 */ GIM_Reject,
     /* 289029 */ // Label 48: @289029
     /* 289029 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5602*/ GIMT_Encode4(289853),
     /* 289040 */ /*GILLT_s32*//*Label 5600*/ GIMT_Encode4(289048),
     /* 289044 */ /*GILLT_s64*//*Label 5601*/ GIMT_Encode4(289403),
     /* 289048 */ // Label 5600: @289048
     /* 289048 */ GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(289402),
     /* 289053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 289056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 289059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289063 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(289127), // Rule ID 6571 //
     /* 289068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 289076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289085 */     // MIs[1] Operand 2
     /* 289085 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 289096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289104 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 289108 */     // MIs[2] Operand 1
     /* 289108 */     // No operand predicates
     /* 289108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289110 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 289110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 289113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 289119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 289122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 289125 */     GIR_RootConstrainSelectedInstOperands,
     /* 289126 */     // GIR_Coverage, 6571,
     /* 289126 */     GIR_EraseRootFromParent_Done,
     /* 289127 */   // Label 5604: @289127
     /* 289127 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(289191), // Rule ID 6573 //
     /* 289132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 289140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289149 */     // MIs[1] Operand 2
     /* 289149 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 289160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289168 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 289172 */     // MIs[2] Operand 1
     /* 289172 */     // No operand predicates
     /* 289172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289174 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 289174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 289177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 289183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 289186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 289189 */     GIR_RootConstrainSelectedInstOperands,
     /* 289190 */     // GIR_Coverage, 6573,
     /* 289190 */     GIR_EraseRootFromParent_Done,
     /* 289191 */   // Label 5605: @289191
     /* 289191 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(289229), // Rule ID 4022 //
     /* 289196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 289212 */     // MIs[1] Operand 1
     /* 289212 */     // No operand predicates
     /* 289212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289214 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 289214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 289217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 289224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 289227 */     GIR_RootConstrainSelectedInstOperands,
     /* 289228 */     // GIR_Coverage, 4022,
     /* 289228 */     GIR_EraseRootFromParent_Done,
     /* 289229 */   // Label 5606: @289229
     /* 289229 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(289270), // Rule ID 2435 //
     /* 289234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 289246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289257 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 289257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 289260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289268 */     GIR_RootConstrainSelectedInstOperands,
     /* 289269 */     // GIR_Coverage, 2435,
     /* 289269 */     GIR_EraseRootFromParent_Done,
     /* 289270 */   // Label 5607: @289270
     /* 289270 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(289311), // Rule ID 2436 //
     /* 289275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 289287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289298 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 289298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 289301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289309 */     GIR_RootConstrainSelectedInstOperands,
     /* 289310 */     // GIR_Coverage, 2436,
     /* 289310 */     GIR_EraseRootFromParent_Done,
     /* 289311 */   // Label 5608: @289311
     /* 289311 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(289352), // Rule ID 2434 //
     /* 289316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 289328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289339 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 289339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 289342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289350 */     GIR_RootConstrainSelectedInstOperands,
     /* 289351 */     // GIR_Coverage, 2434,
     /* 289351 */     GIR_EraseRootFromParent_Done,
     /* 289352 */   // Label 5609: @289352
     /* 289352 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(289401), // Rule ID 2433 //
     /* 289357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289361 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 289361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289373 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 289379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 289392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289399 */     GIR_RootConstrainSelectedInstOperands,
     /* 289400 */     // GIR_Coverage, 2433,
     /* 289400 */     GIR_EraseRootFromParent_Done,
     /* 289401 */   // Label 5610: @289401
     /* 289401 */   GIM_Reject,
     /* 289402 */ // Label 5603: @289402
     /* 289402 */ GIM_Reject,
     /* 289403 */ // Label 5601: @289403
     /* 289403 */ GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(289852),
     /* 289408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 289411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 289414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289418 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(289482), // Rule ID 6572 //
     /* 289423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 289431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 289435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289440 */     // MIs[1] Operand 2
     /* 289440 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 289451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289459 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 289463 */     // MIs[2] Operand 1
     /* 289463 */     // No operand predicates
     /* 289463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289465 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 289465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 289468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 289474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 289477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 289480 */     GIR_RootConstrainSelectedInstOperands,
     /* 289481 */     // GIR_Coverage, 6572,
     /* 289481 */     GIR_EraseRootFromParent_Done,
     /* 289482 */   // Label 5612: @289482
     /* 289482 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(289546), // Rule ID 6574 //
     /* 289487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 289495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 289499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289504 */     // MIs[1] Operand 2
     /* 289504 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 289515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289523 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 289527 */     // MIs[2] Operand 1
     /* 289527 */     // No operand predicates
     /* 289527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289529 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 289529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 289532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 289538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 289541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 289544 */     GIR_RootConstrainSelectedInstOperands,
     /* 289545 */     // GIR_Coverage, 6574,
     /* 289545 */     GIR_EraseRootFromParent_Done,
     /* 289546 */   // Label 5613: @289546
     /* 289546 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(289649), // Rule ID 6575 //
     /* 289551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 289559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 289580 */     // MIs[2] Operand 1
     /* 289580 */     // No operand predicates
     /* 289580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289582 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 289582 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 289585 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289589 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289608 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289611 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 289615 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 289618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 289623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 289628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 289636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 289644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 289647 */     GIR_RootConstrainSelectedInstOperands,
     /* 289648 */     // GIR_Coverage, 6575,
     /* 289648 */     GIR_EraseRootFromParent_Done,
     /* 289649 */   // Label 5614: @289649
     /* 289649 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(289687), // Rule ID 4023 //
     /* 289654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 289670 */     // MIs[1] Operand 1
     /* 289670 */     // No operand predicates
     /* 289670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289672 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 289672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 289675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 289682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 289685 */     GIR_RootConstrainSelectedInstOperands,
     /* 289686 */     // GIR_Coverage, 4023,
     /* 289686 */     GIR_EraseRootFromParent_Done,
     /* 289687 */   // Label 5615: @289687
     /* 289687 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(289759), // Rule ID 2437 //
     /* 289692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 289704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289715 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 289715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289727 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289734 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 289737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 289742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 289750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289757 */     GIR_RootConstrainSelectedInstOperands,
     /* 289758 */     // GIR_Coverage, 2437,
     /* 289758 */     GIR_EraseRootFromParent_Done,
     /* 289759 */   // Label 5616: @289759
     /* 289759 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(289831), // Rule ID 2438 //
     /* 289764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 289776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289787 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 289787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289799 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289806 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 289809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 289814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 289822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289829 */     GIR_RootConstrainSelectedInstOperands,
     /* 289830 */     // GIR_Coverage, 2438,
     /* 289830 */     GIR_EraseRootFromParent_Done,
     /* 289831 */   // Label 5617: @289831
     /* 289831 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(289851), // Rule ID 119 //
     /* 289836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289844 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 289844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 289849 */     GIR_RootConstrainSelectedInstOperands,
     /* 289850 */     // GIR_Coverage, 119,
     /* 289850 */     GIR_Done,
     /* 289851 */   // Label 5618: @289851
     /* 289851 */   GIM_Reject,
     /* 289852 */ // Label 5611: @289852
     /* 289852 */ GIM_Reject,
     /* 289853 */ // Label 5602: @289853
     /* 289853 */ GIM_Reject,
     /* 289854 */ // Label 49: @289854
     /* 289854 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5621*/ GIMT_Encode4(289983),
     /* 289865 */ /*GILLT_s32*//*Label 5619*/ GIMT_Encode4(289873),
     /* 289869 */ /*GILLT_s64*//*Label 5620*/ GIMT_Encode4(289928),
     /* 289873 */ // Label 5619: @289873
     /* 289873 */ GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(289927), // Rule ID 188 //
     /* 289878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 289881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 289884 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 289887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289899 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289903 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289907 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 289911 */   // MIs[1] Operand 1
     /* 289911 */   // No operand predicates
     /* 289911 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289913 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 289913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 289916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289918 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289920 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 289922 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 289925 */   GIR_RootConstrainSelectedInstOperands,
     /* 289926 */   // GIR_Coverage, 188,
     /* 289926 */   GIR_EraseRootFromParent_Done,
     /* 289927 */ // Label 5622: @289927
     /* 289927 */ GIM_Reject,
     /* 289928 */ // Label 5620: @289928
     /* 289928 */ GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(289982), // Rule ID 189 //
     /* 289933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 289936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 289939 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 289942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289962 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 289966 */   // MIs[1] Operand 1
     /* 289966 */   // No operand predicates
     /* 289966 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289968 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 289968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 289971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289973 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289975 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 289977 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 289980 */   GIR_RootConstrainSelectedInstOperands,
     /* 289981 */   // GIR_Coverage, 189,
     /* 289981 */   GIR_EraseRootFromParent_Done,
     /* 289982 */ // Label 5623: @289982
     /* 289982 */ GIM_Reject,
     /* 289983 */ // Label 5621: @289983
     /* 289983 */ GIM_Reject,
     /* 289984 */ // Label 50: @289984
     /* 289984 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5626*/ GIMT_Encode4(290525),
     /* 289995 */ /*GILLT_s32*//*Label 5624*/ GIMT_Encode4(290003),
     /* 289999 */ /*GILLT_s64*//*Label 5625*/ GIMT_Encode4(290268),
     /* 290003 */ // Label 5624: @290003
     /* 290003 */ GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(290267),
     /* 290008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 290011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 290014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290018 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(290057), // Rule ID 184 //
     /* 290023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 290031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 290044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290046 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 290046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 290049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 290055 */     GIR_RootConstrainSelectedInstOperands,
     /* 290056 */     // GIR_Coverage, 184,
     /* 290056 */     GIR_EraseRootFromParent_Done,
     /* 290057 */   // Label 5628: @290057
     /* 290057 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(290094), // Rule ID 4018 //
     /* 290062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 290078 */     // MIs[1] Operand 1
     /* 290078 */     // No operand predicates
     /* 290078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290080 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 290080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 290083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 290092 */     GIR_RootConstrainSelectedInstOperands,
     /* 290093 */     // GIR_Coverage, 4018,
     /* 290093 */     GIR_EraseRootFromParent_Done,
     /* 290094 */   // Label 5629: @290094
     /* 290094 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(290135), // Rule ID 3947 //
     /* 290099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 290111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290122 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 290122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 290125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290133 */     GIR_RootConstrainSelectedInstOperands,
     /* 290134 */     // GIR_Coverage, 3947,
     /* 290134 */     GIR_EraseRootFromParent_Done,
     /* 290135 */   // Label 5630: @290135
     /* 290135 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(290176), // Rule ID 3948 //
     /* 290140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 290152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290163 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 290163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 290166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290174 */     GIR_RootConstrainSelectedInstOperands,
     /* 290175 */     // GIR_Coverage, 3948,
     /* 290175 */     GIR_EraseRootFromParent_Done,
     /* 290176 */   // Label 5631: @290176
     /* 290176 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(290217), // Rule ID 3946 //
     /* 290181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 290193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290204 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 290204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 290207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290215 */     GIR_RootConstrainSelectedInstOperands,
     /* 290216 */     // GIR_Coverage, 3946,
     /* 290216 */     GIR_EraseRootFromParent_Done,
     /* 290217 */   // Label 5632: @290217
     /* 290217 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(290266), // Rule ID 3945 //
     /* 290222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290226 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 290226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 290229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290238 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 290244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 290257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290264 */     GIR_RootConstrainSelectedInstOperands,
     /* 290265 */     // GIR_Coverage, 3945,
     /* 290265 */     GIR_EraseRootFromParent_Done,
     /* 290266 */   // Label 5633: @290266
     /* 290266 */   GIM_Reject,
     /* 290267 */ // Label 5627: @290267
     /* 290267 */ GIM_Reject,
     /* 290268 */ // Label 5625: @290268
     /* 290268 */ GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(290524),
     /* 290273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 290276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 290279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290283 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(290322), // Rule ID 187 //
     /* 290288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 290296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 290309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290311 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 290311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 290314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 290320 */     GIR_RootConstrainSelectedInstOperands,
     /* 290321 */     // GIR_Coverage, 187,
     /* 290321 */     GIR_EraseRootFromParent_Done,
     /* 290322 */   // Label 5635: @290322
     /* 290322 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(290359), // Rule ID 4019 //
     /* 290327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 290343 */     // MIs[1] Operand 1
     /* 290343 */     // No operand predicates
     /* 290343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290345 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 290345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 290348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 290357 */     GIR_RootConstrainSelectedInstOperands,
     /* 290358 */     // GIR_Coverage, 4019,
     /* 290358 */     GIR_EraseRootFromParent_Done,
     /* 290359 */   // Label 5636: @290359
     /* 290359 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(290431), // Rule ID 3949 //
     /* 290364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 290376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290387 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 290387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 290390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290399 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290406 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 290409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 290414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 290422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290429 */     GIR_RootConstrainSelectedInstOperands,
     /* 290430 */     // GIR_Coverage, 3949,
     /* 290430 */     GIR_EraseRootFromParent_Done,
     /* 290431 */   // Label 5637: @290431
     /* 290431 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(290503), // Rule ID 3950 //
     /* 290436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 290448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290459 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 290459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 290462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290471 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290474 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290478 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 290481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 290486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 290494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290501 */     GIR_RootConstrainSelectedInstOperands,
     /* 290502 */     // GIR_Coverage, 3950,
     /* 290502 */     GIR_EraseRootFromParent_Done,
     /* 290503 */   // Label 5638: @290503
     /* 290503 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(290523), // Rule ID 122 //
     /* 290508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290516 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 290516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 290521 */     GIR_RootConstrainSelectedInstOperands,
     /* 290522 */     // GIR_Coverage, 122,
     /* 290522 */     GIR_Done,
     /* 290523 */   // Label 5639: @290523
     /* 290523 */   GIM_Reject,
     /* 290524 */ // Label 5634: @290524
     /* 290524 */ GIM_Reject,
     /* 290525 */ // Label 5626: @290525
     /* 290525 */ GIM_Reject,
     /* 290526 */ // Label 51: @290526
     /* 290526 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5648*/ GIMT_Encode4(298302),
     /* 290537 */ /*GILLT_s64*//*Label 5640*/ GIMT_Encode4(290573), GIMT_Encode4(0),
     /* 290545 */ /*GILLT_v2s32*//*Label 5641*/ GIMT_Encode4(290966),
     /* 290549 */ /*GILLT_v2s64*//*Label 5642*/ GIMT_Encode4(292014),
     /* 290553 */ /*GILLT_v4s16*//*Label 5643*/ GIMT_Encode4(293062),
     /* 290557 */ /*GILLT_v4s32*//*Label 5644*/ GIMT_Encode4(294110),
     /* 290561 */ /*GILLT_v8s8*//*Label 5645*/ GIMT_Encode4(295158),
     /* 290565 */ /*GILLT_v8s16*//*Label 5646*/ GIMT_Encode4(296206),
     /* 290569 */ /*GILLT_v16s8*//*Label 5647*/ GIMT_Encode4(297254),
     /* 290573 */ // Label 5640: @290573
     /* 290573 */ GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(290965),
     /* 290578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 290581 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 290584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290588 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(290624), // Rule ID 5278 //
     /* 290593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290596 */     // MIs[0] Operand 1
     /* 290596 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290605 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290611 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290615 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 290615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 290618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290622 */     GIR_RootConstrainSelectedInstOperands,
     /* 290623 */     // GIR_Coverage, 5278,
     /* 290623 */     GIR_EraseRootFromParent_Done,
     /* 290624 */   // Label 5650: @290624
     /* 290624 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(290660), // Rule ID 5279 //
     /* 290629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290632 */     // MIs[0] Operand 1
     /* 290632 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290641 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290647 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290651 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 290651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 290654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290658 */     GIR_RootConstrainSelectedInstOperands,
     /* 290659 */     // GIR_Coverage, 5279,
     /* 290659 */     GIR_EraseRootFromParent_Done,
     /* 290660 */   // Label 5651: @290660
     /* 290660 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(290696), // Rule ID 2512 //
     /* 290665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290668 */     // MIs[0] Operand 1
     /* 290668 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290677 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290683 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290687 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 290687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 290690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290694 */     GIR_RootConstrainSelectedInstOperands,
     /* 290695 */     // GIR_Coverage, 2512,
     /* 290695 */     GIR_EraseRootFromParent_Done,
     /* 290696 */   // Label 5652: @290696
     /* 290696 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(290732), // Rule ID 5275 //
     /* 290701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290704 */     // MIs[0] Operand 1
     /* 290704 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290713 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290719 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290723 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 290723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 290726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290730 */     GIR_RootConstrainSelectedInstOperands,
     /* 290731 */     // GIR_Coverage, 5275,
     /* 290731 */     GIR_EraseRootFromParent_Done,
     /* 290732 */   // Label 5653: @290732
     /* 290732 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(290768), // Rule ID 5276 //
     /* 290737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290740 */     // MIs[0] Operand 1
     /* 290740 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290749 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290755 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 290757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290759 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 290759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 290762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290766 */     GIR_RootConstrainSelectedInstOperands,
     /* 290767 */     // GIR_Coverage, 5276,
     /* 290767 */     GIR_EraseRootFromParent_Done,
     /* 290768 */   // Label 5654: @290768
     /* 290768 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(290804), // Rule ID 5277 //
     /* 290773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290776 */     // MIs[0] Operand 1
     /* 290776 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290785 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290791 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290795 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 290795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 290798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290802 */     GIR_RootConstrainSelectedInstOperands,
     /* 290803 */     // GIR_Coverage, 5277,
     /* 290803 */     GIR_EraseRootFromParent_Done,
     /* 290804 */   // Label 5655: @290804
     /* 290804 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(290836), // Rule ID 1608 //
     /* 290809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290812 */     // MIs[0] Operand 1
     /* 290812 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290825 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 290825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 290828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290834 */     GIR_RootConstrainSelectedInstOperands,
     /* 290835 */     // GIR_Coverage, 1608,
     /* 290835 */     GIR_EraseRootFromParent_Done,
     /* 290836 */   // Label 5656: @290836
     /* 290836 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(290868), // Rule ID 1609 //
     /* 290841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290844 */     // MIs[0] Operand 1
     /* 290844 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290857 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 290857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 290860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290866 */     GIR_RootConstrainSelectedInstOperands,
     /* 290867 */     // GIR_Coverage, 1609,
     /* 290867 */     GIR_EraseRootFromParent_Done,
     /* 290868 */   // Label 5657: @290868
     /* 290868 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(290900), // Rule ID 1610 //
     /* 290873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290876 */     // MIs[0] Operand 1
     /* 290876 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290889 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 290889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 290892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290898 */     GIR_RootConstrainSelectedInstOperands,
     /* 290899 */     // GIR_Coverage, 1610,
     /* 290899 */     GIR_EraseRootFromParent_Done,
     /* 290900 */   // Label 5658: @290900
     /* 290900 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(290932), // Rule ID 1611 //
     /* 290905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290908 */     // MIs[0] Operand 1
     /* 290908 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290921 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 290921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 290924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290930 */     GIR_RootConstrainSelectedInstOperands,
     /* 290931 */     // GIR_Coverage, 1611,
     /* 290931 */     GIR_EraseRootFromParent_Done,
     /* 290932 */   // Label 5659: @290932
     /* 290932 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(290964), // Rule ID 1612 //
     /* 290937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290940 */     // MIs[0] Operand 1
     /* 290940 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290953 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 290953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 290956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290962 */     GIR_RootConstrainSelectedInstOperands,
     /* 290963 */     // GIR_Coverage, 1612,
     /* 290963 */     GIR_EraseRootFromParent_Done,
     /* 290964 */   // Label 5660: @290964
     /* 290964 */   GIM_Reject,
     /* 290965 */ // Label 5649: @290965
     /* 290965 */ GIM_Reject,
     /* 290966 */ // Label 5641: @290966
     /* 290966 */ GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(292013),
     /* 290971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 290974 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 290977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290981 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(291021), // Rule ID 754 //
     /* 290986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290989 */     // MIs[0] Operand 1
     /* 290989 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290998 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291004 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291012 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 291015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291019 */     GIR_RootConstrainSelectedInstOperands,
     /* 291020 */     // GIR_Coverage, 754,
     /* 291020 */     GIR_EraseRootFromParent_Done,
     /* 291021 */   // Label 5662: @291021
     /* 291021 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(291061), // Rule ID 761 //
     /* 291026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291029 */     // MIs[0] Operand 1
     /* 291029 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291038 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291044 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291052 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 291055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291059 */     GIR_RootConstrainSelectedInstOperands,
     /* 291060 */     // GIR_Coverage, 761,
     /* 291060 */     GIR_EraseRootFromParent_Done,
     /* 291061 */   // Label 5663: @291061
     /* 291061 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(291098), // Rule ID 5212 //
     /* 291066 */     // MIs[0] Operand 1
     /* 291066 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291075 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291081 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291089 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 291092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291096 */     GIR_RootConstrainSelectedInstOperands,
     /* 291097 */     // GIR_Coverage, 5212,
     /* 291097 */     GIR_EraseRootFromParent_Done,
     /* 291098 */   // Label 5664: @291098
     /* 291098 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(291135), // Rule ID 5219 //
     /* 291103 */     // MIs[0] Operand 1
     /* 291103 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291112 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291118 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291126 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 291129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291133 */     GIR_RootConstrainSelectedInstOperands,
     /* 291134 */     // GIR_Coverage, 5219,
     /* 291134 */     GIR_EraseRootFromParent_Done,
     /* 291135 */   // Label 5665: @291135
     /* 291135 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(291172), // Rule ID 5226 //
     /* 291140 */     // MIs[0] Operand 1
     /* 291140 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291149 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291155 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291163 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 291166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291170 */     GIR_RootConstrainSelectedInstOperands,
     /* 291171 */     // GIR_Coverage, 5226,
     /* 291171 */     GIR_EraseRootFromParent_Done,
     /* 291172 */   // Label 5666: @291172
     /* 291172 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(291209), // Rule ID 5233 //
     /* 291177 */     // MIs[0] Operand 1
     /* 291177 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291186 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291192 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291200 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 291203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291207 */     GIR_RootConstrainSelectedInstOperands,
     /* 291208 */     // GIR_Coverage, 5233,
     /* 291208 */     GIR_EraseRootFromParent_Done,
     /* 291209 */   // Label 5667: @291209
     /* 291209 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(291246), // Rule ID 5240 //
     /* 291214 */     // MIs[0] Operand 1
     /* 291214 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291223 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291229 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291237 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 291240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291244 */     GIR_RootConstrainSelectedInstOperands,
     /* 291245 */     // GIR_Coverage, 5240,
     /* 291245 */     GIR_EraseRootFromParent_Done,
     /* 291246 */   // Label 5668: @291246
     /* 291246 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(291286), // Rule ID 726 //
     /* 291251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291254 */     // MIs[0] Operand 1
     /* 291254 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291267 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291273 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291277 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 291280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291284 */     GIR_RootConstrainSelectedInstOperands,
     /* 291285 */     // GIR_Coverage, 726,
     /* 291285 */     GIR_EraseRootFromParent_Done,
     /* 291286 */   // Label 5669: @291286
     /* 291286 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(291326), // Rule ID 737 //
     /* 291291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291294 */     // MIs[0] Operand 1
     /* 291294 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291307 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291313 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291317 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 291320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291324 */     GIR_RootConstrainSelectedInstOperands,
     /* 291325 */     // GIR_Coverage, 737,
     /* 291325 */     GIR_EraseRootFromParent_Done,
     /* 291326 */   // Label 5670: @291326
     /* 291326 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(291366), // Rule ID 738 //
     /* 291331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291334 */     // MIs[0] Operand 1
     /* 291334 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291347 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291353 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 291355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291357 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 291360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291364 */     GIR_RootConstrainSelectedInstOperands,
     /* 291365 */     // GIR_Coverage, 738,
     /* 291365 */     GIR_EraseRootFromParent_Done,
     /* 291366 */   // Label 5671: @291366
     /* 291366 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(291406), // Rule ID 747 //
     /* 291371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291374 */     // MIs[0] Operand 1
     /* 291374 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291387 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291393 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291397 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 291400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291404 */     GIR_RootConstrainSelectedInstOperands,
     /* 291405 */     // GIR_Coverage, 747,
     /* 291405 */     GIR_EraseRootFromParent_Done,
     /* 291406 */   // Label 5672: @291406
     /* 291406 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(291443), // Rule ID 5177 //
     /* 291411 */     // MIs[0] Operand 1
     /* 291411 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291424 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291430 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291434 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 291437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291441 */     GIR_RootConstrainSelectedInstOperands,
     /* 291442 */     // GIR_Coverage, 5177,
     /* 291442 */     GIR_EraseRootFromParent_Done,
     /* 291443 */   // Label 5673: @291443
     /* 291443 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(291480), // Rule ID 5184 //
     /* 291448 */     // MIs[0] Operand 1
     /* 291448 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291461 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291467 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291471 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 291474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291478 */     GIR_RootConstrainSelectedInstOperands,
     /* 291479 */     // GIR_Coverage, 5184,
     /* 291479 */     GIR_EraseRootFromParent_Done,
     /* 291480 */   // Label 5674: @291480
     /* 291480 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(291517), // Rule ID 5191 //
     /* 291485 */     // MIs[0] Operand 1
     /* 291485 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291498 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291504 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291508 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 291511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291515 */     GIR_RootConstrainSelectedInstOperands,
     /* 291516 */     // GIR_Coverage, 5191,
     /* 291516 */     GIR_EraseRootFromParent_Done,
     /* 291517 */   // Label 5675: @291517
     /* 291517 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(291554), // Rule ID 5198 //
     /* 291522 */     // MIs[0] Operand 1
     /* 291522 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291535 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291541 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291545 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 291548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291552 */     GIR_RootConstrainSelectedInstOperands,
     /* 291553 */     // GIR_Coverage, 5198,
     /* 291553 */     GIR_EraseRootFromParent_Done,
     /* 291554 */   // Label 5676: @291554
     /* 291554 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(291591), // Rule ID 5205 //
     /* 291559 */     // MIs[0] Operand 1
     /* 291559 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291572 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291578 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291582 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 291585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291589 */     GIR_RootConstrainSelectedInstOperands,
     /* 291590 */     // GIR_Coverage, 5205,
     /* 291590 */     GIR_EraseRootFromParent_Done,
     /* 291591 */   // Label 5677: @291591
     /* 291591 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(291623), // Rule ID 1125 //
     /* 291596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291599 */     // MIs[0] Operand 1
     /* 291599 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291612 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 291615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291621 */     GIR_RootConstrainSelectedInstOperands,
     /* 291622 */     // GIR_Coverage, 1125,
     /* 291622 */     GIR_EraseRootFromParent_Done,
     /* 291623 */   // Label 5678: @291623
     /* 291623 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(291655), // Rule ID 1132 //
     /* 291628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291631 */     // MIs[0] Operand 1
     /* 291631 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291644 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 291647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291653 */     GIR_RootConstrainSelectedInstOperands,
     /* 291654 */     // GIR_Coverage, 1132,
     /* 291654 */     GIR_EraseRootFromParent_Done,
     /* 291655 */   // Label 5679: @291655
     /* 291655 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(291687), // Rule ID 1139 //
     /* 291660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291663 */     // MIs[0] Operand 1
     /* 291663 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291676 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 291679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291685 */     GIR_RootConstrainSelectedInstOperands,
     /* 291686 */     // GIR_Coverage, 1139,
     /* 291686 */     GIR_EraseRootFromParent_Done,
     /* 291687 */   // Label 5680: @291687
     /* 291687 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(291719), // Rule ID 1146 //
     /* 291692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291695 */     // MIs[0] Operand 1
     /* 291695 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291708 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 291711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291717 */     GIR_RootConstrainSelectedInstOperands,
     /* 291718 */     // GIR_Coverage, 1146,
     /* 291718 */     GIR_EraseRootFromParent_Done,
     /* 291719 */   // Label 5681: @291719
     /* 291719 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(291751), // Rule ID 1153 //
     /* 291724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291727 */     // MIs[0] Operand 1
     /* 291727 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 291732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291740 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 291743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291749 */     GIR_RootConstrainSelectedInstOperands,
     /* 291750 */     // GIR_Coverage, 1153,
     /* 291750 */     GIR_EraseRootFromParent_Done,
     /* 291751 */   // Label 5682: @291751
     /* 291751 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(291780), // Rule ID 5114 //
     /* 291756 */     // MIs[0] Operand 1
     /* 291756 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291769 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 291772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291778 */     GIR_RootConstrainSelectedInstOperands,
     /* 291779 */     // GIR_Coverage, 5114,
     /* 291779 */     GIR_EraseRootFromParent_Done,
     /* 291780 */   // Label 5683: @291780
     /* 291780 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(291809), // Rule ID 5121 //
     /* 291785 */     // MIs[0] Operand 1
     /* 291785 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291798 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 291801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291807 */     GIR_RootConstrainSelectedInstOperands,
     /* 291808 */     // GIR_Coverage, 5121,
     /* 291808 */     GIR_EraseRootFromParent_Done,
     /* 291809 */   // Label 5684: @291809
     /* 291809 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(291838), // Rule ID 5128 //
     /* 291814 */     // MIs[0] Operand 1
     /* 291814 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291827 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 291830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291836 */     GIR_RootConstrainSelectedInstOperands,
     /* 291837 */     // GIR_Coverage, 5128,
     /* 291837 */     GIR_EraseRootFromParent_Done,
     /* 291838 */   // Label 5685: @291838
     /* 291838 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(291867), // Rule ID 5135 //
     /* 291843 */     // MIs[0] Operand 1
     /* 291843 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291856 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 291859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291865 */     GIR_RootConstrainSelectedInstOperands,
     /* 291866 */     // GIR_Coverage, 5135,
     /* 291866 */     GIR_EraseRootFromParent_Done,
     /* 291867 */   // Label 5686: @291867
     /* 291867 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(291896), // Rule ID 5142 //
     /* 291872 */     // MIs[0] Operand 1
     /* 291872 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 291877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291885 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 291888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291894 */     GIR_RootConstrainSelectedInstOperands,
     /* 291895 */     // GIR_Coverage, 5142,
     /* 291895 */     GIR_EraseRootFromParent_Done,
     /* 291896 */   // Label 5687: @291896
     /* 291896 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(291925), // Rule ID 5149 //
     /* 291901 */     // MIs[0] Operand 1
     /* 291901 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291914 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 291914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 291917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291923 */     GIR_RootConstrainSelectedInstOperands,
     /* 291924 */     // GIR_Coverage, 5149,
     /* 291924 */     GIR_EraseRootFromParent_Done,
     /* 291925 */   // Label 5688: @291925
     /* 291925 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(291954), // Rule ID 5156 //
     /* 291930 */     // MIs[0] Operand 1
     /* 291930 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291943 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 291943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 291946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291952 */     GIR_RootConstrainSelectedInstOperands,
     /* 291953 */     // GIR_Coverage, 5156,
     /* 291953 */     GIR_EraseRootFromParent_Done,
     /* 291954 */   // Label 5689: @291954
     /* 291954 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(291983), // Rule ID 5163 //
     /* 291959 */     // MIs[0] Operand 1
     /* 291959 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 291964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291972 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 291972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 291975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291981 */     GIR_RootConstrainSelectedInstOperands,
     /* 291982 */     // GIR_Coverage, 5163,
     /* 291982 */     GIR_EraseRootFromParent_Done,
     /* 291983 */   // Label 5690: @291983
     /* 291983 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(292012), // Rule ID 5170 //
     /* 291988 */     // MIs[0] Operand 1
     /* 291988 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 291993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292001 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 292001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 292004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292010 */     GIR_RootConstrainSelectedInstOperands,
     /* 292011 */     // GIR_Coverage, 5170,
     /* 292011 */     GIR_EraseRootFromParent_Done,
     /* 292012 */   // Label 5691: @292012
     /* 292012 */   GIM_Reject,
     /* 292013 */ // Label 5661: @292013
     /* 292013 */ GIM_Reject,
     /* 292014 */ // Label 5642: @292014
     /* 292014 */ GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(293061),
     /* 292019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 292022 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 292025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292029 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(292069), // Rule ID 756 //
     /* 292034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292037 */     // MIs[0] Operand 1
     /* 292037 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292046 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292052 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292060 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 292063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292067 */     GIR_RootConstrainSelectedInstOperands,
     /* 292068 */     // GIR_Coverage, 756,
     /* 292068 */     GIR_EraseRootFromParent_Done,
     /* 292069 */   // Label 5693: @292069
     /* 292069 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(292109), // Rule ID 763 //
     /* 292074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292077 */     // MIs[0] Operand 1
     /* 292077 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292086 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292092 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292100 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 292103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292107 */     GIR_RootConstrainSelectedInstOperands,
     /* 292108 */     // GIR_Coverage, 763,
     /* 292108 */     GIR_EraseRootFromParent_Done,
     /* 292109 */   // Label 5694: @292109
     /* 292109 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(292146), // Rule ID 5214 //
     /* 292114 */     // MIs[0] Operand 1
     /* 292114 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292123 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292129 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292137 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 292140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292144 */     GIR_RootConstrainSelectedInstOperands,
     /* 292145 */     // GIR_Coverage, 5214,
     /* 292145 */     GIR_EraseRootFromParent_Done,
     /* 292146 */   // Label 5695: @292146
     /* 292146 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(292183), // Rule ID 5221 //
     /* 292151 */     // MIs[0] Operand 1
     /* 292151 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292160 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292166 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292174 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 292177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292181 */     GIR_RootConstrainSelectedInstOperands,
     /* 292182 */     // GIR_Coverage, 5221,
     /* 292182 */     GIR_EraseRootFromParent_Done,
     /* 292183 */   // Label 5696: @292183
     /* 292183 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(292220), // Rule ID 5228 //
     /* 292188 */     // MIs[0] Operand 1
     /* 292188 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292197 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292203 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292211 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 292214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292218 */     GIR_RootConstrainSelectedInstOperands,
     /* 292219 */     // GIR_Coverage, 5228,
     /* 292219 */     GIR_EraseRootFromParent_Done,
     /* 292220 */   // Label 5697: @292220
     /* 292220 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(292257), // Rule ID 5235 //
     /* 292225 */     // MIs[0] Operand 1
     /* 292225 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292234 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292240 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292248 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 292251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292255 */     GIR_RootConstrainSelectedInstOperands,
     /* 292256 */     // GIR_Coverage, 5235,
     /* 292256 */     GIR_EraseRootFromParent_Done,
     /* 292257 */   // Label 5698: @292257
     /* 292257 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(292294), // Rule ID 5242 //
     /* 292262 */     // MIs[0] Operand 1
     /* 292262 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292271 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292277 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292285 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 292288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292292 */     GIR_RootConstrainSelectedInstOperands,
     /* 292293 */     // GIR_Coverage, 5242,
     /* 292293 */     GIR_EraseRootFromParent_Done,
     /* 292294 */   // Label 5699: @292294
     /* 292294 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(292334), // Rule ID 728 //
     /* 292299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292302 */     // MIs[0] Operand 1
     /* 292302 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292315 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292321 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292325 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 292328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292332 */     GIR_RootConstrainSelectedInstOperands,
     /* 292333 */     // GIR_Coverage, 728,
     /* 292333 */     GIR_EraseRootFromParent_Done,
     /* 292334 */   // Label 5700: @292334
     /* 292334 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(292374), // Rule ID 741 //
     /* 292339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292342 */     // MIs[0] Operand 1
     /* 292342 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292355 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292361 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292365 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 292368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292372 */     GIR_RootConstrainSelectedInstOperands,
     /* 292373 */     // GIR_Coverage, 741,
     /* 292373 */     GIR_EraseRootFromParent_Done,
     /* 292374 */   // Label 5701: @292374
     /* 292374 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(292414), // Rule ID 742 //
     /* 292379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292382 */     // MIs[0] Operand 1
     /* 292382 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292395 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292401 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 292403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292405 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 292408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292412 */     GIR_RootConstrainSelectedInstOperands,
     /* 292413 */     // GIR_Coverage, 742,
     /* 292413 */     GIR_EraseRootFromParent_Done,
     /* 292414 */   // Label 5702: @292414
     /* 292414 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(292454), // Rule ID 749 //
     /* 292419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292422 */     // MIs[0] Operand 1
     /* 292422 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292435 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292441 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292445 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 292448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292452 */     GIR_RootConstrainSelectedInstOperands,
     /* 292453 */     // GIR_Coverage, 749,
     /* 292453 */     GIR_EraseRootFromParent_Done,
     /* 292454 */   // Label 5703: @292454
     /* 292454 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(292491), // Rule ID 5179 //
     /* 292459 */     // MIs[0] Operand 1
     /* 292459 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292472 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292478 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292482 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 292485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292489 */     GIR_RootConstrainSelectedInstOperands,
     /* 292490 */     // GIR_Coverage, 5179,
     /* 292490 */     GIR_EraseRootFromParent_Done,
     /* 292491 */   // Label 5704: @292491
     /* 292491 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(292528), // Rule ID 5186 //
     /* 292496 */     // MIs[0] Operand 1
     /* 292496 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292509 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292515 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292519 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 292522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292526 */     GIR_RootConstrainSelectedInstOperands,
     /* 292527 */     // GIR_Coverage, 5186,
     /* 292527 */     GIR_EraseRootFromParent_Done,
     /* 292528 */   // Label 5705: @292528
     /* 292528 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(292565), // Rule ID 5193 //
     /* 292533 */     // MIs[0] Operand 1
     /* 292533 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292546 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292552 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292556 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 292559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292563 */     GIR_RootConstrainSelectedInstOperands,
     /* 292564 */     // GIR_Coverage, 5193,
     /* 292564 */     GIR_EraseRootFromParent_Done,
     /* 292565 */   // Label 5706: @292565
     /* 292565 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(292602), // Rule ID 5200 //
     /* 292570 */     // MIs[0] Operand 1
     /* 292570 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292583 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292589 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292593 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 292596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292600 */     GIR_RootConstrainSelectedInstOperands,
     /* 292601 */     // GIR_Coverage, 5200,
     /* 292601 */     GIR_EraseRootFromParent_Done,
     /* 292602 */   // Label 5707: @292602
     /* 292602 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(292639), // Rule ID 5207 //
     /* 292607 */     // MIs[0] Operand 1
     /* 292607 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292620 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292626 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292630 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 292633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292637 */     GIR_RootConstrainSelectedInstOperands,
     /* 292638 */     // GIR_Coverage, 5207,
     /* 292638 */     GIR_EraseRootFromParent_Done,
     /* 292639 */   // Label 5708: @292639
     /* 292639 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(292671), // Rule ID 1127 //
     /* 292644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292647 */     // MIs[0] Operand 1
     /* 292647 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292660 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 292660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 292663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292669 */     GIR_RootConstrainSelectedInstOperands,
     /* 292670 */     // GIR_Coverage, 1127,
     /* 292670 */     GIR_EraseRootFromParent_Done,
     /* 292671 */   // Label 5709: @292671
     /* 292671 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(292703), // Rule ID 1134 //
     /* 292676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292679 */     // MIs[0] Operand 1
     /* 292679 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292692 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 292692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 292695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292701 */     GIR_RootConstrainSelectedInstOperands,
     /* 292702 */     // GIR_Coverage, 1134,
     /* 292702 */     GIR_EraseRootFromParent_Done,
     /* 292703 */   // Label 5710: @292703
     /* 292703 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(292735), // Rule ID 1141 //
     /* 292708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292711 */     // MIs[0] Operand 1
     /* 292711 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292724 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 292724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 292727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292733 */     GIR_RootConstrainSelectedInstOperands,
     /* 292734 */     // GIR_Coverage, 1141,
     /* 292734 */     GIR_EraseRootFromParent_Done,
     /* 292735 */   // Label 5711: @292735
     /* 292735 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(292767), // Rule ID 1148 //
     /* 292740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292743 */     // MIs[0] Operand 1
     /* 292743 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 292748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292756 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 292756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 292759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292765 */     GIR_RootConstrainSelectedInstOperands,
     /* 292766 */     // GIR_Coverage, 1148,
     /* 292766 */     GIR_EraseRootFromParent_Done,
     /* 292767 */   // Label 5712: @292767
     /* 292767 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(292799), // Rule ID 1155 //
     /* 292772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292775 */     // MIs[0] Operand 1
     /* 292775 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292788 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 292788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 292791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292797 */     GIR_RootConstrainSelectedInstOperands,
     /* 292798 */     // GIR_Coverage, 1155,
     /* 292798 */     GIR_EraseRootFromParent_Done,
     /* 292799 */   // Label 5713: @292799
     /* 292799 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(292828), // Rule ID 5116 //
     /* 292804 */     // MIs[0] Operand 1
     /* 292804 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292817 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 292817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 292820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292826 */     GIR_RootConstrainSelectedInstOperands,
     /* 292827 */     // GIR_Coverage, 5116,
     /* 292827 */     GIR_EraseRootFromParent_Done,
     /* 292828 */   // Label 5714: @292828
     /* 292828 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(292857), // Rule ID 5123 //
     /* 292833 */     // MIs[0] Operand 1
     /* 292833 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292846 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 292846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 292849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292855 */     GIR_RootConstrainSelectedInstOperands,
     /* 292856 */     // GIR_Coverage, 5123,
     /* 292856 */     GIR_EraseRootFromParent_Done,
     /* 292857 */   // Label 5715: @292857
     /* 292857 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(292886), // Rule ID 5130 //
     /* 292862 */     // MIs[0] Operand 1
     /* 292862 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292875 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 292875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 292878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292884 */     GIR_RootConstrainSelectedInstOperands,
     /* 292885 */     // GIR_Coverage, 5130,
     /* 292885 */     GIR_EraseRootFromParent_Done,
     /* 292886 */   // Label 5716: @292886
     /* 292886 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(292915), // Rule ID 5137 //
     /* 292891 */     // MIs[0] Operand 1
     /* 292891 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 292896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292904 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 292904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 292907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292913 */     GIR_RootConstrainSelectedInstOperands,
     /* 292914 */     // GIR_Coverage, 5137,
     /* 292914 */     GIR_EraseRootFromParent_Done,
     /* 292915 */   // Label 5717: @292915
     /* 292915 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(292944), // Rule ID 5144 //
     /* 292920 */     // MIs[0] Operand 1
     /* 292920 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292933 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 292933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 292936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292942 */     GIR_RootConstrainSelectedInstOperands,
     /* 292943 */     // GIR_Coverage, 5144,
     /* 292943 */     GIR_EraseRootFromParent_Done,
     /* 292944 */   // Label 5718: @292944
     /* 292944 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(292973), // Rule ID 5151 //
     /* 292949 */     // MIs[0] Operand 1
     /* 292949 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292962 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 292962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 292965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292971 */     GIR_RootConstrainSelectedInstOperands,
     /* 292972 */     // GIR_Coverage, 5151,
     /* 292972 */     GIR_EraseRootFromParent_Done,
     /* 292973 */   // Label 5719: @292973
     /* 292973 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(293002), // Rule ID 5158 //
     /* 292978 */     // MIs[0] Operand 1
     /* 292978 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292991 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 292991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 292994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293000 */     GIR_RootConstrainSelectedInstOperands,
     /* 293001 */     // GIR_Coverage, 5158,
     /* 293001 */     GIR_EraseRootFromParent_Done,
     /* 293002 */   // Label 5720: @293002
     /* 293002 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(293031), // Rule ID 5165 //
     /* 293007 */     // MIs[0] Operand 1
     /* 293007 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 293012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293020 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 293020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 293023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293029 */     GIR_RootConstrainSelectedInstOperands,
     /* 293030 */     // GIR_Coverage, 5165,
     /* 293030 */     GIR_EraseRootFromParent_Done,
     /* 293031 */   // Label 5721: @293031
     /* 293031 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(293060), // Rule ID 5172 //
     /* 293036 */     // MIs[0] Operand 1
     /* 293036 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 293041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293049 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 293049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 293052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293058 */     GIR_RootConstrainSelectedInstOperands,
     /* 293059 */     // GIR_Coverage, 5172,
     /* 293059 */     GIR_EraseRootFromParent_Done,
     /* 293060 */   // Label 5722: @293060
     /* 293060 */   GIM_Reject,
     /* 293061 */ // Label 5692: @293061
     /* 293061 */ GIM_Reject,
     /* 293062 */ // Label 5643: @293062
     /* 293062 */ GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(294109),
     /* 293067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 293070 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 293073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293077 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(293117), // Rule ID 752 //
     /* 293082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293085 */     // MIs[0] Operand 1
     /* 293085 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293094 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293100 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293108 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 293111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293115 */     GIR_RootConstrainSelectedInstOperands,
     /* 293116 */     // GIR_Coverage, 752,
     /* 293116 */     GIR_EraseRootFromParent_Done,
     /* 293117 */   // Label 5724: @293117
     /* 293117 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(293157), // Rule ID 759 //
     /* 293122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293125 */     // MIs[0] Operand 1
     /* 293125 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293134 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293140 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293148 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 293151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293155 */     GIR_RootConstrainSelectedInstOperands,
     /* 293156 */     // GIR_Coverage, 759,
     /* 293156 */     GIR_EraseRootFromParent_Done,
     /* 293157 */   // Label 5725: @293157
     /* 293157 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(293194), // Rule ID 5210 //
     /* 293162 */     // MIs[0] Operand 1
     /* 293162 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293171 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293177 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293185 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 293188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293192 */     GIR_RootConstrainSelectedInstOperands,
     /* 293193 */     // GIR_Coverage, 5210,
     /* 293193 */     GIR_EraseRootFromParent_Done,
     /* 293194 */   // Label 5726: @293194
     /* 293194 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(293231), // Rule ID 5217 //
     /* 293199 */     // MIs[0] Operand 1
     /* 293199 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293208 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293214 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293222 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 293225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293229 */     GIR_RootConstrainSelectedInstOperands,
     /* 293230 */     // GIR_Coverage, 5217,
     /* 293230 */     GIR_EraseRootFromParent_Done,
     /* 293231 */   // Label 5727: @293231
     /* 293231 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(293268), // Rule ID 5224 //
     /* 293236 */     // MIs[0] Operand 1
     /* 293236 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293245 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293251 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293259 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 293262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293266 */     GIR_RootConstrainSelectedInstOperands,
     /* 293267 */     // GIR_Coverage, 5224,
     /* 293267 */     GIR_EraseRootFromParent_Done,
     /* 293268 */   // Label 5728: @293268
     /* 293268 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(293305), // Rule ID 5231 //
     /* 293273 */     // MIs[0] Operand 1
     /* 293273 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293282 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293288 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293296 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 293299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293303 */     GIR_RootConstrainSelectedInstOperands,
     /* 293304 */     // GIR_Coverage, 5231,
     /* 293304 */     GIR_EraseRootFromParent_Done,
     /* 293305 */   // Label 5729: @293305
     /* 293305 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(293342), // Rule ID 5238 //
     /* 293310 */     // MIs[0] Operand 1
     /* 293310 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293319 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293325 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293333 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 293336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293340 */     GIR_RootConstrainSelectedInstOperands,
     /* 293341 */     // GIR_Coverage, 5238,
     /* 293341 */     GIR_EraseRootFromParent_Done,
     /* 293342 */   // Label 5730: @293342
     /* 293342 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(293382), // Rule ID 724 //
     /* 293347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293350 */     // MIs[0] Operand 1
     /* 293350 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293363 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293369 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293373 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 293376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293380 */     GIR_RootConstrainSelectedInstOperands,
     /* 293381 */     // GIR_Coverage, 724,
     /* 293381 */     GIR_EraseRootFromParent_Done,
     /* 293382 */   // Label 5731: @293382
     /* 293382 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(293422), // Rule ID 733 //
     /* 293387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293390 */     // MIs[0] Operand 1
     /* 293390 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293403 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293409 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293413 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 293416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293420 */     GIR_RootConstrainSelectedInstOperands,
     /* 293421 */     // GIR_Coverage, 733,
     /* 293421 */     GIR_EraseRootFromParent_Done,
     /* 293422 */   // Label 5732: @293422
     /* 293422 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(293462), // Rule ID 734 //
     /* 293427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293430 */     // MIs[0] Operand 1
     /* 293430 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293443 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293449 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 293451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293453 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 293456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293460 */     GIR_RootConstrainSelectedInstOperands,
     /* 293461 */     // GIR_Coverage, 734,
     /* 293461 */     GIR_EraseRootFromParent_Done,
     /* 293462 */   // Label 5733: @293462
     /* 293462 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(293502), // Rule ID 745 //
     /* 293467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293470 */     // MIs[0] Operand 1
     /* 293470 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293483 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293489 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293493 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 293496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293500 */     GIR_RootConstrainSelectedInstOperands,
     /* 293501 */     // GIR_Coverage, 745,
     /* 293501 */     GIR_EraseRootFromParent_Done,
     /* 293502 */   // Label 5734: @293502
     /* 293502 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(293539), // Rule ID 5175 //
     /* 293507 */     // MIs[0] Operand 1
     /* 293507 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293520 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293526 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293530 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 293533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293537 */     GIR_RootConstrainSelectedInstOperands,
     /* 293538 */     // GIR_Coverage, 5175,
     /* 293538 */     GIR_EraseRootFromParent_Done,
     /* 293539 */   // Label 5735: @293539
     /* 293539 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(293576), // Rule ID 5182 //
     /* 293544 */     // MIs[0] Operand 1
     /* 293544 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293557 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293563 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293567 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 293570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293574 */     GIR_RootConstrainSelectedInstOperands,
     /* 293575 */     // GIR_Coverage, 5182,
     /* 293575 */     GIR_EraseRootFromParent_Done,
     /* 293576 */   // Label 5736: @293576
     /* 293576 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(293613), // Rule ID 5189 //
     /* 293581 */     // MIs[0] Operand 1
     /* 293581 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293594 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293600 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293604 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 293607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293611 */     GIR_RootConstrainSelectedInstOperands,
     /* 293612 */     // GIR_Coverage, 5189,
     /* 293612 */     GIR_EraseRootFromParent_Done,
     /* 293613 */   // Label 5737: @293613
     /* 293613 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(293650), // Rule ID 5196 //
     /* 293618 */     // MIs[0] Operand 1
     /* 293618 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293631 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293637 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293641 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 293644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293648 */     GIR_RootConstrainSelectedInstOperands,
     /* 293649 */     // GIR_Coverage, 5196,
     /* 293649 */     GIR_EraseRootFromParent_Done,
     /* 293650 */   // Label 5738: @293650
     /* 293650 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(293687), // Rule ID 5203 //
     /* 293655 */     // MIs[0] Operand 1
     /* 293655 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293668 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293674 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293678 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 293681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293685 */     GIR_RootConstrainSelectedInstOperands,
     /* 293686 */     // GIR_Coverage, 5203,
     /* 293686 */     GIR_EraseRootFromParent_Done,
     /* 293687 */   // Label 5739: @293687
     /* 293687 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(293719), // Rule ID 1123 //
     /* 293692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293695 */     // MIs[0] Operand 1
     /* 293695 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293708 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 293708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 293711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293717 */     GIR_RootConstrainSelectedInstOperands,
     /* 293718 */     // GIR_Coverage, 1123,
     /* 293718 */     GIR_EraseRootFromParent_Done,
     /* 293719 */   // Label 5740: @293719
     /* 293719 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(293751), // Rule ID 1130 //
     /* 293724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293727 */     // MIs[0] Operand 1
     /* 293727 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293740 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 293740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 293743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293749 */     GIR_RootConstrainSelectedInstOperands,
     /* 293750 */     // GIR_Coverage, 1130,
     /* 293750 */     GIR_EraseRootFromParent_Done,
     /* 293751 */   // Label 5741: @293751
     /* 293751 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(293783), // Rule ID 1137 //
     /* 293756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293759 */     // MIs[0] Operand 1
     /* 293759 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293772 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 293772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 293775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293781 */     GIR_RootConstrainSelectedInstOperands,
     /* 293782 */     // GIR_Coverage, 1137,
     /* 293782 */     GIR_EraseRootFromParent_Done,
     /* 293783 */   // Label 5742: @293783
     /* 293783 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(293815), // Rule ID 1144 //
     /* 293788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293791 */     // MIs[0] Operand 1
     /* 293791 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293804 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 293804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 293807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293813 */     GIR_RootConstrainSelectedInstOperands,
     /* 293814 */     // GIR_Coverage, 1144,
     /* 293814 */     GIR_EraseRootFromParent_Done,
     /* 293815 */   // Label 5743: @293815
     /* 293815 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(293847), // Rule ID 1151 //
     /* 293820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293823 */     // MIs[0] Operand 1
     /* 293823 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293836 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 293836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 293839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293845 */     GIR_RootConstrainSelectedInstOperands,
     /* 293846 */     // GIR_Coverage, 1151,
     /* 293846 */     GIR_EraseRootFromParent_Done,
     /* 293847 */   // Label 5744: @293847
     /* 293847 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(293876), // Rule ID 5112 //
     /* 293852 */     // MIs[0] Operand 1
     /* 293852 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293865 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 293865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 293868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293874 */     GIR_RootConstrainSelectedInstOperands,
     /* 293875 */     // GIR_Coverage, 5112,
     /* 293875 */     GIR_EraseRootFromParent_Done,
     /* 293876 */   // Label 5745: @293876
     /* 293876 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(293905), // Rule ID 5119 //
     /* 293881 */     // MIs[0] Operand 1
     /* 293881 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293894 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 293894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 293897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293903 */     GIR_RootConstrainSelectedInstOperands,
     /* 293904 */     // GIR_Coverage, 5119,
     /* 293904 */     GIR_EraseRootFromParent_Done,
     /* 293905 */   // Label 5746: @293905
     /* 293905 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(293934), // Rule ID 5126 //
     /* 293910 */     // MIs[0] Operand 1
     /* 293910 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293923 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 293923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 293926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293932 */     GIR_RootConstrainSelectedInstOperands,
     /* 293933 */     // GIR_Coverage, 5126,
     /* 293933 */     GIR_EraseRootFromParent_Done,
     /* 293934 */   // Label 5747: @293934
     /* 293934 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(293963), // Rule ID 5133 //
     /* 293939 */     // MIs[0] Operand 1
     /* 293939 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293952 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 293952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 293955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293961 */     GIR_RootConstrainSelectedInstOperands,
     /* 293962 */     // GIR_Coverage, 5133,
     /* 293962 */     GIR_EraseRootFromParent_Done,
     /* 293963 */   // Label 5748: @293963
     /* 293963 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(293992), // Rule ID 5140 //
     /* 293968 */     // MIs[0] Operand 1
     /* 293968 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293981 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 293981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 293984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293990 */     GIR_RootConstrainSelectedInstOperands,
     /* 293991 */     // GIR_Coverage, 5140,
     /* 293991 */     GIR_EraseRootFromParent_Done,
     /* 293992 */   // Label 5749: @293992
     /* 293992 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(294021), // Rule ID 5147 //
     /* 293997 */     // MIs[0] Operand 1
     /* 293997 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294010 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 294010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 294013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294019 */     GIR_RootConstrainSelectedInstOperands,
     /* 294020 */     // GIR_Coverage, 5147,
     /* 294020 */     GIR_EraseRootFromParent_Done,
     /* 294021 */   // Label 5750: @294021
     /* 294021 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(294050), // Rule ID 5154 //
     /* 294026 */     // MIs[0] Operand 1
     /* 294026 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294039 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 294039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 294042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294048 */     GIR_RootConstrainSelectedInstOperands,
     /* 294049 */     // GIR_Coverage, 5154,
     /* 294049 */     GIR_EraseRootFromParent_Done,
     /* 294050 */   // Label 5751: @294050
     /* 294050 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(294079), // Rule ID 5161 //
     /* 294055 */     // MIs[0] Operand 1
     /* 294055 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 294060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294068 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 294068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 294071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294077 */     GIR_RootConstrainSelectedInstOperands,
     /* 294078 */     // GIR_Coverage, 5161,
     /* 294078 */     GIR_EraseRootFromParent_Done,
     /* 294079 */   // Label 5752: @294079
     /* 294079 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(294108), // Rule ID 5168 //
     /* 294084 */     // MIs[0] Operand 1
     /* 294084 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 294089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294097 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 294097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 294100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294106 */     GIR_RootConstrainSelectedInstOperands,
     /* 294107 */     // GIR_Coverage, 5168,
     /* 294107 */     GIR_EraseRootFromParent_Done,
     /* 294108 */   // Label 5753: @294108
     /* 294108 */   GIM_Reject,
     /* 294109 */ // Label 5723: @294109
     /* 294109 */ GIM_Reject,
     /* 294110 */ // Label 5644: @294110
     /* 294110 */ GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(295157),
     /* 294115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 294118 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 294121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294125 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(294165), // Rule ID 755 //
     /* 294130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294133 */     // MIs[0] Operand 1
     /* 294133 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294142 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294148 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294156 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 294159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294163 */     GIR_RootConstrainSelectedInstOperands,
     /* 294164 */     // GIR_Coverage, 755,
     /* 294164 */     GIR_EraseRootFromParent_Done,
     /* 294165 */   // Label 5755: @294165
     /* 294165 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(294205), // Rule ID 762 //
     /* 294170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294173 */     // MIs[0] Operand 1
     /* 294173 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294182 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294188 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294196 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 294199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294203 */     GIR_RootConstrainSelectedInstOperands,
     /* 294204 */     // GIR_Coverage, 762,
     /* 294204 */     GIR_EraseRootFromParent_Done,
     /* 294205 */   // Label 5756: @294205
     /* 294205 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(294242), // Rule ID 5213 //
     /* 294210 */     // MIs[0] Operand 1
     /* 294210 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294219 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294225 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294233 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 294236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294240 */     GIR_RootConstrainSelectedInstOperands,
     /* 294241 */     // GIR_Coverage, 5213,
     /* 294241 */     GIR_EraseRootFromParent_Done,
     /* 294242 */   // Label 5757: @294242
     /* 294242 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(294279), // Rule ID 5220 //
     /* 294247 */     // MIs[0] Operand 1
     /* 294247 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294256 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294262 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294270 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 294273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294277 */     GIR_RootConstrainSelectedInstOperands,
     /* 294278 */     // GIR_Coverage, 5220,
     /* 294278 */     GIR_EraseRootFromParent_Done,
     /* 294279 */   // Label 5758: @294279
     /* 294279 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(294316), // Rule ID 5227 //
     /* 294284 */     // MIs[0] Operand 1
     /* 294284 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294293 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294299 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294307 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 294310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294314 */     GIR_RootConstrainSelectedInstOperands,
     /* 294315 */     // GIR_Coverage, 5227,
     /* 294315 */     GIR_EraseRootFromParent_Done,
     /* 294316 */   // Label 5759: @294316
     /* 294316 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(294353), // Rule ID 5234 //
     /* 294321 */     // MIs[0] Operand 1
     /* 294321 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294330 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294336 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294344 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 294347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294351 */     GIR_RootConstrainSelectedInstOperands,
     /* 294352 */     // GIR_Coverage, 5234,
     /* 294352 */     GIR_EraseRootFromParent_Done,
     /* 294353 */   // Label 5760: @294353
     /* 294353 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(294390), // Rule ID 5241 //
     /* 294358 */     // MIs[0] Operand 1
     /* 294358 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294367 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294373 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294381 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 294384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294388 */     GIR_RootConstrainSelectedInstOperands,
     /* 294389 */     // GIR_Coverage, 5241,
     /* 294389 */     GIR_EraseRootFromParent_Done,
     /* 294390 */   // Label 5761: @294390
     /* 294390 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(294430), // Rule ID 727 //
     /* 294395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294398 */     // MIs[0] Operand 1
     /* 294398 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294411 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294417 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294421 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 294424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294428 */     GIR_RootConstrainSelectedInstOperands,
     /* 294429 */     // GIR_Coverage, 727,
     /* 294429 */     GIR_EraseRootFromParent_Done,
     /* 294430 */   // Label 5762: @294430
     /* 294430 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(294470), // Rule ID 739 //
     /* 294435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294438 */     // MIs[0] Operand 1
     /* 294438 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294451 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294457 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294461 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 294464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294468 */     GIR_RootConstrainSelectedInstOperands,
     /* 294469 */     // GIR_Coverage, 739,
     /* 294469 */     GIR_EraseRootFromParent_Done,
     /* 294470 */   // Label 5763: @294470
     /* 294470 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(294510), // Rule ID 740 //
     /* 294475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294478 */     // MIs[0] Operand 1
     /* 294478 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294491 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294497 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 294499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294501 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 294504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294508 */     GIR_RootConstrainSelectedInstOperands,
     /* 294509 */     // GIR_Coverage, 740,
     /* 294509 */     GIR_EraseRootFromParent_Done,
     /* 294510 */   // Label 5764: @294510
     /* 294510 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(294550), // Rule ID 748 //
     /* 294515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294518 */     // MIs[0] Operand 1
     /* 294518 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294531 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294537 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294541 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 294544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294548 */     GIR_RootConstrainSelectedInstOperands,
     /* 294549 */     // GIR_Coverage, 748,
     /* 294549 */     GIR_EraseRootFromParent_Done,
     /* 294550 */   // Label 5765: @294550
     /* 294550 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(294587), // Rule ID 5178 //
     /* 294555 */     // MIs[0] Operand 1
     /* 294555 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294568 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294574 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294578 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 294581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294585 */     GIR_RootConstrainSelectedInstOperands,
     /* 294586 */     // GIR_Coverage, 5178,
     /* 294586 */     GIR_EraseRootFromParent_Done,
     /* 294587 */   // Label 5766: @294587
     /* 294587 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(294624), // Rule ID 5185 //
     /* 294592 */     // MIs[0] Operand 1
     /* 294592 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294605 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294611 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294615 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 294618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294622 */     GIR_RootConstrainSelectedInstOperands,
     /* 294623 */     // GIR_Coverage, 5185,
     /* 294623 */     GIR_EraseRootFromParent_Done,
     /* 294624 */   // Label 5767: @294624
     /* 294624 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(294661), // Rule ID 5192 //
     /* 294629 */     // MIs[0] Operand 1
     /* 294629 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294642 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294648 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294652 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 294655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294659 */     GIR_RootConstrainSelectedInstOperands,
     /* 294660 */     // GIR_Coverage, 5192,
     /* 294660 */     GIR_EraseRootFromParent_Done,
     /* 294661 */   // Label 5768: @294661
     /* 294661 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(294698), // Rule ID 5199 //
     /* 294666 */     // MIs[0] Operand 1
     /* 294666 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294679 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294685 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294689 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 294692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294696 */     GIR_RootConstrainSelectedInstOperands,
     /* 294697 */     // GIR_Coverage, 5199,
     /* 294697 */     GIR_EraseRootFromParent_Done,
     /* 294698 */   // Label 5769: @294698
     /* 294698 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(294735), // Rule ID 5206 //
     /* 294703 */     // MIs[0] Operand 1
     /* 294703 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294716 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294722 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294726 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 294729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294733 */     GIR_RootConstrainSelectedInstOperands,
     /* 294734 */     // GIR_Coverage, 5206,
     /* 294734 */     GIR_EraseRootFromParent_Done,
     /* 294735 */   // Label 5770: @294735
     /* 294735 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(294767), // Rule ID 1126 //
     /* 294740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294743 */     // MIs[0] Operand 1
     /* 294743 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294756 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 294756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 294759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294765 */     GIR_RootConstrainSelectedInstOperands,
     /* 294766 */     // GIR_Coverage, 1126,
     /* 294766 */     GIR_EraseRootFromParent_Done,
     /* 294767 */   // Label 5771: @294767
     /* 294767 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(294799), // Rule ID 1133 //
     /* 294772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294775 */     // MIs[0] Operand 1
     /* 294775 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294788 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 294788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 294791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294797 */     GIR_RootConstrainSelectedInstOperands,
     /* 294798 */     // GIR_Coverage, 1133,
     /* 294798 */     GIR_EraseRootFromParent_Done,
     /* 294799 */   // Label 5772: @294799
     /* 294799 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(294831), // Rule ID 1140 //
     /* 294804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294807 */     // MIs[0] Operand 1
     /* 294807 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294820 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 294820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 294823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294829 */     GIR_RootConstrainSelectedInstOperands,
     /* 294830 */     // GIR_Coverage, 1140,
     /* 294830 */     GIR_EraseRootFromParent_Done,
     /* 294831 */   // Label 5773: @294831
     /* 294831 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(294863), // Rule ID 1147 //
     /* 294836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294839 */     // MIs[0] Operand 1
     /* 294839 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294852 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 294852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 294855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294861 */     GIR_RootConstrainSelectedInstOperands,
     /* 294862 */     // GIR_Coverage, 1147,
     /* 294862 */     GIR_EraseRootFromParent_Done,
     /* 294863 */   // Label 5774: @294863
     /* 294863 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(294895), // Rule ID 1154 //
     /* 294868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294871 */     // MIs[0] Operand 1
     /* 294871 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 294876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294884 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 294884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 294887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294893 */     GIR_RootConstrainSelectedInstOperands,
     /* 294894 */     // GIR_Coverage, 1154,
     /* 294894 */     GIR_EraseRootFromParent_Done,
     /* 294895 */   // Label 5775: @294895
     /* 294895 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(294924), // Rule ID 5115 //
     /* 294900 */     // MIs[0] Operand 1
     /* 294900 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294913 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 294913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 294916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294922 */     GIR_RootConstrainSelectedInstOperands,
     /* 294923 */     // GIR_Coverage, 5115,
     /* 294923 */     GIR_EraseRootFromParent_Done,
     /* 294924 */   // Label 5776: @294924
     /* 294924 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(294953), // Rule ID 5122 //
     /* 294929 */     // MIs[0] Operand 1
     /* 294929 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294942 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 294942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 294945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294951 */     GIR_RootConstrainSelectedInstOperands,
     /* 294952 */     // GIR_Coverage, 5122,
     /* 294952 */     GIR_EraseRootFromParent_Done,
     /* 294953 */   // Label 5777: @294953
     /* 294953 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(294982), // Rule ID 5129 //
     /* 294958 */     // MIs[0] Operand 1
     /* 294958 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294971 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 294971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 294974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294980 */     GIR_RootConstrainSelectedInstOperands,
     /* 294981 */     // GIR_Coverage, 5129,
     /* 294981 */     GIR_EraseRootFromParent_Done,
     /* 294982 */   // Label 5778: @294982
     /* 294982 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(295011), // Rule ID 5136 //
     /* 294987 */     // MIs[0] Operand 1
     /* 294987 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295000 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 295000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 295003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295009 */     GIR_RootConstrainSelectedInstOperands,
     /* 295010 */     // GIR_Coverage, 5136,
     /* 295010 */     GIR_EraseRootFromParent_Done,
     /* 295011 */   // Label 5779: @295011
     /* 295011 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(295040), // Rule ID 5143 //
     /* 295016 */     // MIs[0] Operand 1
     /* 295016 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 295021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295029 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 295029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 295032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295038 */     GIR_RootConstrainSelectedInstOperands,
     /* 295039 */     // GIR_Coverage, 5143,
     /* 295039 */     GIR_EraseRootFromParent_Done,
     /* 295040 */   // Label 5780: @295040
     /* 295040 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(295069), // Rule ID 5150 //
     /* 295045 */     // MIs[0] Operand 1
     /* 295045 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295058 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 295058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 295061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295067 */     GIR_RootConstrainSelectedInstOperands,
     /* 295068 */     // GIR_Coverage, 5150,
     /* 295068 */     GIR_EraseRootFromParent_Done,
     /* 295069 */   // Label 5781: @295069
     /* 295069 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(295098), // Rule ID 5157 //
     /* 295074 */     // MIs[0] Operand 1
     /* 295074 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295087 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 295087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 295090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295096 */     GIR_RootConstrainSelectedInstOperands,
     /* 295097 */     // GIR_Coverage, 5157,
     /* 295097 */     GIR_EraseRootFromParent_Done,
     /* 295098 */   // Label 5782: @295098
     /* 295098 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(295127), // Rule ID 5164 //
     /* 295103 */     // MIs[0] Operand 1
     /* 295103 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 295108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295116 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 295116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 295119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295125 */     GIR_RootConstrainSelectedInstOperands,
     /* 295126 */     // GIR_Coverage, 5164,
     /* 295126 */     GIR_EraseRootFromParent_Done,
     /* 295127 */   // Label 5783: @295127
     /* 295127 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(295156), // Rule ID 5171 //
     /* 295132 */     // MIs[0] Operand 1
     /* 295132 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 295137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295145 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 295145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 295148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295154 */     GIR_RootConstrainSelectedInstOperands,
     /* 295155 */     // GIR_Coverage, 5171,
     /* 295155 */     GIR_EraseRootFromParent_Done,
     /* 295156 */   // Label 5784: @295156
     /* 295156 */   GIM_Reject,
     /* 295157 */ // Label 5754: @295157
     /* 295157 */ GIM_Reject,
     /* 295158 */ // Label 5645: @295158
     /* 295158 */ GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(296205),
     /* 295163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 295166 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 295169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295173 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(295213), // Rule ID 750 //
     /* 295178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295181 */     // MIs[0] Operand 1
     /* 295181 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295190 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295196 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295204 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 295207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295211 */     GIR_RootConstrainSelectedInstOperands,
     /* 295212 */     // GIR_Coverage, 750,
     /* 295212 */     GIR_EraseRootFromParent_Done,
     /* 295213 */   // Label 5786: @295213
     /* 295213 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(295253), // Rule ID 757 //
     /* 295218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295221 */     // MIs[0] Operand 1
     /* 295221 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295230 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295236 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295244 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 295247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295251 */     GIR_RootConstrainSelectedInstOperands,
     /* 295252 */     // GIR_Coverage, 757,
     /* 295252 */     GIR_EraseRootFromParent_Done,
     /* 295253 */   // Label 5787: @295253
     /* 295253 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(295290), // Rule ID 5208 //
     /* 295258 */     // MIs[0] Operand 1
     /* 295258 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295267 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295273 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295281 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 295284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295288 */     GIR_RootConstrainSelectedInstOperands,
     /* 295289 */     // GIR_Coverage, 5208,
     /* 295289 */     GIR_EraseRootFromParent_Done,
     /* 295290 */   // Label 5788: @295290
     /* 295290 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(295327), // Rule ID 5215 //
     /* 295295 */     // MIs[0] Operand 1
     /* 295295 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295304 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295310 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295318 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 295321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295325 */     GIR_RootConstrainSelectedInstOperands,
     /* 295326 */     // GIR_Coverage, 5215,
     /* 295326 */     GIR_EraseRootFromParent_Done,
     /* 295327 */   // Label 5789: @295327
     /* 295327 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(295364), // Rule ID 5222 //
     /* 295332 */     // MIs[0] Operand 1
     /* 295332 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295341 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295347 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295355 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 295358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295362 */     GIR_RootConstrainSelectedInstOperands,
     /* 295363 */     // GIR_Coverage, 5222,
     /* 295363 */     GIR_EraseRootFromParent_Done,
     /* 295364 */   // Label 5790: @295364
     /* 295364 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(295401), // Rule ID 5229 //
     /* 295369 */     // MIs[0] Operand 1
     /* 295369 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295378 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295384 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295392 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 295395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295399 */     GIR_RootConstrainSelectedInstOperands,
     /* 295400 */     // GIR_Coverage, 5229,
     /* 295400 */     GIR_EraseRootFromParent_Done,
     /* 295401 */   // Label 5791: @295401
     /* 295401 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(295438), // Rule ID 5236 //
     /* 295406 */     // MIs[0] Operand 1
     /* 295406 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295415 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295421 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295429 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 295432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295436 */     GIR_RootConstrainSelectedInstOperands,
     /* 295437 */     // GIR_Coverage, 5236,
     /* 295437 */     GIR_EraseRootFromParent_Done,
     /* 295438 */   // Label 5792: @295438
     /* 295438 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(295478), // Rule ID 722 //
     /* 295443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295446 */     // MIs[0] Operand 1
     /* 295446 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295459 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295465 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295469 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 295472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295476 */     GIR_RootConstrainSelectedInstOperands,
     /* 295477 */     // GIR_Coverage, 722,
     /* 295477 */     GIR_EraseRootFromParent_Done,
     /* 295478 */   // Label 5793: @295478
     /* 295478 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(295518), // Rule ID 729 //
     /* 295483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295486 */     // MIs[0] Operand 1
     /* 295486 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295499 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295505 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295509 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 295512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295516 */     GIR_RootConstrainSelectedInstOperands,
     /* 295517 */     // GIR_Coverage, 729,
     /* 295517 */     GIR_EraseRootFromParent_Done,
     /* 295518 */   // Label 5794: @295518
     /* 295518 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(295558), // Rule ID 730 //
     /* 295523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295526 */     // MIs[0] Operand 1
     /* 295526 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295539 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295545 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 295547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295549 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 295552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295556 */     GIR_RootConstrainSelectedInstOperands,
     /* 295557 */     // GIR_Coverage, 730,
     /* 295557 */     GIR_EraseRootFromParent_Done,
     /* 295558 */   // Label 5795: @295558
     /* 295558 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(295598), // Rule ID 743 //
     /* 295563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295566 */     // MIs[0] Operand 1
     /* 295566 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295579 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295585 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295589 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 295592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295596 */     GIR_RootConstrainSelectedInstOperands,
     /* 295597 */     // GIR_Coverage, 743,
     /* 295597 */     GIR_EraseRootFromParent_Done,
     /* 295598 */   // Label 5796: @295598
     /* 295598 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(295635), // Rule ID 5173 //
     /* 295603 */     // MIs[0] Operand 1
     /* 295603 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295616 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295622 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295626 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 295629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295633 */     GIR_RootConstrainSelectedInstOperands,
     /* 295634 */     // GIR_Coverage, 5173,
     /* 295634 */     GIR_EraseRootFromParent_Done,
     /* 295635 */   // Label 5797: @295635
     /* 295635 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(295672), // Rule ID 5180 //
     /* 295640 */     // MIs[0] Operand 1
     /* 295640 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295653 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295659 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295663 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 295666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295670 */     GIR_RootConstrainSelectedInstOperands,
     /* 295671 */     // GIR_Coverage, 5180,
     /* 295671 */     GIR_EraseRootFromParent_Done,
     /* 295672 */   // Label 5798: @295672
     /* 295672 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(295709), // Rule ID 5187 //
     /* 295677 */     // MIs[0] Operand 1
     /* 295677 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295690 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295696 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295700 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 295703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295707 */     GIR_RootConstrainSelectedInstOperands,
     /* 295708 */     // GIR_Coverage, 5187,
     /* 295708 */     GIR_EraseRootFromParent_Done,
     /* 295709 */   // Label 5799: @295709
     /* 295709 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(295746), // Rule ID 5194 //
     /* 295714 */     // MIs[0] Operand 1
     /* 295714 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295727 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295733 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295737 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 295740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295744 */     GIR_RootConstrainSelectedInstOperands,
     /* 295745 */     // GIR_Coverage, 5194,
     /* 295745 */     GIR_EraseRootFromParent_Done,
     /* 295746 */   // Label 5800: @295746
     /* 295746 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(295783), // Rule ID 5201 //
     /* 295751 */     // MIs[0] Operand 1
     /* 295751 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295764 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295770 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295774 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 295777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295781 */     GIR_RootConstrainSelectedInstOperands,
     /* 295782 */     // GIR_Coverage, 5201,
     /* 295782 */     GIR_EraseRootFromParent_Done,
     /* 295783 */   // Label 5801: @295783
     /* 295783 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(295815), // Rule ID 1121 //
     /* 295788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295791 */     // MIs[0] Operand 1
     /* 295791 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295804 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 295804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 295807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295813 */     GIR_RootConstrainSelectedInstOperands,
     /* 295814 */     // GIR_Coverage, 1121,
     /* 295814 */     GIR_EraseRootFromParent_Done,
     /* 295815 */   // Label 5802: @295815
     /* 295815 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(295847), // Rule ID 1128 //
     /* 295820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295823 */     // MIs[0] Operand 1
     /* 295823 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295836 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 295836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 295839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295845 */     GIR_RootConstrainSelectedInstOperands,
     /* 295846 */     // GIR_Coverage, 1128,
     /* 295846 */     GIR_EraseRootFromParent_Done,
     /* 295847 */   // Label 5803: @295847
     /* 295847 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(295879), // Rule ID 1135 //
     /* 295852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295855 */     // MIs[0] Operand 1
     /* 295855 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295868 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 295868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 295871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295877 */     GIR_RootConstrainSelectedInstOperands,
     /* 295878 */     // GIR_Coverage, 1135,
     /* 295878 */     GIR_EraseRootFromParent_Done,
     /* 295879 */   // Label 5804: @295879
     /* 295879 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(295911), // Rule ID 1142 //
     /* 295884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295887 */     // MIs[0] Operand 1
     /* 295887 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 295892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295900 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 295900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 295903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295909 */     GIR_RootConstrainSelectedInstOperands,
     /* 295910 */     // GIR_Coverage, 1142,
     /* 295910 */     GIR_EraseRootFromParent_Done,
     /* 295911 */   // Label 5805: @295911
     /* 295911 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(295943), // Rule ID 1149 //
     /* 295916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295919 */     // MIs[0] Operand 1
     /* 295919 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 295924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295932 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 295932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 295935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295941 */     GIR_RootConstrainSelectedInstOperands,
     /* 295942 */     // GIR_Coverage, 1149,
     /* 295942 */     GIR_EraseRootFromParent_Done,
     /* 295943 */   // Label 5806: @295943
     /* 295943 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(295972), // Rule ID 5110 //
     /* 295948 */     // MIs[0] Operand 1
     /* 295948 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295961 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 295961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 295964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295970 */     GIR_RootConstrainSelectedInstOperands,
     /* 295971 */     // GIR_Coverage, 5110,
     /* 295971 */     GIR_EraseRootFromParent_Done,
     /* 295972 */   // Label 5807: @295972
     /* 295972 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(296001), // Rule ID 5117 //
     /* 295977 */     // MIs[0] Operand 1
     /* 295977 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295990 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 295990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 295993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295999 */     GIR_RootConstrainSelectedInstOperands,
     /* 296000 */     // GIR_Coverage, 5117,
     /* 296000 */     GIR_EraseRootFromParent_Done,
     /* 296001 */   // Label 5808: @296001
     /* 296001 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(296030), // Rule ID 5124 //
     /* 296006 */     // MIs[0] Operand 1
     /* 296006 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296019 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 296019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 296022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296028 */     GIR_RootConstrainSelectedInstOperands,
     /* 296029 */     // GIR_Coverage, 5124,
     /* 296029 */     GIR_EraseRootFromParent_Done,
     /* 296030 */   // Label 5809: @296030
     /* 296030 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(296059), // Rule ID 5131 //
     /* 296035 */     // MIs[0] Operand 1
     /* 296035 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 296040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296048 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 296048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 296051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296057 */     GIR_RootConstrainSelectedInstOperands,
     /* 296058 */     // GIR_Coverage, 5131,
     /* 296058 */     GIR_EraseRootFromParent_Done,
     /* 296059 */   // Label 5810: @296059
     /* 296059 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(296088), // Rule ID 5138 //
     /* 296064 */     // MIs[0] Operand 1
     /* 296064 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 296069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296077 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 296077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 296080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296086 */     GIR_RootConstrainSelectedInstOperands,
     /* 296087 */     // GIR_Coverage, 5138,
     /* 296087 */     GIR_EraseRootFromParent_Done,
     /* 296088 */   // Label 5811: @296088
     /* 296088 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(296117), // Rule ID 5145 //
     /* 296093 */     // MIs[0] Operand 1
     /* 296093 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 296098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296106 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 296106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 296109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296115 */     GIR_RootConstrainSelectedInstOperands,
     /* 296116 */     // GIR_Coverage, 5145,
     /* 296116 */     GIR_EraseRootFromParent_Done,
     /* 296117 */   // Label 5812: @296117
     /* 296117 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(296146), // Rule ID 5152 //
     /* 296122 */     // MIs[0] Operand 1
     /* 296122 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 296127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296135 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 296135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 296138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296144 */     GIR_RootConstrainSelectedInstOperands,
     /* 296145 */     // GIR_Coverage, 5152,
     /* 296145 */     GIR_EraseRootFromParent_Done,
     /* 296146 */   // Label 5813: @296146
     /* 296146 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(296175), // Rule ID 5159 //
     /* 296151 */     // MIs[0] Operand 1
     /* 296151 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 296156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296164 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 296164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 296167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296173 */     GIR_RootConstrainSelectedInstOperands,
     /* 296174 */     // GIR_Coverage, 5159,
     /* 296174 */     GIR_EraseRootFromParent_Done,
     /* 296175 */   // Label 5814: @296175
     /* 296175 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(296204), // Rule ID 5166 //
     /* 296180 */     // MIs[0] Operand 1
     /* 296180 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 296185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296193 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 296193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 296196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296202 */     GIR_RootConstrainSelectedInstOperands,
     /* 296203 */     // GIR_Coverage, 5166,
     /* 296203 */     GIR_EraseRootFromParent_Done,
     /* 296204 */   // Label 5815: @296204
     /* 296204 */   GIM_Reject,
     /* 296205 */ // Label 5785: @296205
     /* 296205 */ GIM_Reject,
     /* 296206 */ // Label 5646: @296206
     /* 296206 */ GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(297253),
     /* 296211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 296214 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 296217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296221 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(296261), // Rule ID 753 //
     /* 296226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296229 */     // MIs[0] Operand 1
     /* 296229 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296238 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296244 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296252 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 296255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 296259 */     GIR_RootConstrainSelectedInstOperands,
     /* 296260 */     // GIR_Coverage, 753,
     /* 296260 */     GIR_EraseRootFromParent_Done,
     /* 296261 */   // Label 5817: @296261
     /* 296261 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(296301), // Rule ID 760 //
     /* 296266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296269 */     // MIs[0] Operand 1
     /* 296269 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296278 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296284 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296292 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 296295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 296299 */     GIR_RootConstrainSelectedInstOperands,
     /* 296300 */     // GIR_Coverage, 760,
     /* 296300 */     GIR_EraseRootFromParent_Done,
     /* 296301 */   // Label 5818: @296301
     /* 296301 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(296338), // Rule ID 5211 //
     /* 296306 */     // MIs[0] Operand 1
     /* 296306 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 296311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296315 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296321 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296329 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 296332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 296336 */     GIR_RootConstrainSelectedInstOperands,
     /* 296337 */     // GIR_Coverage, 5211,
     /* 296337 */     GIR_EraseRootFromParent_Done,
     /* 296338 */   // Label 5819: @296338
     /* 296338 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(296375), // Rule ID 5218 //
     /* 296343 */     // MIs[0] Operand 1
     /* 296343 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296352 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296358 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296366 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 296369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 296373 */     GIR_RootConstrainSelectedInstOperands,
     /* 296374 */     // GIR_Coverage, 5218,
     /* 296374 */     GIR_EraseRootFromParent_Done,
     /* 296375 */   // Label 5820: @296375
     /* 296375 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(296412), // Rule ID 5225 //
     /* 296380 */     // MIs[0] Operand 1
     /* 296380 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296389 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296395 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296403 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 296406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 296410 */     GIR_RootConstrainSelectedInstOperands,
     /* 296411 */     // GIR_Coverage, 5225,
     /* 296411 */     GIR_EraseRootFromParent_Done,
     /* 296412 */   // Label 5821: @296412
     /* 296412 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(296449), // Rule ID 5232 //
     /* 296417 */     // MIs[0] Operand 1
     /* 296417 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 296422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296426 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296432 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296440 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 296443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 296447 */     GIR_RootConstrainSelectedInstOperands,
     /* 296448 */     // GIR_Coverage, 5232,
     /* 296448 */     GIR_EraseRootFromParent_Done,
     /* 296449 */   // Label 5822: @296449
     /* 296449 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(296486), // Rule ID 5239 //
     /* 296454 */     // MIs[0] Operand 1
     /* 296454 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 296459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296463 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296469 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296477 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 296480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 296484 */     GIR_RootConstrainSelectedInstOperands,
     /* 296485 */     // GIR_Coverage, 5239,
     /* 296485 */     GIR_EraseRootFromParent_Done,
     /* 296486 */   // Label 5823: @296486
     /* 296486 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(296526), // Rule ID 725 //
     /* 296491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296494 */     // MIs[0] Operand 1
     /* 296494 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 296499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296507 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296513 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296517 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 296520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296524 */     GIR_RootConstrainSelectedInstOperands,
     /* 296525 */     // GIR_Coverage, 725,
     /* 296525 */     GIR_EraseRootFromParent_Done,
     /* 296526 */   // Label 5824: @296526
     /* 296526 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(296566), // Rule ID 735 //
     /* 296531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296534 */     // MIs[0] Operand 1
     /* 296534 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296547 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296553 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296557 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 296560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296564 */     GIR_RootConstrainSelectedInstOperands,
     /* 296565 */     // GIR_Coverage, 735,
     /* 296565 */     GIR_EraseRootFromParent_Done,
     /* 296566 */   // Label 5825: @296566
     /* 296566 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(296606), // Rule ID 736 //
     /* 296571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296574 */     // MIs[0] Operand 1
     /* 296574 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296587 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296593 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 296595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296597 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 296600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296604 */     GIR_RootConstrainSelectedInstOperands,
     /* 296605 */     // GIR_Coverage, 736,
     /* 296605 */     GIR_EraseRootFromParent_Done,
     /* 296606 */   // Label 5826: @296606
     /* 296606 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(296646), // Rule ID 746 //
     /* 296611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296614 */     // MIs[0] Operand 1
     /* 296614 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296627 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296633 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296637 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 296640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296644 */     GIR_RootConstrainSelectedInstOperands,
     /* 296645 */     // GIR_Coverage, 746,
     /* 296645 */     GIR_EraseRootFromParent_Done,
     /* 296646 */   // Label 5827: @296646
     /* 296646 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(296683), // Rule ID 5176 //
     /* 296651 */     // MIs[0] Operand 1
     /* 296651 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 296656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296664 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296670 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296674 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 296677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296681 */     GIR_RootConstrainSelectedInstOperands,
     /* 296682 */     // GIR_Coverage, 5176,
     /* 296682 */     GIR_EraseRootFromParent_Done,
     /* 296683 */   // Label 5828: @296683
     /* 296683 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(296720), // Rule ID 5183 //
     /* 296688 */     // MIs[0] Operand 1
     /* 296688 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296701 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296707 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296711 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 296714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296718 */     GIR_RootConstrainSelectedInstOperands,
     /* 296719 */     // GIR_Coverage, 5183,
     /* 296719 */     GIR_EraseRootFromParent_Done,
     /* 296720 */   // Label 5829: @296720
     /* 296720 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(296757), // Rule ID 5190 //
     /* 296725 */     // MIs[0] Operand 1
     /* 296725 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296738 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296744 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296748 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 296751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296755 */     GIR_RootConstrainSelectedInstOperands,
     /* 296756 */     // GIR_Coverage, 5190,
     /* 296756 */     GIR_EraseRootFromParent_Done,
     /* 296757 */   // Label 5830: @296757
     /* 296757 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(296794), // Rule ID 5197 //
     /* 296762 */     // MIs[0] Operand 1
     /* 296762 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 296767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296775 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296781 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296785 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 296788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296792 */     GIR_RootConstrainSelectedInstOperands,
     /* 296793 */     // GIR_Coverage, 5197,
     /* 296793 */     GIR_EraseRootFromParent_Done,
     /* 296794 */   // Label 5831: @296794
     /* 296794 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(296831), // Rule ID 5204 //
     /* 296799 */     // MIs[0] Operand 1
     /* 296799 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 296804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296812 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296818 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296822 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 296825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296829 */     GIR_RootConstrainSelectedInstOperands,
     /* 296830 */     // GIR_Coverage, 5204,
     /* 296830 */     GIR_EraseRootFromParent_Done,
     /* 296831 */   // Label 5832: @296831
     /* 296831 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(296863), // Rule ID 1124 //
     /* 296836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296839 */     // MIs[0] Operand 1
     /* 296839 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 296844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296852 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 296852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 296855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296861 */     GIR_RootConstrainSelectedInstOperands,
     /* 296862 */     // GIR_Coverage, 1124,
     /* 296862 */     GIR_EraseRootFromParent_Done,
     /* 296863 */   // Label 5833: @296863
     /* 296863 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(296895), // Rule ID 1131 //
     /* 296868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296871 */     // MIs[0] Operand 1
     /* 296871 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296884 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 296884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 296887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296893 */     GIR_RootConstrainSelectedInstOperands,
     /* 296894 */     // GIR_Coverage, 1131,
     /* 296894 */     GIR_EraseRootFromParent_Done,
     /* 296895 */   // Label 5834: @296895
     /* 296895 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(296927), // Rule ID 1138 //
     /* 296900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296903 */     // MIs[0] Operand 1
     /* 296903 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296916 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 296916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 296919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296925 */     GIR_RootConstrainSelectedInstOperands,
     /* 296926 */     // GIR_Coverage, 1138,
     /* 296926 */     GIR_EraseRootFromParent_Done,
     /* 296927 */   // Label 5835: @296927
     /* 296927 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(296959), // Rule ID 1145 //
     /* 296932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296935 */     // MIs[0] Operand 1
     /* 296935 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 296940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296948 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 296948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 296951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296957 */     GIR_RootConstrainSelectedInstOperands,
     /* 296958 */     // GIR_Coverage, 1145,
     /* 296958 */     GIR_EraseRootFromParent_Done,
     /* 296959 */   // Label 5836: @296959
     /* 296959 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(296991), // Rule ID 1152 //
     /* 296964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296967 */     // MIs[0] Operand 1
     /* 296967 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 296972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296980 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 296980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 296983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296989 */     GIR_RootConstrainSelectedInstOperands,
     /* 296990 */     // GIR_Coverage, 1152,
     /* 296990 */     GIR_EraseRootFromParent_Done,
     /* 296991 */   // Label 5837: @296991
     /* 296991 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(297020), // Rule ID 5113 //
     /* 296996 */     // MIs[0] Operand 1
     /* 296996 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 297001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297009 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 297012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297018 */     GIR_RootConstrainSelectedInstOperands,
     /* 297019 */     // GIR_Coverage, 5113,
     /* 297019 */     GIR_EraseRootFromParent_Done,
     /* 297020 */   // Label 5838: @297020
     /* 297020 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(297049), // Rule ID 5120 //
     /* 297025 */     // MIs[0] Operand 1
     /* 297025 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 297030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297038 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 297041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297047 */     GIR_RootConstrainSelectedInstOperands,
     /* 297048 */     // GIR_Coverage, 5120,
     /* 297048 */     GIR_EraseRootFromParent_Done,
     /* 297049 */   // Label 5839: @297049
     /* 297049 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(297078), // Rule ID 5127 //
     /* 297054 */     // MIs[0] Operand 1
     /* 297054 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 297059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297067 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 297070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297076 */     GIR_RootConstrainSelectedInstOperands,
     /* 297077 */     // GIR_Coverage, 5127,
     /* 297077 */     GIR_EraseRootFromParent_Done,
     /* 297078 */   // Label 5840: @297078
     /* 297078 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(297107), // Rule ID 5134 //
     /* 297083 */     // MIs[0] Operand 1
     /* 297083 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 297088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297096 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 297099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297105 */     GIR_RootConstrainSelectedInstOperands,
     /* 297106 */     // GIR_Coverage, 5134,
     /* 297106 */     GIR_EraseRootFromParent_Done,
     /* 297107 */   // Label 5841: @297107
     /* 297107 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(297136), // Rule ID 5141 //
     /* 297112 */     // MIs[0] Operand 1
     /* 297112 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 297117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297125 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 297128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297134 */     GIR_RootConstrainSelectedInstOperands,
     /* 297135 */     // GIR_Coverage, 5141,
     /* 297135 */     GIR_EraseRootFromParent_Done,
     /* 297136 */   // Label 5842: @297136
     /* 297136 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(297165), // Rule ID 5148 //
     /* 297141 */     // MIs[0] Operand 1
     /* 297141 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 297146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297154 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 297154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 297157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297163 */     GIR_RootConstrainSelectedInstOperands,
     /* 297164 */     // GIR_Coverage, 5148,
     /* 297164 */     GIR_EraseRootFromParent_Done,
     /* 297165 */   // Label 5843: @297165
     /* 297165 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(297194), // Rule ID 5155 //
     /* 297170 */     // MIs[0] Operand 1
     /* 297170 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 297175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297183 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 297183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 297186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297192 */     GIR_RootConstrainSelectedInstOperands,
     /* 297193 */     // GIR_Coverage, 5155,
     /* 297193 */     GIR_EraseRootFromParent_Done,
     /* 297194 */   // Label 5844: @297194
     /* 297194 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(297223), // Rule ID 5162 //
     /* 297199 */     // MIs[0] Operand 1
     /* 297199 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 297204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297212 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 297212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 297215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297221 */     GIR_RootConstrainSelectedInstOperands,
     /* 297222 */     // GIR_Coverage, 5162,
     /* 297222 */     GIR_EraseRootFromParent_Done,
     /* 297223 */   // Label 5845: @297223
     /* 297223 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(297252), // Rule ID 5169 //
     /* 297228 */     // MIs[0] Operand 1
     /* 297228 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 297233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297241 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 297241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 297244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297250 */     GIR_RootConstrainSelectedInstOperands,
     /* 297251 */     // GIR_Coverage, 5169,
     /* 297251 */     GIR_EraseRootFromParent_Done,
     /* 297252 */   // Label 5846: @297252
     /* 297252 */   GIM_Reject,
     /* 297253 */ // Label 5816: @297253
     /* 297253 */ GIM_Reject,
     /* 297254 */ // Label 5647: @297254
     /* 297254 */ GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(298301),
     /* 297259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 297262 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 297265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297269 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(297309), // Rule ID 751 //
     /* 297274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297277 */     // MIs[0] Operand 1
     /* 297277 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 297282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297286 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297292 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297300 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 297303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 297307 */     GIR_RootConstrainSelectedInstOperands,
     /* 297308 */     // GIR_Coverage, 751,
     /* 297308 */     GIR_EraseRootFromParent_Done,
     /* 297309 */   // Label 5848: @297309
     /* 297309 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(297349), // Rule ID 758 //
     /* 297314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297317 */     // MIs[0] Operand 1
     /* 297317 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 297322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297326 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297332 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297340 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 297343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 297347 */     GIR_RootConstrainSelectedInstOperands,
     /* 297348 */     // GIR_Coverage, 758,
     /* 297348 */     GIR_EraseRootFromParent_Done,
     /* 297349 */   // Label 5849: @297349
     /* 297349 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(297386), // Rule ID 5209 //
     /* 297354 */     // MIs[0] Operand 1
     /* 297354 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 297359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297363 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297369 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297377 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 297380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 297384 */     GIR_RootConstrainSelectedInstOperands,
     /* 297385 */     // GIR_Coverage, 5209,
     /* 297385 */     GIR_EraseRootFromParent_Done,
     /* 297386 */   // Label 5850: @297386
     /* 297386 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(297423), // Rule ID 5216 //
     /* 297391 */     // MIs[0] Operand 1
     /* 297391 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 297396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297400 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297406 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297414 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 297417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 297421 */     GIR_RootConstrainSelectedInstOperands,
     /* 297422 */     // GIR_Coverage, 5216,
     /* 297422 */     GIR_EraseRootFromParent_Done,
     /* 297423 */   // Label 5851: @297423
     /* 297423 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(297460), // Rule ID 5223 //
     /* 297428 */     // MIs[0] Operand 1
     /* 297428 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 297433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297437 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297443 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297451 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 297454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 297458 */     GIR_RootConstrainSelectedInstOperands,
     /* 297459 */     // GIR_Coverage, 5223,
     /* 297459 */     GIR_EraseRootFromParent_Done,
     /* 297460 */   // Label 5852: @297460
     /* 297460 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(297497), // Rule ID 5230 //
     /* 297465 */     // MIs[0] Operand 1
     /* 297465 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 297470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297474 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297480 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297488 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 297491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 297495 */     GIR_RootConstrainSelectedInstOperands,
     /* 297496 */     // GIR_Coverage, 5230,
     /* 297496 */     GIR_EraseRootFromParent_Done,
     /* 297497 */   // Label 5853: @297497
     /* 297497 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(297534), // Rule ID 5237 //
     /* 297502 */     // MIs[0] Operand 1
     /* 297502 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 297507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297511 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297517 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297525 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 297528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 297532 */     GIR_RootConstrainSelectedInstOperands,
     /* 297533 */     // GIR_Coverage, 5237,
     /* 297533 */     GIR_EraseRootFromParent_Done,
     /* 297534 */   // Label 5854: @297534
     /* 297534 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(297574), // Rule ID 723 //
     /* 297539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297542 */     // MIs[0] Operand 1
     /* 297542 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 297547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297555 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297561 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297565 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 297568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297572 */     GIR_RootConstrainSelectedInstOperands,
     /* 297573 */     // GIR_Coverage, 723,
     /* 297573 */     GIR_EraseRootFromParent_Done,
     /* 297574 */   // Label 5855: @297574
     /* 297574 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(297614), // Rule ID 731 //
     /* 297579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297582 */     // MIs[0] Operand 1
     /* 297582 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 297587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297595 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297601 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297605 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 297608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297612 */     GIR_RootConstrainSelectedInstOperands,
     /* 297613 */     // GIR_Coverage, 731,
     /* 297613 */     GIR_EraseRootFromParent_Done,
     /* 297614 */   // Label 5856: @297614
     /* 297614 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(297654), // Rule ID 732 //
     /* 297619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297622 */     // MIs[0] Operand 1
     /* 297622 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 297627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297635 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297641 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 297643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297645 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 297648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297652 */     GIR_RootConstrainSelectedInstOperands,
     /* 297653 */     // GIR_Coverage, 732,
     /* 297653 */     GIR_EraseRootFromParent_Done,
     /* 297654 */   // Label 5857: @297654
     /* 297654 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(297694), // Rule ID 744 //
     /* 297659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297662 */     // MIs[0] Operand 1
     /* 297662 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 297667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297675 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297681 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297685 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 297688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297692 */     GIR_RootConstrainSelectedInstOperands,
     /* 297693 */     // GIR_Coverage, 744,
     /* 297693 */     GIR_EraseRootFromParent_Done,
     /* 297694 */   // Label 5858: @297694
     /* 297694 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(297731), // Rule ID 5174 //
     /* 297699 */     // MIs[0] Operand 1
     /* 297699 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 297704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297712 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297718 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297722 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 297725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297729 */     GIR_RootConstrainSelectedInstOperands,
     /* 297730 */     // GIR_Coverage, 5174,
     /* 297730 */     GIR_EraseRootFromParent_Done,
     /* 297731 */   // Label 5859: @297731
     /* 297731 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(297768), // Rule ID 5181 //
     /* 297736 */     // MIs[0] Operand 1
     /* 297736 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 297741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297749 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297755 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297759 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 297762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297766 */     GIR_RootConstrainSelectedInstOperands,
     /* 297767 */     // GIR_Coverage, 5181,
     /* 297767 */     GIR_EraseRootFromParent_Done,
     /* 297768 */   // Label 5860: @297768
     /* 297768 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(297805), // Rule ID 5188 //
     /* 297773 */     // MIs[0] Operand 1
     /* 297773 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 297778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297786 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297792 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297796 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 297799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297803 */     GIR_RootConstrainSelectedInstOperands,
     /* 297804 */     // GIR_Coverage, 5188,
     /* 297804 */     GIR_EraseRootFromParent_Done,
     /* 297805 */   // Label 5861: @297805
     /* 297805 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(297842), // Rule ID 5195 //
     /* 297810 */     // MIs[0] Operand 1
     /* 297810 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 297815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297823 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297829 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297833 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 297836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297840 */     GIR_RootConstrainSelectedInstOperands,
     /* 297841 */     // GIR_Coverage, 5195,
     /* 297841 */     GIR_EraseRootFromParent_Done,
     /* 297842 */   // Label 5862: @297842
     /* 297842 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(297879), // Rule ID 5202 //
     /* 297847 */     // MIs[0] Operand 1
     /* 297847 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 297852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297860 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297866 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297870 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 297873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297877 */     GIR_RootConstrainSelectedInstOperands,
     /* 297878 */     // GIR_Coverage, 5202,
     /* 297878 */     GIR_EraseRootFromParent_Done,
     /* 297879 */   // Label 5863: @297879
     /* 297879 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(297911), // Rule ID 1122 //
     /* 297884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297887 */     // MIs[0] Operand 1
     /* 297887 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 297892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297900 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 297900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 297903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297909 */     GIR_RootConstrainSelectedInstOperands,
     /* 297910 */     // GIR_Coverage, 1122,
     /* 297910 */     GIR_EraseRootFromParent_Done,
     /* 297911 */   // Label 5864: @297911
     /* 297911 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(297943), // Rule ID 1129 //
     /* 297916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297919 */     // MIs[0] Operand 1
     /* 297919 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 297924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297932 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 297932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 297935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297941 */     GIR_RootConstrainSelectedInstOperands,
     /* 297942 */     // GIR_Coverage, 1129,
     /* 297942 */     GIR_EraseRootFromParent_Done,
     /* 297943 */   // Label 5865: @297943
     /* 297943 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(297975), // Rule ID 1136 //
     /* 297948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297951 */     // MIs[0] Operand 1
     /* 297951 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 297956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297964 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 297964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 297967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297973 */     GIR_RootConstrainSelectedInstOperands,
     /* 297974 */     // GIR_Coverage, 1136,
     /* 297974 */     GIR_EraseRootFromParent_Done,
     /* 297975 */   // Label 5866: @297975
     /* 297975 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(298007), // Rule ID 1143 //
     /* 297980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297983 */     // MIs[0] Operand 1
     /* 297983 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 297988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297996 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 297996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 297999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298005 */     GIR_RootConstrainSelectedInstOperands,
     /* 298006 */     // GIR_Coverage, 1143,
     /* 298006 */     GIR_EraseRootFromParent_Done,
     /* 298007 */   // Label 5867: @298007
     /* 298007 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(298039), // Rule ID 1150 //
     /* 298012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298015 */     // MIs[0] Operand 1
     /* 298015 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 298020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298028 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 298031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298037 */     GIR_RootConstrainSelectedInstOperands,
     /* 298038 */     // GIR_Coverage, 1150,
     /* 298038 */     GIR_EraseRootFromParent_Done,
     /* 298039 */   // Label 5868: @298039
     /* 298039 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(298068), // Rule ID 5111 //
     /* 298044 */     // MIs[0] Operand 1
     /* 298044 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 298049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298057 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 298060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298066 */     GIR_RootConstrainSelectedInstOperands,
     /* 298067 */     // GIR_Coverage, 5111,
     /* 298067 */     GIR_EraseRootFromParent_Done,
     /* 298068 */   // Label 5869: @298068
     /* 298068 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(298097), // Rule ID 5118 //
     /* 298073 */     // MIs[0] Operand 1
     /* 298073 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 298078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298086 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 298089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298095 */     GIR_RootConstrainSelectedInstOperands,
     /* 298096 */     // GIR_Coverage, 5118,
     /* 298096 */     GIR_EraseRootFromParent_Done,
     /* 298097 */   // Label 5870: @298097
     /* 298097 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(298126), // Rule ID 5125 //
     /* 298102 */     // MIs[0] Operand 1
     /* 298102 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 298107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298115 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 298118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298124 */     GIR_RootConstrainSelectedInstOperands,
     /* 298125 */     // GIR_Coverage, 5125,
     /* 298125 */     GIR_EraseRootFromParent_Done,
     /* 298126 */   // Label 5871: @298126
     /* 298126 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(298155), // Rule ID 5132 //
     /* 298131 */     // MIs[0] Operand 1
     /* 298131 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 298136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298144 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 298147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298153 */     GIR_RootConstrainSelectedInstOperands,
     /* 298154 */     // GIR_Coverage, 5132,
     /* 298154 */     GIR_EraseRootFromParent_Done,
     /* 298155 */   // Label 5872: @298155
     /* 298155 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(298184), // Rule ID 5139 //
     /* 298160 */     // MIs[0] Operand 1
     /* 298160 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 298165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298173 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 298176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298182 */     GIR_RootConstrainSelectedInstOperands,
     /* 298183 */     // GIR_Coverage, 5139,
     /* 298183 */     GIR_EraseRootFromParent_Done,
     /* 298184 */   // Label 5873: @298184
     /* 298184 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(298213), // Rule ID 5146 //
     /* 298189 */     // MIs[0] Operand 1
     /* 298189 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 298194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298202 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 298202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 298205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298211 */     GIR_RootConstrainSelectedInstOperands,
     /* 298212 */     // GIR_Coverage, 5146,
     /* 298212 */     GIR_EraseRootFromParent_Done,
     /* 298213 */   // Label 5874: @298213
     /* 298213 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(298242), // Rule ID 5153 //
     /* 298218 */     // MIs[0] Operand 1
     /* 298218 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 298223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298231 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 298231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 298234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298240 */     GIR_RootConstrainSelectedInstOperands,
     /* 298241 */     // GIR_Coverage, 5153,
     /* 298241 */     GIR_EraseRootFromParent_Done,
     /* 298242 */   // Label 5875: @298242
     /* 298242 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(298271), // Rule ID 5160 //
     /* 298247 */     // MIs[0] Operand 1
     /* 298247 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 298252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298260 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 298260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 298263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298269 */     GIR_RootConstrainSelectedInstOperands,
     /* 298270 */     // GIR_Coverage, 5160,
     /* 298270 */     GIR_EraseRootFromParent_Done,
     /* 298271 */   // Label 5876: @298271
     /* 298271 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(298300), // Rule ID 5167 //
     /* 298276 */     // MIs[0] Operand 1
     /* 298276 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 298281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298289 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 298289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 298292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298298 */     GIR_RootConstrainSelectedInstOperands,
     /* 298299 */     // GIR_Coverage, 5167,
     /* 298299 */     GIR_EraseRootFromParent_Done,
     /* 298300 */   // Label 5877: @298300
     /* 298300 */   GIM_Reject,
     /* 298301 */ // Label 5847: @298301
     /* 298301 */ GIM_Reject,
     /* 298302 */ // Label 5648: @298302
     /* 298302 */ GIM_Reject,
     /* 298303 */ // Label 52: @298303
     /* 298303 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5890*/ GIMT_Encode4(299347),
     /* 298314 */ /*GILLT_nxv1s1*//*Label 5878*/ GIMT_Encode4(298362),
     /* 298318 */ /*GILLT_nxv2s1*//*Label 5879*/ GIMT_Encode4(298391),
     /* 298322 */ /*GILLT_nxv2s16*//*Label 5880*/ GIMT_Encode4(298420),
     /* 298326 */ /*GILLT_nxv2s32*//*Label 5881*/ GIMT_Encode4(298505),
     /* 298330 */ /*GILLT_nxv2s64*//*Label 5882*/ GIMT_Encode4(298590),
     /* 298334 */ /*GILLT_nxv4s1*//*Label 5883*/ GIMT_Encode4(298756),
     /* 298338 */ /*GILLT_nxv4s16*//*Label 5884*/ GIMT_Encode4(298785),
     /* 298342 */ /*GILLT_nxv4s32*//*Label 5885*/ GIMT_Encode4(298870),
     /* 298346 */ /*GILLT_nxv8s1*//*Label 5886*/ GIMT_Encode4(299036),
     /* 298350 */ /*GILLT_nxv8s16*//*Label 5887*/ GIMT_Encode4(299065),
     /* 298354 */ /*GILLT_nxv16s1*//*Label 5888*/ GIMT_Encode4(299231),
     /* 298358 */ /*GILLT_nxv16s8*//*Label 5889*/ GIMT_Encode4(299260),
     /* 298362 */ // Label 5878: @298362
     /* 298362 */ GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(298390), // Rule ID 8519 //
     /* 298367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 298373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 298376 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 298379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 298383 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 298383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 298388 */   GIR_RootConstrainSelectedInstOperands,
     /* 298389 */   // GIR_Coverage, 8519,
     /* 298389 */   GIR_Done,
     /* 298390 */ // Label 5891: @298390
     /* 298390 */ GIM_Reject,
     /* 298391 */ // Label 5879: @298391
     /* 298391 */ GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(298419), // Rule ID 8518 //
     /* 298396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 298402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 298405 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 298408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 298412 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 298412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 298417 */   GIR_RootConstrainSelectedInstOperands,
     /* 298418 */   // GIR_Coverage, 8518,
     /* 298418 */   GIR_Done,
     /* 298419 */ // Label 5892: @298419
     /* 298419 */ GIM_Reject,
     /* 298420 */ // Label 5880: @298420
     /* 298420 */ GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(298504),
     /* 298425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 298428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 298431 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 298434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298438 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(298488), // Rule ID 3161 //
     /* 298443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 298454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 298458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 298466 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 298470 */     // MIs[2] Operand 1
     /* 298470 */     // No operand predicates
     /* 298470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298472 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 298472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 298475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 298477 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 298479 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 298481 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 298486 */     GIR_RootConstrainSelectedInstOperands,
     /* 298487 */     // GIR_Coverage, 3161,
     /* 298487 */     GIR_EraseRootFromParent_Done,
     /* 298488 */   // Label 5894: @298488
     /* 298488 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(298503), // Rule ID 2741 //
     /* 298493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298496 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 298496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 298501 */     GIR_RootConstrainSelectedInstOperands,
     /* 298502 */     // GIR_Coverage, 2741,
     /* 298502 */     GIR_Done,
     /* 298503 */   // Label 5895: @298503
     /* 298503 */   GIM_Reject,
     /* 298504 */ // Label 5893: @298504
     /* 298504 */ GIM_Reject,
     /* 298505 */ // Label 5881: @298505
     /* 298505 */ GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(298589),
     /* 298510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 298513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 298516 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 298519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298523 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(298573), // Rule ID 3163 //
     /* 298528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 298539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 298551 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 298555 */     // MIs[2] Operand 1
     /* 298555 */     // No operand predicates
     /* 298555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298557 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 298557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 298560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 298562 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 298564 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 298566 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 298571 */     GIR_RootConstrainSelectedInstOperands,
     /* 298572 */     // GIR_Coverage, 3163,
     /* 298572 */     GIR_EraseRootFromParent_Done,
     /* 298573 */   // Label 5897: @298573
     /* 298573 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(298588), // Rule ID 2742 //
     /* 298578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298581 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 298581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 298586 */     GIR_RootConstrainSelectedInstOperands,
     /* 298587 */     // GIR_Coverage, 2742,
     /* 298587 */     GIR_Done,
     /* 298588 */   // Label 5898: @298588
     /* 298588 */   GIM_Reject,
     /* 298589 */ // Label 5896: @298589
     /* 298589 */ GIM_Reject,
     /* 298590 */ // Label 5882: @298590
     /* 298590 */ GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(298755),
     /* 298595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 298598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 298601 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(298658), // Rule ID 3164 //
     /* 298606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 298612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 298624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 298636 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 298640 */     // MIs[2] Operand 1
     /* 298640 */     // No operand predicates
     /* 298640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298642 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 298642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 298645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 298647 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 298649 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 298651 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 298656 */     GIR_RootConstrainSelectedInstOperands,
     /* 298657 */     // GIR_Coverage, 3164,
     /* 298657 */     GIR_EraseRootFromParent_Done,
     /* 298658 */   // Label 5900: @298658
     /* 298658 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(298710), // Rule ID 7565 //
     /* 298663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 298678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 298682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 298686 */     // MIs[0] Op2
     /* 298686 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 298691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298693 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 298693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 298696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 298698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 298700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 298704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 298708 */     GIR_RootConstrainSelectedInstOperands,
     /* 298709 */     // GIR_Coverage, 7565,
     /* 298709 */     GIR_EraseRootFromParent_Done,
     /* 298710 */   // Label 5901: @298710
     /* 298710 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(298732), // Rule ID 2737 //
     /* 298715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 298721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298725 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 298725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 298730 */     GIR_RootConstrainSelectedInstOperands,
     /* 298731 */     // GIR_Coverage, 2737,
     /* 298731 */     GIR_Done,
     /* 298732 */   // Label 5902: @298732
     /* 298732 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(298754), // Rule ID 2743 //
     /* 298737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 298743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298747 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 298747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 298752 */     GIR_RootConstrainSelectedInstOperands,
     /* 298753 */     // GIR_Coverage, 2743,
     /* 298753 */     GIR_Done,
     /* 298754 */   // Label 5903: @298754
     /* 298754 */   GIM_Reject,
     /* 298755 */ // Label 5899: @298755
     /* 298755 */ GIM_Reject,
     /* 298756 */ // Label 5883: @298756
     /* 298756 */ GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(298784), // Rule ID 8517 //
     /* 298761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 298767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 298770 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 298773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 298777 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 298777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 298782 */   GIR_RootConstrainSelectedInstOperands,
     /* 298783 */   // GIR_Coverage, 8517,
     /* 298783 */   GIR_Done,
     /* 298784 */ // Label 5904: @298784
     /* 298784 */ GIM_Reject,
     /* 298785 */ // Label 5884: @298785
     /* 298785 */ GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(298869),
     /* 298790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 298793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 298796 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 298799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298803 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(298853), // Rule ID 3160 //
     /* 298808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 298819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 298823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 298831 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 298835 */     // MIs[2] Operand 1
     /* 298835 */     // No operand predicates
     /* 298835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298837 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 298837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 298840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 298842 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 298844 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 298846 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 298851 */     GIR_RootConstrainSelectedInstOperands,
     /* 298852 */     // GIR_Coverage, 3160,
     /* 298852 */     GIR_EraseRootFromParent_Done,
     /* 298853 */   // Label 5906: @298853
     /* 298853 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(298868), // Rule ID 2739 //
     /* 298858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298861 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 298861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 298866 */     GIR_RootConstrainSelectedInstOperands,
     /* 298867 */     // GIR_Coverage, 2739,
     /* 298867 */     GIR_Done,
     /* 298868 */   // Label 5907: @298868
     /* 298868 */   GIM_Reject,
     /* 298869 */ // Label 5905: @298869
     /* 298869 */ GIM_Reject,
     /* 298870 */ // Label 5885: @298870
     /* 298870 */ GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(299035),
     /* 298875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 298878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 298881 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(298938), // Rule ID 3162 //
     /* 298886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 298892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 298904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 298916 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 298920 */     // MIs[2] Operand 1
     /* 298920 */     // No operand predicates
     /* 298920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298922 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 298922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 298925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 298927 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 298929 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 298931 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 298936 */     GIR_RootConstrainSelectedInstOperands,
     /* 298937 */     // GIR_Coverage, 3162,
     /* 298937 */     GIR_EraseRootFromParent_Done,
     /* 298938 */   // Label 5909: @298938
     /* 298938 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(298990), // Rule ID 7563 //
     /* 298943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 298958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 298962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 298966 */     // MIs[0] Op2
     /* 298966 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 298971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298973 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 298973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 298976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 298978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 298980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 298984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 298988 */     GIR_RootConstrainSelectedInstOperands,
     /* 298989 */     // GIR_Coverage, 7563,
     /* 298989 */     GIR_EraseRootFromParent_Done,
     /* 298990 */   // Label 5910: @298990
     /* 298990 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(299012), // Rule ID 2736 //
     /* 298995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 299001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299005 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 299005 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 299010 */     GIR_RootConstrainSelectedInstOperands,
     /* 299011 */     // GIR_Coverage, 2736,
     /* 299011 */     GIR_Done,
     /* 299012 */   // Label 5911: @299012
     /* 299012 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(299034), // Rule ID 2740 //
     /* 299017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 299023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299027 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 299027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 299032 */     GIR_RootConstrainSelectedInstOperands,
     /* 299033 */     // GIR_Coverage, 2740,
     /* 299033 */     GIR_Done,
     /* 299034 */   // Label 5912: @299034
     /* 299034 */   GIM_Reject,
     /* 299035 */ // Label 5908: @299035
     /* 299035 */ GIM_Reject,
     /* 299036 */ // Label 5886: @299036
     /* 299036 */ GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(299064), // Rule ID 8516 //
     /* 299041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 299047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 299050 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 299053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 299057 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 299057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 299062 */   GIR_RootConstrainSelectedInstOperands,
     /* 299063 */   // GIR_Coverage, 8516,
     /* 299063 */   GIR_Done,
     /* 299064 */ // Label 5913: @299064
     /* 299064 */ GIM_Reject,
     /* 299065 */ // Label 5887: @299065
     /* 299065 */ GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(299230),
     /* 299070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 299073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 299076 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(299133), // Rule ID 3159 //
     /* 299081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 299087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 299099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 299111 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 299115 */     // MIs[2] Operand 1
     /* 299115 */     // No operand predicates
     /* 299115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299117 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 299117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 299120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 299122 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 299124 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 299126 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 299131 */     GIR_RootConstrainSelectedInstOperands,
     /* 299132 */     // GIR_Coverage, 3159,
     /* 299132 */     GIR_EraseRootFromParent_Done,
     /* 299133 */   // Label 5915: @299133
     /* 299133 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(299185), // Rule ID 7561 //
     /* 299138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 299153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 299157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 299161 */     // MIs[0] Op2
     /* 299161 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 299166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299168 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 299168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 299171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 299173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 299175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 299179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 299183 */     GIR_RootConstrainSelectedInstOperands,
     /* 299184 */     // GIR_Coverage, 7561,
     /* 299184 */     GIR_EraseRootFromParent_Done,
     /* 299185 */   // Label 5916: @299185
     /* 299185 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(299207), // Rule ID 2735 //
     /* 299190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 299196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299200 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 299200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 299205 */     GIR_RootConstrainSelectedInstOperands,
     /* 299206 */     // GIR_Coverage, 2735,
     /* 299206 */     GIR_Done,
     /* 299207 */   // Label 5917: @299207
     /* 299207 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(299229), // Rule ID 2738 //
     /* 299212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 299218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299222 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 299222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 299227 */     GIR_RootConstrainSelectedInstOperands,
     /* 299228 */     // GIR_Coverage, 2738,
     /* 299228 */     GIR_Done,
     /* 299229 */   // Label 5918: @299229
     /* 299229 */   GIM_Reject,
     /* 299230 */ // Label 5914: @299230
     /* 299230 */ GIM_Reject,
     /* 299231 */ // Label 5888: @299231
     /* 299231 */ GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(299259), // Rule ID 8515 //
     /* 299236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 299242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 299245 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 299248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 299252 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 299252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 299257 */   GIR_RootConstrainSelectedInstOperands,
     /* 299258 */   // GIR_Coverage, 8515,
     /* 299258 */   GIR_Done,
     /* 299259 */ // Label 5919: @299259
     /* 299259 */ GIM_Reject,
     /* 299260 */ // Label 5889: @299260
     /* 299260 */ GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(299346),
     /* 299265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 299268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 299271 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(299323), // Rule ID 7559 //
     /* 299276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 299291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 299295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 299299 */     // MIs[0] Op2
     /* 299299 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 299304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299306 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 299306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 299309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 299311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 299313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 299317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 299321 */     GIR_RootConstrainSelectedInstOperands,
     /* 299322 */     // GIR_Coverage, 7559,
     /* 299322 */     GIR_EraseRootFromParent_Done,
     /* 299323 */   // Label 5921: @299323
     /* 299323 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(299345), // Rule ID 2734 //
     /* 299328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 299334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299338 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 299338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 299343 */     GIR_RootConstrainSelectedInstOperands,
     /* 299344 */     // GIR_Coverage, 2734,
     /* 299344 */     GIR_Done,
     /* 299345 */   // Label 5922: @299345
     /* 299345 */   GIM_Reject,
     /* 299346 */ // Label 5920: @299346
     /* 299346 */ GIM_Reject,
     /* 299347 */ // Label 5890: @299347
     /* 299347 */ GIM_Reject,
     /* 299348 */ // Label 53: @299348
     /* 299348 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5927*/ GIMT_Encode4(299831),
     /* 299359 */ /*GILLT_s64*//*Label 5923*/ GIMT_Encode4(299395), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 299379 */ /*GILLT_v4s32*//*Label 5924*/ GIMT_Encode4(299426), GIMT_Encode4(0),
     /* 299387 */ /*GILLT_v8s16*//*Label 5925*/ GIMT_Encode4(299561),
     /* 299391 */ /*GILLT_v16s8*//*Label 5926*/ GIMT_Encode4(299696),
     /* 299395 */ // Label 5923: @299395
     /* 299395 */ GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(299425), // Rule ID 128 //
     /* 299400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 299406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 299410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 299414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 299418 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 299418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 299423 */   GIR_RootConstrainSelectedInstOperands,
     /* 299424 */   // GIR_Coverage, 128,
     /* 299424 */   GIR_Done,
     /* 299425 */ // Label 5928: @299425
     /* 299425 */ GIM_Reject,
     /* 299426 */ // Label 5924: @299426
     /* 299426 */ GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(299560), // Rule ID 6585 //
     /* 299431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 299437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299449 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 299449 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 299452 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 299456 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299461 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 299465 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 299469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 299471 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 299474 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299478 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299483 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299489 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299494 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299499 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 299502 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299506 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299511 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299517 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299522 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299527 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299530 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 299534 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299539 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 299542 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 299545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 299550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299555 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 299558 */   GIR_RootConstrainSelectedInstOperands,
     /* 299559 */   // GIR_Coverage, 6585,
     /* 299559 */   GIR_EraseRootFromParent_Done,
     /* 299560 */ // Label 5929: @299560
     /* 299560 */ GIM_Reject,
     /* 299561 */ // Label 5925: @299561
     /* 299561 */ GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(299695), // Rule ID 6584 //
     /* 299566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 299572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299584 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 299584 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 299587 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 299591 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299596 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 299600 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 299604 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 299606 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 299609 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299613 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299618 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299624 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299629 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299634 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 299637 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299641 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299646 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299652 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299657 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 299669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299674 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 299677 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 299680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 299685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299687 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299690 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 299693 */   GIR_RootConstrainSelectedInstOperands,
     /* 299694 */   // GIR_Coverage, 6584,
     /* 299694 */   GIR_EraseRootFromParent_Done,
     /* 299695 */ // Label 5930: @299695
     /* 299695 */ GIM_Reject,
     /* 299696 */ // Label 5926: @299696
     /* 299696 */ GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(299830), // Rule ID 6583 //
     /* 299701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 299704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 299707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299719 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 299719 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 299722 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 299726 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299731 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 299735 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 299739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 299741 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 299744 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299748 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299753 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299759 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299764 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299769 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 299772 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299776 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299781 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299787 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299792 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299797 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299800 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 299804 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299809 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 299812 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 299815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 299820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299822 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299825 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 299828 */   GIR_RootConstrainSelectedInstOperands,
     /* 299829 */   // GIR_Coverage, 6583,
     /* 299829 */   GIR_EraseRootFromParent_Done,
     /* 299830 */ // Label 5931: @299830
     /* 299830 */ GIM_Reject,
     /* 299831 */ // Label 5927: @299831
     /* 299831 */ GIM_Reject,
     /* 299832 */ // Label 54: @299832
     /* 299832 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5936*/ GIMT_Encode4(300315),
     /* 299843 */ /*GILLT_s64*//*Label 5932*/ GIMT_Encode4(299879), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 299863 */ /*GILLT_v4s32*//*Label 5933*/ GIMT_Encode4(299910), GIMT_Encode4(0),
     /* 299871 */ /*GILLT_v8s16*//*Label 5934*/ GIMT_Encode4(300045),
     /* 299875 */ /*GILLT_v16s8*//*Label 5935*/ GIMT_Encode4(300180),
     /* 299879 */ // Label 5932: @299879
     /* 299879 */ GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(299909), // Rule ID 127 //
     /* 299884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 299890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 299894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 299898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 299902 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 299902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 299907 */   GIR_RootConstrainSelectedInstOperands,
     /* 299908 */   // GIR_Coverage, 127,
     /* 299908 */   GIR_Done,
     /* 299909 */ // Label 5937: @299909
     /* 299909 */ GIM_Reject,
     /* 299910 */ // Label 5933: @299910
     /* 299910 */ GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(300044), // Rule ID 6582 //
     /* 299915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 299921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299933 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 299933 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 299936 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 299940 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299945 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 299949 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 299953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 299955 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 299958 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299962 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299967 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299973 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299978 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299983 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 299986 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299990 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299995 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 300001 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300006 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300011 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300014 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 300018 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300023 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 300026 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 300029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 300034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300039 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 300042 */   GIR_RootConstrainSelectedInstOperands,
     /* 300043 */   // GIR_Coverage, 6582,
     /* 300043 */   GIR_EraseRootFromParent_Done,
     /* 300044 */ // Label 5938: @300044
     /* 300044 */ GIM_Reject,
     /* 300045 */ // Label 5934: @300045
     /* 300045 */ GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(300179), // Rule ID 6581 //
     /* 300050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 300056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300068 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 300068 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 300071 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 300075 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300080 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 300084 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 300088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 300090 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 300093 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300097 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300102 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 300108 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300113 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300118 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 300121 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300125 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300130 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 300136 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300141 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 300153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300158 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 300161 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 300164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 300169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300171 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 300177 */   GIR_RootConstrainSelectedInstOperands,
     /* 300178 */   // GIR_Coverage, 6581,
     /* 300178 */   GIR_EraseRootFromParent_Done,
     /* 300179 */ // Label 5939: @300179
     /* 300179 */ GIM_Reject,
     /* 300180 */ // Label 5935: @300180
     /* 300180 */ GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(300314), // Rule ID 6580 //
     /* 300185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 300188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 300191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300203 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 300203 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 300206 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 300210 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300215 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 300219 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 300223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 300225 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 300228 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300232 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300237 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 300243 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300248 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300253 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 300256 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300260 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300265 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 300271 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300276 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 300288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300293 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 300296 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 300299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 300304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300306 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 300312 */   GIR_RootConstrainSelectedInstOperands,
     /* 300313 */   // GIR_Coverage, 6580,
     /* 300313 */   GIR_EraseRootFromParent_Done,
     /* 300314 */ // Label 5940: @300314
     /* 300314 */ GIM_Reject,
     /* 300315 */ // Label 5936: @300315
     /* 300315 */ GIM_Reject,
     /* 300316 */ // Label 55: @300316
     /* 300316 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5952*/ GIMT_Encode4(300745),
     /* 300327 */ /*GILLT_v2s32*//*Label 5941*/ GIMT_Encode4(300403),
     /* 300331 */ /*GILLT_v2s64*//*Label 5942*/ GIMT_Encode4(300437),
     /* 300335 */ /*GILLT_v4s16*//*Label 5943*/ GIMT_Encode4(300471),
     /* 300339 */ /*GILLT_v4s32*//*Label 5944*/ GIMT_Encode4(300505),
     /* 300343 */ /*GILLT_v8s8*//*Label 5945*/ GIMT_Encode4(300539),
     /* 300347 */ /*GILLT_v8s16*//*Label 5946*/ GIMT_Encode4(300573),
     /* 300351 */ /*GILLT_v16s8*//*Label 5947*/ GIMT_Encode4(300607), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 300371 */ /*GILLT_nxv2s64*//*Label 5948*/ GIMT_Encode4(300641), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 300383 */ /*GILLT_nxv4s32*//*Label 5949*/ GIMT_Encode4(300667), GIMT_Encode4(0),
     /* 300391 */ /*GILLT_nxv8s16*//*Label 5950*/ GIMT_Encode4(300693), GIMT_Encode4(0),
     /* 300399 */ /*GILLT_nxv16s8*//*Label 5951*/ GIMT_Encode4(300719),
     /* 300403 */ // Label 5941: @300403
     /* 300403 */ GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(300436), // Rule ID 5059 //
     /* 300408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300429 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 300429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 300434 */   GIR_RootConstrainSelectedInstOperands,
     /* 300435 */   // GIR_Coverage, 5059,
     /* 300435 */   GIR_Done,
     /* 300436 */ // Label 5953: @300436
     /* 300436 */ GIM_Reject,
     /* 300437 */ // Label 5942: @300437
     /* 300437 */ GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(300470), // Rule ID 5063 //
     /* 300442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 300451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300463 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 300463 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 300468 */   GIR_RootConstrainSelectedInstOperands,
     /* 300469 */   // GIR_Coverage, 5063,
     /* 300469 */   GIR_Done,
     /* 300470 */ // Label 5954: @300470
     /* 300470 */ GIM_Reject,
     /* 300471 */ // Label 5943: @300471
     /* 300471 */ GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(300504), // Rule ID 5058 //
     /* 300476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 300482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300493 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300497 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 300497 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 300502 */   GIR_RootConstrainSelectedInstOperands,
     /* 300503 */   // GIR_Coverage, 5058,
     /* 300503 */   GIR_Done,
     /* 300504 */ // Label 5955: @300504
     /* 300504 */ GIM_Reject,
     /* 300505 */ // Label 5944: @300505
     /* 300505 */ GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(300538), // Rule ID 5062 //
     /* 300510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 300519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300531 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 300531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 300536 */   GIR_RootConstrainSelectedInstOperands,
     /* 300537 */   // GIR_Coverage, 5062,
     /* 300537 */   GIR_Done,
     /* 300538 */ // Label 5956: @300538
     /* 300538 */ GIM_Reject,
     /* 300539 */ // Label 5945: @300539
     /* 300539 */ GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(300572), // Rule ID 5057 //
     /* 300544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 300550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 300553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300561 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300565 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 300565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 300570 */   GIR_RootConstrainSelectedInstOperands,
     /* 300571 */   // GIR_Coverage, 5057,
     /* 300571 */   GIR_Done,
     /* 300572 */ // Label 5957: @300572
     /* 300572 */ GIM_Reject,
     /* 300573 */ // Label 5946: @300573
     /* 300573 */ GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(300606), // Rule ID 5061 //
     /* 300578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 300587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300595 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300599 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 300599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 300604 */   GIR_RootConstrainSelectedInstOperands,
     /* 300605 */   // GIR_Coverage, 5061,
     /* 300605 */   GIR_Done,
     /* 300606 */ // Label 5958: @300606
     /* 300606 */ GIM_Reject,
     /* 300607 */ // Label 5947: @300607
     /* 300607 */ GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(300640), // Rule ID 5060 //
     /* 300612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 300618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 300621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300633 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 300633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 300638 */   GIR_RootConstrainSelectedInstOperands,
     /* 300639 */   // GIR_Coverage, 5060,
     /* 300639 */   GIR_Done,
     /* 300640 */ // Label 5959: @300640
     /* 300640 */ GIM_Reject,
     /* 300641 */ // Label 5948: @300641
     /* 300641 */ GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(300666), // Rule ID 7517 //
     /* 300646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 300649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 300652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 300655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 300659 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 300659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 300664 */   GIR_RootConstrainSelectedInstOperands,
     /* 300665 */   // GIR_Coverage, 7517,
     /* 300665 */   GIR_Done,
     /* 300666 */ // Label 5960: @300666
     /* 300666 */ GIM_Reject,
     /* 300667 */ // Label 5949: @300667
     /* 300667 */ GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(300692), // Rule ID 7516 //
     /* 300672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 300675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 300678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 300681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 300685 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 300685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 300690 */   GIR_RootConstrainSelectedInstOperands,
     /* 300691 */   // GIR_Coverage, 7516,
     /* 300691 */   GIR_Done,
     /* 300692 */ // Label 5961: @300692
     /* 300692 */ GIM_Reject,
     /* 300693 */ // Label 5950: @300693
     /* 300693 */ GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(300718), // Rule ID 7515 //
     /* 300698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 300701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 300704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 300707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 300711 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 300711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 300716 */   GIR_RootConstrainSelectedInstOperands,
     /* 300717 */   // GIR_Coverage, 7515,
     /* 300717 */   GIR_Done,
     /* 300718 */ // Label 5962: @300718
     /* 300718 */ GIM_Reject,
     /* 300719 */ // Label 5951: @300719
     /* 300719 */ GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(300744), // Rule ID 7514 //
     /* 300724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 300727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 300730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 300733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 300737 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 300737 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 300742 */   GIR_RootConstrainSelectedInstOperands,
     /* 300743 */   // GIR_Coverage, 7514,
     /* 300743 */   GIR_Done,
     /* 300744 */ // Label 5963: @300744
     /* 300744 */ GIM_Reject,
     /* 300745 */ // Label 5952: @300745
     /* 300745 */ GIM_Reject,
     /* 300746 */ // Label 56: @300746
     /* 300746 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5975*/ GIMT_Encode4(301175),
     /* 300757 */ /*GILLT_v2s32*//*Label 5964*/ GIMT_Encode4(300833),
     /* 300761 */ /*GILLT_v2s64*//*Label 5965*/ GIMT_Encode4(300867),
     /* 300765 */ /*GILLT_v4s16*//*Label 5966*/ GIMT_Encode4(300901),
     /* 300769 */ /*GILLT_v4s32*//*Label 5967*/ GIMT_Encode4(300935),
     /* 300773 */ /*GILLT_v8s8*//*Label 5968*/ GIMT_Encode4(300969),
     /* 300777 */ /*GILLT_v8s16*//*Label 5969*/ GIMT_Encode4(301003),
     /* 300781 */ /*GILLT_v16s8*//*Label 5970*/ GIMT_Encode4(301037), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 300801 */ /*GILLT_nxv2s64*//*Label 5971*/ GIMT_Encode4(301071), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 300813 */ /*GILLT_nxv4s32*//*Label 5972*/ GIMT_Encode4(301097), GIMT_Encode4(0),
     /* 300821 */ /*GILLT_nxv8s16*//*Label 5973*/ GIMT_Encode4(301123), GIMT_Encode4(0),
     /* 300829 */ /*GILLT_nxv16s8*//*Label 5974*/ GIMT_Encode4(301149),
     /* 300833 */ // Label 5964: @300833
     /* 300833 */ GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(300866), // Rule ID 2477 //
     /* 300838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300859 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 300859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 300864 */   GIR_RootConstrainSelectedInstOperands,
     /* 300865 */   // GIR_Coverage, 2477,
     /* 300865 */   GIR_Done,
     /* 300866 */ // Label 5976: @300866
     /* 300866 */ GIM_Reject,
     /* 300867 */ // Label 5965: @300867
     /* 300867 */ GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(300900), // Rule ID 2481 //
     /* 300872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 300881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300893 */   // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 300893 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 300898 */   GIR_RootConstrainSelectedInstOperands,
     /* 300899 */   // GIR_Coverage, 2481,
     /* 300899 */   GIR_Done,
     /* 300900 */ // Label 5977: @300900
     /* 300900 */ GIM_Reject,
     /* 300901 */ // Label 5966: @300901
     /* 300901 */ GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(300934), // Rule ID 2476 //
     /* 300906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 300912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300927 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 300927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 300932 */   GIR_RootConstrainSelectedInstOperands,
     /* 300933 */   // GIR_Coverage, 2476,
     /* 300933 */   GIR_Done,
     /* 300934 */ // Label 5978: @300934
     /* 300934 */ GIM_Reject,
     /* 300935 */ // Label 5967: @300935
     /* 300935 */ GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(300968), // Rule ID 2480 //
     /* 300940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 300949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300961 */   // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 300961 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 300966 */   GIR_RootConstrainSelectedInstOperands,
     /* 300967 */   // GIR_Coverage, 2480,
     /* 300967 */   GIR_Done,
     /* 300968 */ // Label 5979: @300968
     /* 300968 */ GIM_Reject,
     /* 300969 */ // Label 5968: @300969
     /* 300969 */ GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(301002), // Rule ID 2475 //
     /* 300974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 300980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 300983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300995 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 300995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 301000 */   GIR_RootConstrainSelectedInstOperands,
     /* 301001 */   // GIR_Coverage, 2475,
     /* 301001 */   GIR_Done,
     /* 301002 */ // Label 5980: @301002
     /* 301002 */ GIM_Reject,
     /* 301003 */ // Label 5969: @301003
     /* 301003 */ GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(301036), // Rule ID 2479 //
     /* 301008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 301017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301025 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301029 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 301029 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 301034 */   GIR_RootConstrainSelectedInstOperands,
     /* 301035 */   // GIR_Coverage, 2479,
     /* 301035 */   GIR_Done,
     /* 301036 */ // Label 5981: @301036
     /* 301036 */ GIM_Reject,
     /* 301037 */ // Label 5970: @301037
     /* 301037 */ GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(301070), // Rule ID 2478 //
     /* 301042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 301048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 301051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301059 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301063 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 301063 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 301068 */   GIR_RootConstrainSelectedInstOperands,
     /* 301069 */   // GIR_Coverage, 2478,
     /* 301069 */   GIR_Done,
     /* 301070 */ // Label 5982: @301070
     /* 301070 */ GIM_Reject,
     /* 301071 */ // Label 5971: @301071
     /* 301071 */ GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(301096), // Rule ID 7513 //
     /* 301076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 301082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 301085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301089 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 301089 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 301094 */   GIR_RootConstrainSelectedInstOperands,
     /* 301095 */   // GIR_Coverage, 7513,
     /* 301095 */   GIR_Done,
     /* 301096 */ // Label 5983: @301096
     /* 301096 */ GIM_Reject,
     /* 301097 */ // Label 5972: @301097
     /* 301097 */ GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(301122), // Rule ID 7512 //
     /* 301102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301115 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301115 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 301120 */   GIR_RootConstrainSelectedInstOperands,
     /* 301121 */   // GIR_Coverage, 7512,
     /* 301121 */   GIR_Done,
     /* 301122 */ // Label 5984: @301122
     /* 301122 */ GIM_Reject,
     /* 301123 */ // Label 5973: @301123
     /* 301123 */ GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(301148), // Rule ID 7511 //
     /* 301128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 301134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 301137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301141 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 301141 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 301146 */   GIR_RootConstrainSelectedInstOperands,
     /* 301147 */   // GIR_Coverage, 7511,
     /* 301147 */   GIR_Done,
     /* 301148 */ // Label 5985: @301148
     /* 301148 */ GIM_Reject,
     /* 301149 */ // Label 5974: @301149
     /* 301149 */ GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(301174), // Rule ID 7510 //
     /* 301154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 301160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 301163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301167 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 301167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 301172 */   GIR_RootConstrainSelectedInstOperands,
     /* 301173 */   // GIR_Coverage, 7510,
     /* 301173 */   GIR_Done,
     /* 301174 */ // Label 5986: @301174
     /* 301174 */ GIM_Reject,
     /* 301175 */ // Label 5975: @301175
     /* 301175 */ GIM_Reject,
     /* 301176 */ // Label 57: @301176
     /* 301176 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5998*/ GIMT_Encode4(301605),
     /* 301187 */ /*GILLT_v2s32*//*Label 5987*/ GIMT_Encode4(301263),
     /* 301191 */ /*GILLT_v2s64*//*Label 5988*/ GIMT_Encode4(301297),
     /* 301195 */ /*GILLT_v4s16*//*Label 5989*/ GIMT_Encode4(301331),
     /* 301199 */ /*GILLT_v4s32*//*Label 5990*/ GIMT_Encode4(301365),
     /* 301203 */ /*GILLT_v8s8*//*Label 5991*/ GIMT_Encode4(301399),
     /* 301207 */ /*GILLT_v8s16*//*Label 5992*/ GIMT_Encode4(301433),
     /* 301211 */ /*GILLT_v16s8*//*Label 5993*/ GIMT_Encode4(301467), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301231 */ /*GILLT_nxv2s64*//*Label 5994*/ GIMT_Encode4(301501), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301243 */ /*GILLT_nxv4s32*//*Label 5995*/ GIMT_Encode4(301527), GIMT_Encode4(0),
     /* 301251 */ /*GILLT_nxv8s16*//*Label 5996*/ GIMT_Encode4(301553), GIMT_Encode4(0),
     /* 301259 */ /*GILLT_nxv16s8*//*Label 5997*/ GIMT_Encode4(301579),
     /* 301263 */ // Label 5987: @301263
     /* 301263 */ GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(301296), // Rule ID 5073 //
     /* 301268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301289 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 301289 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 301294 */   GIR_RootConstrainSelectedInstOperands,
     /* 301295 */   // GIR_Coverage, 5073,
     /* 301295 */   GIR_Done,
     /* 301296 */ // Label 5999: @301296
     /* 301296 */ GIM_Reject,
     /* 301297 */ // Label 5988: @301297
     /* 301297 */ GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(301330), // Rule ID 5077 //
     /* 301302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 301311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301323 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 301323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 301328 */   GIR_RootConstrainSelectedInstOperands,
     /* 301329 */   // GIR_Coverage, 5077,
     /* 301329 */   GIR_Done,
     /* 301330 */ // Label 6000: @301330
     /* 301330 */ GIM_Reject,
     /* 301331 */ // Label 5989: @301331
     /* 301331 */ GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(301364), // Rule ID 5072 //
     /* 301336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 301342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301353 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301357 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 301357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 301362 */   GIR_RootConstrainSelectedInstOperands,
     /* 301363 */   // GIR_Coverage, 5072,
     /* 301363 */   GIR_Done,
     /* 301364 */ // Label 6001: @301364
     /* 301364 */ GIM_Reject,
     /* 301365 */ // Label 5990: @301365
     /* 301365 */ GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(301398), // Rule ID 5076 //
     /* 301370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 301379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301391 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 301391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 301396 */   GIR_RootConstrainSelectedInstOperands,
     /* 301397 */   // GIR_Coverage, 5076,
     /* 301397 */   GIR_Done,
     /* 301398 */ // Label 6002: @301398
     /* 301398 */ GIM_Reject,
     /* 301399 */ // Label 5991: @301399
     /* 301399 */ GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(301432), // Rule ID 5071 //
     /* 301404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 301410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 301413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301425 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 301425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 301430 */   GIR_RootConstrainSelectedInstOperands,
     /* 301431 */   // GIR_Coverage, 5071,
     /* 301431 */   GIR_Done,
     /* 301432 */ // Label 6003: @301432
     /* 301432 */ GIM_Reject,
     /* 301433 */ // Label 5992: @301433
     /* 301433 */ GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(301466), // Rule ID 5075 //
     /* 301438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 301447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301459 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 301459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 301464 */   GIR_RootConstrainSelectedInstOperands,
     /* 301465 */   // GIR_Coverage, 5075,
     /* 301465 */   GIR_Done,
     /* 301466 */ // Label 6004: @301466
     /* 301466 */ GIM_Reject,
     /* 301467 */ // Label 5993: @301467
     /* 301467 */ GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(301500), // Rule ID 5074 //
     /* 301472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 301478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 301481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301489 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301493 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 301493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 301498 */   GIR_RootConstrainSelectedInstOperands,
     /* 301499 */   // GIR_Coverage, 5074,
     /* 301499 */   GIR_Done,
     /* 301500 */ // Label 6005: @301500
     /* 301500 */ GIM_Reject,
     /* 301501 */ // Label 5994: @301501
     /* 301501 */ GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(301526), // Rule ID 7525 //
     /* 301506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 301512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 301515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301519 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 301519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 301524 */   GIR_RootConstrainSelectedInstOperands,
     /* 301525 */   // GIR_Coverage, 7525,
     /* 301525 */   GIR_Done,
     /* 301526 */ // Label 6006: @301526
     /* 301526 */ GIM_Reject,
     /* 301527 */ // Label 5995: @301527
     /* 301527 */ GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(301552), // Rule ID 7524 //
     /* 301532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301545 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 301550 */   GIR_RootConstrainSelectedInstOperands,
     /* 301551 */   // GIR_Coverage, 7524,
     /* 301551 */   GIR_Done,
     /* 301552 */ // Label 6007: @301552
     /* 301552 */ GIM_Reject,
     /* 301553 */ // Label 5996: @301553
     /* 301553 */ GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(301578), // Rule ID 7523 //
     /* 301558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 301564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 301567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301571 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 301571 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 301576 */   GIR_RootConstrainSelectedInstOperands,
     /* 301577 */   // GIR_Coverage, 7523,
     /* 301577 */   GIR_Done,
     /* 301578 */ // Label 6008: @301578
     /* 301578 */ GIM_Reject,
     /* 301579 */ // Label 5997: @301579
     /* 301579 */ GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(301604), // Rule ID 7522 //
     /* 301584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 301590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 301593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301597 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 301597 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 301602 */   GIR_RootConstrainSelectedInstOperands,
     /* 301603 */   // GIR_Coverage, 7522,
     /* 301603 */   GIR_Done,
     /* 301604 */ // Label 6009: @301604
     /* 301604 */ GIM_Reject,
     /* 301605 */ // Label 5998: @301605
     /* 301605 */ GIM_Reject,
     /* 301606 */ // Label 58: @301606
     /* 301606 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 6021*/ GIMT_Encode4(302035),
     /* 301617 */ /*GILLT_v2s32*//*Label 6010*/ GIMT_Encode4(301693),
     /* 301621 */ /*GILLT_v2s64*//*Label 6011*/ GIMT_Encode4(301727),
     /* 301625 */ /*GILLT_v4s16*//*Label 6012*/ GIMT_Encode4(301761),
     /* 301629 */ /*GILLT_v4s32*//*Label 6013*/ GIMT_Encode4(301795),
     /* 301633 */ /*GILLT_v8s8*//*Label 6014*/ GIMT_Encode4(301829),
     /* 301637 */ /*GILLT_v8s16*//*Label 6015*/ GIMT_Encode4(301863),
     /* 301641 */ /*GILLT_v16s8*//*Label 6016*/ GIMT_Encode4(301897), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301661 */ /*GILLT_nxv2s64*//*Label 6017*/ GIMT_Encode4(301931), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301673 */ /*GILLT_nxv4s32*//*Label 6018*/ GIMT_Encode4(301957), GIMT_Encode4(0),
     /* 301681 */ /*GILLT_nxv8s16*//*Label 6019*/ GIMT_Encode4(301983), GIMT_Encode4(0),
     /* 301689 */ /*GILLT_nxv16s8*//*Label 6020*/ GIMT_Encode4(302009),
     /* 301693 */ // Label 6010: @301693
     /* 301693 */ GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(301726), // Rule ID 5066 //
     /* 301698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301719 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 301719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 301724 */   GIR_RootConstrainSelectedInstOperands,
     /* 301725 */   // GIR_Coverage, 5066,
     /* 301725 */   GIR_Done,
     /* 301726 */ // Label 6022: @301726
     /* 301726 */ GIM_Reject,
     /* 301727 */ // Label 6011: @301727
     /* 301727 */ GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(301760), // Rule ID 5070 //
     /* 301732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 301741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301753 */   // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 301753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 301758 */   GIR_RootConstrainSelectedInstOperands,
     /* 301759 */   // GIR_Coverage, 5070,
     /* 301759 */   GIR_Done,
     /* 301760 */ // Label 6023: @301760
     /* 301760 */ GIM_Reject,
     /* 301761 */ // Label 6012: @301761
     /* 301761 */ GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(301794), // Rule ID 5065 //
     /* 301766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 301772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301783 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301787 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 301787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 301792 */   GIR_RootConstrainSelectedInstOperands,
     /* 301793 */   // GIR_Coverage, 5065,
     /* 301793 */   GIR_Done,
     /* 301794 */ // Label 6024: @301794
     /* 301794 */ GIM_Reject,
     /* 301795 */ // Label 6013: @301795
     /* 301795 */ GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(301828), // Rule ID 5069 //
     /* 301800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 301809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301817 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301821 */   // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 301821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 301826 */   GIR_RootConstrainSelectedInstOperands,
     /* 301827 */   // GIR_Coverage, 5069,
     /* 301827 */   GIR_Done,
     /* 301828 */ // Label 6025: @301828
     /* 301828 */ GIM_Reject,
     /* 301829 */ // Label 6014: @301829
     /* 301829 */ GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(301862), // Rule ID 5064 //
     /* 301834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 301840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 301843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301851 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301855 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 301855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 301860 */   GIR_RootConstrainSelectedInstOperands,
     /* 301861 */   // GIR_Coverage, 5064,
     /* 301861 */   GIR_Done,
     /* 301862 */ // Label 6026: @301862
     /* 301862 */ GIM_Reject,
     /* 301863 */ // Label 6015: @301863
     /* 301863 */ GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(301896), // Rule ID 5068 //
     /* 301868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 301877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301889 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 301889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 301894 */   GIR_RootConstrainSelectedInstOperands,
     /* 301895 */   // GIR_Coverage, 5068,
     /* 301895 */   GIR_Done,
     /* 301896 */ // Label 6027: @301896
     /* 301896 */ GIM_Reject,
     /* 301897 */ // Label 6016: @301897
     /* 301897 */ GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(301930), // Rule ID 5067 //
     /* 301902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 301908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 301911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301923 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 301923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 301928 */   GIR_RootConstrainSelectedInstOperands,
     /* 301929 */   // GIR_Coverage, 5067,
     /* 301929 */   GIR_Done,
     /* 301930 */ // Label 6028: @301930
     /* 301930 */ GIM_Reject,
     /* 301931 */ // Label 6017: @301931
     /* 301931 */ GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(301956), // Rule ID 7521 //
     /* 301936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 301942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 301945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301949 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 301949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 301954 */   GIR_RootConstrainSelectedInstOperands,
     /* 301955 */   // GIR_Coverage, 7521,
     /* 301955 */   GIR_Done,
     /* 301956 */ // Label 6029: @301956
     /* 301956 */ GIM_Reject,
     /* 301957 */ // Label 6018: @301957
     /* 301957 */ GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(301982), // Rule ID 7520 //
     /* 301962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301975 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 301980 */   GIR_RootConstrainSelectedInstOperands,
     /* 301981 */   // GIR_Coverage, 7520,
     /* 301981 */   GIR_Done,
     /* 301982 */ // Label 6030: @301982
     /* 301982 */ GIM_Reject,
     /* 301983 */ // Label 6019: @301983
     /* 301983 */ GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(302008), // Rule ID 7519 //
     /* 301988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 301994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 301997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302001 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 302001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 302006 */   GIR_RootConstrainSelectedInstOperands,
     /* 302007 */   // GIR_Coverage, 7519,
     /* 302007 */   GIR_Done,
     /* 302008 */ // Label 6031: @302008
     /* 302008 */ GIM_Reject,
     /* 302009 */ // Label 6020: @302009
     /* 302009 */ GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(302034), // Rule ID 7518 //
     /* 302014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 302020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 302023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302027 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 302027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 302032 */   GIR_RootConstrainSelectedInstOperands,
     /* 302033 */   // GIR_Coverage, 7518,
     /* 302033 */   GIR_Done,
     /* 302034 */ // Label 6032: @302034
     /* 302034 */ GIM_Reject,
     /* 302035 */ // Label 6021: @302035
     /* 302035 */ GIM_Reject,
     /* 302036 */ // Label 59: @302036
     /* 302036 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6044*/ GIMT_Encode4(303833),
     /* 302047 */ /*GILLT_s16*//*Label 6033*/ GIMT_Encode4(302131),
     /* 302051 */ /*GILLT_s32*//*Label 6034*/ GIMT_Encode4(302357),
     /* 302055 */ /*GILLT_s64*//*Label 6035*/ GIMT_Encode4(302711), GIMT_Encode4(0),
     /* 302063 */ /*GILLT_v2s32*//*Label 6036*/ GIMT_Encode4(302883),
     /* 302067 */ /*GILLT_v2s64*//*Label 6037*/ GIMT_Encode4(302921),
     /* 302071 */ /*GILLT_v4s16*//*Label 6038*/ GIMT_Encode4(303097),
     /* 302075 */ /*GILLT_v4s32*//*Label 6039*/ GIMT_Encode4(303135), GIMT_Encode4(0),
     /* 302083 */ /*GILLT_v8s16*//*Label 6040*/ GIMT_Encode4(303311), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 302107 */ /*GILLT_nxv2s64*//*Label 6041*/ GIMT_Encode4(303755), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 302119 */ /*GILLT_nxv4s32*//*Label 6042*/ GIMT_Encode4(303781), GIMT_Encode4(0),
     /* 302127 */ /*GILLT_nxv8s16*//*Label 6043*/ GIMT_Encode4(303807),
     /* 302131 */ // Label 6033: @302131
     /* 302131 */ GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(302356),
     /* 302136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 302139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 302142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302146 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(302237), // Rule ID 6973 //
     /* 302151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302172 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 302176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302188 */     // MIs[2] Rn
     /* 302188 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 302197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302199 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 302199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 302202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302211 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 302217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 302230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302235 */     GIR_RootConstrainSelectedInstOperands,
     /* 302236 */     // GIR_Coverage, 6973,
     /* 302236 */     GIR_EraseRootFromParent_Done,
     /* 302237 */   // Label 6046: @302237
     /* 302237 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(302328), // Rule ID 14020 //
     /* 302242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302263 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 302267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302279 */     // MIs[2] Rn
     /* 302279 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302284 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 302288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302290 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 302290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 302293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302302 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 302308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302313 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 302321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302326 */     GIR_RootConstrainSelectedInstOperands,
     /* 302327 */     // GIR_Coverage, 14020,
     /* 302327 */     GIR_EraseRootFromParent_Done,
     /* 302328 */   // Label 6047: @302328
     /* 302328 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(302355), // Rule ID 584 //
     /* 302333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302344 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 302344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 302349 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302353 */     GIR_RootConstrainSelectedInstOperands,
     /* 302354 */     // GIR_Coverage, 584,
     /* 302354 */     GIR_Done,
     /* 302355 */   // Label 6048: @302355
     /* 302355 */   GIM_Reject,
     /* 302356 */ // Label 6045: @302356
     /* 302356 */ GIM_Reject,
     /* 302357 */ // Label 6034: @302357
     /* 302357 */ GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(302710),
     /* 302362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 302368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302372 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(302463), // Rule ID 6971 //
     /* 302377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302398 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 302402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302414 */     // MIs[2] Rn
     /* 302414 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302419 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 302423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302425 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 302425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 302428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302437 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 302443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 302456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302461 */     GIR_RootConstrainSelectedInstOperands,
     /* 302462 */     // GIR_Coverage, 6971,
     /* 302462 */     GIR_EraseRootFromParent_Done,
     /* 302463 */   // Label 6050: @302463
     /* 302463 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(302527), // Rule ID 13202 //
     /* 302468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302489 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 302493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302505 */     // MIs[2] Rn
     /* 302505 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302510 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 302514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302516 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 302516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 302519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302525 */     GIR_RootConstrainSelectedInstOperands,
     /* 302526 */     // GIR_Coverage, 13202,
     /* 302526 */     GIR_EraseRootFromParent_Done,
     /* 302527 */   // Label 6051: @302527
     /* 302527 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(302618), // Rule ID 14018 //
     /* 302532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302553 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 302557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302569 */     // MIs[2] Rn
     /* 302569 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302574 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 302578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302580 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 302580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 302583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302592 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 302598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 302611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302616 */     GIR_RootConstrainSelectedInstOperands,
     /* 302617 */     // GIR_Coverage, 14018,
     /* 302617 */     GIR_EraseRootFromParent_Done,
     /* 302618 */   // Label 6052: @302618
     /* 302618 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(302682), // Rule ID 15845 //
     /* 302623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302644 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 302648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302660 */     // MIs[2] Rn
     /* 302660 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302665 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 302669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302671 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 302671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 302674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302680 */     GIR_RootConstrainSelectedInstOperands,
     /* 302681 */     // GIR_Coverage, 15845,
     /* 302681 */     GIR_EraseRootFromParent_Done,
     /* 302682 */   // Label 6053: @302682
     /* 302682 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(302709), // Rule ID 586 //
     /* 302687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302698 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 302698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 302703 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302707 */     GIR_RootConstrainSelectedInstOperands,
     /* 302708 */     // GIR_Coverage, 586,
     /* 302708 */     GIR_Done,
     /* 302709 */   // Label 6054: @302709
     /* 302709 */   GIM_Reject,
     /* 302710 */ // Label 6049: @302710
     /* 302710 */ GIM_Reject,
     /* 302711 */ // Label 6035: @302711
     /* 302711 */ GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(302882),
     /* 302716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 302722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302726 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(302790), // Rule ID 6969 //
     /* 302731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302752 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 302756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302768 */     // MIs[2] Rn
     /* 302768 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302773 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 302777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302779 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 302779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 302782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302788 */     GIR_RootConstrainSelectedInstOperands,
     /* 302789 */     // GIR_Coverage, 6969,
     /* 302789 */     GIR_EraseRootFromParent_Done,
     /* 302790 */   // Label 6056: @302790
     /* 302790 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(302854), // Rule ID 14016 //
     /* 302795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302816 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 302820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302832 */     // MIs[2] Rn
     /* 302832 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302837 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 302841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302843 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 302843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 302846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302852 */     GIR_RootConstrainSelectedInstOperands,
     /* 302853 */     // GIR_Coverage, 14016,
     /* 302853 */     GIR_EraseRootFromParent_Done,
     /* 302854 */   // Label 6057: @302854
     /* 302854 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(302881), // Rule ID 588 //
     /* 302859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302870 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 302870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 302875 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302879 */     GIR_RootConstrainSelectedInstOperands,
     /* 302880 */     // GIR_Coverage, 588,
     /* 302880 */     GIR_Done,
     /* 302881 */   // Label 6058: @302881
     /* 302881 */   GIM_Reject,
     /* 302882 */ // Label 6055: @302882
     /* 302882 */ GIM_Reject,
     /* 302883 */ // Label 6036: @302883
     /* 302883 */ GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(302920), // Rule ID 1203 //
     /* 302888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302905 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302909 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 302909 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 302914 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302918 */   GIR_RootConstrainSelectedInstOperands,
     /* 302919 */   // GIR_Coverage, 1203,
     /* 302919 */   GIR_Done,
     /* 302920 */ // Label 6059: @302920
     /* 302920 */ GIM_Reject,
     /* 302921 */ // Label 6037: @302921
     /* 302921 */ GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(303096),
     /* 302926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 302932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302936 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(303002), // Rule ID 6991 //
     /* 302941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 302949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 302957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 302975 */     // MIs[2] Rn
     /* 302975 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302980 */     // MIs[2] Rm
     /* 302980 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 302985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302987 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 302987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 302990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303000 */     GIR_RootConstrainSelectedInstOperands,
     /* 303001 */     // GIR_Coverage, 6991,
     /* 303001 */     GIR_EraseRootFromParent_Done,
     /* 303002 */   // Label 6061: @303002
     /* 303002 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(303068), // Rule ID 14028 //
     /* 303007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 303015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 303041 */     // MIs[2] Rn
     /* 303041 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303046 */     // MIs[2] Rm
     /* 303046 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 303051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303053 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 303053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 303056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303066 */     GIR_RootConstrainSelectedInstOperands,
     /* 303067 */     // GIR_Coverage, 14028,
     /* 303067 */     GIR_EraseRootFromParent_Done,
     /* 303068 */   // Label 6062: @303068
     /* 303068 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(303095), // Rule ID 1207 //
     /* 303073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303084 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 303084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 303089 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303093 */     GIR_RootConstrainSelectedInstOperands,
     /* 303094 */     // GIR_Coverage, 1207,
     /* 303094 */     GIR_Done,
     /* 303095 */   // Label 6063: @303095
     /* 303095 */   GIM_Reject,
     /* 303096 */ // Label 6060: @303096
     /* 303096 */ GIM_Reject,
     /* 303097 */ // Label 6038: @303097
     /* 303097 */ GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(303134), // Rule ID 1199 //
     /* 303102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 303111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303123 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 303128 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303132 */   GIR_RootConstrainSelectedInstOperands,
     /* 303133 */   // GIR_Coverage, 1199,
     /* 303133 */   GIR_Done,
     /* 303134 */ // Label 6064: @303134
     /* 303134 */ GIM_Reject,
     /* 303135 */ // Label 6039: @303135
     /* 303135 */ GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(303310),
     /* 303140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 303146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303150 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(303216), // Rule ID 6992 //
     /* 303155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 303163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 303171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 303189 */     // MIs[2] Rn
     /* 303189 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303194 */     // MIs[2] Rm
     /* 303194 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 303199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303201 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 303201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 303204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303214 */     GIR_RootConstrainSelectedInstOperands,
     /* 303215 */     // GIR_Coverage, 6992,
     /* 303215 */     GIR_EraseRootFromParent_Done,
     /* 303216 */   // Label 6066: @303216
     /* 303216 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(303282), // Rule ID 14029 //
     /* 303221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 303229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 303237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 303255 */     // MIs[2] Rn
     /* 303255 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303260 */     // MIs[2] Rm
     /* 303260 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 303265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303267 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 303267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 303270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303280 */     GIR_RootConstrainSelectedInstOperands,
     /* 303281 */     // GIR_Coverage, 14029,
     /* 303281 */     GIR_EraseRootFromParent_Done,
     /* 303282 */   // Label 6067: @303282
     /* 303282 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(303309), // Rule ID 1205 //
     /* 303287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303298 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 303298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 303303 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303307 */     GIR_RootConstrainSelectedInstOperands,
     /* 303308 */     // GIR_Coverage, 1205,
     /* 303308 */     GIR_Done,
     /* 303309 */   // Label 6068: @303309
     /* 303309 */   GIM_Reject,
     /* 303310 */ // Label 6065: @303310
     /* 303310 */ GIM_Reject,
     /* 303311 */ // Label 6040: @303311
     /* 303311 */ GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(303754),
     /* 303316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 303322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303326 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(303395), // Rule ID 6993 //
     /* 303331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 303342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 303350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 303368 */     // MIs[2] Rn
     /* 303368 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303373 */     // MIs[2] Rm
     /* 303373 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 303378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303380 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 303380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 303383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303393 */     GIR_RootConstrainSelectedInstOperands,
     /* 303394 */     // GIR_Coverage, 6993,
     /* 303394 */     GIR_EraseRootFromParent_Done,
     /* 303395 */   // Label 6070: @303395
     /* 303395 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(303464), // Rule ID 14030 //
     /* 303400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 303411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 303419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 303437 */     // MIs[2] Rn
     /* 303437 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303442 */     // MIs[2] Rm
     /* 303442 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 303447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303449 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 303449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 303452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303462 */     GIR_RootConstrainSelectedInstOperands,
     /* 303463 */     // GIR_Coverage, 14030,
     /* 303463 */     GIR_EraseRootFromParent_Done,
     /* 303464 */   // Label 6071: @303464
     /* 303464 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(303491), // Rule ID 1201 //
     /* 303469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303480 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 303480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 303485 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303489 */     GIR_RootConstrainSelectedInstOperands,
     /* 303490 */     // GIR_Coverage, 1201,
     /* 303490 */     GIR_Done,
     /* 303491 */   // Label 6072: @303491
     /* 303491 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(303753), // Rule ID 7062 //
     /* 303496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 303499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303507 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 303507 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 303510 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 303514 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303519 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 303523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 303525 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 303528 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 303532 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303537 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 303541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 303543 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 303546 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 303550 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303555 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 303558 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 303561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 303563 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 303566 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303570 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303575 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 303581 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303586 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303591 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 303594 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 303598 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303603 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 303606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 303608 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 303611 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303615 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303620 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303626 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303631 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303636 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 303639 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 303643 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303648 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 303651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 303653 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 303656 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 303660 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303665 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 303668 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 303671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303673 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 303676 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 303680 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303685 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 303688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 303690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 303719 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 303722 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 303725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 303743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 303751 */     GIR_RootConstrainSelectedInstOperands,
     /* 303752 */     // GIR_Coverage, 7062,
     /* 303752 */     GIR_EraseRootFromParent_Done,
     /* 303753 */   // Label 6073: @303753
     /* 303753 */   GIM_Reject,
     /* 303754 */ // Label 6069: @303754
     /* 303754 */ GIM_Reject,
     /* 303755 */ // Label 6041: @303755
     /* 303755 */ GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(303780), // Rule ID 2824 //
     /* 303760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 303766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 303769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303773 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 303773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 303778 */   GIR_RootConstrainSelectedInstOperands,
     /* 303779 */   // GIR_Coverage, 2824,
     /* 303779 */   GIR_Done,
     /* 303780 */ // Label 6074: @303780
     /* 303780 */ GIM_Reject,
     /* 303781 */ // Label 6042: @303781
     /* 303781 */ GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(303806), // Rule ID 2822 //
     /* 303786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 303792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 303795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303799 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 303799 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 303804 */   GIR_RootConstrainSelectedInstOperands,
     /* 303805 */   // GIR_Coverage, 2822,
     /* 303805 */   GIR_Done,
     /* 303806 */ // Label 6075: @303806
     /* 303806 */ GIM_Reject,
     /* 303807 */ // Label 6043: @303807
     /* 303807 */ GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(303832), // Rule ID 2820 //
     /* 303812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 303818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 303821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303825 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 303825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 303830 */   GIR_RootConstrainSelectedInstOperands,
     /* 303831 */   // GIR_Coverage, 2820,
     /* 303831 */   GIR_Done,
     /* 303832 */ // Label 6076: @303832
     /* 303832 */ GIM_Reject,
     /* 303833 */ // Label 6044: @303833
     /* 303833 */ GIM_Reject,
     /* 303834 */ // Label 60: @303834
     /* 303834 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6088*/ GIMT_Encode4(304571),
     /* 303845 */ /*GILLT_s16*//*Label 6077*/ GIMT_Encode4(303929),
     /* 303849 */ /*GILLT_s32*//*Label 6078*/ GIMT_Encode4(303967),
     /* 303853 */ /*GILLT_s64*//*Label 6079*/ GIMT_Encode4(304005), GIMT_Encode4(0),
     /* 303861 */ /*GILLT_v2s32*//*Label 6080*/ GIMT_Encode4(304043),
     /* 303865 */ /*GILLT_v2s64*//*Label 6081*/ GIMT_Encode4(304081),
     /* 303869 */ /*GILLT_v4s16*//*Label 6082*/ GIMT_Encode4(304119),
     /* 303873 */ /*GILLT_v4s32*//*Label 6083*/ GIMT_Encode4(304157), GIMT_Encode4(0),
     /* 303881 */ /*GILLT_v8s16*//*Label 6084*/ GIMT_Encode4(304195), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303905 */ /*GILLT_nxv2s64*//*Label 6085*/ GIMT_Encode4(304493), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303917 */ /*GILLT_nxv4s32*//*Label 6086*/ GIMT_Encode4(304519), GIMT_Encode4(0),
     /* 303925 */ /*GILLT_nxv8s16*//*Label 6087*/ GIMT_Encode4(304545),
     /* 303929 */ // Label 6077: @303929
     /* 303929 */ GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(303966), // Rule ID 632 //
     /* 303934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 303943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303955 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 303955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 303960 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303964 */   GIR_RootConstrainSelectedInstOperands,
     /* 303965 */   // GIR_Coverage, 632,
     /* 303965 */   GIR_Done,
     /* 303966 */ // Label 6089: @303966
     /* 303966 */ GIM_Reject,
     /* 303967 */ // Label 6078: @303967
     /* 303967 */ GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(304004), // Rule ID 634 //
     /* 303972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 303981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303993 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 303993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 303998 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304002 */   GIR_RootConstrainSelectedInstOperands,
     /* 304003 */   // GIR_Coverage, 634,
     /* 304003 */   GIR_Done,
     /* 304004 */ // Label 6090: @304004
     /* 304004 */ GIM_Reject,
     /* 304005 */ // Label 6079: @304005
     /* 304005 */ GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(304042), // Rule ID 636 //
     /* 304010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 304019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304031 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 304031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 304036 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304040 */   GIR_RootConstrainSelectedInstOperands,
     /* 304041 */   // GIR_Coverage, 636,
     /* 304041 */   GIR_Done,
     /* 304042 */ // Label 6091: @304042
     /* 304042 */ GIM_Reject,
     /* 304043 */ // Label 6080: @304043
     /* 304043 */ GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(304080), // Rule ID 1343 //
     /* 304048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 304054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 304057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304069 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 304069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 304074 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304078 */   GIR_RootConstrainSelectedInstOperands,
     /* 304079 */   // GIR_Coverage, 1343,
     /* 304079 */   GIR_Done,
     /* 304080 */ // Label 6092: @304080
     /* 304080 */ GIM_Reject,
     /* 304081 */ // Label 6081: @304081
     /* 304081 */ GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(304118), // Rule ID 1347 //
     /* 304086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 304095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304107 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 304107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 304112 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304116 */   GIR_RootConstrainSelectedInstOperands,
     /* 304117 */   // GIR_Coverage, 1347,
     /* 304117 */   GIR_Done,
     /* 304118 */ // Label 6093: @304118
     /* 304118 */ GIM_Reject,
     /* 304119 */ // Label 6082: @304119
     /* 304119 */ GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(304156), // Rule ID 1339 //
     /* 304124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 304133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304145 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 304145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 304150 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304154 */   GIR_RootConstrainSelectedInstOperands,
     /* 304155 */   // GIR_Coverage, 1339,
     /* 304155 */   GIR_Done,
     /* 304156 */ // Label 6094: @304156
     /* 304156 */ GIM_Reject,
     /* 304157 */ // Label 6083: @304157
     /* 304157 */ GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(304194), // Rule ID 1345 //
     /* 304162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304179 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304183 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304183 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 304188 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304192 */   GIR_RootConstrainSelectedInstOperands,
     /* 304193 */   // GIR_Coverage, 1345,
     /* 304193 */   GIR_Done,
     /* 304194 */ // Label 6095: @304194
     /* 304194 */ GIM_Reject,
     /* 304195 */ // Label 6084: @304195
     /* 304195 */ GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(304492),
     /* 304200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304214 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304218 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(304237), // Rule ID 1341 //
     /* 304223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304226 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 304226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 304231 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304235 */     GIR_RootConstrainSelectedInstOperands,
     /* 304236 */     // GIR_Coverage, 1341,
     /* 304236 */     GIR_Done,
     /* 304237 */   // Label 6097: @304237
     /* 304237 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(304491), // Rule ID 7068 //
     /* 304242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 304245 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 304245 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 304248 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 304252 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304257 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 304261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 304263 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 304266 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 304270 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304275 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 304279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 304281 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 304284 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 304288 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304293 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 304296 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 304299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 304301 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 304304 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304308 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304313 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 304319 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304324 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304329 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 304332 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 304336 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304341 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 304344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 304346 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 304349 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304353 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304358 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 304364 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304369 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304374 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 304377 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 304381 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304386 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 304389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304391 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 304394 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 304398 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304403 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 304406 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 304409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304411 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 304414 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 304418 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304423 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 304428 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304431 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304435 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304454 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 304457 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 304460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 304481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 304489 */     GIR_RootConstrainSelectedInstOperands,
     /* 304490 */     // GIR_Coverage, 7068,
     /* 304490 */     GIR_EraseRootFromParent_Done,
     /* 304491 */   // Label 6098: @304491
     /* 304491 */   GIM_Reject,
     /* 304492 */ // Label 6096: @304492
     /* 304492 */ GIM_Reject,
     /* 304493 */ // Label 6085: @304493
     /* 304493 */ GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(304518), // Rule ID 8268 //
     /* 304498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 304504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 304507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304511 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 304511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 304516 */   GIR_RootConstrainSelectedInstOperands,
     /* 304517 */   // GIR_Coverage, 8268,
     /* 304517 */   GIR_Done,
     /* 304518 */ // Label 6099: @304518
     /* 304518 */ GIM_Reject,
     /* 304519 */ // Label 6086: @304519
     /* 304519 */ GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(304544), // Rule ID 8266 //
     /* 304524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 304530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 304533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304537 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 304537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 304542 */   GIR_RootConstrainSelectedInstOperands,
     /* 304543 */   // GIR_Coverage, 8266,
     /* 304543 */   GIR_Done,
     /* 304544 */ // Label 6100: @304544
     /* 304544 */ GIM_Reject,
     /* 304545 */ // Label 6087: @304545
     /* 304545 */ GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(304570), // Rule ID 8264 //
     /* 304550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 304556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 304559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304563 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 304563 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 304568 */   GIR_RootConstrainSelectedInstOperands,
     /* 304569 */   // GIR_Coverage, 8264,
     /* 304569 */   GIR_Done,
     /* 304570 */ // Label 6101: @304570
     /* 304570 */ GIM_Reject,
     /* 304571 */ // Label 6088: @304571
     /* 304571 */ GIM_Reject,
     /* 304572 */ // Label 61: @304572
     /* 304572 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6113*/ GIMT_Encode4(308667),
     /* 304583 */ /*GILLT_s16*//*Label 6102*/ GIMT_Encode4(304667),
     /* 304587 */ /*GILLT_s32*//*Label 6103*/ GIMT_Encode4(305309),
     /* 304591 */ /*GILLT_s64*//*Label 6104*/ GIMT_Encode4(305939), GIMT_Encode4(0),
     /* 304599 */ /*GILLT_v2s32*//*Label 6105*/ GIMT_Encode4(306569),
     /* 304603 */ /*GILLT_v2s64*//*Label 6106*/ GIMT_Encode4(307099),
     /* 304607 */ /*GILLT_v4s16*//*Label 6107*/ GIMT_Encode4(307457),
     /* 304611 */ /*GILLT_v4s32*//*Label 6108*/ GIMT_Encode4(307799), GIMT_Encode4(0),
     /* 304619 */ /*GILLT_v8s16*//*Label 6109*/ GIMT_Encode4(308157), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 304643 */ /*GILLT_nxv2s64*//*Label 6110*/ GIMT_Encode4(308589), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 304655 */ /*GILLT_nxv4s32*//*Label 6111*/ GIMT_Encode4(308615), GIMT_Encode4(0),
     /* 304663 */ /*GILLT_nxv8s16*//*Label 6112*/ GIMT_Encode4(308641),
     /* 304667 */ // Label 6102: @304667
     /* 304667 */ GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(305308),
     /* 304672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 304678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304682 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(304795), // Rule ID 6301 //
     /* 304687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304711 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304731 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304744 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304748 */     // MIs[3] Operand 1
     /* 304748 */     // No operand predicates
     /* 304748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304750 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304762 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 304768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 304781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304793 */     GIR_RootConstrainSelectedInstOperands,
     /* 304794 */     // GIR_Coverage, 6301,
     /* 304794 */     GIR_EraseRootFromParent_Done,
     /* 304795 */   // Label 6115: @304795
     /* 304795 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(304908), // Rule ID 13997 //
     /* 304800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304832 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304836 */     // MIs[2] Operand 1
     /* 304836 */     // No operand predicates
     /* 304836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 304840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304844 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304848 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 304852 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304857 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 304861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304863 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304875 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 304881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 304894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304906 */     GIR_RootConstrainSelectedInstOperands,
     /* 304907 */     // GIR_Coverage, 13997,
     /* 304907 */     GIR_EraseRootFromParent_Done,
     /* 304908 */   // Label 6116: @304908
     /* 304908 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(304987), // Rule ID 13931 //
     /* 304913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304937 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304947 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 304947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304959 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 304965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 304978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304985 */     GIR_RootConstrainSelectedInstOperands,
     /* 304986 */     // GIR_Coverage, 13931,
     /* 304986 */     GIR_EraseRootFromParent_Done,
     /* 304987 */   // Label 6117: @304987
     /* 304987 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(305066), // Rule ID 4839 //
     /* 304992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305020 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305026 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 305026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305038 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 305044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 305057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305064 */     GIR_RootConstrainSelectedInstOperands,
     /* 305065 */     // GIR_Coverage, 4839,
     /* 305065 */     GIR_EraseRootFromParent_Done,
     /* 305066 */   // Label 6118: @305066
     /* 305066 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(305129), // Rule ID 13546 //
     /* 305071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305103 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305107 */     // MIs[2] Operand 1
     /* 305107 */     // No operand predicates
     /* 305107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305113 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 305116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305127 */     GIR_RootConstrainSelectedInstOperands,
     /* 305128 */     // GIR_Coverage, 13546,
     /* 305128 */     GIR_EraseRootFromParent_Done,
     /* 305129 */   // Label 6119: @305129
     /* 305129 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(305192), // Rule ID 2012 //
     /* 305134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305170 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305174 */     // MIs[2] Operand 1
     /* 305174 */     // No operand predicates
     /* 305174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305176 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 305179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305190 */     GIR_RootConstrainSelectedInstOperands,
     /* 305191 */     // GIR_Coverage, 2012,
     /* 305191 */     GIR_EraseRootFromParent_Done,
     /* 305192 */   // Label 6120: @305192
     /* 305192 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(305236), // Rule ID 4844 //
     /* 305197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305223 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 305223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 305226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 305232 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 305234 */     GIR_RootConstrainSelectedInstOperands,
     /* 305235 */     // GIR_Coverage, 4844,
     /* 305235 */     GIR_EraseRootFromParent_Done,
     /* 305236 */   // Label 6121: @305236
     /* 305236 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(305280), // Rule ID 13936 //
     /* 305241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305267 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 305267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 305270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 305276 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 305278 */     GIR_RootConstrainSelectedInstOperands,
     /* 305279 */     // GIR_Coverage, 13936,
     /* 305279 */     GIR_EraseRootFromParent_Done,
     /* 305280 */   // Label 6122: @305280
     /* 305280 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(305307), // Rule ID 620 //
     /* 305285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305296 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 305296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 305301 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305305 */     GIR_RootConstrainSelectedInstOperands,
     /* 305306 */     // GIR_Coverage, 620,
     /* 305306 */     GIR_Done,
     /* 305307 */   // Label 6123: @305307
     /* 305307 */   GIM_Reject,
     /* 305308 */ // Label 6114: @305308
     /* 305308 */ GIM_Reject,
     /* 305309 */ // Label 6103: @305309
     /* 305309 */ GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(305938),
     /* 305314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 305320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305324 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(305437), // Rule ID 6303 //
     /* 305329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305353 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305386 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305390 */     // MIs[3] Operand 1
     /* 305390 */     // No operand predicates
     /* 305390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305392 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 305392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 305395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305404 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 305410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 305423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305435 */     GIR_RootConstrainSelectedInstOperands,
     /* 305436 */     // GIR_Coverage, 6303,
     /* 305436 */     GIR_EraseRootFromParent_Done,
     /* 305437 */   // Label 6125: @305437
     /* 305437 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(305550), // Rule ID 13999 //
     /* 305442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305474 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305478 */     // MIs[2] Operand 1
     /* 305478 */     // No operand predicates
     /* 305478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 305482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305490 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 305494 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305499 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 305503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305505 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 305505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 305508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305517 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 305523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 305536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305548 */     GIR_RootConstrainSelectedInstOperands,
     /* 305549 */     // GIR_Coverage, 13999,
     /* 305549 */     GIR_EraseRootFromParent_Done,
     /* 305550 */   // Label 6126: @305550
     /* 305550 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(305626), // Rule ID 13933 //
     /* 305555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305576 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305586 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 305586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 305589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305598 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 305604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 305617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305624 */     GIR_RootConstrainSelectedInstOperands,
     /* 305625 */     // GIR_Coverage, 13933,
     /* 305625 */     GIR_EraseRootFromParent_Done,
     /* 305626 */   // Label 6127: @305626
     /* 305626 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(305702), // Rule ID 4841 //
     /* 305631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305656 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305662 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 305662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 305665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305674 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 305680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 305693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305700 */     GIR_RootConstrainSelectedInstOperands,
     /* 305701 */     // GIR_Coverage, 4841,
     /* 305701 */     GIR_EraseRootFromParent_Done,
     /* 305702 */   // Label 6128: @305702
     /* 305702 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(305765), // Rule ID 13548 //
     /* 305707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305739 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305743 */     // MIs[2] Operand 1
     /* 305743 */     // No operand predicates
     /* 305743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305749 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 305752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305763 */     GIR_RootConstrainSelectedInstOperands,
     /* 305764 */     // GIR_Coverage, 13548,
     /* 305764 */     GIR_EraseRootFromParent_Done,
     /* 305765 */   // Label 6129: @305765
     /* 305765 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(305828), // Rule ID 2014 //
     /* 305770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305806 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305810 */     // MIs[2] Operand 1
     /* 305810 */     // No operand predicates
     /* 305810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305812 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 305815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305826 */     GIR_RootConstrainSelectedInstOperands,
     /* 305827 */     // GIR_Coverage, 2014,
     /* 305827 */     GIR_EraseRootFromParent_Done,
     /* 305828 */   // Label 6130: @305828
     /* 305828 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(305869), // Rule ID 4845 //
     /* 305833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 305845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305856 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 305856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 305859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 305865 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 305867 */     GIR_RootConstrainSelectedInstOperands,
     /* 305868 */     // GIR_Coverage, 4845,
     /* 305868 */     GIR_EraseRootFromParent_Done,
     /* 305869 */   // Label 6131: @305869
     /* 305869 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(305910), // Rule ID 13937 //
     /* 305874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 305890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305897 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 305897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 305900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 305906 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 305908 */     GIR_RootConstrainSelectedInstOperands,
     /* 305909 */     // GIR_Coverage, 13937,
     /* 305909 */     GIR_EraseRootFromParent_Done,
     /* 305910 */   // Label 6132: @305910
     /* 305910 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(305937), // Rule ID 622 //
     /* 305915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305926 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 305926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 305931 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305935 */     GIR_RootConstrainSelectedInstOperands,
     /* 305936 */     // GIR_Coverage, 622,
     /* 305936 */     GIR_Done,
     /* 305937 */   // Label 6133: @305937
     /* 305937 */   GIM_Reject,
     /* 305938 */ // Label 6124: @305938
     /* 305938 */ GIM_Reject,
     /* 305939 */ // Label 6104: @305939
     /* 305939 */ GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(306568),
     /* 305944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 305947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 305950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305954 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(306067), // Rule ID 6305 //
     /* 305959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305983 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306016 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 306020 */     // MIs[3] Operand 1
     /* 306020 */     // No operand predicates
     /* 306020 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306022 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 306022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 306025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306034 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 306040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 306053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306065 */     GIR_RootConstrainSelectedInstOperands,
     /* 306066 */     // GIR_Coverage, 6305,
     /* 306066 */     GIR_EraseRootFromParent_Done,
     /* 306067 */   // Label 6135: @306067
     /* 306067 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(306180), // Rule ID 14001 //
     /* 306072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306104 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 306108 */     // MIs[2] Operand 1
     /* 306108 */     // No operand predicates
     /* 306108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 306112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306116 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306120 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 306124 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306129 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 306133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306135 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 306135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 306138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306147 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 306153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 306166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306178 */     GIR_RootConstrainSelectedInstOperands,
     /* 306179 */     // GIR_Coverage, 14001,
     /* 306179 */     GIR_EraseRootFromParent_Done,
     /* 306180 */   // Label 6136: @306180
     /* 306180 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(306256), // Rule ID 13935 //
     /* 306185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306206 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306216 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 306216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 306219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306228 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 306234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 306247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306254 */     GIR_RootConstrainSelectedInstOperands,
     /* 306255 */     // GIR_Coverage, 13935,
     /* 306255 */     GIR_EraseRootFromParent_Done,
     /* 306256 */   // Label 6137: @306256
     /* 306256 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(306332), // Rule ID 4843 //
     /* 306261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306286 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306292 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 306292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 306295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306304 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 306310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 306323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306330 */     GIR_RootConstrainSelectedInstOperands,
     /* 306331 */     // GIR_Coverage, 4843,
     /* 306331 */     GIR_EraseRootFromParent_Done,
     /* 306332 */   // Label 6138: @306332
     /* 306332 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(306395), // Rule ID 13550 //
     /* 306337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306369 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 306373 */     // MIs[2] Operand 1
     /* 306373 */     // No operand predicates
     /* 306373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306379 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 306382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306393 */     GIR_RootConstrainSelectedInstOperands,
     /* 306394 */     // GIR_Coverage, 13550,
     /* 306394 */     GIR_EraseRootFromParent_Done,
     /* 306395 */   // Label 6139: @306395
     /* 306395 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(306458), // Rule ID 2016 //
     /* 306400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306436 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 306440 */     // MIs[2] Operand 1
     /* 306440 */     // No operand predicates
     /* 306440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306442 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 306445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306456 */     GIR_RootConstrainSelectedInstOperands,
     /* 306457 */     // GIR_Coverage, 2016,
     /* 306457 */     GIR_EraseRootFromParent_Done,
     /* 306458 */   // Label 6140: @306458
     /* 306458 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(306499), // Rule ID 4846 //
     /* 306463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 306475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306486 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 306486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 306489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306495 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 306497 */     GIR_RootConstrainSelectedInstOperands,
     /* 306498 */     // GIR_Coverage, 4846,
     /* 306498 */     GIR_EraseRootFromParent_Done,
     /* 306499 */   // Label 6141: @306499
     /* 306499 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(306540), // Rule ID 13938 //
     /* 306504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 306520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306527 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 306527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 306530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306536 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 306538 */     GIR_RootConstrainSelectedInstOperands,
     /* 306539 */     // GIR_Coverage, 13938,
     /* 306539 */     GIR_EraseRootFromParent_Done,
     /* 306540 */   // Label 6142: @306540
     /* 306540 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(306567), // Rule ID 624 //
     /* 306545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306556 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 306556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 306561 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306565 */     GIR_RootConstrainSelectedInstOperands,
     /* 306566 */     // GIR_Coverage, 624,
     /* 306566 */     GIR_Done,
     /* 306567 */   // Label 6143: @306567
     /* 306567 */   GIM_Reject,
     /* 306568 */ // Label 6134: @306568
     /* 306568 */ GIM_Reject,
     /* 306569 */ // Label 6105: @306569
     /* 306569 */ GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(307098),
     /* 306574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 306577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 306580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306584 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(306670), // Rule ID 13539 //
     /* 306589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 306600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306629 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306633 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306637 */     // MIs[3] Operand 1
     /* 306637 */     // No operand predicates
     /* 306637 */     // MIs[1] Operand 2
     /* 306637 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 306648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306654 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306668 */     GIR_RootConstrainSelectedInstOperands,
     /* 306669 */     // GIR_Coverage, 13539,
     /* 306669 */     GIR_EraseRootFromParent_Done,
     /* 306670 */   // Label 6145: @306670
     /* 306670 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(306756), // Rule ID 2005 //
     /* 306675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 306690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306723 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306727 */     // MIs[3] Operand 1
     /* 306727 */     // No operand predicates
     /* 306727 */     // MIs[1] Operand 2
     /* 306727 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 306738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306740 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306754 */     GIR_RootConstrainSelectedInstOperands,
     /* 306755 */     // GIR_Coverage, 2005,
     /* 306755 */     GIR_EraseRootFromParent_Done,
     /* 306756 */   // Label 6146: @306756
     /* 306756 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(306819), // Rule ID 13540 //
     /* 306761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306793 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306797 */     // MIs[2] Operand 1
     /* 306797 */     // No operand predicates
     /* 306797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306801 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306803 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306817 */     GIR_RootConstrainSelectedInstOperands,
     /* 306818 */     // GIR_Coverage, 13540,
     /* 306818 */     GIR_EraseRootFromParent_Done,
     /* 306819 */   // Label 6147: @306819
     /* 306819 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(306882), // Rule ID 2006 //
     /* 306824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306860 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306864 */     // MIs[2] Operand 1
     /* 306864 */     // No operand predicates
     /* 306864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306866 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306880 */     GIR_RootConstrainSelectedInstOperands,
     /* 306881 */     // GIR_Coverage, 2006,
     /* 306881 */     GIR_EraseRootFromParent_Done,
     /* 306882 */   // Label 6148: @306882
     /* 306882 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(306976), // Rule ID 14003 //
     /* 306887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306910 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306910 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 306913 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306917 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 306927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306936 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 306946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306974 */     GIR_RootConstrainSelectedInstOperands,
     /* 306975 */     // GIR_Coverage, 14003,
     /* 306975 */     GIR_EraseRootFromParent_Done,
     /* 306976 */   // Label 6149: @306976
     /* 306976 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(307070), // Rule ID 6307 //
     /* 306981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307004 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307004 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307007 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307011 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307033 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307037 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307068 */     GIR_RootConstrainSelectedInstOperands,
     /* 307069 */     // GIR_Coverage, 6307,
     /* 307069 */     GIR_EraseRootFromParent_Done,
     /* 307070 */   // Label 6150: @307070
     /* 307070 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(307097), // Rule ID 1323 //
     /* 307075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307086 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 307086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 307091 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307095 */     GIR_RootConstrainSelectedInstOperands,
     /* 307096 */     // GIR_Coverage, 1323,
     /* 307096 */     GIR_Done,
     /* 307097 */   // Label 6151: @307097
     /* 307097 */   GIM_Reject,
     /* 307098 */ // Label 6144: @307098
     /* 307098 */ GIM_Reject,
     /* 307099 */ // Label 6106: @307099
     /* 307099 */ GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(307456),
     /* 307104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 307110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307114 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(307177), // Rule ID 13544 //
     /* 307119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 307130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307151 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307155 */     // MIs[2] Operand 1
     /* 307155 */     // No operand predicates
     /* 307155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307161 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 307164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307175 */     GIR_RootConstrainSelectedInstOperands,
     /* 307176 */     // GIR_Coverage, 13544,
     /* 307176 */     GIR_EraseRootFromParent_Done,
     /* 307177 */   // Label 6153: @307177
     /* 307177 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(307240), // Rule ID 2010 //
     /* 307182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 307197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307218 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307222 */     // MIs[2] Operand 1
     /* 307222 */     // No operand predicates
     /* 307222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307224 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 307227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307238 */     GIR_RootConstrainSelectedInstOperands,
     /* 307239 */     // GIR_Coverage, 2010,
     /* 307239 */     GIR_EraseRootFromParent_Done,
     /* 307240 */   // Label 6154: @307240
     /* 307240 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(307334), // Rule ID 14007 //
     /* 307245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307268 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307268 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307271 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307275 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307294 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307297 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307301 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 307304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 307322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307332 */     GIR_RootConstrainSelectedInstOperands,
     /* 307333 */     // GIR_Coverage, 14007,
     /* 307333 */     GIR_EraseRootFromParent_Done,
     /* 307334 */   // Label 6155: @307334
     /* 307334 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(307428), // Rule ID 6311 //
     /* 307339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307362 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307362 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307365 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307369 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307388 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307395 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 307398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 307416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307426 */     GIR_RootConstrainSelectedInstOperands,
     /* 307427 */     // GIR_Coverage, 6311,
     /* 307427 */     GIR_EraseRootFromParent_Done,
     /* 307428 */   // Label 6156: @307428
     /* 307428 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(307455), // Rule ID 1327 //
     /* 307433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307444 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 307444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 307449 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307453 */     GIR_RootConstrainSelectedInstOperands,
     /* 307454 */     // GIR_Coverage, 1327,
     /* 307454 */     GIR_Done,
     /* 307455 */   // Label 6157: @307455
     /* 307455 */   GIM_Reject,
     /* 307456 */ // Label 6152: @307456
     /* 307456 */ GIM_Reject,
     /* 307457 */ // Label 6107: @307457
     /* 307457 */ GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(307798),
     /* 307462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 307465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 307468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307472 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(307558), // Rule ID 13533 //
     /* 307477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 307488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307521 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307525 */     // MIs[3] Operand 1
     /* 307525 */     // No operand predicates
     /* 307525 */     // MIs[1] Operand 2
     /* 307525 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 307536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307542 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 307545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307556 */     GIR_RootConstrainSelectedInstOperands,
     /* 307557 */     // GIR_Coverage, 13533,
     /* 307557 */     GIR_EraseRootFromParent_Done,
     /* 307558 */   // Label 6159: @307558
     /* 307558 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(307644), // Rule ID 1999 //
     /* 307563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 307578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307611 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307615 */     // MIs[3] Operand 1
     /* 307615 */     // No operand predicates
     /* 307615 */     // MIs[1] Operand 2
     /* 307615 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 307626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307628 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 307631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307642 */     GIR_RootConstrainSelectedInstOperands,
     /* 307643 */     // GIR_Coverage, 1999,
     /* 307643 */     GIR_EraseRootFromParent_Done,
     /* 307644 */   // Label 6160: @307644
     /* 307644 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(307707), // Rule ID 13534 //
     /* 307649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307681 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307685 */     // MIs[2] Operand 1
     /* 307685 */     // No operand predicates
     /* 307685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307691 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 307694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307705 */     GIR_RootConstrainSelectedInstOperands,
     /* 307706 */     // GIR_Coverage, 13534,
     /* 307706 */     GIR_EraseRootFromParent_Done,
     /* 307707 */   // Label 6161: @307707
     /* 307707 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(307770), // Rule ID 2000 //
     /* 307712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307748 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307752 */     // MIs[2] Operand 1
     /* 307752 */     // No operand predicates
     /* 307752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307754 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 307757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307768 */     GIR_RootConstrainSelectedInstOperands,
     /* 307769 */     // GIR_Coverage, 2000,
     /* 307769 */     GIR_EraseRootFromParent_Done,
     /* 307770 */   // Label 6162: @307770
     /* 307770 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(307797), // Rule ID 1319 //
     /* 307775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307786 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 307786 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 307791 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307795 */     GIR_RootConstrainSelectedInstOperands,
     /* 307796 */     // GIR_Coverage, 1319,
     /* 307796 */     GIR_Done,
     /* 307797 */   // Label 6163: @307797
     /* 307797 */   GIM_Reject,
     /* 307798 */ // Label 6158: @307798
     /* 307798 */ GIM_Reject,
     /* 307799 */ // Label 6108: @307799
     /* 307799 */ GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(308156),
     /* 307804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 307810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307814 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(307877), // Rule ID 13542 //
     /* 307819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307851 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307855 */     // MIs[2] Operand 1
     /* 307855 */     // No operand predicates
     /* 307855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307861 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 307864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307875 */     GIR_RootConstrainSelectedInstOperands,
     /* 307876 */     // GIR_Coverage, 13542,
     /* 307876 */     GIR_EraseRootFromParent_Done,
     /* 307877 */   // Label 6165: @307877
     /* 307877 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(307940), // Rule ID 2008 //
     /* 307882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307918 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307922 */     // MIs[2] Operand 1
     /* 307922 */     // No operand predicates
     /* 307922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307924 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 307927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307938 */     GIR_RootConstrainSelectedInstOperands,
     /* 307939 */     // GIR_Coverage, 2008,
     /* 307939 */     GIR_EraseRootFromParent_Done,
     /* 307940 */   // Label 6166: @307940
     /* 307940 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(308034), // Rule ID 14005 //
     /* 307945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307968 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307968 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307971 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307975 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307994 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308001 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 308022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308032 */     GIR_RootConstrainSelectedInstOperands,
     /* 308033 */     // GIR_Coverage, 14005,
     /* 308033 */     GIR_EraseRootFromParent_Done,
     /* 308034 */   // Label 6167: @308034
     /* 308034 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(308128), // Rule ID 6309 //
     /* 308039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308062 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308095 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 308116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308126 */     GIR_RootConstrainSelectedInstOperands,
     /* 308127 */     // GIR_Coverage, 6309,
     /* 308127 */     GIR_EraseRootFromParent_Done,
     /* 308128 */   // Label 6168: @308128
     /* 308128 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(308155), // Rule ID 1325 //
     /* 308133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308144 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 308144 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 308149 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308153 */     GIR_RootConstrainSelectedInstOperands,
     /* 308154 */     // GIR_Coverage, 1325,
     /* 308154 */     GIR_Done,
     /* 308155 */   // Label 6169: @308155
     /* 308155 */   GIM_Reject,
     /* 308156 */ // Label 6164: @308156
     /* 308156 */ GIM_Reject,
     /* 308157 */ // Label 6109: @308157
     /* 308157 */ GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(308588),
     /* 308162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 308168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308172 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(308235), // Rule ID 13536 //
     /* 308177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308209 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308213 */     // MIs[2] Operand 1
     /* 308213 */     // No operand predicates
     /* 308213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308219 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 308222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308233 */     GIR_RootConstrainSelectedInstOperands,
     /* 308234 */     // GIR_Coverage, 13536,
     /* 308234 */     GIR_EraseRootFromParent_Done,
     /* 308235 */   // Label 6171: @308235
     /* 308235 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(308298), // Rule ID 2002 //
     /* 308240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308276 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308280 */     // MIs[2] Operand 1
     /* 308280 */     // No operand predicates
     /* 308280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308282 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 308285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308296 */     GIR_RootConstrainSelectedInstOperands,
     /* 308297 */     // GIR_Coverage, 2002,
     /* 308297 */     GIR_EraseRootFromParent_Done,
     /* 308298 */   // Label 6172: @308298
     /* 308298 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(308325), // Rule ID 1321 //
     /* 308303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308314 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 308314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 308319 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308323 */     GIR_RootConstrainSelectedInstOperands,
     /* 308324 */     // GIR_Coverage, 1321,
     /* 308324 */     GIR_Done,
     /* 308325 */   // Label 6173: @308325
     /* 308325 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(308587), // Rule ID 7066 //
     /* 308330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 308333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308341 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 308341 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 308344 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 308348 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308353 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 308357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 308359 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 308362 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 308366 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308371 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 308375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 308377 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 308380 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 308384 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308389 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 308392 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 308395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 308397 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 308400 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308404 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308409 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 308415 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308420 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308425 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 308428 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 308432 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308437 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 308440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 308442 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 308445 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308449 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308454 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 308460 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308465 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308470 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 308473 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 308477 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308482 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 308485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 308487 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 308490 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 308494 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308499 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 308502 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 308505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 308507 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 308510 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 308514 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308519 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 308522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308524 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 308527 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308531 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 308541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308550 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308553 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308556 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 308559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 308577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 308585 */     GIR_RootConstrainSelectedInstOperands,
     /* 308586 */     // GIR_Coverage, 7066,
     /* 308586 */     GIR_EraseRootFromParent_Done,
     /* 308587 */   // Label 6174: @308587
     /* 308587 */   GIM_Reject,
     /* 308588 */ // Label 6170: @308588
     /* 308588 */ GIM_Reject,
     /* 308589 */ // Label 6110: @308589
     /* 308589 */ GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(308614), // Rule ID 8274 //
     /* 308594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 308597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 308600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 308603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 308607 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 308607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 308612 */   GIR_RootConstrainSelectedInstOperands,
     /* 308613 */   // GIR_Coverage, 8274,
     /* 308613 */   GIR_Done,
     /* 308614 */ // Label 6175: @308614
     /* 308614 */ GIM_Reject,
     /* 308615 */ // Label 6111: @308615
     /* 308615 */ GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(308640), // Rule ID 8272 //
     /* 308620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 308623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 308626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 308629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 308633 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 308633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 308638 */   GIR_RootConstrainSelectedInstOperands,
     /* 308639 */   // GIR_Coverage, 8272,
     /* 308639 */   GIR_Done,
     /* 308640 */ // Label 6176: @308640
     /* 308640 */ GIM_Reject,
     /* 308641 */ // Label 6112: @308641
     /* 308641 */ GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(308666), // Rule ID 8270 //
     /* 308646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 308649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 308652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 308655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 308659 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 308659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 308664 */   GIR_RootConstrainSelectedInstOperands,
     /* 308665 */   // GIR_Coverage, 8270,
     /* 308665 */   GIR_Done,
     /* 308666 */ // Label 6177: @308666
     /* 308666 */ GIM_Reject,
     /* 308667 */ // Label 6113: @308667
     /* 308667 */ GIM_Reject,
     /* 308668 */ // Label 62: @308668
     /* 308668 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6186*/ GIMT_Encode4(324940),
     /* 308679 */ /*GILLT_s16*//*Label 6178*/ GIMT_Encode4(308719),
     /* 308683 */ /*GILLT_s32*//*Label 6179*/ GIMT_Encode4(311723),
     /* 308687 */ /*GILLT_s64*//*Label 6180*/ GIMT_Encode4(314871), GIMT_Encode4(0),
     /* 308695 */ /*GILLT_v2s32*//*Label 6181*/ GIMT_Encode4(318019),
     /* 308699 */ /*GILLT_v2s64*//*Label 6182*/ GIMT_Encode4(319540),
     /* 308703 */ /*GILLT_v4s16*//*Label 6183*/ GIMT_Encode4(321061),
     /* 308707 */ /*GILLT_v4s32*//*Label 6184*/ GIMT_Encode4(322240), GIMT_Encode4(0),
     /* 308715 */ /*GILLT_v8s16*//*Label 6185*/ GIMT_Encode4(323761),
     /* 308719 */ // Label 6178: @308719
     /* 308719 */ GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(311722),
     /* 308724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 308730 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 308733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308737 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(308887), // Rule ID 4901 //
     /* 308742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308766 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 308770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308791 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 308799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308803 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 308807 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308814 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 308814 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 308817 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308821 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308826 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 308832 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308837 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308854 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 308873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 308885 */     GIR_RootConstrainSelectedInstOperands,
     /* 308886 */     // GIR_Coverage, 4901,
     /* 308886 */     GIR_EraseRootFromParent_Done,
     /* 308887 */   // Label 6188: @308887
     /* 308887 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(309034), // Rule ID 4865 //
     /* 308892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308916 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 308920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 308936 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308940 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308944 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308948 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308953 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 308957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308963 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 308963 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 308966 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308970 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308975 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 308981 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308986 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309003 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 309022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309032 */     GIR_RootConstrainSelectedInstOperands,
     /* 309033 */     // GIR_Coverage, 4865,
     /* 309033 */     GIR_EraseRootFromParent_Done,
     /* 309034 */   // Label 6189: @309034
     /* 309034 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(309181), // Rule ID 13944 //
     /* 309039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309066 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309075 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 309083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309087 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309091 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309095 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309100 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309110 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309110 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309113 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309117 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309122 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309128 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309133 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309150 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 309169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309179 */     GIR_RootConstrainSelectedInstOperands,
     /* 309180 */     // GIR_Coverage, 13944,
     /* 309180 */     GIR_EraseRootFromParent_Done,
     /* 309181 */   // Label 6190: @309181
     /* 309181 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(309312), // Rule ID 6139 //
     /* 309186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309210 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 309230 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309234 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309238 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309242 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309247 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 309251 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309255 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309259 */     // MIs[4] Operand 1
     /* 309259 */     // No operand predicates
     /* 309259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309263 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 309265 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 309265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309277 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 309296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 309300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 309307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 309310 */     GIR_RootConstrainSelectedInstOperands,
     /* 309311 */     // GIR_Coverage, 6139,
     /* 309311 */     GIR_EraseRootFromParent_Done,
     /* 309312 */   // Label 6191: @309312
     /* 309312 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(309443), // Rule ID 6171 //
     /* 309317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309349 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309353 */     // MIs[2] Operand 1
     /* 309353 */     // No operand predicates
     /* 309353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 309357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309361 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 309365 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 309369 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309373 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309377 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 309381 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309386 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 309390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309394 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 309396 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 309396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309408 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 309427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 309431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309441 */     GIR_RootConstrainSelectedInstOperands,
     /* 309442 */     // GIR_Coverage, 6171,
     /* 309442 */     GIR_EraseRootFromParent_Done,
     /* 309443 */   // Label 6192: @309443
     /* 309443 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(309574), // Rule ID 6235 //
     /* 309448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309484 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 309492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309496 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309500 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309504 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309509 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 309513 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309517 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309521 */     // MIs[4] Operand 1
     /* 309521 */     // No operand predicates
     /* 309521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309525 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 309527 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 309527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309539 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 309558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 309562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 309569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 309572 */     GIR_RootConstrainSelectedInstOperands,
     /* 309573 */     // GIR_Coverage, 6235,
     /* 309573 */     GIR_EraseRootFromParent_Done,
     /* 309574 */   // Label 6193: @309574
     /* 309574 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(309705), // Rule ID 6203 //
     /* 309579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309623 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309627 */     // MIs[3] Operand 1
     /* 309627 */     // No operand predicates
     /* 309627 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 309631 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309635 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309639 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 309643 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309648 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 309652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309656 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 309658 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 309658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309670 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 309689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 309693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 309700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 309703 */     GIR_RootConstrainSelectedInstOperands,
     /* 309704 */     // GIR_Coverage, 6203,
     /* 309704 */     GIR_EraseRootFromParent_Done,
     /* 309705 */   // Label 6194: @309705
     /* 309705 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(309840), // Rule ID 2456 //
     /* 309710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309734 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309750 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309754 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309759 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309769 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309769 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309772 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309776 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309781 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309787 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309792 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309809 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 309828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309838 */     GIR_RootConstrainSelectedInstOperands,
     /* 309839 */     // GIR_Coverage, 2456,
     /* 309839 */     GIR_EraseRootFromParent_Done,
     /* 309840 */   // Label 6195: @309840
     /* 309840 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(309959), // Rule ID 6107 //
     /* 309845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309869 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309902 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309906 */     // MIs[3] Operand 1
     /* 309906 */     // No operand predicates
     /* 309906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309910 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309912 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 309912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309924 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 309943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 309947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 309954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 309957 */     GIR_RootConstrainSelectedInstOperands,
     /* 309958 */     // GIR_Coverage, 6107,
     /* 309958 */     GIR_EraseRootFromParent_Done,
     /* 309959 */   // Label 6196: @309959
     /* 309959 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(310078), // Rule ID 2538 //
     /* 309964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309996 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310000 */     // MIs[2] Operand 1
     /* 310000 */     // No operand predicates
     /* 310000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 310004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310008 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310012 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310016 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310021 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 310025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310031 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310043 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 310062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 310076 */     GIR_RootConstrainSelectedInstOperands,
     /* 310077 */     // GIR_Coverage, 2538,
     /* 310077 */     GIR_EraseRootFromParent_Done,
     /* 310078 */   // Label 6197: @310078
     /* 310078 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(310178), // Rule ID 4863 //
     /* 310083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310107 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310134 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310146 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310176 */     GIR_RootConstrainSelectedInstOperands,
     /* 310177 */     // GIR_Coverage, 4863,
     /* 310177 */     GIR_EraseRootFromParent_Done,
     /* 310178 */   // Label 6198: @310178
     /* 310178 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(310278), // Rule ID 4899 //
     /* 310183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 310219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310234 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310246 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 310265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 310272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 310276 */     GIR_RootConstrainSelectedInstOperands,
     /* 310277 */     // GIR_Coverage, 4899,
     /* 310277 */     GIR_EraseRootFromParent_Done,
     /* 310278 */   // Label 6199: @310278
     /* 310278 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(310375), // Rule ID 13940 //
     /* 310283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310319 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310333 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310345 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 310368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310373 */     GIR_RootConstrainSelectedInstOperands,
     /* 310374 */     // GIR_Coverage, 13940,
     /* 310374 */     GIR_EraseRootFromParent_Done,
     /* 310375 */   // Label 6200: @310375
     /* 310375 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(310475), // Rule ID 13942 //
     /* 310380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310421 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310431 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310443 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310473 */     GIR_RootConstrainSelectedInstOperands,
     /* 310474 */     // GIR_Coverage, 13942,
     /* 310474 */     GIR_EraseRootFromParent_Done,
     /* 310475 */   // Label 6201: @310475
     /* 310475 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(310575), // Rule ID 4897 //
     /* 310480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310508 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 310516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310531 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310543 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 310562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 310573 */     GIR_RootConstrainSelectedInstOperands,
     /* 310574 */     // GIR_Coverage, 4897,
     /* 310574 */     GIR_EraseRootFromParent_Done,
     /* 310575 */   // Label 6202: @310575
     /* 310575 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(310672), // Rule ID 4861 //
     /* 310580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310611 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310620 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310630 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310642 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310670 */     GIR_RootConstrainSelectedInstOperands,
     /* 310671 */     // GIR_Coverage, 4861,
     /* 310671 */     GIR_EraseRootFromParent_Done,
     /* 310672 */   // Label 6203: @310672
     /* 310672 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(310756), // Rule ID 6169 //
     /* 310677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310709 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310713 */     // MIs[2] Operand 1
     /* 310713 */     // No operand predicates
     /* 310713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 310717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310721 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 310725 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310736 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 310747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 310754 */     GIR_RootConstrainSelectedInstOperands,
     /* 310755 */     // GIR_Coverage, 6169,
     /* 310755 */     GIR_EraseRootFromParent_Done,
     /* 310756 */   // Label 6204: @310756
     /* 310756 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(310837), // Rule ID 6201 //
     /* 310761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310805 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310809 */     // MIs[3] Operand 1
     /* 310809 */     // No operand predicates
     /* 310809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310819 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 310828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 310835 */     GIR_RootConstrainSelectedInstOperands,
     /* 310836 */     // GIR_Coverage, 6201,
     /* 310836 */     GIR_EraseRootFromParent_Done,
     /* 310837 */   // Label 6205: @310837
     /* 310837 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(310921), // Rule ID 6233 //
     /* 310842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310891 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310895 */     // MIs[3] Operand 1
     /* 310895 */     // No operand predicates
     /* 310895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310901 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 310919 */     GIR_RootConstrainSelectedInstOperands,
     /* 310920 */     // GIR_Coverage, 6233,
     /* 310920 */     GIR_EraseRootFromParent_Done,
     /* 310921 */   // Label 6206: @310921
     /* 310921 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(311002), // Rule ID 6137 //
     /* 310926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310961 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310974 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310978 */     // MIs[3] Operand 1
     /* 310978 */     // No operand predicates
     /* 310978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310982 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310984 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 311000 */     GIR_RootConstrainSelectedInstOperands,
     /* 311001 */     // GIR_Coverage, 6137,
     /* 311001 */     GIR_EraseRootFromParent_Done,
     /* 311002 */   // Label 6207: @311002
     /* 311002 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(311087), // Rule ID 2454 //
     /* 311007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311031 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311045 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311057 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 311076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 311083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311085 */     GIR_RootConstrainSelectedInstOperands,
     /* 311086 */     // GIR_Coverage, 2454,
     /* 311086 */     GIR_EraseRootFromParent_Done,
     /* 311087 */   // Label 6208: @311087
     /* 311087 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(311172), // Rule ID 2452 //
     /* 311092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311120 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311130 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 311130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311142 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 311148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 311161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311170 */     GIR_RootConstrainSelectedInstOperands,
     /* 311171 */     // GIR_Coverage, 2452,
     /* 311171 */     GIR_EraseRootFromParent_Done,
     /* 311172 */   // Label 6209: @311172
     /* 311172 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(311241), // Rule ID 2536 //
     /* 311177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311209 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311213 */     // MIs[2] Operand 1
     /* 311213 */     // No operand predicates
     /* 311213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311223 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 311226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 311232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 311239 */     GIR_RootConstrainSelectedInstOperands,
     /* 311240 */     // GIR_Coverage, 2536,
     /* 311240 */     GIR_EraseRootFromParent_Done,
     /* 311241 */   // Label 6210: @311241
     /* 311241 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(311310), // Rule ID 6105 //
     /* 311246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311282 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311286 */     // MIs[2] Operand 1
     /* 311286 */     // No operand predicates
     /* 311286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311292 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 311295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 311308 */     GIR_RootConstrainSelectedInstOperands,
     /* 311309 */     // GIR_Coverage, 6105,
     /* 311309 */     GIR_EraseRootFromParent_Done,
     /* 311310 */   // Label 6211: @311310
     /* 311310 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(311375), // Rule ID 4917 //
     /* 311315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 311343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311358 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 311361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 311369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 311373 */     GIR_RootConstrainSelectedInstOperands,
     /* 311374 */     // GIR_Coverage, 4917,
     /* 311374 */     GIR_EraseRootFromParent_Done,
     /* 311375 */   // Label 6212: @311375
     /* 311375 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(311440), // Rule ID 13960 //
     /* 311380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 311408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311423 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 311426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 311434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 311438 */     GIR_RootConstrainSelectedInstOperands,
     /* 311439 */     // GIR_Coverage, 13960,
     /* 311439 */     GIR_EraseRootFromParent_Done,
     /* 311440 */   // Label 6213: @311440
     /* 311440 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(311490), // Rule ID 4914 //
     /* 311445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311475 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 311486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311488 */     GIR_RootConstrainSelectedInstOperands,
     /* 311489 */     // GIR_Coverage, 4914,
     /* 311489 */     GIR_EraseRootFromParent_Done,
     /* 311490 */   // Label 6214: @311490
     /* 311490 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(311540), // Rule ID 13386 //
     /* 311495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311525 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 311532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311538 */     GIR_RootConstrainSelectedInstOperands,
     /* 311539 */     // GIR_Coverage, 13386,
     /* 311539 */     GIR_EraseRootFromParent_Done,
     /* 311540 */   // Label 6215: @311540
     /* 311540 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(311590), // Rule ID 644 //
     /* 311545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311575 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311588 */     GIR_RootConstrainSelectedInstOperands,
     /* 311589 */     // GIR_Coverage, 644,
     /* 311589 */     GIR_EraseRootFromParent_Done,
     /* 311590 */   // Label 6216: @311590
     /* 311590 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(311640), // Rule ID 13957 //
     /* 311595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311625 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 311636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311638 */     GIR_RootConstrainSelectedInstOperands,
     /* 311639 */     // GIR_Coverage, 13957,
     /* 311639 */     GIR_EraseRootFromParent_Done,
     /* 311640 */   // Label 6217: @311640
     /* 311640 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(311690), // Rule ID 656 //
     /* 311645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 311660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311675 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 311678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311680 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 311684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 311688 */     GIR_RootConstrainSelectedInstOperands,
     /* 311689 */     // GIR_Coverage, 656,
     /* 311689 */     GIR_EraseRootFromParent_Done,
     /* 311690 */   // Label 6218: @311690
     /* 311690 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(311721), // Rule ID 638 //
     /* 311695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311710 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 311715 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311719 */     GIR_RootConstrainSelectedInstOperands,
     /* 311720 */     // GIR_Coverage, 638,
     /* 311720 */     GIR_Done,
     /* 311721 */   // Label 6219: @311721
     /* 311721 */   GIM_Reject,
     /* 311722 */ // Label 6187: @311722
     /* 311722 */ GIM_Reject,
     /* 311723 */ // Label 6179: @311723
     /* 311723 */ GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(314870),
     /* 311728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 311734 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 311737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311741 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(311891), // Rule ID 4907 //
     /* 311746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311770 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311795 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 311803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311807 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 311811 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311818 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 311818 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 311821 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311825 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311830 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 311836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311841 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311858 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 311877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 311889 */     GIR_RootConstrainSelectedInstOperands,
     /* 311890 */     // GIR_Coverage, 4907,
     /* 311890 */     GIR_EraseRootFromParent_Done,
     /* 311891 */   // Label 6221: @311891
     /* 311891 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(312038), // Rule ID 4871 //
     /* 311896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311920 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 311936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 311940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311944 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311948 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311952 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311957 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 311961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311967 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 311967 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 311970 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311974 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311979 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 311985 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311990 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312007 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 312026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 312034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312036 */     GIR_RootConstrainSelectedInstOperands,
     /* 312037 */     // GIR_Coverage, 4871,
     /* 312037 */     GIR_EraseRootFromParent_Done,
     /* 312038 */   // Label 6222: @312038
     /* 312038 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(312185), // Rule ID 13950 //
     /* 312043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312079 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 312087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312091 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312095 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 312099 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312104 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 312108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312112 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312114 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312114 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 312117 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312121 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312126 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312132 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312137 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312154 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 312173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 312181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312183 */     GIR_RootConstrainSelectedInstOperands,
     /* 312184 */     // GIR_Coverage, 13950,
     /* 312184 */     GIR_EraseRootFromParent_Done,
     /* 312185 */   // Label 6223: @312185
     /* 312185 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(312316), // Rule ID 6155 //
     /* 312190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312214 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 312230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312238 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312242 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 312246 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312251 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 312255 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312259 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 312263 */     // MIs[4] Operand 1
     /* 312263 */     // No operand predicates
     /* 312263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312267 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 312269 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 312269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312281 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 312300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 312311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 312314 */     GIR_RootConstrainSelectedInstOperands,
     /* 312315 */     // GIR_Coverage, 6155,
     /* 312315 */     GIR_EraseRootFromParent_Done,
     /* 312316 */   // Label 6224: @312316
     /* 312316 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(312447), // Rule ID 6187 //
     /* 312321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312353 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 312357 */     // MIs[2] Operand 1
     /* 312357 */     // No operand predicates
     /* 312357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 312361 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312365 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 312369 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 312373 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312377 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312381 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 312385 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312390 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 312394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312398 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 312400 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 312400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312412 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 312431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 312445 */     GIR_RootConstrainSelectedInstOperands,
     /* 312446 */     // GIR_Coverage, 6187,
     /* 312446 */     GIR_EraseRootFromParent_Done,
     /* 312447 */   // Label 6225: @312447
     /* 312447 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(312578), // Rule ID 6251 //
     /* 312452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312488 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 312496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312500 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312504 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 312508 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312513 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 312517 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312521 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 312525 */     // MIs[4] Operand 1
     /* 312525 */     // No operand predicates
     /* 312525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312529 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 312531 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 312531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312543 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 312562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 312573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 312576 */     GIR_RootConstrainSelectedInstOperands,
     /* 312577 */     // GIR_Coverage, 6251,
     /* 312577 */     GIR_EraseRootFromParent_Done,
     /* 312578 */   // Label 6226: @312578
     /* 312578 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(312709), // Rule ID 6219 //
     /* 312583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 312623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312627 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 312631 */     // MIs[3] Operand 1
     /* 312631 */     // No operand predicates
     /* 312631 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 312635 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312639 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312643 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 312647 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312652 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 312656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312660 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 312662 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 312662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312674 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 312693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 312707 */     GIR_RootConstrainSelectedInstOperands,
     /* 312708 */     // GIR_Coverage, 6219,
     /* 312708 */     GIR_EraseRootFromParent_Done,
     /* 312709 */   // Label 6227: @312709
     /* 312709 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(312844), // Rule ID 2462 //
     /* 312714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312738 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312763 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312773 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 312776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312785 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312791 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312796 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312813 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 312832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 312840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312842 */     GIR_RootConstrainSelectedInstOperands,
     /* 312843 */     // GIR_Coverage, 2462,
     /* 312843 */     GIR_EraseRootFromParent_Done,
     /* 312844 */   // Label 6228: @312844
     /* 312844 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(312963), // Rule ID 6123 //
     /* 312849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312873 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 312902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312906 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 312910 */     // MIs[3] Operand 1
     /* 312910 */     // No operand predicates
     /* 312910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312916 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 312916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312928 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 312947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 312961 */     GIR_RootConstrainSelectedInstOperands,
     /* 312962 */     // GIR_Coverage, 6123,
     /* 312962 */     GIR_EraseRootFromParent_Done,
     /* 312963 */   // Label 6229: @312963
     /* 312963 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(313082), // Rule ID 2554 //
     /* 312968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313000 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313004 */     // MIs[2] Operand 1
     /* 313004 */     // No operand predicates
     /* 313004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 313008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313012 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313016 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 313020 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313025 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 313029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313035 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313047 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 313066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313080 */     GIR_RootConstrainSelectedInstOperands,
     /* 313081 */     // GIR_Coverage, 2554,
     /* 313081 */     GIR_EraseRootFromParent_Done,
     /* 313082 */   // Label 6230: @313082
     /* 313082 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(313182), // Rule ID 4869 //
     /* 313087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313111 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313138 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313150 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313180 */     GIR_RootConstrainSelectedInstOperands,
     /* 313181 */     // GIR_Coverage, 4869,
     /* 313181 */     GIR_EraseRootFromParent_Done,
     /* 313182 */   // Label 6231: @313182
     /* 313182 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(313282), // Rule ID 4905 //
     /* 313187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313211 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 313223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313238 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313250 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 313269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 313276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 313280 */     GIR_RootConstrainSelectedInstOperands,
     /* 313281 */     // GIR_Coverage, 4905,
     /* 313281 */     GIR_EraseRootFromParent_Done,
     /* 313282 */   // Label 6232: @313282
     /* 313282 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(313379), // Rule ID 13946 //
     /* 313287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313323 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313337 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313349 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313377 */     GIR_RootConstrainSelectedInstOperands,
     /* 313378 */     // GIR_Coverage, 13946,
     /* 313378 */     GIR_EraseRootFromParent_Done,
     /* 313379 */   // Label 6233: @313379
     /* 313379 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(313479), // Rule ID 13948 //
     /* 313384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313425 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313435 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313447 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313477 */     GIR_RootConstrainSelectedInstOperands,
     /* 313478 */     // GIR_Coverage, 13948,
     /* 313478 */     GIR_EraseRootFromParent_Done,
     /* 313479 */   // Label 6234: @313479
     /* 313479 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(313579), // Rule ID 4903 //
     /* 313484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313512 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 313520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313535 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313547 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 313566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 313577 */     GIR_RootConstrainSelectedInstOperands,
     /* 313578 */     // GIR_Coverage, 4903,
     /* 313578 */     GIR_EraseRootFromParent_Done,
     /* 313579 */   // Label 6235: @313579
     /* 313579 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(313676), // Rule ID 4867 //
     /* 313584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313624 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313634 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313646 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313674 */     GIR_RootConstrainSelectedInstOperands,
     /* 313675 */     // GIR_Coverage, 4867,
     /* 313675 */     GIR_EraseRootFromParent_Done,
     /* 313676 */   // Label 6236: @313676
     /* 313676 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(313754), // Rule ID 6273 //
     /* 313681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 313718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313722 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313726 */     // MIs[3] Operand 1
     /* 313726 */     // No operand predicates
     /* 313726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313736 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313752 */     GIR_RootConstrainSelectedInstOperands,
     /* 313753 */     // GIR_Coverage, 6273,
     /* 313753 */     GIR_EraseRootFromParent_Done,
     /* 313754 */   // Label 6237: @313754
     /* 313754 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(313838), // Rule ID 6185 //
     /* 313759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 313787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313791 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313795 */     // MIs[2] Operand 1
     /* 313795 */     // No operand predicates
     /* 313795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 313799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313803 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 313807 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313818 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 313829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313836 */     GIR_RootConstrainSelectedInstOperands,
     /* 313837 */     // GIR_Coverage, 6185,
     /* 313837 */     GIR_EraseRootFromParent_Done,
     /* 313838 */   // Label 6238: @313838
     /* 313838 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(313919), // Rule ID 6217 //
     /* 313843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313887 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313891 */     // MIs[3] Operand 1
     /* 313891 */     // No operand predicates
     /* 313891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313901 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313917 */     GIR_RootConstrainSelectedInstOperands,
     /* 313918 */     // GIR_Coverage, 6217,
     /* 313918 */     GIR_EraseRootFromParent_Done,
     /* 313919 */   // Label 6239: @313919
     /* 313919 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(314003), // Rule ID 6249 //
     /* 313924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313973 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313977 */     // MIs[3] Operand 1
     /* 313977 */     // No operand predicates
     /* 313977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313983 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314001 */     GIR_RootConstrainSelectedInstOperands,
     /* 314002 */     // GIR_Coverage, 6249,
     /* 314002 */     GIR_EraseRootFromParent_Done,
     /* 314003 */   // Label 6240: @314003
     /* 314003 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(314081), // Rule ID 6295 //
     /* 314008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 314049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314053 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314057 */     // MIs[3] Operand 1
     /* 314057 */     // No operand predicates
     /* 314057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314061 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314063 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314079 */     GIR_RootConstrainSelectedInstOperands,
     /* 314080 */     // GIR_Coverage, 6295,
     /* 314080 */     GIR_EraseRootFromParent_Done,
     /* 314081 */   // Label 6241: @314081
     /* 314081 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(314162), // Rule ID 6153 //
     /* 314086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314134 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314138 */     // MIs[3] Operand 1
     /* 314138 */     // No operand predicates
     /* 314138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314144 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314160 */     GIR_RootConstrainSelectedInstOperands,
     /* 314161 */     // GIR_Coverage, 6153,
     /* 314161 */     GIR_EraseRootFromParent_Done,
     /* 314162 */   // Label 6242: @314162
     /* 314162 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(314247), // Rule ID 2460 //
     /* 314167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314191 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314205 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314217 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 314236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 314243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314245 */     GIR_RootConstrainSelectedInstOperands,
     /* 314246 */     // GIR_Coverage, 2460,
     /* 314246 */     GIR_EraseRootFromParent_Done,
     /* 314247 */   // Label 6243: @314247
     /* 314247 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(314332), // Rule ID 2458 //
     /* 314252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314280 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314290 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 314290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314302 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 314308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314313 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 314321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314330 */     GIR_RootConstrainSelectedInstOperands,
     /* 314331 */     // GIR_Coverage, 2458,
     /* 314331 */     GIR_EraseRootFromParent_Done,
     /* 314332 */   // Label 6244: @314332
     /* 314332 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(314401), // Rule ID 2552 //
     /* 314337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 314365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314369 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314373 */     // MIs[2] Operand 1
     /* 314373 */     // No operand predicates
     /* 314373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314383 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 314386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 314392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 314399 */     GIR_RootConstrainSelectedInstOperands,
     /* 314400 */     // GIR_Coverage, 2552,
     /* 314400 */     GIR_EraseRootFromParent_Done,
     /* 314401 */   // Label 6245: @314401
     /* 314401 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(314470), // Rule ID 6121 //
     /* 314406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 314438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314442 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314446 */     // MIs[2] Operand 1
     /* 314446 */     // No operand predicates
     /* 314446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314452 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 314455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 314468 */     GIR_RootConstrainSelectedInstOperands,
     /* 314469 */     // GIR_Coverage, 6121,
     /* 314469 */     GIR_EraseRootFromParent_Done,
     /* 314470 */   // Label 6246: @314470
     /* 314470 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(314532), // Rule ID 4918 //
     /* 314475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 314500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 314508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314515 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 314518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 314526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 314530 */     GIR_RootConstrainSelectedInstOperands,
     /* 314531 */     // GIR_Coverage, 4918,
     /* 314531 */     GIR_EraseRootFromParent_Done,
     /* 314532 */   // Label 6247: @314532
     /* 314532 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(314594), // Rule ID 13961 //
     /* 314537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 314562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 314570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314577 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 314580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 314588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 314592 */     GIR_RootConstrainSelectedInstOperands,
     /* 314593 */     // GIR_Coverage, 13961,
     /* 314593 */     GIR_EraseRootFromParent_Done,
     /* 314594 */   // Label 6248: @314594
     /* 314594 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(314641), // Rule ID 4915 //
     /* 314599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314626 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 314637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314639 */     GIR_RootConstrainSelectedInstOperands,
     /* 314640 */     // GIR_Coverage, 4915,
     /* 314640 */     GIR_EraseRootFromParent_Done,
     /* 314641 */   // Label 6249: @314641
     /* 314641 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(314691), // Rule ID 13388 //
     /* 314646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314676 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 314683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314689 */     GIR_RootConstrainSelectedInstOperands,
     /* 314690 */     // GIR_Coverage, 13388,
     /* 314690 */     GIR_EraseRootFromParent_Done,
     /* 314691 */   // Label 6250: @314691
     /* 314691 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(314741), // Rule ID 646 //
     /* 314696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314726 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314739 */     GIR_RootConstrainSelectedInstOperands,
     /* 314740 */     // GIR_Coverage, 646,
     /* 314740 */     GIR_EraseRootFromParent_Done,
     /* 314741 */   // Label 6251: @314741
     /* 314741 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(314788), // Rule ID 13958 //
     /* 314746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314773 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 314784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314786 */     GIR_RootConstrainSelectedInstOperands,
     /* 314787 */     // GIR_Coverage, 13958,
     /* 314787 */     GIR_EraseRootFromParent_Done,
     /* 314788 */   // Label 6252: @314788
     /* 314788 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(314838), // Rule ID 658 //
     /* 314793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 314808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314823 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 314826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 314832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 314836 */     GIR_RootConstrainSelectedInstOperands,
     /* 314837 */     // GIR_Coverage, 658,
     /* 314837 */     GIR_EraseRootFromParent_Done,
     /* 314838 */   // Label 6253: @314838
     /* 314838 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(314869), // Rule ID 640 //
     /* 314843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314858 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 314863 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314867 */     GIR_RootConstrainSelectedInstOperands,
     /* 314868 */     // GIR_Coverage, 640,
     /* 314868 */     GIR_Done,
     /* 314869 */   // Label 6254: @314869
     /* 314869 */   GIM_Reject,
     /* 314870 */ // Label 6220: @314870
     /* 314870 */ GIM_Reject,
     /* 314871 */ // Label 6180: @314871
     /* 314871 */ GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(318018),
     /* 314876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 314882 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 314885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314889 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(315039), // Rule ID 4913 //
     /* 314894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314918 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314938 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314943 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 314951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314955 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 314959 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314966 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 314966 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 314969 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314973 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314978 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 314984 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314989 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315006 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 315025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 315033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 315037 */     GIR_RootConstrainSelectedInstOperands,
     /* 315038 */     // GIR_Coverage, 4913,
     /* 315038 */     GIR_EraseRootFromParent_Done,
     /* 315039 */   // Label 6256: @315039
     /* 315039 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(315186), // Rule ID 4877 //
     /* 315044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315068 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 315084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 315088 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315092 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315096 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 315100 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315105 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 315109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315115 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 315115 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315118 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315122 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315127 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 315133 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315138 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315155 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 315174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 315182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315184 */     GIR_RootConstrainSelectedInstOperands,
     /* 315185 */     // GIR_Coverage, 4877,
     /* 315185 */     GIR_EraseRootFromParent_Done,
     /* 315186 */   // Label 6257: @315186
     /* 315186 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(315333), // Rule ID 13956 //
     /* 315191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 315206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315227 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 315235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315239 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315243 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 315247 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315252 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 315256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315262 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 315262 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315265 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315269 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315274 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 315280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315285 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315302 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315313 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 315321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 315329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315331 */     GIR_RootConstrainSelectedInstOperands,
     /* 315332 */     // GIR_Coverage, 13956,
     /* 315332 */     GIR_EraseRootFromParent_Done,
     /* 315333 */   // Label 6258: @315333
     /* 315333 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(315464), // Rule ID 6159 //
     /* 315338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315362 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 315378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 315382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315386 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315390 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 315394 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315399 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 315403 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315407 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 315411 */     // MIs[4] Operand 1
     /* 315411 */     // No operand predicates
     /* 315411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315415 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 315417 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 315417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315429 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 315448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 315459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 315462 */     GIR_RootConstrainSelectedInstOperands,
     /* 315463 */     // GIR_Coverage, 6159,
     /* 315463 */     GIR_EraseRootFromParent_Done,
     /* 315464 */   // Label 6259: @315464
     /* 315464 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(315595), // Rule ID 6191 //
     /* 315469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 315497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315501 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 315505 */     // MIs[2] Operand 1
     /* 315505 */     // No operand predicates
     /* 315505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 315509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315513 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 315517 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 315521 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315525 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315529 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 315533 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315538 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 315542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315546 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 315548 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 315548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315560 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 315579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 315593 */     GIR_RootConstrainSelectedInstOperands,
     /* 315594 */     // GIR_Coverage, 6191,
     /* 315594 */     GIR_EraseRootFromParent_Done,
     /* 315595 */   // Label 6260: @315595
     /* 315595 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(315726), // Rule ID 6255 //
     /* 315600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 315615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315636 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 315644 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315648 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315652 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 315656 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315661 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 315665 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315669 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 315673 */     // MIs[4] Operand 1
     /* 315673 */     // No operand predicates
     /* 315673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315677 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 315679 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 315679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315691 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 315710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 315721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 315724 */     GIR_RootConstrainSelectedInstOperands,
     /* 315725 */     // GIR_Coverage, 6255,
     /* 315725 */     GIR_EraseRootFromParent_Done,
     /* 315726 */   // Label 6261: @315726
     /* 315726 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(315857), // Rule ID 6223 //
     /* 315731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 315746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315775 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 315779 */     // MIs[3] Operand 1
     /* 315779 */     // No operand predicates
     /* 315779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 315783 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315787 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315791 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 315795 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315800 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 315804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315808 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 315810 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 315810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315822 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 315841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315855 */     GIR_RootConstrainSelectedInstOperands,
     /* 315856 */     // GIR_Coverage, 6223,
     /* 315856 */     GIR_EraseRootFromParent_Done,
     /* 315857 */   // Label 6262: @315857
     /* 315857 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(315992), // Rule ID 2468 //
     /* 315862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315886 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315911 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315921 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 315921 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315924 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315928 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315933 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 315939 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315944 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315961 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 315980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 315988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315990 */     GIR_RootConstrainSelectedInstOperands,
     /* 315991 */     // GIR_Coverage, 2468,
     /* 315991 */     GIR_EraseRootFromParent_Done,
     /* 315992 */   // Label 6263: @315992
     /* 315992 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(316111), // Rule ID 6127 //
     /* 315997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316054 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316058 */     // MIs[3] Operand 1
     /* 316058 */     // No operand predicates
     /* 316058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316064 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316076 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 316095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316109 */     GIR_RootConstrainSelectedInstOperands,
     /* 316110 */     // GIR_Coverage, 6127,
     /* 316110 */     GIR_EraseRootFromParent_Done,
     /* 316111 */   // Label 6264: @316111
     /* 316111 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(316230), // Rule ID 2558 //
     /* 316116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 316144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316148 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316152 */     // MIs[2] Operand 1
     /* 316152 */     // No operand predicates
     /* 316152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 316156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316160 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316164 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 316168 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316173 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 316177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316181 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316183 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316195 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 316214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 316228 */     GIR_RootConstrainSelectedInstOperands,
     /* 316229 */     // GIR_Coverage, 2558,
     /* 316229 */     GIR_EraseRootFromParent_Done,
     /* 316230 */   // Label 6265: @316230
     /* 316230 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(316330), // Rule ID 4875 //
     /* 316235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316259 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 316275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316286 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 316286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316298 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316328 */     GIR_RootConstrainSelectedInstOperands,
     /* 316329 */     // GIR_Coverage, 4875,
     /* 316329 */     GIR_EraseRootFromParent_Done,
     /* 316330 */   // Label 6266: @316330
     /* 316330 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(316430), // Rule ID 4911 //
     /* 316335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316359 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 316371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 316379 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316386 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 316386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316398 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 316417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 316424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 316428 */     GIR_RootConstrainSelectedInstOperands,
     /* 316429 */     // GIR_Coverage, 4911,
     /* 316429 */     GIR_EraseRootFromParent_Done,
     /* 316430 */   // Label 6267: @316430
     /* 316430 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(316527), // Rule ID 13952 //
     /* 316435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316471 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316485 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316497 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 316520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316525 */     GIR_RootConstrainSelectedInstOperands,
     /* 316526 */     // GIR_Coverage, 13952,
     /* 316526 */     GIR_EraseRootFromParent_Done,
     /* 316527 */   // Label 6268: @316527
     /* 316527 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(316627), // Rule ID 13954 //
     /* 316532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316573 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316583 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 316583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316595 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316625 */     GIR_RootConstrainSelectedInstOperands,
     /* 316626 */     // GIR_Coverage, 13954,
     /* 316626 */     GIR_EraseRootFromParent_Done,
     /* 316627 */   // Label 6269: @316627
     /* 316627 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(316727), // Rule ID 4909 //
     /* 316632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316660 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 316668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 316676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316683 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316695 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 316714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 316725 */     GIR_RootConstrainSelectedInstOperands,
     /* 316726 */     // GIR_Coverage, 4909,
     /* 316726 */     GIR_EraseRootFromParent_Done,
     /* 316727 */   // Label 6270: @316727
     /* 316727 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(316824), // Rule ID 4873 //
     /* 316732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316772 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316782 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316794 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316822 */     GIR_RootConstrainSelectedInstOperands,
     /* 316823 */     // GIR_Coverage, 4873,
     /* 316823 */     GIR_EraseRootFromParent_Done,
     /* 316824 */   // Label 6271: @316824
     /* 316824 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(316902), // Rule ID 6277 //
     /* 316829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 316866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316870 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 316874 */     // MIs[3] Operand 1
     /* 316874 */     // No operand predicates
     /* 316874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316884 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 316884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 316893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316900 */     GIR_RootConstrainSelectedInstOperands,
     /* 316901 */     // GIR_Coverage, 6277,
     /* 316901 */     GIR_EraseRootFromParent_Done,
     /* 316902 */   // Label 6272: @316902
     /* 316902 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(316986), // Rule ID 6189 //
     /* 316907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 316935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316939 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316943 */     // MIs[2] Operand 1
     /* 316943 */     // No operand predicates
     /* 316943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 316947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316951 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 316955 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316966 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 316977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 316984 */     GIR_RootConstrainSelectedInstOperands,
     /* 316985 */     // GIR_Coverage, 6189,
     /* 316985 */     GIR_EraseRootFromParent_Done,
     /* 316986 */   // Label 6273: @316986
     /* 316986 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(317067), // Rule ID 6221 //
     /* 316991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317035 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317039 */     // MIs[3] Operand 1
     /* 317039 */     // No operand predicates
     /* 317039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317047 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317049 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317065 */     GIR_RootConstrainSelectedInstOperands,
     /* 317066 */     // GIR_Coverage, 6221,
     /* 317066 */     GIR_EraseRootFromParent_Done,
     /* 317067 */   // Label 6274: @317067
     /* 317067 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(317151), // Rule ID 6253 //
     /* 317072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317121 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317125 */     // MIs[3] Operand 1
     /* 317125 */     // No operand predicates
     /* 317125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317131 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317149 */     GIR_RootConstrainSelectedInstOperands,
     /* 317150 */     // GIR_Coverage, 6253,
     /* 317150 */     GIR_EraseRootFromParent_Done,
     /* 317151 */   // Label 6275: @317151
     /* 317151 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(317229), // Rule ID 6299 //
     /* 317156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317201 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317205 */     // MIs[3] Operand 1
     /* 317205 */     // No operand predicates
     /* 317205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317211 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317227 */     GIR_RootConstrainSelectedInstOperands,
     /* 317228 */     // GIR_Coverage, 6299,
     /* 317228 */     GIR_EraseRootFromParent_Done,
     /* 317229 */   // Label 6276: @317229
     /* 317229 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(317310), // Rule ID 6157 //
     /* 317234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317282 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317286 */     // MIs[3] Operand 1
     /* 317286 */     // No operand predicates
     /* 317286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317292 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317308 */     GIR_RootConstrainSelectedInstOperands,
     /* 317309 */     // GIR_Coverage, 6157,
     /* 317309 */     GIR_EraseRootFromParent_Done,
     /* 317310 */   // Label 6277: @317310
     /* 317310 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(317395), // Rule ID 2466 //
     /* 317315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317339 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317353 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317365 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 317384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 317391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317393 */     GIR_RootConstrainSelectedInstOperands,
     /* 317394 */     // GIR_Coverage, 2466,
     /* 317394 */     GIR_EraseRootFromParent_Done,
     /* 317395 */   // Label 6278: @317395
     /* 317395 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(317480), // Rule ID 2464 //
     /* 317400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317428 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317438 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 317438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317450 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 317456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 317469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317471 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317478 */     GIR_RootConstrainSelectedInstOperands,
     /* 317479 */     // GIR_Coverage, 2464,
     /* 317479 */     GIR_EraseRootFromParent_Done,
     /* 317480 */   // Label 6279: @317480
     /* 317480 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(317549), // Rule ID 2556 //
     /* 317485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317517 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317521 */     // MIs[2] Operand 1
     /* 317521 */     // No operand predicates
     /* 317521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317531 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 317534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317547 */     GIR_RootConstrainSelectedInstOperands,
     /* 317548 */     // GIR_Coverage, 2556,
     /* 317548 */     GIR_EraseRootFromParent_Done,
     /* 317549 */   // Label 6280: @317549
     /* 317549 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(317618), // Rule ID 6125 //
     /* 317554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317590 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317594 */     // MIs[2] Operand 1
     /* 317594 */     // No operand predicates
     /* 317594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317600 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 317603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317616 */     GIR_RootConstrainSelectedInstOperands,
     /* 317617 */     // GIR_Coverage, 6125,
     /* 317617 */     GIR_EraseRootFromParent_Done,
     /* 317618 */   // Label 6281: @317618
     /* 317618 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(317680), // Rule ID 4919 //
     /* 317623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 317648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317663 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 317666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 317674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 317678 */     GIR_RootConstrainSelectedInstOperands,
     /* 317679 */     // GIR_Coverage, 4919,
     /* 317679 */     GIR_EraseRootFromParent_Done,
     /* 317680 */   // Label 6282: @317680
     /* 317680 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(317742), // Rule ID 13962 //
     /* 317685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 317710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317725 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 317728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 317736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 317740 */     GIR_RootConstrainSelectedInstOperands,
     /* 317741 */     // GIR_Coverage, 13962,
     /* 317741 */     GIR_EraseRootFromParent_Done,
     /* 317742 */   // Label 6283: @317742
     /* 317742 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(317789), // Rule ID 4916 //
     /* 317747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317774 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 317785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317787 */     GIR_RootConstrainSelectedInstOperands,
     /* 317788 */     // GIR_Coverage, 4916,
     /* 317788 */     GIR_EraseRootFromParent_Done,
     /* 317789 */   // Label 6284: @317789
     /* 317789 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(317839), // Rule ID 13390 //
     /* 317794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317824 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317837 */     GIR_RootConstrainSelectedInstOperands,
     /* 317838 */     // GIR_Coverage, 13390,
     /* 317838 */     GIR_EraseRootFromParent_Done,
     /* 317839 */   // Label 6285: @317839
     /* 317839 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(317889), // Rule ID 648 //
     /* 317844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317874 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317887 */     GIR_RootConstrainSelectedInstOperands,
     /* 317888 */     // GIR_Coverage, 648,
     /* 317888 */     GIR_EraseRootFromParent_Done,
     /* 317889 */   // Label 6286: @317889
     /* 317889 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(317936), // Rule ID 13959 //
     /* 317894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317921 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 317932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317934 */     GIR_RootConstrainSelectedInstOperands,
     /* 317935 */     // GIR_Coverage, 13959,
     /* 317935 */     GIR_EraseRootFromParent_Done,
     /* 317936 */   // Label 6287: @317936
     /* 317936 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(317986), // Rule ID 660 //
     /* 317941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 317956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317971 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 317974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 317980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 317984 */     GIR_RootConstrainSelectedInstOperands,
     /* 317985 */     // GIR_Coverage, 660,
     /* 317985 */     GIR_EraseRootFromParent_Done,
     /* 317986 */   // Label 6288: @317986
     /* 317986 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(318017), // Rule ID 642 //
     /* 317991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318006 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318006 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 318011 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318015 */     GIR_RootConstrainSelectedInstOperands,
     /* 318016 */     // GIR_Coverage, 642,
     /* 318016 */     GIR_Done,
     /* 318017 */   // Label 6289: @318017
     /* 318017 */   GIM_Reject,
     /* 318018 */ // Label 6255: @318018
     /* 318018 */ GIM_Reject,
     /* 318019 */ // Label 6181: @318019
     /* 318019 */ GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(319539),
     /* 318024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 318030 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 318033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318037 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(318115), // Rule ID 6257 //
     /* 318042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 318079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318083 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318087 */     // MIs[3] Operand 1
     /* 318087 */     // No operand predicates
     /* 318087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318097 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318113 */     GIR_RootConstrainSelectedInstOperands,
     /* 318114 */     // GIR_Coverage, 6257,
     /* 318114 */     GIR_EraseRootFromParent_Done,
     /* 318115 */   // Label 6291: @318115
     /* 318115 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(318199), // Rule ID 6173 //
     /* 318120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318152 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318156 */     // MIs[2] Operand 1
     /* 318156 */     // No operand predicates
     /* 318156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 318160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318164 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318168 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318179 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 318190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 318197 */     GIR_RootConstrainSelectedInstOperands,
     /* 318198 */     // GIR_Coverage, 6173,
     /* 318198 */     GIR_EraseRootFromParent_Done,
     /* 318199 */   // Label 6292: @318199
     /* 318199 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(318280), // Rule ID 6205 //
     /* 318204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318248 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318252 */     // MIs[3] Operand 1
     /* 318252 */     // No operand predicates
     /* 318252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318262 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318278 */     GIR_RootConstrainSelectedInstOperands,
     /* 318279 */     // GIR_Coverage, 6205,
     /* 318279 */     GIR_EraseRootFromParent_Done,
     /* 318280 */   // Label 6293: @318280
     /* 318280 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(318364), // Rule ID 6237 //
     /* 318285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318334 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318338 */     // MIs[3] Operand 1
     /* 318338 */     // No operand predicates
     /* 318338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318344 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318362 */     GIR_RootConstrainSelectedInstOperands,
     /* 318363 */     // GIR_Coverage, 6237,
     /* 318363 */     GIR_EraseRootFromParent_Done,
     /* 318364 */   // Label 6294: @318364
     /* 318364 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(318442), // Rule ID 6279 //
     /* 318369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 318410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318414 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318418 */     // MIs[3] Operand 1
     /* 318418 */     // No operand predicates
     /* 318418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318424 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318440 */     GIR_RootConstrainSelectedInstOperands,
     /* 318441 */     // GIR_Coverage, 6279,
     /* 318441 */     GIR_EraseRootFromParent_Done,
     /* 318442 */   // Label 6295: @318442
     /* 318442 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(318523), // Rule ID 6141 //
     /* 318447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318495 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318499 */     // MIs[3] Operand 1
     /* 318499 */     // No operand predicates
     /* 318499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318505 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318521 */     GIR_RootConstrainSelectedInstOperands,
     /* 318522 */     // GIR_Coverage, 6141,
     /* 318522 */     GIR_EraseRootFromParent_Done,
     /* 318523 */   // Label 6296: @318523
     /* 318523 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(318592), // Rule ID 2540 //
     /* 318528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318560 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318564 */     // MIs[2] Operand 1
     /* 318564 */     // No operand predicates
     /* 318564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318574 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 318577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 318590 */     GIR_RootConstrainSelectedInstOperands,
     /* 318591 */     // GIR_Coverage, 2540,
     /* 318591 */     GIR_EraseRootFromParent_Done,
     /* 318592 */   // Label 6297: @318592
     /* 318592 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(318661), // Rule ID 6109 //
     /* 318597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318633 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318637 */     // MIs[2] Operand 1
     /* 318637 */     // No operand predicates
     /* 318637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318643 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 318646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 318659 */     GIR_RootConstrainSelectedInstOperands,
     /* 318660 */     // GIR_Coverage, 6109,
     /* 318660 */     GIR_EraseRootFromParent_Done,
     /* 318661 */   // Label 6298: @318661
     /* 318661 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(318754), // Rule ID 6261 //
     /* 318666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 318674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 318690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318705 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318717 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318724 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318752 */     GIR_RootConstrainSelectedInstOperands,
     /* 318753 */     // GIR_Coverage, 6261,
     /* 318753 */     GIR_EraseRootFromParent_Done,
     /* 318754 */   // Label 6299: @318754
     /* 318754 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(318853), // Rule ID 6175 //
     /* 318759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 318770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318802 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318814 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318821 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 318845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318851 */     GIR_RootConstrainSelectedInstOperands,
     /* 318852 */     // GIR_Coverage, 6175,
     /* 318852 */     GIR_EraseRootFromParent_Done,
     /* 318853 */   // Label 6300: @318853
     /* 318853 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(318949), // Rule ID 6207 //
     /* 318858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 318881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 318885 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318900 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318912 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318915 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318919 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318947 */     GIR_RootConstrainSelectedInstOperands,
     /* 318948 */     // GIR_Coverage, 6207,
     /* 318948 */     GIR_EraseRootFromParent_Done,
     /* 318949 */   // Label 6301: @318949
     /* 318949 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(319048), // Rule ID 6239 //
     /* 318954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 318982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 318986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318997 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319009 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319016 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319046 */     GIR_RootConstrainSelectedInstOperands,
     /* 319047 */     // GIR_Coverage, 6239,
     /* 319047 */     GIR_EraseRootFromParent_Done,
     /* 319048 */   // Label 6302: @319048
     /* 319048 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(319141), // Rule ID 6283 //
     /* 319053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 319069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 319081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319092 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319104 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319107 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319111 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319139 */     GIR_RootConstrainSelectedInstOperands,
     /* 319140 */     // GIR_Coverage, 6283,
     /* 319140 */     GIR_EraseRootFromParent_Done,
     /* 319141 */   // Label 6303: @319141
     /* 319141 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(319237), // Rule ID 6143 //
     /* 319146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 319173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 319177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319188 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319200 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319203 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319207 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319235 */     GIR_RootConstrainSelectedInstOperands,
     /* 319236 */     // GIR_Coverage, 6143,
     /* 319236 */     GIR_EraseRootFromParent_Done,
     /* 319237 */   // Label 6304: @319237
     /* 319237 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(319321), // Rule ID 2542 //
     /* 319242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 319257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319272 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319284 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319291 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 319307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319319 */     GIR_RootConstrainSelectedInstOperands,
     /* 319320 */     // GIR_Coverage, 2542,
     /* 319320 */     GIR_EraseRootFromParent_Done,
     /* 319321 */   // Label 6305: @319321
     /* 319321 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(319371), // Rule ID 13420 //
     /* 319326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319356 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 319356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 319359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319369 */     GIR_RootConstrainSelectedInstOperands,
     /* 319370 */     // GIR_Coverage, 13420,
     /* 319370 */     GIR_EraseRootFromParent_Done,
     /* 319371 */   // Label 6306: @319371
     /* 319371 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(319455), // Rule ID 6111 //
     /* 319376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 319395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319406 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319418 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319421 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319425 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 319441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319453 */     GIR_RootConstrainSelectedInstOperands,
     /* 319454 */     // GIR_Coverage, 6111,
     /* 319454 */     GIR_EraseRootFromParent_Done,
     /* 319455 */   // Label 6307: @319455
     /* 319455 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(319505), // Rule ID 1308 //
     /* 319460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319490 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 319490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 319493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319503 */     GIR_RootConstrainSelectedInstOperands,
     /* 319504 */     // GIR_Coverage, 1308,
     /* 319504 */     GIR_EraseRootFromParent_Done,
     /* 319505 */   // Label 6308: @319505
     /* 319505 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(319538), // Rule ID 1298 //
     /* 319510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319525 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 319525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 319528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 319536 */     GIR_RootConstrainSelectedInstOperands,
     /* 319537 */     // GIR_Coverage, 1298,
     /* 319537 */     GIR_EraseRootFromParent_Done,
     /* 319538 */   // Label 6309: @319538
     /* 319538 */   GIM_Reject,
     /* 319539 */ // Label 6290: @319539
     /* 319539 */ GIM_Reject,
     /* 319540 */ // Label 6182: @319540
     /* 319540 */ GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(321060),
     /* 319545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 319551 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 319554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319558 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(319636), // Rule ID 6269 //
     /* 319563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319604 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319608 */     // MIs[3] Operand 1
     /* 319608 */     // No operand predicates
     /* 319608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319616 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319618 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319634 */     GIR_RootConstrainSelectedInstOperands,
     /* 319635 */     // GIR_Coverage, 6269,
     /* 319635 */     GIR_EraseRootFromParent_Done,
     /* 319636 */   // Label 6311: @319636
     /* 319636 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(319720), // Rule ID 6181 //
     /* 319641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319673 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319677 */     // MIs[2] Operand 1
     /* 319677 */     // No operand predicates
     /* 319677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 319681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319685 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319689 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319700 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 319711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319718 */     GIR_RootConstrainSelectedInstOperands,
     /* 319719 */     // GIR_Coverage, 6181,
     /* 319719 */     GIR_EraseRootFromParent_Done,
     /* 319720 */   // Label 6312: @319720
     /* 319720 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(319801), // Rule ID 6213 //
     /* 319725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319769 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319773 */     // MIs[3] Operand 1
     /* 319773 */     // No operand predicates
     /* 319773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319783 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319799 */     GIR_RootConstrainSelectedInstOperands,
     /* 319800 */     // GIR_Coverage, 6213,
     /* 319800 */     GIR_EraseRootFromParent_Done,
     /* 319801 */   // Label 6313: @319801
     /* 319801 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(319885), // Rule ID 6245 //
     /* 319806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319855 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319859 */     // MIs[3] Operand 1
     /* 319859 */     // No operand predicates
     /* 319859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319865 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319883 */     GIR_RootConstrainSelectedInstOperands,
     /* 319884 */     // GIR_Coverage, 6245,
     /* 319884 */     GIR_EraseRootFromParent_Done,
     /* 319885 */   // Label 6314: @319885
     /* 319885 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(319963), // Rule ID 6291 //
     /* 319890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319935 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319939 */     // MIs[3] Operand 1
     /* 319939 */     // No operand predicates
     /* 319939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319945 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319952 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319961 */     GIR_RootConstrainSelectedInstOperands,
     /* 319962 */     // GIR_Coverage, 6291,
     /* 319962 */     GIR_EraseRootFromParent_Done,
     /* 319963 */   // Label 6315: @319963
     /* 319963 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(320044), // Rule ID 6149 //
     /* 319968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320016 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320020 */     // MIs[3] Operand 1
     /* 320020 */     // No operand predicates
     /* 320020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320026 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320042 */     GIR_RootConstrainSelectedInstOperands,
     /* 320043 */     // GIR_Coverage, 6149,
     /* 320043 */     GIR_EraseRootFromParent_Done,
     /* 320044 */   // Label 6316: @320044
     /* 320044 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(320113), // Rule ID 2548 //
     /* 320049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320081 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320085 */     // MIs[2] Operand 1
     /* 320085 */     // No operand predicates
     /* 320085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320095 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 320098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320111 */     GIR_RootConstrainSelectedInstOperands,
     /* 320112 */     // GIR_Coverage, 2548,
     /* 320112 */     GIR_EraseRootFromParent_Done,
     /* 320113 */   // Label 6317: @320113
     /* 320113 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(320182), // Rule ID 6117 //
     /* 320118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320154 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320158 */     // MIs[2] Operand 1
     /* 320158 */     // No operand predicates
     /* 320158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320164 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 320167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320180 */     GIR_RootConstrainSelectedInstOperands,
     /* 320181 */     // GIR_Coverage, 6117,
     /* 320181 */     GIR_EraseRootFromParent_Done,
     /* 320182 */   // Label 6318: @320182
     /* 320182 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(320275), // Rule ID 6271 //
     /* 320187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 320211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320226 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320238 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320245 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320273 */     GIR_RootConstrainSelectedInstOperands,
     /* 320274 */     // GIR_Coverage, 6271,
     /* 320274 */     GIR_EraseRootFromParent_Done,
     /* 320275 */   // Label 6319: @320275
     /* 320275 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(320374), // Rule ID 6183 //
     /* 320280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320323 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320342 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 320366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320372 */     GIR_RootConstrainSelectedInstOperands,
     /* 320373 */     // GIR_Coverage, 6183,
     /* 320373 */     GIR_EraseRootFromParent_Done,
     /* 320374 */   // Label 6320: @320374
     /* 320374 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(320470), // Rule ID 6215 //
     /* 320379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 320406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320421 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320433 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320440 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320468 */     GIR_RootConstrainSelectedInstOperands,
     /* 320469 */     // GIR_Coverage, 6215,
     /* 320469 */     GIR_EraseRootFromParent_Done,
     /* 320470 */   // Label 6321: @320470
     /* 320470 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(320569), // Rule ID 6247 //
     /* 320475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 320507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320518 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320530 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320537 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320567 */     GIR_RootConstrainSelectedInstOperands,
     /* 320568 */     // GIR_Coverage, 6247,
     /* 320568 */     GIR_EraseRootFromParent_Done,
     /* 320569 */   // Label 6322: @320569
     /* 320569 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(320662), // Rule ID 6293 //
     /* 320574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 320602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320613 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320625 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320628 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320632 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320660 */     GIR_RootConstrainSelectedInstOperands,
     /* 320661 */     // GIR_Coverage, 6293,
     /* 320661 */     GIR_EraseRootFromParent_Done,
     /* 320662 */   // Label 6323: @320662
     /* 320662 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(320758), // Rule ID 6151 //
     /* 320667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 320698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320709 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320721 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320728 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320756 */     GIR_RootConstrainSelectedInstOperands,
     /* 320757 */     // GIR_Coverage, 6151,
     /* 320757 */     GIR_EraseRootFromParent_Done,
     /* 320758 */   // Label 6324: @320758
     /* 320758 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(320842), // Rule ID 2550 //
     /* 320763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320793 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320805 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320808 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320812 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 320828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320840 */     GIR_RootConstrainSelectedInstOperands,
     /* 320841 */     // GIR_Coverage, 2550,
     /* 320841 */     GIR_EraseRootFromParent_Done,
     /* 320842 */   // Label 6325: @320842
     /* 320842 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(320892), // Rule ID 13424 //
     /* 320847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320877 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 320877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 320880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320890 */     GIR_RootConstrainSelectedInstOperands,
     /* 320891 */     // GIR_Coverage, 13424,
     /* 320891 */     GIR_EraseRootFromParent_Done,
     /* 320892 */   // Label 6326: @320892
     /* 320892 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(320976), // Rule ID 6119 //
     /* 320897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320927 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320939 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320942 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320946 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 320962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320974 */     GIR_RootConstrainSelectedInstOperands,
     /* 320975 */     // GIR_Coverage, 6119,
     /* 320975 */     GIR_EraseRootFromParent_Done,
     /* 320976 */   // Label 6327: @320976
     /* 320976 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(321026), // Rule ID 1312 //
     /* 320981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321011 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 321011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 321014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321024 */     GIR_RootConstrainSelectedInstOperands,
     /* 321025 */     // GIR_Coverage, 1312,
     /* 321025 */     GIR_EraseRootFromParent_Done,
     /* 321026 */   // Label 6328: @321026
     /* 321026 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(321059), // Rule ID 1302 //
     /* 321031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321046 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 321046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 321049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 321057 */     GIR_RootConstrainSelectedInstOperands,
     /* 321058 */     // GIR_Coverage, 1302,
     /* 321058 */     GIR_EraseRootFromParent_Done,
     /* 321059 */   // Label 6329: @321059
     /* 321059 */   GIM_Reject,
     /* 321060 */ // Label 6310: @321060
     /* 321060 */ GIM_Reject,
     /* 321061 */ // Label 6183: @321061
     /* 321061 */ GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(322239),
     /* 321066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 321072 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 321075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321079 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(321163), // Rule ID 6165 //
     /* 321084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 321095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 321108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321116 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 321120 */     // MIs[2] Operand 1
     /* 321120 */     // No operand predicates
     /* 321120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 321124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321128 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321132 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321143 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 321143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 321154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321161 */     GIR_RootConstrainSelectedInstOperands,
     /* 321162 */     // GIR_Coverage, 6165,
     /* 321162 */     GIR_EraseRootFromParent_Done,
     /* 321163 */   // Label 6331: @321163
     /* 321163 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(321244), // Rule ID 6197 //
     /* 321168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 321191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321199 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 321204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321212 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 321216 */     // MIs[3] Operand 1
     /* 321216 */     // No operand predicates
     /* 321216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321226 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 321226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321242 */     GIR_RootConstrainSelectedInstOperands,
     /* 321243 */     // GIR_Coverage, 6197,
     /* 321243 */     GIR_EraseRootFromParent_Done,
     /* 321244 */   // Label 6332: @321244
     /* 321244 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(321328), // Rule ID 6229 //
     /* 321249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 321277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321281 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 321290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321298 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 321302 */     // MIs[3] Operand 1
     /* 321302 */     // No operand predicates
     /* 321302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321308 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 321308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321326 */     GIR_RootConstrainSelectedInstOperands,
     /* 321327 */     // GIR_Coverage, 6229,
     /* 321327 */     GIR_EraseRootFromParent_Done,
     /* 321328 */   // Label 6333: @321328
     /* 321328 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(321409), // Rule ID 6133 //
     /* 321333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 321360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 321373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321381 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 321385 */     // MIs[3] Operand 1
     /* 321385 */     // No operand predicates
     /* 321385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321389 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321391 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 321391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321407 */     GIR_RootConstrainSelectedInstOperands,
     /* 321408 */     // GIR_Coverage, 6133,
     /* 321408 */     GIR_EraseRootFromParent_Done,
     /* 321409 */   // Label 6334: @321409
     /* 321409 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(321478), // Rule ID 2532 //
     /* 321414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 321425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 321438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321446 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 321450 */     // MIs[2] Operand 1
     /* 321450 */     // No operand predicates
     /* 321450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321460 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 321460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 321463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321476 */     GIR_RootConstrainSelectedInstOperands,
     /* 321477 */     // GIR_Coverage, 2532,
     /* 321477 */     GIR_EraseRootFromParent_Done,
     /* 321478 */   // Label 6335: @321478
     /* 321478 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(321547), // Rule ID 6101 //
     /* 321483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 321498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 321511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321519 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 321523 */     // MIs[2] Operand 1
     /* 321523 */     // No operand predicates
     /* 321523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321529 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 321529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 321532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321545 */     GIR_RootConstrainSelectedInstOperands,
     /* 321546 */     // GIR_Coverage, 6101,
     /* 321546 */     GIR_EraseRootFromParent_Done,
     /* 321547 */   // Label 6336: @321547
     /* 321547 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(321646), // Rule ID 6167 //
     /* 321552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321595 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321607 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321610 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321614 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 321638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321644 */     GIR_RootConstrainSelectedInstOperands,
     /* 321645 */     // GIR_Coverage, 6167,
     /* 321645 */     GIR_EraseRootFromParent_Done,
     /* 321646 */   // Label 6337: @321646
     /* 321646 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(321742), // Rule ID 6199 //
     /* 321651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321693 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321705 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321712 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321740 */     GIR_RootConstrainSelectedInstOperands,
     /* 321741 */     // GIR_Coverage, 6199,
     /* 321741 */     GIR_EraseRootFromParent_Done,
     /* 321742 */   // Label 6338: @321742
     /* 321742 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(321841), // Rule ID 6231 //
     /* 321747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321790 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321802 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321809 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321839 */     GIR_RootConstrainSelectedInstOperands,
     /* 321840 */     // GIR_Coverage, 6231,
     /* 321840 */     GIR_EraseRootFromParent_Done,
     /* 321841 */   // Label 6339: @321841
     /* 321841 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(321937), // Rule ID 6135 //
     /* 321846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321888 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321900 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321907 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321935 */     GIR_RootConstrainSelectedInstOperands,
     /* 321936 */     // GIR_Coverage, 6135,
     /* 321936 */     GIR_EraseRootFromParent_Done,
     /* 321937 */   // Label 6340: @321937
     /* 321937 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(322021), // Rule ID 2534 //
     /* 321942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321972 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321984 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321987 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321991 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 322007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322019 */     GIR_RootConstrainSelectedInstOperands,
     /* 322020 */     // GIR_Coverage, 2534,
     /* 322020 */     GIR_EraseRootFromParent_Done,
     /* 322021 */   // Label 6341: @322021
     /* 322021 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(322071), // Rule ID 13416 //
     /* 322026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322056 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 322056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 322059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322069 */     GIR_RootConstrainSelectedInstOperands,
     /* 322070 */     // GIR_Coverage, 13416,
     /* 322070 */     GIR_EraseRootFromParent_Done,
     /* 322071 */   // Label 6342: @322071
     /* 322071 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(322155), // Rule ID 6103 //
     /* 322076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322106 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322118 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322125 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 322141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322153 */     GIR_RootConstrainSelectedInstOperands,
     /* 322154 */     // GIR_Coverage, 6103,
     /* 322154 */     GIR_EraseRootFromParent_Done,
     /* 322155 */   // Label 6343: @322155
     /* 322155 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(322205), // Rule ID 1304 //
     /* 322160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322190 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 322190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 322193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322203 */     GIR_RootConstrainSelectedInstOperands,
     /* 322204 */     // GIR_Coverage, 1304,
     /* 322204 */     GIR_EraseRootFromParent_Done,
     /* 322205 */   // Label 6344: @322205
     /* 322205 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(322238), // Rule ID 1294 //
     /* 322210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322225 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 322225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 322228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 322236 */     GIR_RootConstrainSelectedInstOperands,
     /* 322237 */     // GIR_Coverage, 1294,
     /* 322237 */     GIR_EraseRootFromParent_Done,
     /* 322238 */   // Label 6345: @322238
     /* 322238 */   GIM_Reject,
     /* 322239 */ // Label 6330: @322239
     /* 322239 */ GIM_Reject,
     /* 322240 */ // Label 6184: @322240
     /* 322240 */ GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(323760),
     /* 322245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 322251 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 322254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322258 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(322336), // Rule ID 6263 //
     /* 322263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 322300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322304 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322308 */     // MIs[3] Operand 1
     /* 322308 */     // No operand predicates
     /* 322308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322318 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322334 */     GIR_RootConstrainSelectedInstOperands,
     /* 322335 */     // GIR_Coverage, 6263,
     /* 322335 */     GIR_EraseRootFromParent_Done,
     /* 322336 */   // Label 6347: @322336
     /* 322336 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(322420), // Rule ID 6177 //
     /* 322341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322373 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322377 */     // MIs[2] Operand 1
     /* 322377 */     // No operand predicates
     /* 322377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322385 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322389 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322400 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 322411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322418 */     GIR_RootConstrainSelectedInstOperands,
     /* 322419 */     // GIR_Coverage, 6177,
     /* 322419 */     GIR_EraseRootFromParent_Done,
     /* 322420 */   // Label 6348: @322420
     /* 322420 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(322501), // Rule ID 6209 //
     /* 322425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322469 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322473 */     // MIs[3] Operand 1
     /* 322473 */     // No operand predicates
     /* 322473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322483 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322499 */     GIR_RootConstrainSelectedInstOperands,
     /* 322500 */     // GIR_Coverage, 6209,
     /* 322500 */     GIR_EraseRootFromParent_Done,
     /* 322501 */   // Label 6349: @322501
     /* 322501 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(322585), // Rule ID 6241 //
     /* 322506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322555 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322559 */     // MIs[3] Operand 1
     /* 322559 */     // No operand predicates
     /* 322559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322565 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322583 */     GIR_RootConstrainSelectedInstOperands,
     /* 322584 */     // GIR_Coverage, 6241,
     /* 322584 */     GIR_EraseRootFromParent_Done,
     /* 322585 */   // Label 6350: @322585
     /* 322585 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(322663), // Rule ID 6285 //
     /* 322590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 322631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322635 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322639 */     // MIs[3] Operand 1
     /* 322639 */     // No operand predicates
     /* 322639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322643 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322645 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322661 */     GIR_RootConstrainSelectedInstOperands,
     /* 322662 */     // GIR_Coverage, 6285,
     /* 322662 */     GIR_EraseRootFromParent_Done,
     /* 322663 */   // Label 6351: @322663
     /* 322663 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(322744), // Rule ID 6145 //
     /* 322668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322716 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322720 */     // MIs[3] Operand 1
     /* 322720 */     // No operand predicates
     /* 322720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322724 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322726 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322742 */     GIR_RootConstrainSelectedInstOperands,
     /* 322743 */     // GIR_Coverage, 6145,
     /* 322743 */     GIR_EraseRootFromParent_Done,
     /* 322744 */   // Label 6352: @322744
     /* 322744 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(322813), // Rule ID 2544 //
     /* 322749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322781 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322785 */     // MIs[2] Operand 1
     /* 322785 */     // No operand predicates
     /* 322785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322795 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 322798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322811 */     GIR_RootConstrainSelectedInstOperands,
     /* 322812 */     // GIR_Coverage, 2544,
     /* 322812 */     GIR_EraseRootFromParent_Done,
     /* 322813 */   // Label 6353: @322813
     /* 322813 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(322882), // Rule ID 6113 //
     /* 322818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322854 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322858 */     // MIs[2] Operand 1
     /* 322858 */     // No operand predicates
     /* 322858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322864 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 322867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322880 */     GIR_RootConstrainSelectedInstOperands,
     /* 322881 */     // GIR_Coverage, 6113,
     /* 322881 */     GIR_EraseRootFromParent_Done,
     /* 322882 */   // Label 6354: @322882
     /* 322882 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(322975), // Rule ID 6267 //
     /* 322887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 322899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 322911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322926 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322938 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322941 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322945 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322973 */     GIR_RootConstrainSelectedInstOperands,
     /* 322974 */     // GIR_Coverage, 6267,
     /* 322974 */     GIR_EraseRootFromParent_Done,
     /* 322975 */   // Label 6355: @322975
     /* 322975 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(323074), // Rule ID 6179 //
     /* 322980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 322995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323023 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323035 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323042 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 323066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323072 */     GIR_RootConstrainSelectedInstOperands,
     /* 323073 */     // GIR_Coverage, 6179,
     /* 323073 */     GIR_EraseRootFromParent_Done,
     /* 323074 */   // Label 6356: @323074
     /* 323074 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(323170), // Rule ID 6211 //
     /* 323079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 323106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323121 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323133 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323136 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323140 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323168 */     GIR_RootConstrainSelectedInstOperands,
     /* 323169 */     // GIR_Coverage, 6211,
     /* 323169 */     GIR_EraseRootFromParent_Done,
     /* 323170 */   // Label 6357: @323170
     /* 323170 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(323269), // Rule ID 6243 //
     /* 323175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 323207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323218 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323267 */     GIR_RootConstrainSelectedInstOperands,
     /* 323268 */     // GIR_Coverage, 6243,
     /* 323268 */     GIR_EraseRootFromParent_Done,
     /* 323269 */   // Label 6358: @323269
     /* 323269 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(323362), // Rule ID 6289 //
     /* 323274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 323290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 323302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323313 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323325 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323328 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323332 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323360 */     GIR_RootConstrainSelectedInstOperands,
     /* 323361 */     // GIR_Coverage, 6289,
     /* 323361 */     GIR_EraseRootFromParent_Done,
     /* 323362 */   // Label 6359: @323362
     /* 323362 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(323458), // Rule ID 6147 //
     /* 323367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 323398 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323409 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323421 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323424 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323428 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323456 */     GIR_RootConstrainSelectedInstOperands,
     /* 323457 */     // GIR_Coverage, 6147,
     /* 323457 */     GIR_EraseRootFromParent_Done,
     /* 323458 */   // Label 6360: @323458
     /* 323458 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(323542), // Rule ID 2546 //
     /* 323463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 323478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323493 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323505 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323512 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 323528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323540 */     GIR_RootConstrainSelectedInstOperands,
     /* 323541 */     // GIR_Coverage, 2546,
     /* 323541 */     GIR_EraseRootFromParent_Done,
     /* 323542 */   // Label 6361: @323542
     /* 323542 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(323592), // Rule ID 13422 //
     /* 323547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323577 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 323580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323590 */     GIR_RootConstrainSelectedInstOperands,
     /* 323591 */     // GIR_Coverage, 13422,
     /* 323591 */     GIR_EraseRootFromParent_Done,
     /* 323592 */   // Label 6362: @323592
     /* 323592 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(323676), // Rule ID 6115 //
     /* 323597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 323616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323627 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323639 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323646 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 323662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323674 */     GIR_RootConstrainSelectedInstOperands,
     /* 323675 */     // GIR_Coverage, 6115,
     /* 323675 */     GIR_EraseRootFromParent_Done,
     /* 323676 */   // Label 6363: @323676
     /* 323676 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(323726), // Rule ID 1310 //
     /* 323681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323711 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 323714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323724 */     GIR_RootConstrainSelectedInstOperands,
     /* 323725 */     // GIR_Coverage, 1310,
     /* 323725 */     GIR_EraseRootFromParent_Done,
     /* 323726 */   // Label 6364: @323726
     /* 323726 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(323759), // Rule ID 1300 //
     /* 323731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323746 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 323749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 323757 */     GIR_RootConstrainSelectedInstOperands,
     /* 323758 */     // GIR_Coverage, 1300,
     /* 323758 */     GIR_EraseRootFromParent_Done,
     /* 323759 */   // Label 6365: @323759
     /* 323759 */   GIM_Reject,
     /* 323760 */ // Label 6346: @323760
     /* 323760 */ GIM_Reject,
     /* 323761 */ // Label 6185: @323761
     /* 323761 */ GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(324939),
     /* 323766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323772 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 323775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323779 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(323863), // Rule ID 6161 //
     /* 323784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323816 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323820 */     // MIs[2] Operand 1
     /* 323820 */     // No operand predicates
     /* 323820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323828 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323832 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323843 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 323854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323861 */     GIR_RootConstrainSelectedInstOperands,
     /* 323862 */     // GIR_Coverage, 6161,
     /* 323862 */     GIR_EraseRootFromParent_Done,
     /* 323863 */   // Label 6367: @323863
     /* 323863 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(323944), // Rule ID 6193 //
     /* 323868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323895 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323899 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323908 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323912 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323916 */     // MIs[3] Operand 1
     /* 323916 */     // No operand predicates
     /* 323916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323924 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323926 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323942 */     GIR_RootConstrainSelectedInstOperands,
     /* 323943 */     // GIR_Coverage, 6193,
     /* 323943 */     GIR_EraseRootFromParent_Done,
     /* 323944 */   // Label 6368: @323944
     /* 323944 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(324028), // Rule ID 6225 //
     /* 323949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323998 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324002 */     // MIs[3] Operand 1
     /* 324002 */     // No operand predicates
     /* 324002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324008 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324026 */     GIR_RootConstrainSelectedInstOperands,
     /* 324027 */     // GIR_Coverage, 6225,
     /* 324027 */     GIR_EraseRootFromParent_Done,
     /* 324028 */   // Label 6369: @324028
     /* 324028 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(324109), // Rule ID 6129 //
     /* 324033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 324077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324081 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324085 */     // MIs[3] Operand 1
     /* 324085 */     // No operand predicates
     /* 324085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324091 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324107 */     GIR_RootConstrainSelectedInstOperands,
     /* 324108 */     // GIR_Coverage, 6129,
     /* 324108 */     GIR_EraseRootFromParent_Done,
     /* 324109 */   // Label 6370: @324109
     /* 324109 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(324178), // Rule ID 2528 //
     /* 324114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324146 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324150 */     // MIs[2] Operand 1
     /* 324150 */     // No operand predicates
     /* 324150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324160 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 324163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 324176 */     GIR_RootConstrainSelectedInstOperands,
     /* 324177 */     // GIR_Coverage, 2528,
     /* 324177 */     GIR_EraseRootFromParent_Done,
     /* 324178 */   // Label 6371: @324178
     /* 324178 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(324247), // Rule ID 6097 //
     /* 324183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324219 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324223 */     // MIs[2] Operand 1
     /* 324223 */     // No operand predicates
     /* 324223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324229 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 324232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 324245 */     GIR_RootConstrainSelectedInstOperands,
     /* 324246 */     // GIR_Coverage, 6097,
     /* 324246 */     GIR_EraseRootFromParent_Done,
     /* 324247 */   // Label 6372: @324247
     /* 324247 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(324346), // Rule ID 6163 //
     /* 324252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324295 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 324298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324307 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324314 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 324338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324344 */     GIR_RootConstrainSelectedInstOperands,
     /* 324345 */     // GIR_Coverage, 6163,
     /* 324345 */     GIR_EraseRootFromParent_Done,
     /* 324346 */   // Label 6373: @324346
     /* 324346 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(324442), // Rule ID 6195 //
     /* 324351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324393 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 324396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324405 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324412 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324440 */     GIR_RootConstrainSelectedInstOperands,
     /* 324441 */     // GIR_Coverage, 6195,
     /* 324441 */     GIR_EraseRootFromParent_Done,
     /* 324442 */   // Label 6374: @324442
     /* 324442 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(324541), // Rule ID 6227 //
     /* 324447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324490 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 324493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324502 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324505 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324509 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324539 */     GIR_RootConstrainSelectedInstOperands,
     /* 324540 */     // GIR_Coverage, 6227,
     /* 324540 */     GIR_EraseRootFromParent_Done,
     /* 324541 */   // Label 6375: @324541
     /* 324541 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(324637), // Rule ID 6131 //
     /* 324546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324588 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 324591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324600 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324603 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324607 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324635 */     GIR_RootConstrainSelectedInstOperands,
     /* 324636 */     // GIR_Coverage, 6131,
     /* 324636 */     GIR_EraseRootFromParent_Done,
     /* 324637 */   // Label 6376: @324637
     /* 324637 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(324721), // Rule ID 2530 //
     /* 324642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324672 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 324675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324684 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324691 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 324707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324719 */     GIR_RootConstrainSelectedInstOperands,
     /* 324720 */     // GIR_Coverage, 2530,
     /* 324720 */     GIR_EraseRootFromParent_Done,
     /* 324721 */   // Label 6377: @324721
     /* 324721 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(324771), // Rule ID 13418 //
     /* 324726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324756 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 324759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324769 */     GIR_RootConstrainSelectedInstOperands,
     /* 324770 */     // GIR_Coverage, 13418,
     /* 324770 */     GIR_EraseRootFromParent_Done,
     /* 324771 */   // Label 6378: @324771
     /* 324771 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(324855), // Rule ID 6099 //
     /* 324776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324806 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 324809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324818 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324825 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 324841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324853 */     GIR_RootConstrainSelectedInstOperands,
     /* 324854 */     // GIR_Coverage, 6099,
     /* 324854 */     GIR_EraseRootFromParent_Done,
     /* 324855 */   // Label 6379: @324855
     /* 324855 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(324905), // Rule ID 1306 //
     /* 324860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324890 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 324893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324903 */     GIR_RootConstrainSelectedInstOperands,
     /* 324904 */     // GIR_Coverage, 1306,
     /* 324904 */     GIR_EraseRootFromParent_Done,
     /* 324905 */   // Label 6380: @324905
     /* 324905 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(324938), // Rule ID 1296 //
     /* 324910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324925 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 324928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 324936 */     GIR_RootConstrainSelectedInstOperands,
     /* 324937 */     // GIR_Coverage, 1296,
     /* 324937 */     GIR_EraseRootFromParent_Done,
     /* 324938 */   // Label 6381: @324938
     /* 324938 */   GIM_Reject,
     /* 324939 */ // Label 6366: @324939
     /* 324939 */ GIM_Reject,
     /* 324940 */ // Label 6186: @324940
     /* 324940 */ GIM_Reject,
     /* 324941 */ // Label 63: @324941
     /* 324941 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6390*/ GIMT_Encode4(325556),
     /* 324952 */ /*GILLT_s16*//*Label 6382*/ GIMT_Encode4(324992),
     /* 324956 */ /*GILLT_s32*//*Label 6383*/ GIMT_Encode4(325030),
     /* 324960 */ /*GILLT_s64*//*Label 6384*/ GIMT_Encode4(325068), GIMT_Encode4(0),
     /* 324968 */ /*GILLT_v2s32*//*Label 6385*/ GIMT_Encode4(325106),
     /* 324972 */ /*GILLT_v2s64*//*Label 6386*/ GIMT_Encode4(325144),
     /* 324976 */ /*GILLT_v4s16*//*Label 6387*/ GIMT_Encode4(325182),
     /* 324980 */ /*GILLT_v4s32*//*Label 6388*/ GIMT_Encode4(325220), GIMT_Encode4(0),
     /* 324988 */ /*GILLT_v8s16*//*Label 6389*/ GIMT_Encode4(325258),
     /* 324992 */ // Label 6382: @324992
     /* 324992 */ GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(325029), // Rule ID 590 //
     /* 324997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 325003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 325006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325018 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 325018 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 325023 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325027 */   GIR_RootConstrainSelectedInstOperands,
     /* 325028 */   // GIR_Coverage, 590,
     /* 325028 */   GIR_Done,
     /* 325029 */ // Label 6391: @325029
     /* 325029 */ GIM_Reject,
     /* 325030 */ // Label 6383: @325030
     /* 325030 */ GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(325067), // Rule ID 592 //
     /* 325035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 325038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325056 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 325056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 325061 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325065 */   GIR_RootConstrainSelectedInstOperands,
     /* 325066 */   // GIR_Coverage, 592,
     /* 325066 */   GIR_Done,
     /* 325067 */ // Label 6392: @325067
     /* 325067 */ GIM_Reject,
     /* 325068 */ // Label 6384: @325068
     /* 325068 */ GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(325105), // Rule ID 594 //
     /* 325073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 325076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325094 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 325094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 325099 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325103 */   GIR_RootConstrainSelectedInstOperands,
     /* 325104 */   // GIR_Coverage, 594,
     /* 325104 */   GIR_Done,
     /* 325105 */ // Label 6393: @325105
     /* 325105 */ GIM_Reject,
     /* 325106 */ // Label 6385: @325106
     /* 325106 */ GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(325143), // Rule ID 1228 //
     /* 325111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 325120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325132 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 325132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 325137 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325141 */   GIR_RootConstrainSelectedInstOperands,
     /* 325142 */   // GIR_Coverage, 1228,
     /* 325142 */   GIR_Done,
     /* 325143 */ // Label 6394: @325143
     /* 325143 */ GIM_Reject,
     /* 325144 */ // Label 6386: @325144
     /* 325144 */ GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(325181), // Rule ID 1232 //
     /* 325149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 325158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325170 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 325170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 325175 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325179 */   GIR_RootConstrainSelectedInstOperands,
     /* 325180 */   // GIR_Coverage, 1232,
     /* 325180 */   GIR_Done,
     /* 325181 */ // Label 6395: @325181
     /* 325181 */ GIM_Reject,
     /* 325182 */ // Label 6387: @325182
     /* 325182 */ GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(325219), // Rule ID 1224 //
     /* 325187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325208 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 325208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 325213 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325217 */   GIR_RootConstrainSelectedInstOperands,
     /* 325218 */   // GIR_Coverage, 1224,
     /* 325218 */   GIR_Done,
     /* 325219 */ // Label 6396: @325219
     /* 325219 */ GIM_Reject,
     /* 325220 */ // Label 6388: @325220
     /* 325220 */ GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(325257), // Rule ID 1230 //
     /* 325225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325246 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 325251 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325255 */   GIR_RootConstrainSelectedInstOperands,
     /* 325256 */   // GIR_Coverage, 1230,
     /* 325256 */   GIR_Done,
     /* 325257 */ // Label 6397: @325257
     /* 325257 */ GIM_Reject,
     /* 325258 */ // Label 6389: @325258
     /* 325258 */ GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(325555),
     /* 325263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325281 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(325300), // Rule ID 1226 //
     /* 325286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325289 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325289 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 325294 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325298 */     GIR_RootConstrainSelectedInstOperands,
     /* 325299 */     // GIR_Coverage, 1226,
     /* 325299 */     GIR_Done,
     /* 325300 */   // Label 6399: @325300
     /* 325300 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(325554), // Rule ID 7064 //
     /* 325305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 325308 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 325308 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 325311 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 325315 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325320 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 325324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 325326 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 325329 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 325333 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325338 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 325344 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 325347 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 325351 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325356 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 325359 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 325362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 325364 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 325367 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325371 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325376 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 325382 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325387 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325392 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 325395 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 325399 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325404 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 325407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 325409 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 325412 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325416 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325421 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 325427 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325432 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325437 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 325440 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 325444 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325449 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 325452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 325454 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 325457 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 325461 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325466 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 325469 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 325472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 325474 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 325477 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 325481 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325486 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 325489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 325491 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325494 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325498 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 325505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 325512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325517 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325520 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 325523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 325526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 325544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 325552 */     GIR_RootConstrainSelectedInstOperands,
     /* 325553 */     // GIR_Coverage, 7064,
     /* 325553 */     GIR_EraseRootFromParent_Done,
     /* 325554 */   // Label 6400: @325554
     /* 325554 */   GIM_Reject,
     /* 325555 */ // Label 6398: @325555
     /* 325555 */ GIM_Reject,
     /* 325556 */ // Label 6390: @325556
     /* 325556 */ GIM_Reject,
     /* 325557 */ // Label 64: @325557
     /* 325557 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6409*/ GIMT_Encode4(329063),
     /* 325568 */ /*GILLT_s16*//*Label 6401*/ GIMT_Encode4(325608),
     /* 325572 */ /*GILLT_s32*//*Label 6402*/ GIMT_Encode4(326776),
     /* 325576 */ /*GILLT_s64*//*Label 6403*/ GIMT_Encode4(327799), GIMT_Encode4(0),
     /* 325584 */ /*GILLT_v2s32*//*Label 6404*/ GIMT_Encode4(328822),
     /* 325588 */ /*GILLT_v2s64*//*Label 6405*/ GIMT_Encode4(328849),
     /* 325592 */ /*GILLT_v4s16*//*Label 6406*/ GIMT_Encode4(328876),
     /* 325596 */ /*GILLT_v4s32*//*Label 6407*/ GIMT_Encode4(328956), GIMT_Encode4(0),
     /* 325604 */ /*GILLT_v8s16*//*Label 6408*/ GIMT_Encode4(328983),
     /* 325608 */ // Label 6401: @325608
     /* 325608 */ GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(326775),
     /* 325613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 325616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325620 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(325778), // Rule ID 4883 //
     /* 325625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 325636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325644 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325660 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325669 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 325673 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 325677 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325681 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325685 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 325689 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325694 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 325698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325705 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 325705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 325708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325717 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 325723 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325745 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 325751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 325772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325776 */     GIR_RootConstrainSelectedInstOperands,
     /* 325777 */     // GIR_Coverage, 4883,
     /* 325777 */     GIR_EraseRootFromParent_Done,
     /* 325778 */   // Label 6411: @325778
     /* 325778 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(325936), // Rule ID 4882 //
     /* 325783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 325794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325802 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325827 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 325831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 325835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325839 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325843 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 325847 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325852 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 325856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325863 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 325863 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 325866 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325870 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325875 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 325881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325886 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325903 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 325909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 325930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325934 */     GIR_RootConstrainSelectedInstOperands,
     /* 325935 */     // GIR_Coverage, 4882,
     /* 325935 */     GIR_EraseRootFromParent_Done,
     /* 325936 */   // Label 6412: @325936
     /* 325936 */   GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(326047), // Rule ID 4881 //
     /* 325941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 325952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325960 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325985 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 325989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326001 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 326001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 326004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326013 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 326019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326045 */     GIR_RootConstrainSelectedInstOperands,
     /* 326046 */     // GIR_Coverage, 4881,
     /* 326046 */     GIR_EraseRootFromParent_Done,
     /* 326047 */   // Label 6413: @326047
     /* 326047 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(326158), // Rule ID 4879 //
     /* 326052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326071 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326101 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326112 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 326112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 326115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326124 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 326130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326156 */     GIR_RootConstrainSelectedInstOperands,
     /* 326157 */     // GIR_Coverage, 4879,
     /* 326157 */     GIR_EraseRootFromParent_Done,
     /* 326158 */   // Label 6414: @326158
     /* 326158 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(326269), // Rule ID 4880 //
     /* 326163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326182 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326207 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326223 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 326223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 326226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326235 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 326241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326267 */     GIR_RootConstrainSelectedInstOperands,
     /* 326268 */     // GIR_Coverage, 4880,
     /* 326268 */     GIR_EraseRootFromParent_Done,
     /* 326269 */   // Label 6415: @326269
     /* 326269 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(326380), // Rule ID 4878 //
     /* 326274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326293 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326323 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326334 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 326334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 326337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326346 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 326352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326378 */     GIR_RootConstrainSelectedInstOperands,
     /* 326379 */     // GIR_Coverage, 4878,
     /* 326379 */     GIR_EraseRootFromParent_Done,
     /* 326380 */   // Label 6416: @326380
     /* 326380 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(326444), // Rule ID 650 //
     /* 326385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326404 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326425 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 326425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326442 */     GIR_RootConstrainSelectedInstOperands,
     /* 326443 */     // GIR_Coverage, 650,
     /* 326443 */     GIR_EraseRootFromParent_Done,
     /* 326444 */   // Label 6417: @326444
     /* 326444 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(326508), // Rule ID 649 //
     /* 326449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326468 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326489 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 326489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326506 */     GIR_RootConstrainSelectedInstOperands,
     /* 326507 */     // GIR_Coverage, 649,
     /* 326507 */     GIR_EraseRootFromParent_Done,
     /* 326508 */   // Label 6418: @326508
     /* 326508 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(326559), // Rule ID 626 //
     /* 326513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 326524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326544 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 326544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 326547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326557 */     GIR_RootConstrainSelectedInstOperands,
     /* 326558 */     // GIR_Coverage, 626,
     /* 326558 */     GIR_EraseRootFromParent_Done,
     /* 326559 */   // Label 6419: @326559
     /* 326559 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(326610), // Rule ID 625 //
     /* 326564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 326575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326595 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 326595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 326598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326608 */     GIR_RootConstrainSelectedInstOperands,
     /* 326609 */     // GIR_Coverage, 625,
     /* 326609 */     GIR_EraseRootFromParent_Done,
     /* 326610 */   // Label 6420: @326610
     /* 326610 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(326629), // Rule ID 524 //
     /* 326615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326622 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 326622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 326627 */     GIR_RootConstrainSelectedInstOperands,
     /* 326628 */     // GIR_Coverage, 524,
     /* 326628 */     GIR_Done,
     /* 326629 */   // Label 6421: @326629
     /* 326629 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(326774), // Rule ID 6429 //
     /* 326634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326638 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 326638 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 326641 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326645 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 326652 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 326655 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326659 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326664 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 326667 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 326671 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 326674 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326679 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326684 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326689 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 326692 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326696 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326701 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 326704 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326709 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 326712 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 326716 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326721 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326724 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 326729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326743 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326756 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 326763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326773 */     // GIR_Coverage, 6429,
     /* 326773 */     GIR_EraseRootFromParent_Done,
     /* 326774 */   // Label 6422: @326774
     /* 326774 */   GIM_Reject,
     /* 326775 */ // Label 6410: @326775
     /* 326775 */ GIM_Reject,
     /* 326776 */ // Label 6402: @326776
     /* 326776 */ GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(327798),
     /* 326781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326788 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(326946), // Rule ID 4889 //
     /* 326793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326812 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326837 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 326845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326849 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326853 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 326857 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326862 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 326866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326871 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326873 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 326873 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 326876 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326880 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326885 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 326891 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326896 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326913 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 326919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 326940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326944 */     GIR_RootConstrainSelectedInstOperands,
     /* 326945 */     // GIR_Coverage, 4889,
     /* 326945 */     GIR_EraseRootFromParent_Done,
     /* 326946 */   // Label 6424: @326946
     /* 326946 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(327104), // Rule ID 4888 //
     /* 326951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326970 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326995 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327007 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327011 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327015 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327020 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327031 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 327031 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 327034 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327038 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327043 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 327049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327054 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327071 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 327077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 327098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327102 */     GIR_RootConstrainSelectedInstOperands,
     /* 327103 */     // GIR_Coverage, 4888,
     /* 327103 */     GIR_EraseRootFromParent_Done,
     /* 327104 */   // Label 6425: @327104
     /* 327104 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(327215), // Rule ID 4887 //
     /* 327109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327128 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327153 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327169 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 327169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327181 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 327187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327213 */     GIR_RootConstrainSelectedInstOperands,
     /* 327214 */     // GIR_Coverage, 4887,
     /* 327214 */     GIR_EraseRootFromParent_Done,
     /* 327215 */   // Label 6426: @327215
     /* 327215 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(327326), // Rule ID 4885 //
     /* 327220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327239 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327269 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327280 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 327280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327292 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 327298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327324 */     GIR_RootConstrainSelectedInstOperands,
     /* 327325 */     // GIR_Coverage, 4885,
     /* 327325 */     GIR_EraseRootFromParent_Done,
     /* 327326 */   // Label 6427: @327326
     /* 327326 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(327437), // Rule ID 4886 //
     /* 327331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327350 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327375 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327391 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 327391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327403 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 327409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327435 */     GIR_RootConstrainSelectedInstOperands,
     /* 327436 */     // GIR_Coverage, 4886,
     /* 327436 */     GIR_EraseRootFromParent_Done,
     /* 327437 */   // Label 6428: @327437
     /* 327437 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(327548), // Rule ID 4884 //
     /* 327442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327461 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327491 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327502 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 327502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327514 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 327520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327546 */     GIR_RootConstrainSelectedInstOperands,
     /* 327547 */     // GIR_Coverage, 4884,
     /* 327547 */     GIR_EraseRootFromParent_Done,
     /* 327548 */   // Label 6429: @327548
     /* 327548 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(327612), // Rule ID 652 //
     /* 327553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327572 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327593 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 327593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327610 */     GIR_RootConstrainSelectedInstOperands,
     /* 327611 */     // GIR_Coverage, 652,
     /* 327611 */     GIR_EraseRootFromParent_Done,
     /* 327612 */   // Label 6430: @327612
     /* 327612 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(327676), // Rule ID 651 //
     /* 327617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327636 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327657 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 327657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327674 */     GIR_RootConstrainSelectedInstOperands,
     /* 327675 */     // GIR_Coverage, 651,
     /* 327675 */     GIR_EraseRootFromParent_Done,
     /* 327676 */   // Label 6431: @327676
     /* 327676 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(327727), // Rule ID 628 //
     /* 327681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 327692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327712 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 327712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 327715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327725 */     GIR_RootConstrainSelectedInstOperands,
     /* 327726 */     // GIR_Coverage, 628,
     /* 327726 */     GIR_EraseRootFromParent_Done,
     /* 327727 */   // Label 6432: @327727
     /* 327727 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(327778), // Rule ID 627 //
     /* 327732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 327743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327763 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 327763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 327766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327776 */     GIR_RootConstrainSelectedInstOperands,
     /* 327777 */     // GIR_Coverage, 627,
     /* 327777 */     GIR_EraseRootFromParent_Done,
     /* 327778 */   // Label 6433: @327778
     /* 327778 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(327797), // Rule ID 525 //
     /* 327783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327790 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 327790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 327795 */     GIR_RootConstrainSelectedInstOperands,
     /* 327796 */     // GIR_Coverage, 525,
     /* 327796 */     GIR_Done,
     /* 327797 */   // Label 6434: @327797
     /* 327797 */   GIM_Reject,
     /* 327798 */ // Label 6423: @327798
     /* 327798 */ GIM_Reject,
     /* 327799 */ // Label 6403: @327799
     /* 327799 */ GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(328821),
     /* 327804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327811 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(327969), // Rule ID 4895 //
     /* 327816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327835 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327860 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327872 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327876 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327880 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327885 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327894 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327896 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 327896 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 327899 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327903 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327908 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 327914 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327919 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327936 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 327942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 327963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327967 */     GIR_RootConstrainSelectedInstOperands,
     /* 327968 */     // GIR_Coverage, 4895,
     /* 327968 */     GIR_EraseRootFromParent_Done,
     /* 327969 */   // Label 6436: @327969
     /* 327969 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(328127), // Rule ID 4894 //
     /* 327974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327993 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328018 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328030 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328034 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 328038 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328043 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 328047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328052 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328054 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 328054 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 328057 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328061 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328066 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 328072 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328077 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328094 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 328121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328125 */     GIR_RootConstrainSelectedInstOperands,
     /* 328126 */     // GIR_Coverage, 4894,
     /* 328126 */     GIR_EraseRootFromParent_Done,
     /* 328127 */   // Label 6437: @328127
     /* 328127 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(328238), // Rule ID 4893 //
     /* 328132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328151 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328176 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328192 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 328192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328204 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328236 */     GIR_RootConstrainSelectedInstOperands,
     /* 328237 */     // GIR_Coverage, 4893,
     /* 328237 */     GIR_EraseRootFromParent_Done,
     /* 328238 */   // Label 6438: @328238
     /* 328238 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(328349), // Rule ID 4891 //
     /* 328243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328262 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328292 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328303 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 328303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328315 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 328321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328347 */     GIR_RootConstrainSelectedInstOperands,
     /* 328348 */     // GIR_Coverage, 4891,
     /* 328348 */     GIR_EraseRootFromParent_Done,
     /* 328349 */   // Label 6439: @328349
     /* 328349 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(328460), // Rule ID 4892 //
     /* 328354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328373 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328398 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328414 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 328414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328426 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328458 */     GIR_RootConstrainSelectedInstOperands,
     /* 328459 */     // GIR_Coverage, 4892,
     /* 328459 */     GIR_EraseRootFromParent_Done,
     /* 328460 */   // Label 6440: @328460
     /* 328460 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(328571), // Rule ID 4890 //
     /* 328465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328484 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328514 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328525 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 328525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328537 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 328543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328569 */     GIR_RootConstrainSelectedInstOperands,
     /* 328570 */     // GIR_Coverage, 4890,
     /* 328570 */     GIR_EraseRootFromParent_Done,
     /* 328571 */   // Label 6441: @328571
     /* 328571 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(328635), // Rule ID 654 //
     /* 328576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328595 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328616 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 328616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328633 */     GIR_RootConstrainSelectedInstOperands,
     /* 328634 */     // GIR_Coverage, 654,
     /* 328634 */     GIR_EraseRootFromParent_Done,
     /* 328635 */   // Label 6442: @328635
     /* 328635 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(328699), // Rule ID 653 //
     /* 328640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328659 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328680 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 328680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328697 */     GIR_RootConstrainSelectedInstOperands,
     /* 328698 */     // GIR_Coverage, 653,
     /* 328698 */     GIR_EraseRootFromParent_Done,
     /* 328699 */   // Label 6443: @328699
     /* 328699 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(328750), // Rule ID 630 //
     /* 328704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 328715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328735 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 328735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 328738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328748 */     GIR_RootConstrainSelectedInstOperands,
     /* 328749 */     // GIR_Coverage, 630,
     /* 328749 */     GIR_EraseRootFromParent_Done,
     /* 328750 */   // Label 6444: @328750
     /* 328750 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(328801), // Rule ID 629 //
     /* 328755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 328766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328786 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 328786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 328789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328799 */     GIR_RootConstrainSelectedInstOperands,
     /* 328800 */     // GIR_Coverage, 629,
     /* 328800 */     GIR_EraseRootFromParent_Done,
     /* 328801 */   // Label 6445: @328801
     /* 328801 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(328820), // Rule ID 526 //
     /* 328806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328813 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 328813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 328818 */     GIR_RootConstrainSelectedInstOperands,
     /* 328819 */     // GIR_Coverage, 526,
     /* 328819 */     GIR_Done,
     /* 328820 */   // Label 6446: @328820
     /* 328820 */   GIM_Reject,
     /* 328821 */ // Label 6435: @328821
     /* 328821 */ GIM_Reject,
     /* 328822 */ // Label 6404: @328822
     /* 328822 */ GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(328848), // Rule ID 860 //
     /* 328827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328841 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 328841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 328846 */   GIR_RootConstrainSelectedInstOperands,
     /* 328847 */   // GIR_Coverage, 860,
     /* 328847 */   GIR_Done,
     /* 328848 */ // Label 6447: @328848
     /* 328848 */ GIM_Reject,
     /* 328849 */ // Label 6405: @328849
     /* 328849 */ GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(328875), // Rule ID 862 //
     /* 328854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328868 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 328868 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 328873 */   GIR_RootConstrainSelectedInstOperands,
     /* 328874 */   // GIR_Coverage, 862,
     /* 328874 */   GIR_Done,
     /* 328875 */ // Label 6448: @328875
     /* 328875 */ GIM_Reject,
     /* 328876 */ // Label 6406: @328876
     /* 328876 */ GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(328955),
     /* 328881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328892 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(328907), // Rule ID 858 //
     /* 328897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 328900 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 328900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 328905 */     GIR_RootConstrainSelectedInstOperands,
     /* 328906 */     // GIR_Coverage, 858,
     /* 328906 */     GIR_Done,
     /* 328907 */   // Label 6450: @328907
     /* 328907 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(328954), // Rule ID 6432 //
     /* 328912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328915 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 328915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 328922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328927 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 328937 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 328945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 328949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328952 */     GIR_RootConstrainSelectedInstOperands,
     /* 328953 */     // GIR_Coverage, 6432,
     /* 328953 */     GIR_EraseRootFromParent_Done,
     /* 328954 */   // Label 6451: @328954
     /* 328954 */   GIM_Reject,
     /* 328955 */ // Label 6449: @328955
     /* 328955 */ GIM_Reject,
     /* 328956 */ // Label 6407: @328956
     /* 328956 */ GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(328982), // Rule ID 861 //
     /* 328961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328975 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 328975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 328980 */   GIR_RootConstrainSelectedInstOperands,
     /* 328981 */   // GIR_Coverage, 861,
     /* 328981 */   GIR_Done,
     /* 328982 */ // Label 6452: @328982
     /* 328982 */ GIM_Reject,
     /* 328983 */ // Label 6408: @328983
     /* 328983 */ GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(329062),
     /* 328988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328999 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(329014), // Rule ID 859 //
     /* 329004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 329007 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 329007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 329012 */     GIR_RootConstrainSelectedInstOperands,
     /* 329013 */     // GIR_Coverage, 859,
     /* 329013 */     GIR_Done,
     /* 329014 */   // Label 6454: @329014
     /* 329014 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(329061), // Rule ID 6433 //
     /* 329019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329022 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 329022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 329029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329034 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 329044 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 329052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329059 */     GIR_RootConstrainSelectedInstOperands,
     /* 329060 */     // GIR_Coverage, 6433,
     /* 329060 */     GIR_EraseRootFromParent_Done,
     /* 329061 */   // Label 6455: @329061
     /* 329061 */   GIM_Reject,
     /* 329062 */ // Label 6453: @329062
     /* 329062 */ GIM_Reject,
     /* 329063 */ // Label 6409: @329063
     /* 329063 */ GIM_Reject,
     /* 329064 */ // Label 65: @329064
     /* 329064 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6460*/ GIMT_Encode4(329311),
     /* 329075 */ /*GILLT_s32*//*Label 6456*/ GIMT_Encode4(329103),
     /* 329079 */ /*GILLT_s64*//*Label 6457*/ GIMT_Encode4(329134), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 329091 */ /*GILLT_v2s64*//*Label 6458*/ GIMT_Encode4(329195), GIMT_Encode4(0),
     /* 329099 */ /*GILLT_v4s32*//*Label 6459*/ GIMT_Encode4(329253),
     /* 329103 */ // Label 6456: @329103
     /* 329103 */ GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(329133), // Rule ID 516 //
     /* 329108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 329114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329122 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 329122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 329127 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329131 */   GIR_RootConstrainSelectedInstOperands,
     /* 329132 */   // GIR_Coverage, 516,
     /* 329132 */   GIR_Done,
     /* 329133 */ // Label 6461: @329133
     /* 329133 */ GIM_Reject,
     /* 329134 */ // Label 6457: @329134
     /* 329134 */ GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(329164), // Rule ID 514 //
     /* 329139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 329145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329153 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 329153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 329158 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329162 */   GIR_RootConstrainSelectedInstOperands,
     /* 329163 */   // GIR_Coverage, 514,
     /* 329163 */   GIR_Done,
     /* 329164 */ // Label 6462: @329164
     /* 329164 */ GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(329194), // Rule ID 518 //
     /* 329169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329183 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 329183 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 329188 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329192 */   GIR_RootConstrainSelectedInstOperands,
     /* 329193 */   // GIR_Coverage, 518,
     /* 329193 */   GIR_Done,
     /* 329194 */ // Label 6463: @329194
     /* 329194 */ GIM_Reject,
     /* 329195 */ // Label 6458: @329195
     /* 329195 */ GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(329252),
     /* 329200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329207 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(329231), // Rule ID 4938 //
     /* 329212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 329219 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 329219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 329222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 329229 */     GIR_RootConstrainSelectedInstOperands,
     /* 329230 */     // GIR_Coverage, 4938,
     /* 329230 */     GIR_EraseRootFromParent_Done,
     /* 329231 */   // Label 6465: @329231
     /* 329231 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(329251), // Rule ID 4936 //
     /* 329236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329240 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 329240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 329245 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329249 */     GIR_RootConstrainSelectedInstOperands,
     /* 329250 */     // GIR_Coverage, 4936,
     /* 329250 */     GIR_Done,
     /* 329251 */   // Label 6466: @329251
     /* 329251 */   GIM_Reject,
     /* 329252 */ // Label 6464: @329252
     /* 329252 */ GIM_Reject,
     /* 329253 */ // Label 6459: @329253
     /* 329253 */ GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(329310),
     /* 329258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329265 */   GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(329289), // Rule ID 4942 //
     /* 329270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 329277 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 329277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 329280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 329287 */     GIR_RootConstrainSelectedInstOperands,
     /* 329288 */     // GIR_Coverage, 4942,
     /* 329288 */     GIR_EraseRootFromParent_Done,
     /* 329289 */   // Label 6468: @329289
     /* 329289 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(329309), // Rule ID 4940 //
     /* 329294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329298 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 329298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 329303 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329307 */     GIR_RootConstrainSelectedInstOperands,
     /* 329308 */     // GIR_Coverage, 4940,
     /* 329308 */     GIR_Done,
     /* 329309 */   // Label 6469: @329309
     /* 329309 */   GIM_Reject,
     /* 329310 */ // Label 6467: @329310
     /* 329310 */ GIM_Reject,
     /* 329311 */ // Label 6460: @329311
     /* 329311 */ GIM_Reject,
     /* 329312 */ // Label 66: @329312
     /* 329312 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6474*/ GIMT_Encode4(329499),
     /* 329323 */ /*GILLT_s16*//*Label 6470*/ GIMT_Encode4(329351),
     /* 329327 */ /*GILLT_s32*//*Label 6471*/ GIMT_Encode4(329412), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 329339 */ /*GILLT_v2s32*//*Label 6472*/ GIMT_Encode4(329443), GIMT_Encode4(0),
     /* 329347 */ /*GILLT_v4s16*//*Label 6473*/ GIMT_Encode4(329471),
     /* 329351 */ // Label 6470: @329351
     /* 329351 */ GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(329381), // Rule ID 510 //
     /* 329356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329370 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 329370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 329375 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329379 */   GIR_RootConstrainSelectedInstOperands,
     /* 329380 */   // GIR_Coverage, 510,
     /* 329380 */   GIR_Done,
     /* 329381 */ // Label 6475: @329381
     /* 329381 */ GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(329411), // Rule ID 520 //
     /* 329386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329400 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 329400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 329405 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329409 */   GIR_RootConstrainSelectedInstOperands,
     /* 329410 */   // GIR_Coverage, 520,
     /* 329410 */   GIR_Done,
     /* 329411 */ // Label 6476: @329411
     /* 329411 */ GIM_Reject,
     /* 329412 */ // Label 6471: @329412
     /* 329412 */ GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(329442), // Rule ID 512 //
     /* 329417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329431 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 329431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 329436 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329440 */   GIR_RootConstrainSelectedInstOperands,
     /* 329441 */   // GIR_Coverage, 512,
     /* 329441 */   GIR_Done,
     /* 329442 */ // Label 6477: @329442
     /* 329442 */ GIM_Reject,
     /* 329443 */ // Label 6472: @329443
     /* 329443 */ GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(329470), // Rule ID 4946 //
     /* 329448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329459 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 329459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 329464 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329468 */   GIR_RootConstrainSelectedInstOperands,
     /* 329469 */   // GIR_Coverage, 4946,
     /* 329469 */   GIR_Done,
     /* 329470 */ // Label 6478: @329470
     /* 329470 */ GIM_Reject,
     /* 329471 */ // Label 6473: @329471
     /* 329471 */ GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(329498), // Rule ID 4948 //
     /* 329476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329487 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 329487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 329492 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329496 */   GIR_RootConstrainSelectedInstOperands,
     /* 329497 */   // GIR_Coverage, 4948,
     /* 329497 */   GIR_Done,
     /* 329498 */ // Label 6479: @329498
     /* 329498 */ GIM_Reject,
     /* 329499 */ // Label 6474: @329499
     /* 329499 */ GIM_Reject,
     /* 329500 */ // Label 67: @329500
     /* 329500 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6487*/ GIMT_Encode4(330476),
     /* 329511 */ /*GILLT_s32*//*Label 6480*/ GIMT_Encode4(329547),
     /* 329515 */ /*GILLT_s64*//*Label 6481*/ GIMT_Encode4(329934), GIMT_Encode4(0),
     /* 329523 */ /*GILLT_v2s32*//*Label 6482*/ GIMT_Encode4(330321),
     /* 329527 */ /*GILLT_v2s64*//*Label 6483*/ GIMT_Encode4(330352),
     /* 329531 */ /*GILLT_v4s16*//*Label 6484*/ GIMT_Encode4(330383),
     /* 329535 */ /*GILLT_v4s32*//*Label 6485*/ GIMT_Encode4(330414), GIMT_Encode4(0),
     /* 329543 */ /*GILLT_v8s16*//*Label 6486*/ GIMT_Encode4(330445),
     /* 329547 */ // Label 6480: @329547
     /* 329547 */ GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(329584), // Rule ID 4685 //
     /* 329552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329559 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329563 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 329567 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329573 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 329576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329578 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329582 */   GIR_RootConstrainSelectedInstOperands,
     /* 329583 */   // GIR_Coverage, 4685,
     /* 329583 */   GIR_EraseRootFromParent_Done,
     /* 329584 */ // Label 6488: @329584
     /* 329584 */ GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(329621), // Rule ID 4687 //
     /* 329589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329596 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329600 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 329604 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329608 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329610 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 329613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329615 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329619 */   GIR_RootConstrainSelectedInstOperands,
     /* 329620 */   // GIR_Coverage, 4687,
     /* 329620 */   GIR_EraseRootFromParent_Done,
     /* 329621 */ // Label 6489: @329621
     /* 329621 */ GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(329658), // Rule ID 4705 //
     /* 329626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 329641 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329645 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329647 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 329650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329652 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329656 */   GIR_RootConstrainSelectedInstOperands,
     /* 329657 */   // GIR_Coverage, 4705,
     /* 329657 */   GIR_EraseRootFromParent_Done,
     /* 329658 */ // Label 6490: @329658
     /* 329658 */ GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(329695), // Rule ID 4707 //
     /* 329663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329670 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329674 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 329678 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329682 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329684 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 329687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329689 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329693 */   GIR_RootConstrainSelectedInstOperands,
     /* 329694 */   // GIR_Coverage, 4707,
     /* 329694 */   GIR_EraseRootFromParent_Done,
     /* 329695 */ // Label 6491: @329695
     /* 329695 */ GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(329732), // Rule ID 4745 //
     /* 329700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329707 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329711 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 329715 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329721 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 329724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329726 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329730 */   GIR_RootConstrainSelectedInstOperands,
     /* 329731 */   // GIR_Coverage, 4745,
     /* 329731 */   GIR_EraseRootFromParent_Done,
     /* 329732 */ // Label 6492: @329732
     /* 329732 */ GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(329769), // Rule ID 4747 //
     /* 329737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329744 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329748 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 329752 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329756 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329758 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 329761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329763 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329767 */   GIR_RootConstrainSelectedInstOperands,
     /* 329768 */   // GIR_Coverage, 4747,
     /* 329768 */   GIR_EraseRootFromParent_Done,
     /* 329769 */ // Label 6493: @329769
     /* 329769 */ GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(329806), // Rule ID 4725 //
     /* 329774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 329789 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329793 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329795 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 329798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329800 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329804 */   GIR_RootConstrainSelectedInstOperands,
     /* 329805 */   // GIR_Coverage, 4725,
     /* 329805 */   GIR_EraseRootFromParent_Done,
     /* 329806 */ // Label 6494: @329806
     /* 329806 */ GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(329843), // Rule ID 4727 //
     /* 329811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329818 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329822 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 329826 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329830 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329832 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 329835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329837 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329841 */   GIR_RootConstrainSelectedInstOperands,
     /* 329842 */   // GIR_Coverage, 4727,
     /* 329842 */   GIR_EraseRootFromParent_Done,
     /* 329843 */ // Label 6495: @329843
     /* 329843 */ GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(329873), // Rule ID 395 //
     /* 329848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 329851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 329854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329862 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 329862 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 329867 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329871 */   GIR_RootConstrainSelectedInstOperands,
     /* 329872 */   // GIR_Coverage, 395,
     /* 329872 */   GIR_Done,
     /* 329873 */ // Label 6496: @329873
     /* 329873 */ GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(329903), // Rule ID 399 //
     /* 329878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329892 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 329892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 329897 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329901 */   GIR_RootConstrainSelectedInstOperands,
     /* 329902 */   // GIR_Coverage, 399,
     /* 329902 */   GIR_Done,
     /* 329903 */ // Label 6497: @329903
     /* 329903 */ GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(329933), // Rule ID 403 //
     /* 329908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329922 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 329922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 329927 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329931 */   GIR_RootConstrainSelectedInstOperands,
     /* 329932 */   // GIR_Coverage, 403,
     /* 329932 */   GIR_Done,
     /* 329933 */ // Label 6498: @329933
     /* 329933 */ GIM_Reject,
     /* 329934 */ // Label 6481: @329934
     /* 329934 */ GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(329971), // Rule ID 4686 //
     /* 329939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329946 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 329954 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329958 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329960 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 329960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 329963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329965 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329969 */   GIR_RootConstrainSelectedInstOperands,
     /* 329970 */   // GIR_Coverage, 4686,
     /* 329970 */   GIR_EraseRootFromParent_Done,
     /* 329971 */ // Label 6499: @329971
     /* 329971 */ GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(330008), // Rule ID 4688 //
     /* 329976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329983 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329987 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 329991 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329995 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329997 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 329997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 330000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330002 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330006 */   GIR_RootConstrainSelectedInstOperands,
     /* 330007 */   // GIR_Coverage, 4688,
     /* 330007 */   GIR_EraseRootFromParent_Done,
     /* 330008 */ // Label 6500: @330008
     /* 330008 */ GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(330045), // Rule ID 4706 //
     /* 330013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330020 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330024 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330028 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330032 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330034 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 330037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330039 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330043 */   GIR_RootConstrainSelectedInstOperands,
     /* 330044 */   // GIR_Coverage, 4706,
     /* 330044 */   GIR_EraseRootFromParent_Done,
     /* 330045 */ // Label 6501: @330045
     /* 330045 */ GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(330082), // Rule ID 4708 //
     /* 330050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330057 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330061 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330065 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330071 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 330074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330076 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330080 */   GIR_RootConstrainSelectedInstOperands,
     /* 330081 */   // GIR_Coverage, 4708,
     /* 330081 */   GIR_EraseRootFromParent_Done,
     /* 330082 */ // Label 6502: @330082
     /* 330082 */ GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(330119), // Rule ID 4746 //
     /* 330087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330094 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330098 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330102 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330106 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330108 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 330111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330113 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330117 */   GIR_RootConstrainSelectedInstOperands,
     /* 330118 */   // GIR_Coverage, 4746,
     /* 330118 */   GIR_EraseRootFromParent_Done,
     /* 330119 */ // Label 6503: @330119
     /* 330119 */ GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(330156), // Rule ID 4748 //
     /* 330124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330131 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330135 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330139 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330143 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330145 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 330148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330150 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330154 */   GIR_RootConstrainSelectedInstOperands,
     /* 330155 */   // GIR_Coverage, 4748,
     /* 330155 */   GIR_EraseRootFromParent_Done,
     /* 330156 */ // Label 6504: @330156
     /* 330156 */ GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(330193), // Rule ID 4726 //
     /* 330161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330168 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330172 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330176 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330180 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330182 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 330185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330187 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330191 */   GIR_RootConstrainSelectedInstOperands,
     /* 330192 */   // GIR_Coverage, 4726,
     /* 330192 */   GIR_EraseRootFromParent_Done,
     /* 330193 */ // Label 6505: @330193
     /* 330193 */ GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(330230), // Rule ID 4728 //
     /* 330198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330205 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330209 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330213 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330217 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330219 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 330222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330224 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330228 */   GIR_RootConstrainSelectedInstOperands,
     /* 330229 */   // GIR_Coverage, 4728,
     /* 330229 */   GIR_EraseRootFromParent_Done,
     /* 330230 */ // Label 6506: @330230
     /* 330230 */ GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(330260), // Rule ID 397 //
     /* 330235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 330238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330249 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 330249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 330254 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330258 */   GIR_RootConstrainSelectedInstOperands,
     /* 330259 */   // GIR_Coverage, 397,
     /* 330259 */   GIR_Done,
     /* 330260 */ // Label 6507: @330260
     /* 330260 */ GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(330290), // Rule ID 401 //
     /* 330265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330279 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 330279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 330284 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330288 */   GIR_RootConstrainSelectedInstOperands,
     /* 330289 */   // GIR_Coverage, 401,
     /* 330289 */   GIR_Done,
     /* 330290 */ // Label 6508: @330290
     /* 330290 */ GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(330320), // Rule ID 405 //
     /* 330295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330309 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 330309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 330314 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330318 */   GIR_RootConstrainSelectedInstOperands,
     /* 330319 */   // GIR_Coverage, 405,
     /* 330319 */   GIR_Done,
     /* 330320 */ // Label 6509: @330320
     /* 330320 */ GIM_Reject,
     /* 330321 */ // Label 6482: @330321
     /* 330321 */ GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(330351), // Rule ID 843 //
     /* 330326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330340 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 330340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 330345 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330349 */   GIR_RootConstrainSelectedInstOperands,
     /* 330350 */   // GIR_Coverage, 843,
     /* 330350 */   GIR_Done,
     /* 330351 */ // Label 6510: @330351
     /* 330351 */ GIM_Reject,
     /* 330352 */ // Label 6483: @330352
     /* 330352 */ GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(330382), // Rule ID 847 //
     /* 330357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330371 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 330371 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 330376 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330380 */   GIR_RootConstrainSelectedInstOperands,
     /* 330381 */   // GIR_Coverage, 847,
     /* 330381 */   GIR_Done,
     /* 330382 */ // Label 6511: @330382
     /* 330382 */ GIM_Reject,
     /* 330383 */ // Label 6484: @330383
     /* 330383 */ GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(330413), // Rule ID 839 //
     /* 330388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 330391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330402 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 330402 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 330407 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330411 */   GIR_RootConstrainSelectedInstOperands,
     /* 330412 */   // GIR_Coverage, 839,
     /* 330412 */   GIR_Done,
     /* 330413 */ // Label 6512: @330413
     /* 330413 */ GIM_Reject,
     /* 330414 */ // Label 6485: @330414
     /* 330414 */ GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(330444), // Rule ID 845 //
     /* 330419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330433 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 330433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 330438 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330442 */   GIR_RootConstrainSelectedInstOperands,
     /* 330443 */   // GIR_Coverage, 845,
     /* 330443 */   GIR_Done,
     /* 330444 */ // Label 6513: @330444
     /* 330444 */ GIM_Reject,
     /* 330445 */ // Label 6486: @330445
     /* 330445 */ GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(330475), // Rule ID 841 //
     /* 330450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 330453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330464 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 330464 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 330469 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330473 */   GIR_RootConstrainSelectedInstOperands,
     /* 330474 */   // GIR_Coverage, 841,
     /* 330474 */   GIR_Done,
     /* 330475 */ // Label 6514: @330475
     /* 330475 */ GIM_Reject,
     /* 330476 */ // Label 6487: @330476
     /* 330476 */ GIM_Reject,
     /* 330477 */ // Label 68: @330477
     /* 330477 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6522*/ GIMT_Encode4(331453),
     /* 330488 */ /*GILLT_s32*//*Label 6515*/ GIMT_Encode4(330524),
     /* 330492 */ /*GILLT_s64*//*Label 6516*/ GIMT_Encode4(330911), GIMT_Encode4(0),
     /* 330500 */ /*GILLT_v2s32*//*Label 6517*/ GIMT_Encode4(331298),
     /* 330504 */ /*GILLT_v2s64*//*Label 6518*/ GIMT_Encode4(331329),
     /* 330508 */ /*GILLT_v4s16*//*Label 6519*/ GIMT_Encode4(331360),
     /* 330512 */ /*GILLT_v4s32*//*Label 6520*/ GIMT_Encode4(331391), GIMT_Encode4(0),
     /* 330520 */ /*GILLT_v8s16*//*Label 6521*/ GIMT_Encode4(331422),
     /* 330524 */ // Label 6515: @330524
     /* 330524 */ GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(330561), // Rule ID 4695 //
     /* 330529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330536 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330540 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330544 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330548 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330550 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 330553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330555 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330559 */   GIR_RootConstrainSelectedInstOperands,
     /* 330560 */   // GIR_Coverage, 4695,
     /* 330560 */   GIR_EraseRootFromParent_Done,
     /* 330561 */ // Label 6523: @330561
     /* 330561 */ GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(330598), // Rule ID 4697 //
     /* 330566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330573 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330581 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330587 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 330590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330592 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330596 */   GIR_RootConstrainSelectedInstOperands,
     /* 330597 */   // GIR_Coverage, 4697,
     /* 330597 */   GIR_EraseRootFromParent_Done,
     /* 330598 */ // Label 6524: @330598
     /* 330598 */ GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(330635), // Rule ID 4715 //
     /* 330603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330618 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330622 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330624 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 330627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330629 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330633 */   GIR_RootConstrainSelectedInstOperands,
     /* 330634 */   // GIR_Coverage, 4715,
     /* 330634 */   GIR_EraseRootFromParent_Done,
     /* 330635 */ // Label 6525: @330635
     /* 330635 */ GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(330672), // Rule ID 4717 //
     /* 330640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330647 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330651 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330655 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330659 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330661 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 330664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330666 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330670 */   GIR_RootConstrainSelectedInstOperands,
     /* 330671 */   // GIR_Coverage, 4717,
     /* 330671 */   GIR_EraseRootFromParent_Done,
     /* 330672 */ // Label 6526: @330672
     /* 330672 */ GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(330709), // Rule ID 4755 //
     /* 330677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330684 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330688 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330692 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330696 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330698 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 330701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330703 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330707 */   GIR_RootConstrainSelectedInstOperands,
     /* 330708 */   // GIR_Coverage, 4755,
     /* 330708 */   GIR_EraseRootFromParent_Done,
     /* 330709 */ // Label 6527: @330709
     /* 330709 */ GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(330746), // Rule ID 4757 //
     /* 330714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330721 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330725 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330729 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330735 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 330738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330740 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330744 */   GIR_RootConstrainSelectedInstOperands,
     /* 330745 */   // GIR_Coverage, 4757,
     /* 330745 */   GIR_EraseRootFromParent_Done,
     /* 330746 */ // Label 6528: @330746
     /* 330746 */ GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(330783), // Rule ID 4735 //
     /* 330751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330758 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330762 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330766 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330770 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330772 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 330775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330777 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330781 */   GIR_RootConstrainSelectedInstOperands,
     /* 330782 */   // GIR_Coverage, 4735,
     /* 330782 */   GIR_EraseRootFromParent_Done,
     /* 330783 */ // Label 6529: @330783
     /* 330783 */ GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(330820), // Rule ID 4737 //
     /* 330788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330795 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330799 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330803 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330807 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330809 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 330812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330814 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330818 */   GIR_RootConstrainSelectedInstOperands,
     /* 330819 */   // GIR_Coverage, 4737,
     /* 330819 */   GIR_EraseRootFromParent_Done,
     /* 330820 */ // Label 6530: @330820
     /* 330820 */ GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(330850), // Rule ID 407 //
     /* 330825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 330828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330839 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 330839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 330844 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330848 */   GIR_RootConstrainSelectedInstOperands,
     /* 330849 */   // GIR_Coverage, 407,
     /* 330849 */   GIR_Done,
     /* 330850 */ // Label 6531: @330850
     /* 330850 */ GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(330880), // Rule ID 411 //
     /* 330855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330869 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 330869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 330874 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330878 */   GIR_RootConstrainSelectedInstOperands,
     /* 330879 */   // GIR_Coverage, 411,
     /* 330879 */   GIR_Done,
     /* 330880 */ // Label 6532: @330880
     /* 330880 */ GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(330910), // Rule ID 415 //
     /* 330885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330899 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 330899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 330904 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330908 */   GIR_RootConstrainSelectedInstOperands,
     /* 330909 */   // GIR_Coverage, 415,
     /* 330909 */   GIR_Done,
     /* 330910 */ // Label 6533: @330910
     /* 330910 */ GIM_Reject,
     /* 330911 */ // Label 6516: @330911
     /* 330911 */ GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(330948), // Rule ID 4696 //
     /* 330916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330923 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330927 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330931 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330935 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330937 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 330940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330942 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330946 */   GIR_RootConstrainSelectedInstOperands,
     /* 330947 */   // GIR_Coverage, 4696,
     /* 330947 */   GIR_EraseRootFromParent_Done,
     /* 330948 */ // Label 6534: @330948
     /* 330948 */ GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(330985), // Rule ID 4698 //
     /* 330953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330960 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330964 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330968 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330972 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330974 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 330977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330979 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330983 */   GIR_RootConstrainSelectedInstOperands,
     /* 330984 */   // GIR_Coverage, 4698,
     /* 330984 */   GIR_EraseRootFromParent_Done,
     /* 330985 */ // Label 6535: @330985
     /* 330985 */ GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(331022), // Rule ID 4716 //
     /* 330990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330997 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331001 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331005 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331009 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331011 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 331014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331016 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331020 */   GIR_RootConstrainSelectedInstOperands,
     /* 331021 */   // GIR_Coverage, 4716,
     /* 331021 */   GIR_EraseRootFromParent_Done,
     /* 331022 */ // Label 6536: @331022
     /* 331022 */ GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(331059), // Rule ID 4718 //
     /* 331027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331034 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331038 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331042 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331046 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331048 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 331051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331053 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331057 */   GIR_RootConstrainSelectedInstOperands,
     /* 331058 */   // GIR_Coverage, 4718,
     /* 331058 */   GIR_EraseRootFromParent_Done,
     /* 331059 */ // Label 6537: @331059
     /* 331059 */ GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(331096), // Rule ID 4756 //
     /* 331064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331071 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331079 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331085 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 331088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331090 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331094 */   GIR_RootConstrainSelectedInstOperands,
     /* 331095 */   // GIR_Coverage, 4756,
     /* 331095 */   GIR_EraseRootFromParent_Done,
     /* 331096 */ // Label 6538: @331096
     /* 331096 */ GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(331133), // Rule ID 4758 //
     /* 331101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331108 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331112 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331116 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331120 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331122 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 331125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331127 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331131 */   GIR_RootConstrainSelectedInstOperands,
     /* 331132 */   // GIR_Coverage, 4758,
     /* 331132 */   GIR_EraseRootFromParent_Done,
     /* 331133 */ // Label 6539: @331133
     /* 331133 */ GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(331170), // Rule ID 4736 //
     /* 331138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331145 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331149 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331153 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331157 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331159 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 331162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331164 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331168 */   GIR_RootConstrainSelectedInstOperands,
     /* 331169 */   // GIR_Coverage, 4736,
     /* 331169 */   GIR_EraseRootFromParent_Done,
     /* 331170 */ // Label 6540: @331170
     /* 331170 */ GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(331207), // Rule ID 4738 //
     /* 331175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331182 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331186 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331190 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331194 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331196 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 331199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331201 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331205 */   GIR_RootConstrainSelectedInstOperands,
     /* 331206 */   // GIR_Coverage, 4738,
     /* 331206 */   GIR_EraseRootFromParent_Done,
     /* 331207 */ // Label 6541: @331207
     /* 331207 */ GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(331237), // Rule ID 409 //
     /* 331212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 331218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331226 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 331226 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 331231 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331235 */   GIR_RootConstrainSelectedInstOperands,
     /* 331236 */   // GIR_Coverage, 409,
     /* 331236 */   GIR_Done,
     /* 331237 */ // Label 6542: @331237
     /* 331237 */ GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(331267), // Rule ID 413 //
     /* 331242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331256 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 331256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 331261 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331265 */   GIR_RootConstrainSelectedInstOperands,
     /* 331266 */   // GIR_Coverage, 413,
     /* 331266 */   GIR_Done,
     /* 331267 */ // Label 6543: @331267
     /* 331267 */ GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(331297), // Rule ID 417 //
     /* 331272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331286 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 331286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 331291 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331295 */   GIR_RootConstrainSelectedInstOperands,
     /* 331296 */   // GIR_Coverage, 417,
     /* 331296 */   GIR_Done,
     /* 331297 */ // Label 6544: @331297
     /* 331297 */ GIM_Reject,
     /* 331298 */ // Label 6517: @331298
     /* 331298 */ GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(331328), // Rule ID 853 //
     /* 331303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 331309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331317 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 331317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 331322 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331326 */   GIR_RootConstrainSelectedInstOperands,
     /* 331327 */   // GIR_Coverage, 853,
     /* 331327 */   GIR_Done,
     /* 331328 */ // Label 6545: @331328
     /* 331328 */ GIM_Reject,
     /* 331329 */ // Label 6518: @331329
     /* 331329 */ GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(331359), // Rule ID 857 //
     /* 331334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331348 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 331348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 331353 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331357 */   GIR_RootConstrainSelectedInstOperands,
     /* 331358 */   // GIR_Coverage, 857,
     /* 331358 */   GIR_Done,
     /* 331359 */ // Label 6546: @331359
     /* 331359 */ GIM_Reject,
     /* 331360 */ // Label 6519: @331360
     /* 331360 */ GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(331390), // Rule ID 849 //
     /* 331365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 331368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 331371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331379 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 331379 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 331384 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331388 */   GIR_RootConstrainSelectedInstOperands,
     /* 331389 */   // GIR_Coverage, 849,
     /* 331389 */   GIR_Done,
     /* 331390 */ // Label 6547: @331390
     /* 331390 */ GIM_Reject,
     /* 331391 */ // Label 6520: @331391
     /* 331391 */ GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(331421), // Rule ID 855 //
     /* 331396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 331402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331410 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 331410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 331415 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331419 */   GIR_RootConstrainSelectedInstOperands,
     /* 331420 */   // GIR_Coverage, 855,
     /* 331420 */   GIR_Done,
     /* 331421 */ // Label 6548: @331421
     /* 331421 */ GIM_Reject,
     /* 331422 */ // Label 6521: @331422
     /* 331422 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(331452), // Rule ID 851 //
     /* 331427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 331430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 331433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331441 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 331441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 331446 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331450 */   GIR_RootConstrainSelectedInstOperands,
     /* 331451 */   // GIR_Coverage, 851,
     /* 331451 */   GIR_Done,
     /* 331452 */ // Label 6549: @331452
     /* 331452 */ GIM_Reject,
     /* 331453 */ // Label 6522: @331453
     /* 331453 */ GIM_Reject,
     /* 331454 */ // Label 69: @331454
     /* 331454 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6558*/ GIMT_Encode4(336081),
     /* 331465 */ /*GILLT_s16*//*Label 6550*/ GIMT_Encode4(331505),
     /* 331469 */ /*GILLT_s32*//*Label 6551*/ GIMT_Encode4(331946),
     /* 331473 */ /*GILLT_s64*//*Label 6552*/ GIMT_Encode4(333942), GIMT_Encode4(0),
     /* 331481 */ /*GILLT_v2s32*//*Label 6553*/ GIMT_Encode4(335926),
     /* 331485 */ /*GILLT_v2s64*//*Label 6554*/ GIMT_Encode4(335957),
     /* 331489 */ /*GILLT_v4s16*//*Label 6555*/ GIMT_Encode4(335988),
     /* 331493 */ /*GILLT_v4s32*//*Label 6556*/ GIMT_Encode4(336019), GIMT_Encode4(0),
     /* 331501 */ /*GILLT_v8s16*//*Label 6557*/ GIMT_Encode4(336050),
     /* 331505 */ // Label 6550: @331505
     /* 331505 */ GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(331608), // Rule ID 5359 //
     /* 331510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 331513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331520 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331524 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 331528 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331532 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331536 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331540 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 331544 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 331548 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331553 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 331557 */   // MIs[1] Operand 2
     /* 331557 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 331568 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331570 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 331570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331582 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 331588 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331593 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 331601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331603 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331606 */   GIR_RootConstrainSelectedInstOperands,
     /* 331607 */   // GIR_Coverage, 5359,
     /* 331607 */   GIR_EraseRootFromParent_Done,
     /* 331608 */ // Label 6559: @331608
     /* 331608 */ GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(331688), // Rule ID 2444 //
     /* 331613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 331616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331623 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331627 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331631 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 331635 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331639 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331644 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 331648 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331650 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 331650 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331653 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331657 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331662 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 331668 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331673 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 331681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331683 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331686 */   GIR_RootConstrainSelectedInstOperands,
     /* 331687 */   // GIR_Coverage, 2444,
     /* 331687 */   GIR_EraseRootFromParent_Done,
     /* 331688 */ // Label 6560: @331688
     /* 331688 */ GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(331768), // Rule ID 2448 //
     /* 331693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 331696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331703 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331707 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331711 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331715 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331719 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331724 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 331728 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331730 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 331730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 331733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331742 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 331748 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331753 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 331761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331766 */   GIR_RootConstrainSelectedInstOperands,
     /* 331767 */   // GIR_Coverage, 2448,
     /* 331767 */   GIR_EraseRootFromParent_Done,
     /* 331768 */ // Label 6561: @331768
     /* 331768 */ GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(331825), // Rule ID 5350 //
     /* 331773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 331776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331783 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331787 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 331791 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331795 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331797 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 331797 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331800 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 331804 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331809 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 331818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331823 */   GIR_RootConstrainSelectedInstOperands,
     /* 331824 */   // GIR_Coverage, 5350,
     /* 331824 */   GIR_EraseRootFromParent_Done,
     /* 331825 */ // Label 6562: @331825
     /* 331825 */ GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(331855), // Rule ID 443 //
     /* 331830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331844 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 331844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 331849 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331853 */   GIR_RootConstrainSelectedInstOperands,
     /* 331854 */   // GIR_Coverage, 443,
     /* 331854 */   GIR_Done,
     /* 331855 */ // Label 6563: @331855
     /* 331855 */ GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(331885), // Rule ID 449 //
     /* 331860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331874 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 331874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 331879 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331883 */   GIR_RootConstrainSelectedInstOperands,
     /* 331884 */   // GIR_Coverage, 449,
     /* 331884 */   GIR_Done,
     /* 331885 */ // Label 6564: @331885
     /* 331885 */ GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(331915), // Rule ID 491 //
     /* 331890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 331893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331904 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 331904 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 331909 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331913 */   GIR_RootConstrainSelectedInstOperands,
     /* 331914 */   // GIR_Coverage, 491,
     /* 331914 */   GIR_Done,
     /* 331915 */ // Label 6565: @331915
     /* 331915 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(331945), // Rule ID 495 //
     /* 331920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 331923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331934 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 331934 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 331939 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331943 */   GIR_RootConstrainSelectedInstOperands,
     /* 331944 */   // GIR_Coverage, 495,
     /* 331944 */   GIR_Done,
     /* 331945 */ // Label 6566: @331945
     /* 331945 */ GIM_Reject,
     /* 331946 */ // Label 6551: @331946
     /* 331946 */ GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(332184), // Rule ID 6434 //
     /* 331951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 331954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331961 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331965 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 331969 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331972 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 331979 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 331983 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331985 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 331992 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 331992 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 331995 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 331999 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 332014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 332019 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 332026 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 332029 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332033 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 332040 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 332043 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332047 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332052 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 332055 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 332058 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 332061 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332066 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332071 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 332076 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 332079 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 332083 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332088 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 332091 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 332094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332096 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332099 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332103 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332108 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332115 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332120 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332125 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332128 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332132 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332137 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332140 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332145 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332148 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332152 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332157 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332164 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332169 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332182 */   GIR_RootConstrainSelectedInstOperands,
     /* 332183 */   // GIR_Coverage, 6434,
     /* 332183 */   GIR_EraseRootFromParent_Done,
     /* 332184 */ // Label 6567: @332184
     /* 332184 */ GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(332422), // Rule ID 6435 //
     /* 332189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332199 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332203 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332207 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332210 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 332217 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332221 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332223 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 332230 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332230 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 332233 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 332237 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332247 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 332252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 332257 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 332264 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 332267 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332271 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 332278 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 332281 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332285 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332290 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 332293 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 332296 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 332299 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332304 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332309 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 332314 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 332317 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 332321 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332326 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 332329 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 332332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332334 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332337 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332341 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332346 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332353 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332358 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332363 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332366 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332370 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332375 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332378 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332383 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332386 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332390 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332395 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332402 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332407 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332417 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332420 */   GIR_RootConstrainSelectedInstOperands,
     /* 332421 */   // GIR_Coverage, 6435,
     /* 332421 */   GIR_EraseRootFromParent_Done,
     /* 332422 */ // Label 6568: @332422
     /* 332422 */ GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(332611), // Rule ID 6438 //
     /* 332427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332437 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332441 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332445 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332448 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 332455 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332459 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332461 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 332468 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332468 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 332471 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 332475 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332480 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 332490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 332495 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 332502 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 332505 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332509 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332516 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332519 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332523 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332528 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 332531 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 332534 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 332537 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332542 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332547 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332552 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332555 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332559 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332564 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332567 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332572 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332575 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332579 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332584 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332591 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332596 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332606 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332609 */   GIR_RootConstrainSelectedInstOperands,
     /* 332610 */   // GIR_Coverage, 6438,
     /* 332610 */   GIR_EraseRootFromParent_Done,
     /* 332611 */ // Label 6569: @332611
     /* 332611 */ GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(332800), // Rule ID 6439 //
     /* 332616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332626 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332630 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332634 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332637 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 332644 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332648 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332650 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 332657 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332657 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 332660 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 332664 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 332679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 332684 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 332691 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 332694 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332698 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332705 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332708 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332712 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332717 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 332720 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 332723 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 332726 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332731 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332736 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332741 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332744 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332748 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332753 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332756 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332761 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332764 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332768 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332773 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332780 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332785 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332795 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332798 */   GIR_RootConstrainSelectedInstOperands,
     /* 332799 */   // GIR_Coverage, 6439,
     /* 332799 */   GIR_EraseRootFromParent_Done,
     /* 332800 */ // Label 6570: @332800
     /* 332800 */ GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(333033), // Rule ID 6436 //
     /* 332805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332815 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332823 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332826 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 332833 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332837 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332839 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 332846 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332846 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 332849 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 332853 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 332868 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 332875 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 332878 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332882 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 332889 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 332892 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332896 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332901 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 332904 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 332907 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 332910 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332915 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332920 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 332925 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 332928 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 332932 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332937 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 332940 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 332943 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332945 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332948 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332952 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332957 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332964 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332969 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332974 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332977 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332981 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332986 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332989 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333006 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333013 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333018 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333031 */   GIR_RootConstrainSelectedInstOperands,
     /* 333032 */   // GIR_Coverage, 6436,
     /* 333032 */   GIR_EraseRootFromParent_Done,
     /* 333033 */ // Label 6571: @333033
     /* 333033 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(333266), // Rule ID 6437 //
     /* 333038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333048 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333052 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333056 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333059 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 333066 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333070 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333072 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 333079 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333079 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 333082 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 333086 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 333101 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333108 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333111 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333115 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333122 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333125 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333129 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333134 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333137 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333140 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 333143 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333148 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333153 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 333158 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333161 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 333165 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333170 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333173 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 333176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333178 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333181 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333185 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333190 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333197 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333202 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333207 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333210 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333214 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333219 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333222 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333239 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333246 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333251 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333261 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333264 */   GIR_RootConstrainSelectedInstOperands,
     /* 333265 */   // GIR_Coverage, 6437,
     /* 333265 */   GIR_EraseRootFromParent_Done,
     /* 333266 */ // Label 6572: @333266
     /* 333266 */ GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(333450), // Rule ID 6440 //
     /* 333271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333281 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333285 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333289 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333292 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333299 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333303 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333305 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 333312 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333312 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 333315 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 333319 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 333334 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333341 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 333344 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333348 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333355 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333358 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333362 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333367 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 333370 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 333373 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 333376 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333381 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333386 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333391 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333394 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333398 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333403 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333406 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333423 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333430 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333435 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333445 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333448 */   GIR_RootConstrainSelectedInstOperands,
     /* 333449 */   // GIR_Coverage, 6440,
     /* 333449 */   GIR_EraseRootFromParent_Done,
     /* 333450 */ // Label 6573: @333450
     /* 333450 */ GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(333634), // Rule ID 6441 //
     /* 333455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333465 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333469 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333473 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333476 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333483 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333487 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333489 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 333496 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333496 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 333499 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 333503 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 333518 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333525 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 333528 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333532 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333539 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333542 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333546 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333551 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 333554 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 333557 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 333560 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333565 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333570 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333575 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333578 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333582 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333587 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333590 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333607 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333614 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333619 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333629 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333632 */   GIR_RootConstrainSelectedInstOperands,
     /* 333633 */   // GIR_Coverage, 6441,
     /* 333633 */   GIR_EraseRootFromParent_Done,
     /* 333634 */ // Label 6574: @333634
     /* 333634 */ GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(333714), // Rule ID 2450 //
     /* 333639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 333642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333649 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333653 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333657 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 333661 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333665 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333670 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 333674 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333676 */   // (sint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 333676 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 333679 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333683 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333688 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 333694 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333699 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 333707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333712 */   GIR_RootConstrainSelectedInstOperands,
     /* 333713 */   // GIR_Coverage, 2450,
     /* 333713 */   GIR_EraseRootFromParent_Done,
     /* 333714 */ // Label 6575: @333714
     /* 333714 */ GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(333794), // Rule ID 5355 //
     /* 333719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 333722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333729 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333733 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333737 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 333741 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333745 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333750 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 333754 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333756 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 333756 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333763 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333768 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 333774 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333779 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333792 */   GIR_RootConstrainSelectedInstOperands,
     /* 333793 */   // GIR_Coverage, 5355,
     /* 333793 */   GIR_EraseRootFromParent_Done,
     /* 333794 */ // Label 6576: @333794
     /* 333794 */ GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(333851), // Rule ID 5338 //
     /* 333799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 333802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333809 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333813 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 333817 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 333821 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333823 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 333823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 333830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333835 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333846 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333849 */   GIR_RootConstrainSelectedInstOperands,
     /* 333850 */   // GIR_Coverage, 5338,
     /* 333850 */   GIR_EraseRootFromParent_Done,
     /* 333851 */ // Label 6577: @333851
     /* 333851 */ GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(333881), // Rule ID 445 //
     /* 333856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 333859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 333870 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 333870 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 333875 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333879 */   GIR_RootConstrainSelectedInstOperands,
     /* 333880 */   // GIR_Coverage, 445,
     /* 333880 */   GIR_Done,
     /* 333881 */ // Label 6578: @333881
     /* 333881 */ GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(333911), // Rule ID 451 //
     /* 333886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 333889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 333900 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 333900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 333905 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333909 */   GIR_RootConstrainSelectedInstOperands,
     /* 333910 */   // GIR_Coverage, 451,
     /* 333910 */   GIR_Done,
     /* 333911 */ // Label 6579: @333911
     /* 333911 */ GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(333941), // Rule ID 497 //
     /* 333916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 333919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333930 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 333930 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 333935 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333939 */   GIR_RootConstrainSelectedInstOperands,
     /* 333940 */   // GIR_Coverage, 497,
     /* 333940 */   GIR_Done,
     /* 333941 */ // Label 6580: @333941
     /* 333941 */ GIM_Reject,
     /* 333942 */ // Label 6552: @333942
     /* 333942 */ GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(334128), // Rule ID 6446 //
     /* 333947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333957 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333961 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333965 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333968 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 333972 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333976 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333978 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 333985 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 333985 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 333988 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 333992 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 334012 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334019 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334022 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334026 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334033 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334036 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334040 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334045 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334048 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334051 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 334054 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334059 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334064 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334069 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334072 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334076 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334081 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334084 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334089 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334092 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334096 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334101 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334108 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334113 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334123 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334126 */   GIR_RootConstrainSelectedInstOperands,
     /* 334127 */   // GIR_Coverage, 6446,
     /* 334127 */   GIR_EraseRootFromParent_Done,
     /* 334128 */ // Label 6581: @334128
     /* 334128 */ GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(334314), // Rule ID 6447 //
     /* 334133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334143 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334151 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334154 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 334158 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334162 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334164 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334171 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334171 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 334174 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334178 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334188 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 334198 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334205 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334208 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334212 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334219 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334222 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334226 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334231 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334234 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334237 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 334240 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334245 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334250 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334255 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334258 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334262 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334267 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334270 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334275 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334278 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334282 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334287 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334294 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334299 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334312 */   GIR_RootConstrainSelectedInstOperands,
     /* 334313 */   // GIR_Coverage, 6447,
     /* 334313 */   GIR_EraseRootFromParent_Done,
     /* 334314 */ // Label 6582: @334314
     /* 334314 */ GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(334552), // Rule ID 6442 //
     /* 334319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334329 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334333 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334337 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334340 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334347 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334351 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334353 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 334360 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334360 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 334363 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 334367 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 334387 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 334394 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 334397 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334401 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 334408 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 334411 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334415 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334420 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 334423 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 334426 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 334429 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334434 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334439 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334444 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334447 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334451 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334456 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334459 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334464 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334467 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334471 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334476 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334483 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334488 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334493 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334496 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334500 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334505 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334508 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334525 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334532 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334537 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334547 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334550 */   GIR_RootConstrainSelectedInstOperands,
     /* 334551 */   // GIR_Coverage, 6442,
     /* 334551 */   GIR_EraseRootFromParent_Done,
     /* 334552 */ // Label 6583: @334552
     /* 334552 */ GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(334790), // Rule ID 6443 //
     /* 334557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334567 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334571 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334575 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334578 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334585 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334589 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334591 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 334598 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334598 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 334601 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 334605 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 334625 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 334632 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 334635 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334639 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 334646 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 334649 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334653 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334658 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 334661 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 334664 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 334667 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334672 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334677 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334682 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334685 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334689 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334694 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334697 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334702 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334705 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334709 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334714 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334721 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334726 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334731 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334734 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334738 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334743 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334746 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334763 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334770 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334775 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334788 */   GIR_RootConstrainSelectedInstOperands,
     /* 334789 */   // GIR_Coverage, 6443,
     /* 334789 */   GIR_EraseRootFromParent_Done,
     /* 334790 */ // Label 6584: @334790
     /* 334790 */ GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(334971), // Rule ID 6448 //
     /* 334795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334805 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334809 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334813 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334816 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 334820 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334824 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334826 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 334833 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334833 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 334836 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 334840 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334855 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334862 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334865 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334869 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334876 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334879 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334883 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334888 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334891 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334894 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 334897 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334902 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334907 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334912 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334915 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334919 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334924 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334927 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334932 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334935 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334939 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334944 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334951 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334956 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334966 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334969 */   GIR_RootConstrainSelectedInstOperands,
     /* 334970 */   // GIR_Coverage, 6448,
     /* 334970 */   GIR_EraseRootFromParent_Done,
     /* 334971 */ // Label 6585: @334971
     /* 334971 */ GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(335152), // Rule ID 6449 //
     /* 334976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334986 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334990 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334994 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334997 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335001 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335005 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335007 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335014 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335014 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 335017 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335021 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335036 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335043 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335046 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335050 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335057 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335060 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335064 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335069 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335072 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335075 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 335078 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335083 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335088 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335093 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335096 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335100 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335105 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335108 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335113 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335116 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335120 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335125 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335132 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335137 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335147 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335150 */   GIR_RootConstrainSelectedInstOperands,
     /* 335151 */   // GIR_Coverage, 6449,
     /* 335151 */   GIR_EraseRootFromParent_Done,
     /* 335152 */ // Label 6586: @335152
     /* 335152 */ GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(335385), // Rule ID 6444 //
     /* 335157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335167 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335171 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 335175 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335178 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335185 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335189 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335191 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 335198 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335198 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 335201 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 335205 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335220 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 335227 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 335230 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335234 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 335241 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 335244 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335248 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335253 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 335256 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 335259 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 335262 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335267 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335272 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335277 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 335280 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 335284 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335289 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 335292 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 335295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335297 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335300 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335304 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335309 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335316 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335321 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335326 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335329 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335333 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335338 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335341 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335358 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335370 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335383 */   GIR_RootConstrainSelectedInstOperands,
     /* 335384 */   // GIR_Coverage, 6444,
     /* 335384 */   GIR_EraseRootFromParent_Done,
     /* 335385 */ // Label 6587: @335385
     /* 335385 */ GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(335618), // Rule ID 6445 //
     /* 335390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335400 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335404 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 335408 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335411 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335418 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335422 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335424 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 335431 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335431 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 335434 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 335438 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335453 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 335460 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 335463 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335467 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 335474 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 335477 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335481 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335486 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 335489 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 335492 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 335495 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335500 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335505 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335510 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 335513 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 335517 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335522 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 335525 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 335528 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335530 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335533 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335537 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335542 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335549 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335554 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335559 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335562 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335566 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335571 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335574 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335579 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335582 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335586 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335591 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335598 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335616 */   GIR_RootConstrainSelectedInstOperands,
     /* 335617 */   // GIR_Coverage, 6445,
     /* 335617 */   GIR_EraseRootFromParent_Done,
     /* 335618 */ // Label 6588: @335618
     /* 335618 */ GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(335698), // Rule ID 2446 //
     /* 335623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335641 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335645 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335649 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335654 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 335658 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335660 */   // (sint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 335660 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335663 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335667 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335672 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 335678 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335683 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 335691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335696 */   GIR_RootConstrainSelectedInstOperands,
     /* 335697 */   // GIR_Coverage, 2446,
     /* 335697 */   GIR_EraseRootFromParent_Done,
     /* 335698 */ // Label 6589: @335698
     /* 335698 */ GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(335778), // Rule ID 5357 //
     /* 335703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 335706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335713 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335717 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335721 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335725 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335729 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335734 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 335738 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335740 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 335740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335752 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 335758 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335763 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335776 */   GIR_RootConstrainSelectedInstOperands,
     /* 335777 */   // GIR_Coverage, 5357,
     /* 335777 */   GIR_EraseRootFromParent_Done,
     /* 335778 */ // Label 6590: @335778
     /* 335778 */ GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(335835), // Rule ID 5334 //
     /* 335783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 335786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335793 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335797 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 335801 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 335805 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335807 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 335807 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335810 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 335814 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335819 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335833 */   GIR_RootConstrainSelectedInstOperands,
     /* 335834 */   // GIR_Coverage, 5334,
     /* 335834 */   GIR_EraseRootFromParent_Done,
     /* 335835 */ // Label 6591: @335835
     /* 335835 */ GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(335865), // Rule ID 447 //
     /* 335840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 335843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 335854 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 335854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 335859 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335863 */   GIR_RootConstrainSelectedInstOperands,
     /* 335864 */   // GIR_Coverage, 447,
     /* 335864 */   GIR_Done,
     /* 335865 */ // Label 6592: @335865
     /* 335865 */ GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(335895), // Rule ID 453 //
     /* 335870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 335873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 335884 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 335884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 335889 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335893 */   GIR_RootConstrainSelectedInstOperands,
     /* 335894 */   // GIR_Coverage, 453,
     /* 335894 */   GIR_Done,
     /* 335895 */ // Label 6593: @335895
     /* 335895 */ GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(335925), // Rule ID 493 //
     /* 335900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335914 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 335914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 335919 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335923 */   GIR_RootConstrainSelectedInstOperands,
     /* 335924 */   // GIR_Coverage, 493,
     /* 335924 */   GIR_Done,
     /* 335925 */ // Label 6594: @335925
     /* 335925 */ GIM_Reject,
     /* 335926 */ // Label 6553: @335926
     /* 335926 */ GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(335956), // Rule ID 1017 //
     /* 335931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 335937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335945 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 335945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 335950 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335954 */   GIR_RootConstrainSelectedInstOperands,
     /* 335955 */   // GIR_Coverage, 1017,
     /* 335955 */   GIR_Done,
     /* 335956 */ // Label 6595: @335956
     /* 335956 */ GIM_Reject,
     /* 335957 */ // Label 6554: @335957
     /* 335957 */ GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(335987), // Rule ID 1021 //
     /* 335962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335976 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 335976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 335981 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335985 */   GIR_RootConstrainSelectedInstOperands,
     /* 335986 */   // GIR_Coverage, 1021,
     /* 335986 */   GIR_Done,
     /* 335987 */ // Label 6596: @335987
     /* 335987 */ GIM_Reject,
     /* 335988 */ // Label 6555: @335988
     /* 335988 */ GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(336018), // Rule ID 1013 //
     /* 335993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 335996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 335999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336007 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 336007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 336012 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336016 */   GIR_RootConstrainSelectedInstOperands,
     /* 336017 */   // GIR_Coverage, 1013,
     /* 336017 */   GIR_Done,
     /* 336018 */ // Label 6597: @336018
     /* 336018 */ GIM_Reject,
     /* 336019 */ // Label 6556: @336019
     /* 336019 */ GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(336049), // Rule ID 1019 //
     /* 336024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 336030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336038 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 336038 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 336043 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336047 */   GIR_RootConstrainSelectedInstOperands,
     /* 336048 */   // GIR_Coverage, 1019,
     /* 336048 */   GIR_Done,
     /* 336049 */ // Label 6598: @336049
     /* 336049 */ GIM_Reject,
     /* 336050 */ // Label 6557: @336050
     /* 336050 */ GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(336080), // Rule ID 1015 //
     /* 336055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 336058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 336061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336069 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 336069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 336074 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336078 */   GIR_RootConstrainSelectedInstOperands,
     /* 336079 */   // GIR_Coverage, 1015,
     /* 336079 */   GIR_Done,
     /* 336080 */ // Label 6599: @336080
     /* 336080 */ GIM_Reject,
     /* 336081 */ // Label 6558: @336081
     /* 336081 */ GIM_Reject,
     /* 336082 */ // Label 70: @336082
     /* 336082 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6608*/ GIMT_Encode4(340087),
     /* 336093 */ /*GILLT_s16*//*Label 6600*/ GIMT_Encode4(336133),
     /* 336097 */ /*GILLT_s32*//*Label 6601*/ GIMT_Encode4(336578),
     /* 336101 */ /*GILLT_s64*//*Label 6602*/ GIMT_Encode4(337986), GIMT_Encode4(0),
     /* 336109 */ /*GILLT_v2s32*//*Label 6603*/ GIMT_Encode4(339932),
     /* 336113 */ /*GILLT_v2s64*//*Label 6604*/ GIMT_Encode4(339963),
     /* 336117 */ /*GILLT_v4s16*//*Label 6605*/ GIMT_Encode4(339994),
     /* 336121 */ /*GILLT_v4s32*//*Label 6606*/ GIMT_Encode4(340025), GIMT_Encode4(0),
     /* 336129 */ /*GILLT_v8s16*//*Label 6607*/ GIMT_Encode4(340056),
     /* 336133 */ // Label 6600: @336133
     /* 336133 */ GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(336240), // Rule ID 5360 //
     /* 336138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 336141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 336156 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 336160 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 336164 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 336168 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336172 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 336176 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 336180 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336185 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 336189 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 336200 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336202 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 336202 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 336205 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336209 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336214 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 336220 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336225 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 336233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336235 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336238 */   GIR_RootConstrainSelectedInstOperands,
     /* 336239 */   // GIR_Coverage, 5360,
     /* 336239 */   GIR_EraseRootFromParent_Done,
     /* 336240 */ // Label 6609: @336240
     /* 336240 */ GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(336320), // Rule ID 4784 //
     /* 336245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336255 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336259 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336263 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 336267 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336271 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336276 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 336280 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336282 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 336282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336294 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 336300 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336305 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 336313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336315 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336318 */   GIR_RootConstrainSelectedInstOperands,
     /* 336319 */   // GIR_Coverage, 4784,
     /* 336319 */   GIR_EraseRootFromParent_Done,
     /* 336320 */ // Label 6610: @336320
     /* 336320 */ GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(336400), // Rule ID 4788 //
     /* 336325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336335 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336339 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336343 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 336347 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336351 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336356 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 336360 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336362 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 336362 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336365 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336369 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336374 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 336380 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336385 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 336393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336395 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336398 */   GIR_RootConstrainSelectedInstOperands,
     /* 336399 */   // GIR_Coverage, 4788,
     /* 336399 */   GIR_EraseRootFromParent_Done,
     /* 336400 */ // Label 6611: @336400
     /* 336400 */ GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(336457), // Rule ID 5354 //
     /* 336405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 336408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336415 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336419 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 336423 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336427 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336429 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 336429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 336432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 336436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336441 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 336450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336455 */   GIR_RootConstrainSelectedInstOperands,
     /* 336456 */   // GIR_Coverage, 5354,
     /* 336456 */   GIR_EraseRootFromParent_Done,
     /* 336457 */ // Label 6612: @336457
     /* 336457 */ GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(336487), // Rule ID 467 //
     /* 336462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 336465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 336476 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 336476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 336481 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336485 */   GIR_RootConstrainSelectedInstOperands,
     /* 336486 */   // GIR_Coverage, 467,
     /* 336486 */   GIR_Done,
     /* 336487 */ // Label 6613: @336487
     /* 336487 */ GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(336517), // Rule ID 473 //
     /* 336492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 336495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 336506 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 336506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 336511 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336515 */   GIR_RootConstrainSelectedInstOperands,
     /* 336516 */   // GIR_Coverage, 473,
     /* 336516 */   GIR_Done,
     /* 336517 */ // Label 6614: @336517
     /* 336517 */ GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(336547), // Rule ID 499 //
     /* 336522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336536 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 336536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 336541 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336545 */   GIR_RootConstrainSelectedInstOperands,
     /* 336546 */   // GIR_Coverage, 499,
     /* 336546 */   GIR_Done,
     /* 336547 */ // Label 6615: @336547
     /* 336547 */ GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(336577), // Rule ID 503 //
     /* 336552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336566 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 336566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 336571 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336575 */   GIR_RootConstrainSelectedInstOperands,
     /* 336576 */   // GIR_Coverage, 503,
     /* 336576 */   GIR_Done,
     /* 336577 */ // Label 6616: @336577
     /* 336577 */ GIM_Reject,
     /* 336578 */ // Label 6601: @336578
     /* 336578 */ GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(336718), // Rule ID 5361 //
     /* 336583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336601 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336604 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336611 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336615 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336617 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 336624 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 336624 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 336627 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 336631 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336651 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336658 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336661 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336665 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336684 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336687 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336690 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 336693 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336698 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336703 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336713 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336716 */   GIR_RootConstrainSelectedInstOperands,
     /* 336717 */   // GIR_Coverage, 5361,
     /* 336717 */   GIR_EraseRootFromParent_Done,
     /* 336718 */ // Label 6617: @336718
     /* 336718 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(336858), // Rule ID 5362 //
     /* 336723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336733 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336737 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336741 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336744 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336751 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336755 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336757 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 336764 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 336764 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 336767 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 336771 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336791 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336798 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336801 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336805 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336812 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336815 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336819 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336824 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336827 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336830 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 336833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336838 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336843 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336856 */   GIR_RootConstrainSelectedInstOperands,
     /* 336857 */   // GIR_Coverage, 5362,
     /* 336857 */   GIR_EraseRootFromParent_Done,
     /* 336858 */ // Label 6618: @336858
     /* 336858 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(336998), // Rule ID 5365 //
     /* 336863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336873 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336877 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336881 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336884 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336891 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336897 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 336904 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 336904 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 336907 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 336911 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336931 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336936 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336938 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336941 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336945 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336964 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336967 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336970 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 336973 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336978 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336983 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336996 */   GIR_RootConstrainSelectedInstOperands,
     /* 336997 */   // GIR_Coverage, 5365,
     /* 336997 */   GIR_EraseRootFromParent_Done,
     /* 336998 */ // Label 6619: @336998
     /* 336998 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(337138), // Rule ID 5366 //
     /* 337003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337013 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337017 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337021 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337024 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337031 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337035 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337037 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 337044 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 337044 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 337047 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 337051 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337071 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337078 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337081 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337085 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337092 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337099 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337104 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337107 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337110 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 337113 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337118 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337123 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337133 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337136 */   GIR_RootConstrainSelectedInstOperands,
     /* 337137 */   // GIR_Coverage, 5366,
     /* 337137 */   GIR_EraseRootFromParent_Done,
     /* 337138 */ // Label 6620: @337138
     /* 337138 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(337273), // Rule ID 5363 //
     /* 337143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337153 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337157 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337161 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337164 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337171 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337177 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 337184 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 337184 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 337187 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 337191 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337206 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337213 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337216 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337220 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337239 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337242 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337245 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 337248 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337253 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337258 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337268 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337271 */   GIR_RootConstrainSelectedInstOperands,
     /* 337272 */   // GIR_Coverage, 5363,
     /* 337272 */   GIR_EraseRootFromParent_Done,
     /* 337273 */ // Label 6621: @337273
     /* 337273 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(337408), // Rule ID 5364 //
     /* 337278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337288 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337292 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337296 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337299 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337306 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337310 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337312 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 337319 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 337319 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 337322 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 337326 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337331 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337341 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337348 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337351 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337355 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337362 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337365 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337369 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337374 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337377 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337380 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 337383 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337388 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337393 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337406 */   GIR_RootConstrainSelectedInstOperands,
     /* 337407 */   // GIR_Coverage, 5364,
     /* 337407 */   GIR_EraseRootFromParent_Done,
     /* 337408 */ // Label 6622: @337408
     /* 337408 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(337543), // Rule ID 5367 //
     /* 337413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337423 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337427 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337431 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337434 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337441 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337445 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337447 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 337454 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 337454 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 337457 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 337461 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337476 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337483 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337486 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337490 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337509 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337512 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337515 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 337518 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337523 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337528 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337541 */   GIR_RootConstrainSelectedInstOperands,
     /* 337542 */   // GIR_Coverage, 5367,
     /* 337542 */   GIR_EraseRootFromParent_Done,
     /* 337543 */ // Label 6623: @337543
     /* 337543 */ GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(337678), // Rule ID 5368 //
     /* 337548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337558 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337562 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337566 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337569 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337576 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337580 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337582 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 337589 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 337589 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 337592 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 337596 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337611 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337618 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337621 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337625 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337644 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337647 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337650 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 337653 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337658 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337663 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337673 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337676 */   GIR_RootConstrainSelectedInstOperands,
     /* 337677 */   // GIR_Coverage, 5368,
     /* 337677 */   GIR_EraseRootFromParent_Done,
     /* 337678 */ // Label 6624: @337678
     /* 337678 */ GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(337758), // Rule ID 4790 //
     /* 337683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337693 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337697 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337701 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337705 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337709 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337714 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337718 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337720 */   // (uint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 337720 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337723 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337727 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337732 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 337738 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337743 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 337751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337756 */   GIR_RootConstrainSelectedInstOperands,
     /* 337757 */   // GIR_Coverage, 4790,
     /* 337757 */   GIR_EraseRootFromParent_Done,
     /* 337758 */ // Label 6625: @337758
     /* 337758 */ GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(337838), // Rule ID 5356 //
     /* 337763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337773 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337777 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337781 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337785 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337789 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337794 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337798 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337800 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 337800 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337803 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337807 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337812 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 337818 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337823 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337833 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337836 */   GIR_RootConstrainSelectedInstOperands,
     /* 337837 */   // GIR_Coverage, 5356,
     /* 337837 */   GIR_EraseRootFromParent_Done,
     /* 337838 */ // Label 6626: @337838
     /* 337838 */ GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(337895), // Rule ID 5346 //
     /* 337843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337853 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337857 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 337861 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 337865 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337867 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 337867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 337874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337879 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337883 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337890 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337893 */   GIR_RootConstrainSelectedInstOperands,
     /* 337894 */   // GIR_Coverage, 5346,
     /* 337894 */   GIR_EraseRootFromParent_Done,
     /* 337895 */ // Label 6627: @337895
     /* 337895 */ GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(337925), // Rule ID 469 //
     /* 337900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 337903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337914 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 337914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 337919 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337923 */   GIR_RootConstrainSelectedInstOperands,
     /* 337924 */   // GIR_Coverage, 469,
     /* 337924 */   GIR_Done,
     /* 337925 */ // Label 6628: @337925
     /* 337925 */ GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(337955), // Rule ID 475 //
     /* 337930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 337933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 337944 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 337944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 337949 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337953 */   GIR_RootConstrainSelectedInstOperands,
     /* 337954 */   // GIR_Coverage, 475,
     /* 337954 */   GIR_Done,
     /* 337955 */ // Label 6629: @337955
     /* 337955 */ GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(337985), // Rule ID 505 //
     /* 337960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337974 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 337974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 337979 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337983 */   GIR_RootConstrainSelectedInstOperands,
     /* 337984 */   // GIR_Coverage, 505,
     /* 337984 */   GIR_Done,
     /* 337985 */ // Label 6630: @337985
     /* 337985 */ GIM_Reject,
     /* 337986 */ // Label 6602: @337986
     /* 337986 */ GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(338123), // Rule ID 5377 //
     /* 337991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338001 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338005 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338009 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338012 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338016 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338020 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338022 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 338029 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 338029 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 338032 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 338036 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338056 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338063 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338066 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338070 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338089 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338092 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338095 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 338098 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338103 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338108 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338121 */   GIR_RootConstrainSelectedInstOperands,
     /* 338122 */   // GIR_Coverage, 5377,
     /* 338122 */   GIR_EraseRootFromParent_Done,
     /* 338123 */ // Label 6631: @338123
     /* 338123 */ GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(338260), // Rule ID 5378 //
     /* 338128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338138 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338142 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338146 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338149 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338153 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338157 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338159 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 338166 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 338166 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 338169 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 338173 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338188 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338193 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338198 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338200 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338203 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338207 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338226 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338229 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338232 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 338235 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338240 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338245 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338255 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338258 */   GIR_RootConstrainSelectedInstOperands,
     /* 338259 */   // GIR_Coverage, 5378,
     /* 338259 */   GIR_EraseRootFromParent_Done,
     /* 338260 */ // Label 6632: @338260
     /* 338260 */ GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(338400), // Rule ID 5369 //
     /* 338265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338275 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338279 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338283 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338286 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338293 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338297 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338299 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 338306 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 338306 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338309 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 338313 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338333 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338340 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338343 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338347 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338354 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338357 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338361 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338366 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338369 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338372 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338375 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338380 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338385 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338395 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338398 */   GIR_RootConstrainSelectedInstOperands,
     /* 338399 */   // GIR_Coverage, 5369,
     /* 338399 */   GIR_EraseRootFromParent_Done,
     /* 338400 */ // Label 6633: @338400
     /* 338400 */ GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(338540), // Rule ID 5370 //
     /* 338405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338415 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338419 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338423 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338426 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338433 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338437 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338439 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 338446 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 338446 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338449 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 338453 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338473 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338480 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338483 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338487 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338506 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338509 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338512 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338520 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338525 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338538 */   GIR_RootConstrainSelectedInstOperands,
     /* 338539 */   // GIR_Coverage, 5370,
     /* 338539 */   GIR_EraseRootFromParent_Done,
     /* 338540 */ // Label 6634: @338540
     /* 338540 */ GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(338680), // Rule ID 5373 //
     /* 338545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338555 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338559 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338563 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338566 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338573 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338577 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338579 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 338586 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 338586 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338589 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 338593 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338613 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338620 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338623 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338627 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338637 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338641 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338646 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338649 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338652 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338655 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338660 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338665 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338675 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338678 */   GIR_RootConstrainSelectedInstOperands,
     /* 338679 */   // GIR_Coverage, 5373,
     /* 338679 */   GIR_EraseRootFromParent_Done,
     /* 338680 */ // Label 6635: @338680
     /* 338680 */ GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(338820), // Rule ID 5374 //
     /* 338685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338695 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338699 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338703 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338706 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338713 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338717 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338719 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338726 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 338726 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338729 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338733 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338748 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338753 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338760 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338763 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338767 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338786 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338789 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338792 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338795 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338800 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338805 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338815 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338818 */   GIR_RootConstrainSelectedInstOperands,
     /* 338819 */   // GIR_Coverage, 5374,
     /* 338819 */   GIR_EraseRootFromParent_Done,
     /* 338820 */ // Label 6636: @338820
     /* 338820 */ GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(338952), // Rule ID 5379 //
     /* 338825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338835 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338839 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338843 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338846 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338850 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338854 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338856 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 338863 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 338863 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 338866 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 338870 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338885 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338892 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338895 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338899 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338904 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338906 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338909 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338913 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338918 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338921 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338924 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 338927 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338932 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338937 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338950 */   GIR_RootConstrainSelectedInstOperands,
     /* 338951 */   // GIR_Coverage, 5379,
     /* 338951 */   GIR_EraseRootFromParent_Done,
     /* 338952 */ // Label 6637: @338952
     /* 338952 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(339084), // Rule ID 5380 //
     /* 338957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338967 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338971 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338975 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338978 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338982 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338986 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338988 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 338995 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 338995 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 338998 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 339002 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339017 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339024 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339027 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339031 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339038 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339041 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339045 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339050 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339053 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339056 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 339059 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339064 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339069 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339082 */   GIR_RootConstrainSelectedInstOperands,
     /* 339083 */   // GIR_Coverage, 5380,
     /* 339083 */   GIR_EraseRootFromParent_Done,
     /* 339084 */ // Label 6638: @339084
     /* 339084 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(339219), // Rule ID 5371 //
     /* 339089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339099 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339103 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339107 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339110 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339117 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339121 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339123 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 339130 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 339130 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 339133 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 339137 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339152 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339159 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339162 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339166 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339173 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339176 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339180 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339185 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339188 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339191 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 339194 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339199 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339204 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339217 */   GIR_RootConstrainSelectedInstOperands,
     /* 339218 */   // GIR_Coverage, 5371,
     /* 339218 */   GIR_EraseRootFromParent_Done,
     /* 339219 */ // Label 6639: @339219
     /* 339219 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(339354), // Rule ID 5372 //
     /* 339224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339234 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339242 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339245 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339252 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339256 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339258 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 339265 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 339265 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 339268 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 339272 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339287 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339294 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339297 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339301 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339308 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339311 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339315 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339320 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339323 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339326 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 339329 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339334 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339339 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339349 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339352 */   GIR_RootConstrainSelectedInstOperands,
     /* 339353 */   // GIR_Coverage, 5372,
     /* 339353 */   GIR_EraseRootFromParent_Done,
     /* 339354 */ // Label 6640: @339354
     /* 339354 */ GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(339489), // Rule ID 5375 //
     /* 339359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339369 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339373 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339377 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339380 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339387 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339393 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 339400 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 339400 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 339403 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 339407 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339422 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339429 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339432 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339436 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339455 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339458 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339461 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 339464 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339469 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339474 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339487 */   GIR_RootConstrainSelectedInstOperands,
     /* 339488 */   // GIR_Coverage, 5375,
     /* 339488 */   GIR_EraseRootFromParent_Done,
     /* 339489 */ // Label 6641: @339489
     /* 339489 */ GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(339624), // Rule ID 5376 //
     /* 339494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339504 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339508 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339512 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339515 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339522 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339526 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339528 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 339535 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 339535 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 339538 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 339542 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339557 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339564 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339567 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339571 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339578 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339581 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339585 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339590 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339593 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339596 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 339599 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339604 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339609 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339622 */   GIR_RootConstrainSelectedInstOperands,
     /* 339623 */   // GIR_Coverage, 5376,
     /* 339623 */   GIR_EraseRootFromParent_Done,
     /* 339624 */ // Label 6642: @339624
     /* 339624 */ GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(339704), // Rule ID 4786 //
     /* 339629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 339632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339639 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339643 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339647 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 339651 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339655 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339660 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 339664 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339666 */   // (uint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 339666 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339669 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339673 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339678 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 339684 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339689 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 339697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339702 */   GIR_RootConstrainSelectedInstOperands,
     /* 339703 */   // GIR_Coverage, 4786,
     /* 339703 */   GIR_EraseRootFromParent_Done,
     /* 339704 */ // Label 6643: @339704
     /* 339704 */ GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(339784), // Rule ID 5358 //
     /* 339709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339719 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339723 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339727 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339731 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339735 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339740 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 339744 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339746 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 339746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339758 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 339764 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339769 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339779 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339782 */   GIR_RootConstrainSelectedInstOperands,
     /* 339783 */   // GIR_Coverage, 5358,
     /* 339783 */   GIR_EraseRootFromParent_Done,
     /* 339784 */ // Label 6644: @339784
     /* 339784 */ GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(339841), // Rule ID 5342 //
     /* 339789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339799 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339803 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 339807 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 339811 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339813 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 339813 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339816 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 339820 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339825 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339839 */   GIR_RootConstrainSelectedInstOperands,
     /* 339840 */   // GIR_Coverage, 5342,
     /* 339840 */   GIR_EraseRootFromParent_Done,
     /* 339841 */ // Label 6645: @339841
     /* 339841 */ GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(339871), // Rule ID 471 //
     /* 339846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 339849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339860 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 339860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 339865 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339869 */   GIR_RootConstrainSelectedInstOperands,
     /* 339870 */   // GIR_Coverage, 471,
     /* 339870 */   GIR_Done,
     /* 339871 */ // Label 6646: @339871
     /* 339871 */ GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(339901), // Rule ID 477 //
     /* 339876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 339879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339890 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 339890 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 339895 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339899 */   GIR_RootConstrainSelectedInstOperands,
     /* 339900 */   // GIR_Coverage, 477,
     /* 339900 */   GIR_Done,
     /* 339901 */ // Label 6647: @339901
     /* 339901 */ GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(339931), // Rule ID 501 //
     /* 339906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 339909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339920 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 339920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 339925 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339929 */   GIR_RootConstrainSelectedInstOperands,
     /* 339930 */   // GIR_Coverage, 501,
     /* 339930 */   GIR_Done,
     /* 339931 */ // Label 6648: @339931
     /* 339931 */ GIM_Reject,
     /* 339932 */ // Label 6603: @339932
     /* 339932 */ GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(339962), // Rule ID 1078 //
     /* 339937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 339943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339951 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 339951 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 339956 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339960 */   GIR_RootConstrainSelectedInstOperands,
     /* 339961 */   // GIR_Coverage, 1078,
     /* 339961 */   GIR_Done,
     /* 339962 */ // Label 6649: @339962
     /* 339962 */ GIM_Reject,
     /* 339963 */ // Label 6604: @339963
     /* 339963 */ GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(339993), // Rule ID 1082 //
     /* 339968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339982 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 339982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 339987 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339991 */   GIR_RootConstrainSelectedInstOperands,
     /* 339992 */   // GIR_Coverage, 1082,
     /* 339992 */   GIR_Done,
     /* 339993 */ // Label 6650: @339993
     /* 339993 */ GIM_Reject,
     /* 339994 */ // Label 6605: @339994
     /* 339994 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(340024), // Rule ID 1074 //
     /* 339999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340013 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 340013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 340018 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340022 */   GIR_RootConstrainSelectedInstOperands,
     /* 340023 */   // GIR_Coverage, 1074,
     /* 340023 */   GIR_Done,
     /* 340024 */ // Label 6651: @340024
     /* 340024 */ GIM_Reject,
     /* 340025 */ // Label 6606: @340025
     /* 340025 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(340055), // Rule ID 1080 //
     /* 340030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 340036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340044 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 340044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 340049 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340053 */   GIR_RootConstrainSelectedInstOperands,
     /* 340054 */   // GIR_Coverage, 1080,
     /* 340054 */   GIR_Done,
     /* 340055 */ // Label 6652: @340055
     /* 340055 */ GIM_Reject,
     /* 340056 */ // Label 6607: @340056
     /* 340056 */ GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(340086), // Rule ID 1076 //
     /* 340061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340075 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 340075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 340080 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340084 */   GIR_RootConstrainSelectedInstOperands,
     /* 340085 */   // GIR_Coverage, 1076,
     /* 340085 */   GIR_Done,
     /* 340086 */ // Label 6653: @340086
     /* 340086 */ GIM_Reject,
     /* 340087 */ // Label 6608: @340087
     /* 340087 */ GIM_Reject,
     /* 340088 */ // Label 71: @340088
     /* 340088 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6661*/ GIMT_Encode4(340407),
     /* 340099 */ /*GILLT_s32*//*Label 6654*/ GIMT_Encode4(340135),
     /* 340103 */ /*GILLT_s64*//*Label 6655*/ GIMT_Encode4(340208), GIMT_Encode4(0),
     /* 340111 */ /*GILLT_v2s32*//*Label 6656*/ GIMT_Encode4(340281),
     /* 340115 */ /*GILLT_v2s64*//*Label 6657*/ GIMT_Encode4(340305),
     /* 340119 */ /*GILLT_v4s16*//*Label 6658*/ GIMT_Encode4(340329),
     /* 340123 */ /*GILLT_v4s32*//*Label 6659*/ GIMT_Encode4(340356), GIMT_Encode4(0),
     /* 340131 */ /*GILLT_v8s16*//*Label 6660*/ GIMT_Encode4(340380),
     /* 340135 */ // Label 6654: @340135
     /* 340135 */ GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(340161), // Rule ID 4619 //
     /* 340140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 340146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340150 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 340150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 340155 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340159 */   GIR_RootConstrainSelectedInstOperands,
     /* 340160 */   // GIR_Coverage, 4619,
     /* 340160 */   GIR_Done,
     /* 340161 */ // Label 6662: @340161
     /* 340161 */ GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(340184), // Rule ID 4621 //
     /* 340166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340173 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 340173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 340178 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340182 */   GIR_RootConstrainSelectedInstOperands,
     /* 340183 */   // GIR_Coverage, 4621,
     /* 340183 */   GIR_Done,
     /* 340184 */ // Label 6663: @340184
     /* 340184 */ GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(340207), // Rule ID 4623 //
     /* 340189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340196 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 340196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 340201 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340205 */   GIR_RootConstrainSelectedInstOperands,
     /* 340206 */   // GIR_Coverage, 4623,
     /* 340206 */   GIR_Done,
     /* 340207 */ // Label 6664: @340207
     /* 340207 */ GIM_Reject,
     /* 340208 */ // Label 6655: @340208
     /* 340208 */ GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(340234), // Rule ID 4620 //
     /* 340213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 340219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340223 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 340223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 340228 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340232 */   GIR_RootConstrainSelectedInstOperands,
     /* 340233 */   // GIR_Coverage, 4620,
     /* 340233 */   GIR_Done,
     /* 340234 */ // Label 6665: @340234
     /* 340234 */ GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(340257), // Rule ID 4622 //
     /* 340239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340246 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 340246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 340251 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340255 */   GIR_RootConstrainSelectedInstOperands,
     /* 340256 */   // GIR_Coverage, 4622,
     /* 340256 */   GIR_Done,
     /* 340257 */ // Label 6666: @340257
     /* 340257 */ GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(340280), // Rule ID 4624 //
     /* 340262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340269 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 340269 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 340274 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340278 */   GIR_RootConstrainSelectedInstOperands,
     /* 340279 */   // GIR_Coverage, 4624,
     /* 340279 */   GIR_Done,
     /* 340280 */ // Label 6667: @340280
     /* 340280 */ GIM_Reject,
     /* 340281 */ // Label 6656: @340281
     /* 340281 */ GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(340304), // Rule ID 4960 //
     /* 340286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 340289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340293 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 340293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 340298 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340302 */   GIR_RootConstrainSelectedInstOperands,
     /* 340303 */   // GIR_Coverage, 4960,
     /* 340303 */   GIR_Done,
     /* 340304 */ // Label 6668: @340304
     /* 340304 */ GIM_Reject,
     /* 340305 */ // Label 6657: @340305
     /* 340305 */ GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(340328), // Rule ID 4962 //
     /* 340310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340317 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 340317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 340322 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340326 */   GIR_RootConstrainSelectedInstOperands,
     /* 340327 */   // GIR_Coverage, 4962,
     /* 340327 */   GIR_Done,
     /* 340328 */ // Label 6669: @340328
     /* 340328 */ GIM_Reject,
     /* 340329 */ // Label 6658: @340329
     /* 340329 */ GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(340355), // Rule ID 4955 //
     /* 340334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340344 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 340344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 340349 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340353 */   GIR_RootConstrainSelectedInstOperands,
     /* 340354 */   // GIR_Coverage, 4955,
     /* 340354 */   GIR_Done,
     /* 340355 */ // Label 6670: @340355
     /* 340355 */ GIM_Reject,
     /* 340356 */ // Label 6659: @340356
     /* 340356 */ GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(340379), // Rule ID 4961 //
     /* 340361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 340364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340368 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 340368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 340373 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340377 */   GIR_RootConstrainSelectedInstOperands,
     /* 340378 */   // GIR_Coverage, 4961,
     /* 340378 */   GIR_Done,
     /* 340379 */ // Label 6671: @340379
     /* 340379 */ GIM_Reject,
     /* 340380 */ // Label 6660: @340380
     /* 340380 */ GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(340406), // Rule ID 4956 //
     /* 340385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340395 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 340395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 340400 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340404 */   GIR_RootConstrainSelectedInstOperands,
     /* 340405 */   // GIR_Coverage, 4956,
     /* 340405 */   GIR_Done,
     /* 340406 */ // Label 6672: @340406
     /* 340406 */ GIM_Reject,
     /* 340407 */ // Label 6661: @340407
     /* 340407 */ GIM_Reject,
     /* 340408 */ // Label 72: @340408
     /* 340408 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6680*/ GIMT_Encode4(340727),
     /* 340419 */ /*GILLT_s32*//*Label 6673*/ GIMT_Encode4(340455),
     /* 340423 */ /*GILLT_s64*//*Label 6674*/ GIMT_Encode4(340528), GIMT_Encode4(0),
     /* 340431 */ /*GILLT_v2s32*//*Label 6675*/ GIMT_Encode4(340601),
     /* 340435 */ /*GILLT_v2s64*//*Label 6676*/ GIMT_Encode4(340625),
     /* 340439 */ /*GILLT_v4s16*//*Label 6677*/ GIMT_Encode4(340649),
     /* 340443 */ /*GILLT_v4s32*//*Label 6678*/ GIMT_Encode4(340676), GIMT_Encode4(0),
     /* 340451 */ /*GILLT_v8s16*//*Label 6679*/ GIMT_Encode4(340700),
     /* 340455 */ // Label 6673: @340455
     /* 340455 */ GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(340481), // Rule ID 4643 //
     /* 340460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 340466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340470 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 340470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 340475 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340479 */   GIR_RootConstrainSelectedInstOperands,
     /* 340480 */   // GIR_Coverage, 4643,
     /* 340480 */   GIR_Done,
     /* 340481 */ // Label 6681: @340481
     /* 340481 */ GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(340504), // Rule ID 4645 //
     /* 340486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340493 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 340493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 340498 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340502 */   GIR_RootConstrainSelectedInstOperands,
     /* 340503 */   // GIR_Coverage, 4645,
     /* 340503 */   GIR_Done,
     /* 340504 */ // Label 6682: @340504
     /* 340504 */ GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(340527), // Rule ID 4647 //
     /* 340509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340516 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 340516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 340521 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340525 */   GIR_RootConstrainSelectedInstOperands,
     /* 340526 */   // GIR_Coverage, 4647,
     /* 340526 */   GIR_Done,
     /* 340527 */ // Label 6683: @340527
     /* 340527 */ GIM_Reject,
     /* 340528 */ // Label 6674: @340528
     /* 340528 */ GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(340554), // Rule ID 4644 //
     /* 340533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 340539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340543 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 340543 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 340548 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340552 */   GIR_RootConstrainSelectedInstOperands,
     /* 340553 */   // GIR_Coverage, 4644,
     /* 340553 */   GIR_Done,
     /* 340554 */ // Label 6684: @340554
     /* 340554 */ GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(340577), // Rule ID 4646 //
     /* 340559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340566 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 340566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 340571 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340575 */   GIR_RootConstrainSelectedInstOperands,
     /* 340576 */   // GIR_Coverage, 4646,
     /* 340576 */   GIR_Done,
     /* 340577 */ // Label 6685: @340577
     /* 340577 */ GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(340600), // Rule ID 4648 //
     /* 340582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340589 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 340589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 340594 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340598 */   GIR_RootConstrainSelectedInstOperands,
     /* 340599 */   // GIR_Coverage, 4648,
     /* 340599 */   GIR_Done,
     /* 340600 */ // Label 6686: @340600
     /* 340600 */ GIM_Reject,
     /* 340601 */ // Label 6675: @340601
     /* 340601 */ GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(340624), // Rule ID 4970 //
     /* 340606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 340609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340613 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 340613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 340618 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340622 */   GIR_RootConstrainSelectedInstOperands,
     /* 340623 */   // GIR_Coverage, 4970,
     /* 340623 */   GIR_Done,
     /* 340624 */ // Label 6687: @340624
     /* 340624 */ GIM_Reject,
     /* 340625 */ // Label 6676: @340625
     /* 340625 */ GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(340648), // Rule ID 4972 //
     /* 340630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340637 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 340637 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 340642 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340646 */   GIR_RootConstrainSelectedInstOperands,
     /* 340647 */   // GIR_Coverage, 4972,
     /* 340647 */   GIR_Done,
     /* 340648 */ // Label 6688: @340648
     /* 340648 */ GIM_Reject,
     /* 340649 */ // Label 6677: @340649
     /* 340649 */ GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(340675), // Rule ID 4965 //
     /* 340654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340664 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 340664 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 340669 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340673 */   GIR_RootConstrainSelectedInstOperands,
     /* 340674 */   // GIR_Coverage, 4965,
     /* 340674 */   GIR_Done,
     /* 340675 */ // Label 6689: @340675
     /* 340675 */ GIM_Reject,
     /* 340676 */ // Label 6678: @340676
     /* 340676 */ GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(340699), // Rule ID 4971 //
     /* 340681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 340684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340688 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 340688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 340693 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340697 */   GIR_RootConstrainSelectedInstOperands,
     /* 340698 */   // GIR_Coverage, 4971,
     /* 340698 */   GIR_Done,
     /* 340699 */ // Label 6690: @340699
     /* 340699 */ GIM_Reject,
     /* 340700 */ // Label 6679: @340700
     /* 340700 */ GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(340726), // Rule ID 4966 //
     /* 340705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340715 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 340715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 340720 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340724 */   GIR_RootConstrainSelectedInstOperands,
     /* 340725 */   // GIR_Coverage, 4966,
     /* 340725 */   GIR_Done,
     /* 340726 */ // Label 6691: @340726
     /* 340726 */ GIM_Reject,
     /* 340727 */ // Label 6680: @340727
     /* 340727 */ GIM_Reject,
     /* 340728 */ // Label 73: @340728
     /* 340728 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6700*/ GIMT_Encode4(341584),
     /* 340739 */ /*GILLT_s16*//*Label 6692*/ GIMT_Encode4(340779),
     /* 340743 */ /*GILLT_s32*//*Label 6693*/ GIMT_Encode4(340998),
     /* 340747 */ /*GILLT_s64*//*Label 6694*/ GIMT_Encode4(341072), GIMT_Encode4(0),
     /* 340755 */ /*GILLT_v2s32*//*Label 6695*/ GIMT_Encode4(341146),
     /* 340759 */ /*GILLT_v2s64*//*Label 6696*/ GIMT_Encode4(341220),
     /* 340763 */ /*GILLT_v4s16*//*Label 6697*/ GIMT_Encode4(341294),
     /* 340767 */ /*GILLT_v4s32*//*Label 6698*/ GIMT_Encode4(341402), GIMT_Encode4(0),
     /* 340775 */ /*GILLT_v8s16*//*Label 6699*/ GIMT_Encode4(341476),
     /* 340779 */ // Label 6692: @340779
     /* 340779 */ GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(340997),
     /* 340784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 340787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340791 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(340832), // Rule ID 5244 //
     /* 340796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340817 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 340817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 340820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340830 */     GIR_RootConstrainSelectedInstOperands,
     /* 340831 */     // GIR_Coverage, 5244,
     /* 340831 */     GIR_EraseRootFromParent_Done,
     /* 340832 */   // Label 6702: @340832
     /* 340832 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(340851), // Rule ID 521 //
     /* 340837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340844 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 340844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 340849 */     GIR_RootConstrainSelectedInstOperands,
     /* 340850 */     // GIR_Coverage, 521,
     /* 340850 */     GIR_Done,
     /* 340851 */   // Label 6703: @340851
     /* 340851 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(340996), // Rule ID 6428 //
     /* 340856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340860 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 340860 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 340863 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340867 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 340874 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 340877 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340881 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340886 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 340889 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 340893 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 340896 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340901 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340906 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 340914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340923 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 340926 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340931 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 340934 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 340938 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340943 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340946 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 340951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 340956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340965 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340978 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 340985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340995 */     // GIR_Coverage, 6428,
     /* 340995 */     GIR_EraseRootFromParent_Done,
     /* 340996 */   // Label 6704: @340996
     /* 340996 */   GIM_Reject,
     /* 340997 */ // Label 6701: @340997
     /* 340997 */ GIM_Reject,
     /* 340998 */ // Label 6693: @340998
     /* 340998 */ GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(341071),
     /* 341003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341010 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(341051), // Rule ID 5245 //
     /* 341015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 341030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 341034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341036 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 341036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 341039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341049 */     GIR_RootConstrainSelectedInstOperands,
     /* 341050 */     // GIR_Coverage, 5245,
     /* 341050 */     GIR_EraseRootFromParent_Done,
     /* 341051 */   // Label 6706: @341051
     /* 341051 */   GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(341070), // Rule ID 522 //
     /* 341056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341063 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 341063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 341068 */     GIR_RootConstrainSelectedInstOperands,
     /* 341069 */     // GIR_Coverage, 522,
     /* 341069 */     GIR_Done,
     /* 341070 */   // Label 6707: @341070
     /* 341070 */   GIM_Reject,
     /* 341071 */ // Label 6705: @341071
     /* 341071 */ GIM_Reject,
     /* 341072 */ // Label 6694: @341072
     /* 341072 */ GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(341145),
     /* 341077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341084 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(341125), // Rule ID 5246 //
     /* 341089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 341104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341110 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 341110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 341113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341123 */     GIR_RootConstrainSelectedInstOperands,
     /* 341124 */     // GIR_Coverage, 5246,
     /* 341124 */     GIR_EraseRootFromParent_Done,
     /* 341125 */   // Label 6709: @341125
     /* 341125 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(341144), // Rule ID 523 //
     /* 341130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341137 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 341137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 341142 */     GIR_RootConstrainSelectedInstOperands,
     /* 341143 */     // GIR_Coverage, 523,
     /* 341143 */     GIR_Done,
     /* 341144 */   // Label 6710: @341144
     /* 341144 */   GIM_Reject,
     /* 341145 */ // Label 6708: @341145
     /* 341145 */ GIM_Reject,
     /* 341146 */ // Label 6695: @341146
     /* 341146 */ GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(341219),
     /* 341151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341158 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(341199), // Rule ID 5037 //
     /* 341163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 341182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341184 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 341184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 341187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341197 */     GIR_RootConstrainSelectedInstOperands,
     /* 341198 */     // GIR_Coverage, 5037,
     /* 341198 */     GIR_EraseRootFromParent_Done,
     /* 341199 */   // Label 6712: @341199
     /* 341199 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(341218), // Rule ID 768 //
     /* 341204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341211 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 341211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 341216 */     GIR_RootConstrainSelectedInstOperands,
     /* 341217 */     // GIR_Coverage, 768,
     /* 341217 */     GIR_Done,
     /* 341218 */   // Label 6713: @341218
     /* 341218 */   GIM_Reject,
     /* 341219 */ // Label 6711: @341219
     /* 341219 */ GIM_Reject,
     /* 341220 */ // Label 6696: @341220
     /* 341220 */ GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(341293),
     /* 341225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341232 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(341273), // Rule ID 5039 //
     /* 341237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 341256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341258 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 341258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 341261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341271 */     GIR_RootConstrainSelectedInstOperands,
     /* 341272 */     // GIR_Coverage, 5039,
     /* 341272 */     GIR_EraseRootFromParent_Done,
     /* 341273 */   // Label 6715: @341273
     /* 341273 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(341292), // Rule ID 770 //
     /* 341278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341285 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 341285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 341290 */     GIR_RootConstrainSelectedInstOperands,
     /* 341291 */     // GIR_Coverage, 770,
     /* 341291 */     GIR_Done,
     /* 341292 */   // Label 6716: @341292
     /* 341292 */   GIM_Reject,
     /* 341293 */ // Label 6714: @341293
     /* 341293 */ GIM_Reject,
     /* 341294 */ // Label 6697: @341294
     /* 341294 */ GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(341401),
     /* 341299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341306 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(341347), // Rule ID 5040 //
     /* 341311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 341330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341332 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 341332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 341335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341345 */     GIR_RootConstrainSelectedInstOperands,
     /* 341346 */     // GIR_Coverage, 5040,
     /* 341346 */     GIR_EraseRootFromParent_Done,
     /* 341347 */   // Label 6718: @341347
     /* 341347 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(341366), // Rule ID 766 //
     /* 341352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341359 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 341359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 341364 */     GIR_RootConstrainSelectedInstOperands,
     /* 341365 */     // GIR_Coverage, 766,
     /* 341365 */     GIR_Done,
     /* 341366 */   // Label 6719: @341366
     /* 341366 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(341400), // Rule ID 6430 //
     /* 341371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341378 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 341378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 341381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341385 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 341395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 341398 */     GIR_RootConstrainSelectedInstOperands,
     /* 341399 */     // GIR_Coverage, 6430,
     /* 341399 */     GIR_EraseRootFromParent_Done,
     /* 341400 */   // Label 6720: @341400
     /* 341400 */   GIM_Reject,
     /* 341401 */ // Label 6717: @341401
     /* 341401 */ GIM_Reject,
     /* 341402 */ // Label 6698: @341402
     /* 341402 */ GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(341475),
     /* 341407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341414 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(341455), // Rule ID 5038 //
     /* 341419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 341438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341440 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 341440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 341443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341453 */     GIR_RootConstrainSelectedInstOperands,
     /* 341454 */     // GIR_Coverage, 5038,
     /* 341454 */     GIR_EraseRootFromParent_Done,
     /* 341455 */   // Label 6722: @341455
     /* 341455 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(341474), // Rule ID 769 //
     /* 341460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341467 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 341467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 341472 */     GIR_RootConstrainSelectedInstOperands,
     /* 341473 */     // GIR_Coverage, 769,
     /* 341473 */     GIR_Done,
     /* 341474 */   // Label 6723: @341474
     /* 341474 */   GIM_Reject,
     /* 341475 */ // Label 6721: @341475
     /* 341475 */ GIM_Reject,
     /* 341476 */ // Label 6699: @341476
     /* 341476 */ GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(341583),
     /* 341481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341488 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(341529), // Rule ID 5041 //
     /* 341493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 341512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341514 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 341514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 341517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341527 */     GIR_RootConstrainSelectedInstOperands,
     /* 341528 */     // GIR_Coverage, 5041,
     /* 341528 */     GIR_EraseRootFromParent_Done,
     /* 341529 */   // Label 6725: @341529
     /* 341529 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(341548), // Rule ID 767 //
     /* 341534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341541 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 341541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 341546 */     GIR_RootConstrainSelectedInstOperands,
     /* 341547 */     // GIR_Coverage, 767,
     /* 341547 */     GIR_Done,
     /* 341548 */   // Label 6726: @341548
     /* 341548 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(341582), // Rule ID 6431 //
     /* 341553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341560 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 341560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 341563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341567 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 341577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 341580 */     GIR_RootConstrainSelectedInstOperands,
     /* 341581 */     // GIR_Coverage, 6431,
     /* 341581 */     GIR_EraseRootFromParent_Done,
     /* 341582 */   // Label 6727: @341582
     /* 341582 */   GIM_Reject,
     /* 341583 */ // Label 6724: @341583
     /* 341583 */ GIM_Reject,
     /* 341584 */ // Label 6700: @341584
     /* 341584 */ GIM_Reject,
     /* 341585 */ // Label 74: @341585
     /* 341585 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6736*/ GIMT_Encode4(341866),
     /* 341596 */ /*GILLT_s16*//*Label 6728*/ GIMT_Encode4(341636),
     /* 341600 */ /*GILLT_s32*//*Label 6729*/ GIMT_Encode4(341663),
     /* 341604 */ /*GILLT_s64*//*Label 6730*/ GIMT_Encode4(341687), GIMT_Encode4(0),
     /* 341612 */ /*GILLT_v2s32*//*Label 6731*/ GIMT_Encode4(341711),
     /* 341616 */ /*GILLT_v2s64*//*Label 6732*/ GIMT_Encode4(341742),
     /* 341620 */ /*GILLT_v4s16*//*Label 6733*/ GIMT_Encode4(341773),
     /* 341624 */ /*GILLT_v4s32*//*Label 6734*/ GIMT_Encode4(341804), GIMT_Encode4(0),
     /* 341632 */ /*GILLT_v8s16*//*Label 6735*/ GIMT_Encode4(341835),
     /* 341636 */ // Label 6728: @341636
     /* 341636 */ GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(341662), // Rule ID 4859 //
     /* 341641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341651 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 341651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 341654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341656 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341658 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341660 */   GIR_RootConstrainSelectedInstOperands,
     /* 341661 */   // GIR_Coverage, 4859,
     /* 341661 */   GIR_EraseRootFromParent_Done,
     /* 341662 */ // Label 6737: @341662
     /* 341662 */ GIM_Reject,
     /* 341663 */ // Label 6729: @341663
     /* 341663 */ GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(341686), // Rule ID 4856 //
     /* 341668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341675 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 341675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 341678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341680 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341682 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341684 */   GIR_RootConstrainSelectedInstOperands,
     /* 341685 */   // GIR_Coverage, 4856,
     /* 341685 */   GIR_EraseRootFromParent_Done,
     /* 341686 */ // Label 6738: @341686
     /* 341686 */ GIM_Reject,
     /* 341687 */ // Label 6730: @341687
     /* 341687 */ GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(341710), // Rule ID 4853 //
     /* 341692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341699 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 341699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 341702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341704 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341706 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341708 */   GIR_RootConstrainSelectedInstOperands,
     /* 341709 */   // GIR_Coverage, 4853,
     /* 341709 */   GIR_EraseRootFromParent_Done,
     /* 341710 */ // Label 6739: @341710
     /* 341710 */ GIM_Reject,
     /* 341711 */ // Label 6731: @341711
     /* 341711 */ GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(341741), // Rule ID 5050 //
     /* 341716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341730 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 341730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 341733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341735 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341737 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341739 */   GIR_RootConstrainSelectedInstOperands,
     /* 341740 */   // GIR_Coverage, 5050,
     /* 341740 */   GIR_EraseRootFromParent_Done,
     /* 341741 */ // Label 6740: @341741
     /* 341741 */ GIM_Reject,
     /* 341742 */ // Label 6732: @341742
     /* 341742 */ GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(341772), // Rule ID 5044 //
     /* 341747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341761 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 341761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 341764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341766 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341768 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341770 */   GIR_RootConstrainSelectedInstOperands,
     /* 341771 */   // GIR_Coverage, 5044,
     /* 341771 */   GIR_EraseRootFromParent_Done,
     /* 341772 */ // Label 6741: @341772
     /* 341772 */ GIM_Reject,
     /* 341773 */ // Label 6733: @341773
     /* 341773 */ GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(341803), // Rule ID 5056 //
     /* 341778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341792 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 341792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 341795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341797 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341799 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341801 */   GIR_RootConstrainSelectedInstOperands,
     /* 341802 */   // GIR_Coverage, 5056,
     /* 341802 */   GIR_EraseRootFromParent_Done,
     /* 341803 */ // Label 6742: @341803
     /* 341803 */ GIM_Reject,
     /* 341804 */ // Label 6734: @341804
     /* 341804 */ GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(341834), // Rule ID 5047 //
     /* 341809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341823 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 341823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 341826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341828 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341830 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341832 */   GIR_RootConstrainSelectedInstOperands,
     /* 341833 */   // GIR_Coverage, 5047,
     /* 341833 */   GIR_EraseRootFromParent_Done,
     /* 341834 */ // Label 6743: @341834
     /* 341834 */ GIM_Reject,
     /* 341835 */ // Label 6735: @341835
     /* 341835 */ GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(341865), // Rule ID 5053 //
     /* 341840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341854 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 341854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 341857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341859 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341861 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341863 */   GIR_RootConstrainSelectedInstOperands,
     /* 341864 */   // GIR_Coverage, 5053,
     /* 341864 */   GIR_EraseRootFromParent_Done,
     /* 341865 */ // Label 6744: @341865
     /* 341865 */ GIM_Reject,
     /* 341866 */ // Label 6736: @341866
     /* 341866 */ GIM_Reject,
     /* 341867 */ // Label 75: @341867
     /* 341867 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6753*/ GIMT_Encode4(342244),
     /* 341878 */ /*GILLT_s16*//*Label 6745*/ GIMT_Encode4(341918),
     /* 341882 */ /*GILLT_s32*//*Label 6746*/ GIMT_Encode4(341956),
     /* 341886 */ /*GILLT_s64*//*Label 6747*/ GIMT_Encode4(341994), GIMT_Encode4(0),
     /* 341894 */ /*GILLT_v2s32*//*Label 6748*/ GIMT_Encode4(342054),
     /* 341898 */ /*GILLT_v2s64*//*Label 6749*/ GIMT_Encode4(342092),
     /* 341902 */ /*GILLT_v4s16*//*Label 6750*/ GIMT_Encode4(342130),
     /* 341906 */ /*GILLT_v4s32*//*Label 6751*/ GIMT_Encode4(342168), GIMT_Encode4(0),
     /* 341914 */ /*GILLT_v8s16*//*Label 6752*/ GIMT_Encode4(342206),
     /* 341918 */ // Label 6745: @341918
     /* 341918 */ GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(341955), // Rule ID 608 //
     /* 341923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341944 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 341944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 341949 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341953 */   GIR_RootConstrainSelectedInstOperands,
     /* 341954 */   // GIR_Coverage, 608,
     /* 341954 */   GIR_Done,
     /* 341955 */ // Label 6754: @341955
     /* 341955 */ GIM_Reject,
     /* 341956 */ // Label 6746: @341956
     /* 341956 */ GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(341993), // Rule ID 610 //
     /* 341961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341982 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 341982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 341987 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341991 */   GIR_RootConstrainSelectedInstOperands,
     /* 341992 */   // GIR_Coverage, 610,
     /* 341992 */   GIR_Done,
     /* 341993 */ // Label 6755: @341993
     /* 341993 */ GIM_Reject,
     /* 341994 */ // Label 6747: @341994
     /* 341994 */ GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(342053),
     /* 341999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342017 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(342036), // Rule ID 612 //
     /* 342022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342025 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 342025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 342030 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342034 */     GIR_RootConstrainSelectedInstOperands,
     /* 342035 */     // GIR_Coverage, 612,
     /* 342035 */     GIR_Done,
     /* 342036 */   // Label 6757: @342036
     /* 342036 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(342052), // Rule ID 4850 //
     /* 342041 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 342041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 342046 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342050 */     GIR_RootConstrainSelectedInstOperands,
     /* 342051 */     // GIR_Coverage, 4850,
     /* 342051 */     GIR_Done,
     /* 342052 */   // Label 6758: @342052
     /* 342052 */   GIM_Reject,
     /* 342053 */ // Label 6756: @342053
     /* 342053 */ GIM_Reject,
     /* 342054 */ // Label 6748: @342054
     /* 342054 */ GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(342091), // Rule ID 1273 //
     /* 342059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342080 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 342080 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 342085 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342089 */   GIR_RootConstrainSelectedInstOperands,
     /* 342090 */   // GIR_Coverage, 1273,
     /* 342090 */   GIR_Done,
     /* 342091 */ // Label 6759: @342091
     /* 342091 */ GIM_Reject,
     /* 342092 */ // Label 6749: @342092
     /* 342092 */ GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(342129), // Rule ID 1277 //
     /* 342097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 342106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342118 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 342118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 342123 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342127 */   GIR_RootConstrainSelectedInstOperands,
     /* 342128 */   // GIR_Coverage, 1277,
     /* 342128 */   GIR_Done,
     /* 342129 */ // Label 6760: @342129
     /* 342129 */ GIM_Reject,
     /* 342130 */ // Label 6750: @342130
     /* 342130 */ GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(342167), // Rule ID 1269 //
     /* 342135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 342144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342152 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342156 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 342156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 342161 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342165 */   GIR_RootConstrainSelectedInstOperands,
     /* 342166 */   // GIR_Coverage, 1269,
     /* 342166 */   GIR_Done,
     /* 342167 */ // Label 6761: @342167
     /* 342167 */ GIM_Reject,
     /* 342168 */ // Label 6751: @342168
     /* 342168 */ GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(342205), // Rule ID 1275 //
     /* 342173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 342182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342194 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 342194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 342199 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342203 */   GIR_RootConstrainSelectedInstOperands,
     /* 342204 */   // GIR_Coverage, 1275,
     /* 342204 */   GIR_Done,
     /* 342205 */ // Label 6762: @342205
     /* 342205 */ GIM_Reject,
     /* 342206 */ // Label 6752: @342206
     /* 342206 */ GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(342243), // Rule ID 1271 //
     /* 342211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 342220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342232 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 342232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 342237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342241 */   GIR_RootConstrainSelectedInstOperands,
     /* 342242 */   // GIR_Coverage, 1271,
     /* 342242 */   GIR_Done,
     /* 342243 */ // Label 6763: @342243
     /* 342243 */ GIM_Reject,
     /* 342244 */ // Label 6753: @342244
     /* 342244 */ GIM_Reject,
     /* 342245 */ // Label 76: @342245
     /* 342245 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6772*/ GIMT_Encode4(342622),
     /* 342256 */ /*GILLT_s16*//*Label 6764*/ GIMT_Encode4(342296),
     /* 342260 */ /*GILLT_s32*//*Label 6765*/ GIMT_Encode4(342334),
     /* 342264 */ /*GILLT_s64*//*Label 6766*/ GIMT_Encode4(342372), GIMT_Encode4(0),
     /* 342272 */ /*GILLT_v2s32*//*Label 6767*/ GIMT_Encode4(342432),
     /* 342276 */ /*GILLT_v2s64*//*Label 6768*/ GIMT_Encode4(342470),
     /* 342280 */ /*GILLT_v4s16*//*Label 6769*/ GIMT_Encode4(342508),
     /* 342284 */ /*GILLT_v4s32*//*Label 6770*/ GIMT_Encode4(342546), GIMT_Encode4(0),
     /* 342292 */ /*GILLT_v8s16*//*Label 6771*/ GIMT_Encode4(342584),
     /* 342296 */ // Label 6764: @342296
     /* 342296 */ GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(342333), // Rule ID 596 //
     /* 342301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342322 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 342322 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 342327 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342331 */   GIR_RootConstrainSelectedInstOperands,
     /* 342332 */   // GIR_Coverage, 596,
     /* 342332 */   GIR_Done,
     /* 342333 */ // Label 6773: @342333
     /* 342333 */ GIM_Reject,
     /* 342334 */ // Label 6765: @342334
     /* 342334 */ GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(342371), // Rule ID 598 //
     /* 342339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342360 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 342360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 342365 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342369 */   GIR_RootConstrainSelectedInstOperands,
     /* 342370 */   // GIR_Coverage, 598,
     /* 342370 */   GIR_Done,
     /* 342371 */ // Label 6774: @342371
     /* 342371 */ GIM_Reject,
     /* 342372 */ // Label 6766: @342372
     /* 342372 */ GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(342431),
     /* 342377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342395 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(342414), // Rule ID 600 //
     /* 342400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342403 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 342403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 342408 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342412 */     GIR_RootConstrainSelectedInstOperands,
     /* 342413 */     // GIR_Coverage, 600,
     /* 342413 */     GIR_Done,
     /* 342414 */   // Label 6776: @342414
     /* 342414 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(342430), // Rule ID 4849 //
     /* 342419 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 342419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 342424 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342428 */     GIR_RootConstrainSelectedInstOperands,
     /* 342429 */     // GIR_Coverage, 4849,
     /* 342429 */     GIR_Done,
     /* 342430 */   // Label 6777: @342430
     /* 342430 */   GIM_Reject,
     /* 342431 */ // Label 6775: @342431
     /* 342431 */ GIM_Reject,
     /* 342432 */ // Label 6767: @342432
     /* 342432 */ GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(342469), // Rule ID 1243 //
     /* 342437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342454 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342458 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 342458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 342463 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342467 */   GIR_RootConstrainSelectedInstOperands,
     /* 342468 */   // GIR_Coverage, 1243,
     /* 342468 */   GIR_Done,
     /* 342469 */ // Label 6778: @342469
     /* 342469 */ GIM_Reject,
     /* 342470 */ // Label 6768: @342470
     /* 342470 */ GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(342507), // Rule ID 1247 //
     /* 342475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 342484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342496 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 342496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 342501 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342505 */   GIR_RootConstrainSelectedInstOperands,
     /* 342506 */   // GIR_Coverage, 1247,
     /* 342506 */   GIR_Done,
     /* 342507 */ // Label 6779: @342507
     /* 342507 */ GIM_Reject,
     /* 342508 */ // Label 6769: @342508
     /* 342508 */ GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(342545), // Rule ID 1239 //
     /* 342513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 342522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342534 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 342534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 342539 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342543 */   GIR_RootConstrainSelectedInstOperands,
     /* 342544 */   // GIR_Coverage, 1239,
     /* 342544 */   GIR_Done,
     /* 342545 */ // Label 6780: @342545
     /* 342545 */ GIM_Reject,
     /* 342546 */ // Label 6770: @342546
     /* 342546 */ GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(342583), // Rule ID 1245 //
     /* 342551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 342560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342572 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 342572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 342577 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342581 */   GIR_RootConstrainSelectedInstOperands,
     /* 342582 */   // GIR_Coverage, 1245,
     /* 342582 */   GIR_Done,
     /* 342583 */ // Label 6781: @342583
     /* 342583 */ GIM_Reject,
     /* 342584 */ // Label 6771: @342584
     /* 342584 */ GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(342621), // Rule ID 1241 //
     /* 342589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 342598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342606 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342610 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 342610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 342615 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342619 */   GIR_RootConstrainSelectedInstOperands,
     /* 342620 */   // GIR_Coverage, 1241,
     /* 342620 */   GIR_Done,
     /* 342621 */ // Label 6782: @342621
     /* 342621 */ GIM_Reject,
     /* 342622 */ // Label 6772: @342622
     /* 342622 */ GIM_Reject,
     /* 342623 */ // Label 77: @342623
     /* 342623 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6791*/ GIMT_Encode4(342972),
     /* 342634 */ /*GILLT_s16*//*Label 6783*/ GIMT_Encode4(342674),
     /* 342638 */ /*GILLT_s32*//*Label 6784*/ GIMT_Encode4(342712),
     /* 342642 */ /*GILLT_s64*//*Label 6785*/ GIMT_Encode4(342747), GIMT_Encode4(0),
     /* 342650 */ /*GILLT_v2s32*//*Label 6786*/ GIMT_Encode4(342782),
     /* 342654 */ /*GILLT_v2s64*//*Label 6787*/ GIMT_Encode4(342820),
     /* 342658 */ /*GILLT_v4s16*//*Label 6788*/ GIMT_Encode4(342858),
     /* 342662 */ /*GILLT_v4s32*//*Label 6789*/ GIMT_Encode4(342896), GIMT_Encode4(0),
     /* 342670 */ /*GILLT_v8s16*//*Label 6790*/ GIMT_Encode4(342934),
     /* 342674 */ // Label 6783: @342674
     /* 342674 */ GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(342711), // Rule ID 4857 //
     /* 342679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342700 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 342700 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 342705 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342709 */   GIR_RootConstrainSelectedInstOperands,
     /* 342710 */   // GIR_Coverage, 4857,
     /* 342710 */   GIR_Done,
     /* 342711 */ // Label 6792: @342711
     /* 342711 */ GIM_Reject,
     /* 342712 */ // Label 6784: @342712
     /* 342712 */ GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(342746), // Rule ID 4854 //
     /* 342717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342735 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 342735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 342740 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342744 */   GIR_RootConstrainSelectedInstOperands,
     /* 342745 */   // GIR_Coverage, 4854,
     /* 342745 */   GIR_Done,
     /* 342746 */ // Label 6793: @342746
     /* 342746 */ GIM_Reject,
     /* 342747 */ // Label 6785: @342747
     /* 342747 */ GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(342781), // Rule ID 4851 //
     /* 342752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342770 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 342770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 342775 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342779 */   GIR_RootConstrainSelectedInstOperands,
     /* 342780 */   // GIR_Coverage, 4851,
     /* 342780 */   GIR_Done,
     /* 342781 */ // Label 6794: @342781
     /* 342781 */ GIM_Reject,
     /* 342782 */ // Label 6786: @342782
     /* 342782 */ GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(342819), // Rule ID 5048 //
     /* 342787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342808 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 342808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 342813 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342817 */   GIR_RootConstrainSelectedInstOperands,
     /* 342818 */   // GIR_Coverage, 5048,
     /* 342818 */   GIR_Done,
     /* 342819 */ // Label 6795: @342819
     /* 342819 */ GIM_Reject,
     /* 342820 */ // Label 6787: @342820
     /* 342820 */ GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(342857), // Rule ID 5042 //
     /* 342825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 342834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342842 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342846 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 342846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 342851 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342855 */   GIR_RootConstrainSelectedInstOperands,
     /* 342856 */   // GIR_Coverage, 5042,
     /* 342856 */   GIR_Done,
     /* 342857 */ // Label 6796: @342857
     /* 342857 */ GIM_Reject,
     /* 342858 */ // Label 6788: @342858
     /* 342858 */ GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(342895), // Rule ID 5054 //
     /* 342863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 342872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342884 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 342884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 342889 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342893 */   GIR_RootConstrainSelectedInstOperands,
     /* 342894 */   // GIR_Coverage, 5054,
     /* 342894 */   GIR_Done,
     /* 342895 */ // Label 6797: @342895
     /* 342895 */ GIM_Reject,
     /* 342896 */ // Label 6789: @342896
     /* 342896 */ GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(342933), // Rule ID 5045 //
     /* 342901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 342910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342922 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 342922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 342927 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342931 */   GIR_RootConstrainSelectedInstOperands,
     /* 342932 */   // GIR_Coverage, 5045,
     /* 342932 */   GIR_Done,
     /* 342933 */ // Label 6798: @342933
     /* 342933 */ GIM_Reject,
     /* 342934 */ // Label 6790: @342934
     /* 342934 */ GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(342971), // Rule ID 5051 //
     /* 342939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 342948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342960 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 342960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 342965 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342969 */   GIR_RootConstrainSelectedInstOperands,
     /* 342970 */   // GIR_Coverage, 5051,
     /* 342970 */   GIR_Done,
     /* 342971 */ // Label 6799: @342971
     /* 342971 */ GIM_Reject,
     /* 342972 */ // Label 6791: @342972
     /* 342972 */ GIM_Reject,
     /* 342973 */ // Label 78: @342973
     /* 342973 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6808*/ GIMT_Encode4(343322),
     /* 342984 */ /*GILLT_s16*//*Label 6800*/ GIMT_Encode4(343024),
     /* 342988 */ /*GILLT_s32*//*Label 6801*/ GIMT_Encode4(343062),
     /* 342992 */ /*GILLT_s64*//*Label 6802*/ GIMT_Encode4(343097), GIMT_Encode4(0),
     /* 343000 */ /*GILLT_v2s32*//*Label 6803*/ GIMT_Encode4(343132),
     /* 343004 */ /*GILLT_v2s64*//*Label 6804*/ GIMT_Encode4(343170),
     /* 343008 */ /*GILLT_v4s16*//*Label 6805*/ GIMT_Encode4(343208),
     /* 343012 */ /*GILLT_v4s32*//*Label 6806*/ GIMT_Encode4(343246), GIMT_Encode4(0),
     /* 343020 */ /*GILLT_v8s16*//*Label 6807*/ GIMT_Encode4(343284),
     /* 343024 */ // Label 6800: @343024
     /* 343024 */ GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(343061), // Rule ID 4858 //
     /* 343029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343050 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 343050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 343055 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343059 */   GIR_RootConstrainSelectedInstOperands,
     /* 343060 */   // GIR_Coverage, 4858,
     /* 343060 */   GIR_Done,
     /* 343061 */ // Label 6809: @343061
     /* 343061 */ GIM_Reject,
     /* 343062 */ // Label 6801: @343062
     /* 343062 */ GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(343096), // Rule ID 4855 //
     /* 343067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343085 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 343085 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 343090 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343094 */   GIR_RootConstrainSelectedInstOperands,
     /* 343095 */   // GIR_Coverage, 4855,
     /* 343095 */   GIR_Done,
     /* 343096 */ // Label 6810: @343096
     /* 343096 */ GIM_Reject,
     /* 343097 */ // Label 6802: @343097
     /* 343097 */ GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(343131), // Rule ID 4852 //
     /* 343102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343120 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 343120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 343125 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343129 */   GIR_RootConstrainSelectedInstOperands,
     /* 343130 */   // GIR_Coverage, 4852,
     /* 343130 */   GIR_Done,
     /* 343131 */ // Label 6811: @343131
     /* 343131 */ GIM_Reject,
     /* 343132 */ // Label 6803: @343132
     /* 343132 */ GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(343169), // Rule ID 5049 //
     /* 343137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343158 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 343163 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343167 */   GIR_RootConstrainSelectedInstOperands,
     /* 343168 */   // GIR_Coverage, 5049,
     /* 343168 */   GIR_Done,
     /* 343169 */ // Label 6812: @343169
     /* 343169 */ GIM_Reject,
     /* 343170 */ // Label 6804: @343170
     /* 343170 */ GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(343207), // Rule ID 5043 //
     /* 343175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343196 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 343201 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343205 */   GIR_RootConstrainSelectedInstOperands,
     /* 343206 */   // GIR_Coverage, 5043,
     /* 343206 */   GIR_Done,
     /* 343207 */ // Label 6813: @343207
     /* 343207 */ GIM_Reject,
     /* 343208 */ // Label 6805: @343208
     /* 343208 */ GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(343245), // Rule ID 5055 //
     /* 343213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343234 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 343239 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343243 */   GIR_RootConstrainSelectedInstOperands,
     /* 343244 */   // GIR_Coverage, 5055,
     /* 343244 */   GIR_Done,
     /* 343245 */ // Label 6814: @343245
     /* 343245 */ GIM_Reject,
     /* 343246 */ // Label 6806: @343246
     /* 343246 */ GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(343283), // Rule ID 5046 //
     /* 343251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343268 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343272 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 343277 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343281 */   GIR_RootConstrainSelectedInstOperands,
     /* 343282 */   // GIR_Coverage, 5046,
     /* 343282 */   GIR_Done,
     /* 343283 */ // Label 6815: @343283
     /* 343283 */ GIM_Reject,
     /* 343284 */ // Label 6807: @343284
     /* 343284 */ GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(343321), // Rule ID 5052 //
     /* 343289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343310 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 343315 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343319 */   GIR_RootConstrainSelectedInstOperands,
     /* 343320 */   // GIR_Coverage, 5052,
     /* 343320 */   GIR_Done,
     /* 343321 */ // Label 6816: @343321
     /* 343321 */ GIM_Reject,
     /* 343322 */ // Label 6808: @343322
     /* 343322 */ GIM_Reject,
     /* 343323 */ // Label 79: @343323
     /* 343323 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6825*/ GIMT_Encode4(344025),
     /* 343334 */ /*GILLT_s16*//*Label 6817*/ GIMT_Encode4(343374),
     /* 343338 */ /*GILLT_s32*//*Label 6818*/ GIMT_Encode4(343412),
     /* 343342 */ /*GILLT_s64*//*Label 6819*/ GIMT_Encode4(343450), GIMT_Encode4(0),
     /* 343350 */ /*GILLT_v2s32*//*Label 6820*/ GIMT_Encode4(343510),
     /* 343354 */ /*GILLT_v2s64*//*Label 6821*/ GIMT_Encode4(343613),
     /* 343358 */ /*GILLT_v4s16*//*Label 6822*/ GIMT_Encode4(343716),
     /* 343362 */ /*GILLT_v4s32*//*Label 6823*/ GIMT_Encode4(343819), GIMT_Encode4(0),
     /* 343370 */ /*GILLT_v8s16*//*Label 6824*/ GIMT_Encode4(343922),
     /* 343374 */ // Label 6817: @343374
     /* 343374 */ GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(343411), // Rule ID 614 //
     /* 343379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343400 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 343400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 343405 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343409 */   GIR_RootConstrainSelectedInstOperands,
     /* 343410 */   // GIR_Coverage, 614,
     /* 343410 */   GIR_Done,
     /* 343411 */ // Label 6826: @343411
     /* 343411 */ GIM_Reject,
     /* 343412 */ // Label 6818: @343412
     /* 343412 */ GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(343449), // Rule ID 616 //
     /* 343417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343438 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 343438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 343443 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343447 */   GIR_RootConstrainSelectedInstOperands,
     /* 343448 */   // GIR_Coverage, 616,
     /* 343448 */   GIR_Done,
     /* 343449 */ // Label 6827: @343449
     /* 343449 */ GIM_Reject,
     /* 343450 */ // Label 6819: @343450
     /* 343450 */ GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(343509),
     /* 343455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343473 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(343492), // Rule ID 618 //
     /* 343478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343481 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 343481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 343486 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343490 */     GIR_RootConstrainSelectedInstOperands,
     /* 343491 */     // GIR_Coverage, 618,
     /* 343491 */     GIR_Done,
     /* 343492 */   // Label 6829: @343492
     /* 343492 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(343508), // Rule ID 4848 //
     /* 343497 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 343497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 343502 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343506 */     GIR_RootConstrainSelectedInstOperands,
     /* 343507 */     // GIR_Coverage, 4848,
     /* 343507 */     GIR_Done,
     /* 343508 */   // Label 6830: @343508
     /* 343508 */   GIM_Reject,
     /* 343509 */ // Label 6828: @343509
     /* 343509 */ GIM_Reject,
     /* 343510 */ // Label 6820: @343510
     /* 343510 */ GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(343612),
     /* 343515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343525 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(343584), // Rule ID 2366 //
     /* 343530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343569 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 343572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343582 */     GIR_RootConstrainSelectedInstOperands,
     /* 343583 */     // GIR_Coverage, 2366,
     /* 343583 */     GIR_EraseRootFromParent_Done,
     /* 343584 */   // Label 6832: @343584
     /* 343584 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(343611), // Rule ID 1288 //
     /* 343589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343600 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 343605 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343609 */     GIR_RootConstrainSelectedInstOperands,
     /* 343610 */     // GIR_Coverage, 1288,
     /* 343610 */     GIR_Done,
     /* 343611 */   // Label 6833: @343611
     /* 343611 */   GIM_Reject,
     /* 343612 */ // Label 6831: @343612
     /* 343612 */ GIM_Reject,
     /* 343613 */ // Label 6821: @343613
     /* 343613 */ GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(343715),
     /* 343618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343628 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(343687), // Rule ID 2372 //
     /* 343633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343672 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 343675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343685 */     GIR_RootConstrainSelectedInstOperands,
     /* 343686 */     // GIR_Coverage, 2372,
     /* 343686 */     GIR_EraseRootFromParent_Done,
     /* 343687 */   // Label 6835: @343687
     /* 343687 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(343714), // Rule ID 1292 //
     /* 343692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343703 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 343708 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343712 */     GIR_RootConstrainSelectedInstOperands,
     /* 343713 */     // GIR_Coverage, 1292,
     /* 343713 */     GIR_Done,
     /* 343714 */   // Label 6836: @343714
     /* 343714 */   GIM_Reject,
     /* 343715 */ // Label 6834: @343715
     /* 343715 */ GIM_Reject,
     /* 343716 */ // Label 6822: @343716
     /* 343716 */ GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(343818),
     /* 343721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343731 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(343790), // Rule ID 2360 //
     /* 343736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343775 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 343778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343788 */     GIR_RootConstrainSelectedInstOperands,
     /* 343789 */     // GIR_Coverage, 2360,
     /* 343789 */     GIR_EraseRootFromParent_Done,
     /* 343790 */   // Label 6838: @343790
     /* 343790 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(343817), // Rule ID 1284 //
     /* 343795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343806 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 343811 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343815 */     GIR_RootConstrainSelectedInstOperands,
     /* 343816 */     // GIR_Coverage, 1284,
     /* 343816 */     GIR_Done,
     /* 343817 */   // Label 6839: @343817
     /* 343817 */   GIM_Reject,
     /* 343818 */ // Label 6837: @343818
     /* 343818 */ GIM_Reject,
     /* 343819 */ // Label 6823: @343819
     /* 343819 */ GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(343921),
     /* 343824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343834 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(343893), // Rule ID 2369 //
     /* 343839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343878 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 343881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343891 */     GIR_RootConstrainSelectedInstOperands,
     /* 343892 */     // GIR_Coverage, 2369,
     /* 343892 */     GIR_EraseRootFromParent_Done,
     /* 343893 */   // Label 6841: @343893
     /* 343893 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(343920), // Rule ID 1290 //
     /* 343898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343909 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 343914 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343918 */     GIR_RootConstrainSelectedInstOperands,
     /* 343919 */     // GIR_Coverage, 1290,
     /* 343919 */     GIR_Done,
     /* 343920 */   // Label 6842: @343920
     /* 343920 */   GIM_Reject,
     /* 343921 */ // Label 6840: @343921
     /* 343921 */ GIM_Reject,
     /* 343922 */ // Label 6824: @343922
     /* 343922 */ GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(344024),
     /* 343927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343937 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(343996), // Rule ID 2363 //
     /* 343942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343981 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 343984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343994 */     GIR_RootConstrainSelectedInstOperands,
     /* 343995 */     // GIR_Coverage, 2363,
     /* 343995 */     GIR_EraseRootFromParent_Done,
     /* 343996 */   // Label 6844: @343996
     /* 343996 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(344023), // Rule ID 1286 //
     /* 344001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344012 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344012 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 344017 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344021 */     GIR_RootConstrainSelectedInstOperands,
     /* 344022 */     // GIR_Coverage, 1286,
     /* 344022 */     GIR_Done,
     /* 344023 */   // Label 6845: @344023
     /* 344023 */   GIM_Reject,
     /* 344024 */ // Label 6843: @344024
     /* 344024 */ GIM_Reject,
     /* 344025 */ // Label 6825: @344025
     /* 344025 */ GIM_Reject,
     /* 344026 */ // Label 80: @344026
     /* 344026 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6854*/ GIMT_Encode4(344728),
     /* 344037 */ /*GILLT_s16*//*Label 6846*/ GIMT_Encode4(344077),
     /* 344041 */ /*GILLT_s32*//*Label 6847*/ GIMT_Encode4(344115),
     /* 344045 */ /*GILLT_s64*//*Label 6848*/ GIMT_Encode4(344153), GIMT_Encode4(0),
     /* 344053 */ /*GILLT_v2s32*//*Label 6849*/ GIMT_Encode4(344213),
     /* 344057 */ /*GILLT_v2s64*//*Label 6850*/ GIMT_Encode4(344316),
     /* 344061 */ /*GILLT_v4s16*//*Label 6851*/ GIMT_Encode4(344419),
     /* 344065 */ /*GILLT_v4s32*//*Label 6852*/ GIMT_Encode4(344522), GIMT_Encode4(0),
     /* 344073 */ /*GILLT_v8s16*//*Label 6853*/ GIMT_Encode4(344625),
     /* 344077 */ // Label 6846: @344077
     /* 344077 */ GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(344114), // Rule ID 602 //
     /* 344082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 344085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 344088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344099 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344103 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 344103 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 344108 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344112 */   GIR_RootConstrainSelectedInstOperands,
     /* 344113 */   // GIR_Coverage, 602,
     /* 344113 */   GIR_Done,
     /* 344114 */ // Label 6855: @344114
     /* 344114 */ GIM_Reject,
     /* 344115 */ // Label 6847: @344115
     /* 344115 */ GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(344152), // Rule ID 604 //
     /* 344120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 344123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344141 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 344141 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 344146 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344150 */   GIR_RootConstrainSelectedInstOperands,
     /* 344151 */   // GIR_Coverage, 604,
     /* 344151 */   GIR_Done,
     /* 344152 */ // Label 6856: @344152
     /* 344152 */ GIM_Reject,
     /* 344153 */ // Label 6848: @344153
     /* 344153 */ GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(344212),
     /* 344158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344176 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(344195), // Rule ID 606 //
     /* 344181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 344184 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 344184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 344189 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344193 */     GIR_RootConstrainSelectedInstOperands,
     /* 344194 */     // GIR_Coverage, 606,
     /* 344194 */     GIR_Done,
     /* 344195 */   // Label 6858: @344195
     /* 344195 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(344211), // Rule ID 4847 //
     /* 344200 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 344200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 344205 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344209 */     GIR_RootConstrainSelectedInstOperands,
     /* 344210 */     // GIR_Coverage, 4847,
     /* 344210 */     GIR_Done,
     /* 344211 */   // Label 6859: @344211
     /* 344211 */   GIM_Reject,
     /* 344212 */ // Label 6857: @344212
     /* 344212 */ GIM_Reject,
     /* 344213 */ // Label 6849: @344213
     /* 344213 */ GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(344315),
     /* 344218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344228 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(344287), // Rule ID 2351 //
     /* 344233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344272 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 344275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344285 */     GIR_RootConstrainSelectedInstOperands,
     /* 344286 */     // GIR_Coverage, 2351,
     /* 344286 */     GIR_EraseRootFromParent_Done,
     /* 344287 */   // Label 6861: @344287
     /* 344287 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(344314), // Rule ID 1258 //
     /* 344292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344303 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 344308 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344312 */     GIR_RootConstrainSelectedInstOperands,
     /* 344313 */     // GIR_Coverage, 1258,
     /* 344313 */     GIR_Done,
     /* 344314 */   // Label 6862: @344314
     /* 344314 */   GIM_Reject,
     /* 344315 */ // Label 6860: @344315
     /* 344315 */ GIM_Reject,
     /* 344316 */ // Label 6850: @344316
     /* 344316 */ GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(344418),
     /* 344321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 344327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344331 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(344390), // Rule ID 2357 //
     /* 344336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344375 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 344378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344388 */     GIR_RootConstrainSelectedInstOperands,
     /* 344389 */     // GIR_Coverage, 2357,
     /* 344389 */     GIR_EraseRootFromParent_Done,
     /* 344390 */   // Label 6864: @344390
     /* 344390 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(344417), // Rule ID 1262 //
     /* 344395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344406 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 344411 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344415 */     GIR_RootConstrainSelectedInstOperands,
     /* 344416 */     // GIR_Coverage, 1262,
     /* 344416 */     GIR_Done,
     /* 344417 */   // Label 6865: @344417
     /* 344417 */   GIM_Reject,
     /* 344418 */ // Label 6863: @344418
     /* 344418 */ GIM_Reject,
     /* 344419 */ // Label 6851: @344419
     /* 344419 */ GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(344521),
     /* 344424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344434 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(344493), // Rule ID 2345 //
     /* 344439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344478 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 344481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344491 */     GIR_RootConstrainSelectedInstOperands,
     /* 344492 */     // GIR_Coverage, 2345,
     /* 344492 */     GIR_EraseRootFromParent_Done,
     /* 344493 */   // Label 6867: @344493
     /* 344493 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(344520), // Rule ID 1254 //
     /* 344498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344509 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 344514 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344518 */     GIR_RootConstrainSelectedInstOperands,
     /* 344519 */     // GIR_Coverage, 1254,
     /* 344519 */     GIR_Done,
     /* 344520 */   // Label 6868: @344520
     /* 344520 */   GIM_Reject,
     /* 344521 */ // Label 6866: @344521
     /* 344521 */ GIM_Reject,
     /* 344522 */ // Label 6852: @344522
     /* 344522 */ GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(344624),
     /* 344527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344537 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(344596), // Rule ID 2354 //
     /* 344542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344581 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 344584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344594 */     GIR_RootConstrainSelectedInstOperands,
     /* 344595 */     // GIR_Coverage, 2354,
     /* 344595 */     GIR_EraseRootFromParent_Done,
     /* 344596 */   // Label 6870: @344596
     /* 344596 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(344623), // Rule ID 1260 //
     /* 344601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344612 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 344617 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344621 */     GIR_RootConstrainSelectedInstOperands,
     /* 344622 */     // GIR_Coverage, 1260,
     /* 344622 */     GIR_Done,
     /* 344623 */   // Label 6871: @344623
     /* 344623 */   GIM_Reject,
     /* 344624 */ // Label 6869: @344624
     /* 344624 */ GIM_Reject,
     /* 344625 */ // Label 6853: @344625
     /* 344625 */ GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(344727),
     /* 344630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344640 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(344699), // Rule ID 2348 //
     /* 344645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344684 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 344687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344697 */     GIR_RootConstrainSelectedInstOperands,
     /* 344698 */     // GIR_Coverage, 2348,
     /* 344698 */     GIR_EraseRootFromParent_Done,
     /* 344699 */   // Label 6873: @344699
     /* 344699 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(344726), // Rule ID 1256 //
     /* 344704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344715 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 344720 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344724 */     GIR_RootConstrainSelectedInstOperands,
     /* 344725 */     // GIR_Coverage, 1256,
     /* 344725 */     GIR_Done,
     /* 344726 */   // Label 6874: @344726
     /* 344726 */   GIM_Reject,
     /* 344727 */ // Label 6872: @344727
     /* 344727 */ GIM_Reject,
     /* 344728 */ // Label 6854: @344728
     /* 344728 */ GIM_Reject,
     /* 344729 */ // Label 81: @344729
     /* 344729 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6883*/ GIMT_Encode4(345132),
     /* 344740 */ /*GILLT_s32*//*Label 6875*/ GIMT_Encode4(344780),
     /* 344744 */ /*GILLT_s64*//*Label 6876*/ GIMT_Encode4(344854), GIMT_Encode4(0),
     /* 344752 */ /*GILLT_v2s32*//*Label 6877*/ GIMT_Encode4(344928), GIMT_Encode4(0),
     /* 344760 */ /*GILLT_v4s16*//*Label 6878*/ GIMT_Encode4(344962),
     /* 344764 */ /*GILLT_v4s32*//*Label 6879*/ GIMT_Encode4(344996),
     /* 344768 */ /*GILLT_v8s8*//*Label 6880*/ GIMT_Encode4(345030),
     /* 344772 */ /*GILLT_v8s16*//*Label 6881*/ GIMT_Encode4(345064),
     /* 344776 */ /*GILLT_v16s8*//*Label 6882*/ GIMT_Encode4(345098),
     /* 344780 */ // Label 6875: @344780
     /* 344780 */ GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(344853),
     /* 344785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344799 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(344833), // Rule ID 2328 //
     /* 344804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 344819 */     // MIs[1] Operand 1
     /* 344819 */     // No operand predicates
     /* 344819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344821 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 344821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 344824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 344828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 344831 */     GIR_RootConstrainSelectedInstOperands,
     /* 344832 */     // GIR_Coverage, 2328,
     /* 344832 */     GIR_EraseRootFromParent_Done,
     /* 344833 */   // Label 6885: @344833
     /* 344833 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(344852), // Rule ID 2327 //
     /* 344838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344845 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 344845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 344850 */     GIR_RootConstrainSelectedInstOperands,
     /* 344851 */     // GIR_Coverage, 2327,
     /* 344851 */     GIR_Done,
     /* 344852 */   // Label 6886: @344852
     /* 344852 */   GIM_Reject,
     /* 344853 */ // Label 6884: @344853
     /* 344853 */ GIM_Reject,
     /* 344854 */ // Label 6876: @344854
     /* 344854 */ GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(344927),
     /* 344859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344873 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(344907), // Rule ID 2330 //
     /* 344878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 344893 */     // MIs[1] Operand 1
     /* 344893 */     // No operand predicates
     /* 344893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344895 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 344895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 344898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 344902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 344905 */     GIR_RootConstrainSelectedInstOperands,
     /* 344906 */     // GIR_Coverage, 2330,
     /* 344906 */     GIR_EraseRootFromParent_Done,
     /* 344907 */   // Label 6888: @344907
     /* 344907 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(344926), // Rule ID 2329 //
     /* 344912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344919 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 344919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 344924 */     GIR_RootConstrainSelectedInstOperands,
     /* 344925 */     // GIR_Coverage, 2329,
     /* 344925 */     GIR_Done,
     /* 344926 */   // Label 6889: @344926
     /* 344926 */   GIM_Reject,
     /* 344927 */ // Label 6887: @344927
     /* 344927 */ GIM_Reject,
     /* 344928 */ // Label 6877: @344928
     /* 344928 */ GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(344961), // Rule ID 1414 //
     /* 344933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344954 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 344954 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 344959 */   GIR_RootConstrainSelectedInstOperands,
     /* 344960 */   // GIR_Coverage, 1414,
     /* 344960 */   GIR_Done,
     /* 344961 */ // Label 6890: @344961
     /* 344961 */ GIM_Reject,
     /* 344962 */ // Label 6878: @344962
     /* 344962 */ GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(344995), // Rule ID 1412 //
     /* 344967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344988 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 344988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 344993 */   GIR_RootConstrainSelectedInstOperands,
     /* 344994 */   // GIR_Coverage, 1412,
     /* 344994 */   GIR_Done,
     /* 344995 */ // Label 6891: @344995
     /* 344995 */ GIM_Reject,
     /* 344996 */ // Label 6879: @344996
     /* 344996 */ GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(345029), // Rule ID 1415 //
     /* 345001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345022 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 345022 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 345027 */   GIR_RootConstrainSelectedInstOperands,
     /* 345028 */   // GIR_Coverage, 1415,
     /* 345028 */   GIR_Done,
     /* 345029 */ // Label 6892: @345029
     /* 345029 */ GIM_Reject,
     /* 345030 */ // Label 6880: @345030
     /* 345030 */ GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(345063), // Rule ID 1410 //
     /* 345035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 345041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 345044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345056 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 345056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 345061 */   GIR_RootConstrainSelectedInstOperands,
     /* 345062 */   // GIR_Coverage, 1410,
     /* 345062 */   GIR_Done,
     /* 345063 */ // Label 6893: @345063
     /* 345063 */ GIM_Reject,
     /* 345064 */ // Label 6881: @345064
     /* 345064 */ GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(345097), // Rule ID 1413 //
     /* 345069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345090 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 345090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 345095 */   GIR_RootConstrainSelectedInstOperands,
     /* 345096 */   // GIR_Coverage, 1413,
     /* 345096 */   GIR_Done,
     /* 345097 */ // Label 6894: @345097
     /* 345097 */ GIM_Reject,
     /* 345098 */ // Label 6882: @345098
     /* 345098 */ GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(345131), // Rule ID 1411 //
     /* 345103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 345109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 345112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345124 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 345124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 345129 */   GIR_RootConstrainSelectedInstOperands,
     /* 345130 */   // GIR_Coverage, 1411,
     /* 345130 */   GIR_Done,
     /* 345131 */ // Label 6895: @345131
     /* 345131 */ GIM_Reject,
     /* 345132 */ // Label 6883: @345132
     /* 345132 */ GIM_Reject,
     /* 345133 */ // Label 82: @345133
     /* 345133 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6904*/ GIMT_Encode4(345536),
     /* 345144 */ /*GILLT_s32*//*Label 6896*/ GIMT_Encode4(345184),
     /* 345148 */ /*GILLT_s64*//*Label 6897*/ GIMT_Encode4(345258), GIMT_Encode4(0),
     /* 345156 */ /*GILLT_v2s32*//*Label 6898*/ GIMT_Encode4(345332), GIMT_Encode4(0),
     /* 345164 */ /*GILLT_v4s16*//*Label 6899*/ GIMT_Encode4(345366),
     /* 345168 */ /*GILLT_v4s32*//*Label 6900*/ GIMT_Encode4(345400),
     /* 345172 */ /*GILLT_v8s8*//*Label 6901*/ GIMT_Encode4(345434),
     /* 345176 */ /*GILLT_v8s16*//*Label 6902*/ GIMT_Encode4(345468),
     /* 345180 */ /*GILLT_v16s8*//*Label 6903*/ GIMT_Encode4(345502),
     /* 345184 */ // Label 6896: @345184
     /* 345184 */ GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(345257),
     /* 345189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345203 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(345237), // Rule ID 2324 //
     /* 345208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 345223 */     // MIs[1] Operand 1
     /* 345223 */     // No operand predicates
     /* 345223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345225 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 345225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 345228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345235 */     GIR_RootConstrainSelectedInstOperands,
     /* 345236 */     // GIR_Coverage, 2324,
     /* 345236 */     GIR_EraseRootFromParent_Done,
     /* 345237 */   // Label 6906: @345237
     /* 345237 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(345256), // Rule ID 2323 //
     /* 345242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345249 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 345249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 345254 */     GIR_RootConstrainSelectedInstOperands,
     /* 345255 */     // GIR_Coverage, 2323,
     /* 345255 */     GIR_Done,
     /* 345256 */   // Label 6907: @345256
     /* 345256 */   GIM_Reject,
     /* 345257 */ // Label 6905: @345257
     /* 345257 */ GIM_Reject,
     /* 345258 */ // Label 6897: @345258
     /* 345258 */ GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(345331),
     /* 345263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345277 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(345311), // Rule ID 2326 //
     /* 345282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 345297 */     // MIs[1] Operand 1
     /* 345297 */     // No operand predicates
     /* 345297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345299 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 345299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 345302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345309 */     GIR_RootConstrainSelectedInstOperands,
     /* 345310 */     // GIR_Coverage, 2326,
     /* 345310 */     GIR_EraseRootFromParent_Done,
     /* 345311 */   // Label 6909: @345311
     /* 345311 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(345330), // Rule ID 2325 //
     /* 345316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345323 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 345323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 345328 */     GIR_RootConstrainSelectedInstOperands,
     /* 345329 */     // GIR_Coverage, 2325,
     /* 345329 */     GIR_Done,
     /* 345330 */   // Label 6910: @345330
     /* 345330 */   GIM_Reject,
     /* 345331 */ // Label 6908: @345331
     /* 345331 */ GIM_Reject,
     /* 345332 */ // Label 6898: @345332
     /* 345332 */ GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(345365), // Rule ID 1402 //
     /* 345337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345358 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 345358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 345363 */   GIR_RootConstrainSelectedInstOperands,
     /* 345364 */   // GIR_Coverage, 1402,
     /* 345364 */   GIR_Done,
     /* 345365 */ // Label 6911: @345365
     /* 345365 */ GIM_Reject,
     /* 345366 */ // Label 6899: @345366
     /* 345366 */ GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(345399), // Rule ID 1400 //
     /* 345371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345392 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 345392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 345397 */   GIR_RootConstrainSelectedInstOperands,
     /* 345398 */   // GIR_Coverage, 1400,
     /* 345398 */   GIR_Done,
     /* 345399 */ // Label 6912: @345399
     /* 345399 */ GIM_Reject,
     /* 345400 */ // Label 6900: @345400
     /* 345400 */ GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(345433), // Rule ID 1403 //
     /* 345405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345426 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 345426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 345431 */   GIR_RootConstrainSelectedInstOperands,
     /* 345432 */   // GIR_Coverage, 1403,
     /* 345432 */   GIR_Done,
     /* 345433 */ // Label 6913: @345433
     /* 345433 */ GIM_Reject,
     /* 345434 */ // Label 6901: @345434
     /* 345434 */ GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(345467), // Rule ID 1398 //
     /* 345439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 345445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 345448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345460 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 345460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 345465 */   GIR_RootConstrainSelectedInstOperands,
     /* 345466 */   // GIR_Coverage, 1398,
     /* 345466 */   GIR_Done,
     /* 345467 */ // Label 6914: @345467
     /* 345467 */ GIM_Reject,
     /* 345468 */ // Label 6902: @345468
     /* 345468 */ GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(345501), // Rule ID 1401 //
     /* 345473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345490 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345494 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 345494 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 345499 */   GIR_RootConstrainSelectedInstOperands,
     /* 345500 */   // GIR_Coverage, 1401,
     /* 345500 */   GIR_Done,
     /* 345501 */ // Label 6915: @345501
     /* 345501 */ GIM_Reject,
     /* 345502 */ // Label 6903: @345502
     /* 345502 */ GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(345535), // Rule ID 1399 //
     /* 345507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 345513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 345516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345528 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 345528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 345533 */   GIR_RootConstrainSelectedInstOperands,
     /* 345534 */   // GIR_Coverage, 1399,
     /* 345534 */   GIR_Done,
     /* 345535 */ // Label 6916: @345535
     /* 345535 */ GIM_Reject,
     /* 345536 */ // Label 6904: @345536
     /* 345536 */ GIM_Reject,
     /* 345537 */ // Label 83: @345537
     /* 345537 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6925*/ GIMT_Encode4(345940),
     /* 345548 */ /*GILLT_s32*//*Label 6917*/ GIMT_Encode4(345588),
     /* 345552 */ /*GILLT_s64*//*Label 6918*/ GIMT_Encode4(345662), GIMT_Encode4(0),
     /* 345560 */ /*GILLT_v2s32*//*Label 6919*/ GIMT_Encode4(345736), GIMT_Encode4(0),
     /* 345568 */ /*GILLT_v4s16*//*Label 6920*/ GIMT_Encode4(345770),
     /* 345572 */ /*GILLT_v4s32*//*Label 6921*/ GIMT_Encode4(345804),
     /* 345576 */ /*GILLT_v8s8*//*Label 6922*/ GIMT_Encode4(345838),
     /* 345580 */ /*GILLT_v8s16*//*Label 6923*/ GIMT_Encode4(345872),
     /* 345584 */ /*GILLT_v16s8*//*Label 6924*/ GIMT_Encode4(345906),
     /* 345588 */ // Label 6917: @345588
     /* 345588 */ GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(345661),
     /* 345593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345607 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(345641), // Rule ID 2336 //
     /* 345612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 345627 */     // MIs[1] Operand 1
     /* 345627 */     // No operand predicates
     /* 345627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345629 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 345629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 345632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345639 */     GIR_RootConstrainSelectedInstOperands,
     /* 345640 */     // GIR_Coverage, 2336,
     /* 345640 */     GIR_EraseRootFromParent_Done,
     /* 345641 */   // Label 6927: @345641
     /* 345641 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(345660), // Rule ID 2335 //
     /* 345646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345653 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 345653 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 345658 */     GIR_RootConstrainSelectedInstOperands,
     /* 345659 */     // GIR_Coverage, 2335,
     /* 345659 */     GIR_Done,
     /* 345660 */   // Label 6928: @345660
     /* 345660 */   GIM_Reject,
     /* 345661 */ // Label 6926: @345661
     /* 345661 */ GIM_Reject,
     /* 345662 */ // Label 6918: @345662
     /* 345662 */ GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(345735),
     /* 345667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345681 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(345715), // Rule ID 2338 //
     /* 345686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 345701 */     // MIs[1] Operand 1
     /* 345701 */     // No operand predicates
     /* 345701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345703 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 345703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 345706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345713 */     GIR_RootConstrainSelectedInstOperands,
     /* 345714 */     // GIR_Coverage, 2338,
     /* 345714 */     GIR_EraseRootFromParent_Done,
     /* 345715 */   // Label 6930: @345715
     /* 345715 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(345734), // Rule ID 2337 //
     /* 345720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345727 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 345727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 345732 */     GIR_RootConstrainSelectedInstOperands,
     /* 345733 */     // GIR_Coverage, 2337,
     /* 345733 */     GIR_Done,
     /* 345734 */   // Label 6931: @345734
     /* 345734 */   GIM_Reject,
     /* 345735 */ // Label 6929: @345735
     /* 345735 */ GIM_Reject,
     /* 345736 */ // Label 6919: @345736
     /* 345736 */ GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(345769), // Rule ID 1537 //
     /* 345741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345762 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 345762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 345767 */   GIR_RootConstrainSelectedInstOperands,
     /* 345768 */   // GIR_Coverage, 1537,
     /* 345768 */   GIR_Done,
     /* 345769 */ // Label 6932: @345769
     /* 345769 */ GIM_Reject,
     /* 345770 */ // Label 6920: @345770
     /* 345770 */ GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(345803), // Rule ID 1535 //
     /* 345775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345796 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 345796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 345801 */   GIR_RootConstrainSelectedInstOperands,
     /* 345802 */   // GIR_Coverage, 1535,
     /* 345802 */   GIR_Done,
     /* 345803 */ // Label 6933: @345803
     /* 345803 */ GIM_Reject,
     /* 345804 */ // Label 6921: @345804
     /* 345804 */ GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(345837), // Rule ID 1538 //
     /* 345809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345826 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345830 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 345830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 345835 */   GIR_RootConstrainSelectedInstOperands,
     /* 345836 */   // GIR_Coverage, 1538,
     /* 345836 */   GIR_Done,
     /* 345837 */ // Label 6934: @345837
     /* 345837 */ GIM_Reject,
     /* 345838 */ // Label 6922: @345838
     /* 345838 */ GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(345871), // Rule ID 1533 //
     /* 345843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 345849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 345852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345864 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 345864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 345869 */   GIR_RootConstrainSelectedInstOperands,
     /* 345870 */   // GIR_Coverage, 1533,
     /* 345870 */   GIR_Done,
     /* 345871 */ // Label 6935: @345871
     /* 345871 */ GIM_Reject,
     /* 345872 */ // Label 6923: @345872
     /* 345872 */ GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(345905), // Rule ID 1536 //
     /* 345877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345898 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 345898 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 345903 */   GIR_RootConstrainSelectedInstOperands,
     /* 345904 */   // GIR_Coverage, 1536,
     /* 345904 */   GIR_Done,
     /* 345905 */ // Label 6936: @345905
     /* 345905 */ GIM_Reject,
     /* 345906 */ // Label 6924: @345906
     /* 345906 */ GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(345939), // Rule ID 1534 //
     /* 345911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 345917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 345920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345932 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 345932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 345937 */   GIR_RootConstrainSelectedInstOperands,
     /* 345938 */   // GIR_Coverage, 1534,
     /* 345938 */   GIR_Done,
     /* 345939 */ // Label 6937: @345939
     /* 345939 */ GIM_Reject,
     /* 345940 */ // Label 6925: @345940
     /* 345940 */ GIM_Reject,
     /* 345941 */ // Label 84: @345941
     /* 345941 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6946*/ GIMT_Encode4(346344),
     /* 345952 */ /*GILLT_s32*//*Label 6938*/ GIMT_Encode4(345992),
     /* 345956 */ /*GILLT_s64*//*Label 6939*/ GIMT_Encode4(346066), GIMT_Encode4(0),
     /* 345964 */ /*GILLT_v2s32*//*Label 6940*/ GIMT_Encode4(346140), GIMT_Encode4(0),
     /* 345972 */ /*GILLT_v4s16*//*Label 6941*/ GIMT_Encode4(346174),
     /* 345976 */ /*GILLT_v4s32*//*Label 6942*/ GIMT_Encode4(346208),
     /* 345980 */ /*GILLT_v8s8*//*Label 6943*/ GIMT_Encode4(346242),
     /* 345984 */ /*GILLT_v8s16*//*Label 6944*/ GIMT_Encode4(346276),
     /* 345988 */ /*GILLT_v16s8*//*Label 6945*/ GIMT_Encode4(346310),
     /* 345992 */ // Label 6938: @345992
     /* 345992 */ GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(346065),
     /* 345997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346011 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(346045), // Rule ID 2332 //
     /* 346016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 346031 */     // MIs[1] Operand 1
     /* 346031 */     // No operand predicates
     /* 346031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346033 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 346033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 346036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346043 */     GIR_RootConstrainSelectedInstOperands,
     /* 346044 */     // GIR_Coverage, 2332,
     /* 346044 */     GIR_EraseRootFromParent_Done,
     /* 346045 */   // Label 6948: @346045
     /* 346045 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(346064), // Rule ID 2331 //
     /* 346050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346057 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 346057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 346062 */     GIR_RootConstrainSelectedInstOperands,
     /* 346063 */     // GIR_Coverage, 2331,
     /* 346063 */     GIR_Done,
     /* 346064 */   // Label 6949: @346064
     /* 346064 */   GIM_Reject,
     /* 346065 */ // Label 6947: @346065
     /* 346065 */ GIM_Reject,
     /* 346066 */ // Label 6939: @346066
     /* 346066 */ GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(346139),
     /* 346071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 346077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346085 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(346119), // Rule ID 2334 //
     /* 346090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 346105 */     // MIs[1] Operand 1
     /* 346105 */     // No operand predicates
     /* 346105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346107 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 346107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 346110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346117 */     GIR_RootConstrainSelectedInstOperands,
     /* 346118 */     // GIR_Coverage, 2334,
     /* 346118 */     GIR_EraseRootFromParent_Done,
     /* 346119 */   // Label 6951: @346119
     /* 346119 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(346138), // Rule ID 2333 //
     /* 346124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346131 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 346131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 346136 */     GIR_RootConstrainSelectedInstOperands,
     /* 346137 */     // GIR_Coverage, 2333,
     /* 346137 */     GIR_Done,
     /* 346138 */   // Label 6952: @346138
     /* 346138 */   GIM_Reject,
     /* 346139 */ // Label 6950: @346139
     /* 346139 */ GIM_Reject,
     /* 346140 */ // Label 6940: @346140
     /* 346140 */ GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(346173), // Rule ID 1525 //
     /* 346145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 346154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346162 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346166 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 346166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 346171 */   GIR_RootConstrainSelectedInstOperands,
     /* 346172 */   // GIR_Coverage, 1525,
     /* 346172 */   GIR_Done,
     /* 346173 */ // Label 6953: @346173
     /* 346173 */ GIM_Reject,
     /* 346174 */ // Label 6941: @346174
     /* 346174 */ GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(346207), // Rule ID 1523 //
     /* 346179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 346188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346200 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 346200 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 346205 */   GIR_RootConstrainSelectedInstOperands,
     /* 346206 */   // GIR_Coverage, 1523,
     /* 346206 */   GIR_Done,
     /* 346207 */ // Label 6954: @346207
     /* 346207 */ GIM_Reject,
     /* 346208 */ // Label 6942: @346208
     /* 346208 */ GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(346241), // Rule ID 1526 //
     /* 346213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346234 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 346234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 346239 */   GIR_RootConstrainSelectedInstOperands,
     /* 346240 */   // GIR_Coverage, 1526,
     /* 346240 */   GIR_Done,
     /* 346241 */ // Label 6955: @346241
     /* 346241 */ GIM_Reject,
     /* 346242 */ // Label 6943: @346242
     /* 346242 */ GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(346275), // Rule ID 1521 //
     /* 346247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 346256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346268 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 346268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 346273 */   GIR_RootConstrainSelectedInstOperands,
     /* 346274 */   // GIR_Coverage, 1521,
     /* 346274 */   GIR_Done,
     /* 346275 */ // Label 6956: @346275
     /* 346275 */ GIM_Reject,
     /* 346276 */ // Label 6944: @346276
     /* 346276 */ GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(346309), // Rule ID 1524 //
     /* 346281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346302 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 346302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 346307 */   GIR_RootConstrainSelectedInstOperands,
     /* 346308 */   // GIR_Coverage, 1524,
     /* 346308 */   GIR_Done,
     /* 346309 */ // Label 6957: @346309
     /* 346309 */ GIM_Reject,
     /* 346310 */ // Label 6945: @346310
     /* 346310 */ GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(346343), // Rule ID 1522 //
     /* 346315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 346321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 346324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346336 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 346336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 346341 */   GIR_RootConstrainSelectedInstOperands,
     /* 346342 */   // GIR_Coverage, 1522,
     /* 346342 */   GIR_Done,
     /* 346343 */ // Label 6958: @346343
     /* 346343 */ GIM_Reject,
     /* 346344 */ // Label 6946: @346344
     /* 346344 */ GIM_Reject,
     /* 346345 */ // Label 85: @346345
     /* 346345 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6968*/ GIMT_Encode4(347159),
     /* 346356 */ /*GILLT_s32*//*Label 6959*/ GIMT_Encode4(346396),
     /* 346360 */ /*GILLT_s64*//*Label 6960*/ GIMT_Encode4(346423), GIMT_Encode4(0),
     /* 346368 */ /*GILLT_v2s32*//*Label 6961*/ GIMT_Encode4(346502),
     /* 346372 */ /*GILLT_v2s64*//*Label 6962*/ GIMT_Encode4(346529),
     /* 346376 */ /*GILLT_v4s16*//*Label 6963*/ GIMT_Encode4(346712),
     /* 346380 */ /*GILLT_v4s32*//*Label 6964*/ GIMT_Encode4(346739),
     /* 346384 */ /*GILLT_v8s8*//*Label 6965*/ GIMT_Encode4(346922),
     /* 346388 */ /*GILLT_v8s16*//*Label 6966*/ GIMT_Encode4(346949),
     /* 346392 */ /*GILLT_v16s8*//*Label 6967*/ GIMT_Encode4(347132),
     /* 346396 */ // Label 6959: @346396
     /* 346396 */ GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(346422), // Rule ID 2317 //
     /* 346401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346415 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 346415 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 346420 */   GIR_RootConstrainSelectedInstOperands,
     /* 346421 */   // GIR_Coverage, 2317,
     /* 346421 */   GIR_Done,
     /* 346422 */ // Label 6969: @346422
     /* 346422 */ GIM_Reject,
     /* 346423 */ // Label 6960: @346423
     /* 346423 */ GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(346501),
     /* 346428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346431 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(346454), // Rule ID 1652 //
     /* 346436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346447 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 346447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 346452 */     GIR_RootConstrainSelectedInstOperands,
     /* 346453 */     // GIR_Coverage, 1652,
     /* 346453 */     GIR_Done,
     /* 346454 */   // Label 6971: @346454
     /* 346454 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(346477), // Rule ID 2318 //
     /* 346459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346470 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 346470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 346475 */     GIR_RootConstrainSelectedInstOperands,
     /* 346476 */     // GIR_Coverage, 2318,
     /* 346476 */     GIR_Done,
     /* 346477 */   // Label 6972: @346477
     /* 346477 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(346500), // Rule ID 2514 //
     /* 346482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 346485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346493 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 346493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 346498 */     GIR_RootConstrainSelectedInstOperands,
     /* 346499 */     // GIR_Coverage, 2514,
     /* 346499 */     GIR_Done,
     /* 346500 */   // Label 6973: @346500
     /* 346500 */   GIM_Reject,
     /* 346501 */ // Label 6970: @346501
     /* 346501 */ GIM_Reject,
     /* 346502 */ // Label 6961: @346502
     /* 346502 */ GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(346528), // Rule ID 707 //
     /* 346507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346521 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 346521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 346526 */   GIR_RootConstrainSelectedInstOperands,
     /* 346527 */   // GIR_Coverage, 707,
     /* 346527 */   GIR_Done,
     /* 346528 */ // Label 6974: @346528
     /* 346528 */ GIM_Reject,
     /* 346529 */ // Label 6962: @346529
     /* 346529 */ GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(346711),
     /* 346534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 346537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346541 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(346619), // Rule ID 4925 //
     /* 346546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 346558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 346562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346582 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 346595 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 346602 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 346602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 346605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 346612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 346617 */     GIR_RootConstrainSelectedInstOperands,
     /* 346618 */     // GIR_Coverage, 4925,
     /* 346618 */     GIR_EraseRootFromParent_Done,
     /* 346619 */   // Label 6976: @346619
     /* 346619 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(346691), // Rule ID 4924 //
     /* 346624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 346636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 346640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346669 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346674 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346676 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 346676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 346679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 346685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 346689 */     GIR_RootConstrainSelectedInstOperands,
     /* 346690 */     // GIR_Coverage, 4924,
     /* 346690 */     GIR_EraseRootFromParent_Done,
     /* 346691 */   // Label 6977: @346691
     /* 346691 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(346710), // Rule ID 709 //
     /* 346696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346703 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 346703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 346708 */     GIR_RootConstrainSelectedInstOperands,
     /* 346709 */     // GIR_Coverage, 709,
     /* 346709 */     GIR_Done,
     /* 346710 */   // Label 6978: @346710
     /* 346710 */   GIM_Reject,
     /* 346711 */ // Label 6975: @346711
     /* 346711 */ GIM_Reject,
     /* 346712 */ // Label 6963: @346712
     /* 346712 */ GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(346738), // Rule ID 705 //
     /* 346717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346731 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 346731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 346736 */   GIR_RootConstrainSelectedInstOperands,
     /* 346737 */   // GIR_Coverage, 705,
     /* 346737 */   GIR_Done,
     /* 346738 */ // Label 6979: @346738
     /* 346738 */ GIM_Reject,
     /* 346739 */ // Label 6964: @346739
     /* 346739 */ GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(346921),
     /* 346744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346751 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(346829), // Rule ID 4923 //
     /* 346756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346792 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346796 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 346805 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 346812 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 346812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 346815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 346822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 346827 */     GIR_RootConstrainSelectedInstOperands,
     /* 346828 */     // GIR_Coverage, 4923,
     /* 346828 */     GIR_EraseRootFromParent_Done,
     /* 346829 */   // Label 6981: @346829
     /* 346829 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(346901), // Rule ID 4922 //
     /* 346834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346875 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346879 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346886 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 346886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 346889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 346895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 346899 */     GIR_RootConstrainSelectedInstOperands,
     /* 346900 */     // GIR_Coverage, 4922,
     /* 346900 */     GIR_EraseRootFromParent_Done,
     /* 346901 */   // Label 6982: @346901
     /* 346901 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(346920), // Rule ID 708 //
     /* 346906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346913 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 346913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 346918 */     GIR_RootConstrainSelectedInstOperands,
     /* 346919 */     // GIR_Coverage, 708,
     /* 346919 */     GIR_Done,
     /* 346920 */   // Label 6983: @346920
     /* 346920 */   GIM_Reject,
     /* 346921 */ // Label 6980: @346921
     /* 346921 */ GIM_Reject,
     /* 346922 */ // Label 6965: @346922
     /* 346922 */ GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(346948), // Rule ID 703 //
     /* 346927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346941 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 346941 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 346946 */   GIR_RootConstrainSelectedInstOperands,
     /* 346947 */   // GIR_Coverage, 703,
     /* 346947 */   GIR_Done,
     /* 346948 */ // Label 6984: @346948
     /* 346948 */ GIM_Reject,
     /* 346949 */ // Label 6966: @346949
     /* 346949 */ GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(347131),
     /* 346954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346961 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(347039), // Rule ID 4921 //
     /* 346966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347002 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347008 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 347015 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 347022 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 347022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 347025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 347032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 347037 */     GIR_RootConstrainSelectedInstOperands,
     /* 347038 */     // GIR_Coverage, 4921,
     /* 347038 */     GIR_EraseRootFromParent_Done,
     /* 347039 */   // Label 6986: @347039
     /* 347039 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(347111), // Rule ID 4920 //
     /* 347044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 347060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 347064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347085 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347089 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347096 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 347096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 347099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 347105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 347109 */     GIR_RootConstrainSelectedInstOperands,
     /* 347110 */     // GIR_Coverage, 4920,
     /* 347110 */     GIR_EraseRootFromParent_Done,
     /* 347111 */   // Label 6987: @347111
     /* 347111 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(347130), // Rule ID 706 //
     /* 347116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347123 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 347123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 347128 */     GIR_RootConstrainSelectedInstOperands,
     /* 347129 */     // GIR_Coverage, 706,
     /* 347129 */     GIR_Done,
     /* 347130 */   // Label 6988: @347130
     /* 347130 */   GIM_Reject,
     /* 347131 */ // Label 6985: @347131
     /* 347131 */ GIM_Reject,
     /* 347132 */ // Label 6967: @347132
     /* 347132 */ GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(347158), // Rule ID 704 //
     /* 347137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 347143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347151 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 347151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 347156 */   GIR_RootConstrainSelectedInstOperands,
     /* 347157 */   // GIR_Coverage, 704,
     /* 347157 */   GIR_Done,
     /* 347158 */ // Label 6989: @347158
     /* 347158 */ GIM_Reject,
     /* 347159 */ // Label 6968: @347159
     /* 347159 */ GIM_Reject,
     /* 347160 */ // Label 86: @347160
     /* 347160 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6992*/ GIMT_Encode4(347325),
     /* 347171 */ /*GILLT_s32*//*Label 6990*/ GIMT_Encode4(347179),
     /* 347175 */ /*GILLT_s64*//*Label 6991*/ GIMT_Encode4(347252),
     /* 347179 */ // Label 6990: @347179
     /* 347179 */ GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(347205), // Rule ID 4766 //
     /* 347184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 347187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 347190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347194 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 347194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 347199 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347203 */   GIR_RootConstrainSelectedInstOperands,
     /* 347204 */   // GIR_Coverage, 4766,
     /* 347204 */   GIR_Done,
     /* 347205 */ // Label 6993: @347205
     /* 347205 */ GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(347228), // Rule ID 4772 //
     /* 347210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 347213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347217 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 347217 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 347222 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347226 */   GIR_RootConstrainSelectedInstOperands,
     /* 347227 */   // GIR_Coverage, 4772,
     /* 347227 */   GIR_Done,
     /* 347228 */ // Label 6994: @347228
     /* 347228 */ GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(347251), // Rule ID 4774 //
     /* 347233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 347236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347240 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 347240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 347245 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347249 */   GIR_RootConstrainSelectedInstOperands,
     /* 347250 */   // GIR_Coverage, 4774,
     /* 347250 */   GIR_Done,
     /* 347251 */ // Label 6995: @347251
     /* 347251 */ GIM_Reject,
     /* 347252 */ // Label 6991: @347252
     /* 347252 */ GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(347278), // Rule ID 4768 //
     /* 347257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 347260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 347263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347267 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 347267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 347272 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347276 */   GIR_RootConstrainSelectedInstOperands,
     /* 347277 */   // GIR_Coverage, 4768,
     /* 347277 */   GIR_Done,
     /* 347278 */ // Label 6996: @347278
     /* 347278 */ GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(347301), // Rule ID 4776 //
     /* 347283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 347286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347290 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 347290 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 347295 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347299 */   GIR_RootConstrainSelectedInstOperands,
     /* 347300 */   // GIR_Coverage, 4776,
     /* 347300 */   GIR_Done,
     /* 347301 */ // Label 6997: @347301
     /* 347301 */ GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(347324), // Rule ID 4778 //
     /* 347306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 347309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347313 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 347313 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 347318 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347322 */   GIR_RootConstrainSelectedInstOperands,
     /* 347323 */   // GIR_Coverage, 4778,
     /* 347323 */   GIR_Done,
     /* 347324 */ // Label 6998: @347324
     /* 347324 */ GIM_Reject,
     /* 347325 */ // Label 6992: @347325
     /* 347325 */ GIM_Reject,
     /* 347326 */ // Label 87: @347326
     /* 347326 */ GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(347424),
     /* 347331 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 347334 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7003*/ GIMT_Encode4(347423),
     /* 347345 */   /*GILLT_s16*//*Label 7000*/ GIMT_Encode4(347357),
     /* 347349 */   /*GILLT_s32*//*Label 7001*/ GIMT_Encode4(347381),
     /* 347353 */   /*GILLT_s64*//*Label 7002*/ GIMT_Encode4(347402),
     /* 347357 */   // Label 7000: @347357
     /* 347357 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(347380), // Rule ID 4770 //
     /* 347362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 347365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347369 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 347369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 347374 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347378 */     GIR_RootConstrainSelectedInstOperands,
     /* 347379 */     // GIR_Coverage, 4770,
     /* 347379 */     GIR_Done,
     /* 347380 */   // Label 7004: @347380
     /* 347380 */   GIM_Reject,
     /* 347381 */   // Label 7001: @347381
     /* 347381 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(347401), // Rule ID 4780 //
     /* 347386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347390 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 347390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 347395 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347399 */     GIR_RootConstrainSelectedInstOperands,
     /* 347400 */     // GIR_Coverage, 4780,
     /* 347400 */     GIR_Done,
     /* 347401 */   // Label 7005: @347401
     /* 347401 */   GIM_Reject,
     /* 347402 */   // Label 7002: @347402
     /* 347402 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(347422), // Rule ID 4782 //
     /* 347407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347411 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 347411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 347416 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347420 */     GIR_RootConstrainSelectedInstOperands,
     /* 347421 */     // GIR_Coverage, 4782,
     /* 347421 */     GIR_Done,
     /* 347422 */   // Label 7006: @347422
     /* 347422 */   GIM_Reject,
     /* 347423 */   // Label 7003: @347423
     /* 347423 */   GIM_Reject,
     /* 347424 */ // Label 6999: @347424
     /* 347424 */ GIM_Reject,
     /* 347425 */ // Label 88: @347425
     /* 347425 */ GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(347440), // Rule ID 225 //
     /* 347430 */   // MIs[0] addr
     /* 347430 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 347433 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 347433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 347438 */   GIR_RootConstrainSelectedInstOperands,
     /* 347439 */   // GIR_Coverage, 225,
     /* 347439 */   GIR_Done,
     /* 347440 */ // Label 7007: @347440
     /* 347440 */ GIM_Reject,
     /* 347441 */ // Label 89: @347441
     /* 347441 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 7019*/ GIMT_Encode4(352812),
     /* 347452 */ /*GILLT_s64*//*Label 7008*/ GIMT_Encode4(347524), GIMT_Encode4(0),
     /* 347460 */ /*GILLT_v2s32*//*Label 7009*/ GIMT_Encode4(347926), GIMT_Encode4(0),
     /* 347468 */ /*GILLT_v4s16*//*Label 7010*/ GIMT_Encode4(348328), GIMT_Encode4(0),
     /* 347476 */ /*GILLT_v8s8*//*Label 7011*/ GIMT_Encode4(348730), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 347488 */ /*GILLT_nxv1s1*//*Label 7012*/ GIMT_Encode4(348910),
     /* 347492 */ /*GILLT_nxv2s1*//*Label 7013*/ GIMT_Encode4(351173),
     /* 347496 */ /*GILLT_nxv2s16*//*Label 7014*/ GIMT_Encode4(352028),
     /* 347500 */ /*GILLT_nxv2s32*//*Label 7015*/ GIMT_Encode4(352315), GIMT_Encode4(0),
     /* 347508 */ /*GILLT_nxv4s1*//*Label 7016*/ GIMT_Encode4(352385),
     /* 347512 */ /*GILLT_nxv4s16*//*Label 7017*/ GIMT_Encode4(352672), GIMT_Encode4(0),
     /* 347520 */ /*GILLT_nxv8s1*//*Label 7018*/ GIMT_Encode4(352742),
     /* 347524 */ // Label 7008: @347524
     /* 347524 */ GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(347925),
     /* 347529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 347532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347536 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(347588), // Rule ID 5616 //
     /* 347541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 347549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347553 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 347555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347560 */     // MIs[0] Operand 2
     /* 347560 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347573 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 347573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 347576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347586 */     GIR_RootConstrainSelectedInstOperands,
     /* 347587 */     // GIR_Coverage, 5616,
     /* 347587 */     GIR_EraseRootFromParent_Done,
     /* 347588 */   // Label 7021: @347588
     /* 347588 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(347640), // Rule ID 5619 //
     /* 347593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 347601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347605 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 347607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347612 */     // MIs[0] Operand 2
     /* 347612 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347625 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 347625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 347628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347638 */     GIR_RootConstrainSelectedInstOperands,
     /* 347639 */     // GIR_Coverage, 5619,
     /* 347639 */     GIR_EraseRootFromParent_Done,
     /* 347640 */   // Label 7022: @347640
     /* 347640 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(347708), // Rule ID 5495 //
     /* 347645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347649 */     // MIs[0] Operand 2
     /* 347649 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347660 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 347667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347672 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347680 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 347683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347690 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347707 */     // GIR_Coverage, 5495,
     /* 347707 */     GIR_EraseRootFromParent_Done,
     /* 347708 */   // Label 7023: @347708
     /* 347708 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(347776), // Rule ID 5500 //
     /* 347713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347717 */     // MIs[0] Operand 2
     /* 347717 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347728 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 347735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347740 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347744 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347748 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 347751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347758 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347775 */     // GIR_Coverage, 5500,
     /* 347775 */     GIR_EraseRootFromParent_Done,
     /* 347776 */   // Label 7024: @347776
     /* 347776 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(347818), // Rule ID 6947 //
     /* 347781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347785 */     // MIs[0] Operand 2
     /* 347785 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347796 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 347796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347801 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 347807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347817 */     // GIR_Coverage, 6947,
     /* 347817 */     GIR_EraseRootFromParent_Done,
     /* 347818 */   // Label 7025: @347818
     /* 347818 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(347860), // Rule ID 6948 //
     /* 347823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347827 */     // MIs[0] Operand 2
     /* 347827 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347838 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 347838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347843 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 347849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347859 */     // GIR_Coverage, 6948,
     /* 347859 */     GIR_EraseRootFromParent_Done,
     /* 347860 */   // Label 7026: @347860
     /* 347860 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(347924), // Rule ID 6952 //
     /* 347865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347869 */     // MIs[0] Operand 2
     /* 347869 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347880 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 347880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 347887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347896 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 347899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347906 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347923 */     // GIR_Coverage, 6952,
     /* 347923 */     GIR_EraseRootFromParent_Done,
     /* 347924 */   // Label 7027: @347924
     /* 347924 */   GIM_Reject,
     /* 347925 */ // Label 7020: @347925
     /* 347925 */ GIM_Reject,
     /* 347926 */ // Label 7009: @347926
     /* 347926 */ GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(348327),
     /* 347931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347938 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(347990), // Rule ID 5615 //
     /* 347943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 347951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347955 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 347957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347962 */     // MIs[0] Operand 2
     /* 347962 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347975 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 347975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 347978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347988 */     GIR_RootConstrainSelectedInstOperands,
     /* 347989 */     // GIR_Coverage, 5615,
     /* 347989 */     GIR_EraseRootFromParent_Done,
     /* 347990 */   // Label 7029: @347990
     /* 347990 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(348042), // Rule ID 5618 //
     /* 347995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 348003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 348007 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 348009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348014 */     // MIs[0] Operand 2
     /* 348014 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 348025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348027 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 348027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 348030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348040 */     GIR_RootConstrainSelectedInstOperands,
     /* 348041 */     // GIR_Coverage, 5618,
     /* 348041 */     GIR_EraseRootFromParent_Done,
     /* 348042 */   // Label 7030: @348042
     /* 348042 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(348110), // Rule ID 5485 //
     /* 348047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348051 */     // MIs[0] Operand 2
     /* 348051 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 348062 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348074 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348078 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348082 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348092 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348109 */     // GIR_Coverage, 5485,
     /* 348109 */     GIR_EraseRootFromParent_Done,
     /* 348110 */   // Label 7031: @348110
     /* 348110 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(348178), // Rule ID 5490 //
     /* 348115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348119 */     // MIs[0] Operand 2
     /* 348119 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 348130 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348150 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348160 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348177 */     // GIR_Coverage, 5490,
     /* 348177 */     GIR_EraseRootFromParent_Done,
     /* 348178 */   // Label 7032: @348178
     /* 348178 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(348220), // Rule ID 6944 //
     /* 348183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348187 */     // MIs[0] Operand 2
     /* 348187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348198 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 348198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348203 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348219 */     // GIR_Coverage, 6944,
     /* 348219 */     GIR_EraseRootFromParent_Done,
     /* 348220 */   // Label 7033: @348220
     /* 348220 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(348262), // Rule ID 6946 //
     /* 348225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348229 */     // MIs[0] Operand 2
     /* 348229 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348240 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 348240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348245 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348261 */     // GIR_Coverage, 6946,
     /* 348261 */     GIR_EraseRootFromParent_Done,
     /* 348262 */   // Label 7034: @348262
     /* 348262 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(348326), // Rule ID 6951 //
     /* 348267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348271 */     // MIs[0] Operand 2
     /* 348271 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348282 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 348282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 348289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348298 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 348301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348308 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348325 */     // GIR_Coverage, 6951,
     /* 348325 */     GIR_EraseRootFromParent_Done,
     /* 348326 */   // Label 7035: @348326
     /* 348326 */   GIM_Reject,
     /* 348327 */ // Label 7028: @348327
     /* 348327 */ GIM_Reject,
     /* 348328 */ // Label 7010: @348328
     /* 348328 */ GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(348729),
     /* 348333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 348336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348340 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(348392), // Rule ID 5614 //
     /* 348345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 348353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348357 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 348359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348364 */     // MIs[0] Operand 2
     /* 348364 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348377 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 348377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 348380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348390 */     GIR_RootConstrainSelectedInstOperands,
     /* 348391 */     // GIR_Coverage, 5614,
     /* 348391 */     GIR_EraseRootFromParent_Done,
     /* 348392 */   // Label 7037: @348392
     /* 348392 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(348444), // Rule ID 5617 //
     /* 348397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 348405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348409 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 348411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348416 */     // MIs[0] Operand 2
     /* 348416 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 348427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348429 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 348429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 348432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348442 */     GIR_RootConstrainSelectedInstOperands,
     /* 348443 */     // GIR_Coverage, 5617,
     /* 348443 */     GIR_EraseRootFromParent_Done,
     /* 348444 */   // Label 7038: @348444
     /* 348444 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(348512), // Rule ID 5475 //
     /* 348449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348453 */     // MIs[0] Operand 2
     /* 348453 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 348464 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348476 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348484 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348494 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348501 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348511 */     // GIR_Coverage, 5475,
     /* 348511 */     GIR_EraseRootFromParent_Done,
     /* 348512 */   // Label 7039: @348512
     /* 348512 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(348580), // Rule ID 5480 //
     /* 348517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348521 */     // MIs[0] Operand 2
     /* 348521 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 348532 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348548 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348552 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348562 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348579 */     // GIR_Coverage, 5480,
     /* 348579 */     GIR_EraseRootFromParent_Done,
     /* 348580 */   // Label 7040: @348580
     /* 348580 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(348622), // Rule ID 6942 //
     /* 348585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348589 */     // MIs[0] Operand 2
     /* 348589 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348600 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 348600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348605 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348621 */     // GIR_Coverage, 6942,
     /* 348621 */     GIR_EraseRootFromParent_Done,
     /* 348622 */   // Label 7041: @348622
     /* 348622 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(348664), // Rule ID 6945 //
     /* 348627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348631 */     // MIs[0] Operand 2
     /* 348631 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348642 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 348642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348647 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348663 */     // GIR_Coverage, 6945,
     /* 348663 */     GIR_EraseRootFromParent_Done,
     /* 348664 */   // Label 7042: @348664
     /* 348664 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(348728), // Rule ID 6950 //
     /* 348669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348673 */     // MIs[0] Operand 2
     /* 348673 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348684 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 348684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 348691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348696 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348700 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 348703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348710 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348722 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348727 */     // GIR_Coverage, 6950,
     /* 348727 */     GIR_EraseRootFromParent_Done,
     /* 348728 */   // Label 7043: @348728
     /* 348728 */   GIM_Reject,
     /* 348729 */ // Label 7036: @348729
     /* 348729 */ GIM_Reject,
     /* 348730 */ // Label 7011: @348730
     /* 348730 */ GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(348909),
     /* 348735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 348738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348746 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(348810), // Rule ID 5470 //
     /* 348751 */     // MIs[0] Operand 2
     /* 348751 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 348762 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348792 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348809 */     // GIR_Coverage, 5470,
     /* 348809 */     GIR_EraseRootFromParent_Done,
     /* 348810 */   // Label 7045: @348810
     /* 348810 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(348848), // Rule ID 6943 //
     /* 348815 */     // MIs[0] Operand 2
     /* 348815 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348826 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 348826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348831 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348847 */     // GIR_Coverage, 6943,
     /* 348847 */     GIR_EraseRootFromParent_Done,
     /* 348848 */   // Label 7046: @348848
     /* 348848 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(348908), // Rule ID 6949 //
     /* 348853 */     // MIs[0] Operand 2
     /* 348853 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348864 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 348864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 348871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348876 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348880 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 348883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348890 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348907 */     // GIR_Coverage, 6949,
     /* 348907 */     GIR_EraseRootFromParent_Done,
     /* 348908 */   // Label 7047: @348908
     /* 348908 */   GIM_Reject,
     /* 348909 */ // Label 7044: @348909
     /* 348909 */ GIM_Reject,
     /* 348910 */ // Label 7012: @348910
     /* 348910 */ GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(348945), // Rule ID 9041 //
     /* 348915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 348921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348925 */   // MIs[0] Operand 2
     /* 348925 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348936 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 348936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348941 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 348943 */   GIR_RootConstrainSelectedInstOperands,
     /* 348944 */   // GIR_Coverage, 9041,
     /* 348944 */   GIR_EraseRootFromParent_Done,
     /* 348945 */ // Label 7048: @348945
     /* 348945 */ GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(348980), // Rule ID 9042 //
     /* 348950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 348956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348960 */   // MIs[0] Operand 2
     /* 348960 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348971 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 348971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348976 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 348978 */   GIR_RootConstrainSelectedInstOperands,
     /* 348979 */   // GIR_Coverage, 9042,
     /* 348979 */   GIR_EraseRootFromParent_Done,
     /* 348980 */ // Label 7049: @348980
     /* 348980 */ GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(349034), // Rule ID 9049 //
     /* 348985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 348991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348995 */   // MIs[0] Operand 2
     /* 348995 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349006 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 349006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349018 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349032 */   GIR_RootConstrainSelectedInstOperands,
     /* 349033 */   // GIR_Coverage, 9049,
     /* 349033 */   GIR_EraseRootFromParent_Done,
     /* 349034 */ // Label 7050: @349034
     /* 349034 */ GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(349088), // Rule ID 9050 //
     /* 349039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 349045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349049 */   // MIs[0] Operand 2
     /* 349049 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349060 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 349060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349072 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349086 */   GIR_RootConstrainSelectedInstOperands,
     /* 349087 */   // GIR_Coverage, 9050,
     /* 349087 */   GIR_EraseRootFromParent_Done,
     /* 349088 */ // Label 7051: @349088
     /* 349088 */ GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(349142), // Rule ID 9051 //
     /* 349093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 349099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349103 */   // MIs[0] Operand 2
     /* 349103 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 349114 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 349114 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349117 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349121 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349126 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349137 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349140 */   GIR_RootConstrainSelectedInstOperands,
     /* 349141 */   // GIR_Coverage, 9051,
     /* 349141 */   GIR_EraseRootFromParent_Done,
     /* 349142 */ // Label 7052: @349142
     /* 349142 */ GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(349196), // Rule ID 9052 //
     /* 349147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 349153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349157 */   // MIs[0] Operand 2
     /* 349157 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 349168 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 349168 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349171 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349175 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349180 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349194 */   GIR_RootConstrainSelectedInstOperands,
     /* 349195 */   // GIR_Coverage, 9052,
     /* 349195 */   GIR_EraseRootFromParent_Done,
     /* 349196 */ // Label 7053: @349196
     /* 349196 */ GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(349267), // Rule ID 9061 //
     /* 349201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349211 */   // MIs[0] Operand 2
     /* 349211 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349222 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349222 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349225 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349229 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349234 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349240 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349243 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349247 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349252 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349265 */   GIR_RootConstrainSelectedInstOperands,
     /* 349266 */   // GIR_Coverage, 9061,
     /* 349266 */   GIR_EraseRootFromParent_Done,
     /* 349267 */ // Label 7054: @349267
     /* 349267 */ GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(349338), // Rule ID 9062 //
     /* 349272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349282 */   // MIs[0] Operand 2
     /* 349282 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349293 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349293 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349296 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349300 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349305 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349311 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349314 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349318 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349323 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349333 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349336 */   GIR_RootConstrainSelectedInstOperands,
     /* 349337 */   // GIR_Coverage, 9062,
     /* 349337 */   GIR_EraseRootFromParent_Done,
     /* 349338 */ // Label 7055: @349338
     /* 349338 */ GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(349409), // Rule ID 9063 //
     /* 349343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349353 */   // MIs[0] Operand 2
     /* 349353 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 349364 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349364 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349367 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349371 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349376 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349394 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349404 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349407 */   GIR_RootConstrainSelectedInstOperands,
     /* 349408 */   // GIR_Coverage, 9063,
     /* 349408 */   GIR_EraseRootFromParent_Done,
     /* 349409 */ // Label 7056: @349409
     /* 349409 */ GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(349480), // Rule ID 9064 //
     /* 349414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349424 */   // MIs[0] Operand 2
     /* 349424 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 349435 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349435 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349438 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349442 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349447 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349453 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349456 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349460 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349465 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349475 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349478 */   GIR_RootConstrainSelectedInstOperands,
     /* 349479 */   // GIR_Coverage, 9064,
     /* 349479 */   GIR_EraseRootFromParent_Done,
     /* 349480 */ // Label 7057: @349480
     /* 349480 */ GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(349551), // Rule ID 9065 //
     /* 349485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349495 */   // MIs[0] Operand 2
     /* 349495 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 349506 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349506 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349509 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349513 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349518 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349536 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349549 */   GIR_RootConstrainSelectedInstOperands,
     /* 349550 */   // GIR_Coverage, 9065,
     /* 349550 */   GIR_EraseRootFromParent_Done,
     /* 349551 */ // Label 7058: @349551
     /* 349551 */ GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(349622), // Rule ID 9066 //
     /* 349556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349566 */   // MIs[0] Operand 2
     /* 349566 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 349577 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349577 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349580 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349584 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349589 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349607 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349620 */   GIR_RootConstrainSelectedInstOperands,
     /* 349621 */   // GIR_Coverage, 9066,
     /* 349621 */   GIR_EraseRootFromParent_Done,
     /* 349622 */ // Label 7059: @349622
     /* 349622 */ GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(349693), // Rule ID 9067 //
     /* 349627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349637 */   // MIs[0] Operand 2
     /* 349637 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 349648 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349648 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349651 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349655 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349660 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349666 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349669 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349673 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349678 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349691 */   GIR_RootConstrainSelectedInstOperands,
     /* 349692 */   // GIR_Coverage, 9067,
     /* 349692 */   GIR_EraseRootFromParent_Done,
     /* 349693 */ // Label 7060: @349693
     /* 349693 */ GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(349764), // Rule ID 9068 //
     /* 349698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349708 */   // MIs[0] Operand 2
     /* 349708 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 349719 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349719 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349722 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349726 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349731 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349749 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349759 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349762 */   GIR_RootConstrainSelectedInstOperands,
     /* 349763 */   // GIR_Coverage, 9068,
     /* 349763 */   GIR_EraseRootFromParent_Done,
     /* 349764 */ // Label 7061: @349764
     /* 349764 */ GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(349852), // Rule ID 9077 //
     /* 349769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349779 */   // MIs[0] Operand 2
     /* 349779 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349790 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349790 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349793 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349797 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349802 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349806 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349808 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349811 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349815 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349820 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349825 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349828 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349832 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349837 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349847 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349850 */   GIR_RootConstrainSelectedInstOperands,
     /* 349851 */   // GIR_Coverage, 9077,
     /* 349851 */   GIR_EraseRootFromParent_Done,
     /* 349852 */ // Label 7062: @349852
     /* 349852 */ GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(349940), // Rule ID 9078 //
     /* 349857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349867 */   // MIs[0] Operand 2
     /* 349867 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349878 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349878 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349881 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349885 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349890 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349896 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349899 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349903 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349908 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349913 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349916 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349920 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349925 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349938 */   GIR_RootConstrainSelectedInstOperands,
     /* 349939 */   // GIR_Coverage, 9078,
     /* 349939 */   GIR_EraseRootFromParent_Done,
     /* 349940 */ // Label 7063: @349940
     /* 349940 */ GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(350028), // Rule ID 9079 //
     /* 349945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349955 */   // MIs[0] Operand 2
     /* 349955 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 349966 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349966 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349969 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349973 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349978 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349984 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349987 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349991 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349996 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350001 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350004 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350008 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350013 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350023 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350026 */   GIR_RootConstrainSelectedInstOperands,
     /* 350027 */   // GIR_Coverage, 9079,
     /* 350027 */   GIR_EraseRootFromParent_Done,
     /* 350028 */ // Label 7064: @350028
     /* 350028 */ GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(350116), // Rule ID 9080 //
     /* 350033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350043 */   // MIs[0] Operand 2
     /* 350043 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 350054 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350054 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350057 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350061 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350066 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350072 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350075 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350079 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350084 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350089 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350092 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350096 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350101 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350114 */   GIR_RootConstrainSelectedInstOperands,
     /* 350115 */   // GIR_Coverage, 9080,
     /* 350115 */   GIR_EraseRootFromParent_Done,
     /* 350116 */ // Label 7065: @350116
     /* 350116 */ GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(350204), // Rule ID 9081 //
     /* 350121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350131 */   // MIs[0] Operand 2
     /* 350131 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 350142 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350142 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350145 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350149 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350154 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350160 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350163 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350167 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350172 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350189 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350199 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350202 */   GIR_RootConstrainSelectedInstOperands,
     /* 350203 */   // GIR_Coverage, 9081,
     /* 350203 */   GIR_EraseRootFromParent_Done,
     /* 350204 */ // Label 7066: @350204
     /* 350204 */ GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(350292), // Rule ID 9082 //
     /* 350209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350219 */   // MIs[0] Operand 2
     /* 350219 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 350230 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350230 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350233 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350237 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350242 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350248 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350251 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350255 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350260 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350265 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350268 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350272 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350277 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350290 */   GIR_RootConstrainSelectedInstOperands,
     /* 350291 */   // GIR_Coverage, 9082,
     /* 350291 */   GIR_EraseRootFromParent_Done,
     /* 350292 */ // Label 7067: @350292
     /* 350292 */ GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(350380), // Rule ID 9083 //
     /* 350297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350307 */   // MIs[0] Operand 2
     /* 350307 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 350318 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350318 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350321 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350325 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350330 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350336 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350339 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350343 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350348 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350353 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350356 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350360 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350365 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350375 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350378 */   GIR_RootConstrainSelectedInstOperands,
     /* 350379 */   // GIR_Coverage, 9083,
     /* 350379 */   GIR_EraseRootFromParent_Done,
     /* 350380 */ // Label 7068: @350380
     /* 350380 */ GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(350468), // Rule ID 9084 //
     /* 350385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350395 */   // MIs[0] Operand 2
     /* 350395 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 350406 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350406 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350409 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350413 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350418 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350424 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350427 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350431 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350436 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350441 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350444 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350448 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350453 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350466 */   GIR_RootConstrainSelectedInstOperands,
     /* 350467 */   // GIR_Coverage, 9084,
     /* 350467 */   GIR_EraseRootFromParent_Done,
     /* 350468 */ // Label 7069: @350468
     /* 350468 */ GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(350556), // Rule ID 9085 //
     /* 350473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350483 */   // MIs[0] Operand 2
     /* 350483 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 350494 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350494 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350497 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350501 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350506 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350512 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350515 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350519 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350524 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350529 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350532 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350536 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350541 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350551 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350554 */   GIR_RootConstrainSelectedInstOperands,
     /* 350555 */   // GIR_Coverage, 9085,
     /* 350555 */   GIR_EraseRootFromParent_Done,
     /* 350556 */ // Label 7070: @350556
     /* 350556 */ GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(350644), // Rule ID 9086 //
     /* 350561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350571 */   // MIs[0] Operand 2
     /* 350571 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 350582 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350582 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350585 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350589 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350594 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350598 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350600 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350603 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350607 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350612 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350617 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350620 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350624 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350629 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350642 */   GIR_RootConstrainSelectedInstOperands,
     /* 350643 */   // GIR_Coverage, 9086,
     /* 350643 */   GIR_EraseRootFromParent_Done,
     /* 350644 */ // Label 7071: @350644
     /* 350644 */ GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(350732), // Rule ID 9087 //
     /* 350649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350659 */   // MIs[0] Operand 2
     /* 350659 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 350670 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350670 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350673 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350677 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350682 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350688 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350691 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350695 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350700 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350717 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350730 */   GIR_RootConstrainSelectedInstOperands,
     /* 350731 */   // GIR_Coverage, 9087,
     /* 350731 */   GIR_EraseRootFromParent_Done,
     /* 350732 */ // Label 7072: @350732
     /* 350732 */ GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(350820), // Rule ID 9088 //
     /* 350737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350747 */   // MIs[0] Operand 2
     /* 350747 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 350758 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350758 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350761 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350765 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350770 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350776 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350779 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350783 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350788 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350805 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350815 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350818 */   GIR_RootConstrainSelectedInstOperands,
     /* 350819 */   // GIR_Coverage, 9088,
     /* 350819 */   GIR_EraseRootFromParent_Done,
     /* 350820 */ // Label 7073: @350820
     /* 350820 */ GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(350908), // Rule ID 9089 //
     /* 350825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350835 */   // MIs[0] Operand 2
     /* 350835 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 350846 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350846 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350849 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350853 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350858 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350864 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350867 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350871 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350876 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350893 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350903 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350906 */   GIR_RootConstrainSelectedInstOperands,
     /* 350907 */   // GIR_Coverage, 9089,
     /* 350907 */   GIR_EraseRootFromParent_Done,
     /* 350908 */ // Label 7074: @350908
     /* 350908 */ GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(350996), // Rule ID 9090 //
     /* 350913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350923 */   // MIs[0] Operand 2
     /* 350923 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 350934 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350934 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350937 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350941 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350946 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350952 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350955 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350959 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350964 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350981 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350994 */   GIR_RootConstrainSelectedInstOperands,
     /* 350995 */   // GIR_Coverage, 9090,
     /* 350995 */   GIR_EraseRootFromParent_Done,
     /* 350996 */ // Label 7075: @350996
     /* 350996 */ GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(351084), // Rule ID 9091 //
     /* 351001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351011 */   // MIs[0] Operand 2
     /* 351011 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 351022 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351022 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351025 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351029 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351034 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351040 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351043 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351047 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351052 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351069 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351082 */   GIR_RootConstrainSelectedInstOperands,
     /* 351083 */   // GIR_Coverage, 9091,
     /* 351083 */   GIR_EraseRootFromParent_Done,
     /* 351084 */ // Label 7076: @351084
     /* 351084 */ GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(351172), // Rule ID 9092 //
     /* 351089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351099 */   // MIs[0] Operand 2
     /* 351099 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 351110 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351110 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351113 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351117 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351122 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351128 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351131 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351135 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351140 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351145 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351148 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351152 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351157 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351167 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351170 */   GIR_RootConstrainSelectedInstOperands,
     /* 351171 */   // GIR_Coverage, 9092,
     /* 351171 */   GIR_EraseRootFromParent_Done,
     /* 351172 */ // Label 7077: @351172
     /* 351172 */ GIM_Reject,
     /* 351173 */ // Label 7013: @351173
     /* 351173 */ GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(351208), // Rule ID 9043 //
     /* 351178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 351184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351188 */   // MIs[0] Operand 2
     /* 351188 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351199 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 351199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351204 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 351206 */   GIR_RootConstrainSelectedInstOperands,
     /* 351207 */   // GIR_Coverage, 9043,
     /* 351207 */   GIR_EraseRootFromParent_Done,
     /* 351208 */ // Label 7078: @351208
     /* 351208 */ GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(351243), // Rule ID 9044 //
     /* 351213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 351219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351223 */   // MIs[0] Operand 2
     /* 351223 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351234 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 351234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351239 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 351241 */   GIR_RootConstrainSelectedInstOperands,
     /* 351242 */   // GIR_Coverage, 9044,
     /* 351242 */   GIR_EraseRootFromParent_Done,
     /* 351243 */ // Label 7079: @351243
     /* 351243 */ GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(351297), // Rule ID 9053 //
     /* 351248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351258 */   // MIs[0] Operand 2
     /* 351258 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351269 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 351269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351281 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351295 */   GIR_RootConstrainSelectedInstOperands,
     /* 351296 */   // GIR_Coverage, 9053,
     /* 351296 */   GIR_EraseRootFromParent_Done,
     /* 351297 */ // Label 7080: @351297
     /* 351297 */ GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(351351), // Rule ID 9054 //
     /* 351302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351312 */   // MIs[0] Operand 2
     /* 351312 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351323 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 351323 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351326 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351330 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351335 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351349 */   GIR_RootConstrainSelectedInstOperands,
     /* 351350 */   // GIR_Coverage, 9054,
     /* 351350 */   GIR_EraseRootFromParent_Done,
     /* 351351 */ // Label 7081: @351351
     /* 351351 */ GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(351405), // Rule ID 9055 //
     /* 351356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351366 */   // MIs[0] Operand 2
     /* 351366 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 351377 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 351377 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351380 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351384 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351389 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351403 */   GIR_RootConstrainSelectedInstOperands,
     /* 351404 */   // GIR_Coverage, 9055,
     /* 351404 */   GIR_EraseRootFromParent_Done,
     /* 351405 */ // Label 7082: @351405
     /* 351405 */ GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(351459), // Rule ID 9056 //
     /* 351410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351420 */   // MIs[0] Operand 2
     /* 351420 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 351431 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 351431 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351434 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351438 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351443 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351454 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351457 */   GIR_RootConstrainSelectedInstOperands,
     /* 351458 */   // GIR_Coverage, 9056,
     /* 351458 */   GIR_EraseRootFromParent_Done,
     /* 351459 */ // Label 7083: @351459
     /* 351459 */ GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(351530), // Rule ID 9069 //
     /* 351464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351474 */   // MIs[0] Operand 2
     /* 351474 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351485 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351485 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351488 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351492 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351497 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351503 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351506 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351510 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351515 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351528 */   GIR_RootConstrainSelectedInstOperands,
     /* 351529 */   // GIR_Coverage, 9069,
     /* 351529 */   GIR_EraseRootFromParent_Done,
     /* 351530 */ // Label 7084: @351530
     /* 351530 */ GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(351601), // Rule ID 9070 //
     /* 351535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351545 */   // MIs[0] Operand 2
     /* 351545 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351556 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351556 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351559 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351563 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351568 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351586 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351599 */   GIR_RootConstrainSelectedInstOperands,
     /* 351600 */   // GIR_Coverage, 9070,
     /* 351600 */   GIR_EraseRootFromParent_Done,
     /* 351601 */ // Label 7085: @351601
     /* 351601 */ GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(351672), // Rule ID 9071 //
     /* 351606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351616 */   // MIs[0] Operand 2
     /* 351616 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 351627 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351627 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351630 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351634 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351639 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351657 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351670 */   GIR_RootConstrainSelectedInstOperands,
     /* 351671 */   // GIR_Coverage, 9071,
     /* 351671 */   GIR_EraseRootFromParent_Done,
     /* 351672 */ // Label 7086: @351672
     /* 351672 */ GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(351743), // Rule ID 9072 //
     /* 351677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351687 */   // MIs[0] Operand 2
     /* 351687 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 351698 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351698 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351701 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351705 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351710 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351716 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351719 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351723 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351728 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351741 */   GIR_RootConstrainSelectedInstOperands,
     /* 351742 */   // GIR_Coverage, 9072,
     /* 351742 */   GIR_EraseRootFromParent_Done,
     /* 351743 */ // Label 7087: @351743
     /* 351743 */ GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(351814), // Rule ID 9073 //
     /* 351748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351758 */   // MIs[0] Operand 2
     /* 351758 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 351769 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351769 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351772 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351776 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351781 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351799 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351812 */   GIR_RootConstrainSelectedInstOperands,
     /* 351813 */   // GIR_Coverage, 9073,
     /* 351813 */   GIR_EraseRootFromParent_Done,
     /* 351814 */ // Label 7088: @351814
     /* 351814 */ GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(351885), // Rule ID 9074 //
     /* 351819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351829 */   // MIs[0] Operand 2
     /* 351829 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 351840 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351840 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351843 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351847 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351852 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351870 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351880 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351883 */   GIR_RootConstrainSelectedInstOperands,
     /* 351884 */   // GIR_Coverage, 9074,
     /* 351884 */   GIR_EraseRootFromParent_Done,
     /* 351885 */ // Label 7089: @351885
     /* 351885 */ GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(351956), // Rule ID 9075 //
     /* 351890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351900 */   // MIs[0] Operand 2
     /* 351900 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 351911 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351911 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351914 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351918 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351923 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351941 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351951 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351954 */   GIR_RootConstrainSelectedInstOperands,
     /* 351955 */   // GIR_Coverage, 9075,
     /* 351955 */   GIR_EraseRootFromParent_Done,
     /* 351956 */ // Label 7090: @351956
     /* 351956 */ GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(352027), // Rule ID 9076 //
     /* 351961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351971 */   // MIs[0] Operand 2
     /* 351971 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 351982 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351982 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351985 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351989 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351994 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352012 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352022 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352025 */   GIR_RootConstrainSelectedInstOperands,
     /* 352026 */   // GIR_Coverage, 9076,
     /* 352026 */   GIR_EraseRootFromParent_Done,
     /* 352027 */ // Label 7091: @352027
     /* 352027 */ GIM_Reject,
     /* 352028 */ // Label 7014: @352028
     /* 352028 */ GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(352063), // Rule ID 9093 //
     /* 352033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 352039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352043 */   // MIs[0] Operand 2
     /* 352043 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352054 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 352054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 352057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352059 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352061 */   GIR_RootConstrainSelectedInstOperands,
     /* 352062 */   // GIR_Coverage, 9093,
     /* 352062 */   GIR_EraseRootFromParent_Done,
     /* 352063 */ // Label 7092: @352063
     /* 352063 */ GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(352098), // Rule ID 9094 //
     /* 352068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 352074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352078 */   // MIs[0] Operand 2
     /* 352078 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352089 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 352089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 352092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352094 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352096 */   GIR_RootConstrainSelectedInstOperands,
     /* 352097 */   // GIR_Coverage, 9094,
     /* 352097 */   GIR_EraseRootFromParent_Done,
     /* 352098 */ // Label 7093: @352098
     /* 352098 */ GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(352152), // Rule ID 9099 //
     /* 352103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352113 */   // MIs[0] Operand 2
     /* 352113 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352124 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 352124 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352127 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 352131 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352136 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 352140 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 352145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352147 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352150 */   GIR_RootConstrainSelectedInstOperands,
     /* 352151 */   // GIR_Coverage, 9099,
     /* 352151 */   GIR_EraseRootFromParent_Done,
     /* 352152 */ // Label 7094: @352152
     /* 352152 */ GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(352206), // Rule ID 9100 //
     /* 352157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352167 */   // MIs[0] Operand 2
     /* 352167 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352178 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 352178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 352185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352190 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 352194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 352199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352204 */   GIR_RootConstrainSelectedInstOperands,
     /* 352205 */   // GIR_Coverage, 9100,
     /* 352205 */   GIR_EraseRootFromParent_Done,
     /* 352206 */ // Label 7095: @352206
     /* 352206 */ GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(352260), // Rule ID 9101 //
     /* 352211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352221 */   // MIs[0] Operand 2
     /* 352221 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352232 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 352232 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352235 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 352239 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352244 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 352248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 352253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352255 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352258 */   GIR_RootConstrainSelectedInstOperands,
     /* 352259 */   // GIR_Coverage, 9101,
     /* 352259 */   GIR_EraseRootFromParent_Done,
     /* 352260 */ // Label 7096: @352260
     /* 352260 */ GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(352314), // Rule ID 9102 //
     /* 352265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352275 */   // MIs[0] Operand 2
     /* 352275 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 352286 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 352286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 352293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352298 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 352302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 352307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352312 */   GIR_RootConstrainSelectedInstOperands,
     /* 352313 */   // GIR_Coverage, 9102,
     /* 352313 */   GIR_EraseRootFromParent_Done,
     /* 352314 */ // Label 7097: @352314
     /* 352314 */ GIM_Reject,
     /* 352315 */ // Label 7015: @352315
     /* 352315 */ GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(352384),
     /* 352320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 352323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352327 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(352355), // Rule ID 9097 //
     /* 352332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352335 */     // MIs[0] Operand 2
     /* 352335 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352346 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 352346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 352349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352351 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352353 */     GIR_RootConstrainSelectedInstOperands,
     /* 352354 */     // GIR_Coverage, 9097,
     /* 352354 */     GIR_EraseRootFromParent_Done,
     /* 352355 */   // Label 7099: @352355
     /* 352355 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(352383), // Rule ID 9098 //
     /* 352360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352363 */     // MIs[0] Operand 2
     /* 352363 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352374 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 352374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 352377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352381 */     GIR_RootConstrainSelectedInstOperands,
     /* 352382 */     // GIR_Coverage, 9098,
     /* 352382 */     GIR_EraseRootFromParent_Done,
     /* 352383 */   // Label 7100: @352383
     /* 352383 */   GIM_Reject,
     /* 352384 */ // Label 7098: @352384
     /* 352384 */ GIM_Reject,
     /* 352385 */ // Label 7016: @352385
     /* 352385 */ GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(352420), // Rule ID 9045 //
     /* 352390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 352396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352400 */   // MIs[0] Operand 2
     /* 352400 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352411 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 352411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352416 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352418 */   GIR_RootConstrainSelectedInstOperands,
     /* 352419 */   // GIR_Coverage, 9045,
     /* 352419 */   GIR_EraseRootFromParent_Done,
     /* 352420 */ // Label 7101: @352420
     /* 352420 */ GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(352455), // Rule ID 9046 //
     /* 352425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 352431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352435 */   // MIs[0] Operand 2
     /* 352435 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352446 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 352446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352451 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352453 */   GIR_RootConstrainSelectedInstOperands,
     /* 352454 */   // GIR_Coverage, 9046,
     /* 352454 */   GIR_EraseRootFromParent_Done,
     /* 352455 */ // Label 7102: @352455
     /* 352455 */ GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(352509), // Rule ID 9057 //
     /* 352460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352470 */   // MIs[0] Operand 2
     /* 352470 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352481 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 352481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352493 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352504 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352507 */   GIR_RootConstrainSelectedInstOperands,
     /* 352508 */   // GIR_Coverage, 9057,
     /* 352508 */   GIR_EraseRootFromParent_Done,
     /* 352509 */ // Label 7103: @352509
     /* 352509 */ GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(352563), // Rule ID 9058 //
     /* 352514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352524 */   // MIs[0] Operand 2
     /* 352524 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352535 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 352535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352547 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352558 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352561 */   GIR_RootConstrainSelectedInstOperands,
     /* 352562 */   // GIR_Coverage, 9058,
     /* 352562 */   GIR_EraseRootFromParent_Done,
     /* 352563 */ // Label 7104: @352563
     /* 352563 */ GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(352617), // Rule ID 9059 //
     /* 352568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352578 */   // MIs[0] Operand 2
     /* 352578 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 352589 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 352589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352601 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352605 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352612 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352615 */   GIR_RootConstrainSelectedInstOperands,
     /* 352616 */   // GIR_Coverage, 9059,
     /* 352616 */   GIR_EraseRootFromParent_Done,
     /* 352617 */ // Label 7105: @352617
     /* 352617 */ GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(352671), // Rule ID 9060 //
     /* 352622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352632 */   // MIs[0] Operand 2
     /* 352632 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 352643 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 352643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352655 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352669 */   GIR_RootConstrainSelectedInstOperands,
     /* 352670 */   // GIR_Coverage, 9060,
     /* 352670 */   GIR_EraseRootFromParent_Done,
     /* 352671 */ // Label 7106: @352671
     /* 352671 */ GIM_Reject,
     /* 352672 */ // Label 7017: @352672
     /* 352672 */ GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(352741),
     /* 352677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352684 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(352712), // Rule ID 9095 //
     /* 352689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352692 */     // MIs[0] Operand 2
     /* 352692 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352703 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 352703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 352706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352710 */     GIR_RootConstrainSelectedInstOperands,
     /* 352711 */     // GIR_Coverage, 9095,
     /* 352711 */     GIR_EraseRootFromParent_Done,
     /* 352712 */   // Label 7108: @352712
     /* 352712 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(352740), // Rule ID 9096 //
     /* 352717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352720 */     // MIs[0] Operand 2
     /* 352720 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352731 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 352731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 352734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352738 */     GIR_RootConstrainSelectedInstOperands,
     /* 352739 */     // GIR_Coverage, 9096,
     /* 352739 */     GIR_EraseRootFromParent_Done,
     /* 352740 */   // Label 7109: @352740
     /* 352740 */   GIM_Reject,
     /* 352741 */ // Label 7107: @352741
     /* 352741 */ GIM_Reject,
     /* 352742 */ // Label 7018: @352742
     /* 352742 */ GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(352811),
     /* 352747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352754 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(352782), // Rule ID 9047 //
     /* 352759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352762 */     // MIs[0] Operand 2
     /* 352762 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352773 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 352773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352780 */     GIR_RootConstrainSelectedInstOperands,
     /* 352781 */     // GIR_Coverage, 9047,
     /* 352781 */     GIR_EraseRootFromParent_Done,
     /* 352782 */   // Label 7111: @352782
     /* 352782 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(352810), // Rule ID 9048 //
     /* 352787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352790 */     // MIs[0] Operand 2
     /* 352790 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 352801 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 352801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352806 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352808 */     GIR_RootConstrainSelectedInstOperands,
     /* 352809 */     // GIR_Coverage, 9048,
     /* 352809 */     GIR_EraseRootFromParent_Done,
     /* 352810 */   // Label 7112: @352810
     /* 352810 */   GIM_Reject,
     /* 352811 */ // Label 7110: @352811
     /* 352811 */ GIM_Reject,
     /* 352812 */ // Label 7019: @352812
     /* 352812 */ GIM_Reject,
     /* 352813 */ // Label 90: @352813
     /* 352813 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7128*/ GIMT_Encode4(385734),
     /* 352824 */ /*GILLT_s64*//*Label 7113*/ GIMT_Encode4(352908), GIMT_Encode4(0),
     /* 352832 */ /*GILLT_v2s32*//*Label 7114*/ GIMT_Encode4(353618),
     /* 352836 */ /*GILLT_v2s64*//*Label 7115*/ GIMT_Encode4(357149),
     /* 352840 */ /*GILLT_v4s16*//*Label 7116*/ GIMT_Encode4(360390),
     /* 352844 */ /*GILLT_v4s32*//*Label 7117*/ GIMT_Encode4(364030),
     /* 352848 */ /*GILLT_v8s8*//*Label 7118*/ GIMT_Encode4(367098),
     /* 352852 */ /*GILLT_v8s16*//*Label 7119*/ GIMT_Encode4(370311),
     /* 352856 */ /*GILLT_v16s8*//*Label 7120*/ GIMT_Encode4(373730), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 352868 */ /*GILLT_nxv2s16*//*Label 7121*/ GIMT_Encode4(376934),
     /* 352872 */ /*GILLT_nxv2s32*//*Label 7122*/ GIMT_Encode4(377059),
     /* 352876 */ /*GILLT_nxv2s64*//*Label 7123*/ GIMT_Encode4(377184), GIMT_Encode4(0),
     /* 352884 */ /*GILLT_nxv4s16*//*Label 7124*/ GIMT_Encode4(379162),
     /* 352888 */ /*GILLT_nxv4s32*//*Label 7125*/ GIMT_Encode4(379314), GIMT_Encode4(0),
     /* 352896 */ /*GILLT_nxv8s16*//*Label 7126*/ GIMT_Encode4(381346), GIMT_Encode4(0),
     /* 352904 */ /*GILLT_nxv16s8*//*Label 7127*/ GIMT_Encode4(383614),
     /* 352908 */ // Label 7113: @352908
     /* 352908 */ GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(353617),
     /* 352913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 352916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352919 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352926 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(353056), // Rule ID 5770 //
     /* 352931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352964 */     // MIs[2] Operand 1
     /* 352964 */     // No operand predicates
     /* 352964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352972 */     // MIs[3] Operand 1
     /* 352972 */     // No operand predicates
     /* 352972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352974 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 352974 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 352977 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352981 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352986 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 352989 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 352993 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352996 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 353009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 353013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353018 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 353024 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 353031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353038 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 353045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353055 */     // GIR_Coverage, 5770,
     /* 353055 */     GIR_EraseRootFromParent_Done,
     /* 353056 */   // Label 7130: @353056
     /* 353056 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(353217), // Rule ID 5771 //
     /* 353061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 353077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353094 */     // MIs[2] Operand 1
     /* 353094 */     // No operand predicates
     /* 353094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353102 */     // MIs[3] Operand 1
     /* 353102 */     // No operand predicates
     /* 353102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353104 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 353104 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 353107 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353111 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353116 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 353119 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353123 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 353126 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353131 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353136 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 353139 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353143 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353148 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 353151 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353155 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 353158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353163 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 353171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 353175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353180 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 353186 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 353189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 353192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353199 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 353206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353216 */     // GIR_Coverage, 5771,
     /* 353216 */     GIR_EraseRootFromParent_Done,
     /* 353217 */   // Label 7131: @353217
     /* 353217 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(353347), // Rule ID 5810 //
     /* 353222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 353238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353255 */     // MIs[2] Operand 1
     /* 353255 */     // No operand predicates
     /* 353255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353263 */     // MIs[3] Operand 1
     /* 353263 */     // No operand predicates
     /* 353263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353265 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 353265 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 353268 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353272 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353277 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 353280 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353284 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 353287 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353292 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 353300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 353304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353309 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 353315 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 353322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353329 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 353336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353346 */     // GIR_Coverage, 5810,
     /* 353346 */     GIR_EraseRootFromParent_Done,
     /* 353347 */   // Label 7132: @353347
     /* 353347 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(353508), // Rule ID 5811 //
     /* 353352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 353368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353385 */     // MIs[2] Operand 1
     /* 353385 */     // No operand predicates
     /* 353385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353393 */     // MIs[3] Operand 1
     /* 353393 */     // No operand predicates
     /* 353393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353395 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 353395 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 353398 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353402 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353407 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 353410 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353414 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 353417 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353422 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353427 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 353430 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353434 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353439 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 353442 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353446 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 353449 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353454 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 353462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 353466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353471 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 353477 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 353480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 353483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353490 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 353497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353502 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353507 */     // GIR_Coverage, 5811,
     /* 353507 */     GIR_EraseRootFromParent_Done,
     /* 353508 */   // Label 7133: @353508
     /* 353508 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(353544), // Rule ID 6723 //
     /* 353513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353531 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 353531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 353538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353543 */     // GIR_Coverage, 6723,
     /* 353543 */     GIR_EraseRootFromParent_Done,
     /* 353544 */   // Label 7134: @353544
     /* 353544 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(353580), // Rule ID 6725 //
     /* 353549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353567 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 353567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 353574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353579 */     // GIR_Coverage, 6725,
     /* 353579 */     GIR_EraseRootFromParent_Done,
     /* 353580 */   // Label 7135: @353580
     /* 353580 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(353616), // Rule ID 6727 //
     /* 353585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353603 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 353603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353606 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 353608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 353610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353615 */     // GIR_Coverage, 6727,
     /* 353615 */     GIR_EraseRootFromParent_Done,
     /* 353616 */   // Label 7136: @353616
     /* 353616 */   GIM_Reject,
     /* 353617 */ // Label 7129: @353617
     /* 353617 */ GIM_Reject,
     /* 353618 */ // Label 7114: @353618
     /* 353618 */ GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(357148),
     /* 353623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 353626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353629 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353636 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(353745), // Rule ID 4308 //
     /* 353641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353645 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353651 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353661 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353664 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353668 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353678 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 353685 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 353692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353712 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353744 */     // GIR_Coverage, 4308,
     /* 353744 */     GIR_EraseRootFromParent_Done,
     /* 353745 */   // Label 7138: @353745
     /* 353745 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(353854), // Rule ID 4309 //
     /* 353750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353754 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353760 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353770 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353773 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353777 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353787 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 353794 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 353801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353821 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353843 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353853 */     // GIR_Coverage, 4309,
     /* 353853 */     GIR_EraseRootFromParent_Done,
     /* 353854 */   // Label 7139: @353854
     /* 353854 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(353963), // Rule ID 4416 //
     /* 353859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353863 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353869 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353879 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353882 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353886 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353896 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 353903 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 353910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353930 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353962 */     // GIR_Coverage, 4416,
     /* 353962 */     GIR_EraseRootFromParent_Done,
     /* 353963 */   // Label 7140: @353963
     /* 353963 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(354072), // Rule ID 4417 //
     /* 353968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353972 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353978 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353988 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353991 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353995 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353999 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354005 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 354012 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 354019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354039 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354071 */     // GIR_Coverage, 4417,
     /* 354071 */     GIR_EraseRootFromParent_Done,
     /* 354072 */   // Label 7141: @354072
     /* 354072 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(354177), // Rule ID 4314 //
     /* 354077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354093 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354096 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354100 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 354117 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 354124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354144 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354176 */     // GIR_Coverage, 4314,
     /* 354176 */     GIR_EraseRootFromParent_Done,
     /* 354177 */   // Label 7142: @354177
     /* 354177 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(354282), // Rule ID 4316 //
     /* 354182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354198 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354201 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354205 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354215 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 354222 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 354229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354249 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354281 */     // GIR_Coverage, 4316,
     /* 354281 */     GIR_EraseRootFromParent_Done,
     /* 354282 */   // Label 7143: @354282
     /* 354282 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(354387), // Rule ID 4422 //
     /* 354287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354303 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354306 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354310 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 354327 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 354334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354354 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354386 */     // GIR_Coverage, 4422,
     /* 354386 */     GIR_EraseRootFromParent_Done,
     /* 354387 */   // Label 7144: @354387
     /* 354387 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(354492), // Rule ID 4424 //
     /* 354392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354408 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354411 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354415 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354425 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 354432 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 354439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354459 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354491 */     // GIR_Coverage, 4424,
     /* 354491 */     GIR_EraseRootFromParent_Done,
     /* 354492 */   // Label 7145: @354492
     /* 354492 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(354596), // Rule ID 4306 //
     /* 354497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354501 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354507 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354517 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354520 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354524 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 354541 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 354541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 354548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354563 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354595 */     // GIR_Coverage, 4306,
     /* 354595 */     GIR_EraseRootFromParent_Done,
     /* 354596 */   // Label 7146: @354596
     /* 354596 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(354700), // Rule ID 4307 //
     /* 354601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354605 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354611 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354621 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354624 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354628 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354638 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 354645 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 354645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 354652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354667 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354699 */     // GIR_Coverage, 4307,
     /* 354699 */     GIR_EraseRootFromParent_Done,
     /* 354700 */   // Label 7147: @354700
     /* 354700 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(354804), // Rule ID 4414 //
     /* 354705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354709 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354715 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354725 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354728 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354732 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354742 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 354749 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 354749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 354756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354771 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354803 */     // GIR_Coverage, 4414,
     /* 354803 */     GIR_EraseRootFromParent_Done,
     /* 354804 */   // Label 7148: @354804
     /* 354804 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(354908), // Rule ID 4415 //
     /* 354809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354813 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354819 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354829 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354836 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 354853 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 354853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 354860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354875 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354907 */     // GIR_Coverage, 4415,
     /* 354907 */     GIR_EraseRootFromParent_Done,
     /* 354908 */   // Label 7149: @354908
     /* 354908 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(355008), // Rule ID 4310 //
     /* 354913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354929 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354936 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 354953 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 354953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 354960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354975 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355007 */     // GIR_Coverage, 4310,
     /* 355007 */     GIR_EraseRootFromParent_Done,
     /* 355008 */   // Label 7150: @355008
     /* 355008 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(355108), // Rule ID 4312 //
     /* 355013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355029 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355032 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355036 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 355053 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 355053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 355060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355075 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355107 */     // GIR_Coverage, 4312,
     /* 355107 */     GIR_EraseRootFromParent_Done,
     /* 355108 */   // Label 7151: @355108
     /* 355108 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(355208), // Rule ID 4418 //
     /* 355113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355129 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355132 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355136 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355146 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 355153 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 355153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 355160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355175 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355202 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355207 */     // GIR_Coverage, 4418,
     /* 355207 */     GIR_EraseRootFromParent_Done,
     /* 355208 */   // Label 7152: @355208
     /* 355208 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(355308), // Rule ID 4420 //
     /* 355213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355229 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355232 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355236 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355246 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 355253 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 355253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 355260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355275 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355307 */     // GIR_Coverage, 4420,
     /* 355307 */     GIR_EraseRootFromParent_Done,
     /* 355308 */   // Label 7153: @355308
     /* 355308 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(355428), // Rule ID 6501 //
     /* 355313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355332 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355335 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355339 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 355346 */     // MIs[2] Rn
     /* 355346 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 355350 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 355355 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355361 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 355361 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 355364 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355368 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 355382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355387 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355390 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 355393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 355397 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355410 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355417 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355427 */     // GIR_Coverage, 6501,
     /* 355427 */     GIR_EraseRootFromParent_Done,
     /* 355428 */   // Label 7154: @355428
     /* 355428 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(355548), // Rule ID 6503 //
     /* 355433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355452 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355455 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355459 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 355466 */     // MIs[2] Rn
     /* 355466 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 355470 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 355475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355481 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 355481 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 355484 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355488 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 355502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355507 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 355513 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 355517 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355530 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355547 */     // GIR_Coverage, 6503,
     /* 355547 */     GIR_EraseRootFromParent_Done,
     /* 355548 */   // Label 7155: @355548
     /* 355548 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(355678), // Rule ID 5762 //
     /* 355553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 355569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355586 */     // MIs[2] Operand 1
     /* 355586 */     // No operand predicates
     /* 355586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355594 */     // MIs[3] Operand 1
     /* 355594 */     // No operand predicates
     /* 355594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355596 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355596 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 355599 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355603 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355608 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355611 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355615 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355618 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355623 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 355635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355640 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355660 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355677 */     // GIR_Coverage, 5762,
     /* 355677 */     GIR_EraseRootFromParent_Done,
     /* 355678 */   // Label 7156: @355678
     /* 355678 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(355839), // Rule ID 5763 //
     /* 355683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 355699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355716 */     // MIs[2] Operand 1
     /* 355716 */     // No operand predicates
     /* 355716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355724 */     // MIs[3] Operand 1
     /* 355724 */     // No operand predicates
     /* 355724 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355726 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355726 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 355729 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355733 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355738 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355741 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355745 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 355748 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355753 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355758 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 355761 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355765 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355770 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355773 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355777 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355780 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355785 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 355797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355802 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355808 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355821 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355838 */     // GIR_Coverage, 5763,
     /* 355838 */     GIR_EraseRootFromParent_Done,
     /* 355839 */   // Label 7157: @355839
     /* 355839 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(355969), // Rule ID 5802 //
     /* 355844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 355860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355877 */     // MIs[2] Operand 1
     /* 355877 */     // No operand predicates
     /* 355877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355885 */     // MIs[3] Operand 1
     /* 355885 */     // No operand predicates
     /* 355885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355887 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 355890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355899 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355902 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355906 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355914 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 355926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355937 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355951 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355968 */     // GIR_Coverage, 5802,
     /* 355968 */     GIR_EraseRootFromParent_Done,
     /* 355969 */   // Label 7158: @355969
     /* 355969 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(356130), // Rule ID 5803 //
     /* 355974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 355990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356007 */     // MIs[2] Operand 1
     /* 356007 */     // No operand predicates
     /* 356007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 356011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356015 */     // MIs[3] Operand 1
     /* 356015 */     // No operand predicates
     /* 356015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356017 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 356017 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 356020 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356024 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356029 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 356032 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356036 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 356039 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356044 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356049 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 356052 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356056 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356061 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 356064 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356068 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356071 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356076 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356093 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 356099 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 356105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356112 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356129 */     // GIR_Coverage, 5803,
     /* 356129 */     GIR_EraseRootFromParent_Done,
     /* 356130 */   // Label 7159: @356130
     /* 356130 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(356196), // Rule ID 5713 //
     /* 356135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356147 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356153 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 356153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 356156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 356177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356195 */     // GIR_Coverage, 5713,
     /* 356195 */     GIR_EraseRootFromParent_Done,
     /* 356196 */   // Label 7160: @356196
     /* 356196 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(356262), // Rule ID 5725 //
     /* 356201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356219 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 356219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 356222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 356243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356261 */     // GIR_Coverage, 5725,
     /* 356261 */     GIR_EraseRootFromParent_Done,
     /* 356262 */   // Label 7161: @356262
     /* 356262 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(356397), // Rule ID 5733 //
     /* 356267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 356279 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 356283 */     // MIs[1] Operand 1
     /* 356283 */     // No operand predicates
     /* 356283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 356287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356291 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 356295 */     // MIs[2] Operand 1
     /* 356295 */     // No operand predicates
     /* 356295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356297 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 356297 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 356300 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356304 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356311 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356314 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356318 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356323 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 356326 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 356330 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356333 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356338 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356343 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 356355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356360 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 356366 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 356372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356379 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356396 */     // GIR_Coverage, 5733,
     /* 356396 */     GIR_EraseRootFromParent_Done,
     /* 356397 */   // Label 7162: @356397
     /* 356397 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(356529), // Rule ID 6510 //
     /* 356402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356414 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 356421 */     // MIs[1] Rn
     /* 356421 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 356425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 356430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 356434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356438 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 356442 */     // MIs[2] Operand 1
     /* 356442 */     // No operand predicates
     /* 356442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356444 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 356444 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 356447 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356451 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356456 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 356459 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 356463 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356466 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356471 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 356483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356488 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 356494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356498 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356511 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356528 */     // GIR_Coverage, 6510,
     /* 356528 */     GIR_EraseRootFromParent_Done,
     /* 356529 */   // Label 7163: @356529
     /* 356529 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(356661), // Rule ID 6511 //
     /* 356534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356546 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356549 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 356553 */     // MIs[1] Rn
     /* 356553 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 356557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 356562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 356566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356570 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 356574 */     // MIs[2] Operand 1
     /* 356574 */     // No operand predicates
     /* 356574 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356576 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 356576 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 356579 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356583 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356588 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 356591 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 356595 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356598 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356603 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 356615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356620 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 356626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356630 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356643 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356660 */     // GIR_Coverage, 6511,
     /* 356660 */     GIR_EraseRootFromParent_Done,
     /* 356661 */   // Label 7164: @356661
     /* 356661 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(356844), // Rule ID 5813 //
     /* 356666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 356674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 356678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 356687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356691 */     // MIs[2] Operand 1
     /* 356691 */     // No operand predicates
     /* 356691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356693 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 356693 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 356696 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356700 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 356707 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 356710 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356714 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356719 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 356722 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 356726 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 356729 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356734 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356739 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356744 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 356747 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356751 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356758 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356761 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356765 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356770 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 356773 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356777 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356780 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356785 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356790 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356807 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 356813 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 356816 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 356819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356826 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356838 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356843 */     // GIR_Coverage, 5813,
     /* 356843 */     GIR_EraseRootFromParent_Done,
     /* 356844 */   // Label 7165: @356844
     /* 356844 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(357022), // Rule ID 5736 //
     /* 356849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 356861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 356869 */     // MIs[1] Operand 1
     /* 356869 */     // No operand predicates
     /* 356869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356871 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 356871 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 356874 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356878 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 356885 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 356888 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356892 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356897 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 356900 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 356904 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 356907 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356912 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356917 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356922 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 356925 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356929 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356948 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 356951 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 356955 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356958 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356963 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356968 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356985 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 356991 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 356994 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 356997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357004 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357021 */     // GIR_Coverage, 5736,
     /* 357021 */     GIR_EraseRootFromParent_Done,
     /* 357022 */   // Label 7166: @357022
     /* 357022 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(357147), // Rule ID 5739 //
     /* 357027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 357039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 357047 */     // MIs[1] Operand 1
     /* 357047 */     // No operand predicates
     /* 357047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357049 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 357049 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 357052 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357056 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357063 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 357066 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357070 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357075 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 357078 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357082 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357085 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357090 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357095 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 357107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357112 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 357118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 357122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357129 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357146 */     // GIR_Coverage, 5739,
     /* 357146 */     GIR_EraseRootFromParent_Done,
     /* 357147 */   // Label 7167: @357147
     /* 357147 */   GIM_Reject,
     /* 357148 */ // Label 7137: @357148
     /* 357148 */ GIM_Reject,
     /* 357149 */ // Label 7115: @357149
     /* 357149 */ GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(360389),
     /* 357154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 357157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357160 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357167 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(357276), // Rule ID 4332 //
     /* 357172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357176 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357182 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357192 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357195 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357199 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357209 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 357216 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 357223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357243 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357275 */     // GIR_Coverage, 4332,
     /* 357275 */     GIR_EraseRootFromParent_Done,
     /* 357276 */   // Label 7169: @357276
     /* 357276 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(357385), // Rule ID 4333 //
     /* 357281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357285 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357291 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357301 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357304 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357308 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 357325 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 357332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357352 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357379 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357384 */     // GIR_Coverage, 4333,
     /* 357384 */     GIR_EraseRootFromParent_Done,
     /* 357385 */   // Label 7170: @357385
     /* 357385 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(357494), // Rule ID 4440 //
     /* 357390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357394 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357400 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357410 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357413 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357417 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 357434 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 357441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357461 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357493 */     // GIR_Coverage, 4440,
     /* 357493 */     GIR_EraseRootFromParent_Done,
     /* 357494 */   // Label 7171: @357494
     /* 357494 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(357603), // Rule ID 4441 //
     /* 357499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357503 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357509 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357519 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357522 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357526 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 357543 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 357550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357570 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357602 */     // GIR_Coverage, 4441,
     /* 357602 */     GIR_EraseRootFromParent_Done,
     /* 357603 */   // Label 7172: @357603
     /* 357603 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(357708), // Rule ID 4338 //
     /* 357608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357624 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357631 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357635 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 357648 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 357655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357675 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357707 */     // GIR_Coverage, 4338,
     /* 357707 */     GIR_EraseRootFromParent_Done,
     /* 357708 */   // Label 7173: @357708
     /* 357708 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(357813), // Rule ID 4340 //
     /* 357713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357729 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357732 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357736 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 357753 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 357760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357780 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357812 */     // GIR_Coverage, 4340,
     /* 357812 */     GIR_EraseRootFromParent_Done,
     /* 357813 */   // Label 7174: @357813
     /* 357813 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(357918), // Rule ID 4446 //
     /* 357818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357834 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357837 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357841 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 357858 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 357865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357885 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357917 */     // GIR_Coverage, 4446,
     /* 357917 */     GIR_EraseRootFromParent_Done,
     /* 357918 */   // Label 7175: @357918
     /* 357918 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(358023), // Rule ID 4448 //
     /* 357923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357939 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357946 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 357963 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 357970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357990 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358022 */     // GIR_Coverage, 4448,
     /* 358022 */     GIR_EraseRootFromParent_Done,
     /* 358023 */   // Label 7176: @358023
     /* 358023 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(358127), // Rule ID 4330 //
     /* 358028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358032 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358038 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358048 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358055 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 358072 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 358072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 358079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358094 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358126 */     // GIR_Coverage, 4330,
     /* 358126 */     GIR_EraseRootFromParent_Done,
     /* 358127 */   // Label 7177: @358127
     /* 358127 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(358231), // Rule ID 4331 //
     /* 358132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358136 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358142 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358152 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358155 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358159 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 358176 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 358176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 358183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358198 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358230 */     // GIR_Coverage, 4331,
     /* 358230 */     GIR_EraseRootFromParent_Done,
     /* 358231 */   // Label 7178: @358231
     /* 358231 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(358335), // Rule ID 4438 //
     /* 358236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358240 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358246 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358256 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358259 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358263 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358267 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358273 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 358280 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 358280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 358287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358302 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358334 */     // GIR_Coverage, 4438,
     /* 358334 */     GIR_EraseRootFromParent_Done,
     /* 358335 */   // Label 7179: @358335
     /* 358335 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(358439), // Rule ID 4439 //
     /* 358340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358344 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358350 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358360 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358367 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 358384 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 358384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 358391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358406 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358438 */     // GIR_Coverage, 4439,
     /* 358438 */     GIR_EraseRootFromParent_Done,
     /* 358439 */   // Label 7180: @358439
     /* 358439 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(358539), // Rule ID 4334 //
     /* 358444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358460 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358463 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358467 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 358484 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 358484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 358491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358506 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358538 */     // GIR_Coverage, 4334,
     /* 358538 */     GIR_EraseRootFromParent_Done,
     /* 358539 */   // Label 7181: @358539
     /* 358539 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(358639), // Rule ID 4336 //
     /* 358544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358560 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358563 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358567 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358577 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 358584 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 358584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 358591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358606 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358638 */     // GIR_Coverage, 4336,
     /* 358638 */     GIR_EraseRootFromParent_Done,
     /* 358639 */   // Label 7182: @358639
     /* 358639 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(358739), // Rule ID 4442 //
     /* 358644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358660 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358667 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 358684 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 358684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 358691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358706 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358738 */     // GIR_Coverage, 4442,
     /* 358738 */     GIR_EraseRootFromParent_Done,
     /* 358739 */   // Label 7183: @358739
     /* 358739 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(358839), // Rule ID 4444 //
     /* 358744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358760 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358763 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358767 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358777 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 358784 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 358784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 358791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358806 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358838 */     // GIR_Coverage, 4444,
     /* 358838 */     GIR_EraseRootFromParent_Done,
     /* 358839 */   // Label 7184: @358839
     /* 358839 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(358952), // Rule ID 5768 //
     /* 358844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 358877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358881 */     // MIs[3] Operand 1
     /* 358881 */     // No operand predicates
     /* 358881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358887 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 358887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 358890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 358894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358899 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 358903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 358906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 358911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 358933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358951 */     // GIR_Coverage, 5768,
     /* 358951 */     GIR_EraseRootFromParent_Done,
     /* 358952 */   // Label 7185: @358952
     /* 358952 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(359065), // Rule ID 5808 //
     /* 358957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 358990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358994 */     // MIs[3] Operand 1
     /* 358994 */     // No operand predicates
     /* 358994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359000 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 359000 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 359003 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 359007 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359012 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 359016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 359019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 359046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359064 */     // GIR_Coverage, 5808,
     /* 359064 */     GIR_EraseRootFromParent_Done,
     /* 359065 */   // Label 7186: @359065
     /* 359065 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(359143), // Rule ID 1941 //
     /* 359070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 359102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359106 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359110 */     // MIs[2] Operand 1
     /* 359110 */     // No operand predicates
     /* 359110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359118 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359122 */     // MIs[3] Operand 1
     /* 359122 */     // No operand predicates
     /* 359122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359124 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 359124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 359131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 359134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 359141 */     GIR_RootConstrainSelectedInstOperands,
     /* 359142 */     // GIR_Coverage, 1941,
     /* 359142 */     GIR_EraseRootFromParent_Done,
     /* 359143 */   // Label 7187: @359143
     /* 359143 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(359238), // Rule ID 7490 //
     /* 359148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 359151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 359163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 359167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359175 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 359178 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359182 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 359189 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 359192 */     // MIs[2] Rn
     /* 359192 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 359196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 359201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359209 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359213 */     // MIs[3] Operand 1
     /* 359213 */     // No operand predicates
     /* 359213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359215 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15760>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 359215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 359218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 359222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 359225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 359229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 359236 */     GIR_RootConstrainSelectedInstOperands,
     /* 359237 */     // GIR_Coverage, 7490,
     /* 359237 */     GIR_EraseRootFromParent_Done,
     /* 359238 */   // Label 7188: @359238
     /* 359238 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(359327), // Rule ID 5765 //
     /* 359243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 359255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 359263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359267 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359271 */     // MIs[2] Operand 1
     /* 359271 */     // No operand predicates
     /* 359271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359279 */     // MIs[3] Operand 1
     /* 359279 */     // No operand predicates
     /* 359279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359281 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2f64] } ZPR:{ *:[nxv2f64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 359281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359293 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 359299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 359316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 359319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 359325 */     GIR_RootConstrainSelectedInstOperands,
     /* 359326 */     // GIR_Coverage, 5765,
     /* 359326 */     GIR_EraseRootFromParent_Done,
     /* 359327 */   // Label 7189: @359327
     /* 359327 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(359416), // Rule ID 5805 //
     /* 359332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 359344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 359352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359356 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359360 */     // MIs[2] Operand 1
     /* 359360 */     // No operand predicates
     /* 359360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359368 */     // MIs[3] Operand 1
     /* 359368 */     // No operand predicates
     /* 359368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359370 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 359370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359382 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 359388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 359405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 359408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 359414 */     GIR_RootConstrainSelectedInstOperands,
     /* 359415 */     // GIR_Coverage, 5805,
     /* 359415 */     GIR_EraseRootFromParent_Done,
     /* 359416 */   // Label 7190: @359416
     /* 359416 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(359483), // Rule ID 5767 //
     /* 359421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 359450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359454 */     // MIs[2] Operand 1
     /* 359454 */     // No operand predicates
     /* 359454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359462 */     // MIs[3] Operand 1
     /* 359462 */     // No operand predicates
     /* 359462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359464 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 359464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 359471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 359474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 359481 */     GIR_RootConstrainSelectedInstOperands,
     /* 359482 */     // GIR_Coverage, 5767,
     /* 359482 */     GIR_EraseRootFromParent_Done,
     /* 359483 */   // Label 7191: @359483
     /* 359483 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(359581), // Rule ID 5769 //
     /* 359488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 359504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 359517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359521 */     // MIs[2] Operand 1
     /* 359521 */     // No operand predicates
     /* 359521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359529 */     // MIs[3] Operand 1
     /* 359529 */     // No operand predicates
     /* 359529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359531 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 359531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359543 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 359546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359550 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359568 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 359570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 359573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 359579 */     GIR_RootConstrainSelectedInstOperands,
     /* 359580 */     // GIR_Coverage, 5769,
     /* 359580 */     GIR_EraseRootFromParent_Done,
     /* 359581 */   // Label 7192: @359581
     /* 359581 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(359648), // Rule ID 5807 //
     /* 359586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 359615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359619 */     // MIs[2] Operand 1
     /* 359619 */     // No operand predicates
     /* 359619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359627 */     // MIs[3] Operand 1
     /* 359627 */     // No operand predicates
     /* 359627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359629 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 359629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359634 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 359636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 359639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 359646 */     GIR_RootConstrainSelectedInstOperands,
     /* 359647 */     // GIR_Coverage, 5807,
     /* 359647 */     GIR_EraseRootFromParent_Done,
     /* 359648 */   // Label 7193: @359648
     /* 359648 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(359746), // Rule ID 5809 //
     /* 359653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 359669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 359682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359686 */     // MIs[2] Operand 1
     /* 359686 */     // No operand predicates
     /* 359686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359694 */     // MIs[3] Operand 1
     /* 359694 */     // No operand predicates
     /* 359694 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359696 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 359696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359708 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 359711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359715 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359733 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 359735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 359738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 359744 */     GIR_RootConstrainSelectedInstOperands,
     /* 359745 */     // GIR_Coverage, 5809,
     /* 359745 */     GIR_EraseRootFromParent_Done,
     /* 359746 */   // Label 7194: @359746
     /* 359746 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(359812), // Rule ID 5717 //
     /* 359751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359769 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 359769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 359793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359811 */     // GIR_Coverage, 5717,
     /* 359811 */     GIR_EraseRootFromParent_Done,
     /* 359812 */   // Label 7195: @359812
     /* 359812 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(359878), // Rule ID 5727 //
     /* 359817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359835 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 359835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 359859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359877 */     // GIR_Coverage, 5727,
     /* 359877 */     GIR_EraseRootFromParent_Done,
     /* 359878 */   // Label 7196: @359878
     /* 359878 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(359947), // Rule ID 6492 //
     /* 359883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359895 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 359902 */     // MIs[1] Rn
     /* 359902 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 359906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 359911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 359915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359919 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359923 */     // MIs[2] Operand 1
     /* 359923 */     // No operand predicates
     /* 359923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359925 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 359925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 359928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 359932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 359935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359945 */     GIR_RootConstrainSelectedInstOperands,
     /* 359946 */     // GIR_Coverage, 6492,
     /* 359946 */     GIR_EraseRootFromParent_Done,
     /* 359947 */   // Label 7197: @359947
     /* 359947 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(360016), // Rule ID 6493 //
     /* 359952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359964 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359967 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 359971 */     // MIs[1] Rn
     /* 359971 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 359975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 359980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 359984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359988 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359992 */     // MIs[2] Operand 1
     /* 359992 */     // No operand predicates
     /* 359992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359994 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 359994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 359997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360014 */     GIR_RootConstrainSelectedInstOperands,
     /* 360015 */     // GIR_Coverage, 6493,
     /* 360015 */     GIR_EraseRootFromParent_Done,
     /* 360016 */   // Label 7198: @360016
     /* 360016 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(360098), // Rule ID 7489 //
     /* 360021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 360024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360036 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 360039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 360043 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 360050 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 360053 */     // MIs[1] Rn
     /* 360053 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 360057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 360062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 360066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360074 */     // MIs[2] Operand 1
     /* 360074 */     // No operand predicates
     /* 360074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360076 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15760>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 360076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 360079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360096 */     GIR_RootConstrainSelectedInstOperands,
     /* 360097 */     // GIR_Coverage, 7489,
     /* 360097 */     GIR_EraseRootFromParent_Done,
     /* 360098 */   // Label 7199: @360098
     /* 360098 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(360147), // Rule ID 5734 //
     /* 360103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 360111 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 360115 */     // MIs[1] Operand 1
     /* 360115 */     // No operand predicates
     /* 360115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 360119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360123 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360127 */     // MIs[2] Operand 1
     /* 360127 */     // No operand predicates
     /* 360127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360129 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 360129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 360132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 360139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 360145 */     GIR_RootConstrainSelectedInstOperands,
     /* 360146 */     // GIR_Coverage, 5734,
     /* 360146 */     GIR_EraseRootFromParent_Done,
     /* 360147 */   // Label 7200: @360147
     /* 360147 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(360248), // Rule ID 5814 //
     /* 360152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 360160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 360164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 360173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360177 */     // MIs[2] Operand 1
     /* 360177 */     // No operand predicates
     /* 360177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360179 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 360179 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 360182 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360186 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 360196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360205 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 360212 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 360215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360235 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 360237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 360240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360246 */     GIR_RootConstrainSelectedInstOperands,
     /* 360247 */     // GIR_Coverage, 5814,
     /* 360247 */     GIR_EraseRootFromParent_Done,
     /* 360248 */   // Label 7201: @360248
     /* 360248 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(360292), // Rule ID 1937 //
     /* 360253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 360268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360276 */     // MIs[1] Operand 1
     /* 360276 */     // No operand predicates
     /* 360276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360278 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 360278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 360281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 360288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360290 */     GIR_RootConstrainSelectedInstOperands,
     /* 360291 */     // GIR_Coverage, 1937,
     /* 360291 */     GIR_EraseRootFromParent_Done,
     /* 360292 */   // Label 7202: @360292
     /* 360292 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(360388), // Rule ID 5738 //
     /* 360297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 360309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360317 */     // MIs[1] Operand 1
     /* 360317 */     // No operand predicates
     /* 360317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360319 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 360319 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 360322 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360326 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360345 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 360352 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 360355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 360380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360386 */     GIR_RootConstrainSelectedInstOperands,
     /* 360387 */     // GIR_Coverage, 5738,
     /* 360387 */     GIR_EraseRootFromParent_Done,
     /* 360388 */   // Label 7203: @360388
     /* 360388 */   GIM_Reject,
     /* 360389 */ // Label 7168: @360389
     /* 360389 */ GIM_Reject,
     /* 360390 */ // Label 7116: @360390
     /* 360390 */ GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(364029),
     /* 360395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 360398 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(360524), // Rule ID 4272 //
     /* 360403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360417 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360423 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360433 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360436 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360440 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360447 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360457 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 360464 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 360471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360491 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360523 */     // GIR_Coverage, 4272,
     /* 360523 */     GIR_EraseRootFromParent_Done,
     /* 360524 */   // Label 7205: @360524
     /* 360524 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(360650), // Rule ID 4273 //
     /* 360529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360543 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360549 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360559 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360562 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360566 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360573 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360583 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 360590 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 360597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360617 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360649 */     // GIR_Coverage, 4273,
     /* 360649 */     GIR_EraseRootFromParent_Done,
     /* 360650 */   // Label 7206: @360650
     /* 360650 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(360769), // Rule ID 4380 //
     /* 360655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360669 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360675 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360685 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360688 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360692 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 360709 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 360716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360736 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360768 */     // GIR_Coverage, 4380,
     /* 360768 */     GIR_EraseRootFromParent_Done,
     /* 360769 */   // Label 7207: @360769
     /* 360769 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(360888), // Rule ID 4381 //
     /* 360774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360788 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360794 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360804 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360807 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360811 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 360828 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 360835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360855 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360887 */     // GIR_Coverage, 4381,
     /* 360887 */     GIR_EraseRootFromParent_Done,
     /* 360888 */   // Label 7208: @360888
     /* 360888 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(361010), // Rule ID 4278 //
     /* 360893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360919 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360922 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360926 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360933 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360943 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 360950 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 360957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360977 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361009 */     // GIR_Coverage, 4278,
     /* 361009 */     GIR_EraseRootFromParent_Done,
     /* 361010 */   // Label 7209: @361010
     /* 361010 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(361132), // Rule ID 4280 //
     /* 361015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361041 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361044 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361048 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361055 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 361072 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 361079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361099 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361131 */     // GIR_Coverage, 4280,
     /* 361131 */     GIR_EraseRootFromParent_Done,
     /* 361132 */   // Label 7210: @361132
     /* 361132 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(361247), // Rule ID 4386 //
     /* 361137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361163 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361166 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361170 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361180 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 361187 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 361194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361214 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361246 */     // GIR_Coverage, 4386,
     /* 361246 */     GIR_EraseRootFromParent_Done,
     /* 361247 */   // Label 7211: @361247
     /* 361247 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(361362), // Rule ID 4388 //
     /* 361252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361278 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361281 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361285 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361289 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361295 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 361302 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 361309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361329 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361351 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361361 */     // GIR_Coverage, 4388,
     /* 361361 */     GIR_EraseRootFromParent_Done,
     /* 361362 */   // Label 7212: @361362
     /* 361362 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(361483), // Rule ID 4270 //
     /* 361367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361381 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361387 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361397 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361400 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361404 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361411 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 361428 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 361428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 361435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361450 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361482 */     // GIR_Coverage, 4270,
     /* 361482 */     GIR_EraseRootFromParent_Done,
     /* 361483 */   // Label 7213: @361483
     /* 361483 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(361604), // Rule ID 4271 //
     /* 361488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361502 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361508 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361518 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361521 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361525 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361532 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 361549 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 361549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 361556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361571 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361603 */     // GIR_Coverage, 4271,
     /* 361603 */     GIR_EraseRootFromParent_Done,
     /* 361604 */   // Label 7214: @361604
     /* 361604 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(361718), // Rule ID 4378 //
     /* 361609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361623 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361629 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361639 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361642 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361646 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361656 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 361663 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 361663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 361670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361685 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361717 */     // GIR_Coverage, 4378,
     /* 361717 */     GIR_EraseRootFromParent_Done,
     /* 361718 */   // Label 7215: @361718
     /* 361718 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(361832), // Rule ID 4379 //
     /* 361723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361737 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361743 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361753 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361756 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361760 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361770 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 361777 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 361777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 361784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361799 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361831 */     // GIR_Coverage, 4379,
     /* 361831 */     GIR_EraseRootFromParent_Done,
     /* 361832 */   // Label 7216: @361832
     /* 361832 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(361949), // Rule ID 4274 //
     /* 361837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361863 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361866 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361870 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361877 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 361894 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 361894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 361901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361916 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361948 */     // GIR_Coverage, 4274,
     /* 361948 */     GIR_EraseRootFromParent_Done,
     /* 361949 */   // Label 7217: @361949
     /* 361949 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(362066), // Rule ID 4276 //
     /* 361954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361980 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361983 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361987 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361994 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 362011 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 362011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 362018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362033 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362065 */     // GIR_Coverage, 4276,
     /* 362065 */     GIR_EraseRootFromParent_Done,
     /* 362066 */   // Label 7218: @362066
     /* 362066 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(362176), // Rule ID 4382 //
     /* 362071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362097 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362100 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362104 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 362121 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 362121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 362128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362143 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362170 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362175 */     // GIR_Coverage, 4382,
     /* 362175 */     GIR_EraseRootFromParent_Done,
     /* 362176 */   // Label 7219: @362176
     /* 362176 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(362286), // Rule ID 4384 //
     /* 362181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362207 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362210 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362214 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 362231 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 362231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 362238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362253 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362285 */     // GIR_Coverage, 4384,
     /* 362285 */     GIR_EraseRootFromParent_Done,
     /* 362286 */   // Label 7220: @362286
     /* 362286 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(362416), // Rule ID 6505 //
     /* 362291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362320 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362323 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362327 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 362334 */     // MIs[2] Rn
     /* 362334 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 362338 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 362343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362349 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 362349 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 362352 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362356 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 362370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362375 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362378 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 362381 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 362385 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362398 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362410 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362415 */     // GIR_Coverage, 6505,
     /* 362415 */     GIR_EraseRootFromParent_Done,
     /* 362416 */   // Label 7221: @362416
     /* 362416 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(362556), // Rule ID 5754 //
     /* 362421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362464 */     // MIs[2] Operand 1
     /* 362464 */     // No operand predicates
     /* 362464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 362468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362472 */     // MIs[3] Operand 1
     /* 362472 */     // No operand predicates
     /* 362472 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362474 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 362474 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 362477 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362481 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362486 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 362489 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 362493 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362496 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362501 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 362513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362518 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 362524 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 362531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362538 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362555 */     // GIR_Coverage, 5754,
     /* 362555 */     GIR_EraseRootFromParent_Done,
     /* 362556 */   // Label 7222: @362556
     /* 362556 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(362727), // Rule ID 5755 //
     /* 362561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 362587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362604 */     // MIs[2] Operand 1
     /* 362604 */     // No operand predicates
     /* 362604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 362608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362612 */     // MIs[3] Operand 1
     /* 362612 */     // No operand predicates
     /* 362612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362614 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 362614 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 362617 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362621 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362626 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 362629 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362633 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 362636 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362641 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 362649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362658 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 362661 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 362665 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362673 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 362685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362690 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 362696 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 362699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 362702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362709 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362726 */     // GIR_Coverage, 5755,
     /* 362726 */     GIR_EraseRootFromParent_Done,
     /* 362727 */   // Label 7223: @362727
     /* 362727 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(362867), // Rule ID 5794 //
     /* 362732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362775 */     // MIs[2] Operand 1
     /* 362775 */     // No operand predicates
     /* 362775 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 362779 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362783 */     // MIs[3] Operand 1
     /* 362783 */     // No operand predicates
     /* 362783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362785 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 362785 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 362788 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362792 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362797 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 362800 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 362804 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362807 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362812 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 362824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362829 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 362835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 362842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362849 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362866 */     // GIR_Coverage, 5794,
     /* 362866 */     GIR_EraseRootFromParent_Done,
     /* 362867 */   // Label 7224: @362867
     /* 362867 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(363038), // Rule ID 5795 //
     /* 362872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 362898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362915 */     // MIs[2] Operand 1
     /* 362915 */     // No operand predicates
     /* 362915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 362919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362923 */     // MIs[3] Operand 1
     /* 362923 */     // No operand predicates
     /* 362923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362925 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 362925 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 362928 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362932 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362937 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 362940 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362944 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 362947 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362952 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362957 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 362960 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362964 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362969 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 362972 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 362976 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362984 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 362996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363001 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 363007 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 363010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 363013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363020 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363037 */     // GIR_Coverage, 5795,
     /* 363037 */     GIR_EraseRootFromParent_Done,
     /* 363038 */   // Label 7225: @363038
     /* 363038 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(363117), // Rule ID 5707 //
     /* 363043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363071 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 363071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363083 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 363087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 363106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363116 */     // GIR_Coverage, 5707,
     /* 363116 */     GIR_EraseRootFromParent_Done,
     /* 363117 */   // Label 7226: @363117
     /* 363117 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(363193), // Rule ID 5709 //
     /* 363122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363150 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 363150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 363153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363182 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363192 */     // GIR_Coverage, 5709,
     /* 363192 */     GIR_EraseRootFromParent_Done,
     /* 363193 */   // Label 7227: @363193
     /* 363193 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(363269), // Rule ID 5719 //
     /* 363198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363226 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 363226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 363229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363268 */     // GIR_Coverage, 5719,
     /* 363268 */     GIR_EraseRootFromParent_Done,
     /* 363269 */   // Label 7228: @363269
     /* 363269 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(363414), // Rule ID 5731 //
     /* 363274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 363296 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 363300 */     // MIs[1] Operand 1
     /* 363300 */     // No operand predicates
     /* 363300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 363304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363308 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363312 */     // MIs[2] Operand 1
     /* 363312 */     // No operand predicates
     /* 363312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363314 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 363314 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 363317 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363321 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 363328 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 363331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363335 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363340 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 363343 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 363347 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363355 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363360 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 363372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363377 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 363383 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363396 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363413 */     // GIR_Coverage, 5731,
     /* 363413 */     GIR_EraseRootFromParent_Done,
     /* 363414 */   // Label 7229: @363414
     /* 363414 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(363563), // Rule ID 6509 //
     /* 363419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363441 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363444 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 363448 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363455 */     // MIs[1] Rn
     /* 363455 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 363459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 363464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 363468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363472 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363476 */     // MIs[2] Operand 1
     /* 363476 */     // No operand predicates
     /* 363476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363478 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 363478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 363481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363490 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 363493 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 363497 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 363517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 363528 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 363532 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363545 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363562 */     // GIR_Coverage, 6509,
     /* 363562 */     GIR_EraseRootFromParent_Done,
     /* 363563 */   // Label 7230: @363563
     /* 363563 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(363705), // Rule ID 6512 //
     /* 363568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 363597 */     // MIs[1] Rn
     /* 363597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 363601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 363606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 363610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363614 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363618 */     // MIs[2] Operand 1
     /* 363618 */     // No operand predicates
     /* 363618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363620 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 363620 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 363623 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363627 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363632 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 363635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 363639 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363647 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 363659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363664 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 363670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 363674 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363687 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363704 */     // GIR_Coverage, 6512,
     /* 363704 */     GIR_EraseRootFromParent_Done,
     /* 363705 */   // Label 7231: @363705
     /* 363705 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(363893), // Rule ID 5729 //
     /* 363710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 363732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 363740 */     // MIs[1] Operand 1
     /* 363740 */     // No operand predicates
     /* 363740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363742 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 363742 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 363745 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363749 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 363756 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 363759 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363763 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363768 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 363771 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 363775 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 363778 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363783 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363788 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363793 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 363796 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363800 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 363807 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 363810 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363814 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363819 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 363822 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 363826 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363829 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363834 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363839 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 363851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363856 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 363862 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 363865 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 363868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363875 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363892 */     // GIR_Coverage, 5729,
     /* 363892 */     GIR_EraseRootFromParent_Done,
     /* 363893 */   // Label 7232: @363893
     /* 363893 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(364028), // Rule ID 5740 //
     /* 363898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 363920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363928 */     // MIs[1] Operand 1
     /* 363928 */     // No operand predicates
     /* 363928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363930 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 363930 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 363933 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363937 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 363944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 363947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363956 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 363959 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 363963 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363966 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363976 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 363988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363993 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 363999 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 364003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364010 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364027 */     // GIR_Coverage, 5740,
     /* 364027 */     GIR_EraseRootFromParent_Done,
     /* 364028 */   // Label 7233: @364028
     /* 364028 */   GIM_Reject,
     /* 364029 */ // Label 7204: @364029
     /* 364029 */ GIM_Reject,
     /* 364030 */ // Label 7117: @364030
     /* 364030 */ GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(367097),
     /* 364035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 364038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364048 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(364157), // Rule ID 4296 //
     /* 364053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364057 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364063 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364073 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364076 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364080 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364090 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 364097 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 364104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364124 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364146 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364156 */     // GIR_Coverage, 4296,
     /* 364156 */     GIR_EraseRootFromParent_Done,
     /* 364157 */   // Label 7235: @364157
     /* 364157 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(364266), // Rule ID 4297 //
     /* 364162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364166 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364172 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364182 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364189 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364193 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 364206 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 364213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364233 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364265 */     // GIR_Coverage, 4297,
     /* 364265 */     GIR_EraseRootFromParent_Done,
     /* 364266 */   // Label 7236: @364266
     /* 364266 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(364375), // Rule ID 4404 //
     /* 364271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364275 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364281 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364291 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364294 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364298 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 364315 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 364322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364342 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364364 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364374 */     // GIR_Coverage, 4404,
     /* 364374 */     GIR_EraseRootFromParent_Done,
     /* 364375 */   // Label 7237: @364375
     /* 364375 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(364484), // Rule ID 4405 //
     /* 364380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364384 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364390 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364400 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364403 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364407 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 364424 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 364431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364451 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364483 */     // GIR_Coverage, 4405,
     /* 364483 */     GIR_EraseRootFromParent_Done,
     /* 364484 */   // Label 7238: @364484
     /* 364484 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(364589), // Rule ID 4302 //
     /* 364489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364505 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364508 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364512 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364522 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 364529 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 364536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364556 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364578 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364588 */     // GIR_Coverage, 4302,
     /* 364588 */     GIR_EraseRootFromParent_Done,
     /* 364589 */   // Label 7239: @364589
     /* 364589 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(364694), // Rule ID 4304 //
     /* 364594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364610 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364613 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364617 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 364634 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 364641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364661 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364693 */     // GIR_Coverage, 4304,
     /* 364693 */     GIR_EraseRootFromParent_Done,
     /* 364694 */   // Label 7240: @364694
     /* 364694 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(364799), // Rule ID 4410 //
     /* 364699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364715 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364718 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364722 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 364739 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 364746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364766 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364798 */     // GIR_Coverage, 4410,
     /* 364798 */     GIR_EraseRootFromParent_Done,
     /* 364799 */   // Label 7241: @364799
     /* 364799 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(364904), // Rule ID 4412 //
     /* 364804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364820 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364827 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 364844 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 364851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364871 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364903 */     // GIR_Coverage, 4412,
     /* 364903 */     GIR_EraseRootFromParent_Done,
     /* 364904 */   // Label 7242: @364904
     /* 364904 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(365008), // Rule ID 4294 //
     /* 364909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364913 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364919 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364929 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364936 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 364953 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 364953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 364960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364975 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365007 */     // GIR_Coverage, 4294,
     /* 365007 */     GIR_EraseRootFromParent_Done,
     /* 365008 */   // Label 7243: @365008
     /* 365008 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(365112), // Rule ID 4295 //
     /* 365013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365017 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365023 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365033 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365036 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365040 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 365057 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 365057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 365064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365079 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365111 */     // GIR_Coverage, 4295,
     /* 365111 */     GIR_EraseRootFromParent_Done,
     /* 365112 */   // Label 7244: @365112
     /* 365112 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(365216), // Rule ID 4402 //
     /* 365117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365121 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365127 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365137 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365140 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365144 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 365161 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 365161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 365168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365183 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365215 */     // GIR_Coverage, 4402,
     /* 365215 */     GIR_EraseRootFromParent_Done,
     /* 365216 */   // Label 7245: @365216
     /* 365216 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(365320), // Rule ID 4403 //
     /* 365221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365225 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365231 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365241 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365244 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365248 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365258 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 365265 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 365265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 365272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365287 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365319 */     // GIR_Coverage, 4403,
     /* 365319 */     GIR_EraseRootFromParent_Done,
     /* 365320 */   // Label 7246: @365320
     /* 365320 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(365420), // Rule ID 4298 //
     /* 365325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365341 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365344 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365348 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365358 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 365365 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 365365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 365372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365387 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365419 */     // GIR_Coverage, 4298,
     /* 365419 */     GIR_EraseRootFromParent_Done,
     /* 365420 */   // Label 7247: @365420
     /* 365420 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(365520), // Rule ID 4300 //
     /* 365425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365441 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365444 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365448 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 365465 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 365465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 365472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365487 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365519 */     // GIR_Coverage, 4300,
     /* 365519 */     GIR_EraseRootFromParent_Done,
     /* 365520 */   // Label 7248: @365520
     /* 365520 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(365620), // Rule ID 4406 //
     /* 365525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365541 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365544 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365548 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365558 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 365565 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 365565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 365572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365587 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365619 */     // GIR_Coverage, 4406,
     /* 365619 */     GIR_EraseRootFromParent_Done,
     /* 365620 */   // Label 7249: @365620
     /* 365620 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(365720), // Rule ID 4408 //
     /* 365625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365641 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365648 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365658 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 365665 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 365665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 365672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365687 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365719 */     // GIR_Coverage, 4408,
     /* 365719 */     GIR_EraseRootFromParent_Done,
     /* 365720 */   // Label 7250: @365720
     /* 365720 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(365833), // Rule ID 5760 //
     /* 365725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365762 */     // MIs[3] Operand 1
     /* 365762 */     // No operand predicates
     /* 365762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365768 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 365768 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 365771 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 365775 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365780 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 365784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 365787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 365814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365817 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365822 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365832 */     // GIR_Coverage, 5760,
     /* 365832 */     GIR_EraseRootFromParent_Done,
     /* 365833 */   // Label 7251: @365833
     /* 365833 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(365946), // Rule ID 5800 //
     /* 365838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365875 */     // MIs[3] Operand 1
     /* 365875 */     // No operand predicates
     /* 365875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365879 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365881 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 365881 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 365884 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 365888 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 365897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 365900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 365927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365945 */     // GIR_Coverage, 5800,
     /* 365945 */     GIR_EraseRootFromParent_Done,
     /* 365946 */   // Label 7252: @365946
     /* 365946 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(366024), // Rule ID 1940 //
     /* 365951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365987 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365991 */     // MIs[2] Operand 1
     /* 365991 */     // No operand predicates
     /* 365991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365999 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366003 */     // MIs[3] Operand 1
     /* 366003 */     // No operand predicates
     /* 366003 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366005 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 366005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 366012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 366015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 366022 */     GIR_RootConstrainSelectedInstOperands,
     /* 366023 */     // GIR_Coverage, 1940,
     /* 366023 */     GIR_EraseRootFromParent_Done,
     /* 366024 */   // Label 7253: @366024
     /* 366024 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(366113), // Rule ID 5757 //
     /* 366029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366053 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366057 */     // MIs[2] Operand 1
     /* 366057 */     // No operand predicates
     /* 366057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366065 */     // MIs[3] Operand 1
     /* 366065 */     // No operand predicates
     /* 366065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366067 */     // (vector_insert:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4f32] } ZPR:{ *:[nxv4f32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 366067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366079 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 366085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 366105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 366111 */     GIR_RootConstrainSelectedInstOperands,
     /* 366112 */     // GIR_Coverage, 5757,
     /* 366112 */     GIR_EraseRootFromParent_Done,
     /* 366113 */   // Label 7254: @366113
     /* 366113 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(366202), // Rule ID 5797 //
     /* 366118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366142 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366146 */     // MIs[2] Operand 1
     /* 366146 */     // No operand predicates
     /* 366146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366154 */     // MIs[3] Operand 1
     /* 366154 */     // No operand predicates
     /* 366154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366156 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 366156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366168 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 366174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 366194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 366200 */     GIR_RootConstrainSelectedInstOperands,
     /* 366201 */     // GIR_Coverage, 5797,
     /* 366201 */     GIR_EraseRootFromParent_Done,
     /* 366202 */   // Label 7255: @366202
     /* 366202 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(366269), // Rule ID 5759 //
     /* 366207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366240 */     // MIs[2] Operand 1
     /* 366240 */     // No operand predicates
     /* 366240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366248 */     // MIs[3] Operand 1
     /* 366248 */     // No operand predicates
     /* 366248 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366250 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 366250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366255 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 366257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 366260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 366267 */     GIR_RootConstrainSelectedInstOperands,
     /* 366268 */     // GIR_Coverage, 5759,
     /* 366268 */     GIR_EraseRootFromParent_Done,
     /* 366269 */   // Label 7256: @366269
     /* 366269 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(366367), // Rule ID 5761 //
     /* 366274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 366290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366307 */     // MIs[2] Operand 1
     /* 366307 */     // No operand predicates
     /* 366307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366315 */     // MIs[3] Operand 1
     /* 366315 */     // No operand predicates
     /* 366315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366317 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 366317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366329 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 366332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366336 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 366339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366354 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 366356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 366359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 366365 */     GIR_RootConstrainSelectedInstOperands,
     /* 366366 */     // GIR_Coverage, 5761,
     /* 366366 */     GIR_EraseRootFromParent_Done,
     /* 366367 */   // Label 7257: @366367
     /* 366367 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(366434), // Rule ID 5799 //
     /* 366372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366405 */     // MIs[2] Operand 1
     /* 366405 */     // No operand predicates
     /* 366405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366413 */     // MIs[3] Operand 1
     /* 366413 */     // No operand predicates
     /* 366413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366415 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 366415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366420 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 366422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 366425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 366432 */     GIR_RootConstrainSelectedInstOperands,
     /* 366433 */     // GIR_Coverage, 5799,
     /* 366433 */     GIR_EraseRootFromParent_Done,
     /* 366434 */   // Label 7258: @366434
     /* 366434 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(366532), // Rule ID 5801 //
     /* 366439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 366455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366472 */     // MIs[2] Operand 1
     /* 366472 */     // No operand predicates
     /* 366472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366480 */     // MIs[3] Operand 1
     /* 366480 */     // No operand predicates
     /* 366480 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366482 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 366482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366494 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 366497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366501 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 366504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 366521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 366524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 366530 */     GIR_RootConstrainSelectedInstOperands,
     /* 366531 */     // GIR_Coverage, 5801,
     /* 366531 */     GIR_EraseRootFromParent_Done,
     /* 366532 */   // Label 7259: @366532
     /* 366532 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(366598), // Rule ID 5715 //
     /* 366537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366555 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 366555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366587 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366597 */     // GIR_Coverage, 5715,
     /* 366597 */     GIR_EraseRootFromParent_Done,
     /* 366598 */   // Label 7260: @366598
     /* 366598 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(366664), // Rule ID 5723 //
     /* 366603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366615 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366621 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 366621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366663 */     // GIR_Coverage, 5723,
     /* 366663 */     GIR_EraseRootFromParent_Done,
     /* 366664 */   // Label 7261: @366664
     /* 366664 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(366717), // Rule ID 5732 //
     /* 366669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 366681 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 366685 */     // MIs[1] Operand 1
     /* 366685 */     // No operand predicates
     /* 366685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366693 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366697 */     // MIs[2] Operand 1
     /* 366697 */     // No operand predicates
     /* 366697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366699 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 366699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 366702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 366709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366715 */     GIR_RootConstrainSelectedInstOperands,
     /* 366716 */     // GIR_Coverage, 5732,
     /* 366716 */     GIR_EraseRootFromParent_Done,
     /* 366717 */   // Label 7262: @366717
     /* 366717 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(366786), // Rule ID 6490 //
     /* 366722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366734 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366737 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 366741 */     // MIs[1] Rn
     /* 366741 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 366745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 366750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366758 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366762 */     // MIs[2] Operand 1
     /* 366762 */     // No operand predicates
     /* 366762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366764 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 366764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 366767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 366771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366784 */     GIR_RootConstrainSelectedInstOperands,
     /* 366785 */     // GIR_Coverage, 6490,
     /* 366785 */     GIR_EraseRootFromParent_Done,
     /* 366786 */   // Label 7263: @366786
     /* 366786 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(366855), // Rule ID 6491 //
     /* 366791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366803 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366806 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 366810 */     // MIs[1] Rn
     /* 366810 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 366814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 366819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366827 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366831 */     // MIs[2] Operand 1
     /* 366831 */     // No operand predicates
     /* 366831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366833 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 366833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 366836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 366840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366853 */     GIR_RootConstrainSelectedInstOperands,
     /* 366854 */     // GIR_Coverage, 6491,
     /* 366854 */     GIR_EraseRootFromParent_Done,
     /* 366855 */   // Label 7264: @366855
     /* 366855 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(366956), // Rule ID 5812 //
     /* 366860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 366868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366885 */     // MIs[2] Operand 1
     /* 366885 */     // No operand predicates
     /* 366885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366887 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 366887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 366890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366913 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 366920 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 366923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366943 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 366945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 366948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366954 */     GIR_RootConstrainSelectedInstOperands,
     /* 366955 */     // GIR_Coverage, 5812,
     /* 366955 */     GIR_EraseRootFromParent_Done,
     /* 366956 */   // Label 7265: @366956
     /* 366956 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(367000), // Rule ID 1936 //
     /* 366961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 366976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366984 */     // MIs[1] Operand 1
     /* 366984 */     // No operand predicates
     /* 366984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366986 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 366986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 366989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 366993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 366996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366998 */     GIR_RootConstrainSelectedInstOperands,
     /* 366999 */     // GIR_Coverage, 1936,
     /* 366999 */     GIR_EraseRootFromParent_Done,
     /* 367000 */   // Label 7266: @367000
     /* 367000 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(367096), // Rule ID 5737 //
     /* 367005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 367017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367025 */     // MIs[1] Operand 1
     /* 367025 */     // No operand predicates
     /* 367025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367027 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 367027 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 367030 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367034 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 367041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367053 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 367056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 367060 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 367063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 367088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367094 */     GIR_RootConstrainSelectedInstOperands,
     /* 367095 */     // GIR_Coverage, 5737,
     /* 367095 */     GIR_EraseRootFromParent_Done,
     /* 367096 */   // Label 7267: @367096
     /* 367096 */   GIM_Reject,
     /* 367097 */ // Label 7234: @367097
     /* 367097 */ GIM_Reject,
     /* 367098 */ // Label 7118: @367098
     /* 367098 */ GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(370310),
     /* 367103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 367106 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(367225), // Rule ID 4200 //
     /* 367111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367125 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367131 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367141 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367144 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367148 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 367165 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 367172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367192 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367224 */     // GIR_Coverage, 4200,
     /* 367224 */     GIR_EraseRootFromParent_Done,
     /* 367225 */   // Label 7269: @367225
     /* 367225 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(367344), // Rule ID 4201 //
     /* 367230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367244 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367250 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367260 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367267 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367277 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 367284 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 367291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367311 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367343 */     // GIR_Coverage, 4201,
     /* 367343 */     GIR_EraseRootFromParent_Done,
     /* 367344 */   // Label 7270: @367344
     /* 367344 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(367470), // Rule ID 4236 //
     /* 367349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367363 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367369 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367379 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367382 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367386 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 367393 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367403 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 367410 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 367417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367437 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367469 */     // GIR_Coverage, 4236,
     /* 367469 */     GIR_EraseRootFromParent_Done,
     /* 367470 */   // Label 7271: @367470
     /* 367470 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(367596), // Rule ID 4237 //
     /* 367475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367489 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367495 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367505 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367508 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367512 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 367519 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 367536 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 367543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367563 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367595 */     // GIR_Coverage, 4237,
     /* 367595 */     GIR_EraseRootFromParent_Done,
     /* 367596 */   // Label 7272: @367596
     /* 367596 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(367711), // Rule ID 4206 //
     /* 367601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367627 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367630 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367634 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 367651 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 367658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367678 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367710 */     // GIR_Coverage, 4206,
     /* 367710 */     GIR_EraseRootFromParent_Done,
     /* 367711 */   // Label 7273: @367711
     /* 367711 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(367826), // Rule ID 4208 //
     /* 367716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367742 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367745 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367749 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 367766 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 367773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367793 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367825 */     // GIR_Coverage, 4208,
     /* 367825 */     GIR_EraseRootFromParent_Done,
     /* 367826 */   // Label 7274: @367826
     /* 367826 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(367948), // Rule ID 4242 //
     /* 367831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367857 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367860 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367864 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 367871 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 367888 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 367895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367915 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367947 */     // GIR_Coverage, 4242,
     /* 367947 */     GIR_EraseRootFromParent_Done,
     /* 367948 */   // Label 7275: @367948
     /* 367948 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(368070), // Rule ID 4244 //
     /* 367953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367979 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367982 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367986 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 367993 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367997 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368003 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 368010 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 368017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368037 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368069 */     // GIR_Coverage, 4244,
     /* 368069 */     GIR_EraseRootFromParent_Done,
     /* 368070 */   // Label 7276: @368070
     /* 368070 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(368184), // Rule ID 4198 //
     /* 368075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368089 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368095 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368105 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368108 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368112 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 368129 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 368129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 368136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368151 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368183 */     // GIR_Coverage, 4198,
     /* 368183 */     GIR_EraseRootFromParent_Done,
     /* 368184 */   // Label 7277: @368184
     /* 368184 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(368298), // Rule ID 4199 //
     /* 368189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368203 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368209 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368219 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368222 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368226 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368236 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 368243 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 368243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 368250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368265 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368292 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368297 */     // GIR_Coverage, 4199,
     /* 368297 */     GIR_EraseRootFromParent_Done,
     /* 368298 */   // Label 7278: @368298
     /* 368298 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(368419), // Rule ID 4234 //
     /* 368303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368317 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368323 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368333 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368336 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368340 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368347 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368357 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 368364 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 368364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 368371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368386 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368418 */     // GIR_Coverage, 4234,
     /* 368418 */     GIR_EraseRootFromParent_Done,
     /* 368419 */   // Label 7279: @368419
     /* 368419 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(368540), // Rule ID 4235 //
     /* 368424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368438 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368444 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368454 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368457 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368461 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368468 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 368485 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 368485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 368492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368507 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368539 */     // GIR_Coverage, 4235,
     /* 368539 */     GIR_EraseRootFromParent_Done,
     /* 368540 */   // Label 7280: @368540
     /* 368540 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(368650), // Rule ID 4202 //
     /* 368545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368571 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368574 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368578 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 368595 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 368595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 368602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368617 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368649 */     // GIR_Coverage, 4202,
     /* 368649 */     GIR_EraseRootFromParent_Done,
     /* 368650 */   // Label 7281: @368650
     /* 368650 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(368760), // Rule ID 4204 //
     /* 368655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368681 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368688 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 368705 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 368705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 368712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368727 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368759 */     // GIR_Coverage, 4204,
     /* 368759 */     GIR_EraseRootFromParent_Done,
     /* 368760 */   // Label 7282: @368760
     /* 368760 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(368877), // Rule ID 4238 //
     /* 368765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368791 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368794 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368798 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368805 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368815 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 368822 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 368822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 368829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368844 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368866 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368876 */     // GIR_Coverage, 4238,
     /* 368876 */     GIR_EraseRootFromParent_Done,
     /* 368877 */   // Label 7283: @368877
     /* 368877 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(368994), // Rule ID 4240 //
     /* 368882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368908 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368911 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368915 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368922 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368926 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368932 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 368939 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 368939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 368946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368961 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368993 */     // GIR_Coverage, 4240,
     /* 368993 */     GIR_EraseRootFromParent_Done,
     /* 368994 */   // Label 7284: @368994
     /* 368994 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(369134), // Rule ID 5778 //
     /* 368999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 369025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369042 */     // MIs[2] Operand 1
     /* 369042 */     // No operand predicates
     /* 369042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 369046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369050 */     // MIs[3] Operand 1
     /* 369050 */     // No operand predicates
     /* 369050 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369052 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 369052 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 369055 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369059 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369064 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369067 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369071 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369074 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369079 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 369091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369096 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 369102 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 369109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369116 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369133 */     // GIR_Coverage, 5778,
     /* 369133 */     GIR_EraseRootFromParent_Done,
     /* 369134 */   // Label 7285: @369134
     /* 369134 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(369305), // Rule ID 5779 //
     /* 369139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 369165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369182 */     // MIs[2] Operand 1
     /* 369182 */     // No operand predicates
     /* 369182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 369186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369190 */     // MIs[3] Operand 1
     /* 369190 */     // No operand predicates
     /* 369190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369192 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 369192 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 369195 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369199 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369204 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 369207 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369211 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 369214 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369219 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369224 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369227 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369231 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369236 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369239 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369243 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369246 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369251 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 369263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369268 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 369274 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 369277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 369280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369287 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369304 */     // GIR_Coverage, 5779,
     /* 369304 */     GIR_EraseRootFromParent_Done,
     /* 369305 */   // Label 7286: @369305
     /* 369305 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(369445), // Rule ID 5786 //
     /* 369310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 369336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369353 */     // MIs[2] Operand 1
     /* 369353 */     // No operand predicates
     /* 369353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 369357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369361 */     // MIs[3] Operand 1
     /* 369361 */     // No operand predicates
     /* 369361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369363 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 369363 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 369366 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369370 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369375 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369378 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369382 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369385 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369390 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 369402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369407 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 369413 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 369420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369427 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369444 */     // GIR_Coverage, 5786,
     /* 369444 */     GIR_EraseRootFromParent_Done,
     /* 369445 */   // Label 7287: @369445
     /* 369445 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(369616), // Rule ID 5787 //
     /* 369450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 369476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369493 */     // MIs[2] Operand 1
     /* 369493 */     // No operand predicates
     /* 369493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 369497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369501 */     // MIs[3] Operand 1
     /* 369501 */     // No operand predicates
     /* 369501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369503 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 369503 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 369506 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369510 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369515 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 369518 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369522 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 369525 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369530 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369535 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369538 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369542 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369547 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369550 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369554 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369557 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369562 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 369574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369579 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 369585 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 369588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 369591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369598 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369615 */     // GIR_Coverage, 5787,
     /* 369615 */     GIR_EraseRootFromParent_Done,
     /* 369616 */   // Label 7288: @369616
     /* 369616 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(369695), // Rule ID 5702 //
     /* 369621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 369643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369649 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 369649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 369652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369661 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 369665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 369684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369694 */     // GIR_Coverage, 5702,
     /* 369694 */     GIR_EraseRootFromParent_Done,
     /* 369695 */   // Label 7289: @369695
     /* 369695 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(369837), // Rule ID 6507 //
     /* 369700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369722 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369725 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 369729 */     // MIs[1] Rn
     /* 369729 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 369733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 369738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 369742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369746 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 369750 */     // MIs[2] Operand 1
     /* 369750 */     // No operand predicates
     /* 369750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369752 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 369752 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369755 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369759 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369764 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369767 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 369771 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369774 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369779 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 369791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369796 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 369802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369806 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369819 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369836 */     // GIR_Coverage, 6507,
     /* 369836 */     GIR_EraseRootFromParent_Done,
     /* 369837 */   // Label 7290: @369837
     /* 369837 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(369986), // Rule ID 6508 //
     /* 369842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369864 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369867 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 369871 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369878 */     // MIs[1] Rn
     /* 369878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 369882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 369887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 369891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369895 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 369899 */     // MIs[2] Operand 1
     /* 369899 */     // No operand predicates
     /* 369899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369901 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 369901 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369904 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369908 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369913 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369916 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 369920 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369923 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369928 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 369940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369945 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 369951 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369955 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369968 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369985 */     // GIR_Coverage, 6508,
     /* 369985 */     GIR_EraseRootFromParent_Done,
     /* 369986 */   // Label 7291: @369986
     /* 369986 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(370121), // Rule ID 5741 //
     /* 369991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 370009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 370013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 370021 */     // MIs[1] Operand 1
     /* 370021 */     // No operand predicates
     /* 370021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370023 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 370023 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 370026 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370030 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 370037 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 370040 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370044 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370049 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 370052 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 370056 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370059 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370064 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370069 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 370081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370086 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 370092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 370096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370103 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370120 */     // GIR_Coverage, 5741,
     /* 370120 */     GIR_EraseRootFromParent_Done,
     /* 370121 */   // Label 7292: @370121
     /* 370121 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(370309), // Rule ID 5742 //
     /* 370126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 370148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 370156 */     // MIs[1] Operand 1
     /* 370156 */     // No operand predicates
     /* 370156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370158 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 370158 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 370161 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370165 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 370172 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 370175 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370179 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370184 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 370187 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 370191 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 370194 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370199 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370204 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370209 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 370212 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370216 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 370223 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 370226 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370230 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370235 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 370238 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 370242 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370245 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370250 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370255 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 370267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370272 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 370278 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 370281 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 370284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370291 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370308 */     // GIR_Coverage, 5742,
     /* 370308 */     GIR_EraseRootFromParent_Done,
     /* 370309 */   // Label 7293: @370309
     /* 370309 */   GIM_Reject,
     /* 370310 */ // Label 7268: @370310
     /* 370310 */ GIM_Reject,
     /* 370311 */ // Label 7119: @370311
     /* 370311 */ GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(373729),
     /* 370316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370319 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(370445), // Rule ID 4260 //
     /* 370324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370338 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370344 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370354 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370357 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370361 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 370368 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370378 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 370385 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 370392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370412 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370444 */     // GIR_Coverage, 4260,
     /* 370444 */     GIR_EraseRootFromParent_Done,
     /* 370445 */   // Label 7295: @370445
     /* 370445 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(370571), // Rule ID 4261 //
     /* 370450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370464 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370470 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370480 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370483 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370487 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 370494 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370498 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370504 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 370511 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 370518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370538 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370570 */     // GIR_Coverage, 4261,
     /* 370570 */     GIR_EraseRootFromParent_Done,
     /* 370571 */   // Label 7296: @370571
     /* 370571 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(370690), // Rule ID 4368 //
     /* 370576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370590 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370596 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370606 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370609 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370613 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370623 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 370630 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 370637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370657 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370689 */     // GIR_Coverage, 4368,
     /* 370689 */     GIR_EraseRootFromParent_Done,
     /* 370690 */   // Label 7297: @370690
     /* 370690 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(370809), // Rule ID 4369 //
     /* 370695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370709 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370715 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370725 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370728 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370732 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370742 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 370749 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 370756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370776 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370803 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370808 */     // GIR_Coverage, 4369,
     /* 370808 */     GIR_EraseRootFromParent_Done,
     /* 370809 */   // Label 7298: @370809
     /* 370809 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(370931), // Rule ID 4266 //
     /* 370814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370840 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370843 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370847 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 370854 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 370871 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 370878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370898 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370930 */     // GIR_Coverage, 4266,
     /* 370930 */     GIR_EraseRootFromParent_Done,
     /* 370931 */   // Label 7299: @370931
     /* 370931 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(371053), // Rule ID 4268 //
     /* 370936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370962 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370965 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370969 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 370976 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 370993 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 371000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371020 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371052 */     // GIR_Coverage, 4268,
     /* 371052 */     GIR_EraseRootFromParent_Done,
     /* 371053 */   // Label 7300: @371053
     /* 371053 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(371168), // Rule ID 4374 //
     /* 371058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371084 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371087 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371091 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 371108 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 371115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371135 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371157 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371167 */     // GIR_Coverage, 4374,
     /* 371167 */     GIR_EraseRootFromParent_Done,
     /* 371168 */   // Label 7301: @371168
     /* 371168 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(371283), // Rule ID 4376 //
     /* 371173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371199 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371202 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371206 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371216 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 371223 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 371230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371250 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371282 */     // GIR_Coverage, 4376,
     /* 371282 */     GIR_EraseRootFromParent_Done,
     /* 371283 */   // Label 7302: @371283
     /* 371283 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(371404), // Rule ID 4258 //
     /* 371288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371302 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371308 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371318 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371321 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371325 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371332 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 371349 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 371349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 371356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371371 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371403 */     // GIR_Coverage, 4258,
     /* 371403 */     GIR_EraseRootFromParent_Done,
     /* 371404 */   // Label 7303: @371404
     /* 371404 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(371525), // Rule ID 4259 //
     /* 371409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371423 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371429 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371439 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371442 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371446 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371453 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371463 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 371470 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 371470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 371477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371492 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371524 */     // GIR_Coverage, 4259,
     /* 371524 */     GIR_EraseRootFromParent_Done,
     /* 371525 */   // Label 7304: @371525
     /* 371525 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(371639), // Rule ID 4366 //
     /* 371530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371544 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371550 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371560 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371563 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371567 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371577 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 371584 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 371584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 371591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371606 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371638 */     // GIR_Coverage, 4366,
     /* 371638 */     GIR_EraseRootFromParent_Done,
     /* 371639 */   // Label 7305: @371639
     /* 371639 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(371753), // Rule ID 4367 //
     /* 371644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371658 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371664 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371674 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371677 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371681 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 371698 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 371698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 371705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371720 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371742 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371752 */     // GIR_Coverage, 4367,
     /* 371752 */     GIR_EraseRootFromParent_Done,
     /* 371753 */   // Label 7306: @371753
     /* 371753 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(371870), // Rule ID 4262 //
     /* 371758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371784 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371787 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371791 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371798 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371808 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 371815 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 371815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 371822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371837 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371864 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371869 */     // GIR_Coverage, 4262,
     /* 371869 */     GIR_EraseRootFromParent_Done,
     /* 371870 */   // Label 7307: @371870
     /* 371870 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(371987), // Rule ID 4264 //
     /* 371875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371901 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371904 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371908 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371915 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371925 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 371932 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 371932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 371939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371954 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371976 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371986 */     // GIR_Coverage, 4264,
     /* 371986 */     GIR_EraseRootFromParent_Done,
     /* 371987 */   // Label 7308: @371987
     /* 371987 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(372097), // Rule ID 4370 //
     /* 371992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372018 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372021 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372025 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372035 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 372042 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 372042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 372049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372064 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372096 */     // GIR_Coverage, 4370,
     /* 372096 */     GIR_EraseRootFromParent_Done,
     /* 372097 */   // Label 7309: @372097
     /* 372097 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(372207), // Rule ID 4372 //
     /* 372102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372128 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372131 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372135 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372139 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372145 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 372152 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 372152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 372159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372174 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372206 */     // GIR_Coverage, 4372,
     /* 372206 */     GIR_EraseRootFromParent_Done,
     /* 372207 */   // Label 7310: @372207
     /* 372207 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(372330), // Rule ID 5752 //
     /* 372212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372259 */     // MIs[3] Operand 1
     /* 372259 */     // No operand predicates
     /* 372259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372265 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 372265 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 372268 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 372272 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372277 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 372281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 372284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 372286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 372311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372329 */     // GIR_Coverage, 5752,
     /* 372329 */     GIR_EraseRootFromParent_Done,
     /* 372330 */   // Label 7311: @372330
     /* 372330 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(372453), // Rule ID 5792 //
     /* 372335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372382 */     // MIs[3] Operand 1
     /* 372382 */     // No operand predicates
     /* 372382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372388 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 372388 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 372391 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 372395 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372400 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 372404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 372407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 372409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 372434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372452 */     // GIR_Coverage, 5792,
     /* 372452 */     GIR_EraseRootFromParent_Done,
     /* 372453 */   // Label 7312: @372453
     /* 372453 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(372541), // Rule ID 1939 //
     /* 372458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372504 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372508 */     // MIs[2] Operand 1
     /* 372508 */     // No operand predicates
     /* 372508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372516 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372520 */     // MIs[3] Operand 1
     /* 372520 */     // No operand predicates
     /* 372520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372522 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 372522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 372529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 372539 */     GIR_RootConstrainSelectedInstOperands,
     /* 372540 */     // GIR_Coverage, 1939,
     /* 372540 */     GIR_EraseRootFromParent_Done,
     /* 372541 */   // Label 7313: @372541
     /* 372541 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(372640), // Rule ID 5749 //
     /* 372546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 372568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372580 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372584 */     // MIs[2] Operand 1
     /* 372584 */     // No operand predicates
     /* 372584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372592 */     // MIs[3] Operand 1
     /* 372592 */     // No operand predicates
     /* 372592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372594 */     // (vector_insert:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8f16] } ZPR:{ *:[nxv8f16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 372594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372606 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 372612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 372622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372638 */     GIR_RootConstrainSelectedInstOperands,
     /* 372639 */     // GIR_Coverage, 5749,
     /* 372639 */     GIR_EraseRootFromParent_Done,
     /* 372640 */   // Label 7314: @372640
     /* 372640 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(372739), // Rule ID 5789 //
     /* 372645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 372667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372679 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372683 */     // MIs[2] Operand 1
     /* 372683 */     // No operand predicates
     /* 372683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372691 */     // MIs[3] Operand 1
     /* 372691 */     // No operand predicates
     /* 372691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372693 */     // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 372693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372705 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 372711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 372721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372737 */     GIR_RootConstrainSelectedInstOperands,
     /* 372738 */     // GIR_Coverage, 5789,
     /* 372738 */     GIR_EraseRootFromParent_Done,
     /* 372739 */   // Label 7315: @372739
     /* 372739 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(372816), // Rule ID 5751 //
     /* 372744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372787 */     // MIs[2] Operand 1
     /* 372787 */     // No operand predicates
     /* 372787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372795 */     // MIs[3] Operand 1
     /* 372795 */     // No operand predicates
     /* 372795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372797 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 372797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372802 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 372804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372814 */     GIR_RootConstrainSelectedInstOperands,
     /* 372815 */     // GIR_Coverage, 5751,
     /* 372815 */     GIR_EraseRootFromParent_Done,
     /* 372816 */   // Label 7316: @372816
     /* 372816 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(372924), // Rule ID 5753 //
     /* 372821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 372847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372864 */     // MIs[2] Operand 1
     /* 372864 */     // No operand predicates
     /* 372864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372872 */     // MIs[3] Operand 1
     /* 372872 */     // No operand predicates
     /* 372872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372874 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 372874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372886 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 372889 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372893 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 372896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372911 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 372913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372922 */     GIR_RootConstrainSelectedInstOperands,
     /* 372923 */     // GIR_Coverage, 5753,
     /* 372923 */     GIR_EraseRootFromParent_Done,
     /* 372924 */   // Label 7317: @372924
     /* 372924 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(373001), // Rule ID 5791 //
     /* 372929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372972 */     // MIs[2] Operand 1
     /* 372972 */     // No operand predicates
     /* 372972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372980 */     // MIs[3] Operand 1
     /* 372980 */     // No operand predicates
     /* 372980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372982 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 372982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372987 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 372989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372999 */     GIR_RootConstrainSelectedInstOperands,
     /* 373000 */     // GIR_Coverage, 5791,
     /* 373000 */     GIR_EraseRootFromParent_Done,
     /* 373001 */   // Label 7318: @373001
     /* 373001 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(373109), // Rule ID 5793 //
     /* 373006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 373032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373049 */     // MIs[2] Operand 1
     /* 373049 */     // No operand predicates
     /* 373049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373057 */     // MIs[3] Operand 1
     /* 373057 */     // No operand predicates
     /* 373057 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373059 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 373059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373071 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 373074 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373078 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 373081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373096 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 373098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 373101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 373107 */     GIR_RootConstrainSelectedInstOperands,
     /* 373108 */     // GIR_Coverage, 5793,
     /* 373108 */     GIR_EraseRootFromParent_Done,
     /* 373109 */   // Label 7319: @373109
     /* 373109 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(373188), // Rule ID 5705 //
     /* 373114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 373136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373142 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 373142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 373145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373154 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 373158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 373177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373182 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373187 */     // GIR_Coverage, 5705,
     /* 373187 */     GIR_EraseRootFromParent_Done,
     /* 373188 */   // Label 7320: @373188
     /* 373188 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(373264), // Rule ID 5711 //
     /* 373193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373215 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373221 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 373221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373263 */     // GIR_Coverage, 5711,
     /* 373263 */     GIR_EraseRootFromParent_Done,
     /* 373264 */   // Label 7321: @373264
     /* 373264 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(373340), // Rule ID 5721 //
     /* 373269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373297 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 373297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373339 */     // GIR_Coverage, 5721,
     /* 373339 */     GIR_EraseRootFromParent_Done,
     /* 373340 */   // Label 7322: @373340
     /* 373340 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(373403), // Rule ID 5730 //
     /* 373345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 373367 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 373371 */     // MIs[1] Operand 1
     /* 373371 */     // No operand predicates
     /* 373371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 373375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373379 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373383 */     // MIs[2] Operand 1
     /* 373383 */     // No operand predicates
     /* 373383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373385 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 373385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 373388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 373395 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 373401 */     GIR_RootConstrainSelectedInstOperands,
     /* 373402 */     // GIR_Coverage, 5730,
     /* 373402 */     GIR_EraseRootFromParent_Done,
     /* 373403 */   // Label 7323: @373403
     /* 373403 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(373489), // Rule ID 6489 //
     /* 373408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373430 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373433 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 373437 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 373444 */     // MIs[1] Rn
     /* 373444 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 373448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 373453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 373457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373461 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373465 */     // MIs[2] Operand 1
     /* 373465 */     // No operand predicates
     /* 373465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373467 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 373467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 373470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 373474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373487 */     GIR_RootConstrainSelectedInstOperands,
     /* 373488 */     // GIR_Coverage, 6489,
     /* 373488 */     GIR_EraseRootFromParent_Done,
     /* 373489 */   // Label 7324: @373489
     /* 373489 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(373568), // Rule ID 6494 //
     /* 373494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373516 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 373523 */     // MIs[1] Rn
     /* 373523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 373527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 373532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 373536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373540 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373544 */     // MIs[2] Operand 1
     /* 373544 */     // No operand predicates
     /* 373544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373546 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 373546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 373549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 373553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373566 */     GIR_RootConstrainSelectedInstOperands,
     /* 373567 */     // GIR_Coverage, 6494,
     /* 373567 */     GIR_EraseRootFromParent_Done,
     /* 373568 */   // Label 7325: @373568
     /* 373568 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(373622), // Rule ID 1935 //
     /* 373573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 373594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 373598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373606 */     // MIs[1] Operand 1
     /* 373606 */     // No operand predicates
     /* 373606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373608 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 373608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 373611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 373615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 373618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373620 */     GIR_RootConstrainSelectedInstOperands,
     /* 373621 */     // GIR_Coverage, 1935,
     /* 373621 */     GIR_EraseRootFromParent_Done,
     /* 373622 */   // Label 7326: @373622
     /* 373622 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(373728), // Rule ID 5735 //
     /* 373627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 373649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373657 */     // MIs[1] Operand 1
     /* 373657 */     // No operand predicates
     /* 373657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373659 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373659 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 373662 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373666 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 373688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 373692 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 373695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 373720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373726 */     GIR_RootConstrainSelectedInstOperands,
     /* 373727 */     // GIR_Coverage, 5735,
     /* 373727 */     GIR_EraseRootFromParent_Done,
     /* 373728 */   // Label 7327: @373728
     /* 373728 */   GIM_Reject,
     /* 373729 */ // Label 7294: @373729
     /* 373729 */ GIM_Reject,
     /* 373730 */ // Label 7120: @373730
     /* 373730 */ GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(376933),
     /* 373735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 373738 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(373857), // Rule ID 4188 //
     /* 373743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 373746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373757 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373763 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373773 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373776 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373780 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373790 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 373797 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 373804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373824 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373856 */     // GIR_Coverage, 4188,
     /* 373856 */     GIR_EraseRootFromParent_Done,
     /* 373857 */   // Label 7329: @373857
     /* 373857 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(373976), // Rule ID 4189 //
     /* 373862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 373865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373876 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373882 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373892 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373895 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373899 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373909 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 373916 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 373923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373943 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373975 */     // GIR_Coverage, 4189,
     /* 373975 */     GIR_EraseRootFromParent_Done,
     /* 373976 */   // Label 7330: @373976
     /* 373976 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(374102), // Rule ID 4224 //
     /* 373981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373995 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374001 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374011 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374014 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374018 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374025 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374035 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 374042 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 374049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374069 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374101 */     // GIR_Coverage, 4224,
     /* 374101 */     GIR_EraseRootFromParent_Done,
     /* 374102 */   // Label 7331: @374102
     /* 374102 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(374228), // Rule ID 4225 //
     /* 374107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374121 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374127 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374137 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374140 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374144 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374151 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 374168 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 374175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374195 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374227 */     // GIR_Coverage, 4225,
     /* 374227 */     GIR_EraseRootFromParent_Done,
     /* 374228 */   // Label 7332: @374228
     /* 374228 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(374343), // Rule ID 4194 //
     /* 374233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374259 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374262 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374266 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 374283 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 374290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374310 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374342 */     // GIR_Coverage, 4194,
     /* 374342 */     GIR_EraseRootFromParent_Done,
     /* 374343 */   // Label 7333: @374343
     /* 374343 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(374458), // Rule ID 4196 //
     /* 374348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374374 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374381 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 374398 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 374405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374425 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374457 */     // GIR_Coverage, 4196,
     /* 374457 */     GIR_EraseRootFromParent_Done,
     /* 374458 */   // Label 7334: @374458
     /* 374458 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(374580), // Rule ID 4230 //
     /* 374463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374489 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374492 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374496 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374503 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 374520 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 374527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374547 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374579 */     // GIR_Coverage, 4230,
     /* 374579 */     GIR_EraseRootFromParent_Done,
     /* 374580 */   // Label 7335: @374580
     /* 374580 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(374702), // Rule ID 4232 //
     /* 374585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374611 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374614 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374618 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374625 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 374642 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 374649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374669 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374701 */     // GIR_Coverage, 4232,
     /* 374701 */     GIR_EraseRootFromParent_Done,
     /* 374702 */   // Label 7336: @374702
     /* 374702 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(374816), // Rule ID 4186 //
     /* 374707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374721 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374727 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374737 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374740 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374744 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 374761 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 374761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 374768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374783 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374815 */     // GIR_Coverage, 4186,
     /* 374815 */     GIR_EraseRootFromParent_Done,
     /* 374816 */   // Label 7337: @374816
     /* 374816 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(374930), // Rule ID 4187 //
     /* 374821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374835 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374841 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374851 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374858 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 374875 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 374875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 374882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374897 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374929 */     // GIR_Coverage, 4187,
     /* 374929 */     GIR_EraseRootFromParent_Done,
     /* 374930 */   // Label 7338: @374930
     /* 374930 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(375051), // Rule ID 4222 //
     /* 374935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374949 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374955 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374965 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374968 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374972 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374979 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 374996 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 374996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 375003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375018 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375050 */     // GIR_Coverage, 4222,
     /* 375050 */     GIR_EraseRootFromParent_Done,
     /* 375051 */   // Label 7339: @375051
     /* 375051 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(375172), // Rule ID 4223 //
     /* 375056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375070 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375076 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375086 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375089 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375093 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375100 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 375117 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 375117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 375124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375139 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375171 */     // GIR_Coverage, 4223,
     /* 375171 */     GIR_EraseRootFromParent_Done,
     /* 375172 */   // Label 7340: @375172
     /* 375172 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(375282), // Rule ID 4190 //
     /* 375177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375203 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375206 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375210 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375214 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375220 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 375227 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 375227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 375234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375249 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375281 */     // GIR_Coverage, 4190,
     /* 375281 */     GIR_EraseRootFromParent_Done,
     /* 375282 */   // Label 7341: @375282
     /* 375282 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(375392), // Rule ID 4192 //
     /* 375287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375313 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375316 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375320 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375330 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 375337 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 375337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 375344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375359 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375391 */     // GIR_Coverage, 4192,
     /* 375391 */     GIR_EraseRootFromParent_Done,
     /* 375392 */   // Label 7342: @375392
     /* 375392 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(375509), // Rule ID 4226 //
     /* 375397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375423 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375426 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375430 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375437 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375447 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 375454 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 375454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 375461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375476 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375508 */     // GIR_Coverage, 4226,
     /* 375508 */     GIR_EraseRootFromParent_Done,
     /* 375509 */   // Label 7343: @375509
     /* 375509 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(375626), // Rule ID 4228 //
     /* 375514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375540 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375543 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375547 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375554 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 375571 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 375571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 375578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375593 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375625 */     // GIR_Coverage, 4228,
     /* 375625 */     GIR_EraseRootFromParent_Done,
     /* 375626 */   // Label 7344: @375626
     /* 375626 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(375749), // Rule ID 5776 //
     /* 375631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 375661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375678 */     // MIs[3] Operand 1
     /* 375678 */     // No operand predicates
     /* 375678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375684 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 375684 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 375687 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 375691 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375696 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 375700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 375703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 375730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375748 */     // GIR_Coverage, 5776,
     /* 375748 */     GIR_EraseRootFromParent_Done,
     /* 375749 */   // Label 7345: @375749
     /* 375749 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(375872), // Rule ID 5784 //
     /* 375754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 375784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375801 */     // MIs[3] Operand 1
     /* 375801 */     // No operand predicates
     /* 375801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375807 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 375807 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 375810 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 375814 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375819 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 375823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 375826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 375853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375866 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375871 */     // GIR_Coverage, 5784,
     /* 375871 */     GIR_EraseRootFromParent_Done,
     /* 375872 */   // Label 7346: @375872
     /* 375872 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(375960), // Rule ID 1938 //
     /* 375877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 375906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375923 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 375927 */     // MIs[2] Operand 1
     /* 375927 */     // No operand predicates
     /* 375927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375935 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 375939 */     // MIs[3] Operand 1
     /* 375939 */     // No operand predicates
     /* 375939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375941 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 375941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 375948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 375958 */     GIR_RootConstrainSelectedInstOperands,
     /* 375959 */     // GIR_Coverage, 1938,
     /* 375959 */     GIR_EraseRootFromParent_Done,
     /* 375960 */   // Label 7347: @375960
     /* 375960 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(376059), // Rule ID 5773 //
     /* 375965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 375987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375999 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376003 */     // MIs[2] Operand 1
     /* 376003 */     // No operand predicates
     /* 376003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376011 */     // MIs[3] Operand 1
     /* 376011 */     // No operand predicates
     /* 376011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376013 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i8] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 376013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376025 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 376031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 376051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 376057 */     GIR_RootConstrainSelectedInstOperands,
     /* 376058 */     // GIR_Coverage, 5773,
     /* 376058 */     GIR_EraseRootFromParent_Done,
     /* 376059 */   // Label 7348: @376059
     /* 376059 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(376158), // Rule ID 5781 //
     /* 376064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 376086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376098 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376102 */     // MIs[2] Operand 1
     /* 376102 */     // No operand predicates
     /* 376102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376110 */     // MIs[3] Operand 1
     /* 376110 */     // No operand predicates
     /* 376110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376112 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 376112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376124 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 376130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 376150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 376156 */     GIR_RootConstrainSelectedInstOperands,
     /* 376157 */     // GIR_Coverage, 5781,
     /* 376157 */     GIR_EraseRootFromParent_Done,
     /* 376158 */   // Label 7349: @376158
     /* 376158 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(376235), // Rule ID 5775 //
     /* 376163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 376189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376206 */     // MIs[2] Operand 1
     /* 376206 */     // No operand predicates
     /* 376206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376214 */     // MIs[3] Operand 1
     /* 376214 */     // No operand predicates
     /* 376214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376216 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 376216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376221 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 376223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 376226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 376233 */     GIR_RootConstrainSelectedInstOperands,
     /* 376234 */     // GIR_Coverage, 5775,
     /* 376234 */     GIR_EraseRootFromParent_Done,
     /* 376235 */   // Label 7350: @376235
     /* 376235 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(376343), // Rule ID 5777 //
     /* 376240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 376266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376283 */     // MIs[2] Operand 1
     /* 376283 */     // No operand predicates
     /* 376283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376291 */     // MIs[3] Operand 1
     /* 376291 */     // No operand predicates
     /* 376291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376293 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 376293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376305 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376308 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376312 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 376315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376330 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 376332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 376335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 376341 */     GIR_RootConstrainSelectedInstOperands,
     /* 376342 */     // GIR_Coverage, 5777,
     /* 376342 */     GIR_EraseRootFromParent_Done,
     /* 376343 */   // Label 7351: @376343
     /* 376343 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(376420), // Rule ID 5783 //
     /* 376348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 376374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376391 */     // MIs[2] Operand 1
     /* 376391 */     // No operand predicates
     /* 376391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376399 */     // MIs[3] Operand 1
     /* 376399 */     // No operand predicates
     /* 376399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376401 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 376401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376406 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 376408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 376411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 376418 */     GIR_RootConstrainSelectedInstOperands,
     /* 376419 */     // GIR_Coverage, 5783,
     /* 376419 */     GIR_EraseRootFromParent_Done,
     /* 376420 */   // Label 7352: @376420
     /* 376420 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(376528), // Rule ID 5785 //
     /* 376425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 376451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376468 */     // MIs[2] Operand 1
     /* 376468 */     // No operand predicates
     /* 376468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376476 */     // MIs[3] Operand 1
     /* 376476 */     // No operand predicates
     /* 376476 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376478 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 376478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376490 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376493 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376497 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 376500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376515 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 376517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 376520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 376526 */     GIR_RootConstrainSelectedInstOperands,
     /* 376527 */     // GIR_Coverage, 5785,
     /* 376527 */     GIR_EraseRootFromParent_Done,
     /* 376528 */   // Label 7353: @376528
     /* 376528 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(376607), // Rule ID 5700 //
     /* 376533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 376555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376561 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 376561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 376564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 376577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 376596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376606 */     // GIR_Coverage, 5700,
     /* 376606 */     GIR_EraseRootFromParent_Done,
     /* 376607 */   // Label 7354: @376607
     /* 376607 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(376686), // Rule ID 6487 //
     /* 376612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376634 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376637 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 376641 */     // MIs[1] Rn
     /* 376641 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 376645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 376650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 376654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376658 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376662 */     // MIs[2] Operand 1
     /* 376662 */     // No operand predicates
     /* 376662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376664 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 376664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 376667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 376671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376684 */     GIR_RootConstrainSelectedInstOperands,
     /* 376685 */     // GIR_Coverage, 6487,
     /* 376685 */     GIR_EraseRootFromParent_Done,
     /* 376686 */   // Label 7355: @376686
     /* 376686 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(376772), // Rule ID 6488 //
     /* 376691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376713 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376716 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 376720 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376727 */     // MIs[1] Rn
     /* 376727 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 376731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 376736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 376740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376748 */     // MIs[2] Operand 1
     /* 376748 */     // No operand predicates
     /* 376748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376750 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 376750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 376753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 376757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376770 */     GIR_RootConstrainSelectedInstOperands,
     /* 376771 */     // GIR_Coverage, 6488,
     /* 376771 */     GIR_EraseRootFromParent_Done,
     /* 376772 */   // Label 7356: @376772
     /* 376772 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(376826), // Rule ID 1934 //
     /* 376777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 376798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 376802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376806 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376810 */     // MIs[1] Operand 1
     /* 376810 */     // No operand predicates
     /* 376810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376812 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 376812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 376815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 376819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 376822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376824 */     GIR_RootConstrainSelectedInstOperands,
     /* 376825 */     // GIR_Coverage, 1934,
     /* 376825 */     GIR_EraseRootFromParent_Done,
     /* 376826 */   // Label 7357: @376826
     /* 376826 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(376932), // Rule ID 5743 //
     /* 376831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 376853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376861 */     // MIs[1] Operand 1
     /* 376861 */     // No operand predicates
     /* 376861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376863 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376863 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 376866 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376870 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 376892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 376896 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 376899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 376924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376930 */     GIR_RootConstrainSelectedInstOperands,
     /* 376931 */     // GIR_Coverage, 5743,
     /* 376931 */     GIR_EraseRootFromParent_Done,
     /* 376932 */   // Label 7358: @376932
     /* 376932 */   GIM_Reject,
     /* 376933 */ // Label 7328: @376933
     /* 376933 */ GIM_Reject,
     /* 376934 */ // Label 7121: @376934
     /* 376934 */ GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(377058), // Rule ID 11262 //
     /* 376939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 376942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 376945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 376948 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376955 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376959 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 376963 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 376963 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 376966 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 376970 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376975 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 376979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 376981 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 376984 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 376988 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376993 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 376996 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 376999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 377001 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 377004 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 377008 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377013 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 377016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 377018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 377021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 377025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377030 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 377033 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 377036 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 377039 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 377042 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 377047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 377049 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 377051 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377054 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 377056 */   GIR_RootConstrainSelectedInstOperands,
     /* 377057 */   // GIR_Coverage, 11262,
     /* 377057 */   GIR_EraseRootFromParent_Done,
     /* 377058 */ // Label 7359: @377058
     /* 377058 */ GIM_Reject,
     /* 377059 */ // Label 7122: @377059
     /* 377059 */ GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(377183), // Rule ID 11265 //
     /* 377064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 377067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 377070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377073 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377084 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 377088 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 377088 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 377091 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 377095 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377100 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 377104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 377106 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 377109 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 377113 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377118 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 377121 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 377124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 377126 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 377129 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 377133 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377138 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 377141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 377143 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 377146 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 377150 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377155 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 377158 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 377161 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 377164 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 377167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 377172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 377174 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 377176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377179 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 377181 */   GIR_RootConstrainSelectedInstOperands,
     /* 377182 */   // GIR_Coverage, 11265,
     /* 377182 */   GIR_EraseRootFromParent_Done,
     /* 377183 */ // Label 7360: @377183
     /* 377183 */ GIM_Reject,
     /* 377184 */ // Label 7123: @377184
     /* 377184 */ GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(379161),
     /* 377189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 377192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 377195 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377202 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(377311), // Rule ID 4356 //
     /* 377207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377211 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377217 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377227 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377230 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377234 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 377251 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 377258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377278 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377310 */     // GIR_Coverage, 4356,
     /* 377310 */     GIR_EraseRootFromParent_Done,
     /* 377311 */   // Label 7362: @377311
     /* 377311 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(377420), // Rule ID 4357 //
     /* 377316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377320 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377326 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377336 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377339 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377343 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377353 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 377360 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 377367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377387 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377419 */     // GIR_Coverage, 4357,
     /* 377419 */     GIR_EraseRootFromParent_Done,
     /* 377420 */   // Label 7363: @377420
     /* 377420 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(377529), // Rule ID 4464 //
     /* 377425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377429 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377435 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377445 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377448 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377452 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377462 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 377469 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 377476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377496 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377528 */     // GIR_Coverage, 4464,
     /* 377528 */     GIR_EraseRootFromParent_Done,
     /* 377529 */   // Label 7364: @377529
     /* 377529 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(377638), // Rule ID 4465 //
     /* 377534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377538 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377544 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377554 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377557 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377561 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377565 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 377578 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 377585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377605 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377632 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377637 */     // GIR_Coverage, 4465,
     /* 377637 */     GIR_EraseRootFromParent_Done,
     /* 377638 */   // Label 7365: @377638
     /* 377638 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(377743), // Rule ID 4362 //
     /* 377643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377659 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377662 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377666 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377676 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 377683 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 377690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377710 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377742 */     // GIR_Coverage, 4362,
     /* 377742 */     GIR_EraseRootFromParent_Done,
     /* 377743 */   // Label 7366: @377743
     /* 377743 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(377848), // Rule ID 4364 //
     /* 377748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377764 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377767 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377771 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 377788 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 377795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377815 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377847 */     // GIR_Coverage, 4364,
     /* 377847 */     GIR_EraseRootFromParent_Done,
     /* 377848 */   // Label 7367: @377848
     /* 377848 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(377953), // Rule ID 4470 //
     /* 377853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377869 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377876 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 377893 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 377900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377920 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377952 */     // GIR_Coverage, 4470,
     /* 377952 */     GIR_EraseRootFromParent_Done,
     /* 377953 */   // Label 7368: @377953
     /* 377953 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(378058), // Rule ID 4472 //
     /* 377958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377974 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377981 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 377998 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 378005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378025 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378057 */     // GIR_Coverage, 4472,
     /* 378057 */     GIR_EraseRootFromParent_Done,
     /* 378058 */   // Label 7369: @378058
     /* 378058 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(378162), // Rule ID 4354 //
     /* 378063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378067 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378073 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378083 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378086 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378090 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378100 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 378107 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 378107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 378114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378129 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378161 */     // GIR_Coverage, 4354,
     /* 378161 */     GIR_EraseRootFromParent_Done,
     /* 378162 */   // Label 7370: @378162
     /* 378162 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(378266), // Rule ID 4355 //
     /* 378167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378171 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378177 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378187 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378194 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 378211 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 378211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 378218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378233 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378265 */     // GIR_Coverage, 4355,
     /* 378265 */     GIR_EraseRootFromParent_Done,
     /* 378266 */   // Label 7371: @378266
     /* 378266 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(378370), // Rule ID 4462 //
     /* 378271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378275 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378281 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378291 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378294 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378298 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 378315 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 378315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 378322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378337 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378359 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378364 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378369 */     // GIR_Coverage, 4462,
     /* 378369 */     GIR_EraseRootFromParent_Done,
     /* 378370 */   // Label 7372: @378370
     /* 378370 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(378474), // Rule ID 4463 //
     /* 378375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378379 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378385 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378395 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378398 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378402 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 378419 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 378419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 378426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378441 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378463 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378473 */     // GIR_Coverage, 4463,
     /* 378473 */     GIR_EraseRootFromParent_Done,
     /* 378474 */   // Label 7373: @378474
     /* 378474 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(378574), // Rule ID 4358 //
     /* 378479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378495 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378498 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378502 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 378519 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 378519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 378526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378541 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378573 */     // GIR_Coverage, 4358,
     /* 378573 */     GIR_EraseRootFromParent_Done,
     /* 378574 */   // Label 7374: @378574
     /* 378574 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(378674), // Rule ID 4360 //
     /* 378579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378595 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378598 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378602 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 378619 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 378619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 378626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378641 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378673 */     // GIR_Coverage, 4360,
     /* 378673 */     GIR_EraseRootFromParent_Done,
     /* 378674 */   // Label 7375: @378674
     /* 378674 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(378774), // Rule ID 4466 //
     /* 378679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378695 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378698 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378702 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378712 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 378719 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 378719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 378726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378741 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378773 */     // GIR_Coverage, 4466,
     /* 378773 */     GIR_EraseRootFromParent_Done,
     /* 378774 */   // Label 7376: @378774
     /* 378774 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(378874), // Rule ID 4468 //
     /* 378779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378795 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378802 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 378819 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 378819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 378826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378841 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378873 */     // GIR_Coverage, 4468,
     /* 378873 */     GIR_EraseRootFromParent_Done,
     /* 378874 */   // Label 7377: @378874
     /* 378874 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(378938), // Rule ID 11320 //
     /* 378879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 378882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 378902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378914 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 378918 */     // MIs[3] Operand 1
     /* 378918 */     // No operand predicates
     /* 378918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378922 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378924 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx)
     /* 378924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 378927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 378929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 378933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 378936 */     GIR_RootConstrainSelectedInstOperands,
     /* 378937 */     // GIR_Coverage, 11320,
     /* 378937 */     GIR_EraseRootFromParent_Done,
     /* 378938 */   // Label 7378: @378938
     /* 378938 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(379049), // Rule ID 11261 //
     /* 378943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 378946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 378950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 378954 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 378954 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 378957 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 378961 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378966 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 378970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 378972 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 378975 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 378979 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378984 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 378987 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 378990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 378992 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 378995 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 378999 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379004 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 379007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 379012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 379016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379021 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379024 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 379027 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 379030 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 379033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 379038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 379040 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 379042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379045 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 379047 */     GIR_RootConstrainSelectedInstOperands,
     /* 379048 */     // GIR_Coverage, 11261,
     /* 379048 */     GIR_EraseRootFromParent_Done,
     /* 379049 */   // Label 7379: @379049
     /* 379049 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(379160), // Rule ID 11267 //
     /* 379054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 379057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379065 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 379065 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 379068 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 379072 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379077 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 379081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 379083 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 379086 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 379090 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379095 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 379098 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 379101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 379103 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 379106 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 379110 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379115 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 379118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 379123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 379127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379132 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379135 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 379138 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 379141 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 379144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 379149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 379151 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 379153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 379158 */     GIR_RootConstrainSelectedInstOperands,
     /* 379159 */     // GIR_Coverage, 11267,
     /* 379159 */     GIR_EraseRootFromParent_Done,
     /* 379160 */   // Label 7380: @379160
     /* 379160 */   GIM_Reject,
     /* 379161 */ // Label 7361: @379161
     /* 379161 */ GIM_Reject,
     /* 379162 */ // Label 7124: @379162
     /* 379162 */ GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(379313), // Rule ID 11263 //
     /* 379167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 379170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 379173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 379176 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 379179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379187 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379191 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 379191 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 379194 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379198 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379203 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 379209 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 379214 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379219 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 379222 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 379226 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379231 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 379234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 379236 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 379239 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 379243 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379248 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 379251 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 379254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 379256 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 379259 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 379263 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379268 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 379271 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 379276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 379280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379285 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379288 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 379291 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 379294 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 379297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 379302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 379304 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 379306 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379309 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 379311 */   GIR_RootConstrainSelectedInstOperands,
     /* 379312 */   // GIR_Coverage, 11263,
     /* 379312 */   GIR_EraseRootFromParent_Done,
     /* 379313 */ // Label 7381: @379313
     /* 379313 */ GIM_Reject,
     /* 379314 */ // Label 7125: @379314
     /* 379314 */ GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(381345),
     /* 379319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 379322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 379325 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 379328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379332 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(379441), // Rule ID 4320 //
     /* 379337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379341 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379347 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379357 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379360 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379364 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379374 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 379381 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 379388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379408 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379440 */     // GIR_Coverage, 4320,
     /* 379440 */     GIR_EraseRootFromParent_Done,
     /* 379441 */   // Label 7383: @379441
     /* 379441 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(379550), // Rule ID 4321 //
     /* 379446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379450 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379456 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379466 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379469 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379473 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379483 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 379490 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 379497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379517 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379549 */     // GIR_Coverage, 4321,
     /* 379549 */     GIR_EraseRootFromParent_Done,
     /* 379550 */   // Label 7384: @379550
     /* 379550 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(379659), // Rule ID 4428 //
     /* 379555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379559 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379565 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379575 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379578 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379582 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 379599 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 379606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379626 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379658 */     // GIR_Coverage, 4428,
     /* 379658 */     GIR_EraseRootFromParent_Done,
     /* 379659 */   // Label 7385: @379659
     /* 379659 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(379768), // Rule ID 4429 //
     /* 379664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379668 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379674 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379684 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379687 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379691 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 379708 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 379715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379735 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379762 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379767 */     // GIR_Coverage, 4429,
     /* 379767 */     GIR_EraseRootFromParent_Done,
     /* 379768 */   // Label 7386: @379768
     /* 379768 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(379873), // Rule ID 4326 //
     /* 379773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379789 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379792 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379796 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 379813 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 379820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379840 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379872 */     // GIR_Coverage, 4326,
     /* 379872 */     GIR_EraseRootFromParent_Done,
     /* 379873 */   // Label 7387: @379873
     /* 379873 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(379978), // Rule ID 4328 //
     /* 379878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379894 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379897 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379901 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 379918 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 379925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379945 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379977 */     // GIR_Coverage, 4328,
     /* 379977 */     GIR_EraseRootFromParent_Done,
     /* 379978 */   // Label 7388: @379978
     /* 379978 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(380083), // Rule ID 4434 //
     /* 379983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379999 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380002 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380006 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 380023 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 380030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380050 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380082 */     // GIR_Coverage, 4434,
     /* 380082 */     GIR_EraseRootFromParent_Done,
     /* 380083 */   // Label 7389: @380083
     /* 380083 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(380188), // Rule ID 4436 //
     /* 380088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380104 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380111 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380115 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 380128 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 380135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380155 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380182 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380187 */     // GIR_Coverage, 4436,
     /* 380187 */     GIR_EraseRootFromParent_Done,
     /* 380188 */   // Label 7390: @380188
     /* 380188 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(380292), // Rule ID 4318 //
     /* 380193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380197 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380203 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380213 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380216 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380220 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 380237 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 380237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 380244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380259 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380281 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380291 */     // GIR_Coverage, 4318,
     /* 380291 */     GIR_EraseRootFromParent_Done,
     /* 380292 */   // Label 7391: @380292
     /* 380292 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(380396), // Rule ID 4319 //
     /* 380297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380301 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380307 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380317 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380324 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 380341 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 380341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 380348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380363 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380395 */     // GIR_Coverage, 4319,
     /* 380395 */     GIR_EraseRootFromParent_Done,
     /* 380396 */   // Label 7392: @380396
     /* 380396 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(380500), // Rule ID 4426 //
     /* 380401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380405 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380411 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380421 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380424 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380428 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 380445 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 380445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 380452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380467 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380494 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380499 */     // GIR_Coverage, 4426,
     /* 380499 */     GIR_EraseRootFromParent_Done,
     /* 380500 */   // Label 7393: @380500
     /* 380500 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(380604), // Rule ID 4427 //
     /* 380505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380509 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380515 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380525 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380528 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380532 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 380549 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 380549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 380556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380571 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380603 */     // GIR_Coverage, 4427,
     /* 380603 */     GIR_EraseRootFromParent_Done,
     /* 380604 */   // Label 7394: @380604
     /* 380604 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(380704), // Rule ID 4322 //
     /* 380609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380625 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380628 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380632 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380642 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 380649 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 380649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 380656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380671 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380703 */     // GIR_Coverage, 4322,
     /* 380703 */     GIR_EraseRootFromParent_Done,
     /* 380704 */   // Label 7395: @380704
     /* 380704 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(380804), // Rule ID 4324 //
     /* 380709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380725 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380728 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380732 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380742 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 380749 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 380749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 380756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380771 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380803 */     // GIR_Coverage, 4324,
     /* 380803 */     GIR_EraseRootFromParent_Done,
     /* 380804 */   // Label 7396: @380804
     /* 380804 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(380904), // Rule ID 4430 //
     /* 380809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380825 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380828 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380832 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380842 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 380849 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 380849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 380856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380871 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380903 */     // GIR_Coverage, 4430,
     /* 380903 */     GIR_EraseRootFromParent_Done,
     /* 380904 */   // Label 7397: @380904
     /* 380904 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(381004), // Rule ID 4432 //
     /* 380909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380925 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380928 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380932 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380942 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 380949 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 380949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 380956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380971 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380993 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381003 */     // GIR_Coverage, 4432,
     /* 381003 */     GIR_EraseRootFromParent_Done,
     /* 381004 */   // Label 7398: @381004
     /* 381004 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(381068), // Rule ID 11318 //
     /* 381009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 381012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 381032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381044 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 381048 */     // MIs[3] Operand 1
     /* 381048 */     // No operand predicates
     /* 381048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381052 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381054 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx)
     /* 381054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 381057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 381059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 381063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 381066 */     GIR_RootConstrainSelectedInstOperands,
     /* 381067 */     // GIR_Coverage, 11318,
     /* 381067 */     GIR_EraseRootFromParent_Done,
     /* 381068 */   // Label 7399: @381068
     /* 381068 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(381206), // Rule ID 11260 //
     /* 381073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 381076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 381080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381084 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 381084 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 381087 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381091 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381096 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 381102 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 381107 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381112 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 381115 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 381119 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381124 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 381127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 381129 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 381132 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 381136 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381141 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 381144 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 381147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 381149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 381152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 381156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381161 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 381164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 381166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 381169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 381173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381178 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 381181 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 381184 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 381187 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 381190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 381195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 381197 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 381199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381202 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 381204 */     GIR_RootConstrainSelectedInstOperands,
     /* 381205 */     // GIR_Coverage, 11260,
     /* 381205 */     GIR_EraseRootFromParent_Done,
     /* 381206 */   // Label 7400: @381206
     /* 381206 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(381344), // Rule ID 11266 //
     /* 381211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 381214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381222 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 381222 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 381225 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381229 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381234 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 381240 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 381245 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381250 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 381253 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 381257 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381262 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 381265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 381267 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 381270 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 381274 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381279 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 381282 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 381285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 381287 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 381290 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 381294 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381299 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 381302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 381304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 381307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 381311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381316 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 381319 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 381322 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 381325 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 381328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 381333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 381335 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 381337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381340 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 381342 */     GIR_RootConstrainSelectedInstOperands,
     /* 381343 */     // GIR_Coverage, 11266,
     /* 381343 */     GIR_EraseRootFromParent_Done,
     /* 381344 */   // Label 7401: @381344
     /* 381344 */   GIM_Reject,
     /* 381345 */ // Label 7382: @381345
     /* 381345 */ GIM_Reject,
     /* 381346 */ // Label 7126: @381346
     /* 381346 */ GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(383613),
     /* 381351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 381354 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(381480), // Rule ID 4284 //
     /* 381359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381373 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381379 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381389 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381392 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381396 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 381403 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381413 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 381420 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 381427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381447 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381479 */     // GIR_Coverage, 4284,
     /* 381479 */     GIR_EraseRootFromParent_Done,
     /* 381480 */   // Label 7403: @381480
     /* 381480 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(381606), // Rule ID 4285 //
     /* 381485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381499 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381505 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381515 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381518 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381522 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 381529 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 381546 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 381553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381573 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381605 */     // GIR_Coverage, 4285,
     /* 381605 */     GIR_EraseRootFromParent_Done,
     /* 381606 */   // Label 7404: @381606
     /* 381606 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(381725), // Rule ID 4392 //
     /* 381611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381625 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381631 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381641 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381648 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381658 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 381665 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 381672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381692 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381724 */     // GIR_Coverage, 4392,
     /* 381724 */     GIR_EraseRootFromParent_Done,
     /* 381725 */   // Label 7405: @381725
     /* 381725 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(381844), // Rule ID 4393 //
     /* 381730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381744 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381750 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381760 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381763 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381767 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381777 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 381784 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 381791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381811 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381838 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381843 */     // GIR_Coverage, 4393,
     /* 381843 */     GIR_EraseRootFromParent_Done,
     /* 381844 */   // Label 7406: @381844
     /* 381844 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(381966), // Rule ID 4290 //
     /* 381849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381875 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381878 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381882 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 381889 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 381906 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 381913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381933 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381965 */     // GIR_Coverage, 4290,
     /* 381965 */     GIR_EraseRootFromParent_Done,
     /* 381966 */   // Label 7407: @381966
     /* 381966 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(382088), // Rule ID 4292 //
     /* 381971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381997 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382000 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382004 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382011 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382015 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382021 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 382028 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 382035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382055 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382082 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382087 */     // GIR_Coverage, 4292,
     /* 382087 */     GIR_EraseRootFromParent_Done,
     /* 382088 */   // Label 7408: @382088
     /* 382088 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(382203), // Rule ID 4398 //
     /* 382093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382119 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382122 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382126 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382136 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 382143 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 382150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382170 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382202 */     // GIR_Coverage, 4398,
     /* 382202 */     GIR_EraseRootFromParent_Done,
     /* 382203 */   // Label 7409: @382203
     /* 382203 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(382318), // Rule ID 4400 //
     /* 382208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382234 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382237 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382241 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 382258 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 382265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382285 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382317 */     // GIR_Coverage, 4400,
     /* 382317 */     GIR_EraseRootFromParent_Done,
     /* 382318 */   // Label 7410: @382318
     /* 382318 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(382439), // Rule ID 4282 //
     /* 382323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382337 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382343 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382353 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382356 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382360 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382367 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 382384 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 382384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 382391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382406 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382438 */     // GIR_Coverage, 4282,
     /* 382438 */     GIR_EraseRootFromParent_Done,
     /* 382439 */   // Label 7411: @382439
     /* 382439 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(382560), // Rule ID 4283 //
     /* 382444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382458 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382464 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382474 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382477 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382481 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382488 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 382505 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 382505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 382512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382527 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382559 */     // GIR_Coverage, 4283,
     /* 382559 */     GIR_EraseRootFromParent_Done,
     /* 382560 */   // Label 7412: @382560
     /* 382560 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(382674), // Rule ID 4390 //
     /* 382565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382579 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382585 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382595 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382598 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382602 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 382619 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 382619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 382626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382641 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382673 */     // GIR_Coverage, 4390,
     /* 382673 */     GIR_EraseRootFromParent_Done,
     /* 382674 */   // Label 7413: @382674
     /* 382674 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(382788), // Rule ID 4391 //
     /* 382679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382693 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382699 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382709 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382712 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382716 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382726 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 382733 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 382733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 382740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382755 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382787 */     // GIR_Coverage, 4391,
     /* 382787 */     GIR_EraseRootFromParent_Done,
     /* 382788 */   // Label 7414: @382788
     /* 382788 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(382905), // Rule ID 4286 //
     /* 382793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382819 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382822 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382826 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382833 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382843 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 382850 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 382850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 382857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382872 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382894 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382904 */     // GIR_Coverage, 4286,
     /* 382904 */     GIR_EraseRootFromParent_Done,
     /* 382905 */   // Label 7415: @382905
     /* 382905 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(383022), // Rule ID 4288 //
     /* 382910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382936 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382939 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382943 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382950 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 382967 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 382967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 382974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382989 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383021 */     // GIR_Coverage, 4288,
     /* 383021 */     GIR_EraseRootFromParent_Done,
     /* 383022 */   // Label 7416: @383022
     /* 383022 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(383132), // Rule ID 4394 //
     /* 383027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383053 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383060 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383070 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 383077 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 383077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 383084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383099 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383131 */     // GIR_Coverage, 4394,
     /* 383131 */     GIR_EraseRootFromParent_Done,
     /* 383132 */   // Label 7417: @383132
     /* 383132 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(383242), // Rule ID 4396 //
     /* 383137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383163 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383166 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383170 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383180 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 383187 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 383187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 383194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383209 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383241 */     // GIR_Coverage, 4396,
     /* 383241 */     GIR_EraseRootFromParent_Done,
     /* 383242 */   // Label 7418: @383242
     /* 383242 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(383316), // Rule ID 11316 //
     /* 383247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 383250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 383280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383292 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 383296 */     // MIs[3] Operand 1
     /* 383296 */     // No operand predicates
     /* 383296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383302 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx)
     /* 383302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 383305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 383307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 383311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 383314 */     GIR_RootConstrainSelectedInstOperands,
     /* 383315 */     // GIR_Coverage, 11316,
     /* 383315 */     GIR_EraseRootFromParent_Done,
     /* 383316 */   // Label 7419: @383316
     /* 383316 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(383464), // Rule ID 11259 //
     /* 383321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 383324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 383338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383342 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 383342 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 383345 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383349 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383354 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 383360 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 383365 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383370 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 383373 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 383377 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383382 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 383385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 383387 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 383390 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 383394 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383399 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 383402 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 383405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 383407 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 383410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 383414 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383419 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 383422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 383424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 383427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 383431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383436 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 383439 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 383442 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 383445 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 383448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 383453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 383455 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 383457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383460 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 383462 */     GIR_RootConstrainSelectedInstOperands,
     /* 383463 */     // GIR_Coverage, 11259,
     /* 383463 */     GIR_EraseRootFromParent_Done,
     /* 383464 */   // Label 7420: @383464
     /* 383464 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(383612), // Rule ID 11264 //
     /* 383469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 383472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383490 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 383490 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 383493 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383497 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383502 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 383508 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 383513 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383518 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 383521 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 383525 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383530 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 383533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 383535 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 383538 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 383542 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383547 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 383550 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 383553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 383555 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 383558 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 383562 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383567 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 383570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 383572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 383575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 383579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383584 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 383587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 383590 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 383593 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 383596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 383601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 383603 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 383605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383608 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 383610 */     GIR_RootConstrainSelectedInstOperands,
     /* 383611 */     // GIR_Coverage, 11264,
     /* 383611 */     GIR_EraseRootFromParent_Done,
     /* 383612 */   // Label 7421: @383612
     /* 383612 */   GIM_Reject,
     /* 383613 */ // Label 7402: @383613
     /* 383613 */ GIM_Reject,
     /* 383614 */ // Label 7127: @383614
     /* 383614 */ GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(385733),
     /* 383619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 383622 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(383741), // Rule ID 4212 //
     /* 383627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 383630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383641 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383647 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383657 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383660 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383664 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 383681 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 383688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383708 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383740 */     // GIR_Coverage, 4212,
     /* 383740 */     GIR_EraseRootFromParent_Done,
     /* 383741 */   // Label 7423: @383741
     /* 383741 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(383860), // Rule ID 4213 //
     /* 383746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 383749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383760 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383766 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383776 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383783 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383793 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 383800 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 383807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383827 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383859 */     // GIR_Coverage, 4213,
     /* 383859 */     GIR_EraseRootFromParent_Done,
     /* 383860 */   // Label 7424: @383860
     /* 383860 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(383986), // Rule ID 4248 //
     /* 383865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383879 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383885 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383895 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383898 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383902 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 383909 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383919 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 383926 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 383933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383953 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383985 */     // GIR_Coverage, 4248,
     /* 383985 */     GIR_EraseRootFromParent_Done,
     /* 383986 */   // Label 7425: @383986
     /* 383986 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(384112), // Rule ID 4249 //
     /* 383991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384005 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384011 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384021 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384024 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384028 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384035 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384045 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 384052 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 384059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384079 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384111 */     // GIR_Coverage, 4249,
     /* 384111 */     GIR_EraseRootFromParent_Done,
     /* 384112 */   // Label 7426: @384112
     /* 384112 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(384227), // Rule ID 4218 //
     /* 384117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384143 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384146 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384150 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384160 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 384167 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 384174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384194 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384226 */     // GIR_Coverage, 4218,
     /* 384226 */     GIR_EraseRootFromParent_Done,
     /* 384227 */   // Label 7427: @384227
     /* 384227 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(384342), // Rule ID 4220 //
     /* 384232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384258 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384261 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384265 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384275 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 384282 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 384289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384309 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384341 */     // GIR_Coverage, 4220,
     /* 384341 */     GIR_EraseRootFromParent_Done,
     /* 384342 */   // Label 7428: @384342
     /* 384342 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(384464), // Rule ID 4254 //
     /* 384347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384373 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384376 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384380 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384387 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384397 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 384404 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 384411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384431 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384463 */     // GIR_Coverage, 4254,
     /* 384463 */     GIR_EraseRootFromParent_Done,
     /* 384464 */   // Label 7429: @384464
     /* 384464 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(384586), // Rule ID 4256 //
     /* 384469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384495 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384498 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384502 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384509 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 384526 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 384533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384553 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384585 */     // GIR_Coverage, 4256,
     /* 384585 */     GIR_EraseRootFromParent_Done,
     /* 384586 */   // Label 7430: @384586
     /* 384586 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(384700), // Rule ID 4210 //
     /* 384591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384605 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384611 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384621 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384624 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384628 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384638 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 384645 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 384645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 384652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384667 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384699 */     // GIR_Coverage, 4210,
     /* 384699 */     GIR_EraseRootFromParent_Done,
     /* 384700 */   // Label 7431: @384700
     /* 384700 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(384814), // Rule ID 4211 //
     /* 384705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384719 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384725 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384735 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384738 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384742 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384752 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 384759 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 384759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 384766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384781 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384803 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384813 */     // GIR_Coverage, 4211,
     /* 384813 */     GIR_EraseRootFromParent_Done,
     /* 384814 */   // Label 7432: @384814
     /* 384814 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(384935), // Rule ID 4246 //
     /* 384819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384833 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384839 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384849 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384852 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384856 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384863 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 384880 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 384880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 384887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384902 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384934 */     // GIR_Coverage, 4246,
     /* 384934 */     GIR_EraseRootFromParent_Done,
     /* 384935 */   // Label 7433: @384935
     /* 384935 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(385056), // Rule ID 4247 //
     /* 384940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384954 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384960 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384970 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384973 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384977 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384984 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384994 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 385001 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 385001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 385008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385023 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385055 */     // GIR_Coverage, 4247,
     /* 385055 */     GIR_EraseRootFromParent_Done,
     /* 385056 */   // Label 7434: @385056
     /* 385056 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(385166), // Rule ID 4214 //
     /* 385061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385087 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385094 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 385111 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 385111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 385118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385133 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385165 */     // GIR_Coverage, 4214,
     /* 385165 */     GIR_EraseRootFromParent_Done,
     /* 385166 */   // Label 7435: @385166
     /* 385166 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(385276), // Rule ID 4216 //
     /* 385171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385197 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385200 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385204 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 385221 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 385221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 385228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385243 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385275 */     // GIR_Coverage, 4216,
     /* 385275 */     GIR_EraseRootFromParent_Done,
     /* 385276 */   // Label 7436: @385276
     /* 385276 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(385393), // Rule ID 4250 //
     /* 385281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385307 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385310 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385314 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385321 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385331 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 385338 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 385338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 385345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385360 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385392 */     // GIR_Coverage, 4250,
     /* 385392 */     GIR_EraseRootFromParent_Done,
     /* 385393 */   // Label 7437: @385393
     /* 385393 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(385510), // Rule ID 4252 //
     /* 385398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385424 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385427 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385431 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385438 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385448 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 385455 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 385455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 385462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385477 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385499 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385504 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385509 */     // GIR_Coverage, 4252,
     /* 385509 */     GIR_EraseRootFromParent_Done,
     /* 385510 */   // Label 7438: @385510
     /* 385510 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(385584), // Rule ID 11314 //
     /* 385515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 385548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385560 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 385564 */     // MIs[3] Operand 1
     /* 385564 */     // No operand predicates
     /* 385564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385570 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx)
     /* 385570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 385573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 385575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 385579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 385582 */     GIR_RootConstrainSelectedInstOperands,
     /* 385583 */     // GIR_Coverage, 11314,
     /* 385583 */     GIR_EraseRootFromParent_Done,
     /* 385584 */   // Label 7439: @385584
     /* 385584 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(385732), // Rule ID 11258 //
     /* 385589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385610 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 385610 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 385613 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385617 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385622 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 385628 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385633 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385638 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 385641 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 385645 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385650 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 385653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 385655 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 385658 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 385662 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385667 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 385670 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 385673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 385675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 385678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 385682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385687 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 385690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 385692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 385695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 385699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385704 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 385707 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 385710 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 385713 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 385716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 385721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 385723 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 385725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385728 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 385730 */     GIR_RootConstrainSelectedInstOperands,
     /* 385731 */     // GIR_Coverage, 11258,
     /* 385731 */     GIR_EraseRootFromParent_Done,
     /* 385732 */   // Label 7440: @385732
     /* 385732 */   GIM_Reject,
     /* 385733 */ // Label 7422: @385733
     /* 385733 */ GIM_Reject,
     /* 385734 */ // Label 7128: @385734
     /* 385734 */ GIM_Reject,
     /* 385735 */ // Label 91: @385735
     /* 385735 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7444*/ GIMT_Encode4(388652),
     /* 385746 */ /*GILLT_s16*//*Label 7441*/ GIMT_Encode4(385758),
     /* 385750 */ /*GILLT_s32*//*Label 7442*/ GIMT_Encode4(386392),
     /* 385754 */ /*GILLT_s64*//*Label 7443*/ GIMT_Encode4(387985),
     /* 385758 */ // Label 7441: @385758
     /* 385758 */ GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(385802), // Rule ID 11307 //
     /* 385763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 385769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385776 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385780 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 385780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385785 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 385791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385796 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385801 */   // GIR_Coverage, 11307,
     /* 385801 */   GIR_EraseRootFromParent_Done,
     /* 385802 */ // Label 7445: @385802
     /* 385802 */ GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(385846), // Rule ID 11308 //
     /* 385807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 385813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385820 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385824 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 385824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385829 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 385835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385840 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385845 */   // GIR_Coverage, 11308,
     /* 385845 */   GIR_EraseRootFromParent_Done,
     /* 385846 */ // Label 7446: @385846
     /* 385846 */ GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(385890), // Rule ID 11309 //
     /* 385851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 385857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385864 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385868 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 385868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385873 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 385879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385884 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385889 */   // GIR_Coverage, 11309,
     /* 385889 */   GIR_EraseRootFromParent_Done,
     /* 385890 */ // Label 7447: @385890
     /* 385890 */ GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(385935), // Rule ID 5837 //
     /* 385895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385909 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385913 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 385913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385918 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 385924 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385929 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385934 */   // GIR_Coverage, 5837,
     /* 385934 */   GIR_EraseRootFromParent_Done,
     /* 385935 */ // Label 7448: @385935
     /* 385935 */ GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(385980), // Rule ID 5840 //
     /* 385940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385962 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 385966 */   // MIs[1] Operand 1
     /* 385966 */   // No operand predicates
     /* 385966 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385968 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 385968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 385971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385973 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385975 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 385978 */   GIR_RootConstrainSelectedInstOperands,
     /* 385979 */   // GIR_Coverage, 5840,
     /* 385979 */   GIR_EraseRootFromParent_Done,
     /* 385980 */ // Label 7449: @385980
     /* 385980 */ GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(386056), // Rule ID 11282 //
     /* 385985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 385991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385998 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386002 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386006 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 386010 */   // MIs[1] Operand 1
     /* 386010 */   // No operand predicates
     /* 386010 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386012 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 386012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 386019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386024 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386028 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386038 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 386045 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386050 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386055 */   // GIR_Coverage, 11282,
     /* 386055 */   GIR_EraseRootFromParent_Done,
     /* 386056 */ // Label 7450: @386056
     /* 386056 */ GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(386132), // Rule ID 11283 //
     /* 386061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 386067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386074 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386078 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386082 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 386086 */   // MIs[1] Operand 1
     /* 386086 */   // No operand predicates
     /* 386086 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386088 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 386088 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386091 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 386095 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386100 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386104 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386114 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 386121 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386126 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386131 */   // GIR_Coverage, 11283,
     /* 386131 */   GIR_EraseRootFromParent_Done,
     /* 386132 */ // Label 7451: @386132
     /* 386132 */ GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(386208), // Rule ID 11284 //
     /* 386137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 386143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386150 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386154 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386158 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 386162 */   // MIs[1] Operand 1
     /* 386162 */   // No operand predicates
     /* 386162 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386164 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 386164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 386171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386176 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386180 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386190 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 386197 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386207 */   // GIR_Coverage, 11284,
     /* 386207 */   GIR_EraseRootFromParent_Done,
     /* 386208 */ // Label 7452: @386208
     /* 386208 */ GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(386269), // Rule ID 11272 //
     /* 386213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 386219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 386230 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 386230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 386233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 386237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386242 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 386248 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 386252 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 386255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 386260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 386262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386265 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 386267 */   GIR_RootConstrainSelectedInstOperands,
     /* 386268 */   // GIR_Coverage, 11272,
     /* 386268 */   GIR_EraseRootFromParent_Done,
     /* 386269 */ // Label 7453: @386269
     /* 386269 */ GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(386330), // Rule ID 11273 //
     /* 386274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 386280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 386291 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 386291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 386294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 386298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386303 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 386309 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 386313 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 386316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 386321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 386323 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386326 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 386328 */   GIR_RootConstrainSelectedInstOperands,
     /* 386329 */   // GIR_Coverage, 11273,
     /* 386329 */   GIR_EraseRootFromParent_Done,
     /* 386330 */ // Label 7454: @386330
     /* 386330 */ GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(386391), // Rule ID 11274 //
     /* 386335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 386341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 386352 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 386352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 386355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 386359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386364 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 386370 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 386374 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 386377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 386382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 386384 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386387 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 386389 */   GIR_RootConstrainSelectedInstOperands,
     /* 386390 */   // GIR_Coverage, 11274,
     /* 386390 */   GIR_EraseRootFromParent_Done,
     /* 386391 */ // Label 7455: @386391
     /* 386391 */ GIM_Reject,
     /* 386392 */ // Label 7442: @386392
     /* 386392 */ GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(386437), // Rule ID 7016 //
     /* 386397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386411 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386415 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 386415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386420 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 386426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386436 */   // GIR_Coverage, 7016,
     /* 386436 */   GIR_EraseRootFromParent_Done,
     /* 386437 */ // Label 7456: @386437
     /* 386437 */ GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(386482), // Rule ID 7017 //
     /* 386442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386456 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386460 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 386460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386465 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 386471 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386476 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386481 */   // GIR_Coverage, 7017,
     /* 386481 */   GIR_EraseRootFromParent_Done,
     /* 386482 */ // Label 7457: @386482
     /* 386482 */ GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(386526), // Rule ID 11303 //
     /* 386487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 386493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386500 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386504 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 386504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386509 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 386515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386525 */   // GIR_Coverage, 11303,
     /* 386525 */   GIR_EraseRootFromParent_Done,
     /* 386526 */ // Label 7458: @386526
     /* 386526 */ GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(386570), // Rule ID 11304 //
     /* 386531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 386537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386544 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386548 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 386548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386553 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 386559 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386564 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386569 */   // GIR_Coverage, 11304,
     /* 386569 */   GIR_EraseRootFromParent_Done,
     /* 386570 */ // Label 7459: @386570
     /* 386570 */ GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(386614), // Rule ID 11305 //
     /* 386575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 386581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386588 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386592 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 386592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386597 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 386603 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386608 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386613 */   // GIR_Coverage, 11305,
     /* 386613 */   GIR_EraseRootFromParent_Done,
     /* 386614 */ // Label 7460: @386614
     /* 386614 */ GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(386658), // Rule ID 11310 //
     /* 386619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 386625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386632 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386636 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 386636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386641 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 386647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386652 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386657 */   // GIR_Coverage, 11310,
     /* 386657 */   GIR_EraseRootFromParent_Done,
     /* 386658 */ // Label 7461: @386658
     /* 386658 */ GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(386702), // Rule ID 11311 //
     /* 386663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 386669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386676 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386680 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 386680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386685 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 386691 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386701 */   // GIR_Coverage, 11311,
     /* 386701 */   GIR_EraseRootFromParent_Done,
     /* 386702 */ // Label 7462: @386702
     /* 386702 */ GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(386747), // Rule ID 5836 //
     /* 386707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386721 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386725 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 386725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386730 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 386736 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386746 */   // GIR_Coverage, 5836,
     /* 386746 */   GIR_EraseRootFromParent_Done,
     /* 386747 */ // Label 7463: @386747
     /* 386747 */ GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(386820), // Rule ID 11288 //
     /* 386752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 386758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386765 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386769 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386773 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 386777 */   // MIs[1] Operand 1
     /* 386777 */   // No operand predicates
     /* 386777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386779 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 386779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 386782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386791 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 386797 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386802 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 386810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386815 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 386818 */   GIR_RootConstrainSelectedInstOperands,
     /* 386819 */   // GIR_Coverage, 11288,
     /* 386819 */   GIR_EraseRootFromParent_Done,
     /* 386820 */ // Label 7464: @386820
     /* 386820 */ GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(386893), // Rule ID 11289 //
     /* 386825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 386831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386838 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386842 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386846 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386850 */   // MIs[1] Operand 1
     /* 386850 */   // No operand predicates
     /* 386850 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386852 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 386852 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 386855 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386859 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386864 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 386870 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386875 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 386883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386888 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 386891 */   GIR_RootConstrainSelectedInstOperands,
     /* 386892 */   // GIR_Coverage, 11289,
     /* 386892 */   GIR_EraseRootFromParent_Done,
     /* 386893 */ // Label 7465: @386893
     /* 386893 */ GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(386966), // Rule ID 11290 //
     /* 386898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 386904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386911 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386915 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386919 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386923 */   // MIs[1] Operand 1
     /* 386923 */   // No operand predicates
     /* 386923 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386925 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 386925 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 386928 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386932 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386937 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 386943 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386948 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 386956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386961 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 386964 */   GIR_RootConstrainSelectedInstOperands,
     /* 386965 */   // GIR_Coverage, 11290,
     /* 386965 */   GIR_EraseRootFromParent_Done,
     /* 386966 */ // Label 7466: @386966
     /* 386966 */ GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(387014), // Rule ID 1926 //
     /* 386971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 386974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 386977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386988 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386992 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386996 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 387000 */   // MIs[1] Operand 1
     /* 387000 */   // No operand predicates
     /* 387000 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387002 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 387005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387007 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387009 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387012 */   GIR_RootConstrainSelectedInstOperands,
     /* 387013 */   // GIR_Coverage, 1926,
     /* 387013 */   GIR_EraseRootFromParent_Done,
     /* 387014 */ // Label 7467: @387014
     /* 387014 */ GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(387062), // Rule ID 1927 //
     /* 387019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 387022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387036 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387040 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387044 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 387048 */   // MIs[1] Operand 1
     /* 387048 */   // No operand predicates
     /* 387048 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387050 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 387053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387055 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387057 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387060 */   GIR_RootConstrainSelectedInstOperands,
     /* 387061 */   // GIR_Coverage, 1927,
     /* 387061 */   GIR_EraseRootFromParent_Done,
     /* 387062 */ // Label 7468: @387062
     /* 387062 */ GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(387110), // Rule ID 1928 //
     /* 387067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 387070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387084 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387088 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387092 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 387096 */   // MIs[1] Operand 1
     /* 387096 */   // No operand predicates
     /* 387096 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387098 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 387101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387103 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387105 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387108 */   GIR_RootConstrainSelectedInstOperands,
     /* 387109 */   // GIR_Coverage, 1928,
     /* 387109 */   GIR_EraseRootFromParent_Done,
     /* 387110 */ // Label 7469: @387110
     /* 387110 */ GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(387158), // Rule ID 1930 //
     /* 387115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 387121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387132 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387136 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387140 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 387144 */   // MIs[1] Operand 1
     /* 387144 */   // No operand predicates
     /* 387144 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387146 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 387149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387151 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387153 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387156 */   GIR_RootConstrainSelectedInstOperands,
     /* 387157 */   // GIR_Coverage, 1930,
     /* 387157 */   GIR_EraseRootFromParent_Done,
     /* 387158 */ // Label 7470: @387158
     /* 387158 */ GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(387206), // Rule ID 1931 //
     /* 387163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387180 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387184 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387188 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387192 */   // MIs[1] Operand 1
     /* 387192 */   // No operand predicates
     /* 387192 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387194 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 387197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387199 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387201 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387204 */   GIR_RootConstrainSelectedInstOperands,
     /* 387205 */   // GIR_Coverage, 1931,
     /* 387205 */   GIR_EraseRootFromParent_Done,
     /* 387206 */ // Label 7471: @387206
     /* 387206 */ GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(387254), // Rule ID 1932 //
     /* 387211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387228 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387236 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 387240 */   // MIs[1] Operand 1
     /* 387240 */   // No operand predicates
     /* 387240 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387242 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 387245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387247 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387249 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387252 */   GIR_RootConstrainSelectedInstOperands,
     /* 387253 */   // GIR_Coverage, 1932,
     /* 387253 */   GIR_EraseRootFromParent_Done,
     /* 387254 */ // Label 7472: @387254
     /* 387254 */ GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(387299), // Rule ID 5839 //
     /* 387259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387273 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387277 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387281 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 387285 */   // MIs[1] Operand 1
     /* 387285 */   // No operand predicates
     /* 387285 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387287 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 387290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387292 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387294 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387297 */   GIR_RootConstrainSelectedInstOperands,
     /* 387298 */   // GIR_Coverage, 5839,
     /* 387298 */   GIR_EraseRootFromParent_Done,
     /* 387299 */ // Label 7473: @387299
     /* 387299 */ GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(387375), // Rule ID 11278 //
     /* 387304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 387310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387317 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387321 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387325 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 387329 */   // MIs[1] Operand 1
     /* 387329 */   // No operand predicates
     /* 387329 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387331 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 387331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 387338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387343 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387347 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387357 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 387364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387369 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387374 */   // GIR_Coverage, 11278,
     /* 387374 */   GIR_EraseRootFromParent_Done,
     /* 387375 */ // Label 7474: @387375
     /* 387375 */ GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(387451), // Rule ID 11279 //
     /* 387380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387393 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387397 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387401 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 387405 */   // MIs[1] Operand 1
     /* 387405 */   // No operand predicates
     /* 387405 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387407 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 387407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 387414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387419 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387423 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387433 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 387440 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387445 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387450 */   // GIR_Coverage, 11279,
     /* 387450 */   GIR_EraseRootFromParent_Done,
     /* 387451 */ // Label 7475: @387451
     /* 387451 */ GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(387527), // Rule ID 11280 //
     /* 387456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387469 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387477 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 387481 */   // MIs[1] Operand 1
     /* 387481 */   // No operand predicates
     /* 387481 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387483 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 387483 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387486 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 387490 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387495 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387499 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387509 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 387516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387521 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387526 */   // GIR_Coverage, 11280,
     /* 387526 */   GIR_EraseRootFromParent_Done,
     /* 387527 */ // Label 7476: @387527
     /* 387527 */ GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(387603), // Rule ID 11285 //
     /* 387532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387545 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387549 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387553 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 387557 */   // MIs[1] Operand 1
     /* 387557 */   // No operand predicates
     /* 387557 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387559 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 387559 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387562 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 387566 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387571 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387575 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387585 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 387592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387597 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387602 */   // GIR_Coverage, 11285,
     /* 387602 */   GIR_EraseRootFromParent_Done,
     /* 387603 */ // Label 7477: @387603
     /* 387603 */ GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(387679), // Rule ID 11286 //
     /* 387608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 387614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387629 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 387633 */   // MIs[1] Operand 1
     /* 387633 */   // No operand predicates
     /* 387633 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387635 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 387635 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387638 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 387642 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387647 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387651 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387661 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 387668 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387673 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387678 */   // GIR_Coverage, 11286,
     /* 387678 */   GIR_EraseRootFromParent_Done,
     /* 387679 */ // Label 7478: @387679
     /* 387679 */ GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(387740), // Rule ID 11268 //
     /* 387684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 387690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387701 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 387701 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387704 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 387708 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387713 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387719 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387723 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 387731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387736 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387738 */   GIR_RootConstrainSelectedInstOperands,
     /* 387739 */   // GIR_Coverage, 11268,
     /* 387739 */   GIR_EraseRootFromParent_Done,
     /* 387740 */ // Label 7479: @387740
     /* 387740 */ GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(387801), // Rule ID 11269 //
     /* 387745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387762 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 387762 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387765 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 387769 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387774 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387780 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387784 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 387792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387797 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387799 */   GIR_RootConstrainSelectedInstOperands,
     /* 387800 */   // GIR_Coverage, 11269,
     /* 387800 */   GIR_EraseRootFromParent_Done,
     /* 387801 */ // Label 7480: @387801
     /* 387801 */ GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(387862), // Rule ID 11270 //
     /* 387806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387823 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 387823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 387830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387835 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387841 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387845 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 387853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387858 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387860 */   GIR_RootConstrainSelectedInstOperands,
     /* 387861 */   // GIR_Coverage, 11270,
     /* 387861 */   GIR_EraseRootFromParent_Done,
     /* 387862 */ // Label 7481: @387862
     /* 387862 */ GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(387923), // Rule ID 11275 //
     /* 387867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387884 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 387884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 387891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387896 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387902 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387906 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 387914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 387916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387919 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387921 */   GIR_RootConstrainSelectedInstOperands,
     /* 387922 */   // GIR_Coverage, 11275,
     /* 387922 */   GIR_EraseRootFromParent_Done,
     /* 387923 */ // Label 7482: @387923
     /* 387923 */ GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(387984), // Rule ID 11276 //
     /* 387928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 387934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387945 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 387945 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387948 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 387952 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387957 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387963 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387967 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 387975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 387977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387980 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387982 */   GIR_RootConstrainSelectedInstOperands,
     /* 387983 */   // GIR_Coverage, 11276,
     /* 387983 */   GIR_EraseRootFromParent_Done,
     /* 387984 */ // Label 7483: @387984
     /* 387984 */ GIM_Reject,
     /* 387985 */ // Label 7443: @387985
     /* 387985 */ GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(388030), // Rule ID 7015 //
     /* 387990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388004 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388008 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 388008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388013 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 388019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388024 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388029 */   // GIR_Coverage, 7015,
     /* 388029 */   GIR_EraseRootFromParent_Done,
     /* 388030 */ // Label 7484: @388030
     /* 388030 */ GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(388074), // Rule ID 11306 //
     /* 388035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388048 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388052 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 388052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388057 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 388063 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388068 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388073 */   // GIR_Coverage, 11306,
     /* 388073 */   GIR_EraseRootFromParent_Done,
     /* 388074 */ // Label 7485: @388074
     /* 388074 */ GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(388118), // Rule ID 11312 //
     /* 388079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388092 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388096 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 388096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388101 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 388107 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388112 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388117 */   // GIR_Coverage, 11312,
     /* 388117 */   GIR_EraseRootFromParent_Done,
     /* 388118 */ // Label 7486: @388118
     /* 388118 */ GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(388163), // Rule ID 5835 //
     /* 388123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388137 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388141 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 388141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388146 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 388152 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388157 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388162 */   // GIR_Coverage, 5835,
     /* 388162 */   GIR_EraseRootFromParent_Done,
     /* 388163 */ // Label 7487: @388163
     /* 388163 */ GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(388236), // Rule ID 11291 //
     /* 388168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388181 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388185 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388189 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 388193 */   // MIs[1] Operand 1
     /* 388193 */   // No operand predicates
     /* 388193 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388195 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 388195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 388198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388207 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 388213 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388218 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 388226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388228 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388231 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 388234 */   GIR_RootConstrainSelectedInstOperands,
     /* 388235 */   // GIR_Coverage, 11291,
     /* 388235 */   GIR_EraseRootFromParent_Done,
     /* 388236 */ // Label 7488: @388236
     /* 388236 */ GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(388284), // Rule ID 1929 //
     /* 388241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 388244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388266 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 388270 */   // MIs[1] Operand 1
     /* 388270 */   // No operand predicates
     /* 388270 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388272 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 388275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388277 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388279 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388282 */   GIR_RootConstrainSelectedInstOperands,
     /* 388283 */   // GIR_Coverage, 1929,
     /* 388283 */   GIR_EraseRootFromParent_Done,
     /* 388284 */ // Label 7489: @388284
     /* 388284 */ GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(388332), // Rule ID 1933 //
     /* 388289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388306 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388310 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388314 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 388318 */   // MIs[1] Operand 1
     /* 388318 */   // No operand predicates
     /* 388318 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388320 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 388323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388325 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388327 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388330 */   GIR_RootConstrainSelectedInstOperands,
     /* 388331 */   // GIR_Coverage, 1933,
     /* 388331 */   GIR_EraseRootFromParent_Done,
     /* 388332 */ // Label 7490: @388332
     /* 388332 */ GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(388377), // Rule ID 5838 //
     /* 388337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388351 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388355 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388359 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 388363 */   // MIs[1] Operand 1
     /* 388363 */   // No operand predicates
     /* 388363 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388365 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 388365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 388368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388370 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388372 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388375 */   GIR_RootConstrainSelectedInstOperands,
     /* 388376 */   // GIR_Coverage, 5838,
     /* 388376 */   GIR_EraseRootFromParent_Done,
     /* 388377 */ // Label 7491: @388377
     /* 388377 */ GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(388453), // Rule ID 11281 //
     /* 388382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388395 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388399 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388403 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388407 */   // MIs[1] Operand 1
     /* 388407 */   // No operand predicates
     /* 388407 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388409 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 388409 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388412 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388416 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388421 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388425 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388435 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 388442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388447 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388452 */   // GIR_Coverage, 11281,
     /* 388452 */   GIR_EraseRootFromParent_Done,
     /* 388453 */ // Label 7492: @388453
     /* 388453 */ GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(388529), // Rule ID 11287 //
     /* 388458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388471 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388475 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388479 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388483 */   // MIs[1] Operand 1
     /* 388483 */   // No operand predicates
     /* 388483 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388485 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 388485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388497 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388501 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388511 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 388518 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388523 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388528 */   // GIR_Coverage, 11287,
     /* 388528 */   GIR_EraseRootFromParent_Done,
     /* 388529 */ // Label 7493: @388529
     /* 388529 */ GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(388590), // Rule ID 11271 //
     /* 388534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388551 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 388551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 388558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388563 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388569 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388573 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 388581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388586 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388588 */   GIR_RootConstrainSelectedInstOperands,
     /* 388589 */   // GIR_Coverage, 11271,
     /* 388589 */   GIR_EraseRootFromParent_Done,
     /* 388590 */ // Label 7494: @388590
     /* 388590 */ GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(388651), // Rule ID 11277 //
     /* 388595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388612 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 388612 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 388619 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388624 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388630 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388634 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 388642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 388644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388647 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388649 */   GIR_RootConstrainSelectedInstOperands,
     /* 388650 */   // GIR_Coverage, 11277,
     /* 388650 */   GIR_EraseRootFromParent_Done,
     /* 388651 */ // Label 7495: @388651
     /* 388651 */ GIM_Reject,
     /* 388652 */ // Label 7444: @388652
     /* 388652 */ GIM_Reject,
     /* 388653 */ // Label 92: @388653
     /* 388653 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7503*/ GIMT_Encode4(390972),
     /* 388664 */ /*GILLT_nxv2s16*//*Label 7496*/ GIMT_Encode4(388704),
     /* 388668 */ /*GILLT_nxv2s32*//*Label 7497*/ GIMT_Encode4(389063),
     /* 388672 */ /*GILLT_nxv2s64*//*Label 7498*/ GIMT_Encode4(389365), GIMT_Encode4(0),
     /* 388680 */ /*GILLT_nxv4s16*//*Label 7499*/ GIMT_Encode4(389740),
     /* 388684 */ /*GILLT_nxv4s32*//*Label 7500*/ GIMT_Encode4(390042), GIMT_Encode4(0),
     /* 388692 */ /*GILLT_nxv8s16*//*Label 7501*/ GIMT_Encode4(390417), GIMT_Encode4(0),
     /* 388700 */ /*GILLT_nxv16s8*//*Label 7502*/ GIMT_Encode4(390828),
     /* 388704 */ // Label 7496: @388704
     /* 388704 */ GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(389062),
     /* 388709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 388712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388716 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(388780), // Rule ID 6069 //
     /* 388721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388732 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 388736 */     // MIs[1] Operand 1
     /* 388736 */     // No operand predicates
     /* 388736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388738 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 388738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 388745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388750 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 388769 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388779 */     // GIR_Coverage, 6069,
     /* 388779 */     GIR_EraseRootFromParent_Done,
     /* 388780 */   // Label 7505: @388780
     /* 388780 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(388837), // Rule ID 2675 //
     /* 388785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 388800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388817 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 388821 */     // MIs[2] Operand 1
     /* 388821 */     // No operand predicates
     /* 388821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388823 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 388823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 388826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388835 */     GIR_RootConstrainSelectedInstOperands,
     /* 388836 */     // GIR_Coverage, 2675,
     /* 388836 */     GIR_EraseRootFromParent_Done,
     /* 388837 */   // Label 7506: @388837
     /* 388837 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(388894), // Rule ID 2677 //
     /* 388842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 388857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388874 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388878 */     // MIs[2] Operand 1
     /* 388878 */     // No operand predicates
     /* 388878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388880 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 388880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388892 */     GIR_RootConstrainSelectedInstOperands,
     /* 388893 */     // GIR_Coverage, 2677,
     /* 388893 */     GIR_EraseRootFromParent_Done,
     /* 388894 */   // Label 7507: @388894
     /* 388894 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(388951), // Rule ID 8411 //
     /* 388899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388931 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 388935 */     // MIs[2] Operand 1
     /* 388935 */     // No operand predicates
     /* 388935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388937 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 388937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 388940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388949 */     GIR_RootConstrainSelectedInstOperands,
     /* 388950 */     // GIR_Coverage, 8411,
     /* 388950 */     GIR_EraseRootFromParent_Done,
     /* 388951 */   // Label 7508: @388951
     /* 388951 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(388985), // Rule ID 8454 //
     /* 388956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388967 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 388971 */     // MIs[1] Operand 1
     /* 388971 */     // No operand predicates
     /* 388971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388973 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 388973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 388976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388978 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 388983 */     GIR_RootConstrainSelectedInstOperands,
     /* 388984 */     // GIR_Coverage, 8454,
     /* 388984 */     GIR_EraseRootFromParent_Done,
     /* 388985 */   // Label 7509: @388985
     /* 388985 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(389061), // Rule ID 8432 //
     /* 388990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388997 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388997 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 389000 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 389004 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 389011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 389018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389023 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 389026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 389030 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 389033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389059 */     GIR_RootConstrainSelectedInstOperands,
     /* 389060 */     // GIR_Coverage, 8432,
     /* 389060 */     GIR_EraseRootFromParent_Done,
     /* 389061 */   // Label 7510: @389061
     /* 389061 */   GIM_Reject,
     /* 389062 */ // Label 7504: @389062
     /* 389062 */ GIM_Reject,
     /* 389063 */ // Label 7497: @389063
     /* 389063 */ GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(389364),
     /* 389068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 389071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389075 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(389139), // Rule ID 6067 //
     /* 389080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389091 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 389095 */     // MIs[1] Operand 1
     /* 389095 */     // No operand predicates
     /* 389095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389097 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389109 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389138 */     // GIR_Coverage, 6067,
     /* 389138 */     GIR_EraseRootFromParent_Done,
     /* 389139 */   // Label 7512: @389139
     /* 389139 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(389196), // Rule ID 8420 //
     /* 389144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389176 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389180 */     // MIs[2] Operand 1
     /* 389180 */     // No operand predicates
     /* 389180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389182 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 389182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389194 */     GIR_RootConstrainSelectedInstOperands,
     /* 389195 */     // GIR_Coverage, 8420,
     /* 389195 */     GIR_EraseRootFromParent_Done,
     /* 389196 */   // Label 7513: @389196
     /* 389196 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(389253), // Rule ID 8429 //
     /* 389201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 389216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389233 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 389237 */     // MIs[2] Operand 1
     /* 389237 */     // No operand predicates
     /* 389237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389239 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 389239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389251 */     GIR_RootConstrainSelectedInstOperands,
     /* 389252 */     // GIR_Coverage, 8429,
     /* 389252 */     GIR_EraseRootFromParent_Done,
     /* 389253 */   // Label 7514: @389253
     /* 389253 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(389287), // Rule ID 8456 //
     /* 389258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389269 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 389273 */     // MIs[1] Operand 1
     /* 389273 */     // No operand predicates
     /* 389273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389275 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 389275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 389278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389280 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 389285 */     GIR_RootConstrainSelectedInstOperands,
     /* 389286 */     // GIR_Coverage, 8456,
     /* 389286 */     GIR_EraseRootFromParent_Done,
     /* 389287 */   // Label 7515: @389287
     /* 389287 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(389363), // Rule ID 8434 //
     /* 389292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389299 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389299 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 389302 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 389306 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 389313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 389320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389325 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 389328 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 389332 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389361 */     GIR_RootConstrainSelectedInstOperands,
     /* 389362 */     // GIR_Coverage, 8434,
     /* 389362 */     GIR_EraseRootFromParent_Done,
     /* 389363 */   // Label 7516: @389363
     /* 389363 */   GIM_Reject,
     /* 389364 */ // Label 7511: @389364
     /* 389364 */ GIM_Reject,
     /* 389365 */ // Label 7498: @389365
     /* 389365 */ GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(389739),
     /* 389370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 389373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389377 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(389431), // Rule ID 6062 //
     /* 389382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 389389 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389401 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389430 */     // GIR_Coverage, 6062,
     /* 389430 */     GIR_EraseRootFromParent_Done,
     /* 389431 */   // Label 7518: @389431
     /* 389431 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(389495), // Rule ID 6066 //
     /* 389436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389447 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 389451 */     // MIs[1] Operand 1
     /* 389451 */     // No operand predicates
     /* 389451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389453 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389465 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389494 */     // GIR_Coverage, 6066,
     /* 389494 */     GIR_EraseRootFromParent_Done,
     /* 389495 */   // Label 7519: @389495
     /* 389495 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(389552), // Rule ID 2672 //
     /* 389500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389532 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 389536 */     // MIs[2] Operand 1
     /* 389536 */     // No operand predicates
     /* 389536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389538 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 389538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389550 */     GIR_RootConstrainSelectedInstOperands,
     /* 389551 */     // GIR_Coverage, 2672,
     /* 389551 */     GIR_EraseRootFromParent_Done,
     /* 389552 */   // Label 7520: @389552
     /* 389552 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(389609), // Rule ID 8426 //
     /* 389557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 389593 */     // MIs[2] Operand 1
     /* 389593 */     // No operand predicates
     /* 389593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389595 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 389595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389607 */     GIR_RootConstrainSelectedInstOperands,
     /* 389608 */     // GIR_Coverage, 8426,
     /* 389608 */     GIR_EraseRootFromParent_Done,
     /* 389609 */   // Label 7521: @389609
     /* 389609 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(389643), // Rule ID 8457 //
     /* 389614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389625 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 389629 */     // MIs[1] Operand 1
     /* 389629 */     // No operand predicates
     /* 389629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389631 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 389631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 389634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389636 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 389641 */     GIR_RootConstrainSelectedInstOperands,
     /* 389642 */     // GIR_Coverage, 8457,
     /* 389642 */     GIR_EraseRootFromParent_Done,
     /* 389643 */   // Label 7522: @389643
     /* 389643 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(389662), // Rule ID 2391 //
     /* 389648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 389655 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 389655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 389660 */     GIR_RootConstrainSelectedInstOperands,
     /* 389661 */     // GIR_Coverage, 2391,
     /* 389661 */     GIR_Done,
     /* 389662 */   // Label 7523: @389662
     /* 389662 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(389738), // Rule ID 8435 //
     /* 389667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389674 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389674 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 389677 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 389681 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 389688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 389695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389700 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 389703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 389707 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 389710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389736 */     GIR_RootConstrainSelectedInstOperands,
     /* 389737 */     // GIR_Coverage, 8435,
     /* 389737 */     GIR_EraseRootFromParent_Done,
     /* 389738 */   // Label 7524: @389738
     /* 389738 */   GIM_Reject,
     /* 389739 */ // Label 7517: @389739
     /* 389739 */ GIM_Reject,
     /* 389740 */ // Label 7499: @389740
     /* 389740 */ GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(390041),
     /* 389745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 389748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389752 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(389816), // Rule ID 6070 //
     /* 389757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389768 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 389772 */     // MIs[1] Operand 1
     /* 389772 */     // No operand predicates
     /* 389772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389774 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389786 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389815 */     // GIR_Coverage, 6070,
     /* 389815 */     GIR_EraseRootFromParent_Done,
     /* 389816 */   // Label 7526: @389816
     /* 389816 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(389873), // Rule ID 2676 //
     /* 389821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 389836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389853 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389857 */     // MIs[2] Operand 1
     /* 389857 */     // No operand predicates
     /* 389857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389859 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 389859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389871 */     GIR_RootConstrainSelectedInstOperands,
     /* 389872 */     // GIR_Coverage, 2676,
     /* 389872 */     GIR_EraseRootFromParent_Done,
     /* 389873 */   // Label 7527: @389873
     /* 389873 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(389930), // Rule ID 8414 //
     /* 389878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 389893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389910 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 389914 */     // MIs[2] Operand 1
     /* 389914 */     // No operand predicates
     /* 389914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389916 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 389916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389928 */     GIR_RootConstrainSelectedInstOperands,
     /* 389929 */     // GIR_Coverage, 8414,
     /* 389929 */     GIR_EraseRootFromParent_Done,
     /* 389930 */   // Label 7528: @389930
     /* 389930 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(389964), // Rule ID 8453 //
     /* 389935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389946 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 389950 */     // MIs[1] Operand 1
     /* 389950 */     // No operand predicates
     /* 389950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389952 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 389952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 389955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389957 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 389962 */     GIR_RootConstrainSelectedInstOperands,
     /* 389963 */     // GIR_Coverage, 8453,
     /* 389963 */     GIR_EraseRootFromParent_Done,
     /* 389964 */   // Label 7529: @389964
     /* 389964 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(390040), // Rule ID 8431 //
     /* 389969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389976 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389976 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 389979 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 389983 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 389990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 389997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390002 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 390005 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 390009 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 390012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390038 */     GIR_RootConstrainSelectedInstOperands,
     /* 390039 */     // GIR_Coverage, 8431,
     /* 390039 */     GIR_EraseRootFromParent_Done,
     /* 390040 */   // Label 7530: @390040
     /* 390040 */   GIM_Reject,
     /* 390041 */ // Label 7525: @390041
     /* 390041 */ GIM_Reject,
     /* 390042 */ // Label 7500: @390042
     /* 390042 */ GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(390416),
     /* 390047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390054 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(390108), // Rule ID 6063 //
     /* 390059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 390066 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390078 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390107 */     // GIR_Coverage, 6063,
     /* 390107 */     GIR_EraseRootFromParent_Done,
     /* 390108 */   // Label 7532: @390108
     /* 390108 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(390172), // Rule ID 6068 //
     /* 390113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390124 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 390128 */     // MIs[1] Operand 1
     /* 390128 */     // No operand predicates
     /* 390128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390130 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390142 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390171 */     // GIR_Coverage, 6068,
     /* 390171 */     GIR_EraseRootFromParent_Done,
     /* 390172 */   // Label 7533: @390172
     /* 390172 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(390229), // Rule ID 2669 //
     /* 390177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 390192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390209 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 390213 */     // MIs[2] Operand 1
     /* 390213 */     // No operand predicates
     /* 390213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390215 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 390215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 390218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390227 */     GIR_RootConstrainSelectedInstOperands,
     /* 390228 */     // GIR_Coverage, 2669,
     /* 390228 */     GIR_EraseRootFromParent_Done,
     /* 390229 */   // Label 7534: @390229
     /* 390229 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(390286), // Rule ID 8423 //
     /* 390234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 390249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390266 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 390270 */     // MIs[2] Operand 1
     /* 390270 */     // No operand predicates
     /* 390270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390272 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 390272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 390275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390284 */     GIR_RootConstrainSelectedInstOperands,
     /* 390285 */     // GIR_Coverage, 8423,
     /* 390285 */     GIR_EraseRootFromParent_Done,
     /* 390286 */   // Label 7535: @390286
     /* 390286 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(390320), // Rule ID 8455 //
     /* 390291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390302 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 390306 */     // MIs[1] Operand 1
     /* 390306 */     // No operand predicates
     /* 390306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390308 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 390308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 390311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390313 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 390318 */     GIR_RootConstrainSelectedInstOperands,
     /* 390319 */     // GIR_Coverage, 8455,
     /* 390319 */     GIR_EraseRootFromParent_Done,
     /* 390320 */   // Label 7536: @390320
     /* 390320 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(390339), // Rule ID 2390 //
     /* 390325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 390332 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 390332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 390337 */     GIR_RootConstrainSelectedInstOperands,
     /* 390338 */     // GIR_Coverage, 2390,
     /* 390338 */     GIR_Done,
     /* 390339 */   // Label 7537: @390339
     /* 390339 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(390415), // Rule ID 8433 //
     /* 390344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390351 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390351 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 390354 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 390358 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 390365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 390372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390377 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 390380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 390384 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 390405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390413 */     GIR_RootConstrainSelectedInstOperands,
     /* 390414 */     // GIR_Coverage, 8433,
     /* 390414 */     GIR_EraseRootFromParent_Done,
     /* 390415 */   // Label 7538: @390415
     /* 390415 */   GIM_Reject,
     /* 390416 */ // Label 7531: @390416
     /* 390416 */ GIM_Reject,
     /* 390417 */ // Label 7501: @390417
     /* 390417 */ GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(390478), // Rule ID 6064 //
     /* 390422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390432 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 390436 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390448 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390461 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390467 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390472 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390477 */   // GIR_Coverage, 6064,
     /* 390477 */   GIR_EraseRootFromParent_Done,
     /* 390478 */ // Label 7539: @390478
     /* 390478 */ GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(390549), // Rule ID 6071 //
     /* 390483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 390489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390493 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390497 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390501 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 390505 */   // MIs[1] Operand 1
     /* 390505 */   // No operand predicates
     /* 390505 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390507 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390507 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390510 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390514 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390519 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390538 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390543 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390548 */   // GIR_Coverage, 6071,
     /* 390548 */   GIR_EraseRootFromParent_Done,
     /* 390549 */ // Label 7540: @390549
     /* 390549 */ GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(390613), // Rule ID 2666 //
     /* 390554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390564 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390568 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390572 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 390576 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390580 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390585 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390589 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390593 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 390597 */   // MIs[2] Operand 1
     /* 390597 */   // No operand predicates
     /* 390597 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390599 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 390599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390604 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390608 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390611 */   GIR_RootConstrainSelectedInstOperands,
     /* 390612 */   // GIR_Coverage, 2666,
     /* 390612 */   GIR_EraseRootFromParent_Done,
     /* 390613 */ // Label 7541: @390613
     /* 390613 */ GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(390677), // Rule ID 8417 //
     /* 390618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 390624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390628 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390632 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390636 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 390640 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390644 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390649 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390653 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390657 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 390661 */   // MIs[2] Operand 1
     /* 390661 */   // No operand predicates
     /* 390661 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390663 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 390663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390668 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390672 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390675 */   GIR_RootConstrainSelectedInstOperands,
     /* 390676 */   // GIR_Coverage, 8417,
     /* 390676 */   GIR_EraseRootFromParent_Done,
     /* 390677 */ // Label 7542: @390677
     /* 390677 */ GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(390718), // Rule ID 8452 //
     /* 390682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 390688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390692 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390700 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 390704 */   // MIs[1] Operand 1
     /* 390704 */   // No operand predicates
     /* 390704 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390706 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 390706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 390709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390711 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 390716 */   GIR_RootConstrainSelectedInstOperands,
     /* 390717 */   // GIR_Coverage, 8452,
     /* 390717 */   GIR_EraseRootFromParent_Done,
     /* 390718 */ // Label 7543: @390718
     /* 390718 */ GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(390744), // Rule ID 2389 //
     /* 390723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 390737 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 390737 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 390742 */   GIR_RootConstrainSelectedInstOperands,
     /* 390743 */   // GIR_Coverage, 2389,
     /* 390743 */   GIR_Done,
     /* 390744 */ // Label 7544: @390744
     /* 390744 */ GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(390827), // Rule ID 8430 //
     /* 390749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 390755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390763 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390763 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 390766 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 390770 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 390777 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390780 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 390784 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390789 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 390792 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 390796 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 390799 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390804 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390809 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390819 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390825 */   GIR_RootConstrainSelectedInstOperands,
     /* 390826 */   // GIR_Coverage, 8430,
     /* 390826 */   GIR_EraseRootFromParent_Done,
     /* 390827 */ // Label 7545: @390827
     /* 390827 */ GIM_Reject,
     /* 390828 */ // Label 7502: @390828
     /* 390828 */ GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(390971),
     /* 390833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390840 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(390894), // Rule ID 6065 //
     /* 390845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 390852 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390864 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390893 */     // GIR_Coverage, 6065,
     /* 390893 */     GIR_EraseRootFromParent_Done,
     /* 390894 */   // Label 7547: @390894
     /* 390894 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(390951), // Rule ID 2663 //
     /* 390899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 390914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390931 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 390935 */     // MIs[2] Operand 1
     /* 390935 */     // No operand predicates
     /* 390935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390937 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 390937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 390940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390949 */     GIR_RootConstrainSelectedInstOperands,
     /* 390950 */     // GIR_Coverage, 2663,
     /* 390950 */     GIR_EraseRootFromParent_Done,
     /* 390951 */   // Label 7548: @390951
     /* 390951 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(390970), // Rule ID 2388 //
     /* 390956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 390963 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 390963 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 390968 */     GIR_RootConstrainSelectedInstOperands,
     /* 390969 */     // GIR_Coverage, 2388,
     /* 390969 */     GIR_Done,
     /* 390970 */   // Label 7549: @390970
     /* 390970 */   GIM_Reject,
     /* 390971 */ // Label 7546: @390971
     /* 390971 */ GIM_Reject,
     /* 390972 */ // Label 7503: @390972
     /* 390972 */ GIM_Reject,
     /* 390973 */ // Label 93: @390973
     /* 390973 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7552*/ GIMT_Encode4(391124),
     /* 390984 */ /*GILLT_s32*//*Label 7550*/ GIMT_Encode4(390992),
     /* 390988 */ /*GILLT_s64*//*Label 7551*/ GIMT_Encode4(391058),
     /* 390992 */ // Label 7550: @390992
     /* 390992 */ GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(391057),
     /* 390997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391008 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(391023), // Rule ID 2321 //
     /* 391013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 391016 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 391021 */     GIR_RootConstrainSelectedInstOperands,
     /* 391022 */     // GIR_Coverage, 2321,
     /* 391022 */     GIR_Done,
     /* 391023 */   // Label 7554: @391023
     /* 391023 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(391056), // Rule ID 4005 //
     /* 391028 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 391028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 391031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 391035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 391049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391054 */     GIR_RootConstrainSelectedInstOperands,
     /* 391055 */     // GIR_Coverage, 4005,
     /* 391055 */     GIR_EraseRootFromParent_Done,
     /* 391056 */   // Label 7555: @391056
     /* 391056 */   GIM_Reject,
     /* 391057 */ // Label 7553: @391057
     /* 391057 */ GIM_Reject,
     /* 391058 */ // Label 7551: @391058
     /* 391058 */ GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(391123),
     /* 391063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391074 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(391089), // Rule ID 2322 //
     /* 391079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 391082 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 391087 */     GIR_RootConstrainSelectedInstOperands,
     /* 391088 */     // GIR_Coverage, 2322,
     /* 391088 */     GIR_Done,
     /* 391089 */   // Label 7557: @391089
     /* 391089 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(391122), // Rule ID 4006 //
     /* 391094 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 391094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 391097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 391101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 391115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391120 */     GIR_RootConstrainSelectedInstOperands,
     /* 391121 */     // GIR_Coverage, 4006,
     /* 391121 */     GIR_EraseRootFromParent_Done,
     /* 391122 */   // Label 7558: @391122
     /* 391122 */   GIM_Reject,
     /* 391123 */ // Label 7556: @391123
     /* 391123 */ GIM_Reject,
     /* 391124 */ // Label 7552: @391124
     /* 391124 */ GIM_Reject,
     /* 391125 */ // Label 94: @391125
     /* 391125 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7567*/ GIMT_Encode4(391798),
     /* 391136 */ /*GILLT_s32*//*Label 7559*/ GIMT_Encode4(391176),
     /* 391140 */ /*GILLT_s64*//*Label 7560*/ GIMT_Encode4(391406), GIMT_Encode4(0),
     /* 391148 */ /*GILLT_v2s32*//*Label 7561*/ GIMT_Encode4(391636), GIMT_Encode4(0),
     /* 391156 */ /*GILLT_v4s16*//*Label 7562*/ GIMT_Encode4(391663),
     /* 391160 */ /*GILLT_v4s32*//*Label 7563*/ GIMT_Encode4(391690),
     /* 391164 */ /*GILLT_v8s8*//*Label 7564*/ GIMT_Encode4(391717),
     /* 391168 */ /*GILLT_v8s16*//*Label 7565*/ GIMT_Encode4(391744),
     /* 391172 */ /*GILLT_v16s8*//*Label 7566*/ GIMT_Encode4(391771),
     /* 391176 */ // Label 7559: @391176
     /* 391176 */ GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(391405),
     /* 391181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391188 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(391288), // Rule ID 4007 //
     /* 391193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 391201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 391205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 391209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 391217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 391221 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 391233 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 391237 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 391241 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 391245 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 391249 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 391253 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391258 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 391262 */     // MIs[3] Rn
     /* 391262 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 391267 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 391271 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 391275 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 391277 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 391280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 391286 */     GIR_RootConstrainSelectedInstOperands,
     /* 391287 */     // GIR_Coverage, 4007,
     /* 391287 */     GIR_EraseRootFromParent_Done,
     /* 391288 */   // Label 7569: @391288
     /* 391288 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(391388), // Rule ID 13881 //
     /* 391293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 391301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 391305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 391309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 391317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 391321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391329 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 391333 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 391337 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 391341 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391346 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 391350 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 391354 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 391358 */     // MIs[4] Rn
     /* 391358 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 391363 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 391367 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 391371 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 391375 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 391377 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 391380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 391386 */     GIR_RootConstrainSelectedInstOperands,
     /* 391387 */     // GIR_Coverage, 13881,
     /* 391387 */     GIR_EraseRootFromParent_Done,
     /* 391388 */   // Label 7570: @391388
     /* 391388 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(391404), // Rule ID 180 //
     /* 391393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391397 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 391402 */     GIR_RootConstrainSelectedInstOperands,
     /* 391403 */     // GIR_Coverage, 180,
     /* 391403 */     GIR_Done,
     /* 391404 */   // Label 7571: @391404
     /* 391404 */   GIM_Reject,
     /* 391405 */ // Label 7568: @391405
     /* 391405 */ GIM_Reject,
     /* 391406 */ // Label 7560: @391406
     /* 391406 */ GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(391635),
     /* 391411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391418 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(391518), // Rule ID 4008 //
     /* 391423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 391431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 391435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 391447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 391451 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 391463 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 391467 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 391471 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 391475 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 391479 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 391483 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391488 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 391492 */     // MIs[3] Rn
     /* 391492 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 391497 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 391501 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 391505 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 391507 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 391510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 391516 */     GIR_RootConstrainSelectedInstOperands,
     /* 391517 */     // GIR_Coverage, 4008,
     /* 391517 */     GIR_EraseRootFromParent_Done,
     /* 391518 */   // Label 7573: @391518
     /* 391518 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(391618), // Rule ID 13882 //
     /* 391523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 391531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 391535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 391547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 391551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 391563 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 391567 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 391571 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391576 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 391580 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 391584 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 391588 */     // MIs[4] Rn
     /* 391588 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 391593 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 391597 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 391601 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 391605 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 391607 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 391610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 391616 */     GIR_RootConstrainSelectedInstOperands,
     /* 391617 */     // GIR_Coverage, 13882,
     /* 391617 */     GIR_EraseRootFromParent_Done,
     /* 391618 */   // Label 7574: @391618
     /* 391618 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(391634), // Rule ID 181 //
     /* 391623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391627 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 391632 */     GIR_RootConstrainSelectedInstOperands,
     /* 391633 */     // GIR_Coverage, 181,
     /* 391633 */     GIR_Done,
     /* 391634 */   // Label 7575: @391634
     /* 391634 */   GIM_Reject,
     /* 391635 */ // Label 7572: @391635
     /* 391635 */ GIM_Reject,
     /* 391636 */ // Label 7561: @391636
     /* 391636 */ GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(391662), // Rule ID 720 //
     /* 391641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391655 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 391655 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 391660 */   GIR_RootConstrainSelectedInstOperands,
     /* 391661 */   // GIR_Coverage, 720,
     /* 391661 */   GIR_Done,
     /* 391662 */ // Label 7576: @391662
     /* 391662 */ GIM_Reject,
     /* 391663 */ // Label 7562: @391663
     /* 391663 */ GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(391689), // Rule ID 718 //
     /* 391668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391682 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 391682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 391687 */   GIR_RootConstrainSelectedInstOperands,
     /* 391688 */   // GIR_Coverage, 718,
     /* 391688 */   GIR_Done,
     /* 391689 */ // Label 7577: @391689
     /* 391689 */ GIM_Reject,
     /* 391690 */ // Label 7563: @391690
     /* 391690 */ GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(391716), // Rule ID 721 //
     /* 391695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391709 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 391709 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 391714 */   GIR_RootConstrainSelectedInstOperands,
     /* 391715 */   // GIR_Coverage, 721,
     /* 391715 */   GIR_Done,
     /* 391716 */ // Label 7578: @391716
     /* 391716 */ GIM_Reject,
     /* 391717 */ // Label 7564: @391717
     /* 391717 */ GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(391743), // Rule ID 716 //
     /* 391722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391736 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 391741 */   GIR_RootConstrainSelectedInstOperands,
     /* 391742 */   // GIR_Coverage, 716,
     /* 391742 */   GIR_Done,
     /* 391743 */ // Label 7579: @391743
     /* 391743 */ GIM_Reject,
     /* 391744 */ // Label 7565: @391744
     /* 391744 */ GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(391770), // Rule ID 719 //
     /* 391749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391763 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 391763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 391768 */   GIR_RootConstrainSelectedInstOperands,
     /* 391769 */   // GIR_Coverage, 719,
     /* 391769 */   GIR_Done,
     /* 391770 */ // Label 7580: @391770
     /* 391770 */ GIM_Reject,
     /* 391771 */ // Label 7566: @391771
     /* 391771 */ GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(391797), // Rule ID 717 //
     /* 391776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391790 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391790 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 391795 */   GIR_RootConstrainSelectedInstOperands,
     /* 391796 */   // GIR_Coverage, 717,
     /* 391796 */   GIR_Done,
     /* 391797 */ // Label 7581: @391797
     /* 391797 */ GIM_Reject,
     /* 391798 */ // Label 7567: @391798
     /* 391798 */ GIM_Reject,
     /* 391799 */ // Label 95: @391799
     /* 391799 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7586*/ GIMT_Encode4(391958),
     /* 391810 */ /*GILLT_s32*//*Label 7582*/ GIMT_Encode4(391850),
     /* 391814 */ /*GILLT_s64*//*Label 7583*/ GIMT_Encode4(391877), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 391838 */ /*GILLT_v8s8*//*Label 7584*/ GIMT_Encode4(391904), GIMT_Encode4(0),
     /* 391846 */ /*GILLT_v16s8*//*Label 7585*/ GIMT_Encode4(391931),
     /* 391850 */ // Label 7582: @391850
     /* 391850 */ GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(391876), // Rule ID 2319 //
     /* 391855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 391858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391869 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 391874 */   GIR_RootConstrainSelectedInstOperands,
     /* 391875 */   // GIR_Coverage, 2319,
     /* 391875 */   GIR_Done,
     /* 391876 */ // Label 7587: @391876
     /* 391876 */ GIM_Reject,
     /* 391877 */ // Label 7583: @391877
     /* 391877 */ GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(391903), // Rule ID 2320 //
     /* 391882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 391885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391896 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 391901 */   GIR_RootConstrainSelectedInstOperands,
     /* 391902 */   // GIR_Coverage, 2320,
     /* 391902 */   GIR_Done,
     /* 391903 */ // Label 7588: @391903
     /* 391903 */ GIM_Reject,
     /* 391904 */ // Label 7584: @391904
     /* 391904 */ GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(391930), // Rule ID 764 //
     /* 391909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391923 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 391928 */   GIR_RootConstrainSelectedInstOperands,
     /* 391929 */   // GIR_Coverage, 764,
     /* 391929 */   GIR_Done,
     /* 391930 */ // Label 7589: @391930
     /* 391930 */ GIM_Reject,
     /* 391931 */ // Label 7585: @391931
     /* 391931 */ GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(391957), // Rule ID 765 //
     /* 391936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391950 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 391955 */   GIR_RootConstrainSelectedInstOperands,
     /* 391956 */   // GIR_Coverage, 765,
     /* 391956 */   GIR_Done,
     /* 391957 */ // Label 7590: @391957
     /* 391957 */ GIM_Reject,
     /* 391958 */ // Label 7586: @391958
     /* 391958 */ GIM_Reject,
     /* 391959 */ // Label 96: @391959
     /* 391959 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7598*/ GIMT_Encode4(392272),
     /* 391970 */ /*GILLT_s32*//*Label 7591*/ GIMT_Encode4(392006),
     /* 391974 */ /*GILLT_s64*//*Label 7592*/ GIMT_Encode4(392079), GIMT_Encode4(0),
     /* 391982 */ /*GILLT_v2s32*//*Label 7593*/ GIMT_Encode4(392152),
     /* 391986 */ /*GILLT_v2s64*//*Label 7594*/ GIMT_Encode4(392176),
     /* 391990 */ /*GILLT_v4s16*//*Label 7595*/ GIMT_Encode4(392200),
     /* 391994 */ /*GILLT_v4s32*//*Label 7596*/ GIMT_Encode4(392224), GIMT_Encode4(0),
     /* 392002 */ /*GILLT_v8s16*//*Label 7597*/ GIMT_Encode4(392248),
     /* 392006 */ // Label 7591: @392006
     /* 392006 */ GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(392078),
     /* 392011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392018 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(392061), // Rule ID 4011 //
     /* 392023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 392031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 392035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392044 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 392048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392050 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 392053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392059 */     GIR_RootConstrainSelectedInstOperands,
     /* 392060 */     // GIR_Coverage, 4011,
     /* 392060 */     GIR_EraseRootFromParent_Done,
     /* 392061 */   // Label 7600: @392061
     /* 392061 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(392077), // Rule ID 185 //
     /* 392066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392070 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 392075 */     GIR_RootConstrainSelectedInstOperands,
     /* 392076 */     // GIR_Coverage, 185,
     /* 392076 */     GIR_Done,
     /* 392077 */   // Label 7601: @392077
     /* 392077 */   GIM_Reject,
     /* 392078 */ // Label 7599: @392078
     /* 392078 */ GIM_Reject,
     /* 392079 */ // Label 7592: @392079
     /* 392079 */ GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(392151),
     /* 392084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392091 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(392134), // Rule ID 4012 //
     /* 392096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 392104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 392108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392117 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 392121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392123 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 392126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392132 */     GIR_RootConstrainSelectedInstOperands,
     /* 392133 */     // GIR_Coverage, 4012,
     /* 392133 */     GIR_EraseRootFromParent_Done,
     /* 392134 */   // Label 7603: @392134
     /* 392134 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(392150), // Rule ID 186 //
     /* 392139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392143 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 392148 */     GIR_RootConstrainSelectedInstOperands,
     /* 392149 */     // GIR_Coverage, 186,
     /* 392149 */     GIR_Done,
     /* 392150 */   // Label 7604: @392150
     /* 392150 */   GIM_Reject,
     /* 392151 */ // Label 7602: @392151
     /* 392151 */ GIM_Reject,
     /* 392152 */ // Label 7593: @392152
     /* 392152 */ GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(392175), // Rule ID 5024 //
     /* 392157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392168 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 392168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 392173 */   GIR_RootConstrainSelectedInstOperands,
     /* 392174 */   // GIR_Coverage, 5024,
     /* 392174 */   GIR_Done,
     /* 392175 */ // Label 7605: @392175
     /* 392175 */ GIM_Reject,
     /* 392176 */ // Label 7594: @392176
     /* 392176 */ GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(392199), // Rule ID 5026 //
     /* 392181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392192 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 392192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 392197 */   GIR_RootConstrainSelectedInstOperands,
     /* 392198 */   // GIR_Coverage, 5026,
     /* 392198 */   GIR_Done,
     /* 392199 */ // Label 7606: @392199
     /* 392199 */ GIM_Reject,
     /* 392200 */ // Label 7595: @392200
     /* 392200 */ GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(392223), // Rule ID 5022 //
     /* 392205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392216 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 392216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 392221 */   GIR_RootConstrainSelectedInstOperands,
     /* 392222 */   // GIR_Coverage, 5022,
     /* 392222 */   GIR_Done,
     /* 392223 */ // Label 7607: @392223
     /* 392223 */ GIM_Reject,
     /* 392224 */ // Label 7596: @392224
     /* 392224 */ GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(392247), // Rule ID 5025 //
     /* 392229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392240 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 392240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 392245 */   GIR_RootConstrainSelectedInstOperands,
     /* 392246 */   // GIR_Coverage, 5025,
     /* 392246 */   GIR_Done,
     /* 392247 */ // Label 7608: @392247
     /* 392247 */ GIM_Reject,
     /* 392248 */ // Label 7597: @392248
     /* 392248 */ GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(392271), // Rule ID 5023 //
     /* 392253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392264 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 392264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 392269 */   GIR_RootConstrainSelectedInstOperands,
     /* 392270 */   // GIR_Coverage, 5023,
     /* 392270 */   GIR_Done,
     /* 392271 */ // Label 7609: @392271
     /* 392271 */ GIM_Reject,
     /* 392272 */ // Label 7598: @392272
     /* 392272 */ GIM_Reject,
     /* 392273 */ // Label 97: @392273
     /* 392273 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7614*/ GIMT_Encode4(392426),
     /* 392284 */ /*GILLT_s32*//*Label 7610*/ GIMT_Encode4(392324),
     /* 392288 */ /*GILLT_s64*//*Label 7611*/ GIMT_Encode4(392348), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392312 */ /*GILLT_v8s8*//*Label 7612*/ GIMT_Encode4(392372), GIMT_Encode4(0),
     /* 392320 */ /*GILLT_v16s8*//*Label 7613*/ GIMT_Encode4(392399),
     /* 392324 */ // Label 7610: @392324
     /* 392324 */ GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(392347), // Rule ID 182 //
     /* 392329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392340 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 392345 */   GIR_RootConstrainSelectedInstOperands,
     /* 392346 */   // GIR_Coverage, 182,
     /* 392346 */   GIR_Done,
     /* 392347 */ // Label 7615: @392347
     /* 392347 */ GIM_Reject,
     /* 392348 */ // Label 7611: @392348
     /* 392348 */ GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(392371), // Rule ID 183 //
     /* 392353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392364 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 392369 */   GIR_RootConstrainSelectedInstOperands,
     /* 392370 */   // GIR_Coverage, 183,
     /* 392370 */   GIR_Done,
     /* 392371 */ // Label 7616: @392371
     /* 392371 */ GIM_Reject,
     /* 392372 */ // Label 7612: @392372
     /* 392372 */ GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(392398), // Rule ID 974 //
     /* 392377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 392383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392391 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 392391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 392396 */   GIR_RootConstrainSelectedInstOperands,
     /* 392397 */   // GIR_Coverage, 974,
     /* 392397 */   GIR_Done,
     /* 392398 */ // Label 7617: @392398
     /* 392398 */ GIM_Reject,
     /* 392399 */ // Label 7613: @392399
     /* 392399 */ GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(392425), // Rule ID 975 //
     /* 392404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 392410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392418 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 392418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 392423 */   GIR_RootConstrainSelectedInstOperands,
     /* 392424 */   // GIR_Coverage, 975,
     /* 392424 */   GIR_Done,
     /* 392425 */ // Label 7618: @392425
     /* 392425 */ GIM_Reject,
     /* 392426 */ // Label 7614: @392426
     /* 392426 */ GIM_Reject,
     /* 392427 */ // Label 98: @392427
     /* 392427 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7627*/ GIMT_Encode4(392917),
     /* 392438 */ /*GILLT_s16*//*Label 7619*/ GIMT_Encode4(392478),
     /* 392442 */ /*GILLT_s32*//*Label 7620*/ GIMT_Encode4(392509),
     /* 392446 */ /*GILLT_s64*//*Label 7621*/ GIMT_Encode4(392540), GIMT_Encode4(0),
     /* 392454 */ /*GILLT_v2s32*//*Label 7622*/ GIMT_Encode4(392571),
     /* 392458 */ /*GILLT_v2s64*//*Label 7623*/ GIMT_Encode4(392602),
     /* 392462 */ /*GILLT_v4s16*//*Label 7624*/ GIMT_Encode4(392633),
     /* 392466 */ /*GILLT_v4s32*//*Label 7625*/ GIMT_Encode4(392664), GIMT_Encode4(0),
     /* 392474 */ /*GILLT_v8s16*//*Label 7626*/ GIMT_Encode4(392695),
     /* 392478 */ // Label 7619: @392478
     /* 392478 */ GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(392508), // Rule ID 552 //
     /* 392483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 392486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392497 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 392497 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 392502 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392506 */   GIR_RootConstrainSelectedInstOperands,
     /* 392507 */   // GIR_Coverage, 552,
     /* 392507 */   GIR_Done,
     /* 392508 */ // Label 7628: @392508
     /* 392508 */ GIM_Reject,
     /* 392509 */ // Label 7620: @392509
     /* 392509 */ GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(392539), // Rule ID 554 //
     /* 392514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392528 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 392528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 392533 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392537 */   GIR_RootConstrainSelectedInstOperands,
     /* 392538 */   // GIR_Coverage, 554,
     /* 392538 */   GIR_Done,
     /* 392539 */ // Label 7629: @392539
     /* 392539 */ GIM_Reject,
     /* 392540 */ // Label 7621: @392540
     /* 392540 */ GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(392570), // Rule ID 556 //
     /* 392545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392559 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 392559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 392564 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392568 */   GIR_RootConstrainSelectedInstOperands,
     /* 392569 */   // GIR_Coverage, 556,
     /* 392569 */   GIR_Done,
     /* 392570 */ // Label 7630: @392570
     /* 392570 */ GIM_Reject,
     /* 392571 */ // Label 7622: @392571
     /* 392571 */ GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(392601), // Rule ID 913 //
     /* 392576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392590 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 392595 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392599 */   GIR_RootConstrainSelectedInstOperands,
     /* 392600 */   // GIR_Coverage, 913,
     /* 392600 */   GIR_Done,
     /* 392601 */ // Label 7631: @392601
     /* 392601 */ GIM_Reject,
     /* 392602 */ // Label 7623: @392602
     /* 392602 */ GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(392632), // Rule ID 917 //
     /* 392607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392621 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 392626 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392630 */   GIR_RootConstrainSelectedInstOperands,
     /* 392631 */   // GIR_Coverage, 917,
     /* 392631 */   GIR_Done,
     /* 392632 */ // Label 7632: @392632
     /* 392632 */ GIM_Reject,
     /* 392633 */ // Label 7624: @392633
     /* 392633 */ GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(392663), // Rule ID 909 //
     /* 392638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392652 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 392657 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392661 */   GIR_RootConstrainSelectedInstOperands,
     /* 392662 */   // GIR_Coverage, 909,
     /* 392662 */   GIR_Done,
     /* 392663 */ // Label 7633: @392663
     /* 392663 */ GIM_Reject,
     /* 392664 */ // Label 7625: @392664
     /* 392664 */ GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(392694), // Rule ID 915 //
     /* 392669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392683 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 392688 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392692 */   GIR_RootConstrainSelectedInstOperands,
     /* 392693 */   // GIR_Coverage, 915,
     /* 392693 */   GIR_Done,
     /* 392694 */ // Label 7634: @392694
     /* 392694 */ GIM_Reject,
     /* 392695 */ // Label 7626: @392695
     /* 392695 */ GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(392916),
     /* 392700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392711 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(392730), // Rule ID 911 //
     /* 392716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392719 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 392724 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392728 */     GIR_RootConstrainSelectedInstOperands,
     /* 392729 */     // GIR_Coverage, 911,
     /* 392729 */     GIR_Done,
     /* 392730 */   // Label 7636: @392730
     /* 392730 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(392915), // Rule ID 7048 //
     /* 392735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 392738 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 392738 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 392741 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 392745 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392750 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 392756 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 392759 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 392763 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392768 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 392771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 392773 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 392776 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 392780 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392785 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 392791 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392796 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392801 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 392804 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 392808 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392813 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 392816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 392818 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 392821 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 392825 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392830 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 392833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 392835 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 392838 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 392842 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392847 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 392850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 392852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 392855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 392859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 392873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392878 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 392881 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 392884 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 392887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 392905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 392913 */     GIR_RootConstrainSelectedInstOperands,
     /* 392914 */     // GIR_Coverage, 7048,
     /* 392914 */     GIR_EraseRootFromParent_Done,
     /* 392915 */   // Label 7637: @392915
     /* 392915 */   GIM_Reject,
     /* 392916 */ // Label 7635: @392916
     /* 392916 */ GIM_Reject,
     /* 392917 */ // Label 7627: @392917
     /* 392917 */ GIM_Reject,
     /* 392918 */ // Label 99: @392918
     /* 392918 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7646*/ GIMT_Encode4(393217),
     /* 392929 */ /*GILLT_s16*//*Label 7638*/ GIMT_Encode4(392969),
     /* 392933 */ /*GILLT_s32*//*Label 7639*/ GIMT_Encode4(393000),
     /* 392937 */ /*GILLT_s64*//*Label 7640*/ GIMT_Encode4(393031), GIMT_Encode4(0),
     /* 392945 */ /*GILLT_v2s32*//*Label 7641*/ GIMT_Encode4(393062),
     /* 392949 */ /*GILLT_v2s64*//*Label 7642*/ GIMT_Encode4(393093),
     /* 392953 */ /*GILLT_v4s16*//*Label 7643*/ GIMT_Encode4(393124),
     /* 392957 */ /*GILLT_v4s32*//*Label 7644*/ GIMT_Encode4(393155), GIMT_Encode4(0),
     /* 392965 */ /*GILLT_v8s16*//*Label 7645*/ GIMT_Encode4(393186),
     /* 392969 */ // Label 7638: @392969
     /* 392969 */ GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(392999), // Rule ID 570 //
     /* 392974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 392977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392988 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 392988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 392993 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392997 */   GIR_RootConstrainSelectedInstOperands,
     /* 392998 */   // GIR_Coverage, 570,
     /* 392998 */   GIR_Done,
     /* 392999 */ // Label 7647: @392999
     /* 392999 */ GIM_Reject,
     /* 393000 */ // Label 7639: @393000
     /* 393000 */ GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(393030), // Rule ID 572 //
     /* 393005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393019 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 393019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 393024 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393028 */   GIR_RootConstrainSelectedInstOperands,
     /* 393029 */   // GIR_Coverage, 572,
     /* 393029 */   GIR_Done,
     /* 393030 */ // Label 7648: @393030
     /* 393030 */ GIM_Reject,
     /* 393031 */ // Label 7640: @393031
     /* 393031 */ GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(393061), // Rule ID 574 //
     /* 393036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393050 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 393050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 393055 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393059 */   GIR_RootConstrainSelectedInstOperands,
     /* 393060 */   // GIR_Coverage, 574,
     /* 393060 */   GIR_Done,
     /* 393061 */ // Label 7649: @393061
     /* 393061 */ GIM_Reject,
     /* 393062 */ // Label 7641: @393062
     /* 393062 */ GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(393092), // Rule ID 960 //
     /* 393067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393081 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 393086 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393090 */   GIR_RootConstrainSelectedInstOperands,
     /* 393091 */   // GIR_Coverage, 960,
     /* 393091 */   GIR_Done,
     /* 393092 */ // Label 7650: @393092
     /* 393092 */ GIM_Reject,
     /* 393093 */ // Label 7642: @393093
     /* 393093 */ GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(393123), // Rule ID 964 //
     /* 393098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393112 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 393117 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393121 */   GIR_RootConstrainSelectedInstOperands,
     /* 393122 */   // GIR_Coverage, 964,
     /* 393122 */   GIR_Done,
     /* 393123 */ // Label 7651: @393123
     /* 393123 */ GIM_Reject,
     /* 393124 */ // Label 7643: @393124
     /* 393124 */ GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(393154), // Rule ID 956 //
     /* 393129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393143 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 393148 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393152 */   GIR_RootConstrainSelectedInstOperands,
     /* 393153 */   // GIR_Coverage, 956,
     /* 393153 */   GIR_Done,
     /* 393154 */ // Label 7652: @393154
     /* 393154 */ GIM_Reject,
     /* 393155 */ // Label 7644: @393155
     /* 393155 */ GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(393185), // Rule ID 962 //
     /* 393160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393174 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393174 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 393179 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393183 */   GIR_RootConstrainSelectedInstOperands,
     /* 393184 */   // GIR_Coverage, 962,
     /* 393184 */   GIR_Done,
     /* 393185 */ // Label 7653: @393185
     /* 393185 */ GIM_Reject,
     /* 393186 */ // Label 7645: @393186
     /* 393186 */ GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(393216), // Rule ID 958 //
     /* 393191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393205 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393205 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 393210 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393214 */   GIR_RootConstrainSelectedInstOperands,
     /* 393215 */   // GIR_Coverage, 958,
     /* 393215 */   GIR_Done,
     /* 393216 */ // Label 7654: @393216
     /* 393216 */ GIM_Reject,
     /* 393217 */ // Label 7646: @393217
     /* 393217 */ GIM_Reject,
     /* 393218 */ // Label 100: @393218
     /* 393218 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7663*/ GIMT_Encode4(393708),
     /* 393229 */ /*GILLT_s16*//*Label 7655*/ GIMT_Encode4(393269),
     /* 393233 */ /*GILLT_s32*//*Label 7656*/ GIMT_Encode4(393300),
     /* 393237 */ /*GILLT_s64*//*Label 7657*/ GIMT_Encode4(393331), GIMT_Encode4(0),
     /* 393245 */ /*GILLT_v2s32*//*Label 7658*/ GIMT_Encode4(393362),
     /* 393249 */ /*GILLT_v2s64*//*Label 7659*/ GIMT_Encode4(393393),
     /* 393253 */ /*GILLT_v4s16*//*Label 7660*/ GIMT_Encode4(393424),
     /* 393257 */ /*GILLT_v4s32*//*Label 7661*/ GIMT_Encode4(393455), GIMT_Encode4(0),
     /* 393265 */ /*GILLT_v8s16*//*Label 7662*/ GIMT_Encode4(393486),
     /* 393269 */ // Label 7655: @393269
     /* 393269 */ GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(393299), // Rule ID 540 //
     /* 393274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 393277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393288 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 393288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 393293 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393297 */   GIR_RootConstrainSelectedInstOperands,
     /* 393298 */   // GIR_Coverage, 540,
     /* 393298 */   GIR_Done,
     /* 393299 */ // Label 7664: @393299
     /* 393299 */ GIM_Reject,
     /* 393300 */ // Label 7656: @393300
     /* 393300 */ GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(393330), // Rule ID 542 //
     /* 393305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393319 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 393319 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 393324 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393328 */   GIR_RootConstrainSelectedInstOperands,
     /* 393329 */   // GIR_Coverage, 542,
     /* 393329 */   GIR_Done,
     /* 393330 */ // Label 7665: @393330
     /* 393330 */ GIM_Reject,
     /* 393331 */ // Label 7657: @393331
     /* 393331 */ GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(393361), // Rule ID 544 //
     /* 393336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393350 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 393350 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 393355 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393359 */   GIR_RootConstrainSelectedInstOperands,
     /* 393360 */   // GIR_Coverage, 544,
     /* 393360 */   GIR_Done,
     /* 393361 */ // Label 7666: @393361
     /* 393361 */ GIM_Reject,
     /* 393362 */ // Label 7658: @393362
     /* 393362 */ GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(393392), // Rule ID 893 //
     /* 393367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393381 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 393386 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393390 */   GIR_RootConstrainSelectedInstOperands,
     /* 393391 */   // GIR_Coverage, 893,
     /* 393391 */   GIR_Done,
     /* 393392 */ // Label 7667: @393392
     /* 393392 */ GIM_Reject,
     /* 393393 */ // Label 7659: @393393
     /* 393393 */ GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(393423), // Rule ID 897 //
     /* 393398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393412 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 393417 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393421 */   GIR_RootConstrainSelectedInstOperands,
     /* 393422 */   // GIR_Coverage, 897,
     /* 393422 */   GIR_Done,
     /* 393423 */ // Label 7668: @393423
     /* 393423 */ GIM_Reject,
     /* 393424 */ // Label 7660: @393424
     /* 393424 */ GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(393454), // Rule ID 889 //
     /* 393429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393443 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 393448 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393452 */   GIR_RootConstrainSelectedInstOperands,
     /* 393453 */   // GIR_Coverage, 889,
     /* 393453 */   GIR_Done,
     /* 393454 */ // Label 7669: @393454
     /* 393454 */ GIM_Reject,
     /* 393455 */ // Label 7661: @393455
     /* 393455 */ GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(393485), // Rule ID 895 //
     /* 393460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393474 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 393479 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393483 */   GIR_RootConstrainSelectedInstOperands,
     /* 393484 */   // GIR_Coverage, 895,
     /* 393484 */   GIR_Done,
     /* 393485 */ // Label 7670: @393485
     /* 393485 */ GIM_Reject,
     /* 393486 */ // Label 7662: @393486
     /* 393486 */ GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(393707),
     /* 393491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393502 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(393521), // Rule ID 891 //
     /* 393507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393510 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 393515 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393519 */     GIR_RootConstrainSelectedInstOperands,
     /* 393520 */     // GIR_Coverage, 891,
     /* 393520 */     GIR_Done,
     /* 393521 */   // Label 7672: @393521
     /* 393521 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(393706), // Rule ID 7050 //
     /* 393526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 393529 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 393529 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 393532 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 393536 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393541 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 393547 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 393550 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 393554 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393559 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 393562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 393564 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 393567 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 393571 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393576 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 393582 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393587 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393592 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 393595 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 393599 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393604 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 393607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 393609 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 393612 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 393616 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393621 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 393624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 393626 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 393629 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 393633 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393638 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 393641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 393643 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 393646 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 393650 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 393657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 393664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393669 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 393672 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 393675 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 393678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 393696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 393704 */     GIR_RootConstrainSelectedInstOperands,
     /* 393705 */     // GIR_Coverage, 7050,
     /* 393705 */     GIR_EraseRootFromParent_Done,
     /* 393706 */   // Label 7673: @393706
     /* 393706 */   GIM_Reject,
     /* 393707 */ // Label 7671: @393707
     /* 393707 */ GIM_Reject,
     /* 393708 */ // Label 7663: @393708
     /* 393708 */ GIM_Reject,
     /* 393709 */ // Label 101: @393709
     /* 393709 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7682*/ GIMT_Encode4(394199),
     /* 393720 */ /*GILLT_s16*//*Label 7674*/ GIMT_Encode4(393760),
     /* 393724 */ /*GILLT_s32*//*Label 7675*/ GIMT_Encode4(393791),
     /* 393728 */ /*GILLT_s64*//*Label 7676*/ GIMT_Encode4(393822), GIMT_Encode4(0),
     /* 393736 */ /*GILLT_v2s32*//*Label 7677*/ GIMT_Encode4(393853),
     /* 393740 */ /*GILLT_v2s64*//*Label 7678*/ GIMT_Encode4(393884),
     /* 393744 */ /*GILLT_v4s16*//*Label 7679*/ GIMT_Encode4(393915),
     /* 393748 */ /*GILLT_v4s32*//*Label 7680*/ GIMT_Encode4(393946), GIMT_Encode4(0),
     /* 393756 */ /*GILLT_v8s16*//*Label 7681*/ GIMT_Encode4(393977),
     /* 393760 */ // Label 7674: @393760
     /* 393760 */ GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(393790), // Rule ID 558 //
     /* 393765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 393768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393779 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 393779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 393784 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393788 */   GIR_RootConstrainSelectedInstOperands,
     /* 393789 */   // GIR_Coverage, 558,
     /* 393789 */   GIR_Done,
     /* 393790 */ // Label 7683: @393790
     /* 393790 */ GIM_Reject,
     /* 393791 */ // Label 7675: @393791
     /* 393791 */ GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(393821), // Rule ID 560 //
     /* 393796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393810 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 393810 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 393815 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393819 */   GIR_RootConstrainSelectedInstOperands,
     /* 393820 */   // GIR_Coverage, 560,
     /* 393820 */   GIR_Done,
     /* 393821 */ // Label 7684: @393821
     /* 393821 */ GIM_Reject,
     /* 393822 */ // Label 7676: @393822
     /* 393822 */ GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(393852), // Rule ID 562 //
     /* 393827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393841 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 393841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 393846 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393850 */   GIR_RootConstrainSelectedInstOperands,
     /* 393851 */   // GIR_Coverage, 562,
     /* 393851 */   GIR_Done,
     /* 393852 */ // Label 7685: @393852
     /* 393852 */ GIM_Reject,
     /* 393853 */ // Label 7677: @393853
     /* 393853 */ GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(393883), // Rule ID 923 //
     /* 393858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393872 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393872 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 393877 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393881 */   GIR_RootConstrainSelectedInstOperands,
     /* 393882 */   // GIR_Coverage, 923,
     /* 393882 */   GIR_Done,
     /* 393883 */ // Label 7686: @393883
     /* 393883 */ GIM_Reject,
     /* 393884 */ // Label 7678: @393884
     /* 393884 */ GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(393914), // Rule ID 927 //
     /* 393889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393903 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 393908 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393912 */   GIR_RootConstrainSelectedInstOperands,
     /* 393913 */   // GIR_Coverage, 927,
     /* 393913 */   GIR_Done,
     /* 393914 */ // Label 7687: @393914
     /* 393914 */ GIM_Reject,
     /* 393915 */ // Label 7679: @393915
     /* 393915 */ GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(393945), // Rule ID 919 //
     /* 393920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393934 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393934 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 393939 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393943 */   GIR_RootConstrainSelectedInstOperands,
     /* 393944 */   // GIR_Coverage, 919,
     /* 393944 */   GIR_Done,
     /* 393945 */ // Label 7688: @393945
     /* 393945 */ GIM_Reject,
     /* 393946 */ // Label 7680: @393946
     /* 393946 */ GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(393976), // Rule ID 925 //
     /* 393951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393965 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 393970 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393974 */   GIR_RootConstrainSelectedInstOperands,
     /* 393975 */   // GIR_Coverage, 925,
     /* 393975 */   GIR_Done,
     /* 393976 */ // Label 7689: @393976
     /* 393976 */ GIM_Reject,
     /* 393977 */ // Label 7681: @393977
     /* 393977 */ GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(394198),
     /* 393982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393993 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(394012), // Rule ID 921 //
     /* 393998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394001 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 394001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 394006 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394010 */     GIR_RootConstrainSelectedInstOperands,
     /* 394011 */     // GIR_Coverage, 921,
     /* 394011 */     GIR_Done,
     /* 394012 */   // Label 7691: @394012
     /* 394012 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(394197), // Rule ID 7058 //
     /* 394017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 394020 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 394020 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 394023 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 394027 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394032 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 394038 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 394041 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 394045 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394050 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 394053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 394055 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 394058 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394062 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394067 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394073 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394078 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394083 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 394086 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 394090 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394095 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 394098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 394100 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 394103 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 394107 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394112 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 394115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 394117 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 394120 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 394124 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394129 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 394132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 394134 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 394137 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 394141 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 394148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 394155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394160 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 394163 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 394166 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 394169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 394187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 394195 */     GIR_RootConstrainSelectedInstOperands,
     /* 394196 */     // GIR_Coverage, 7058,
     /* 394196 */     GIR_EraseRootFromParent_Done,
     /* 394197 */   // Label 7692: @394197
     /* 394197 */   GIM_Reject,
     /* 394198 */ // Label 7690: @394198
     /* 394198 */ GIM_Reject,
     /* 394199 */ // Label 7682: @394199
     /* 394199 */ GIM_Reject,
     /* 394200 */ // Label 102: @394200
     /* 394200 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7701*/ GIMT_Encode4(394690),
     /* 394211 */ /*GILLT_s16*//*Label 7693*/ GIMT_Encode4(394251),
     /* 394215 */ /*GILLT_s32*//*Label 7694*/ GIMT_Encode4(394282),
     /* 394219 */ /*GILLT_s64*//*Label 7695*/ GIMT_Encode4(394313), GIMT_Encode4(0),
     /* 394227 */ /*GILLT_v2s32*//*Label 7696*/ GIMT_Encode4(394344),
     /* 394231 */ /*GILLT_v2s64*//*Label 7697*/ GIMT_Encode4(394375),
     /* 394235 */ /*GILLT_v4s16*//*Label 7698*/ GIMT_Encode4(394406),
     /* 394239 */ /*GILLT_v4s32*//*Label 7699*/ GIMT_Encode4(394437), GIMT_Encode4(0),
     /* 394247 */ /*GILLT_v8s16*//*Label 7700*/ GIMT_Encode4(394468),
     /* 394251 */ // Label 7693: @394251
     /* 394251 */ GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(394281), // Rule ID 534 //
     /* 394256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 394259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 394262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394270 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 394270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 394275 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394279 */   GIR_RootConstrainSelectedInstOperands,
     /* 394280 */   // GIR_Coverage, 534,
     /* 394280 */   GIR_Done,
     /* 394281 */ // Label 7702: @394281
     /* 394281 */ GIM_Reject,
     /* 394282 */ // Label 7694: @394282
     /* 394282 */ GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(394312), // Rule ID 536 //
     /* 394287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394301 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 394301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 394306 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394310 */   GIR_RootConstrainSelectedInstOperands,
     /* 394311 */   // GIR_Coverage, 536,
     /* 394311 */   GIR_Done,
     /* 394312 */ // Label 7703: @394312
     /* 394312 */ GIM_Reject,
     /* 394313 */ // Label 7695: @394313
     /* 394313 */ GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(394343), // Rule ID 538 //
     /* 394318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394332 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 394332 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 394337 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394341 */   GIR_RootConstrainSelectedInstOperands,
     /* 394342 */   // GIR_Coverage, 538,
     /* 394342 */   GIR_Done,
     /* 394343 */ // Label 7704: @394343
     /* 394343 */ GIM_Reject,
     /* 394344 */ // Label 7696: @394344
     /* 394344 */ GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(394374), // Rule ID 883 //
     /* 394349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394363 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 394363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 394368 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394372 */   GIR_RootConstrainSelectedInstOperands,
     /* 394373 */   // GIR_Coverage, 883,
     /* 394373 */   GIR_Done,
     /* 394374 */ // Label 7705: @394374
     /* 394374 */ GIM_Reject,
     /* 394375 */ // Label 7697: @394375
     /* 394375 */ GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(394405), // Rule ID 887 //
     /* 394380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394394 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 394394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 394399 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394403 */   GIR_RootConstrainSelectedInstOperands,
     /* 394404 */   // GIR_Coverage, 887,
     /* 394404 */   GIR_Done,
     /* 394405 */ // Label 7706: @394405
     /* 394405 */ GIM_Reject,
     /* 394406 */ // Label 7698: @394406
     /* 394406 */ GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(394436), // Rule ID 879 //
     /* 394411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394425 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 394425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 394430 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394434 */   GIR_RootConstrainSelectedInstOperands,
     /* 394435 */   // GIR_Coverage, 879,
     /* 394435 */   GIR_Done,
     /* 394436 */ // Label 7707: @394436
     /* 394436 */ GIM_Reject,
     /* 394437 */ // Label 7699: @394437
     /* 394437 */ GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(394467), // Rule ID 885 //
     /* 394442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394456 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 394456 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 394461 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394465 */   GIR_RootConstrainSelectedInstOperands,
     /* 394466 */   // GIR_Coverage, 885,
     /* 394466 */   GIR_Done,
     /* 394467 */ // Label 7708: @394467
     /* 394467 */ GIM_Reject,
     /* 394468 */ // Label 7700: @394468
     /* 394468 */ GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(394689),
     /* 394473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394484 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(394503), // Rule ID 881 //
     /* 394489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394492 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 394492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 394497 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394501 */     GIR_RootConstrainSelectedInstOperands,
     /* 394502 */     // GIR_Coverage, 881,
     /* 394502 */     GIR_Done,
     /* 394503 */   // Label 7710: @394503
     /* 394503 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(394688), // Rule ID 7052 //
     /* 394508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 394511 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 394511 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 394514 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 394518 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394523 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 394529 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 394532 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 394536 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394541 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 394544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 394546 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 394549 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394553 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394558 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394564 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394569 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394574 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 394577 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 394581 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394586 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 394589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 394591 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 394594 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 394598 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394603 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 394606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 394608 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 394611 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 394615 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394620 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 394623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 394625 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 394628 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 394632 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 394639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 394646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394651 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 394654 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 394657 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 394660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 394678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 394686 */     GIR_RootConstrainSelectedInstOperands,
     /* 394687 */     // GIR_Coverage, 7052,
     /* 394687 */     GIR_EraseRootFromParent_Done,
     /* 394688 */   // Label 7711: @394688
     /* 394688 */   GIM_Reject,
     /* 394689 */ // Label 7709: @394689
     /* 394689 */ GIM_Reject,
     /* 394690 */ // Label 7701: @394690
     /* 394690 */ GIM_Reject,
     /* 394691 */ // Label 103: @394691
     /* 394691 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7720*/ GIMT_Encode4(395816),
     /* 394702 */ /*GILLT_s16*//*Label 7712*/ GIMT_Encode4(394742),
     /* 394706 */ /*GILLT_s32*//*Label 7713*/ GIMT_Encode4(394968),
     /* 394710 */ /*GILLT_s64*//*Label 7714*/ GIMT_Encode4(395194), GIMT_Encode4(0),
     /* 394718 */ /*GILLT_v2s32*//*Label 7715*/ GIMT_Encode4(395366),
     /* 394722 */ /*GILLT_v2s64*//*Label 7716*/ GIMT_Encode4(395404),
     /* 394726 */ /*GILLT_v4s16*//*Label 7717*/ GIMT_Encode4(395442),
     /* 394730 */ /*GILLT_v4s32*//*Label 7718*/ GIMT_Encode4(395480), GIMT_Encode4(0),
     /* 394738 */ /*GILLT_v8s16*//*Label 7719*/ GIMT_Encode4(395518),
     /* 394742 */ // Label 7712: @394742
     /* 394742 */ GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(394967),
     /* 394747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 394750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 394753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394757 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(394848), // Rule ID 6972 //
     /* 394762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394783 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 394787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394795 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394799 */     // MIs[2] Rn
     /* 394799 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394804 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 394808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394810 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 394810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394822 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 394841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394846 */     GIR_RootConstrainSelectedInstOperands,
     /* 394847 */     // GIR_Coverage, 6972,
     /* 394847 */     GIR_EraseRootFromParent_Done,
     /* 394848 */   // Label 7722: @394848
     /* 394848 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(394939), // Rule ID 14019 //
     /* 394853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394874 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 394878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394890 */     // MIs[2] Rn
     /* 394890 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394895 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 394899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394901 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 394901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394913 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 394932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394937 */     GIR_RootConstrainSelectedInstOperands,
     /* 394938 */     // GIR_Coverage, 14019,
     /* 394938 */     GIR_EraseRootFromParent_Done,
     /* 394939 */   // Label 7723: @394939
     /* 394939 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(394966), // Rule ID 583 //
     /* 394944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 394947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394955 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 394955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 394960 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394964 */     GIR_RootConstrainSelectedInstOperands,
     /* 394965 */     // GIR_Coverage, 583,
     /* 394965 */     GIR_Done,
     /* 394966 */   // Label 7724: @394966
     /* 394966 */   GIM_Reject,
     /* 394967 */ // Label 7721: @394967
     /* 394967 */ GIM_Reject,
     /* 394968 */ // Label 7713: @394968
     /* 394968 */ GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(395193),
     /* 394973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 394979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394983 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(395074), // Rule ID 6970 //
     /* 394988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 395013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395025 */     // MIs[2] Rn
     /* 395025 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395030 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 395034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395036 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 395036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395048 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 395067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395072 */     GIR_RootConstrainSelectedInstOperands,
     /* 395073 */     // GIR_Coverage, 6970,
     /* 395073 */     GIR_EraseRootFromParent_Done,
     /* 395074 */   // Label 7726: @395074
     /* 395074 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(395165), // Rule ID 14017 //
     /* 395079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395100 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 395104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395116 */     // MIs[2] Rn
     /* 395116 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395121 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 395125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395127 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 395127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395139 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 395158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395163 */     GIR_RootConstrainSelectedInstOperands,
     /* 395164 */     // GIR_Coverage, 14017,
     /* 395164 */     GIR_EraseRootFromParent_Done,
     /* 395165 */   // Label 7727: @395165
     /* 395165 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(395192), // Rule ID 585 //
     /* 395170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395181 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 395181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 395186 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395190 */     GIR_RootConstrainSelectedInstOperands,
     /* 395191 */     // GIR_Coverage, 585,
     /* 395191 */     GIR_Done,
     /* 395192 */   // Label 7728: @395192
     /* 395192 */   GIM_Reject,
     /* 395193 */ // Label 7725: @395193
     /* 395193 */ GIM_Reject,
     /* 395194 */ // Label 7714: @395194
     /* 395194 */ GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(395365),
     /* 395199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 395205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395209 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(395273), // Rule ID 6968 //
     /* 395214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395235 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 395239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395251 */     // MIs[2] Rn
     /* 395251 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395256 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 395260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395262 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 395262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 395265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395271 */     GIR_RootConstrainSelectedInstOperands,
     /* 395272 */     // GIR_Coverage, 6968,
     /* 395272 */     GIR_EraseRootFromParent_Done,
     /* 395273 */   // Label 7730: @395273
     /* 395273 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(395337), // Rule ID 14015 //
     /* 395278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395299 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 395303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395315 */     // MIs[2] Rn
     /* 395315 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395320 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 395324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395326 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 395326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 395329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395335 */     GIR_RootConstrainSelectedInstOperands,
     /* 395336 */     // GIR_Coverage, 14015,
     /* 395336 */     GIR_EraseRootFromParent_Done,
     /* 395337 */   // Label 7731: @395337
     /* 395337 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(395364), // Rule ID 587 //
     /* 395342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395353 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 395353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 395358 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395362 */     GIR_RootConstrainSelectedInstOperands,
     /* 395363 */     // GIR_Coverage, 587,
     /* 395363 */     GIR_Done,
     /* 395364 */   // Label 7732: @395364
     /* 395364 */   GIM_Reject,
     /* 395365 */ // Label 7729: @395365
     /* 395365 */ GIM_Reject,
     /* 395366 */ // Label 7715: @395366
     /* 395366 */ GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(395403), // Rule ID 1202 //
     /* 395371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 395380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395392 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 395392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 395397 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395401 */   GIR_RootConstrainSelectedInstOperands,
     /* 395402 */   // GIR_Coverage, 1202,
     /* 395402 */   GIR_Done,
     /* 395403 */ // Label 7733: @395403
     /* 395403 */ GIM_Reject,
     /* 395404 */ // Label 7716: @395404
     /* 395404 */ GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(395441), // Rule ID 1206 //
     /* 395409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 395418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395430 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 395430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 395435 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395439 */   GIR_RootConstrainSelectedInstOperands,
     /* 395440 */   // GIR_Coverage, 1206,
     /* 395440 */   GIR_Done,
     /* 395441 */ // Label 7734: @395441
     /* 395441 */ GIM_Reject,
     /* 395442 */ // Label 7717: @395442
     /* 395442 */ GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(395479), // Rule ID 1198 //
     /* 395447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 395456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395468 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 395468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 395473 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395477 */   GIR_RootConstrainSelectedInstOperands,
     /* 395478 */   // GIR_Coverage, 1198,
     /* 395478 */   GIR_Done,
     /* 395479 */ // Label 7735: @395479
     /* 395479 */ GIM_Reject,
     /* 395480 */ // Label 7718: @395480
     /* 395480 */ GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(395517), // Rule ID 1204 //
     /* 395485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 395494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395506 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 395506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 395511 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395515 */   GIR_RootConstrainSelectedInstOperands,
     /* 395516 */   // GIR_Coverage, 1204,
     /* 395516 */   GIR_Done,
     /* 395517 */ // Label 7736: @395517
     /* 395517 */ GIM_Reject,
     /* 395518 */ // Label 7719: @395518
     /* 395518 */ GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(395815),
     /* 395523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395541 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(395560), // Rule ID 1200 //
     /* 395546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395549 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 395549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 395554 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395558 */     GIR_RootConstrainSelectedInstOperands,
     /* 395559 */     // GIR_Coverage, 1200,
     /* 395559 */     GIR_Done,
     /* 395560 */   // Label 7738: @395560
     /* 395560 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(395814), // Rule ID 7061 //
     /* 395565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 395568 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 395568 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 395571 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 395575 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395580 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 395584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 395586 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 395589 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 395593 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395598 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 395604 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 395607 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 395611 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395616 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 395619 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 395622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 395624 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 395627 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395631 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395636 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 395642 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395647 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395652 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 395655 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395659 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395664 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 395667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 395669 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 395672 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395676 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395681 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395687 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395692 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395697 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 395700 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395704 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395709 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 395712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 395714 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 395717 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 395721 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395726 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 395729 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 395732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 395734 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 395737 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 395741 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395746 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 395749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 395751 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 395754 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395758 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 395768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395777 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395780 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 395783 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 395786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 395804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 395812 */     GIR_RootConstrainSelectedInstOperands,
     /* 395813 */     // GIR_Coverage, 7061,
     /* 395813 */     GIR_EraseRootFromParent_Done,
     /* 395814 */   // Label 7739: @395814
     /* 395814 */   GIM_Reject,
     /* 395815 */ // Label 7737: @395815
     /* 395815 */ GIM_Reject,
     /* 395816 */ // Label 7720: @395816
     /* 395816 */ GIM_Reject,
     /* 395817 */ // Label 104: @395817
     /* 395817 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7748*/ GIMT_Encode4(396432),
     /* 395828 */ /*GILLT_s16*//*Label 7740*/ GIMT_Encode4(395868),
     /* 395832 */ /*GILLT_s32*//*Label 7741*/ GIMT_Encode4(395906),
     /* 395836 */ /*GILLT_s64*//*Label 7742*/ GIMT_Encode4(395944), GIMT_Encode4(0),
     /* 395844 */ /*GILLT_v2s32*//*Label 7743*/ GIMT_Encode4(395982),
     /* 395848 */ /*GILLT_v2s64*//*Label 7744*/ GIMT_Encode4(396020),
     /* 395852 */ /*GILLT_v4s16*//*Label 7745*/ GIMT_Encode4(396058),
     /* 395856 */ /*GILLT_v4s32*//*Label 7746*/ GIMT_Encode4(396096), GIMT_Encode4(0),
     /* 395864 */ /*GILLT_v8s16*//*Label 7747*/ GIMT_Encode4(396134),
     /* 395868 */ // Label 7740: @395868
     /* 395868 */ GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(395905), // Rule ID 631 //
     /* 395873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 395882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395890 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395894 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 395894 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 395899 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395903 */   GIR_RootConstrainSelectedInstOperands,
     /* 395904 */   // GIR_Coverage, 631,
     /* 395904 */   GIR_Done,
     /* 395905 */ // Label 7749: @395905
     /* 395905 */ GIM_Reject,
     /* 395906 */ // Label 7741: @395906
     /* 395906 */ GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(395943), // Rule ID 633 //
     /* 395911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 395920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395932 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 395932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 395937 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395941 */   GIR_RootConstrainSelectedInstOperands,
     /* 395942 */   // GIR_Coverage, 633,
     /* 395942 */   GIR_Done,
     /* 395943 */ // Label 7750: @395943
     /* 395943 */ GIM_Reject,
     /* 395944 */ // Label 7742: @395944
     /* 395944 */ GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(395981), // Rule ID 635 //
     /* 395949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 395958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395970 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 395970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 395975 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395979 */   GIR_RootConstrainSelectedInstOperands,
     /* 395980 */   // GIR_Coverage, 635,
     /* 395980 */   GIR_Done,
     /* 395981 */ // Label 7751: @395981
     /* 395981 */ GIM_Reject,
     /* 395982 */ // Label 7743: @395982
     /* 395982 */ GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(396019), // Rule ID 1342 //
     /* 395987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 395996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396008 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 396008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 396013 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396017 */   GIR_RootConstrainSelectedInstOperands,
     /* 396018 */   // GIR_Coverage, 1342,
     /* 396018 */   GIR_Done,
     /* 396019 */ // Label 7752: @396019
     /* 396019 */ GIM_Reject,
     /* 396020 */ // Label 7744: @396020
     /* 396020 */ GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(396057), // Rule ID 1346 //
     /* 396025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 396034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396046 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 396046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 396051 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396055 */   GIR_RootConstrainSelectedInstOperands,
     /* 396056 */   // GIR_Coverage, 1346,
     /* 396056 */   GIR_Done,
     /* 396057 */ // Label 7753: @396057
     /* 396057 */ GIM_Reject,
     /* 396058 */ // Label 7745: @396058
     /* 396058 */ GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(396095), // Rule ID 1338 //
     /* 396063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 396072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396084 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 396084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 396089 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396093 */   GIR_RootConstrainSelectedInstOperands,
     /* 396094 */   // GIR_Coverage, 1338,
     /* 396094 */   GIR_Done,
     /* 396095 */ // Label 7754: @396095
     /* 396095 */ GIM_Reject,
     /* 396096 */ // Label 7746: @396096
     /* 396096 */ GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(396133), // Rule ID 1344 //
     /* 396101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 396110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396118 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396122 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 396122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 396127 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396131 */   GIR_RootConstrainSelectedInstOperands,
     /* 396132 */   // GIR_Coverage, 1344,
     /* 396132 */   GIR_Done,
     /* 396133 */ // Label 7755: @396133
     /* 396133 */ GIM_Reject,
     /* 396134 */ // Label 7747: @396134
     /* 396134 */ GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(396431),
     /* 396139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 396145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396157 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(396176), // Rule ID 1340 //
     /* 396162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396165 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 396165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 396170 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396174 */     GIR_RootConstrainSelectedInstOperands,
     /* 396175 */     // GIR_Coverage, 1340,
     /* 396175 */     GIR_Done,
     /* 396176 */   // Label 7757: @396176
     /* 396176 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(396430), // Rule ID 7067 //
     /* 396181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 396184 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 396184 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 396187 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 396191 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396196 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 396200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 396202 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 396205 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 396209 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396214 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 396220 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 396223 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 396227 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396232 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 396235 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 396238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 396240 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 396243 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396247 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396252 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 396258 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396263 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396268 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 396271 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 396275 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396280 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 396283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 396285 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 396288 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396292 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396297 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396303 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396308 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396313 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 396316 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 396320 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396325 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 396328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 396330 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 396333 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 396337 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396342 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 396345 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 396348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 396350 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 396353 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 396357 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396362 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 396365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 396367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 396370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 396384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396393 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396396 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 396399 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 396402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 396420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 396428 */     GIR_RootConstrainSelectedInstOperands,
     /* 396429 */     // GIR_Coverage, 7067,
     /* 396429 */     GIR_EraseRootFromParent_Done,
     /* 396430 */   // Label 7758: @396430
     /* 396430 */   GIM_Reject,
     /* 396431 */ // Label 7756: @396431
     /* 396431 */ GIM_Reject,
     /* 396432 */ // Label 7748: @396432
     /* 396432 */ GIM_Reject,
     /* 396433 */ // Label 105: @396433
     /* 396433 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7767*/ GIMT_Encode4(400154),
     /* 396444 */ /*GILLT_s16*//*Label 7759*/ GIMT_Encode4(396484),
     /* 396448 */ /*GILLT_s32*//*Label 7760*/ GIMT_Encode4(397038),
     /* 396452 */ /*GILLT_s64*//*Label 7761*/ GIMT_Encode4(397586), GIMT_Encode4(0),
     /* 396460 */ /*GILLT_v2s32*//*Label 7762*/ GIMT_Encode4(398134),
     /* 396464 */ /*GILLT_v2s64*//*Label 7763*/ GIMT_Encode4(398664),
     /* 396468 */ /*GILLT_v4s16*//*Label 7764*/ GIMT_Encode4(399022),
     /* 396472 */ /*GILLT_v4s32*//*Label 7765*/ GIMT_Encode4(399364), GIMT_Encode4(0),
     /* 396480 */ /*GILLT_v8s16*//*Label 7766*/ GIMT_Encode4(399722),
     /* 396484 */ // Label 7759: @396484
     /* 396484 */ GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(397037),
     /* 396489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 396495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396499 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(396612), // Rule ID 6300 //
     /* 396504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396528 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 396557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396561 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396565 */     // MIs[3] Operand 1
     /* 396565 */     // No operand predicates
     /* 396565 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396567 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 396567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396579 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 396585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 396598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 396610 */     GIR_RootConstrainSelectedInstOperands,
     /* 396611 */     // GIR_Coverage, 6300,
     /* 396611 */     GIR_EraseRootFromParent_Done,
     /* 396612 */   // Label 7769: @396612
     /* 396612 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(396725), // Rule ID 13996 //
     /* 396617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396649 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396653 */     // MIs[2] Operand 1
     /* 396653 */     // No operand predicates
     /* 396653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396661 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396665 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 396669 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396674 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 396678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396680 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 396680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396692 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 396698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 396711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396723 */     GIR_RootConstrainSelectedInstOperands,
     /* 396724 */     // GIR_Coverage, 13996,
     /* 396724 */     GIR_EraseRootFromParent_Done,
     /* 396725 */   // Label 7770: @396725
     /* 396725 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(396804), // Rule ID 13930 //
     /* 396730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396754 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396764 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 396764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396776 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 396782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 396795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396802 */     GIR_RootConstrainSelectedInstOperands,
     /* 396803 */     // GIR_Coverage, 13930,
     /* 396803 */     GIR_EraseRootFromParent_Done,
     /* 396804 */   // Label 7771: @396804
     /* 396804 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(396883), // Rule ID 4838 //
     /* 396809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396837 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396843 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 396843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396855 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 396861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 396874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396881 */     GIR_RootConstrainSelectedInstOperands,
     /* 396882 */     // GIR_Coverage, 4838,
     /* 396882 */     GIR_EraseRootFromParent_Done,
     /* 396883 */   // Label 7772: @396883
     /* 396883 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(396946), // Rule ID 13545 //
     /* 396888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 396912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396920 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396924 */     // MIs[2] Operand 1
     /* 396924 */     // No operand predicates
     /* 396924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396930 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 396933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396944 */     GIR_RootConstrainSelectedInstOperands,
     /* 396945 */     // GIR_Coverage, 13545,
     /* 396945 */     GIR_EraseRootFromParent_Done,
     /* 396946 */   // Label 7773: @396946
     /* 396946 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(397009), // Rule ID 2011 //
     /* 396951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 396979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396987 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396991 */     // MIs[2] Operand 1
     /* 396991 */     // No operand predicates
     /* 396991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396993 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 396996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397007 */     GIR_RootConstrainSelectedInstOperands,
     /* 397008 */     // GIR_Coverage, 2011,
     /* 397008 */     GIR_EraseRootFromParent_Done,
     /* 397009 */   // Label 7774: @397009
     /* 397009 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(397036), // Rule ID 619 //
     /* 397014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 397017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397025 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 397025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 397030 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397034 */     GIR_RootConstrainSelectedInstOperands,
     /* 397035 */     // GIR_Coverage, 619,
     /* 397035 */     GIR_Done,
     /* 397036 */   // Label 7775: @397036
     /* 397036 */   GIM_Reject,
     /* 397037 */ // Label 7768: @397037
     /* 397037 */ GIM_Reject,
     /* 397038 */ // Label 7760: @397038
     /* 397038 */ GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(397585),
     /* 397043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 397049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397053 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(397166), // Rule ID 6302 //
     /* 397058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397082 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397102 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397115 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397119 */     // MIs[3] Operand 1
     /* 397119 */     // No operand predicates
     /* 397119 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397121 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 397121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 397124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397133 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 397139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 397152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397164 */     GIR_RootConstrainSelectedInstOperands,
     /* 397165 */     // GIR_Coverage, 6302,
     /* 397165 */     GIR_EraseRootFromParent_Done,
     /* 397166 */   // Label 7777: @397166
     /* 397166 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(397279), // Rule ID 13998 //
     /* 397171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397207 */     // MIs[2] Operand 1
     /* 397207 */     // No operand predicates
     /* 397207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397215 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397219 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 397223 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397228 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 397232 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397234 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 397234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 397237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397246 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 397252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 397265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397277 */     GIR_RootConstrainSelectedInstOperands,
     /* 397278 */     // GIR_Coverage, 13998,
     /* 397278 */     GIR_EraseRootFromParent_Done,
     /* 397279 */   // Label 7778: @397279
     /* 397279 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(397355), // Rule ID 13932 //
     /* 397284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397305 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397315 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 397315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 397318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397327 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 397333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 397346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397353 */     GIR_RootConstrainSelectedInstOperands,
     /* 397354 */     // GIR_Coverage, 13932,
     /* 397354 */     GIR_EraseRootFromParent_Done,
     /* 397355 */   // Label 7779: @397355
     /* 397355 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(397431), // Rule ID 4840 //
     /* 397360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397385 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397391 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 397391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 397394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397403 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 397409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 397422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397429 */     GIR_RootConstrainSelectedInstOperands,
     /* 397430 */     // GIR_Coverage, 4840,
     /* 397430 */     GIR_EraseRootFromParent_Done,
     /* 397431 */   // Label 7780: @397431
     /* 397431 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(397494), // Rule ID 13547 //
     /* 397436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397468 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397472 */     // MIs[2] Operand 1
     /* 397472 */     // No operand predicates
     /* 397472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397478 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 397481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397492 */     GIR_RootConstrainSelectedInstOperands,
     /* 397493 */     // GIR_Coverage, 13547,
     /* 397493 */     GIR_EraseRootFromParent_Done,
     /* 397494 */   // Label 7781: @397494
     /* 397494 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(397557), // Rule ID 2013 //
     /* 397499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397535 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397539 */     // MIs[2] Operand 1
     /* 397539 */     // No operand predicates
     /* 397539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397541 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 397544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397555 */     GIR_RootConstrainSelectedInstOperands,
     /* 397556 */     // GIR_Coverage, 2013,
     /* 397556 */     GIR_EraseRootFromParent_Done,
     /* 397557 */   // Label 7782: @397557
     /* 397557 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(397584), // Rule ID 621 //
     /* 397562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 397565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397573 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 397573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 397578 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397582 */     GIR_RootConstrainSelectedInstOperands,
     /* 397583 */     // GIR_Coverage, 621,
     /* 397583 */     GIR_Done,
     /* 397584 */   // Label 7783: @397584
     /* 397584 */   GIM_Reject,
     /* 397585 */ // Label 7776: @397585
     /* 397585 */ GIM_Reject,
     /* 397586 */ // Label 7761: @397586
     /* 397586 */ GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(398133),
     /* 397591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 397594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397601 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(397714), // Rule ID 6304 //
     /* 397606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397630 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397663 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 397667 */     // MIs[3] Operand 1
     /* 397667 */     // No operand predicates
     /* 397667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397669 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 397669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397681 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 397687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 397700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397712 */     GIR_RootConstrainSelectedInstOperands,
     /* 397713 */     // GIR_Coverage, 6304,
     /* 397713 */     GIR_EraseRootFromParent_Done,
     /* 397714 */   // Label 7785: @397714
     /* 397714 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(397827), // Rule ID 14000 //
     /* 397719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397751 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 397755 */     // MIs[2] Operand 1
     /* 397755 */     // No operand predicates
     /* 397755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397763 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397767 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 397771 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397776 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 397780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397782 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 397782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397794 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 397800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 397813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397825 */     GIR_RootConstrainSelectedInstOperands,
     /* 397826 */     // GIR_Coverage, 14000,
     /* 397826 */     GIR_EraseRootFromParent_Done,
     /* 397827 */   // Label 7786: @397827
     /* 397827 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(397903), // Rule ID 13934 //
     /* 397832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397853 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397863 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 397863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397875 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 397881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 397894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397901 */     GIR_RootConstrainSelectedInstOperands,
     /* 397902 */     // GIR_Coverage, 13934,
     /* 397902 */     GIR_EraseRootFromParent_Done,
     /* 397903 */   // Label 7787: @397903
     /* 397903 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(397979), // Rule ID 4842 //
     /* 397908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397933 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397939 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 397939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397951 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 397957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 397970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397977 */     GIR_RootConstrainSelectedInstOperands,
     /* 397978 */     // GIR_Coverage, 4842,
     /* 397978 */     GIR_EraseRootFromParent_Done,
     /* 397979 */   // Label 7788: @397979
     /* 397979 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(398042), // Rule ID 13549 //
     /* 397984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398016 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398020 */     // MIs[2] Operand 1
     /* 398020 */     // No operand predicates
     /* 398020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398026 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 398029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398040 */     GIR_RootConstrainSelectedInstOperands,
     /* 398041 */     // GIR_Coverage, 13549,
     /* 398041 */     GIR_EraseRootFromParent_Done,
     /* 398042 */   // Label 7789: @398042
     /* 398042 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(398105), // Rule ID 2015 //
     /* 398047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398083 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398087 */     // MIs[2] Operand 1
     /* 398087 */     // No operand predicates
     /* 398087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398089 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 398092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398103 */     GIR_RootConstrainSelectedInstOperands,
     /* 398104 */     // GIR_Coverage, 2015,
     /* 398104 */     GIR_EraseRootFromParent_Done,
     /* 398105 */   // Label 7790: @398105
     /* 398105 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(398132), // Rule ID 623 //
     /* 398110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 398113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398121 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 398121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 398126 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398130 */     GIR_RootConstrainSelectedInstOperands,
     /* 398131 */     // GIR_Coverage, 623,
     /* 398131 */     GIR_Done,
     /* 398132 */   // Label 7791: @398132
     /* 398132 */   GIM_Reject,
     /* 398133 */ // Label 7784: @398133
     /* 398133 */ GIM_Reject,
     /* 398134 */ // Label 7762: @398134
     /* 398134 */ GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(398663),
     /* 398139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 398145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398149 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(398235), // Rule ID 13537 //
     /* 398154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 398173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 398177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398198 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398202 */     // MIs[3] Operand 1
     /* 398202 */     // No operand predicates
     /* 398202 */     // MIs[1] Operand 2
     /* 398202 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398219 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 398222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398233 */     GIR_RootConstrainSelectedInstOperands,
     /* 398234 */     // GIR_Coverage, 13537,
     /* 398234 */     GIR_EraseRootFromParent_Done,
     /* 398235 */   // Label 7793: @398235
     /* 398235 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(398321), // Rule ID 2003 //
     /* 398240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 398263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 398267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398288 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398292 */     // MIs[3] Operand 1
     /* 398292 */     // No operand predicates
     /* 398292 */     // MIs[1] Operand 2
     /* 398292 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398305 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 398308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398319 */     GIR_RootConstrainSelectedInstOperands,
     /* 398320 */     // GIR_Coverage, 2003,
     /* 398320 */     GIR_EraseRootFromParent_Done,
     /* 398321 */   // Label 7794: @398321
     /* 398321 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(398384), // Rule ID 13538 //
     /* 398326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 398337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398358 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398362 */     // MIs[2] Operand 1
     /* 398362 */     // No operand predicates
     /* 398362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398368 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 398371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398382 */     GIR_RootConstrainSelectedInstOperands,
     /* 398383 */     // GIR_Coverage, 13538,
     /* 398383 */     GIR_EraseRootFromParent_Done,
     /* 398384 */   // Label 7795: @398384
     /* 398384 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(398447), // Rule ID 2004 //
     /* 398389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 398404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398425 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398429 */     // MIs[2] Operand 1
     /* 398429 */     // No operand predicates
     /* 398429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398431 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 398434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398445 */     GIR_RootConstrainSelectedInstOperands,
     /* 398446 */     // GIR_Coverage, 2004,
     /* 398446 */     GIR_EraseRootFromParent_Done,
     /* 398447 */   // Label 7796: @398447
     /* 398447 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(398541), // Rule ID 14002 //
     /* 398452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 398460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 398464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398475 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398475 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 398478 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398482 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 398492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398501 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398508 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 398511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 398529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398539 */     GIR_RootConstrainSelectedInstOperands,
     /* 398540 */     // GIR_Coverage, 14002,
     /* 398540 */     GIR_EraseRootFromParent_Done,
     /* 398541 */   // Label 7797: @398541
     /* 398541 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(398635), // Rule ID 6306 //
     /* 398546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 398558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 398562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398569 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 398572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 398586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398595 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398598 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398602 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 398605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 398623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398633 */     GIR_RootConstrainSelectedInstOperands,
     /* 398634 */     // GIR_Coverage, 6306,
     /* 398634 */     GIR_EraseRootFromParent_Done,
     /* 398635 */   // Label 7798: @398635
     /* 398635 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(398662), // Rule ID 1322 //
     /* 398640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398651 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 398651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 398656 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398660 */     GIR_RootConstrainSelectedInstOperands,
     /* 398661 */     // GIR_Coverage, 1322,
     /* 398661 */     GIR_Done,
     /* 398662 */   // Label 7799: @398662
     /* 398662 */   GIM_Reject,
     /* 398663 */ // Label 7792: @398663
     /* 398663 */ GIM_Reject,
     /* 398664 */ // Label 7763: @398664
     /* 398664 */ GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(399021),
     /* 398669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 398675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398679 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(398742), // Rule ID 13543 //
     /* 398684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 398695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398716 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398720 */     // MIs[2] Operand 1
     /* 398720 */     // No operand predicates
     /* 398720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398726 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 398729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398740 */     GIR_RootConstrainSelectedInstOperands,
     /* 398741 */     // GIR_Coverage, 13543,
     /* 398741 */     GIR_EraseRootFromParent_Done,
     /* 398742 */   // Label 7801: @398742
     /* 398742 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(398805), // Rule ID 2009 //
     /* 398747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 398762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398783 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398787 */     // MIs[2] Operand 1
     /* 398787 */     // No operand predicates
     /* 398787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398789 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 398792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398803 */     GIR_RootConstrainSelectedInstOperands,
     /* 398804 */     // GIR_Coverage, 2009,
     /* 398804 */     GIR_EraseRootFromParent_Done,
     /* 398805 */   // Label 7802: @398805
     /* 398805 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(398899), // Rule ID 14006 //
     /* 398810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 398818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 398822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398833 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398833 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 398836 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398840 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 398850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398859 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398866 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 398869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 398887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398897 */     GIR_RootConstrainSelectedInstOperands,
     /* 398898 */     // GIR_Coverage, 14006,
     /* 398898 */     GIR_EraseRootFromParent_Done,
     /* 398899 */   // Label 7803: @398899
     /* 398899 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(398993), // Rule ID 6310 //
     /* 398904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 398916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 398920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398927 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398927 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 398930 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398934 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 398944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398953 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398956 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398960 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 398963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 398981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398991 */     GIR_RootConstrainSelectedInstOperands,
     /* 398992 */     // GIR_Coverage, 6310,
     /* 398992 */     GIR_EraseRootFromParent_Done,
     /* 398993 */   // Label 7804: @398993
     /* 398993 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(399020), // Rule ID 1326 //
     /* 398998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399009 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 399009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 399014 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399018 */     GIR_RootConstrainSelectedInstOperands,
     /* 399019 */     // GIR_Coverage, 1326,
     /* 399019 */     GIR_Done,
     /* 399020 */   // Label 7805: @399020
     /* 399020 */   GIM_Reject,
     /* 399021 */ // Label 7800: @399021
     /* 399021 */ GIM_Reject,
     /* 399022 */ // Label 7764: @399022
     /* 399022 */ GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(399363),
     /* 399027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 399033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399037 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(399123), // Rule ID 13531 //
     /* 399042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399086 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399090 */     // MIs[3] Operand 1
     /* 399090 */     // No operand predicates
     /* 399090 */     // MIs[1] Operand 2
     /* 399090 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399107 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 399110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399121 */     GIR_RootConstrainSelectedInstOperands,
     /* 399122 */     // GIR_Coverage, 13531,
     /* 399122 */     GIR_EraseRootFromParent_Done,
     /* 399123 */   // Label 7807: @399123
     /* 399123 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(399209), // Rule ID 1997 //
     /* 399128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399159 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399176 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399180 */     // MIs[3] Operand 1
     /* 399180 */     // No operand predicates
     /* 399180 */     // MIs[1] Operand 2
     /* 399180 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399193 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 399196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399207 */     GIR_RootConstrainSelectedInstOperands,
     /* 399208 */     // GIR_Coverage, 1997,
     /* 399208 */     GIR_EraseRootFromParent_Done,
     /* 399209 */   // Label 7808: @399209
     /* 399209 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(399272), // Rule ID 13532 //
     /* 399214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399246 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399250 */     // MIs[2] Operand 1
     /* 399250 */     // No operand predicates
     /* 399250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399256 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 399259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399270 */     GIR_RootConstrainSelectedInstOperands,
     /* 399271 */     // GIR_Coverage, 13532,
     /* 399271 */     GIR_EraseRootFromParent_Done,
     /* 399272 */   // Label 7809: @399272
     /* 399272 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(399335), // Rule ID 1998 //
     /* 399277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399313 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399317 */     // MIs[2] Operand 1
     /* 399317 */     // No operand predicates
     /* 399317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399319 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 399322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399333 */     GIR_RootConstrainSelectedInstOperands,
     /* 399334 */     // GIR_Coverage, 1998,
     /* 399334 */     GIR_EraseRootFromParent_Done,
     /* 399335 */   // Label 7810: @399335
     /* 399335 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(399362), // Rule ID 1318 //
     /* 399340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399351 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 399351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 399356 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399360 */     GIR_RootConstrainSelectedInstOperands,
     /* 399361 */     // GIR_Coverage, 1318,
     /* 399361 */     GIR_Done,
     /* 399362 */   // Label 7811: @399362
     /* 399362 */   GIM_Reject,
     /* 399363 */ // Label 7806: @399363
     /* 399363 */ GIM_Reject,
     /* 399364 */ // Label 7765: @399364
     /* 399364 */ GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(399721),
     /* 399369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 399375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399379 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(399442), // Rule ID 13541 //
     /* 399384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399416 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399420 */     // MIs[2] Operand 1
     /* 399420 */     // No operand predicates
     /* 399420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399426 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 399429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399440 */     GIR_RootConstrainSelectedInstOperands,
     /* 399441 */     // GIR_Coverage, 13541,
     /* 399441 */     GIR_EraseRootFromParent_Done,
     /* 399442 */   // Label 7813: @399442
     /* 399442 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(399505), // Rule ID 2007 //
     /* 399447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399483 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399487 */     // MIs[2] Operand 1
     /* 399487 */     // No operand predicates
     /* 399487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399489 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 399492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399503 */     GIR_RootConstrainSelectedInstOperands,
     /* 399504 */     // GIR_Coverage, 2007,
     /* 399504 */     GIR_EraseRootFromParent_Done,
     /* 399505 */   // Label 7814: @399505
     /* 399505 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(399599), // Rule ID 14004 //
     /* 399510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 399518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 399522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399533 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399533 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399536 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399540 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399566 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 399569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 399587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399597 */     GIR_RootConstrainSelectedInstOperands,
     /* 399598 */     // GIR_Coverage, 14004,
     /* 399598 */     GIR_EraseRootFromParent_Done,
     /* 399599 */   // Label 7815: @399599
     /* 399599 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(399693), // Rule ID 6308 //
     /* 399604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 399616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 399620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399627 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399627 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399630 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399634 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399653 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399656 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399660 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 399663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 399681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399691 */     GIR_RootConstrainSelectedInstOperands,
     /* 399692 */     // GIR_Coverage, 6308,
     /* 399692 */     GIR_EraseRootFromParent_Done,
     /* 399693 */   // Label 7816: @399693
     /* 399693 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(399720), // Rule ID 1324 //
     /* 399698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399709 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 399709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 399714 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399718 */     GIR_RootConstrainSelectedInstOperands,
     /* 399719 */     // GIR_Coverage, 1324,
     /* 399719 */     GIR_Done,
     /* 399720 */   // Label 7817: @399720
     /* 399720 */   GIM_Reject,
     /* 399721 */ // Label 7812: @399721
     /* 399721 */ GIM_Reject,
     /* 399722 */ // Label 7766: @399722
     /* 399722 */ GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(400153),
     /* 399727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 399733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399737 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(399800), // Rule ID 13535 //
     /* 399742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399774 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399778 */     // MIs[2] Operand 1
     /* 399778 */     // No operand predicates
     /* 399778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399784 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 399787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399798 */     GIR_RootConstrainSelectedInstOperands,
     /* 399799 */     // GIR_Coverage, 13535,
     /* 399799 */     GIR_EraseRootFromParent_Done,
     /* 399800 */   // Label 7819: @399800
     /* 399800 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(399863), // Rule ID 2001 //
     /* 399805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399841 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399845 */     // MIs[2] Operand 1
     /* 399845 */     // No operand predicates
     /* 399845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399847 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 399850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399861 */     GIR_RootConstrainSelectedInstOperands,
     /* 399862 */     // GIR_Coverage, 2001,
     /* 399862 */     GIR_EraseRootFromParent_Done,
     /* 399863 */   // Label 7820: @399863
     /* 399863 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(399890), // Rule ID 1320 //
     /* 399868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399879 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 399879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 399884 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399888 */     GIR_RootConstrainSelectedInstOperands,
     /* 399889 */     // GIR_Coverage, 1320,
     /* 399889 */     GIR_Done,
     /* 399890 */   // Label 7821: @399890
     /* 399890 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(400152), // Rule ID 7065 //
     /* 399895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 399898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399906 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 399906 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 399909 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 399913 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399918 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 399922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 399924 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 399927 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 399931 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399936 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 399942 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 399945 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 399949 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399954 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 399957 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 399960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 399962 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 399965 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399969 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399974 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 399980 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399985 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399990 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 399993 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 399997 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400002 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 400005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 400007 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 400010 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400014 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400019 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 400025 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400030 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400035 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 400038 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 400042 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400047 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 400050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 400052 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 400055 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 400059 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400064 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 400067 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 400070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 400072 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 400075 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 400079 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400084 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 400087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 400089 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 400092 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400096 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 400106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400115 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400118 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 400121 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 400124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 400142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 400150 */     GIR_RootConstrainSelectedInstOperands,
     /* 400151 */     // GIR_Coverage, 7065,
     /* 400151 */     GIR_EraseRootFromParent_Done,
     /* 400152 */   // Label 7822: @400152
     /* 400152 */   GIM_Reject,
     /* 400153 */ // Label 7818: @400153
     /* 400153 */ GIM_Reject,
     /* 400154 */ // Label 7767: @400154
     /* 400154 */ GIM_Reject,
     /* 400155 */ // Label 106: @400155
     /* 400155 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7831*/ GIMT_Encode4(400770),
     /* 400166 */ /*GILLT_s16*//*Label 7823*/ GIMT_Encode4(400206),
     /* 400170 */ /*GILLT_s32*//*Label 7824*/ GIMT_Encode4(400244),
     /* 400174 */ /*GILLT_s64*//*Label 7825*/ GIMT_Encode4(400282), GIMT_Encode4(0),
     /* 400182 */ /*GILLT_v2s32*//*Label 7826*/ GIMT_Encode4(400320),
     /* 400186 */ /*GILLT_v2s64*//*Label 7827*/ GIMT_Encode4(400358),
     /* 400190 */ /*GILLT_v4s16*//*Label 7828*/ GIMT_Encode4(400396),
     /* 400194 */ /*GILLT_v4s32*//*Label 7829*/ GIMT_Encode4(400434), GIMT_Encode4(0),
     /* 400202 */ /*GILLT_v8s16*//*Label 7830*/ GIMT_Encode4(400472),
     /* 400206 */ // Label 7823: @400206
     /* 400206 */ GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(400243), // Rule ID 589 //
     /* 400211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 400214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 400217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 400220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400232 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 400232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 400237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400241 */   GIR_RootConstrainSelectedInstOperands,
     /* 400242 */   // GIR_Coverage, 589,
     /* 400242 */   GIR_Done,
     /* 400243 */ // Label 7832: @400243
     /* 400243 */ GIM_Reject,
     /* 400244 */ // Label 7824: @400244
     /* 400244 */ GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(400281), // Rule ID 591 //
     /* 400249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 400252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 400258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400270 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 400270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 400275 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400279 */   GIR_RootConstrainSelectedInstOperands,
     /* 400280 */   // GIR_Coverage, 591,
     /* 400280 */   GIR_Done,
     /* 400281 */ // Label 7833: @400281
     /* 400281 */ GIM_Reject,
     /* 400282 */ // Label 7825: @400282
     /* 400282 */ GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(400319), // Rule ID 593 //
     /* 400287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 400290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 400296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400308 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 400308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 400313 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400317 */   GIR_RootConstrainSelectedInstOperands,
     /* 400318 */   // GIR_Coverage, 593,
     /* 400318 */   GIR_Done,
     /* 400319 */ // Label 7834: @400319
     /* 400319 */ GIM_Reject,
     /* 400320 */ // Label 7826: @400320
     /* 400320 */ GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(400357), // Rule ID 1227 //
     /* 400325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 400334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400346 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 400346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 400351 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400355 */   GIR_RootConstrainSelectedInstOperands,
     /* 400356 */   // GIR_Coverage, 1227,
     /* 400356 */   GIR_Done,
     /* 400357 */ // Label 7835: @400357
     /* 400357 */ GIM_Reject,
     /* 400358 */ // Label 7827: @400358
     /* 400358 */ GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(400395), // Rule ID 1231 //
     /* 400363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 400372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400384 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 400384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 400389 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400393 */   GIR_RootConstrainSelectedInstOperands,
     /* 400394 */   // GIR_Coverage, 1231,
     /* 400394 */   GIR_Done,
     /* 400395 */ // Label 7836: @400395
     /* 400395 */ GIM_Reject,
     /* 400396 */ // Label 7828: @400396
     /* 400396 */ GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(400433), // Rule ID 1223 //
     /* 400401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 400410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400422 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 400422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 400427 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400431 */   GIR_RootConstrainSelectedInstOperands,
     /* 400432 */   // GIR_Coverage, 1223,
     /* 400432 */   GIR_Done,
     /* 400433 */ // Label 7837: @400433
     /* 400433 */ GIM_Reject,
     /* 400434 */ // Label 7829: @400434
     /* 400434 */ GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(400471), // Rule ID 1229 //
     /* 400439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 400448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400460 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 400460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 400465 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400469 */   GIR_RootConstrainSelectedInstOperands,
     /* 400470 */   // GIR_Coverage, 1229,
     /* 400470 */   GIR_Done,
     /* 400471 */ // Label 7838: @400471
     /* 400471 */ GIM_Reject,
     /* 400472 */ // Label 7830: @400472
     /* 400472 */ GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(400769),
     /* 400477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 400483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400495 */   GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(400514), // Rule ID 1225 //
     /* 400500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400503 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 400503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 400508 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400512 */     GIR_RootConstrainSelectedInstOperands,
     /* 400513 */     // GIR_Coverage, 1225,
     /* 400513 */     GIR_Done,
     /* 400514 */   // Label 7840: @400514
     /* 400514 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(400768), // Rule ID 7063 //
     /* 400519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 400522 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 400522 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 400525 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 400529 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400534 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 400538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 400540 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 400543 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 400547 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400552 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 400556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 400558 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 400561 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 400565 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400570 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 400573 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 400576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 400578 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 400581 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400585 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400590 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 400596 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400601 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400606 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 400609 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 400613 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400618 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 400621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 400623 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 400626 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400630 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400635 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 400641 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400646 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400651 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 400654 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 400658 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400663 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 400666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 400668 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 400671 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 400675 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400680 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 400683 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 400686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 400688 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 400691 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 400695 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400700 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 400703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 400705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 400708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 400722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400731 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400734 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 400737 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 400740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 400758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 400766 */     GIR_RootConstrainSelectedInstOperands,
     /* 400767 */     // GIR_Coverage, 7063,
     /* 400767 */     GIR_EraseRootFromParent_Done,
     /* 400768 */   // Label 7841: @400768
     /* 400768 */   GIM_Reject,
     /* 400769 */ // Label 7839: @400769
     /* 400769 */ GIM_Reject,
     /* 400770 */ // Label 7831: @400770
     /* 400770 */ GIM_Reject,
     /* 400771 */ // Label 107: @400771
     /* 400771 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7850*/ GIMT_Encode4(416377),
     /* 400782 */ /*GILLT_s16*//*Label 7842*/ GIMT_Encode4(400822),
     /* 400786 */ /*GILLT_s32*//*Label 7843*/ GIMT_Encode4(403596),
     /* 400790 */ /*GILLT_s64*//*Label 7844*/ GIMT_Encode4(406526), GIMT_Encode4(0),
     /* 400798 */ /*GILLT_v2s32*//*Label 7845*/ GIMT_Encode4(409456),
     /* 400802 */ /*GILLT_v2s64*//*Label 7846*/ GIMT_Encode4(410977),
     /* 400806 */ /*GILLT_v4s16*//*Label 7847*/ GIMT_Encode4(412498),
     /* 400810 */ /*GILLT_v4s32*//*Label 7848*/ GIMT_Encode4(413677), GIMT_Encode4(0),
     /* 400818 */ /*GILLT_v8s16*//*Label 7849*/ GIMT_Encode4(415198),
     /* 400822 */ // Label 7842: @400822
     /* 400822 */ GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(403595),
     /* 400827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 400830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 400833 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 400836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400840 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(400990), // Rule ID 4900 //
     /* 400845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 400848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400869 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 400873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400894 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 400898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 400902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 400906 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 400910 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400917 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 400917 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 400920 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400924 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400929 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 400935 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400940 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 400948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400957 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 400963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 400976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 400984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 400988 */     GIR_RootConstrainSelectedInstOperands,
     /* 400989 */     // GIR_Coverage, 4900,
     /* 400989 */     GIR_EraseRootFromParent_Done,
     /* 400990 */   // Label 7852: @400990
     /* 400990 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(401137), // Rule ID 4864 //
     /* 400995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 400998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401019 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 401039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401043 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401047 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 401051 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401056 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 401060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401066 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401066 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 401069 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401073 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401078 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401084 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401089 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401106 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 401125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 401133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 401135 */     GIR_RootConstrainSelectedInstOperands,
     /* 401136 */     // GIR_Coverage, 4864,
     /* 401136 */     GIR_EraseRootFromParent_Done,
     /* 401137 */   // Label 7853: @401137
     /* 401137 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(401284), // Rule ID 13943 //
     /* 401142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401169 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401173 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401178 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 401182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401190 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401194 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 401198 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401203 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 401207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401213 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401213 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 401216 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401220 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401225 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401231 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401236 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401253 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 401272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 401280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 401282 */     GIR_RootConstrainSelectedInstOperands,
     /* 401283 */     // GIR_Coverage, 13943,
     /* 401283 */     GIR_EraseRootFromParent_Done,
     /* 401284 */   // Label 7854: @401284
     /* 401284 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(401415), // Rule ID 6138 //
     /* 401289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401313 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 401333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401337 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401341 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 401345 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401350 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 401354 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401358 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401362 */     // MIs[4] Operand 1
     /* 401362 */     // No operand predicates
     /* 401362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401366 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 401368 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 401368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401380 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 401399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 401403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 401410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 401413 */     GIR_RootConstrainSelectedInstOperands,
     /* 401414 */     // GIR_Coverage, 6138,
     /* 401414 */     GIR_EraseRootFromParent_Done,
     /* 401415 */   // Label 7855: @401415
     /* 401415 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(401546), // Rule ID 6170 //
     /* 401420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401452 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401456 */     // MIs[2] Operand 1
     /* 401456 */     // No operand predicates
     /* 401456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401464 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 401468 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 401472 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401476 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401480 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 401484 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401489 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 401493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401497 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 401499 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 401499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401511 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 401530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 401534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401544 */     GIR_RootConstrainSelectedInstOperands,
     /* 401545 */     // GIR_Coverage, 6170,
     /* 401545 */     GIR_EraseRootFromParent_Done,
     /* 401546 */   // Label 7856: @401546
     /* 401546 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(401677), // Rule ID 6234 //
     /* 401551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401587 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 401591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401599 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401603 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 401607 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401612 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 401616 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401620 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401624 */     // MIs[4] Operand 1
     /* 401624 */     // No operand predicates
     /* 401624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401628 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 401630 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 401630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401642 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 401661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 401665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 401672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 401675 */     GIR_RootConstrainSelectedInstOperands,
     /* 401676 */     // GIR_Coverage, 6234,
     /* 401676 */     GIR_EraseRootFromParent_Done,
     /* 401677 */   // Label 7857: @401677
     /* 401677 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(401808), // Rule ID 6202 //
     /* 401682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401713 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 401722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401726 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401730 */     // MIs[3] Operand 1
     /* 401730 */     // No operand predicates
     /* 401730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 401734 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401738 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401742 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 401746 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401751 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 401755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401759 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 401761 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 401761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401773 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 401792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 401796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 401806 */     GIR_RootConstrainSelectedInstOperands,
     /* 401807 */     // GIR_Coverage, 6202,
     /* 401807 */     GIR_EraseRootFromParent_Done,
     /* 401808 */   // Label 7858: @401808
     /* 401808 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(401943), // Rule ID 2455 //
     /* 401813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401837 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401862 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 401866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401872 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401872 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 401875 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401879 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401884 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401890 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401895 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401912 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 401931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 401939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 401941 */     GIR_RootConstrainSelectedInstOperands,
     /* 401942 */     // GIR_Coverage, 2455,
     /* 401942 */     GIR_EraseRootFromParent_Done,
     /* 401943 */   // Label 7859: @401943
     /* 401943 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(402062), // Rule ID 6106 //
     /* 401948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401972 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401992 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 402001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402005 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402009 */     // MIs[3] Operand 1
     /* 402009 */     // No operand predicates
     /* 402009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402015 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402027 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 402046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 402060 */     GIR_RootConstrainSelectedInstOperands,
     /* 402061 */     // GIR_Coverage, 6106,
     /* 402061 */     GIR_EraseRootFromParent_Done,
     /* 402062 */   // Label 7860: @402062
     /* 402062 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(402181), // Rule ID 2537 //
     /* 402067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402099 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402103 */     // MIs[2] Operand 1
     /* 402103 */     // No operand predicates
     /* 402103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402111 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402115 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 402119 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402124 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 402128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402134 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402146 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 402165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 402179 */     GIR_RootConstrainSelectedInstOperands,
     /* 402180 */     // GIR_Coverage, 2537,
     /* 402180 */     GIR_EraseRootFromParent_Done,
     /* 402181 */   // Label 7861: @402181
     /* 402181 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(402281), // Rule ID 4862 //
     /* 402186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402210 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402237 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402249 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402279 */     GIR_RootConstrainSelectedInstOperands,
     /* 402280 */     // GIR_Coverage, 4862,
     /* 402280 */     GIR_EraseRootFromParent_Done,
     /* 402281 */   // Label 7862: @402281
     /* 402281 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(402381), // Rule ID 4898 //
     /* 402286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402310 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 402322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402337 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402349 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 402368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 402379 */     GIR_RootConstrainSelectedInstOperands,
     /* 402380 */     // GIR_Coverage, 4898,
     /* 402380 */     GIR_EraseRootFromParent_Done,
     /* 402381 */   // Label 7863: @402381
     /* 402381 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(402478), // Rule ID 13939 //
     /* 402386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402422 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402436 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402448 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402476 */     GIR_RootConstrainSelectedInstOperands,
     /* 402477 */     // GIR_Coverage, 13939,
     /* 402477 */     GIR_EraseRootFromParent_Done,
     /* 402478 */   // Label 7864: @402478
     /* 402478 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(402578), // Rule ID 13941 //
     /* 402483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402515 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402524 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402534 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402546 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402576 */     GIR_RootConstrainSelectedInstOperands,
     /* 402577 */     // GIR_Coverage, 13941,
     /* 402577 */     GIR_EraseRootFromParent_Done,
     /* 402578 */   // Label 7865: @402578
     /* 402578 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(402678), // Rule ID 4896 //
     /* 402583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402611 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 402619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402634 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402646 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 402665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 402676 */     GIR_RootConstrainSelectedInstOperands,
     /* 402677 */     // GIR_Coverage, 4896,
     /* 402677 */     GIR_EraseRootFromParent_Done,
     /* 402678 */   // Label 7866: @402678
     /* 402678 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(402775), // Rule ID 4860 //
     /* 402683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402723 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402733 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402745 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402773 */     GIR_RootConstrainSelectedInstOperands,
     /* 402774 */     // GIR_Coverage, 4860,
     /* 402774 */     GIR_EraseRootFromParent_Done,
     /* 402775 */   // Label 7867: @402775
     /* 402775 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(402859), // Rule ID 6168 //
     /* 402780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402812 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402816 */     // MIs[2] Operand 1
     /* 402816 */     // No operand predicates
     /* 402816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402824 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 402828 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402837 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402839 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 402850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 402857 */     GIR_RootConstrainSelectedInstOperands,
     /* 402858 */     // GIR_Coverage, 6168,
     /* 402858 */     GIR_EraseRootFromParent_Done,
     /* 402859 */   // Label 7868: @402859
     /* 402859 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(402940), // Rule ID 6200 //
     /* 402864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 402904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402908 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402912 */     // MIs[3] Operand 1
     /* 402912 */     // No operand predicates
     /* 402912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402922 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 402938 */     GIR_RootConstrainSelectedInstOperands,
     /* 402939 */     // GIR_Coverage, 6200,
     /* 402939 */     GIR_EraseRootFromParent_Done,
     /* 402940 */   // Label 7869: @402940
     /* 402940 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(403024), // Rule ID 6232 //
     /* 402945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 402990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402994 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402998 */     // MIs[3] Operand 1
     /* 402998 */     // No operand predicates
     /* 402998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403002 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403004 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403022 */     GIR_RootConstrainSelectedInstOperands,
     /* 403023 */     // GIR_Coverage, 6232,
     /* 403023 */     GIR_EraseRootFromParent_Done,
     /* 403024 */   // Label 7870: @403024
     /* 403024 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(403105), // Rule ID 6136 //
     /* 403029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403077 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403081 */     // MIs[3] Operand 1
     /* 403081 */     // No operand predicates
     /* 403081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403087 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403103 */     GIR_RootConstrainSelectedInstOperands,
     /* 403104 */     // GIR_Coverage, 6136,
     /* 403104 */     GIR_EraseRootFromParent_Done,
     /* 403105 */   // Label 7871: @403105
     /* 403105 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(403190), // Rule ID 2453 //
     /* 403110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403134 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403148 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403160 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 403179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403188 */     GIR_RootConstrainSelectedInstOperands,
     /* 403189 */     // GIR_Coverage, 2453,
     /* 403189 */     GIR_EraseRootFromParent_Done,
     /* 403190 */   // Label 7872: @403190
     /* 403190 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(403275), // Rule ID 2451 //
     /* 403195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403223 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403233 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 403233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403245 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 403251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 403264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403266 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403273 */     GIR_RootConstrainSelectedInstOperands,
     /* 403274 */     // GIR_Coverage, 2451,
     /* 403274 */     GIR_EraseRootFromParent_Done,
     /* 403275 */   // Label 7873: @403275
     /* 403275 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(403344), // Rule ID 2535 //
     /* 403280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403312 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403316 */     // MIs[2] Operand 1
     /* 403316 */     // No operand predicates
     /* 403316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403326 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 403329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 403342 */     GIR_RootConstrainSelectedInstOperands,
     /* 403343 */     // GIR_Coverage, 2535,
     /* 403343 */     GIR_EraseRootFromParent_Done,
     /* 403344 */   // Label 7874: @403344
     /* 403344 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(403413), // Rule ID 6104 //
     /* 403349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403385 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403389 */     // MIs[2] Operand 1
     /* 403389 */     // No operand predicates
     /* 403389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403395 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 403398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 403411 */     GIR_RootConstrainSelectedInstOperands,
     /* 403412 */     // GIR_Coverage, 6104,
     /* 403412 */     GIR_EraseRootFromParent_Done,
     /* 403413 */   // Label 7875: @403413
     /* 403413 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(403463), // Rule ID 13385 //
     /* 403418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403448 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403461 */     GIR_RootConstrainSelectedInstOperands,
     /* 403462 */     // GIR_Coverage, 13385,
     /* 403462 */     GIR_EraseRootFromParent_Done,
     /* 403463 */   // Label 7876: @403463
     /* 403463 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(403513), // Rule ID 643 //
     /* 403468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403498 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403511 */     GIR_RootConstrainSelectedInstOperands,
     /* 403512 */     // GIR_Coverage, 643,
     /* 403512 */     GIR_EraseRootFromParent_Done,
     /* 403513 */   // Label 7877: @403513
     /* 403513 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(403563), // Rule ID 655 //
     /* 403518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403548 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 403551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 403561 */     GIR_RootConstrainSelectedInstOperands,
     /* 403562 */     // GIR_Coverage, 655,
     /* 403562 */     GIR_EraseRootFromParent_Done,
     /* 403563 */   // Label 7878: @403563
     /* 403563 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(403594), // Rule ID 637 //
     /* 403568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403583 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 403588 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403592 */     GIR_RootConstrainSelectedInstOperands,
     /* 403593 */     // GIR_Coverage, 637,
     /* 403593 */     GIR_Done,
     /* 403594 */   // Label 7879: @403594
     /* 403594 */   GIM_Reject,
     /* 403595 */ // Label 7851: @403595
     /* 403595 */ GIM_Reject,
     /* 403596 */ // Label 7843: @403596
     /* 403596 */ GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(406525),
     /* 403601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 403604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 403607 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 403610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403614 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(403764), // Rule ID 4906 //
     /* 403619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 403622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403643 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403668 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 403676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403680 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 403684 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403691 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 403691 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 403694 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403698 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403703 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 403709 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403714 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403731 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 403750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 403762 */     GIR_RootConstrainSelectedInstOperands,
     /* 403763 */     // GIR_Coverage, 4906,
     /* 403763 */     GIR_EraseRootFromParent_Done,
     /* 403764 */   // Label 7881: @403764
     /* 403764 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(403911), // Rule ID 4870 //
     /* 403769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 403772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403793 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 403809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 403813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403821 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403825 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403830 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 403834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403840 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 403840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 403843 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403847 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403852 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 403858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403863 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403880 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 403899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403909 */     GIR_RootConstrainSelectedInstOperands,
     /* 403910 */     // GIR_Coverage, 4870,
     /* 403910 */     GIR_EraseRootFromParent_Done,
     /* 403911 */   // Label 7882: @403911
     /* 403911 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(404058), // Rule ID 13949 //
     /* 403916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 403919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 403931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403947 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403952 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403964 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403968 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403972 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403977 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 403981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403985 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403987 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 403987 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 403990 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403994 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403999 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404005 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404010 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404027 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 404046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404056 */     GIR_RootConstrainSelectedInstOperands,
     /* 404057 */     // GIR_Coverage, 13949,
     /* 404057 */     GIR_EraseRootFromParent_Done,
     /* 404058 */   // Label 7883: @404058
     /* 404058 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(404189), // Rule ID 6154 //
     /* 404063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404087 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 404103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 404107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404111 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404115 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404119 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404124 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 404128 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404132 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404136 */     // MIs[4] Operand 1
     /* 404136 */     // No operand predicates
     /* 404136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404140 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 404142 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404154 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 404173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 404184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 404187 */     GIR_RootConstrainSelectedInstOperands,
     /* 404188 */     // GIR_Coverage, 6154,
     /* 404188 */     GIR_EraseRootFromParent_Done,
     /* 404189 */   // Label 7884: @404189
     /* 404189 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(404320), // Rule ID 6186 //
     /* 404194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404226 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404230 */     // MIs[2] Operand 1
     /* 404230 */     // No operand predicates
     /* 404230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404238 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 404242 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 404246 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404250 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404254 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 404258 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404263 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 404267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404271 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 404273 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404285 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 404304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404318 */     GIR_RootConstrainSelectedInstOperands,
     /* 404319 */     // GIR_Coverage, 6186,
     /* 404319 */     GIR_EraseRootFromParent_Done,
     /* 404320 */   // Label 7885: @404320
     /* 404320 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(404451), // Rule ID 6250 //
     /* 404325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 404340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404361 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404373 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404377 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404381 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404386 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 404390 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404394 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404398 */     // MIs[4] Operand 1
     /* 404398 */     // No operand predicates
     /* 404398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404402 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 404404 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404416 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 404435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 404446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 404449 */     GIR_RootConstrainSelectedInstOperands,
     /* 404450 */     // GIR_Coverage, 6250,
     /* 404450 */     GIR_EraseRootFromParent_Done,
     /* 404451 */   // Label 7886: @404451
     /* 404451 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(404582), // Rule ID 6218 //
     /* 404456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 404471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404500 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404504 */     // MIs[3] Operand 1
     /* 404504 */     // No operand predicates
     /* 404504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 404508 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404512 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404516 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 404520 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404525 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 404529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404533 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 404535 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404547 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 404566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404580 */     GIR_RootConstrainSelectedInstOperands,
     /* 404581 */     // GIR_Coverage, 6218,
     /* 404581 */     GIR_EraseRootFromParent_Done,
     /* 404582 */   // Label 7887: @404582
     /* 404582 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(404717), // Rule ID 2461 //
     /* 404587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404611 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404636 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404646 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 404649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404658 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404664 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404669 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404686 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 404705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404715 */     GIR_RootConstrainSelectedInstOperands,
     /* 404716 */     // GIR_Coverage, 2461,
     /* 404716 */     GIR_EraseRootFromParent_Done,
     /* 404717 */   // Label 7888: @404717
     /* 404717 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(404836), // Rule ID 6122 //
     /* 404722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404746 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404779 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404783 */     // MIs[3] Operand 1
     /* 404783 */     // No operand predicates
     /* 404783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404787 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404789 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404801 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 404820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404834 */     GIR_RootConstrainSelectedInstOperands,
     /* 404835 */     // GIR_Coverage, 6122,
     /* 404835 */     GIR_EraseRootFromParent_Done,
     /* 404836 */   // Label 7889: @404836
     /* 404836 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(404955), // Rule ID 2553 //
     /* 404841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404873 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404877 */     // MIs[2] Operand 1
     /* 404877 */     // No operand predicates
     /* 404877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404885 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404889 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404893 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404898 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 404902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404906 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404908 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404920 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 404939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404953 */     GIR_RootConstrainSelectedInstOperands,
     /* 404954 */     // GIR_Coverage, 2553,
     /* 404954 */     GIR_EraseRootFromParent_Done,
     /* 404955 */   // Label 7890: @404955
     /* 404955 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(405055), // Rule ID 4868 //
     /* 404960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404984 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 405000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405011 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405023 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405053 */     GIR_RootConstrainSelectedInstOperands,
     /* 405054 */     // GIR_Coverage, 4868,
     /* 405054 */     GIR_EraseRootFromParent_Done,
     /* 405055 */   // Label 7891: @405055
     /* 405055 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(405155), // Rule ID 4904 //
     /* 405060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405084 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 405096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 405104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405111 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405123 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 405142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 405149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 405153 */     GIR_RootConstrainSelectedInstOperands,
     /* 405154 */     // GIR_Coverage, 4904,
     /* 405154 */     GIR_EraseRootFromParent_Done,
     /* 405155 */   // Label 7892: @405155
     /* 405155 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(405252), // Rule ID 13945 //
     /* 405160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405196 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405210 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 405210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405222 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 405228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405250 */     GIR_RootConstrainSelectedInstOperands,
     /* 405251 */     // GIR_Coverage, 13945,
     /* 405251 */     GIR_EraseRootFromParent_Done,
     /* 405252 */   // Label 7893: @405252
     /* 405252 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(405352), // Rule ID 13947 //
     /* 405257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405298 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405308 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405320 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405350 */     GIR_RootConstrainSelectedInstOperands,
     /* 405351 */     // GIR_Coverage, 13947,
     /* 405351 */     GIR_EraseRootFromParent_Done,
     /* 405352 */   // Label 7894: @405352
     /* 405352 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(405452), // Rule ID 4902 //
     /* 405357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405385 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 405393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 405401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405408 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 405408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405420 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 405426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 405439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 405450 */     GIR_RootConstrainSelectedInstOperands,
     /* 405451 */     // GIR_Coverage, 4902,
     /* 405451 */     GIR_EraseRootFromParent_Done,
     /* 405452 */   // Label 7895: @405452
     /* 405452 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(405549), // Rule ID 4866 //
     /* 405457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405497 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405507 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 405507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405519 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 405525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405547 */     GIR_RootConstrainSelectedInstOperands,
     /* 405548 */     // GIR_Coverage, 4866,
     /* 405548 */     GIR_EraseRootFromParent_Done,
     /* 405549 */   // Label 7896: @405549
     /* 405549 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(405627), // Rule ID 6272 //
     /* 405554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 405591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405595 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405599 */     // MIs[3] Operand 1
     /* 405599 */     // No operand predicates
     /* 405599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405609 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405625 */     GIR_RootConstrainSelectedInstOperands,
     /* 405626 */     // GIR_Coverage, 6272,
     /* 405626 */     GIR_EraseRootFromParent_Done,
     /* 405627 */   // Label 7897: @405627
     /* 405627 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(405711), // Rule ID 6184 //
     /* 405632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405664 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405668 */     // MIs[2] Operand 1
     /* 405668 */     // No operand predicates
     /* 405668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405676 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 405680 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405691 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 405702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405709 */     GIR_RootConstrainSelectedInstOperands,
     /* 405710 */     // GIR_Coverage, 6184,
     /* 405710 */     GIR_EraseRootFromParent_Done,
     /* 405711 */   // Label 7898: @405711
     /* 405711 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(405792), // Rule ID 6216 //
     /* 405716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405760 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405764 */     // MIs[3] Operand 1
     /* 405764 */     // No operand predicates
     /* 405764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405774 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405790 */     GIR_RootConstrainSelectedInstOperands,
     /* 405791 */     // GIR_Coverage, 6216,
     /* 405791 */     GIR_EraseRootFromParent_Done,
     /* 405792 */   // Label 7899: @405792
     /* 405792 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(405876), // Rule ID 6248 //
     /* 405797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405846 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405850 */     // MIs[3] Operand 1
     /* 405850 */     // No operand predicates
     /* 405850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405856 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405874 */     GIR_RootConstrainSelectedInstOperands,
     /* 405875 */     // GIR_Coverage, 6248,
     /* 405875 */     GIR_EraseRootFromParent_Done,
     /* 405876 */   // Label 7900: @405876
     /* 405876 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(405954), // Rule ID 6294 //
     /* 405881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 405922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405926 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405930 */     // MIs[3] Operand 1
     /* 405930 */     // No operand predicates
     /* 405930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405936 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405952 */     GIR_RootConstrainSelectedInstOperands,
     /* 405953 */     // GIR_Coverage, 6294,
     /* 405953 */     GIR_EraseRootFromParent_Done,
     /* 405954 */   // Label 7901: @405954
     /* 405954 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(406035), // Rule ID 6152 //
     /* 405959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405990 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405994 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406007 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406011 */     // MIs[3] Operand 1
     /* 406011 */     // No operand predicates
     /* 406011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406017 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406033 */     GIR_RootConstrainSelectedInstOperands,
     /* 406034 */     // GIR_Coverage, 6152,
     /* 406034 */     GIR_EraseRootFromParent_Done,
     /* 406035 */   // Label 7902: @406035
     /* 406035 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(406120), // Rule ID 2459 //
     /* 406040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406064 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406078 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406090 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 406109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 406116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406118 */     GIR_RootConstrainSelectedInstOperands,
     /* 406119 */     // GIR_Coverage, 2459,
     /* 406119 */     GIR_EraseRootFromParent_Done,
     /* 406120 */   // Label 7903: @406120
     /* 406120 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(406205), // Rule ID 2457 //
     /* 406125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406153 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406163 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 406163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406175 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 406181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 406194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406203 */     GIR_RootConstrainSelectedInstOperands,
     /* 406204 */     // GIR_Coverage, 2457,
     /* 406204 */     GIR_EraseRootFromParent_Done,
     /* 406205 */   // Label 7904: @406205
     /* 406205 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(406274), // Rule ID 2551 //
     /* 406210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 406238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406242 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406246 */     // MIs[2] Operand 1
     /* 406246 */     // No operand predicates
     /* 406246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406256 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 406259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 406272 */     GIR_RootConstrainSelectedInstOperands,
     /* 406273 */     // GIR_Coverage, 2551,
     /* 406273 */     GIR_EraseRootFromParent_Done,
     /* 406274 */   // Label 7905: @406274
     /* 406274 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(406343), // Rule ID 6120 //
     /* 406279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 406311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406315 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406319 */     // MIs[2] Operand 1
     /* 406319 */     // No operand predicates
     /* 406319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406325 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 406328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 406341 */     GIR_RootConstrainSelectedInstOperands,
     /* 406342 */     // GIR_Coverage, 6120,
     /* 406342 */     GIR_EraseRootFromParent_Done,
     /* 406343 */   // Label 7906: @406343
     /* 406343 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(406393), // Rule ID 13387 //
     /* 406348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406378 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 406381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406391 */     GIR_RootConstrainSelectedInstOperands,
     /* 406392 */     // GIR_Coverage, 13387,
     /* 406392 */     GIR_EraseRootFromParent_Done,
     /* 406393 */   // Label 7907: @406393
     /* 406393 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(406443), // Rule ID 645 //
     /* 406398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406428 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 406431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406441 */     GIR_RootConstrainSelectedInstOperands,
     /* 406442 */     // GIR_Coverage, 645,
     /* 406442 */     GIR_EraseRootFromParent_Done,
     /* 406443 */   // Label 7908: @406443
     /* 406443 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(406493), // Rule ID 657 //
     /* 406448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 406463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406478 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 406481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 406487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 406491 */     GIR_RootConstrainSelectedInstOperands,
     /* 406492 */     // GIR_Coverage, 657,
     /* 406492 */     GIR_EraseRootFromParent_Done,
     /* 406493 */   // Label 7909: @406493
     /* 406493 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(406524), // Rule ID 639 //
     /* 406498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406513 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 406518 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406522 */     GIR_RootConstrainSelectedInstOperands,
     /* 406523 */     // GIR_Coverage, 639,
     /* 406523 */     GIR_Done,
     /* 406524 */   // Label 7910: @406524
     /* 406524 */   GIM_Reject,
     /* 406525 */ // Label 7880: @406525
     /* 406525 */ GIM_Reject,
     /* 406526 */ // Label 7844: @406526
     /* 406526 */ GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(409455),
     /* 406531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 406534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 406537 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 406540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406544 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(406694), // Rule ID 4912 //
     /* 406549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406573 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406598 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 406606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406610 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 406614 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406621 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 406621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 406624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406633 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 406639 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406644 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406661 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 406680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 406692 */     GIR_RootConstrainSelectedInstOperands,
     /* 406693 */     // GIR_Coverage, 4912,
     /* 406693 */     GIR_EraseRootFromParent_Done,
     /* 406694 */   // Label 7912: @406694
     /* 406694 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(406841), // Rule ID 4876 //
     /* 406699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406723 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 406739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 406743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406747 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406751 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406755 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406760 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 406764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406770 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 406770 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 406773 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406777 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406782 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 406788 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406793 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406810 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 406829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406839 */     GIR_RootConstrainSelectedInstOperands,
     /* 406840 */     // GIR_Coverage, 4876,
     /* 406840 */     GIR_EraseRootFromParent_Done,
     /* 406841 */   // Label 7913: @406841
     /* 406841 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(406988), // Rule ID 13955 //
     /* 406846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 406861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406882 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406894 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406898 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406902 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406907 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 406911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406917 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 406917 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 406920 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406924 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406929 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 406935 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406940 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406957 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 406976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406986 */     GIR_RootConstrainSelectedInstOperands,
     /* 406987 */     // GIR_Coverage, 13955,
     /* 406987 */     GIR_EraseRootFromParent_Done,
     /* 406988 */   // Label 7914: @406988
     /* 406988 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(407119), // Rule ID 6158 //
     /* 406993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407017 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 407033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 407037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407041 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407045 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 407049 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407054 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 407058 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407062 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407066 */     // MIs[4] Operand 1
     /* 407066 */     // No operand predicates
     /* 407066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407070 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 407072 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407084 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 407103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 407114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 407117 */     GIR_RootConstrainSelectedInstOperands,
     /* 407118 */     // GIR_Coverage, 6158,
     /* 407118 */     GIR_EraseRootFromParent_Done,
     /* 407119 */   // Label 7915: @407119
     /* 407119 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(407250), // Rule ID 6190 //
     /* 407124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 407152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407156 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407160 */     // MIs[2] Operand 1
     /* 407160 */     // No operand predicates
     /* 407160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407168 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 407172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 407176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407180 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407184 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 407188 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407193 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 407197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407201 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 407203 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407215 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 407234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 407248 */     GIR_RootConstrainSelectedInstOperands,
     /* 407249 */     // GIR_Coverage, 6190,
     /* 407249 */     GIR_EraseRootFromParent_Done,
     /* 407250 */   // Label 7916: @407250
     /* 407250 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(407381), // Rule ID 6254 //
     /* 407255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407282 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407291 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407303 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407307 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 407311 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407316 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 407320 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407324 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407328 */     // MIs[4] Operand 1
     /* 407328 */     // No operand predicates
     /* 407328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407332 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 407334 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407346 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 407365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 407376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 407379 */     GIR_RootConstrainSelectedInstOperands,
     /* 407380 */     // GIR_Coverage, 6254,
     /* 407380 */     GIR_EraseRootFromParent_Done,
     /* 407381 */   // Label 7917: @407381
     /* 407381 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(407512), // Rule ID 6222 //
     /* 407386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407426 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407430 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407434 */     // MIs[3] Operand 1
     /* 407434 */     // No operand predicates
     /* 407434 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 407438 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407442 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407446 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 407450 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407455 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 407459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407463 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 407465 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407477 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 407496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407510 */     GIR_RootConstrainSelectedInstOperands,
     /* 407511 */     // GIR_Coverage, 6222,
     /* 407511 */     GIR_EraseRootFromParent_Done,
     /* 407512 */   // Label 7918: @407512
     /* 407512 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(407647), // Rule ID 2467 //
     /* 407517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407541 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407566 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407574 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407576 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407576 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 407579 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407583 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407588 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407594 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407599 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407616 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 407635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 407643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407645 */     GIR_RootConstrainSelectedInstOperands,
     /* 407646 */     // GIR_Coverage, 2467,
     /* 407646 */     GIR_EraseRootFromParent_Done,
     /* 407647 */   // Label 7919: @407647
     /* 407647 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(407766), // Rule ID 6126 //
     /* 407652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407676 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407709 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407713 */     // MIs[3] Operand 1
     /* 407713 */     // No operand predicates
     /* 407713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407719 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407731 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 407750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407764 */     GIR_RootConstrainSelectedInstOperands,
     /* 407765 */     // GIR_Coverage, 6126,
     /* 407765 */     GIR_EraseRootFromParent_Done,
     /* 407766 */   // Label 7920: @407766
     /* 407766 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(407885), // Rule ID 2557 //
     /* 407771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 407799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407803 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407807 */     // MIs[2] Operand 1
     /* 407807 */     // No operand predicates
     /* 407807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407815 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407819 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 407823 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407828 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 407832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407838 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407850 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 407869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 407883 */     GIR_RootConstrainSelectedInstOperands,
     /* 407884 */     // GIR_Coverage, 2557,
     /* 407884 */     GIR_EraseRootFromParent_Done,
     /* 407885 */   // Label 7921: @407885
     /* 407885 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(407985), // Rule ID 4874 //
     /* 407890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407914 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 407930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407941 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 407941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407953 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407983 */     GIR_RootConstrainSelectedInstOperands,
     /* 407984 */     // GIR_Coverage, 4874,
     /* 407984 */     GIR_EraseRootFromParent_Done,
     /* 407985 */   // Label 7922: @407985
     /* 407985 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(408085), // Rule ID 4910 //
     /* 407990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408014 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 408026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 408034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408041 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408053 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 408072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 408079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 408083 */     GIR_RootConstrainSelectedInstOperands,
     /* 408084 */     // GIR_Coverage, 4910,
     /* 408084 */     GIR_EraseRootFromParent_Done,
     /* 408085 */   // Label 7923: @408085
     /* 408085 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(408182), // Rule ID 13951 //
     /* 408090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408126 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 408130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408140 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 408140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408152 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 408158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 408171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408180 */     GIR_RootConstrainSelectedInstOperands,
     /* 408181 */     // GIR_Coverage, 13951,
     /* 408181 */     GIR_EraseRootFromParent_Done,
     /* 408182 */   // Label 7924: @408182
     /* 408182 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(408282), // Rule ID 13953 //
     /* 408187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408228 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 408232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408238 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408250 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 408269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408280 */     GIR_RootConstrainSelectedInstOperands,
     /* 408281 */     // GIR_Coverage, 13953,
     /* 408281 */     GIR_EraseRootFromParent_Done,
     /* 408282 */   // Label 7925: @408282
     /* 408282 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(408382), // Rule ID 4908 //
     /* 408287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408315 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 408323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 408331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408338 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 408338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408350 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 408356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 408369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 408380 */     GIR_RootConstrainSelectedInstOperands,
     /* 408381 */     // GIR_Coverage, 4908,
     /* 408381 */     GIR_EraseRootFromParent_Done,
     /* 408382 */   // Label 7926: @408382
     /* 408382 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(408479), // Rule ID 4872 //
     /* 408387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408427 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 408431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408437 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 408437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408449 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 408455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 408468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408477 */     GIR_RootConstrainSelectedInstOperands,
     /* 408478 */     // GIR_Coverage, 4872,
     /* 408478 */     GIR_EraseRootFromParent_Done,
     /* 408479 */   // Label 7927: @408479
     /* 408479 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(408557), // Rule ID 6276 //
     /* 408484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 408521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408525 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408529 */     // MIs[3] Operand 1
     /* 408529 */     // No operand predicates
     /* 408529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408537 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408539 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408555 */     GIR_RootConstrainSelectedInstOperands,
     /* 408556 */     // GIR_Coverage, 6276,
     /* 408556 */     GIR_EraseRootFromParent_Done,
     /* 408557 */   // Label 7928: @408557
     /* 408557 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(408641), // Rule ID 6188 //
     /* 408562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408594 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408598 */     // MIs[2] Operand 1
     /* 408598 */     // No operand predicates
     /* 408598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408606 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 408610 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408621 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 408632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408639 */     GIR_RootConstrainSelectedInstOperands,
     /* 408640 */     // GIR_Coverage, 6188,
     /* 408640 */     GIR_EraseRootFromParent_Done,
     /* 408641 */   // Label 7929: @408641
     /* 408641 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(408722), // Rule ID 6220 //
     /* 408646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408673 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408690 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408694 */     // MIs[3] Operand 1
     /* 408694 */     // No operand predicates
     /* 408694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408704 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408720 */     GIR_RootConstrainSelectedInstOperands,
     /* 408721 */     // GIR_Coverage, 6220,
     /* 408721 */     GIR_EraseRootFromParent_Done,
     /* 408722 */   // Label 7930: @408722
     /* 408722 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(408806), // Rule ID 6252 //
     /* 408727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408776 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408780 */     // MIs[3] Operand 1
     /* 408780 */     // No operand predicates
     /* 408780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408786 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 408797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408804 */     GIR_RootConstrainSelectedInstOperands,
     /* 408805 */     // GIR_Coverage, 6252,
     /* 408805 */     GIR_EraseRootFromParent_Done,
     /* 408806 */   // Label 7931: @408806
     /* 408806 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(408884), // Rule ID 6298 //
     /* 408811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 408852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408856 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408860 */     // MIs[3] Operand 1
     /* 408860 */     // No operand predicates
     /* 408860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408866 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408882 */     GIR_RootConstrainSelectedInstOperands,
     /* 408883 */     // GIR_Coverage, 6298,
     /* 408883 */     GIR_EraseRootFromParent_Done,
     /* 408884 */   // Label 7932: @408884
     /* 408884 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(408965), // Rule ID 6156 //
     /* 408889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408937 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408941 */     // MIs[3] Operand 1
     /* 408941 */     // No operand predicates
     /* 408941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408947 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408963 */     GIR_RootConstrainSelectedInstOperands,
     /* 408964 */     // GIR_Coverage, 6156,
     /* 408964 */     GIR_EraseRootFromParent_Done,
     /* 408965 */   // Label 7933: @408965
     /* 408965 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(409050), // Rule ID 2465 //
     /* 408970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408994 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 409008 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409020 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 409039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 409046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409048 */     GIR_RootConstrainSelectedInstOperands,
     /* 409049 */     // GIR_Coverage, 2465,
     /* 409049 */     GIR_EraseRootFromParent_Done,
     /* 409050 */   // Label 7934: @409050
     /* 409050 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(409135), // Rule ID 2463 //
     /* 409055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409083 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 409093 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 409093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409105 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 409111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 409124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409133 */     GIR_RootConstrainSelectedInstOperands,
     /* 409134 */     // GIR_Coverage, 2463,
     /* 409134 */     GIR_EraseRootFromParent_Done,
     /* 409135 */   // Label 7935: @409135
     /* 409135 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(409204), // Rule ID 2555 //
     /* 409140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409172 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409176 */     // MIs[2] Operand 1
     /* 409176 */     // No operand predicates
     /* 409176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409186 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 409189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409202 */     GIR_RootConstrainSelectedInstOperands,
     /* 409203 */     // GIR_Coverage, 2555,
     /* 409203 */     GIR_EraseRootFromParent_Done,
     /* 409204 */   // Label 7936: @409204
     /* 409204 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(409273), // Rule ID 6124 //
     /* 409209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409245 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409249 */     // MIs[2] Operand 1
     /* 409249 */     // No operand predicates
     /* 409249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409255 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 409258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409271 */     GIR_RootConstrainSelectedInstOperands,
     /* 409272 */     // GIR_Coverage, 6124,
     /* 409272 */     GIR_EraseRootFromParent_Done,
     /* 409273 */   // Label 7937: @409273
     /* 409273 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(409323), // Rule ID 13389 //
     /* 409278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 409308 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 409311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409321 */     GIR_RootConstrainSelectedInstOperands,
     /* 409322 */     // GIR_Coverage, 13389,
     /* 409322 */     GIR_EraseRootFromParent_Done,
     /* 409323 */   // Label 7938: @409323
     /* 409323 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(409373), // Rule ID 647 //
     /* 409328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 409358 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 409361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409371 */     GIR_RootConstrainSelectedInstOperands,
     /* 409372 */     // GIR_Coverage, 647,
     /* 409372 */     GIR_EraseRootFromParent_Done,
     /* 409373 */   // Label 7939: @409373
     /* 409373 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(409423), // Rule ID 659 //
     /* 409378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 409393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 409408 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 409411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 409417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 409421 */     GIR_RootConstrainSelectedInstOperands,
     /* 409422 */     // GIR_Coverage, 659,
     /* 409422 */     GIR_EraseRootFromParent_Done,
     /* 409423 */   // Label 7940: @409423
     /* 409423 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(409454), // Rule ID 641 //
     /* 409428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409443 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 409448 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 409452 */     GIR_RootConstrainSelectedInstOperands,
     /* 409453 */     // GIR_Coverage, 641,
     /* 409453 */     GIR_Done,
     /* 409454 */   // Label 7941: @409454
     /* 409454 */   GIM_Reject,
     /* 409455 */ // Label 7911: @409455
     /* 409455 */ GIM_Reject,
     /* 409456 */ // Label 7845: @409456
     /* 409456 */ GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(410976),
     /* 409461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 409467 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 409470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409474 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(409552), // Rule ID 6256 //
     /* 409479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 409516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409520 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409524 */     // MIs[3] Operand 1
     /* 409524 */     // No operand predicates
     /* 409524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409534 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409550 */     GIR_RootConstrainSelectedInstOperands,
     /* 409551 */     // GIR_Coverage, 6256,
     /* 409551 */     GIR_EraseRootFromParent_Done,
     /* 409552 */   // Label 7943: @409552
     /* 409552 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(409636), // Rule ID 6172 //
     /* 409557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409593 */     // MIs[2] Operand 1
     /* 409593 */     // No operand predicates
     /* 409593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409601 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409605 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409616 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 409627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409634 */     GIR_RootConstrainSelectedInstOperands,
     /* 409635 */     // GIR_Coverage, 6172,
     /* 409635 */     GIR_EraseRootFromParent_Done,
     /* 409636 */   // Label 7944: @409636
     /* 409636 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(409717), // Rule ID 6204 //
     /* 409641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409685 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409689 */     // MIs[3] Operand 1
     /* 409689 */     // No operand predicates
     /* 409689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409697 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409699 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409715 */     GIR_RootConstrainSelectedInstOperands,
     /* 409716 */     // GIR_Coverage, 6204,
     /* 409716 */     GIR_EraseRootFromParent_Done,
     /* 409717 */   // Label 7945: @409717
     /* 409717 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(409801), // Rule ID 6236 //
     /* 409722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409771 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409775 */     // MIs[3] Operand 1
     /* 409775 */     // No operand predicates
     /* 409775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409781 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 409792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409799 */     GIR_RootConstrainSelectedInstOperands,
     /* 409800 */     // GIR_Coverage, 6236,
     /* 409800 */     GIR_EraseRootFromParent_Done,
     /* 409801 */   // Label 7946: @409801
     /* 409801 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(409879), // Rule ID 6278 //
     /* 409806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 409847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409851 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409855 */     // MIs[3] Operand 1
     /* 409855 */     // No operand predicates
     /* 409855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409859 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409861 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409877 */     GIR_RootConstrainSelectedInstOperands,
     /* 409878 */     // GIR_Coverage, 6278,
     /* 409878 */     GIR_EraseRootFromParent_Done,
     /* 409879 */   // Label 7947: @409879
     /* 409879 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(409960), // Rule ID 6140 //
     /* 409884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409915 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409919 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409932 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409936 */     // MIs[3] Operand 1
     /* 409936 */     // No operand predicates
     /* 409936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409942 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409958 */     GIR_RootConstrainSelectedInstOperands,
     /* 409959 */     // GIR_Coverage, 6140,
     /* 409959 */     GIR_EraseRootFromParent_Done,
     /* 409960 */   // Label 7948: @409960
     /* 409960 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(410029), // Rule ID 2539 //
     /* 409965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409997 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410001 */     // MIs[2] Operand 1
     /* 410001 */     // No operand predicates
     /* 410001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410011 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 410014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410027 */     GIR_RootConstrainSelectedInstOperands,
     /* 410028 */     // GIR_Coverage, 2539,
     /* 410028 */     GIR_EraseRootFromParent_Done,
     /* 410029 */   // Label 7949: @410029
     /* 410029 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(410098), // Rule ID 6108 //
     /* 410034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410074 */     // MIs[2] Operand 1
     /* 410074 */     // No operand predicates
     /* 410074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410080 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 410083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410096 */     GIR_RootConstrainSelectedInstOperands,
     /* 410097 */     // GIR_Coverage, 6108,
     /* 410097 */     GIR_EraseRootFromParent_Done,
     /* 410098 */   // Label 7950: @410098
     /* 410098 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(410191), // Rule ID 6260 //
     /* 410103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 410111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 410115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 410127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410142 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410154 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410157 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410161 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410189 */     GIR_RootConstrainSelectedInstOperands,
     /* 410190 */     // GIR_Coverage, 6260,
     /* 410190 */     GIR_EraseRootFromParent_Done,
     /* 410191 */   // Label 7951: @410191
     /* 410191 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(410290), // Rule ID 6174 //
     /* 410196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 410207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 410211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410239 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410258 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 410282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410288 */     GIR_RootConstrainSelectedInstOperands,
     /* 410289 */     // GIR_Coverage, 6174,
     /* 410289 */     GIR_EraseRootFromParent_Done,
     /* 410290 */   // Label 7952: @410290
     /* 410290 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(410386), // Rule ID 6206 //
     /* 410295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 410318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 410322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410337 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410349 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410352 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410356 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410384 */     GIR_RootConstrainSelectedInstOperands,
     /* 410385 */     // GIR_Coverage, 6206,
     /* 410385 */     GIR_EraseRootFromParent_Done,
     /* 410386 */   // Label 7953: @410386
     /* 410386 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(410485), // Rule ID 6238 //
     /* 410391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 410419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 410423 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410434 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410446 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410449 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410453 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 410477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410483 */     GIR_RootConstrainSelectedInstOperands,
     /* 410484 */     // GIR_Coverage, 6238,
     /* 410484 */     GIR_EraseRootFromParent_Done,
     /* 410485 */   // Label 7954: @410485
     /* 410485 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(410578), // Rule ID 6282 //
     /* 410490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 410502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 410506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 410518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410529 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410541 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410548 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410576 */     GIR_RootConstrainSelectedInstOperands,
     /* 410577 */     // GIR_Coverage, 6282,
     /* 410577 */     GIR_EraseRootFromParent_Done,
     /* 410578 */   // Label 7955: @410578
     /* 410578 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(410674), // Rule ID 6142 //
     /* 410583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 410610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 410614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410623 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410625 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410637 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410644 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410672 */     GIR_RootConstrainSelectedInstOperands,
     /* 410673 */     // GIR_Coverage, 6142,
     /* 410673 */     GIR_EraseRootFromParent_Done,
     /* 410674 */   // Label 7956: @410674
     /* 410674 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(410758), // Rule ID 2541 //
     /* 410679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 410690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 410694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410709 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410721 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410728 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 410744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410756 */     GIR_RootConstrainSelectedInstOperands,
     /* 410757 */     // GIR_Coverage, 2541,
     /* 410757 */     GIR_EraseRootFromParent_Done,
     /* 410758 */   // Label 7957: @410758
     /* 410758 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(410808), // Rule ID 13419 //
     /* 410763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410793 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 410796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410806 */     GIR_RootConstrainSelectedInstOperands,
     /* 410807 */     // GIR_Coverage, 13419,
     /* 410807 */     GIR_EraseRootFromParent_Done,
     /* 410808 */   // Label 7958: @410808
     /* 410808 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(410892), // Rule ID 6110 //
     /* 410813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 410828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 410832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410843 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410855 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410862 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 410878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410890 */     GIR_RootConstrainSelectedInstOperands,
     /* 410891 */     // GIR_Coverage, 6110,
     /* 410891 */     GIR_EraseRootFromParent_Done,
     /* 410892 */   // Label 7959: @410892
     /* 410892 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(410942), // Rule ID 1307 //
     /* 410897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410927 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 410930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410940 */     GIR_RootConstrainSelectedInstOperands,
     /* 410941 */     // GIR_Coverage, 1307,
     /* 410941 */     GIR_EraseRootFromParent_Done,
     /* 410942 */   // Label 7960: @410942
     /* 410942 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(410975), // Rule ID 1297 //
     /* 410947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410962 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 410965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 410973 */     GIR_RootConstrainSelectedInstOperands,
     /* 410974 */     // GIR_Coverage, 1297,
     /* 410974 */     GIR_EraseRootFromParent_Done,
     /* 410975 */   // Label 7961: @410975
     /* 410975 */   GIM_Reject,
     /* 410976 */ // Label 7942: @410976
     /* 410976 */ GIM_Reject,
     /* 410977 */ // Label 7846: @410977
     /* 410977 */ GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(412497),
     /* 410982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 410988 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 410991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410995 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(411073), // Rule ID 6268 //
     /* 411000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 411037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411041 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411045 */     // MIs[3] Operand 1
     /* 411045 */     // No operand predicates
     /* 411045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411055 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411071 */     GIR_RootConstrainSelectedInstOperands,
     /* 411072 */     // GIR_Coverage, 6268,
     /* 411072 */     GIR_EraseRootFromParent_Done,
     /* 411073 */   // Label 7963: @411073
     /* 411073 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(411157), // Rule ID 6180 //
     /* 411078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411110 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411114 */     // MIs[2] Operand 1
     /* 411114 */     // No operand predicates
     /* 411114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 411118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411122 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411126 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411137 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 411148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411155 */     GIR_RootConstrainSelectedInstOperands,
     /* 411156 */     // GIR_Coverage, 6180,
     /* 411156 */     GIR_EraseRootFromParent_Done,
     /* 411157 */   // Label 7964: @411157
     /* 411157 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(411238), // Rule ID 6212 //
     /* 411162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411206 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411210 */     // MIs[3] Operand 1
     /* 411210 */     // No operand predicates
     /* 411210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411220 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411236 */     GIR_RootConstrainSelectedInstOperands,
     /* 411237 */     // GIR_Coverage, 6212,
     /* 411237 */     GIR_EraseRootFromParent_Done,
     /* 411238 */   // Label 7965: @411238
     /* 411238 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(411322), // Rule ID 6244 //
     /* 411243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411292 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411296 */     // MIs[3] Operand 1
     /* 411296 */     // No operand predicates
     /* 411296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411302 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 411313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411320 */     GIR_RootConstrainSelectedInstOperands,
     /* 411321 */     // GIR_Coverage, 6244,
     /* 411321 */     GIR_EraseRootFromParent_Done,
     /* 411322 */   // Label 7966: @411322
     /* 411322 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(411400), // Rule ID 6290 //
     /* 411327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 411368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411372 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411376 */     // MIs[3] Operand 1
     /* 411376 */     // No operand predicates
     /* 411376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411382 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411398 */     GIR_RootConstrainSelectedInstOperands,
     /* 411399 */     // GIR_Coverage, 6290,
     /* 411399 */     GIR_EraseRootFromParent_Done,
     /* 411400 */   // Label 7967: @411400
     /* 411400 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(411481), // Rule ID 6148 //
     /* 411405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411453 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411457 */     // MIs[3] Operand 1
     /* 411457 */     // No operand predicates
     /* 411457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411463 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411479 */     GIR_RootConstrainSelectedInstOperands,
     /* 411480 */     // GIR_Coverage, 6148,
     /* 411480 */     GIR_EraseRootFromParent_Done,
     /* 411481 */   // Label 7968: @411481
     /* 411481 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(411550), // Rule ID 2547 //
     /* 411486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411518 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411522 */     // MIs[2] Operand 1
     /* 411522 */     // No operand predicates
     /* 411522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411532 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 411535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411548 */     GIR_RootConstrainSelectedInstOperands,
     /* 411549 */     // GIR_Coverage, 2547,
     /* 411549 */     GIR_EraseRootFromParent_Done,
     /* 411550 */   // Label 7969: @411550
     /* 411550 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(411619), // Rule ID 6116 //
     /* 411555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411591 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411595 */     // MIs[2] Operand 1
     /* 411595 */     // No operand predicates
     /* 411595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411601 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 411604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411617 */     GIR_RootConstrainSelectedInstOperands,
     /* 411618 */     // GIR_Coverage, 6116,
     /* 411618 */     GIR_EraseRootFromParent_Done,
     /* 411619 */   // Label 7970: @411619
     /* 411619 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(411712), // Rule ID 6270 //
     /* 411624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 411648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411663 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411675 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411682 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411710 */     GIR_RootConstrainSelectedInstOperands,
     /* 411711 */     // GIR_Coverage, 6270,
     /* 411711 */     GIR_EraseRootFromParent_Done,
     /* 411712 */   // Label 7971: @411712
     /* 411712 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(411811), // Rule ID 6182 //
     /* 411717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411760 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411772 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411775 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411779 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 411803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411809 */     GIR_RootConstrainSelectedInstOperands,
     /* 411810 */     // GIR_Coverage, 6182,
     /* 411810 */     GIR_EraseRootFromParent_Done,
     /* 411811 */   // Label 7972: @411811
     /* 411811 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(411907), // Rule ID 6214 //
     /* 411816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 411839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 411843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411858 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411870 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411873 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411877 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411905 */     GIR_RootConstrainSelectedInstOperands,
     /* 411906 */     // GIR_Coverage, 6214,
     /* 411906 */     GIR_EraseRootFromParent_Done,
     /* 411907 */   // Label 7973: @411907
     /* 411907 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(412006), // Rule ID 6246 //
     /* 411912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 411940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 411944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411955 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411967 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411974 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 411998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412004 */     GIR_RootConstrainSelectedInstOperands,
     /* 412005 */     // GIR_Coverage, 6246,
     /* 412005 */     GIR_EraseRootFromParent_Done,
     /* 412006 */   // Label 7974: @412006
     /* 412006 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(412099), // Rule ID 6292 //
     /* 412011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 412027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 412039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412050 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412062 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412065 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412069 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412097 */     GIR_RootConstrainSelectedInstOperands,
     /* 412098 */     // GIR_Coverage, 6292,
     /* 412098 */     GIR_EraseRootFromParent_Done,
     /* 412099 */   // Label 7975: @412099
     /* 412099 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(412195), // Rule ID 6150 //
     /* 412104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 412135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412146 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412158 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412165 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412193 */     GIR_RootConstrainSelectedInstOperands,
     /* 412194 */     // GIR_Coverage, 6150,
     /* 412194 */     GIR_EraseRootFromParent_Done,
     /* 412195 */   // Label 7976: @412195
     /* 412195 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(412279), // Rule ID 2549 //
     /* 412200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 412215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412230 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412242 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412249 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 412265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412277 */     GIR_RootConstrainSelectedInstOperands,
     /* 412278 */     // GIR_Coverage, 2549,
     /* 412278 */     GIR_EraseRootFromParent_Done,
     /* 412279 */   // Label 7977: @412279
     /* 412279 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(412329), // Rule ID 13423 //
     /* 412284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412314 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 412314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 412317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412327 */     GIR_RootConstrainSelectedInstOperands,
     /* 412328 */     // GIR_Coverage, 13423,
     /* 412328 */     GIR_EraseRootFromParent_Done,
     /* 412329 */   // Label 7978: @412329
     /* 412329 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(412413), // Rule ID 6118 //
     /* 412334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 412353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412364 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412376 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412379 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412383 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 412399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412411 */     GIR_RootConstrainSelectedInstOperands,
     /* 412412 */     // GIR_Coverage, 6118,
     /* 412412 */     GIR_EraseRootFromParent_Done,
     /* 412413 */   // Label 7979: @412413
     /* 412413 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(412463), // Rule ID 1311 //
     /* 412418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412448 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 412448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 412451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412455 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412461 */     GIR_RootConstrainSelectedInstOperands,
     /* 412462 */     // GIR_Coverage, 1311,
     /* 412462 */     GIR_EraseRootFromParent_Done,
     /* 412463 */   // Label 7980: @412463
     /* 412463 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(412496), // Rule ID 1301 //
     /* 412468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412483 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 412483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 412486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 412494 */     GIR_RootConstrainSelectedInstOperands,
     /* 412495 */     // GIR_Coverage, 1301,
     /* 412495 */     GIR_EraseRootFromParent_Done,
     /* 412496 */   // Label 7981: @412496
     /* 412496 */   GIM_Reject,
     /* 412497 */ // Label 7962: @412497
     /* 412497 */ GIM_Reject,
     /* 412498 */ // Label 7847: @412498
     /* 412498 */ GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(413676),
     /* 412503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 412509 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 412512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412516 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(412600), // Rule ID 6164 //
     /* 412521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412553 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412557 */     // MIs[2] Operand 1
     /* 412557 */     // No operand predicates
     /* 412557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 412561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412565 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412569 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412578 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412580 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 412591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412598 */     GIR_RootConstrainSelectedInstOperands,
     /* 412599 */     // GIR_Coverage, 6164,
     /* 412599 */     GIR_EraseRootFromParent_Done,
     /* 412600 */   // Label 7983: @412600
     /* 412600 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(412681), // Rule ID 6196 //
     /* 412605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412649 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412653 */     // MIs[3] Operand 1
     /* 412653 */     // No operand predicates
     /* 412653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412663 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412679 */     GIR_RootConstrainSelectedInstOperands,
     /* 412680 */     // GIR_Coverage, 6196,
     /* 412680 */     GIR_EraseRootFromParent_Done,
     /* 412681 */   // Label 7984: @412681
     /* 412681 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(412765), // Rule ID 6228 //
     /* 412686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412735 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412739 */     // MIs[3] Operand 1
     /* 412739 */     // No operand predicates
     /* 412739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412745 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 412756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412763 */     GIR_RootConstrainSelectedInstOperands,
     /* 412764 */     // GIR_Coverage, 6228,
     /* 412764 */     GIR_EraseRootFromParent_Done,
     /* 412765 */   // Label 7985: @412765
     /* 412765 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(412846), // Rule ID 6132 //
     /* 412770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412814 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412818 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412822 */     // MIs[3] Operand 1
     /* 412822 */     // No operand predicates
     /* 412822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412828 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412844 */     GIR_RootConstrainSelectedInstOperands,
     /* 412845 */     // GIR_Coverage, 6132,
     /* 412845 */     GIR_EraseRootFromParent_Done,
     /* 412846 */   // Label 7986: @412846
     /* 412846 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(412915), // Rule ID 2531 //
     /* 412851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412883 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412887 */     // MIs[2] Operand 1
     /* 412887 */     // No operand predicates
     /* 412887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412897 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 412900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412913 */     GIR_RootConstrainSelectedInstOperands,
     /* 412914 */     // GIR_Coverage, 2531,
     /* 412914 */     GIR_EraseRootFromParent_Done,
     /* 412915 */   // Label 7987: @412915
     /* 412915 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(412984), // Rule ID 6100 //
     /* 412920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412956 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412960 */     // MIs[2] Operand 1
     /* 412960 */     // No operand predicates
     /* 412960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412966 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 412969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412982 */     GIR_RootConstrainSelectedInstOperands,
     /* 412983 */     // GIR_Coverage, 6100,
     /* 412983 */     GIR_EraseRootFromParent_Done,
     /* 412984 */   // Label 7988: @412984
     /* 412984 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(413083), // Rule ID 6166 //
     /* 412989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413021 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413032 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 413035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413044 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413047 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413051 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 413054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 413075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413081 */     GIR_RootConstrainSelectedInstOperands,
     /* 413082 */     // GIR_Coverage, 6166,
     /* 413082 */     GIR_EraseRootFromParent_Done,
     /* 413083 */   // Label 7989: @413083
     /* 413083 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(413179), // Rule ID 6198 //
     /* 413088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413130 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 413133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413142 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413149 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 413152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413177 */     GIR_RootConstrainSelectedInstOperands,
     /* 413178 */     // GIR_Coverage, 6198,
     /* 413178 */     GIR_EraseRootFromParent_Done,
     /* 413179 */   // Label 7990: @413179
     /* 413179 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(413278), // Rule ID 6230 //
     /* 413184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413227 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 413230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413239 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413246 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 413249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 413270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413276 */     GIR_RootConstrainSelectedInstOperands,
     /* 413277 */     // GIR_Coverage, 6230,
     /* 413277 */     GIR_EraseRootFromParent_Done,
     /* 413278 */   // Label 7991: @413278
     /* 413278 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(413374), // Rule ID 6134 //
     /* 413283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413325 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 413328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413337 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413340 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413344 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 413347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413372 */     GIR_RootConstrainSelectedInstOperands,
     /* 413373 */     // GIR_Coverage, 6134,
     /* 413373 */     GIR_EraseRootFromParent_Done,
     /* 413374 */   // Label 7992: @413374
     /* 413374 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(413458), // Rule ID 2533 //
     /* 413379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413409 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 413412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413421 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413424 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413428 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 413431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 413444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413456 */     GIR_RootConstrainSelectedInstOperands,
     /* 413457 */     // GIR_Coverage, 2533,
     /* 413457 */     GIR_EraseRootFromParent_Done,
     /* 413458 */   // Label 7993: @413458
     /* 413458 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(413508), // Rule ID 13415 //
     /* 413463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413493 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 413493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 413496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413506 */     GIR_RootConstrainSelectedInstOperands,
     /* 413507 */     // GIR_Coverage, 13415,
     /* 413507 */     GIR_EraseRootFromParent_Done,
     /* 413508 */   // Label 7994: @413508
     /* 413508 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(413592), // Rule ID 6102 //
     /* 413513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413543 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 413546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413555 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413558 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413562 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 413565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 413578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413590 */     GIR_RootConstrainSelectedInstOperands,
     /* 413591 */     // GIR_Coverage, 6102,
     /* 413591 */     GIR_EraseRootFromParent_Done,
     /* 413592 */   // Label 7995: @413592
     /* 413592 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(413642), // Rule ID 1303 //
     /* 413597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413627 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 413627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 413630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413640 */     GIR_RootConstrainSelectedInstOperands,
     /* 413641 */     // GIR_Coverage, 1303,
     /* 413641 */     GIR_EraseRootFromParent_Done,
     /* 413642 */   // Label 7996: @413642
     /* 413642 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(413675), // Rule ID 1293 //
     /* 413647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413662 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 413662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 413665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 413673 */     GIR_RootConstrainSelectedInstOperands,
     /* 413674 */     // GIR_Coverage, 1293,
     /* 413674 */     GIR_EraseRootFromParent_Done,
     /* 413675 */   // Label 7997: @413675
     /* 413675 */   GIM_Reject,
     /* 413676 */ // Label 7982: @413676
     /* 413676 */ GIM_Reject,
     /* 413677 */ // Label 7848: @413677
     /* 413677 */ GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(415197),
     /* 413682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 413688 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 413691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413695 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(413773), // Rule ID 6262 //
     /* 413700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413728 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 413737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413741 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413745 */     // MIs[3] Operand 1
     /* 413745 */     // No operand predicates
     /* 413745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413755 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413771 */     GIR_RootConstrainSelectedInstOperands,
     /* 413772 */     // GIR_Coverage, 6262,
     /* 413772 */     GIR_EraseRootFromParent_Done,
     /* 413773 */   // Label 7999: @413773
     /* 413773 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(413857), // Rule ID 6176 //
     /* 413778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413810 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413814 */     // MIs[2] Operand 1
     /* 413814 */     // No operand predicates
     /* 413814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 413818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413826 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413837 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 413848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413855 */     GIR_RootConstrainSelectedInstOperands,
     /* 413856 */     // GIR_Coverage, 6176,
     /* 413856 */     GIR_EraseRootFromParent_Done,
     /* 413857 */   // Label 8000: @413857
     /* 413857 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(413938), // Rule ID 6208 //
     /* 413862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413906 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413910 */     // MIs[3] Operand 1
     /* 413910 */     // No operand predicates
     /* 413910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413920 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413936 */     GIR_RootConstrainSelectedInstOperands,
     /* 413937 */     // GIR_Coverage, 6208,
     /* 413937 */     GIR_EraseRootFromParent_Done,
     /* 413938 */   // Label 8001: @413938
     /* 413938 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(414022), // Rule ID 6240 //
     /* 413943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413975 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413992 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413996 */     // MIs[3] Operand 1
     /* 413996 */     // No operand predicates
     /* 413996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414002 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 414013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414020 */     GIR_RootConstrainSelectedInstOperands,
     /* 414021 */     // GIR_Coverage, 6240,
     /* 414021 */     GIR_EraseRootFromParent_Done,
     /* 414022 */   // Label 8002: @414022
     /* 414022 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(414100), // Rule ID 6284 //
     /* 414027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 414068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414072 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414076 */     // MIs[3] Operand 1
     /* 414076 */     // No operand predicates
     /* 414076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414082 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414098 */     GIR_RootConstrainSelectedInstOperands,
     /* 414099 */     // GIR_Coverage, 6284,
     /* 414099 */     GIR_EraseRootFromParent_Done,
     /* 414100 */   // Label 8003: @414100
     /* 414100 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(414181), // Rule ID 6144 //
     /* 414105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414153 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414157 */     // MIs[3] Operand 1
     /* 414157 */     // No operand predicates
     /* 414157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414163 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414179 */     GIR_RootConstrainSelectedInstOperands,
     /* 414180 */     // GIR_Coverage, 6144,
     /* 414180 */     GIR_EraseRootFromParent_Done,
     /* 414181 */   // Label 8004: @414181
     /* 414181 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(414250), // Rule ID 2543 //
     /* 414186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414218 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414222 */     // MIs[2] Operand 1
     /* 414222 */     // No operand predicates
     /* 414222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414232 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 414235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414248 */     GIR_RootConstrainSelectedInstOperands,
     /* 414249 */     // GIR_Coverage, 2543,
     /* 414249 */     GIR_EraseRootFromParent_Done,
     /* 414250 */   // Label 8005: @414250
     /* 414250 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(414319), // Rule ID 6112 //
     /* 414255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414291 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414295 */     // MIs[2] Operand 1
     /* 414295 */     // No operand predicates
     /* 414295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414301 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 414304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414317 */     GIR_RootConstrainSelectedInstOperands,
     /* 414318 */     // GIR_Coverage, 6112,
     /* 414318 */     GIR_EraseRootFromParent_Done,
     /* 414319 */   // Label 8006: @414319
     /* 414319 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(414412), // Rule ID 6266 //
     /* 414324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 414336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 414348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414363 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414375 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414382 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414410 */     GIR_RootConstrainSelectedInstOperands,
     /* 414411 */     // GIR_Coverage, 6266,
     /* 414411 */     GIR_EraseRootFromParent_Done,
     /* 414412 */   // Label 8007: @414412
     /* 414412 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(414511), // Rule ID 6178 //
     /* 414417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 414432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414460 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414472 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414475 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414479 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 414503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414509 */     GIR_RootConstrainSelectedInstOperands,
     /* 414510 */     // GIR_Coverage, 6178,
     /* 414510 */     GIR_EraseRootFromParent_Done,
     /* 414511 */   // Label 8008: @414511
     /* 414511 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(414607), // Rule ID 6210 //
     /* 414516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 414543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414558 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414570 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414577 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414605 */     GIR_RootConstrainSelectedInstOperands,
     /* 414606 */     // GIR_Coverage, 6210,
     /* 414606 */     GIR_EraseRootFromParent_Done,
     /* 414607 */   // Label 8009: @414607
     /* 414607 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(414706), // Rule ID 6242 //
     /* 414612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 414644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414655 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414667 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414674 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 414698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414704 */     GIR_RootConstrainSelectedInstOperands,
     /* 414705 */     // GIR_Coverage, 6242,
     /* 414705 */     GIR_EraseRootFromParent_Done,
     /* 414706 */   // Label 8010: @414706
     /* 414706 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(414799), // Rule ID 6288 //
     /* 414711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 414727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 414739 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414750 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414769 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414797 */     GIR_RootConstrainSelectedInstOperands,
     /* 414798 */     // GIR_Coverage, 6288,
     /* 414798 */     GIR_EraseRootFromParent_Done,
     /* 414799 */   // Label 8011: @414799
     /* 414799 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(414895), // Rule ID 6146 //
     /* 414804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 414835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414846 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414858 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414865 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414885 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414893 */     GIR_RootConstrainSelectedInstOperands,
     /* 414894 */     // GIR_Coverage, 6146,
     /* 414894 */     GIR_EraseRootFromParent_Done,
     /* 414895 */   // Label 8012: @414895
     /* 414895 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(414979), // Rule ID 2545 //
     /* 414900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 414915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414930 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414942 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414945 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414949 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414952 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 414965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414977 */     GIR_RootConstrainSelectedInstOperands,
     /* 414978 */     // GIR_Coverage, 2545,
     /* 414978 */     GIR_EraseRootFromParent_Done,
     /* 414979 */   // Label 8013: @414979
     /* 414979 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(415029), // Rule ID 13421 //
     /* 414984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415014 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 415014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 415017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415027 */     GIR_RootConstrainSelectedInstOperands,
     /* 415028 */     // GIR_Coverage, 13421,
     /* 415028 */     GIR_EraseRootFromParent_Done,
     /* 415029 */   // Label 8014: @415029
     /* 415029 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(415113), // Rule ID 6114 //
     /* 415034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 415053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415064 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415083 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 415099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415111 */     GIR_RootConstrainSelectedInstOperands,
     /* 415112 */     // GIR_Coverage, 6114,
     /* 415112 */     GIR_EraseRootFromParent_Done,
     /* 415113 */   // Label 8015: @415113
     /* 415113 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(415163), // Rule ID 1309 //
     /* 415118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415148 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 415148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 415151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415161 */     GIR_RootConstrainSelectedInstOperands,
     /* 415162 */     // GIR_Coverage, 1309,
     /* 415162 */     GIR_EraseRootFromParent_Done,
     /* 415163 */   // Label 8016: @415163
     /* 415163 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(415196), // Rule ID 1299 //
     /* 415168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415183 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 415183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 415186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 415194 */     GIR_RootConstrainSelectedInstOperands,
     /* 415195 */     // GIR_Coverage, 1299,
     /* 415195 */     GIR_EraseRootFromParent_Done,
     /* 415196 */   // Label 8017: @415196
     /* 415196 */   GIM_Reject,
     /* 415197 */ // Label 7998: @415197
     /* 415197 */ GIM_Reject,
     /* 415198 */ // Label 7849: @415198
     /* 415198 */ GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(416376),
     /* 415203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 415209 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 415212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415216 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(415300), // Rule ID 6160 //
     /* 415221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 415249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415253 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415257 */     // MIs[2] Operand 1
     /* 415257 */     // No operand predicates
     /* 415257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 415261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415265 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415269 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415278 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415280 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 415291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415298 */     GIR_RootConstrainSelectedInstOperands,
     /* 415299 */     // GIR_Coverage, 6160,
     /* 415299 */     GIR_EraseRootFromParent_Done,
     /* 415300 */   // Label 8019: @415300
     /* 415300 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(415381), // Rule ID 6192 //
     /* 415305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 415336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415349 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415353 */     // MIs[3] Operand 1
     /* 415353 */     // No operand predicates
     /* 415353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415363 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415379 */     GIR_RootConstrainSelectedInstOperands,
     /* 415380 */     // GIR_Coverage, 6192,
     /* 415380 */     GIR_EraseRootFromParent_Done,
     /* 415381 */   // Label 8020: @415381
     /* 415381 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(415465), // Rule ID 6224 //
     /* 415386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 415422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415435 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415439 */     // MIs[3] Operand 1
     /* 415439 */     // No operand predicates
     /* 415439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415445 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 415456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415463 */     GIR_RootConstrainSelectedInstOperands,
     /* 415464 */     // GIR_Coverage, 6224,
     /* 415464 */     GIR_EraseRootFromParent_Done,
     /* 415465 */   // Label 8021: @415465
     /* 415465 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(415546), // Rule ID 6128 //
     /* 415470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 415505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415518 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415522 */     // MIs[3] Operand 1
     /* 415522 */     // No operand predicates
     /* 415522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415528 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415544 */     GIR_RootConstrainSelectedInstOperands,
     /* 415545 */     // GIR_Coverage, 6128,
     /* 415545 */     GIR_EraseRootFromParent_Done,
     /* 415546 */   // Label 8022: @415546
     /* 415546 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(415615), // Rule ID 2527 //
     /* 415551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 415579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415583 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415587 */     // MIs[2] Operand 1
     /* 415587 */     // No operand predicates
     /* 415587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415597 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 415600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415613 */     GIR_RootConstrainSelectedInstOperands,
     /* 415614 */     // GIR_Coverage, 2527,
     /* 415614 */     GIR_EraseRootFromParent_Done,
     /* 415615 */   // Label 8023: @415615
     /* 415615 */   GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(415684), // Rule ID 6096 //
     /* 415620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 415652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415656 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415660 */     // MIs[2] Operand 1
     /* 415660 */     // No operand predicates
     /* 415660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415666 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 415669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415682 */     GIR_RootConstrainSelectedInstOperands,
     /* 415683 */     // GIR_Coverage, 6096,
     /* 415683 */     GIR_EraseRootFromParent_Done,
     /* 415684 */   // Label 8024: @415684
     /* 415684 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(415783), // Rule ID 6162 //
     /* 415689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415721 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415732 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415744 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 415775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415781 */     GIR_RootConstrainSelectedInstOperands,
     /* 415782 */     // GIR_Coverage, 6162,
     /* 415782 */     GIR_EraseRootFromParent_Done,
     /* 415783 */   // Label 8025: @415783
     /* 415783 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(415879), // Rule ID 6194 //
     /* 415788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415830 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415842 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415849 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415877 */     GIR_RootConstrainSelectedInstOperands,
     /* 415878 */     // GIR_Coverage, 6194,
     /* 415878 */     GIR_EraseRootFromParent_Done,
     /* 415879 */   // Label 8026: @415879
     /* 415879 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(415978), // Rule ID 6226 //
     /* 415884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415927 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415939 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415942 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415946 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 415970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415976 */     GIR_RootConstrainSelectedInstOperands,
     /* 415977 */     // GIR_Coverage, 6226,
     /* 415977 */     GIR_EraseRootFromParent_Done,
     /* 415978 */   // Label 8027: @415978
     /* 415978 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(416074), // Rule ID 6130 //
     /* 415983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 416010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416014 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416025 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416037 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416044 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416072 */     GIR_RootConstrainSelectedInstOperands,
     /* 416073 */     // GIR_Coverage, 6130,
     /* 416073 */     GIR_EraseRootFromParent_Done,
     /* 416074 */   // Label 8028: @416074
     /* 416074 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(416158), // Rule ID 2529 //
     /* 416079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 416090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416109 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416121 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416128 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 416144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416156 */     GIR_RootConstrainSelectedInstOperands,
     /* 416157 */     // GIR_Coverage, 2529,
     /* 416157 */     GIR_EraseRootFromParent_Done,
     /* 416158 */   // Label 8029: @416158
     /* 416158 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(416208), // Rule ID 13417 //
     /* 416163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416193 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 416193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 416196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416206 */     GIR_RootConstrainSelectedInstOperands,
     /* 416207 */     // GIR_Coverage, 13417,
     /* 416207 */     GIR_EraseRootFromParent_Done,
     /* 416208 */   // Label 8030: @416208
     /* 416208 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(416292), // Rule ID 6098 //
     /* 416213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 416228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416243 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416255 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416262 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 416278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416290 */     GIR_RootConstrainSelectedInstOperands,
     /* 416291 */     // GIR_Coverage, 6098,
     /* 416291 */     GIR_EraseRootFromParent_Done,
     /* 416292 */   // Label 8031: @416292
     /* 416292 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(416342), // Rule ID 1305 //
     /* 416297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416327 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 416327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 416330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416340 */     GIR_RootConstrainSelectedInstOperands,
     /* 416341 */     // GIR_Coverage, 1305,
     /* 416341 */     GIR_EraseRootFromParent_Done,
     /* 416342 */   // Label 8032: @416342
     /* 416342 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(416375), // Rule ID 1295 //
     /* 416347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416362 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 416362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 416365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 416373 */     GIR_RootConstrainSelectedInstOperands,
     /* 416374 */     // GIR_Coverage, 1295,
     /* 416374 */     GIR_EraseRootFromParent_Done,
     /* 416375 */   // Label 8033: @416375
     /* 416375 */   GIM_Reject,
     /* 416376 */ // Label 8018: @416376
     /* 416376 */ GIM_Reject,
     /* 416377 */ // Label 7850: @416377
     /* 416377 */ GIM_Reject,
     /* 416378 */ // Label 108: @416378
     /* 416378 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 8042*/ GIMT_Encode4(416677),
     /* 416389 */ /*GILLT_s16*//*Label 8034*/ GIMT_Encode4(416429),
     /* 416393 */ /*GILLT_s32*//*Label 8035*/ GIMT_Encode4(416460),
     /* 416397 */ /*GILLT_s64*//*Label 8036*/ GIMT_Encode4(416491), GIMT_Encode4(0),
     /* 416405 */ /*GILLT_v2s32*//*Label 8037*/ GIMT_Encode4(416522),
     /* 416409 */ /*GILLT_v2s64*//*Label 8038*/ GIMT_Encode4(416553),
     /* 416413 */ /*GILLT_v4s16*//*Label 8039*/ GIMT_Encode4(416584),
     /* 416417 */ /*GILLT_v4s32*//*Label 8040*/ GIMT_Encode4(416615), GIMT_Encode4(0),
     /* 416425 */ /*GILLT_v8s16*//*Label 8041*/ GIMT_Encode4(416646),
     /* 416429 */ // Label 8034: @416429
     /* 416429 */ GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(416459), // Rule ID 569 //
     /* 416434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 416437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 416440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416448 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 416448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 416453 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416457 */   GIR_RootConstrainSelectedInstOperands,
     /* 416458 */   // GIR_Coverage, 569,
     /* 416458 */   GIR_Done,
     /* 416459 */ // Label 8043: @416459
     /* 416459 */ GIM_Reject,
     /* 416460 */ // Label 8035: @416460
     /* 416460 */ GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(416490), // Rule ID 571 //
     /* 416465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 416468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 416471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416479 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 416479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 416484 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416488 */   GIR_RootConstrainSelectedInstOperands,
     /* 416489 */   // GIR_Coverage, 571,
     /* 416489 */   GIR_Done,
     /* 416490 */ // Label 8044: @416490
     /* 416490 */ GIM_Reject,
     /* 416491 */ // Label 8036: @416491
     /* 416491 */ GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(416521), // Rule ID 573 //
     /* 416496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 416499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 416502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416510 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 416510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 416515 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416519 */   GIR_RootConstrainSelectedInstOperands,
     /* 416520 */   // GIR_Coverage, 573,
     /* 416520 */   GIR_Done,
     /* 416521 */ // Label 8045: @416521
     /* 416521 */ GIM_Reject,
     /* 416522 */ // Label 8037: @416522
     /* 416522 */ GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(416552), // Rule ID 959 //
     /* 416527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416541 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 416541 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 416546 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416550 */   GIR_RootConstrainSelectedInstOperands,
     /* 416551 */   // GIR_Coverage, 959,
     /* 416551 */   GIR_Done,
     /* 416552 */ // Label 8046: @416552
     /* 416552 */ GIM_Reject,
     /* 416553 */ // Label 8038: @416553
     /* 416553 */ GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(416583), // Rule ID 963 //
     /* 416558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 416564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416572 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 416572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 416577 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416581 */   GIR_RootConstrainSelectedInstOperands,
     /* 416582 */   // GIR_Coverage, 963,
     /* 416582 */   GIR_Done,
     /* 416583 */ // Label 8047: @416583
     /* 416583 */ GIM_Reject,
     /* 416584 */ // Label 8039: @416584
     /* 416584 */ GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(416614), // Rule ID 955 //
     /* 416589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416603 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 416603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 416608 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416612 */   GIR_RootConstrainSelectedInstOperands,
     /* 416613 */   // GIR_Coverage, 955,
     /* 416613 */   GIR_Done,
     /* 416614 */ // Label 8048: @416614
     /* 416614 */ GIM_Reject,
     /* 416615 */ // Label 8040: @416615
     /* 416615 */ GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(416645), // Rule ID 961 //
     /* 416620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416634 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 416634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 416639 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416643 */   GIR_RootConstrainSelectedInstOperands,
     /* 416644 */   // GIR_Coverage, 961,
     /* 416644 */   GIR_Done,
     /* 416645 */ // Label 8049: @416645
     /* 416645 */ GIM_Reject,
     /* 416646 */ // Label 8041: @416646
     /* 416646 */ GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(416676), // Rule ID 957 //
     /* 416651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416665 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 416665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 416670 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416674 */   GIR_RootConstrainSelectedInstOperands,
     /* 416675 */   // GIR_Coverage, 957,
     /* 416675 */   GIR_Done,
     /* 416676 */ // Label 8050: @416676
     /* 416676 */ GIM_Reject,
     /* 416677 */ // Label 8042: @416677
     /* 416677 */ GIM_Reject,
     /* 416678 */ // Label 109: @416678
     /* 416678 */ GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(416691), // Rule ID 6577 //
     /* 416683 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 416683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 416686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 416689 */   GIR_RootConstrainSelectedInstOperands,
     /* 416690 */   // GIR_Coverage, 6577,
     /* 416690 */   GIR_EraseRootFromParent_Done,
     /* 416691 */ // Label 8051: @416691
     /* 416691 */ GIM_Reject,
     /* 416692 */ // Label 110: @416692
     /* 416692 */ GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(416712), // Rule ID 6578 //
     /* 416697 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 416697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 416700 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 416710 */   GIR_RootConstrainSelectedInstOperands,
     /* 416711 */   // GIR_Coverage, 6578,
     /* 416711 */   GIR_EraseRootFromParent_Done,
     /* 416712 */ // Label 8052: @416712
     /* 416712 */ GIM_Reject,
     /* 416713 */ // Label 111: @416713
     /* 416713 */ GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(416737), // Rule ID 6579 //
     /* 416718 */   // MIs[0] kind
     /* 416718 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 416721 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 416726 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 416726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 416729 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 416735 */   GIR_RootConstrainSelectedInstOperands,
     /* 416736 */   // GIR_Coverage, 6579,
     /* 416736 */   GIR_EraseRootFromParent_Done,
     /* 416737 */ // Label 8053: @416737
     /* 416737 */ GIM_Reject,
     /* 416738 */ // Label 112: @416738
     /* 416738 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8057*/ GIMT_Encode4(417047),
     /* 416749 */ /*GILLT_s16*//*Label 8054*/ GIMT_Encode4(416761),
     /* 416753 */ /*GILLT_s32*//*Label 8055*/ GIMT_Encode4(416914),
     /* 416757 */ /*GILLT_s64*//*Label 8056*/ GIMT_Encode4(417019),
     /* 416761 */ // Label 8054: @416761
     /* 416761 */ GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(416862), // Rule ID 5642 //
     /* 416766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 416769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416780 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 416780 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 416783 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 416787 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416792 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416796 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 416802 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 416805 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 416809 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416814 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 416817 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 416823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 416826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 416830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416835 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 416842 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416847 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 416855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416857 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416860 */   GIR_RootConstrainSelectedInstOperands,
     /* 416861 */   // GIR_Coverage, 5642,
     /* 416861 */   GIR_EraseRootFromParent_Done,
     /* 416862 */ // Label 8058: @416862
     /* 416862 */ GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(416913), // Rule ID 5643 //
     /* 416867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 416870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416881 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 416881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 416884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 416888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416893 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416897 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 416903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 416906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416908 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416911 */   GIR_RootConstrainSelectedInstOperands,
     /* 416912 */   // GIR_Coverage, 5643,
     /* 416912 */   GIR_EraseRootFromParent_Done,
     /* 416913 */ // Label 8059: @416913
     /* 416913 */ GIM_Reject,
     /* 416914 */ // Label 8055: @416914
     /* 416914 */ GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(416991), // Rule ID 5644 //
     /* 416919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416930 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 416930 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 416933 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 416937 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416942 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416946 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 416952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 416955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 416959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416964 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 416971 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416976 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 416984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416989 */   GIR_RootConstrainSelectedInstOperands,
     /* 416990 */   // GIR_Coverage, 5644,
     /* 416990 */   GIR_EraseRootFromParent_Done,
     /* 416991 */ // Label 8060: @416991
     /* 416991 */ GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(417018), // Rule ID 5645 //
     /* 416996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417007 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 417007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 417012 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417016 */   GIR_RootConstrainSelectedInstOperands,
     /* 417017 */   // GIR_Coverage, 5645,
     /* 417017 */   GIR_Done,
     /* 417018 */ // Label 8061: @417018
     /* 417018 */ GIM_Reject,
     /* 417019 */ // Label 8056: @417019
     /* 417019 */ GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(417046), // Rule ID 5646 //
     /* 417024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417035 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 417040 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417044 */   GIR_RootConstrainSelectedInstOperands,
     /* 417045 */   // GIR_Coverage, 5646,
     /* 417045 */   GIR_Done,
     /* 417046 */ // Label 8062: @417046
     /* 417046 */ GIM_Reject,
     /* 417047 */ // Label 8057: @417047
     /* 417047 */ GIM_Reject,
     /* 417048 */ // Label 113: @417048
     /* 417048 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8066*/ GIMT_Encode4(417218),
     /* 417059 */ /*GILLT_s16*//*Label 8063*/ GIMT_Encode4(417071),
     /* 417063 */ /*GILLT_s32*//*Label 8064*/ GIMT_Encode4(417132),
     /* 417067 */ /*GILLT_s64*//*Label 8065*/ GIMT_Encode4(417190),
     /* 417071 */ // Label 8063: @417071
     /* 417071 */ GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(417101), // Rule ID 1942 //
     /* 417076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417090 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 417090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 417095 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417099 */   GIR_RootConstrainSelectedInstOperands,
     /* 417100 */   // GIR_Coverage, 1942,
     /* 417100 */   GIR_Done,
     /* 417101 */ // Label 8067: @417101
     /* 417101 */ GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(417131), // Rule ID 1944 //
     /* 417106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417120 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 417120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 417125 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417129 */   GIR_RootConstrainSelectedInstOperands,
     /* 417130 */   // GIR_Coverage, 1944,
     /* 417130 */   GIR_Done,
     /* 417131 */ // Label 8068: @417131
     /* 417131 */ GIM_Reject,
     /* 417132 */ // Label 8064: @417132
     /* 417132 */ GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(417162), // Rule ID 1946 //
     /* 417137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417151 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 417151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 417156 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417160 */   GIR_RootConstrainSelectedInstOperands,
     /* 417161 */   // GIR_Coverage, 1946,
     /* 417161 */   GIR_Done,
     /* 417162 */ // Label 8069: @417162
     /* 417162 */ GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(417189), // Rule ID 5652 //
     /* 417167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417178 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 417178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 417183 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417187 */   GIR_RootConstrainSelectedInstOperands,
     /* 417188 */   // GIR_Coverage, 5652,
     /* 417188 */   GIR_Done,
     /* 417189 */ // Label 8070: @417189
     /* 417189 */ GIM_Reject,
     /* 417190 */ // Label 8065: @417190
     /* 417190 */ GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(417217), // Rule ID 5654 //
     /* 417195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417206 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 417211 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417215 */   GIR_RootConstrainSelectedInstOperands,
     /* 417216 */   // GIR_Coverage, 5654,
     /* 417216 */   GIR_Done,
     /* 417217 */ // Label 8071: @417217
     /* 417217 */ GIM_Reject,
     /* 417218 */ // Label 8066: @417218
     /* 417218 */ GIM_Reject,
     /* 417219 */ // Label 114: @417219
     /* 417219 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8075*/ GIMT_Encode4(417389),
     /* 417230 */ /*GILLT_s16*//*Label 8072*/ GIMT_Encode4(417242),
     /* 417234 */ /*GILLT_s32*//*Label 8073*/ GIMT_Encode4(417303),
     /* 417238 */ /*GILLT_s64*//*Label 8074*/ GIMT_Encode4(417361),
     /* 417242 */ // Label 8072: @417242
     /* 417242 */ GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(417272), // Rule ID 1954 //
     /* 417247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417261 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 417261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 417266 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417270 */   GIR_RootConstrainSelectedInstOperands,
     /* 417271 */   // GIR_Coverage, 1954,
     /* 417271 */   GIR_Done,
     /* 417272 */ // Label 8076: @417272
     /* 417272 */ GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(417302), // Rule ID 1956 //
     /* 417277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417291 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 417291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 417296 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417300 */   GIR_RootConstrainSelectedInstOperands,
     /* 417301 */   // GIR_Coverage, 1956,
     /* 417301 */   GIR_Done,
     /* 417302 */ // Label 8077: @417302
     /* 417302 */ GIM_Reject,
     /* 417303 */ // Label 8073: @417303
     /* 417303 */ GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(417333), // Rule ID 1958 //
     /* 417308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417322 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 417322 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 417327 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417331 */   GIR_RootConstrainSelectedInstOperands,
     /* 417332 */   // GIR_Coverage, 1958,
     /* 417332 */   GIR_Done,
     /* 417333 */ // Label 8078: @417333
     /* 417333 */ GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(417360), // Rule ID 5660 //
     /* 417338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417349 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 417349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 417354 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417358 */   GIR_RootConstrainSelectedInstOperands,
     /* 417359 */   // GIR_Coverage, 5660,
     /* 417359 */   GIR_Done,
     /* 417360 */ // Label 8079: @417360
     /* 417360 */ GIM_Reject,
     /* 417361 */ // Label 8074: @417361
     /* 417361 */ GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(417388), // Rule ID 5662 //
     /* 417366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417377 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417377 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 417382 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417386 */   GIR_RootConstrainSelectedInstOperands,
     /* 417387 */   // GIR_Coverage, 5662,
     /* 417387 */   GIR_Done,
     /* 417388 */ // Label 8080: @417388
     /* 417388 */ GIM_Reject,
     /* 417389 */ // Label 8075: @417389
     /* 417389 */ GIM_Reject,
     /* 417390 */ // Label 115: @417390
     /* 417390 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8084*/ GIMT_Encode4(417560),
     /* 417401 */ /*GILLT_s16*//*Label 8081*/ GIMT_Encode4(417413),
     /* 417405 */ /*GILLT_s32*//*Label 8082*/ GIMT_Encode4(417474),
     /* 417409 */ /*GILLT_s64*//*Label 8083*/ GIMT_Encode4(417532),
     /* 417413 */ // Label 8081: @417413
     /* 417413 */ GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(417443), // Rule ID 1948 //
     /* 417418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417432 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 417432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 417437 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417441 */   GIR_RootConstrainSelectedInstOperands,
     /* 417442 */   // GIR_Coverage, 1948,
     /* 417442 */   GIR_Done,
     /* 417443 */ // Label 8085: @417443
     /* 417443 */ GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(417473), // Rule ID 1950 //
     /* 417448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417462 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 417462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 417467 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417471 */   GIR_RootConstrainSelectedInstOperands,
     /* 417472 */   // GIR_Coverage, 1950,
     /* 417472 */   GIR_Done,
     /* 417473 */ // Label 8086: @417473
     /* 417473 */ GIM_Reject,
     /* 417474 */ // Label 8082: @417474
     /* 417474 */ GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(417504), // Rule ID 1952 //
     /* 417479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417493 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 417493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 417498 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417502 */   GIR_RootConstrainSelectedInstOperands,
     /* 417503 */   // GIR_Coverage, 1952,
     /* 417503 */   GIR_Done,
     /* 417504 */ // Label 8087: @417504
     /* 417504 */ GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(417531), // Rule ID 5656 //
     /* 417509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417520 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 417520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 417525 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417529 */   GIR_RootConstrainSelectedInstOperands,
     /* 417530 */   // GIR_Coverage, 5656,
     /* 417530 */   GIR_Done,
     /* 417531 */ // Label 8088: @417531
     /* 417531 */ GIM_Reject,
     /* 417532 */ // Label 8083: @417532
     /* 417532 */ GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(417559), // Rule ID 5658 //
     /* 417537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417548 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 417553 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417557 */   GIR_RootConstrainSelectedInstOperands,
     /* 417558 */   // GIR_Coverage, 5658,
     /* 417558 */   GIR_Done,
     /* 417559 */ // Label 8089: @417559
     /* 417559 */ GIM_Reject,
     /* 417560 */ // Label 8084: @417560
     /* 417560 */ GIM_Reject,
     /* 417561 */ // Label 116: @417561
     /* 417561 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8093*/ GIMT_Encode4(417731),
     /* 417572 */ /*GILLT_s16*//*Label 8090*/ GIMT_Encode4(417584),
     /* 417576 */ /*GILLT_s32*//*Label 8091*/ GIMT_Encode4(417645),
     /* 417580 */ /*GILLT_s64*//*Label 8092*/ GIMT_Encode4(417703),
     /* 417584 */ // Label 8090: @417584
     /* 417584 */ GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(417614), // Rule ID 1960 //
     /* 417589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417603 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 417603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 417608 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417612 */   GIR_RootConstrainSelectedInstOperands,
     /* 417613 */   // GIR_Coverage, 1960,
     /* 417613 */   GIR_Done,
     /* 417614 */ // Label 8094: @417614
     /* 417614 */ GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(417644), // Rule ID 1962 //
     /* 417619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417633 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 417633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 417638 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417642 */   GIR_RootConstrainSelectedInstOperands,
     /* 417643 */   // GIR_Coverage, 1962,
     /* 417643 */   GIR_Done,
     /* 417644 */ // Label 8095: @417644
     /* 417644 */ GIM_Reject,
     /* 417645 */ // Label 8091: @417645
     /* 417645 */ GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(417675), // Rule ID 1964 //
     /* 417650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417664 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 417664 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 417669 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417673 */   GIR_RootConstrainSelectedInstOperands,
     /* 417674 */   // GIR_Coverage, 1964,
     /* 417674 */   GIR_Done,
     /* 417675 */ // Label 8096: @417675
     /* 417675 */ GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(417702), // Rule ID 5664 //
     /* 417680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417691 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 417691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 417696 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417700 */   GIR_RootConstrainSelectedInstOperands,
     /* 417701 */   // GIR_Coverage, 5664,
     /* 417701 */   GIR_Done,
     /* 417702 */ // Label 8097: @417702
     /* 417702 */ GIM_Reject,
     /* 417703 */ // Label 8092: @417703
     /* 417703 */ GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(417730), // Rule ID 5666 //
     /* 417708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417719 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 417724 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417728 */   GIR_RootConstrainSelectedInstOperands,
     /* 417729 */   // GIR_Coverage, 5666,
     /* 417729 */   GIR_Done,
     /* 417730 */ // Label 8098: @417730
     /* 417730 */ GIM_Reject,
     /* 417731 */ // Label 8093: @417731
     /* 417731 */ GIM_Reject,
     /* 417732 */ // Label 117: @417732
     /* 417732 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 8103*/ GIMT_Encode4(418860),
     /* 417743 */ /*GILLT_s8*//*Label 8099*/ GIMT_Encode4(417759),
     /* 417747 */ /*GILLT_s16*//*Label 8100*/ GIMT_Encode4(417806),
     /* 417751 */ /*GILLT_s32*//*Label 8101*/ GIMT_Encode4(418221),
     /* 417755 */ /*GILLT_s64*//*Label 8102*/ GIMT_Encode4(418674),
     /* 417759 */ // Label 8099: @417759
     /* 417759 */ GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(417782), // Rule ID 5949 //
     /* 417764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 417767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 417771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417775 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 417775 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 417780 */   GIR_RootConstrainSelectedInstOperands,
     /* 417781 */   // GIR_Coverage, 5949,
     /* 417781 */   GIR_Done,
     /* 417782 */ // Label 8104: @417782
     /* 417782 */ GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(417805), // Rule ID 5950 //
     /* 417787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 417790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 417794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417798 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 417798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 417803 */   GIR_RootConstrainSelectedInstOperands,
     /* 417804 */   // GIR_Coverage, 5950,
     /* 417804 */   GIR_Done,
     /* 417805 */ // Label 8105: @417805
     /* 417805 */ GIM_Reject,
     /* 417806 */ // Label 8100: @417806
     /* 417806 */ GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(417856), // Rule ID 5896 //
     /* 417811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417818 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417822 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417826 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417829 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 417834 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 417838 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417843 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417845 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 726:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 417845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 417848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417850 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417854 */   GIR_RootConstrainSelectedInstOperands,
     /* 417855 */   // GIR_Coverage, 5896,
     /* 417855 */   GIR_EraseRootFromParent_Done,
     /* 417856 */ // Label 8106: @417856
     /* 417856 */ GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(417906), // Rule ID 5898 //
     /* 417861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417868 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417876 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417879 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 417884 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 417888 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417893 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417895 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 726:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 417895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 417898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417900 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417904 */   GIR_RootConstrainSelectedInstOperands,
     /* 417905 */   // GIR_Coverage, 5898,
     /* 417905 */   GIR_EraseRootFromParent_Done,
     /* 417906 */ // Label 8107: @417906
     /* 417906 */ GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(417956), // Rule ID 5906 //
     /* 417911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417918 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417922 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417926 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417929 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 417934 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 417938 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417945 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 661:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 417945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 417948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417950 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417954 */   GIR_RootConstrainSelectedInstOperands,
     /* 417955 */   // GIR_Coverage, 5906,
     /* 417955 */   GIR_EraseRootFromParent_Done,
     /* 417956 */ // Label 8108: @417956
     /* 417956 */ GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(418006), // Rule ID 5908 //
     /* 417961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417976 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417979 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 417984 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 417988 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417993 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417995 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 661:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 417995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 417998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418000 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418004 */   GIR_RootConstrainSelectedInstOperands,
     /* 418005 */   // GIR_Coverage, 5908,
     /* 418005 */   GIR_EraseRootFromParent_Done,
     /* 418006 */ // Label 8109: @418006
     /* 418006 */ GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(418048), // Rule ID 5905 //
     /* 418011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418018 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418022 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 418026 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418030 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418035 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418037 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 418037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 418040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418042 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418046 */   GIR_RootConstrainSelectedInstOperands,
     /* 418047 */   // GIR_Coverage, 5905,
     /* 418047 */   GIR_EraseRootFromParent_Done,
     /* 418048 */ // Label 8110: @418048
     /* 418048 */ GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(418090), // Rule ID 5907 //
     /* 418053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418060 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418064 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 418068 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418072 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418077 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418079 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 418079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 418082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418084 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418088 */   GIR_RootConstrainSelectedInstOperands,
     /* 418089 */   // GIR_Coverage, 5907,
     /* 418089 */   GIR_EraseRootFromParent_Done,
     /* 418090 */ // Label 8111: @418090
     /* 418090 */ GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(418132), // Rule ID 5895 //
     /* 418095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418102 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418106 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 418110 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418114 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418119 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418121 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 418121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 418124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418126 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418130 */   GIR_RootConstrainSelectedInstOperands,
     /* 418131 */   // GIR_Coverage, 5895,
     /* 418131 */   GIR_EraseRootFromParent_Done,
     /* 418132 */ // Label 8112: @418132
     /* 418132 */ GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(418174), // Rule ID 5897 //
     /* 418137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418144 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418148 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 418152 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418156 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418161 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418163 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 418163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 418166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418168 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418172 */   GIR_RootConstrainSelectedInstOperands,
     /* 418173 */   // GIR_Coverage, 5897,
     /* 418173 */   GIR_EraseRootFromParent_Done,
     /* 418174 */ // Label 8113: @418174
     /* 418174 */ GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(418197), // Rule ID 5951 //
     /* 418179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418190 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 418190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 418195 */   GIR_RootConstrainSelectedInstOperands,
     /* 418196 */   // GIR_Coverage, 5951,
     /* 418196 */   GIR_Done,
     /* 418197 */ // Label 8114: @418197
     /* 418197 */ GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(418220), // Rule ID 5952 //
     /* 418202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418213 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 418213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 418218 */   GIR_RootConstrainSelectedInstOperands,
     /* 418219 */   // GIR_Coverage, 5952,
     /* 418219 */   GIR_Done,
     /* 418220 */ // Label 8115: @418220
     /* 418220 */ GIM_Reject,
     /* 418221 */ // Label 8101: @418221
     /* 418221 */ GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(418271), // Rule ID 5900 //
     /* 418226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418233 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418237 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418241 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418244 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 418249 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 418253 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418258 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418260 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 726:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 418260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 418263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418265 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418269 */   GIR_RootConstrainSelectedInstOperands,
     /* 418270 */   // GIR_Coverage, 5900,
     /* 418270 */   GIR_EraseRootFromParent_Done,
     /* 418271 */ // Label 8116: @418271
     /* 418271 */ GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(418321), // Rule ID 5902 //
     /* 418276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418283 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418287 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418291 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418294 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 418299 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 418303 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418308 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418310 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 726:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 418310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 418313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418315 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418319 */   GIR_RootConstrainSelectedInstOperands,
     /* 418320 */   // GIR_Coverage, 5902,
     /* 418320 */   GIR_EraseRootFromParent_Done,
     /* 418321 */ // Label 8117: @418321
     /* 418321 */ GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(418371), // Rule ID 5910 //
     /* 418326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418333 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418337 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418341 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418344 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 418349 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 418353 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418358 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418360 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 661:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 418360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 418363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418365 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418369 */   GIR_RootConstrainSelectedInstOperands,
     /* 418370 */   // GIR_Coverage, 5910,
     /* 418370 */   GIR_EraseRootFromParent_Done,
     /* 418371 */ // Label 8118: @418371
     /* 418371 */ GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(418421), // Rule ID 5912 //
     /* 418376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418383 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418387 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418391 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418394 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 418399 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 418403 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418408 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418410 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 661:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 418410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 418413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418415 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418419 */   GIR_RootConstrainSelectedInstOperands,
     /* 418420 */   // GIR_Coverage, 5912,
     /* 418420 */   GIR_EraseRootFromParent_Done,
     /* 418421 */ // Label 8119: @418421
     /* 418421 */ GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(418463), // Rule ID 5909 //
     /* 418426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418433 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418437 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 418441 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418445 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418450 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418452 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 418452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 418455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418457 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418461 */   GIR_RootConstrainSelectedInstOperands,
     /* 418462 */   // GIR_Coverage, 5909,
     /* 418462 */   GIR_EraseRootFromParent_Done,
     /* 418463 */ // Label 8120: @418463
     /* 418463 */ GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(418505), // Rule ID 5911 //
     /* 418468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418475 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 418483 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418487 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418492 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418494 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 418494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 418497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418499 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418503 */   GIR_RootConstrainSelectedInstOperands,
     /* 418504 */   // GIR_Coverage, 5911,
     /* 418504 */   GIR_EraseRootFromParent_Done,
     /* 418505 */ // Label 8121: @418505
     /* 418505 */ GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(418547), // Rule ID 5899 //
     /* 418510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418517 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418521 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 418525 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418529 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418534 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418536 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 418536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 418539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418541 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418545 */   GIR_RootConstrainSelectedInstOperands,
     /* 418546 */   // GIR_Coverage, 5899,
     /* 418546 */   GIR_EraseRootFromParent_Done,
     /* 418547 */ // Label 8122: @418547
     /* 418547 */ GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(418589), // Rule ID 5901 //
     /* 418552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418559 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418563 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 418567 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418571 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418576 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418578 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 418578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 418581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418583 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418587 */   GIR_RootConstrainSelectedInstOperands,
     /* 418588 */   // GIR_Coverage, 5901,
     /* 418588 */   GIR_EraseRootFromParent_Done,
     /* 418589 */ // Label 8123: @418589
     /* 418589 */ GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(418650), // Rule ID 5953 //
     /* 418594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418605 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 418605 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 418608 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 418612 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418617 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418621 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 418627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 418630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418632 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 418639 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418649 */   // GIR_Coverage, 5953,
     /* 418649 */   GIR_EraseRootFromParent_Done,
     /* 418650 */ // Label 8124: @418650
     /* 418650 */ GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(418673), // Rule ID 5954 //
     /* 418655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418666 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 418666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 418671 */   GIR_RootConstrainSelectedInstOperands,
     /* 418672 */   // GIR_Coverage, 5954,
     /* 418672 */   GIR_Done,
     /* 418673 */ // Label 8125: @418673
     /* 418673 */ GIM_Reject,
     /* 418674 */ // Label 8102: @418674
     /* 418674 */ GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(418859),
     /* 418679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418686 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(418729), // Rule ID 5904 //
     /* 418691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418699 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418702 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 418707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 418711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418718 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 726:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 418718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 418721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418727 */     GIR_RootConstrainSelectedInstOperands,
     /* 418728 */     // GIR_Coverage, 5904,
     /* 418728 */     GIR_EraseRootFromParent_Done,
     /* 418729 */   // Label 8127: @418729
     /* 418729 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(418772), // Rule ID 5914 //
     /* 418734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418742 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418745 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 418750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 418754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418761 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 661:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 418761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 418764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418770 */     GIR_RootConstrainSelectedInstOperands,
     /* 418771 */     // GIR_Coverage, 5914,
     /* 418771 */     GIR_EraseRootFromParent_Done,
     /* 418772 */   // Label 8128: @418772
     /* 418772 */   GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(418807), // Rule ID 5913 //
     /* 418777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 418785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418796 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 418796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 418799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418805 */     GIR_RootConstrainSelectedInstOperands,
     /* 418806 */     // GIR_Coverage, 5913,
     /* 418806 */     GIR_EraseRootFromParent_Done,
     /* 418807 */   // Label 8129: @418807
     /* 418807 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(418842), // Rule ID 5903 //
     /* 418812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 418820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418831 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 418831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 418834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418840 */     GIR_RootConstrainSelectedInstOperands,
     /* 418841 */     // GIR_Coverage, 5903,
     /* 418841 */     GIR_EraseRootFromParent_Done,
     /* 418842 */   // Label 8130: @418842
     /* 418842 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(418858), // Rule ID 5955 //
     /* 418847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418851 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 418851 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 418856 */     GIR_RootConstrainSelectedInstOperands,
     /* 418857 */     // GIR_Coverage, 5955,
     /* 418857 */     GIR_Done,
     /* 418858 */   // Label 8131: @418858
     /* 418858 */   GIM_Reject,
     /* 418859 */ // Label 8126: @418859
     /* 418859 */ GIM_Reject,
     /* 418860 */ // Label 8103: @418860
     /* 418860 */ GIM_Reject,
     /* 418861 */ // Label 118: @418861
     /* 418861 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8135*/ GIMT_Encode4(419063),
     /* 418872 */ /*GILLT_s8*//*Label 8132*/ GIMT_Encode4(418884),
     /* 418876 */ /*GILLT_s16*//*Label 8133*/ GIMT_Encode4(418931),
     /* 418880 */ /*GILLT_s32*//*Label 8134*/ GIMT_Encode4(418978),
     /* 418884 */ // Label 8132: @418884
     /* 418884 */ GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(418907), // Rule ID 6046 //
     /* 418889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418900 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 418900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 418905 */   GIR_RootConstrainSelectedInstOperands,
     /* 418906 */   // GIR_Coverage, 6046,
     /* 418906 */   GIR_Done,
     /* 418907 */ // Label 8136: @418907
     /* 418907 */ GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(418930), // Rule ID 6047 //
     /* 418912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418923 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 418923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 418928 */   GIR_RootConstrainSelectedInstOperands,
     /* 418929 */   // GIR_Coverage, 6047,
     /* 418929 */   GIR_Done,
     /* 418930 */ // Label 8137: @418930
     /* 418930 */ GIM_Reject,
     /* 418931 */ // Label 8133: @418931
     /* 418931 */ GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(418954), // Rule ID 6048 //
     /* 418936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418947 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 418947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 418952 */   GIR_RootConstrainSelectedInstOperands,
     /* 418953 */   // GIR_Coverage, 6048,
     /* 418953 */   GIR_Done,
     /* 418954 */ // Label 8138: @418954
     /* 418954 */ GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(418977), // Rule ID 6049 //
     /* 418959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418970 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 418970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 418975 */   GIR_RootConstrainSelectedInstOperands,
     /* 418976 */   // GIR_Coverage, 6049,
     /* 418976 */   GIR_Done,
     /* 418977 */ // Label 8139: @418977
     /* 418977 */ GIM_Reject,
     /* 418978 */ // Label 8134: @418978
     /* 418978 */ GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(419001), // Rule ID 6050 //
     /* 418983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418994 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 418994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 418999 */   GIR_RootConstrainSelectedInstOperands,
     /* 419000 */   // GIR_Coverage, 6050,
     /* 419000 */   GIR_Done,
     /* 419001 */ // Label 8140: @419001
     /* 419001 */ GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(419062), // Rule ID 6051 //
     /* 419006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419017 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 419017 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 419020 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 419024 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419029 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419033 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 419039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 419042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 419044 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 419051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419061 */   // GIR_Coverage, 6051,
     /* 419061 */   GIR_EraseRootFromParent_Done,
     /* 419062 */ // Label 8141: @419062
     /* 419062 */ GIM_Reject,
     /* 419063 */ // Label 8135: @419063
     /* 419063 */ GIM_Reject,
     /* 419064 */ // Label 119: @419064
     /* 419064 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8145*/ GIMT_Encode4(419266),
     /* 419075 */ /*GILLT_s8*//*Label 8142*/ GIMT_Encode4(419087),
     /* 419079 */ /*GILLT_s16*//*Label 8143*/ GIMT_Encode4(419134),
     /* 419083 */ /*GILLT_s32*//*Label 8144*/ GIMT_Encode4(419181),
     /* 419087 */ // Label 8142: @419087
     /* 419087 */ GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(419110), // Rule ID 6040 //
     /* 419092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419103 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 419103 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 419108 */   GIR_RootConstrainSelectedInstOperands,
     /* 419109 */   // GIR_Coverage, 6040,
     /* 419109 */   GIR_Done,
     /* 419110 */ // Label 8146: @419110
     /* 419110 */ GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(419133), // Rule ID 6041 //
     /* 419115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419126 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 419126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 419131 */   GIR_RootConstrainSelectedInstOperands,
     /* 419132 */   // GIR_Coverage, 6041,
     /* 419132 */   GIR_Done,
     /* 419133 */ // Label 8147: @419133
     /* 419133 */ GIM_Reject,
     /* 419134 */ // Label 8143: @419134
     /* 419134 */ GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(419157), // Rule ID 6042 //
     /* 419139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419150 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 419150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 419155 */   GIR_RootConstrainSelectedInstOperands,
     /* 419156 */   // GIR_Coverage, 6042,
     /* 419156 */   GIR_Done,
     /* 419157 */ // Label 8148: @419157
     /* 419157 */ GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(419180), // Rule ID 6043 //
     /* 419162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419173 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 419173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 419178 */   GIR_RootConstrainSelectedInstOperands,
     /* 419179 */   // GIR_Coverage, 6043,
     /* 419179 */   GIR_Done,
     /* 419180 */ // Label 8149: @419180
     /* 419180 */ GIM_Reject,
     /* 419181 */ // Label 8144: @419181
     /* 419181 */ GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(419204), // Rule ID 6044 //
     /* 419186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419197 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 419197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 419202 */   GIR_RootConstrainSelectedInstOperands,
     /* 419203 */   // GIR_Coverage, 6044,
     /* 419203 */   GIR_Done,
     /* 419204 */ // Label 8150: @419204
     /* 419204 */ GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(419265), // Rule ID 6045 //
     /* 419209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419220 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 419220 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 419223 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 419227 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419232 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419236 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 419242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 419245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 419247 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 419254 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419259 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419264 */   // GIR_Coverage, 6045,
     /* 419264 */   GIR_EraseRootFromParent_Done,
     /* 419265 */ // Label 8151: @419265
     /* 419265 */ GIM_Reject,
     /* 419266 */ // Label 8145: @419266
     /* 419266 */ GIM_Reject,
     /* 419267 */ // Label 120: @419267
     /* 419267 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8155*/ GIMT_Encode4(419469),
     /* 419278 */ /*GILLT_s8*//*Label 8152*/ GIMT_Encode4(419290),
     /* 419282 */ /*GILLT_s16*//*Label 8153*/ GIMT_Encode4(419337),
     /* 419286 */ /*GILLT_s32*//*Label 8154*/ GIMT_Encode4(419384),
     /* 419290 */ // Label 8152: @419290
     /* 419290 */ GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(419313), // Rule ID 6034 //
     /* 419295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419306 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 419306 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 419311 */   GIR_RootConstrainSelectedInstOperands,
     /* 419312 */   // GIR_Coverage, 6034,
     /* 419312 */   GIR_Done,
     /* 419313 */ // Label 8156: @419313
     /* 419313 */ GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(419336), // Rule ID 6035 //
     /* 419318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419329 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 419329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 419334 */   GIR_RootConstrainSelectedInstOperands,
     /* 419335 */   // GIR_Coverage, 6035,
     /* 419335 */   GIR_Done,
     /* 419336 */ // Label 8157: @419336
     /* 419336 */ GIM_Reject,
     /* 419337 */ // Label 8153: @419337
     /* 419337 */ GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(419360), // Rule ID 6036 //
     /* 419342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419353 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 419353 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 419358 */   GIR_RootConstrainSelectedInstOperands,
     /* 419359 */   // GIR_Coverage, 6036,
     /* 419359 */   GIR_Done,
     /* 419360 */ // Label 8158: @419360
     /* 419360 */ GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(419383), // Rule ID 6037 //
     /* 419365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419376 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 419376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 419381 */   GIR_RootConstrainSelectedInstOperands,
     /* 419382 */   // GIR_Coverage, 6037,
     /* 419382 */   GIR_Done,
     /* 419383 */ // Label 8159: @419383
     /* 419383 */ GIM_Reject,
     /* 419384 */ // Label 8154: @419384
     /* 419384 */ GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(419407), // Rule ID 6038 //
     /* 419389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419400 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 419400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 419405 */   GIR_RootConstrainSelectedInstOperands,
     /* 419406 */   // GIR_Coverage, 6038,
     /* 419406 */   GIR_Done,
     /* 419407 */ // Label 8160: @419407
     /* 419407 */ GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(419468), // Rule ID 6039 //
     /* 419412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419423 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 419423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 419426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 419430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419435 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419439 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 419445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 419448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 419450 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 419457 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419462 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419467 */   // GIR_Coverage, 6039,
     /* 419467 */   GIR_EraseRootFromParent_Done,
     /* 419468 */ // Label 8161: @419468
     /* 419468 */ GIM_Reject,
     /* 419469 */ // Label 8155: @419469
     /* 419469 */ GIM_Reject,
     /* 419470 */ // Label 121: @419470
     /* 419470 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8165*/ GIMT_Encode4(419672),
     /* 419481 */ /*GILLT_s8*//*Label 8162*/ GIMT_Encode4(419493),
     /* 419485 */ /*GILLT_s16*//*Label 8163*/ GIMT_Encode4(419540),
     /* 419489 */ /*GILLT_s32*//*Label 8164*/ GIMT_Encode4(419587),
     /* 419493 */ // Label 8162: @419493
     /* 419493 */ GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(419516), // Rule ID 6028 //
     /* 419498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419509 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 419509 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 419514 */   GIR_RootConstrainSelectedInstOperands,
     /* 419515 */   // GIR_Coverage, 6028,
     /* 419515 */   GIR_Done,
     /* 419516 */ // Label 8166: @419516
     /* 419516 */ GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(419539), // Rule ID 6029 //
     /* 419521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419532 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 419532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 419537 */   GIR_RootConstrainSelectedInstOperands,
     /* 419538 */   // GIR_Coverage, 6029,
     /* 419538 */   GIR_Done,
     /* 419539 */ // Label 8167: @419539
     /* 419539 */ GIM_Reject,
     /* 419540 */ // Label 8163: @419540
     /* 419540 */ GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(419563), // Rule ID 6030 //
     /* 419545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419556 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 419556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 419561 */   GIR_RootConstrainSelectedInstOperands,
     /* 419562 */   // GIR_Coverage, 6030,
     /* 419562 */   GIR_Done,
     /* 419563 */ // Label 8168: @419563
     /* 419563 */ GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(419586), // Rule ID 6031 //
     /* 419568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419579 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 419579 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 419584 */   GIR_RootConstrainSelectedInstOperands,
     /* 419585 */   // GIR_Coverage, 6031,
     /* 419585 */   GIR_Done,
     /* 419586 */ // Label 8169: @419586
     /* 419586 */ GIM_Reject,
     /* 419587 */ // Label 8164: @419587
     /* 419587 */ GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(419610), // Rule ID 6032 //
     /* 419592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419603 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 419603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 419608 */   GIR_RootConstrainSelectedInstOperands,
     /* 419609 */   // GIR_Coverage, 6032,
     /* 419609 */   GIR_Done,
     /* 419610 */ // Label 8170: @419610
     /* 419610 */ GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(419671), // Rule ID 6033 //
     /* 419615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419626 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 419626 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 419629 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 419633 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419638 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419642 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419646 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 419648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 419651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 419653 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 419660 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419665 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419670 */   // GIR_Coverage, 6033,
     /* 419670 */   GIR_EraseRootFromParent_Done,
     /* 419671 */ // Label 8171: @419671
     /* 419671 */ GIM_Reject,
     /* 419672 */ // Label 8165: @419672
     /* 419672 */ GIM_Reject,
     /* 419673 */ // Label 122: @419673
     /* 419673 */ GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(419812),
     /* 419678 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 419681 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 419685 */   GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(419719), // Rule ID 257 //
     /* 419690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 419697 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 419697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 419700 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 419712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 419717 */     GIR_RootConstrainSelectedInstOperands,
     /* 419718 */     // GIR_Coverage, 257,
     /* 419718 */     GIR_EraseRootFromParent_Done,
     /* 419719 */   // Label 8173: @419719
     /* 419719 */   GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(419753), // Rule ID 258 //
     /* 419724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 419731 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 419731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 419734 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 419746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 419751 */     GIR_RootConstrainSelectedInstOperands,
     /* 419752 */     // GIR_Coverage, 258,
     /* 419752 */     GIR_EraseRootFromParent_Done,
     /* 419753 */   // Label 8174: @419753
     /* 419753 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(419782), // Rule ID 273 //
     /* 419758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 419765 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 419765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 419768 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 419780 */     GIR_RootConstrainSelectedInstOperands,
     /* 419781 */     // GIR_Coverage, 273,
     /* 419781 */     GIR_EraseRootFromParent_Done,
     /* 419782 */   // Label 8175: @419782
     /* 419782 */   GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(419811), // Rule ID 294 //
     /* 419787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 419794 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 419794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 419797 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 419809 */     GIR_RootConstrainSelectedInstOperands,
     /* 419810 */     // GIR_Coverage, 294,
     /* 419810 */     GIR_EraseRootFromParent_Done,
     /* 419811 */   // Label 8176: @419811
     /* 419811 */   GIM_Reject,
     /* 419812 */ // Label 8172: @419812
     /* 419812 */ GIM_Reject,
     /* 419813 */ // Label 123: @419813
     /* 419813 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8189*/ GIMT_Encode4(420800),
     /* 419824 */ /*GILLT_s64*//*Label 8177*/ GIMT_Encode4(419908), GIMT_Encode4(0),
     /* 419832 */ /*GILLT_v2s32*//*Label 8178*/ GIMT_Encode4(419946),
     /* 419836 */ /*GILLT_v2s64*//*Label 8179*/ GIMT_Encode4(419984),
     /* 419840 */ /*GILLT_v4s16*//*Label 8180*/ GIMT_Encode4(420022),
     /* 419844 */ /*GILLT_v4s32*//*Label 8181*/ GIMT_Encode4(420060),
     /* 419848 */ /*GILLT_v8s8*//*Label 8182*/ GIMT_Encode4(420098),
     /* 419852 */ /*GILLT_v8s16*//*Label 8183*/ GIMT_Encode4(420136),
     /* 419856 */ /*GILLT_v16s8*//*Label 8184*/ GIMT_Encode4(420174), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 419876 */ /*GILLT_nxv2s64*//*Label 8185*/ GIMT_Encode4(420212), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 419888 */ /*GILLT_nxv4s32*//*Label 8186*/ GIMT_Encode4(420359), GIMT_Encode4(0),
     /* 419896 */ /*GILLT_nxv8s16*//*Label 8187*/ GIMT_Encode4(420506), GIMT_Encode4(0),
     /* 419904 */ /*GILLT_nxv16s8*//*Label 8188*/ GIMT_Encode4(420653),
     /* 419908 */ // Label 8177: @419908
     /* 419908 */ GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(419945), // Rule ID 5105 //
     /* 419913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 419916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 419919 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 419922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419934 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419938 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 419938 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 419943 */   GIR_RootConstrainSelectedInstOperands,
     /* 419944 */   // GIR_Coverage, 5105,
     /* 419944 */   GIR_Done,
     /* 419945 */ // Label 8190: @419945
     /* 419945 */ GIM_Reject,
     /* 419946 */ // Label 8178: @419946
     /* 419946 */ GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(419983), // Rule ID 5104 //
     /* 419951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 419957 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 419960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419972 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419976 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 419976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 419981 */   GIR_RootConstrainSelectedInstOperands,
     /* 419982 */   // GIR_Coverage, 5104,
     /* 419982 */   GIR_Done,
     /* 419983 */ // Label 8191: @419983
     /* 419983 */ GIM_Reject,
     /* 419984 */ // Label 8179: @419984
     /* 419984 */ GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(420021), // Rule ID 5109 //
     /* 419989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 419992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 419995 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 419998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420010 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420014 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 420014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 420019 */   GIR_RootConstrainSelectedInstOperands,
     /* 420020 */   // GIR_Coverage, 5109,
     /* 420020 */   GIR_Done,
     /* 420021 */ // Label 8192: @420021
     /* 420021 */ GIM_Reject,
     /* 420022 */ // Label 8180: @420022
     /* 420022 */ GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(420059), // Rule ID 5103 //
     /* 420027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 420033 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 420036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420048 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420052 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 420052 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 420057 */   GIR_RootConstrainSelectedInstOperands,
     /* 420058 */   // GIR_Coverage, 5103,
     /* 420058 */   GIR_Done,
     /* 420059 */ // Label 8193: @420059
     /* 420059 */ GIM_Reject,
     /* 420060 */ // Label 8181: @420060
     /* 420060 */ GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(420097), // Rule ID 5108 //
     /* 420065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 420071 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 420074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420082 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420086 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420090 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 420090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 420095 */   GIR_RootConstrainSelectedInstOperands,
     /* 420096 */   // GIR_Coverage, 5108,
     /* 420096 */   GIR_Done,
     /* 420097 */ // Label 8194: @420097
     /* 420097 */ GIM_Reject,
     /* 420098 */ // Label 8182: @420098
     /* 420098 */ GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(420135), // Rule ID 5102 //
     /* 420103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 420106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 420109 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 420112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420124 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420128 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 420128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 420133 */   GIR_RootConstrainSelectedInstOperands,
     /* 420134 */   // GIR_Coverage, 5102,
     /* 420134 */   GIR_Done,
     /* 420135 */ // Label 8195: @420135
     /* 420135 */ GIM_Reject,
     /* 420136 */ // Label 8183: @420136
     /* 420136 */ GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(420173), // Rule ID 5107 //
     /* 420141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 420147 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 420150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420162 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420166 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 420166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 420171 */   GIR_RootConstrainSelectedInstOperands,
     /* 420172 */   // GIR_Coverage, 5107,
     /* 420172 */   GIR_Done,
     /* 420173 */ // Label 8196: @420173
     /* 420173 */ GIM_Reject,
     /* 420174 */ // Label 8184: @420174
     /* 420174 */ GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(420211), // Rule ID 5106 //
     /* 420179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 420182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 420185 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 420188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420200 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420204 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 420204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 420209 */   GIR_RootConstrainSelectedInstOperands,
     /* 420210 */   // GIR_Coverage, 5106,
     /* 420210 */   GIR_Done,
     /* 420211 */ // Label 8197: @420211
     /* 420211 */ GIM_Reject,
     /* 420212 */ // Label 8185: @420212
     /* 420212 */ GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(420358),
     /* 420217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 420220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 420223 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 420226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 420230 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(420283), // Rule ID 11959 //
     /* 420235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 420242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 420250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 420254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420258 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420264 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420268 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 420268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 420271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 420277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420281 */     GIR_RootConstrainSelectedInstOperands,
     /* 420282 */     // GIR_Coverage, 11959,
     /* 420282 */     GIR_EraseRootFromParent_Done,
     /* 420283 */   // Label 8199: @420283
     /* 420283 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(420336), // Rule ID 11970 //
     /* 420288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 420295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 420303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 420307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420311 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420317 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420321 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 420321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 420324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 420332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420334 */     GIR_RootConstrainSelectedInstOperands,
     /* 420335 */     // GIR_Coverage, 11970,
     /* 420335 */     GIR_EraseRootFromParent_Done,
     /* 420336 */   // Label 8200: @420336
     /* 420336 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(420357), // Rule ID 11951 //
     /* 420341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420344 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 420344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 420347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420355 */     GIR_RootConstrainSelectedInstOperands,
     /* 420356 */     // GIR_Coverage, 11951,
     /* 420356 */     GIR_EraseRootFromParent_Done,
     /* 420357 */   // Label 8201: @420357
     /* 420357 */   GIM_Reject,
     /* 420358 */ // Label 8198: @420358
     /* 420358 */ GIM_Reject,
     /* 420359 */ // Label 8186: @420359
     /* 420359 */ GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(420505),
     /* 420364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 420367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 420370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 420373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 420377 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(420430), // Rule ID 11957 //
     /* 420382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 420389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 420397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 420401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420405 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420411 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420415 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 420415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 420418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 420424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420428 */     GIR_RootConstrainSelectedInstOperands,
     /* 420429 */     // GIR_Coverage, 11957,
     /* 420429 */     GIR_EraseRootFromParent_Done,
     /* 420430 */   // Label 8203: @420430
     /* 420430 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(420483), // Rule ID 11967 //
     /* 420435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 420442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 420450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 420454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420458 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420464 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420468 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 420468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 420471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 420479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420481 */     GIR_RootConstrainSelectedInstOperands,
     /* 420482 */     // GIR_Coverage, 11967,
     /* 420482 */     GIR_EraseRootFromParent_Done,
     /* 420483 */   // Label 8204: @420483
     /* 420483 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(420504), // Rule ID 11949 //
     /* 420488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420491 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 420491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 420494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420502 */     GIR_RootConstrainSelectedInstOperands,
     /* 420503 */     // GIR_Coverage, 11949,
     /* 420503 */     GIR_EraseRootFromParent_Done,
     /* 420504 */   // Label 8205: @420504
     /* 420504 */   GIM_Reject,
     /* 420505 */ // Label 8202: @420505
     /* 420505 */ GIM_Reject,
     /* 420506 */ // Label 8187: @420506
     /* 420506 */ GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(420652),
     /* 420511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 420514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 420517 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 420520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 420524 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(420577), // Rule ID 11955 //
     /* 420529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 420536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 420544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 420548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420552 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420558 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420562 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 420562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 420565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 420571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420575 */     GIR_RootConstrainSelectedInstOperands,
     /* 420576 */     // GIR_Coverage, 11955,
     /* 420576 */     GIR_EraseRootFromParent_Done,
     /* 420577 */   // Label 8207: @420577
     /* 420577 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(420630), // Rule ID 11964 //
     /* 420582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 420589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 420597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 420601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420605 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420611 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420615 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 420615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 420618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 420626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420628 */     GIR_RootConstrainSelectedInstOperands,
     /* 420629 */     // GIR_Coverage, 11964,
     /* 420629 */     GIR_EraseRootFromParent_Done,
     /* 420630 */   // Label 8208: @420630
     /* 420630 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(420651), // Rule ID 11947 //
     /* 420635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420638 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 420638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 420641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420649 */     GIR_RootConstrainSelectedInstOperands,
     /* 420650 */     // GIR_Coverage, 11947,
     /* 420650 */     GIR_EraseRootFromParent_Done,
     /* 420651 */   // Label 8209: @420651
     /* 420651 */   GIM_Reject,
     /* 420652 */ // Label 8206: @420652
     /* 420652 */ GIM_Reject,
     /* 420653 */ // Label 8188: @420653
     /* 420653 */ GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(420799),
     /* 420658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 420661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 420664 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 420667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 420671 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(420724), // Rule ID 11953 //
     /* 420676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 420683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 420691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 420695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420699 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420705 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420709 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 420709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 420712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 420718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420722 */     GIR_RootConstrainSelectedInstOperands,
     /* 420723 */     // GIR_Coverage, 11953,
     /* 420723 */     GIR_EraseRootFromParent_Done,
     /* 420724 */   // Label 8211: @420724
     /* 420724 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(420777), // Rule ID 11961 //
     /* 420729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 420736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 420744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 420748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420752 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420758 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420762 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 420762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 420765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 420773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420775 */     GIR_RootConstrainSelectedInstOperands,
     /* 420776 */     // GIR_Coverage, 11961,
     /* 420776 */     GIR_EraseRootFromParent_Done,
     /* 420777 */   // Label 8212: @420777
     /* 420777 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(420798), // Rule ID 11945 //
     /* 420782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420785 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 420785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 420788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420796 */     GIR_RootConstrainSelectedInstOperands,
     /* 420797 */     // GIR_Coverage, 11945,
     /* 420797 */     GIR_EraseRootFromParent_Done,
     /* 420798 */   // Label 8213: @420798
     /* 420798 */   GIM_Reject,
     /* 420799 */ // Label 8210: @420799
     /* 420799 */ GIM_Reject,
     /* 420800 */ // Label 8189: @420800
     /* 420800 */ GIM_Reject,
     /* 420801 */ // Label 124: @420801
     /* 420801 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8222*/ GIMT_Encode4(422623),
     /* 420812 */ /*GILLT_s64*//*Label 8214*/ GIMT_Encode4(420848), GIMT_Encode4(0),
     /* 420820 */ /*GILLT_v2s32*//*Label 8215*/ GIMT_Encode4(421043),
     /* 420824 */ /*GILLT_v2s64*//*Label 8216*/ GIMT_Encode4(421290),
     /* 420828 */ /*GILLT_v4s16*//*Label 8217*/ GIMT_Encode4(421537),
     /* 420832 */ /*GILLT_v4s32*//*Label 8218*/ GIMT_Encode4(421813),
     /* 420836 */ /*GILLT_v8s8*//*Label 8219*/ GIMT_Encode4(422060),
     /* 420840 */ /*GILLT_v8s16*//*Label 8220*/ GIMT_Encode4(422205),
     /* 420844 */ /*GILLT_v16s8*//*Label 8221*/ GIMT_Encode4(422481),
     /* 420848 */ // Label 8214: @420848
     /* 420848 */ GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(421042),
     /* 420853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 420856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420860 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(420907), // Rule ID 6473 //
     /* 420865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420873 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420880 */     // MIs[1] Rn
     /* 420880 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420891 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 420894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420905 */     GIR_RootConstrainSelectedInstOperands,
     /* 420906 */     // GIR_Coverage, 6473,
     /* 420906 */     GIR_EraseRootFromParent_Done,
     /* 420907 */   // Label 8224: @420907
     /* 420907 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(420954), // Rule ID 6484 //
     /* 420912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420920 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420927 */     // MIs[1] Rn
     /* 420927 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420938 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 420941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420952 */     GIR_RootConstrainSelectedInstOperands,
     /* 420953 */     // GIR_Coverage, 6484,
     /* 420953 */     GIR_EraseRootFromParent_Done,
     /* 420954 */   // Label 8225: @420954
     /* 420954 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(421001), // Rule ID 13288 //
     /* 420959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420967 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420974 */     // MIs[1] Rn
     /* 420974 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420985 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 420988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420999 */     GIR_RootConstrainSelectedInstOperands,
     /* 421000 */     // GIR_Coverage, 13288,
     /* 421000 */     GIR_EraseRootFromParent_Done,
     /* 421001 */   // Label 8226: @421001
     /* 421001 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(421021), // Rule ID 5668 //
     /* 421006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 421010 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 421010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 421015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421020 */     // GIR_Coverage, 5668,
     /* 421020 */     GIR_Done,
     /* 421021 */   // Label 8227: @421021
     /* 421021 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(421041), // Rule ID 5669 //
     /* 421026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421030 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 421030 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 421035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421040 */     // GIR_Coverage, 5669,
     /* 421040 */     GIR_Done,
     /* 421041 */   // Label 8228: @421041
     /* 421041 */   GIM_Reject,
     /* 421042 */ // Label 8223: @421042
     /* 421042 */ GIM_Reject,
     /* 421043 */ // Label 8215: @421043
     /* 421043 */ GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(421289),
     /* 421048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421055 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(421102), // Rule ID 6470 //
     /* 421060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421068 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421071 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421075 */     // MIs[1] Rn
     /* 421075 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421086 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 421089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421100 */     GIR_RootConstrainSelectedInstOperands,
     /* 421101 */     // GIR_Coverage, 6470,
     /* 421101 */     GIR_EraseRootFromParent_Done,
     /* 421102 */   // Label 8230: @421102
     /* 421102 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(421149), // Rule ID 6481 //
     /* 421107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421115 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421122 */     // MIs[1] Rn
     /* 421122 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421133 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 421136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421147 */     GIR_RootConstrainSelectedInstOperands,
     /* 421148 */     // GIR_Coverage, 6481,
     /* 421148 */     GIR_EraseRootFromParent_Done,
     /* 421149 */   // Label 8231: @421149
     /* 421149 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(421196), // Rule ID 13285 //
     /* 421154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421162 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421165 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421169 */     // MIs[1] Rn
     /* 421169 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421180 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 421183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421194 */     GIR_RootConstrainSelectedInstOperands,
     /* 421195 */     // GIR_Coverage, 13285,
     /* 421195 */     GIR_EraseRootFromParent_Done,
     /* 421196 */   // Label 8232: @421196
     /* 421196 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(421215), // Rule ID 1916 //
     /* 421201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421208 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 421208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 421213 */     GIR_RootConstrainSelectedInstOperands,
     /* 421214 */     // GIR_Coverage, 1916,
     /* 421214 */     GIR_Done,
     /* 421215 */   // Label 8233: @421215
     /* 421215 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(421288), // Rule ID 5670 //
     /* 421220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421224 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 421224 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 421227 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 421231 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 421238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 421241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 421245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421250 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 421253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421257 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 421260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 421278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 421283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421286 */     GIR_RootConstrainSelectedInstOperands,
     /* 421287 */     // GIR_Coverage, 5670,
     /* 421287 */     GIR_EraseRootFromParent_Done,
     /* 421288 */   // Label 8234: @421288
     /* 421288 */   GIM_Reject,
     /* 421289 */ // Label 8229: @421289
     /* 421289 */ GIM_Reject,
     /* 421290 */ // Label 8216: @421290
     /* 421290 */ GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(421536),
     /* 421295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 421298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421302 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(421349), // Rule ID 6472 //
     /* 421307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421315 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421318 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421322 */     // MIs[1] Rn
     /* 421322 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421333 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 421336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421347 */     GIR_RootConstrainSelectedInstOperands,
     /* 421348 */     // GIR_Coverage, 6472,
     /* 421348 */     GIR_EraseRootFromParent_Done,
     /* 421349 */   // Label 8236: @421349
     /* 421349 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(421396), // Rule ID 6483 //
     /* 421354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421362 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421365 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421369 */     // MIs[1] Rn
     /* 421369 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421380 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 421383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421394 */     GIR_RootConstrainSelectedInstOperands,
     /* 421395 */     // GIR_Coverage, 6483,
     /* 421395 */     GIR_EraseRootFromParent_Done,
     /* 421396 */   // Label 8237: @421396
     /* 421396 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(421443), // Rule ID 13287 //
     /* 421401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421409 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421412 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421416 */     // MIs[1] Rn
     /* 421416 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421427 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 421430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421441 */     GIR_RootConstrainSelectedInstOperands,
     /* 421442 */     // GIR_Coverage, 13287,
     /* 421442 */     GIR_EraseRootFromParent_Done,
     /* 421443 */   // Label 8238: @421443
     /* 421443 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(421462), // Rule ID 1918 //
     /* 421448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 421455 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 421455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 421460 */     GIR_RootConstrainSelectedInstOperands,
     /* 421461 */     // GIR_Coverage, 1918,
     /* 421461 */     GIR_Done,
     /* 421462 */   // Label 8239: @421462
     /* 421462 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(421535), // Rule ID 5672 //
     /* 421467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421471 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 421471 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 421474 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 421478 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 421485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 421488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 421492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421497 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 421500 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421504 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 421507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 421525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 421530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421533 */     GIR_RootConstrainSelectedInstOperands,
     /* 421534 */     // GIR_Coverage, 5672,
     /* 421534 */     GIR_EraseRootFromParent_Done,
     /* 421535 */   // Label 8240: @421535
     /* 421535 */   GIM_Reject,
     /* 421536 */ // Label 8235: @421536
     /* 421536 */ GIM_Reject,
     /* 421537 */ // Label 8217: @421537
     /* 421537 */ GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(421598), // Rule ID 6468 //
     /* 421542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421549 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421553 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421557 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421560 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421564 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 421571 */   // MIs[1] Rn
     /* 421571 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421575 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421580 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421582 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 421585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421587 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421591 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421596 */   GIR_RootConstrainSelectedInstOperands,
     /* 421597 */   // GIR_Coverage, 6468,
     /* 421597 */   GIR_EraseRootFromParent_Done,
     /* 421598 */ // Label 8241: @421598
     /* 421598 */ GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(421652), // Rule ID 6485 //
     /* 421603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 421606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421618 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421621 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421625 */   // MIs[1] Rn
     /* 421625 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421629 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421634 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421636 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 421639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421641 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421645 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421650 */   GIR_RootConstrainSelectedInstOperands,
     /* 421651 */   // GIR_Coverage, 6485,
     /* 421651 */   GIR_EraseRootFromParent_Done,
     /* 421652 */ // Label 8242: @421652
     /* 421652 */ GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(421706), // Rule ID 13283 //
     /* 421657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 421660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421664 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421668 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421672 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421675 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421679 */   // MIs[1] Rn
     /* 421679 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421683 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421688 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421690 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 421693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421695 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421699 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421704 */   GIR_RootConstrainSelectedInstOperands,
     /* 421705 */   // GIR_Coverage, 13283,
     /* 421705 */   GIR_EraseRootFromParent_Done,
     /* 421706 */ // Label 8243: @421706
     /* 421706 */ GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(421732), // Rule ID 1914 //
     /* 421711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421725 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 421725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 421730 */   GIR_RootConstrainSelectedInstOperands,
     /* 421731 */   // GIR_Coverage, 1914,
     /* 421731 */   GIR_Done,
     /* 421732 */ // Label 8244: @421732
     /* 421732 */ GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(421812), // Rule ID 5673 //
     /* 421737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 421740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421748 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 421748 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 421751 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 421755 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 421762 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 421765 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 421769 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421774 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 421777 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421781 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 421784 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421789 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421794 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 421802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 421807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421810 */   GIR_RootConstrainSelectedInstOperands,
     /* 421811 */   // GIR_Coverage, 5673,
     /* 421811 */   GIR_EraseRootFromParent_Done,
     /* 421812 */ // Label 8245: @421812
     /* 421812 */ GIM_Reject,
     /* 421813 */ // Label 8218: @421813
     /* 421813 */ GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(422059),
     /* 421818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421825 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(421872), // Rule ID 6471 //
     /* 421830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421838 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421841 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421845 */     // MIs[1] Rn
     /* 421845 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421856 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 421859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421870 */     GIR_RootConstrainSelectedInstOperands,
     /* 421871 */     // GIR_Coverage, 6471,
     /* 421871 */     GIR_EraseRootFromParent_Done,
     /* 421872 */   // Label 8247: @421872
     /* 421872 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(421919), // Rule ID 6482 //
     /* 421877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421885 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421888 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421892 */     // MIs[1] Rn
     /* 421892 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421903 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 421906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421917 */     GIR_RootConstrainSelectedInstOperands,
     /* 421918 */     // GIR_Coverage, 6482,
     /* 421918 */     GIR_EraseRootFromParent_Done,
     /* 421919 */   // Label 8248: @421919
     /* 421919 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(421966), // Rule ID 13286 //
     /* 421924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421932 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421939 */     // MIs[1] Rn
     /* 421939 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421950 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 421953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421964 */     GIR_RootConstrainSelectedInstOperands,
     /* 421965 */     // GIR_Coverage, 13286,
     /* 421965 */     GIR_EraseRootFromParent_Done,
     /* 421966 */   // Label 8249: @421966
     /* 421966 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(421985), // Rule ID 1917 //
     /* 421971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421978 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 421978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 421983 */     GIR_RootConstrainSelectedInstOperands,
     /* 421984 */     // GIR_Coverage, 1917,
     /* 421984 */     GIR_Done,
     /* 421985 */   // Label 8250: @421985
     /* 421985 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(422058), // Rule ID 5671 //
     /* 421990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421994 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 421994 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 421997 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 422001 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 422008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 422011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 422015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422020 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 422023 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 422027 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 422030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 422045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 422048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 422053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422056 */     GIR_RootConstrainSelectedInstOperands,
     /* 422057 */     // GIR_Coverage, 5671,
     /* 422057 */     GIR_EraseRootFromParent_Done,
     /* 422058 */   // Label 8251: @422058
     /* 422058 */   GIM_Reject,
     /* 422059 */ // Label 8246: @422059
     /* 422059 */ GIM_Reject,
     /* 422060 */ // Label 8219: @422060
     /* 422060 */ GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(422117), // Rule ID 13281 //
     /* 422065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 422068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422072 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422076 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422080 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422083 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422087 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 422091 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422093 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 422100 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 422103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 422110 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422115 */   GIR_RootConstrainSelectedInstOperands,
     /* 422116 */   // GIR_Coverage, 13281,
     /* 422116 */   GIR_EraseRootFromParent_Done,
     /* 422117 */ // Label 8252: @422117
     /* 422117 */ GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(422178), // Rule ID 6466 //
     /* 422122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422129 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422133 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422137 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422140 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422144 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 422151 */   // MIs[1] Rn
     /* 422151 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422155 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422160 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422162 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 422165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422167 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422171 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422176 */   GIR_RootConstrainSelectedInstOperands,
     /* 422177 */   // GIR_Coverage, 6466,
     /* 422177 */   GIR_EraseRootFromParent_Done,
     /* 422178 */ // Label 8253: @422178
     /* 422178 */ GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(422204), // Rule ID 1912 //
     /* 422183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 422197 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 422197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 422202 */   GIR_RootConstrainSelectedInstOperands,
     /* 422203 */   // GIR_Coverage, 1912,
     /* 422203 */   GIR_Done,
     /* 422204 */ // Label 8254: @422204
     /* 422204 */ GIM_Reject,
     /* 422205 */ // Label 8220: @422205
     /* 422205 */ GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(422266), // Rule ID 6469 //
     /* 422210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422217 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422221 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422225 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422228 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422232 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 422239 */   // MIs[1] Rn
     /* 422239 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422243 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422248 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422250 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 422253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422255 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422259 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422264 */   GIR_RootConstrainSelectedInstOperands,
     /* 422265 */   // GIR_Coverage, 6469,
     /* 422265 */   GIR_EraseRootFromParent_Done,
     /* 422266 */ // Label 8255: @422266
     /* 422266 */ GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(422320), // Rule ID 6486 //
     /* 422271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 422274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422278 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422282 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422286 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422289 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422293 */   // MIs[1] Rn
     /* 422293 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422297 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422302 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422304 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 422307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422309 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422313 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422318 */   GIR_RootConstrainSelectedInstOperands,
     /* 422319 */   // GIR_Coverage, 6486,
     /* 422319 */   GIR_EraseRootFromParent_Done,
     /* 422320 */ // Label 8256: @422320
     /* 422320 */ GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(422374), // Rule ID 13284 //
     /* 422325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 422328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422332 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422336 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422340 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422343 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422347 */   // MIs[1] Rn
     /* 422347 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422351 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422356 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422358 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 422361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422363 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422367 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422372 */   GIR_RootConstrainSelectedInstOperands,
     /* 422373 */   // GIR_Coverage, 13284,
     /* 422373 */   GIR_EraseRootFromParent_Done,
     /* 422374 */ // Label 8257: @422374
     /* 422374 */ GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(422400), // Rule ID 1915 //
     /* 422379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 422393 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 422393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 422398 */   GIR_RootConstrainSelectedInstOperands,
     /* 422399 */   // GIR_Coverage, 1915,
     /* 422399 */   GIR_Done,
     /* 422400 */ // Label 8258: @422400
     /* 422400 */ GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(422480), // Rule ID 5674 //
     /* 422405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 422408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 422416 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 422416 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 422419 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 422423 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 422430 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 422433 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 422437 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422442 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 422445 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 422449 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 422452 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422457 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422462 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 422467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 422470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422472 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 422475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422478 */   GIR_RootConstrainSelectedInstOperands,
     /* 422479 */   // GIR_Coverage, 5674,
     /* 422479 */   GIR_EraseRootFromParent_Done,
     /* 422480 */ // Label 8259: @422480
     /* 422480 */ GIM_Reject,
     /* 422481 */ // Label 8221: @422481
     /* 422481 */ GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(422542), // Rule ID 6467 //
     /* 422486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422493 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422497 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422501 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422504 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422508 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 422515 */   // MIs[1] Rn
     /* 422515 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422519 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422524 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422526 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 422529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422531 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422535 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422540 */   GIR_RootConstrainSelectedInstOperands,
     /* 422541 */   // GIR_Coverage, 6467,
     /* 422541 */   GIR_EraseRootFromParent_Done,
     /* 422542 */ // Label 8260: @422542
     /* 422542 */ GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(422596), // Rule ID 13282 //
     /* 422547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 422550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422554 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422562 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422565 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422569 */   // MIs[1] Rn
     /* 422569 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422573 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422578 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422580 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 422583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422585 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422594 */   GIR_RootConstrainSelectedInstOperands,
     /* 422595 */   // GIR_Coverage, 13282,
     /* 422595 */   GIR_EraseRootFromParent_Done,
     /* 422596 */ // Label 8261: @422596
     /* 422596 */ GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(422622), // Rule ID 1913 //
     /* 422601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 422615 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 422615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 422620 */   GIR_RootConstrainSelectedInstOperands,
     /* 422621 */   // GIR_Coverage, 1913,
     /* 422621 */   GIR_Done,
     /* 422622 */ // Label 8262: @422622
     /* 422622 */ GIM_Reject,
     /* 422623 */ // Label 8222: @422623
     /* 422623 */ GIM_Reject,
     /* 422624 */ // Label 125: @422624
     /* 422624 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8265*/ GIMT_Encode4(422878),
     /* 422635 */ /*GILLT_v4s16*//*Label 8263*/ GIMT_Encode4(422651), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 422647 */ /*GILLT_v8s16*//*Label 8264*/ GIMT_Encode4(422737),
     /* 422651 */ // Label 8263: @422651
     /* 422651 */ GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(422736),
     /* 422656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 422659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422670 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(422704), // Rule ID 1922 //
     /* 422675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 422690 */     // MIs[1] Operand 1
     /* 422690 */     // No operand predicates
     /* 422690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422692 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 422695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422702 */     GIR_RootConstrainSelectedInstOperands,
     /* 422703 */     // GIR_Coverage, 1922,
     /* 422703 */     GIR_EraseRootFromParent_Done,
     /* 422704 */   // Label 8267: @422704
     /* 422704 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(422735), // Rule ID 5675 //
     /* 422709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 422721 */     // MIs[1] Operand 1
     /* 422721 */     // No operand predicates
     /* 422721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422723 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 422723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 422726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 422733 */     GIR_RootConstrainSelectedInstOperands,
     /* 422734 */     // GIR_Coverage, 5675,
     /* 422734 */     GIR_EraseRootFromParent_Done,
     /* 422735 */   // Label 8268: @422735
     /* 422735 */   GIM_Reject,
     /* 422736 */ // Label 8266: @422736
     /* 422736 */ GIM_Reject,
     /* 422737 */ // Label 8264: @422737
     /* 422737 */ GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(422877),
     /* 422742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 422745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422752 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(422803), // Rule ID 6477 //
     /* 422757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422765 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422768 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422772 */     // MIs[1] Rn
     /* 422772 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 422785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422787 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 422790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422801 */     GIR_RootConstrainSelectedInstOperands,
     /* 422802 */     // GIR_Coverage, 6477,
     /* 422802 */     GIR_EraseRootFromParent_Done,
     /* 422803 */   // Label 8270: @422803
     /* 422803 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(422841), // Rule ID 1923 //
     /* 422808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 422827 */     // MIs[1] Operand 1
     /* 422827 */     // No operand predicates
     /* 422827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422829 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 422832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422839 */     GIR_RootConstrainSelectedInstOperands,
     /* 422840 */     // GIR_Coverage, 1923,
     /* 422840 */     GIR_EraseRootFromParent_Done,
     /* 422841 */   // Label 8271: @422841
     /* 422841 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(422876), // Rule ID 5676 //
     /* 422846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 422862 */     // MIs[1] Operand 1
     /* 422862 */     // No operand predicates
     /* 422862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422864 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 422864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 422867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422869 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 422874 */     GIR_RootConstrainSelectedInstOperands,
     /* 422875 */     // GIR_Coverage, 5676,
     /* 422875 */     GIR_EraseRootFromParent_Done,
     /* 422876 */   // Label 8272: @422876
     /* 422876 */   GIM_Reject,
     /* 422877 */ // Label 8269: @422877
     /* 422877 */ GIM_Reject,
     /* 422878 */ // Label 8265: @422878
     /* 422878 */ GIM_Reject,
     /* 422879 */ // Label 126: @422879
     /* 422879 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8275*/ GIMT_Encode4(423133),
     /* 422890 */ /*GILLT_v2s32*//*Label 8273*/ GIMT_Encode4(422906), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 422902 */ /*GILLT_v4s32*//*Label 8274*/ GIMT_Encode4(422992),
     /* 422906 */ // Label 8273: @422906
     /* 422906 */ GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(422991),
     /* 422911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 422914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422925 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(422959), // Rule ID 1920 //
     /* 422930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 422945 */     // MIs[1] Operand 1
     /* 422945 */     // No operand predicates
     /* 422945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422947 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 422950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422952 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422957 */     GIR_RootConstrainSelectedInstOperands,
     /* 422958 */     // GIR_Coverage, 1920,
     /* 422958 */     GIR_EraseRootFromParent_Done,
     /* 422959 */   // Label 8277: @422959
     /* 422959 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(422990), // Rule ID 5677 //
     /* 422964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 422976 */     // MIs[1] Operand 1
     /* 422976 */     // No operand predicates
     /* 422976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422978 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 422978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 422981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 422988 */     GIR_RootConstrainSelectedInstOperands,
     /* 422989 */     // GIR_Coverage, 5677,
     /* 422989 */     GIR_EraseRootFromParent_Done,
     /* 422990 */   // Label 8278: @422990
     /* 422990 */   GIM_Reject,
     /* 422991 */ // Label 8276: @422991
     /* 422991 */ GIM_Reject,
     /* 422992 */ // Label 8274: @422992
     /* 422992 */ GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(423132),
     /* 422997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 423000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423007 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(423058), // Rule ID 6479 //
     /* 423012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423020 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423023 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423027 */     // MIs[1] Rn
     /* 423027 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 423040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423042 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 423045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423056 */     GIR_RootConstrainSelectedInstOperands,
     /* 423057 */     // GIR_Coverage, 6479,
     /* 423057 */     GIR_EraseRootFromParent_Done,
     /* 423058 */   // Label 8280: @423058
     /* 423058 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(423096), // Rule ID 1921 //
     /* 423063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 423082 */     // MIs[1] Operand 1
     /* 423082 */     // No operand predicates
     /* 423082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423084 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 423084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 423087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 423094 */     GIR_RootConstrainSelectedInstOperands,
     /* 423095 */     // GIR_Coverage, 1921,
     /* 423095 */     GIR_EraseRootFromParent_Done,
     /* 423096 */   // Label 8281: @423096
     /* 423096 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(423131), // Rule ID 5678 //
     /* 423101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 423117 */     // MIs[1] Operand 1
     /* 423117 */     // No operand predicates
     /* 423117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423119 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 423119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 423122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423129 */     GIR_RootConstrainSelectedInstOperands,
     /* 423130 */     // GIR_Coverage, 5678,
     /* 423130 */     GIR_EraseRootFromParent_Done,
     /* 423131 */   // Label 8282: @423131
     /* 423131 */   GIM_Reject,
     /* 423132 */ // Label 8279: @423132
     /* 423132 */ GIM_Reject,
     /* 423133 */ // Label 8275: @423133
     /* 423133 */ GIM_Reject,
     /* 423134 */ // Label 127: @423134
     /* 423134 */ GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(423279),
     /* 423139 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 423142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 423145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423152 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(423203), // Rule ID 6480 //
     /* 423157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423165 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423168 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423172 */     // MIs[1] Rn
     /* 423172 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 423185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423187 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 423190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423201 */     GIR_RootConstrainSelectedInstOperands,
     /* 423202 */     // GIR_Coverage, 6480,
     /* 423202 */     GIR_EraseRootFromParent_Done,
     /* 423203 */   // Label 8284: @423203
     /* 423203 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(423278),
     /* 423208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423212 */     GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(423246), // Rule ID 1919 //
     /* 423217 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423220 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423224 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423228 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 423232 */       // MIs[1] Operand 1
     /* 423232 */       // No operand predicates
     /* 423232 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423234 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 423234 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 423237 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423239 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423241 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 423244 */       GIR_RootConstrainSelectedInstOperands,
     /* 423245 */       // GIR_Coverage, 1919,
     /* 423245 */       GIR_EraseRootFromParent_Done,
     /* 423246 */     // Label 8286: @423246
     /* 423246 */     GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(423277), // Rule ID 5679 //
     /* 423251 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423255 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423259 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 423263 */       // MIs[1] Operand 1
     /* 423263 */       // No operand predicates
     /* 423263 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423265 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 423265 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 423268 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423270 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423272 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423275 */       GIR_RootConstrainSelectedInstOperands,
     /* 423276 */       // GIR_Coverage, 5679,
     /* 423276 */       GIR_EraseRootFromParent_Done,
     /* 423277 */     // Label 8287: @423277
     /* 423277 */     GIM_Reject,
     /* 423278 */   // Label 8285: @423278
     /* 423278 */   GIM_Reject,
     /* 423279 */ // Label 8283: @423279
     /* 423279 */ GIM_Reject,
     /* 423280 */ // Label 128: @423280
     /* 423280 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8290*/ GIMT_Encode4(423458),
     /* 423291 */ /*GILLT_v8s8*//*Label 8288*/ GIMT_Encode4(423303), GIMT_Encode4(0),
     /* 423299 */ /*GILLT_v16s8*//*Label 8289*/ GIMT_Encode4(423352),
     /* 423303 */ // Label 8288: @423303
     /* 423303 */ GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(423351), // Rule ID 1924 //
     /* 423308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 423314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423325 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423329 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423333 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 423337 */   // MIs[1] Operand 1
     /* 423337 */   // No operand predicates
     /* 423337 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423339 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 423339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 423342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423344 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423346 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 423349 */   GIR_RootConstrainSelectedInstOperands,
     /* 423350 */   // GIR_Coverage, 1924,
     /* 423350 */   GIR_EraseRootFromParent_Done,
     /* 423351 */ // Label 8291: @423351
     /* 423351 */ GIM_Reject,
     /* 423352 */ // Label 8289: @423352
     /* 423352 */ GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(423457),
     /* 423357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 423360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423367 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(423418), // Rule ID 6475 //
     /* 423372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423380 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423383 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423387 */     // MIs[1] Rn
     /* 423387 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 423400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423402 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 423405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423416 */     GIR_RootConstrainSelectedInstOperands,
     /* 423417 */     // GIR_Coverage, 6475,
     /* 423417 */     GIR_EraseRootFromParent_Done,
     /* 423418 */   // Label 8293: @423418
     /* 423418 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(423456), // Rule ID 1925 //
     /* 423423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 423442 */     // MIs[1] Operand 1
     /* 423442 */     // No operand predicates
     /* 423442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423444 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 423444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 423447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 423454 */     GIR_RootConstrainSelectedInstOperands,
     /* 423455 */     // GIR_Coverage, 1925,
     /* 423455 */     GIR_EraseRootFromParent_Done,
     /* 423456 */   // Label 8294: @423456
     /* 423456 */   GIM_Reject,
     /* 423457 */ // Label 8292: @423457
     /* 423457 */ GIM_Reject,
     /* 423458 */ // Label 8290: @423458
     /* 423458 */ GIM_Reject,
     /* 423459 */ // Label 129: @423459
     /* 423459 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8304*/ GIMT_Encode4(425108),
     /* 423470 */ /*GILLT_s64*//*Label 8295*/ GIMT_Encode4(423554), GIMT_Encode4(0),
     /* 423478 */ /*GILLT_v2s32*//*Label 8296*/ GIMT_Encode4(423875),
     /* 423482 */ /*GILLT_v2s64*//*Label 8297*/ GIMT_Encode4(424196),
     /* 423486 */ /*GILLT_v4s16*//*Label 8298*/ GIMT_Encode4(424279),
     /* 423490 */ /*GILLT_v4s32*//*Label 8299*/ GIMT_Encode4(424600),
     /* 423494 */ /*GILLT_v8s8*//*Label 8300*/ GIMT_Encode4(424683),
     /* 423498 */ /*GILLT_v8s16*//*Label 8301*/ GIMT_Encode4(424892),
     /* 423502 */ /*GILLT_v16s8*//*Label 8302*/ GIMT_Encode4(424975), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 423550 */ /*GILLT_nxv16s8*//*Label 8303*/ GIMT_Encode4(425061),
     /* 423554 */ // Label 8295: @423554
     /* 423554 */ GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(423874),
     /* 423559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 423562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423569 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(423684), // Rule ID 5496 //
     /* 423574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 423586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423591 */     // MIs[1] Operand 2
     /* 423591 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423610 */     // MIs[2] Rn
     /* 423610 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423615 */     // MIs[2] Operand 2
     /* 423615 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 423626 */     // MIs[0] imm
     /* 423626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423634 */     // MIs[3] Operand 1
     /* 423634 */     // No operand predicates
     /* 423634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423636 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423666 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423683 */     // GIR_Coverage, 5496,
     /* 423683 */     GIR_EraseRootFromParent_Done,
     /* 423684 */   // Label 8306: @423684
     /* 423684 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(423799), // Rule ID 5501 //
     /* 423689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 423701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423706 */     // MIs[1] Operand 2
     /* 423706 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423725 */     // MIs[2] Rn
     /* 423725 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423730 */     // MIs[2] Operand 2
     /* 423730 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 423741 */     // MIs[0] imm
     /* 423741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423749 */     // MIs[3] Operand 1
     /* 423749 */     // No operand predicates
     /* 423749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423751 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423763 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423767 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423781 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423798 */     // GIR_Coverage, 5501,
     /* 423798 */     GIR_EraseRootFromParent_Done,
     /* 423799 */   // Label 8307: @423799
     /* 423799 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(423836), // Rule ID 5493 //
     /* 423804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423812 */     // MIs[0] imm
     /* 423812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423820 */     // MIs[1] Operand 1
     /* 423820 */     // No operand predicates
     /* 423820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423822 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 423825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423834 */     GIR_RootConstrainSelectedInstOperands,
     /* 423835 */     // GIR_Coverage, 5493,
     /* 423835 */     GIR_EraseRootFromParent_Done,
     /* 423836 */   // Label 8308: @423836
     /* 423836 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(423873), // Rule ID 5498 //
     /* 423841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423849 */     // MIs[0] imm
     /* 423849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423857 */     // MIs[1] Operand 1
     /* 423857 */     // No operand predicates
     /* 423857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423859 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 423862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423871 */     GIR_RootConstrainSelectedInstOperands,
     /* 423872 */     // GIR_Coverage, 5498,
     /* 423872 */     GIR_EraseRootFromParent_Done,
     /* 423873 */   // Label 8309: @423873
     /* 423873 */   GIM_Reject,
     /* 423874 */ // Label 8305: @423874
     /* 423874 */ GIM_Reject,
     /* 423875 */ // Label 8296: @423875
     /* 423875 */ GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(424195),
     /* 423880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 423883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 423886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423890 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(424005), // Rule ID 5486 //
     /* 423895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 423907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423912 */     // MIs[1] Operand 2
     /* 423912 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423931 */     // MIs[2] Rn
     /* 423931 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423936 */     // MIs[2] Operand 2
     /* 423936 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 423947 */     // MIs[0] imm
     /* 423947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423955 */     // MIs[3] Operand 1
     /* 423955 */     // No operand predicates
     /* 423955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423957 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423969 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423987 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424004 */     // GIR_Coverage, 5486,
     /* 424004 */     GIR_EraseRootFromParent_Done,
     /* 424005 */   // Label 8311: @424005
     /* 424005 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(424120), // Rule ID 5491 //
     /* 424010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 424022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424027 */     // MIs[1] Operand 2
     /* 424027 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424046 */     // MIs[2] Rn
     /* 424046 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424051 */     // MIs[2] Operand 2
     /* 424051 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 424062 */     // MIs[0] imm
     /* 424062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424070 */     // MIs[3] Operand 1
     /* 424070 */     // No operand predicates
     /* 424070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424072 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424088 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 424095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 424097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 424100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 424102 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424119 */     // GIR_Coverage, 5491,
     /* 424119 */     GIR_EraseRootFromParent_Done,
     /* 424120 */   // Label 8312: @424120
     /* 424120 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(424157), // Rule ID 5483 //
     /* 424125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424133 */     // MIs[0] imm
     /* 424133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424141 */     // MIs[1] Operand 1
     /* 424141 */     // No operand predicates
     /* 424141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424143 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424155 */     GIR_RootConstrainSelectedInstOperands,
     /* 424156 */     // GIR_Coverage, 5483,
     /* 424156 */     GIR_EraseRootFromParent_Done,
     /* 424157 */   // Label 8313: @424157
     /* 424157 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(424194), // Rule ID 5488 //
     /* 424162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424170 */     // MIs[0] imm
     /* 424170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424178 */     // MIs[1] Operand 1
     /* 424178 */     // No operand predicates
     /* 424178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424180 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424192 */     GIR_RootConstrainSelectedInstOperands,
     /* 424193 */     // GIR_Coverage, 5488,
     /* 424193 */     GIR_EraseRootFromParent_Done,
     /* 424194 */   // Label 8314: @424194
     /* 424194 */   GIM_Reject,
     /* 424195 */ // Label 8310: @424195
     /* 424195 */ GIM_Reject,
     /* 424196 */ // Label 8297: @424196
     /* 424196 */ GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(424278),
     /* 424201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 424204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 424207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424219 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(424248), // Rule ID 5494 //
     /* 424224 */     // MIs[0] imm
     /* 424224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424232 */     // MIs[1] Operand 1
     /* 424232 */     // No operand predicates
     /* 424232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424234 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424246 */     GIR_RootConstrainSelectedInstOperands,
     /* 424247 */     // GIR_Coverage, 5494,
     /* 424247 */     GIR_EraseRootFromParent_Done,
     /* 424248 */   // Label 8316: @424248
     /* 424248 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(424277), // Rule ID 5499 //
     /* 424253 */     // MIs[0] imm
     /* 424253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424261 */     // MIs[1] Operand 1
     /* 424261 */     // No operand predicates
     /* 424261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424263 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424275 */     GIR_RootConstrainSelectedInstOperands,
     /* 424276 */     // GIR_Coverage, 5499,
     /* 424276 */     GIR_EraseRootFromParent_Done,
     /* 424277 */   // Label 8317: @424277
     /* 424277 */   GIM_Reject,
     /* 424278 */ // Label 8315: @424278
     /* 424278 */ GIM_Reject,
     /* 424279 */ // Label 8298: @424279
     /* 424279 */ GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(424599),
     /* 424284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 424287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 424290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424294 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(424409), // Rule ID 5476 //
     /* 424299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 424311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424316 */     // MIs[1] Operand 2
     /* 424316 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424335 */     // MIs[2] Rn
     /* 424335 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424340 */     // MIs[2] Operand 2
     /* 424340 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 424351 */     // MIs[0] imm
     /* 424351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424359 */     // MIs[3] Operand 1
     /* 424359 */     // No operand predicates
     /* 424359 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424361 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424373 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424377 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 424384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 424386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 424389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 424391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424408 */     // GIR_Coverage, 5476,
     /* 424408 */     GIR_EraseRootFromParent_Done,
     /* 424409 */   // Label 8319: @424409
     /* 424409 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(424524), // Rule ID 5481 //
     /* 424414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 424426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424431 */     // MIs[1] Operand 2
     /* 424431 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424450 */     // MIs[2] Rn
     /* 424450 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424455 */     // MIs[2] Operand 2
     /* 424455 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 424466 */     // MIs[0] imm
     /* 424466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424474 */     // MIs[3] Operand 1
     /* 424474 */     // No operand predicates
     /* 424474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424476 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 424499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 424501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 424504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 424506 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424523 */     // GIR_Coverage, 5481,
     /* 424523 */     GIR_EraseRootFromParent_Done,
     /* 424524 */   // Label 8320: @424524
     /* 424524 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(424561), // Rule ID 5473 //
     /* 424529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424537 */     // MIs[0] imm
     /* 424537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424545 */     // MIs[1] Operand 1
     /* 424545 */     // No operand predicates
     /* 424545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424547 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424559 */     GIR_RootConstrainSelectedInstOperands,
     /* 424560 */     // GIR_Coverage, 5473,
     /* 424560 */     GIR_EraseRootFromParent_Done,
     /* 424561 */   // Label 8321: @424561
     /* 424561 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(424598), // Rule ID 5478 //
     /* 424566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424574 */     // MIs[0] imm
     /* 424574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424582 */     // MIs[1] Operand 1
     /* 424582 */     // No operand predicates
     /* 424582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424584 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424596 */     GIR_RootConstrainSelectedInstOperands,
     /* 424597 */     // GIR_Coverage, 5478,
     /* 424597 */     GIR_EraseRootFromParent_Done,
     /* 424598 */   // Label 8322: @424598
     /* 424598 */   GIM_Reject,
     /* 424599 */ // Label 8318: @424599
     /* 424599 */ GIM_Reject,
     /* 424600 */ // Label 8299: @424600
     /* 424600 */ GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(424682),
     /* 424605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 424608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 424611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424623 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(424652), // Rule ID 5484 //
     /* 424628 */     // MIs[0] imm
     /* 424628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424636 */     // MIs[1] Operand 1
     /* 424636 */     // No operand predicates
     /* 424636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424638 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424650 */     GIR_RootConstrainSelectedInstOperands,
     /* 424651 */     // GIR_Coverage, 5484,
     /* 424651 */     GIR_EraseRootFromParent_Done,
     /* 424652 */   // Label 8324: @424652
     /* 424652 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(424681), // Rule ID 5489 //
     /* 424657 */     // MIs[0] imm
     /* 424657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424665 */     // MIs[1] Operand 1
     /* 424665 */     // No operand predicates
     /* 424665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424667 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424679 */     GIR_RootConstrainSelectedInstOperands,
     /* 424680 */     // GIR_Coverage, 5489,
     /* 424680 */     GIR_EraseRootFromParent_Done,
     /* 424681 */   // Label 8325: @424681
     /* 424681 */   GIM_Reject,
     /* 424682 */ // Label 8323: @424682
     /* 424682 */ GIM_Reject,
     /* 424683 */ // Label 8300: @424683
     /* 424683 */ GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(424891),
     /* 424688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 424691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 424694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424698 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(424813), // Rule ID 5471 //
     /* 424703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 424715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424720 */     // MIs[1] Operand 2
     /* 424720 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424739 */     // MIs[2] Rn
     /* 424739 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424744 */     // MIs[2] Operand 2
     /* 424744 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 424755 */     // MIs[0] imm
     /* 424755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424763 */     // MIs[3] Operand 1
     /* 424763 */     // No operand predicates
     /* 424763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424765 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424777 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424781 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 424788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 424790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 424793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 424795 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424812 */     // GIR_Coverage, 5471,
     /* 424812 */     GIR_EraseRootFromParent_Done,
     /* 424813 */   // Label 8327: @424813
     /* 424813 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(424853), // Rule ID 1868 //
     /* 424818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424829 */     // MIs[0] imm
     /* 424829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424837 */     // MIs[1] Operand 1
     /* 424837 */     // No operand predicates
     /* 424837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424839 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424851 */     GIR_RootConstrainSelectedInstOperands,
     /* 424852 */     // GIR_Coverage, 1868,
     /* 424852 */     GIR_EraseRootFromParent_Done,
     /* 424853 */   // Label 8328: @424853
     /* 424853 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(424890), // Rule ID 5468 //
     /* 424858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424866 */     // MIs[0] imm
     /* 424866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424874 */     // MIs[1] Operand 1
     /* 424874 */     // No operand predicates
     /* 424874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424876 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424888 */     GIR_RootConstrainSelectedInstOperands,
     /* 424889 */     // GIR_Coverage, 5468,
     /* 424889 */     GIR_EraseRootFromParent_Done,
     /* 424890 */   // Label 8329: @424890
     /* 424890 */   GIM_Reject,
     /* 424891 */ // Label 8326: @424891
     /* 424891 */ GIM_Reject,
     /* 424892 */ // Label 8301: @424892
     /* 424892 */ GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(424974),
     /* 424897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 424900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 424903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424915 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(424944), // Rule ID 5474 //
     /* 424920 */     // MIs[0] imm
     /* 424920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424928 */     // MIs[1] Operand 1
     /* 424928 */     // No operand predicates
     /* 424928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424930 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424942 */     GIR_RootConstrainSelectedInstOperands,
     /* 424943 */     // GIR_Coverage, 5474,
     /* 424943 */     GIR_EraseRootFromParent_Done,
     /* 424944 */   // Label 8331: @424944
     /* 424944 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(424973), // Rule ID 5479 //
     /* 424949 */     // MIs[0] imm
     /* 424949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424957 */     // MIs[1] Operand 1
     /* 424957 */     // No operand predicates
     /* 424957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424959 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424971 */     GIR_RootConstrainSelectedInstOperands,
     /* 424972 */     // GIR_Coverage, 5479,
     /* 424972 */     GIR_EraseRootFromParent_Done,
     /* 424973 */   // Label 8332: @424973
     /* 424973 */   GIM_Reject,
     /* 424974 */ // Label 8330: @424974
     /* 424974 */ GIM_Reject,
     /* 424975 */ // Label 8302: @424975
     /* 424975 */ GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(425060),
     /* 424980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 424983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 424986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424994 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424998 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(425030), // Rule ID 1869 //
     /* 425003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425006 */     // MIs[0] imm
     /* 425006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425014 */     // MIs[1] Operand 1
     /* 425014 */     // No operand predicates
     /* 425014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425016 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425028 */     GIR_RootConstrainSelectedInstOperands,
     /* 425029 */     // GIR_Coverage, 1869,
     /* 425029 */     GIR_EraseRootFromParent_Done,
     /* 425030 */   // Label 8334: @425030
     /* 425030 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(425059), // Rule ID 5469 //
     /* 425035 */     // MIs[0] imm
     /* 425035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425043 */     // MIs[1] Operand 1
     /* 425043 */     // No operand predicates
     /* 425043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425045 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425057 */     GIR_RootConstrainSelectedInstOperands,
     /* 425058 */     // GIR_Coverage, 5469,
     /* 425058 */     GIR_EraseRootFromParent_Done,
     /* 425059 */   // Label 8335: @425059
     /* 425059 */   GIM_Reject,
     /* 425060 */ // Label 8333: @425060
     /* 425060 */ GIM_Reject,
     /* 425061 */ // Label 8303: @425061
     /* 425061 */ GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(425107), // Rule ID 2733 //
     /* 425066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 425069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 425072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 425075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 425079 */   // MIs[0] Op3
     /* 425079 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425083 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425087 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 425091 */   // MIs[1] Operand 1
     /* 425091 */   // No operand predicates
     /* 425091 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425093 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 425093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 425096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 425098 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 425100 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 425102 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 425105 */   GIR_RootConstrainSelectedInstOperands,
     /* 425106 */   // GIR_Coverage, 2733,
     /* 425106 */   GIR_EraseRootFromParent_Done,
     /* 425107 */ // Label 8336: @425107
     /* 425107 */ GIM_Reject,
     /* 425108 */ // Label 8304: @425108
     /* 425108 */ GIM_Reject,
     /* 425109 */ // Label 130: @425109
     /* 425109 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8344*/ GIMT_Encode4(425667),
     /* 425120 */ /*GILLT_s32*//*Label 8337*/ GIMT_Encode4(425156),
     /* 425124 */ /*GILLT_s64*//*Label 8338*/ GIMT_Encode4(425194), GIMT_Encode4(0),
     /* 425132 */ /*GILLT_v2s32*//*Label 8339*/ GIMT_Encode4(425292),
     /* 425136 */ /*GILLT_v2s64*//*Label 8340*/ GIMT_Encode4(425367),
     /* 425140 */ /*GILLT_v4s16*//*Label 8341*/ GIMT_Encode4(425442),
     /* 425144 */ /*GILLT_v4s32*//*Label 8342*/ GIMT_Encode4(425517), GIMT_Encode4(0),
     /* 425152 */ /*GILLT_v8s16*//*Label 8343*/ GIMT_Encode4(425592),
     /* 425156 */ // Label 8337: @425156
     /* 425156 */ GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(425193), // Rule ID 1622 //
     /* 425161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 425167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 425170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425182 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 425182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 425187 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425191 */   GIR_RootConstrainSelectedInstOperands,
     /* 425192 */   // GIR_Coverage, 1622,
     /* 425192 */   GIR_Done,
     /* 425193 */ // Label 8345: @425193
     /* 425193 */ GIM_Reject,
     /* 425194 */ // Label 8338: @425194
     /* 425194 */ GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(425291),
     /* 425199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 425202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425213 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(425244), // Rule ID 2513 //
     /* 425218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425225 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425231 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425235 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 425235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 425238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425242 */     GIR_RootConstrainSelectedInstOperands,
     /* 425243 */     // GIR_Coverage, 2513,
     /* 425243 */     GIR_EraseRootFromParent_Done,
     /* 425244 */   // Label 8347: @425244
     /* 425244 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(425267), // Rule ID 1621 //
     /* 425249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425256 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 425256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 425261 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425265 */     GIR_RootConstrainSelectedInstOperands,
     /* 425266 */     // GIR_Coverage, 1621,
     /* 425266 */     GIR_Done,
     /* 425267 */   // Label 8348: @425267
     /* 425267 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(425290), // Rule ID 5248 //
     /* 425272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425279 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 425279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 425284 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425288 */     GIR_RootConstrainSelectedInstOperands,
     /* 425289 */     // GIR_Coverage, 5248,
     /* 425289 */     GIR_Done,
     /* 425290 */   // Label 8349: @425290
     /* 425290 */   GIM_Reject,
     /* 425291 */ // Label 8346: @425291
     /* 425291 */ GIM_Reject,
     /* 425292 */ // Label 8339: @425292
     /* 425292 */ GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(425366),
     /* 425297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 425300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 425303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425311 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(425342), // Rule ID 773 //
     /* 425316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425323 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425329 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425333 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 425333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 425336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425340 */     GIR_RootConstrainSelectedInstOperands,
     /* 425341 */     // GIR_Coverage, 773,
     /* 425341 */     GIR_EraseRootFromParent_Done,
     /* 425342 */   // Label 8351: @425342
     /* 425342 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(425365), // Rule ID 1210 //
     /* 425347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425354 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 425354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 425359 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425363 */     GIR_RootConstrainSelectedInstOperands,
     /* 425364 */     // GIR_Coverage, 1210,
     /* 425364 */     GIR_Done,
     /* 425365 */   // Label 8352: @425365
     /* 425365 */   GIM_Reject,
     /* 425366 */ // Label 8350: @425366
     /* 425366 */ GIM_Reject,
     /* 425367 */ // Label 8340: @425367
     /* 425367 */ GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(425441),
     /* 425372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 425375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 425378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425386 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(425417), // Rule ID 775 //
     /* 425391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425398 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425404 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425408 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 425408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 425411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425415 */     GIR_RootConstrainSelectedInstOperands,
     /* 425416 */     // GIR_Coverage, 775,
     /* 425416 */     GIR_EraseRootFromParent_Done,
     /* 425417 */   // Label 8354: @425417
     /* 425417 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(425440), // Rule ID 1212 //
     /* 425422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425429 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 425429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 425434 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425438 */     GIR_RootConstrainSelectedInstOperands,
     /* 425439 */     // GIR_Coverage, 1212,
     /* 425439 */     GIR_Done,
     /* 425440 */   // Label 8355: @425440
     /* 425440 */   GIM_Reject,
     /* 425441 */ // Label 8353: @425441
     /* 425441 */ GIM_Reject,
     /* 425442 */ // Label 8341: @425442
     /* 425442 */ GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(425516),
     /* 425447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 425450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 425453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425461 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(425492), // Rule ID 771 //
     /* 425466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425473 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425479 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425483 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 425483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 425486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425490 */     GIR_RootConstrainSelectedInstOperands,
     /* 425491 */     // GIR_Coverage, 771,
     /* 425491 */     GIR_EraseRootFromParent_Done,
     /* 425492 */   // Label 8357: @425492
     /* 425492 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(425515), // Rule ID 1208 //
     /* 425497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425504 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 425504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 425509 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425513 */     GIR_RootConstrainSelectedInstOperands,
     /* 425514 */     // GIR_Coverage, 1208,
     /* 425514 */     GIR_Done,
     /* 425515 */   // Label 8358: @425515
     /* 425515 */   GIM_Reject,
     /* 425516 */ // Label 8356: @425516
     /* 425516 */ GIM_Reject,
     /* 425517 */ // Label 8342: @425517
     /* 425517 */ GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(425591),
     /* 425522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 425528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425536 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(425567), // Rule ID 774 //
     /* 425541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425548 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425554 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425558 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 425558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 425561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425565 */     GIR_RootConstrainSelectedInstOperands,
     /* 425566 */     // GIR_Coverage, 774,
     /* 425566 */     GIR_EraseRootFromParent_Done,
     /* 425567 */   // Label 8360: @425567
     /* 425567 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(425590), // Rule ID 1211 //
     /* 425572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425579 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 425579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 425584 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425588 */     GIR_RootConstrainSelectedInstOperands,
     /* 425589 */     // GIR_Coverage, 1211,
     /* 425589 */     GIR_Done,
     /* 425590 */   // Label 8361: @425590
     /* 425590 */   GIM_Reject,
     /* 425591 */ // Label 8359: @425591
     /* 425591 */ GIM_Reject,
     /* 425592 */ // Label 8343: @425592
     /* 425592 */ GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(425666),
     /* 425597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 425600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 425603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425611 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(425642), // Rule ID 772 //
     /* 425616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425623 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425629 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425633 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 425633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 425636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425640 */     GIR_RootConstrainSelectedInstOperands,
     /* 425641 */     // GIR_Coverage, 772,
     /* 425641 */     GIR_EraseRootFromParent_Done,
     /* 425642 */   // Label 8363: @425642
     /* 425642 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(425665), // Rule ID 1209 //
     /* 425647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425654 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 425654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 425659 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425663 */     GIR_RootConstrainSelectedInstOperands,
     /* 425664 */     // GIR_Coverage, 1209,
     /* 425664 */     GIR_Done,
     /* 425665 */   // Label 8364: @425665
     /* 425665 */   GIM_Reject,
     /* 425666 */ // Label 8362: @425666
     /* 425666 */ GIM_Reject,
     /* 425667 */ // Label 8344: @425667
     /* 425667 */ GIM_Reject,
     /* 425668 */ // Label 131: @425668
     /* 425668 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8372*/ GIMT_Encode4(426759),
     /* 425679 */ /*GILLT_s32*//*Label 8365*/ GIMT_Encode4(425715),
     /* 425683 */ /*GILLT_s64*//*Label 8366*/ GIMT_Encode4(425753), GIMT_Encode4(0),
     /* 425691 */ /*GILLT_v2s32*//*Label 8367*/ GIMT_Encode4(425894),
     /* 425695 */ /*GILLT_v2s64*//*Label 8368*/ GIMT_Encode4(426067),
     /* 425699 */ /*GILLT_v4s16*//*Label 8369*/ GIMT_Encode4(426240),
     /* 425703 */ /*GILLT_v4s32*//*Label 8370*/ GIMT_Encode4(426413), GIMT_Encode4(0),
     /* 425711 */ /*GILLT_v8s16*//*Label 8371*/ GIMT_Encode4(426586),
     /* 425715 */ // Label 8365: @425715
     /* 425715 */ GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(425752), // Rule ID 1624 //
     /* 425720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 425726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 425729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425737 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425741 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 425741 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 425746 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425750 */   GIR_RootConstrainSelectedInstOperands,
     /* 425751 */   // GIR_Coverage, 1624,
     /* 425751 */   GIR_Done,
     /* 425752 */ // Label 8373: @425752
     /* 425752 */ GIM_Reject,
     /* 425753 */ // Label 8366: @425753
     /* 425753 */ GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(425893),
     /* 425758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 425761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425768 */   GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(425803), // Rule ID 5282 //
     /* 425773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425780 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425786 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425794 */     // (AArch64fcmge:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 425794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 425797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 425801 */     GIR_RootConstrainSelectedInstOperands,
     /* 425802 */     // GIR_Coverage, 5282,
     /* 425802 */     GIR_EraseRootFromParent_Done,
     /* 425803 */   // Label 8375: @425803
     /* 425803 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(425838), // Rule ID 5280 //
     /* 425808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425819 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425825 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425829 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 425829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 425832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425836 */     GIR_RootConstrainSelectedInstOperands,
     /* 425837 */     // GIR_Coverage, 5280,
     /* 425837 */     GIR_EraseRootFromParent_Done,
     /* 425838 */   // Label 8376: @425838
     /* 425838 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(425865), // Rule ID 1623 //
     /* 425843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425854 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 425854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 425859 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425863 */     GIR_RootConstrainSelectedInstOperands,
     /* 425864 */     // GIR_Coverage, 1623,
     /* 425864 */     GIR_Done,
     /* 425865 */   // Label 8377: @425865
     /* 425865 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(425892), // Rule ID 5249 //
     /* 425870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425881 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 425881 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 425886 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425890 */     GIR_RootConstrainSelectedInstOperands,
     /* 425891 */     // GIR_Coverage, 5249,
     /* 425891 */     GIR_Done,
     /* 425892 */   // Label 8378: @425892
     /* 425892 */   GIM_Reject,
     /* 425893 */ // Label 8374: @425893
     /* 425893 */ GIM_Reject,
     /* 425894 */ // Label 8367: @425894
     /* 425894 */ GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(426066),
     /* 425899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 425902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 425905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425909 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(425968), // Rule ID 1172 //
     /* 425914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 425929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 425946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 425953 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 425953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 425956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 425966 */     GIR_RootConstrainSelectedInstOperands,
     /* 425967 */     // GIR_Coverage, 1172,
     /* 425967 */     GIR_EraseRootFromParent_Done,
     /* 425968 */   // Label 8380: @425968
     /* 425968 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(426003), // Rule ID 788 //
     /* 425973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425980 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425986 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425994 */     // (AArch64fcmge:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 425994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 425997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426001 */     GIR_RootConstrainSelectedInstOperands,
     /* 426002 */     // GIR_Coverage, 788,
     /* 426002 */     GIR_EraseRootFromParent_Done,
     /* 426003 */   // Label 8381: @426003
     /* 426003 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(426038), // Rule ID 778 //
     /* 426008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426019 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426025 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426029 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 426029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 426032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426036 */     GIR_RootConstrainSelectedInstOperands,
     /* 426037 */     // GIR_Coverage, 778,
     /* 426037 */     GIR_EraseRootFromParent_Done,
     /* 426038 */   // Label 8382: @426038
     /* 426038 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(426065), // Rule ID 1215 //
     /* 426043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426054 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 426054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 426059 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426063 */     GIR_RootConstrainSelectedInstOperands,
     /* 426064 */     // GIR_Coverage, 1215,
     /* 426064 */     GIR_Done,
     /* 426065 */   // Label 8383: @426065
     /* 426065 */   GIM_Reject,
     /* 426066 */ // Label 8379: @426066
     /* 426066 */ GIM_Reject,
     /* 426067 */ // Label 8368: @426067
     /* 426067 */ GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(426239),
     /* 426072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 426078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426082 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(426141), // Rule ID 1176 //
     /* 426087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426119 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426126 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 426126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 426129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426139 */     GIR_RootConstrainSelectedInstOperands,
     /* 426140 */     // GIR_Coverage, 1176,
     /* 426140 */     GIR_EraseRootFromParent_Done,
     /* 426141 */   // Label 8385: @426141
     /* 426141 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(426176), // Rule ID 790 //
     /* 426146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426153 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426159 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426167 */     // (AArch64fcmge:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 426167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 426170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426174 */     GIR_RootConstrainSelectedInstOperands,
     /* 426175 */     // GIR_Coverage, 790,
     /* 426175 */     GIR_EraseRootFromParent_Done,
     /* 426176 */   // Label 8386: @426176
     /* 426176 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(426211), // Rule ID 780 //
     /* 426181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426192 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426198 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426202 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 426202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 426205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426209 */     GIR_RootConstrainSelectedInstOperands,
     /* 426210 */     // GIR_Coverage, 780,
     /* 426210 */     GIR_EraseRootFromParent_Done,
     /* 426211 */   // Label 8387: @426211
     /* 426211 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(426238), // Rule ID 1217 //
     /* 426216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426227 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 426227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 426232 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426236 */     GIR_RootConstrainSelectedInstOperands,
     /* 426237 */     // GIR_Coverage, 1217,
     /* 426237 */     GIR_Done,
     /* 426238 */   // Label 8388: @426238
     /* 426238 */   GIM_Reject,
     /* 426239 */ // Label 8384: @426239
     /* 426239 */ GIM_Reject,
     /* 426240 */ // Label 8369: @426240
     /* 426240 */ GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(426412),
     /* 426245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 426251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426255 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(426314), // Rule ID 1168 //
     /* 426260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426299 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 426299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 426302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426312 */     GIR_RootConstrainSelectedInstOperands,
     /* 426313 */     // GIR_Coverage, 1168,
     /* 426313 */     GIR_EraseRootFromParent_Done,
     /* 426314 */   // Label 8390: @426314
     /* 426314 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(426349), // Rule ID 786 //
     /* 426319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426326 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426332 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426340 */     // (AArch64fcmge:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 426340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 426343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426347 */     GIR_RootConstrainSelectedInstOperands,
     /* 426348 */     // GIR_Coverage, 786,
     /* 426348 */     GIR_EraseRootFromParent_Done,
     /* 426349 */   // Label 8391: @426349
     /* 426349 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(426384), // Rule ID 776 //
     /* 426354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426365 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426371 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426375 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 426375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 426378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426382 */     GIR_RootConstrainSelectedInstOperands,
     /* 426383 */     // GIR_Coverage, 776,
     /* 426383 */     GIR_EraseRootFromParent_Done,
     /* 426384 */   // Label 8392: @426384
     /* 426384 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(426411), // Rule ID 1213 //
     /* 426389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426400 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 426400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 426405 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426409 */     GIR_RootConstrainSelectedInstOperands,
     /* 426410 */     // GIR_Coverage, 1213,
     /* 426410 */     GIR_Done,
     /* 426411 */   // Label 8393: @426411
     /* 426411 */   GIM_Reject,
     /* 426412 */ // Label 8389: @426412
     /* 426412 */ GIM_Reject,
     /* 426413 */ // Label 8370: @426413
     /* 426413 */ GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(426585),
     /* 426418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 426424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426428 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(426487), // Rule ID 1174 //
     /* 426433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426472 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 426472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 426475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426485 */     GIR_RootConstrainSelectedInstOperands,
     /* 426486 */     // GIR_Coverage, 1174,
     /* 426486 */     GIR_EraseRootFromParent_Done,
     /* 426487 */   // Label 8395: @426487
     /* 426487 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(426522), // Rule ID 789 //
     /* 426492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426499 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426505 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426513 */     // (AArch64fcmge:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 426513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 426516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426520 */     GIR_RootConstrainSelectedInstOperands,
     /* 426521 */     // GIR_Coverage, 789,
     /* 426521 */     GIR_EraseRootFromParent_Done,
     /* 426522 */   // Label 8396: @426522
     /* 426522 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(426557), // Rule ID 779 //
     /* 426527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426538 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426544 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426548 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 426548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 426551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426555 */     GIR_RootConstrainSelectedInstOperands,
     /* 426556 */     // GIR_Coverage, 779,
     /* 426556 */     GIR_EraseRootFromParent_Done,
     /* 426557 */   // Label 8397: @426557
     /* 426557 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(426584), // Rule ID 1216 //
     /* 426562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426573 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 426573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 426578 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426582 */     GIR_RootConstrainSelectedInstOperands,
     /* 426583 */     // GIR_Coverage, 1216,
     /* 426583 */     GIR_Done,
     /* 426584 */   // Label 8398: @426584
     /* 426584 */   GIM_Reject,
     /* 426585 */ // Label 8394: @426585
     /* 426585 */ GIM_Reject,
     /* 426586 */ // Label 8371: @426586
     /* 426586 */ GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(426758),
     /* 426591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 426597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426601 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(426660), // Rule ID 1170 //
     /* 426606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426638 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426645 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 426645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 426648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426658 */     GIR_RootConstrainSelectedInstOperands,
     /* 426659 */     // GIR_Coverage, 1170,
     /* 426659 */     GIR_EraseRootFromParent_Done,
     /* 426660 */   // Label 8400: @426660
     /* 426660 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(426695), // Rule ID 787 //
     /* 426665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426672 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426678 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426686 */     // (AArch64fcmge:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 426686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 426689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426693 */     GIR_RootConstrainSelectedInstOperands,
     /* 426694 */     // GIR_Coverage, 787,
     /* 426694 */     GIR_EraseRootFromParent_Done,
     /* 426695 */   // Label 8401: @426695
     /* 426695 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(426730), // Rule ID 777 //
     /* 426700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426711 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426717 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426721 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 426721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 426724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426728 */     GIR_RootConstrainSelectedInstOperands,
     /* 426729 */     // GIR_Coverage, 777,
     /* 426729 */     GIR_EraseRootFromParent_Done,
     /* 426730 */   // Label 8402: @426730
     /* 426730 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(426757), // Rule ID 1214 //
     /* 426735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426746 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 426746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 426751 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426755 */     GIR_RootConstrainSelectedInstOperands,
     /* 426756 */     // GIR_Coverage, 1214,
     /* 426756 */     GIR_Done,
     /* 426757 */   // Label 8403: @426757
     /* 426757 */   GIM_Reject,
     /* 426758 */ // Label 8399: @426758
     /* 426758 */ GIM_Reject,
     /* 426759 */ // Label 8372: @426759
     /* 426759 */ GIM_Reject,
     /* 426760 */ // Label 132: @426760
     /* 426760 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8411*/ GIMT_Encode4(427851),
     /* 426771 */ /*GILLT_s32*//*Label 8404*/ GIMT_Encode4(426807),
     /* 426775 */ /*GILLT_s64*//*Label 8405*/ GIMT_Encode4(426845), GIMT_Encode4(0),
     /* 426783 */ /*GILLT_v2s32*//*Label 8406*/ GIMT_Encode4(426986),
     /* 426787 */ /*GILLT_v2s64*//*Label 8407*/ GIMT_Encode4(427159),
     /* 426791 */ /*GILLT_v4s16*//*Label 8408*/ GIMT_Encode4(427332),
     /* 426795 */ /*GILLT_v4s32*//*Label 8409*/ GIMT_Encode4(427505), GIMT_Encode4(0),
     /* 426803 */ /*GILLT_v8s16*//*Label 8410*/ GIMT_Encode4(427678),
     /* 426807 */ // Label 8404: @426807
     /* 426807 */ GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(426844), // Rule ID 1626 //
     /* 426812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 426818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 426821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426833 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 426833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 426838 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426842 */   GIR_RootConstrainSelectedInstOperands,
     /* 426843 */   // GIR_Coverage, 1626,
     /* 426843 */   GIR_Done,
     /* 426844 */ // Label 8412: @426844
     /* 426844 */ GIM_Reject,
     /* 426845 */ // Label 8405: @426845
     /* 426845 */ GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(426985),
     /* 426850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 426853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 426856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426860 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(426895), // Rule ID 5283 //
     /* 426865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426872 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426878 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426886 */     // (AArch64fcmgt:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 426886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 426889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426893 */     GIR_RootConstrainSelectedInstOperands,
     /* 426894 */     // GIR_Coverage, 5283,
     /* 426894 */     GIR_EraseRootFromParent_Done,
     /* 426895 */   // Label 8414: @426895
     /* 426895 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(426930), // Rule ID 5281 //
     /* 426900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426911 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426917 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426921 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 426921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 426924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426928 */     GIR_RootConstrainSelectedInstOperands,
     /* 426929 */     // GIR_Coverage, 5281,
     /* 426929 */     GIR_EraseRootFromParent_Done,
     /* 426930 */   // Label 8415: @426930
     /* 426930 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(426957), // Rule ID 1625 //
     /* 426935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426946 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 426946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 426951 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426955 */     GIR_RootConstrainSelectedInstOperands,
     /* 426956 */     // GIR_Coverage, 1625,
     /* 426956 */     GIR_Done,
     /* 426957 */   // Label 8416: @426957
     /* 426957 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(426984), // Rule ID 5250 //
     /* 426962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426973 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 426973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 426978 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426982 */     GIR_RootConstrainSelectedInstOperands,
     /* 426983 */     // GIR_Coverage, 5250,
     /* 426983 */     GIR_Done,
     /* 426984 */   // Label 8417: @426984
     /* 426984 */   GIM_Reject,
     /* 426985 */ // Label 8413: @426985
     /* 426985 */ GIM_Reject,
     /* 426986 */ // Label 8406: @426986
     /* 426986 */ GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(427158),
     /* 426991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 426997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427001 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(427060), // Rule ID 1182 //
     /* 427006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427045 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 427045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 427048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427058 */     GIR_RootConstrainSelectedInstOperands,
     /* 427059 */     // GIR_Coverage, 1182,
     /* 427059 */     GIR_EraseRootFromParent_Done,
     /* 427060 */   // Label 8419: @427060
     /* 427060 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(427095), // Rule ID 793 //
     /* 427065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427072 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427078 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427086 */     // (AArch64fcmgt:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 427086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 427089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427093 */     GIR_RootConstrainSelectedInstOperands,
     /* 427094 */     // GIR_Coverage, 793,
     /* 427094 */     GIR_EraseRootFromParent_Done,
     /* 427095 */   // Label 8420: @427095
     /* 427095 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(427130), // Rule ID 783 //
     /* 427100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427111 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427117 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427121 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 427121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 427124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427128 */     GIR_RootConstrainSelectedInstOperands,
     /* 427129 */     // GIR_Coverage, 783,
     /* 427129 */     GIR_EraseRootFromParent_Done,
     /* 427130 */   // Label 8421: @427130
     /* 427130 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(427157), // Rule ID 1220 //
     /* 427135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427146 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 427146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 427151 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427155 */     GIR_RootConstrainSelectedInstOperands,
     /* 427156 */     // GIR_Coverage, 1220,
     /* 427156 */     GIR_Done,
     /* 427157 */   // Label 8422: @427157
     /* 427157 */   GIM_Reject,
     /* 427158 */ // Label 8418: @427158
     /* 427158 */ GIM_Reject,
     /* 427159 */ // Label 8407: @427159
     /* 427159 */ GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(427331),
     /* 427164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 427167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 427170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427174 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(427233), // Rule ID 1186 //
     /* 427179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 427194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 427211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427218 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 427218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 427221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427231 */     GIR_RootConstrainSelectedInstOperands,
     /* 427232 */     // GIR_Coverage, 1186,
     /* 427232 */     GIR_EraseRootFromParent_Done,
     /* 427233 */   // Label 8424: @427233
     /* 427233 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(427268), // Rule ID 795 //
     /* 427238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427245 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427251 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427259 */     // (AArch64fcmgt:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 427259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 427262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427266 */     GIR_RootConstrainSelectedInstOperands,
     /* 427267 */     // GIR_Coverage, 795,
     /* 427267 */     GIR_EraseRootFromParent_Done,
     /* 427268 */   // Label 8425: @427268
     /* 427268 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(427303), // Rule ID 785 //
     /* 427273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427284 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427290 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427294 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 427294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 427297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427301 */     GIR_RootConstrainSelectedInstOperands,
     /* 427302 */     // GIR_Coverage, 785,
     /* 427302 */     GIR_EraseRootFromParent_Done,
     /* 427303 */   // Label 8426: @427303
     /* 427303 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(427330), // Rule ID 1222 //
     /* 427308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427319 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 427319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 427324 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427328 */     GIR_RootConstrainSelectedInstOperands,
     /* 427329 */     // GIR_Coverage, 1222,
     /* 427329 */     GIR_Done,
     /* 427330 */   // Label 8427: @427330
     /* 427330 */   GIM_Reject,
     /* 427331 */ // Label 8423: @427331
     /* 427331 */ GIM_Reject,
     /* 427332 */ // Label 8408: @427332
     /* 427332 */ GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(427504),
     /* 427337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 427343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427347 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(427406), // Rule ID 1178 //
     /* 427352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427391 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 427391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 427394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427404 */     GIR_RootConstrainSelectedInstOperands,
     /* 427405 */     // GIR_Coverage, 1178,
     /* 427405 */     GIR_EraseRootFromParent_Done,
     /* 427406 */   // Label 8429: @427406
     /* 427406 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(427441), // Rule ID 791 //
     /* 427411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427418 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427424 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427432 */     // (AArch64fcmgt:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 427432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 427435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427439 */     GIR_RootConstrainSelectedInstOperands,
     /* 427440 */     // GIR_Coverage, 791,
     /* 427440 */     GIR_EraseRootFromParent_Done,
     /* 427441 */   // Label 8430: @427441
     /* 427441 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(427476), // Rule ID 781 //
     /* 427446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427457 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427463 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427467 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 427467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 427470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427474 */     GIR_RootConstrainSelectedInstOperands,
     /* 427475 */     // GIR_Coverage, 781,
     /* 427475 */     GIR_EraseRootFromParent_Done,
     /* 427476 */   // Label 8431: @427476
     /* 427476 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(427503), // Rule ID 1218 //
     /* 427481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427492 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 427492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 427497 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427501 */     GIR_RootConstrainSelectedInstOperands,
     /* 427502 */     // GIR_Coverage, 1218,
     /* 427502 */     GIR_Done,
     /* 427503 */   // Label 8432: @427503
     /* 427503 */   GIM_Reject,
     /* 427504 */ // Label 8428: @427504
     /* 427504 */ GIM_Reject,
     /* 427505 */ // Label 8409: @427505
     /* 427505 */ GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(427677),
     /* 427510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 427516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427520 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(427579), // Rule ID 1184 //
     /* 427525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427564 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 427564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 427567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427577 */     GIR_RootConstrainSelectedInstOperands,
     /* 427578 */     // GIR_Coverage, 1184,
     /* 427578 */     GIR_EraseRootFromParent_Done,
     /* 427579 */   // Label 8434: @427579
     /* 427579 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(427614), // Rule ID 794 //
     /* 427584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427591 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427597 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427605 */     // (AArch64fcmgt:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 427605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 427608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427612 */     GIR_RootConstrainSelectedInstOperands,
     /* 427613 */     // GIR_Coverage, 794,
     /* 427613 */     GIR_EraseRootFromParent_Done,
     /* 427614 */   // Label 8435: @427614
     /* 427614 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(427649), // Rule ID 784 //
     /* 427619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427630 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427636 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427640 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 427640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 427643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427647 */     GIR_RootConstrainSelectedInstOperands,
     /* 427648 */     // GIR_Coverage, 784,
     /* 427648 */     GIR_EraseRootFromParent_Done,
     /* 427649 */   // Label 8436: @427649
     /* 427649 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(427676), // Rule ID 1221 //
     /* 427654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427665 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 427665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 427670 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427674 */     GIR_RootConstrainSelectedInstOperands,
     /* 427675 */     // GIR_Coverage, 1221,
     /* 427675 */     GIR_Done,
     /* 427676 */   // Label 8437: @427676
     /* 427676 */   GIM_Reject,
     /* 427677 */ // Label 8433: @427677
     /* 427677 */ GIM_Reject,
     /* 427678 */ // Label 8410: @427678
     /* 427678 */ GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(427850),
     /* 427683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 427689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427693 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(427752), // Rule ID 1180 //
     /* 427698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427737 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 427737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 427740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427750 */     GIR_RootConstrainSelectedInstOperands,
     /* 427751 */     // GIR_Coverage, 1180,
     /* 427751 */     GIR_EraseRootFromParent_Done,
     /* 427752 */   // Label 8439: @427752
     /* 427752 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(427787), // Rule ID 792 //
     /* 427757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427764 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427770 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427778 */     // (AArch64fcmgt:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 427778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 427781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427785 */     GIR_RootConstrainSelectedInstOperands,
     /* 427786 */     // GIR_Coverage, 792,
     /* 427786 */     GIR_EraseRootFromParent_Done,
     /* 427787 */   // Label 8440: @427787
     /* 427787 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(427822), // Rule ID 782 //
     /* 427792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427803 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427809 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427813 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 427813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 427816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427820 */     GIR_RootConstrainSelectedInstOperands,
     /* 427821 */     // GIR_Coverage, 782,
     /* 427821 */     GIR_EraseRootFromParent_Done,
     /* 427822 */   // Label 8441: @427822
     /* 427822 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(427849), // Rule ID 1219 //
     /* 427827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427838 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 427838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 427843 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427847 */     GIR_RootConstrainSelectedInstOperands,
     /* 427848 */     // GIR_Coverage, 1219,
     /* 427848 */     GIR_Done,
     /* 427849 */   // Label 8442: @427849
     /* 427849 */   GIM_Reject,
     /* 427850 */ // Label 8438: @427850
     /* 427850 */ GIM_Reject,
     /* 427851 */ // Label 8411: @427851
     /* 427851 */ GIM_Reject,
     /* 427852 */ // Label 133: @427852
     /* 427852 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8447*/ GIMT_Encode4(428005),
     /* 427863 */ /*GILLT_s32*//*Label 8443*/ GIMT_Encode4(427903),
     /* 427867 */ /*GILLT_s64*//*Label 8444*/ GIMT_Encode4(427927), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 427891 */ /*GILLT_v8s8*//*Label 8445*/ GIMT_Encode4(427951), GIMT_Encode4(0),
     /* 427899 */ /*GILLT_v16s8*//*Label 8446*/ GIMT_Encode4(427978),
     /* 427903 */ // Label 8443: @427903
     /* 427903 */ GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(427926), // Rule ID 4015 //
     /* 427908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 427911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 427915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 427919 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 427919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 427924 */   GIR_RootConstrainSelectedInstOperands,
     /* 427925 */   // GIR_Coverage, 4015,
     /* 427925 */   GIR_Done,
     /* 427926 */ // Label 8448: @427926
     /* 427926 */ GIM_Reject,
     /* 427927 */ // Label 8444: @427927
     /* 427927 */ GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(427950), // Rule ID 4016 //
     /* 427932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 427935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 427939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 427943 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 427943 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 427948 */   GIR_RootConstrainSelectedInstOperands,
     /* 427949 */   // GIR_Coverage, 4016,
     /* 427949 */   GIR_Done,
     /* 427950 */ // Label 8449: @427950
     /* 427950 */ GIM_Reject,
     /* 427951 */ // Label 8445: @427951
     /* 427951 */ GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(427977), // Rule ID 976 //
     /* 427956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 427962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427970 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 427970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 427975 */   GIR_RootConstrainSelectedInstOperands,
     /* 427976 */   // GIR_Coverage, 976,
     /* 427976 */   GIR_Done,
     /* 427977 */ // Label 8450: @427977
     /* 427977 */ GIM_Reject,
     /* 427978 */ // Label 8446: @427978
     /* 427978 */ GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(428004), // Rule ID 977 //
     /* 427983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 427989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427997 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 427997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 428002 */   GIR_RootConstrainSelectedInstOperands,
     /* 428003 */   // GIR_Coverage, 977,
     /* 428003 */   GIR_Done,
     /* 428004 */ // Label 8451: @428004
     /* 428004 */ GIM_Reject,
     /* 428005 */ // Label 8447: @428005
     /* 428005 */ GIM_Reject,
     /* 428006 */ // Label 134: @428006
     /* 428006 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8456*/ GIMT_Encode4(428181),
     /* 428017 */ /*GILLT_v4s16*//*Label 8452*/ GIMT_Encode4(428037), GIMT_Encode4(0),
     /* 428025 */ /*GILLT_v8s8*//*Label 8453*/ GIMT_Encode4(428082),
     /* 428029 */ /*GILLT_v8s16*//*Label 8454*/ GIMT_Encode4(428109),
     /* 428033 */ /*GILLT_v16s8*//*Label 8455*/ GIMT_Encode4(428154),
     /* 428037 */ // Label 8452: @428037
     /* 428037 */ GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(428081),
     /* 428042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428053 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(428068), // Rule ID 980 //
     /* 428058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428061 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 428061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 428066 */     GIR_RootConstrainSelectedInstOperands,
     /* 428067 */     // GIR_Coverage, 980,
     /* 428067 */     GIR_Done,
     /* 428068 */   // Label 8458: @428068
     /* 428068 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(428080), // Rule ID 4998 //
     /* 428073 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 428073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 428078 */     GIR_RootConstrainSelectedInstOperands,
     /* 428079 */     // GIR_Coverage, 4998,
     /* 428079 */     GIR_Done,
     /* 428080 */   // Label 8459: @428080
     /* 428080 */   GIM_Reject,
     /* 428081 */ // Label 8457: @428081
     /* 428081 */ GIM_Reject,
     /* 428082 */ // Label 8453: @428082
     /* 428082 */ GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(428108), // Rule ID 978 //
     /* 428087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 428093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428101 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 428101 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 428106 */   GIR_RootConstrainSelectedInstOperands,
     /* 428107 */   // GIR_Coverage, 978,
     /* 428107 */   GIR_Done,
     /* 428108 */ // Label 8460: @428108
     /* 428108 */ GIM_Reject,
     /* 428109 */ // Label 8454: @428109
     /* 428109 */ GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(428153),
     /* 428114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428125 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(428140), // Rule ID 981 //
     /* 428130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428133 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 428133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 428138 */     GIR_RootConstrainSelectedInstOperands,
     /* 428139 */     // GIR_Coverage, 981,
     /* 428139 */     GIR_Done,
     /* 428140 */   // Label 8462: @428140
     /* 428140 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(428152), // Rule ID 5000 //
     /* 428145 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 428145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 428150 */     GIR_RootConstrainSelectedInstOperands,
     /* 428151 */     // GIR_Coverage, 5000,
     /* 428151 */     GIR_Done,
     /* 428152 */   // Label 8463: @428152
     /* 428152 */   GIM_Reject,
     /* 428153 */ // Label 8461: @428153
     /* 428153 */ GIM_Reject,
     /* 428154 */ // Label 8455: @428154
     /* 428154 */ GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(428180), // Rule ID 979 //
     /* 428159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 428165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428173 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 428173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 428178 */   GIR_RootConstrainSelectedInstOperands,
     /* 428179 */   // GIR_Coverage, 979,
     /* 428179 */   GIR_Done,
     /* 428180 */ // Label 8464: @428180
     /* 428180 */ GIM_Reject,
     /* 428181 */ // Label 8456: @428181
     /* 428181 */ GIM_Reject,
     /* 428182 */ // Label 135: @428182
     /* 428182 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8471*/ GIMT_Encode4(428455),
     /* 428193 */ /*GILLT_v2s32*//*Label 8465*/ GIMT_Encode4(428221), GIMT_Encode4(0),
     /* 428201 */ /*GILLT_v4s16*//*Label 8466*/ GIMT_Encode4(428266),
     /* 428205 */ /*GILLT_v4s32*//*Label 8467*/ GIMT_Encode4(428311),
     /* 428209 */ /*GILLT_v8s8*//*Label 8468*/ GIMT_Encode4(428356),
     /* 428213 */ /*GILLT_v8s16*//*Label 8469*/ GIMT_Encode4(428383),
     /* 428217 */ /*GILLT_v16s8*//*Label 8470*/ GIMT_Encode4(428428),
     /* 428221 */ // Label 8465: @428221
     /* 428221 */ GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(428265),
     /* 428226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428237 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(428252), // Rule ID 986 //
     /* 428242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428245 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 428245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 428250 */     GIR_RootConstrainSelectedInstOperands,
     /* 428251 */     // GIR_Coverage, 986,
     /* 428251 */     GIR_Done,
     /* 428252 */   // Label 8473: @428252
     /* 428252 */   GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(428264), // Rule ID 5002 //
     /* 428257 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 428257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 428262 */     GIR_RootConstrainSelectedInstOperands,
     /* 428263 */     // GIR_Coverage, 5002,
     /* 428263 */     GIR_Done,
     /* 428264 */   // Label 8474: @428264
     /* 428264 */   GIM_Reject,
     /* 428265 */ // Label 8472: @428265
     /* 428265 */ GIM_Reject,
     /* 428266 */ // Label 8466: @428266
     /* 428266 */ GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(428310),
     /* 428271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428282 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(428297), // Rule ID 984 //
     /* 428287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428290 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 428290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 428295 */     GIR_RootConstrainSelectedInstOperands,
     /* 428296 */     // GIR_Coverage, 984,
     /* 428296 */     GIR_Done,
     /* 428297 */   // Label 8476: @428297
     /* 428297 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(428309), // Rule ID 4999 //
     /* 428302 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 428302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 428307 */     GIR_RootConstrainSelectedInstOperands,
     /* 428308 */     // GIR_Coverage, 4999,
     /* 428308 */     GIR_Done,
     /* 428309 */   // Label 8477: @428309
     /* 428309 */   GIM_Reject,
     /* 428310 */ // Label 8475: @428310
     /* 428310 */ GIM_Reject,
     /* 428311 */ // Label 8467: @428311
     /* 428311 */ GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(428355),
     /* 428316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428327 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(428342), // Rule ID 987 //
     /* 428332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428335 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 428335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 428340 */     GIR_RootConstrainSelectedInstOperands,
     /* 428341 */     // GIR_Coverage, 987,
     /* 428341 */     GIR_Done,
     /* 428342 */   // Label 8479: @428342
     /* 428342 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(428354), // Rule ID 5003 //
     /* 428347 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 428347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 428352 */     GIR_RootConstrainSelectedInstOperands,
     /* 428353 */     // GIR_Coverage, 5003,
     /* 428353 */     GIR_Done,
     /* 428354 */   // Label 8480: @428354
     /* 428354 */   GIM_Reject,
     /* 428355 */ // Label 8478: @428355
     /* 428355 */ GIM_Reject,
     /* 428356 */ // Label 8468: @428356
     /* 428356 */ GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(428382), // Rule ID 982 //
     /* 428361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 428367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428375 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 428375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 428380 */   GIR_RootConstrainSelectedInstOperands,
     /* 428381 */   // GIR_Coverage, 982,
     /* 428381 */   GIR_Done,
     /* 428382 */ // Label 8481: @428382
     /* 428382 */ GIM_Reject,
     /* 428383 */ // Label 8469: @428383
     /* 428383 */ GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(428427),
     /* 428388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428399 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(428414), // Rule ID 985 //
     /* 428404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428407 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 428407 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 428412 */     GIR_RootConstrainSelectedInstOperands,
     /* 428413 */     // GIR_Coverage, 985,
     /* 428413 */     GIR_Done,
     /* 428414 */   // Label 8483: @428414
     /* 428414 */   GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(428426), // Rule ID 5001 //
     /* 428419 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 428419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 428424 */     GIR_RootConstrainSelectedInstOperands,
     /* 428425 */     // GIR_Coverage, 5001,
     /* 428425 */     GIR_Done,
     /* 428426 */   // Label 8484: @428426
     /* 428426 */   GIM_Reject,
     /* 428427 */ // Label 8482: @428427
     /* 428427 */ GIM_Reject,
     /* 428428 */ // Label 8470: @428428
     /* 428428 */ GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(428454), // Rule ID 983 //
     /* 428433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 428439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428447 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 428447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 428452 */   GIR_RootConstrainSelectedInstOperands,
     /* 428453 */   // GIR_Coverage, 983,
     /* 428453 */   GIR_Done,
     /* 428454 */ // Label 8485: @428454
     /* 428454 */ GIM_Reject,
     /* 428455 */ // Label 8471: @428455
     /* 428455 */ GIM_Reject,
     /* 428456 */ // Label 136: @428456
     /* 428456 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8492*/ GIMT_Encode4(428661),
     /* 428467 */ /*GILLT_s64*//*Label 8486*/ GIMT_Encode4(428499), GIMT_Encode4(0),
     /* 428475 */ /*GILLT_v2s32*//*Label 8487*/ GIMT_Encode4(428526),
     /* 428479 */ /*GILLT_v2s64*//*Label 8488*/ GIMT_Encode4(428553),
     /* 428483 */ /*GILLT_v4s16*//*Label 8489*/ GIMT_Encode4(428580),
     /* 428487 */ /*GILLT_v4s32*//*Label 8490*/ GIMT_Encode4(428607), GIMT_Encode4(0),
     /* 428495 */ /*GILLT_v8s16*//*Label 8491*/ GIMT_Encode4(428634),
     /* 428499 */ // Label 8486: @428499
     /* 428499 */ GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(428525), // Rule ID 1008 //
     /* 428504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428518 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 428518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 428523 */   GIR_RootConstrainSelectedInstOperands,
     /* 428524 */   // GIR_Coverage, 1008,
     /* 428524 */   GIR_Done,
     /* 428525 */ // Label 8493: @428525
     /* 428525 */ GIM_Reject,
     /* 428526 */ // Label 8487: @428526
     /* 428526 */ GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(428552), // Rule ID 1004 //
     /* 428531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428545 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 428545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 428550 */   GIR_RootConstrainSelectedInstOperands,
     /* 428551 */   // GIR_Coverage, 1004,
     /* 428551 */   GIR_Done,
     /* 428552 */ // Label 8494: @428552
     /* 428552 */ GIM_Reject,
     /* 428553 */ // Label 8488: @428553
     /* 428553 */ GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(428579), // Rule ID 1010 //
     /* 428558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428572 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 428572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 428577 */   GIR_RootConstrainSelectedInstOperands,
     /* 428578 */   // GIR_Coverage, 1010,
     /* 428578 */   GIR_Done,
     /* 428579 */ // Label 8495: @428579
     /* 428579 */ GIM_Reject,
     /* 428580 */ // Label 8489: @428580
     /* 428580 */ GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(428606), // Rule ID 1000 //
     /* 428585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 428591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428599 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 428599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 428604 */   GIR_RootConstrainSelectedInstOperands,
     /* 428605 */   // GIR_Coverage, 1000,
     /* 428605 */   GIR_Done,
     /* 428606 */ // Label 8496: @428606
     /* 428606 */ GIM_Reject,
     /* 428607 */ // Label 8490: @428607
     /* 428607 */ GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(428633), // Rule ID 1006 //
     /* 428612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428626 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 428626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 428631 */   GIR_RootConstrainSelectedInstOperands,
     /* 428632 */   // GIR_Coverage, 1006,
     /* 428632 */   GIR_Done,
     /* 428633 */ // Label 8497: @428633
     /* 428633 */ GIM_Reject,
     /* 428634 */ // Label 8491: @428634
     /* 428634 */ GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(428660), // Rule ID 1002 //
     /* 428639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 428645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428653 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 428653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 428658 */   GIR_RootConstrainSelectedInstOperands,
     /* 428659 */   // GIR_Coverage, 1002,
     /* 428659 */   GIR_Done,
     /* 428660 */ // Label 8498: @428660
     /* 428660 */ GIM_Reject,
     /* 428661 */ // Label 8492: @428661
     /* 428661 */ GIM_Reject,
     /* 428662 */ // Label 137: @428662
     /* 428662 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8501*/ GIMT_Encode4(429060),
     /* 428673 */ /*GILLT_v2s64*//*Label 8499*/ GIMT_Encode4(428685), GIMT_Encode4(0),
     /* 428681 */ /*GILLT_v4s32*//*Label 8500*/ GIMT_Encode4(428823),
     /* 428685 */ // Label 8499: @428685
     /* 428685 */ GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(428744), // Rule ID 5930 //
     /* 428690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428701 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 428701 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 428704 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 428708 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428713 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 428733 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428738 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428743 */   // GIR_Coverage, 5930,
     /* 428743 */   GIR_EraseRootFromParent_Done,
     /* 428744 */ // Label 8502: @428744
     /* 428744 */ GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(428822), // Rule ID 6052 //
     /* 428749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428760 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 428760 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 428763 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 428767 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428772 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 428778 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 428781 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 428785 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 428795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428797 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428800 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 428803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 428806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428811 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428816 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428821 */   // GIR_Coverage, 6052,
     /* 428821 */   GIR_EraseRootFromParent_Done,
     /* 428822 */ // Label 8503: @428822
     /* 428822 */ GIM_Reject,
     /* 428823 */ // Label 8500: @428823
     /* 428823 */ GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(428882), // Rule ID 5926 //
     /* 428828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 428831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428839 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 428839 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 428842 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 428846 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428851 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428865 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 428871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428876 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 428881 */   // GIR_Coverage, 5926,
     /* 428881 */   GIR_EraseRootFromParent_Done,
     /* 428882 */ // Label 8504: @428882
     /* 428882 */ GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(428941), // Rule ID 5927 //
     /* 428887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428898 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 428898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 428901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 428905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428910 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428924 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 428930 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428935 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428940 */   // GIR_Coverage, 5927,
     /* 428940 */   GIR_EraseRootFromParent_Done,
     /* 428941 */ // Label 8505: @428941
     /* 428941 */ GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(429000), // Rule ID 5928 //
     /* 428946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 428949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428957 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 428957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 428960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 428964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428969 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 428989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428994 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 428999 */   // GIR_Coverage, 5928,
     /* 428999 */   GIR_EraseRootFromParent_Done,
     /* 429000 */ // Label 8506: @429000
     /* 429000 */ GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(429059), // Rule ID 5929 //
     /* 429005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429016 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 429016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 429019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 429023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 429028 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 429032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 429034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 429037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 429045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 429048 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 429058 */   // GIR_Coverage, 5929,
     /* 429058 */   GIR_EraseRootFromParent_Done,
     /* 429059 */ // Label 8507: @429059
     /* 429059 */ GIM_Reject,
     /* 429060 */ // Label 8501: @429060
     /* 429060 */ GIM_Reject,
     /* 429061 */ // Label 138: @429061
     /* 429061 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8512*/ GIMT_Encode4(429430),
     /* 429072 */ /*GILLT_v2s32*//*Label 8508*/ GIMT_Encode4(429132), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 429084 */ /*GILLT_v4s32*//*Label 8509*/ GIMT_Encode4(429252), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 429116 */ /*GILLT_nxv2s64*//*Label 8510*/ GIMT_Encode4(429372), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 429128 */ /*GILLT_nxv4s32*//*Label 8511*/ GIMT_Encode4(429401),
     /* 429132 */ // Label 8508: @429132
     /* 429132 */ GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(429251),
     /* 429137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 429143 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 429146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429158 */   GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(429231), // Rule ID 26 //
     /* 429163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 429166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 429170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 429174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429190 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429207 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429211 */     // MIs[3] Operand 1
     /* 429211 */     // No operand predicates
     /* 429211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429213 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 429216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 429220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429229 */     GIR_RootConstrainSelectedInstOperands,
     /* 429230 */     // GIR_Coverage, 26,
     /* 429230 */     GIR_EraseRootFromParent_Done,
     /* 429231 */   // Label 8514: @429231
     /* 429231 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(429250), // Rule ID 22 //
     /* 429236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 429239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429243 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 429243 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 429248 */     GIR_RootConstrainSelectedInstOperands,
     /* 429249 */     // GIR_Coverage, 22,
     /* 429249 */     GIR_Done,
     /* 429250 */   // Label 8515: @429250
     /* 429250 */   GIM_Reject,
     /* 429251 */ // Label 8513: @429251
     /* 429251 */ GIM_Reject,
     /* 429252 */ // Label 8509: @429252
     /* 429252 */ GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(429371),
     /* 429257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 429263 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 429266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429278 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(429351), // Rule ID 27 //
     /* 429283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 429286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 429290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 429294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429323 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429327 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429331 */     // MIs[3] Operand 1
     /* 429331 */     // No operand predicates
     /* 429331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429333 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 429336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 429340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429349 */     GIR_RootConstrainSelectedInstOperands,
     /* 429350 */     // GIR_Coverage, 27,
     /* 429350 */     GIR_EraseRootFromParent_Done,
     /* 429351 */   // Label 8517: @429351
     /* 429351 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(429370), // Rule ID 23 //
     /* 429356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 429359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429363 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 429363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 429368 */     GIR_RootConstrainSelectedInstOperands,
     /* 429369 */     // GIR_Coverage, 23,
     /* 429369 */     GIR_Done,
     /* 429370 */   // Label 8518: @429370
     /* 429370 */   GIM_Reject,
     /* 429371 */ // Label 8516: @429371
     /* 429371 */ GIM_Reject,
     /* 429372 */ // Label 8510: @429372
     /* 429372 */ GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(429400), // Rule ID 2986 //
     /* 429377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 429380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 429383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 429386 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 429389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 429393 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 429393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 429398 */   GIR_RootConstrainSelectedInstOperands,
     /* 429399 */   // GIR_Coverage, 2986,
     /* 429399 */   GIR_Done,
     /* 429400 */ // Label 8519: @429400
     /* 429400 */ GIM_Reject,
     /* 429401 */ // Label 8511: @429401
     /* 429401 */ GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(429429), // Rule ID 2985 //
     /* 429406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 429409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 429412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 429415 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 429418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 429422 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 429422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 429427 */   GIR_RootConstrainSelectedInstOperands,
     /* 429428 */   // GIR_Coverage, 2985,
     /* 429428 */   GIR_Done,
     /* 429429 */ // Label 8520: @429429
     /* 429429 */ GIM_Reject,
     /* 429430 */ // Label 8512: @429430
     /* 429430 */ GIM_Reject,
     /* 429431 */ // Label 139: @429431
     /* 429431 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8524*/ GIMT_Encode4(429547),
     /* 429442 */ /*GILLT_s16*//*Label 8521*/ GIMT_Encode4(429454),
     /* 429446 */ /*GILLT_s32*//*Label 8522*/ GIMT_Encode4(429485),
     /* 429450 */ /*GILLT_s64*//*Label 8523*/ GIMT_Encode4(429516),
     /* 429454 */ // Label 8521: @429454
     /* 429454 */ GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(429484), // Rule ID 1658 //
     /* 429459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 429462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 429465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 429469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 429473 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 429473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 429478 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429482 */   GIR_RootConstrainSelectedInstOperands,
     /* 429483 */   // GIR_Coverage, 1658,
     /* 429483 */   GIR_Done,
     /* 429484 */ // Label 8525: @429484
     /* 429484 */ GIM_Reject,
     /* 429485 */ // Label 8522: @429485
     /* 429485 */ GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(429515), // Rule ID 1657 //
     /* 429490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 429493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 429496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 429500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 429504 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 429504 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 429509 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429513 */   GIR_RootConstrainSelectedInstOperands,
     /* 429514 */   // GIR_Coverage, 1657,
     /* 429514 */   GIR_Done,
     /* 429515 */ // Label 8526: @429515
     /* 429515 */ GIM_Reject,
     /* 429516 */ // Label 8523: @429516
     /* 429516 */ GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(429546), // Rule ID 1656 //
     /* 429521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 429524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 429527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429535 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 429535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 429540 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429544 */   GIR_RootConstrainSelectedInstOperands,
     /* 429545 */   // GIR_Coverage, 1656,
     /* 429545 */   GIR_Done,
     /* 429546 */ // Label 8527: @429546
     /* 429546 */ GIM_Reject,
     /* 429547 */ // Label 8524: @429547
     /* 429547 */ GIM_Reject,
     /* 429548 */ // Label 140: @429548
     /* 429548 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8531*/ GIMT_Encode4(430780),
     /* 429559 */ /*GILLT_v2s64*//*Label 8528*/ GIMT_Encode4(429579), GIMT_Encode4(0),
     /* 429567 */ /*GILLT_v4s32*//*Label 8529*/ GIMT_Encode4(430140), GIMT_Encode4(0),
     /* 429575 */ /*GILLT_v8s16*//*Label 8530*/ GIMT_Encode4(430701),
     /* 429579 */ // Label 8528: @429579
     /* 429579 */ GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(430139),
     /* 429584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 429590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429594 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(429686), // Rule ID 2054 //
     /* 429599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429643 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429647 */     // MIs[3] Operand 1
     /* 429647 */     // No operand predicates
     /* 429647 */     // MIs[1] Operand 2
     /* 429647 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 429658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 429667 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 429670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429684 */     GIR_RootConstrainSelectedInstOperands,
     /* 429685 */     // GIR_Coverage, 2054,
     /* 429685 */     GIR_EraseRootFromParent_Done,
     /* 429686 */   // Label 8533: @429686
     /* 429686 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(429778), // Rule ID 13586 //
     /* 429691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429735 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429739 */     // MIs[3] Operand 1
     /* 429739 */     // No operand predicates
     /* 429739 */     // MIs[1] Operand 2
     /* 429739 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 429750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 429759 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 429762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429776 */     GIR_RootConstrainSelectedInstOperands,
     /* 429777 */     // GIR_Coverage, 13586,
     /* 429777 */     GIR_EraseRootFromParent_Done,
     /* 429778 */   // Label 8534: @429778
     /* 429778 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(429864), // Rule ID 13584 //
     /* 429783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429827 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429831 */     // MIs[3] Operand 1
     /* 429831 */     // No operand predicates
     /* 429831 */     // MIs[1] Operand 2
     /* 429831 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 429842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429848 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 429851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429862 */     GIR_RootConstrainSelectedInstOperands,
     /* 429863 */     // GIR_Coverage, 13584,
     /* 429863 */     GIR_EraseRootFromParent_Done,
     /* 429864 */   // Label 8535: @429864
     /* 429864 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(429950), // Rule ID 2052 //
     /* 429869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429900 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429917 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429921 */     // MIs[3] Operand 1
     /* 429921 */     // No operand predicates
     /* 429921 */     // MIs[1] Operand 2
     /* 429921 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 429932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429934 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 429937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429948 */     GIR_RootConstrainSelectedInstOperands,
     /* 429949 */     // GIR_Coverage, 2052,
     /* 429949 */     GIR_EraseRootFromParent_Done,
     /* 429950 */   // Label 8536: @429950
     /* 429950 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(429989), // Rule ID 1741 //
     /* 429955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 429965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 429972 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 429972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 429975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 429987 */     GIR_RootConstrainSelectedInstOperands,
     /* 429988 */     // GIR_Coverage, 1741,
     /* 429988 */     GIR_EraseRootFromParent_Done,
     /* 429989 */   // Label 8537: @429989
     /* 429989 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(430052), // Rule ID 13585 //
     /* 429994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 430013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 430022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430026 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430030 */     // MIs[2] Operand 1
     /* 430030 */     // No operand predicates
     /* 430030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 430036 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 430039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 430047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 430050 */     GIR_RootConstrainSelectedInstOperands,
     /* 430051 */     // GIR_Coverage, 13585,
     /* 430051 */     GIR_EraseRootFromParent_Done,
     /* 430052 */   // Label 8538: @430052
     /* 430052 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(430115), // Rule ID 2053 //
     /* 430057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 430080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 430089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430093 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430097 */     // MIs[2] Operand 1
     /* 430097 */     // No operand predicates
     /* 430097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 430099 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 430102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 430106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 430110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 430113 */     GIR_RootConstrainSelectedInstOperands,
     /* 430114 */     // GIR_Coverage, 2053,
     /* 430114 */     GIR_EraseRootFromParent_Done,
     /* 430115 */   // Label 8539: @430115
     /* 430115 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(430138), // Rule ID 1740 //
     /* 430120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430131 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 430131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 430136 */     GIR_RootConstrainSelectedInstOperands,
     /* 430137 */     // GIR_Coverage, 1740,
     /* 430137 */     GIR_Done,
     /* 430138 */   // Label 8540: @430138
     /* 430138 */   GIM_Reject,
     /* 430139 */ // Label 8532: @430139
     /* 430139 */ GIM_Reject,
     /* 430140 */ // Label 8529: @430140
     /* 430140 */ GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(430700),
     /* 430145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 430148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 430151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430155 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(430247), // Rule ID 2051 //
     /* 430160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 430183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 430196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430204 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 430208 */     // MIs[3] Operand 1
     /* 430208 */     // No operand predicates
     /* 430208 */     // MIs[1] Operand 2
     /* 430208 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 430219 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 430228 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 430231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430245 */     GIR_RootConstrainSelectedInstOperands,
     /* 430246 */     // GIR_Coverage, 2051,
     /* 430246 */     GIR_EraseRootFromParent_Done,
     /* 430247 */   // Label 8542: @430247
     /* 430247 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(430339), // Rule ID 13583 //
     /* 430252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 430275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 430288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430296 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 430300 */     // MIs[3] Operand 1
     /* 430300 */     // No operand predicates
     /* 430300 */     // MIs[1] Operand 2
     /* 430300 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 430311 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 430320 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 430323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430337 */     GIR_RootConstrainSelectedInstOperands,
     /* 430338 */     // GIR_Coverage, 13583,
     /* 430338 */     GIR_EraseRootFromParent_Done,
     /* 430339 */   // Label 8543: @430339
     /* 430339 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(430425), // Rule ID 13581 //
     /* 430344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 430367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 430380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430388 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 430392 */     // MIs[3] Operand 1
     /* 430392 */     // No operand predicates
     /* 430392 */     // MIs[1] Operand 2
     /* 430392 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 430403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430409 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 430412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430423 */     GIR_RootConstrainSelectedInstOperands,
     /* 430424 */     // GIR_Coverage, 13581,
     /* 430424 */     GIR_EraseRootFromParent_Done,
     /* 430425 */   // Label 8544: @430425
     /* 430425 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(430511), // Rule ID 2049 //
     /* 430430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 430457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 430470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430478 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 430482 */     // MIs[3] Operand 1
     /* 430482 */     // No operand predicates
     /* 430482 */     // MIs[1] Operand 2
     /* 430482 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 430493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430495 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 430498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 430502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430509 */     GIR_RootConstrainSelectedInstOperands,
     /* 430510 */     // GIR_Coverage, 2049,
     /* 430510 */     GIR_EraseRootFromParent_Done,
     /* 430511 */   // Label 8545: @430511
     /* 430511 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(430550), // Rule ID 1739 //
     /* 430516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 430526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 430533 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 430533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 430536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 430548 */     GIR_RootConstrainSelectedInstOperands,
     /* 430549 */     // GIR_Coverage, 1739,
     /* 430549 */     GIR_EraseRootFromParent_Done,
     /* 430550 */   // Label 8546: @430550
     /* 430550 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(430613), // Rule ID 13582 //
     /* 430555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 430566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 430574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 430579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 430583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430587 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 430591 */     // MIs[2] Operand 1
     /* 430591 */     // No operand predicates
     /* 430591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 430597 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 430600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 430608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 430611 */     GIR_RootConstrainSelectedInstOperands,
     /* 430612 */     // GIR_Coverage, 13582,
     /* 430612 */     GIR_EraseRootFromParent_Done,
     /* 430613 */   // Label 8547: @430613
     /* 430613 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(430676), // Rule ID 2050 //
     /* 430618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 430633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 430641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 430646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 430650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430654 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 430658 */     // MIs[2] Operand 1
     /* 430658 */     // No operand predicates
     /* 430658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 430660 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 430663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 430667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 430671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 430674 */     GIR_RootConstrainSelectedInstOperands,
     /* 430675 */     // GIR_Coverage, 2050,
     /* 430675 */     GIR_EraseRootFromParent_Done,
     /* 430676 */   // Label 8548: @430676
     /* 430676 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(430699), // Rule ID 1738 //
     /* 430681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430692 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 430692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 430697 */     GIR_RootConstrainSelectedInstOperands,
     /* 430698 */     // GIR_Coverage, 1738,
     /* 430698 */     GIR_Done,
     /* 430699 */   // Label 8549: @430699
     /* 430699 */   GIM_Reject,
     /* 430700 */ // Label 8541: @430700
     /* 430700 */ GIM_Reject,
     /* 430701 */ // Label 8530: @430701
     /* 430701 */ GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(430779),
     /* 430706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 430709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 430712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430716 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(430755), // Rule ID 1737 //
     /* 430721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 430731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 430738 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 430738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 430741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 430753 */     GIR_RootConstrainSelectedInstOperands,
     /* 430754 */     // GIR_Coverage, 1737,
     /* 430754 */     GIR_EraseRootFromParent_Done,
     /* 430755 */   // Label 8551: @430755
     /* 430755 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(430778), // Rule ID 1736 //
     /* 430760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430771 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 430771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 430776 */     GIR_RootConstrainSelectedInstOperands,
     /* 430777 */     // GIR_Coverage, 1736,
     /* 430777 */     GIR_Done,
     /* 430778 */   // Label 8552: @430778
     /* 430778 */   GIM_Reject,
     /* 430779 */ // Label 8550: @430779
     /* 430779 */ GIM_Reject,
     /* 430780 */ // Label 8531: @430780
     /* 430780 */ GIM_Reject,
     /* 430781 */ // Label 141: @430781
     /* 430781 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8571*/ GIMT_Encode4(431560),
     /* 430792 */ /*GILLT_v2s32*//*Label 8553*/ GIMT_Encode4(430868),
     /* 430796 */ /*GILLT_v2s64*//*Label 8554*/ GIMT_Encode4(430923),
     /* 430800 */ /*GILLT_v4s16*//*Label 8555*/ GIMT_Encode4(430978),
     /* 430804 */ /*GILLT_v4s32*//*Label 8556*/ GIMT_Encode4(431033),
     /* 430808 */ /*GILLT_v8s8*//*Label 8557*/ GIMT_Encode4(431088),
     /* 430812 */ /*GILLT_v8s16*//*Label 8558*/ GIMT_Encode4(431122),
     /* 430816 */ /*GILLT_v16s8*//*Label 8559*/ GIMT_Encode4(431177), GIMT_Encode4(0),
     /* 430824 */ /*GILLT_nxv2s1*//*Label 8560*/ GIMT_Encode4(431211),
     /* 430828 */ /*GILLT_nxv2s16*//*Label 8561*/ GIMT_Encode4(431237),
     /* 430832 */ /*GILLT_nxv2s32*//*Label 8562*/ GIMT_Encode4(431263),
     /* 430836 */ /*GILLT_nxv2s64*//*Label 8563*/ GIMT_Encode4(431289),
     /* 430840 */ /*GILLT_nxv4s1*//*Label 8564*/ GIMT_Encode4(431336),
     /* 430844 */ /*GILLT_nxv4s16*//*Label 8565*/ GIMT_Encode4(431362),
     /* 430848 */ /*GILLT_nxv4s32*//*Label 8566*/ GIMT_Encode4(431388),
     /* 430852 */ /*GILLT_nxv8s1*//*Label 8567*/ GIMT_Encode4(431435),
     /* 430856 */ /*GILLT_nxv8s16*//*Label 8568*/ GIMT_Encode4(431461),
     /* 430860 */ /*GILLT_nxv16s1*//*Label 8569*/ GIMT_Encode4(431508),
     /* 430864 */ /*GILLT_nxv16s8*//*Label 8570*/ GIMT_Encode4(431534),
     /* 430868 */ // Label 8553: @430868
     /* 430868 */ GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(430922),
     /* 430873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 430876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 430879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430891 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(430906), // Rule ID 1874 //
     /* 430896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430899 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 430899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 430904 */     GIR_RootConstrainSelectedInstOperands,
     /* 430905 */     // GIR_Coverage, 1874,
     /* 430905 */     GIR_Done,
     /* 430906 */   // Label 8573: @430906
     /* 430906 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(430921), // Rule ID 2505 //
     /* 430911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430914 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 430914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 430919 */     GIR_RootConstrainSelectedInstOperands,
     /* 430920 */     // GIR_Coverage, 2505,
     /* 430920 */     GIR_Done,
     /* 430921 */   // Label 8574: @430921
     /* 430921 */   GIM_Reject,
     /* 430922 */ // Label 8572: @430922
     /* 430922 */ GIM_Reject,
     /* 430923 */ // Label 8554: @430923
     /* 430923 */ GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(430977),
     /* 430928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 430931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 430934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430942 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430946 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(430961), // Rule ID 1876 //
     /* 430951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430954 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 430954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 430959 */     GIR_RootConstrainSelectedInstOperands,
     /* 430960 */     // GIR_Coverage, 1876,
     /* 430960 */     GIR_Done,
     /* 430961 */   // Label 8576: @430961
     /* 430961 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(430976), // Rule ID 2507 //
     /* 430966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430969 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 430969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 430974 */     GIR_RootConstrainSelectedInstOperands,
     /* 430975 */     // GIR_Coverage, 2507,
     /* 430975 */     GIR_Done,
     /* 430976 */   // Label 8577: @430976
     /* 430976 */   GIM_Reject,
     /* 430977 */ // Label 8575: @430977
     /* 430977 */ GIM_Reject,
     /* 430978 */ // Label 8555: @430978
     /* 430978 */ GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(431032),
     /* 430983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 430986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 430989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431001 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(431016), // Rule ID 1872 //
     /* 431006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431009 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 431009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 431014 */     GIR_RootConstrainSelectedInstOperands,
     /* 431015 */     // GIR_Coverage, 1872,
     /* 431015 */     GIR_Done,
     /* 431016 */   // Label 8579: @431016
     /* 431016 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(431031), // Rule ID 2503 //
     /* 431021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431024 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 431024 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 431029 */     GIR_RootConstrainSelectedInstOperands,
     /* 431030 */     // GIR_Coverage, 2503,
     /* 431030 */     GIR_Done,
     /* 431031 */   // Label 8580: @431031
     /* 431031 */   GIM_Reject,
     /* 431032 */ // Label 8578: @431032
     /* 431032 */ GIM_Reject,
     /* 431033 */ // Label 8556: @431033
     /* 431033 */ GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(431087),
     /* 431038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 431044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431056 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(431071), // Rule ID 1875 //
     /* 431061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431064 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 431064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 431069 */     GIR_RootConstrainSelectedInstOperands,
     /* 431070 */     // GIR_Coverage, 1875,
     /* 431070 */     GIR_Done,
     /* 431071 */   // Label 8582: @431071
     /* 431071 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(431086), // Rule ID 2506 //
     /* 431076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431079 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 431079 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 431084 */     GIR_RootConstrainSelectedInstOperands,
     /* 431085 */     // GIR_Coverage, 2506,
     /* 431085 */     GIR_Done,
     /* 431086 */   // Label 8583: @431086
     /* 431086 */   GIM_Reject,
     /* 431087 */ // Label 8581: @431087
     /* 431087 */ GIM_Reject,
     /* 431088 */ // Label 8557: @431088
     /* 431088 */ GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(431121), // Rule ID 1870 //
     /* 431093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 431099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 431102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431114 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 431114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 431119 */   GIR_RootConstrainSelectedInstOperands,
     /* 431120 */   // GIR_Coverage, 1870,
     /* 431120 */   GIR_Done,
     /* 431121 */ // Label 8584: @431121
     /* 431121 */ GIM_Reject,
     /* 431122 */ // Label 8558: @431122
     /* 431122 */ GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(431176),
     /* 431127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 431133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431145 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(431160), // Rule ID 1873 //
     /* 431150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431153 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 431153 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 431158 */     GIR_RootConstrainSelectedInstOperands,
     /* 431159 */     // GIR_Coverage, 1873,
     /* 431159 */     GIR_Done,
     /* 431160 */   // Label 8586: @431160
     /* 431160 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(431175), // Rule ID 2504 //
     /* 431165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431168 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 431168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 431173 */     GIR_RootConstrainSelectedInstOperands,
     /* 431174 */     // GIR_Coverage, 2504,
     /* 431174 */     GIR_Done,
     /* 431175 */   // Label 8587: @431175
     /* 431175 */   GIM_Reject,
     /* 431176 */ // Label 8585: @431176
     /* 431176 */ GIM_Reject,
     /* 431177 */ // Label 8559: @431177
     /* 431177 */ GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(431210), // Rule ID 1871 //
     /* 431182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 431188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 431191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431203 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 431203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 431208 */   GIR_RootConstrainSelectedInstOperands,
     /* 431209 */   // GIR_Coverage, 1871,
     /* 431209 */   GIR_Done,
     /* 431210 */ // Label 8588: @431210
     /* 431210 */ GIM_Reject,
     /* 431211 */ // Label 8560: @431211
     /* 431211 */ GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(431236), // Rule ID 9037 //
     /* 431216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 431222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 431225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431229 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 431229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 431234 */   GIR_RootConstrainSelectedInstOperands,
     /* 431235 */   // GIR_Coverage, 9037,
     /* 431235 */   GIR_Done,
     /* 431236 */ // Label 8589: @431236
     /* 431236 */ GIM_Reject,
     /* 431237 */ // Label 8561: @431237
     /* 431237 */ GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(431262), // Rule ID 9013 //
     /* 431242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 431248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 431251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431255 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 431255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 431260 */   GIR_RootConstrainSelectedInstOperands,
     /* 431261 */   // GIR_Coverage, 9013,
     /* 431261 */   GIR_Done,
     /* 431262 */ // Label 8590: @431262
     /* 431262 */ GIM_Reject,
     /* 431263 */ // Label 8562: @431263
     /* 431263 */ GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(431288), // Rule ID 9014 //
     /* 431268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 431274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 431277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431281 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 431281 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 431286 */   GIR_RootConstrainSelectedInstOperands,
     /* 431287 */   // GIR_Coverage, 9014,
     /* 431287 */   GIR_Done,
     /* 431288 */ // Label 8591: @431288
     /* 431288 */ GIM_Reject,
     /* 431289 */ // Label 8563: @431289
     /* 431289 */ GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(431335),
     /* 431294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 431297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 431300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431304 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(431319), // Rule ID 9009 //
     /* 431309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431312 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 431312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 431317 */     GIR_RootConstrainSelectedInstOperands,
     /* 431318 */     // GIR_Coverage, 9009,
     /* 431318 */     GIR_Done,
     /* 431319 */   // Label 8593: @431319
     /* 431319 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(431334), // Rule ID 9015 //
     /* 431324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431327 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 431327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 431332 */     GIR_RootConstrainSelectedInstOperands,
     /* 431333 */     // GIR_Coverage, 9015,
     /* 431333 */     GIR_Done,
     /* 431334 */   // Label 8594: @431334
     /* 431334 */   GIM_Reject,
     /* 431335 */ // Label 8592: @431335
     /* 431335 */ GIM_Reject,
     /* 431336 */ // Label 8564: @431336
     /* 431336 */ GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(431361), // Rule ID 9036 //
     /* 431341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 431347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 431350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431354 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 431354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 431359 */   GIR_RootConstrainSelectedInstOperands,
     /* 431360 */   // GIR_Coverage, 9036,
     /* 431360 */   GIR_Done,
     /* 431361 */ // Label 8595: @431361
     /* 431361 */ GIM_Reject,
     /* 431362 */ // Label 8565: @431362
     /* 431362 */ GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(431387), // Rule ID 9011 //
     /* 431367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 431373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 431376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431380 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 431380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 431385 */   GIR_RootConstrainSelectedInstOperands,
     /* 431386 */   // GIR_Coverage, 9011,
     /* 431386 */   GIR_Done,
     /* 431387 */ // Label 8596: @431387
     /* 431387 */ GIM_Reject,
     /* 431388 */ // Label 8566: @431388
     /* 431388 */ GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(431434),
     /* 431393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 431396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 431399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431403 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(431418), // Rule ID 9008 //
     /* 431408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431411 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 431411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 431416 */     GIR_RootConstrainSelectedInstOperands,
     /* 431417 */     // GIR_Coverage, 9008,
     /* 431417 */     GIR_Done,
     /* 431418 */   // Label 8598: @431418
     /* 431418 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(431433), // Rule ID 9012 //
     /* 431423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431426 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 431426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 431431 */     GIR_RootConstrainSelectedInstOperands,
     /* 431432 */     // GIR_Coverage, 9012,
     /* 431432 */     GIR_Done,
     /* 431433 */   // Label 8599: @431433
     /* 431433 */   GIM_Reject,
     /* 431434 */ // Label 8597: @431434
     /* 431434 */ GIM_Reject,
     /* 431435 */ // Label 8567: @431435
     /* 431435 */ GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(431460), // Rule ID 9035 //
     /* 431440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 431446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 431449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431453 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 431453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 431458 */   GIR_RootConstrainSelectedInstOperands,
     /* 431459 */   // GIR_Coverage, 9035,
     /* 431459 */   GIR_Done,
     /* 431460 */ // Label 8600: @431460
     /* 431460 */ GIM_Reject,
     /* 431461 */ // Label 8568: @431461
     /* 431461 */ GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(431507),
     /* 431466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 431469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 431472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431476 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(431491), // Rule ID 9007 //
     /* 431481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431484 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 431484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 431489 */     GIR_RootConstrainSelectedInstOperands,
     /* 431490 */     // GIR_Coverage, 9007,
     /* 431490 */     GIR_Done,
     /* 431491 */   // Label 8602: @431491
     /* 431491 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(431506), // Rule ID 9010 //
     /* 431496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431499 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 431499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 431504 */     GIR_RootConstrainSelectedInstOperands,
     /* 431505 */     // GIR_Coverage, 9010,
     /* 431505 */     GIR_Done,
     /* 431506 */   // Label 8603: @431506
     /* 431506 */   GIM_Reject,
     /* 431507 */ // Label 8601: @431507
     /* 431507 */ GIM_Reject,
     /* 431508 */ // Label 8569: @431508
     /* 431508 */ GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(431533), // Rule ID 2414 //
     /* 431513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 431519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 431522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431526 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 431526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 431531 */   GIR_RootConstrainSelectedInstOperands,
     /* 431532 */   // GIR_Coverage, 2414,
     /* 431532 */   GIR_Done,
     /* 431533 */ // Label 8604: @431533
     /* 431533 */ GIM_Reject,
     /* 431534 */ // Label 8570: @431534
     /* 431534 */ GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(431559), // Rule ID 9006 //
     /* 431539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 431545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 431548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431552 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 431552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 431557 */   GIR_RootConstrainSelectedInstOperands,
     /* 431558 */   // GIR_Coverage, 9006,
     /* 431558 */   GIR_Done,
     /* 431559 */ // Label 8605: @431559
     /* 431559 */ GIM_Reject,
     /* 431560 */ // Label 8571: @431560
     /* 431560 */ GIM_Reject,
     /* 431561 */ // Label 142: @431561
     /* 431561 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8624*/ GIMT_Encode4(432340),
     /* 431572 */ /*GILLT_v2s32*//*Label 8606*/ GIMT_Encode4(431648),
     /* 431576 */ /*GILLT_v2s64*//*Label 8607*/ GIMT_Encode4(431703),
     /* 431580 */ /*GILLT_v4s16*//*Label 8608*/ GIMT_Encode4(431758),
     /* 431584 */ /*GILLT_v4s32*//*Label 8609*/ GIMT_Encode4(431813),
     /* 431588 */ /*GILLT_v8s8*//*Label 8610*/ GIMT_Encode4(431868),
     /* 431592 */ /*GILLT_v8s16*//*Label 8611*/ GIMT_Encode4(431902),
     /* 431596 */ /*GILLT_v16s8*//*Label 8612*/ GIMT_Encode4(431957), GIMT_Encode4(0),
     /* 431604 */ /*GILLT_nxv2s1*//*Label 8613*/ GIMT_Encode4(431991),
     /* 431608 */ /*GILLT_nxv2s16*//*Label 8614*/ GIMT_Encode4(432017),
     /* 431612 */ /*GILLT_nxv2s32*//*Label 8615*/ GIMT_Encode4(432043),
     /* 431616 */ /*GILLT_nxv2s64*//*Label 8616*/ GIMT_Encode4(432069),
     /* 431620 */ /*GILLT_nxv4s1*//*Label 8617*/ GIMT_Encode4(432116),
     /* 431624 */ /*GILLT_nxv4s16*//*Label 8618*/ GIMT_Encode4(432142),
     /* 431628 */ /*GILLT_nxv4s32*//*Label 8619*/ GIMT_Encode4(432168),
     /* 431632 */ /*GILLT_nxv8s1*//*Label 8620*/ GIMT_Encode4(432215),
     /* 431636 */ /*GILLT_nxv8s16*//*Label 8621*/ GIMT_Encode4(432241),
     /* 431640 */ /*GILLT_nxv16s1*//*Label 8622*/ GIMT_Encode4(432288),
     /* 431644 */ /*GILLT_nxv16s8*//*Label 8623*/ GIMT_Encode4(432314),
     /* 431648 */ // Label 8606: @431648
     /* 431648 */ GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(431702),
     /* 431653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 431656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 431659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431667 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431671 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(431686), // Rule ID 1881 //
     /* 431676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431679 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 431679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 431684 */     GIR_RootConstrainSelectedInstOperands,
     /* 431685 */     // GIR_Coverage, 1881,
     /* 431685 */     GIR_Done,
     /* 431686 */   // Label 8626: @431686
     /* 431686 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(431701), // Rule ID 5505 //
     /* 431691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431694 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 431694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 431699 */     GIR_RootConstrainSelectedInstOperands,
     /* 431700 */     // GIR_Coverage, 5505,
     /* 431700 */     GIR_Done,
     /* 431701 */   // Label 8627: @431701
     /* 431701 */   GIM_Reject,
     /* 431702 */ // Label 8625: @431702
     /* 431702 */ GIM_Reject,
     /* 431703 */ // Label 8607: @431703
     /* 431703 */ GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(431757),
     /* 431708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 431711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 431714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431722 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431726 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(431741), // Rule ID 1883 //
     /* 431731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431734 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 431734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 431739 */     GIR_RootConstrainSelectedInstOperands,
     /* 431740 */     // GIR_Coverage, 1883,
     /* 431740 */     GIR_Done,
     /* 431741 */   // Label 8629: @431741
     /* 431741 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(431756), // Rule ID 5507 //
     /* 431746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431749 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 431749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 431754 */     GIR_RootConstrainSelectedInstOperands,
     /* 431755 */     // GIR_Coverage, 5507,
     /* 431755 */     GIR_Done,
     /* 431756 */   // Label 8630: @431756
     /* 431756 */   GIM_Reject,
     /* 431757 */ // Label 8628: @431757
     /* 431757 */ GIM_Reject,
     /* 431758 */ // Label 8608: @431758
     /* 431758 */ GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(431812),
     /* 431763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 431766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 431769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431781 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(431796), // Rule ID 1879 //
     /* 431786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431789 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 431789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 431794 */     GIR_RootConstrainSelectedInstOperands,
     /* 431795 */     // GIR_Coverage, 1879,
     /* 431795 */     GIR_Done,
     /* 431796 */   // Label 8632: @431796
     /* 431796 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(431811), // Rule ID 5503 //
     /* 431801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431804 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 431804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 431809 */     GIR_RootConstrainSelectedInstOperands,
     /* 431810 */     // GIR_Coverage, 5503,
     /* 431810 */     GIR_Done,
     /* 431811 */   // Label 8633: @431811
     /* 431811 */   GIM_Reject,
     /* 431812 */ // Label 8631: @431812
     /* 431812 */ GIM_Reject,
     /* 431813 */ // Label 8609: @431813
     /* 431813 */ GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(431867),
     /* 431818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 431824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431836 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(431851), // Rule ID 1882 //
     /* 431841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431844 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 431844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 431849 */     GIR_RootConstrainSelectedInstOperands,
     /* 431850 */     // GIR_Coverage, 1882,
     /* 431850 */     GIR_Done,
     /* 431851 */   // Label 8635: @431851
     /* 431851 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(431866), // Rule ID 5506 //
     /* 431856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431859 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 431859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 431864 */     GIR_RootConstrainSelectedInstOperands,
     /* 431865 */     // GIR_Coverage, 5506,
     /* 431865 */     GIR_Done,
     /* 431866 */   // Label 8636: @431866
     /* 431866 */   GIM_Reject,
     /* 431867 */ // Label 8634: @431867
     /* 431867 */ GIM_Reject,
     /* 431868 */ // Label 8610: @431868
     /* 431868 */ GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(431901), // Rule ID 1877 //
     /* 431873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 431879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 431882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431890 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431894 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 431894 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 431899 */   GIR_RootConstrainSelectedInstOperands,
     /* 431900 */   // GIR_Coverage, 1877,
     /* 431900 */   GIR_Done,
     /* 431901 */ // Label 8637: @431901
     /* 431901 */ GIM_Reject,
     /* 431902 */ // Label 8611: @431902
     /* 431902 */ GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(431956),
     /* 431907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 431913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431925 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(431940), // Rule ID 1880 //
     /* 431930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431933 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 431933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 431938 */     GIR_RootConstrainSelectedInstOperands,
     /* 431939 */     // GIR_Coverage, 1880,
     /* 431939 */     GIR_Done,
     /* 431940 */   // Label 8639: @431940
     /* 431940 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(431955), // Rule ID 5504 //
     /* 431945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431948 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 431948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 431953 */     GIR_RootConstrainSelectedInstOperands,
     /* 431954 */     // GIR_Coverage, 5504,
     /* 431954 */     GIR_Done,
     /* 431955 */   // Label 8640: @431955
     /* 431955 */   GIM_Reject,
     /* 431956 */ // Label 8638: @431956
     /* 431956 */ GIM_Reject,
     /* 431957 */ // Label 8612: @431957
     /* 431957 */ GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(431990), // Rule ID 1878 //
     /* 431962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 431968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 431971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431983 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 431983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 431988 */   GIR_RootConstrainSelectedInstOperands,
     /* 431989 */   // GIR_Coverage, 1878,
     /* 431989 */   GIR_Done,
     /* 431990 */ // Label 8641: @431990
     /* 431990 */ GIM_Reject,
     /* 431991 */ // Label 8613: @431991
     /* 431991 */ GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(432016), // Rule ID 9040 //
     /* 431996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 432002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 432005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432009 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 432009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 432014 */   GIR_RootConstrainSelectedInstOperands,
     /* 432015 */   // GIR_Coverage, 9040,
     /* 432015 */   GIR_Done,
     /* 432016 */ // Label 8642: @432016
     /* 432016 */ GIM_Reject,
     /* 432017 */ // Label 8614: @432017
     /* 432017 */ GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(432042), // Rule ID 9023 //
     /* 432022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 432028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 432031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432035 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 432035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 432040 */   GIR_RootConstrainSelectedInstOperands,
     /* 432041 */   // GIR_Coverage, 9023,
     /* 432041 */   GIR_Done,
     /* 432042 */ // Label 8643: @432042
     /* 432042 */ GIM_Reject,
     /* 432043 */ // Label 8615: @432043
     /* 432043 */ GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(432068), // Rule ID 9024 //
     /* 432048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 432054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 432057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432061 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 432061 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 432066 */   GIR_RootConstrainSelectedInstOperands,
     /* 432067 */   // GIR_Coverage, 9024,
     /* 432067 */   GIR_Done,
     /* 432068 */ // Label 8644: @432068
     /* 432068 */ GIM_Reject,
     /* 432069 */ // Label 8616: @432069
     /* 432069 */ GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(432115),
     /* 432074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 432077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 432080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432084 */   GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(432099), // Rule ID 9019 //
     /* 432089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432092 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 432092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 432097 */     GIR_RootConstrainSelectedInstOperands,
     /* 432098 */     // GIR_Coverage, 9019,
     /* 432098 */     GIR_Done,
     /* 432099 */   // Label 8646: @432099
     /* 432099 */   GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(432114), // Rule ID 9025 //
     /* 432104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432107 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 432107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 432112 */     GIR_RootConstrainSelectedInstOperands,
     /* 432113 */     // GIR_Coverage, 9025,
     /* 432113 */     GIR_Done,
     /* 432114 */   // Label 8647: @432114
     /* 432114 */   GIM_Reject,
     /* 432115 */ // Label 8645: @432115
     /* 432115 */ GIM_Reject,
     /* 432116 */ // Label 8617: @432116
     /* 432116 */ GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(432141), // Rule ID 9039 //
     /* 432121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 432127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 432130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432134 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 432134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 432139 */   GIR_RootConstrainSelectedInstOperands,
     /* 432140 */   // GIR_Coverage, 9039,
     /* 432140 */   GIR_Done,
     /* 432141 */ // Label 8648: @432141
     /* 432141 */ GIM_Reject,
     /* 432142 */ // Label 8618: @432142
     /* 432142 */ GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(432167), // Rule ID 9021 //
     /* 432147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 432153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 432156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432160 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 432160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 432165 */   GIR_RootConstrainSelectedInstOperands,
     /* 432166 */   // GIR_Coverage, 9021,
     /* 432166 */   GIR_Done,
     /* 432167 */ // Label 8649: @432167
     /* 432167 */ GIM_Reject,
     /* 432168 */ // Label 8619: @432168
     /* 432168 */ GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(432214),
     /* 432173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 432176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 432179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432183 */   GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(432198), // Rule ID 9018 //
     /* 432188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432191 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 432191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 432196 */     GIR_RootConstrainSelectedInstOperands,
     /* 432197 */     // GIR_Coverage, 9018,
     /* 432197 */     GIR_Done,
     /* 432198 */   // Label 8651: @432198
     /* 432198 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(432213), // Rule ID 9022 //
     /* 432203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432206 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 432206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 432211 */     GIR_RootConstrainSelectedInstOperands,
     /* 432212 */     // GIR_Coverage, 9022,
     /* 432212 */     GIR_Done,
     /* 432213 */   // Label 8652: @432213
     /* 432213 */   GIM_Reject,
     /* 432214 */ // Label 8650: @432214
     /* 432214 */ GIM_Reject,
     /* 432215 */ // Label 8620: @432215
     /* 432215 */ GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(432240), // Rule ID 9038 //
     /* 432220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 432226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 432229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432233 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 432233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 432238 */   GIR_RootConstrainSelectedInstOperands,
     /* 432239 */   // GIR_Coverage, 9038,
     /* 432239 */   GIR_Done,
     /* 432240 */ // Label 8653: @432240
     /* 432240 */ GIM_Reject,
     /* 432241 */ // Label 8621: @432241
     /* 432241 */ GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(432287),
     /* 432246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 432249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 432252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432256 */   GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(432271), // Rule ID 9017 //
     /* 432261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432264 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 432264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 432269 */     GIR_RootConstrainSelectedInstOperands,
     /* 432270 */     // GIR_Coverage, 9017,
     /* 432270 */     GIR_Done,
     /* 432271 */   // Label 8655: @432271
     /* 432271 */   GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(432286), // Rule ID 9020 //
     /* 432276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432279 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 432279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 432284 */     GIR_RootConstrainSelectedInstOperands,
     /* 432285 */     // GIR_Coverage, 9020,
     /* 432285 */     GIR_Done,
     /* 432286 */   // Label 8656: @432286
     /* 432286 */   GIM_Reject,
     /* 432287 */ // Label 8654: @432287
     /* 432287 */ GIM_Reject,
     /* 432288 */ // Label 8622: @432288
     /* 432288 */ GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(432313), // Rule ID 2418 //
     /* 432293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 432299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 432302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432306 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 432306 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 432311 */   GIR_RootConstrainSelectedInstOperands,
     /* 432312 */   // GIR_Coverage, 2418,
     /* 432312 */   GIR_Done,
     /* 432313 */ // Label 8657: @432313
     /* 432313 */ GIM_Reject,
     /* 432314 */ // Label 8623: @432314
     /* 432314 */ GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(432339), // Rule ID 9016 //
     /* 432319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 432325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 432328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432332 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 432332 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 432337 */   GIR_RootConstrainSelectedInstOperands,
     /* 432338 */   // GIR_Coverage, 9016,
     /* 432338 */   GIR_Done,
     /* 432339 */ // Label 8658: @432339
     /* 432339 */ GIM_Reject,
     /* 432340 */ // Label 8624: @432340
     /* 432340 */ GIM_Reject,
     /* 432341 */ // Label 143: @432341
     /* 432341 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8665*/ GIMT_Encode4(432546),
     /* 432352 */ /*GILLT_s64*//*Label 8659*/ GIMT_Encode4(432384), GIMT_Encode4(0),
     /* 432360 */ /*GILLT_v2s32*//*Label 8660*/ GIMT_Encode4(432411),
     /* 432364 */ /*GILLT_v2s64*//*Label 8661*/ GIMT_Encode4(432438),
     /* 432368 */ /*GILLT_v4s16*//*Label 8662*/ GIMT_Encode4(432465),
     /* 432372 */ /*GILLT_v4s32*//*Label 8663*/ GIMT_Encode4(432492), GIMT_Encode4(0),
     /* 432380 */ /*GILLT_v8s16*//*Label 8664*/ GIMT_Encode4(432519),
     /* 432384 */ // Label 8659: @432384
     /* 432384 */ GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(432410), // Rule ID 1069 //
     /* 432389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 432395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432403 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 432403 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 432408 */   GIR_RootConstrainSelectedInstOperands,
     /* 432409 */   // GIR_Coverage, 1069,
     /* 432409 */   GIR_Done,
     /* 432410 */ // Label 8666: @432410
     /* 432410 */ GIM_Reject,
     /* 432411 */ // Label 8660: @432411
     /* 432411 */ GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(432437), // Rule ID 1065 //
     /* 432416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432430 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 432430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 432435 */   GIR_RootConstrainSelectedInstOperands,
     /* 432436 */   // GIR_Coverage, 1065,
     /* 432436 */   GIR_Done,
     /* 432437 */ // Label 8667: @432437
     /* 432437 */ GIM_Reject,
     /* 432438 */ // Label 8661: @432438
     /* 432438 */ GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(432464), // Rule ID 1071 //
     /* 432443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432457 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 432457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 432462 */   GIR_RootConstrainSelectedInstOperands,
     /* 432463 */   // GIR_Coverage, 1071,
     /* 432463 */   GIR_Done,
     /* 432464 */ // Label 8668: @432464
     /* 432464 */ GIM_Reject,
     /* 432465 */ // Label 8662: @432465
     /* 432465 */ GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(432491), // Rule ID 1061 //
     /* 432470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 432476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432484 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 432484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 432489 */   GIR_RootConstrainSelectedInstOperands,
     /* 432490 */   // GIR_Coverage, 1061,
     /* 432490 */   GIR_Done,
     /* 432491 */ // Label 8669: @432491
     /* 432491 */ GIM_Reject,
     /* 432492 */ // Label 8663: @432492
     /* 432492 */ GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(432518), // Rule ID 1067 //
     /* 432497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432511 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 432511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 432516 */   GIR_RootConstrainSelectedInstOperands,
     /* 432517 */   // GIR_Coverage, 1067,
     /* 432517 */   GIR_Done,
     /* 432518 */ // Label 8670: @432518
     /* 432518 */ GIM_Reject,
     /* 432519 */ // Label 8664: @432519
     /* 432519 */ GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(432545), // Rule ID 1063 //
     /* 432524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 432530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432538 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 432538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 432543 */   GIR_RootConstrainSelectedInstOperands,
     /* 432544 */   // GIR_Coverage, 1063,
     /* 432544 */   GIR_Done,
     /* 432545 */ // Label 8671: @432545
     /* 432545 */ GIM_Reject,
     /* 432546 */ // Label 8665: @432546
     /* 432546 */ GIM_Reject,
     /* 432547 */ // Label 144: @432547
     /* 432547 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8674*/ GIMT_Encode4(433413),
     /* 432558 */ /*GILLT_v2s64*//*Label 8672*/ GIMT_Encode4(432570), GIMT_Encode4(0),
     /* 432566 */ /*GILLT_v4s32*//*Label 8673*/ GIMT_Encode4(432864),
     /* 432570 */ // Label 8672: @432570
     /* 432570 */ GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(432652), // Rule ID 5916 //
     /* 432575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432582 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 432590 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 432593 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 432598 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 432602 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432607 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432609 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 726:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 432609 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 432612 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 432616 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432621 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 432625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 432641 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432646 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 432651 */   // GIR_Coverage, 5916,
     /* 432651 */   GIR_EraseRootFromParent_Done,
     /* 432652 */ // Label 8675: @432652
     /* 432652 */ GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(432726), // Rule ID 5915 //
     /* 432657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432664 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432668 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 432672 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432676 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432681 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432683 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 432683 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 432686 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 432690 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432695 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 432699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 432715 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432720 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 432725 */   // GIR_Coverage, 5915,
     /* 432725 */   GIR_EraseRootFromParent_Done,
     /* 432726 */ // Label 8676: @432726
     /* 432726 */ GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(432785), // Rule ID 5925 //
     /* 432731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432742 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 432742 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 432745 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 432749 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432754 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432768 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 432774 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432779 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432784 */   // GIR_Coverage, 5925,
     /* 432784 */   GIR_EraseRootFromParent_Done,
     /* 432785 */ // Label 8677: @432785
     /* 432785 */ GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(432863), // Rule ID 6053 //
     /* 432790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 432793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432801 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 432801 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 432804 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 432808 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432813 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 432819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 432822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 432826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 432836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432838 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 432844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 432847 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432852 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432857 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432862 */   // GIR_Coverage, 6053,
     /* 432862 */   GIR_EraseRootFromParent_Done,
     /* 432863 */ // Label 8678: @432863
     /* 432863 */ GIM_Reject,
     /* 432864 */ // Label 8673: @432864
     /* 432864 */ GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(432946), // Rule ID 5918 //
     /* 432869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432876 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432880 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 432884 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 432887 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 432892 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 432896 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432901 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432903 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 726:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 432903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 432906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 432910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432915 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 432919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 432935 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432940 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432945 */   // GIR_Coverage, 5918,
     /* 432945 */   GIR_EraseRootFromParent_Done,
     /* 432946 */ // Label 8679: @432946
     /* 432946 */ GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(433028), // Rule ID 5920 //
     /* 432951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432958 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432962 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 432966 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 432969 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 432974 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 432978 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432983 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432985 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 726:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 432985 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 432988 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 432992 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432997 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 433001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 433017 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433022 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433027 */   // GIR_Coverage, 5920,
     /* 433027 */   GIR_EraseRootFromParent_Done,
     /* 433028 */ // Label 8680: @433028
     /* 433028 */ GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(433102), // Rule ID 5917 //
     /* 433033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 433048 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 433052 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433057 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433059 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 433059 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 433062 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 433066 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433071 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 433075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433085 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 433091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433101 */   // GIR_Coverage, 5917,
     /* 433101 */   GIR_EraseRootFromParent_Done,
     /* 433102 */ // Label 8681: @433102
     /* 433102 */ GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(433176), // Rule ID 5919 //
     /* 433107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 433110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433114 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433118 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 433122 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 433126 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433131 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433133 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 433133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 433136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 433140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433145 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 433149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433159 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 433165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433175 */   // GIR_Coverage, 5919,
     /* 433175 */   GIR_EraseRootFromParent_Done,
     /* 433176 */ // Label 8682: @433176
     /* 433176 */ GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(433235), // Rule ID 5921 //
     /* 433181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 433184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433192 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 433192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 433195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 433199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433204 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 433208 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433218 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 433224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433229 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433234 */   // GIR_Coverage, 5921,
     /* 433234 */   GIR_EraseRootFromParent_Done,
     /* 433235 */ // Label 8683: @433235
     /* 433235 */ GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(433294), // Rule ID 5922 //
     /* 433240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 433243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433251 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 433251 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 433254 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 433258 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433263 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 433267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 433283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433288 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 433293 */   // GIR_Coverage, 5922,
     /* 433293 */   GIR_EraseRootFromParent_Done,
     /* 433294 */ // Label 8684: @433294
     /* 433294 */ GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(433353), // Rule ID 5923 //
     /* 433299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 433302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433310 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 433310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 433313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 433317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433322 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 433326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433336 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 433342 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433352 */   // GIR_Coverage, 5923,
     /* 433352 */   GIR_EraseRootFromParent_Done,
     /* 433353 */ // Label 8685: @433353
     /* 433353 */ GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(433412), // Rule ID 5924 //
     /* 433358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433369 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 433369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 433372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 433376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433381 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 433385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433395 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 433401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433406 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 433411 */   // GIR_Coverage, 5924,
     /* 433411 */   GIR_EraseRootFromParent_Done,
     /* 433412 */ // Label 8686: @433412
     /* 433412 */ GIM_Reject,
     /* 433413 */ // Label 8674: @433413
     /* 433413 */ GIM_Reject,
     /* 433414 */ // Label 145: @433414
     /* 433414 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8691*/ GIMT_Encode4(433783),
     /* 433425 */ /*GILLT_v2s32*//*Label 8687*/ GIMT_Encode4(433485), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 433437 */ /*GILLT_v4s32*//*Label 8688*/ GIMT_Encode4(433605), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 433469 */ /*GILLT_nxv2s64*//*Label 8689*/ GIMT_Encode4(433725), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 433481 */ /*GILLT_nxv4s32*//*Label 8690*/ GIMT_Encode4(433754),
     /* 433485 */ // Label 8687: @433485
     /* 433485 */ GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(433604),
     /* 433490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 433496 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 433499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433511 */   GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(433584), // Rule ID 28 //
     /* 433516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 433519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 433523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 433527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433560 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433564 */     // MIs[3] Operand 1
     /* 433564 */     // No operand predicates
     /* 433564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433566 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 433569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 433573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 433575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433582 */     GIR_RootConstrainSelectedInstOperands,
     /* 433583 */     // GIR_Coverage, 28,
     /* 433583 */     GIR_EraseRootFromParent_Done,
     /* 433584 */   // Label 8693: @433584
     /* 433584 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(433603), // Rule ID 24 //
     /* 433589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 433592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433596 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 433596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 433601 */     GIR_RootConstrainSelectedInstOperands,
     /* 433602 */     // GIR_Coverage, 24,
     /* 433602 */     GIR_Done,
     /* 433603 */   // Label 8694: @433603
     /* 433603 */   GIM_Reject,
     /* 433604 */ // Label 8692: @433604
     /* 433604 */ GIM_Reject,
     /* 433605 */ // Label 8688: @433605
     /* 433605 */ GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(433724),
     /* 433610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 433616 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 433619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433627 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433631 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(433704), // Rule ID 29 //
     /* 433636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 433639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 433643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 433647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433680 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433684 */     // MIs[3] Operand 1
     /* 433684 */     // No operand predicates
     /* 433684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433686 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 433689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 433693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 433695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433702 */     GIR_RootConstrainSelectedInstOperands,
     /* 433703 */     // GIR_Coverage, 29,
     /* 433703 */     GIR_EraseRootFromParent_Done,
     /* 433704 */   // Label 8696: @433704
     /* 433704 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(433723), // Rule ID 25 //
     /* 433709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 433712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433716 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 433716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 433721 */     GIR_RootConstrainSelectedInstOperands,
     /* 433722 */     // GIR_Coverage, 25,
     /* 433722 */     GIR_Done,
     /* 433723 */   // Label 8697: @433723
     /* 433723 */   GIM_Reject,
     /* 433724 */ // Label 8695: @433724
     /* 433724 */ GIM_Reject,
     /* 433725 */ // Label 8689: @433725
     /* 433725 */ GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(433753), // Rule ID 7723 //
     /* 433730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 433736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 433739 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 433742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433746 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 433746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 433751 */   GIR_RootConstrainSelectedInstOperands,
     /* 433752 */   // GIR_Coverage, 7723,
     /* 433752 */   GIR_Done,
     /* 433753 */ // Label 8698: @433753
     /* 433753 */ GIM_Reject,
     /* 433754 */ // Label 8690: @433754
     /* 433754 */ GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(433782), // Rule ID 7722 //
     /* 433759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 433765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 433768 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 433771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433775 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 433775 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 433780 */   GIR_RootConstrainSelectedInstOperands,
     /* 433781 */   // GIR_Coverage, 7722,
     /* 433781 */   GIR_Done,
     /* 433782 */ // Label 8699: @433782
     /* 433782 */ GIM_Reject,
     /* 433783 */ // Label 8691: @433783
     /* 433783 */ GIM_Reject,
     /* 433784 */ // Label 146: @433784
     /* 433784 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8703*/ GIMT_Encode4(433900),
     /* 433795 */ /*GILLT_s16*//*Label 8700*/ GIMT_Encode4(433807),
     /* 433799 */ /*GILLT_s32*//*Label 8701*/ GIMT_Encode4(433838),
     /* 433803 */ /*GILLT_s64*//*Label 8702*/ GIMT_Encode4(433869),
     /* 433807 */ // Label 8700: @433807
     /* 433807 */ GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(433837), // Rule ID 1669 //
     /* 433812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 433815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 433818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433826 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 433826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 433831 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 433835 */   GIR_RootConstrainSelectedInstOperands,
     /* 433836 */   // GIR_Coverage, 1669,
     /* 433836 */   GIR_Done,
     /* 433837 */ // Label 8704: @433837
     /* 433837 */ GIM_Reject,
     /* 433838 */ // Label 8701: @433838
     /* 433838 */ GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(433868), // Rule ID 1668 //
     /* 433843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 433846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 433849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 433853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 433857 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 433857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 433862 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 433866 */   GIR_RootConstrainSelectedInstOperands,
     /* 433867 */   // GIR_Coverage, 1668,
     /* 433867 */   GIR_Done,
     /* 433868 */ // Label 8705: @433868
     /* 433868 */ GIM_Reject,
     /* 433869 */ // Label 8702: @433869
     /* 433869 */ GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(433899), // Rule ID 1667 //
     /* 433874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 433877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 433880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433888 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 433888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 433893 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 433897 */   GIR_RootConstrainSelectedInstOperands,
     /* 433898 */   // GIR_Coverage, 1667,
     /* 433898 */   GIR_Done,
     /* 433899 */ // Label 8706: @433899
     /* 433899 */ GIM_Reject,
     /* 433900 */ // Label 8703: @433900
     /* 433900 */ GIM_Reject,
     /* 433901 */ // Label 147: @433901
     /* 433901 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8710*/ GIMT_Encode4(435133),
     /* 433912 */ /*GILLT_v2s64*//*Label 8707*/ GIMT_Encode4(433932), GIMT_Encode4(0),
     /* 433920 */ /*GILLT_v4s32*//*Label 8708*/ GIMT_Encode4(434493), GIMT_Encode4(0),
     /* 433928 */ /*GILLT_v8s16*//*Label 8709*/ GIMT_Encode4(435054),
     /* 433932 */ // Label 8707: @433932
     /* 433932 */ GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(434492),
     /* 433937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 433943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433947 */   GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(434039), // Rule ID 2106 //
     /* 433952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 433963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433996 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434000 */     // MIs[3] Operand 1
     /* 434000 */     // No operand predicates
     /* 434000 */     // MIs[1] Operand 2
     /* 434000 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 434011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 434020 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 434023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434037 */     GIR_RootConstrainSelectedInstOperands,
     /* 434038 */     // GIR_Coverage, 2106,
     /* 434038 */     GIR_EraseRootFromParent_Done,
     /* 434039 */   // Label 8712: @434039
     /* 434039 */   GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(434131), // Rule ID 13616 //
     /* 434044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434071 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434075 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434088 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434092 */     // MIs[3] Operand 1
     /* 434092 */     // No operand predicates
     /* 434092 */     // MIs[1] Operand 2
     /* 434092 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 434103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 434112 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 434115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434129 */     GIR_RootConstrainSelectedInstOperands,
     /* 434130 */     // GIR_Coverage, 13616,
     /* 434130 */     GIR_EraseRootFromParent_Done,
     /* 434131 */   // Label 8713: @434131
     /* 434131 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(434217), // Rule ID 13614 //
     /* 434136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434180 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434184 */     // MIs[3] Operand 1
     /* 434184 */     // No operand predicates
     /* 434184 */     // MIs[1] Operand 2
     /* 434184 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 434195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434201 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 434204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434215 */     GIR_RootConstrainSelectedInstOperands,
     /* 434216 */     // GIR_Coverage, 13614,
     /* 434216 */     GIR_EraseRootFromParent_Done,
     /* 434217 */   // Label 8714: @434217
     /* 434217 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(434303), // Rule ID 2104 //
     /* 434222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 434233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434270 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434274 */     // MIs[3] Operand 1
     /* 434274 */     // No operand predicates
     /* 434274 */     // MIs[1] Operand 2
     /* 434274 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 434285 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434287 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 434290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 434294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434301 */     GIR_RootConstrainSelectedInstOperands,
     /* 434302 */     // GIR_Coverage, 2104,
     /* 434302 */     GIR_EraseRootFromParent_Done,
     /* 434303 */   // Label 8715: @434303
     /* 434303 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(434342), // Rule ID 1831 //
     /* 434308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 434318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 434325 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 434325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 434328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 434340 */     GIR_RootConstrainSelectedInstOperands,
     /* 434341 */     // GIR_Coverage, 1831,
     /* 434341 */     GIR_EraseRootFromParent_Done,
     /* 434342 */   // Label 8716: @434342
     /* 434342 */   GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(434405), // Rule ID 13615 //
     /* 434347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 434366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 434375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434379 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434383 */     // MIs[2] Operand 1
     /* 434383 */     // No operand predicates
     /* 434383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 434389 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 434392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 434400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 434403 */     GIR_RootConstrainSelectedInstOperands,
     /* 434404 */     // GIR_Coverage, 13615,
     /* 434404 */     GIR_EraseRootFromParent_Done,
     /* 434405 */   // Label 8717: @434405
     /* 434405 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(434468), // Rule ID 2105 //
     /* 434410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 434421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 434433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 434442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434446 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434450 */     // MIs[2] Operand 1
     /* 434450 */     // No operand predicates
     /* 434450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 434452 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 434455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 434459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 434463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 434466 */     GIR_RootConstrainSelectedInstOperands,
     /* 434467 */     // GIR_Coverage, 2105,
     /* 434467 */     GIR_EraseRootFromParent_Done,
     /* 434468 */   // Label 8718: @434468
     /* 434468 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(434491), // Rule ID 1830 //
     /* 434473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434484 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 434484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 434489 */     GIR_RootConstrainSelectedInstOperands,
     /* 434490 */     // GIR_Coverage, 1830,
     /* 434490 */     GIR_Done,
     /* 434491 */   // Label 8719: @434491
     /* 434491 */   GIM_Reject,
     /* 434492 */ // Label 8711: @434492
     /* 434492 */ GIM_Reject,
     /* 434493 */ // Label 8708: @434493
     /* 434493 */ GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(435053),
     /* 434498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 434501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 434504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434508 */   GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(434600), // Rule ID 2103 //
     /* 434513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 434520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434553 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434557 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434561 */     // MIs[3] Operand 1
     /* 434561 */     // No operand predicates
     /* 434561 */     // MIs[1] Operand 2
     /* 434561 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 434572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 434581 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 434584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434598 */     GIR_RootConstrainSelectedInstOperands,
     /* 434599 */     // GIR_Coverage, 2103,
     /* 434599 */     GIR_EraseRootFromParent_Done,
     /* 434600 */   // Label 8721: @434600
     /* 434600 */   GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(434692), // Rule ID 13613 //
     /* 434605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434649 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434653 */     // MIs[3] Operand 1
     /* 434653 */     // No operand predicates
     /* 434653 */     // MIs[1] Operand 2
     /* 434653 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 434664 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 434673 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 434676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434690 */     GIR_RootConstrainSelectedInstOperands,
     /* 434691 */     // GIR_Coverage, 13613,
     /* 434691 */     GIR_EraseRootFromParent_Done,
     /* 434692 */   // Label 8722: @434692
     /* 434692 */   GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(434778), // Rule ID 13611 //
     /* 434697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434728 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434741 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434745 */     // MIs[3] Operand 1
     /* 434745 */     // No operand predicates
     /* 434745 */     // MIs[1] Operand 2
     /* 434745 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 434756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434762 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 434765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434776 */     GIR_RootConstrainSelectedInstOperands,
     /* 434777 */     // GIR_Coverage, 13611,
     /* 434777 */     GIR_EraseRootFromParent_Done,
     /* 434778 */   // Label 8723: @434778
     /* 434778 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(434864), // Rule ID 2101 //
     /* 434783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 434794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434831 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434835 */     // MIs[3] Operand 1
     /* 434835 */     // No operand predicates
     /* 434835 */     // MIs[1] Operand 2
     /* 434835 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 434846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434848 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 434851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 434855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434862 */     GIR_RootConstrainSelectedInstOperands,
     /* 434863 */     // GIR_Coverage, 2101,
     /* 434863 */     GIR_EraseRootFromParent_Done,
     /* 434864 */   // Label 8724: @434864
     /* 434864 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(434903), // Rule ID 1829 //
     /* 434869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 434879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 434886 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 434886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 434889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 434901 */     GIR_RootConstrainSelectedInstOperands,
     /* 434902 */     // GIR_Coverage, 1829,
     /* 434902 */     GIR_EraseRootFromParent_Done,
     /* 434903 */   // Label 8725: @434903
     /* 434903 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(434966), // Rule ID 13612 //
     /* 434908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 434927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 434936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434940 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434944 */     // MIs[2] Operand 1
     /* 434944 */     // No operand predicates
     /* 434944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 434950 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 434953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 434961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 434964 */     GIR_RootConstrainSelectedInstOperands,
     /* 434965 */     // GIR_Coverage, 13612,
     /* 434965 */     GIR_EraseRootFromParent_Done,
     /* 434966 */   // Label 8726: @434966
     /* 434966 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(435029), // Rule ID 2102 //
     /* 434971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 434982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 434994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 435003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435007 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 435011 */     // MIs[2] Operand 1
     /* 435011 */     // No operand predicates
     /* 435011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 435013 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 435016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 435020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 435024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 435027 */     GIR_RootConstrainSelectedInstOperands,
     /* 435028 */     // GIR_Coverage, 2102,
     /* 435028 */     GIR_EraseRootFromParent_Done,
     /* 435029 */   // Label 8727: @435029
     /* 435029 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(435052), // Rule ID 1828 //
     /* 435034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435045 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 435045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 435050 */     GIR_RootConstrainSelectedInstOperands,
     /* 435051 */     // GIR_Coverage, 1828,
     /* 435051 */     GIR_Done,
     /* 435052 */   // Label 8728: @435052
     /* 435052 */   GIM_Reject,
     /* 435053 */ // Label 8720: @435053
     /* 435053 */ GIM_Reject,
     /* 435054 */ // Label 8709: @435054
     /* 435054 */ GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(435132),
     /* 435059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 435062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 435065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435069 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(435108), // Rule ID 1827 //
     /* 435074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 435084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 435091 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 435091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 435094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 435101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 435106 */     GIR_RootConstrainSelectedInstOperands,
     /* 435107 */     // GIR_Coverage, 1827,
     /* 435107 */     GIR_EraseRootFromParent_Done,
     /* 435108 */   // Label 8730: @435108
     /* 435108 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(435131), // Rule ID 1826 //
     /* 435113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435124 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 435124 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 435129 */     GIR_RootConstrainSelectedInstOperands,
     /* 435130 */     // GIR_Coverage, 1826,
     /* 435130 */     GIR_Done,
     /* 435131 */   // Label 8731: @435131
     /* 435131 */   GIM_Reject,
     /* 435132 */ // Label 8729: @435132
     /* 435132 */ GIM_Reject,
     /* 435133 */ // Label 8710: @435133
     /* 435133 */ GIM_Reject,
     /* 435134 */ // Label 148: @435134
     /* 435134 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8750*/ GIMT_Encode4(435913),
     /* 435145 */ /*GILLT_v2s32*//*Label 8732*/ GIMT_Encode4(435221),
     /* 435149 */ /*GILLT_v2s64*//*Label 8733*/ GIMT_Encode4(435276),
     /* 435153 */ /*GILLT_v4s16*//*Label 8734*/ GIMT_Encode4(435331),
     /* 435157 */ /*GILLT_v4s32*//*Label 8735*/ GIMT_Encode4(435386),
     /* 435161 */ /*GILLT_v8s8*//*Label 8736*/ GIMT_Encode4(435441),
     /* 435165 */ /*GILLT_v8s16*//*Label 8737*/ GIMT_Encode4(435475),
     /* 435169 */ /*GILLT_v16s8*//*Label 8738*/ GIMT_Encode4(435530), GIMT_Encode4(0),
     /* 435177 */ /*GILLT_nxv2s1*//*Label 8739*/ GIMT_Encode4(435564),
     /* 435181 */ /*GILLT_nxv2s16*//*Label 8740*/ GIMT_Encode4(435590),
     /* 435185 */ /*GILLT_nxv2s32*//*Label 8741*/ GIMT_Encode4(435616),
     /* 435189 */ /*GILLT_nxv2s64*//*Label 8742*/ GIMT_Encode4(435642),
     /* 435193 */ /*GILLT_nxv4s1*//*Label 8743*/ GIMT_Encode4(435689),
     /* 435197 */ /*GILLT_nxv4s16*//*Label 8744*/ GIMT_Encode4(435715),
     /* 435201 */ /*GILLT_nxv4s32*//*Label 8745*/ GIMT_Encode4(435741),
     /* 435205 */ /*GILLT_nxv8s1*//*Label 8746*/ GIMT_Encode4(435788),
     /* 435209 */ /*GILLT_nxv8s16*//*Label 8747*/ GIMT_Encode4(435814),
     /* 435213 */ /*GILLT_nxv16s1*//*Label 8748*/ GIMT_Encode4(435861),
     /* 435217 */ /*GILLT_nxv16s8*//*Label 8749*/ GIMT_Encode4(435887),
     /* 435221 */ // Label 8732: @435221
     /* 435221 */ GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(435275),
     /* 435226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 435229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 435232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435244 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(435259), // Rule ID 1888 //
     /* 435249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435252 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 435252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 435257 */     GIR_RootConstrainSelectedInstOperands,
     /* 435258 */     // GIR_Coverage, 1888,
     /* 435258 */     GIR_Done,
     /* 435259 */   // Label 8752: @435259
     /* 435259 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(435274), // Rule ID 5510 //
     /* 435264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435267 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 435267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 435272 */     GIR_RootConstrainSelectedInstOperands,
     /* 435273 */     // GIR_Coverage, 5510,
     /* 435273 */     GIR_Done,
     /* 435274 */   // Label 8753: @435274
     /* 435274 */   GIM_Reject,
     /* 435275 */ // Label 8751: @435275
     /* 435275 */ GIM_Reject,
     /* 435276 */ // Label 8733: @435276
     /* 435276 */ GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(435330),
     /* 435281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 435284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 435287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435299 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(435314), // Rule ID 1890 //
     /* 435304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435307 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 435307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 435312 */     GIR_RootConstrainSelectedInstOperands,
     /* 435313 */     // GIR_Coverage, 1890,
     /* 435313 */     GIR_Done,
     /* 435314 */   // Label 8755: @435314
     /* 435314 */   GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(435329), // Rule ID 5512 //
     /* 435319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435322 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 435322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 435327 */     GIR_RootConstrainSelectedInstOperands,
     /* 435328 */     // GIR_Coverage, 5512,
     /* 435328 */     GIR_Done,
     /* 435329 */   // Label 8756: @435329
     /* 435329 */   GIM_Reject,
     /* 435330 */ // Label 8754: @435330
     /* 435330 */ GIM_Reject,
     /* 435331 */ // Label 8734: @435331
     /* 435331 */ GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(435385),
     /* 435336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 435339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 435342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435354 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(435369), // Rule ID 1886 //
     /* 435359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435362 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 435362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 435367 */     GIR_RootConstrainSelectedInstOperands,
     /* 435368 */     // GIR_Coverage, 1886,
     /* 435368 */     GIR_Done,
     /* 435369 */   // Label 8758: @435369
     /* 435369 */   GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(435384), // Rule ID 5508 //
     /* 435374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435377 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 435377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 435382 */     GIR_RootConstrainSelectedInstOperands,
     /* 435383 */     // GIR_Coverage, 5508,
     /* 435383 */     GIR_Done,
     /* 435384 */   // Label 8759: @435384
     /* 435384 */   GIM_Reject,
     /* 435385 */ // Label 8757: @435385
     /* 435385 */ GIM_Reject,
     /* 435386 */ // Label 8735: @435386
     /* 435386 */ GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(435440),
     /* 435391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 435397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435409 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(435424), // Rule ID 1889 //
     /* 435414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435417 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 435417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 435422 */     GIR_RootConstrainSelectedInstOperands,
     /* 435423 */     // GIR_Coverage, 1889,
     /* 435423 */     GIR_Done,
     /* 435424 */   // Label 8761: @435424
     /* 435424 */   GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(435439), // Rule ID 5511 //
     /* 435429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435432 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 435432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 435437 */     GIR_RootConstrainSelectedInstOperands,
     /* 435438 */     // GIR_Coverage, 5511,
     /* 435438 */     GIR_Done,
     /* 435439 */   // Label 8762: @435439
     /* 435439 */   GIM_Reject,
     /* 435440 */ // Label 8760: @435440
     /* 435440 */ GIM_Reject,
     /* 435441 */ // Label 8736: @435441
     /* 435441 */ GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(435474), // Rule ID 1884 //
     /* 435446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 435452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 435455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435463 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435467 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 435467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 435472 */   GIR_RootConstrainSelectedInstOperands,
     /* 435473 */   // GIR_Coverage, 1884,
     /* 435473 */   GIR_Done,
     /* 435474 */ // Label 8763: @435474
     /* 435474 */ GIM_Reject,
     /* 435475 */ // Label 8737: @435475
     /* 435475 */ GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(435529),
     /* 435480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 435486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435498 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(435513), // Rule ID 1887 //
     /* 435503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435506 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 435506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 435511 */     GIR_RootConstrainSelectedInstOperands,
     /* 435512 */     // GIR_Coverage, 1887,
     /* 435512 */     GIR_Done,
     /* 435513 */   // Label 8765: @435513
     /* 435513 */   GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(435528), // Rule ID 5509 //
     /* 435518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435521 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 435521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 435526 */     GIR_RootConstrainSelectedInstOperands,
     /* 435527 */     // GIR_Coverage, 5509,
     /* 435527 */     GIR_Done,
     /* 435528 */   // Label 8766: @435528
     /* 435528 */   GIM_Reject,
     /* 435529 */ // Label 8764: @435529
     /* 435529 */ GIM_Reject,
     /* 435530 */ // Label 8738: @435530
     /* 435530 */ GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(435563), // Rule ID 1885 //
     /* 435535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 435541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 435544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435556 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 435556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 435561 */   GIR_RootConstrainSelectedInstOperands,
     /* 435562 */   // GIR_Coverage, 1885,
     /* 435562 */   GIR_Done,
     /* 435563 */ // Label 8767: @435563
     /* 435563 */ GIM_Reject,
     /* 435564 */ // Label 8739: @435564
     /* 435564 */ GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(435589), // Rule ID 9031 //
     /* 435569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 435575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 435578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435582 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 435582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 435587 */   GIR_RootConstrainSelectedInstOperands,
     /* 435588 */   // GIR_Coverage, 9031,
     /* 435588 */   GIR_Done,
     /* 435589 */ // Label 8768: @435589
     /* 435589 */ GIM_Reject,
     /* 435590 */ // Label 8740: @435590
     /* 435590 */ GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(435615), // Rule ID 8993 //
     /* 435595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 435601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 435604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435608 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 435608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 435613 */   GIR_RootConstrainSelectedInstOperands,
     /* 435614 */   // GIR_Coverage, 8993,
     /* 435614 */   GIR_Done,
     /* 435615 */ // Label 8769: @435615
     /* 435615 */ GIM_Reject,
     /* 435616 */ // Label 8741: @435616
     /* 435616 */ GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(435641), // Rule ID 8994 //
     /* 435621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 435627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 435630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435634 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 435634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 435639 */   GIR_RootConstrainSelectedInstOperands,
     /* 435640 */   // GIR_Coverage, 8994,
     /* 435640 */   GIR_Done,
     /* 435641 */ // Label 8770: @435641
     /* 435641 */ GIM_Reject,
     /* 435642 */ // Label 8742: @435642
     /* 435642 */ GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(435688),
     /* 435647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 435650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 435653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435657 */   GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(435672), // Rule ID 8989 //
     /* 435662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435665 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 435665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 435670 */     GIR_RootConstrainSelectedInstOperands,
     /* 435671 */     // GIR_Coverage, 8989,
     /* 435671 */     GIR_Done,
     /* 435672 */   // Label 8772: @435672
     /* 435672 */   GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(435687), // Rule ID 8995 //
     /* 435677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435680 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 435680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 435685 */     GIR_RootConstrainSelectedInstOperands,
     /* 435686 */     // GIR_Coverage, 8995,
     /* 435686 */     GIR_Done,
     /* 435687 */   // Label 8773: @435687
     /* 435687 */   GIM_Reject,
     /* 435688 */ // Label 8771: @435688
     /* 435688 */ GIM_Reject,
     /* 435689 */ // Label 8743: @435689
     /* 435689 */ GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(435714), // Rule ID 9030 //
     /* 435694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 435700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 435703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435707 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 435707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 435712 */   GIR_RootConstrainSelectedInstOperands,
     /* 435713 */   // GIR_Coverage, 9030,
     /* 435713 */   GIR_Done,
     /* 435714 */ // Label 8774: @435714
     /* 435714 */ GIM_Reject,
     /* 435715 */ // Label 8744: @435715
     /* 435715 */ GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(435740), // Rule ID 8991 //
     /* 435720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 435726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 435729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435733 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 435733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 435738 */   GIR_RootConstrainSelectedInstOperands,
     /* 435739 */   // GIR_Coverage, 8991,
     /* 435739 */   GIR_Done,
     /* 435740 */ // Label 8775: @435740
     /* 435740 */ GIM_Reject,
     /* 435741 */ // Label 8745: @435741
     /* 435741 */ GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(435787),
     /* 435746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 435749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 435752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435756 */   GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(435771), // Rule ID 8988 //
     /* 435761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435764 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 435764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 435769 */     GIR_RootConstrainSelectedInstOperands,
     /* 435770 */     // GIR_Coverage, 8988,
     /* 435770 */     GIR_Done,
     /* 435771 */   // Label 8777: @435771
     /* 435771 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(435786), // Rule ID 8992 //
     /* 435776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435779 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 435779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 435784 */     GIR_RootConstrainSelectedInstOperands,
     /* 435785 */     // GIR_Coverage, 8992,
     /* 435785 */     GIR_Done,
     /* 435786 */   // Label 8778: @435786
     /* 435786 */   GIM_Reject,
     /* 435787 */ // Label 8776: @435787
     /* 435787 */ GIM_Reject,
     /* 435788 */ // Label 8746: @435788
     /* 435788 */ GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(435813), // Rule ID 9029 //
     /* 435793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 435799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 435802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435806 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 435806 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 435811 */   GIR_RootConstrainSelectedInstOperands,
     /* 435812 */   // GIR_Coverage, 9029,
     /* 435812 */   GIR_Done,
     /* 435813 */ // Label 8779: @435813
     /* 435813 */ GIM_Reject,
     /* 435814 */ // Label 8747: @435814
     /* 435814 */ GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(435860),
     /* 435819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 435822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 435825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435829 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(435844), // Rule ID 8987 //
     /* 435834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435837 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 435837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 435842 */     GIR_RootConstrainSelectedInstOperands,
     /* 435843 */     // GIR_Coverage, 8987,
     /* 435843 */     GIR_Done,
     /* 435844 */   // Label 8781: @435844
     /* 435844 */   GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(435859), // Rule ID 8990 //
     /* 435849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435852 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 435852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 435857 */     GIR_RootConstrainSelectedInstOperands,
     /* 435858 */     // GIR_Coverage, 8990,
     /* 435858 */     GIR_Done,
     /* 435859 */   // Label 8782: @435859
     /* 435859 */   GIM_Reject,
     /* 435860 */ // Label 8780: @435860
     /* 435860 */ GIM_Reject,
     /* 435861 */ // Label 8748: @435861
     /* 435861 */ GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(435886), // Rule ID 2406 //
     /* 435866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 435872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 435875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435879 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 435879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 435884 */   GIR_RootConstrainSelectedInstOperands,
     /* 435885 */   // GIR_Coverage, 2406,
     /* 435885 */   GIR_Done,
     /* 435886 */ // Label 8783: @435886
     /* 435886 */ GIM_Reject,
     /* 435887 */ // Label 8749: @435887
     /* 435887 */ GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(435912), // Rule ID 8986 //
     /* 435892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 435898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 435901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435905 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 435905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 435910 */   GIR_RootConstrainSelectedInstOperands,
     /* 435911 */   // GIR_Coverage, 8986,
     /* 435911 */   GIR_Done,
     /* 435912 */ // Label 8784: @435912
     /* 435912 */ GIM_Reject,
     /* 435913 */ // Label 8750: @435913
     /* 435913 */ GIM_Reject,
     /* 435914 */ // Label 149: @435914
     /* 435914 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8803*/ GIMT_Encode4(436693),
     /* 435925 */ /*GILLT_v2s32*//*Label 8785*/ GIMT_Encode4(436001),
     /* 435929 */ /*GILLT_v2s64*//*Label 8786*/ GIMT_Encode4(436056),
     /* 435933 */ /*GILLT_v4s16*//*Label 8787*/ GIMT_Encode4(436111),
     /* 435937 */ /*GILLT_v4s32*//*Label 8788*/ GIMT_Encode4(436166),
     /* 435941 */ /*GILLT_v8s8*//*Label 8789*/ GIMT_Encode4(436221),
     /* 435945 */ /*GILLT_v8s16*//*Label 8790*/ GIMT_Encode4(436255),
     /* 435949 */ /*GILLT_v16s8*//*Label 8791*/ GIMT_Encode4(436310), GIMT_Encode4(0),
     /* 435957 */ /*GILLT_nxv2s1*//*Label 8792*/ GIMT_Encode4(436344),
     /* 435961 */ /*GILLT_nxv2s16*//*Label 8793*/ GIMT_Encode4(436370),
     /* 435965 */ /*GILLT_nxv2s32*//*Label 8794*/ GIMT_Encode4(436396),
     /* 435969 */ /*GILLT_nxv2s64*//*Label 8795*/ GIMT_Encode4(436422),
     /* 435973 */ /*GILLT_nxv4s1*//*Label 8796*/ GIMT_Encode4(436469),
     /* 435977 */ /*GILLT_nxv4s16*//*Label 8797*/ GIMT_Encode4(436495),
     /* 435981 */ /*GILLT_nxv4s32*//*Label 8798*/ GIMT_Encode4(436521),
     /* 435985 */ /*GILLT_nxv8s1*//*Label 8799*/ GIMT_Encode4(436568),
     /* 435989 */ /*GILLT_nxv8s16*//*Label 8800*/ GIMT_Encode4(436594),
     /* 435993 */ /*GILLT_nxv16s1*//*Label 8801*/ GIMT_Encode4(436641),
     /* 435997 */ /*GILLT_nxv16s8*//*Label 8802*/ GIMT_Encode4(436667),
     /* 436001 */ // Label 8785: @436001
     /* 436001 */ GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(436055),
     /* 436006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 436009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 436012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436024 */   GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(436039), // Rule ID 1895 //
     /* 436029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436032 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 436032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 436037 */     GIR_RootConstrainSelectedInstOperands,
     /* 436038 */     // GIR_Coverage, 1895,
     /* 436038 */     GIR_Done,
     /* 436039 */   // Label 8805: @436039
     /* 436039 */   GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(436054), // Rule ID 5515 //
     /* 436044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436047 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 436047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 436052 */     GIR_RootConstrainSelectedInstOperands,
     /* 436053 */     // GIR_Coverage, 5515,
     /* 436053 */     GIR_Done,
     /* 436054 */   // Label 8806: @436054
     /* 436054 */   GIM_Reject,
     /* 436055 */ // Label 8804: @436055
     /* 436055 */ GIM_Reject,
     /* 436056 */ // Label 8786: @436056
     /* 436056 */ GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(436110),
     /* 436061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 436064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 436067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436079 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(436094), // Rule ID 1897 //
     /* 436084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436087 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 436087 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 436092 */     GIR_RootConstrainSelectedInstOperands,
     /* 436093 */     // GIR_Coverage, 1897,
     /* 436093 */     GIR_Done,
     /* 436094 */   // Label 8808: @436094
     /* 436094 */   GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(436109), // Rule ID 5517 //
     /* 436099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436102 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 436102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 436107 */     GIR_RootConstrainSelectedInstOperands,
     /* 436108 */     // GIR_Coverage, 5517,
     /* 436108 */     GIR_Done,
     /* 436109 */   // Label 8809: @436109
     /* 436109 */   GIM_Reject,
     /* 436110 */ // Label 8807: @436110
     /* 436110 */ GIM_Reject,
     /* 436111 */ // Label 8787: @436111
     /* 436111 */ GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(436165),
     /* 436116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 436119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 436122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436134 */   GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(436149), // Rule ID 1893 //
     /* 436139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436142 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 436142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 436147 */     GIR_RootConstrainSelectedInstOperands,
     /* 436148 */     // GIR_Coverage, 1893,
     /* 436148 */     GIR_Done,
     /* 436149 */   // Label 8811: @436149
     /* 436149 */   GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(436164), // Rule ID 5513 //
     /* 436154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436157 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 436157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 436162 */     GIR_RootConstrainSelectedInstOperands,
     /* 436163 */     // GIR_Coverage, 5513,
     /* 436163 */     GIR_Done,
     /* 436164 */   // Label 8812: @436164
     /* 436164 */   GIM_Reject,
     /* 436165 */ // Label 8810: @436165
     /* 436165 */ GIM_Reject,
     /* 436166 */ // Label 8788: @436166
     /* 436166 */ GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(436220),
     /* 436171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 436177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436189 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(436204), // Rule ID 1896 //
     /* 436194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436197 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 436197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 436202 */     GIR_RootConstrainSelectedInstOperands,
     /* 436203 */     // GIR_Coverage, 1896,
     /* 436203 */     GIR_Done,
     /* 436204 */   // Label 8814: @436204
     /* 436204 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(436219), // Rule ID 5516 //
     /* 436209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436212 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 436212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 436217 */     GIR_RootConstrainSelectedInstOperands,
     /* 436218 */     // GIR_Coverage, 5516,
     /* 436218 */     GIR_Done,
     /* 436219 */   // Label 8815: @436219
     /* 436219 */   GIM_Reject,
     /* 436220 */ // Label 8813: @436220
     /* 436220 */ GIM_Reject,
     /* 436221 */ // Label 8789: @436221
     /* 436221 */ GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(436254), // Rule ID 1891 //
     /* 436226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 436232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 436235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436247 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 436247 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 436252 */   GIR_RootConstrainSelectedInstOperands,
     /* 436253 */   // GIR_Coverage, 1891,
     /* 436253 */   GIR_Done,
     /* 436254 */ // Label 8816: @436254
     /* 436254 */ GIM_Reject,
     /* 436255 */ // Label 8790: @436255
     /* 436255 */ GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(436309),
     /* 436260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 436266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436278 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(436293), // Rule ID 1894 //
     /* 436283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436286 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 436286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 436291 */     GIR_RootConstrainSelectedInstOperands,
     /* 436292 */     // GIR_Coverage, 1894,
     /* 436292 */     GIR_Done,
     /* 436293 */   // Label 8818: @436293
     /* 436293 */   GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(436308), // Rule ID 5514 //
     /* 436298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436301 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 436301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 436306 */     GIR_RootConstrainSelectedInstOperands,
     /* 436307 */     // GIR_Coverage, 5514,
     /* 436307 */     GIR_Done,
     /* 436308 */   // Label 8819: @436308
     /* 436308 */   GIM_Reject,
     /* 436309 */ // Label 8817: @436309
     /* 436309 */ GIM_Reject,
     /* 436310 */ // Label 8791: @436310
     /* 436310 */ GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(436343), // Rule ID 1892 //
     /* 436315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 436321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 436324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436336 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 436336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 436341 */   GIR_RootConstrainSelectedInstOperands,
     /* 436342 */   // GIR_Coverage, 1892,
     /* 436342 */   GIR_Done,
     /* 436343 */ // Label 8820: @436343
     /* 436343 */ GIM_Reject,
     /* 436344 */ // Label 8792: @436344
     /* 436344 */ GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(436369), // Rule ID 9034 //
     /* 436349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 436355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 436358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436362 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 436362 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 436367 */   GIR_RootConstrainSelectedInstOperands,
     /* 436368 */   // GIR_Coverage, 9034,
     /* 436368 */   GIR_Done,
     /* 436369 */ // Label 8821: @436369
     /* 436369 */ GIM_Reject,
     /* 436370 */ // Label 8793: @436370
     /* 436370 */ GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(436395), // Rule ID 9003 //
     /* 436375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 436381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 436384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436388 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 436388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 436393 */   GIR_RootConstrainSelectedInstOperands,
     /* 436394 */   // GIR_Coverage, 9003,
     /* 436394 */   GIR_Done,
     /* 436395 */ // Label 8822: @436395
     /* 436395 */ GIM_Reject,
     /* 436396 */ // Label 8794: @436396
     /* 436396 */ GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(436421), // Rule ID 9004 //
     /* 436401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 436407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 436410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436414 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 436414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 436419 */   GIR_RootConstrainSelectedInstOperands,
     /* 436420 */   // GIR_Coverage, 9004,
     /* 436420 */   GIR_Done,
     /* 436421 */ // Label 8823: @436421
     /* 436421 */ GIM_Reject,
     /* 436422 */ // Label 8795: @436422
     /* 436422 */ GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(436468),
     /* 436427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 436430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 436433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436437 */   GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(436452), // Rule ID 8999 //
     /* 436442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436445 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 436445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 436450 */     GIR_RootConstrainSelectedInstOperands,
     /* 436451 */     // GIR_Coverage, 8999,
     /* 436451 */     GIR_Done,
     /* 436452 */   // Label 8825: @436452
     /* 436452 */   GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(436467), // Rule ID 9005 //
     /* 436457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436460 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 436460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 436465 */     GIR_RootConstrainSelectedInstOperands,
     /* 436466 */     // GIR_Coverage, 9005,
     /* 436466 */     GIR_Done,
     /* 436467 */   // Label 8826: @436467
     /* 436467 */   GIM_Reject,
     /* 436468 */ // Label 8824: @436468
     /* 436468 */ GIM_Reject,
     /* 436469 */ // Label 8796: @436469
     /* 436469 */ GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(436494), // Rule ID 9033 //
     /* 436474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 436480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 436483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436487 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 436487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 436492 */   GIR_RootConstrainSelectedInstOperands,
     /* 436493 */   // GIR_Coverage, 9033,
     /* 436493 */   GIR_Done,
     /* 436494 */ // Label 8827: @436494
     /* 436494 */ GIM_Reject,
     /* 436495 */ // Label 8797: @436495
     /* 436495 */ GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(436520), // Rule ID 9001 //
     /* 436500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 436506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 436509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436513 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 436513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 436518 */   GIR_RootConstrainSelectedInstOperands,
     /* 436519 */   // GIR_Coverage, 9001,
     /* 436519 */   GIR_Done,
     /* 436520 */ // Label 8828: @436520
     /* 436520 */ GIM_Reject,
     /* 436521 */ // Label 8798: @436521
     /* 436521 */ GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(436567),
     /* 436526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 436529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 436532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436536 */   GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(436551), // Rule ID 8998 //
     /* 436541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436544 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 436544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 436549 */     GIR_RootConstrainSelectedInstOperands,
     /* 436550 */     // GIR_Coverage, 8998,
     /* 436550 */     GIR_Done,
     /* 436551 */   // Label 8830: @436551
     /* 436551 */   GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(436566), // Rule ID 9002 //
     /* 436556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436559 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 436559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 436564 */     GIR_RootConstrainSelectedInstOperands,
     /* 436565 */     // GIR_Coverage, 9002,
     /* 436565 */     GIR_Done,
     /* 436566 */   // Label 8831: @436566
     /* 436566 */   GIM_Reject,
     /* 436567 */ // Label 8829: @436567
     /* 436567 */ GIM_Reject,
     /* 436568 */ // Label 8799: @436568
     /* 436568 */ GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(436593), // Rule ID 9032 //
     /* 436573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 436579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 436582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436586 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 436586 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 436591 */   GIR_RootConstrainSelectedInstOperands,
     /* 436592 */   // GIR_Coverage, 9032,
     /* 436592 */   GIR_Done,
     /* 436593 */ // Label 8832: @436593
     /* 436593 */ GIM_Reject,
     /* 436594 */ // Label 8800: @436594
     /* 436594 */ GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(436640),
     /* 436599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 436602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 436605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436609 */   GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(436624), // Rule ID 8997 //
     /* 436614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436617 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 436617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 436622 */     GIR_RootConstrainSelectedInstOperands,
     /* 436623 */     // GIR_Coverage, 8997,
     /* 436623 */     GIR_Done,
     /* 436624 */   // Label 8834: @436624
     /* 436624 */   GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(436639), // Rule ID 9000 //
     /* 436629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436632 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 436632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 436637 */     GIR_RootConstrainSelectedInstOperands,
     /* 436638 */     // GIR_Coverage, 9000,
     /* 436638 */     GIR_Done,
     /* 436639 */   // Label 8835: @436639
     /* 436639 */   GIM_Reject,
     /* 436640 */ // Label 8833: @436640
     /* 436640 */ GIM_Reject,
     /* 436641 */ // Label 8801: @436641
     /* 436641 */ GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(436666), // Rule ID 2410 //
     /* 436646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 436652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 436655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436659 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 436659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 436664 */   GIR_RootConstrainSelectedInstOperands,
     /* 436665 */   // GIR_Coverage, 2410,
     /* 436665 */   GIR_Done,
     /* 436666 */ // Label 8836: @436666
     /* 436666 */ GIM_Reject,
     /* 436667 */ // Label 8802: @436667
     /* 436667 */ GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(436692), // Rule ID 8996 //
     /* 436672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 436678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 436681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436685 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 436685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 436690 */   GIR_RootConstrainSelectedInstOperands,
     /* 436691 */   // GIR_Coverage, 8996,
     /* 436691 */   GIR_Done,
     /* 436692 */ // Label 8837: @436692
     /* 436692 */ GIM_Reject,
     /* 436693 */ // Label 8803: @436693
     /* 436693 */ GIM_Reject,
     /* 436694 */ // Label 150: @436694
     /* 436694 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8846*/ GIMT_Encode4(437391),
     /* 436705 */ /*GILLT_s64*//*Label 8838*/ GIMT_Encode4(436741), GIMT_Encode4(0),
     /* 436713 */ /*GILLT_v2s32*//*Label 8839*/ GIMT_Encode4(436852),
     /* 436717 */ /*GILLT_v2s64*//*Label 8840*/ GIMT_Encode4(436929),
     /* 436721 */ /*GILLT_v4s16*//*Label 8841*/ GIMT_Encode4(437006),
     /* 436725 */ /*GILLT_v4s32*//*Label 8842*/ GIMT_Encode4(437083),
     /* 436729 */ /*GILLT_v8s8*//*Label 8843*/ GIMT_Encode4(437160),
     /* 436733 */ /*GILLT_v8s16*//*Label 8844*/ GIMT_Encode4(437237),
     /* 436737 */ /*GILLT_v16s8*//*Label 8845*/ GIMT_Encode4(437314),
     /* 436741 */ // Label 8838: @436741
     /* 436741 */ GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(436851),
     /* 436746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 436749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436757 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(436782), // Rule ID 5287 //
     /* 436762 */     // MIs[0] Operand 2
     /* 436762 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 436773 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 436773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 436776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436780 */     GIR_RootConstrainSelectedInstOperands,
     /* 436781 */     // GIR_Coverage, 5287,
     /* 436781 */     GIR_EraseRootFromParent_Done,
     /* 436782 */   // Label 8848: @436782
     /* 436782 */   GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(436816), // Rule ID 2120 //
     /* 436787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436790 */     // MIs[0] imm
     /* 436790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 436802 */     // MIs[1] Operand 1
     /* 436802 */     // No operand predicates
     /* 436802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436804 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 436807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436814 */     GIR_RootConstrainSelectedInstOperands,
     /* 436815 */     // GIR_Coverage, 2120,
     /* 436815 */     GIR_EraseRootFromParent_Done,
     /* 436816 */   // Label 8849: @436816
     /* 436816 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(436850), // Rule ID 6349 //
     /* 436821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436824 */     // MIs[0] imm
     /* 436824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 436836 */     // MIs[1] Operand 1
     /* 436836 */     // No operand predicates
     /* 436836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436838 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 436838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 436841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436848 */     GIR_RootConstrainSelectedInstOperands,
     /* 436849 */     // GIR_Coverage, 6349,
     /* 436849 */     GIR_EraseRootFromParent_Done,
     /* 436850 */   // Label 8850: @436850
     /* 436850 */   GIM_Reject,
     /* 436851 */ // Label 8847: @436851
     /* 436851 */ GIM_Reject,
     /* 436852 */ // Label 8839: @436852
     /* 436852 */ GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(436928),
     /* 436857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 436860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436868 */   GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(436893), // Rule ID 4928 //
     /* 436873 */     // MIs[0] Operand 2
     /* 436873 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 436884 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 436884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 436887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436891 */     GIR_RootConstrainSelectedInstOperands,
     /* 436892 */     // GIR_Coverage, 4928,
     /* 436892 */     GIR_EraseRootFromParent_Done,
     /* 436893 */   // Label 8852: @436893
     /* 436893 */   GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(436927), // Rule ID 2227 //
     /* 436898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436901 */     // MIs[0] imm
     /* 436901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 436913 */     // MIs[1] Operand 1
     /* 436913 */     // No operand predicates
     /* 436913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436915 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 436918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436925 */     GIR_RootConstrainSelectedInstOperands,
     /* 436926 */     // GIR_Coverage, 2227,
     /* 436926 */     GIR_EraseRootFromParent_Done,
     /* 436927 */   // Label 8853: @436927
     /* 436927 */   GIM_Reject,
     /* 436928 */ // Label 8851: @436928
     /* 436928 */ GIM_Reject,
     /* 436929 */ // Label 8840: @436929
     /* 436929 */ GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(437005),
     /* 436934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 436937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436945 */   GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(436970), // Rule ID 4932 //
     /* 436950 */     // MIs[0] Operand 2
     /* 436950 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 436961 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 436961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 436964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436968 */     GIR_RootConstrainSelectedInstOperands,
     /* 436969 */     // GIR_Coverage, 4932,
     /* 436969 */     GIR_EraseRootFromParent_Done,
     /* 436970 */   // Label 8855: @436970
     /* 436970 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(437004), // Rule ID 2229 //
     /* 436975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436978 */     // MIs[0] imm
     /* 436978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 436990 */     // MIs[1] Operand 1
     /* 436990 */     // No operand predicates
     /* 436990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436992 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 436995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437002 */     GIR_RootConstrainSelectedInstOperands,
     /* 437003 */     // GIR_Coverage, 2229,
     /* 437003 */     GIR_EraseRootFromParent_Done,
     /* 437004 */   // Label 8856: @437004
     /* 437004 */   GIM_Reject,
     /* 437005 */ // Label 8854: @437005
     /* 437005 */ GIM_Reject,
     /* 437006 */ // Label 8841: @437006
     /* 437006 */ GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(437082),
     /* 437011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 437014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437022 */   GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(437047), // Rule ID 4927 //
     /* 437027 */     // MIs[0] Operand 2
     /* 437027 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 437038 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 437038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 437041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437045 */     GIR_RootConstrainSelectedInstOperands,
     /* 437046 */     // GIR_Coverage, 4927,
     /* 437046 */     GIR_EraseRootFromParent_Done,
     /* 437047 */   // Label 8858: @437047
     /* 437047 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(437081), // Rule ID 2225 //
     /* 437052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437055 */     // MIs[0] imm
     /* 437055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 437067 */     // MIs[1] Operand 1
     /* 437067 */     // No operand predicates
     /* 437067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437069 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 437072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437079 */     GIR_RootConstrainSelectedInstOperands,
     /* 437080 */     // GIR_Coverage, 2225,
     /* 437080 */     GIR_EraseRootFromParent_Done,
     /* 437081 */   // Label 8859: @437081
     /* 437081 */   GIM_Reject,
     /* 437082 */ // Label 8857: @437082
     /* 437082 */ GIM_Reject,
     /* 437083 */ // Label 8842: @437083
     /* 437083 */ GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(437159),
     /* 437088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 437091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437099 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(437124), // Rule ID 4931 //
     /* 437104 */     // MIs[0] Operand 2
     /* 437104 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 437115 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 437115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 437118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437120 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437122 */     GIR_RootConstrainSelectedInstOperands,
     /* 437123 */     // GIR_Coverage, 4931,
     /* 437123 */     GIR_EraseRootFromParent_Done,
     /* 437124 */   // Label 8861: @437124
     /* 437124 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(437158), // Rule ID 2228 //
     /* 437129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437132 */     // MIs[0] imm
     /* 437132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 437144 */     // MIs[1] Operand 1
     /* 437144 */     // No operand predicates
     /* 437144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437146 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 437149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437156 */     GIR_RootConstrainSelectedInstOperands,
     /* 437157 */     // GIR_Coverage, 2228,
     /* 437157 */     GIR_EraseRootFromParent_Done,
     /* 437158 */   // Label 8862: @437158
     /* 437158 */   GIM_Reject,
     /* 437159 */ // Label 8860: @437159
     /* 437159 */ GIM_Reject,
     /* 437160 */ // Label 8843: @437160
     /* 437160 */ GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(437236),
     /* 437165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 437168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437176 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(437201), // Rule ID 4926 //
     /* 437181 */     // MIs[0] Operand 2
     /* 437181 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 437192 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 437192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 437195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437199 */     GIR_RootConstrainSelectedInstOperands,
     /* 437200 */     // GIR_Coverage, 4926,
     /* 437200 */     GIR_EraseRootFromParent_Done,
     /* 437201 */   // Label 8864: @437201
     /* 437201 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(437235), // Rule ID 2223 //
     /* 437206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437209 */     // MIs[0] imm
     /* 437209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 437221 */     // MIs[1] Operand 1
     /* 437221 */     // No operand predicates
     /* 437221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437223 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 437226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437233 */     GIR_RootConstrainSelectedInstOperands,
     /* 437234 */     // GIR_Coverage, 2223,
     /* 437234 */     GIR_EraseRootFromParent_Done,
     /* 437235 */   // Label 8865: @437235
     /* 437235 */   GIM_Reject,
     /* 437236 */ // Label 8863: @437236
     /* 437236 */ GIM_Reject,
     /* 437237 */ // Label 8844: @437237
     /* 437237 */ GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(437313),
     /* 437242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437253 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(437278), // Rule ID 4930 //
     /* 437258 */     // MIs[0] Operand 2
     /* 437258 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 437269 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 437269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 437272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437276 */     GIR_RootConstrainSelectedInstOperands,
     /* 437277 */     // GIR_Coverage, 4930,
     /* 437277 */     GIR_EraseRootFromParent_Done,
     /* 437278 */   // Label 8867: @437278
     /* 437278 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(437312), // Rule ID 2226 //
     /* 437283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437286 */     // MIs[0] imm
     /* 437286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437294 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 437298 */     // MIs[1] Operand 1
     /* 437298 */     // No operand predicates
     /* 437298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437300 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 437303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437310 */     GIR_RootConstrainSelectedInstOperands,
     /* 437311 */     // GIR_Coverage, 2226,
     /* 437311 */     GIR_EraseRootFromParent_Done,
     /* 437312 */   // Label 8868: @437312
     /* 437312 */   GIM_Reject,
     /* 437313 */ // Label 8866: @437313
     /* 437313 */ GIM_Reject,
     /* 437314 */ // Label 8845: @437314
     /* 437314 */ GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(437390),
     /* 437319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 437322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437330 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(437355), // Rule ID 4929 //
     /* 437335 */     // MIs[0] Operand 2
     /* 437335 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 437346 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 437346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 437349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437351 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437353 */     GIR_RootConstrainSelectedInstOperands,
     /* 437354 */     // GIR_Coverage, 4929,
     /* 437354 */     GIR_EraseRootFromParent_Done,
     /* 437355 */   // Label 8870: @437355
     /* 437355 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(437389), // Rule ID 2224 //
     /* 437360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437363 */     // MIs[0] imm
     /* 437363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 437375 */     // MIs[1] Operand 1
     /* 437375 */     // No operand predicates
     /* 437375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437377 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 437380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437387 */     GIR_RootConstrainSelectedInstOperands,
     /* 437388 */     // GIR_Coverage, 2224,
     /* 437388 */     GIR_EraseRootFromParent_Done,
     /* 437389 */   // Label 8871: @437389
     /* 437389 */   GIM_Reject,
     /* 437390 */ // Label 8869: @437390
     /* 437390 */ GIM_Reject,
     /* 437391 */ // Label 8846: @437391
     /* 437391 */ GIM_Reject,
     /* 437392 */ // Label 151: @437392
     /* 437392 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8880*/ GIMT_Encode4(437847),
     /* 437403 */ /*GILLT_s64*//*Label 8872*/ GIMT_Encode4(437439), GIMT_Encode4(0),
     /* 437411 */ /*GILLT_v2s32*//*Label 8873*/ GIMT_Encode4(437525),
     /* 437415 */ /*GILLT_v2s64*//*Label 8874*/ GIMT_Encode4(437571),
     /* 437419 */ /*GILLT_v4s16*//*Label 8875*/ GIMT_Encode4(437617),
     /* 437423 */ /*GILLT_v4s32*//*Label 8876*/ GIMT_Encode4(437663),
     /* 437427 */ /*GILLT_v8s8*//*Label 8877*/ GIMT_Encode4(437709),
     /* 437431 */ /*GILLT_v8s16*//*Label 8878*/ GIMT_Encode4(437755),
     /* 437435 */ /*GILLT_v16s8*//*Label 8879*/ GIMT_Encode4(437801),
     /* 437439 */ // Label 8872: @437439
     /* 437439 */ GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(437524),
     /* 437444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 437447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437455 */   GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(437489), // Rule ID 2129 //
     /* 437460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437463 */     // MIs[0] imm
     /* 437463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 437475 */     // MIs[1] Operand 1
     /* 437475 */     // No operand predicates
     /* 437475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437477 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 437480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437487 */     GIR_RootConstrainSelectedInstOperands,
     /* 437488 */     // GIR_Coverage, 2129,
     /* 437488 */     GIR_EraseRootFromParent_Done,
     /* 437489 */   // Label 8882: @437489
     /* 437489 */   GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(437523), // Rule ID 6352 //
     /* 437494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437497 */     // MIs[0] imm
     /* 437497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 437509 */     // MIs[1] Operand 1
     /* 437509 */     // No operand predicates
     /* 437509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437511 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 437511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 437514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437521 */     GIR_RootConstrainSelectedInstOperands,
     /* 437522 */     // GIR_Coverage, 6352,
     /* 437522 */     GIR_EraseRootFromParent_Done,
     /* 437523 */   // Label 8883: @437523
     /* 437523 */   GIM_Reject,
     /* 437524 */ // Label 8881: @437524
     /* 437524 */ GIM_Reject,
     /* 437525 */ // Label 8873: @437525
     /* 437525 */ GIM_Try, /*On fail goto*//*Label 8884*/ GIMT_Encode4(437570), // Rule ID 2286 //
     /* 437530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 437536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437544 */   // MIs[0] imm
     /* 437544 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437548 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437552 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 437556 */   // MIs[1] Operand 1
     /* 437556 */   // No operand predicates
     /* 437556 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437558 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 437561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437563 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437565 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437568 */   GIR_RootConstrainSelectedInstOperands,
     /* 437569 */   // GIR_Coverage, 2286,
     /* 437569 */   GIR_EraseRootFromParent_Done,
     /* 437570 */ // Label 8884: @437570
     /* 437570 */ GIM_Reject,
     /* 437571 */ // Label 8874: @437571
     /* 437571 */ GIM_Try, /*On fail goto*//*Label 8885*/ GIMT_Encode4(437616), // Rule ID 2288 //
     /* 437576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 437582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437590 */   // MIs[0] imm
     /* 437590 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437594 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437598 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 437602 */   // MIs[1] Operand 1
     /* 437602 */   // No operand predicates
     /* 437602 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437604 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 437607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437609 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437611 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437614 */   GIR_RootConstrainSelectedInstOperands,
     /* 437615 */   // GIR_Coverage, 2288,
     /* 437615 */   GIR_EraseRootFromParent_Done,
     /* 437616 */ // Label 8885: @437616
     /* 437616 */ GIM_Reject,
     /* 437617 */ // Label 8875: @437617
     /* 437617 */ GIM_Try, /*On fail goto*//*Label 8886*/ GIMT_Encode4(437662), // Rule ID 2284 //
     /* 437622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 437628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437636 */   // MIs[0] imm
     /* 437636 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437640 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437644 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 437648 */   // MIs[1] Operand 1
     /* 437648 */   // No operand predicates
     /* 437648 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437650 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 437653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437655 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437657 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437660 */   GIR_RootConstrainSelectedInstOperands,
     /* 437661 */   // GIR_Coverage, 2284,
     /* 437661 */   GIR_EraseRootFromParent_Done,
     /* 437662 */ // Label 8886: @437662
     /* 437662 */ GIM_Reject,
     /* 437663 */ // Label 8876: @437663
     /* 437663 */ GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(437708), // Rule ID 2287 //
     /* 437668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 437674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437682 */   // MIs[0] imm
     /* 437682 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437686 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437690 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 437694 */   // MIs[1] Operand 1
     /* 437694 */   // No operand predicates
     /* 437694 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437696 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 437699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437701 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437703 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437706 */   GIR_RootConstrainSelectedInstOperands,
     /* 437707 */   // GIR_Coverage, 2287,
     /* 437707 */   GIR_EraseRootFromParent_Done,
     /* 437708 */ // Label 8887: @437708
     /* 437708 */ GIM_Reject,
     /* 437709 */ // Label 8877: @437709
     /* 437709 */ GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(437754), // Rule ID 2282 //
     /* 437714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 437720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437728 */   // MIs[0] imm
     /* 437728 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437732 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437736 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 437740 */   // MIs[1] Operand 1
     /* 437740 */   // No operand predicates
     /* 437740 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437742 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 437745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437747 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437749 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437752 */   GIR_RootConstrainSelectedInstOperands,
     /* 437753 */   // GIR_Coverage, 2282,
     /* 437753 */   GIR_EraseRootFromParent_Done,
     /* 437754 */ // Label 8888: @437754
     /* 437754 */ GIM_Reject,
     /* 437755 */ // Label 8878: @437755
     /* 437755 */ GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(437800), // Rule ID 2285 //
     /* 437760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437774 */   // MIs[0] imm
     /* 437774 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437778 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437782 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 437786 */   // MIs[1] Operand 1
     /* 437786 */   // No operand predicates
     /* 437786 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437788 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 437791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437793 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437795 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437798 */   GIR_RootConstrainSelectedInstOperands,
     /* 437799 */   // GIR_Coverage, 2285,
     /* 437799 */   GIR_EraseRootFromParent_Done,
     /* 437800 */ // Label 8889: @437800
     /* 437800 */ GIM_Reject,
     /* 437801 */ // Label 8879: @437801
     /* 437801 */ GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(437846), // Rule ID 2283 //
     /* 437806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 437812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437820 */   // MIs[0] imm
     /* 437820 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437824 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437828 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 437832 */   // MIs[1] Operand 1
     /* 437832 */   // No operand predicates
     /* 437832 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437834 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 437837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437839 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437841 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437844 */   GIR_RootConstrainSelectedInstOperands,
     /* 437845 */   // GIR_Coverage, 2283,
     /* 437845 */   GIR_EraseRootFromParent_Done,
     /* 437846 */ // Label 8890: @437846
     /* 437846 */ GIM_Reject,
     /* 437847 */ // Label 8880: @437847
     /* 437847 */ GIM_Reject,
     /* 437848 */ // Label 152: @437848
     /* 437848 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8909*/ GIMT_Encode4(438627),
     /* 437859 */ /*GILLT_v2s32*//*Label 8891*/ GIMT_Encode4(437935),
     /* 437863 */ /*GILLT_v2s64*//*Label 8892*/ GIMT_Encode4(437990),
     /* 437867 */ /*GILLT_v4s16*//*Label 8893*/ GIMT_Encode4(438045),
     /* 437871 */ /*GILLT_v4s32*//*Label 8894*/ GIMT_Encode4(438100),
     /* 437875 */ /*GILLT_v8s8*//*Label 8895*/ GIMT_Encode4(438155),
     /* 437879 */ /*GILLT_v8s16*//*Label 8896*/ GIMT_Encode4(438189),
     /* 437883 */ /*GILLT_v16s8*//*Label 8897*/ GIMT_Encode4(438244), GIMT_Encode4(0),
     /* 437891 */ /*GILLT_nxv2s1*//*Label 8898*/ GIMT_Encode4(438278),
     /* 437895 */ /*GILLT_nxv2s16*//*Label 8899*/ GIMT_Encode4(438304),
     /* 437899 */ /*GILLT_nxv2s32*//*Label 8900*/ GIMT_Encode4(438330),
     /* 437903 */ /*GILLT_nxv2s64*//*Label 8901*/ GIMT_Encode4(438356),
     /* 437907 */ /*GILLT_nxv4s1*//*Label 8902*/ GIMT_Encode4(438403),
     /* 437911 */ /*GILLT_nxv4s16*//*Label 8903*/ GIMT_Encode4(438429),
     /* 437915 */ /*GILLT_nxv4s32*//*Label 8904*/ GIMT_Encode4(438455),
     /* 437919 */ /*GILLT_nxv8s1*//*Label 8905*/ GIMT_Encode4(438502),
     /* 437923 */ /*GILLT_nxv8s16*//*Label 8906*/ GIMT_Encode4(438528),
     /* 437927 */ /*GILLT_nxv16s1*//*Label 8907*/ GIMT_Encode4(438575),
     /* 437931 */ /*GILLT_nxv16s8*//*Label 8908*/ GIMT_Encode4(438601),
     /* 437935 */ // Label 8891: @437935
     /* 437935 */ GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(437989),
     /* 437940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 437943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 437946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437958 */   GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(437973), // Rule ID 1902 //
     /* 437963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437966 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 437966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 437971 */     GIR_RootConstrainSelectedInstOperands,
     /* 437972 */     // GIR_Coverage, 1902,
     /* 437972 */     GIR_Done,
     /* 437973 */   // Label 8911: @437973
     /* 437973 */   GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(437988), // Rule ID 5520 //
     /* 437978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437981 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 437981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 437986 */     GIR_RootConstrainSelectedInstOperands,
     /* 437987 */     // GIR_Coverage, 5520,
     /* 437987 */     GIR_Done,
     /* 437988 */   // Label 8912: @437988
     /* 437988 */   GIM_Reject,
     /* 437989 */ // Label 8910: @437989
     /* 437989 */ GIM_Reject,
     /* 437990 */ // Label 8892: @437990
     /* 437990 */ GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(438044),
     /* 437995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 437998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 438001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438013 */   GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(438028), // Rule ID 1904 //
     /* 438018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438021 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 438021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 438026 */     GIR_RootConstrainSelectedInstOperands,
     /* 438027 */     // GIR_Coverage, 1904,
     /* 438027 */     GIR_Done,
     /* 438028 */   // Label 8914: @438028
     /* 438028 */   GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(438043), // Rule ID 5522 //
     /* 438033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438036 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 438036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 438041 */     GIR_RootConstrainSelectedInstOperands,
     /* 438042 */     // GIR_Coverage, 5522,
     /* 438042 */     GIR_Done,
     /* 438043 */   // Label 8915: @438043
     /* 438043 */   GIM_Reject,
     /* 438044 */ // Label 8913: @438044
     /* 438044 */ GIM_Reject,
     /* 438045 */ // Label 8893: @438045
     /* 438045 */ GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(438099),
     /* 438050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 438053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 438056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438068 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(438083), // Rule ID 1900 //
     /* 438073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438076 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 438076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 438081 */     GIR_RootConstrainSelectedInstOperands,
     /* 438082 */     // GIR_Coverage, 1900,
     /* 438082 */     GIR_Done,
     /* 438083 */   // Label 8917: @438083
     /* 438083 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(438098), // Rule ID 5518 //
     /* 438088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438091 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 438091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 438096 */     GIR_RootConstrainSelectedInstOperands,
     /* 438097 */     // GIR_Coverage, 5518,
     /* 438097 */     GIR_Done,
     /* 438098 */   // Label 8918: @438098
     /* 438098 */   GIM_Reject,
     /* 438099 */ // Label 8916: @438099
     /* 438099 */ GIM_Reject,
     /* 438100 */ // Label 8894: @438100
     /* 438100 */ GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(438154),
     /* 438105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 438108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 438111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438123 */   GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(438138), // Rule ID 1903 //
     /* 438128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438131 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 438131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 438136 */     GIR_RootConstrainSelectedInstOperands,
     /* 438137 */     // GIR_Coverage, 1903,
     /* 438137 */     GIR_Done,
     /* 438138 */   // Label 8920: @438138
     /* 438138 */   GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(438153), // Rule ID 5521 //
     /* 438143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438146 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 438146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 438151 */     GIR_RootConstrainSelectedInstOperands,
     /* 438152 */     // GIR_Coverage, 5521,
     /* 438152 */     GIR_Done,
     /* 438153 */   // Label 8921: @438153
     /* 438153 */   GIM_Reject,
     /* 438154 */ // Label 8919: @438154
     /* 438154 */ GIM_Reject,
     /* 438155 */ // Label 8895: @438155
     /* 438155 */ GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(438188), // Rule ID 1898 //
     /* 438160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 438166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 438169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438181 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 438181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 438186 */   GIR_RootConstrainSelectedInstOperands,
     /* 438187 */   // GIR_Coverage, 1898,
     /* 438187 */   GIR_Done,
     /* 438188 */ // Label 8922: @438188
     /* 438188 */ GIM_Reject,
     /* 438189 */ // Label 8896: @438189
     /* 438189 */ GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(438243),
     /* 438194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 438197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 438200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438212 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(438227), // Rule ID 1901 //
     /* 438217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438220 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 438220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 438225 */     GIR_RootConstrainSelectedInstOperands,
     /* 438226 */     // GIR_Coverage, 1901,
     /* 438226 */     GIR_Done,
     /* 438227 */   // Label 8924: @438227
     /* 438227 */   GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(438242), // Rule ID 5519 //
     /* 438232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438235 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 438235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 438240 */     GIR_RootConstrainSelectedInstOperands,
     /* 438241 */     // GIR_Coverage, 5519,
     /* 438241 */     GIR_Done,
     /* 438242 */   // Label 8925: @438242
     /* 438242 */   GIM_Reject,
     /* 438243 */ // Label 8923: @438243
     /* 438243 */ GIM_Reject,
     /* 438244 */ // Label 8897: @438244
     /* 438244 */ GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(438277), // Rule ID 1899 //
     /* 438249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 438255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 438258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438270 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 438270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 438275 */   GIR_RootConstrainSelectedInstOperands,
     /* 438276 */   // GIR_Coverage, 1899,
     /* 438276 */   GIR_Done,
     /* 438277 */ // Label 8926: @438277
     /* 438277 */ GIM_Reject,
     /* 438278 */ // Label 8898: @438278
     /* 438278 */ GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(438303), // Rule ID 3348 //
     /* 438283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 438289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 438292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438296 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 438296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 438301 */   GIR_RootConstrainSelectedInstOperands,
     /* 438302 */   // GIR_Coverage, 3348,
     /* 438302 */   GIR_Done,
     /* 438303 */ // Label 8927: @438303
     /* 438303 */ GIM_Reject,
     /* 438304 */ // Label 8899: @438304
     /* 438304 */ GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(438329), // Rule ID 2879 //
     /* 438309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 438315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 438318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438322 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 438322 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 438327 */   GIR_RootConstrainSelectedInstOperands,
     /* 438328 */   // GIR_Coverage, 2879,
     /* 438328 */   GIR_Done,
     /* 438329 */ // Label 8928: @438329
     /* 438329 */ GIM_Reject,
     /* 438330 */ // Label 8900: @438330
     /* 438330 */ GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(438355), // Rule ID 2880 //
     /* 438335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 438341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 438344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438348 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 438348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 438353 */   GIR_RootConstrainSelectedInstOperands,
     /* 438354 */   // GIR_Coverage, 2880,
     /* 438354 */   GIR_Done,
     /* 438355 */ // Label 8929: @438355
     /* 438355 */ GIM_Reject,
     /* 438356 */ // Label 8901: @438356
     /* 438356 */ GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(438402),
     /* 438361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 438364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 438367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438371 */   GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(438386), // Rule ID 2875 //
     /* 438376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438379 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 438379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 438384 */     GIR_RootConstrainSelectedInstOperands,
     /* 438385 */     // GIR_Coverage, 2875,
     /* 438385 */     GIR_Done,
     /* 438386 */   // Label 8931: @438386
     /* 438386 */   GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(438401), // Rule ID 2881 //
     /* 438391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438394 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 438394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 438399 */     GIR_RootConstrainSelectedInstOperands,
     /* 438400 */     // GIR_Coverage, 2881,
     /* 438400 */     GIR_Done,
     /* 438401 */   // Label 8932: @438401
     /* 438401 */   GIM_Reject,
     /* 438402 */ // Label 8930: @438402
     /* 438402 */ GIM_Reject,
     /* 438403 */ // Label 8902: @438403
     /* 438403 */ GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(438428), // Rule ID 3347 //
     /* 438408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 438414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 438417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438421 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 438421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 438426 */   GIR_RootConstrainSelectedInstOperands,
     /* 438427 */   // GIR_Coverage, 3347,
     /* 438427 */   GIR_Done,
     /* 438428 */ // Label 8933: @438428
     /* 438428 */ GIM_Reject,
     /* 438429 */ // Label 8903: @438429
     /* 438429 */ GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(438454), // Rule ID 2877 //
     /* 438434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 438440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 438443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438447 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 438447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 438452 */   GIR_RootConstrainSelectedInstOperands,
     /* 438453 */   // GIR_Coverage, 2877,
     /* 438453 */   GIR_Done,
     /* 438454 */ // Label 8934: @438454
     /* 438454 */ GIM_Reject,
     /* 438455 */ // Label 8904: @438455
     /* 438455 */ GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(438501),
     /* 438460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 438463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 438466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438470 */   GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(438485), // Rule ID 2874 //
     /* 438475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438478 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 438478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 438483 */     GIR_RootConstrainSelectedInstOperands,
     /* 438484 */     // GIR_Coverage, 2874,
     /* 438484 */     GIR_Done,
     /* 438485 */   // Label 8936: @438485
     /* 438485 */   GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(438500), // Rule ID 2878 //
     /* 438490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438493 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 438493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 438498 */     GIR_RootConstrainSelectedInstOperands,
     /* 438499 */     // GIR_Coverage, 2878,
     /* 438499 */     GIR_Done,
     /* 438500 */   // Label 8937: @438500
     /* 438500 */   GIM_Reject,
     /* 438501 */ // Label 8935: @438501
     /* 438501 */ GIM_Reject,
     /* 438502 */ // Label 8905: @438502
     /* 438502 */ GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(438527), // Rule ID 3346 //
     /* 438507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 438513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 438516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438520 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 438520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 438525 */   GIR_RootConstrainSelectedInstOperands,
     /* 438526 */   // GIR_Coverage, 3346,
     /* 438526 */   GIR_Done,
     /* 438527 */ // Label 8938: @438527
     /* 438527 */ GIM_Reject,
     /* 438528 */ // Label 8906: @438528
     /* 438528 */ GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(438574),
     /* 438533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 438536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 438539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438543 */   GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(438558), // Rule ID 2873 //
     /* 438548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438551 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 438551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 438556 */     GIR_RootConstrainSelectedInstOperands,
     /* 438557 */     // GIR_Coverage, 2873,
     /* 438557 */     GIR_Done,
     /* 438558 */   // Label 8940: @438558
     /* 438558 */   GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(438573), // Rule ID 2876 //
     /* 438563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438566 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 438566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 438571 */     GIR_RootConstrainSelectedInstOperands,
     /* 438572 */     // GIR_Coverage, 2876,
     /* 438572 */     GIR_Done,
     /* 438573 */   // Label 8941: @438573
     /* 438573 */   GIM_Reject,
     /* 438574 */ // Label 8939: @438574
     /* 438574 */ GIM_Reject,
     /* 438575 */ // Label 8907: @438575
     /* 438575 */ GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(438600), // Rule ID 2398 //
     /* 438580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 438586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 438589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438593 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 438593 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 438598 */   GIR_RootConstrainSelectedInstOperands,
     /* 438599 */   // GIR_Coverage, 2398,
     /* 438599 */   GIR_Done,
     /* 438600 */ // Label 8942: @438600
     /* 438600 */ GIM_Reject,
     /* 438601 */ // Label 8908: @438601
     /* 438601 */ GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(438626), // Rule ID 2872 //
     /* 438606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 438612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 438615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438619 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 438619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 438624 */   GIR_RootConstrainSelectedInstOperands,
     /* 438625 */   // GIR_Coverage, 2872,
     /* 438625 */   GIR_Done,
     /* 438626 */ // Label 8943: @438626
     /* 438626 */ GIM_Reject,
     /* 438627 */ // Label 8909: @438627
     /* 438627 */ GIM_Reject,
     /* 438628 */ // Label 153: @438628
     /* 438628 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8962*/ GIMT_Encode4(439407),
     /* 438639 */ /*GILLT_v2s32*//*Label 8944*/ GIMT_Encode4(438715),
     /* 438643 */ /*GILLT_v2s64*//*Label 8945*/ GIMT_Encode4(438770),
     /* 438647 */ /*GILLT_v4s16*//*Label 8946*/ GIMT_Encode4(438825),
     /* 438651 */ /*GILLT_v4s32*//*Label 8947*/ GIMT_Encode4(438880),
     /* 438655 */ /*GILLT_v8s8*//*Label 8948*/ GIMT_Encode4(438935),
     /* 438659 */ /*GILLT_v8s16*//*Label 8949*/ GIMT_Encode4(438969),
     /* 438663 */ /*GILLT_v16s8*//*Label 8950*/ GIMT_Encode4(439024), GIMT_Encode4(0),
     /* 438671 */ /*GILLT_nxv2s1*//*Label 8951*/ GIMT_Encode4(439058),
     /* 438675 */ /*GILLT_nxv2s16*//*Label 8952*/ GIMT_Encode4(439084),
     /* 438679 */ /*GILLT_nxv2s32*//*Label 8953*/ GIMT_Encode4(439110),
     /* 438683 */ /*GILLT_nxv2s64*//*Label 8954*/ GIMT_Encode4(439136),
     /* 438687 */ /*GILLT_nxv4s1*//*Label 8955*/ GIMT_Encode4(439183),
     /* 438691 */ /*GILLT_nxv4s16*//*Label 8956*/ GIMT_Encode4(439209),
     /* 438695 */ /*GILLT_nxv4s32*//*Label 8957*/ GIMT_Encode4(439235),
     /* 438699 */ /*GILLT_nxv8s1*//*Label 8958*/ GIMT_Encode4(439282),
     /* 438703 */ /*GILLT_nxv8s16*//*Label 8959*/ GIMT_Encode4(439308),
     /* 438707 */ /*GILLT_nxv16s1*//*Label 8960*/ GIMT_Encode4(439355),
     /* 438711 */ /*GILLT_nxv16s8*//*Label 8961*/ GIMT_Encode4(439381),
     /* 438715 */ // Label 8944: @438715
     /* 438715 */ GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(438769),
     /* 438720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 438723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 438726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438738 */   GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(438753), // Rule ID 1909 //
     /* 438743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438746 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 438746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 438751 */     GIR_RootConstrainSelectedInstOperands,
     /* 438752 */     // GIR_Coverage, 1909,
     /* 438752 */     GIR_Done,
     /* 438753 */   // Label 8964: @438753
     /* 438753 */   GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(438768), // Rule ID 5525 //
     /* 438758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438761 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 438761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 438766 */     GIR_RootConstrainSelectedInstOperands,
     /* 438767 */     // GIR_Coverage, 5525,
     /* 438767 */     GIR_Done,
     /* 438768 */   // Label 8965: @438768
     /* 438768 */   GIM_Reject,
     /* 438769 */ // Label 8963: @438769
     /* 438769 */ GIM_Reject,
     /* 438770 */ // Label 8945: @438770
     /* 438770 */ GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(438824),
     /* 438775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 438778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 438781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438793 */   GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(438808), // Rule ID 1911 //
     /* 438798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438801 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 438801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 438806 */     GIR_RootConstrainSelectedInstOperands,
     /* 438807 */     // GIR_Coverage, 1911,
     /* 438807 */     GIR_Done,
     /* 438808 */   // Label 8967: @438808
     /* 438808 */   GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(438823), // Rule ID 5527 //
     /* 438813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438816 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 438816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 438821 */     GIR_RootConstrainSelectedInstOperands,
     /* 438822 */     // GIR_Coverage, 5527,
     /* 438822 */     GIR_Done,
     /* 438823 */   // Label 8968: @438823
     /* 438823 */   GIM_Reject,
     /* 438824 */ // Label 8966: @438824
     /* 438824 */ GIM_Reject,
     /* 438825 */ // Label 8946: @438825
     /* 438825 */ GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(438879),
     /* 438830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 438833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 438836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438848 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(438863), // Rule ID 1907 //
     /* 438853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438856 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 438856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 438861 */     GIR_RootConstrainSelectedInstOperands,
     /* 438862 */     // GIR_Coverage, 1907,
     /* 438862 */     GIR_Done,
     /* 438863 */   // Label 8970: @438863
     /* 438863 */   GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(438878), // Rule ID 5523 //
     /* 438868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438871 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 438871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 438876 */     GIR_RootConstrainSelectedInstOperands,
     /* 438877 */     // GIR_Coverage, 5523,
     /* 438877 */     GIR_Done,
     /* 438878 */   // Label 8971: @438878
     /* 438878 */   GIM_Reject,
     /* 438879 */ // Label 8969: @438879
     /* 438879 */ GIM_Reject,
     /* 438880 */ // Label 8947: @438880
     /* 438880 */ GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(438934),
     /* 438885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 438888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 438891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438903 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(438918), // Rule ID 1910 //
     /* 438908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438911 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 438911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 438916 */     GIR_RootConstrainSelectedInstOperands,
     /* 438917 */     // GIR_Coverage, 1910,
     /* 438917 */     GIR_Done,
     /* 438918 */   // Label 8973: @438918
     /* 438918 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(438933), // Rule ID 5526 //
     /* 438923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438926 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 438926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 438931 */     GIR_RootConstrainSelectedInstOperands,
     /* 438932 */     // GIR_Coverage, 5526,
     /* 438932 */     GIR_Done,
     /* 438933 */   // Label 8974: @438933
     /* 438933 */   GIM_Reject,
     /* 438934 */ // Label 8972: @438934
     /* 438934 */ GIM_Reject,
     /* 438935 */ // Label 8948: @438935
     /* 438935 */ GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(438968), // Rule ID 1905 //
     /* 438940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 438946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 438949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438961 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 438961 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 438966 */   GIR_RootConstrainSelectedInstOperands,
     /* 438967 */   // GIR_Coverage, 1905,
     /* 438967 */   GIR_Done,
     /* 438968 */ // Label 8975: @438968
     /* 438968 */ GIM_Reject,
     /* 438969 */ // Label 8949: @438969
     /* 438969 */ GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(439023),
     /* 438974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 438977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 438980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438992 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(439007), // Rule ID 1908 //
     /* 438997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439000 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 439000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 439005 */     GIR_RootConstrainSelectedInstOperands,
     /* 439006 */     // GIR_Coverage, 1908,
     /* 439006 */     GIR_Done,
     /* 439007 */   // Label 8977: @439007
     /* 439007 */   GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(439022), // Rule ID 5524 //
     /* 439012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439015 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 439015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 439020 */     GIR_RootConstrainSelectedInstOperands,
     /* 439021 */     // GIR_Coverage, 5524,
     /* 439021 */     GIR_Done,
     /* 439022 */   // Label 8978: @439022
     /* 439022 */   GIM_Reject,
     /* 439023 */ // Label 8976: @439023
     /* 439023 */ GIM_Reject,
     /* 439024 */ // Label 8950: @439024
     /* 439024 */ GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(439057), // Rule ID 1906 //
     /* 439029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 439035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 439038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439050 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 439050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 439055 */   GIR_RootConstrainSelectedInstOperands,
     /* 439056 */   // GIR_Coverage, 1906,
     /* 439056 */   GIR_Done,
     /* 439057 */ // Label 8979: @439057
     /* 439057 */ GIM_Reject,
     /* 439058 */ // Label 8951: @439058
     /* 439058 */ GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(439083), // Rule ID 9028 //
     /* 439063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 439069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 439072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439076 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 439076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 439081 */   GIR_RootConstrainSelectedInstOperands,
     /* 439082 */   // GIR_Coverage, 9028,
     /* 439082 */   GIR_Done,
     /* 439083 */ // Label 8980: @439083
     /* 439083 */ GIM_Reject,
     /* 439084 */ // Label 8952: @439084
     /* 439084 */ GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(439109), // Rule ID 8983 //
     /* 439089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 439095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 439098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439102 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 439102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 439107 */   GIR_RootConstrainSelectedInstOperands,
     /* 439108 */   // GIR_Coverage, 8983,
     /* 439108 */   GIR_Done,
     /* 439109 */ // Label 8981: @439109
     /* 439109 */ GIM_Reject,
     /* 439110 */ // Label 8953: @439110
     /* 439110 */ GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(439135), // Rule ID 8984 //
     /* 439115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 439121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 439124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439128 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 439128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 439133 */   GIR_RootConstrainSelectedInstOperands,
     /* 439134 */   // GIR_Coverage, 8984,
     /* 439134 */   GIR_Done,
     /* 439135 */ // Label 8982: @439135
     /* 439135 */ GIM_Reject,
     /* 439136 */ // Label 8954: @439136
     /* 439136 */ GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(439182),
     /* 439141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 439144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 439147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439151 */   GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(439166), // Rule ID 8979 //
     /* 439156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439159 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 439159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 439164 */     GIR_RootConstrainSelectedInstOperands,
     /* 439165 */     // GIR_Coverage, 8979,
     /* 439165 */     GIR_Done,
     /* 439166 */   // Label 8984: @439166
     /* 439166 */   GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(439181), // Rule ID 8985 //
     /* 439171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439174 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 439174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 439179 */     GIR_RootConstrainSelectedInstOperands,
     /* 439180 */     // GIR_Coverage, 8985,
     /* 439180 */     GIR_Done,
     /* 439181 */   // Label 8985: @439181
     /* 439181 */   GIM_Reject,
     /* 439182 */ // Label 8983: @439182
     /* 439182 */ GIM_Reject,
     /* 439183 */ // Label 8955: @439183
     /* 439183 */ GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(439208), // Rule ID 9027 //
     /* 439188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 439194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 439197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439201 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 439201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 439206 */   GIR_RootConstrainSelectedInstOperands,
     /* 439207 */   // GIR_Coverage, 9027,
     /* 439207 */   GIR_Done,
     /* 439208 */ // Label 8986: @439208
     /* 439208 */ GIM_Reject,
     /* 439209 */ // Label 8956: @439209
     /* 439209 */ GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(439234), // Rule ID 8981 //
     /* 439214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 439220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 439223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439227 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 439227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 439232 */   GIR_RootConstrainSelectedInstOperands,
     /* 439233 */   // GIR_Coverage, 8981,
     /* 439233 */   GIR_Done,
     /* 439234 */ // Label 8987: @439234
     /* 439234 */ GIM_Reject,
     /* 439235 */ // Label 8957: @439235
     /* 439235 */ GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(439281),
     /* 439240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 439243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 439246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439250 */   GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(439265), // Rule ID 8978 //
     /* 439255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439258 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 439258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 439263 */     GIR_RootConstrainSelectedInstOperands,
     /* 439264 */     // GIR_Coverage, 8978,
     /* 439264 */     GIR_Done,
     /* 439265 */   // Label 8989: @439265
     /* 439265 */   GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(439280), // Rule ID 8982 //
     /* 439270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439273 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 439273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 439278 */     GIR_RootConstrainSelectedInstOperands,
     /* 439279 */     // GIR_Coverage, 8982,
     /* 439279 */     GIR_Done,
     /* 439280 */   // Label 8990: @439280
     /* 439280 */   GIM_Reject,
     /* 439281 */ // Label 8988: @439281
     /* 439281 */ GIM_Reject,
     /* 439282 */ // Label 8958: @439282
     /* 439282 */ GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(439307), // Rule ID 9026 //
     /* 439287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 439293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 439296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439300 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 439300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 439305 */   GIR_RootConstrainSelectedInstOperands,
     /* 439306 */   // GIR_Coverage, 9026,
     /* 439306 */   GIR_Done,
     /* 439307 */ // Label 8991: @439307
     /* 439307 */ GIM_Reject,
     /* 439308 */ // Label 8959: @439308
     /* 439308 */ GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(439354),
     /* 439313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 439316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 439319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439323 */   GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(439338), // Rule ID 8977 //
     /* 439328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439331 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 439331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 439336 */     GIR_RootConstrainSelectedInstOperands,
     /* 439337 */     // GIR_Coverage, 8977,
     /* 439337 */     GIR_Done,
     /* 439338 */   // Label 8993: @439338
     /* 439338 */   GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(439353), // Rule ID 8980 //
     /* 439343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439346 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 439346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 439351 */     GIR_RootConstrainSelectedInstOperands,
     /* 439352 */     // GIR_Coverage, 8980,
     /* 439352 */     GIR_Done,
     /* 439353 */   // Label 8994: @439353
     /* 439353 */   GIM_Reject,
     /* 439354 */ // Label 8992: @439354
     /* 439354 */ GIM_Reject,
     /* 439355 */ // Label 8960: @439355
     /* 439355 */ GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(439380), // Rule ID 2402 //
     /* 439360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 439366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 439369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439373 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 439373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 439378 */   GIR_RootConstrainSelectedInstOperands,
     /* 439379 */   // GIR_Coverage, 2402,
     /* 439379 */   GIR_Done,
     /* 439380 */ // Label 8995: @439380
     /* 439380 */ GIM_Reject,
     /* 439381 */ // Label 8961: @439381
     /* 439381 */ GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(439406), // Rule ID 8976 //
     /* 439386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 439392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 439395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439399 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 439399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 439404 */   GIR_RootConstrainSelectedInstOperands,
     /* 439405 */   // GIR_Coverage, 8976,
     /* 439405 */   GIR_Done,
     /* 439406 */ // Label 8996: @439406
     /* 439406 */ GIM_Reject,
     /* 439407 */ // Label 8962: @439407
     /* 439407 */ GIM_Reject,
     /* 439408 */ // Label 154: @439408
     /* 439408 */ GIM_Reject,
     /* 439409 */ }; // Size: 439409 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
